#include "precomp.h"

# 34 "../rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "./../../rktio/rktio.h"
typedef struct rktio_t rktio_t ; 



__xform_nongcing__ extern rktio_t * rktio_init (void ) ; 

# 121 "./../../rktio/rktio.h"
typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "./../../rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 351 "./../../rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "./../../rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 

# 403 "./../../rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "./../../rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "./../../rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "./../../rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "./../../rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "./../../rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "./../../rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "./../../rktio/rktio.h"
rktio_process_result_t ; 

# 646 "./../../rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "./../../rktio/rktio.h"
rktio_status_t ; 

# 669 "./../../rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "./../../rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

# 742 "./../../rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

# 762 "./../../rktio/rktio.h"
enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

# 793 "./../../rktio/rktio.h"
enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 874 "./../../rktio/rktio.h"
typedef intptr_t rktio_timestamp_t ; 






typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "./../../rktio/rktio.h"
rktio_stat_t ; 



typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "./../../rktio/rktio.h"
rktio_identity_t ; 

# 925 "./../../rktio/rktio.h"
typedef struct rktio_directory_list_t rktio_directory_list_t ; 

# 947 "./../../rktio/rktio.h"
typedef struct rktio_file_copy_t rktio_file_copy_t ; 

# 975 "./../../rktio/rktio.h"
enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 






enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

# 1018 "./../../rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "./../../rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

__xform_nongcing__ extern void rktio_will_modify_os_signal_handler (int sig_id ) ; 

# 1075 "./../../rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "./../../rktio/rktio.h"
rktio_date_t ; 

# 1109 "./../../rktio/rktio.h"
enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1160 "./../../rktio/rktio.h"
enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "./../../rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "./../../rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "./../../rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "./../../rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "./../../rktio/rktio.h"
rktio_sha1_ctx_t ; 

# 1304 "./../../rktio/rktio.h"
typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "./../../rktio/rktio.h"
rktio_sha2_ctx_t ; 

# 1322 "./../../rktio/rktio.h"
typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "./../../rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 

# 1378 "./../../rktio/rktio.h"
enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 




enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 

# 24 "/usr/include/bits/types/__sigval_t.h" 3
union sigval 
{
  int sival_int ; 
  void * sival_ptr ; 
}

# 28 "/usr/include/bits/types/__sigval_t.h" 3
; 

typedef union sigval __sigval_t ; 

# 36 "/usr/include/bits/types/siginfo_t.h" 3
typedef struct 
{
  int si_signo ; 

  int si_errno ; 

  int si_code ; 





  int __pad0 ; 


  union 
  {
    int _pad [((128 / sizeof (int ) ) - 4 ) ] ; 


    struct 
    {
      __pid_t si_pid ; 
      __uid_t si_uid ; 
    }

# 60 "/usr/include/bits/types/siginfo_t.h" 3
    _kill ; 


    struct 
    {
      int si_tid ; 
      int si_overrun ; 
      __sigval_t si_sigval ; 
    }

# 68 "/usr/include/bits/types/siginfo_t.h" 3
    _timer ; 


    struct 
    {
      __pid_t si_pid ; 
      __uid_t si_uid ; 
      __sigval_t si_sigval ; 
    }

# 76 "/usr/include/bits/types/siginfo_t.h" 3
    _rt ; 


    struct 
    {
      __pid_t si_pid ; 
      __uid_t si_uid ; 
      int si_status ; 
      __clock_t si_utime ; 
      __clock_t si_stime ; 
    }

# 86 "/usr/include/bits/types/siginfo_t.h" 3
    _sigchld ; 


    struct 
    {
      void * si_addr ; 

      short int si_addr_lsb ; 
      union 
      {

        struct 
        {
          void * _lower ; 
          void * _upper ; 
        }

# 101 "/usr/include/bits/types/siginfo_t.h" 3
        _addr_bnd ; 

        __uint32_t _pkey ; 
      }

# 104 "/usr/include/bits/types/siginfo_t.h" 3
      _bounds ; 
    }

# 105 "/usr/include/bits/types/siginfo_t.h" 3
    _sigfault ; 


    struct 
    {
      long int si_band ; 
      int si_fd ; 
    }

# 112 "/usr/include/bits/types/siginfo_t.h" 3
    _sigpoll ; 



    struct 
    {
      void * _call_addr ; 
      int _syscall ; 
      unsigned int _arch ; 
    }

# 121 "/usr/include/bits/types/siginfo_t.h" 3
    _sigsys ; 
  }
  _sifields ; 
}

# 124 "/usr/include/bits/types/siginfo_t.h" 3
siginfo_t ; 

# 35 "/usr/include/bits/siginfo-consts.h" 3
enum 
{
  SI_ASYNCNL = - 60 , 
  SI_DETHREAD = - 7 , 

  SI_TKILL , 
  SI_SIGIO , 

  SI_ASYNCIO , 
  SI_MESGQ , 
  SI_TIMER , 





  SI_QUEUE , 
  SI_USER , 
  SI_KERNEL = 0x80 }

# 66 "/usr/include/bits/siginfo-consts.h" 3
; 




enum 
{
  ILL_ILLOPC = 1 , 

  ILL_ILLOPN , 

  ILL_ILLADR , 

  ILL_ILLTRP , 

  ILL_PRVOPC , 

  ILL_PRVREG , 

  ILL_COPROC , 

  ILL_BADSTK , 

  ILL_BADIADDR }

; 


enum 
{
  FPE_INTDIV = 1 , 

  FPE_INTOVF , 

  FPE_FLTDIV , 

  FPE_FLTOVF , 

  FPE_FLTUND , 

  FPE_FLTRES , 

  FPE_FLTINV , 

  FPE_FLTSUB , 

  FPE_FLTUNK = 14 , 

  FPE_CONDTRAP }

; 


enum 
{
  SEGV_MAPERR = 1 , 

  SEGV_ACCERR , 

  SEGV_BNDERR , 

  SEGV_PKUERR , 

  SEGV_ACCADI , 

  SEGV_ADIDERR , 

  SEGV_ADIPERR , 

  SEGV_MTEAERR , 

  SEGV_MTESERR }

; 


enum 
{
  BUS_ADRALN = 1 , 

  BUS_ADRERR , 

  BUS_OBJERR , 

  BUS_MCEERR_AR , 

  BUS_MCEERR_AO }

; 

# 176 "/usr/include/bits/siginfo-consts.h" 3
enum 
{
  CLD_EXITED = 1 , 

  CLD_KILLED , 

  CLD_DUMPED , 

  CLD_TRAPPED , 

  CLD_STOPPED , 

  CLD_CONTINUED }

; 


enum 
{
  POLL_IN = 1 , 

  POLL_OUT , 

  POLL_MSG , 

  POLL_ERR , 

  POLL_PRI , 

  POLL_HUP }

; 

# 22 "/usr/include/bits/types/sigevent_t.h" 3
typedef struct sigevent 
{
  __sigval_t sigev_value ; 
  int sigev_signo ; 
  int sigev_notify ; 

  union 
  {
    int _pad [((64 / sizeof (int ) ) - 4 ) ] ; 



    __pid_t _tid ; 

    struct 
    {
      void (* _function ) (__sigval_t ) ; 
      pthread_attr_t * _attribute ; 
    }

# 40 "/usr/include/bits/types/sigevent_t.h" 3
    _sigev_thread ; 
  }

# 41 "/usr/include/bits/types/sigevent_t.h" 3
  _sigev_un ; 
}

# 42 "/usr/include/bits/types/sigevent_t.h" 3
sigevent_t ; 

# 27 "/usr/include/bits/sigevent-consts.h" 3
enum 
{
  SIGEV_SIGNAL = 0 , 

  SIGEV_NONE , 

  SIGEV_THREAD , 


  SIGEV_THREAD_ID = 4 }


; 

# 72 "/usr/include/signal.h" 3
typedef void (* __sighandler_t ) (int ) ; 

# 88 "/usr/include/signal.h" 3
extern __sighandler_t signal (int __sig , __sighandler_t __handler ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) ; 

# 199 "/usr/include/signal.h" 3
extern int sigemptyset (sigset_t * __set ) __attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__nonnull__ (1 ) ) ) ; 

# 27 "/usr/include/bits/sigaction.h" 3
struct sigaction 
{


  union 
  {

    __sighandler_t sa_handler ; 

    void (* sa_sigaction ) (int , siginfo_t * , void * ) ; 
  }
  __sigaction_handler ; 







  __sigset_t sa_mask ; 


  int sa_flags ; 


  void (* sa_restorer ) (void ) ; 
}

# 53 "/usr/include/bits/sigaction.h" 3
; 

# 243 "/usr/include/signal.h" 3
extern int sigaction (int __sig , const struct sigaction * __restrict __act , 
struct sigaction * __restrict __oact ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 

# 24 "/usr/include/asm-generic/int-l64.h" 3
typedef unsigned short __u16 ; 


typedef unsigned int __u32 ; 


typedef unsigned long __u64 ; 

# 34 "/usr/include/asm/types.h" 3
typedef struct {
  __u32 u [4 ] ; 
}

# 36 "/usr/include/asm/types.h" 3
__attribute__ ((aligned (16 ) ) ) __vector128 ; 

# 25 "/usr/include/linux/posix_types.h" 3
typedef struct {
  unsigned long fds_bits [1024 / (8 * sizeof (long ) ) ] ; 
}

# 27 "/usr/include/linux/posix_types.h" 3
__kernel_fd_set ; 


typedef void (* __kernel_sighandler_t ) (int ) ; 

# 15 "/usr/include/asm-generic/posix_types.h" 3
typedef long __kernel_long_t ; 
typedef unsigned long __kernel_ulong_t ; 

# 36 "/usr/include/asm-generic/posix_types.h" 3
typedef unsigned int __kernel_uid_t ; 
typedef unsigned int __kernel_gid_t ; 

# 79 "/usr/include/asm-generic/posix_types.h" 3
typedef struct {
  int val [2 ] ; 
}

# 81 "/usr/include/asm-generic/posix_types.h" 3
__kernel_fsid_t ; 

# 32 "/usr/include/asm/ptrace.h" 3
struct pt_regs 
{
  unsigned long gpr [32 ] ; 
  unsigned long nip ; 
  unsigned long msr ; 
  unsigned long orig_gpr3 ; 
  unsigned long ctr ; 
  unsigned long link ; 
  unsigned long xer ; 
  unsigned long ccr ; 

  unsigned long softe ; 




  unsigned long trap ; 


  unsigned long dar ; 
  unsigned long dsisr ; 
  unsigned long result ; 
}

# 54 "/usr/include/asm/ptrace.h" 3
; 

# 201 "/usr/include/asm/ptrace.h" 3
struct ppc_debug_info {
  __u32 version ; 
  __u32 num_instruction_bps ; 
  __u32 num_data_bps ; 
  __u32 num_condition_regs ; 
  __u32 data_bp_alignment ; 
  __u32 sizeof_condition ; 
  __u64 features ; 
}

# 209 "/usr/include/asm/ptrace.h" 3
; 

# 225 "/usr/include/asm/ptrace.h" 3
struct ppc_hw_breakpoint {
  __u32 version ; 
  __u32 trigger_type ; 
  __u32 addr_mode ; 
  __u32 condition_mode ; 
  __u64 addr ; 
  __u64 addr2 ; 
  __u64 condition_value ; 
}

# 233 "/usr/include/asm/ptrace.h" 3
; 

# 102 "/usr/include/asm/elf.h" 3
typedef unsigned long elf_greg_t64 ; 
typedef elf_greg_t64 elf_gregset_t64 [48 ] ; 

typedef unsigned int elf_greg_t32 ; 
typedef elf_greg_t32 elf_gregset_t32 [48 ] ; 

# 120 "/usr/include/asm/elf.h" 3
typedef elf_gregset_t64 elf_gregset_t ; 

# 138 "/usr/include/asm/elf.h" 3
typedef double elf_fpreg_t ; 
typedef elf_fpreg_t elf_fpregset_t [33 ] ; 

# 160 "/usr/include/asm/elf.h" 3
typedef __vector128 elf_vrreg_t ; 
typedef elf_vrreg_t elf_vrregset_t [34 ] ; 

typedef elf_vrreg_t elf_vrregset_t32 [33 ] ; 
typedef elf_fpreg_t elf_vsrreghalf_t32 [32 ] ; 

# 293 "/usr/include/asm/elf.h" 3
struct ppc64_opd_entry 
{
  unsigned long funcaddr ; 
  unsigned long r2 ; 
}

# 297 "/usr/include/asm/elf.h" 3
; 

# 17 "/usr/include/asm/sigcontext.h" 3
struct sigcontext {
  unsigned long _unused [4 ] ; 
  int signal ; 

  int _pad0 ; 

  unsigned long handler ; 
  unsigned long oldmask ; 
  struct pt_regs * regs ; 

  elf_gregset_t gp_regs ; 
  elf_fpregset_t fp_regs ; 

# 83 "/usr/include/asm/sigcontext.h" 3
  elf_vrreg_t * v_regs ; 
  long vmx_reserve [34 + 34 + 1 + 32 ] ; 
}
; 

# 26 "/usr/include/bits/types/stack_t.h" 3
typedef struct 
{
  void * ss_sp ; 
  int ss_flags ; 
  size_t ss_size ; 
}

# 31 "/usr/include/bits/types/stack_t.h" 3
stack_t ; 

# 33 "/usr/include/sys/ucontext.h" 3
struct pt_regs ; 

# 93 "/usr/include/sys/ucontext.h" 3
typedef unsigned long gregset_t [48 ] ; 
typedef double fpregset_t [33 ] ; 




typedef struct _libc_vscr 
{




  unsigned int vscr_word ; 
  unsigned int __pad [3 ] ; 
}
vscr_t ; 



typedef struct _libc_vrstate 
{
  unsigned int vrregs [32 ] [4 ] ; 
  vscr_t vscr ; 
  unsigned int vrsave ; 
  unsigned int __pad [3 ] ; 
}

# 118 "/usr/include/sys/ucontext.h" 3
vrregset_t __attribute__ ((__aligned__ (16 ) ) ) ; 

typedef struct {
  unsigned long __glibc_reserved [4 ] ; 
  int signal ; 
  int __pad0 ; 
  unsigned long handler ; 
  unsigned long oldmask ; 
  struct pt_regs * regs ; 
  gregset_t gp_regs ; 
  fpregset_t fp_regs ; 

# 148 "/usr/include/sys/ucontext.h" 3
  vrregset_t * v_regs ; 
  long vmx_reserve [34 + 34 + 1 ] ; 
}

# 150 "/usr/include/sys/ucontext.h" 3
mcontext_t ; 




typedef struct ucontext_t 
{
  unsigned long int uc_flags ; 
  struct ucontext_t * uc_link ; 
  stack_t uc_stack ; 

# 193 "/usr/include/sys/ucontext.h" 3
  sigset_t uc_sigmask ; 
  mcontext_t uc_mcontext ; 
}
ucontext_t ; 

# 27 "/usr/include/bits/ss_flags.h" 3
enum 
{
  SS_ONSTACK = 1 , 

  SS_DISABLE }

; 

# 23 "/usr/include/bits/types/struct_sigstack.h" 3
struct sigstack 
{
  void * ss_sp ; 
  int ss_onstack ; 
}

# 27 "/usr/include/bits/types/struct_sigstack.h" 3
; 

# 347 "/usr/include/signal.h" 3
extern int sigstack (struct sigstack * __ss , struct sigstack * __oss ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__deprecated__ ) ) ; 

# 358 "/usr/include/unistd.h" 3
extern int close (int __fd ) ; 

# 371 "/usr/include/unistd.h" 3
extern ssize_t read (int __fd , void * __buf , size_t __nbytes ) 
__attribute__ ((__access__ (__write_only__ , 2 , 3 ) ) ) ; 





extern ssize_t write (int __fd , const void * __buf , size_t __n ) 
__attribute__ ((__access__ (__read_only__ , 2 , 3 ) ) ) ; 

# 489 "/usr/include/unistd.h" 3
extern int pause (void ) ; 

# 24 "/usr/include/bits/confname.h" 3
enum 
{
  _PC_LINK_MAX , 

  _PC_MAX_CANON , 

  _PC_MAX_INPUT , 

  _PC_NAME_MAX , 

  _PC_PATH_MAX , 

  _PC_PIPE_BUF , 

  _PC_CHOWN_RESTRICTED , 

  _PC_NO_TRUNC , 

  _PC_VDISABLE , 

  _PC_SYNC_IO , 

  _PC_ASYNC_IO , 

  _PC_PRIO_IO , 

  _PC_SOCK_MAXBUF , 

  _PC_FILESIZEBITS , 

  _PC_REC_INCR_XFER_SIZE , 

  _PC_REC_MAX_XFER_SIZE , 

  _PC_REC_MIN_XFER_SIZE , 

  _PC_REC_XFER_ALIGN , 

  _PC_ALLOC_SIZE_MIN , 

  _PC_SYMLINK_MAX , 

  _PC_2_SYMLINKS }

; 


enum 
{
  _SC_ARG_MAX , 

  _SC_CHILD_MAX , 

  _SC_CLK_TCK , 

  _SC_NGROUPS_MAX , 

  _SC_OPEN_MAX , 

  _SC_STREAM_MAX , 

  _SC_TZNAME_MAX , 

  _SC_JOB_CONTROL , 

  _SC_SAVED_IDS , 

  _SC_REALTIME_SIGNALS , 

  _SC_PRIORITY_SCHEDULING , 

  _SC_TIMERS , 

  _SC_ASYNCHRONOUS_IO , 

  _SC_PRIORITIZED_IO , 

  _SC_SYNCHRONIZED_IO , 

  _SC_FSYNC , 

  _SC_MAPPED_FILES , 

  _SC_MEMLOCK , 

  _SC_MEMLOCK_RANGE , 

  _SC_MEMORY_PROTECTION , 

  _SC_MESSAGE_PASSING , 

  _SC_SEMAPHORES , 

  _SC_SHARED_MEMORY_OBJECTS , 

  _SC_AIO_LISTIO_MAX , 

  _SC_AIO_MAX , 

  _SC_AIO_PRIO_DELTA_MAX , 

  _SC_DELAYTIMER_MAX , 

  _SC_MQ_OPEN_MAX , 

  _SC_MQ_PRIO_MAX , 

  _SC_VERSION , 

  _SC_PAGESIZE , 


  _SC_RTSIG_MAX , 

  _SC_SEM_NSEMS_MAX , 

  _SC_SEM_VALUE_MAX , 

  _SC_SIGQUEUE_MAX , 

  _SC_TIMER_MAX , 




  _SC_BC_BASE_MAX , 

  _SC_BC_DIM_MAX , 

  _SC_BC_SCALE_MAX , 

  _SC_BC_STRING_MAX , 

  _SC_COLL_WEIGHTS_MAX , 

  _SC_EQUIV_CLASS_MAX , 

  _SC_EXPR_NEST_MAX , 

  _SC_LINE_MAX , 

  _SC_RE_DUP_MAX , 

  _SC_CHARCLASS_NAME_MAX , 


  _SC_2_VERSION , 

  _SC_2_C_BIND , 

  _SC_2_C_DEV , 

  _SC_2_FORT_DEV , 

  _SC_2_FORT_RUN , 

  _SC_2_SW_DEV , 

  _SC_2_LOCALEDEF , 


  _SC_PII , 

  _SC_PII_XTI , 

  _SC_PII_SOCKET , 

  _SC_PII_INTERNET , 

  _SC_PII_OSI , 

  _SC_POLL , 

  _SC_SELECT , 

  _SC_UIO_MAXIOV , 

  _SC_IOV_MAX = _SC_UIO_MAXIOV , 

  _SC_PII_INTERNET_STREAM , 

  _SC_PII_INTERNET_DGRAM , 

  _SC_PII_OSI_COTS , 

  _SC_PII_OSI_CLTS , 

  _SC_PII_OSI_M , 

  _SC_T_IOV_MAX , 



  _SC_THREADS , 

  _SC_THREAD_SAFE_FUNCTIONS , 

  _SC_GETGR_R_SIZE_MAX , 

  _SC_GETPW_R_SIZE_MAX , 

  _SC_LOGIN_NAME_MAX , 

  _SC_TTY_NAME_MAX , 

  _SC_THREAD_DESTRUCTOR_ITERATIONS , 

  _SC_THREAD_KEYS_MAX , 

  _SC_THREAD_STACK_MIN , 

  _SC_THREAD_THREADS_MAX , 

  _SC_THREAD_ATTR_STACKADDR , 

  _SC_THREAD_ATTR_STACKSIZE , 

  _SC_THREAD_PRIORITY_SCHEDULING , 

  _SC_THREAD_PRIO_INHERIT , 

  _SC_THREAD_PRIO_PROTECT , 

  _SC_THREAD_PROCESS_SHARED , 


  _SC_NPROCESSORS_CONF , 

  _SC_NPROCESSORS_ONLN , 

  _SC_PHYS_PAGES , 

  _SC_AVPHYS_PAGES , 

  _SC_ATEXIT_MAX , 

  _SC_PASS_MAX , 


  _SC_XOPEN_VERSION , 

  _SC_XOPEN_XCU_VERSION , 

  _SC_XOPEN_UNIX , 

  _SC_XOPEN_CRYPT , 

  _SC_XOPEN_ENH_I18N , 

  _SC_XOPEN_SHM , 


  _SC_2_CHAR_TERM , 

  _SC_2_C_VERSION , 

  _SC_2_UPE , 


  _SC_XOPEN_XPG2 , 

  _SC_XOPEN_XPG3 , 

  _SC_XOPEN_XPG4 , 


  _SC_CHAR_BIT , 

  _SC_CHAR_MAX , 

  _SC_CHAR_MIN , 

  _SC_INT_MAX , 

  _SC_INT_MIN , 

  _SC_LONG_BIT , 

  _SC_WORD_BIT , 

  _SC_MB_LEN_MAX , 

  _SC_NZERO , 

  _SC_SSIZE_MAX , 

  _SC_SCHAR_MAX , 

  _SC_SCHAR_MIN , 

  _SC_SHRT_MAX , 

  _SC_SHRT_MIN , 

  _SC_UCHAR_MAX , 

  _SC_UINT_MAX , 

  _SC_ULONG_MAX , 

  _SC_USHRT_MAX , 


  _SC_NL_ARGMAX , 

  _SC_NL_LANGMAX , 

  _SC_NL_MSGMAX , 

  _SC_NL_NMAX , 

  _SC_NL_SETMAX , 

  _SC_NL_TEXTMAX , 


  _SC_XBS5_ILP32_OFF32 , 

  _SC_XBS5_ILP32_OFFBIG , 

  _SC_XBS5_LP64_OFF64 , 

  _SC_XBS5_LPBIG_OFFBIG , 


  _SC_XOPEN_LEGACY , 

  _SC_XOPEN_REALTIME , 

  _SC_XOPEN_REALTIME_THREADS , 


  _SC_ADVISORY_INFO , 

  _SC_BARRIERS , 

  _SC_BASE , 

  _SC_C_LANG_SUPPORT , 

  _SC_C_LANG_SUPPORT_R , 

  _SC_CLOCK_SELECTION , 

  _SC_CPUTIME , 

  _SC_THREAD_CPUTIME , 

  _SC_DEVICE_IO , 

  _SC_DEVICE_SPECIFIC , 

  _SC_DEVICE_SPECIFIC_R , 

  _SC_FD_MGMT , 

  _SC_FIFO , 

  _SC_PIPE , 

  _SC_FILE_ATTRIBUTES , 

  _SC_FILE_LOCKING , 

  _SC_FILE_SYSTEM , 

  _SC_MONOTONIC_CLOCK , 

  _SC_MULTI_PROCESS , 

  _SC_SINGLE_PROCESS , 

  _SC_NETWORKING , 

  _SC_READER_WRITER_LOCKS , 

  _SC_SPIN_LOCKS , 

  _SC_REGEXP , 

  _SC_REGEX_VERSION , 

  _SC_SHELL , 

  _SC_SIGNALS , 

  _SC_SPAWN , 

  _SC_SPORADIC_SERVER , 

  _SC_THREAD_SPORADIC_SERVER , 

  _SC_SYSTEM_DATABASE , 

  _SC_SYSTEM_DATABASE_R , 

  _SC_TIMEOUTS , 

  _SC_TYPED_MEMORY_OBJECTS , 

  _SC_USER_GROUPS , 

  _SC_USER_GROUPS_R , 

  _SC_2_PBS , 

  _SC_2_PBS_ACCOUNTING , 

  _SC_2_PBS_LOCATE , 

  _SC_2_PBS_MESSAGE , 

  _SC_2_PBS_TRACK , 

  _SC_SYMLOOP_MAX , 

  _SC_STREAMS , 

  _SC_2_PBS_CHECKPOINT , 


  _SC_V6_ILP32_OFF32 , 

  _SC_V6_ILP32_OFFBIG , 

  _SC_V6_LP64_OFF64 , 

  _SC_V6_LPBIG_OFFBIG , 


  _SC_HOST_NAME_MAX , 

  _SC_TRACE , 

  _SC_TRACE_EVENT_FILTER , 

  _SC_TRACE_INHERIT , 

  _SC_TRACE_LOG , 


  _SC_LEVEL1_ICACHE_SIZE , 

  _SC_LEVEL1_ICACHE_ASSOC , 

  _SC_LEVEL1_ICACHE_LINESIZE , 

  _SC_LEVEL1_DCACHE_SIZE , 

  _SC_LEVEL1_DCACHE_ASSOC , 

  _SC_LEVEL1_DCACHE_LINESIZE , 

  _SC_LEVEL2_CACHE_SIZE , 

  _SC_LEVEL2_CACHE_ASSOC , 

  _SC_LEVEL2_CACHE_LINESIZE , 

  _SC_LEVEL3_CACHE_SIZE , 

  _SC_LEVEL3_CACHE_ASSOC , 

  _SC_LEVEL3_CACHE_LINESIZE , 

  _SC_LEVEL4_CACHE_SIZE , 

  _SC_LEVEL4_CACHE_ASSOC , 

  _SC_LEVEL4_CACHE_LINESIZE , 



  _SC_IPV6 = _SC_LEVEL1_ICACHE_SIZE + 50 , 

  _SC_RAW_SOCKETS , 


  _SC_V7_ILP32_OFF32 , 

  _SC_V7_ILP32_OFFBIG , 

  _SC_V7_LP64_OFF64 , 

  _SC_V7_LPBIG_OFFBIG , 


  _SC_SS_REPL_MAX , 


  _SC_TRACE_EVENT_NAME_MAX , 

  _SC_TRACE_NAME_MAX , 

  _SC_TRACE_SYS_MAX , 

  _SC_TRACE_USER_EVENT_MAX , 


  _SC_XOPEN_STREAMS , 


  _SC_THREAD_ROBUST_PRIO_INHERIT , 

  _SC_THREAD_ROBUST_PRIO_PROTECT , 


  _SC_MINSIGSTKSZ , 


  _SC_SIGSTKSZ }

; 


enum 
{
  _CS_PATH , 


  _CS_V6_WIDTH_RESTRICTED_ENVS , 



  _CS_GNU_LIBC_VERSION , 

  _CS_GNU_LIBPTHREAD_VERSION , 


  _CS_V5_WIDTH_RESTRICTED_ENVS , 



  _CS_V7_WIDTH_RESTRICTED_ENVS , 



  _CS_LFS_CFLAGS = 1000 , 

  _CS_LFS_LDFLAGS , 

  _CS_LFS_LIBS , 

  _CS_LFS_LINTFLAGS , 

  _CS_LFS64_CFLAGS , 

  _CS_LFS64_LDFLAGS , 

  _CS_LFS64_LIBS , 

  _CS_LFS64_LINTFLAGS , 


  _CS_XBS5_ILP32_OFF32_CFLAGS = 1100 , 

  _CS_XBS5_ILP32_OFF32_LDFLAGS , 

  _CS_XBS5_ILP32_OFF32_LIBS , 

  _CS_XBS5_ILP32_OFF32_LINTFLAGS , 

  _CS_XBS5_ILP32_OFFBIG_CFLAGS , 

  _CS_XBS5_ILP32_OFFBIG_LDFLAGS , 

  _CS_XBS5_ILP32_OFFBIG_LIBS , 

  _CS_XBS5_ILP32_OFFBIG_LINTFLAGS , 

  _CS_XBS5_LP64_OFF64_CFLAGS , 

  _CS_XBS5_LP64_OFF64_LDFLAGS , 

  _CS_XBS5_LP64_OFF64_LIBS , 

  _CS_XBS5_LP64_OFF64_LINTFLAGS , 

  _CS_XBS5_LPBIG_OFFBIG_CFLAGS , 

  _CS_XBS5_LPBIG_OFFBIG_LDFLAGS , 

  _CS_XBS5_LPBIG_OFFBIG_LIBS , 

  _CS_XBS5_LPBIG_OFFBIG_LINTFLAGS , 


  _CS_POSIX_V6_ILP32_OFF32_CFLAGS , 

  _CS_POSIX_V6_ILP32_OFF32_LDFLAGS , 

  _CS_POSIX_V6_ILP32_OFF32_LIBS , 

  _CS_POSIX_V6_ILP32_OFF32_LINTFLAGS , 

  _CS_POSIX_V6_ILP32_OFFBIG_CFLAGS , 

  _CS_POSIX_V6_ILP32_OFFBIG_LDFLAGS , 

  _CS_POSIX_V6_ILP32_OFFBIG_LIBS , 

  _CS_POSIX_V6_ILP32_OFFBIG_LINTFLAGS , 

  _CS_POSIX_V6_LP64_OFF64_CFLAGS , 

  _CS_POSIX_V6_LP64_OFF64_LDFLAGS , 

  _CS_POSIX_V6_LP64_OFF64_LIBS , 

  _CS_POSIX_V6_LP64_OFF64_LINTFLAGS , 

  _CS_POSIX_V6_LPBIG_OFFBIG_CFLAGS , 

  _CS_POSIX_V6_LPBIG_OFFBIG_LDFLAGS , 

  _CS_POSIX_V6_LPBIG_OFFBIG_LIBS , 

  _CS_POSIX_V6_LPBIG_OFFBIG_LINTFLAGS , 


  _CS_POSIX_V7_ILP32_OFF32_CFLAGS , 

  _CS_POSIX_V7_ILP32_OFF32_LDFLAGS , 

  _CS_POSIX_V7_ILP32_OFF32_LIBS , 

  _CS_POSIX_V7_ILP32_OFF32_LINTFLAGS , 

  _CS_POSIX_V7_ILP32_OFFBIG_CFLAGS , 

  _CS_POSIX_V7_ILP32_OFFBIG_LDFLAGS , 

  _CS_POSIX_V7_ILP32_OFFBIG_LIBS , 

  _CS_POSIX_V7_ILP32_OFFBIG_LINTFLAGS , 

  _CS_POSIX_V7_LP64_OFF64_CFLAGS , 

  _CS_POSIX_V7_LP64_OFF64_LDFLAGS , 

  _CS_POSIX_V7_LP64_OFF64_LIBS , 

  _CS_POSIX_V7_LP64_OFF64_LINTFLAGS , 

  _CS_POSIX_V7_LPBIG_OFFBIG_CFLAGS , 

  _CS_POSIX_V7_LPBIG_OFFBIG_LDFLAGS , 

  _CS_POSIX_V7_LPBIG_OFFBIG_LIBS , 

  _CS_POSIX_V7_LPBIG_OFFBIG_LINTFLAGS , 


  _CS_V6_ENV , 

  _CS_V7_ENV }

; 

# 640 "/usr/include/unistd.h" 3
extern long int sysconf (int __name ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 

# 819 "/usr/include/unistd.h" 3
extern int link (const char * __from , const char * __to ) 
__attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__nonnull__ (1 , 2 ) ) ) ; 

# 57 "/usr/include/sys/mman.h" 3
extern void * mmap (void * __addr , size_t __len , int __prot , 
int __flags , int __fd , __off_t __offset ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 

# 76 "/usr/include/sys/mman.h" 3
extern int munmap (void * __addr , size_t __len ) __attribute__ ((__nothrow__ , __leaf__ ) ) ; 

# 36 "./../src/salloc.c"
; 

; 

; 
; 
; 

# 55 "./../src/salloc.c"
__thread Thread_Local_Variables scheme_thread_locals ; 

# 66 "./../src/salloc.c"
static uintptr_t primordial_os_thread_stack_base ; 
; 

Thread_Local_Variables * scheme_vars ; 


static Scheme_Report_Out_Of_Memory_Proc more_report_out_of_memory ; 

# 97 "./../src/salloc.c"
static int use_registered_statics ; 









void scheme_set_stack_base (void * base , int no_auto_statics ) XFORM_SKIP_PROC 
{

  GC_report_signal_handle_modify = rktio_will_modify_os_signal_handler ; 
  GC_init_type_tags (_scheme_last_type_ , 
  scheme_pair_type , scheme_mutable_pair_type , scheme_weak_box_type , 
  scheme_ephemeron_type , scheme_rt_weak_array , 
  scheme_cust_box_type , scheme_phantom_bytes_type ) ; 

  scheme_register_traversers () ; 


  primordial_os_thread_stack_base = (uintptr_t ) base ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_os_thread_stack_base_ ) = (uintptr_t ) base ; 


  GC_set_stack_base (base ) ; 

# 137 "./../src/salloc.c"
  use_registered_statics = no_auto_statics ; 

  GC_report_out_of_memory = scheme_out_of_memory_abort ; 
}

# 153 "./../src/salloc.c"
void scheme_set_current_os_thread_stack_base (void * base ) 
{
  /* No conversion */

# 155 "./../src/salloc.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_os_thread_stack_base_ ) = (uintptr_t ) base ; 
}

uintptr_t scheme_get_current_os_thread_stack_base () 
{
  /* No conversion */

# 160 "./../src/salloc.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_os_thread_stack_base_ ) ; 
}

uintptr_t scheme_get_primordial_thread_stack_base () 
{
  /* No conversion */

# 165 "./../src/salloc.c"
  return primordial_os_thread_stack_base ; 
}

typedef struct {
  Scheme_Env_Main _main ; 
  int argc ; 
  char * * argv ; 
}

# 172 "./../src/salloc.c"
Scheme_Main_Data ; 

static int call_with_basic (void * data ) 
{
  Scheme_Main_Data * ma = (Scheme_Main_Data * ) data ; 
  Scheme_Env_Main _main = ma -> _main ; 
  Scheme_Env * __funcarg65 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ma, 0)));
# define XfOrM4_COUNT (1)
# define SETUP_XfOrM4(x) SETUP(XfOrM4_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 179 "./../src/salloc.c"
  RET_VALUE_START ((__funcarg65 = FUNCCALL(SETUP_XfOrM4(_), scheme_basic_env () ), FUNCCALL_EMPTY(_main (__funcarg65 , ma -> argc , ma -> argv ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 182 "./../src/salloc.c"
int scheme_main_setup (int no_auto_statics , Scheme_Env_Main _main , int argc , char * * argv ) XFORM_SKIP_PROC 
{
  Scheme_Main_Data d ; 
  d . _main = _main ; 
  d . argc = argc ; 
  d . argv = argv ; 
  return scheme_main_stack_setup (no_auto_statics , call_with_basic , & d ) ; 
}

extern int _tls_index ; 

static int do_main_stack_setup (int no_auto_statics , Scheme_Nested_Main _main , void * data ) 
{
  void * stack_start ; 
  int volatile return_code ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(data, 0), PUSH(stack_start, 1)));
# define XfOrM5_COUNT (2)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stack_start = NULLED_OUT ; 

# 199 "./../src/salloc.c"
  scheme_vars = (& scheme_thread_locals ) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_set_stack_base (& __gc_var_stack__ , no_auto_statics ) )

  ; 

  return_code = FUNCCALL_AGAIN(_main (data ) ); 



  stack_start = ((void * ) 0 ) ; 


  RET_VALUE_START (return_code ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 246 "./../src/salloc.c"
void scheme_register_tls_space (void * tls_space , int tls_index ) XFORM_SKIP_PROC 
{
}

# 260 "./../src/salloc.c"
void scheme_setup_thread_local_key_if_needed () XFORM_SKIP_PROC 
{
}

# 330 "./../src/salloc.c"
int scheme_main_stack_setup (int no_auto_statics , Scheme_Nested_Main _main , void * data ) XFORM_SKIP_PROC 
{
  scheme_setup_thread_local_key_if_needed () ; 
  scheme_init_os_thread () ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) = rktio_init () ; 

  scheme_init_glib_log_queue () ; 

  return do_main_stack_setup (no_auto_statics , _main , data ) ; 
}

void scheme_set_stack_bounds (void * base , void * deepest , int no_auto_statics ) XFORM_SKIP_PROC 
{
  scheme_set_stack_base (base , no_auto_statics ) ; 


  if (deepest ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) = (uintptr_t ) deepest ; 
  }
}


extern uintptr_t scheme_get_stack_base () XFORM_SKIP_PROC 
{









  return (uintptr_t ) GC_get_stack_base () ; 
}


void scheme_out_of_memory_abort () 
{
  /* No conversion */

# 369 "./../src/salloc.c"
  scheme_log_abort ("Racket virtual machine has run out of memory; aborting" ) ; 
  if (more_report_out_of_memory )
    more_report_out_of_memory () ; 
  abort () ; 
}

void scheme_set_report_out_of_memory (Scheme_Report_Out_Of_Memory_Proc p ) 
{
  /* No conversion */

# 377 "./../src/salloc.c"
  more_report_out_of_memory = p ; 
}

# 394 "./../src/salloc.c"
void * scheme_get_os_thread_like () 
{
  /* No conversion */


  return ((void * ) 0 ) ; 
}


void scheme_init_os_thread_like (void * other ) XFORM_SKIP_PROC 
{
}

# 428 "./../src/salloc.c"
void scheme_init_os_thread (void ) XFORM_SKIP_PROC 
{
  scheme_init_os_thread_like (((void * ) 0 ) ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_os_thread_id_ ) = (uintptr_t ) mz_proc_os_thread_self () ; 
}


void scheme_done_os_thread () XFORM_SKIP_PROC 
{
}









int scheme_is_place_main_os_thread () XFORM_SKIP_PROC 
{





  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_os_thread_id_ ) != (uintptr_t ) mz_proc_os_thread_self () )
    return 0 ; 

  return 1 ; 
}

void scheme_set_signal_handler (int sig_id , Scheme_Signal_Handler_Proc proc ) XFORM_SKIP_PROC 
{

  struct sigaction sa ; 

  if (sig_id == 1 ) {

    sigaction (1 , ((void * ) 0 ) , & sa ) ; 
    if (sa . __sigaction_handler . sa_handler == ((__sighandler_t ) 1 ) )
      return ; 
  }

  sigemptyset (& sa . sa_mask ) ; 
  sa . sa_flags = 0 ; 
  sa . __sigaction_handler . sa_handler = (proc ? proc : ((__sighandler_t ) 1 ) ) ; 
  rktio_will_modify_os_signal_handler (sig_id ) ; 
  sigaction (sig_id , & sa , ((void * ) 0 ) ) ; 
}






void scheme_dont_gc_ptr (void * p ) 
{
  int i , oldsize ; 
  void * * naya ; 
  int * nayac ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(nayac, 1), PUSH(p, 2)));
# define XfOrM9_COUNT (3)
# define SETUP_XfOrM9(x) SETUP(XfOrM9_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 
  nayac = NULLED_OUT ; 

# 492 "./../src/salloc.c"
  for (i = 0 ; i < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_size_ ) ; i ++ ) {
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_array_ ) [i ] == p ) {
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_count_ ) [i ] ++ ; 
      RET_NOTHING ; 
    }
  }


  for (i = 0 ; i < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_size_ ) ; i ++ ) {
    if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_array_ ) [i ] ) {
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_array_ ) [i ] = p ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_count_ ) [i ] = 1 ; 
      RET_NOTHING ; 
    }
  }


  oldsize = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_size_ ) ; 
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_array_ ) ) {
#   define XfOrM14_COUNT (0+XfOrM9_COUNT)
#   define SETUP_XfOrM14(x) SETUP_XfOrM9(x)
    FUNCCALL(SETUP_XfOrM14(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_array_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_array_ ) ) ) )
# 511 "./../src/salloc.c"
    ; 
    FUNCCALL(SETUP_XfOrM14(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_count_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_count_ ) ) ) ); 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_size_ ) = 50 ; 
  }

# 514 "./../src/salloc.c"
  else 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_size_ ) *= 2 ; 

  naya = ((void * * ) FUNCCALL(SETUP_XfOrM9(_), GC_malloc (sizeof (void * ) * (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_size_ ) ) ) )) ; 
  nayac = ((int * ) FUNCCALL(SETUP_XfOrM9(_), GC_malloc (sizeof (int ) * (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_size_ ) ) ) )) ; 

  for (i = 0 ; i < oldsize ; i ++ ) {
    naya [i ] = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_array_ ) [i ] ; 
    nayac [i ] = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_count_ ) [i ] ; 
  }

  for (; i < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_size_ ) ; i ++ ) {
    naya [i ] = ((void * ) 0 ) ; 
    nayac [i ] = 0 ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_array_ ) = naya ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_count_ ) = nayac ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_array_ ) [oldsize ] = p ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_count_ ) [oldsize ] = 1 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 537 "./../src/salloc.c"
void scheme_gc_ptr_ok (void * p ) 
{
  /* No conversion */

# 539 "./../src/salloc.c"
  int i ; 

  for (i = 0 ; i < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_size_ ) ; i ++ ) {
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_array_ ) [i ] == p ) {
      if (! (-- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_count_ ) [i ] ) )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> dgc_array_ ) [i ] = ((void * ) 0 ) ; 
      break ; 
    }
  }
}

# 564 "./../src/salloc.c"
void * 
scheme_calloc (size_t num , size_t size ) 
{
  /* No conversion */

# 567 "./../src/salloc.c"
  void * space ; 

  space = malloc (num * size ) ; 
  if (! space )
    scheme_raise_out_of_memory (((void * ) 0 ) , ((void * ) 0 ) ) ; 




  return space ; 
}

char * 
scheme_strdup (const char * str ) 
{
  char * naya ; 
  intptr_t len ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(str, 1)));
# define XfOrM29_COUNT (2)
# define SETUP_XfOrM29(x) SETUP(XfOrM29_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 585 "./../src/salloc.c"
  len = strlen (str ) + 1 ; 
  naya = (char * ) FUNCCALL(SETUP_XfOrM29(_), GC_malloc_atomic (len * sizeof (char ) ) ); 
  (memcpy (naya , str , len ) ) ; 

  RET_VALUE_START (naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 592 "./../src/salloc.c"
char * 
scheme_strdup_eternal (const char * str ) 
{
  char * naya ; 
  intptr_t len ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(str, 1)));
# define XfOrM30_COUNT (2)
# define SETUP_XfOrM30(x) SETUP(XfOrM30_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 598 "./../src/salloc.c"
  len = strlen (str ) + 1 ; 
  naya = (char * ) FUNCCALL(SETUP_XfOrM30(_), scheme_malloc_eternal (len * sizeof (char ) ) ); 
  (memcpy (naya , str , len ) ) ; 

  RET_VALUE_START (naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 605 "./../src/salloc.c"
char * 
scheme_strdup_and_free (const char * str ) 
{
  char * naya ; 
  intptr_t len ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(str, 1)));
# define XfOrM31_COUNT (2)
# define SETUP_XfOrM31(x) SETUP(XfOrM31_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 611 "./../src/salloc.c"
  len = strlen (str ) + 1 ; 
  naya = (char * ) FUNCCALL(SETUP_XfOrM31(_), GC_malloc_atomic (len * sizeof (char ) ) ); 
  (memcpy (naya , str , len ) ) ; 
  FUNCCALL(SETUP_XfOrM31(_), free ((void * ) str ) )
  ; 

  RET_VALUE_START (naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

Scheme_Object * scheme_make_cptr (void * cptr , Scheme_Object * typetag ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(typetag, 0), PUSH(cptr, 1), PUSH(o, 2)));
# define XfOrM32_COUNT (3)
# define SETUP_XfOrM32(x) SETUP(XfOrM32_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 628 "./../src/salloc.c"
  o = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM32(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cptr ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) ); 
  o -> type = scheme_cpointer_type ; 
  (((Scheme_Cptr * ) (o ) ) -> val ) = cptr ; 
  (((Scheme_Cptr * ) (o ) ) -> type ) = (void * ) typetag ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 636 "./../src/salloc.c"
Scheme_Object * scheme_make_external_cptr (GC_CAN_IGNORE void * cptr , Scheme_Object * typetag ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM33_COUNT (1)
# define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 639 "./../src/salloc.c"
  o = FUNCCALL(SETUP_XfOrM33(_), scheme_make_cptr (((void * ) 0 ) , typetag ) ); 
  (& ((Scheme_Cptr * ) (o ) ) -> so ) -> so . keyex |= 0x1 ; 
  (((Scheme_Cptr * ) (o ) ) -> val ) = cptr ; 

# 654 "./../src/salloc.c"
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 657 "./../src/salloc.c"
Scheme_Object * scheme_make_offset_cptr (void * cptr , intptr_t offset , Scheme_Object * typetag ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(typetag, 0), PUSH(cptr, 1), PUSH(o, 2)));
# define XfOrM34_COUNT (3)
# define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 661 "./../src/salloc.c"
  o = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM34(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Offset_Cptr ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) ); 
  o -> type = scheme_cpointer_type ; 
  (& ((Scheme_Cptr * ) (o ) ) -> so ) -> so . keyex |= 0x2 ; 
  (((Scheme_Cptr * ) (o ) ) -> val ) = cptr ; 
  (((Scheme_Cptr * ) (o ) ) -> type ) = (void * ) typetag ; 
  ((Scheme_Offset_Cptr * ) o ) -> offset = offset ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 671 "./../src/salloc.c"
Scheme_Object * scheme_make_offset_external_cptr (GC_CAN_IGNORE void * cptr , intptr_t offset , Scheme_Object * typetag ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM35_COUNT (1)
# define SETUP_XfOrM35(x) SETUP(XfOrM35_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 674 "./../src/salloc.c"
  o = FUNCCALL(SETUP_XfOrM35(_), scheme_make_offset_cptr (((void * ) 0 ) , offset , typetag ) ); 
  (& ((Scheme_Cptr * ) (o ) ) -> so ) -> so . keyex |= 0x1 ; 
  (((Scheme_Cptr * ) (o ) ) -> val ) = cptr ; 
  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}






void * * scheme_malloc_immobile_box (void * p ) 
{
  /* No conversion */
  return GC_malloc_immobile_box (p ) ; 
}

# 709 "./../src/salloc.c"
void scheme_free_immobile_box (void * * b ) 
{
  /* No conversion */
  GC_free_immobile_box (b ) ; 
}








static void raise_out_of_memory (void ) 
{
  /* No conversion */
  GC_set_out_of_memory (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> save_oom_ ) ) ; 



  scheme_raise_out_of_memory (((void * ) 0 ) , ((void * ) 0 ) ) ; 
}

intptr_t scheme_check_overflow (intptr_t n , intptr_t m , intptr_t a ) 
{
  /* No conversion */

# 734 "./../src/salloc.c"
  intptr_t v ; 

  v = (intptr_t ) (((uintptr_t ) n * (uintptr_t ) m ) + (uintptr_t ) a ) ; 
  if ((v < n ) || (v < m ) || (v < a ) || (((v - a ) / n ) != m ) )
    scheme_signal_error ("allocation size overflow" ) ; 

  return v ; 
}

void * scheme_malloc_fail_ok (void * (* f ) (size_t ) , size_t s ) 
{
  void * v ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM40_COUNT (1)
# define SETUP_XfOrM40(x) SETUP(XfOrM40_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 748 "./../src/salloc.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> save_oom_ ) = FUNCCALL(SETUP_XfOrM40(_), GC_get_out_of_memory () ); 
  FUNCCALL(SETUP_XfOrM40(_), GC_set_out_of_memory (raise_out_of_memory ) ); 





  v = FUNCCALL_AGAIN(f (s ) ); 
  FUNCCALL_AGAIN(GC_set_out_of_memory (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> save_oom_ ) ) )

  ; 




  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 766 "./../src/salloc.c"
void scheme_end_stubborn_change (void * p ) 
{
  /* No conversion */
}



void * scheme_malloc_eternal (size_t n ) 
{



  void * s ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM42_COUNT (1)
# define SETUP_XfOrM42(x) SETUP(XfOrM42_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 780 "./../src/salloc.c"
  s = malloc (n ) ; 
  if (! s ) {

    GC_Out_Of_Memory_Proc oom ; 
#   define XfOrM43_COUNT (0+XfOrM42_COUNT)
#   define SETUP_XfOrM43(x) SETUP_XfOrM42(x)

# 784 "./../src/salloc.c"
    oom = FUNCCALL(SETUP_XfOrM43(_), GC_get_out_of_memory () ); 
    if (oom )
      FUNCCALL(SETUP_XfOrM43(_), oom () ); 


    if (GC_out_of_memory )
      FUNCCALL(SETUP_XfOrM43(_), GC_out_of_memory () ); 

    if (scheme_console_printf )
      FUNCCALL(SETUP_XfOrM43(_), scheme_console_printf ("out of memory\n" ) ); 
    else (
    printf ("out of memory\n" ) ) ; 
    FUNCCALL_EMPTY(exit (1 ) ); 
  }
  (

  memset (s , 0 , n ) ) ; 

  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 807 "./../src/salloc.c"
void * scheme_malloc_uncollectable (size_t size_in_bytes ) 
{
  void * p ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM44_COUNT (1)
# define SETUP_XfOrM44(x) SETUP(XfOrM44_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 810 "./../src/salloc.c"
  p = FUNCCALL(SETUP_XfOrM44(_), GC_malloc (size_in_bytes ) ); 
  FUNCCALL_AGAIN(scheme_dont_gc_ptr (p ) ); 
  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 816 "./../src/salloc.c"
void scheme_register_static (void * ptr , intptr_t size ) XFORM_SKIP_PROC 
{


  GC_add_roots ((char * ) ptr , (char * ) (((char * ) ptr ) + size + 1 ) ) ; 
}

# 954 "./../src/salloc.c"
; 

; 
; 
; 

; 

# 993 "./../src/salloc.c"
struct free_list_entry {
  intptr_t size ; 
  void * elems ; 
  int count ; 
}

# 997 "./../src/salloc.c"
; 





static mzrt_mutex * permanent_code_mutex = ((void * ) 0 ) ; 
static void * permanent_code_page = ((void * ) 0 ) ; 
static intptr_t available_code_page_amount = 0 ; 


static intptr_t get_page_size () 
{



  static uintptr_t page_size = - 1 ; 
  if (page_size == - 1 ) {





    page_size = sysconf (_SC_PAGESIZE ) ; 
  }



  return page_size ; 
}

# 1039 "./../src/salloc.c"
static void * malloc_page (intptr_t size ) 
{
  void * r ; 

# 1062 "./../src/salloc.c"
  r = mmap (((void * ) 0 ) , size , 0x1 | 0x2 | 0x4 , 0x02 | 0 | 0x20 , - 1 , 0 ) ; 







  if (r == (void * ) - 1 )
    r = ((void * ) 0 ) ; 


  if (! r )
    scheme_raise_out_of_memory (((void * ) 0 ) , ((void * ) 0 ) ) ; 





  return r ; 
}

static void free_page (void * p , intptr_t size ) 
{






  munmap (p , size ) ; 
}





static void chain_page (void * pg ) 
{
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> code_allocation_page_list_ ) )
    ((void * * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> code_allocation_page_list_ ) ) [2 ] = pg ; 
  ((void * * ) pg ) [2 ] = ((void * ) 0 ) ; 
  ((void * * ) pg ) [3 ] = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> code_allocation_page_list_ ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> code_allocation_page_list_ ) = pg ; 
}

static void unchain_page (void * pg ) 
{
  if (! ((void * * ) pg ) [2 ] )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> code_allocation_page_list_ ) = ((void * * ) pg ) [3 ] ; 
  else 
  ((void * * ) (((void * * ) pg ) [2 ] ) ) [3 ] = ((void * * ) pg ) [3 ] ; 

  if (((void * * ) pg ) [3 ] )
    ((void * * ) (((void * * ) pg ) [3 ] ) ) [2 ] = ((void * * ) pg ) [2 ] ; 
}

static void init_free_list () 
{
  intptr_t page_size = get_page_size () ; 
  int pos = 0 ; 
  int cnt = 2 ; 
  intptr_t last_v = page_size , v ; 




  while (1 ) {
    v = (page_size - 32 ) / cnt ; 
    v = (v / 32 ) * 32 ; 
    if (v != last_v ) {
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [pos ] . size = v ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [pos ] . elems = ((void * ) 0 ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [pos ] . count = 0 ; 
      last_v = v ; 
      pos ++ ; 
      if (v == 32 )
        break ; 
    }
    cnt ++ ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_bucket_count_ ) = pos ; 
}

static intptr_t free_list_find_bucket (intptr_t size ) 
{

  int lo = 0 , hi = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_bucket_count_ ) - 1 , mid ; 

  while (lo + 1 < hi ) {
    mid = (lo + hi ) / 2 ; 
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [mid ] . size > size ) {
      lo = mid ; 
    }

# 1156 "./../src/salloc.c"
    else {
      hi = mid ; 
    }
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [hi ] . size == size )
    return hi ; 
  else 
  return lo ; 
}


void * scheme_malloc_code (intptr_t size ) 
{


  intptr_t size2 , bucket , sz , page_size ; 
  void * p , * pg , * prev ; 

  do {
  }

# 1175 "./../src/salloc.c"
  while (0 ) ; 

  if (size < 32 ) {


    size = 32 ; 
  }

  page_size = get_page_size () ; 

  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) = (struct free_list_entry * ) malloc_page (page_size ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_page_total_ ) += page_size ; 
    init_free_list () ; 
  }

  if (size > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [0 ] . size ) {

    sz = size + 32 ; 
    sz = (sz + page_size - 1 ) & ~ (page_size - 1 ) ; 
    pg = malloc_page (sz ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_page_total_ ) += sz ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_total_ ) += sz ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_count_ ) ++ ; 
    * (intptr_t * ) pg = sz ; 
    chain_page (pg ) ; 

    ; 
    p = ((char * ) pg ) + 32 ; 
  }

# 1204 "./../src/salloc.c"
  else {
    bucket = free_list_find_bucket (size ) ; 
    size2 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . size ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_total_ ) += size2 ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_count_ ) ++ ; 

    if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . elems ) {

      int i , count = 0 ; 
      pg = malloc_page (page_size ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_page_total_ ) += page_size ; 

      ; 
      sz = page_size - size2 ; 
      for (i = 32 ; i <= sz ; i += size2 ) {
        p = ((char * ) pg ) + i ; 
        prev = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . elems ; 
        ((void * * ) p ) [0 ] = prev ; 
        ((void * * ) p ) [1 ] = ((void * ) 0 ) ; 
        if (prev )
          ((void * * ) prev ) [1 ] = p ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . elems = p ; 
        count ++ ; 
      }
      ((intptr_t * ) pg ) [0 ] = bucket ; 
      ((intptr_t * ) pg ) [1 ] = 0 ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . count = count ; 
      chain_page (pg ) ; 
    }

    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . elems ; 
    prev = ((void * * ) p ) [0 ] ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . elems = prev ; 
    -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . count ; 
    if (prev )
      ((void * * ) prev ) [1 ] = ((void * ) 0 ) ; 
    ((intptr_t * ) ((void * ) (((uintptr_t ) p ) & ~ (page_size - 1 ) ) ) ) [1 ] += 1 ; 

    ; 
  }

  do {
  }

# 1246 "./../src/salloc.c"
  while (0 ) ; 

  return p ; 
}




void * scheme_malloc_permanent_code (intptr_t size ) 


{

  void * p ; 
  intptr_t page_size ; 

  if (! permanent_code_mutex ) {


    mzrt_mutex_create (& permanent_code_mutex ) ; 
  }


  if (size & 0xF )

# 1269 "./../src/salloc.c"
  size += 16 - (size & 0xF ) ; 

  mzrt_mutex_lock (permanent_code_mutex ) ; 

  if (available_code_page_amount < size ) {
    page_size = get_page_size () ; 
    page_size *= 4 ; 
    while (page_size < size ) page_size *= 2 ; 

    permanent_code_page = malloc_page (page_size ) ; 

    available_code_page_amount = page_size ; 
  }

  p = permanent_code_page ; 
  permanent_code_page = ((char * ) permanent_code_page ) + size ; 
  available_code_page_amount -= size ; 

  mzrt_mutex_unlock (permanent_code_mutex ) ; 

  return p ; 
}




void scheme_free_code (void * p ) 
{

  intptr_t size , size2 , bucket , page_size ; 
  int per_page , n ; 
  void * prev ; 

  do {
  }

# 1302 "./../src/salloc.c"
  while (0 ) ; 

  page_size = get_page_size () ; 

  size = * (intptr_t * ) ((void * ) (((uintptr_t ) p ) & ~ (page_size - 1 ) ) ) ; 

  if (size >= page_size ) {

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_page_total_ ) -= size ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_total_ ) -= size ; 
    -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_count_ ) ; 

    ; 
    unchain_page ((char * ) p - 32 ) ; 
    free_page ((char * ) p - 32 , size ) ; 
  }

# 1317 "./../src/salloc.c"
  else {
    bucket = size ; 

    if ((bucket < 0 ) || (bucket >= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_bucket_count_ ) ) ) {
      printf ("bad free: %p\n" , (char * ) p + 32 ) ; 
      abort () ; 
    }

    size2 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . size ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_total_ ) -= size2 ; 
    -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_count_ ) ; 

    ; 


    per_page = (page_size - 32 ) / size2 ; 
    n = ((intptr_t * ) ((void * ) (((uintptr_t ) p ) & ~ (page_size - 1 ) ) ) ) [1 ] ; 

    if ((n < 1 ) || (n > per_page ) ) {
      printf ("bad free: %p\n" , (char * ) p + 32 ) ; 
      abort () ; 
    }
    n -- ; 
    ((intptr_t * ) ((void * ) (((uintptr_t ) p ) & ~ (page_size - 1 ) ) ) ) [1 ] = n ; 


    prev = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . elems ; 
    ((void * * ) p ) [0 ] = prev ; 
    ((void * * ) p ) [1 ] = ((void * ) 0 ) ; 
    if (prev )
      ((void * * ) prev ) [1 ] = p ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . elems = p ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . count ++ ; 



    if ((n == 0 ) && ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . count - per_page ) >= (per_page / 2 ) ) ) {

      int i ; 
      intptr_t sz ; 
      void * pg ; 

      sz = page_size - size2 ; 
      pg = ((void * ) (((uintptr_t ) p ) & ~ (page_size - 1 ) ) ) ; 
      for (i = 32 ; i <= sz ; i += size2 ) {
        p = ((char * ) pg ) + i ; 
        prev = ((void * * ) p ) [1 ] ; 
        if (prev )
          ((void * * ) prev ) [0 ] = ((void * * ) p ) [0 ] ; 
        else 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . elems = ((void * * ) p ) [0 ] ; 
        prev = ((void * * ) p ) [0 ] ; 
        if (prev )
          ((void * * ) prev ) [1 ] = ((void * * ) p ) [1 ] ; 
        -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) [bucket ] . count ; 
      }

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_page_total_ ) -= page_size ; 

      ; 
      unchain_page (((void * ) (((uintptr_t ) p ) & ~ (page_size - 1 ) ) ) ) ; 
      free_page (((void * ) (((uintptr_t ) p ) & ~ (page_size - 1 ) ) ) , page_size ) ; 
    }
  }

  do {
  }

# 1382 "./../src/salloc.c"
  while (0 ) ; 
}





void scheme_free_all_code (void ) 
{

  void * p , * next ; 
  intptr_t page_size ; 

  do {
  }

# 1395 "./../src/salloc.c"
  while (0 ) ; 

  page_size = get_page_size () ; 

  for (p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> code_allocation_page_list_ ) ; p ; p = next ) {
    next = ((void * * ) p ) [3 ] ; 
    if (((intptr_t * ) p ) [0 ] > page_size )
      free_page (p , ((intptr_t * ) p ) [0 ] ) ; 
    else 
    free_page (p , page_size ) ; 
  }
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> code_allocation_page_list_ ) = ((void * ) 0 ) ; 

  free_page (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> free_list_ ) , page_size ) ; 

  do {
  }

# 1410 "./../src/salloc.c"
  while (0 ) ; 
}

# 1685 "./../src/salloc.c"
typedef struct Finalization {
  Scheme_Type type ; 
  void (* f ) (void * o , void * data ) ; 
  void * data ; 
  struct Finalization * next , * prev ; 
}

# 1690 "./../src/salloc.c"
Finalization ; 

typedef struct Finalizations {
  Scheme_Type type ; 
  short lifetime ; 
  Finalization * scheme_first , * scheme_last ; 
  void (* ext_f ) (void * o , void * data ) ; 
  void * ext_data ; 
  Finalization * prim_first , * prim_last ; 
}

# 1699 "./../src/salloc.c"
Finalizations ; 

# 7 "./../src/../gc2/gc2_dump.h"
typedef char * (* GC_get_type_name_proc ) (short t ) ; 
typedef void (* GC_for_each_found_proc ) (void * p ) ; 
typedef void (* GC_for_each_struct_proc ) (void * p , int sz ) ; 

typedef int (* GC_record_traced_filter_proc ) (void * p ) ; 
typedef void (* GC_print_tagged_value_proc ) (const char * prefix , 
void * v , uintptr_t diff , int max_w , 
const char * suffix ) ; 
typedef int (* GC_print_traced_filter_proc ) (void * p ) ; 

extern void GC_dump_with_traces (int flags , 
GC_get_type_name_proc get_type_name , 
GC_for_each_found_proc for_each_found , 
short min_trace_for_tag , short max_trace_for_tag , 
GC_record_traced_filter_proc record_traced_filter , 
GC_print_traced_filter_proc print_traced_filter , 
GC_print_tagged_value_proc print_tagged_value , 
int path_length_limit , 
GC_for_each_struct_proc for_each_struct ) ; 

# 43 "./../src/../gc2/gc2_dump.h"
typedef void (* GC_allocated_object_callback_proc ) (void * , intptr_t size , int tagged , int atomic ) ; 

# 3 "./../src/mzmark_salloc.inc"
static int mark_finalization_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_finalization_MARK (void * p , struct NewGC * gc ) {

  Finalization * f = (Finalization * ) p ; 

  GC_mark2 (& (f -> data ) , gc ) ; 
  GC_mark2 (& (f -> next ) , gc ) ; 
  GC_mark2 (& (f -> prev ) , gc ) ; 


  return 0 ; 
}






static int mark_finalization_FIXUP (void * p , struct NewGC * gc ) {

  Finalization * f = (Finalization * ) p ; 

  GC_fixup2 (& (f -> data ) , gc ) ; 
  GC_fixup2 (& (f -> next ) , gc ) ; 
  GC_fixup2 (& (f -> prev ) , gc ) ; 


  return 0 ; 
}

# 49 "./../src/mzmark_salloc.inc"
static int mark_finalizations_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_finalizations_MARK (void * p , struct NewGC * gc ) {

  Finalizations * f = (Finalizations * ) p ; 

  GC_mark2 (& (f -> scheme_first ) , gc ) ; 
  GC_mark2 (& (f -> scheme_last ) , gc ) ; 
  GC_mark2 (& (f -> prim_first ) , gc ) ; 
  GC_mark2 (& (f -> prim_last ) , gc ) ; 
  GC_mark2 (& (f -> ext_data ) , gc ) ; 


  return 0 ; 
}






static int mark_finalizations_FIXUP (void * p , struct NewGC * gc ) {

  Finalizations * f = (Finalizations * ) p ; 

  GC_fixup2 (& (f -> scheme_first ) , gc ) ; 
  GC_fixup2 (& (f -> scheme_last ) , gc ) ; 
  GC_fixup2 (& (f -> prim_first ) , gc ) ; 
  GC_fixup2 (& (f -> prim_last ) , gc ) ; 
  GC_fixup2 (& (f -> ext_data ) , gc ) ; 


  return 0 ; 
}

# 1716 "./../src/salloc.c"
; 

void scheme_reset_finalizations (void ) 
{
  /* No conversion */

# 1720 "./../src/salloc.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> current_lifetime_ ) ++ ; 
}

static void do_next_finalization (void * o , void * _data ) 
{
  Finalizations * fns = * (Finalizations * * ) _data ; 
  Finalization * fn ; 
  GC_CAN_IGNORE void * data ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(fn, 0), PUSH(fns, 1), PUSH(o, 2)));
# define XfOrM46_COUNT (3)
# define SETUP_XfOrM46(x) SETUP(XfOrM46_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  fn = NULLED_OUT ; 

# 1729 "./../src/salloc.c"
  if (fns -> lifetime != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> current_lifetime_ ) )
    RET_NOTHING ; 

  if (fns -> scheme_first ) {
#   define XfOrM50_COUNT (0+XfOrM46_COUNT)
#   define SETUP_XfOrM50(x) SETUP_XfOrM46(x)

# 1733 "./../src/salloc.c"
    if (fns -> scheme_first -> next || fns -> ext_f || fns -> prim_first ) {
#     define XfOrM51_COUNT (0+XfOrM50_COUNT)
#     define SETUP_XfOrM51(x) SETUP_XfOrM50(x)
      FUNCCALL(SETUP_XfOrM51(_), GC_set_finalizer (o , 1 , fns -> scheme_first -> next ? 1 : 2 , do_next_finalization , _data , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
    }

    fn = fns -> scheme_first ; 
    fns -> scheme_first = fn -> next ; 
    if (! fn -> next )
      fns -> scheme_last = ((void * ) 0 ) ; 
    else 
    fn -> next -> prev = ((void * ) 0 ) ; 




    data = fn -> data ; 
    fn -> data = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM50(_), fn -> f (o , data ) )
    ; 
    RET_NOTHING ; 
  }

  if (fns -> ext_f ) {
#   define XfOrM49_COUNT (0+XfOrM46_COUNT)
#   define SETUP_XfOrM49(x) SETUP_XfOrM46(x)

# 1757 "./../src/salloc.c"
    data = fns -> ext_data ; 
    fns -> ext_data = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM49(_), fns -> ext_f (o , data ) ); 
  }

  for (fn = fns -> prim_first ; fn ; fn = fn -> next ) {
#   define XfOrM48_COUNT (0+XfOrM46_COUNT)
#   define SETUP_XfOrM48(x) SETUP_XfOrM46(x)

# 1763 "./../src/salloc.c"
    data = fn -> data ; 
    fn -> data = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM48(_), fn -> f (o , data ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1769 "./../src/salloc.c"
typedef void (* finalizer_function ) (void * p , void * data ) ; 

void scheme_init_finalization () {
  /* No conversion */
  GC_register_traversers2 (scheme_rt_finalization , mark_finalization_SIZE , mark_finalization_MARK , mark_finalization_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_finalizations , mark_finalizations_SIZE , mark_finalizations_MARK , mark_finalizations_FIXUP , 1 , 0 ) ; 
}


static void add_finalizer (void * v , void (* f ) (void * , void * ) , void * data , 
int prim , int ext , 
void (* * ext_oldf ) (void * p , void * data ) , 
void * * ext_olddata , 
int no_dup , int rmve ) 
{
  finalizer_function oldf ; 
  void * olddata ; 
  Finalizations * fns , * * fns_ptr , * prealloced ; 
  Finalization * fn ; 
  PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(fn, 0), PUSH(olddata, 1), PUSH(fns, 2), PUSH(prealloced, 3), PUSH(v, 4), PUSH(data, 5), PUSH(fns_ptr, 6), PUSH(ext_olddata, 7)));
# define XfOrM53_COUNT (8)
# define SETUP_XfOrM53(x) SETUP(XfOrM53_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  olddata = NULLED_OUT ; 
  fns = NULLED_OUT ; 
  fns_ptr = NULLED_OUT ; 
  prealloced = NULLED_OUT ; 
  fn = NULLED_OUT ; 

# 1797 "./../src/salloc.c"
  fns_ptr = ((Finalizations * * ) FUNCCALL(SETUP_XfOrM53(_), GC_malloc (sizeof (Finalizations * ) * (1 ) ) )) ; 

  if (! ext && ! rmve ) {
#   define XfOrM75_COUNT (0+XfOrM53_COUNT)
#   define SETUP_XfOrM75(x) SETUP_XfOrM53(x)

# 1800 "./../src/salloc.c"
    fn = ((Finalization * ) FUNCCALL(SETUP_XfOrM75(_), GC_malloc_one_small_tagged ((((sizeof (Finalization ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

    fn -> type = scheme_rt_finalization ; 

    fn -> f = f ; 
    fn -> data = data ; 
  }

# 1806 "./../src/salloc.c"
  else 
  fn = ((void * ) 0 ) ; 

  if (! rmve ) {
#   define XfOrM74_COUNT (0+XfOrM53_COUNT)
#   define SETUP_XfOrM74(x) SETUP_XfOrM53(x)

# 1810 "./../src/salloc.c"
    prealloced = ((Finalizations * ) FUNCCALL(SETUP_XfOrM74(_), GC_malloc_one_small_tagged ((((sizeof (Finalizations ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

    prealloced -> type = scheme_rt_finalizations ; 
  }
  else 
  prealloced = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM53(_), GC_set_finalizer (v , 1 , prim ? 2 : 1 , do_next_finalization , fns_ptr , & oldf , & olddata ) )
  ; 

  if (oldf ) {
#   define XfOrM70_COUNT (0+XfOrM53_COUNT)
#   define SETUP_XfOrM70(x) SETUP_XfOrM53(x)

# 1820 "./../src/salloc.c"
    if (oldf != do_next_finalization ) {
#     define XfOrM73_COUNT (0+XfOrM70_COUNT)
#     define SETUP_XfOrM73(x) SETUP_XfOrM70(x)
      FUNCCALL(SETUP_XfOrM73(_), scheme_warning ("warning: non-Racket finalization on object dropped! %p %p" , oldf , olddata ) ); 
    }

# 1824 "./../src/salloc.c"
    else {
#     define XfOrM71_COUNT (0+XfOrM70_COUNT)
#     define SETUP_XfOrM71(x) SETUP_XfOrM70(x)

# 1825 "./../src/salloc.c"
      * fns_ptr = * (Finalizations * * ) olddata ; 
      if (prim && (* fns_ptr ) -> scheme_first ) {
#       define XfOrM72_COUNT (0+XfOrM71_COUNT)
#       define SETUP_XfOrM72(x) SETUP_XfOrM71(x)
        FUNCCALL(SETUP_XfOrM72(_), GC_set_finalizer (v , 1 , 1 , do_next_finalization , fns_ptr , ((void * ) 0 ) , ((void * ) 0 ) ) )
# 1828 "./../src/salloc.c"
        ; 
      }
    }
  }

# 1831 "./../src/salloc.c"
  else if (rmve ) {
#   define XfOrM69_COUNT (0+XfOrM53_COUNT)
#   define SETUP_XfOrM69(x) SETUP_XfOrM53(x)
    FUNCCALL(SETUP_XfOrM69(_), GC_set_finalizer (v , 1 , 1 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )
# 1832 "./../src/salloc.c"
    ; 
    RET_NOTHING ; 
  }

  if (! (* fns_ptr ) ) {
    prealloced -> lifetime = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> current_lifetime_ ) ; 
    * fns_ptr = prealloced ; 
  }
  fns = * fns_ptr ; 

  if (ext ) {
#   define XfOrM66_COUNT (0+XfOrM53_COUNT)
#   define SETUP_XfOrM66(x) SETUP_XfOrM53(x)

# 1843 "./../src/salloc.c"
    if (ext_oldf )
      * ext_oldf = fns -> ext_f ; 
    fns -> ext_f = f ; 
    if (ext_olddata )
      * ext_olddata = fns -> ext_data ; 
    fns -> ext_data = data ; 

    if (! f && ! fns -> prim_first && ! fns -> scheme_first ) {
#     define XfOrM67_COUNT (0+XfOrM66_COUNT)
#     define SETUP_XfOrM67(x) SETUP_XfOrM66(x)
      FUNCCALL(SETUP_XfOrM67(_), GC_set_finalizer (v , 1 , 1 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )
# 1852 "./../src/salloc.c"
      ; 
    }
  }

# 1854 "./../src/salloc.c"
  else {
#   define XfOrM54_COUNT (0+XfOrM53_COUNT)
#   define SETUP_XfOrM54(x) SETUP_XfOrM53(x)

# 1855 "./../src/salloc.c"
    if (prim ) {
#     define XfOrM56_COUNT (0+XfOrM54_COUNT)
#     define SETUP_XfOrM56(x) SETUP_XfOrM54(x)

# 1856 "./../src/salloc.c"
      if (no_dup ) {

        Finalization * fnx ; 
        fnx = NULLED_OUT ; 

# 1859 "./../src/salloc.c"
        for (fnx = fns -> prim_first ; fnx ; fnx = fnx -> next ) {
          if (fnx -> f == f && fnx -> data == data ) {
            if (rmve ) {
              if (fnx -> prev )
                fnx -> prev -> next = fnx -> next ; 
              else 
              fns -> prim_first = fnx -> next ; 
              if (fnx -> next )
                fnx -> next -> prev = fnx -> prev ; 
              else 
              fns -> prim_last = fnx -> prev ; 
            }
            fn = ((void * ) 0 ) ; 
            break ; 
          }
        }
      }
      if (fn ) {
        fn -> next = fns -> prim_first ; 
        fns -> prim_first = fn ; 
        if (! fn -> next )
          fns -> prim_last = fn ; 
        else 
        fn -> next -> prev = fn ; 
      }

      if (! fns -> ext_f && ! fns -> prim_first && ! fns -> scheme_first ) {
#       define XfOrM57_COUNT (0+XfOrM56_COUNT)
#       define SETUP_XfOrM57(x) SETUP_XfOrM56(x)
        FUNCCALL(SETUP_XfOrM57(_), GC_set_finalizer (v , 1 , 1 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )
# 1886 "./../src/salloc.c"
        ; 
      }
    }

# 1888 "./../src/salloc.c"
    else {
      fn -> next = fns -> scheme_first ; 
      fns -> scheme_first = fn ; 
      if (! fn -> next )
        fns -> scheme_last = fn ; 
      else 
      fn -> next -> prev = fn ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1928 "./../src/salloc.c"
void scheme_add_finalizer (void * p , void (* f ) (void * p , void * data ) , void * data ) 
{
  /* No conversion */

# 1930 "./../src/salloc.c"
  add_finalizer (p , f , data , 1 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 0 ) ; 
}

void scheme_add_finalizer_once (void * p , void (* f ) (void * p , void * data ) , void * data ) 
{
  /* No conversion */

# 1935 "./../src/salloc.c"
  add_finalizer (p , f , data , 1 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , 1 , 0 ) ; 
}

void scheme_subtract_finalizer (void * p , void (* f ) (void * p , void * data ) , void * data ) 
{
  /* No conversion */

# 1940 "./../src/salloc.c"
  add_finalizer (p , f , data , 1 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , 1 , 1 ) ; 
}

void scheme_add_scheme_finalizer (void * p , void (* f ) (void * p , void * data ) , void * data ) 
{
  /* No conversion */

# 1945 "./../src/salloc.c"
  add_finalizer (p , f , data , 0 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 0 ) ; 
}

void scheme_add_scheme_finalizer_once (void * p , void (* f ) (void * p , void * data ) , void * data ) 
{
  /* No conversion */

# 1950 "./../src/salloc.c"
  add_finalizer (p , f , data , 0 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , 1 , 0 ) ; 
}

void scheme_register_finalizer (void * p , void (* f ) (void * p , void * data ) , 
void * data , void (* * oldf ) (void * p , void * data ) , 
void * * olddata ) 
{
  /* No conversion */

# 1957 "./../src/salloc.c"
  add_finalizer (p , f , data , 1 , 1 , oldf , olddata , 0 , 0 ) ; 
}

void scheme_remove_all_finalization (void * p ) 
{
  /* No conversion */

# 1962 "./../src/salloc.c"
  GC_set_finalizer (p , 1 , 1 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ; 
}

void scheme_collect_garbage (void ) 
{
  /* No conversion */

# 1967 "./../src/salloc.c"
  GC_gcollect () ; 
}

void scheme_collect_garbage_minor (void ) 
{
  /* No conversion */
  GC_gcollect_minor () ; 
}



void scheme_enable_garbage_collection (int on ) 
{
  /* No conversion */
  GC_enable_collection (on ) ; 
}







void scheme_incremental_garbage_collection (int on ) 
{
  /* No conversion */
  GC_set_incremental_mode (on ) ; 
}


uintptr_t scheme_get_deeper_address (void ) __attribute__ ((noinline ) ) ; 

uintptr_t scheme_get_deeper_address (void ) 
{
  /* No conversion */

# 2001 "./../src/salloc.c"
  int v , * vp ; 
  vp = & v ; 
  return (uintptr_t ) vp ; 
}

Scheme_Object * scheme_malloc_key () 


{
  /* No conversion */

# 2010 "./../src/salloc.c"
  Scheme_Object * k ; 

  k = (Scheme_Object * ) malloc (sizeof (Scheme_Small_Object ) ) ; 
  k -> type = scheme_box_type ; 
  (((Scheme_Small_Object * ) (k ) ) -> u . ptr_val ) = scheme_false ; 

  return k ; 
}

void scheme_free_key (Scheme_Object * k ) 
{
  /* No conversion */

# 2021 "./../src/salloc.c"
  free (k ) ; 
}





void scheme_unused_object (Scheme_Object * o ) {
  /* No conversion */
}

# 2029 "./../src/salloc.c"
void scheme_unused_intptr (intptr_t i ) {
  /* No conversion */
}

# 2209 "./../src/salloc.c"
void (* scheme_external_dump_info ) (void ) ; 
void (* scheme_external_dump_arg ) (Scheme_Object * arg ) ; 
char * (* scheme_external_dump_type ) (void * v ) ; 

# 2355 "./../src/salloc.c"
static int found_counter = 0 ; 
static void increment_found_counter (void * p ) 
{
  /* No conversion */

# 2358 "./../src/salloc.c"
  found_counter ++ ; 
}



static mzlonglong code_counter = 0 ; 
static void increment_code_counter (void * p ) 
{
  /* No conversion */

# 2366 "./../src/salloc.c"
  if (((Scheme_Load_Delay * ) p ) -> cached )
    code_counter += ((Scheme_Load_Delay * ) p ) -> size ; 
}

# 2607 "./../src/salloc.c"
Scheme_Object * scheme_dump_gc_stats (int c , Scheme_Object * p [] ) 
{
  Scheme_Object * result = scheme_void ; 





  int skip_summary = 0 ; 
  int trace_for_tag = 0 ; 
  int dump_flags = 0 ; 
  GC_for_each_found_proc for_each_found = ((void * ) 0 ) ; 
  GC_print_traced_filter_proc maybe_print_traced_filter = ((void * ) 0 ) ; 
  GC_record_traced_filter_proc record_traced_filter = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(result, 0), PUSH(p, 1)));
# define XfOrM94_COUNT (2)
# define SETUP_XfOrM94(x) SETUP(XfOrM94_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  FUNCCALL(SETUP_XfOrM94(_), scheme_start_atomic () )
# 2698 "./../src/salloc.c"
  ; 

  if (scheme_external_dump_arg )
    FUNCCALL(SETUP_XfOrM94(_), scheme_external_dump_arg (c ? p [0 ] : ((void * ) 0 ) ) ); 

# 2904 "./../src/salloc.c"
  trace_for_tag = scheme_rt_delay_load_info ; 
  for_each_found = increment_code_counter ; 
  code_counter = 0 ; 

  if (c && ((Scheme_Type ) (((((intptr_t ) (p [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#   define XfOrM97_COUNT (0+XfOrM94_COUNT)
#   define SETUP_XfOrM97(x) SETUP_XfOrM94(x)

# 2909 "./../src/salloc.c"
    if (! (strcmp ("count" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (p [0 ] ) ) ) -> s ) ) ) 
    && (c == 2 ) 
    && ((Scheme_Type ) (((((intptr_t ) (p [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
      int i , maxpos ; 
#     define XfOrM98_COUNT (0+XfOrM97_COUNT)
#     define SETUP_XfOrM98(x) SETUP_XfOrM97(x)

# 2913 "./../src/salloc.c"
      maxpos = FUNCCALL(SETUP_XfOrM98(_), scheme_num_types () ); 
      for (i = maxpos ; i -- ; ) {
        void * tn ; 
        BLOCK_SETUP((PUSH(tn, 0+XfOrM98_COUNT)));
#       define XfOrM101_COUNT (1+XfOrM98_COUNT)
#       define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
        tn = NULLED_OUT ; 

# 2916 "./../src/salloc.c"
        tn = FUNCCALL(SETUP_XfOrM101(_), scheme_get_type_name_or_null (i ) ); 
        if (tn && ! (strcmp (tn , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (p [1 ] ) ) ) -> s ) ) ) ) {
          found_counter = 0 ; 
          for_each_found = increment_found_counter ; 
          trace_for_tag = i ; 
          dump_flags |= 0x8 ; 
          skip_summary = 1 ; 
          break ; 
        }
      }
    }
  }

# 3060 "./../src/salloc.c"
  if (! skip_summary )
    FUNCCALL(SETUP_XfOrM94(_), scheme_console_printf ("Begin Dump\n" ) ); 
  FUNCCALL(SETUP_XfOrM94(_), GC_dump_with_traces (dump_flags , scheme_get_type_name_or_null , for_each_found , trace_for_tag , trace_for_tag , record_traced_filter , maybe_print_traced_filter , ((void * ) 0 ) , 10000 , ((void * ) 0 ) ) )
# 3072 "./../src/salloc.c"
  ; 





  if (! skip_summary )
    FUNCCALL(SETUP_XfOrM94(_), scheme_console_printf ("JIT-generated code: %ld\n" , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_code_page_total_ ) ) ); 


  if (! skip_summary || (for_each_found == increment_code_counter ) ) {
#   define XfOrM96_COUNT (0+XfOrM94_COUNT)
#   define SETUP_XfOrM96(x) SETUP_XfOrM94(x)
    FUNCCALL(SETUP_XfOrM96(_), scheme_console_printf ("Marshaled code: %ld\n" , code_counter ) )
# 3083 "./../src/salloc.c"
    ; 
  }

# 3110 "./../src/salloc.c"
  if (scheme_external_dump_info )
    FUNCCALL(SETUP_XfOrM94(_), scheme_external_dump_info () ); 

# 3167 "./../src/salloc.c"
  if (! skip_summary ) {
#   define XfOrM95_COUNT (0+XfOrM94_COUNT)
#   define SETUP_XfOrM95(x) SETUP_XfOrM94(x)
    FUNCCALL(SETUP_XfOrM95(_), scheme_console_printf ("Begin Help\n" ) )
# 3169 "./../src/salloc.c"
    ; 
    FUNCCALL(SETUP_XfOrM95(_), scheme_console_printf (" (dump-memory-stats 'count sym) - return number of instances of type named by sym\n" ) )
# 3184 "./../src/salloc.c"
    ; 
    FUNCCALL_AGAIN(scheme_console_printf ("   Example: (dump-memory-stats 'count '<pair>)\n" ) ); 
    FUNCCALL_AGAIN(scheme_console_printf ("End Help\n" ) )






    ; 
    FUNCCALL_AGAIN(scheme_console_printf ("End Dump\n" ) )

    ; 
  }


  if (for_each_found == increment_found_counter )
    result = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (found_counter ) ) ) << 1 ) | 0x1 ) ) ; 
  FUNCCALL(SETUP_XfOrM94(_), scheme_end_atomic () )






  ; 

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
