#include "precomp.h"

# 15 "./../src/compile.c"
Scheme_Object scheme_undefined [1 ] ; 


static Scheme_Object * lambda_symbol ; 
static Scheme_Object * case_lambda_symbol ; 
static Scheme_Object * ref_symbol ; 
static Scheme_Object * quote_symbol ; 
static Scheme_Object * if_symbol ; 
static Scheme_Object * set_symbol ; 
static Scheme_Object * let_values_symbol ; 
static Scheme_Object * letrec_values_symbol ; 
static Scheme_Object * begin_symbol ; 
static Scheme_Object * begin0_symbol ; 
static Scheme_Object * with_cont_mark_symbol ; 
static Scheme_Object * define_values_symbol ; 

static Scheme_Object * compiler_inline_hint_symbol ; 
static Scheme_Object * protected_symbol ; 
static Scheme_Object * values_symbol ; 
static Scheme_Object * call_with_values_symbol ; 
static Scheme_Object * inferred_name_symbol ; 
static Scheme_Object * source_name_symbol ; 


static Scheme_Object * lambda_compile (Scheme_Object * form , Scheme_Comp_Env * env ) ; 
static Scheme_Object * case_lambda_compile (Scheme_Object * form , Scheme_Comp_Env * env ) ; 
static Scheme_Object * ref_compile (Scheme_Object * form , Scheme_Comp_Env * env ) ; 
static Scheme_Object * quote_compile (Scheme_Object * form , Scheme_Comp_Env * env ) ; 
static Scheme_Object * if_compile (Scheme_Object * form , Scheme_Comp_Env * env ) ; 
static Scheme_Object * set_compile (Scheme_Object * form , Scheme_Comp_Env * env ) ; 
static Scheme_Object * letrec_values_compile (Scheme_Object * form , Scheme_Comp_Env * env ) ; 
static Scheme_Object * begin_compile (Scheme_Object * form , Scheme_Comp_Env * env ) ; 
static Scheme_Object * begin0_compile (Scheme_Object * form , Scheme_Comp_Env * env ) ; 
static Scheme_Object * with_cont_mark_compile (Scheme_Object * form , Scheme_Comp_Env * env ) ; 

static Scheme_Object * compile_expr (Scheme_Object * form , Scheme_Comp_Env * env , int app_position ) ; 
static Scheme_Object * compile_list (Scheme_Object * form , 
Scheme_Comp_Env * first_env , Scheme_Comp_Env * env , Scheme_Comp_Env * last_env , 
int start_app_position ) ; 
static Scheme_Object * compile_app (Scheme_Object * form , Scheme_Comp_Env * env ) ; 

static Scheme_Object * generate_defn_name (Scheme_Object * base_sym , 
Scheme_Hash_Tree * used_names , 
Scheme_Hash_Tree * also_used_names , 
int search_start ) ; 

static Scheme_Object * extract_source_name (Scheme_Object * e , int no_default ) ; 


static void register_traversers (void ) ; 









void scheme_init_compile (Scheme_Startup_Env * env ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM1_COUNT (1)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM1(_), register_traversers () )
# 77 "./../src/compile.c"
  ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_register_static ((void * ) & lambda_symbol , sizeof (lambda_symbol ) ) )

  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & case_lambda_symbol , sizeof (case_lambda_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & ref_symbol , sizeof (ref_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & quote_symbol , sizeof (quote_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & if_symbol , sizeof (if_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & set_symbol , sizeof (set_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & let_values_symbol , sizeof (let_values_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & letrec_values_symbol , sizeof (letrec_values_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & begin_symbol , sizeof (begin_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & begin0_symbol , sizeof (begin0_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & with_cont_mark_symbol , sizeof (with_cont_mark_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & define_values_symbol , sizeof (define_values_symbol ) ) ); 

  lambda_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("lambda" ) ); 
  case_lambda_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("case-lambda" ) ); 
  ref_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("#%variable-reference" ) ); 
  quote_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("quote" ) ); 
  if_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("if" ) ); 
  set_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("set!" ) ); 
  let_values_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("let-values" ) ); 
  letrec_values_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("letrec-values" ) ); 
  begin_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("begin" ) ); 
  begin0_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("begin0" ) ); 
  with_cont_mark_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("with-continuation-mark" ) ); 
  define_values_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("define-values" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & compiler_inline_hint_symbol , sizeof (compiler_inline_hint_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & inferred_name_symbol , sizeof (inferred_name_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & source_name_symbol , sizeof (source_name_symbol ) ) ); 

  scheme_undefined -> type = scheme_undefined_type ; 

  compiler_inline_hint_symbol = FUNCCALL(SETUP_XfOrM1(_), scheme_intern_symbol ("compiler-hint:cross-module-inline" ) ); 

  inferred_name_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("inferred-name" ) ); 
  source_name_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("source-name" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & protected_symbol , sizeof (protected_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & values_symbol , sizeof (values_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & call_with_values_symbol , sizeof (call_with_values_symbol ) ) ); 

  protected_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("protected" ) ); 
  values_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("values" ) ); 
  call_with_values_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("call-with-values" ) ); 
  FUNCCALL_EMPTY(scheme_init_marshal (env ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 128 "./../src/compile.c"
void scheme_init_compile_places () 
{
  /* No conversion */
}




static int check_form (Scheme_Object * form , Scheme_Object * base_form ) 
{
  /* No conversion */

# 138 "./../src/compile.c"
  int i ; 

  for (i = 0 ; (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ; i ++ ) {
    form = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  }

  if (! (((form ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) form ) -> val ) == (scheme_null ) ) ) ) ) {
    scheme_wrong_syntax (((void * ) 0 ) , form , base_form , "illegal use of `.'" ) ; 
  }

  return i ; 
}

static void bad_form (Scheme_Object * form , int l ) 
{
  /* No conversion */

# 153 "./../src/compile.c"
  scheme_wrong_syntax (((void * ) 0 ) , ((void * ) 0 ) , form , 
  "bad syntax;\n has %d part%s after keyword" , 
  l - 1 , (l != 2 ) ? "s" : "" ) ; 
}

static Scheme_Comp_Env * check_name_property (Scheme_Object * code , Scheme_Comp_Env * env ) 
{
  Scheme_Object * name ; 
  DECL_RET_SAVE (Scheme_Comp_Env * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(name, 1)));
# define XfOrM8_COUNT (2)
# define SETUP_XfOrM8(x) SETUP(XfOrM8_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name = NULLED_OUT ; 

# 162 "./../src/compile.c"
  name = FUNCCALL(SETUP_XfOrM8(_), scheme_stx_property (code , inferred_name_symbol , ((void * ) 0 ) ) ); 
  if (name && ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_set_comp_env_name (env , name ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START (env ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * lambda_check (Scheme_Object * form ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(form, 0)));
# define XfOrM9_COUNT (1)
# define SETUP_XfOrM9(x) SETUP(XfOrM9_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 175 "./../src/compile.c"
  if ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) 
  && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ) {
    Scheme_Object * rest ; 
#   define XfOrM10_COUNT (0+XfOrM9_COUNT)
#   define SETUP_XfOrM10(x) SETUP_XfOrM9(x)
    rest = NULLED_OUT ; 

# 178 "./../src/compile.c"
    rest = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
    if (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )  {
      int len ; 
#     define XfOrM11_COUNT (0+XfOrM10_COUNT)
#     define SETUP_XfOrM11(x) SETUP_XfOrM10(x)

# 181 "./../src/compile.c"
      len = FUNCCALL(SETUP_XfOrM11(_), check_form (form , form ) ); 
      if (len != 3 )
        FUNCCALL(SETUP_XfOrM11(_), bad_form (form , len ) ); 

      RET_VALUE_START (form ) RET_VALUE_END ; 
    }
  }
  FUNCCALL_EMPTY(scheme_wrong_syntax (((void * ) 0 ) , ((void * ) 0 ) , form , ((void * ) 0 ) ) )
  ; 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 193 "./../src/compile.c"
static void lambda_check_args (Scheme_Object * args , Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  Scheme_Object * v , * a ; 
  DupCheckRecord r ; 
  PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(a, 1), PUSH(form, 2), PUSHARRAY(r.syms, 5, 3), PUSH(r.ht, 6), PUSH(args, 7)));
# define XfOrM12_COUNT (8)
# define SETUP_XfOrM12(x) SETUP(XfOrM12_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  a = NULLED_OUT ; 
  NULL_OUT_ARRAY (r.syms ) ; 
  r.ht = NULLED_OUT ; 

# 198 "./../src/compile.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (args ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (args ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) args ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) args ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) ) ) {
#   define XfOrM13_COUNT (0+XfOrM12_COUNT)
#   define SETUP_XfOrM13(x) SETUP_XfOrM12(x)

# 199 "./../src/compile.c"
    for (v = args ; (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) v ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) v ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ; v = (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) v ) -> val ) ) -> u . pair_val . cdr ) ) ) {
#     define XfOrM20_COUNT (0+XfOrM13_COUNT)
#     define SETUP_XfOrM20(x) SETUP_XfOrM13(x)

# 200 "./../src/compile.c"
      a = (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) v ) -> val ) ) -> u . pair_val . car ) ) ; 
      FUNCCALL(SETUP_XfOrM20(_), scheme_check_identifier (((void * ) 0 ) , a , ((void * ) 0 ) , form ) ); 
    }

    if (! (((v ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) v ) -> val ) == (scheme_null ) ) ) ) ) {
#     define XfOrM17_COUNT (0+XfOrM13_COUNT)
#     define SETUP_XfOrM17(x) SETUP_XfOrM13(x)

# 205 "./../src/compile.c"
      if (! (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) v ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) v ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) ) ) {
#       define XfOrM18_COUNT (0+XfOrM17_COUNT)
#       define SETUP_XfOrM18(x) SETUP_XfOrM17(x)
        FUNCCALL(SETUP_XfOrM18(_), scheme_check_identifier (((void * ) 0 ) , v , ((void * ) 0 ) , form ) )
# 206 "./../src/compile.c"
        ; 
      }
    }
    FUNCCALL(SETUP_XfOrM13(_), scheme_begin_dup_symbol_check (& r ) )

    ; 
    for (v = args ; (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) v ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) v ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ; v = (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) v ) -> val ) ) -> u . pair_val . cdr ) ) ) {
      Scheme_Object * name ; 
      BLOCK_SETUP((PUSH(name, 0+XfOrM13_COUNT)));
#     define XfOrM16_COUNT (1+XfOrM13_COUNT)
#     define SETUP_XfOrM16(x) SETUP(XfOrM16_COUNT)
      name = NULLED_OUT ; 

# 215 "./../src/compile.c"
      name = (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) v ) -> val ) ) -> u . pair_val . car ) ) ; 
      FUNCCALL(SETUP_XfOrM16(_), scheme_dup_symbol_check (& r , ((void * ) 0 ) , name , "argument" , form ) ); 
    }
    if (! (((v ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) v ) -> val ) == (scheme_null ) ) ) ) ) {
#     define XfOrM14_COUNT (0+XfOrM13_COUNT)
#     define SETUP_XfOrM14(x) SETUP_XfOrM13(x)
      FUNCCALL(SETUP_XfOrM14(_), scheme_dup_symbol_check (& r , ((void * ) 0 ) , v , "argument" , form ) )
# 219 "./../src/compile.c"
      ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 224 "./../src/compile.c"
Scheme_Object * scheme_source_to_name (Scheme_Object * code ) 

{
  Scheme_Stx * cstx = (Scheme_Stx * ) code ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(cstx, 0)));
# define XfOrM21_COUNT (1)
# define SETUP_XfOrM21(x) SETUP(XfOrM21_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 229 "./../src/compile.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (code ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (code ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  if ((cstx -> srcloc -> col >= 0 ) || (cstx -> srcloc -> pos >= 0 ) ) {
    char buf [50 ] , src [20 ] ; 
    Scheme_Object * name , * bstr ; 
    int convert_backslash = 0 ; 
    BLOCK_SETUP((PUSH(name, 0+XfOrM21_COUNT), PUSH(bstr, 1+XfOrM21_COUNT)));
#   define XfOrM22_COUNT (2+XfOrM21_COUNT)
#   define SETUP_XfOrM22(x) SETUP(XfOrM22_COUNT)
    name = NULLED_OUT ; 
    bstr = NULLED_OUT ; 

# 237 "./../src/compile.c"
    if (cstx -> srcloc -> src ) {
#     define XfOrM31_COUNT (0+XfOrM22_COUNT)
#     define SETUP_XfOrM31(x) SETUP_XfOrM22(x)

# 238 "./../src/compile.c"
      if ((Scheme_Type ) (((((intptr_t ) (cstx -> srcloc -> src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cstx -> srcloc -> src ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
        bstr = cstx -> srcloc -> src ; 


        convert_backslash = 1 ; 
      }

# 243 "./../src/compile.c"
      else if ((Scheme_Type ) (((((intptr_t ) (cstx -> srcloc -> src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cstx -> srcloc -> src ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
        bstr = FUNCCALL(SETUP_XfOrM31(_), scheme_char_string_to_byte_string (cstx -> srcloc -> src ) ); 
      else 
      bstr = ((void * ) 0 ) ; 
    }

# 247 "./../src/compile.c"
    else 
    bstr = ((void * ) 0 ) ; 

    if (bstr ) {
#     define XfOrM26_COUNT (0+XfOrM22_COUNT)
#     define SETUP_XfOrM26(x) SETUP_XfOrM22(x)

# 251 "./../src/compile.c"
      if ((((Scheme_Simple_Object * ) (bstr ) ) -> u . byte_str_val . tag_val ) < 20 )
        (memcpy (src , (((Scheme_Simple_Object * ) (bstr ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (bstr ) ) -> u . byte_str_val . tag_val ) + 1 ) ) ; 
      else {
#       define XfOrM30_COUNT (0+XfOrM26_COUNT)
#       define SETUP_XfOrM30(x) SETUP_XfOrM26(x)
        (
# 254 "./../src/compile.c"
        memcpy (src , (((Scheme_Simple_Object * ) (bstr ) ) -> u . byte_str_val . string_val ) + (((Scheme_Simple_Object * ) (bstr ) ) -> u . byte_str_val . tag_val ) - 19 , 20 ) ) ; 
        src [0 ] = '.' ; 
        src [1 ] = '.' ; 
        src [2 ] = '.' ; 
      }
      if (convert_backslash ) {
        int i ; 
        for (i = 0 ; src [i ] ; i ++ ) {
          if (src [i ] == '\\' )
            src [i ] = '/' ; 
        }
      }
    }

# 266 "./../src/compile.c"
    else {
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    if (cstx -> srcloc -> line >= 0 ) {
#     define XfOrM24_COUNT (0+XfOrM22_COUNT)
#     define SETUP_XfOrM24(x) SETUP_XfOrM22(x)
      (
# 271 "./../src/compile.c"
      sprintf (buf , "%s%s%" "l" "d" ":%" "l" "d" , 
      src , (src [0 ] ? ":" : "" ) , cstx -> srcloc -> line , cstx -> srcloc -> col - 1 ) ) ; 
    }

# 273 "./../src/compile.c"
    else {
#     define XfOrM23_COUNT (0+XfOrM22_COUNT)
#     define SETUP_XfOrM23(x) SETUP_XfOrM22(x)
      (
# 274 "./../src/compile.c"
      sprintf (buf , "%s%s%" "l" "d" , 
      src , (src [0 ] ? "::" : "" ) , cstx -> srcloc -> pos ) ) ; 
    }

    name = FUNCCALL(SETUP_XfOrM22(_), scheme_intern_exact_symbol (buf , strlen (buf ) ) ); 
    RET_VALUE_START (name ) RET_VALUE_END ; 
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 285 "./../src/compile.c"
Scheme_Object * combine_name_with_srcloc (Scheme_Object * name , Scheme_Object * code , int src_based_name ) 
{
  Scheme_Stx * cstx = (Scheme_Stx * ) code ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(cstx, 1)));
# define XfOrM33_COUNT (2)
# define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 289 "./../src/compile.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (code ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (code ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) )
    RET_VALUE_START (name ) RET_VALUE_END ; 

  if (((cstx -> srcloc -> col >= 0 ) || (cstx -> srcloc -> pos >= 0 ) ) 
  && cstx -> srcloc -> src ) {
    Scheme_Object * vec ; 
    BLOCK_SETUP((PUSH(vec, 0+XfOrM33_COUNT)));
#   define XfOrM34_COUNT (1+XfOrM33_COUNT)
#   define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
    vec = NULLED_OUT ; 

# 295 "./../src/compile.c"
    vec = FUNCCALL(SETUP_XfOrM34(_), scheme_make_vector (7 , ((void * ) 0 ) ) ); 
    (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = name ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = cstx -> srcloc -> src ; 
    if (cstx -> srcloc -> line >= 0 ) {
      (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (cstx -> srcloc -> line ) ) ) << 1 ) | 0x1 ) ) ; 
      (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (cstx -> srcloc -> col - 1 ) ) ) << 1 ) | 0x1 ) ) ; 
    }

# 301 "./../src/compile.c"
    else {
      (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = scheme_false ; 
      (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = scheme_false ; 
    }
    if (cstx -> srcloc -> pos >= 0 )
      (((Scheme_Vector * ) (vec ) ) -> els ) [4 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (cstx -> srcloc -> pos ) ) ) << 1 ) | 0x1 ) ) ; 
    else 
    (((Scheme_Vector * ) (vec ) ) -> els ) [4 ] = scheme_false ; 
    if (cstx -> srcloc -> span >= 0 )
      (((Scheme_Vector * ) (vec ) ) -> els ) [5 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (cstx -> srcloc -> span ) ) ) << 1 ) | 0x1 ) ) ; 
    else 
    (((Scheme_Vector * ) (vec ) ) -> els ) [5 ] = scheme_false ; 
    (((Scheme_Vector * ) (vec ) ) -> els ) [6 ] = (src_based_name ? scheme_true : scheme_false ) ; 

    RET_VALUE_START (vec ) RET_VALUE_END ; 
  }

  RET_VALUE_START (name ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 321 "./../src/compile.c"
Scheme_Object * scheme_build_closure_name (Scheme_Object * code , Scheme_Comp_Env * env ) 
{
  Scheme_Object * name ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(name, 1), PUSH(code, 2)));
# define XfOrM37_COUNT (3)
# define SETUP_XfOrM37(x) SETUP(XfOrM37_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name = NULLED_OUT ; 

# 325 "./../src/compile.c"
  name = FUNCCALL(SETUP_XfOrM37(_), scheme_stx_property (code , inferred_name_symbol , ((void * ) 0 ) ) ); 
  if (name && ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#   define XfOrM42_COUNT (0+XfOrM37_COUNT)
#   define SETUP_XfOrM42(x) SETUP_XfOrM37(x)

# 327 "./../src/compile.c"
    name = FUNCCALL(SETUP_XfOrM42(_), combine_name_with_srcloc (name , code , 0 ) ); 
  }

# 328 "./../src/compile.c"
  else if (name && (((name ) ) == (scheme_void ) ) ) {
#   define XfOrM41_COUNT (0+XfOrM37_COUNT)
#   define SETUP_XfOrM41(x) SETUP_XfOrM37(x)

# 329 "./../src/compile.c"
    name = FUNCCALL(SETUP_XfOrM41(_), scheme_source_to_name (code ) ); 
    if (name )
      name = FUNCCALL(SETUP_XfOrM41(_), combine_name_with_srcloc (name , code , 1 ) ); 
  }

# 332 "./../src/compile.c"
  else {
#   define XfOrM38_COUNT (0+XfOrM37_COUNT)
#   define SETUP_XfOrM38(x) SETUP_XfOrM37(x)

# 333 "./../src/compile.c"
    name = env -> value_name ; 
    if (name )
      name = (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) name ) -> val : name ) ; 
    if (! name || (((name ) ) == (scheme_false ) ) ) {
#     define XfOrM40_COUNT (0+XfOrM38_COUNT)
#     define SETUP_XfOrM40(x) SETUP_XfOrM38(x)

# 337 "./../src/compile.c"
      name = FUNCCALL(SETUP_XfOrM40(_), scheme_source_to_name (code ) ); 
      if (name )
        name = FUNCCALL(SETUP_XfOrM40(_), combine_name_with_srcloc (name , code , 1 ) ); 
    }

# 340 "./../src/compile.c"
    else {
#     define XfOrM39_COUNT (0+XfOrM38_COUNT)
#     define SETUP_XfOrM39(x) SETUP_XfOrM38(x)

# 341 "./../src/compile.c"
      name = FUNCCALL(SETUP_XfOrM39(_), combine_name_with_srcloc (name , code , 0 ) ); 
    }
  }

# 358 "./../src/compile.c"
  RET_VALUE_START (name ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 361 "./../src/compile.c"
static Scheme_Object * make_lambda (Scheme_Comp_Env * env , Scheme_Object * code ) 

{
  Scheme_Object * allparams , * params , * forms , * param , * name ; 
  Scheme_Lambda * lam ; 
  intptr_t num_params ; 
  Scheme_IR_Local * var , * * vars ; 
  Scheme_IR_Lambda_Info * cl ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(cl, 1), PUSH(param, 2), PUSH(allparams, 3), PUSH(name, 4), PUSH(forms, 5), PUSH(var, 6), PUSH(params, 7), PUSH(code, 8), PUSH(vars, 9), PUSH(lam, 10)));
# define XfOrM43_COUNT (11)
# define SETUP_XfOrM43(x) SETUP(XfOrM43_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  allparams = NULLED_OUT ; 
  params = NULLED_OUT ; 
  forms = NULLED_OUT ; 
  param = NULLED_OUT ; 
  name = NULLED_OUT ; 
  lam = NULLED_OUT ; 
  var = NULLED_OUT ; 
  vars = NULLED_OUT ; 
  cl = NULLED_OUT ; 

# 371 "./../src/compile.c"
  lam = ((Scheme_Lambda * ) FUNCCALL(SETUP_XfOrM43(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Lambda ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  lam -> iso . so . type = scheme_ir_lambda_type ; 

  params = (((Scheme_Type ) (((((intptr_t ) (code ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (code ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (code ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) code ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  params = (((Scheme_Type ) (((((intptr_t ) (params ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (params ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) params ) -> val ) ) -> u . pair_val . car ) ) ; 
  allparams = params ; 

  num_params = 0 ; 
  for (; (((Scheme_Type ) (((((intptr_t ) (params ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (params ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) params ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) params ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ; params = (((Scheme_Type ) (((((intptr_t ) (params ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (params ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) params ) -> val ) ) -> u . pair_val . cdr ) ) ) {
    num_params ++ ; 
  }
  (& (lam ) -> iso ) -> so . keyex = 0 ; 
  if (! (((params ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (params ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) params ) -> val ) == (scheme_null ) ) ) ) ) {
    (& (lam ) -> iso ) -> so . keyex |= 1 ; 
    num_params ++ ; 
  }
  lam -> num_params = num_params ; 
  if ((lam -> num_params > 0 ) && FUNCCALL(SETUP_XfOrM43(_), scheme_has_method_property (code ) ))
    (& (lam ) -> iso ) -> so . keyex |= 16 ; 

  forms = (((Scheme_Type ) (((((intptr_t ) (code ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (code ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (code ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) code ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  forms = (((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (forms ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) forms ) -> val ) ) -> u . pair_val . cdr ) ) ; 

  env = FUNCCALL(SETUP_XfOrM43(_), check_name_property (code , env ) ); 
  name = FUNCCALL_AGAIN(scheme_build_closure_name (code , env ) ); 
  lam -> name = name ; 

  env = FUNCCALL(SETUP_XfOrM43(_), scheme_set_comp_env_name (env , ((void * ) 0 ) ) ); 

  vars = ((Scheme_IR_Local * * ) FUNCCALL(SETUP_XfOrM43(_), GC_malloc (sizeof (Scheme_IR_Local * ) * (num_params ) ) )) ; 

  params = allparams ; 
  for (i = 0 ; i < num_params ; i ++ ) {
#   define XfOrM46_COUNT (0+XfOrM43_COUNT)
#   define SETUP_XfOrM46(x) SETUP_XfOrM43(x)

# 405 "./../src/compile.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (params ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (params ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) params ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) params ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) )
      param = params ; 
    else 
    param = (((Scheme_Type ) (((((intptr_t ) (params ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (params ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) params ) -> val ) ) -> u . pair_val . car ) ) ; 
    var = FUNCCALL(SETUP_XfOrM46(_), scheme_make_ir_local (param ) ); 
    vars [i ] = var ; 
    env = FUNCCALL(SETUP_XfOrM46(_), scheme_extend_comp_env (env , param , (Scheme_Object * ) var , i > 0 , 0 ) ); 
    if (((Scheme_Type ) (((((intptr_t ) (params ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (params ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) params ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) params ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) 
      params = (((Scheme_Type ) (((((intptr_t ) (params ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (params ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (params ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) params ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  }

  if (((forms ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) forms ) -> val ) == (scheme_null ) ) ) ) 
    FUNCCALL_EMPTY(scheme_wrong_syntax (((void * ) 0 ) , ((void * ) 0 ) , code , "empty body not allowed" ) ); 

  {
    Scheme_Object * body ; 
    BLOCK_SETUP((PUSH(body, 0+XfOrM43_COUNT)));
#   define XfOrM44_COUNT (1+XfOrM43_COUNT)
#   define SETUP_XfOrM44(x) SETUP(XfOrM44_COUNT)
    body = NULLED_OUT ; 

# 421 "./../src/compile.c"
    body = FUNCCALL(SETUP_XfOrM44(_), compile_expr ((((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (forms ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) forms ) -> val ) ) -> u . pair_val . car ) ) , env , 0 ) ); 
    lam -> body = body ; 
  }

  cl = ((Scheme_IR_Lambda_Info * ) FUNCCALL(SETUP_XfOrM43(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Lambda_Info ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  cl -> type = scheme_rt_ir_lambda_info ; 
  cl -> vars = vars ; 
  lam -> ir_info = cl ; 

  RET_VALUE_START ((Scheme_Object * ) lam ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 433 "./../src/compile.c"
static Scheme_Object * lambda_compile (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  Scheme_Object * args ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(form, 1), PUSH(args, 2)));
# define XfOrM50_COUNT (3)
# define SETUP_XfOrM50(x) SETUP(XfOrM50_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  args = NULLED_OUT ; 

# 437 "./../src/compile.c"
  form = FUNCCALL(SETUP_XfOrM50(_), lambda_check (form ) ); 

  args = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  args = (((Scheme_Type ) (((((intptr_t ) (args ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (args ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) args ) -> val ) ) -> u . pair_val . car ) ) ; 
  FUNCCALL(SETUP_XfOrM50(_), lambda_check_args (args , form , env ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_lambda (env , form ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 446 "./../src/compile.c"
Scheme_Object * scheme_clone_vector (Scheme_Object * lam , int skip , int set_type ) 
{
  Scheme_Object * naya ; 
  int i , size ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(lam, 1)));
# define XfOrM51_COUNT (2)
# define SETUP_XfOrM51(x) SETUP(XfOrM51_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 451 "./../src/compile.c"
  size = (((Scheme_Vector * ) (lam ) ) -> size ) ; 
  naya = FUNCCALL(SETUP_XfOrM51(_), scheme_make_vector (size - skip , ((void * ) 0 ) ) ); 
  for (i = skip ; i < size ; i ++ ) {
    (((Scheme_Vector * ) (naya ) ) -> els ) [i - skip ] = (((Scheme_Vector * ) (lam ) ) -> els ) [i ] ; 
  }

  if (set_type )
    naya -> type = lam -> type ; 

  RET_VALUE_START (naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * quote_compile (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  /* No conversion */

# 469 "./../src/compile.c"
  Scheme_Object * v , * rest ; 

  rest = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  if (! ((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) rest ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) && ((((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) == (scheme_null ) ) ) ) ) )
    scheme_wrong_syntax (((void * ) 0 ) , ((void * ) 0 ) , form , "wrong number of parts" ) ; 

  v = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . car ) ) ; 

  return scheme_syntax_to_datum (v ) ; 
}





static void check_if_len (Scheme_Object * form , int len ) 
{
  /* No conversion */

# 486 "./../src/compile.c"
  if (len != 4 ) {
    if (len == 3 ) {
      scheme_wrong_syntax (((void * ) 0 ) , ((void * ) 0 ) , form , 
      "missing an \"else\" expression" ) ; 
    }

# 490 "./../src/compile.c"
    else {
      bad_form (form , len ) ; 
    }
  }
}

Scheme_Object * scheme_make_branch (Scheme_Object * test , Scheme_Object * thenp , 
Scheme_Object * elsep ) 
{
  Scheme_Branch_Rec * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(test, 0), PUSH(thenp, 1), PUSH(elsep, 2), PUSH(b, 3)));
# define XfOrM59_COUNT (4)
# define SETUP_XfOrM59(x) SETUP(XfOrM59_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 501 "./../src/compile.c"
  if (((((intptr_t ) (test ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (test ) ) -> type ) > _scheme_ir_values_types_ ) {
    if (((test ) ) == (scheme_false ) ) 
      RET_VALUE_START (elsep ) RET_VALUE_END ; 
    else 
    RET_VALUE_START (thenp ) RET_VALUE_END ; 
  }

  b = ((Scheme_Branch_Rec * ) FUNCCALL(SETUP_XfOrM59(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Branch_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  b -> so . type = scheme_branch_type ; 

  b -> test = test ; 
  b -> tbranch = thenp ; 
  b -> fbranch = elsep ; 

  RET_VALUE_START ((Scheme_Object * ) b ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 518 "./../src/compile.c"
static Scheme_Object * if_compile (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  int len , opt ; 
  Scheme_Object * test , * thenp , * elsep , * rest ; 
  Scheme_Comp_Env * __funcarg60 = NULLED_OUT ; 
  Scheme_Comp_Env * __funcarg59 = NULLED_OUT ; 
  Scheme_Comp_Env * __funcarg58 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(rest, 1), PUSH(form, 2), PUSH(thenp, 3), PUSH(elsep, 4), PUSH(test, 5)));
# define XfOrM61_COUNT (6)
# define SETUP_XfOrM61(x) SETUP(XfOrM61_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  test = NULLED_OUT ; 
  thenp = NULLED_OUT ; 
  elsep = NULLED_OUT ; 
  rest = NULLED_OUT ; 

# 523 "./../src/compile.c"
  len = FUNCCALL(SETUP_XfOrM61(_), check_form (form , form ) ); 
  FUNCCALL_AGAIN(check_if_len (form , len ) ); 

  env = FUNCCALL_AGAIN(check_name_property (form , env ) ); 

  rest = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  test = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . car ) ) ; 
  rest = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  thenp = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . car ) ) ; 
  if (len == 4 ) {
    rest = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ; 
    elsep = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . car ) ) ; 
  }

# 535 "./../src/compile.c"
  else 
  elsep = FUNCCALL(SETUP_XfOrM61(_), scheme_compiled_void () ); 

  test = (__funcarg60 = FUNCCALL(SETUP_XfOrM61(_), scheme_set_comp_env_name (env , ((void * ) 0 ) ) ), FUNCCALL_AGAIN(compile_expr (test , __funcarg60 , 0 ) )) ; 

  if (((((intptr_t ) (test ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (test ) ) -> type ) > _scheme_ir_values_types_ ) {
#   define XfOrM63_COUNT (0+XfOrM61_COUNT)
#   define SETUP_XfOrM63(x) SETUP_XfOrM61(x)

# 541 "./../src/compile.c"
    opt = 1 ; 

    if (((test ) ) == (scheme_false ) )  {
#     define XfOrM66_COUNT (0+XfOrM63_COUNT)
#     define SETUP_XfOrM66(x) SETUP_XfOrM63(x)
      (__funcarg59 = FUNCCALL(SETUP_XfOrM66(_), scheme_set_comp_env_flags (env , 0x2 ) )
# 545 "./../src/compile.c"
      , FUNCCALL_AGAIN(compile_expr (thenp , __funcarg59 , 0 ) )) ; 

      if (len == 4 )
        test = FUNCCALL(SETUP_XfOrM66(_), compile_expr (elsep , env , 0 ) ); 
      else 
      test = elsep ; 
    }

# 551 "./../src/compile.c"
    else {
#     define XfOrM64_COUNT (0+XfOrM63_COUNT)
#     define SETUP_XfOrM64(x) SETUP_XfOrM63(x)

# 552 "./../src/compile.c"
      if (len == 4 ) {
#       define XfOrM65_COUNT (0+XfOrM64_COUNT)
#       define SETUP_XfOrM65(x) SETUP_XfOrM64(x)
        (__funcarg58 = FUNCCALL(SETUP_XfOrM65(_), scheme_set_comp_env_flags (env , 0x2 ) )
# 554 "./../src/compile.c"
        , FUNCCALL_AGAIN(compile_expr (elsep , __funcarg58 , 0 ) )) ; 
      }

      test = FUNCCALL(SETUP_XfOrM64(_), compile_expr (thenp , env , 0 ) ); 
    }
  }

# 559 "./../src/compile.c"
  else {
#   define XfOrM62_COUNT (0+XfOrM61_COUNT)
#   define SETUP_XfOrM62(x) SETUP_XfOrM61(x)

# 560 "./../src/compile.c"
    opt = 0 ; 
    thenp = FUNCCALL(SETUP_XfOrM62(_), compile_expr (thenp , env , 0 ) ); 
    if (len == 4 )
      elsep = FUNCCALL(SETUP_XfOrM62(_), compile_expr (elsep , env , 0 ) ); 
  }

  if (opt )
    RET_VALUE_START (test ) RET_VALUE_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_branch (test , thenp , elsep ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * with_cont_mark_compile (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  Scheme_Object * key , * val , * expr ; 
  Scheme_Comp_Env * k_env ; 
  Scheme_With_Continuation_Mark * wcm ; 
  int len ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(form, 1), PUSH(expr, 2), PUSH(wcm, 3), PUSH(key, 4), PUSH(k_env, 5), PUSH(val, 6)));
# define XfOrM68_COUNT (7)
# define SETUP_XfOrM68(x) SETUP(XfOrM68_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  key = NULLED_OUT ; 
  val = NULLED_OUT ; 
  expr = NULLED_OUT ; 
  k_env = NULLED_OUT ; 
  wcm = NULLED_OUT ; 

# 583 "./../src/compile.c"
  len = FUNCCALL(SETUP_XfOrM68(_), check_form (form , form ) ); 

  if (len != 4 )
    FUNCCALL(SETUP_XfOrM68(_), bad_form (form , len ) ); 

  form = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  key = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
  form = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  val = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
  form = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  expr = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 

  k_env = FUNCCALL(SETUP_XfOrM68(_), scheme_set_comp_env_name (env , ((void * ) 0 ) ) ); 

  key = FUNCCALL_AGAIN(compile_expr (key , k_env , 0 ) ); 
  val = FUNCCALL_AGAIN(compile_expr (val , k_env , 0 ) ); 
  expr = FUNCCALL_AGAIN(compile_expr (expr , env , 0 ) ); 

  wcm = ((Scheme_With_Continuation_Mark * ) FUNCCALL(SETUP_XfOrM68(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_With_Continuation_Mark ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  wcm -> so . type = scheme_with_cont_mark_type ; 
  wcm -> key = key ; 
  wcm -> val = val ; 
  wcm -> body = expr ; 

  RET_VALUE_START ((Scheme_Object * ) wcm ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * set_compile (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  Scheme_Set_Bang * sb ; 
  Scheme_Object * var , * val , * name , * body , * rest ; 
  int l , set_undef ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(rest, 1), PUSH(name, 2), PUSH(body, 3), PUSH(sb, 4), PUSH(var, 5), PUSH(form, 6), PUSH(val, 7)));
# define XfOrM69_COUNT (8)
# define SETUP_XfOrM69(x) SETUP(XfOrM69_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sb = NULLED_OUT ; 
  var = NULLED_OUT ; 
  val = NULLED_OUT ; 
  name = NULLED_OUT ; 
  body = NULLED_OUT ; 
  rest = NULLED_OUT ; 

# 620 "./../src/compile.c"
  l = FUNCCALL(SETUP_XfOrM69(_), check_form (form , form ) ); 
  if (l != 3 )
    FUNCCALL(SETUP_XfOrM69(_), bad_form (form , l ) ); 

  rest = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  name = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . car ) ) ; 
  rest = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  body = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . car ) ) ; 
  FUNCCALL(SETUP_XfOrM69(_), scheme_check_identifier ("set!" , name , ((void * ) 0 ) , form ) )
  ; 

  var = FUNCCALL_AGAIN(scheme_compile_lookup (name , env , 4 ) ); 

  if ((Scheme_Type ) (((((intptr_t ) (var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (var ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) )  {
#   define XfOrM71_COUNT (0+XfOrM69_COUNT)
#   define SETUP_XfOrM71(x) SETUP_XfOrM69(x)

# 634 "./../src/compile.c"
    if (((Scheme_IR_Toplevel * ) var ) -> instance_pos != - 1 )
      FUNCCALL_EMPTY(scheme_wrong_syntax (((void * ) 0 ) , form , name , "cannot mutate imported variable" ) ); 
    (& (((Scheme_IR_Toplevel * ) var ) ) -> iso ) -> so . keyex |= 0x4 ; 
  }

# 637 "./../src/compile.c"
  else if ((Scheme_Type ) (((((intptr_t ) (var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (var ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_local_type ) )  {
    if (((Scheme_IR_Local * ) var ) -> compile . keep_assignment )
      ((Scheme_IR_Local * ) var ) -> compile . keep_assignment = 2 ; 
  }

  env = FUNCCALL(SETUP_XfOrM69(_), scheme_set_comp_env_name (env , (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) name ) -> val : name ) ) ); 

  val = FUNCCALL(SETUP_XfOrM69(_), compile_expr (body , env , 0 ) ); 

  set_undef = (env -> flags & 0x4 ) ; 

  sb = ((Scheme_Set_Bang * ) FUNCCALL(SETUP_XfOrM69(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Set_Bang ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  sb -> so . type = scheme_set_bang_type ; 
  sb -> var = var ; 
  sb -> val = val ; 
  sb -> set_undef = set_undef ; 

  RET_VALUE_START ((Scheme_Object * ) sb ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * ref_compile (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  Scheme_Object * var , * name , * rest , * pseudo_var ; 
  int l , ok ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(rest, 1), PUSH(name, 2), PUSH(form, 3), PUSH(pseudo_var, 4), PUSH(var, 5)));
# define XfOrM72_COUNT (6)
# define SETUP_XfOrM72(x) SETUP(XfOrM72_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  var = NULLED_OUT ; 
  name = NULLED_OUT ; 
  rest = NULLED_OUT ; 
  pseudo_var = NULLED_OUT ; 

# 666 "./../src/compile.c"
  l = FUNCCALL(SETUP_XfOrM72(_), check_form (form , form ) ); 



  if ((l == 1 ) || ! (env -> flags & 0x1 ) )
    pseudo_var = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM72(_), scheme_make_ir_toplevel (- 1 , - 1 , 0 ) ); 
  else {



    pseudo_var = scheme_false ; 
  }

  if (l == 1 ) {
    var = scheme_false ; 
  }

# 681 "./../src/compile.c"
  else {
#   define XfOrM74_COUNT (0+XfOrM72_COUNT)
#   define SETUP_XfOrM74(x) SETUP_XfOrM72(x)

# 682 "./../src/compile.c"
    if (l != 2 )
      FUNCCALL(SETUP_XfOrM74(_), bad_form (form , l ) ); 

    rest = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
    name = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . car ) ) ; 
    ok = (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) name ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) name ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) ) ; 

    if (! ok ) {
#     define XfOrM76_COUNT (0+XfOrM74_COUNT)
#     define SETUP_XfOrM76(x) SETUP_XfOrM74(x)
      FUNCCALL_EMPTY(scheme_wrong_syntax ("#%variable-reference" , name , form , "not an identifier" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    var = FUNCCALL(SETUP_XfOrM74(_), scheme_compile_lookup (name , env , 4096 ) ); 

    if (! ((Scheme_Type ) (((((intptr_t ) (var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (var ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) 
    && ! ((Scheme_Type ) (((((intptr_t ) (var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (var ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_local_type ) ) 
    && ! ((Scheme_Type ) (((((intptr_t ) (var ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (var ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#     define XfOrM75_COUNT (0+XfOrM74_COUNT)
#     define SETUP_XfOrM75(x) SETUP_XfOrM74(x)
      FUNCCALL_EMPTY(scheme_wrong_syntax (((void * ) 0 ) , name , form , "identifier does not refer to a variable" ) )
# 701 "./../src/compile.c"
      ; 
    }
  }

  {
    Scheme_Object * o ; 
    BLOCK_SETUP((PUSH(o, 0+XfOrM72_COUNT)));
#   define XfOrM73_COUNT (1+XfOrM72_COUNT)
#   define SETUP_XfOrM73(x) SETUP(XfOrM73_COUNT)
    o = NULLED_OUT ; 

# 707 "./../src/compile.c"
    o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM73(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    o -> type = scheme_varref_form_type ; 
    (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr1 ) = var ; 
    (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr2 ) = pseudo_var ; 
    RET_VALUE_START (o ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

Scheme_Object * scheme_unclose_case_lambda (Scheme_Object * expr , int mode ) 
{
  Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) expr ; 
  Scheme_Closure * c ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(expr, 0), PUSH(cl, 1), PUSH(c, 2)));
# define XfOrM79_COUNT (3)
# define SETUP_XfOrM79(x) SETUP(XfOrM79_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  c = NULLED_OUT ; 

# 725 "./../src/compile.c"
  for (i = cl -> count ; i -- ; ) {
    c = (Scheme_Closure * ) cl -> array [i ] ; 
    if (! ! (c -> code -> closure_size ) ) {
      break ; 
    }
  }

  if (i < 0 ) {

    Scheme_Case_Lambda * cl2 ; 
    BLOCK_SETUP((PUSH(cl2, 0+XfOrM79_COUNT)));
#   define XfOrM80_COUNT (1+XfOrM79_COUNT)
#   define SETUP_XfOrM80(x) SETUP(XfOrM80_COUNT)
    cl2 = NULLED_OUT ; 

# 736 "./../src/compile.c"
    cl2 = (Scheme_Case_Lambda * ) FUNCCALL(SETUP_XfOrM80(_), GC_malloc_one_tagged (sizeof (Scheme_Case_Lambda ) + ((cl -> count - 0 ) * sizeof (Scheme_Object * ) ) ) )
    ; 

    cl2 -> so . type = scheme_case_lambda_sequence_type ; 
    cl2 -> count = cl -> count ; 
    cl2 -> name = cl -> name ; 

    for (i = cl -> count ; i -- ; ) {
      c = (Scheme_Closure * ) cl -> array [i ] ; 
      cl2 -> array [i ] = (Scheme_Object * ) c -> code ; 
    }

    if (mode == 2 ) {

      RET_VALUE_START ((Scheme_Object * ) cl2 ) RET_VALUE_END ; 
    }




    else 
    RET_VALUE_START ((Scheme_Object * ) cl2 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (expr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 763 "./../src/compile.c"
static void case_lambda_check_line (Scheme_Object * line , Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  Scheme_Object * body , * args ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(form, 0), PUSH(body, 1), PUSH(line, 2)));
# define XfOrM88_COUNT (3)
# define SETUP_XfOrM88(x) SETUP(XfOrM88_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  body = NULLED_OUT ; 
  args = NULLED_OUT ; 

# 767 "./../src/compile.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (line ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (line ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (line ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (line ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) line ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) line ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_syntax (((void * ) 0 ) , line , form , ((void * ) 0 ) ) ); 

  body = (((Scheme_Type ) (((((intptr_t ) (line ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (line ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (line ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) line ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  args = (((Scheme_Type ) (((((intptr_t ) (line ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (line ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (line ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) line ) -> val ) ) -> u . pair_val . car ) ) ; 
  FUNCCALL(SETUP_XfOrM88(_), lambda_check_args (args , form , env ) )
  ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (body ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (body ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (body ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (body ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) body ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) body ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_syntax (((void * ) 0 ) , line , form , "%s" , (((body ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (body ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (body ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) body ) -> val ) == (scheme_null ) ) ) ) ? "empty body not allowed" : "illegal use of `.'" ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 780 "./../src/compile.c"
static Scheme_Object * case_lambda_compile (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  Scheme_Object * list , * last , * c , * orig_form = form , * name ; 
  Scheme_Case_Lambda * cl ; 
  int i , count = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(list, 1), PUSH(name, 2), PUSH(last, 3), PUSH(c, 4), PUSH(orig_form, 5), PUSH(form, 6), PUSH(cl, 7)));
# define XfOrM89_COUNT (8)
# define SETUP_XfOrM89(x) SETUP(XfOrM89_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  list = NULLED_OUT ; 
  last = NULLED_OUT ; 
  c = NULLED_OUT ; 
  name = NULLED_OUT ; 
  cl = NULLED_OUT ; 

# 786 "./../src/compile.c"
  form = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 

  env = FUNCCALL(SETUP_XfOrM89(_), check_name_property (orig_form , env ) ); 
  name = FUNCCALL_AGAIN(scheme_build_closure_name (orig_form , env ) ); 

  if (((form ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) form ) -> val ) == (scheme_null ) ) ) )  {
#   define XfOrM99_COUNT (0+XfOrM89_COUNT)
#   define SETUP_XfOrM99(x) SETUP_XfOrM89(x)

# 793 "./../src/compile.c"
    form = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM99(_), GC_malloc_one_tagged (sizeof (Scheme_Case_Lambda ) - (0 * sizeof (Scheme_Object * ) ) ) )
    ; 

    form -> type = scheme_case_lambda_sequence_type ; 
    ((Scheme_Case_Lambda * ) form ) -> count = 0 ; 
    ((Scheme_Case_Lambda * ) form ) -> name = name ; 

    if (FUNCCALL(SETUP_XfOrM99(_), scheme_has_method_property (orig_form ) )) {
#     define XfOrM100_COUNT (0+XfOrM99_COUNT)
#     define SETUP_XfOrM100(x) SETUP_XfOrM99(x)

# 802 "./../src/compile.c"
      if (! name )
        name = scheme_false ; 
      name = FUNCCALL(SETUP_XfOrM100(_), scheme_box (name ) ); 
      ((Scheme_Case_Lambda * ) form ) -> name = name ; 
    }

    RET_VALUE_START (form ) RET_VALUE_END ; 
  }

  if (! (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_syntax (((void * ) 0 ) , form , orig_form , ((void * ) 0 ) ) ); 
  if ((((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) == (scheme_null ) ) ) )  {
#   define XfOrM98_COUNT (0+XfOrM89_COUNT)
#   define SETUP_XfOrM98(x) SETUP_XfOrM89(x)

# 814 "./../src/compile.c"
    c = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
    FUNCCALL(SETUP_XfOrM98(_), case_lambda_check_line (c , orig_form , env ) )
    ; 

    c = FUNCCALL_AGAIN(scheme_make_pair (lambda_symbol , c ) ); 
    c = FUNCCALL_AGAIN(scheme_datum_to_syntax (c , orig_form , 0x1 ) ); 

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(lambda_compile (c , env ) )) RET_VALUE_EMPTY_END ; 
  }

  list = last = ((void * ) 0 ) ; 
  while ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ) {
    Scheme_Object * clause ; 
    BLOCK_SETUP((PUSH(clause, 0+XfOrM89_COUNT)));
#   define XfOrM97_COUNT (1+XfOrM89_COUNT)
#   define SETUP_XfOrM97(x) SETUP(XfOrM97_COUNT)
    clause = NULLED_OUT ; 

# 827 "./../src/compile.c"
    clause = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
    FUNCCALL(SETUP_XfOrM97(_), case_lambda_check_line (clause , orig_form , env ) ); 

    c = FUNCCALL_AGAIN(scheme_make_pair (lambda_symbol , clause ) ); 

    c = FUNCCALL_AGAIN(scheme_datum_to_syntax (c , clause , 0 ) ); 

    c = FUNCCALL_AGAIN(scheme_make_pair (c , scheme_null ) ); 

    if (list )
      (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = c ; 
    else 
    list = c ; 

    last = c ; 
    form = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 

    count ++ ; 
  }

  if (! (((form ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) form ) -> val ) == (scheme_null ) ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_syntax (((void * ) 0 ) , form , orig_form , ((void * ) 0 ) ) ); 

  cl = (Scheme_Case_Lambda * ) FUNCCALL(SETUP_XfOrM89(_), GC_malloc_one_tagged (sizeof (Scheme_Case_Lambda ) + (count - 0 ) * sizeof (Scheme_Object * ) ) )

  ; 
  cl -> so . type = scheme_case_lambda_sequence_type ; 
  cl -> count = count ; 
  cl -> name = (! (((name ) ) == (scheme_false ) ) ) ? name : ((void * ) 0 ) ; 

  env = FUNCCALL(SETUP_XfOrM89(_), scheme_set_comp_env_name (env , ((void * ) 0 ) ) ); 

  for (i = 0 ; i < count ; i ++ ) {
    Scheme_Object * ce ; 
    BLOCK_SETUP((PUSH(ce, 0+XfOrM89_COUNT)));
#   define XfOrM95_COUNT (1+XfOrM89_COUNT)
#   define SETUP_XfOrM95(x) SETUP(XfOrM95_COUNT)
    ce = NULLED_OUT ; 

# 861 "./../src/compile.c"
    ce = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ; 
    ce = FUNCCALL(SETUP_XfOrM95(_), compile_expr (ce , env , 0 ) ); 
    cl -> array [i ] = ce ; 
    list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 
  }

  if (FUNCCALL(SETUP_XfOrM89(_), scheme_has_method_property (orig_form ) )) {
    Scheme_Lambda * lam ; 
    lam = NULLED_OUT ; 
    for (i = 0 ; i < count ; i ++ ) {
      lam = (Scheme_Lambda * ) cl -> array [i ] ; 
      if (! lam -> num_params )
        break ; 
    }
    if (i >= count ) {
      lam = (Scheme_Lambda * ) cl -> array [0 ] ; 
      (& (lam ) -> iso ) -> so . keyex |= 16 ; 
    }
  }

  RET_VALUE_START ((Scheme_Object * ) cl ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_IR_Let_Header * make_header (Scheme_Object * first , int num_bindings , int num_clauses , 
int flags ) 
{
  Scheme_IR_Let_Header * head ; 
  DECL_RET_SAVE (Scheme_IR_Let_Header * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(head, 0), PUSH(first, 1)));
# define XfOrM101_COUNT (2)
# define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  head = NULLED_OUT ; 

# 893 "./../src/compile.c"
  head = ((Scheme_IR_Let_Header * ) FUNCCALL(SETUP_XfOrM101(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Let_Header ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  head -> iso . so . type = scheme_ir_let_header_type ; 
  head -> body = first ; 
  head -> count = num_bindings ; 
  head -> num_clauses = num_clauses ; 
  (& head -> iso ) -> so . keyex = flags ; 

  RET_VALUE_START (head ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 903 "./../src/compile.c"
static Scheme_Object * do_let_compile (Scheme_Object * form , Scheme_Comp_Env * origenv , char * formname , 
int recursive ) 
{
  Scheme_Object * bindings , * l , * binding , * name , * * names , * forms ; 
  int num_clauses , num_bindings , i , k , m , pre_k , mutate_frame = 0 , * use_box ; 
  Scheme_Comp_Env * frame , * rhs_env ; 
  Scheme_Object * first = ((void * ) 0 ) ; 
  Scheme_IR_Let_Value * last = ((void * ) 0 ) , * lv ; 
  Scheme_IR_Local * var , * * vars ; 
  DupCheckRecord r ; 
  Scheme_IR_Let_Header * head ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(25);
  BLOCK_SETUP_TOP((PUSH(binding, 0), PUSH(name, 1), PUSH(frame, 2), PUSH(last, 3), PUSH(var, 4), PUSH(rhs_env, 5), PUSH(l, 6), PUSH(bindings, 7), PUSH(lv, 8), PUSH(form, 9), PUSH(forms, 10), PUSHARRAY(r.syms, 5, 11), PUSH(r.ht, 14), PUSH(head, 15), PUSH(origenv, 16), PUSH(names, 17), PUSH(first, 18), PUSH(vars, 19), PUSH(use_box, 20)));
# define XfOrM102_COUNT (21)
# define SETUP_XfOrM102(x) SETUP(XfOrM102_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  bindings = NULLED_OUT ; 
  l = NULLED_OUT ; 
  binding = NULLED_OUT ; 
  name = NULLED_OUT ; 
  names = NULLED_OUT ; 
  forms = NULLED_OUT ; 
  use_box = NULLED_OUT ; 
  frame = NULLED_OUT ; 
  rhs_env = NULLED_OUT ; 
  lv = NULLED_OUT ; 
  var = NULLED_OUT ; 
  vars = NULLED_OUT ; 
  NULL_OUT_ARRAY (r.syms ) ; 
  r.ht = NULLED_OUT ; 
  head = NULLED_OUT ; 

# 915 "./../src/compile.c"
  i = FUNCCALL(SETUP_XfOrM102(_), check_form (form , form ) ); 
  if (i != 3 )
    FUNCCALL(SETUP_XfOrM102(_), bad_form (form , i ) ); 

  bindings = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  bindings = (((Scheme_Type ) (((((intptr_t ) (bindings ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bindings ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (bindings ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) bindings ) -> val ) ) -> u . pair_val . car ) ) ; 
  num_clauses = FUNCCALL(SETUP_XfOrM102(_), scheme_stx_proper_list_length (bindings ) ); 

  if (num_clauses < 0 )
    FUNCCALL(SETUP_XfOrM102(_), scheme_wrong_syntax (((void * ) 0 ) , bindings , form , ((void * ) 0 ) ) ); 


  forms = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  forms = (((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (forms ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) forms ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  forms = (((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (forms ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) forms ) -> val ) ) -> u . pair_val . car ) ) ; 

  origenv = FUNCCALL(SETUP_XfOrM102(_), check_name_property (form , origenv ) ); 

  if (! num_clauses )
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM102(_), compile_expr (forms , origenv , 0 ) )) RET_VALUE_END ; 

  num_bindings = 0 ; 
  l = bindings ; 
  while (! (((l ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) l ) -> val ) == (scheme_null ) ) ) ) ) {
    Scheme_Object * clause , * names , * rest ; 
    int num_names ; 
    BLOCK_SETUP((PUSH(rest, 0+XfOrM102_COUNT), PUSH(names, 1+XfOrM102_COUNT), PUSH(clause, 2+XfOrM102_COUNT)));
#   define XfOrM149_COUNT (3+XfOrM102_COUNT)
#   define SETUP_XfOrM149(x) SETUP(XfOrM149_COUNT)
    clause = NULLED_OUT ; 
    names = NULLED_OUT ; 
    rest = NULLED_OUT ; 

# 942 "./../src/compile.c"
    clause = (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) l ) -> val ) ) -> u . pair_val . car ) ) ; 

    if (! (((Scheme_Type ) (((((intptr_t ) (clause ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (clause ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (clause ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (clause ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) clause ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) clause ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) )
      rest = ((void * ) 0 ) ; 
    else {
      rest = (((Scheme_Type ) (((((intptr_t ) (clause ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (clause ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (clause ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) clause ) -> val ) ) -> u . pair_val . cdr ) ) ; 
      if (! (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) rest ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) )
        rest = ((void * ) 0 ) ; 
      else {
        rest = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ; 
        if (! (((rest ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) rest ) -> val ) == (scheme_null ) ) ) ) )
          rest = ((void * ) 0 ) ; 
      }
    }
    if (! rest )
      FUNCCALL(SETUP_XfOrM149(_), scheme_wrong_syntax (((void * ) 0 ) , clause , form , ((void * ) 0 ) ) ); 

    names = (((Scheme_Type ) (((((intptr_t ) (clause ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (clause ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (clause ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) clause ) -> val ) ) -> u . pair_val . car ) ) ; 

    num_names = FUNCCALL(SETUP_XfOrM149(_), scheme_stx_proper_list_length (names ) ); 
    if (num_names < 0 )
      FUNCCALL(SETUP_XfOrM149(_), scheme_wrong_syntax (((void * ) 0 ) , names , form , ((void * ) 0 ) ) ); 

    num_bindings += num_names ; 

    l = (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) l ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  }

  names = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM102(_), GC_malloc (sizeof (Scheme_Object * ) * (num_bindings ) ) )) ; 

  frame = FUNCCALL(SETUP_XfOrM102(_), scheme_set_comp_env_name (origenv , ((void * ) 0 ) ) ); 

  if (recursive ) {
#   define XfOrM145_COUNT (0+XfOrM102_COUNT)
#   define SETUP_XfOrM145(x) SETUP_XfOrM102(x)

# 975 "./../src/compile.c"
    use_box = ((int * ) FUNCCALL(SETUP_XfOrM145(_), GC_malloc_atomic (sizeof (int ) * (1 ) ) )) ; 
    * use_box = - 1 ; 
  }

# 977 "./../src/compile.c"
  else 
  use_box = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM102(_), scheme_begin_dup_symbol_check (& r ) )
  ; 

  k = 0 ; 

  for (i = 0 ; i < num_clauses ; i ++ ) {
#   define XfOrM135_COUNT (0+XfOrM102_COUNT)
#   define SETUP_XfOrM135(x) SETUP_XfOrM102(x)

# 985 "./../src/compile.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (bindings ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bindings ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (bindings ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bindings ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) bindings ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) bindings ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) )
      FUNCCALL(SETUP_XfOrM135(_), scheme_wrong_syntax (((void * ) 0 ) , bindings , form , ((void * ) 0 ) ) ); 
    binding = (((Scheme_Type ) (((((intptr_t ) (bindings ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bindings ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (bindings ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) bindings ) -> val ) ) -> u . pair_val . car ) ) ; 
    if (! (((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) binding ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) binding ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) || ! (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (binding ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) binding ) -> val ) ) -> u . pair_val . cdr ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (binding ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) binding ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (binding ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) binding ) -> val ) ) -> u . pair_val . cdr ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (binding ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) binding ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (binding ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) binding ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (binding ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) binding ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) )
      FUNCCALL(SETUP_XfOrM135(_), scheme_wrong_syntax (((void * ) 0 ) , binding , form , ((void * ) 0 ) ) ); 

    {
      Scheme_Object * rest ; 
#     define XfOrM144_COUNT (0+XfOrM135_COUNT)
#     define SETUP_XfOrM144(x) SETUP_XfOrM135(x)
      rest = NULLED_OUT ; 

# 993 "./../src/compile.c"
      rest = (((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (binding ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) binding ) -> val ) ) -> u . pair_val . cdr ) ) ; 
      if (! ((((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) == (scheme_null ) ) ) ) )
        FUNCCALL(SETUP_XfOrM144(_), scheme_wrong_syntax (((void * ) 0 ) , binding , form , ((void * ) 0 ) ) ); 
    }

    pre_k = k ; 

    name = (((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (binding ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) binding ) -> val ) ) -> u . pair_val . car ) ) ; 
    while (! (((name ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) name ) -> val ) == (scheme_null ) ) ) ) ) {
      Scheme_Object * n ; 
      BLOCK_SETUP((PUSH(n, 0+XfOrM135_COUNT)));
#     define XfOrM143_COUNT (1+XfOrM135_COUNT)
#     define SETUP_XfOrM143(x) SETUP(XfOrM143_COUNT)
      n = NULLED_OUT ; 

# 1003 "./../src/compile.c"
      n = (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) name ) -> val ) ) -> u . pair_val . car ) ) ; 
      names [k ] = n ; 
      FUNCCALL(SETUP_XfOrM143(_), scheme_check_identifier (((void * ) 0 ) , names [k ] , ((void * ) 0 ) , form ) ); 
      FUNCCALL_AGAIN(scheme_dup_symbol_check (& r , ((void * ) 0 ) , names [k ] , "binding" , form ) ); 
      k ++ ; 
      name = (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) name ) -> val ) ) -> u . pair_val . cdr ) ) ; 
    }

    vars = ((Scheme_IR_Local * * ) FUNCCALL(SETUP_XfOrM135(_), GC_malloc (sizeof (Scheme_IR_Local * ) * (k - pre_k ) ) )) ; 

    lv = ((Scheme_IR_Let_Value * ) FUNCCALL(SETUP_XfOrM135(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_IR_Let_Value ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    lv -> iso . so . type = scheme_ir_let_value_type ; 
    if (! last )
      first = (Scheme_Object * ) lv ; 
    else 
    last -> body = (Scheme_Object * ) lv ; 
    last = lv ; 
    lv -> count = (k - pre_k ) ; 
    lv -> vars = vars ; 

    {
      Scheme_Object * rhs ; 
      BLOCK_SETUP((PUSH(rhs, 0+XfOrM135_COUNT)));
#     define XfOrM140_COUNT (1+XfOrM135_COUNT)
#     define SETUP_XfOrM140(x) SETUP(XfOrM140_COUNT)
      rhs = NULLED_OUT ; 

# 1025 "./../src/compile.c"
      rhs = (((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (binding ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) binding ) -> val ) ) -> u . pair_val . cdr ) ) ; 
      rhs = (((Scheme_Type ) (((((intptr_t ) (rhs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rhs ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rhs ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rhs ) -> val ) ) -> u . pair_val . car ) ) ; 
      if (! recursive ) {
#       define XfOrM141_COUNT (0+XfOrM140_COUNT)
#       define SETUP_XfOrM141(x) SETUP_XfOrM140(x)

# 1028 "./../src/compile.c"
        if (lv -> count == 1 )
          rhs_env = FUNCCALL(SETUP_XfOrM141(_), scheme_set_comp_env_name (origenv , names [pre_k ] ) ); 
        else 
        rhs_env = FUNCCALL(SETUP_XfOrM141(_), scheme_set_comp_env_name (origenv , ((void * ) 0 ) ) ); 
        rhs = (((Scheme_Type ) (((((intptr_t ) (binding ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (binding ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (binding ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) binding ) -> val ) ) -> u . pair_val . cdr ) ) ; 
        rhs = (((Scheme_Type ) (((((intptr_t ) (rhs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rhs ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rhs ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rhs ) -> val ) ) -> u . pair_val . car ) ) ; 
        rhs = FUNCCALL(SETUP_XfOrM141(_), compile_expr (rhs , rhs_env , 0 ) ); 
      }
      lv -> value = rhs ; 
    }

    for (m = pre_k ; m < k ; m ++ ) {
#     define XfOrM138_COUNT (0+XfOrM135_COUNT)
#     define SETUP_XfOrM138(x) SETUP_XfOrM135(x)

# 1040 "./../src/compile.c"
      var = FUNCCALL(SETUP_XfOrM138(_), scheme_make_ir_local (names [m ] ) ); 
      if (recursive ) {
        var -> mode = 1 ; 
        var -> compile . use_box = use_box ; 
        var -> compile . use_position = m ; 
        var -> compile . keep_assignment = 1 ; 
      }
      vars [m - pre_k ] = var ; 
      frame = FUNCCALL(SETUP_XfOrM138(_), scheme_extend_comp_env (frame , names [m ] , (Scheme_Object * ) var , mutate_frame , 0 ) ); 
      mutate_frame = 1 ; 
    }

    bindings = (((Scheme_Type ) (((((intptr_t ) (bindings ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bindings ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (bindings ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) bindings ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  }

  head = FUNCCALL(SETUP_XfOrM102(_), make_header (first , num_bindings , num_clauses , (recursive ? 0x1 : 0 ) ) )
  ; 

  if (recursive ) {
    int prev_might_invoke = 0 , j ; 
    int group_clauses = 0 ; 
    Scheme_Object * rhs ; 
    BLOCK_SETUP((PUSH(rhs, 0+XfOrM102_COUNT)));
#   define XfOrM103_COUNT (1+XfOrM102_COUNT)
#   define SETUP_XfOrM103(x) SETUP(XfOrM103_COUNT)
    rhs = NULLED_OUT ; 

# 1063 "./../src/compile.c"
    k = 0 ; 
    lv = (Scheme_IR_Let_Value * ) first ; 
    for (i = 0 ; i < num_clauses ; i ++ , lv = (Scheme_IR_Let_Value * ) lv -> body ) {
#     define XfOrM119_COUNT (0+XfOrM103_COUNT)
#     define SETUP_XfOrM119(x) SETUP_XfOrM103(x)

# 1066 "./../src/compile.c"
      rhs = lv -> value ; 
      if (lv -> count == 1 )
        rhs_env = FUNCCALL(SETUP_XfOrM119(_), scheme_set_comp_env_name (frame , names [k ] ) ); 
      else 
      rhs_env = FUNCCALL(SETUP_XfOrM119(_), scheme_set_comp_env_name (frame , ((void * ) 0 ) ) ); 
      rhs = FUNCCALL(SETUP_XfOrM119(_), compile_expr (rhs , rhs_env , 0 ) ); 
      lv -> value = rhs ; 

      for (j = lv -> count ; j -- ; ) {
        if (lv -> vars [j ] -> compile . keep_assignment < 2 )
          lv -> vars [j ] -> compile . keep_assignment = 0 ; 
      }







      if (! prev_might_invoke && ! FUNCCALL(SETUP_XfOrM119(_), scheme_might_invoke_call_cc (rhs ) )) {
        group_clauses ++ ; 
        if ((group_clauses == 1 ) && (* use_box < k ) ) {

          (& (lv ) -> iso ) -> so . keyex |= 0x2 ; 
          group_clauses = 0 ; 
        }

# 1091 "./../src/compile.c"
        else if (* use_box < (k + lv -> count ) ) {

          (& (lv ) -> iso ) -> so . keyex |= 0x1 ; 
          group_clauses = 0 ; 
        }
      }

# 1096 "./../src/compile.c"
      else 
      prev_might_invoke = 1 ; 

      k += lv -> count ; 
    }

    if (! prev_might_invoke ) {
      Scheme_IR_Let_Header * current_head = head ; 
      Scheme_IR_Let_Value * next = ((void * ) 0 ) ; 
      int group_count = 0 ; 
      BLOCK_SETUP((PUSH(current_head, 0+XfOrM103_COUNT), PUSH(next, 1+XfOrM103_COUNT)));
#     define XfOrM104_COUNT (2+XfOrM103_COUNT)
#     define SETUP_XfOrM104(x) SETUP(XfOrM104_COUNT)

# 1106 "./../src/compile.c"
      lv = (Scheme_IR_Let_Value * ) first ; 
      group_clauses = 0 ; 
      for (i = 0 ; i < num_clauses ; i ++ , lv = next ) {
#       define XfOrM109_COUNT (0+XfOrM104_COUNT)
#       define SETUP_XfOrM109(x) SETUP_XfOrM104(x)

# 1109 "./../src/compile.c"
        next = (Scheme_IR_Let_Value * ) lv -> body ; 
        group_clauses ++ ; 
        group_count += lv -> count ; 
        if ((& (lv ) -> iso ) -> so . keyex & (0x2 
        | 0x1 ) ) {

          Scheme_IR_Let_Header * next_head ; 
          int single = ((& (lv ) -> iso ) -> so . keyex & 0x2 ) ; 
          BLOCK_SETUP((PUSH(next_head, 0+XfOrM109_COUNT)));
#         define XfOrM110_COUNT (1+XfOrM109_COUNT)
#         define SETUP_XfOrM110(x) SETUP(XfOrM110_COUNT)
          next_head = NULLED_OUT ; 

# 1117 "./../src/compile.c"
          ((void ) sizeof ((! single || (group_clauses == 1 ) ) ? 1 : 0 ) , __extension__ ({
#           define XfOrM112_COUNT (0+XfOrM110_COUNT)
#           define SETUP_XfOrM112(x) SETUP_XfOrM110(x)

# 1117 "./../src/compile.c" 3
            if (! single || (group_clauses == 1 ) )

# 1117 "./../src/compile.c" 3
            ; 

# 1117 "./../src/compile.c" 3
            else FUNCCALL(SETUP_XfOrM112(_), __assert_fail ("!single || (group_clauses == 1)" , "./../src/compile.c" , 1117 , __extension__ __PRETTY_FUNCTION__ ) ); 
          }
          ) ) 
# 1117 "./../src/compile.c"
          ; 
          if (current_head -> num_clauses - group_clauses ) {
#           define XfOrM111_COUNT (0+XfOrM110_COUNT)
#           define SETUP_XfOrM111(x) SETUP_XfOrM110(x)

# 1119 "./../src/compile.c"
            next_head = FUNCCALL(SETUP_XfOrM111(_), make_header (lv -> body , current_head -> count - group_count , current_head -> num_clauses - group_clauses , 0x1 ) )


            ; 
            lv -> body = (Scheme_Object * ) next_head ; 
            current_head -> num_clauses = group_clauses ; 
            current_head -> count = group_count ; 
          }

# 1126 "./../src/compile.c"
          else 
          next_head = ((void * ) 0 ) ; 
          if (single )
            (& current_head -> iso ) -> so . keyex -= 0x1 ; 
          current_head = next_head ; 
          group_clauses = 0 ; 
          group_count = 0 ; 
        }
      }
    }
  }

  frame = FUNCCALL(SETUP_XfOrM102(_), scheme_set_comp_env_name (frame , origenv -> value_name ) ); 

  forms = FUNCCALL(SETUP_XfOrM102(_), compile_expr (forms , frame , 0 ) ); 
  last -> body = forms ; 

  RET_VALUE_START ((Scheme_Object * ) head ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1146 "./../src/compile.c"
static Scheme_Object * let_values_compile (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  /* No conversion */

# 1148 "./../src/compile.c"
  return do_let_compile (form , env , "let-values" , 0 ) ; 
}

static Scheme_Object * letrec_values_compile (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  /* No conversion */

# 1153 "./../src/compile.c"
  return do_let_compile (form , env , "letrec-values" , 1 ) ; 
}





Scheme_Object * scheme_compiled_void () 
{
  /* No conversion */

# 1162 "./../src/compile.c"
  return scheme_void ; 
}

static Scheme_Object * do_begin_compile (char * name , 
Scheme_Object * form , Scheme_Comp_Env * env , 
int zero ) 
{
  Scheme_Comp_Env * nontail_env ; 
  Scheme_Object * forms , * body ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(form, 1), PUSH(body, 2), PUSH(nontail_env, 3), PUSH(forms, 4)));
# define XfOrM155_COUNT (5)
# define SETUP_XfOrM155(x) SETUP(XfOrM155_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  nontail_env = NULLED_OUT ; 
  forms = NULLED_OUT ; 
  body = NULLED_OUT ; 

# 1172 "./../src/compile.c"
  forms = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 

  if (((forms ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) forms ) -> val ) == (scheme_null ) ) ) )  {
#   define XfOrM159_COUNT (0+XfOrM155_COUNT)
#   define SETUP_XfOrM159(x) SETUP_XfOrM155(x)

# 1175 "./../src/compile.c"
    if (! zero )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_compiled_void () )) RET_VALUE_EMPTY_END ; 
    FUNCCALL_EMPTY(scheme_wrong_syntax (((void * ) 0 ) , ((void * ) 0 ) , form , "empty form not allowed" ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  FUNCCALL(SETUP_XfOrM155(_), check_form (form , form ) )
  ; 

  env = FUNCCALL(SETUP_XfOrM155(_), check_name_property (form , env ) ); 
  nontail_env = FUNCCALL_AGAIN(scheme_set_comp_env_name (env , ((void * ) 0 ) ) ); 





  if ((((((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (forms ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) forms ) -> val ) ) -> u . pair_val . cdr ) ) ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (forms ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) forms ) -> val ) ) -> u . pair_val . cdr ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (forms ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) forms ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (forms ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) forms ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) == (scheme_null ) ) ) )  {
#   define XfOrM158_COUNT (0+XfOrM155_COUNT)
#   define SETUP_XfOrM158(x) SETUP_XfOrM155(x)

# 1191 "./../src/compile.c"
    forms = (((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (forms ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) forms ) -> val ) ) -> u . pair_val . car ) ) ; 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(compile_expr (forms , env , 0 ) )) RET_VALUE_EMPTY_END ; 
  }

  if (zero ) {
    Scheme_Object * first , * rest ; 
    BLOCK_SETUP((PUSH(rest, 0+XfOrM155_COUNT), PUSH(first, 1+XfOrM155_COUNT)));
#   define XfOrM157_COUNT (2+XfOrM155_COUNT)
#   define SETUP_XfOrM157(x) SETUP(XfOrM157_COUNT)
    first = NULLED_OUT ; 
    rest = NULLED_OUT ; 

# 1198 "./../src/compile.c"
    first = (((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (forms ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) forms ) -> val ) ) -> u . pair_val . car ) ) ; 
    first = FUNCCALL(SETUP_XfOrM157(_), compile_expr (first , env , 0 ) ); 
    rest = (((Scheme_Type ) (((((intptr_t ) (forms ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (forms ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (forms ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) forms ) -> val ) ) -> u . pair_val . cdr ) ) ; 
    rest = FUNCCALL(SETUP_XfOrM157(_), compile_list (rest , nontail_env , nontail_env , nontail_env , 0 ) ); 

    body = FUNCCALL_AGAIN(scheme_make_pair (first , rest ) ); 
  }

# 1204 "./../src/compile.c"
  else {
#   define XfOrM156_COUNT (0+XfOrM155_COUNT)
#   define SETUP_XfOrM156(x) SETUP_XfOrM155(x)

# 1205 "./../src/compile.c"
    body = FUNCCALL(SETUP_XfOrM156(_), compile_list (forms , nontail_env , nontail_env , env , 0 ) ); 
  }

  forms = FUNCCALL(SETUP_XfOrM155(_), scheme_make_sequence_compilation (body , zero ? - 1 : 1 , 0 ) ); 

  RET_VALUE_START (forms ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1213 "./../src/compile.c"
static Scheme_Object * begin_compile (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  /* No conversion */

# 1215 "./../src/compile.c"
  return do_begin_compile ("begin" , form , env , 0 ) ; 
}

static Scheme_Object * begin0_compile (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  /* No conversion */

# 1220 "./../src/compile.c"
  return do_begin_compile ("begin0" , form , env , 1 ) ; 
}

static Scheme_Sequence * malloc_big_sequence (int count ) 
{
  intptr_t sz ; 
  Scheme_Sequence * seq ; 
  DECL_RET_SAVE (Scheme_Sequence * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(seq, 0)));
# define XfOrM162_COUNT (1)
# define SETUP_XfOrM162(x) SETUP(XfOrM162_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  seq = NULLED_OUT ; 

# 1228 "./../src/compile.c"
  sz = FUNCCALL(SETUP_XfOrM162(_), scheme_check_overflow ((count - 0 ) , sizeof (Scheme_Object * ) , sizeof (Scheme_Sequence ) ) ); 
  seq = (Scheme_Sequence * ) FUNCCALL(SETUP_XfOrM162(_), scheme_malloc_fail_ok (GC_malloc_one_tagged , sz ) ); 
  if (! seq )
    FUNCCALL_EMPTY(scheme_signal_error ("out of memory allocating sequence bytecode" ) )
# 1230 "./../src/compile.c"
  ; 

  RET_VALUE_START (seq ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1235 "./../src/compile.c"
Scheme_Sequence * scheme_malloc_sequence (int count ) XFORM_ASSERT_NO_CONVERSION 
{
  /* No conversion */

# 1237 "./../src/compile.c"
  if (count < 4096 )
    return (Scheme_Sequence * ) GC_malloc_one_tagged (sizeof (Scheme_Sequence ) 
  + (count - 0 ) 
  * sizeof (Scheme_Object * ) ) ; 
  else 
  return malloc_big_sequence (count ) ; 
}

Scheme_Object * scheme_make_sequence_compilation (Scheme_Object * seq , int opt , int resolved ) 
{


  Scheme_Object * list , * v , * good ; 
  Scheme_Sequence * o ; 
  int count , i , k , total , last , first , setgood ; 
  Scheme_Type type ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(seq, 0), PUSH(list, 1), PUSH(v, 2), PUSH(o, 3), PUSH(good, 4)));
# define XfOrM164_COUNT (5)
# define SETUP_XfOrM164(x) SETUP(XfOrM164_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  list = NULLED_OUT ; 
  v = NULLED_OUT ; 
  good = NULLED_OUT ; 
  o = NULLED_OUT ; 

# 1254 "./../src/compile.c"
  type = scheme_sequence_type ; 

  list = seq ; 
  count = i = 0 ; 
  good = ((void * ) 0 ) ; 
  total = 0 ; 
  first = 1 ; 
  setgood = 1 ; 
  while (((Scheme_Type ) (((((intptr_t ) (list ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (list ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM183_COUNT (0+XfOrM164_COUNT)
#   define SETUP_XfOrM183(x) SETUP_XfOrM164(x)

# 1263 "./../src/compile.c"
    v = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . car ) ; 
    list = (((Scheme_Simple_Object * ) (list ) ) -> u . pair_val . cdr ) ; 
    last = ((list ) == (scheme_null ) ) ; 

    if (((opt > 0 ) || ! first ) && ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (type ) ) ) {

      count += ((Scheme_Sequence * ) v ) -> count ; 
      total ++ ; 
    }

# 1271 "./../src/compile.c"
    else if (opt 
    && (((opt > 0 ) && ! last ) || ((opt < 0 ) && ! first ) ) 
    && FUNCCALL(SETUP_XfOrM183(_), scheme_omittable_expr (v , - 1 , - 1 , (resolved ? 0x1 : 0x2 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )) 

    {

      total ++ ; 
    }

# 1278 "./../src/compile.c"
    else {
      if (setgood )
        good = v ; 
      count ++ ; 
      total ++ ; 
    }
    i ++ ; 
    if (first ) {
      if (opt < 0 )
        setgood = 0 ; 
      first = 0 ; 
    }
  }

  if (! ((list ) == (scheme_null ) ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  if (! count )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_compiled_void () )) RET_VALUE_EMPTY_END ; 

  if (count == 1 ) {
#   define XfOrM175_COUNT (0+XfOrM164_COUNT)
#   define SETUP_XfOrM175(x) SETUP_XfOrM164(x)

# 1299 "./../src/compile.c"
    if (opt < - 1 ) {
    }
    else if ((opt < 0 ) 
    && ! FUNCCALL(SETUP_XfOrM175(_), scheme_omittable_expr ((((Scheme_Simple_Object * ) (seq ) ) -> u . pair_val . car ) , 1 , - 1 , (resolved ? 0x1 : 0x2 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )) 

    {
    }


    else 
    RET_VALUE_START (good ) RET_VALUE_END ; 
  }

  o = FUNCCALL(SETUP_XfOrM164(_), scheme_malloc_sequence (count ) ); 

  o -> so . type = ((opt < 0 ) ? scheme_begin0_sequence_type : scheme_sequence_type ) ; 
  o -> count = count ; 

  -- total ; 
  for (i = k = 0 ; i < count ; k ++ ) {
#   define XfOrM170_COUNT (0+XfOrM164_COUNT)
#   define SETUP_XfOrM170(x) SETUP_XfOrM164(x)

# 1319 "./../src/compile.c"
    v = (((Scheme_Simple_Object * ) (seq ) ) -> u . pair_val . car ) ; 
    seq = (((Scheme_Simple_Object * ) (seq ) ) -> u . pair_val . cdr ) ; 

    if (((opt > 0 ) || k ) && ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (type ) ) ) {
      int c , j ; 
      Scheme_Object * * a ; 
      a = NULLED_OUT ; 
      c = ((Scheme_Sequence * ) v ) -> count ; 
      a = ((Scheme_Sequence * ) v ) -> array ; 
      for (j = 0 ; j < c ; j ++ ) {
        o -> array [i ++ ] = a [j ] ; 
      }
    }

# 1331 "./../src/compile.c"
    else if (opt 
    && (((opt > 0 ) && (k < total ) ) 
    || ((opt < 0 ) && k ) ) 
    && FUNCCALL(SETUP_XfOrM170(_), scheme_omittable_expr (v , - 1 , - 1 , (resolved ? 0x1 : 0x2 ) , ((void * ) 0 ) , ((void * ) 0 ) ) )) 

    {
    }
    else 
    o -> array [i ++ ] = v ; 
  }

  RET_VALUE_START ((Scheme_Object * ) o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

int scheme_get_eval_type (Scheme_Object * obj ) 

{
  /* No conversion */

# 1352 "./../src/compile.c"
  Scheme_Type type ; 

  type = ((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ; 

  if (type > _scheme_values_types_ )
    return SCHEME_EVAL_CONSTANT ; 
  else if (((Scheme_Type ) (type ) == (Scheme_Type ) (scheme_ir_local_type ) ) 
  || ((Scheme_Type ) (type ) == (Scheme_Type ) (scheme_local_type ) ) )
    return SCHEME_EVAL_LOCAL ; 
  else if ((Scheme_Type ) (type ) == (Scheme_Type ) (scheme_local_unbox_type ) ) 
    return SCHEME_EVAL_LOCAL_UNBOX ; 
  else if ((Scheme_Type ) (type ) == (Scheme_Type ) (scheme_toplevel_type ) ) 
    return SCHEME_EVAL_GLOBAL ; 
  else 
  return SCHEME_EVAL_GENERAL ; 
}

Scheme_Object * scheme_try_apply (Scheme_Object * f , Scheme_Object * args , Optimize_Info * info ) 


{
  Scheme_Object * volatile result ; 
  Scheme_Object * volatile exn = ((void * ) 0 ) ; 
  mz_jmp_buf * savebuf , newbuf ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(result, 0), PUSH(savebuf, 1), PUSH(f, 2), PUSH(exn, 3), PUSH(args, 4)));
# define XfOrM189_COUNT (5)
# define SETUP_XfOrM189(x) SETUP(XfOrM189_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  result = NULLED_OUT ; 
  savebuf = NULLED_OUT ; 

# 1377 "./../src/compile.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding = (info ? info : (Optimize_Info * ) scheme_false ) ; 
  savebuf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 

  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM189_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
    result = ((void * ) 0 ) ; 
    exn = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed ; 
  }

# 1385 "./../src/compile.c"
  else 
  result = FUNCCALL(SETUP_XfOrM189(_), _scheme_apply_to_list (f , args ) ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = savebuf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed = ((void * ) 0 ) ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> cjs . is_kill ) {
    (((intptr_t * ) (void * ) ((* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs ) ) [1 ] = (* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs , longjmp ((* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . jb , 1 ) ) ; 
  }

  if (exn )
    FUNCCALL(SETUP_XfOrM189(_), scheme_raise (exn ) ); 

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1402 "./../src/compile.c"
static int foldable_body (Scheme_Object * f ) 
{
  Scheme_Lambda * d ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(d, 0)));
# define XfOrM192_COUNT (1)
# define SETUP_XfOrM192(x) SETUP(XfOrM192_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  d = NULLED_OUT ; 

# 1406 "./../src/compile.c"
  d = ((Scheme_Closure * ) f ) -> code ; 
  FUNCCALL(SETUP_XfOrM192(_), scheme_delay_load_closure (d ) )
  ; 

  RET_VALUE_START ((((((intptr_t ) (d -> body ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (d -> body ) ) -> type ) > _scheme_values_types_ ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1413 "./../src/compile.c"
int scheme_is_foldable_prim (Scheme_Object * f ) 
{
  /* No conversion */

# 1415 "./../src/compile.c"
  if (((Scheme_Type ) (((((intptr_t ) (f ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (f ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) 
  && ((((Scheme_Primitive_Proc * ) f ) -> pp . flags & (1 | 2 ) ) 
  == 3 ) )
    return 1 ; 

  if (((Scheme_Type ) (((((intptr_t ) (f ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (f ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) 
  && ((((Scheme_Closed_Primitive_Proc * ) f ) -> pp . flags & (1 | 2 ) ) 
  == 3 ) )
    return 1 ; 

  return 0 ; 
}

Scheme_Object * scheme_make_application (Scheme_Object * v , Optimize_Info * info ) 
{
  Scheme_Object * o ; 
  int i , nv ; 
  volatile int n ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(info, 0), PUSH(v, 1)));
# define XfOrM194_COUNT (2)
# define SETUP_XfOrM194(x) SETUP(XfOrM194_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 

# 1434 "./../src/compile.c"
  o = v ; 
  n = 0 ; 
  nv = 0 ; 
  while (! ((o ) == (scheme_null ) ) ) {
    Scheme_Type type ; 

    n ++ ; 
    type = ((((intptr_t ) ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ) ) -> type ) ; 
    if (type < _scheme_ir_values_types_ )
      nv = 1 ; 
    o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ; 
  }

  if (! nv ) {

    Scheme_Object * f ; 
    BLOCK_SETUP((PUSH(f, 0+XfOrM194_COUNT)));
#   define XfOrM200_COUNT (1+XfOrM194_COUNT)
#   define SETUP_XfOrM200(x) SETUP(XfOrM200_COUNT)
    f = NULLED_OUT ; 

# 1451 "./../src/compile.c"
    f = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 

    if (FUNCCALL(SETUP_XfOrM200(_), scheme_is_foldable_prim (f ) )
    || (((Scheme_Type ) (((((intptr_t ) (f ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (f ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) ) 
    && (FUNCCALL(SETUP_XfOrM200(_), foldable_body (f ) )) ) ) {
#     define XfOrM201_COUNT (0+XfOrM200_COUNT)
#     define SETUP_XfOrM201(x) SETUP_XfOrM200(x)

# 1456 "./../src/compile.c"
      f = FUNCCALL(SETUP_XfOrM201(_), scheme_try_apply (f , (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) , info ) ); 

      if (f )
        RET_VALUE_START (f ) RET_VALUE_END ; 
    }
  }

  if (n == 2 ) {
    Scheme_App2_Rec * app ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM194_COUNT)));
#   define XfOrM199_COUNT (1+XfOrM194_COUNT)
#   define SETUP_XfOrM199(x) SETUP(XfOrM199_COUNT)
    app = NULLED_OUT ; 

# 1466 "./../src/compile.c"
    app = ((Scheme_App2_Rec * ) FUNCCALL(SETUP_XfOrM199(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App2_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    app -> iso . so . type = scheme_application2_type ; 

    app -> rator = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 
    v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
    app -> rand = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 

    RET_VALUE_START ((Scheme_Object * ) app ) RET_VALUE_END ; 
  }

# 1474 "./../src/compile.c"
  else if (n == 3 ) {
    Scheme_App3_Rec * app ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM194_COUNT)));
#   define XfOrM198_COUNT (1+XfOrM194_COUNT)
#   define SETUP_XfOrM198(x) SETUP(XfOrM198_COUNT)
    app = NULLED_OUT ; 

# 1477 "./../src/compile.c"
    app = ((Scheme_App3_Rec * ) FUNCCALL(SETUP_XfOrM198(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_App3_Rec ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    app -> iso . so . type = scheme_application3_type ; 

    app -> rator = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 
    v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
    app -> rand1 = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 
    v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
    app -> rand2 = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 

    RET_VALUE_START ((Scheme_Object * ) app ) RET_VALUE_END ; 
  }

# 1487 "./../src/compile.c"
  else {
    Scheme_App_Rec * app ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM194_COUNT)));
#   define XfOrM195_COUNT (1+XfOrM194_COUNT)
#   define SETUP_XfOrM195(x) SETUP(XfOrM195_COUNT)
    app = NULLED_OUT ; 

# 1490 "./../src/compile.c"
    app = FUNCCALL(SETUP_XfOrM195(_), scheme_malloc_application (n ) ); 

    for (i = 0 ; i < n ; i ++ , v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ) {
      app -> args [i ] = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 
    }

    RET_VALUE_START ((Scheme_Object * ) app ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1500 "./../src/compile.c"
Scheme_App_Rec * scheme_malloc_application (int n ) 
{
  Scheme_App_Rec * app ; 
  intptr_t size ; 
  DECL_RET_SAVE (Scheme_App_Rec * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(app, 0)));
# define XfOrM204_COUNT (1)
# define SETUP_XfOrM204(x) SETUP(XfOrM204_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  app = NULLED_OUT ; 

# 1505 "./../src/compile.c"
  if (n < 0 ) {
#   define XfOrM207_COUNT (0+XfOrM204_COUNT)
#   define SETUP_XfOrM207(x) SETUP_XfOrM204(x)
    FUNCCALL_EMPTY(scheme_signal_error ("bad application count" ) )
# 1506 "./../src/compile.c"
    ; 
    app = ((void * ) 0 ) ; 
  }

# 1508 "./../src/compile.c"
  else if (n > 4096 ) {
#   define XfOrM206_COUNT (0+XfOrM204_COUNT)
#   define SETUP_XfOrM206(x) SETUP_XfOrM204(x)

# 1509 "./../src/compile.c"
    size = FUNCCALL(SETUP_XfOrM206(_), scheme_check_overflow (n , sizeof (char ) , (sizeof (Scheme_App_Rec ) + ((n - 0 ) * sizeof (Scheme_Object * ) ) ) ) )


    ; 
    app = (Scheme_App_Rec * ) FUNCCALL(SETUP_XfOrM206(_), scheme_malloc_fail_ok (GC_malloc_one_tagged , size ) ); 
    if (! app )
      FUNCCALL_EMPTY(scheme_signal_error ("out of memory allocating application bytecode" ) )
# 1514 "./../src/compile.c"
    ; 
  }

# 1515 "./../src/compile.c"
  else {
#   define XfOrM205_COUNT (0+XfOrM204_COUNT)
#   define SETUP_XfOrM205(x) SETUP_XfOrM204(x)

# 1516 "./../src/compile.c"
    size = (sizeof (Scheme_App_Rec ) 
    + ((n - 0 ) * sizeof (Scheme_Object * ) ) 
    + n * sizeof (char ) ) ; 
    app = (Scheme_App_Rec * ) FUNCCALL(SETUP_XfOrM205(_), GC_malloc_one_tagged (size ) ); 
  }

  app -> iso . so . type = scheme_application_type ; 

  app -> num_args = n - 1 ; 

  RET_VALUE_START (app ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1529 "./../src/compile.c"
void scheme_finish_application (Scheme_App_Rec * app ) 
{
  int i , devals , n ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(app, 0)));
# define XfOrM208_COUNT (1)
# define SETUP_XfOrM208(x) SETUP(XfOrM208_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1533 "./../src/compile.c"
  n = app -> num_args + 1 ; 

  devals = sizeof (Scheme_App_Rec ) + ((app -> num_args + 1 - 0 ) * sizeof (Scheme_Object * ) ) ; 

  for (i = 0 ; i < n ; i ++ ) {
    char etype ; 
#   define XfOrM210_COUNT (0+XfOrM208_COUNT)
#   define SETUP_XfOrM210(x) SETUP_XfOrM208(x)

# 1539 "./../src/compile.c"
    etype = FUNCCALL(SETUP_XfOrM210(_), scheme_get_eval_type (app -> args [i ] ) ); 
    ((char * ) app XFORM_OK_PLUS devals ) [i ] = etype ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * 
compile_list (Scheme_Object * form , 
Scheme_Comp_Env * first_env , Scheme_Comp_Env * env , Scheme_Comp_Env * last_env , 
int start_app_position ) 
{
  int len ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(form, 1), PUSH(last_env, 2), PUSH(first_env, 3)));
# define XfOrM211_COUNT (4)
# define SETUP_XfOrM211(x) SETUP(XfOrM211_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1555 "./../src/compile.c"
  len = FUNCCALL(SETUP_XfOrM211(_), scheme_stx_proper_list_length (form ) ); 

  if (! len ) {
    RET_VALUE_START (scheme_null ) RET_VALUE_END ; 
  }

# 1559 "./../src/compile.c"
  else if (len > 0 ) {
    int i ; 
    Scheme_Object * c , * p , * comp_first , * comp_last , * first , * rest ; 
    BLOCK_SETUP((PUSH(comp_last, 0+XfOrM211_COUNT), PUSH(rest, 1+XfOrM211_COUNT), PUSH(comp_first, 2+XfOrM211_COUNT), PUSH(p, 3+XfOrM211_COUNT), PUSH(first, 4+XfOrM211_COUNT), PUSH(c, 5+XfOrM211_COUNT)));
#   define XfOrM213_COUNT (6+XfOrM211_COUNT)
#   define SETUP_XfOrM213(x) SETUP(XfOrM213_COUNT)
    c = NULLED_OUT ; 
    p = NULLED_OUT ; 
    comp_first = NULLED_OUT ; 
    comp_last = NULLED_OUT ; 
    first = NULLED_OUT ; 
    rest = NULLED_OUT ; 

# 1563 "./../src/compile.c"
    comp_first = comp_last = ((void * ) 0 ) ; 

    for (i = 0 , rest = form ; i < len ; i ++ ) {
#     define XfOrM215_COUNT (0+XfOrM213_COUNT)
#     define SETUP_XfOrM215(x) SETUP_XfOrM213(x)

# 1566 "./../src/compile.c"
      first = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . car ) ) ; 
      rest = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ; 

      c = FUNCCALL(SETUP_XfOrM215(_), compile_expr (first , (! i ? first_env : ((i == (len - 1 ) ) ? last_env : env ) ) , ! i && start_app_position ) )

      ; 

      p = FUNCCALL_AGAIN(scheme_make_pair (c , scheme_null ) ); 
      if (comp_last )
        (((Scheme_Simple_Object * ) (comp_last ) ) -> u . pair_val . cdr ) = p ; 
      else 
      comp_first = p ; 
      comp_last = p ; 

      if (! i && start_app_position && (len == 2 ) 
      && ((c ) == (scheme_varref_const_p_proc ) ) )
        last_env = FUNCCALL(SETUP_XfOrM215(_), scheme_set_comp_env_flags (last_env , 0x1 ) ); 
    }

    RET_VALUE_START (comp_first ) RET_VALUE_END ; 
  }

# 1586 "./../src/compile.c"
  else {
#   define XfOrM212_COUNT (0+XfOrM211_COUNT)
#   define SETUP_XfOrM212(x) SETUP_XfOrM211(x)
    FUNCCALL_EMPTY(scheme_signal_error ("internal error: compile-list on non-list" ) )
# 1587 "./../src/compile.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1592 "./../src/compile.c"
static Scheme_Object * compile_plain_app (Scheme_Object * form , Scheme_Comp_Env * env ) 
{
  Scheme_Object * result , * rator ; 
  int len ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(form, 1), PUSH(result, 2), PUSH(rator, 3)));
# define XfOrM217_COUNT (4)
# define SETUP_XfOrM217(x) SETUP(XfOrM217_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  result = NULLED_OUT ; 
  rator = NULLED_OUT ; 

# 1597 "./../src/compile.c"
  len = FUNCCALL(SETUP_XfOrM217(_), scheme_stx_proper_list_length (form ) ); 

  if (len < 0 )
    FUNCCALL_EMPTY(scheme_wrong_syntax ("application" , ((void * ) 0 ) , form , ((void * ) 0 ) ) ); 

  env = FUNCCALL(SETUP_XfOrM217(_), scheme_set_comp_env_name (env , ((void * ) 0 ) ) ); 

  form = FUNCCALL_AGAIN(compile_list (form , env , env , env , 1 ) ); 

  result = FUNCCALL_AGAIN(scheme_make_application (form , ((void * ) 0 ) ) ); 



  if ((Scheme_Type ) (((((intptr_t ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) ) == (Scheme_Type ) (scheme_application_type ) ) 
    rator = ((Scheme_App_Rec * ) result ) -> args [0 ] ; 
  else if ((Scheme_Type ) (((((intptr_t ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) ) == (Scheme_Type ) (scheme_application2_type ) ) 
    rator = ((Scheme_App2_Rec * ) result ) -> rator ; 
  else if ((Scheme_Type ) (((((intptr_t ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) ) == (Scheme_Type ) (scheme_application3_type ) ) 
    rator = ((Scheme_App3_Rec * ) result ) -> rator ; 
  else 
  rator = ((void * ) 0 ) ; 
  if (rator ) {
#   define XfOrM218_COUNT (0+XfOrM217_COUNT)
#   define SETUP_XfOrM218(x) SETUP_XfOrM217(x)

# 1619 "./../src/compile.c"
    rator = FUNCCALL(SETUP_XfOrM218(_), scheme_optimize_extract_tail_inside (rator ) ); 
    if ((Scheme_Type ) (((((intptr_t ) (rator ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rator ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_local_type ) )  {
      if (((Scheme_IR_Local * ) rator ) -> use_count < 7 ) {
        if ((Scheme_Type ) (((((intptr_t ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) ) == (Scheme_Type ) (scheme_application_type ) ) 
          (& ((Scheme_App_Rec * ) result ) -> iso ) -> so . keyex |= ((Scheme_IR_Local * ) rator ) -> use_count ; 
        else if ((Scheme_Type ) (((((intptr_t ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) ) == (Scheme_Type ) (scheme_application2_type ) ) 
          (& ((Scheme_App2_Rec * ) result ) -> iso ) -> so . keyex |= ((Scheme_IR_Local * ) rator ) -> use_count ; 
        else if ((Scheme_Type ) (((((intptr_t ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) ) == (Scheme_Type ) (scheme_application3_type ) ) 
          (& ((Scheme_App3_Rec * ) result ) -> iso ) -> so . keyex |= ((Scheme_IR_Local * ) rator ) -> use_count ; 
      }
    }
  }

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1635 "./../src/compile.c"
static int arg_count (Scheme_Object * lam ) 
{
  Scheme_Object * l , * id , * form = lam ; 
  int cnt = 0 ; 
  DupCheckRecord r ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(form, 1), PUSHARRAY(r.syms, 5, 2), PUSH(r.ht, 5), PUSH(id, 6)));
# define XfOrM221_COUNT (7)
# define SETUP_XfOrM221(x) SETUP(XfOrM221_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 
  id = NULLED_OUT ; 
  NULL_OUT_ARRAY (r.syms ) ; 
  r.ht = NULLED_OUT ; 

# 1641 "./../src/compile.c"
  lam = (((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (lam ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) lam ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  if (! (((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) lam ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) lam ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) )

# 1642 "./../src/compile.c"
  RET_VALUE_START (- 1 ) RET_VALUE_END ; 

  l = (((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (lam ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) lam ) -> val ) ) -> u . pair_val . car ) ) ; 

  lam = (((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (lam ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) lam ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  if (! (((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) lam ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) lam ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) )

# 1647 "./../src/compile.c"
  RET_VALUE_START (- 1 ) RET_VALUE_END ; 

  while ((((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) lam ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) lam ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ) {

# 1649 "./../src/compile.c"
    lam = (((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (lam ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) lam ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  }

# 1650 "./../src/compile.c"
  if (! (((lam ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (lam ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (lam ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) lam ) -> val ) == (scheme_null ) ) ) ) )

# 1650 "./../src/compile.c"
  RET_VALUE_START (- 1 ) RET_VALUE_END ; 
  FUNCCALL(SETUP_XfOrM221(_), scheme_begin_dup_symbol_check (& r ) )
  ; 

  while ((((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) l ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) l ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ) {
#   define XfOrM223_COUNT (0+XfOrM221_COUNT)
#   define SETUP_XfOrM223(x) SETUP_XfOrM221(x)

# 1655 "./../src/compile.c"
    id = (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) l ) -> val ) ) -> u . pair_val . car ) ) ; 
    FUNCCALL(SETUP_XfOrM223(_), scheme_check_identifier ("lambda" , id , "argument" , form ) ); 
    FUNCCALL_AGAIN(scheme_dup_symbol_check (& r , ((void * ) 0 ) , id , "argument" , form ) ); 
    l = (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) l ) -> val ) ) -> u . pair_val . cdr ) ) ; 
    cnt ++ ; 
  }
  if (! (((l ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) l ) -> val ) == (scheme_null ) ) ) ) )

# 1661 "./../src/compile.c"
  RET_VALUE_START (- 1 ) RET_VALUE_END ; 

  RET_VALUE_START (cnt ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1666 "./../src/compile.c"
static Scheme_Object * compile_app (Scheme_Object * orig_form , Scheme_Comp_Env * env ) 
{
  Scheme_Object * form , * forms , * orig_vname = env -> value_name ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(21);
  BLOCK_SETUP_TOP((PUSH(orig_vname, 0), PUSH(forms, 1), PUSH(form, 2), PUSH(env, 3), PUSH(__funcarg63, 4), PUSH(__funcarg73, 5)));
# define XfOrM226_COUNT (6)
# define SETUP_XfOrM226(x) SETUP(XfOrM226_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  form = NULLED_OUT ; 
  forms = NULLED_OUT ; 

# 1670 "./../src/compile.c"
  forms = orig_form ; 
  form = forms ; 

  if (((form ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) form ) -> val ) == (scheme_null ) ) ) )  {

    RET_VALUE_START (scheme_null ) RET_VALUE_END ; 
  }

# 1676 "./../src/compile.c"
  else if (! (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ) {
#   define XfOrM249_COUNT (0+XfOrM226_COUNT)
#   define SETUP_XfOrM249(x) SETUP_XfOrM226(x)

# 1678 "./../src/compile.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(compile_plain_app (form , env ) )) RET_VALUE_EMPTY_END ; 
  }

# 1679 "./../src/compile.c"
  else {
    Scheme_Object * name , * origname , * orig_rest_form , * rest_form ; 
    BLOCK_SETUP((PUSH(origname, 0+XfOrM226_COUNT), PUSH(orig_rest_form, 1+XfOrM226_COUNT), PUSH(name, 2+XfOrM226_COUNT), PUSH(rest_form, 3+XfOrM226_COUNT)));
#   define XfOrM227_COUNT (4+XfOrM226_COUNT)
#   define SETUP_XfOrM227(x) SETUP(XfOrM227_COUNT)
    name = NULLED_OUT ; 
    origname = NULLED_OUT ; 
    orig_rest_form = NULLED_OUT ; 
    rest_form = NULLED_OUT ; 

# 1681 "./../src/compile.c"
    name = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
    origname = name ; 


    if (((((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) name ) -> val : name ) ) == (lambda_symbol ) )  {
      Scheme_Object * argsnbody ; 
#     define XfOrM236_COUNT (0+XfOrM227_COUNT)
#     define SETUP_XfOrM236(x) SETUP_XfOrM227(x)
      argsnbody = NULLED_OUT ; 

# 1688 "./../src/compile.c"
      argsnbody = (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) name ) -> val ) ) -> u . pair_val . cdr ) ) ; 
      if (((Scheme_Type ) (((((intptr_t ) (argsnbody ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argsnbody ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (argsnbody ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argsnbody ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) argsnbody ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) argsnbody ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )  {
        Scheme_Object * args , * body ; 
        BLOCK_SETUP((PUSH(body, 0+XfOrM236_COUNT), PUSH(args, 1+XfOrM236_COUNT)));
#       define XfOrM237_COUNT (2+XfOrM236_COUNT)
#       define SETUP_XfOrM237(x) SETUP(XfOrM237_COUNT)
        args = NULLED_OUT ; 
        body = NULLED_OUT ; 

# 1692 "./../src/compile.c"
        args = (((Scheme_Type ) (((((intptr_t ) (argsnbody ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argsnbody ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (argsnbody ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) argsnbody ) -> val ) ) -> u . pair_val . car ) ) ; 
        body = (((Scheme_Type ) (((((intptr_t ) (argsnbody ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argsnbody ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (argsnbody ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) argsnbody ) -> val ) ) -> u . pair_val . cdr ) ) ; 

        if (((Scheme_Type ) (((((intptr_t ) (body ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (body ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (body ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (body ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) body ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) body ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )  {
          int pl ; 
#         define XfOrM238_COUNT (0+XfOrM237_COUNT)
#         define SETUP_XfOrM238(x) SETUP_XfOrM237(x)

# 1697 "./../src/compile.c"
          pl = FUNCCALL(SETUP_XfOrM238(_), scheme_stx_proper_list_length (args ) ); 
          if ((pl >= 0 ) || (((Scheme_Type ) (((((intptr_t ) (args ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (args ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) args ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) args ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) ) ) {
            Scheme_Object * bindings = scheme_null , * last = ((void * ) 0 ) ; 
            Scheme_Object * rest ; 
            int al ; 
            BLOCK_SETUP((PUSH(rest, 0+XfOrM238_COUNT), PUSH(bindings, 1+XfOrM238_COUNT), PUSH(last, 2+XfOrM238_COUNT)));
#           define XfOrM239_COUNT (3+XfOrM238_COUNT)
#           define SETUP_XfOrM239(x) SETUP(XfOrM239_COUNT)
            rest = NULLED_OUT ; 

# 1703 "./../src/compile.c"
            rest = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
            al = FUNCCALL(SETUP_XfOrM239(_), scheme_stx_proper_list_length (rest ) ); 

            if ((pl < 0 ) || (al == pl ) ) {
              DupCheckRecord r ; 
              BLOCK_SETUP((PUSHARRAY(r.syms, 5, 0+XfOrM239_COUNT), PUSH(r.ht, 3+XfOrM239_COUNT)));
#             define XfOrM240_COUNT (4+XfOrM239_COUNT)
#             define SETUP_XfOrM240(x) SETUP(XfOrM240_COUNT)
              NULL_OUT_ARRAY (r.syms ) ; 
              r.ht = NULLED_OUT ; 
              FUNCCALL(SETUP_XfOrM240(_), scheme_begin_dup_symbol_check (& r ) )
# 1709 "./../src/compile.c"
              ; 

              while (! (((args ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (args ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) args ) -> val ) == (scheme_null ) ) ) ) ) {
                Scheme_Object * v , * n ; 
                BLOCK_SETUP((PUSH(v, 0+XfOrM240_COUNT), PUSH(n, 1+XfOrM240_COUNT)));
#               define XfOrM245_COUNT (2+XfOrM240_COUNT)
#               define SETUP_XfOrM245(x) SETUP(XfOrM245_COUNT)
                v = NULLED_OUT ; 
                n = NULLED_OUT ; 

# 1714 "./../src/compile.c"
                if (pl < 0 )
                  n = args ; 
                else 
                n = (((Scheme_Type ) (((((intptr_t ) (args ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (args ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) args ) -> val ) ) -> u . pair_val . car ) ) ; 
                FUNCCALL(SETUP_XfOrM245(_), scheme_check_identifier ("lambda" , n , ((void * ) 0 ) , name ) ); 
                FUNCCALL_AGAIN(scheme_dup_symbol_check (& r , ((void * ) 0 ) , n , "argument" , name ) )

                ; 

                if (pl < 0 ) {
#                 define XfOrM248_COUNT (0+XfOrM245_COUNT)
#                 define SETUP_XfOrM248(x) SETUP_XfOrM245(x)

# 1724 "./../src/compile.c"
                  v = FUNCCALL(SETUP_XfOrM248(_), scheme_intern_symbol ("list" ) ); 
                  v = FUNCCALL(SETUP_XfOrM248(_), scheme_make_pair (v , rest ) ); 
                }

# 1726 "./../src/compile.c"
                else 
                v = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . car ) ) ; 
                v = (__funcarg72 = (__funcarg73 = FUNCCALL(SETUP_XfOrM245(_), scheme_make_pair (n , scheme_null ) ), __funcarg74 = FUNCCALL(SETUP_XfOrM245(_), scheme_make_pair (v , scheme_null ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg73 , __funcarg74 ) )) , FUNCCALL_AGAIN(scheme_make_pair (__funcarg72 , scheme_null ) )) ; 
                if (last )
                  (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = v ; 
                else 
                bindings = v ; 

                last = v ; 
                if (pl < 0 ) {

                  break ; 
                }

# 1738 "./../src/compile.c"
                else {
                  args = (((Scheme_Type ) (((((intptr_t ) (args ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (args ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) args ) -> val ) ) -> u . pair_val . cdr ) ) ; 
                  rest = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ; 
                }
              }

              body = (__funcarg67 = (__funcarg68 = FUNCCALL(SETUP_XfOrM240(_), scheme_make_pair (bindings , body ) ), FUNCCALL_AGAIN(scheme_make_pair (let_values_symbol , __funcarg68 ) )) 
              , FUNCCALL_AGAIN(scheme_datum_to_syntax (__funcarg67 , form , 0x1 ) )) 

              ; 

              env = FUNCCALL(SETUP_XfOrM240(_), scheme_set_comp_env_name (env , orig_vname ) ); 

              RET_VALUE_START (FUNCCALL(SETUP_XfOrM240(_), compile_expr (body , env , 0 ) )) RET_VALUE_END ; 
            }
          }
        }
      }
    }

    orig_rest_form = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 


    if (((((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) name ) -> val : name ) ) == (call_with_values_symbol ) )  {
      Scheme_Object * at_first , * at_second , * the_end ; 
      BLOCK_SETUP((PUSH(at_second, 0+XfOrM227_COUNT), PUSH(at_first, 1+XfOrM227_COUNT)));
#     define XfOrM230_COUNT (2+XfOrM227_COUNT)
#     define SETUP_XfOrM230(x) SETUP(XfOrM230_COUNT)
      at_first = NULLED_OUT ; 
      at_second = NULLED_OUT ; 
      the_end = NULLED_OUT ; 

# 1763 "./../src/compile.c"
      at_first = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
      if (((Scheme_Type ) (((((intptr_t ) (at_first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (at_first ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (at_first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (at_first ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) at_first ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) at_first ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )  {
#       define XfOrM231_COUNT (0+XfOrM230_COUNT)
#       define SETUP_XfOrM231(x) SETUP_XfOrM230(x)

# 1765 "./../src/compile.c"
        at_second = (((Scheme_Type ) (((((intptr_t ) (at_first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (at_first ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (at_first ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) at_first ) -> val ) ) -> u . pair_val . cdr ) ) ; 
        if (((Scheme_Type ) (((((intptr_t ) (at_second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (at_second ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (at_second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (at_second ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) at_second ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) at_second ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )  {
#         define XfOrM232_COUNT (0+XfOrM231_COUNT)
#         define SETUP_XfOrM232(x) SETUP_XfOrM231(x)

# 1767 "./../src/compile.c"
          the_end = (((Scheme_Type ) (((((intptr_t ) (at_second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (at_second ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (at_second ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) at_second ) -> val ) ) -> u . pair_val . cdr ) ) ; 
          if (((the_end ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (the_end ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (the_end ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) the_end ) -> val ) == (scheme_null ) ) ) )  {
            Scheme_Object * first ; 
            BLOCK_SETUP((PUSH(first, 0+XfOrM232_COUNT)));
#           define XfOrM233_COUNT (1+XfOrM232_COUNT)
#           define SETUP_XfOrM233(x) SETUP(XfOrM233_COUNT)
            first = NULLED_OUT ; 

# 1770 "./../src/compile.c"
            first = (((Scheme_Type ) (((((intptr_t ) (at_first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (at_first ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (at_first ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) at_first ) -> val ) ) -> u . pair_val . car ) ) ; 
            if ((((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) first ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) first ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) 
            && (((((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (first ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) first ) -> val ) ) -> u . pair_val . car ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (first ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) first ) -> val ) ) -> u . pair_val . car ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (first ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) first ) -> val ) ) -> u . pair_val . car ) ) ) -> val : (((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (first ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) first ) -> val ) ) -> u . pair_val . car ) ) ) ) == (lambda_symbol ) ) 
            && (FUNCCALL(SETUP_XfOrM233(_), arg_count (first ) )== 0 ) ) {
              Scheme_Object * second ; 
              BLOCK_SETUP((PUSH(second, 0+XfOrM233_COUNT)));
#             define XfOrM234_COUNT (1+XfOrM233_COUNT)
#             define SETUP_XfOrM234(x) SETUP(XfOrM234_COUNT)
              second = NULLED_OUT ; 

# 1775 "./../src/compile.c"
              second = (((Scheme_Type ) (((((intptr_t ) (at_second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (at_second ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (at_second ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) at_second ) -> val ) ) -> u . pair_val . car ) ) ; 
              if ((((Scheme_Type ) (((((intptr_t ) (second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (second ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (second ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) second ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) second ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) 
              && (((((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (second ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (second ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) second ) -> val ) ) -> u . pair_val . car ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (second ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (second ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) second ) -> val ) ) -> u . pair_val . car ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (second ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (second ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) second ) -> val ) ) -> u . pair_val . car ) ) ) -> val : (((Scheme_Type ) (((((intptr_t ) (second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (second ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (second ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) second ) -> val ) ) -> u . pair_val . car ) ) ) ) == (lambda_symbol ) ) 
              && (FUNCCALL(SETUP_XfOrM234(_), arg_count (second ) )>= 0 ) ) {
                Scheme_Object * lhs ; 
                BLOCK_SETUP((PUSH(lhs, 0+XfOrM234_COUNT)));
#               define XfOrM235_COUNT (1+XfOrM234_COUNT)
#               define SETUP_XfOrM235(x) SETUP(XfOrM235_COUNT)
                lhs = NULLED_OUT ; 

# 1780 "./../src/compile.c"
                second = (((Scheme_Type ) (((((intptr_t ) (second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (second ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (second ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) second ) -> val ) ) -> u . pair_val . cdr ) ) ; 
                lhs = (((Scheme_Type ) (((((intptr_t ) (second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (second ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (second ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) second ) -> val ) ) -> u . pair_val . car ) ) ; 
                second = (((Scheme_Type ) (((((intptr_t ) (second ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (second ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (second ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) second ) -> val ) ) -> u . pair_val . cdr ) ) ; 
                first = (((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (first ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) first ) -> val ) ) -> u . pair_val . cdr ) ) ; 
                first = (((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (first ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) first ) -> val ) ) -> u . pair_val . cdr ) ) ; 
                first = FUNCCALL(SETUP_XfOrM235(_), scheme_make_pair (begin_symbol , first ) ); 
                first = FUNCCALL_AGAIN(scheme_datum_to_syntax (first , at_first , 0x1 ) ); 
                second = FUNCCALL_AGAIN(scheme_make_pair (begin_symbol , second ) ); 
                second = FUNCCALL_AGAIN(scheme_datum_to_syntax (second , at_second , 0x1 ) ); 

                name = (__funcarg62 = (__funcarg63 = (__funcarg65 = (__funcarg66 = FUNCCALL(SETUP_XfOrM235(_), scheme_make_pair (first , scheme_null ) ), FUNCCALL_AGAIN(scheme_make_pair (lhs , __funcarg66 ) )) , FUNCCALL_AGAIN(scheme_make_pair (__funcarg65 , scheme_null ) )) , __funcarg64 = FUNCCALL(SETUP_XfOrM235(_), scheme_make_pair (second , scheme_null ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg63 , __funcarg64 ) )) , FUNCCALL_AGAIN(scheme_make_pair (let_values_symbol , __funcarg62 ) )) 


                ; 
                form = FUNCCALL_AGAIN(scheme_datum_to_syntax (name , forms , 0x1 ) ); 
                env -> value_name = orig_vname ; 
                RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(compile_expr (form , env , 0 ) )) RET_VALUE_EMPTY_END ; 
              }
            }
          }
        }
      }
      rest_form = at_first ; 
    }

# 1803 "./../src/compile.c"
    else {
      rest_form = orig_rest_form ; 
    }

    if (((name ) != (origname ) ) 
    || ((rest_form ) != (orig_rest_form ) ) ) {
#     define XfOrM228_COUNT (0+XfOrM227_COUNT)
#     define SETUP_XfOrM228(x) SETUP_XfOrM227(x)

# 1809 "./../src/compile.c"
      form = (__funcarg61 = FUNCCALL(SETUP_XfOrM228(_), scheme_make_pair (name , rest_form ) ), FUNCCALL_AGAIN(scheme_datum_to_syntax (__funcarg61 , forms , 0x1 ) )) ; 
    }

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(compile_plain_app (form , env ) )) RET_VALUE_EMPTY_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * compile_expr_k (void ) 
{
  /* No conversion */

# 1822 "./../src/compile.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * form = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Comp_Env * env = (Scheme_Comp_Env * ) p -> ku . k . p2 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 

  return compile_expr (form , env , p -> ku . k . i1 ) ; 
}

Scheme_Object * compile_expr (Scheme_Object * form , Scheme_Comp_Env * env , int app_position ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(form, 1)));
# define XfOrM252_COUNT (2)
# define SETUP_XfOrM252(x) SETUP(XfOrM252_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1835 "./../src/compile.c"
  {

# 24 "./../src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM257_COUNT (0+XfOrM252_COUNT)
#   define SETUP_XfOrM257(x) SETUP_XfOrM252(x)

# 26 "./../src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 1837 "./../src/compile.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#     define XfOrM258_COUNT (0+XfOrM257_COUNT)
#     define SETUP_XfOrM258(x) SETUP_XfOrM257(x)

# 1840 "./../src/compile.c"
      p -> ku . k . p1 = (void * ) form ; 
      p -> ku . k . p2 = (void * ) env ; 
      p -> ku . k . i1 = app_position ; 

      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (compile_expr_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }


  if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#   define XfOrM256_COUNT (0+XfOrM252_COUNT)
#   define SETUP_XfOrM256(x) SETUP_XfOrM252(x)

# 1849 "./../src/compile.c"
    ; 
    FUNCCALL(SETUP_XfOrM256(_), scheme_thread_block (0 ) )
# 1849 "./../src/compile.c"
    ; 

# 1849 "./../src/compile.c"
    (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) -> ran_some = 1 ; 
  }

# 1849 "./../src/compile.c"
  ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ) {
    Scheme_Object * val = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) form ) -> val : form ) ; 
#   define XfOrM255_COUNT (0+XfOrM252_COUNT)
#   define SETUP_XfOrM255(x) SETUP_XfOrM252(x)

# 1853 "./../src/compile.c"
    if ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_compile_lookup (form , env , (app_position ? 2 : 0 ) ) )) RET_VALUE_EMPTY_END ; 
    else if (((((intptr_t ) (val ) ) & 0x1 ) || ((((val ) -> type ) >= scheme_bignum_type ) && (((val ) -> type ) <= scheme_complex_type ) ) ) 
    || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
    || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
    || ((val ) == (scheme_true ) ) 
    || ((val ) == (scheme_false ) ) )
      RET_VALUE_START (val ) RET_VALUE_END ; 
    else FUNCCALL_EMPTY(scheme_wrong_syntax ("compile" , form , ((void * ) 0 ) , "unrecognized form" ) )
    ; 
  }

# 1863 "./../src/compile.c"
  else {
    Scheme_Object * name = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
#   define XfOrM253_COUNT (0+XfOrM252_COUNT)
#   define SETUP_XfOrM253(x) SETUP_XfOrM252(x)

# 1865 "./../src/compile.c"
    if (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) name ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) name ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) )  {
#     define XfOrM254_COUNT (0+XfOrM253_COUNT)
#     define SETUP_XfOrM254(x) SETUP_XfOrM253(x)

# 1867 "./../src/compile.c"
      name = (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) name ) -> val : name ) ; 
      if ((name ) == (quote_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(quote_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
      else if ((name ) == (let_values_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(let_values_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
      else if ((name ) == (letrec_values_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(letrec_values_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
      else if ((name ) == (lambda_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(lambda_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
      else if ((name ) == (case_lambda_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(case_lambda_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
      else if ((name ) == (set_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(set_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
      else if ((name ) == (if_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(if_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
      else if ((name ) == (begin_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(begin_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
      else if ((name ) == (begin0_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(begin0_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
      else if ((name ) == (with_cont_mark_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(with_cont_mark_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
      else if ((name ) == (ref_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(ref_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
      else if ((name ) == (ref_symbol ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(ref_compile (form , env ) )) RET_VALUE_EMPTY_END ; 
    }
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(compile_app (form , env ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static int is_define_values (Scheme_Object * form ) 
{
  /* No conversion */

# 1904 "./../src/compile.c"
  Scheme_Object * rest ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) )
    return 0 ; 

  rest = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
  if (! (((((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) rest ) -> val : rest ) ) == (define_values_symbol ) ) )
    return 0 ; 

  return 1 ; 
}

static Scheme_Object * define_parse (Scheme_Object * form , 
Scheme_Object * * _vars , Scheme_Object * * _val , 
Scheme_Comp_Env * * _env , 
DupCheckRecord * r , 
int * _extra_vars_pos , 
Scheme_Hash_Tree * * _source_names ) 
{
  Scheme_Object * vars , * rest , * name , * src_name , * v , * extra_vars = scheme_null ; 
  Scheme_Comp_Env * env ; 
  Scheme_Hash_Tree * source_names = * _source_names ; 
  int len ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(15);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(v, 1), PUSH(name, 2), PUSH(_val, 3), PUSH(r, 4), PUSH(_extra_vars_pos, 5), PUSH(source_names, 6), PUSH(rest, 7), PUSH(form, 8), PUSH(_vars, 9), PUSH(extra_vars, 10), PUSH(src_name, 11), PUSH(_env, 12), PUSH(vars, 13), PUSH(_source_names, 14)));
# define XfOrM260_COUNT (15)
# define SETUP_XfOrM260(x) SETUP(XfOrM260_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  vars = NULLED_OUT ; 
  rest = NULLED_OUT ; 
  name = NULLED_OUT ; 
  src_name = NULLED_OUT ; 
  v = NULLED_OUT ; 
  env = NULLED_OUT ; 

# 1928 "./../src/compile.c"
  len = FUNCCALL(SETUP_XfOrM260(_), check_form (form , form ) ); 
  if (len != 3 )
    FUNCCALL(SETUP_XfOrM260(_), bad_form (form , len ) ); 

  rest = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  vars = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . car ) ) ; 
  rest = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  * _val = (((Scheme_Type ) (((((intptr_t ) (rest ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rest ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (rest ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) rest ) -> val ) ) -> u . pair_val . car ) ) ; 

  * _vars = vars ; 

  while ((((Scheme_Type ) (((((intptr_t ) (vars ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vars ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (vars ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vars ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) vars ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) vars ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ) {
#   define XfOrM263_COUNT (0+XfOrM260_COUNT)
#   define SETUP_XfOrM263(x) SETUP_XfOrM260(x)

# 1940 "./../src/compile.c"
    name = (((Scheme_Type ) (((((intptr_t ) (vars ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vars ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (vars ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) vars ) -> val ) ) -> u . pair_val . car ) ) ; 
    FUNCCALL(SETUP_XfOrM263(_), scheme_check_identifier (((void * ) 0 ) , name , ((void * ) 0 ) , form ) ); 

    src_name = FUNCCALL_AGAIN(extract_source_name (name , 0 ) ); 
    if (! ((src_name ) == ((((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) name ) -> val : name ) ) ) )
      source_names = FUNCCALL(SETUP_XfOrM263(_), scheme_hash_tree_set (source_names , (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) name ) -> val : name ) , src_name ) ); 

    vars = (((Scheme_Type ) (((((intptr_t ) (vars ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vars ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (vars ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) vars ) -> val ) ) -> u . pair_val . cdr ) ) ; 
    FUNCCALL(SETUP_XfOrM263(_), scheme_dup_symbol_check (r , ((void * ) 0 ) , name , "binding" , form ) )
    ; 

    v = FUNCCALL_AGAIN(scheme_compile_lookup (name , * _env , 512 ) ); 
    if (v && (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) 
    || ((Scheme_IR_Toplevel * ) v ) -> instance_pos != - 1 ) )
      FUNCCALL_EMPTY(scheme_wrong_syntax (((void * ) 0 ) , name , form , "not a definable variable" ) ); 

    if (! v ) {
#     define XfOrM264_COUNT (0+XfOrM263_COUNT)
#     define SETUP_XfOrM264(x) SETUP_XfOrM263(x)

# 1957 "./../src/compile.c"
      v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM264(_), scheme_make_ir_toplevel (- 1 , * _extra_vars_pos , 0 ) ); 
      env = FUNCCALL(SETUP_XfOrM264(_), scheme_extend_comp_env (* _env , name , v , 1 , 0 ) ); 
      * _env = env ; 
      extra_vars = FUNCCALL(SETUP_XfOrM264(_), scheme_make_pair (name , extra_vars ) ); 
      (* _extra_vars_pos ) ++ ; 
    }
  }

  if (! (((vars ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (vars ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vars ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) vars ) -> val ) == (scheme_null ) ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_syntax (((void * ) 0 ) , vars , form , "bad variable list" ) ); 

  * _source_names = source_names ; 

  RET_VALUE_START (extra_vars ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1973 "./../src/compile.c"
static void check_import_export_clause (Scheme_Object * e , Scheme_Object * orig_form ) 
{
  /* No conversion */

# 1975 "./../src/compile.c"
  if (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) e ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) ) 
    return ; 

  if (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) e ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )  {
    if (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) )  {
      e = (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ; 
      if (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) e ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) )  {
        if (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) )  {
          e = (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ; 
          if (((e ) == (scheme_null ) ) || (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((((Scheme_Stx * ) e ) -> val ) == (scheme_null ) ) ) ) 
            return ; 
        }
      }
    }
  }

  scheme_wrong_syntax (((void * ) 0 ) , e , orig_form , "bad import/export clause" ) ; 
}

static Scheme_Object * extract_source_name (Scheme_Object * e , int no_default ) 
{
  Scheme_Object * a ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(e, 1)));
# define XfOrM270_COUNT (2)
# define SETUP_XfOrM270(x) SETUP(XfOrM270_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 1998 "./../src/compile.c"
  a = FUNCCALL(SETUP_XfOrM270(_), scheme_stx_property (e , source_name_symbol , ((void * ) 0 ) ) ); 
  if (! a || ! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
    if (no_default )
      a = ((void * ) 0 ) ; 
    else 
    a = (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) e ) -> val : e ) ; 
  }

  RET_VALUE_START (a ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2009 "./../src/compile.c"
Scheme_Linklet * scheme_compile_linklet (Scheme_Object * form , int set_undef , Scheme_Object * import_keys ) 
{
  Scheme_Linklet * linklet ; 
  Scheme_Object * orig_form = form , * imports , * exports ; 
  Scheme_Object * defn_syms , * a , * e , * extra_vars , * vec , * v ; 
  Scheme_Object * import_syms , * import_symss , * bodies , * all_extra_vars ; 
  Scheme_Hash_Tree * source_names , * also_used_names ; 
  Scheme_IR_Toplevel * tl ; 
  int body_len , len , islen , i , j , extra_vars_pos ; 
  Scheme_Comp_Env * env , * d_env ; 
  DupCheckRecord r ; 
  DECL_RET_SAVE (Scheme_Linklet * ) PREPARE_VAR_STACK(27);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(v, 1), PUSH(d_env, 2), PUSH(defn_syms, 3), PUSHARRAY(r.syms, 5, 4), PUSH(r.ht, 7), PUSH(also_used_names, 8), PUSH(source_names, 9), PUSH(vec, 10), PUSH(linklet, 11), PUSH(import_syms, 12), PUSH(tl, 13), PUSH(e, 14), PUSH(extra_vars, 15), PUSH(imports, 16), PUSH(form, 17), PUSH(import_symss, 18), PUSH(all_extra_vars, 19), PUSH(a, 20), PUSH(bodies, 21), PUSH(orig_form, 22), PUSH(exports, 23), PUSH(import_keys, 24)));
# define XfOrM272_COUNT (25)
# define SETUP_XfOrM272(x) SETUP(XfOrM272_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  linklet = NULLED_OUT ; 
  imports = NULLED_OUT ; 
  exports = NULLED_OUT ; 
  defn_syms = NULLED_OUT ; 
  a = NULLED_OUT ; 
  e = NULLED_OUT ; 
  extra_vars = NULLED_OUT ; 
  vec = NULLED_OUT ; 
  v = NULLED_OUT ; 
  import_syms = NULLED_OUT ; 
  import_symss = NULLED_OUT ; 
  bodies = NULLED_OUT ; 
  all_extra_vars = NULLED_OUT ; 
  source_names = NULLED_OUT ; 
  also_used_names = NULLED_OUT ; 
  tl = NULLED_OUT ; 
  env = NULLED_OUT ; 
  d_env = NULLED_OUT ; 
  NULL_OUT_ARRAY (r.syms ) ; 
  r.ht = NULLED_OUT ; 

# 2021 "./../src/compile.c"
  body_len = FUNCCALL(SETUP_XfOrM272(_), check_form (form , form ) ); 
  if (body_len < 3 )
    FUNCCALL(SETUP_XfOrM272(_), bad_form (form , body_len ) ); 

  linklet = ((Scheme_Linklet * ) FUNCCALL(SETUP_XfOrM272(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Linklet ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  linklet -> so . type = scheme_linklet_type ; 

  env = FUNCCALL(SETUP_XfOrM272(_), scheme_new_comp_env (linklet , set_undef ? 0x4 : 0 ) ); 

  form = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  imports = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
  form = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  exports = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
  form = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ; 
  body_len -= 3 ; 



  islen = FUNCCALL(SETUP_XfOrM272(_), scheme_stx_proper_list_length (imports ) ); 
  if (islen < 0 )
    FUNCCALL(SETUP_XfOrM272(_), scheme_wrong_syntax (((void * ) 0 ) , imports , orig_form , "illegal use of `.'" ) ); 

  if (import_keys && ((((Scheme_Vector * ) (import_keys ) ) -> size ) != islen ) )
    FUNCCALL(SETUP_XfOrM272(_), scheme_contract_error ("compile-linklet" , "import count of linklet form does not match given number of import keys" , "linklet" , 1 , linklet , "linklet form imports" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (islen ) ) ) << 1 ) | 0x1 ) ) , "given keys" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((Scheme_Vector * ) (import_keys ) ) -> size ) ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )




  ; 

  import_symss = FUNCCALL(SETUP_XfOrM272(_), scheme_make_vector (islen , scheme_false ) ); 

  for (i = 0 ; i < islen ; i ++ , imports = (((Scheme_Type ) (((((intptr_t ) (imports ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (imports ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (imports ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) imports ) -> val ) ) -> u . pair_val . cdr ) ) ) {
#   define XfOrM325_COUNT (0+XfOrM272_COUNT)
#   define SETUP_XfOrM325(x) SETUP_XfOrM272(x)

# 2054 "./../src/compile.c"
    a = (((Scheme_Type ) (((((intptr_t ) (imports ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (imports ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (imports ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) imports ) -> val ) ) -> u . pair_val . car ) ) ; 
    len = FUNCCALL(SETUP_XfOrM325(_), scheme_stx_proper_list_length (a ) ); 

    import_syms = FUNCCALL_AGAIN(scheme_make_vector (len , ((void * ) 0 ) ) ); 
    (((Scheme_Vector * ) (import_symss ) ) -> els ) [i ] = import_syms ; 

    for (j = 0 ; j < len ; j ++ , a = (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) a ) -> val ) ) -> u . pair_val . cdr ) ) ) {
#     define XfOrM329_COUNT (0+XfOrM325_COUNT)
#     define SETUP_XfOrM329(x) SETUP_XfOrM325(x)

# 2061 "./../src/compile.c"
      e = (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) a ) -> val ) ) -> u . pair_val . car ) ) ; 
      FUNCCALL(SETUP_XfOrM329(_), check_import_export_clause (e , orig_form ) ); 
      if (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) e ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) )  {
        (((Scheme_Vector * ) (import_syms ) ) -> els ) [j ] = (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) e ) -> val : e ) ; 
      }

# 2065 "./../src/compile.c"
      else {
        (((Scheme_Vector * ) (import_syms ) ) -> els ) [j ] = (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) -> val : (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ) ; 
        e = (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) : (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) ) ; 
      }
      tl = FUNCCALL(SETUP_XfOrM329(_), scheme_make_ir_toplevel (i , j , 1 ) ); 
      env = FUNCCALL(SETUP_XfOrM329(_), scheme_extend_comp_env (env , e , (Scheme_Object * ) tl , 1 , 1 ) ); 
      if (! env )
        FUNCCALL(SETUP_XfOrM329(_), scheme_wrong_syntax ("linklet" , e , ((void * ) 0 ) , "duplicate import" ) ); 
    }

    linklet -> num_total_imports += len ; 
  }


  len = FUNCCALL(SETUP_XfOrM272(_), scheme_stx_proper_list_length (exports ) ); 
  if (len < 0 )
    FUNCCALL(SETUP_XfOrM272(_), scheme_wrong_syntax (((void * ) 0 ) , exports , orig_form , "illegal use of `.'" ) ); 

  linklet -> num_exports = len ; 
  FUNCCALL(SETUP_XfOrM272(_), scheme_begin_dup_symbol_check (& r ) )
  ; 

  defn_syms = FUNCCALL_AGAIN(scheme_make_vector (len , ((void * ) 0 ) ) ); 
  source_names = (scheme_make_hash_tree (0 ) ) ; 
  also_used_names = (scheme_make_hash_tree (0 ) ) ; 

  for (j = 0 ; j < len ; j ++ , exports = (((Scheme_Type ) (((((intptr_t ) (exports ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exports ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (exports ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) exports ) -> val ) ) -> u . pair_val . cdr ) ) ) {
#   define XfOrM312_COUNT (0+XfOrM272_COUNT)
#   define SETUP_XfOrM312(x) SETUP_XfOrM272(x)

# 2092 "./../src/compile.c"
    e = (((Scheme_Type ) (((((intptr_t ) (exports ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exports ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (exports ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) exports ) -> val ) ) -> u . pair_val . car ) ) ; 
    FUNCCALL(SETUP_XfOrM312(_), check_import_export_clause (e , orig_form ) ); 
    if (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) e ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) )  {
      a = (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) e ) -> val : e ) ; 
    }

# 2096 "./../src/compile.c"
    else {
      a = (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) : (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) : (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) : (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) ) ) -> val : (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) : (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) ) ) ; 
      e = (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . car ) ) ; 
    }



    (((Scheme_Vector * ) (defn_syms ) ) -> els ) [j ] = a ; 
    if (FUNCCALL(SETUP_XfOrM312(_), scheme_hash_tree_get (source_names , a ) )|| FUNCCALL(SETUP_XfOrM312(_), scheme_hash_tree_get (also_used_names , a ) )) {
#     define XfOrM315_COUNT (0+XfOrM312_COUNT)
#     define SETUP_XfOrM315(x) SETUP_XfOrM312(x)
      FUNCCALL(SETUP_XfOrM315(_), scheme_wrong_syntax ("linklet" , a , ((void * ) 0 ) , "duplicate export" ) )
# 2105 "./../src/compile.c"
      ; 
    }

    a = FUNCCALL(SETUP_XfOrM312(_), extract_source_name (e , 1 ) ); 
    if (a ) {
#     define XfOrM314_COUNT (0+XfOrM312_COUNT)
#     define SETUP_XfOrM314(x) SETUP_XfOrM312(x)

# 2110 "./../src/compile.c"
      if (! ((a ) == ((((Scheme_Vector * ) (defn_syms ) ) -> els ) [j ] ) ) )
        source_names = FUNCCALL(SETUP_XfOrM314(_), scheme_hash_tree_set (source_names , (((Scheme_Vector * ) (defn_syms ) ) -> els ) [j ] , a ) ); 
      else 
      also_used_names = FUNCCALL(SETUP_XfOrM314(_), scheme_hash_tree_set (also_used_names , (((Scheme_Vector * ) (defn_syms ) ) -> els ) [j ] , scheme_true ) ); 
    }

# 2114 "./../src/compile.c"
    else {
#     define XfOrM313_COUNT (0+XfOrM312_COUNT)
#     define SETUP_XfOrM313(x) SETUP_XfOrM312(x)
      also_used_names = FUNCCALL(SETUP_XfOrM313(_), scheme_hash_tree_set (also_used_names , (((Scheme_Vector * ) (defn_syms ) ) -> els ) [j ] , scheme_true ) ); 
    }
    tl = FUNCCALL(SETUP_XfOrM312(_), scheme_make_ir_toplevel (- 1 , j , 0 ) ); 
    env = FUNCCALL(SETUP_XfOrM312(_), scheme_extend_comp_env (env , e , (Scheme_Object * ) tl , 1 , 1 ) ); 
    if (! env )
      FUNCCALL(SETUP_XfOrM312(_), scheme_wrong_syntax ("linklet" , e , ((void * ) 0 ) , "export duplicates import" ) ); 
  }



  extra_vars_pos = len ; 
  all_extra_vars = scheme_null ; 

  for (i = 0 , a = form ; i < body_len ; i ++ , a = (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) a ) -> val ) ) -> u . pair_val . cdr ) ) ) {
#   define XfOrM303_COUNT (0+XfOrM272_COUNT)
#   define SETUP_XfOrM303(x) SETUP_XfOrM272(x)

# 2131 "./../src/compile.c"
    e = (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) a ) -> val ) ) -> u . pair_val . car ) ) ; 
    if (FUNCCALL(SETUP_XfOrM303(_), is_define_values (e ) )) {
      Scheme_Object * vars , * vals ; 
      BLOCK_SETUP((PUSH(vals, 0+XfOrM303_COUNT), PUSH(vars, 1+XfOrM303_COUNT)));
#     define XfOrM304_COUNT (2+XfOrM303_COUNT)
#     define SETUP_XfOrM304(x) SETUP(XfOrM304_COUNT)
      vars = NULLED_OUT ; 
      vals = NULLED_OUT ; 

# 2134 "./../src/compile.c"
      extra_vars = FUNCCALL(SETUP_XfOrM304(_), define_parse (e , & vars , & vals , & env , & r , & extra_vars_pos , & source_names ) ); 
      if (extra_vars ) {
#       define XfOrM305_COUNT (0+XfOrM304_COUNT)
#       define SETUP_XfOrM305(x) SETUP_XfOrM304(x)

# 2136 "./../src/compile.c"
        all_extra_vars = FUNCCALL(SETUP_XfOrM305(_), scheme_append (extra_vars , all_extra_vars ) ); 
      }
    }
  }

  if (extra_vars_pos ) {
#   define XfOrM293_COUNT (0+XfOrM272_COUNT)
#   define SETUP_XfOrM293(x) SETUP_XfOrM272(x)

# 2142 "./../src/compile.c"
    a = defn_syms ; 
    defn_syms = FUNCCALL(SETUP_XfOrM293(_), scheme_make_vector (extra_vars_pos , ((void * ) 0 ) ) ); 
    for (i = 0 ; i < len ; i ++ ) {
      (((Scheme_Vector * ) (defn_syms ) ) -> els ) [i ] = (((Scheme_Vector * ) (a ) ) -> els ) [i ] ; 
    }

    all_extra_vars = FUNCCALL(SETUP_XfOrM293(_), scheme_reverse (all_extra_vars ) ); 
    for (i = len ; i < extra_vars_pos ; i ++ , all_extra_vars = (((Scheme_Simple_Object * ) (all_extra_vars ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM296_COUNT (0+XfOrM293_COUNT)
#     define SETUP_XfOrM296(x) SETUP_XfOrM293(x)

# 2150 "./../src/compile.c"
      e = (((Scheme_Simple_Object * ) (all_extra_vars ) ) -> u . pair_val . car ) ; 
      a = (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) e ) -> val : e ) ; 
      if (FUNCCALL(SETUP_XfOrM296(_), scheme_hash_tree_get (source_names , a ) )|| FUNCCALL(SETUP_XfOrM296(_), scheme_hash_tree_get (also_used_names , a ) )) {
#       define XfOrM297_COUNT (0+XfOrM296_COUNT)
#       define SETUP_XfOrM297(x) SETUP_XfOrM296(x)
        a = FUNCCALL(SETUP_XfOrM297(_), generate_defn_name (a , source_names , also_used_names , extra_vars_pos ) ); 
      }
      (((Scheme_Vector * ) (defn_syms ) ) -> els ) [i ] = a ; 
      a = FUNCCALL(SETUP_XfOrM296(_), extract_source_name (e , 0 ) ); 
      if (! ((a ) == ((((Scheme_Vector * ) (defn_syms ) ) -> els ) [i ] ) ) )
        source_names = FUNCCALL(SETUP_XfOrM296(_), scheme_hash_tree_set (source_names , (((Scheme_Vector * ) (defn_syms ) ) -> els ) [i ] , a ) ); 
      else 
      also_used_names = FUNCCALL(SETUP_XfOrM296(_), scheme_hash_tree_set (also_used_names , a , scheme_true ) ); 
    }
  }



  linklet -> importss = import_symss ; 
  linklet -> defns = defn_syms ; 
  linklet -> source_names = source_names ; 


  bodies = FUNCCALL(SETUP_XfOrM272(_), scheme_make_vector (body_len , scheme_false ) ); 

  linklet -> bodies = bodies ; 

  for (i = 0 ; i < body_len ; i ++ , form = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . cdr ) ) ) {
#   define XfOrM283_COUNT (0+XfOrM272_COUNT)
#   define SETUP_XfOrM283(x) SETUP_XfOrM272(x)

# 2178 "./../src/compile.c"
    e = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
    if (FUNCCALL(SETUP_XfOrM283(_), is_define_values (e ) )) {
#     define XfOrM285_COUNT (0+XfOrM283_COUNT)
#     define SETUP_XfOrM285(x) SETUP_XfOrM283(x)

# 2180 "./../src/compile.c"
      a = (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) : (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) ) ; 
      len = FUNCCALL(SETUP_XfOrM285(_), scheme_stx_proper_list_length (a ) ); 
      vec = FUNCCALL_AGAIN(scheme_make_vector (len + 1 , ((void * ) 0 ) ) ); 

      if (len == 1 )
        d_env = FUNCCALL(SETUP_XfOrM285(_), scheme_set_comp_env_name (env , (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) a ) -> val ) ) -> u . pair_val . car ) ) ) ); 
      else 
      d_env = env ; 

      for (j = 0 ; j < len ; j ++ , a = (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) a ) -> val ) ) -> u . pair_val . cdr ) ) ) {
#       define XfOrM290_COUNT (0+XfOrM285_COUNT)
#       define SETUP_XfOrM290(x) SETUP_XfOrM285(x)

# 2190 "./../src/compile.c"
        v = FUNCCALL(SETUP_XfOrM290(_), scheme_compile_lookup ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) a ) -> val ) ) -> u . pair_val . car ) ) , env , 0 ) ); 
        ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) ) ? 1 : 0 ) , __extension__ ({
#         define XfOrM292_COUNT (0+XfOrM290_COUNT)
#         define SETUP_XfOrM292(x) SETUP_XfOrM290(x)

# 2191 "./../src/compile.c" 3
          if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_ir_toplevel_type ) ) 

# 2191 "./../src/compile.c" 3
          ; 

# 2191 "./../src/compile.c" 3
          else FUNCCALL(SETUP_XfOrM292(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(v)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(v))->type)) == (Scheme_Type)(scheme_ir_toplevel_type))" , "./../src/compile.c" , 2191 , __extension__ __PRETTY_FUNCTION__ ) ); 
        }
        ) ) 
# 2191 "./../src/compile.c"
        ; 
        ((void ) sizeof ((((Scheme_IR_Toplevel * ) v ) -> instance_pos == - 1 ) ? 1 : 0 ) , __extension__ ({
#         define XfOrM291_COUNT (0+XfOrM290_COUNT)
#         define SETUP_XfOrM291(x) SETUP_XfOrM290(x)

# 2192 "./../src/compile.c" 3
          if (((Scheme_IR_Toplevel * ) v ) -> instance_pos == - 1 )

# 2192 "./../src/compile.c" 3
          ; 

# 2192 "./../src/compile.c" 3
          else FUNCCALL(SETUP_XfOrM291(_), __assert_fail ("((Scheme_IR_Toplevel *)v)->instance_pos == -1" , "./../src/compile.c" , 2192 , __extension__ __PRETTY_FUNCTION__ ) ); 
        }
        ) ) 
# 2192 "./../src/compile.c"
        ; 
        ((((Scheme_Vector * ) (vec ) ) -> els ) [(j ) + 1 ] ) = v ; 
      }

      a = FUNCCALL(SETUP_XfOrM285(_), compile_expr ((((Scheme_Type ) (((((intptr_t ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) ((((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) : (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Simple_Object * ) (((Scheme_Stx * ) (((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (e ) ) -> u . pair_val . cdr ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) e ) -> val ) ) -> u . pair_val . cdr ) ) ) -> val ) ) -> u . pair_val . cdr ) ) -> val ) ) -> u . pair_val . car ) ) ) , d_env , 0 ) ); 
      ((((Scheme_Vector * ) (vec ) ) -> els ) [0 ] ) = a ; 

      if (! (((FUNCCALL(SETUP_XfOrM285(_), scheme_stx_property (e , compiler_inline_hint_symbol , ((void * ) 0 ) ) )) ) == (scheme_false ) ) )  {

        ((((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex |= 0x1 ) ) ; 
      }

      e = vec ; 
      e -> type = scheme_define_values_type ; 
    }

# 2206 "./../src/compile.c"
    else {
#     define XfOrM284_COUNT (0+XfOrM283_COUNT)
#     define SETUP_XfOrM284(x) SETUP_XfOrM283(x)

# 2207 "./../src/compile.c"
      e = FUNCCALL(SETUP_XfOrM284(_), compile_expr (e , env , 0 ) ); 
    }

    (((Scheme_Vector * ) (bodies ) ) -> els ) [i ] = e ; 
  }

  RET_VALUE_START (linklet ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2216 "./../src/compile.c"
static Scheme_Object * generate_defn_name (Scheme_Object * base_sym , 
Scheme_Hash_Tree * used_names , 
Scheme_Hash_Tree * also_used_names , 
int search_start ) 
{
  char buf [32 ] ; 
  Scheme_Object * n ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(also_used_names, 0), PUSH(used_names, 1), PUSH(base_sym, 2), PUSH(n, 3)));
# define XfOrM332_COUNT (4)
# define SETUP_XfOrM332(x) SETUP(XfOrM332_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  n = NULLED_OUT ; 

# 2224 "./../src/compile.c"
  while (1 ) {
#   define XfOrM334_COUNT (0+XfOrM332_COUNT)
#   define SETUP_XfOrM334(x) SETUP_XfOrM332(x)
    (
# 2225 "./../src/compile.c"
    sprintf (buf , ".%d" , search_start ) ) ; 
    n = FUNCCALL(SETUP_XfOrM334(_), scheme_intern_exact_parallel_symbol (buf , strlen (buf ) ) ); 
    n = FUNCCALL_AGAIN(scheme_symbol_append (base_sym , n ) ); 
    if (! FUNCCALL(SETUP_XfOrM334(_), scheme_hash_tree_get (used_names , n ) )&& ! FUNCCALL(SETUP_XfOrM334(_), scheme_hash_tree_get (also_used_names , n ) ))
      RET_VALUE_START (n ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3 "./../src/mzmark_compile.inc"
static int mark_ir_lambda_info_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_ir_lambda_info_MARK (void * p , struct NewGC * gc ) {

  Scheme_IR_Lambda_Info * i = (Scheme_IR_Lambda_Info * ) p ; 

  GC_mark2 (& (i -> base_closure ) , gc ) ; 
  GC_mark2 (& (i -> vars ) , gc ) ; 
  GC_mark2 (& (i -> arg_types ) , gc ) ; 
  GC_mark2 (& (i -> arg_type_contributors ) , gc ) ; 


  return 0 ; 
}






static int mark_ir_lambda_info_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_IR_Lambda_Info * i = (Scheme_IR_Lambda_Info * ) p ; 

  GC_fixup2 (& (i -> base_closure ) , gc ) ; 
  GC_fixup2 (& (i -> vars ) , gc ) ; 
  GC_fixup2 (& (i -> arg_types ) , gc ) ; 
  GC_fixup2 (& (i -> arg_type_contributors ) , gc ) ; 


  return 0 ; 
}

# 2244 "./../src/compile.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_rt_ir_lambda_info , mark_ir_lambda_info_SIZE , mark_ir_lambda_info_MARK , mark_ir_lambda_info_FIXUP , 1 , 0 ) ; 
}
