#include "precomp.h"

# 34 "../rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "./../../rktio/rktio.h"
typedef struct rktio_t rktio_t ; 

# 121 "./../../rktio/rktio.h"
typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "./../../rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 256 "./../../rktio/rktio.h"
__xform_nongcing__ extern void rktio_forget (rktio_t * rktio , rktio_fd_t * fd ) ; 




__xform_nongcing__ extern rktio_fd_t * rktio_std_fd (rktio_t * rktio , int which ) ; 






__xform_nongcing__ extern void rktio_create_console (void ) ; 

# 351 "./../../rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "./../../rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 

# 403 "./../../rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "./../../rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "./../../rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "./../../rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "./../../rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "./../../rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "./../../rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "./../../rktio/rktio.h"
rktio_process_result_t ; 

# 646 "./../../rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "./../../rktio/rktio.h"
rktio_status_t ; 

# 669 "./../../rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "./../../rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

# 742 "./../../rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

# 762 "./../../rktio/rktio.h"
enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

# 793 "./../../rktio/rktio.h"
enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 874 "./../../rktio/rktio.h"
typedef intptr_t rktio_timestamp_t ; 






typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "./../../rktio/rktio.h"
rktio_stat_t ; 



typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "./../../rktio/rktio.h"
rktio_identity_t ; 

# 925 "./../../rktio/rktio.h"
typedef struct rktio_directory_list_t rktio_directory_list_t ; 

# 947 "./../../rktio/rktio.h"
typedef struct rktio_file_copy_t rktio_file_copy_t ; 

# 975 "./../../rktio/rktio.h"
enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 






enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

# 1018 "./../../rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "./../../rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

# 1075 "./../../rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "./../../rktio/rktio.h"
rktio_date_t ; 

# 1109 "./../../rktio/rktio.h"
enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1152 "./../../rktio/rktio.h"
__xform_nongcing__ extern rktio_ok_t rktio_syslog (rktio_t * rktio , int level , rktio_const_string_t name , rktio_const_string_t msg , 
rktio_const_string_t exec_name ) ; 






enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "./../../rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "./../../rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "./../../rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "./../../rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "./../../rktio/rktio.h"
rktio_sha1_ctx_t ; 

# 1304 "./../../rktio/rktio.h"
typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "./../../rktio/rktio.h"
rktio_sha2_ctx_t ; 

# 1322 "./../../rktio/rktio.h"
typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "./../../rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 









__xform_nongcing__ extern int rktio_get_last_error_kind (rktio_t * rktio ) ; 


enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 

__xform_nongcing__ extern int rktio_get_last_error (rktio_t * rktio ) ; 


enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 









__xform_nongcing__ extern void rktio_remap_last_error (rktio_t * rktio ) ; 





__xform_nongcing__ extern const char * rktio_get_error_string (rktio_t * rktio , int kind , int errid ) ; 

# 46 "/usr/include/ctype.h" 3
enum 
{
  _ISupper = ((0 ) < 8 ? ((1 << (0 ) ) << 8 ) : ((1 << (0 ) ) >> 8 ) ) , 
  _ISlower = ((1 ) < 8 ? ((1 << (1 ) ) << 8 ) : ((1 << (1 ) ) >> 8 ) ) , 
  _ISalpha = ((2 ) < 8 ? ((1 << (2 ) ) << 8 ) : ((1 << (2 ) ) >> 8 ) ) , 
  _ISdigit = ((3 ) < 8 ? ((1 << (3 ) ) << 8 ) : ((1 << (3 ) ) >> 8 ) ) , 
  _ISxdigit = ((4 ) < 8 ? ((1 << (4 ) ) << 8 ) : ((1 << (4 ) ) >> 8 ) ) , 
  _ISspace = ((5 ) < 8 ? ((1 << (5 ) ) << 8 ) : ((1 << (5 ) ) >> 8 ) ) , 
  _ISprint = ((6 ) < 8 ? ((1 << (6 ) ) << 8 ) : ((1 << (6 ) ) >> 8 ) ) , 
  _ISgraph = ((7 ) < 8 ? ((1 << (7 ) ) << 8 ) : ((1 << (7 ) ) >> 8 ) ) , 
  _ISblank = ((8 ) < 8 ? ((1 << (8 ) ) << 8 ) : ((1 << (8 ) ) >> 8 ) ) , 
  _IScntrl = ((9 ) < 8 ? ((1 << (9 ) ) << 8 ) : ((1 << (9 ) ) >> 8 ) ) , 
  _ISpunct = ((10 ) < 8 ? ((1 << (10 ) ) << 8 ) : ((1 << (10 ) ) >> 8 ) ) , 
  _ISalnum = ((11 ) < 8 ? ((1 << (11 ) ) << 8 ) : ((1 << (11 ) ) >> 8 ) ) }
; 

# 37 "/usr/include/errno.h" 3
extern int * __errno_location (void ) __attribute__ ((__nothrow__ , __leaf__ ) ) __attribute__ ((__const__ ) ) ; 

# 21 "./../src/error.c"
scheme_console_printf_t scheme_console_printf ; 
scheme_console_printf_t scheme_get_console_printf () {
  /* No conversion */

# 22 "./../src/error.c"
  return scheme_console_printf ; 
}

# 23 "./../src/error.c"
void scheme_set_console_printf (scheme_console_printf_t p ) {
  /* No conversion */

# 23 "./../src/error.c"
  scheme_console_printf = p ; 
}

# 24 "./../src/error.c"
Scheme_Exit_Proc scheme_exit ; 
void scheme_set_exit (Scheme_Exit_Proc p ) {
  /* No conversion */

# 25 "./../src/error.c"
  scheme_exit = p ; 
}
void (* scheme_console_output ) (char * str , intptr_t len ) ; 
void scheme_set_console_output (scheme_console_output_t p ) {
  /* No conversion */

# 28 "./../src/error.c"
  scheme_console_output = p ; 
}
static Scheme_Object * init_syslog_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
static Scheme_Object * init_stderr_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (2 ) ) ) << 1 ) | 0x1 ) ) ; 
static Scheme_Object * init_stdout_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
; 
; 
; 
; 


static Scheme_Object * none_symbol ; 
static Scheme_Object * fatal_symbol ; 
static Scheme_Object * error_symbol ; 
static Scheme_Object * warning_symbol ; 
static Scheme_Object * info_symbol ; 
static Scheme_Object * debug_symbol ; 
static Scheme_Object * posix_symbol ; 
static Scheme_Object * windows_symbol ; 
static Scheme_Object * gai_symbol ; 
static Scheme_Object * arity_property ; 
static Scheme_Object * def_err_val_proc ; 
static Scheme_Object * def_err_stx_proc ; 
static Scheme_Object * def_error_esc_proc ; 
static Scheme_Object * default_display_handler ; 
static Scheme_Object * emergency_display_handler ; 
static Scheme_Object * def_exe_yield_proc ; 
Scheme_Object * scheme_def_exit_proc ; 
Scheme_Object * scheme_raise_arity_error_proc ; 






static mzrt_mutex * glib_log_queue_lock ; 
typedef struct glib_log_queue_entry {
  const char * log_domain ; 
  int log_level ; 
  const char * message ; 
  struct glib_log_queue_entry * next ; 
}

# 69 "./../src/error.c"
glib_log_queue_entry ; 
static glib_log_queue_entry * glib_log_queue ; 
static void * glib_log_signal_handle ; 



static Scheme_Object * error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * assert_unreachable (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_user_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_type_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_argument_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_result_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_mismatch_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_arguments_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_range_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_arity_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_arity_mask_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * raise_result_arity_error (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * error_escape_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_display_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_value_string_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_syntax_string_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * exit_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * exe_yield_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_print_width (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_print_context_length (int , Scheme_Object * [] ) ; 
static Scheme_Object * error_print_srcloc (int , Scheme_Object * [] ) ; 
static void def_error_escape_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_error_display_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * emergency_error_display_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_error_value_string_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_error_syntax_string_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * def_exit_handler_proc (int , Scheme_Object * [] ) ; 
static Scheme_Object * default_yield_handler (int , Scheme_Object * [] ) ; 
static Scheme_Object * srcloc_to_string (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unquoted_printing_string (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unquoted_printing_string_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * unquoted_printing_string_value (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * log_message (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * log_level_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * log_max_level (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * log_all_levels (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * log_level_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_logger (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * logger_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_logger (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * logger_name (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_log_reader (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * log_reader_p (int argc , Scheme_Object * argv [] ) ; 
static int log_reader_get (Scheme_Object * ch , Scheme_Schedule_Info * sinfo ) ; 

static void do_raise (Scheme_Object * arg , int need_debug , int barrier ) ; 
static void nested_exn_handler (void * old_exn , int argc , Scheme_Object * argv [] ) ; 

static void update_want_level (Scheme_Logger * logger , Scheme_Object * name ) ; 

static Scheme_Object * check_arity_property_value_ok (int argc , Scheme_Object * argv [] ) ; 

static char * make_provided_list (Scheme_Object * o , int count , intptr_t * lenout ) ; 

static char * init_buf (intptr_t * len , intptr_t * blen ) ; 

void scheme_set_logging2 (int syslog_level , int stderr_level , int stdout_level ) 
{
  /* No conversion */

# 134 "./../src/error.c"
  if (syslog_level > - 1 )
    init_syslog_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (syslog_level ) ) ) << 1 ) | 0x1 ) ) ; 
  if (stderr_level > - 1 )
    init_stderr_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (stderr_level ) ) ) << 1 ) | 0x1 ) ) ; 
  if (stdout_level > - 1 )
    init_stdout_level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (stdout_level ) ) ) << 1 ) | 0x1 ) ) ; 
}

void scheme_set_logging (int syslog_level , int stderr_level ) 
{
  /* No conversion */

# 144 "./../src/error.c"
  scheme_set_logging2 (syslog_level , stderr_level , - 1 ) ; 
}

void scheme_set_logging2_spec (Scheme_Object * syslog_level , Scheme_Object * stderr_level , Scheme_Object * stdout_level ) 
{
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(stdout_level, 0), PUSH(stderr_level, 1), PUSH(syslog_level, 2)));
# define XfOrM7_COUNT (3)
# define SETUP_XfOrM7(x) SETUP(XfOrM7_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 150 "./../src/error.c"
  if (syslog_level ) {
#   define XfOrM10_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM10(x) SETUP_XfOrM7(x)
    FUNCCALL(SETUP_XfOrM10(_), scheme_register_static ((void * ) & init_syslog_level , sizeof (init_syslog_level ) ) )
# 151 "./../src/error.c"
    ; 
    init_syslog_level = syslog_level ; 
  }
  if (stderr_level ) {
#   define XfOrM9_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM9(x) SETUP_XfOrM7(x)
    FUNCCALL(SETUP_XfOrM9(_), scheme_register_static ((void * ) & init_stderr_level , sizeof (init_stderr_level ) ) )
# 155 "./../src/error.c"
    ; 
    init_stderr_level = stderr_level ; 
  }
  if (stdout_level ) {
#   define XfOrM8_COUNT (0+XfOrM7_COUNT)
#   define SETUP_XfOrM8(x) SETUP_XfOrM7(x)
    FUNCCALL(SETUP_XfOrM8(_), scheme_register_static ((void * ) & init_stdout_level , sizeof (init_stdout_level ) ) )
# 159 "./../src/error.c"
    ; 
    init_stdout_level = stdout_level ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 164 "./../src/error.c"
void scheme_set_logging_spec (Scheme_Object * syslog_level , Scheme_Object * stderr_level ) 
{
  /* No conversion */

# 166 "./../src/error.c"
  scheme_set_logging2_spec (syslog_level , stderr_level , ((void * ) 0 ) ) ; 
}

void scheme_init_logging_once (void ) 
{

  int j ; 
  Scheme_Object * l , * s ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(s, 1)));
# define XfOrM12_COUNT (2)
# define SETUP_XfOrM12(x) SETUP(XfOrM12_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 175 "./../src/error.c"
  for (j = 0 ; j < 3 ; j ++ ) {
#   define XfOrM18_COUNT (0+XfOrM12_COUNT)
#   define SETUP_XfOrM18(x) SETUP_XfOrM12(x)

# 176 "./../src/error.c"
    switch (j ) {
      case 0 : l = init_syslog_level ; 

# 177 "./../src/error.c"
      break ; 
      case 1 : l = init_stderr_level ; 

# 178 "./../src/error.c"
      break ; 
      default : l = init_stdout_level ; 

# 179 "./../src/error.c"
      break ; 
    }
    if (l ) {
#     define XfOrM19_COUNT (0+XfOrM18_COUNT)
#     define SETUP_XfOrM19(x) SETUP_XfOrM18(x)

# 182 "./../src/error.c"
      while (! (((intptr_t ) (l ) ) & 0x1 ) ) {
#       define XfOrM21_COUNT (0+XfOrM19_COUNT)
#       define SETUP_XfOrM21(x) SETUP_XfOrM19(x)

# 183 "./../src/error.c"
        l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        s = FUNCCALL(SETUP_XfOrM21(_), scheme_intern_exact_symbol ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) -> u . byte_str_val . tag_val ) ) )
        ; 
        (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) = s ; 
        l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 193 "./../src/error.c"
typedef struct {
  int args ; 
  Scheme_Object * type ; 
  Scheme_Object * * names ; 
  int count ; 
  Scheme_Object * exptime ; 
  int super_pos ; 
}

# 200 "./../src/error.c"
exn_rec ; 

# 63 "./../src/schexn.h"
static exn_rec * exn_table ; 

# 206 "./../src/error.c"
static void default_printf (char * msg , ... ) 
{
  /* No conversion */

# 208 "./../src/error.c"
  GC_CAN_IGNORE va_list args ; 
  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  vfprintf (stderr , msg , args ) ; 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 
  fflush (stderr ) ; 
}

static void default_output (char * s , intptr_t len ) 
{
  /* No conversion */

# 217 "./../src/error.c"
  fwrite (s , len , 1 , stderr ) ; 
  fflush (stderr ) ; 
}

intptr_t scheme_errno () {
  /* No conversion */


  return (* __errno_location () ) ; 
}


Scheme_Config * scheme_init_error_escape_proc (Scheme_Config * config ) 
{
  DECL_RET_SAVE (Scheme_Config * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(config, 0)));
# define XfOrM26_COUNT (1)
# define SETUP_XfOrM26(x) SETUP(XfOrM26_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 231 "./../src/error.c"
  if (! def_error_esc_proc ) {
#   define XfOrM28_COUNT (0+XfOrM26_COUNT)
#   define SETUP_XfOrM28(x) SETUP_XfOrM26(x)
    FUNCCALL(SETUP_XfOrM28(_), scheme_register_static ((void * ) & def_error_esc_proc , sizeof (def_error_esc_proc ) ) )
# 232 "./../src/error.c"
    ; 
    def_error_esc_proc = FUNCCALL(SETUP_XfOrM28(_), scheme_make_prim_w_arity ((Scheme_Prim * ) def_error_escape_proc , "default-error-escape-handler" , 0 , 0 ) )


    ; 
  }

  if (config )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_extend_config (config , MZCONFIG_ERROR_ESCAPE_HANDLER , def_error_esc_proc ) )) RET_VALUE_EMPTY_END ; 
  else {
#   define XfOrM27_COUNT (0+XfOrM26_COUNT)
#   define SETUP_XfOrM27(x) SETUP_XfOrM26(x)
    FUNCCALL_EMPTY(scheme_set_root_param (MZCONFIG_ERROR_ESCAPE_HANDLER , def_error_esc_proc ) )
# 242 "./../src/error.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 293 "./../src/error.c"
static intptr_t sch_vsprintf (char * s , intptr_t maxlen , const char * msg , va_list args , char * * _s , 
Scheme_Object * * _errno_val , int * _unsupported ) 


{
  intptr_t i , j ; 
  char buf [100 ] ; 





  int pp = 0 , ip = 0 , dp = 0 ; 
  void * ptrs [25 ] ; 
  intptr_t ints [25 ] ; 
  double dbls [25 ] ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(_errno_val, 0), PUSH(_unsupported, 1), PUSH(s, 2), PUSH(msg, 3), PUSH(_s, 4), PUSHARRAY(ptrs, 25, 5)));
# define XfOrM29_COUNT (8)
# define SETUP_XfOrM29(x) SETUP(XfOrM29_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  NULL_OUT_ARRAY (ptrs ) ; 

# 310 "./../src/error.c"
  for (j = 0 ; msg [j ] ; j ++ ) {
    if (msg [j ] == '%' ) {
      int type ; 

      j ++ ; 
      type = msg [j ] ; 

      switch (type ) {
        case 'c' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        break ; 
        case 'd' : 
        case 'o' : 
        case '-' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        break ; 
        case 'g' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , long ) ) ; 
        break ; 
        case 'l' : 
        case 'I' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , intptr_t ) ) ; 
        break ; 
        case 'f' : 
        dbls [dp ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , double ) ) ; 
        break ; 
        case 'L' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , intptr_t ) ) ; 
        break ; 
        case 'e' : 
        case 'E' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        break ; 
        case 'N' : 
        case 'm' : 
        case 'M' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        break ; 
        case 'Z' : 
        ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
        ptrs [pp ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , char * ) ) ; 
        break ; 
        case 'S' : 
        case 'V' : 
        case '@' : 
        case 'D' : 
        case 'W' : 
        case 'T' : 
        case 'Q' : 
        case '_' : 
        ptrs [pp ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , Scheme_Object * ) ) ; 
        break ; 
        default : 
        ptrs [pp ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , char * ) ) ; 
        if ((type == 't' ) || (type == 'u' ) ) {
          ints [ip ++ ] = HIDE_FROM_XFORM (__builtin_va_arg (args , intptr_t ) ) ; 
        }
      }
    }
  }
  pp = 0 ; 
  ip = 0 ; 
  dp = 0 ; 

  if (! s ) {
#   define XfOrM134_COUNT (0+XfOrM29_COUNT)
#   define SETUP_XfOrM134(x) SETUP_XfOrM29(x)

# 376 "./../src/error.c"
    s = FUNCCALL(SETUP_XfOrM134(_), init_buf (((void * ) 0 ) , & maxlen ) ); 
    * _s = s ; 
  }

  -- maxlen ; 

  i = j = 0 ; 
  while ((i < maxlen ) && msg [j ] ) {
#   define XfOrM82_COUNT (0+XfOrM29_COUNT)
#   define SETUP_XfOrM82(x) SETUP_XfOrM29(x)

# 384 "./../src/error.c"
    if (msg [j ] == '%' ) {
      int type ; 

      j ++ ; 
#     define XfOrM84_COUNT (0+XfOrM82_COUNT)
#     define SETUP_XfOrM84(x) SETUP_XfOrM82(x)

# 388 "./../src/error.c"
      type = msg [j ++ ] ; 

      if (type == '%' )
        s [i ++ ] = '%' ; 
      else {
        const char * t ; 
        intptr_t tlen ; 
        int dots = 0 ; 
        BLOCK_SETUP((PUSH(t, 0+XfOrM84_COUNT)));
#       define XfOrM85_COUNT (1+XfOrM84_COUNT)
#       define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
        t = NULLED_OUT ; 

# 397 "./../src/error.c"
        switch (type ) {
#         define XfOrM92_COUNT (0+XfOrM85_COUNT)
#         define SETUP_XfOrM92(x) SETUP_XfOrM85(x)

# 398 "./../src/error.c"
          case 'c' : 
          {
            int c ; 
#           define XfOrM131_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM131(x) SETUP_XfOrM92(x)

# 401 "./../src/error.c"
            c = ints [ip ++ ] ; 
            if (c < 128 ) {
              buf [0 ] = c ; 
              tlen = 1 ; 
            }

# 405 "./../src/error.c"
            else {
              mzchar mc ; 
#             define XfOrM132_COUNT (0+XfOrM131_COUNT)
#             define SETUP_XfOrM132(x) SETUP_XfOrM131(x)

# 407 "./../src/error.c"
              mc = c ; 
              tlen = FUNCCALL(SETUP_XfOrM132(_), scheme_utf8_encode_all (& mc , 1 , (unsigned char * ) buf ) ); 
            }
            t = buf ; 
          }
          break ; 
          case 'd' : 
          {
            int d ; 
#           define XfOrM130_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM130(x) SETUP_XfOrM92(x)

# 416 "./../src/error.c"
            d = ints [ip ++ ] ; 
            (sprintf (buf , "%d" , d ) ) ; 
            t = buf ; 
            tlen = strlen (t ) ; 
          }
          break ; 
          case '-' : 
          {
            ip ++ ; 
            t = "" ; 
            tlen = 0 ; 
          }
          break ; 
          case 'o' : 
          {
            int d ; 
#           define XfOrM128_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM128(x) SETUP_XfOrM92(x)

# 432 "./../src/error.c"
            d = ints [ip ++ ] ; 
            (sprintf (buf , "%o" , d ) ) ; 
            t = buf ; 
            tlen = strlen (t ) ; 
          }
          break ; 
          case 'I' : 
          case 'l' : 
          case 'g' : 
          {
            intptr_t d ; 
            int as_hex ; 
#           define XfOrM127_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM127(x) SETUP_XfOrM92(x)

# 444 "./../src/error.c"
            if ((type == 'I' ) && (msg [j ] == '6' ) && (msg [j + 1 ] == '4' ) )
              j ++ ; 
            as_hex = (msg [j ] == 'x' ) ; 
            j ++ ; 
            d = ints [ip ++ ] ; 
            if (as_hex )
              (sprintf (buf , "%" "l" "x" , d ) ) ; 
            else (
            sprintf (buf , "%" "l" "d" , d ) ) ; 
            t = buf ; 
            tlen = strlen (t ) ; 
          }
          break ; 
          case 'f' : 
          {
            double f ; 
#           define XfOrM126_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM126(x) SETUP_XfOrM92(x)

# 460 "./../src/error.c"
            f = dbls [dp ++ ] ; 
            (sprintf (buf , "%f" , f ) ) ; 
            t = buf ; 
            tlen = strlen (t ) ; 
          }
          break ; 
          case 'L' : 
          {
            intptr_t d ; 
#           define XfOrM123_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM123(x) SETUP_XfOrM92(x)

# 469 "./../src/error.c"
            d = ints [ip ++ ] ; 
            if (d >= 0 ) {
#             define XfOrM125_COUNT (0+XfOrM123_COUNT)
#             define SETUP_XfOrM125(x) SETUP_XfOrM123(x)
              (
# 471 "./../src/error.c"
              sprintf (buf , "%" "l" "d" ":" , d ) ) ; 
              t = buf ; 
              tlen = strlen (t ) ; 
            }

# 474 "./../src/error.c"
            else {
              t = ":" ; 
              tlen = 1 ; 
            }
          }
          break ; 
          case 'R' : 
          {
            intptr_t errid ; 
            intptr_t errkind ; 
            const char * es , * errkind_str ; 
            intptr_t elen ; 
            BLOCK_SETUP((PUSH(es, 0+XfOrM92_COUNT)));
#           define XfOrM118_COUNT (1+XfOrM92_COUNT)
#           define SETUP_XfOrM118(x) SETUP(XfOrM118_COUNT)
            es = NULLED_OUT ; 
            errkind_str = NULLED_OUT ; 

# 486 "./../src/error.c"
            errkind = (rktio_get_last_error_kind (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
            errid = (rktio_get_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
            switch (errkind ) {
              case RKTIO_ERROR_KIND_WINDOWS : 
              errkind_str = "errid" ; 
              break ; 
              case RKTIO_ERROR_KIND_POSIX : 
              errkind_str = "errno" ; 
              break ; 
              case RKTIO_ERROR_KIND_GAI : 
              errkind_str = "gai_err" ; 
              break ; 
              default : 
              errkind_str = "rktio_err" ; 
              break ; 
            }
            es = (rktio_get_error_string (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , errkind , errid ) ) ; 
            (sprintf (buf , "; %s=%" "l" "d" "" , errkind_str , errid ) ) ; 
            if (es )

# 504 "./../src/error.c"
            elen = strlen (es ) ; 

# 504 "./../src/error.c"
            else elen = 0 ; 
            tlen = strlen (buf ) ; 
            t = (const char * ) FUNCCALL(SETUP_XfOrM118(_), GC_malloc_atomic (tlen + elen + 1 ) ); 
            (memcpy ((char * ) t , es , elen ) ) ; 
            (memcpy ((char * ) t + elen , buf , tlen + 1 ) ) ; 
            tlen += elen ; 
            if (_errno_val ) {
              Scheme_Object * err_kind ; 
              BLOCK_SETUP((PUSH(err_kind, 0+XfOrM118_COUNT)));
#             define XfOrM119_COUNT (1+XfOrM118_COUNT)
#             define SETUP_XfOrM119(x) SETUP(XfOrM119_COUNT)
              err_kind = NULLED_OUT ; 

# 512 "./../src/error.c"
              switch (errkind ) {
                case RKTIO_ERROR_KIND_WINDOWS : 
                err_kind = windows_symbol ; 
                break ; 
                case RKTIO_ERROR_KIND_POSIX : 
                err_kind = posix_symbol ; 
                break ; 
                case RKTIO_ERROR_KIND_GAI : 
                err_kind = gai_symbol ; 
                break ; 
                default : 
                err_kind = ((void * ) 0 ) ; 
              }
              if (err_kind ) {
#               define XfOrM120_COUNT (0+XfOrM119_COUNT)
#               define SETUP_XfOrM120(x) SETUP_XfOrM119(x)

# 526 "./../src/error.c"
                err_kind = (__funcarg62 = FUNCCALL(SETUP_XfOrM120(_), scheme_make_integer_value (errid ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg62 , err_kind ) )) ; 
                * _errno_val = err_kind ; 
              }
            }
            if (_unsupported 
            && (errid == RKTIO_ERROR_UNSUPPORTED ) 
            && (errkind == RKTIO_ERROR_KIND_RACKET ) )
              * _unsupported = 1 ; 
          }
          break ; 
          case 'e' : 
          case 'm' : 
          case 'E' : 
          case 'M' : 
          case 'Z' : 
          case 'N' : 
          {
            int en , he , none = 0 ; 
            char * es ; 
            const char * errkind_str = ((void * ) 0 ) ; 
            Scheme_Object * err_kind = ((void * ) 0 ) ; 
            BLOCK_SETUP((PUSH(es, 0+XfOrM92_COUNT), PUSH(err_kind, 1+XfOrM92_COUNT), PUSH(errkind_str, 2+XfOrM92_COUNT)));
#           define XfOrM106_COUNT (3+XfOrM92_COUNT)
#           define SETUP_XfOrM106(x) SETUP(XfOrM106_COUNT)
            es = NULLED_OUT ; 

# 548 "./../src/error.c"
            if (type == 'm' ) {
              none = ! ints [ip ++ ] ; 
              type = 'e' ; 
              he = 0 ; 
            }

# 552 "./../src/error.c"
            else if (type == 'M' ) {
              none = ! ints [ip ++ ] ; 
              type = 'E' ; 
              he = 0 ; 
            }

# 556 "./../src/error.c"
            else if (type == 'N' ) {
              he = ints [ip ++ ] ; 
              type = 'E' ; 
            }

# 559 "./../src/error.c"
            else 
            he = 0 ; 

            en = ints [ip ++ ] ; 

            if (type == 'Z' )
              es = ptrs [pp ++ ] ; 
            else 
            es = ((void * ) 0 ) ; 

            if (he ) {
#             define XfOrM114_COUNT (0+XfOrM106_COUNT)
#             define SETUP_XfOrM114(x) SETUP_XfOrM106(x)

# 570 "./../src/error.c"
              es = (char * ) FUNCCALL(SETUP_XfOrM114(_), scheme_hostname_error (en ) ); 
              err_kind = gai_symbol ; 
              errkind_str = "gai_err" ; 
            }

            if ((en || es ) && ! none ) {
#             define XfOrM110_COUNT (0+XfOrM106_COUNT)
#             define SETUP_XfOrM110(x) SETUP_XfOrM106(x)

# 607 "./../src/error.c"
              if (! es ) {
#               define XfOrM113_COUNT (0+XfOrM110_COUNT)
#               define SETUP_XfOrM113(x) SETUP_XfOrM110(x)

# 608 "./../src/error.c"
                es = FUNCCALL(SETUP_XfOrM113(_), strerror (en ) ); 
                err_kind = posix_symbol ; 
                errkind_str = "errno" ; 
              }

              tlen = strlen (es ) + 24 ; 
              t = (const char * ) FUNCCALL(SETUP_XfOrM110(_), GC_malloc_atomic (tlen ) ); 

              ((void ) sizeof ((errkind_str ) ? 1 : 0 ) , __extension__ ({
#               define XfOrM112_COUNT (0+XfOrM110_COUNT)
#               define SETUP_XfOrM112(x) SETUP_XfOrM110(x)

# 616 "./../src/error.c" 3
                if (errkind_str )

# 616 "./../src/error.c" 3
                ; 

# 616 "./../src/error.c" 3
                else FUNCCALL(SETUP_XfOrM112(_), __assert_fail ("errkind_str" , "./../src/error.c" , 616 , __extension__ __PRETTY_FUNCTION__ ) ); 
              }
              ) ) 
# 616 "./../src/error.c"
              ; 
              (sprintf ((char * ) t , "%s; %s=%d" , es , errkind_str , en ) ) ; 
              tlen = strlen (t ) ; 
              if (_errno_val ) {
#               define XfOrM111_COUNT (0+XfOrM110_COUNT)
#               define SETUP_XfOrM111(x) SETUP_XfOrM110(x)

# 620 "./../src/error.c"
                err_kind = (__funcarg61 = FUNCCALL(SETUP_XfOrM111(_), scheme_make_integer_value (en ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg61 , err_kind ) )) ; 
                * _errno_val = err_kind ; 
              }
            }

# 623 "./../src/error.c"
            else {
              if (none ) {
                t = "" ; 
                tlen = 0 ; 
              }

# 627 "./../src/error.c"
              else {
                t = "errno=?" ; 
                tlen = 7 ; 
              }
            }
          }

          break ; 
          case 'S' : 
          {
            Scheme_Object * sym ; 
#           define XfOrM105_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM105(x) SETUP_XfOrM92(x)
            sym = NULLED_OUT ; 

# 638 "./../src/error.c"
            sym = (Scheme_Object * ) ptrs [pp ++ ] ; 
            t = FUNCCALL(SETUP_XfOrM105(_), scheme_symbol_name_and_size (sym , (uintptr_t * ) & tlen , 0 ) ); 
          }
          break ; 
          case 'V' : 
          {
            Scheme_Object * o ; 
#           define XfOrM104_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM104(x) SETUP_XfOrM92(x)
            o = NULLED_OUT ; 

# 645 "./../src/error.c"
            o = (Scheme_Object * ) ptrs [pp ++ ] ; 
            t = FUNCCALL(SETUP_XfOrM104(_), scheme_make_provided_string (o , 1 , & tlen ) ); 
          }
          break ; 
          case '@' : 
          {
            Scheme_Object * o ; 
#           define XfOrM103_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM103(x) SETUP_XfOrM92(x)
            o = NULLED_OUT ; 

# 652 "./../src/error.c"
            o = (Scheme_Object * ) ptrs [pp ++ ] ; 
            t = FUNCCALL(SETUP_XfOrM103(_), make_provided_list (o , 1 , & tlen ) ); 
          }
          break ; 
          case 'D' : 
          {
            Scheme_Object * o ; 
            intptr_t dlen ; 
#           define XfOrM102_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM102(x) SETUP_XfOrM92(x)
            o = NULLED_OUT ; 

# 660 "./../src/error.c"
            o = (Scheme_Object * ) ptrs [pp ++ ] ; 
            t = FUNCCALL(SETUP_XfOrM102(_), scheme_display_to_string (o , & dlen ) ); 
            tlen = dlen ; 
          }
          break ; 
          case 'W' : 
          {
            Scheme_Object * o ; 
            intptr_t dlen ; 
#           define XfOrM101_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM101(x) SETUP_XfOrM92(x)
            o = NULLED_OUT ; 

# 669 "./../src/error.c"
            o = (Scheme_Object * ) ptrs [pp ++ ] ; 
            t = FUNCCALL(SETUP_XfOrM101(_), scheme_write_to_string (o , & dlen ) ); 
            tlen = dlen ; 
          }
          break ; 
          case '_' : 
          {
            pp ++ ; 
            t = "" ; 
            tlen = 0 ; 
          }
          break ; 
          case 'T' : 
          case 'Q' : 
          {
            Scheme_Object * str ; 
            BLOCK_SETUP((PUSH(str, 0+XfOrM92_COUNT)));
#           define XfOrM99_COUNT (1+XfOrM92_COUNT)
#           define SETUP_XfOrM99(x) SETUP(XfOrM99_COUNT)
            str = NULLED_OUT ; 

# 685 "./../src/error.c"
            str = (Scheme_Object * ) ptrs [pp ++ ] ; 
            if ((Scheme_Type ) (((((intptr_t ) (str ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (str ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
              str = FUNCCALL(SETUP_XfOrM99(_), scheme_char_string_to_byte_string (str ) ); 
            t = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) ; 
            tlen = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . tag_val ) ; 
          }
          break ; 
          case 'u' : 
          case '5' : 
          {
            mzchar * u ; 
            intptr_t ltlen ; 
            BLOCK_SETUP((PUSH(u, 0+XfOrM92_COUNT)));
#           define XfOrM96_COUNT (1+XfOrM92_COUNT)
#           define SETUP_XfOrM96(x) SETUP(XfOrM96_COUNT)
            u = NULLED_OUT ; 

# 697 "./../src/error.c"
            u = (mzchar * ) ptrs [pp ++ ] ; 
            if (type == 'u' ) {
#             define XfOrM98_COUNT (0+XfOrM96_COUNT)
#             define SETUP_XfOrM98(x) SETUP_XfOrM96(x)

# 699 "./../src/error.c"
              tlen = ints [ip ++ ] ; 
              if (tlen < 0 )
                tlen = FUNCCALL(SETUP_XfOrM98(_), scheme_char_strlen (u ) ); 
            }

# 702 "./../src/error.c"
            else {
#             define XfOrM97_COUNT (0+XfOrM96_COUNT)
#             define SETUP_XfOrM97(x) SETUP_XfOrM96(x)

# 703 "./../src/error.c"
              tlen = FUNCCALL(SETUP_XfOrM97(_), scheme_char_strlen (u ) ); 
            }
            t = FUNCCALL(SETUP_XfOrM96(_), scheme_utf8_encode_to_buffer_len (u , tlen , ((void * ) 0 ) , 0 , & ltlen ) ); 
            tlen = ltlen ; 
          }
          break ; 
          default : 
          {
            t = (char * ) ptrs [pp ++ ] ; 
            if (type == 't' ) {
              tlen = ints [ip ++ ] ; 
              if (tlen < 0 )
                tlen = strlen (t ) ; 
            }

# 716 "./../src/error.c"
            else {
              tlen = strlen (t ) ; 
            }
          }
          break ; 
        }

        if ((type == 'q' ) || (type == 'Q' ) ) {
          if (tlen > 256 ) {
            tlen = 250 ; 
            dots = 1 ; 
          }
        }


        while (tlen && i < maxlen ) {
          s [i ++ ] = * t ; 
          t = t XFORM_OK_PLUS 1 ; 
          tlen -- ; 
        }

        if (dots ) {

          if (i < maxlen - 3 ) {
            s [i ++ ] = '.' ; 
            s [i ++ ] = '.' ; 
            s [i ++ ] = '.' ; 
          }
        }
      }
    }

# 746 "./../src/error.c"
    else {
      s [i ++ ] = msg [j ++ ] ; 
    }
  }

  s [i ] = 0 ; 

  RET_VALUE_START (i ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 756 "./../src/error.c"
intptr_t scheme_sprintf (char * s , intptr_t maxlen , const char * msg , ... ) 
{
  /* No conversion */

# 758 "./../src/error.c"
  intptr_t len ; 
  GC_CAN_IGNORE va_list args ; 

  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  len = sch_vsprintf (s , maxlen , msg , args , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ; 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  return len ; 
}

int scheme_last_error_is_racket (int errid ) 
{
  /* No conversion */

# 770 "./../src/error.c"
  return ((rktio_get_last_error_kind (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) == RKTIO_ERROR_KIND_RACKET ) 
  && (rktio_get_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) == errid ) ) ; 
}






void scheme_init_unsafe_error (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(p, 1)));
# define XfOrM145_COUNT (2)
# define SETUP_XfOrM145(x) SETUP(XfOrM145_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 782 "./../src/error.c"
  p = FUNCCALL(SETUP_XfOrM145(_), scheme_make_noncm_prim (assert_unreachable , "unsafe-assert-unreachable" , 0 , 0 ) ); 

# 782 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM145(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("unsafe-assert-unreachable" , p , env ) )
# 782 "./../src/error.c"
  ; 

# 782 "./../src/error.c"
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 785 "./../src/error.c"
void scheme_init_error (Scheme_Startup_Env * env ) 
{
  Scheme_Object * p ; 
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(env, 0), PUSH(p, 1)));
# define XfOrM146_COUNT (2)
# define SETUP_XfOrM146(x) SETUP(XfOrM146_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 

# 789 "./../src/error.c"
  if (! scheme_console_printf )
    scheme_console_printf = default_printf ; 
  if (! scheme_console_output )
    scheme_console_output = default_output ; 
  FUNCCALL(SETUP_XfOrM146(_), scheme_register_static ((void * ) & scheme_raise_arity_error_proc , sizeof (scheme_raise_arity_error_proc ) ) )
  ; 


  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (error , "error" , 1 , - 1 ) ); 

# 797 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM146(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("error" , p , env ) )
# 797 "./../src/error.c"
  ; 

# 797 "./../src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_user_error , "raise-user-error" , 1 , - 1 ) ); 

# 798 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM146(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-user-error" , p , env ) )
# 798 "./../src/error.c"
  ; 

# 798 "./../src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_type_error , "raise-type-error" , 3 , - 1 ) ); 

# 799 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM146(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-type-error" , p , env ) )
# 799 "./../src/error.c"
  ; 

# 799 "./../src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_argument_error , "raise-argument-error" , 3 , - 1 ) ); 

# 800 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM146(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-argument-error" , p , env ) )
# 800 "./../src/error.c"
  ; 

# 800 "./../src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_result_error , "raise-result-error" , 3 , - 1 ) ); 

# 801 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM146(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-result-error" , p , env ) )
# 801 "./../src/error.c"
  ; 

# 801 "./../src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_arguments_error , "raise-arguments-error" , 2 , - 1 ) ); 

# 802 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM146(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-arguments-error" , p , env ) )
# 802 "./../src/error.c"
  ; 

# 802 "./../src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_mismatch_error , "raise-mismatch-error" , 3 , - 1 ) ); 

# 803 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM146(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-mismatch-error" , p , env ) )
# 803 "./../src/error.c"
  ; 

# 803 "./../src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_range_error , "raise-range-error" , 7 , 8 ) ); 

# 804 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM146(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-range-error" , p , env ) )
# 804 "./../src/error.c"
  ; 

# 804 "./../src/error.c"
  ; 

  scheme_raise_arity_error_proc = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_arity_error , "raise-arity-error" , 2 , - 1 ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("raise-arity-error" , scheme_raise_arity_error_proc , env ) ); 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_arity_mask_error , "raise-arity-mask-error" , 2 , - 1 ) ); 

# 808 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM146(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-arity-mask-error" , p , env ) )
# 808 "./../src/error.c"
  ; 

# 808 "./../src/error.c"
  ; 
  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (raise_result_arity_error , "raise-result-arity-error" , 3 , - 1 ) ); 

# 809 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM146(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("raise-result-arity-error" , p , env ) )
# 809 "./../src/error.c"
  ; 

# 809 "./../src/error.c"
  ; 
  (__funcarg88 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_display_handler , "error-display-handler" , MZCONFIG_ERROR_DISPLAY_HANDLER ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-display-handler" , __funcarg88 , env ) )) ; 
  (__funcarg87 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_value_string_handler , "error-value->string-handler" , MZCONFIG_ERROR_PRINT_VALUE_HANDLER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-value->string-handler" , __funcarg87 , env ) )) ; 
  (__funcarg86 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_syntax_string_handler , "error-syntax->string-handler" , MZCONFIG_ERROR_PRINT_SYNTAX_HANDLER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-syntax->string-handler" , __funcarg86 , env ) )) ; 
  (__funcarg85 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_escape_handler , "error-escape-handler" , MZCONFIG_ERROR_ESCAPE_HANDLER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-escape-handler" , __funcarg85 , env ) )) ; 
  (__funcarg84 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (exit_handler , "exit-handler" , MZCONFIG_EXIT_HANDLER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("exit-handler" , __funcarg84 , env ) )) ; 
  (__funcarg83 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (exe_yield_handler , "executable-yield-handler" , MZCONFIG_EXE_YIELD_HANDLER ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("executable-yield-handler" , __funcarg83 , env ) )) ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_print_width , "error-print-width" , MZCONFIG_ERROR_PRINT_WIDTH ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-print-width" , __funcarg82 , env ) )) ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_print_context_length , "error-print-context-length" , MZCONFIG_ERROR_PRINT_CONTEXT_LENGTH ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-print-context-length" , __funcarg81 , env ) )) ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (error_print_srcloc , "error-print-source-location" , MZCONFIG_ERROR_PRINT_SRCLOC ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("error-print-source-location" , __funcarg80 , env ) )) ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (scheme_do_exit , "exit" , 0 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("exit" , __funcarg79 , env ) )) ; 

  p = FUNCCALL_AGAIN(scheme_make_noncm_prim (assert_unreachable , "assert-unreachable" , 0 , 0 ) ); 

# 823 "./../src/error.c"
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM146(_), scheme_intern_prim_opt_flags ((1 << 16 ) ) ); 
  FUNCCALL(SETUP_XfOrM146(_), scheme_addto_prim_instance ("assert-unreachable" , p , env ) )
# 823 "./../src/error.c"
  ; 

# 823 "./../src/error.c"
  ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (log_level_p , "log-level?" , 2 , 3 ) )

  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-level?" , __funcarg78 , env ) )) ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (log_max_level , "log-max-level" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-max-level" , __funcarg77 , env ) )) ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (log_all_levels , "log-all-levels" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-all-levels" , __funcarg76 , env ) )) ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (log_level_evt , "log-level-evt" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-level-evt" , __funcarg75 , env ) )) ; 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (make_logger , "make-logger" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-logger" , __funcarg74 , env ) )) ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (make_log_reader , "make-log-receiver" , 2 , - 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-log-receiver" , __funcarg73 , env ) )) ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_prim_w_arity (log_message , "log-message" , 3 , 6 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-message" , __funcarg72 , env ) )) ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_folding_prim (logger_p , "logger?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("logger?" , __funcarg71 , env ) )) ; 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_folding_prim (logger_name , "logger-name" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("logger-name" , __funcarg70 , env ) )) ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_folding_prim (log_reader_p , "log-receiver?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("log-receiver?" , __funcarg69 , env ) )) ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM146(_), scheme_register_parameter (current_logger , "current-logger" , MZCONFIG_LOGGER ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-logger" , __funcarg68 , env ) )) ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (srcloc_to_string , "srcloc->string" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("srcloc->string" , __funcarg67 , env ) )) ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_noncm_prim (unquoted_printing_string , "unquoted-printing-string" , 1 , 1 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unquoted-printing-string" , __funcarg66 , env ) )) ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_folding_prim (unquoted_printing_string_p , "unquoted-printing-string?" , 1 , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unquoted-printing-string?" , __funcarg65 , env ) )) ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM146(_), scheme_make_immed_prim (unquoted_printing_string_value , "unquoted-printing-string-value" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unquoted-printing-string-value" , __funcarg64 , env ) )) ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_def_exit_proc , sizeof (scheme_def_exit_proc ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & default_display_handler , sizeof (default_display_handler ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & emergency_display_handler , sizeof (emergency_display_handler ) ) ); 

  scheme_def_exit_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (def_exit_handler_proc , "default-exit-handler" , 1 , 1 ) ); 
  default_display_handler = FUNCCALL_AGAIN(scheme_make_prim_w_arity (def_error_display_proc , "default-error-display-handler" , 2 , 2 ) ); 
  emergency_display_handler = FUNCCALL_AGAIN(scheme_make_prim_w_arity (emergency_error_display_proc , "emergency-error-display-handler" , 2 , 2 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & def_err_val_proc , sizeof (def_err_val_proc ) ) )
  ; 
  def_err_val_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (def_error_value_string_proc , "default-error-value->string-handler" , 2 , 2 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & def_err_stx_proc , sizeof (def_err_stx_proc ) ) )
  ; 
  def_err_stx_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (def_error_syntax_string_proc , "default-error-syntax->string-handler" , 2 , 2 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & none_symbol , sizeof (none_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & fatal_symbol , sizeof (fatal_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & error_symbol , sizeof (error_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & warning_symbol , sizeof (warning_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & info_symbol , sizeof (info_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & debug_symbol , sizeof (debug_symbol ) ) ); 
  none_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("none" ) ); 
  fatal_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("fatal" ) ); 
  error_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("error" ) ); 
  warning_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("warning" ) ); 
  info_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("info" ) ); 
  debug_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("debug" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & posix_symbol , sizeof (posix_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & windows_symbol , sizeof (windows_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & gai_symbol , sizeof (gai_symbol ) ) ); 
  posix_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("posix" ) ); 
  windows_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("windows" ) ); 
  gai_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("gai" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & arity_property , sizeof (arity_property ) ) )
  ; 
  {
    Scheme_Object * guard ; 
    BLOCK_SETUP((PUSH(guard, 0+XfOrM146_COUNT)));
#   define XfOrM147_COUNT (1+XfOrM146_COUNT)
#   define SETUP_XfOrM147(x) SETUP(XfOrM147_COUNT)
    guard = NULLED_OUT ; 

# 883 "./../src/error.c"
    guard = FUNCCALL(SETUP_XfOrM147(_), scheme_make_prim_w_arity (check_arity_property_value_ok , "guard-for-prop:arity-string" , 2 , 2 ) ); 
    arity_property = (__funcarg63 = FUNCCALL(SETUP_XfOrM147(_), scheme_intern_symbol ("arity-string" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg63 , guard ) )) ; 
  }
  FUNCCALL_EMPTY(scheme_addto_prim_instance ("prop:arity-string" , arity_property , env ) )
  ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & def_exe_yield_proc , sizeof (def_exe_yield_proc ) ) )
  ; 
  def_exe_yield_proc = FUNCCALL_EMPTY(scheme_make_prim_w_arity (default_yield_handler , "default-executable-yield-handler" , 1 , 1 ) )

  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 895 "./../src/error.c"
void scheme_init_logger_wait () 
{
  /* No conversion */

# 897 "./../src/error.c"
  scheme_add_evt (scheme_log_reader_type , (Scheme_Ready_Fun ) log_reader_get , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

void scheme_init_logger () 
{
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  Scheme_Object * __funcarg90 = NULLED_OUT ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(0);
# define XfOrM149_COUNT (0)
# define SETUP_XfOrM149(x) SETUP(XfOrM149_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) ) ) )
# 902 "./../src/error.c"
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) = FUNCCALL_EMPTY(scheme_make_logger (((void * ) 0 ) , ((void * ) 0 ) ) ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) -> syslog_level = init_syslog_level ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) -> stderr_level = init_stderr_level ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) -> stdout_level = init_stdout_level ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_gc_logger_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_gc_logger_ ) ) ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_gc_logger_ ) = (__funcarg91 = FUNCCALL_EMPTY(scheme_intern_symbol ("GC" ) ), FUNCCALL_EMPTY(scheme_make_logger (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , __funcarg91 ) )) ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_future_logger_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_future_logger_ ) ) ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_future_logger_ ) = (__funcarg90 = FUNCCALL_EMPTY(scheme_intern_symbol ("future" ) ), FUNCCALL_EMPTY(scheme_make_logger (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , __funcarg90 ) )) ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_logger_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_logger_ ) ) ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_logger_ ) = (__funcarg89 = FUNCCALL_EMPTY(scheme_intern_symbol ("place" ) ), FUNCCALL_EMPTY(scheme_make_logger (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , __funcarg89 ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 918 "./../src/error.c"
Scheme_Logger * scheme_get_main_logger () {
  /* No conversion */

# 919 "./../src/error.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) ; 
}

Scheme_Logger * scheme_get_gc_logger () {
  /* No conversion */

# 923 "./../src/error.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_gc_logger_ ) ; 
}

Scheme_Logger * scheme_get_future_logger () {
  /* No conversion */

# 927 "./../src/error.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_future_logger_ ) ; 
}

Scheme_Logger * scheme_get_place_logger () {
  /* No conversion */

# 931 "./../src/error.c"
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_place_logger_ ) ; 
}

void scheme_init_error_config (void ) 
{
  /* No conversion */

# 936 "./../src/error.c"
  scheme_set_root_param (MZCONFIG_EXIT_HANDLER , scheme_def_exit_proc ) ; 
  scheme_set_root_param (MZCONFIG_ERROR_DISPLAY_HANDLER , default_display_handler ) ; 
  scheme_set_root_param (MZCONFIG_ERROR_PRINT_VALUE_HANDLER , def_err_val_proc ) ; 
  scheme_set_root_param (MZCONFIG_ERROR_PRINT_SYNTAX_HANDLER , def_err_val_proc ) ; 
  scheme_set_root_param (MZCONFIG_EXE_YIELD_HANDLER , def_exe_yield_proc ) ; 
}

void scheme_init_logger_config () {
  /* No conversion */

# 944 "./../src/error.c"
  scheme_set_root_param (MZCONFIG_LOGGER , (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) ) ; 
}

static void 
call_error (char * buffer , int len , Scheme_Object * exn ) 
{
  char * __funcarg95 = NULLED_OUT ; 
  Scheme_Logger * __funcarg94 = NULLED_OUT ; 
  Scheme_Object * __funcarg93 = NULLED_OUT ; 
  Scheme_Object * __funcarg92 = NULLED_OUT ; 
  PREPARE_VAR_STACK(13);
  BLOCK_SETUP_TOP((PUSH(__funcarg94, 0), PUSH(buffer, 1), PUSH(exn, 2)));
# define XfOrM156_COUNT (3)
# define SETUP_XfOrM156(x) SETUP(XfOrM156_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 950 "./../src/error.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding ) {
#   define XfOrM162_COUNT (0+XfOrM156_COUNT)
#   define SETUP_XfOrM162(x) SETUP_XfOrM156(x)

# 951 "./../src/error.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding != (Optimize_Info * ) scheme_false )
      (__funcarg94 = FUNCCALL(SETUP_XfOrM162(_), scheme_optimize_info_logger (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding ) ), __funcarg95 = FUNCCALL(SETUP_XfOrM162(_), scheme_optimize_info_context (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> constant_folding ) )



    , FUNCCALL_AGAIN(scheme_log (__funcarg94 , 3 , 0 , "constant-fold attempt failed%s: %s" , __funcarg95 , buffer ) )) 
    ; 
    if (((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && (scheme_is_struct_instance (exn_table [MZEXN_BREAK ] . type , exn ) ) ) {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed = exn ; 
    }
    (((intptr_t * ) (void * ) ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs ) ) [1 ] = (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs , longjmp ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . jb , 1 ) ) ; 
  }

# 964 "./../src/error.c"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed = exn ; 
    (((intptr_t * ) (void * ) ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs ) ) [1 ] = (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs , longjmp ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . jb , 1 ) ) ; 
  }

# 967 "./../src/error.c"
  else {
    mz_jmp_buf savebuf ; 
    Scheme_Object * p [2 ] , * display_handler , * escape_handler , * v ; 
    Scheme_Config * config , * orig_config ; 
    Scheme_Cont_Frame_Data cframe , cframe2 ; 
    BLOCK_SETUP((PUSHARRAY(p, 2, 0+XfOrM156_COUNT), PUSH(display_handler, 3+XfOrM156_COUNT), PUSH(cframe.cache, 4+XfOrM156_COUNT), PUSH(escape_handler, 5+XfOrM156_COUNT), PUSH(config, 6+XfOrM156_COUNT), PUSH(v, 7+XfOrM156_COUNT), PUSH(cframe2.cache, 8+XfOrM156_COUNT), PUSH(orig_config, 9+XfOrM156_COUNT)));
#   define XfOrM157_COUNT (10+XfOrM156_COUNT)
#   define SETUP_XfOrM157(x) SETUP(XfOrM157_COUNT)
    p[0] = NULLED_OUT ; 
    p[1] = NULLED_OUT ; 
    display_handler = NULLED_OUT ; 
    escape_handler = NULLED_OUT ; 
    v = NULLED_OUT ; 
    config = NULLED_OUT ; 
    orig_config = NULLED_OUT ; 
    cframe.cache = NULLED_OUT ; 
    cframe2.cache = NULLED_OUT ; 
    (
# 974 "./../src/error.c"
    memcpy ((void * ) & savebuf , & * (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) , sizeof (mz_jmp_buf ) ) ) ; 

    orig_config = FUNCCALL(SETUP_XfOrM157(_), scheme_current_config () ); 
    display_handler = FUNCCALL_AGAIN(scheme_get_param (orig_config , MZCONFIG_ERROR_DISPLAY_HANDLER ) ); 
    escape_handler = FUNCCALL_AGAIN(scheme_get_param (orig_config , MZCONFIG_ERROR_ESCAPE_HANDLER ) ); 

    v = FUNCCALL_AGAIN(scheme_make_byte_string_without_copying ("error display handler" ) ); 
    v = (__funcarg93 = FUNCCALL(SETUP_XfOrM157(_), scheme_make_pair (v , exn ) )
    , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity ((Scheme_Closed_Prim * ) nested_exn_handler , __funcarg93 , "nested-exception-handler" , 1 , 1 ) )) 

    ; 

    config = orig_config ; 
    if ((display_handler ) == (default_display_handler ) ) 
      config = FUNCCALL(SETUP_XfOrM157(_), scheme_extend_config (config , MZCONFIG_ERROR_DISPLAY_HANDLER , emergency_display_handler ) )

    ; 
    else 
    config = FUNCCALL(SETUP_XfOrM157(_), scheme_extend_config (config , MZCONFIG_ERROR_DISPLAY_HANDLER , default_display_handler ) )

    ; 
    FUNCCALL(SETUP_XfOrM157(_), scheme_push_continuation_frame (& cframe ) )
    ; 
    FUNCCALL_AGAIN(scheme_install_config (config ) ); 
    FUNCCALL_AGAIN(scheme_set_cont_mark (scheme_exn_handler_key , v ) ); 
    FUNCCALL_AGAIN(scheme_push_break_enable (& cframe2 , 0 , 0 ) ); 

    if (((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && ((scheme_is_struct_instance (exn_table [MZEXN_BREAK_HANG_UP ] . type , exn ) ) ) ) {
    }
    else {
#     define XfOrM159_COUNT (0+XfOrM157_COUNT)
#     define SETUP_XfOrM159(x) SETUP_XfOrM157(x)

# 1005 "./../src/error.c"
      p [0 ] = FUNCCALL(SETUP_XfOrM159(_), scheme_make_immutable_sized_utf8_string (buffer , len ) ); 
      p [1 ] = exn ; 
      FUNCCALL(SETUP_XfOrM159(_), scheme_apply_multi (display_handler , 2 , p ) ); 
    }

    if (((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (exn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (exn ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) exn ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && ((scheme_is_struct_instance (exn_table [MZEXN_BREAK_HANG_UP ] . type , exn ) ) 
    || (scheme_is_struct_instance (exn_table [MZEXN_BREAK_TERMINATE ] . type , exn ) ) ) ) {
#     define XfOrM158_COUNT (0+XfOrM157_COUNT)
#     define SETUP_XfOrM158(x) SETUP_XfOrM157(x)
      p [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
      FUNCCALL(SETUP_XfOrM158(_), scheme_do_exit (1 , p ) ); 
    }


    v = FUNCCALL(SETUP_XfOrM157(_), scheme_make_byte_string_without_copying ("error escape handler" ) ); 
    v = (__funcarg92 = FUNCCALL(SETUP_XfOrM157(_), scheme_make_pair (v , exn ) )
    , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity ((Scheme_Closed_Prim * ) nested_exn_handler , __funcarg92 , "nested-exception-handler" , 1 , 1 ) )) 

    ; 

    config = FUNCCALL_AGAIN(scheme_extend_config (config , MZCONFIG_ERROR_DISPLAY_HANDLER , default_display_handler ) )

    ; 
    config = FUNCCALL_AGAIN(scheme_extend_config (config , MZCONFIG_ERROR_ESCAPE_HANDLER , def_error_esc_proc ) )

    ; 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe2 , 0 ) )
    ; 
    FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) ); 
    FUNCCALL_AGAIN(scheme_push_continuation_frame (& cframe ) )
    ; 
    FUNCCALL_AGAIN(scheme_set_cont_mark (scheme_exn_handler_key , v ) ); 
    FUNCCALL_AGAIN(scheme_install_config (config ) ); 
    FUNCCALL_AGAIN(scheme_push_break_enable (& cframe2 , 0 , 0 ) ); 
    FUNCCALL_AGAIN(scheme_apply_multi (escape_handler , 0 , ((void * ) 0 ) ) )

    ; 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe2 , 0 ) )
    ; 
    FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) ); 
    FUNCCALL_AGAIN(def_error_escape_proc (0 , ((void * ) 0 ) ) )

    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1052 "./../src/error.c"
intptr_t scheme_get_print_width (void ) 
{
  intptr_t print_width ; 
  Scheme_Object * w ; 
  Scheme_Config * __funcarg96 = NULLED_OUT ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(w, 0)));
# define XfOrM164_COUNT (1)
# define SETUP_XfOrM164(x) SETUP(XfOrM164_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  w = NULLED_OUT ; 

# 1057 "./../src/error.c"
  w = (__funcarg96 = FUNCCALL(SETUP_XfOrM164(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg96 , MZCONFIG_ERROR_PRINT_WIDTH ) )) ; 
  if (((intptr_t ) (w ) ) & 0x1 ) 
    print_width = (((intptr_t ) (w ) ) >> 1 ) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (w ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (w ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
    print_width = 0x7FFFFFFF ; 
  else 
  print_width = 10000 ; 

  RET_VALUE_START (print_width ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1068 "./../src/error.c"
static char * init_buf (intptr_t * len , intptr_t * _size ) 
{
  uintptr_t local_max_symbol_length ; 
  intptr_t print_width ; 
  intptr_t size ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(len, 0), PUSH(_size, 1)));
# define XfOrM165_COUNT (2)
# define SETUP_XfOrM165(x) SETUP(XfOrM165_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1074 "./../src/error.c"
  local_max_symbol_length = FUNCCALL(SETUP_XfOrM165(_), scheme_get_max_symbol_length () ); 
  print_width = FUNCCALL(SETUP_XfOrM165(_), scheme_get_print_width () ); 

  size = (3 * local_max_symbol_length + 500 + 2 * print_width ) ; 


  if (len )
    * len = print_width ; 
  if (_size )
    * _size = size ; 

  RET_VALUE_START ((char * ) FUNCCALL_EMPTY(GC_malloc_atomic (size ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1088 "./../src/error.c"
void 
scheme_signal_error (const char * msg , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  char * buffer ; 
  intptr_t len ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(buffer, 0)));
# define XfOrM166_COUNT (1)
# define SETUP_XfOrM166(x) SETUP(XfOrM166_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buffer = NULLED_OUT ; 

# 1095 "./../src/error.c"
  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  len = FUNCCALL(SETUP_XfOrM166(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & buffer , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  buffer [len ] = 0 ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) ) {
#   define XfOrM167_COUNT (0+XfOrM166_COUNT)
#   define SETUP_XfOrM167(x) SETUP_XfOrM166(x)

# 1102 "./../src/error.c"
    buffer [len ++ ] = '\n' ; 
    buffer [len ] = 0 ; 
    FUNCCALL(SETUP_XfOrM167(_), scheme_console_output (buffer , len ) ); 
    FUNCCALL_AGAIN(exit (0 ) ); 
  }
  FUNCCALL(SETUP_XfOrM166(_), scheme_raise_exn (MZEXN_FAIL , "%t" , buffer , len ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1111 "./../src/error.c"
void scheme_warning (char * msg , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  char * buffer ; 
  intptr_t len ; 
  Scheme_Config * __funcarg98 = NULLED_OUT ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(buffer, 0)));
# define XfOrM168_COUNT (1)
# define SETUP_XfOrM168(x) SETUP(XfOrM168_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buffer = NULLED_OUT ; 

# 1117 "./../src/error.c"
  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  len = FUNCCALL(SETUP_XfOrM168(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & buffer , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  buffer [len ++ ] = '\n' ; 
  buffer [len ] = 0 ; 
  (__funcarg97 = (__funcarg98 = FUNCCALL(SETUP_XfOrM168(_), scheme_current_config () )

  , FUNCCALL_AGAIN(scheme_get_param (__funcarg98 , MZCONFIG_ERROR_PORT ) )) , FUNCCALL_AGAIN(scheme_write_byte_string (buffer , len , __funcarg97 ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1128 "./../src/error.c"
void scheme_ensure_console_ready () 
{
  /* No conversion */

# 1130 "./../src/error.c"
  rktio_create_console () ; 
}

void scheme_log (Scheme_Logger * logger , int level , int flags , 
const char * msg , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  char * buffer ; 
  intptr_t len ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(logger, 0), PUSH(buffer, 1)));
# define XfOrM170_COUNT (2)
# define SETUP_XfOrM170(x) SETUP(XfOrM170_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buffer = NULLED_OUT ; 

# 1140 "./../src/error.c"
  if (logger ) {
    if (logger -> local_timestamp == (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
      if (logger -> want_level < level )
      RET_NOTHING ; 
  }

  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  len = FUNCCALL(SETUP_XfOrM170(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & buffer , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  buffer [len ] = 0 ; 
  FUNCCALL(SETUP_XfOrM170(_), scheme_log_message (logger , level , buffer , len , ((void * ) 0 ) ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1155 "./../src/error.c"
void scheme_log_w_data (Scheme_Logger * logger , int level , int flags , 
Scheme_Object * data , 
const char * msg , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  char * buffer ; 
  intptr_t len ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(data, 0), PUSH(logger, 1), PUSH(buffer, 2)));
# define XfOrM172_COUNT (3)
# define SETUP_XfOrM172(x) SETUP(XfOrM172_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buffer = NULLED_OUT ; 

# 1163 "./../src/error.c"
  if (logger ) {
    if (logger -> local_timestamp == (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
      if (logger -> want_level < level )
      RET_NOTHING ; 
  }

  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  len = FUNCCALL(SETUP_XfOrM172(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & buffer , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  buffer [len ] = 0 ; 
  FUNCCALL(SETUP_XfOrM172(_), scheme_log_message (logger , level , buffer , len , data ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1178 "./../src/error.c"
static char * error_write_to_string_w_max (Scheme_Object * v , int len , intptr_t * lenout ) 
{
  Scheme_Object * o , * args [2 ] ; 
  Scheme_Config * __funcarg101 = NULLED_OUT ; 
  Scheme_Config * __funcarg100 = NULLED_OUT ; 
  Scheme_Config * __funcarg99 = NULLED_OUT ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSHARRAY(args, 2, 1), PUSH(lenout, 4), PUSH(o, 5)));
# define XfOrM174_COUNT (6)
# define SETUP_XfOrM174(x) SETUP(XfOrM174_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 
  args[0] = NULLED_OUT ; 
  args[1] = NULLED_OUT ; 

# 1182 "./../src/error.c"
  o = (__funcarg101 = FUNCCALL(SETUP_XfOrM174(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg101 , MZCONFIG_ERROR_PRINT_VALUE_HANDLER ) )) ; 

  if (((o ) == (def_err_val_proc ) ) 
  && (((__funcarg100 = FUNCCALL(SETUP_XfOrM174(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg100 , MZCONFIG_PORT_PRINT_HANDLER ) )) ) == (scheme_default_global_print_handler ) ) )  
  {
    intptr_t l ; 
    char * s ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM174_COUNT)));
#   define XfOrM180_COUNT (1+XfOrM174_COUNT)
#   define SETUP_XfOrM180(x) SETUP(XfOrM180_COUNT)
    s = NULLED_OUT ; 

# 1189 "./../src/error.c"
    s = FUNCCALL(SETUP_XfOrM180(_), scheme_print_to_string_w_max (v , & l , len ) ); 
    if (lenout )
      * lenout = l ; 
    RET_VALUE_START (s ) RET_VALUE_END ; 
  }

# 1193 "./../src/error.c"
  else {
    Scheme_Config * config ; 
    Scheme_Cont_Frame_Data cframe , cframe2 ; 
    BLOCK_SETUP((PUSH(cframe.cache, 0+XfOrM174_COUNT), PUSH(cframe2.cache, 1+XfOrM174_COUNT), PUSH(config, 2+XfOrM174_COUNT)));
#   define XfOrM175_COUNT (3+XfOrM174_COUNT)
#   define SETUP_XfOrM175(x) SETUP(XfOrM175_COUNT)
    config = NULLED_OUT ; 
    cframe.cache = NULLED_OUT ; 
    cframe2.cache = NULLED_OUT ; 

# 1197 "./../src/error.c"
    args [0 ] = v ; 
    args [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (len ) ) ) << 1 ) | 0x1 ) ) ; 

    config = (__funcarg99 = FUNCCALL(SETUP_XfOrM175(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_extend_config (__funcarg99 , MZCONFIG_ERROR_PRINT_VALUE_HANDLER , def_err_val_proc ) )) 

    ; 
    config = FUNCCALL_AGAIN(scheme_extend_config (config , MZCONFIG_PRINT_UNREADABLE , scheme_true ) )

    ; 
    FUNCCALL_AGAIN(scheme_push_continuation_frame (& cframe ) )
    ; 
    FUNCCALL_AGAIN(scheme_install_config (config ) ); 
    FUNCCALL_AGAIN(scheme_push_break_enable (& cframe2 , 0 , 0 ) ); 

    o = FUNCCALL_AGAIN(scheme_do_eval (o , 2 , args , 1 ) ); 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe2 , 0 ) )
    ; 
    FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) ); 

    if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#     define XfOrM179_COUNT (0+XfOrM175_COUNT)
#     define SETUP_XfOrM179(x) SETUP_XfOrM175(x)

# 1217 "./../src/error.c"
      o = FUNCCALL(SETUP_XfOrM179(_), scheme_char_string_to_byte_string (o ) ); 
    }

    if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  {
      char * s = (((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . string_val ) ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM175_COUNT)));
#     define XfOrM177_COUNT (1+XfOrM175_COUNT)
#     define SETUP_XfOrM177(x) SETUP(XfOrM177_COUNT)

# 1222 "./../src/error.c"
      if ((((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . tag_val ) > len ) {
        char * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM177_COUNT)));
#       define XfOrM178_COUNT (1+XfOrM177_COUNT)
#       define SETUP_XfOrM178(x) SETUP(XfOrM178_COUNT)
        naya = NULLED_OUT ; 

# 1224 "./../src/error.c"
        naya = FUNCCALL(SETUP_XfOrM178(_), GC_malloc_atomic (len + 1 ) ); 
        (memcpy (naya , s , len ) ) ; 
        s [len ] = 0 ; 
        if (lenout )
          * lenout = len ; 
      }

# 1229 "./../src/error.c"
      else if (lenout )
        * lenout = (((Scheme_Simple_Object * ) (o ) ) -> u . byte_str_val . tag_val ) ; 
      RET_VALUE_START (s ) RET_VALUE_END ; 
    }

# 1232 "./../src/error.c"
    else {
      if (lenout )
        * lenout = 3 ; 
      RET_VALUE_START ("..." ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1240 "./../src/error.c"
static Scheme_Object * check_arity_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM181_COUNT (1)
# define SETUP_XfOrM181(x) SETUP(XfOrM181_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1242 "./../src/error.c"
  if (! FUNCCALL(SETUP_XfOrM181(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , 1 , argv ) ))
    FUNCCALL(SETUP_XfOrM181(_), scheme_arg_mismatch ("guard-for-prop:arity-string" , "property value is not a procedure (arity 1): " , argv [0 ] ) )

  ; 
  RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1249 "./../src/error.c"
static char * make_arity_expect_string (const char * name , int namelen , 
int minc , int maxc , 
int argc , Scheme_Object * * argv , 
intptr_t * _len , int is_method , 
const char * map_name ) 


{
  intptr_t len , pos , slen ; 
  int xargc , xminc , xmaxc ; 
  char * s , * arity_str = ((void * ) 0 ) ; 
  const char * prefix_msg1 , * prefix_msg2 , * suffix_msg ; 
  int arity_len = 0 ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(14);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(suffix_msg, 1), PUSH(map_name, 2), PUSH(s, 3), PUSH(argv, 4), PUSH(arity_str, 5), PUSH(prefix_msg2, 6), PUSH(prefix_msg1, 7), PUSH(_len, 8)));
# define XfOrM182_COUNT (9)
# define SETUP_XfOrM182(x) SETUP(XfOrM182_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 
  prefix_msg1 = NULLED_OUT ; 
  prefix_msg2 = NULLED_OUT ; 
  suffix_msg = NULLED_OUT ; 

# 1263 "./../src/error.c"
  s = FUNCCALL(SETUP_XfOrM182(_), init_buf (& len , & slen ) ); 

  if (! name )
    name = "#<procedure>" ; 

  xargc = argc - (is_method ? 1 : 0 ) ; 
  xminc = minc - (is_method ? 1 : 0 ) ; 
  xmaxc = maxc - (is_method ? 1 : 0 ) ; 

  if ((minc == - 1 ) && (((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) name ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) || ((((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) name ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) (Scheme_Object * ) name ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) (Scheme_Object * ) name ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) {
    Scheme_Object * arity_maker ; 
    BLOCK_SETUP((PUSH(arity_maker, 0+XfOrM182_COUNT)));
#   define XfOrM197_COUNT (1+XfOrM182_COUNT)
#   define SETUP_XfOrM197(x) SETUP(XfOrM197_COUNT)
    arity_maker = NULLED_OUT ; 

# 1275 "./../src/error.c"
    while (1 ) {
#     define XfOrM208_COUNT (0+XfOrM197_COUNT)
#     define SETUP_XfOrM208(x) SETUP_XfOrM197(x)

# 1276 "./../src/error.c"
      arity_maker = (scheme_struct_type_property_ref (arity_property , (Scheme_Object * ) name ) ) ; 
      if (arity_maker ) {
        Scheme_Object * v , * a [1 ] ; 
        BLOCK_SETUP((PUSH(v, 0+XfOrM208_COUNT), PUSHARRAY(a, 1, 1+XfOrM208_COUNT)));
#       define XfOrM212_COUNT (4+XfOrM208_COUNT)
#       define SETUP_XfOrM212(x) SETUP(XfOrM212_COUNT)
        v = NULLED_OUT ; 
        a[0] = NULLED_OUT ; 

# 1279 "./../src/error.c"
        a [0 ] = (Scheme_Object * ) name ; 
        v = FUNCCALL(SETUP_XfOrM212(_), scheme_apply (arity_maker , 1 , a ) ); 
        if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#         define XfOrM213_COUNT (0+XfOrM212_COUNT)
#         define SETUP_XfOrM213(x) SETUP_XfOrM212(x)

# 1282 "./../src/error.c"
          v = FUNCCALL(SETUP_XfOrM213(_), scheme_char_string_to_byte_string (v ) ); 
          arity_str = (((Scheme_Simple_Object * ) (v ) ) -> u . byte_str_val . string_val ) ; 
          arity_len = (((Scheme_Simple_Object * ) (v ) ) -> u . byte_str_val . tag_val ) ; 
          if (arity_len > len )
            arity_len = len ; 
          name = FUNCCALL(SETUP_XfOrM213(_), scheme_get_proc_name ((Scheme_Object * ) name , & namelen , 1 ) ); 
          if (! name ) {
            name = "#<procedure>" ; 
            namelen = strlen (name ) ; 
          }
          break ; 
        }

# 1293 "./../src/error.c"
        else 
        break ; 
      }

# 1295 "./../src/error.c"
      else {
        Scheme_Object * v ; 
        int is_method ; 
        BLOCK_SETUP((PUSH(v, 0+XfOrM208_COUNT)));
#       define XfOrM211_COUNT (1+XfOrM208_COUNT)
#       define SETUP_XfOrM211(x) SETUP(XfOrM211_COUNT)
        v = NULLED_OUT ; 

# 1298 "./../src/error.c"
        v = (Scheme_Object * ) name ; 
        if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
          v = (((Scheme_Chaperone * ) v ) -> val ) ; 
        if (scheme_is_struct_instance (scheme_reduced_procedure_struct , v ) ) 
          v = ((void * ) 0 ) ; 
        else 
        v = FUNCCALL(SETUP_XfOrM211(_), scheme_extract_struct_procedure (v , - 1 , ((void * ) 0 ) , & is_method ) ); 
        if (! v || is_method || ! (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) )
          break ; 
        name = (const char * ) v ; 
      }
      {
#       define XfOrM209_COUNT (0+XfOrM208_COUNT)
#       define SETUP_XfOrM209(x) SETUP_XfOrM208(x)

# 1309 "./../src/error.c"
        if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#         define XfOrM210_COUNT (0+XfOrM209_COUNT)
#         define SETUP_XfOrM210(x) SETUP_XfOrM209(x)
          FUNCCALL(SETUP_XfOrM210(_), scheme_out_of_fuel () )
# 1309 "./../src/error.c"
          ; 
        }
      }

# 1309 "./../src/error.c"
      ; 
    }

    if (! arity_str ) {



      Scheme_Object * arity ; 
      BLOCK_SETUP((PUSH(arity, 0+XfOrM197_COUNT)));
#     define XfOrM198_COUNT (1+XfOrM197_COUNT)
#     define SETUP_XfOrM198(x) SETUP(XfOrM198_COUNT)
      arity = NULLED_OUT ; 

# 1317 "./../src/error.c"
      arity = FUNCCALL(SETUP_XfOrM198(_), scheme_arity ((Scheme_Object * ) name ) ); 
      if (((intptr_t ) (arity ) ) & 0x1 )  {
#       define XfOrM199_COUNT (0+XfOrM198_COUNT)
#       define SETUP_XfOrM199(x) SETUP_XfOrM198(x)

# 1319 "./../src/error.c"
        minc = maxc = (((intptr_t ) (arity ) ) >> 1 ) ; 
        xmaxc = xminc = minc - (is_method ? 1 : 0 ) ; 
        name = FUNCCALL(SETUP_XfOrM199(_), scheme_get_proc_name ((Scheme_Object * ) name , & namelen , 1 ) ); 
        if (! name ) {
          name = "#<procedure>" ; 
          namelen = strlen (name ) ; 
        }
      }
    }
  }

  if (map_name ) {
    prefix_msg1 = map_name ; 
    prefix_msg2 = (": argument mismatch;\n" 
    " the given procedure's expected number of arguments does not match\n" 
    " the given number of lists\n" 
    "  given procedure: " ) ; 
    suffix_msg = "" ; 
  }

# 1337 "./../src/error.c"
  else {
    prefix_msg1 = "" ; 
    prefix_msg2 = "" ; 
    suffix_msg = (": arity mismatch;\n" 
    " the expected number of arguments does not match the given number" ) ; 
  }

  if (arity_str ) {
#   define XfOrM194_COUNT (0+XfOrM182_COUNT)
#   define SETUP_XfOrM194(x) SETUP_XfOrM182(x)

# 1345 "./../src/error.c"
    pos = FUNCCALL(SETUP_XfOrM194(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  expected: %t\n" "  given: %d" , prefix_msg1 , prefix_msg2 , name , (intptr_t ) namelen , suffix_msg , arity_str , (intptr_t ) arity_len , xargc ) )






    ; 
  }

# 1353 "./../src/error.c"
  else if (minc < 0 ) {
    const char * n ; 
    int nlen ; 
    BLOCK_SETUP((PUSH(n, 0+XfOrM182_COUNT)));
#   define XfOrM191_COUNT (1+XfOrM182_COUNT)
#   define SETUP_XfOrM191(x) SETUP(XfOrM191_COUNT)
    n = NULLED_OUT ; 

# 1357 "./../src/error.c"
    if (minc == - 2 ) {
      n = name ; 
      nlen = (namelen < 0 ? strlen (n ) : namelen ) ; 
    }

# 1360 "./../src/error.c"
    else 
    n = FUNCCALL(SETUP_XfOrM191(_), scheme_get_proc_name ((Scheme_Object * ) name , & nlen , 1 ) ); 

    if (! n ) {
      n = "#<case-lambda-procedure>" ; 
      nlen = strlen (n ) ; 
    }

    pos = FUNCCALL(SETUP_XfOrM191(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  given: %d" , prefix_msg1 , prefix_msg2 , n , (intptr_t ) nlen , suffix_msg , xargc ) )





    ; 
  }

# 1375 "./../src/error.c"
  else if (! maxc )
    pos = FUNCCALL(SETUP_XfOrM182(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  expected: 0\n" "  given: %d" , prefix_msg1 , prefix_msg2 , name , (intptr_t ) namelen , suffix_msg , xargc ) )






  ; 
  else if (maxc < 0 )
    pos = FUNCCALL(SETUP_XfOrM182(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  expected: at least %d\n" "  given: %d" , prefix_msg1 , prefix_msg2 , name , (intptr_t ) namelen , suffix_msg , xminc , xargc ) )






  ; 
  else if (minc == maxc )
    pos = FUNCCALL(SETUP_XfOrM182(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  expected: %d\n" "  given: %d" , prefix_msg1 , prefix_msg2 , name , (intptr_t ) namelen , suffix_msg , xminc , xargc ) )






  ; 
  else 
  pos = FUNCCALL(SETUP_XfOrM182(_), scheme_sprintf (s , slen , "%s%s%t%s\n" "  expected: %d to %d\n" "  given: %d" , prefix_msg1 , prefix_msg2 , name , (intptr_t ) namelen , suffix_msg , xminc , xmaxc , xargc ) )






  ; 

  if (xargc && argv ) {
#   define XfOrM183_COUNT (0+XfOrM182_COUNT)
#   define SETUP_XfOrM183(x) SETUP_XfOrM182(x)

# 1413 "./../src/error.c"
    len -= (xargc * 4 ) ; 
    len /= xargc ; 
    if ((xargc < 50 ) && (len >= 3 ) ) {
      int i ; 
#     define XfOrM184_COUNT (0+XfOrM183_COUNT)
#     define SETUP_XfOrM184(x) SETUP_XfOrM183(x)

# 1418 "./../src/error.c"
      for (i = (is_method ? 1 : 0 ) ; i < argc ; i ++ ) {
        intptr_t l ; 
        char * o ; 
        BLOCK_SETUP((PUSH(o, 0+XfOrM184_COUNT)));
#       define XfOrM188_COUNT (1+XfOrM184_COUNT)
#       define SETUP_XfOrM188(x) SETUP(XfOrM188_COUNT)
        o = NULLED_OUT ; 

# 1421 "./../src/error.c"
        if (i == (is_method ? 1 : 0 ) ) {
#         define XfOrM190_COUNT (0+XfOrM188_COUNT)
#         define SETUP_XfOrM190(x) SETUP_XfOrM188(x)
          (
# 1422 "./../src/error.c"
          strcpy (s + pos , "\n  arguments...:\n   " ) ) ; 
          pos += 20 ; 
        }

# 1424 "./../src/error.c"
        else {
#         define XfOrM189_COUNT (0+XfOrM188_COUNT)
#         define SETUP_XfOrM189(x) SETUP_XfOrM188(x)
          (
# 1425 "./../src/error.c"
          strcpy (s + pos , "\n   " ) ) ; 
          pos += 4 ; 
        }

        o = FUNCCALL(SETUP_XfOrM188(_), error_write_to_string_w_max (argv [i ] , len , & l ) ); 
        (memcpy (s + pos , o , l ) ) ; 
        pos += l ; 
      }

      s [pos ] = 0 ; 
    }
  }

  * _len = pos ; 

  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1443 "./../src/error.c"
void scheme_wrong_count_m (const char * name , int minc , int maxc , 
int argc , Scheme_Object * * argv , int is_method ) 


{
  char * s ; 
  intptr_t len ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(s, 1), PUSH(argv, 2)));
# define XfOrM215_COUNT (3)
# define SETUP_XfOrM215(x) SETUP(XfOrM215_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 

# 1452 "./../src/error.c"
  if (argv == p -> tail_buffer ) {
#   define XfOrM222_COUNT (0+XfOrM215_COUNT)
#   define SETUP_XfOrM222(x) SETUP_XfOrM215(x)
    FUNCCALL(SETUP_XfOrM222(_), scheme_realloc_tail_buffer (p ) )
# 1454 "./../src/error.c"
    ; 
  }



  if (minc == - 1 ) {
#   define XfOrM216_COUNT (0+XfOrM215_COUNT)
#   define SETUP_XfOrM216(x) SETUP_XfOrM215(x)

# 1461 "./../src/error.c"
    if ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) name ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) )  {
      Scheme_Lambda * data ; 
      BLOCK_SETUP((PUSH(data, 0+XfOrM216_COUNT)));
#     define XfOrM220_COUNT (1+XfOrM216_COUNT)
#     define SETUP_XfOrM220(x) SETUP(XfOrM220_COUNT)
      data = NULLED_OUT ; 

# 1463 "./../src/error.c"
      data = ((Scheme_Closure * ) (Scheme_Object * ) name ) -> code ; 
      name = FUNCCALL(SETUP_XfOrM220(_), scheme_get_proc_name ((Scheme_Object * ) name , ((void * ) 0 ) , 1 ) ); 

      minc = data -> num_params ; 
      if ((& (data ) -> iso ) -> so . keyex & 1 ) {
        minc -= 1 ; 
        maxc = - 1 ; 
      }

# 1470 "./../src/error.c"
      else 
      maxc = minc ; 
    }

# 1472 "./../src/error.c"
    else if ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) name ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) )  {
      Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) name ; 
      if (cl -> count ) {
        Scheme_Lambda * data ; 
        data = NULLED_OUT ; 

# 1476 "./../src/error.c"
        data = (Scheme_Lambda * ) ((Scheme_Closure * ) cl -> array [0 ] ) -> code ; 
        if ((& (data ) -> iso ) -> so . keyex & 16 )
          is_method = 1 ; 
      }

# 1479 "./../src/error.c"
      else if (cl -> name && ((Scheme_Type ) (((((intptr_t ) (cl -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cl -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) {

        is_method = 1 ; 
      }
    }
  }

# 1514 "./../src/error.c"
  if (! argc || ! minc )
    is_method = 0 ; 

  if (maxc > 0x3FFFFFFE )
    maxc = - 1 ; 

  s = FUNCCALL(SETUP_XfOrM215(_), make_arity_expect_string (name , - 1 , minc , maxc , argc , argv , & len , is_method , ((void * ) 0 ) ) ); 
  FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "%t" , s , len ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1525 "./../src/error.c"
void scheme_wrong_count (const char * name , int minc , int maxc , int argc , 
Scheme_Object * * argv ) 
{
  /* No conversion */
  scheme_wrong_count_m (name , minc , maxc , argc , argv , 0 ) ; 
}

void scheme_case_lambda_wrong_count (const char * name , 
int argc , Scheme_Object * * argv , 
int is_method , 
int count , ... ) 
{
  char * s ; 
  intptr_t len ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM224_COUNT (1)
# define SETUP_XfOrM224(x) SETUP(XfOrM224_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 1541 "./../src/error.c"
  if (! argc )
    is_method = 0 ; 

  s = FUNCCALL(SETUP_XfOrM224(_), make_arity_expect_string (name , - 1 , - 2 , 0 , argc , argv , & len , is_method , ((void * ) 0 ) ) ); 
  FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "%t" , s , len ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1549 "./../src/error.c"
char * scheme_make_arity_expect_string (const char * map_name , 
Scheme_Object * proc , 
int argc , Scheme_Object * * argv , 
intptr_t * _slen ) 
{
  const char * name ; 
  int namelen = - 1 ; 
  int mina , maxa ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(name, 1), PUSH(map_name, 2), PUSH(_slen, 3), PUSH(argv, 4)));
# define XfOrM225_COUNT (5)
# define SETUP_XfOrM225(x) SETUP(XfOrM225_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name = NULLED_OUT ; 

# 1558 "./../src/error.c"
  if (((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    proc = (((Scheme_Chaperone * ) proc ) -> val ) ; 
  }

  if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) )  {
    name = ((Scheme_Primitive_Proc * ) proc ) -> name ; 
    mina = ((Scheme_Primitive_Proc * ) proc ) -> mina ; 
    if (mina < 0 ) {

      mina = - 2 ; 
      maxa = 0 ; 
    }

# 1569 "./../src/error.c"
    else {
      maxa = ((Scheme_Primitive_Proc * ) proc ) -> mu . maxa ; 
      if (maxa > 0x3FFFFFFE )
        maxa = - 1 ; 
    }
  }

# 1574 "./../src/error.c"
  else if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) )  {
    name = ((Scheme_Closed_Primitive_Proc * ) proc ) -> name ; 
    mina = ((Scheme_Closed_Primitive_Proc * ) proc ) -> mina ; 
    maxa = ((Scheme_Closed_Primitive_Proc * ) proc ) -> maxa ; 
  }

# 1578 "./../src/error.c"
  else if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) )  {
#   define XfOrM229_COUNT (0+XfOrM225_COUNT)
#   define SETUP_XfOrM229(x) SETUP_XfOrM225(x)

# 1579 "./../src/error.c"
    name = FUNCCALL(SETUP_XfOrM229(_), scheme_get_proc_name (proc , & namelen , 1 ) ); 
    mina = - 2 ; 
    maxa = 0 ; 
  }

# 1609 "./../src/error.c"
  else if ((((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) proc ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) proc ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) proc ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) proc ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) )  {
    name = (const char * ) proc ; 
    mina = - 1 ; 
    maxa = 0 ; 
  }

# 1613 "./../src/error.c"
  else {
    Scheme_Lambda * data ; 
#   define XfOrM226_COUNT (0+XfOrM225_COUNT)
#   define SETUP_XfOrM226(x) SETUP_XfOrM225(x)
    data = NULLED_OUT ; 

# 1616 "./../src/error.c"
    data = (Scheme_Lambda * ) ((Scheme_Closure * ) proc ) -> code ; 
    mina = maxa = data -> num_params ; 
    if ((& (data ) -> iso ) -> so . keyex & 1 ) {
      -- mina ; 
      maxa = - 1 ; 
    }
    name = FUNCCALL(SETUP_XfOrM226(_), scheme_get_proc_name (proc , & namelen , 1 ) ); 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_arity_expect_string (name , namelen , mina , maxa , argc , argv , _slen , 0 , map_name ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1628 "./../src/error.c"
char * scheme_make_args_string (const char * s , int which , int argc , Scheme_Object * * argv , intptr_t * _olen ) 
{
  char * other ; 
  intptr_t len ; 
  GC_CAN_IGNORE char * isres = "arguments" ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(_olen, 0), PUSH(s, 1), PUSH(other, 2), PUSH(argv, 3)));
# define XfOrM235_COUNT (4)
# define SETUP_XfOrM235(x) SETUP(XfOrM235_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  other = NULLED_OUT ; 

# 1634 "./../src/error.c"
  other = FUNCCALL(SETUP_XfOrM235(_), init_buf (& len , ((void * ) 0 ) ) ); 

  if (argc < 0 ) {
    isres = "results" ; 
    argc = - argc ; 
  }

  len /= (argc - (((which >= 0 ) && (argc > 1 ) ) ? 1 : 0 ) ) ; 
  if ((argc < 50 ) && (len >= 3 ) ) {
    int i , pos ; 
#   define XfOrM237_COUNT (0+XfOrM235_COUNT)
#   define SETUP_XfOrM237(x) SETUP_XfOrM235(x)
    (
# 1645 "./../src/error.c"
    sprintf (other , "; %s%s were:" , s , isres ) ) ; 
    pos = strlen (other ) ; 
    for (i = 0 ; i < argc ; i ++ ) {
#     define XfOrM240_COUNT (0+XfOrM237_COUNT)
#     define SETUP_XfOrM240(x) SETUP_XfOrM237(x)

# 1648 "./../src/error.c"
      if (i != which ) {
        intptr_t l ; 
        char * o ; 
        BLOCK_SETUP((PUSH(o, 0+XfOrM240_COUNT)));
#       define XfOrM241_COUNT (1+XfOrM240_COUNT)
#       define SETUP_XfOrM241(x) SETUP(XfOrM241_COUNT)
        o = NULLED_OUT ; 

# 1651 "./../src/error.c"
        o = FUNCCALL(SETUP_XfOrM241(_), error_write_to_string_w_max (argv [i ] , len , & l ) ); 
        (memcpy (other + pos , " " , 1 ) ) ; 
        (memcpy (other + pos + 1 , o , l ) ) ; 
        pos += l + 1 ; 
      }
    }
    other [pos ] = 0 ; 
    if (_olen )
      * _olen = pos ; 
  }

# 1660 "./../src/error.c"
  else {
#   define XfOrM236_COUNT (0+XfOrM235_COUNT)
#   define SETUP_XfOrM236(x) SETUP_XfOrM235(x)
    (
# 1661 "./../src/error.c"
    sprintf (other , "; given %d arguments total" , argc ) ) ; 
    if (_olen )
      * _olen = strlen (other ) ; 
  }

  RET_VALUE_START (other ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1669 "./../src/error.c"
char * scheme_make_arg_lines_string (const char * indent , int which , int argc , Scheme_Object * * argv , intptr_t * _olen ) 
{
  char * other ; 
  intptr_t len , plen ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(other, 0), PUSH(_olen, 1), PUSH(indent, 2), PUSH(argv, 3)));
# define XfOrM243_COUNT (4)
# define SETUP_XfOrM243(x) SETUP(XfOrM243_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  other = NULLED_OUT ; 

# 1674 "./../src/error.c"
  if (! argc || ((argc == 1 ) && (which == 0 ) ) ) {
    other = " [none]" ; 
    if (_olen )
      * _olen = strlen (other ) ; 
    RET_VALUE_START (other ) RET_VALUE_END ; 
  }

  other = FUNCCALL(SETUP_XfOrM243(_), init_buf (& len , ((void * ) 0 ) ) ); 

  plen = strlen (indent ) ; 

  len -= ((argc - 1 ) * (plen + 1 ) ) ; 
  len /= (argc - (((which >= 0 ) && (argc > 1 ) ) ? 1 : 0 ) ) ; 

  if (len >= 3 ) {
    int i , pos ; 
#   define XfOrM245_COUNT (0+XfOrM243_COUNT)
#   define SETUP_XfOrM245(x) SETUP_XfOrM243(x)

# 1691 "./../src/error.c"
    pos = 0 ; 
    for (i = 0 ; i < argc ; i ++ ) {
#     define XfOrM248_COUNT (0+XfOrM245_COUNT)
#     define SETUP_XfOrM248(x) SETUP_XfOrM245(x)

# 1693 "./../src/error.c"
      if (i != which ) {
        intptr_t l ; 
        char * o ; 
        BLOCK_SETUP((PUSH(o, 0+XfOrM248_COUNT)));
#       define XfOrM249_COUNT (1+XfOrM248_COUNT)
#       define SETUP_XfOrM249(x) SETUP(XfOrM249_COUNT)
        o = NULLED_OUT ; 
        (
# 1697 "./../src/error.c"
        memcpy (other + pos , "\n" , 1 ) ) ; 
        pos ++ ; 
        (memcpy (other + pos , indent , plen ) ) ; 
        pos += plen ; 

        o = FUNCCALL(SETUP_XfOrM249(_), error_write_to_string_w_max (argv [i ] , len , & l ) ); 
        (memcpy (other + pos , o , l ) ) ; 
        pos += l ; 
      }
    }
    other [pos ] = 0 ; 
    if (_olen )
      * _olen = pos ; 
  }

# 1710 "./../src/error.c"
  else {
#   define XfOrM244_COUNT (0+XfOrM243_COUNT)
#   define SETUP_XfOrM244(x) SETUP_XfOrM243(x)
    (
# 1711 "./../src/error.c"
    sprintf (other , "... [%d total] ..." , argc ) ) ; 
    if (_olen )
      * _olen = strlen (other ) ; 
  }

  RET_VALUE_START (other ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1719 "./../src/error.c"
const char * scheme_number_suffix (int which ) 
{
  /* No conversion */

# 1721 "./../src/error.c"
  static char * ending [] = {

# 1721 "./../src/error.c"
    "st" , "nd" , "rd" }

# 1721 "./../src/error.c"
  ; 

  if (! which )
    return "th" ; 
  -- which ; 

  which = which % 100 ; 

  return ((which < 10 || which >= 20 ) 
  && ((which % 10 ) < 3 ) ) ? ending [which % 10 ] : "th" ; 
}

void scheme_wrong_type (const char * name , const char * expected , 
int which , int argc , 
Scheme_Object * * argv ) 
{
  Scheme_Object * o ; 
  char * s ; 
  intptr_t slen ; 
  int isres = 0 ; 
  GC_CAN_IGNORE char * isress = "argument" ; 
  GC_CAN_IGNORE char * isgiven = "given" ; 

# 1719 "./../src/error.c"
  const char * __funcarg102 = NULLED_OUT ; 
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(expected, 1), PUSH(s, 2), PUSH(argv, 3)));
# define XfOrM252_COUNT (4)
# define SETUP_XfOrM252(x) SETUP(XfOrM252_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 1744 "./../src/error.c"
  o = argv [which < 0 ? 0 : which ] ; 
  if (argc < 0 ) {
    argc = - argc ; 
    isress = "result" ; 
    isgiven = "received" ; 
    isres = 1 ; 
  }
  if (which == - 2 ) {
    isress = "value" ; 
    isgiven = "received" ; 
  }

  s = FUNCCALL(SETUP_XfOrM252(_), scheme_make_provided_string (o , 1 , & slen ) ); 

  if ((which < 0 ) || (argc == 1 ) )
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: expect%s %s of type <%s>; " "%s: %t" , name , (which < 0 ) ? "ed" : "s" , isress , expected , isgiven , s , slen ) )





  ; 
  else {
    char * other ; 
    intptr_t olen ; 
    BLOCK_SETUP((PUSH(other, 0+XfOrM252_COUNT)));
#   define XfOrM253_COUNT (1+XfOrM252_COUNT)
#   define SETUP_XfOrM253(x) SETUP(XfOrM253_COUNT)
    other = NULLED_OUT ; 

# 1770 "./../src/error.c"
    if ((which >= 0 ) && (argc > 1 ) )
      other = FUNCCALL(SETUP_XfOrM253(_), scheme_make_args_string ("other " , which , (isres ? - argc : argc ) , argv , & olen ) )

    ; 
    else {
      other = "" ; 
      olen = 0 ; 
    }
    (__funcarg102 = FUNCCALL(SETUP_XfOrM253(_), scheme_number_suffix (which + 1 ) )




    , FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: expects type <%s> as %d%s %s, " "given: %t%t" , name , expected , which + 1 , __funcarg102 , isress , s , slen , other , olen ) )) 

    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1789 "./../src/error.c"
static const char * indent_lines (const char * s , intptr_t * _len , int initial_indent , int amt ) 
{
  intptr_t len , i , j , lines = 1 ; 
  int a ; 
  char * s2 ; 
  DECL_RET_SAVE (const char * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(_len, 0), PUSH(s2, 1), PUSH(s, 2)));
# define XfOrM257_COUNT (3)
# define SETUP_XfOrM257(x) SETUP(XfOrM257_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s2 = NULLED_OUT ; 

# 1795 "./../src/error.c"
  if (_len )
    len = * _len ; 
  else 
  len = strlen (s ) ; 

  for (i = 0 ; i < len ; i ++ ) {
    if (s [i ] == '\n' )
      lines ++ ; 
  }

  if ((len > 72 ) || (lines > 1 ) ) {
#   define XfOrM258_COUNT (0+XfOrM257_COUNT)
#   define SETUP_XfOrM258(x) SETUP_XfOrM257(x)

# 1806 "./../src/error.c"
    s2 = FUNCCALL(SETUP_XfOrM258(_), GC_malloc_atomic (len + (lines * (amt + 1 ) ) + 1 ) ); 

    if (initial_indent ) {
      s2 [0 ] = '\n' ; 
      j = 1 ; 
      for (a = 0 ; a < amt ; a ++ ) {
        s2 [j ++ ] = ' ' ; 
      }
    }

# 1814 "./../src/error.c"
    else 
    j = 0 ; 

    for (i = 0 ; i < len ; i ++ ) {
      s2 [j ++ ] = s [i ] ; 
      if (s [i ] == '\n' ) {
        for (a = 0 ; a < amt ; a ++ ) {
          s2 [j ++ ] = ' ' ; 
        }
      }
    }
    s2 [j ] = 0 ; 

    if (_len )
      * _len = j ; 

    RET_VALUE_START (s2 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1836 "./../src/error.c"
void scheme_wrong_contract (const char * name , const char * expected , 
int which , int argc , 
Scheme_Object * * argv ) 
{
  Scheme_Object * o ; 
  char * s ; 
  intptr_t slen ; 
  int isres = 0 ; 
  GC_CAN_IGNORE char * isgiven = "given" , * kind = "argument" ; 

# 1789 "./../src/error.c"
  const char * __funcarg105 = NULLED_OUT ; 

# 1719 "./../src/error.c"
  const char * __funcarg104 = NULLED_OUT ; 

# 1789 "./../src/error.c"
  const char * __funcarg103 = NULLED_OUT ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(expected, 1), PUSH(__funcarg103, 2), PUSH(s, 3), PUSH(argv, 4)));
# define XfOrM272_COUNT (5)
# define SETUP_XfOrM272(x) SETUP(XfOrM272_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 1846 "./../src/error.c"
  o = argv [which < 0 ? 0 : which ] ; 
  if (argc < 0 ) {
    argc = - argc ; 
    isgiven = "received" ; 
    kind = "result" ; 
    isres = 1 ; 
  }
  if (which == - 2 ) {
    isgiven = "received" ; 
    kind = "result" ; 
  }
  if (argc == 0 )
    kind = "value" ; 

  s = FUNCCALL(SETUP_XfOrM272(_), scheme_make_provided_string (o , 1 , & slen ) ); 

  if ((which < 0 ) || (argc <= 1 ) )
    (__funcarg105 = FUNCCALL(SETUP_XfOrM272(_), indent_lines (expected , ((void * ) 0 ) , 1 , 3 ) )




  , FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: contract violation\n" "  expected: %s\n" "  %s: %t" , name , __funcarg105 , isgiven , s , slen ) )) 
  ; 
  else {
    char * other ; 
    intptr_t olen ; 
    BLOCK_SETUP((PUSH(other, 0+XfOrM272_COUNT)));
#   define XfOrM273_COUNT (1+XfOrM272_COUNT)
#   define SETUP_XfOrM273(x) SETUP(XfOrM273_COUNT)
    other = NULLED_OUT ; 

# 1874 "./../src/error.c"
    other = FUNCCALL(SETUP_XfOrM273(_), scheme_make_arg_lines_string ("   " , which , argc , argv , & olen ) ); 
    (__funcarg103 = FUNCCALL(SETUP_XfOrM273(_), indent_lines (expected , ((void * ) 0 ) , 1 , 3 ) )







    , __funcarg104 = FUNCCALL(SETUP_XfOrM273(_), scheme_number_suffix (which + 1 ) )

    , FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: contract violation\n" "  expected: %s\n" "  %s: %t\n" "  %s position: %d%s\n" "  other %s...:%s" , name , __funcarg103 , isgiven , s , slen , kind , which + 1 , __funcarg104 , (! isres ? "arguments" : "results" ) , other , olen ) )) 
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1890 "./../src/error.c"
void scheme_wrong_field_type (Scheme_Object * c_name , 
const char * expected , 
Scheme_Object * o ) 
{
  const char * s ; 
  Scheme_Object * a [1 ] ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(expected, 0), PUSHARRAY(a, 1, 1), PUSH(s, 4)));
# define XfOrM276_COUNT (5)
# define SETUP_XfOrM276(x) SETUP(XfOrM276_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 1896 "./../src/error.c"
  a [0 ] = o ; 
  s = FUNCCALL(SETUP_XfOrM276(_), scheme_symbol_name (c_name ) ); 
  FUNCCALL_AGAIN(scheme_wrong_type (s , expected , - 1 , 0 , a ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1901 "./../src/error.c"
void scheme_wrong_field_contract (Scheme_Object * c_name , 
const char * expected , 
Scheme_Object * o ) 
{
  const char * s ; 
  Scheme_Object * a [1 ] ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(expected, 0), PUSHARRAY(a, 1, 1), PUSH(s, 4)));
# define XfOrM277_COUNT (5)
# define SETUP_XfOrM277(x) SETUP(XfOrM277_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 1907 "./../src/error.c"
  a [0 ] = o ; 
  s = FUNCCALL(SETUP_XfOrM277(_), scheme_symbol_name (c_name ) ); 
  FUNCCALL_AGAIN(scheme_wrong_contract (s , expected , - 1 , 0 , a ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1912 "./../src/error.c"
void scheme_arg_mismatch (const char * name , const char * msg , Scheme_Object * o ) 
{
  char * s ; 
  intptr_t slen ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(s, 1), PUSH(msg, 2)));
# define XfOrM278_COUNT (3)
# define SETUP_XfOrM278(x) SETUP(XfOrM278_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 1917 "./../src/error.c"
  if (o )
    s = FUNCCALL(SETUP_XfOrM278(_), scheme_make_provided_string (o , 1 , & slen ) ); 
  else {
    s = "" ; 
    slen = 0 ; 
  }
  FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: %s%t" , name , msg , s , slen ) )


  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1929 "./../src/error.c"
static void do_out_of_range (const char * name , const char * type , const char * which , 
int ending , 
Scheme_Object * i , Scheme_Object * s , 
Scheme_Object * low_bound , Scheme_Object * sstart , Scheme_Object * slen ) 
{
  char * __funcarg107 = NULLED_OUT ; 
  char * __funcarg106 = NULLED_OUT ; 
  PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(s, 1), PUSH(i, 2), PUSH(low_bound, 3), PUSH(slen, 4), PUSH(sstart, 5), PUSH(which, 6), PUSH(type, 7)));
# define XfOrM280_COUNT (8)
# define SETUP_XfOrM280(x) SETUP(XfOrM280_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1934 "./../src/error.c"
  if (! type ) {
    type = (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) ? "byte string" : "string" ) ; 
  }

  if (! FUNCCALL(SETUP_XfOrM280(_), scheme_bin_lt (slen , sstart ) )) {
    char * sstr ; 
    intptr_t strlen ; 
    int small_end = 0 ; 
    BLOCK_SETUP((PUSH(sstr, 0+XfOrM280_COUNT)));
#   define XfOrM282_COUNT (1+XfOrM280_COUNT)
#   define SETUP_XfOrM282(x) SETUP(XfOrM282_COUNT)
    sstr = NULLED_OUT ; 

# 1943 "./../src/error.c"
    if (ending ) {
#     define XfOrM283_COUNT (0+XfOrM282_COUNT)
#     define SETUP_XfOrM283(x) SETUP_XfOrM282(x)

# 1944 "./../src/error.c"
      if (FUNCCALL(SETUP_XfOrM283(_), scheme_bin_gt_eq (i , low_bound ) )
      && FUNCCALL(SETUP_XfOrM283(_), scheme_bin_lt (i , sstart ) ))
        small_end = 1 ; 
    }

    sstr = FUNCCALL(SETUP_XfOrM282(_), scheme_make_provided_string (s , 2 , & strlen ) ); 
    (__funcarg107 = FUNCCALL(SETUP_XfOrM282(_), scheme_make_provided_string (i , 2 , ((void * ) 0 ) ) )



    , FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: %sindex is %s\n  %sindex: %s\n  %s%V%s%V]\n  %s: %t" , name , which , small_end ? "smaller than starting index" : "out of range" , which , __funcarg107 , ending ? "starting index: " : "valid range: [" , sstart , ending ? "\n  valid range: [0, " : ", " , slen , type , sstr , strlen ) )) 





    ; 
  }

# 1961 "./../src/error.c"
  else {
#   define XfOrM281_COUNT (0+XfOrM280_COUNT)
#   define SETUP_XfOrM281(x) SETUP_XfOrM280(x)
    (__funcarg106 = FUNCCALL(SETUP_XfOrM281(_), scheme_make_provided_string (i , 0 , ((void * ) 0 ) ) ), FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: %sindex is out of range for empty %s\n  %sindex: %s" , name , which , type , which , __funcarg106 ) )) 

    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1970 "./../src/error.c"
void scheme_out_of_range (const char * name , const char * type , const char * which , 
Scheme_Object * i , Scheme_Object * s , 
intptr_t start , intptr_t len ) 
{

# 156 "/usr/include/string.h" 3
  int __funcarg108 ; 
  PREPARE_VAR_STACK_ONCE(0);
# define XfOrM285_COUNT (0)
# define SETUP_XfOrM285(x) SETUP(XfOrM285_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1974 "./../src/error.c"
  if (start < 0 ) {
    start = 0 ; 
    len = len - 1 ; 
  }
  (__funcarg108 = (
  strcmp (which , "ending " ) ) , FUNCCALL_EMPTY(do_out_of_range (name , type , which , ! __funcarg108 , i , s , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (start ) ) ) << 1 ) | 0x1 ) ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (len ) ) ) << 1 ) | 0x1 ) ) ) )) 
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1983 "./../src/error.c"
static Scheme_Object * raise_range_error (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * type , * desc ; 
  char * __funcarg109 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(type, 1), PUSH(desc, 2)));
# define XfOrM287_COUNT (3)
# define SETUP_XfOrM287(x) SETUP(XfOrM287_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  type = NULLED_OUT ; 
  desc = NULLED_OUT ; 

# 1987 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("raise-range-error" , "symbol?" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("raise-range-error" , "string?" , 1 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("raise-range-error" , "string?" , 2 , argc , argv ) ); 
  if (! (((intptr_t ) (argv [3 ] ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("raise-range-error" , "exact-integer?" , 3 , argc , argv ) ); 
  if (! (((intptr_t ) (argv [5 ] ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [5 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [5 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("raise-range-error" , "exact-integer?" , 5 , argc , argv ) ); 
  if (! (((intptr_t ) (argv [6 ] ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [6 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [6 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("raise-range-error" , "exact-integer?" , 6 , argc , argv ) ); 
  if (argc > 7 ) {
#   define XfOrM288_COUNT (0+XfOrM287_COUNT)
#   define SETUP_XfOrM288(x) SETUP_XfOrM287(x)

# 2000 "./../src/error.c"
    if (! (((argv [7 ] ) ) == (scheme_false ) ) && ! (((intptr_t ) (argv [7 ] ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [7 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [7 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("raise-range-error" , "(or/c exact-integer? #f)" , 7 , argc , argv ) ); 
  }

  type = FUNCCALL(SETUP_XfOrM287(_), scheme_char_string_to_byte_string (argv [1 ] ) ); 
  desc = FUNCCALL(SETUP_XfOrM287(_), scheme_char_string_to_byte_string (argv [2 ] ) ); 
  (__funcarg109 = FUNCCALL(SETUP_XfOrM287(_), scheme_symbol_val (argv [0 ] ) )
  , FUNCCALL_AGAIN(do_out_of_range (__funcarg109 , (((Scheme_Simple_Object * ) (type ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (desc ) ) -> u . byte_str_val . string_val ) , ((argc > 7 ) && (! (((argv [7 ] ) ) == (scheme_false ) ) ) ) , argv [3 ] , argv [4 ] , argv [7 ] , argv [5 ] , argv [6 ] ) )) 







  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2022 "./../src/error.c"
void scheme_contract_error (const char * name , const char * msg , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  int i , cnt = 0 , kind ; 
  intptr_t len = 0 , nlen , mlen , seplen ; 
  const char * strs [5 ] , * str , * sep ; 
  Scheme_Object * vs [5 ] , * v ; 
  const char * v_strs [5 ] , * v_str ; 
  intptr_t v_str_lens [5 ] , v_str_len ; 
  char * s ; 
  PREPARE_VAR_STACK_ONCE(14);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSHARRAY(strs, 5, 1), PUSH(v_str, 4), PUSHARRAY(v_strs, 5, 5), PUSH(s, 8), PUSH(sep, 9), PUSHARRAY(vs, 5, 10), PUSH(msg, 13)));
# define XfOrM289_COUNT (14)
# define SETUP_XfOrM289(x) SETUP(XfOrM289_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  NULL_OUT_ARRAY (strs ) ; 
  str = NULLED_OUT ; 
  sep = NULLED_OUT ; 
  NULL_OUT_ARRAY (vs ) ; 
  v = NULLED_OUT ; 
  NULL_OUT_ARRAY (v_strs ) ; 
  v_str = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 2033 "./../src/error.c"
  HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
  while (1 ) {
    str = HIDE_FROM_XFORM (__builtin_va_arg (args , const char * ) ) ; 
    if (! str )

# 2036 "./../src/error.c"
    break ; 
    strs [cnt ] = str ; 
    kind = HIDE_FROM_XFORM (__builtin_va_arg (args , int ) ) ; 
    if (kind ) {
      v = HIDE_FROM_XFORM (__builtin_va_arg (args , Scheme_Object * ) ) ; 
      vs [cnt ++ ] = v ; 
    }

# 2042 "./../src/error.c"
    else {
      str = HIDE_FROM_XFORM (__builtin_va_arg (args , const char * ) ) ; 
      v_strs [cnt ] = str ; 
      v_str_lens [cnt ] = strlen (str ) ; 
      vs [cnt ++ ] = ((void * ) 0 ) ; 
    }
  }
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM294_COUNT (0+XfOrM289_COUNT)
#   define SETUP_XfOrM294(x) SETUP_XfOrM289(x)

# 2052 "./../src/error.c"
    if (vs [i ] ) {
#     define XfOrM295_COUNT (0+XfOrM294_COUNT)
#     define SETUP_XfOrM295(x) SETUP_XfOrM294(x)

# 2053 "./../src/error.c"
      v_str = FUNCCALL(SETUP_XfOrM295(_), scheme_make_provided_string (vs [i ] , 1 , & v_str_len ) ); 
      v_strs [i ] = v_str ; 
      v_str_lens [i ] = v_str_len ; 
    }

# 2056 "./../src/error.c"
    else 
    v_str_len = v_str_lens [i ] ; 
    len += v_str_len + 5 + strlen (strs [i ] ) ; 
  }

  sep = ": " ; 

  mlen = strlen (msg ) ; 
  nlen = strlen (name ) ; 
  seplen = strlen (sep ) ; 

  len += mlen + nlen + seplen + 10 ; 

  s = FUNCCALL(SETUP_XfOrM289(_), GC_malloc_atomic (len ) ); 
  len = 0 ; 
  (memcpy (s , name , nlen ) ) ; 
  len += nlen ; 
  (memcpy (s + len , sep , seplen ) ) ; 
  len += seplen ; 
  (memcpy (s + len , msg , mlen ) ) ; 
  len += mlen ; 
  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM291_COUNT (0+XfOrM289_COUNT)
#   define SETUP_XfOrM291(x) SETUP_XfOrM289(x)
    (
# 2078 "./../src/error.c"
    memcpy (s + len , "\n  " , 3 ) ) ; 
    len += 3 ; 
    nlen = strlen (strs [i ] ) ; 
    (memcpy (s + len , strs [i ] , nlen ) ) ; 
    len += nlen ; 
    (memcpy (s + len , ": " , 2 ) ) ; 
    len += 2 ; 
    (memcpy (s + len , v_strs [i ] , v_str_lens [i ] ) ) ; 
    len += v_str_lens [i ] ; 
  }
  s [len ] = 0 ; 
  FUNCCALL(SETUP_XfOrM289(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%t" , s , len ) )


  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2095 "./../src/error.c"
void scheme_wrong_chaperoned (const char * who , const char * what , Scheme_Object * orig , Scheme_Object * naya ) 
{
  /* No conversion */

# 2097 "./../src/error.c"
  char buf [128 ] ; 

  sprintf (buf , 
  "non-chaperone result;\n" 
  " received a %s that is not a chaperone of the original %s" , 
  what , what ) ; 

  scheme_contract_error (who , 
  buf , 
  "original" , 1 , orig , 
  "received" , 1 , naya , 
  ((void * ) 0 ) ) ; 
}

void scheme_system_error (const char * name , const char * what , int errid ) 
{
  /* No conversion */

# 2113 "./../src/error.c"
  scheme_raise_exn (MZEXN_FAIL , 
  "%s: %s failed\n" 
  "  system error: %e" , 
  name , what , errid ) ; 
}

void scheme_rktio_error (const char * name , const char * what ) 
{
  /* No conversion */

# 2121 "./../src/error.c"
  scheme_raise_exn (MZEXN_FAIL , 
  "%s: %s failed\n" 
  "  system error: %R" , 
  name , what ) ; 
}



static char * make_srcloc_string (Scheme_Object * src , intptr_t line , intptr_t col , intptr_t pos , intptr_t * len ) 
{
  char * srcstr , * result ; 
  intptr_t srclen , rlen ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(len, 0), PUSH(src, 1), PUSH(result, 2), PUSH(srcstr, 3)));
# define XfOrM305_COUNT (4)
# define SETUP_XfOrM305(x) SETUP(XfOrM305_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  srcstr = NULLED_OUT ; 
  result = NULLED_OUT ; 

# 2134 "./../src/error.c"
  if (! src || ((((src ) ) == (scheme_false ) ) && (pos < 0 ) ) ) {
    if (len )

# 2135 "./../src/error.c"
    * len = 0 ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (src && ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#   define XfOrM309_COUNT (0+XfOrM305_COUNT)
#   define SETUP_XfOrM309(x) SETUP_XfOrM305(x)

# 2141 "./../src/error.c"
    src = FUNCCALL(SETUP_XfOrM309(_), scheme_remove_current_directory_prefix (src ) ); 


    srclen = (((Scheme_Simple_Object * ) (src ) ) -> u . byte_str_val . tag_val ) ; 
    if (srclen > 100 ) {
#     define XfOrM310_COUNT (0+XfOrM309_COUNT)
#     define SETUP_XfOrM310(x) SETUP_XfOrM309(x)

# 2146 "./../src/error.c"
      srcstr = FUNCCALL(SETUP_XfOrM310(_), GC_malloc_atomic (100 ) ); 
      (memcpy (srcstr , (((Scheme_Simple_Object * ) (src ) ) -> u . byte_str_val . string_val ) + (srclen - 100 ) , 
      100 ) ) ; 
      srcstr [0 ] = '.' ; 
      srcstr [1 ] = '.' ; 
      srcstr [2 ] = '.' ; 
      srclen = 100 ; 
    }

# 2153 "./../src/error.c"
    else 
    srcstr = (((Scheme_Simple_Object * ) (src ) ) -> u . byte_str_val . string_val ) ; 
  }

# 2155 "./../src/error.c"
  else 
  srcstr = FUNCCALL(SETUP_XfOrM305(_), scheme_display_to_string_w_max (src , & srclen , 100 ) ); 

  result = (char * ) FUNCCALL(SETUP_XfOrM305(_), GC_malloc_atomic (srclen + 15 ) ); 

  if (line >= 0 && col >= 0 ) {
#   define XfOrM308_COUNT (0+XfOrM305_COUNT)
#   define SETUP_XfOrM308(x) SETUP_XfOrM305(x)

# 2162 "./../src/error.c"
    rlen = FUNCCALL(SETUP_XfOrM308(_), scheme_sprintf (result , srclen + 15 , "%t:%L%ld" , srcstr , srclen , line , col - 1 ) )
    ; 
  }

# 2164 "./../src/error.c"
  else if (pos >= 0 ) {
#   define XfOrM307_COUNT (0+XfOrM305_COUNT)
#   define SETUP_XfOrM307(x) SETUP_XfOrM305(x)

# 2166 "./../src/error.c"
    rlen = FUNCCALL(SETUP_XfOrM307(_), scheme_sprintf (result , srclen + 15 , "%t::%ld" , srcstr , srclen , pos ) )
    ; 
  }

# 2168 "./../src/error.c"
  else {
#   define XfOrM306_COUNT (0+XfOrM305_COUNT)
#   define SETUP_XfOrM306(x) SETUP_XfOrM305(x)

# 2170 "./../src/error.c"
    rlen = FUNCCALL(SETUP_XfOrM306(_), scheme_sprintf (result , srclen + 15 , "%t" , srcstr , srclen ) )
    ; 
  }

  if (len )

# 2174 "./../src/error.c"
  * len = rlen ; 
  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2178 "./../src/error.c"
static char * make_stx_srcloc_string (Scheme_Stx_Srcloc * srcloc , intptr_t * len ) 
{
  /* No conversion */

# 2180 "./../src/error.c"
  return make_srcloc_string (srcloc -> src , srcloc -> line , srcloc -> col , srcloc -> pos , len ) ; 
}

char * scheme_make_srcloc_string (Scheme_Object * stx , intptr_t * len ) 
{
  /* No conversion */

# 2185 "./../src/error.c"
  return make_stx_srcloc_string (((Scheme_Stx * ) stx ) -> srcloc , len ) ; 
}

static intptr_t struct_number_ref (Scheme_Object * s , int pos ) 
{
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM314_COUNT (1)
# define SETUP_XfOrM314(x) SETUP(XfOrM314_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2190 "./../src/error.c"
  s = FUNCCALL(SETUP_XfOrM314(_), scheme_struct_ref (s , pos ) ); 
  if (((s ) ) == (scheme_false ) ) 
    RET_VALUE_START (- 1 ) RET_VALUE_END ; 
  else 
  RET_VALUE_START ((((intptr_t ) (s ) ) >> 1 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2197 "./../src/error.c"
Scheme_Object * srcloc_to_string (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * src ; 
  char * s ; 
  intptr_t len , line , col , pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(src, 0), PUSH(s, 1), PUSH(argv, 2)));
# define XfOrM315_COUNT (3)
# define SETUP_XfOrM315(x) SETUP(XfOrM315_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  src = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 2203 "./../src/error.c"
  if (! FUNCCALL(SETUP_XfOrM315(_), scheme_is_location (argv [0 ] ) ))
    FUNCCALL_EMPTY(scheme_wrong_contract ("srcloc->string" , "srcloc?" , 0 , argc , argv ) ); 

  src = FUNCCALL(SETUP_XfOrM315(_), scheme_struct_ref (argv [0 ] , 0 ) ); 
  if (((src ) ) == (scheme_false ) ) 

# 2207 "./../src/error.c"
  src = ((void * ) 0 ) ; 
  line = FUNCCALL(SETUP_XfOrM315(_), struct_number_ref (argv [0 ] , 1 ) ); 
  col = FUNCCALL_AGAIN(struct_number_ref (argv [0 ] , 2 ) ); 
  pos = FUNCCALL_AGAIN(struct_number_ref (argv [0 ] , 3 ) ); 

  s = FUNCCALL_AGAIN(make_srcloc_string (src , line , (col >= 0 ? col + 1 : - 1 ) , pos , & len ) ); 

  if (s )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (s , len ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2220 "./../src/error.c"
static Scheme_Object * unquoted_printing_string (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(argv, 1)));
# define XfOrM316_COUNT (2)
# define SETUP_XfOrM316(x) SETUP(XfOrM316_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 2224 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("unquoted-printing-string" , "string?" , 0 , argc , argv ) ); 

  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM316(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = scheme_unquoted_printing_string_type ; 
  (((Scheme_Small_Object * ) (o ) ) -> u . ptr_val ) = argv [0 ] ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2234 "./../src/error.c"
static Scheme_Object * unquoted_printing_string_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2236 "./../src/error.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unquoted_printing_string_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * unquoted_printing_string_value (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2243 "./../src/error.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unquoted_printing_string_type ) ) 
    return (((Scheme_Small_Object * ) (argv [0 ] ) ) -> u . ptr_val ) ; 

  scheme_wrong_contract ("unquoted-printing-string-value" , "unquoted-printing-string?" , 0 , argc , argv ) ; 
  return ((void * ) 0 ) ; 
}

void scheme_read_err (Scheme_Object * port , 
const char * detail , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  Scheme_Object * pn ; 
  char * s , * fn ; 
  intptr_t slen ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(fn, 1), PUSH(pn, 2), PUSH(port, 3)));
# define XfOrM319_COUNT (4)
# define SETUP_XfOrM319(x) SETUP(XfOrM319_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pn = NULLED_OUT ; 
  s = NULLED_OUT ; 
  fn = NULLED_OUT ; 

# 2258 "./../src/error.c"
  HIDE_FROM_XFORM (__builtin_va_start (args , detail ) ) ; 
  slen = FUNCCALL(SETUP_XfOrM319(_), sch_vsprintf (((void * ) 0 ) , 0 , detail , args , & s , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  if (port ) {
#   define XfOrM320_COUNT (0+XfOrM319_COUNT)
#   define SETUP_XfOrM320(x) SETUP_XfOrM319(x)

# 2263 "./../src/error.c"
    pn = FUNCCALL(SETUP_XfOrM320(_), scheme_input_port_record (port ) )-> name ; 
    if ((Scheme_Type ) (((((intptr_t ) (pn ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pn ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#     define XfOrM321_COUNT (0+XfOrM320_COUNT)
#     define SETUP_XfOrM321(x) SETUP_XfOrM320(x)

# 2265 "./../src/error.c"
      pn = FUNCCALL(SETUP_XfOrM321(_), scheme_remove_current_directory_prefix (pn ) ); 
      fn = (((Scheme_Simple_Object * ) (pn ) ) -> u . byte_str_val . string_val ) ; 
    }

# 2267 "./../src/error.c"
    else 
    fn = ((void * ) 0 ) ; 
  }

# 2269 "./../src/error.c"
  else 
  fn = ((void * ) 0 ) ; 

  if (fn )
    FUNCCALL(SETUP_XfOrM319(_), scheme_raise_exn (MZEXN_FAIL_READ , scheme_null , "%t\n  in: %s" , s , slen , fn ) ); 
  else FUNCCALL(SETUP_XfOrM319(_), scheme_raise_exn (MZEXN_FAIL_READ , scheme_null , "%t" , s , slen ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2278 "./../src/error.c"
Scheme_Object * scheme_numr_err (Scheme_Object * complain , const char * detail , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  char * s ; 
  intptr_t slen ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(complain, 0), PUSH(s, 1)));
# define XfOrM322_COUNT (2)
# define SETUP_XfOrM322(x) SETUP(XfOrM322_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 2284 "./../src/error.c"
  HIDE_FROM_XFORM (__builtin_va_start (args , detail ) ) ; 
  slen = FUNCCALL(SETUP_XfOrM322(_), sch_vsprintf (((void * ) 0 ) , 0 , detail , args , & s , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  if (((complain ) ) == (scheme_false ) ) 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM322(_), scheme_make_sized_utf8_string (s , slen ) )) RET_VALUE_END ; 
  FUNCCALL(SETUP_XfOrM322(_), scheme_read_err (complain , "read: %s" , s ) )
  ; 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2295 "./../src/error.c"
static void do_wrong_syntax (const char * where , 
Scheme_Object * detail_form , 
Scheme_Object * form , 
char * s , intptr_t slen ) 
{
  intptr_t len , vlen , dvlen , blen , plen ; 
  char * buffer ; 
  char * v , * dv , * p ; 
  Scheme_Object * who ; 
  int show_src ; 
  Scheme_Config * __funcarg110 = NULLED_OUT ; 
  PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(where, 0), PUSH(buffer, 1), PUSH(who, 2), PUSH(detail_form, 3), PUSH(form, 4), PUSH(p, 5), PUSH(v, 6), PUSH(s, 7), PUSH(dv, 8)));
# define XfOrM323_COUNT (9)
# define SETUP_XfOrM323(x) SETUP(XfOrM323_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  buffer = NULLED_OUT ; 
  v = NULLED_OUT ; 
  dv = NULLED_OUT ; 
  p = NULLED_OUT ; 
  who = NULLED_OUT ; 

# 2306 "./../src/error.c"
  who = ((void * ) 0 ) ; 

  if (! s ) {
    s = "bad syntax" ; 
    slen = strlen (s ) ; 
  }

  buffer = FUNCCALL(SETUP_XfOrM323(_), init_buf (& len , & blen ) ); 

  p = ((void * ) 0 ) ; 
  plen = 0 ; 

  show_src = (! ((((__funcarg110 = FUNCCALL(SETUP_XfOrM323(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg110 , MZCONFIG_ERROR_PRINT_SRCLOC ) )) ) ) == (scheme_false ) ) ) ; 

  if (form ) {
    Scheme_Object * pform ; 
    BLOCK_SETUP((PUSH(pform, 0+XfOrM323_COUNT)));
#   define XfOrM332_COUNT (1+XfOrM323_COUNT)
#   define SETUP_XfOrM332(x) SETUP(XfOrM332_COUNT)
    pform = NULLED_OUT ; 

# 2322 "./../src/error.c"
    if ((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) )  {
#     define XfOrM335_COUNT (0+XfOrM332_COUNT)
#     define SETUP_XfOrM335(x) SETUP_XfOrM332(x)

# 2323 "./../src/error.c"
      p = FUNCCALL(SETUP_XfOrM335(_), make_stx_srcloc_string (((Scheme_Stx * ) form ) -> srcloc , & plen ) ); 
      pform = FUNCCALL(SETUP_XfOrM335(_), scheme_syntax_to_datum (form ) ); 


      if (! who && ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) ) ) {
        Scheme_Object * first ; 
        first = NULLED_OUT ; 

# 2329 "./../src/error.c"
        if (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) form ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) ) 
          first = (((Scheme_Type ) (((((intptr_t ) (form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (form ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ? (((Scheme_Simple_Object * ) (form ) ) -> u . pair_val . car ) : (((Scheme_Simple_Object * ) (((Scheme_Stx * ) form ) -> val ) ) -> u . pair_val . car ) ) ; 
        else 
        first = form ; 
        if (((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Stx * ) first ) -> val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Stx * ) first ) -> val ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) ) 
          who = (((Scheme_Type ) (((((intptr_t ) (first ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (first ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) ) ? ((Scheme_Stx * ) first ) -> val : first ) ; 
      }
    }

# 2336 "./../src/error.c"
    else {
      pform = form ; 
    }

    if (show_src )
      v = FUNCCALL(SETUP_XfOrM332(_), scheme_write_to_string_w_max (pform , & vlen , len ) ); 
    else {
      v = ((void * ) 0 ) ; 
      vlen = 0 ; 
    }
  }

# 2346 "./../src/error.c"
  else {
    form = scheme_false ; 
    v = ((void * ) 0 ) ; 
    vlen = 0 ; 
  }

  if (detail_form ) {
    Scheme_Object * pform ; 
    BLOCK_SETUP((PUSH(pform, 0+XfOrM323_COUNT)));
#   define XfOrM328_COUNT (1+XfOrM323_COUNT)
#   define SETUP_XfOrM328(x) SETUP(XfOrM328_COUNT)
    pform = NULLED_OUT ; 

# 2354 "./../src/error.c"
    if ((Scheme_Type ) (((((intptr_t ) (detail_form ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (detail_form ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) )  {
#     define XfOrM330_COUNT (0+XfOrM328_COUNT)
#     define SETUP_XfOrM330(x) SETUP_XfOrM328(x)

# 2355 "./../src/error.c"
      if (((Scheme_Stx * ) detail_form ) -> srcloc -> line >= 0 )
        p = FUNCCALL(SETUP_XfOrM330(_), make_stx_srcloc_string (((Scheme_Stx * ) detail_form ) -> srcloc , & plen ) ); 
    }
    pform = FUNCCALL(SETUP_XfOrM328(_), scheme_syntax_to_datum (detail_form ) ); 


    if (show_src )
      dv = FUNCCALL(SETUP_XfOrM328(_), scheme_write_to_string_w_max (pform , & dvlen , len ) ); 
    else {
      dv = ((void * ) 0 ) ; 
      dvlen = 0 ; 
    }
  }

# 2367 "./../src/error.c"
  else {
    dv = ((void * ) 0 ) ; 
    dvlen = 0 ; 
  }

  if (! who ) {
#   define XfOrM326_COUNT (0+XfOrM323_COUNT)
#   define SETUP_XfOrM326(x) SETUP_XfOrM323(x)

# 2373 "./../src/error.c"
    if (where )
      who = FUNCCALL(SETUP_XfOrM326(_), scheme_intern_symbol (where ) ); 
    else 
    who = scheme_false ; 
  }

  if (! where ) {
#   define XfOrM325_COUNT (0+XfOrM323_COUNT)
#   define SETUP_XfOrM325(x) SETUP_XfOrM323(x)

# 2380 "./../src/error.c"
    if (((who ) ) == (scheme_false ) ) 
      where = "?" ; 
    else 
    where = FUNCCALL(SETUP_XfOrM325(_), scheme_symbol_val (who ) ); 
  }

  if (v ) {
#   define XfOrM324_COUNT (0+XfOrM323_COUNT)
#   define SETUP_XfOrM324(x) SETUP_XfOrM323(x)

# 2387 "./../src/error.c"
    if (dv )
      blen = FUNCCALL(SETUP_XfOrM324(_), scheme_sprintf (buffer , blen , "%t%s%s: %t\n" "  at: %t\n" "  in: %t" , p , plen , p ? ": " : "" , where , s , slen , dv , dvlen , v , vlen ) )








    ; 
    else 
    blen = FUNCCALL(SETUP_XfOrM324(_), scheme_sprintf (buffer , blen , "%t%s%s: %t\n" "  in: %t" , p , plen , p ? ": " : "" , where , s , slen , v , vlen ) )






    ; 
  }

# 2407 "./../src/error.c"
  else if (dv )
    blen = FUNCCALL(SETUP_XfOrM323(_), scheme_sprintf (buffer , blen , "%t%s%s: %t\n" "  at: %t" , p , plen , p ? ": " : "" , where , s , slen , dv , dvlen ) )






  ; 
  else 
  blen = FUNCCALL(SETUP_XfOrM323(_), scheme_sprintf (buffer , blen , "%s: %t" , where , s , slen ) )

  ; 
  FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%t" , buffer , blen ) )

  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2425 "./../src/error.c"
void scheme_wrong_syntax (const char * where , 
Scheme_Object * detail_form , 
Scheme_Object * form , 
const char * detail , ... ) 
{
  char * s ; 
  intptr_t slen ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(where, 0), PUSH(detail_form, 1), PUSH(form, 2), PUSH(s, 3)));
# define XfOrM338_COUNT (4)
# define SETUP_XfOrM338(x) SETUP(XfOrM338_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 2433 "./../src/error.c"
  if (! detail ) {
    s = ((void * ) 0 ) ; 
    slen = 0 ; 
  }

# 2436 "./../src/error.c"
  else {
    GC_CAN_IGNORE va_list args ; 
#   define XfOrM339_COUNT (0+XfOrM338_COUNT)
#   define SETUP_XfOrM339(x) SETUP_XfOrM338(x)

# 2439 "./../src/error.c"
    HIDE_FROM_XFORM (__builtin_va_start (args , detail ) ) ; 
    slen = FUNCCALL(SETUP_XfOrM339(_), sch_vsprintf (((void * ) 0 ) , 0 , detail , args , & s , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
    HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 
  }
  FUNCCALL(SETUP_XfOrM338(_), do_wrong_syntax (where , detail_form , form , s , slen ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2447 "./../src/error.c"
void scheme_wrong_rator (Scheme_Object * rator , int argc , Scheme_Object * * argv ) 
{
  intptr_t slen , rlen ; 
  char * s , * r ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(r, 0), PUSH(s, 1), PUSH(argv, 2)));
# define XfOrM341_COUNT (3)
# define SETUP_XfOrM341(x) SETUP(XfOrM341_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  r = NULLED_OUT ; 

# 2452 "./../src/error.c"
  r = FUNCCALL(SETUP_XfOrM341(_), scheme_make_provided_string (rator , 1 , & rlen ) ); 

  s = FUNCCALL_AGAIN(scheme_make_arg_lines_string ("   " , - 1 , argc , argv , & slen ) ); 
  FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "application: not a procedure;\n" " expected a procedure that can be applied to arguments\n" "  given: %t\n" "  arguments...:%t" , r , rlen , s , slen ) )





  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2464 "./../src/error.c"
void scheme_wrong_return_arity (const char * where , 
int expected , int got , 
Scheme_Object * * argv , 
const char * detail , ... ) 
{
  intptr_t slen , vlen , blen ; 
  char * s , * buffer ; 
  char * v ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(where, 0), PUSH(v, 1), PUSH(buffer, 2), PUSH(s, 3), PUSH(argv, 4)));
# define XfOrM342_COUNT (5)
# define SETUP_XfOrM342(x) SETUP(XfOrM342_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  buffer = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 2473 "./../src/error.c"
  if ((got != 1 ) && ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) == (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> values_buffer ) ) )

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> values_buffer = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array = ((void * ) 0 ) ; 

  if (! detail ) {
    s = ((void * ) 0 ) ; 
    slen = 0 ; 
  }

# 2481 "./../src/error.c"
  else {
    GC_CAN_IGNORE va_list args ; 
#   define XfOrM345_COUNT (0+XfOrM342_COUNT)
#   define SETUP_XfOrM345(x) SETUP_XfOrM342(x)

# 2484 "./../src/error.c"
    HIDE_FROM_XFORM (__builtin_va_start (args , detail ) ) ; 
    slen = FUNCCALL(SETUP_XfOrM345(_), sch_vsprintf (((void * ) 0 ) , 0 , detail , args , & s , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
    HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 
  }

  buffer = FUNCCALL(SETUP_XfOrM342(_), init_buf (((void * ) 0 ) , & blen ) ); 

  if (! got || ! argv ) {
    v = "" ; 
    vlen = 0 ; 
  }

# 2494 "./../src/error.c"
  else {
    Scheme_Object * * array ; 
#   define XfOrM343_COUNT (0+XfOrM342_COUNT)
#   define SETUP_XfOrM343(x) SETUP_XfOrM342(x)
    array = NULLED_OUT ; 

# 2497 "./../src/error.c"
    array = ((got == 1 ) ? (Scheme_Object * * ) (void * ) & argv : argv ) ; 

    v = FUNCCALL(SETUP_XfOrM343(_), scheme_make_arg_lines_string ("   " , - 1 , got , array , & vlen ) ); 
  }

  blen = FUNCCALL(SETUP_XfOrM342(_), scheme_sprintf (buffer , blen , "%s%sresult arity mismatch;\n" " expected number of values not received\n" "  expected: %d\n" "  received: %d" "%t\n" "  values...:%t" , where ? where : "" , where ? ": " : "" , expected , got , s , slen , v , vlen ) )
# 2515 "./../src/error.c"
  ; 
  FUNCCALL(SETUP_XfOrM342(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "%t" , buffer , blen ) )


  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2522 "./../src/error.c"
void scheme_non_fixnum_result (const char * name , Scheme_Object * o ) 
{
  /* No conversion */

# 2524 "./../src/error.c"
  scheme_raise_exn (MZEXN_FAIL_CONTRACT_NON_FIXNUM_RESULT , 
  "%s: result is not a fixnum\n" 
  "  result: %V" , 
  name , o ) ; 
}

void scheme_raise_out_of_memory (const char * where , const char * msg , ... ) 
{
  char * s ; 
  intptr_t slen ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(where, 0), PUSH(s, 1)));
# define XfOrM348_COUNT (2)
# define SETUP_XfOrM348(x) SETUP(XfOrM348_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 2535 "./../src/error.c"
  if (! msg ) {
    s = "" ; 
    slen = 0 ; 
  }

# 2538 "./../src/error.c"
  else {
    GC_CAN_IGNORE va_list args ; 
#   define XfOrM349_COUNT (0+XfOrM348_COUNT)
#   define SETUP_XfOrM349(x) SETUP_XfOrM348(x)

# 2541 "./../src/error.c"
    HIDE_FROM_XFORM (__builtin_va_start (args , msg ) ) ; 
    slen = FUNCCALL(SETUP_XfOrM349(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & s , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
    HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 
  }
  FUNCCALL(SETUP_XfOrM348(_), scheme_raise_exn (MZEXN_FAIL_OUT_OF_MEMORY , "%s%sout of memory %t" , where ? where : "" , where ? ": " : "" , s , slen ) )




  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2553 "./../src/error.c"
void scheme_unbound_global (Scheme_Bucket * b ) 
{
  Scheme_Object * name = (Scheme_Object * ) b -> key ; 
  Scheme_Instance * home ; 
  Scheme_Config * __funcarg111 = NULLED_OUT ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(home, 0), PUSH(name, 1)));
# define XfOrM351_COUNT (2)
# define SETUP_XfOrM351(x) SETUP(XfOrM351_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  home = NULLED_OUT ; 

# 2558 "./../src/error.c"
  home = (scheme_get_bucket_home (b ) ) ; 

  if (home ) {
    Scheme_Object * src_name ; 
    const char * errmsg ; 
    BLOCK_SETUP((PUSH(src_name, 0+XfOrM351_COUNT), PUSH(errmsg, 1+XfOrM351_COUNT)));
#   define XfOrM353_COUNT (2+XfOrM351_COUNT)
#   define SETUP_XfOrM353(x) SETUP(XfOrM353_COUNT)
    src_name = NULLED_OUT ; 
    errmsg = NULLED_OUT ; 

# 2564 "./../src/error.c"
    src_name = FUNCCALL(SETUP_XfOrM353(_), scheme_hash_tree_get (home -> source_names , name ) ); 
    if (! src_name )
      src_name = name ; 

    if (! ((((__funcarg111 = FUNCCALL(SETUP_XfOrM353(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg111 , MZCONFIG_ERROR_PRINT_SRCLOC ) )) ) ) == (scheme_false ) ) )  {
      if (! ((name ) == (src_name ) ) )
        errmsg = ("%S: undefined;\n" 
      " cannot reference an identifier before its definition\n" 
      "  in module: %D\n" 
      "  internal name: %S" ) ; 
      else 
      errmsg = ("%S: undefined;\n" 
      " cannot reference an identifier before its definition\n" 
      "  in module: %D" ) ; 
    }

# 2578 "./../src/error.c"
    else 
    errmsg = ("%S: undefined;\n" 
    " cannot reference an identifier before its definition%_%_" ) ; 
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_VARIABLE , name , errmsg , src_name , home -> name , name ) )





    ; 
  }

# 2588 "./../src/error.c"
  else {
#   define XfOrM352_COUNT (0+XfOrM351_COUNT)
#   define SETUP_XfOrM352(x) SETUP_XfOrM351(x)
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_VARIABLE , name , "%S: undefined;\n" " cannot reference undefined identifier" , name ) )

    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2597 "./../src/error.c"
char * scheme_make_provided_string (Scheme_Object * o , int count , intptr_t * lenout ) 
{
  intptr_t len ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(lenout, 1)));
# define XfOrM355_COUNT (2)
# define SETUP_XfOrM355(x) SETUP(XfOrM355_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2601 "./../src/error.c"
  len = FUNCCALL(SETUP_XfOrM355(_), scheme_get_print_width () ); 

  if (count )
    len /= count ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(error_write_to_string_w_max (o , len , lenout ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2609 "./../src/error.c"
static char * make_provided_list (Scheme_Object * o , int count , intptr_t * lenout ) 
{
  intptr_t len , cnt , i , onelen , total , sz ; 
  char * s , * accum , * naya ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(naya, 1), PUSH(accum, 2), PUSH(s, 3), PUSH(lenout, 4)));
# define XfOrM356_COUNT (5)
# define SETUP_XfOrM356(x) SETUP(XfOrM356_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  accum = NULLED_OUT ; 
  naya = NULLED_OUT ; 

# 2614 "./../src/error.c"
  cnt = (scheme_proper_list_length (o ) ) ; 
  if (cnt < 0 )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_provided_string (o , count , lenout ) )) RET_VALUE_EMPTY_END ; 

  if (! cnt ) {
    * lenout = 0 ; 
    RET_VALUE_START ("" ) RET_VALUE_END ; 
  }

  len = FUNCCALL(SETUP_XfOrM356(_), scheme_get_print_width () ); 

  if (count )
    len /= count ; 

  total = 0 ; 
  sz = 64 ; 
  accum = (char * ) FUNCCALL(SETUP_XfOrM356(_), GC_malloc_atomic (sz ) ); 

  for (i = 0 ; i < cnt ; i ++ ) {
#   define XfOrM359_COUNT (0+XfOrM356_COUNT)
#   define SETUP_XfOrM359(x) SETUP_XfOrM356(x)

# 2633 "./../src/error.c"
    s = FUNCCALL(SETUP_XfOrM359(_), scheme_write_to_string_w_max ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) , & onelen , len / cnt ) ); 
    if (total + onelen + 1 >= sz ) {
#     define XfOrM360_COUNT (0+XfOrM359_COUNT)
#     define SETUP_XfOrM360(x) SETUP_XfOrM359(x)

# 2635 "./../src/error.c"
      sz = (2 * sz ) + onelen + 1 ; 
      naya = (char * ) FUNCCALL(SETUP_XfOrM360(_), GC_malloc_atomic (sz ) ); 
      (memcpy (naya , accum , total ) ) ; 
      accum = naya ; 
    }
    (memcpy (accum + total , s , onelen ) ) ; 
    accum [total + onelen ] = ' ' ; 
    total += onelen + 1 ; 
    o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ; 
  }

  total -= 1 ; 
  accum [total ] = 0 ; 
  * lenout = total ; 

  RET_VALUE_START (accum ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2653 "./../src/error.c"
static Scheme_Object * do_error (const char * who , int mode , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * newargs [2 ] ; 
  Scheme_Object * __funcarg114 = NULLED_OUT ; 
  Scheme_Object * __funcarg113 = NULLED_OUT ; 
  Scheme_Object * __funcarg112 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(__funcarg113, 0), PUSHARRAY(newargs, 2, 1), PUSH(who, 4), PUSH(argv, 5)));
# define XfOrM362_COUNT (6)
# define SETUP_XfOrM362(x) SETUP(XfOrM362_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  newargs[0] = NULLED_OUT ; 
  newargs[1] = NULLED_OUT ; 

# 2657 "./../src/error.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#   define XfOrM366_COUNT (0+XfOrM362_COUNT)
#   define SETUP_XfOrM366(x) SETUP_XfOrM362(x)

# 2658 "./../src/error.c"
    if (argc < 2 ) {
      const char * s ; 
      int l ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM366_COUNT)));
#     define XfOrM368_COUNT (1+XfOrM366_COUNT)
#     define SETUP_XfOrM368(x) SETUP(XfOrM368_COUNT)
      s = NULLED_OUT ; 

# 2662 "./../src/error.c"
      s = FUNCCALL(SETUP_XfOrM368(_), scheme_symbol_val (argv [0 ] ) ); 
      l = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> len ) ; 


      newargs [0 ] = (__funcarg113 = FUNCCALL(SETUP_XfOrM368(_), scheme_make_utf8_string ("error: " ) )
      , __funcarg114 = FUNCCALL(SETUP_XfOrM368(_), scheme_make_sized_utf8_string ((char * ) s , l ) ), FUNCCALL_AGAIN(scheme_append_char_string (__funcarg113 , __funcarg114 ) )) 
      ; 

      ((((Scheme_Inclhash_Object * ) (newargs [0 ] ) ) -> so . keyex |= 0x1 ) ) ; 
    }

# 2671 "./../src/error.c"
    else {
      char * s , * r ; 
      intptr_t l , l2 ; 
      Scheme_Object * port ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM366_COUNT), PUSH(r, 1+XfOrM366_COUNT), PUSH(port, 2+XfOrM366_COUNT)));
#     define XfOrM367_COUNT (3+XfOrM366_COUNT)
#     define SETUP_XfOrM367(x) SETUP(XfOrM367_COUNT)
      s = NULLED_OUT ; 
      r = NULLED_OUT ; 
      port = NULLED_OUT ; 

# 2675 "./../src/error.c"
      port = FUNCCALL(SETUP_XfOrM367(_), scheme_make_byte_string_output_port () ); 


      if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
        FUNCCALL(SETUP_XfOrM367(_), scheme_wrong_contract (who , "string?" , 1 , argc , argv ) ); 
      FUNCCALL(SETUP_XfOrM367(_), scheme_do_format (who , port , ((void * ) 0 ) , - 1 , 1 , 2 , argc , argv ) )
      ; 

      s = FUNCCALL_AGAIN(scheme_get_sized_byte_string_output (port , & l ) ); 

      l2 = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> len ) ; 
      r = ((char * ) FUNCCALL(SETUP_XfOrM367(_), GC_malloc_atomic (sizeof (char ) * (l + l2 + 3 ) ) )) ; 
      (memcpy (r , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> s ) , l2 ) ) ; 
      (memcpy (r + l2 , ": " , 2 ) ) ; 
      (memcpy (r + l2 + 2 , s , l + 1 ) ) ; 

      newargs [0 ] = FUNCCALL(SETUP_XfOrM367(_), scheme_make_immutable_sized_utf8_string (r , l + l2 + 2 ) ); 
    }
  }

# 2693 "./../src/error.c"
  else {
    Scheme_Object * strout ; 
    char * str ; 
    intptr_t len , i ; 
    BLOCK_SETUP((PUSH(strout, 0+XfOrM362_COUNT), PUSH(str, 1+XfOrM362_COUNT)));
#   define XfOrM363_COUNT (2+XfOrM362_COUNT)
#   define SETUP_XfOrM363(x) SETUP(XfOrM363_COUNT)
    strout = NULLED_OUT ; 
    str = NULLED_OUT ; 

# 2699 "./../src/error.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
      FUNCCALL(SETUP_XfOrM363(_), scheme_wrong_contract (who , "(or/c string? symbol?)" , 0 , argc , argv ) ); 

    strout = FUNCCALL(SETUP_XfOrM363(_), scheme_make_byte_string_output_port () ); 
    FUNCCALL_AGAIN(scheme_internal_display (argv [0 ] , strout ) )
    ; 
    for (i = 1 ; i < argc ; i ++ ) {
#     define XfOrM365_COUNT (0+XfOrM363_COUNT)
#     define SETUP_XfOrM365(x) SETUP_XfOrM363(x)
      FUNCCALL(SETUP_XfOrM365(_), scheme_write_byte_string (" " , 1 , strout ) )
# 2706 "./../src/error.c"
      ; 
      FUNCCALL(SETUP_XfOrM365(_), scheme_internal_write (argv [i ] , strout ) ); 
    }

    str = FUNCCALL(SETUP_XfOrM363(_), scheme_get_sized_byte_string_output (strout , & len ) ); 
    newargs [0 ] = FUNCCALL(SETUP_XfOrM363(_), scheme_make_immutable_sized_utf8_string (str , len ) ); 
  }

  newargs [1 ] = scheme_parameterization_key ; 
  (__funcarg112 = FUNCCALL(SETUP_XfOrM362(_), scheme_make_struct_instance (exn_table [mode ] . type , 2 , newargs ) )
  , FUNCCALL_AGAIN(do_raise (__funcarg112 , 1 , 1 ) )) 

  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2723 "./../src/error.c"
static Scheme_Object * error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2725 "./../src/error.c"
  return do_error ("error" , MZEXN_FAIL , argc , argv ) ; 
}

static Scheme_Object * assert_unreachable (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2730 "./../src/error.c"
  scheme_contract_error ("assert-unreachable" , "unreachable code reached" , ((void * ) 0 ) ) ; 
  return scheme_void ; 
}

static Scheme_Object * raise_user_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2736 "./../src/error.c"
  return do_error ("raise-user-error" , MZEXN_FAIL_USER , argc , argv ) ; 
}

typedef void (* wrong_proc_t ) (const char * name , const char * expected , 
int which , int argc , 
Scheme_Object * * argv ) ; 

static Scheme_Object * do_raise_type_error (const char * name , int argc , Scheme_Object * argv [] , int mode ) 
{
  wrong_proc_t wrong ; 
  int negate = 0 ; 
  char * __funcarg116 = NULLED_OUT ; 
  char * __funcarg115 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(argv, 1)));
# define XfOrM372_COUNT (2)
# define SETUP_XfOrM372(x) SETUP(XfOrM372_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2748 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "symbol?" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "string?" , 1 , argc , argv ) ); 

  switch (mode ) {
    case 0 : wrong = scheme_wrong_type ; 

# 2754 "./../src/error.c"
    break ; 
    case 1 : wrong = scheme_wrong_contract ; 

# 2755 "./../src/error.c"
    break ; 
    case 2 : wrong = scheme_wrong_contract ; 

# 2756 "./../src/error.c"
    negate = 1 ; 

# 2756 "./../src/error.c"
    break ; 
    default : wrong = ((void * ) 0 ) ; 

# 2757 "./../src/error.c"
    break ; 
  }

  if (argc == 3 ) {
    Scheme_Object * v , * s ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM372_COUNT), PUSH(s, 1+XfOrM372_COUNT)));
#   define XfOrM376_COUNT (2+XfOrM372_COUNT)
#   define SETUP_XfOrM376(x) SETUP(XfOrM376_COUNT)
    v = NULLED_OUT ; 
    s = NULLED_OUT ; 

# 2762 "./../src/error.c"
    v = argv [2 ] ; 
    s = FUNCCALL(SETUP_XfOrM376(_), scheme_char_string_to_byte_string (argv [1 ] ) ); 
    (__funcarg116 = FUNCCALL(SETUP_XfOrM376(_), scheme_symbol_val (argv [0 ] ) ), FUNCCALL_AGAIN(wrong (__funcarg116 , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , negate ? - 2 : - 1 , 0 , & v ) )) 

    ; 
  }

# 2767 "./../src/error.c"
  else {
    Scheme_Object * * args , * s ; 
    int i ; 
    BLOCK_SETUP((PUSH(args, 0+XfOrM372_COUNT), PUSH(s, 1+XfOrM372_COUNT)));
#   define XfOrM373_COUNT (2+XfOrM372_COUNT)
#   define SETUP_XfOrM373(x) SETUP(XfOrM373_COUNT)
    args = NULLED_OUT ; 
    s = NULLED_OUT ; 

# 2771 "./../src/error.c"
    if (! ((((intptr_t ) (argv [2 ] ) ) & 0x1 ) && ((((intptr_t ) (argv [2 ] ) ) >> 1 ) >= 0 ) ) 
    && ! (((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) argv [2 ] ) -> iso ) -> so . keyex & 0x1 ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "exact-nonnegative-integer?" , 2 , argc , argv ) ); 

    if (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) && ((((intptr_t ) (argv [2 ] ) ) >> 1 ) >= argc - 3 ) ) 
    || ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
      FUNCCALL_EMPTY(scheme_contract_error (name , (negate ? "position index >= provided result count" : "position index >= provided argument count" ) , "position index" , 1 , argv [2 ] , (negate ? "provided result count" : "provided argument count" ) , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (argc - 3 ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )







    ; 

    args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM373(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 3 ) ) )) ; 
    for (i = 3 ; i < argc ; i ++ ) {
      args [i - 3 ] = argv [i ] ; 
    }

    s = FUNCCALL(SETUP_XfOrM373(_), scheme_char_string_to_byte_string (argv [1 ] ) ); 
    (__funcarg115 = FUNCCALL(SETUP_XfOrM373(_), scheme_symbol_val (argv [0 ] ) )
    , FUNCCALL_AGAIN(wrong (__funcarg115 , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , (((intptr_t ) (argv [2 ] ) ) >> 1 ) , negate ? (3 - argc ) : (argc - 3 ) , args ) )) 


    ; 
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2803 "./../src/error.c"
static Scheme_Object * raise_type_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2805 "./../src/error.c"
  return do_raise_type_error ("raise-type-error" , argc , argv , 0 ) ; 
}

static Scheme_Object * raise_argument_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2810 "./../src/error.c"
  return do_raise_type_error ("raise-argument-error" , argc , argv , 1 ) ; 
}

static Scheme_Object * raise_result_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2815 "./../src/error.c"
  return do_raise_type_error ("raise-result-error" , argc , argv , 2 ) ; 
}

static Scheme_Object * do_raise_mismatch_error (const char * who , int mismatch , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * s ; 
  int i ; 
  char * s2 ; 
  intptr_t l2 ; 
  char * __funcarg119 = NULLED_OUT ; 
  char * __funcarg118 = NULLED_OUT ; 
  char * __funcarg117 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(s2, 0), PUSH(s, 1), PUSH(argv, 2)));
# define XfOrM381_COUNT (3)
# define SETUP_XfOrM381(x) SETUP(XfOrM381_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 
  s2 = NULLED_OUT ; 

# 2825 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "symbol?" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "string?" , 1 , argc , argv ) ); 


  for (i = 2 + mismatch ; i < argc ; i += 2 ) {
#   define XfOrM405_COUNT (0+XfOrM381_COUNT)
#   define SETUP_XfOrM405(x) SETUP_XfOrM381(x)

# 2832 "./../src/error.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "string?" , i , argc , argv ) ); 
  }

  if (! mismatch && (argc & 1 ) ) {
#   define XfOrM403_COUNT (0+XfOrM381_COUNT)
#   define SETUP_XfOrM403(x) SETUP_XfOrM381(x)
    FUNCCALL_EMPTY(scheme_contract_error (who , "missing value after field string" , "field string" , 1 , argv [argc - 1 ] , ((void * ) 0 ) ) )
    ; 
  }

  if (! mismatch && (argc == 2 ) ) {
#   define XfOrM402_COUNT (0+XfOrM381_COUNT)
#   define SETUP_XfOrM402(x) SETUP_XfOrM381(x)

# 2845 "./../src/error.c"
    s = FUNCCALL(SETUP_XfOrM402(_), scheme_char_string_to_byte_string (argv [1 ] ) ); 
    (__funcarg119 = FUNCCALL(SETUP_XfOrM402(_), scheme_symbol_val (argv [0 ] ) )
    , FUNCCALL_EMPTY(scheme_contract_error (__funcarg119 , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , ((void * ) 0 ) ) )) 

    ; 
  }

# 2850 "./../src/error.c"
  else if (mismatch && (argc == 3 ) ) {
#   define XfOrM401_COUNT (0+XfOrM381_COUNT)
#   define SETUP_XfOrM401(x) SETUP_XfOrM381(x)

# 2852 "./../src/error.c"
    s = FUNCCALL(SETUP_XfOrM401(_), scheme_char_string_to_byte_string (argv [1 ] ) ); 
    (__funcarg118 = FUNCCALL(SETUP_XfOrM401(_), scheme_symbol_val (argv [0 ] ) )
    , FUNCCALL_AGAIN(scheme_arg_mismatch (__funcarg118 , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , argv [2 ] ) )) 

    ; 
  }

# 2857 "./../src/error.c"
  else {

    char * st , * * ss ; 
    intptr_t slen , * slens , total = 0 ; 
    int offset = (mismatch ? 0 : 1 ) ; 
    int scount = argc - 1 - offset ; 
    BLOCK_SETUP((PUSH(ss, 0+XfOrM381_COUNT), PUSH(slens, 1+XfOrM381_COUNT), PUSH(st, 2+XfOrM381_COUNT)));
#   define XfOrM382_COUNT (3+XfOrM381_COUNT)
#   define SETUP_XfOrM382(x) SETUP(XfOrM382_COUNT)
    st = NULLED_OUT ; 
    ss = NULLED_OUT ; 
    slens = NULLED_OUT ; 

# 2864 "./../src/error.c"
    ss = (char * * ) ((char * * ) FUNCCALL(SETUP_XfOrM382(_), GC_malloc (sizeof (char * ) * (scount ) ) )) ; 
    slens = (intptr_t * ) ((intptr_t * ) FUNCCALL(SETUP_XfOrM382(_), GC_malloc_atomic (sizeof (intptr_t ) * (scount ) ) )) ; 

    for (i = 1 ; (i + offset ) < argc ; i ++ ) {
#     define XfOrM396_COUNT (0+XfOrM382_COUNT)
#     define SETUP_XfOrM396(x) SETUP_XfOrM382(x)

# 2868 "./../src/error.c"
      if (i & 1 ) {
#       define XfOrM400_COUNT (0+XfOrM396_COUNT)
#       define SETUP_XfOrM400(x) SETUP_XfOrM396(x)

# 2869 "./../src/error.c"
        s = FUNCCALL(SETUP_XfOrM400(_), scheme_char_string_to_byte_string (argv [i + offset ] ) ); 
        st = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) ; 
        slen = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) ; 
        if (! mismatch )
          total += 5 ; 
      }

# 2874 "./../src/error.c"
      else {
#       define XfOrM397_COUNT (0+XfOrM396_COUNT)
#       define SETUP_XfOrM397(x) SETUP_XfOrM396(x)

# 2875 "./../src/error.c"
        s = argv [i + offset ] ; 
        if ((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_unquoted_printing_string_type ) )  {
#         define XfOrM399_COUNT (0+XfOrM397_COUNT)
#         define SETUP_XfOrM399(x) SETUP_XfOrM397(x)

# 2877 "./../src/error.c"
          s = (((Scheme_Small_Object * ) (s ) ) -> u . ptr_val ) ; 
          s = FUNCCALL(SETUP_XfOrM399(_), scheme_char_string_to_byte_string (s ) ); 
          st = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) ; 
          slen = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) ; 
        }

# 2881 "./../src/error.c"
        else {
#         define XfOrM398_COUNT (0+XfOrM397_COUNT)
#         define SETUP_XfOrM398(x) SETUP_XfOrM397(x)

# 2882 "./../src/error.c"
          st = FUNCCALL(SETUP_XfOrM398(_), scheme_make_provided_string (s , scount / 2 , & slen ) ); 
        }
      }
      total += slen ; 
      ss [i - 1 ] = st ; 
      slens [i - 1 ] = slen ; 
    }
    st = (char * ) FUNCCALL(SETUP_XfOrM382(_), GC_malloc_atomic (total + 1 ) ); 

    total = 0 ; 
    for (i = 0 ; i < scount ; i ++ ) {
#     define XfOrM388_COUNT (0+XfOrM382_COUNT)
#     define SETUP_XfOrM388(x) SETUP_XfOrM382(x)

# 2893 "./../src/error.c"
      slen = slens [i ] ; 
      if (! mismatch && ! (i & 1 ) ) {
#       define XfOrM390_COUNT (0+XfOrM388_COUNT)
#       define SETUP_XfOrM390(x) SETUP_XfOrM388(x)
        (
# 2895 "./../src/error.c"
        memcpy (st + total , "\n   " , 3 ) ) ; 
        total += 3 ; 
      }
      (memcpy (st + total , ss [i ] , slen ) ) ; 
      total += slen ; 
      if (! mismatch && ! (i & 1 ) ) {
#       define XfOrM389_COUNT (0+XfOrM388_COUNT)
#       define SETUP_XfOrM389(x) SETUP_XfOrM388(x)
        (
# 2901 "./../src/error.c"
        memcpy (st + total , ": " , 2 ) ) ; 
        total += 2 ; 
      }
    }
    st [total ] = 0 ; 

    s = FUNCCALL(SETUP_XfOrM382(_), scheme_char_string_to_byte_string (argv [1 ] ) ); 
    if (mismatch ) {
      s2 = "" ; 
      l2 = 0 ; 
    }

# 2911 "./../src/error.c"
    else {
      s2 = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) ; 
      l2 = (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) ; 
    }
    (__funcarg117 = FUNCCALL(SETUP_XfOrM382(_), scheme_symbol_val (argv [0 ] ) )


    , FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: %t%t" , __funcarg117 , s2 , l2 , st , total ) )) 

    ; 
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2926 "./../src/error.c"
static Scheme_Object * raise_mismatch_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2928 "./../src/error.c"
  return do_raise_mismatch_error ("raise-mismatch-error" , 1 , argc , argv ) ; 
}

static Scheme_Object * raise_arguments_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2933 "./../src/error.c"
  return do_raise_mismatch_error ("raise-arguments-error" , 0 , argc , argv ) ; 
}


static int is_arity_at_least (Scheme_Object * v ) 
{
  /* No conversion */

# 2939 "./../src/error.c"
  return (((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && scheme_is_struct_instance (scheme_arity_at_least , v ) 
  && scheme_nonneg_exact_p (((Scheme_Structure * ) v ) -> slots [0 ] ) ) ; 
}

static int is_arity_list (Scheme_Object * l ) 
{
  int c ; 
  Scheme_Object * a ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(a, 1)));
# define XfOrM409_COUNT (2)
# define SETUP_XfOrM409(x) SETUP(XfOrM409_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 2949 "./../src/error.c"
  c = (scheme_proper_list_length (l ) ) ; 
  if (c < 0 )

# 2950 "./../src/error.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
  while (! ((l ) == (scheme_null ) ) ) {
#   define XfOrM411_COUNT (0+XfOrM409_COUNT)
#   define SETUP_XfOrM411(x) SETUP_XfOrM409(x)

# 2952 "./../src/error.c"
    a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    if (! FUNCCALL(SETUP_XfOrM411(_), scheme_nonneg_exact_p (a ) )
    && ! FUNCCALL(SETUP_XfOrM411(_), is_arity_at_least (a ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2962 "./../src/error.c"
static Scheme_Object * do_raise_arity_error (const char * who , int argc , Scheme_Object * argv [] , int as_arity ) 
{
  Scheme_Object * * args , * arity ; 
  const char * name ; 
  int minc , maxc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(who, 1), PUSH(args, 2), PUSH(arity, 3), PUSH(argv, 4)));
# define XfOrM412_COUNT (5)
# define SETUP_XfOrM412(x) SETUP(XfOrM412_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  args = NULLED_OUT ; 
  arity = NULLED_OUT ; 
  name = NULLED_OUT ; 

# 2968 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) && ! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c symbol? procedure?)" , 0 , argc , argv ) ); 
  if (as_arity ) {
#   define XfOrM420_COUNT (0+XfOrM412_COUNT)
#   define SETUP_XfOrM420(x) SETUP_XfOrM412(x)

# 2971 "./../src/error.c"
    arity = argv [1 ] ; 
    if (! FUNCCALL(SETUP_XfOrM420(_), scheme_nonneg_exact_p (arity ) )
    && ! FUNCCALL(SETUP_XfOrM420(_), is_arity_at_least (arity ) )
    && ! FUNCCALL(SETUP_XfOrM420(_), is_arity_list (arity ) ))
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c exact-nonnegative-integer? arity-at-least? (listof (or/c exact-nonnegative-integer? arity-at-least?)))" , 1 , argc , argv ) )

    ; 
  }

# 2978 "./../src/error.c"
  else {
#   define XfOrM419_COUNT (0+XfOrM412_COUNT)
#   define SETUP_XfOrM419(x) SETUP_XfOrM412(x)

# 2979 "./../src/error.c"
    if (! FUNCCALL(SETUP_XfOrM419(_), scheme_exact_p (argv [1 ] ) ))
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-integer?" , 1 , argc , argv ) )

    ; 
    arity = FUNCCALL(SETUP_XfOrM419(_), scheme_arity_mask_to_arity (argv [1 ] , - 1 ) ); 
  }

  args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM412(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 2 ) ) )) ; 
  (memcpy (args , argv + 2 , sizeof (Scheme_Object * ) * (argc - 2 ) ) ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    name = FUNCCALL(SETUP_XfOrM412(_), scheme_symbol_val (argv [0 ] ) ); 
  else {
    int len ; 
#   define XfOrM418_COUNT (0+XfOrM412_COUNT)
#   define SETUP_XfOrM418(x) SETUP_XfOrM412(x)

# 2993 "./../src/error.c"
    name = FUNCCALL(SETUP_XfOrM418(_), scheme_get_proc_name (argv [0 ] , & len , 1 ) ); 
  }

  if (((intptr_t ) (arity ) ) & 0x1 )  {
    minc = maxc = (((intptr_t ) (arity ) ) >> 1 ) ; 
  }

# 2998 "./../src/error.c"
  else if (FUNCCALL(SETUP_XfOrM412(_), is_arity_at_least (arity ) )) {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM412_COUNT)));
#   define XfOrM414_COUNT (1+XfOrM412_COUNT)
#   define SETUP_XfOrM414(x) SETUP(XfOrM414_COUNT)
    v = NULLED_OUT ; 

# 3000 "./../src/error.c"
    v = FUNCCALL(SETUP_XfOrM414(_), scheme_struct_ref (arity , 0 ) ); 
    if (((intptr_t ) (v ) ) & 0x1 )  {
      minc = (((intptr_t ) (v ) ) >> 1 ) ; 
      maxc = - 1 ; 
    }

# 3004 "./../src/error.c"
    else {
      minc = - 2 ; 
      maxc = 0 ; 
    }
  }

# 3008 "./../src/error.c"
  else {
    minc = - 2 ; 
    maxc = 0 ; 
  }
  FUNCCALL_EMPTY(scheme_wrong_count_m (name , minc , maxc , argc - 2 , args , 0 ) )
  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3018 "./../src/error.c"
static Scheme_Object * raise_arity_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3020 "./../src/error.c"
  return do_raise_arity_error ("raise-arity-error" , argc , argv , 1 ) ; 
}

static Scheme_Object * raise_arity_mask_error (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3025 "./../src/error.c"
  return do_raise_arity_error ("raise-arity-mask-error" , argc , argv , 0 ) ; 
}

static Scheme_Object * raise_result_arity_error (int argc , Scheme_Object * argv [] ) 
{
  const char * where = ((void * ) 0 ) , * detail = ((void * ) 0 ) ; 
  Scheme_Object * * got_argv ; 
  int i , expected ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(where, 0), PUSH(got_argv, 1), PUSH(detail, 2), PUSH(argv, 3)));
# define XfOrM423_COUNT (4)
# define SETUP_XfOrM423(x) SETUP(XfOrM423_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  got_argv = NULLED_OUT ; 

# 3034 "./../src/error.c"
  if (((argv [0 ] ) ) == (scheme_false ) ) 
    where = ((void * ) 0 ) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    where = FUNCCALL(SETUP_XfOrM423(_), scheme_symbol_val (argv [0 ] ) ); 
  else FUNCCALL_EMPTY(scheme_wrong_contract ("raise-result-arity-error" , "(or/c symbol? #f)" , 0 , argc , argv ) )
  ; 

  if (((intptr_t ) (argv [1 ] ) ) & 0x1 )  {
    expected = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
  }

# 3043 "./../src/error.c"
  else if (((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) argv [1 ] ) -> iso ) -> so . keyex & 0x1 ) )
    expected = (int ) (((unsigned ) - 1 ) >> 1 ) ; 
  else 
  expected = - 1 ; 
  if (expected < 0 )
    FUNCCALL_EMPTY(scheme_wrong_contract ("raise-result-arity-error" , "exact-nonnegative-integer?" , 1 , argc , argv ) ); 

  if (((argv [2 ] ) ) == (scheme_false ) ) 
    detail = ((void * ) 0 ) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
    Scheme_Object * bstr ; 
    BLOCK_SETUP((PUSH(bstr, 0+XfOrM423_COUNT)));
#   define XfOrM426_COUNT (1+XfOrM423_COUNT)
#   define SETUP_XfOrM426(x) SETUP(XfOrM426_COUNT)
    bstr = NULLED_OUT ; 

# 3054 "./../src/error.c"
    bstr = FUNCCALL(SETUP_XfOrM426(_), scheme_char_string_to_byte_string (argv [2 ] ) ); 
    detail = (((Scheme_Simple_Object * ) (bstr ) ) -> u . byte_str_val . string_val ) ; 
  }

# 3056 "./../src/error.c"
  else FUNCCALL_EMPTY(scheme_wrong_contract ("raise-result-arity-error" , "(or/c string? #f)" , 2 , argc , argv ) )
  ; 

  got_argv = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM423(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 3 ) ) )) ; 
  for (i = 3 ; i < argc ; i ++ ) {
    got_argv [i - 3 ] = argv [i ] ; 
  }
  FUNCCALL_EMPTY(scheme_wrong_return_arity (where , expected , argc - 3 , got_argv , (detail ? "%s" : ((void * ) 0 ) ) , detail , ((void * ) 0 ) ) )



  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3072 "./../src/error.c"
static Scheme_Object * good_print_width (int c , Scheme_Object * * argv ) 
{
  /* No conversion */

# 3074 "./../src/error.c"
  int ok ; 

  ok = ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
  ? ((((intptr_t ) (argv [0 ] ) ) >> 1 ) >= 3 ) 
  : (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
  ? ((& ((Scheme_Bignum * ) argv [0 ] ) -> iso ) -> so . keyex & 0x1 ) 
  : 0 ) ) ; 

  return ok ? scheme_true : scheme_false ; 
}

static Scheme_Object * error_print_width (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3087 "./../src/error.c"
  return scheme_param_config2 ("error-print-width" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_PRINT_WIDTH ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , good_print_width , "(and/c exact-integer? (>=/c 3))" , 0 ) ; 
}

static Scheme_Object * good_print_context_length (int c , Scheme_Object * * argv ) 
{
  /* No conversion */

# 3095 "./../src/error.c"
  int ok ; 

  ok = ((((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
  ? ((((intptr_t ) (argv [0 ] ) ) >> 1 ) >= 0 ) 
  : (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
  ? ((& ((Scheme_Bignum * ) argv [0 ] ) -> iso ) -> so . keyex & 0x1 ) 
  : 0 ) ) ; 

  return ok ? scheme_true : scheme_false ; 
}

static Scheme_Object * error_print_context_length (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3108 "./../src/error.c"
  return scheme_param_config2 ("error-print-context-length" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_PRINT_CONTEXT_LENGTH ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , good_print_context_length , "exact-nonnegative-integer?" , 0 ) ; 
}

static Scheme_Object * error_print_srcloc (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3116 "./../src/error.c"
  return scheme_param_config ("error-print-source-location" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_PRINT_SRCLOC ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

void scheme_write_proc_context (Scheme_Object * port , int print_width , 
Scheme_Object * name , 
Scheme_Object * src , Scheme_Object * line , 
Scheme_Object * col , Scheme_Object * pos , 
int generated ) 
{
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(col, 1), PUSH(pos, 2), PUSH(port, 3), PUSH(line, 4)));
# define XfOrM433_COUNT (5)
# define SETUP_XfOrM433(x) SETUP(XfOrM433_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3128 "./../src/error.c"
  if (src ) {
#   define XfOrM435_COUNT (0+XfOrM433_COUNT)
#   define SETUP_XfOrM435(x) SETUP_XfOrM433(x)
    FUNCCALL(SETUP_XfOrM435(_), scheme_display_w_max (src , port , print_width ) )
# 3129 "./../src/error.c"
    ; 
    if (line && (! (((line ) ) == (scheme_false ) ) ) ) {
#     define XfOrM438_COUNT (0+XfOrM435_COUNT)
#     define SETUP_XfOrM438(x) SETUP_XfOrM435(x)
      FUNCCALL(SETUP_XfOrM438(_), scheme_write_byte_string (":" , 1 , port ) )
# 3132 "./../src/error.c"
      ; 
      FUNCCALL(SETUP_XfOrM438(_), scheme_display_w_max (line , port , print_width ) ); 
      FUNCCALL_AGAIN(scheme_write_byte_string (":" , 1 , port ) ); 
      FUNCCALL_AGAIN(scheme_display_w_max (col , port , print_width ) ); 
    }

# 3136 "./../src/error.c"
    else if (pos && (! (((pos ) ) == (scheme_false ) ) ) ) {
#     define XfOrM437_COUNT (0+XfOrM435_COUNT)
#     define SETUP_XfOrM437(x) SETUP_XfOrM435(x)
      FUNCCALL(SETUP_XfOrM437(_), scheme_write_byte_string ("::" , 2 , port ) )
# 3138 "./../src/error.c"
      ; 
      FUNCCALL(SETUP_XfOrM437(_), scheme_display_w_max (pos , port , print_width ) ); 
    }

    if (! (((name ) ) == (scheme_false ) ) )  {
#     define XfOrM436_COUNT (0+XfOrM435_COUNT)
#     define SETUP_XfOrM436(x) SETUP_XfOrM435(x)
      FUNCCALL(SETUP_XfOrM436(_), scheme_write_byte_string (": " , 2 , port ) )
# 3143 "./../src/error.c"
      ; 
    }
  }

  if (! (((name ) ) == (scheme_false ) ) )  {
#   define XfOrM434_COUNT (0+XfOrM433_COUNT)
#   define SETUP_XfOrM434(x) SETUP_XfOrM433(x)
    FUNCCALL_EMPTY(scheme_display_w_max (name , port , print_width ) )
# 3148 "./../src/error.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3152 "./../src/error.c"
static void write_context_repeats (int repeats , Scheme_Object * port ) 
{
  /* No conversion */

# 3154 "./../src/error.c"
  char buf [64 ] ; 
  sprintf (buf , "[repeats %d more time%s]" , repeats , (repeats == 1 ) ? "" : "s" ) ; 
  scheme_write_byte_string (buf , strlen (buf ) , port ) ; 
}

static Scheme_Object * 
def_error_display_proc (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Config * config ; 
  Scheme_Object * port , * s ; 
  Scheme_Config * __funcarg121 = NULLED_OUT ; 
  Scheme_Object * __funcarg120 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(s, 1), PUSH(config, 2), PUSH(argv, 3)));
# define XfOrM440_COUNT (4)
# define SETUP_XfOrM440(x) SETUP(XfOrM440_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  config = NULLED_OUT ; 
  port = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 3165 "./../src/error.c"
  config = FUNCCALL(SETUP_XfOrM440(_), scheme_current_config () ); 
  port = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_ERROR_PORT ) ); 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("default-error-display-handler" , "string?" , 0 , argc , argv ) ); 


  s = FUNCCALL(SETUP_XfOrM440(_), scheme_char_string_to_byte_string (argv [0 ] ) ); 
  FUNCCALL_AGAIN(scheme_write_byte_string ((((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) , port ) )


  ; 


  if (((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && (scheme_is_struct_instance (exn_table [MZEXN ] . type , argv [1 ] ) ) 
  && ! (scheme_is_struct_instance (exn_table [MZEXN_FAIL_USER ] . type , argv [1 ] ) ) ) {
    Scheme_Object * l , * w ; 
    int print_width = 1024 , max_cnt = 16 ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM440_COUNT), PUSH(w, 1+XfOrM440_COUNT)));
#   define XfOrM441_COUNT (2+XfOrM440_COUNT)
#   define SETUP_XfOrM441(x) SETUP(XfOrM441_COUNT)
    l = NULLED_OUT ; 
    w = NULLED_OUT ; 

# 3185 "./../src/error.c"
    w = FUNCCALL(SETUP_XfOrM441(_), scheme_get_param (config , MZCONFIG_ERROR_PRINT_CONTEXT_LENGTH ) ); 
    if (((intptr_t ) (w ) ) & 0x1 ) 
      max_cnt = (((intptr_t ) (w ) ) >> 1 ) ; 
    else 
    max_cnt = 0x7FFFFFFF ; 

    if (max_cnt ) {
      Scheme_Object * prev_name ; 
      int orig_max_cnt = max_cnt , repeats ; 
      BLOCK_SETUP((PUSH(prev_name, 0+XfOrM441_COUNT)));
#     define XfOrM442_COUNT (1+XfOrM441_COUNT)
#     define SETUP_XfOrM442(x) SETUP(XfOrM442_COUNT)
      prev_name = NULLED_OUT ; 

# 3194 "./../src/error.c"
      w = FUNCCALL(SETUP_XfOrM442(_), scheme_get_param (config , MZCONFIG_ERROR_PRINT_WIDTH ) ); 
      if (((intptr_t ) (w ) ) & 0x1 ) 
        print_width = (((intptr_t ) (w ) ) >> 1 ) ; 
      else 
      print_width = 0x7FFFFFFF ; 


      l = (scheme_struct_type_property_ref (scheme_source_property , argv [1 ] ) ) ; 
      if (l ) {
#       define XfOrM469_COUNT (0+XfOrM442_COUNT)
#       define SETUP_XfOrM469(x) SETUP_XfOrM442(x)

# 3203 "./../src/error.c"
        l = FUNCCALL(SETUP_XfOrM469(_), scheme_do_eval (l , 1 , & (argv [1 ] ) , 1 ) ); 
        for (w = l ; ((Scheme_Type ) (((((intptr_t ) (w ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (w ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; w = (((Scheme_Simple_Object * ) (w ) ) -> u . pair_val . cdr ) ) {
#         define XfOrM471_COUNT (0+XfOrM469_COUNT)
#         define SETUP_XfOrM471(x) SETUP_XfOrM469(x)

# 3205 "./../src/error.c"
          if (! FUNCCALL(SETUP_XfOrM471(_), scheme_is_location ((((Scheme_Simple_Object * ) (w ) ) -> u . pair_val . car ) ) ))
            break ; 
        }
        if (! ((w ) == (scheme_null ) ) )
          FUNCCALL(SETUP_XfOrM469(_), scheme_wrong_contract ("prop:exn:srclocs procedure" , "(listof srcloc?)" , - 1 , 1 , & l ) ); 
      }

      if (l && ! ((l ) == (scheme_null ) ) ) {
#       define XfOrM466_COUNT (0+XfOrM442_COUNT)
#       define SETUP_XfOrM466(x) SETUP_XfOrM442(x)

# 3214 "./../src/error.c"
        if ((! ((((__funcarg121 = FUNCCALL(SETUP_XfOrM466(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg121 , MZCONFIG_ERROR_PRINT_SRCLOC ) )) ) ) == (scheme_false ) ) ) 
        && ((scheme_is_struct_instance (exn_table [MZEXN_FAIL_READ ] . type , argv [1 ] ) ) 
        || (scheme_is_struct_instance (exn_table [MZEXN_FAIL_CONTRACT_VARIABLE ] . type , argv [1 ] ) ) ) )
          l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 

        if (! ((l ) == (scheme_null ) ) )
          FUNCCALL(SETUP_XfOrM466(_), scheme_write_byte_string ("\n  location...:" , 15 , port ) ); 

        while (! ((l ) == (scheme_null ) ) ) {
#         define XfOrM468_COUNT (0+XfOrM466_COUNT)
#         define SETUP_XfOrM468(x) SETUP_XfOrM466(x)
          FUNCCALL(SETUP_XfOrM468(_), scheme_write_byte_string ("\n   " , 4 , port ) )
# 3223 "./../src/error.c"
          ; 
          w = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
          w = FUNCCALL(SETUP_XfOrM468(_), srcloc_to_string (1 , & w ) ); 
          FUNCCALL_AGAIN(scheme_display_w_max (w , port , print_width ) ); 
          l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        }
      }

      prev_name = ((void * ) 0 ) ; 
      repeats = 0 ; 

      l = (__funcarg120 = FUNCCALL(SETUP_XfOrM442(_), scheme_struct_ref (argv [1 ] , 1 ) ), FUNCCALL_AGAIN(scheme_get_stack_trace (__funcarg120 ) )) ; 
      while (! ((l ) == (scheme_null ) ) ) {
#       define XfOrM455_COUNT (0+XfOrM442_COUNT)
#       define SETUP_XfOrM455(x) SETUP_XfOrM442(x)

# 3236 "./../src/error.c"
        if (! max_cnt ) {
#         define XfOrM465_COUNT (0+XfOrM455_COUNT)
#         define SETUP_XfOrM465(x) SETUP_XfOrM455(x)
          FUNCCALL(SETUP_XfOrM465(_), scheme_write_byte_string ("\n   ..." , 7 , port ) )
# 3237 "./../src/error.c"
          ; 
          break ; 
        }

# 3239 "./../src/error.c"
        else {
          Scheme_Object * name , * loc ; 
          BLOCK_SETUP((PUSH(name, 0+XfOrM455_COUNT), PUSH(loc, 1+XfOrM455_COUNT)));
#         define XfOrM456_COUNT (2+XfOrM455_COUNT)
#         define SETUP_XfOrM456(x) SETUP(XfOrM456_COUNT)
          name = NULLED_OUT ; 
          loc = NULLED_OUT ; 

# 3242 "./../src/error.c"
          name = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
          if (prev_name && FUNCCALL(SETUP_XfOrM456(_), scheme_equal (name , prev_name ) )) {
            repeats ++ ; 
          }

# 3245 "./../src/error.c"
          else {
#           define XfOrM457_COUNT (0+XfOrM456_COUNT)
#           define SETUP_XfOrM457(x) SETUP_XfOrM456(x)

# 3246 "./../src/error.c"
            if (max_cnt == orig_max_cnt ) {
#             define XfOrM463_COUNT (0+XfOrM457_COUNT)
#             define SETUP_XfOrM463(x) SETUP_XfOrM457(x)
              FUNCCALL(SETUP_XfOrM463(_), scheme_write_byte_string ("\n  context...:\n" , 15 , port ) )
# 3248 "./../src/error.c"
              ; 
            }

# 3249 "./../src/error.c"
            else {
#             define XfOrM462_COUNT (0+XfOrM457_COUNT)
#             define SETUP_XfOrM462(x) SETUP_XfOrM457(x)
              FUNCCALL(SETUP_XfOrM462(_), scheme_write_byte_string ("\n" , 1 , port ) )
# 3250 "./../src/error.c"
              ; 
            }

            if (repeats ) {
#             define XfOrM461_COUNT (0+XfOrM457_COUNT)
#             define SETUP_XfOrM461(x) SETUP_XfOrM457(x)
              FUNCCALL(SETUP_XfOrM461(_), scheme_write_byte_string ("   " , 3 , port ) )
# 3254 "./../src/error.c"
              ; 
              FUNCCALL(SETUP_XfOrM461(_), write_context_repeats (repeats , port ) ); 
              repeats = 0 ; 
              -- max_cnt ; 
              if (max_cnt )
                FUNCCALL(SETUP_XfOrM461(_), scheme_write_byte_string ("\n" , 1 , port ) ); 
            }

            prev_name = name ; 

            if (max_cnt ) {
#             define XfOrM458_COUNT (0+XfOrM457_COUNT)
#             define SETUP_XfOrM458(x) SETUP_XfOrM457(x)

# 3265 "./../src/error.c"
              loc = (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . cdr ) ; 
              name = (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . car ) ; 
              FUNCCALL(SETUP_XfOrM458(_), scheme_write_byte_string ("   " , 3 , port ) )
              ; 

              if (! (((loc ) ) == (scheme_false ) ) )  {
                Scheme_Structure * sloc = (Scheme_Structure * ) loc ; 
#               define XfOrM460_COUNT (0+XfOrM458_COUNT)
#               define SETUP_XfOrM460(x) SETUP_XfOrM458(x)
                FUNCCALL(SETUP_XfOrM460(_), scheme_write_proc_context (port , print_width , name , sloc -> slots [0 ] , sloc -> slots [1 ] , sloc -> slots [2 ] , sloc -> slots [3 ] , 0 ) )

                ; 
              }

# 3277 "./../src/error.c"
              else {
#               define XfOrM459_COUNT (0+XfOrM458_COUNT)
#               define SETUP_XfOrM459(x) SETUP_XfOrM458(x)
                FUNCCALL(SETUP_XfOrM459(_), scheme_write_proc_context (port , print_width , name , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) )
                ; 
              }
              -- max_cnt ; 
            }
          }

          l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        }
      }

      if (repeats ) {
#       define XfOrM443_COUNT (0+XfOrM442_COUNT)
#       define SETUP_XfOrM443(x) SETUP_XfOrM442(x)
        FUNCCALL(SETUP_XfOrM443(_), scheme_write_byte_string ("\n" , 1 , port ) )
# 3292 "./../src/error.c"
        ; 
        FUNCCALL(SETUP_XfOrM443(_), scheme_write_byte_string ("   " , 3 , port ) ); 
        FUNCCALL_AGAIN(write_context_repeats (repeats , port ) ); 
      }
    }
  }
  FUNCCALL_EMPTY(scheme_write_byte_string ("\n" , 1 , port ) )
  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3304 "./../src/error.c"
static Scheme_Object * 
emergency_error_display_proc (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * s ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM472_COUNT (1)
# define SETUP_XfOrM472(x) SETUP(XfOrM472_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 3309 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 

  s = FUNCCALL(SETUP_XfOrM472(_), scheme_char_string_to_byte_string (argv [0 ] ) ); 
  FUNCCALL_EMPTY(scheme_log_message (((void * ) 0 ) , 2 , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (s ) ) -> u . byte_str_val . tag_val ) , scheme_false ) )


  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3321 "./../src/error.c"
static Scheme_Object * 
def_error_value_string_proc (int argc , Scheme_Object * argv [] ) 
{
  intptr_t origl , len , l ; 
  char * s ; 
  Scheme_Object * pph ; 
  Scheme_Config * __funcarg122 = NULLED_OUT ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(pph, 0), PUSH(s, 1), PUSH(argv, 2)));
# define XfOrM473_COUNT (3)
# define SETUP_XfOrM473(x) SETUP(XfOrM473_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 
  pph = NULLED_OUT ; 

# 3328 "./../src/error.c"
  if (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("default-error-value->string-handler" , "number?" , 1 , argc , argv ) ); 

  origl = len = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 

  pph = (__funcarg122 = FUNCCALL(SETUP_XfOrM473(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg122 , MZCONFIG_PORT_PRINT_HANDLER ) )) ; 
  if ((pph ) == (scheme_default_global_print_handler ) )  {
#   define XfOrM478_COUNT (0+XfOrM473_COUNT)
#   define SETUP_XfOrM478(x) SETUP_XfOrM473(x)

# 3335 "./../src/error.c"
    if (len < 3 )
      len = 3 ; 

    s = FUNCCALL(SETUP_XfOrM478(_), scheme_print_to_string_w_max (argv [0 ] , & l , len ) ); 

    if ((origl < 3 ) && (l > origl ) )
      l = origl ; 
  }

# 3342 "./../src/error.c"
  else {
    Scheme_Object * a [2 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM473_COUNT)));
#   define XfOrM474_COUNT (3+XfOrM473_COUNT)
#   define SETUP_XfOrM474(x) SETUP(XfOrM474_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 

# 3345 "./../src/error.c"
    a [0 ] = argv [0 ] ; 
    a [1 ] = FUNCCALL(SETUP_XfOrM474(_), scheme_make_byte_string_output_port () ); 
    FUNCCALL(SETUP_XfOrM474(_), scheme_do_eval (pph , 2 , a , 1 ) ); 

    s = FUNCCALL_AGAIN(scheme_get_sized_byte_string_output (a [1 ] , & l ) ); 

    if (l > origl ) {

      l = origl ; 
      if (origl >= 1 ) {
        s [origl - 1 ] = '.' ; 
        if (origl >= 2 ) {
          s [origl - 2 ] = '.' ; 
          if (origl >= 3 )
            s [origl - 3 ] = '.' ; 
        }
      }
    }
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (s , l ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3368 "./../src/error.c"
static Scheme_Object * 
def_error_syntax_string_proc (int argc , Scheme_Object * argv [] ) 
{
  intptr_t len , l ; 
  char * s ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(s, 0)));
# define XfOrM479_COUNT (1)
# define SETUP_XfOrM479(x) SETUP(XfOrM479_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 

# 3374 "./../src/error.c"
  if ((! (((argv [1 ] ) ) == (scheme_false ) ) ) && ! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("default-error-syntax->string-handler" , "number?" , 1 , argc , argv ) ); 

  if (((intptr_t ) (argv [1 ] ) ) & 0x1 )  {
    len = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
    if (len < 3 )
      len = 3 ; 
  }

# 3381 "./../src/error.c"
  else 
  len = - 1 ; 

  s = FUNCCALL(SETUP_XfOrM479(_), scheme_write_to_string_w_max (argv [0 ] , & l , len ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sized_utf8_string (s , l ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3389 "./../src/error.c"
static void 
def_error_escape_proc (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * prompt ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(prompt, 1)));
# define XfOrM481_COUNT (2)
# define SETUP_XfOrM481(x) SETUP(XfOrM481_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prompt = NULLED_OUT ; 

# 3395 "./../src/error.c"
  prompt = FUNCCALL(SETUP_XfOrM481(_), scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (scheme_default_prompt_tag ) ) -> u . ptr_val ) ) ); 

  if (prompt ) {
    p -> cjs . jumping_to_continuation = prompt ; 
    p -> cjs . alt_full_continuation = ((void * ) 0 ) ; 
    p -> cjs . num_vals = 1 ; 
    p -> cjs . val = scheme_void_proc ; 
  }
  (((intptr_t * ) (void * ) ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs ) ) [1 ] = (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs , longjmp ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . jb , 1 ) ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3406 "./../src/error.c"
static Scheme_Object * 
error_display_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3409 "./../src/error.c"
  return scheme_param_config ("error-display-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_DISPLAY_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  2 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
error_value_string_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3418 "./../src/error.c"
  return scheme_param_config ("error-value->string-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_PRINT_VALUE_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  2 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
error_syntax_string_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3427 "./../src/error.c"
  return scheme_param_config ("error-value->syntax-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_PRINT_SYNTAX_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  2 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
error_escape_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3436 "./../src/error.c"
  return scheme_param_config ("error-escape-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_ERROR_ESCAPE_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
exit_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3445 "./../src/error.c"
  return scheme_param_config ("exit-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_EXIT_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  1 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
def_exit_handler_proc (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3454 "./../src/error.c"
  intptr_t status ; 

  if (((intptr_t ) (argv [0 ] ) ) & 0x1 )  {
    status = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 
    if (status < 1 || status > 255 )
      status = 0 ; 
  }

# 3460 "./../src/error.c"
  else 
  status = 0 ; 

  scheme_flush_managed (((void * ) 0 ) , 0 ) ; 

  if (scheme_exit )
    scheme_exit (status ) ; 
  else 
  exit (status ) ; 

  return scheme_void ; 
}

Scheme_Object * 
scheme_do_exit (int argc , Scheme_Object * argv [] ) 
{
  intptr_t status ; 
  Scheme_Object * handler ; 
  Scheme_Config * __funcarg123 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(handler, 0), PUSH(argv, 1)));
# define XfOrM490_COUNT (2)
# define SETUP_XfOrM490(x) SETUP(XfOrM490_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  handler = NULLED_OUT ; 

# 3479 "./../src/error.c"
  if (argc == 1 ) {
    if (((intptr_t ) (argv [0 ] ) ) & 0x1 ) 
      status = (((intptr_t ) (argv [0 ] ) ) >> 1 ) ; 
    else 
    status = 0 ; 
  }

# 3484 "./../src/error.c"
  else 
  status = 0 ; 

  handler = (__funcarg123 = FUNCCALL(SETUP_XfOrM490(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg123 , MZCONFIG_EXIT_HANDLER ) )) ; 

  if (handler ) {
    Scheme_Object * p [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(p, 1, 0+XfOrM490_COUNT)));
#   define XfOrM491_COUNT (3+XfOrM490_COUNT)
#   define SETUP_XfOrM491(x) SETUP(XfOrM491_COUNT)
    p[0] = NULLED_OUT ; 

# 3492 "./../src/error.c"
    p [0 ] = argc ? argv [0 ] : ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (status ) ) ) << 1 ) | 0x1 ) ) ; 
    FUNCCALL(SETUP_XfOrM491(_), scheme_apply_multi (handler , 1 , p ) ); 
  }

# 3494 "./../src/error.c"
  else if (scheme_exit )
    FUNCCALL_EMPTY(scheme_exit (status ) ); 
  else FUNCCALL_EMPTY(exit (status ) )
  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
void scheme_immediate_exit (int status ) 
{
  /* No conversion */

# 3507 "./../src/error.c"
  exit (status ) ; 
}

static Scheme_Object * 
exe_yield_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3513 "./../src/error.c"
  return scheme_param_config ("exeuctable-yield-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_EXE_YIELD_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  1 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * default_yield_handler (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 3521 "./../src/error.c"
  return scheme_void ; 
}



static Scheme_Object * level_number_to_symbol (int level ) 
{
  /* No conversion */

# 3528 "./../src/error.c"
  switch (level ) {
    case 0 : 
    return scheme_false ; 
    break ; 
    case 1 : 
    return fatal_symbol ; 
    break ; 
    case 2 : 
    return error_symbol ; 
    break ; 
    case 3 : 
    return warning_symbol ; 
    break ; 
    case 4 : 
    return info_symbol ; 
    break ; 
    case 5 : 
    default : 
    return debug_symbol ; 
    break ; 
  }
}

static int extract_spec_level (Scheme_Object * level_spec , Scheme_Object * name ) 
{
  /* No conversion */

# 3553 "./../src/error.c"
  if (! level_spec )

# 3553 "./../src/error.c"
  return 0 ; 

  while (1 ) {
    if (((intptr_t ) (level_spec ) ) & 0x1 ) 
      return (((intptr_t ) (level_spec ) ) >> 1 ) ; 
    else if (name && ((((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (level_spec ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) == (name ) ) )
      return (((intptr_t ) ((((Scheme_Simple_Object * ) (level_spec ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
    level_spec = (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (level_spec ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ; 
  }
}

static int extract_max_spec_level (Scheme_Object * level_spec , Scheme_Object * name ) 
{
  /* No conversion */

# 3566 "./../src/error.c"
  int mx = 0 , v ; 

  if (name )
    return extract_spec_level (level_spec , name ) ; 

  if (level_spec ) {
    while (1 ) {
      if (((intptr_t ) (level_spec ) ) & 0x1 )  {
        v = (((intptr_t ) (level_spec ) ) >> 1 ) ; 
        if (v > mx )

# 3575 "./../src/error.c"
        mx = v ; 
        break ; 
      }

# 3577 "./../src/error.c"
      else {
        v = (((intptr_t ) ((((Scheme_Simple_Object * ) (level_spec ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
        if (v > mx )

# 3579 "./../src/error.c"
        mx = v ; 
        level_spec = (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (level_spec ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) ; 
      }
    }
  }

  return mx ; 
}

void update_want_level (Scheme_Logger * logger , Scheme_Object * name ) 
{
  Scheme_Log_Reader * lr ; 
  Scheme_Object * queue , * b , * prev ; 
  Scheme_Logger * parent = logger ; 
  int want_level , level , ceiling_level = 5 ; 
  PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(parent, 1), PUSH(b, 2), PUSH(lr, 3), PUSH(logger, 4), PUSH(queue, 5), PUSH(prev, 6)));
# define XfOrM509_COUNT (7)
# define SETUP_XfOrM509(x) SETUP(XfOrM509_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  lr = NULLED_OUT ; 
  queue = NULLED_OUT ; 
  b = NULLED_OUT ; 
  prev = NULLED_OUT ; 

# 3595 "./../src/error.c"
  want_level = 0 ; 
  while (parent ) {
#   define XfOrM526_COUNT (0+XfOrM509_COUNT)
#   define SETUP_XfOrM526(x) SETUP_XfOrM509(x)

# 3597 "./../src/error.c"
    queue = parent -> readers ; 
    prev = ((void * ) 0 ) ; 
    while (queue ) {
#     define XfOrM530_COUNT (0+XfOrM526_COUNT)
#     define SETUP_XfOrM530(x) SETUP_XfOrM526(x)

# 3600 "./../src/error.c"
      b = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . car ) ; 
      b = (((Scheme_Simple_Object * ) (b ) ) -> u . pair_val . car ) ; 
      lr = (Scheme_Log_Reader * ) (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) ; 
      if (lr ) {
#       define XfOrM532_COUNT (0+XfOrM530_COUNT)
#       define SETUP_XfOrM532(x) SETUP_XfOrM530(x)

# 3604 "./../src/error.c"
        level = FUNCCALL(SETUP_XfOrM532(_), extract_max_spec_level (lr -> level , name ) ); 
        if (level > ceiling_level )
          level = ceiling_level ; 
        if (level > want_level )
          want_level = level ; 
        if (want_level >= ceiling_level )
          break ; 
        prev = queue ; 
      }

# 3612 "./../src/error.c"
      else {
        if (prev )
          (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . cdr ) ; 
        else 
        parent -> readers = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . cdr ) ; 
      }
      queue = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . cdr ) ; 
    }

    level = FUNCCALL(SETUP_XfOrM526(_), extract_max_spec_level (parent -> syslog_level , name ) ); 
    if (level > want_level )
      want_level = level ; 
    level = FUNCCALL(SETUP_XfOrM526(_), extract_max_spec_level (parent -> stderr_level , name ) ); 
    if (level > want_level )
      want_level = level ; 
    level = FUNCCALL(SETUP_XfOrM526(_), extract_max_spec_level (parent -> stdout_level , name ) ); 
    if (level > want_level )
      want_level = level ; 

    if (parent -> propagate_level )
      level = FUNCCALL(SETUP_XfOrM526(_), extract_max_spec_level (parent -> propagate_level , name ) ); 
    else 
    level = 5 ; 
    if (level <= ceiling_level )
      ceiling_level = level ; 

    if (want_level >= ceiling_level )
      break ; 

    parent = parent -> parent ; 
  }

  if (! name ) {
    logger -> want_level = want_level ; 
    logger -> local_timestamp = (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) ; 
  }

# 3647 "./../src/error.c"
  else {

    int i ; 
#   define XfOrM510_COUNT (0+XfOrM509_COUNT)
#   define SETUP_XfOrM510(x) SETUP_XfOrM509(x)

# 3651 "./../src/error.c"
    b = logger -> want_name_level_cache ; 
    if (! b ) {
#     define XfOrM517_COUNT (0+XfOrM510_COUNT)
#     define SETUP_XfOrM517(x) SETUP_XfOrM510(x)

# 3653 "./../src/error.c"
      b = FUNCCALL(SETUP_XfOrM517(_), scheme_make_vector (3 * 8 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
      logger -> want_name_level_cache = b ; 
    }


    for (i = (((Scheme_Vector * ) (b ) ) -> size ) ; (i -= 3 ) >= 0 ; ) {
      if ((name ) == ((((Scheme_Vector * ) (b ) ) -> els ) [i ] ) ) 
        break ; 
    }
    if (i == 0 )
      FUNCCALL(SETUP_XfOrM510(_), abort () )
# 3662 "./../src/error.c"
    ; 
    if (i < 0 ) {
#     define XfOrM511_COUNT (0+XfOrM510_COUNT)
#     define SETUP_XfOrM511(x) SETUP_XfOrM510(x)

# 3665 "./../src/error.c"
      for (i = (((Scheme_Vector * ) (b ) ) -> size ) ; (i -= 3 ) >= 0 ; ) {
        if ((((intptr_t ) ((((Scheme_Vector * ) (b ) ) -> els ) [i + 1 ] ) ) >> 1 ) < (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
          break ; 
      }
      if (i < 0 ) {
#       define XfOrM512_COUNT (0+XfOrM511_COUNT)
#       define SETUP_XfOrM512(x) SETUP_XfOrM511(x)

# 3671 "./../src/error.c"
        i = 3 * (8 - 1 ) ; 
        (memmove (& ((((Scheme_Vector * ) (b ) ) -> els ) [0 ] ) , 
        & ((((Scheme_Vector * ) (b ) ) -> els ) [3 ] ) , 
        i * sizeof (Scheme_Object * ) ) ) ; 
      }
    }

    (((Scheme_Vector * ) (b ) ) -> els ) [i ] = name ; 
    (((Scheme_Vector * ) (b ) ) -> els ) [i + 1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) ) ) ) << 1 ) | 0x1 ) ) ; 
    (((Scheme_Vector * ) (b ) ) -> els ) [i + 2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (want_level ) ) ) << 1 ) | 0x1 ) ) ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3684 "./../src/error.c"
static int get_want_level (Scheme_Logger * logger , Scheme_Object * name ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(logger, 1)));
# define XfOrM533_COUNT (2)
# define SETUP_XfOrM533(x) SETUP(XfOrM533_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3686 "./../src/error.c"
  if (name && (! (((name ) ) == (scheme_false ) ) ) ) {
#   define XfOrM535_COUNT (0+XfOrM533_COUNT)
#   define SETUP_XfOrM535(x) SETUP_XfOrM533(x)

# 3687 "./../src/error.c"
    while (1 ) {
#     define XfOrM544_COUNT (0+XfOrM535_COUNT)
#     define SETUP_XfOrM544(x) SETUP_XfOrM535(x)

# 3688 "./../src/error.c"
      if (logger -> want_name_level_cache ) {
        int i ; 
        for (i = (((Scheme_Vector * ) (logger -> want_name_level_cache ) ) -> size ) ; (i -= 3 ) >= 0 ; ) {
          if ((name ) == ((((Scheme_Vector * ) (logger -> want_name_level_cache ) ) -> els ) [i ] ) )  {
            if ((((intptr_t ) ((((Scheme_Vector * ) (logger -> want_name_level_cache ) ) -> els ) [i + 1 ] ) ) >> 1 ) == (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) ) {
              RET_VALUE_START ((((intptr_t ) ((((Scheme_Vector * ) (logger -> want_name_level_cache ) ) -> els ) [i + 2 ] ) ) >> 1 ) ) RET_VALUE_END ; 
            }
          }
        }
      }
      FUNCCALL(SETUP_XfOrM544(_), update_want_level (logger , name ) ); 
    }
  }

# 3700 "./../src/error.c"
  else {
#   define XfOrM534_COUNT (0+XfOrM533_COUNT)
#   define SETUP_XfOrM534(x) SETUP_XfOrM533(x)

# 3701 "./../src/error.c"
    if (logger -> local_timestamp < (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
      FUNCCALL(SETUP_XfOrM534(_), update_want_level (logger , ((void * ) 0 ) ) ); 

    RET_VALUE_START (logger -> want_level ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3708 "./../src/error.c"
int scheme_log_level_topic_p (Scheme_Logger * logger , int level , Scheme_Object * name ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(logger, 1)));
# define XfOrM552_COUNT (2)
# define SETUP_XfOrM552(x) SETUP(XfOrM552_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3710 "./../src/error.c"
  if (! logger ) {
    Scheme_Config * config ; 
    BLOCK_SETUP((PUSH(config, 0+XfOrM552_COUNT)));
#   define XfOrM555_COUNT (1+XfOrM552_COUNT)
#   define SETUP_XfOrM555(x) SETUP(XfOrM555_COUNT)
    config = NULLED_OUT ; 

# 3712 "./../src/error.c"
    config = FUNCCALL(SETUP_XfOrM555(_), scheme_current_config () ); 
    logger = (Scheme_Logger * ) FUNCCALL(SETUP_XfOrM555(_), scheme_get_param (config , MZCONFIG_LOGGER ) ); 
  }

  if (! name ) {
#   define XfOrM554_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM554(x) SETUP_XfOrM552(x)

# 3717 "./../src/error.c"
    if (logger -> local_timestamp < (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
      FUNCCALL(SETUP_XfOrM554(_), update_want_level (logger , ((void * ) 0 ) ) ); 

    RET_VALUE_START ((logger -> want_level >= level ) ) RET_VALUE_END ; 
  }

# 3721 "./../src/error.c"
  else {
    int want_level ; 
#   define XfOrM553_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM553(x) SETUP_XfOrM552(x)

# 3724 "./../src/error.c"
    want_level = FUNCCALL_EMPTY(get_want_level (logger , name ) ); 

    RET_VALUE_START ((want_level >= level ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3730 "./../src/error.c"
int scheme_log_level_p (Scheme_Logger * logger , int level ) 
{
  /* No conversion */

# 3732 "./../src/error.c"
  return scheme_log_level_topic_p (logger , level , ((void * ) 0 ) ) ; 
}

Scheme_Object * extract_all_levels (Scheme_Logger * logger ) 
{
  Scheme_Hash_Table * names ; 
  Scheme_Log_Reader * lr ; 
  Scheme_Object * queue , * b , * name , * result = scheme_null , * l ; 
  int level , default_level ; 
  Scheme_Logger * parent = logger ; 
  Scheme_Object * __funcarg141 = NULLED_OUT ; 

# 3526 "./../src/error.c"
  Scheme_Object * __funcarg140 = NULLED_OUT ; 
  Scheme_Object * __funcarg125 = NULLED_OUT ; 

# 3526 "./../src/error.c"
  Scheme_Object * __funcarg124 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(11);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(l, 1), PUSH(names, 2), PUSH(parent, 3), PUSH(b, 4), PUSH(lr, 5), PUSH(__funcarg124, 6), PUSH(logger, 7), PUSH(queue, 8), PUSH(__funcarg140, 9), PUSH(result, 10)));
# define XfOrM557_COUNT (11)
# define SETUP_XfOrM557(x) SETUP(XfOrM557_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  names = NULLED_OUT ; 
  lr = NULLED_OUT ; 
  queue = NULLED_OUT ; 
  b = NULLED_OUT ; 
  name = NULLED_OUT ; 
  l = NULLED_OUT ; 

# 3743 "./../src/error.c"
  names = FUNCCALL(SETUP_XfOrM557(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

  default_level = FUNCCALL_AGAIN(get_want_level (logger , scheme_void ) ); 

  while (parent ) {
#   define XfOrM585_COUNT (0+XfOrM557_COUNT)
#   define SETUP_XfOrM585(x) SETUP_XfOrM557(x)

# 3748 "./../src/error.c"
    queue = parent -> readers ; 
    while (queue ) {
#     define XfOrM600_COUNT (0+XfOrM585_COUNT)
#     define SETUP_XfOrM600(x) SETUP_XfOrM585(x)

# 3750 "./../src/error.c"
      b = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . car ) ; 
      b = (((Scheme_Simple_Object * ) (b ) ) -> u . pair_val . car ) ; 
      lr = (Scheme_Log_Reader * ) (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) ; 
      if (lr ) {
#       define XfOrM601_COUNT (0+XfOrM600_COUNT)
#       define SETUP_XfOrM601(x) SETUP_XfOrM600(x)

# 3754 "./../src/error.c"
        for (l = lr -> level ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#         define XfOrM607_COUNT (0+XfOrM601_COUNT)
#         define SETUP_XfOrM607(x) SETUP_XfOrM601(x)

# 3755 "./../src/error.c"
          l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
          name = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
          if (! ((& ((Scheme_Symbol * ) (name ) ) -> iso ) -> so . keyex & 0x3 ) && ! FUNCCALL(SETUP_XfOrM607(_), scheme_hash_get (names , name ) )) {
#           define XfOrM610_COUNT (0+XfOrM607_COUNT)
#           define SETUP_XfOrM610(x) SETUP_XfOrM607(x)

# 3758 "./../src/error.c"
            level = FUNCCALL(SETUP_XfOrM610(_), get_want_level (logger , name ) ); 
            FUNCCALL(SETUP_XfOrM610(_), scheme_hash_set (names , name , scheme_true ) ); 
            if (level != default_level ) {
#             define XfOrM611_COUNT (0+XfOrM610_COUNT)
#             define SETUP_XfOrM611(x) SETUP_XfOrM610(x)

# 3761 "./../src/error.c"
              result = (__funcarg140 = FUNCCALL(SETUP_XfOrM611(_), level_number_to_symbol (level ) ), __funcarg141 = FUNCCALL(SETUP_XfOrM611(_), scheme_make_pair (name , result ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg140 , __funcarg141 ) )) 
              ; 
            }
          }
          {
#           define XfOrM608_COUNT (0+XfOrM607_COUNT)
#           define SETUP_XfOrM608(x) SETUP_XfOrM607(x)

# 3765 "./../src/error.c"
            if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#             define XfOrM609_COUNT (0+XfOrM608_COUNT)
#             define SETUP_XfOrM609(x) SETUP_XfOrM608(x)
              FUNCCALL(SETUP_XfOrM609(_), scheme_out_of_fuel () )
# 3765 "./../src/error.c"
              ; 
            }
          }

# 3765 "./../src/error.c"
          ; 
        }
      }
      queue = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . cdr ) ; 
    }
    parent = parent -> parent ; 
    {
#     define XfOrM586_COUNT (0+XfOrM585_COUNT)
#     define SETUP_XfOrM586(x) SETUP_XfOrM585(x)

# 3771 "./../src/error.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM587_COUNT (0+XfOrM586_COUNT)
#       define SETUP_XfOrM587(x) SETUP_XfOrM586(x)
        FUNCCALL(SETUP_XfOrM587(_), scheme_out_of_fuel () )
# 3771 "./../src/error.c"
        ; 
      }
    }

# 3771 "./../src/error.c"
    ; 
  }

  result = (__funcarg124 = FUNCCALL(SETUP_XfOrM557(_), level_number_to_symbol (default_level ) ), __funcarg125 = FUNCCALL(SETUP_XfOrM557(_), scheme_make_pair (scheme_false , result ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg124 , __funcarg125 ) )) 
  ; 

  RET_VALUE_START (result ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3780 "./../src/error.c"
static Scheme_Object * make_log_message (int level , Scheme_Object * name , int prefix_msg , 
char * buffer , intptr_t len , Scheme_Object * data ) {
  Scheme_Object * msg ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(data, 1), PUSH(v, 2), PUSH(buffer, 3), PUSH(msg, 4)));
# define XfOrM612_COUNT (5)
# define SETUP_XfOrM612(x) SETUP(XfOrM612_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  msg = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 3785 "./../src/error.c"
  msg = FUNCCALL(SETUP_XfOrM612(_), scheme_make_vector (4 , ((void * ) 0 ) ) ); 
  v = FUNCCALL_AGAIN(level_number_to_symbol (level ) ); 
  (((Scheme_Vector * ) (msg ) ) -> els ) [0 ] = v ; 

  if (name && prefix_msg ) {

    intptr_t slen ; 
    char * cp ; 
    BLOCK_SETUP((PUSH(cp, 0+XfOrM612_COUNT)));
#   define XfOrM613_COUNT (1+XfOrM612_COUNT)
#   define SETUP_XfOrM613(x) SETUP(XfOrM613_COUNT)
    cp = NULLED_OUT ; 

# 3793 "./../src/error.c"
    slen = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ; 
    cp = FUNCCALL(SETUP_XfOrM613(_), GC_malloc_atomic (slen + 2 + len + 1 ) ); 
    (memcpy (cp , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) , slen ) ) ; 
    (memcpy (cp + slen , ": " , 2 ) ) ; 
    (memcpy (cp + slen + 2 , buffer , len + 1 ) ) ; 
    len += slen + 2 ; 
    buffer = cp ; 
  }

  v = FUNCCALL(SETUP_XfOrM612(_), scheme_make_sized_utf8_string (buffer , len ) ); 
  ((((Scheme_Inclhash_Object * ) (v ) ) -> so . keyex |= 0x1 ) ) ; 
  (((Scheme_Vector * ) (msg ) ) -> els ) [1 ] = v ; 
  (((Scheme_Vector * ) (msg ) ) -> els ) [2 ] = (data ? data : scheme_false ) ; 
  (((Scheme_Vector * ) (msg ) ) -> els ) [3 ] = (name ? name : scheme_false ) ; 

  ((((Scheme_Inclhash_Object * ) (msg ) ) -> so . keyex |= 0x1 ) ) ; 

  RET_VALUE_START (msg ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3813 "./../src/error.c"
void scheme_log_name_pfx_message (Scheme_Logger * logger , int level , Scheme_Object * name , 
char * buffer , intptr_t len , Scheme_Object * data , 
int prefix_msg ) 
{


  Scheme_Object * queue , * q , * msg = ((void * ) 0 ) , * b ; 
  Scheme_Log_Reader * lr ; 
  PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(b, 1), PUSH(logger, 2), PUSH(lr, 3), PUSH(data, 4), PUSH(queue, 5), PUSH(q, 6), PUSH(buffer, 7), PUSH(msg, 8)));
# define XfOrM614_COUNT (9)
# define SETUP_XfOrM614(x) SETUP(XfOrM614_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  queue = NULLED_OUT ; 
  q = NULLED_OUT ; 
  b = NULLED_OUT ; 
  lr = NULLED_OUT ; 

# 3822 "./../src/error.c"
  if (! logger ) {
    Scheme_Config * config ; 
    BLOCK_SETUP((PUSH(config, 0+XfOrM614_COUNT)));
#   define XfOrM647_COUNT (1+XfOrM614_COUNT)
#   define SETUP_XfOrM647(x) SETUP(XfOrM647_COUNT)
    config = NULLED_OUT ; 

# 3824 "./../src/error.c"
    config = FUNCCALL(SETUP_XfOrM647(_), scheme_current_config () ); 
    logger = (Scheme_Logger * ) FUNCCALL(SETUP_XfOrM647(_), scheme_get_param (config , MZCONFIG_LOGGER ) ); 
  }

  if (logger -> local_timestamp < (((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) )
    FUNCCALL(SETUP_XfOrM614(_), update_want_level (logger , ((void * ) 0 ) ) ); 

  if (logger -> want_level < level )
    RET_NOTHING ; 

  if (! name )
    name = logger -> name ; 

  if (((name ) ) == (scheme_false ) ) 
    name = ((void * ) 0 ) ; 

  while (logger ) {
#   define XfOrM631_COUNT (0+XfOrM614_COUNT)
#   define SETUP_XfOrM631(x) SETUP_XfOrM614(x)

# 3841 "./../src/error.c"
    if (FUNCCALL(SETUP_XfOrM631(_), extract_spec_level (logger -> syslog_level , name ) )>= level ) {
      int pri ; 
      Scheme_Object * cmd ; 
      BLOCK_SETUP((PUSH(cmd, 0+XfOrM631_COUNT)));
#     define XfOrM645_COUNT (1+XfOrM631_COUNT)
#     define SETUP_XfOrM645(x) SETUP(XfOrM645_COUNT)
      cmd = NULLED_OUT ; 

# 3844 "./../src/error.c"
      switch (level ) {
        case 1 : 
        pri = RKTIO_LOG_FATAL ; 
        break ; 
        case 2 : 
        pri = RKTIO_LOG_ERROR ; 
        break ; 
        case 3 : 
        pri = RKTIO_LOG_WARNING ; 
        break ; 
        case 4 : 
        pri = RKTIO_LOG_INFO ; 
        break ; 
        case 5 : 
        default : 
        pri = RKTIO_LOG_DEBUG ; 
        break ; 
      }
      cmd = FUNCCALL(SETUP_XfOrM645(_), scheme_get_run_cmd () ); 
      (rktio_syslog (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , pri , 
      (name ? (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) : ((void * ) 0 ) ) , 
      buffer , (((Scheme_Simple_Object * ) (cmd ) ) -> u . byte_str_val . string_val ) ) ) ; 
    }

    if (FUNCCALL(SETUP_XfOrM631(_), extract_spec_level (logger -> stderr_level , name ) )>= level ) {
      rktio_fd_t * fd ; 
      BLOCK_SETUP((PUSH(fd, 0+XfOrM631_COUNT)));
#     define XfOrM642_COUNT (1+XfOrM631_COUNT)
#     define SETUP_XfOrM642(x) SETUP(XfOrM642_COUNT)
      fd = NULLED_OUT ; 

# 3870 "./../src/error.c"
      fd = (rktio_std_fd (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , 2 ) ) ; 
      if (fd ) {
#       define XfOrM643_COUNT (0+XfOrM642_COUNT)
#       define SETUP_XfOrM643(x) SETUP_XfOrM642(x)

# 3872 "./../src/error.c"
        if (name && prefix_msg ) {
          intptr_t slen ; 
#         define XfOrM644_COUNT (0+XfOrM643_COUNT)
#         define SETUP_XfOrM644(x) SETUP_XfOrM643(x)

# 3874 "./../src/error.c"
          slen = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ; 
          FUNCCALL(SETUP_XfOrM644(_), scheme_rktio_write_all (fd , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) , slen ) ); 
          FUNCCALL_AGAIN(scheme_rktio_write_all (fd , ": " , 2 ) ); 
        }
        FUNCCALL(SETUP_XfOrM643(_), scheme_rktio_write_all (fd , buffer , len ) ); 
        FUNCCALL(SETUP_XfOrM643(_), scheme_rktio_write_all (fd , "\n" , 1 ) ); 
        (rktio_forget (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fd ) ) ; 
      }
    }

    if (FUNCCALL(SETUP_XfOrM631(_), extract_spec_level (logger -> stdout_level , name ) )>= level ) {
      rktio_fd_t * fd ; 
      BLOCK_SETUP((PUSH(fd, 0+XfOrM631_COUNT)));
#     define XfOrM639_COUNT (1+XfOrM631_COUNT)
#     define SETUP_XfOrM639(x) SETUP(XfOrM639_COUNT)
      fd = NULLED_OUT ; 

# 3886 "./../src/error.c"
      fd = (rktio_std_fd (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , 1 ) ) ; 
      if (fd ) {
#       define XfOrM640_COUNT (0+XfOrM639_COUNT)
#       define SETUP_XfOrM640(x) SETUP_XfOrM639(x)

# 3888 "./../src/error.c"
        if (name && prefix_msg ) {
          intptr_t slen ; 
#         define XfOrM641_COUNT (0+XfOrM640_COUNT)
#         define SETUP_XfOrM641(x) SETUP_XfOrM640(x)

# 3890 "./../src/error.c"
          slen = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ; 
          FUNCCALL(SETUP_XfOrM641(_), scheme_rktio_write_all (fd , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) , slen ) ); 
          FUNCCALL_AGAIN(scheme_rktio_write_all (fd , ": " , 2 ) ); 
        }
        FUNCCALL(SETUP_XfOrM640(_), scheme_rktio_write_all (fd , buffer , len ) ); 
        FUNCCALL(SETUP_XfOrM640(_), scheme_rktio_write_all (fd , "\n" , 1 ) ); 
        (rktio_forget (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fd ) ) ; 
      }
    }

    queue = logger -> readers ; 
    while (queue ) {
#     define XfOrM636_COUNT (0+XfOrM631_COUNT)
#     define SETUP_XfOrM636(x) SETUP_XfOrM631(x)

# 3902 "./../src/error.c"
      b = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . car ) ; 
      b = (((Scheme_Simple_Object * ) (b ) ) -> u . pair_val . car ) ; 
      lr = (Scheme_Log_Reader * ) (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) ; 
      if (lr ) {
#       define XfOrM637_COUNT (0+XfOrM636_COUNT)
#       define SETUP_XfOrM637(x) SETUP_XfOrM636(x)

# 3906 "./../src/error.c"
        if (FUNCCALL(SETUP_XfOrM637(_), extract_spec_level (lr -> level , name ) )>= level ) {
#         define XfOrM638_COUNT (0+XfOrM637_COUNT)
#         define SETUP_XfOrM638(x) SETUP_XfOrM637(x)

# 3907 "./../src/error.c"
          if (! msg )
            msg = FUNCCALL(SETUP_XfOrM638(_), make_log_message (level , name , prefix_msg , buffer , len , data ) ); 


          q = FUNCCALL(SETUP_XfOrM638(_), scheme_make_raw_pair (msg , ((void * ) 0 ) ) ); 
          if (lr -> tail )
            (((Scheme_Simple_Object * ) (lr -> tail ) ) -> u . pair_val . cdr ) = q ; 
          else 
          lr -> head = q ; 
          lr -> tail = q ; 
          FUNCCALL(SETUP_XfOrM638(_), scheme_post_sema (lr -> sema ) ); 
        }
      }
      queue = (((Scheme_Simple_Object * ) (queue ) ) -> u . pair_val . cdr ) ; 
    }

    if (logger -> parent && logger -> propagate_level ) {
#     define XfOrM632_COUNT (0+XfOrM631_COUNT)
#     define SETUP_XfOrM632(x) SETUP_XfOrM631(x)

# 3924 "./../src/error.c"
      if (FUNCCALL(SETUP_XfOrM632(_), extract_spec_level (logger -> propagate_level , name ) )< level )
        break ; 
    }

    logger = logger -> parent ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3932 "./../src/error.c"
void scheme_log_name_message (Scheme_Logger * logger , int level , Scheme_Object * name , 
char * buffer , intptr_t len , Scheme_Object * data ) 
{
  /* No conversion */

# 3935 "./../src/error.c"
  scheme_log_name_pfx_message (logger , level , name , buffer , len , data , 1 ) ; 
}

void scheme_log_message (Scheme_Logger * logger , int level , char * buffer , intptr_t len , Scheme_Object * data ) 
{
  /* No conversion */

# 3940 "./../src/error.c"
  scheme_log_name_pfx_message (logger , level , ((void * ) 0 ) , buffer , len , data , 1 ) ; 
}

void scheme_log_abort (char * buffer ) 
{
  Scheme_Logger logger ; 
  Scheme_Object * ts [2 ] ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(ts, 2, 0)));
# define XfOrM650_COUNT (3)
# define SETUP_XfOrM650(x) SETUP(XfOrM650_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ts[0] = NULLED_OUT ; 
  ts[1] = NULLED_OUT ; 
  (
# 3948 "./../src/error.c"
  memset (& logger , 0 , sizeof (logger ) ) ) ; 

  logger . name = ((void * ) 0 ) ; 
  logger . parent = ((void * ) 0 ) ; 
  logger . want_level = 1 ; 

  ts [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
  ts [1 ] = ((void * ) 0 ) ; 
  logger . root_timestamp = ts ; 
  logger . local_timestamp = 0 ; 
  logger . syslog_level = init_syslog_level ; 
  logger . stderr_level = init_stderr_level ; 
  logger . stdout_level = init_stdout_level ; 
  FUNCCALL(SETUP_XfOrM650(_), scheme_log_message (& logger , 1 , buffer , strlen (buffer ) , scheme_false ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3965 "./../src/error.c"
void scheme_log_warning (char * buffer ) 
{
  /* No conversion */

# 3967 "./../src/error.c"
  scheme_log_message (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , 3 , buffer , strlen (buffer ) , scheme_false ) ; 
}

static void glib_log_message (const char * log_domain , 
int log_level , 
const char * message , 
void * user_data ) 

{






  int level , len1 , len2 ; 
  char * together ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(log_domain, 0), PUSH(message, 1), PUSH(together, 2)));
# define XfOrM652_COUNT (3)
# define SETUP_XfOrM652(x) SETUP(XfOrM652_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  together = NULLED_OUT ; 

# 3985 "./../src/error.c"
  if (log_level & ((1 << 2 ) ) )
    level = 1 ; 
  else if (log_level & ((1 << 3 ) ) )
    level = 2 ; 
  else if (log_level & ((1 << 4 ) | (1 << 5 ) ) )
    level = 3 ; 
  else if (log_level & ((1 << 6 ) ) )
    level = 4 ; 
  else 
  level = 5 ; 

  len2 = strlen (message ) ; 
  if (log_domain ) {
#   define XfOrM653_COUNT (0+XfOrM652_COUNT)
#   define SETUP_XfOrM653(x) SETUP_XfOrM652(x)

# 3998 "./../src/error.c"
    len1 = strlen (log_domain ) ; 
    together = (char * ) FUNCCALL(SETUP_XfOrM653(_), GC_malloc_atomic (len1 + len2 + 3 ) ); 
    (memcpy (together , log_domain , len1 ) ) ; 
    (memcpy (together + len1 , ": " , 2 ) ) ; 
    (memcpy (together + len1 + 2 , message , len2 ) ) ; 
    len2 += len1 + 2 ; 
  }

# 4004 "./../src/error.c"
  else 
  together = (char * ) message ; 
  FUNCCALL_EMPTY(scheme_log_message (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_logger_ ) , level , together , len2 , scheme_false ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4010 "./../src/error.c"
void scheme_glib_log_message (const char * log_domain , 
int log_level , 
const char * message , 
void * user_data ) 
XFORM_SKIP_PROC 




{
  if (scheme_is_place_main_os_thread () )
    glib_log_message (log_domain , log_level , message , user_data ) ; 
  else {


    glib_log_queue_entry * e = malloc (sizeof (glib_log_queue_entry ) ) ; 
    e -> log_domain = strdup (log_domain ) ; 
    e -> log_level = log_level ; 
    e -> message = strdup (message ) ; 

    mzrt_mutex_lock (glib_log_queue_lock ) ; 
    e -> next = glib_log_queue ; 
    glib_log_queue = e ; 
    mzrt_mutex_unlock (glib_log_queue_lock ) ; 

    scheme_signal_received_at (glib_log_signal_handle ) ; 
  }
}







void * scheme_glib_log_message_test (char * str ) 
XFORM_SKIP_PROC 
{
  if (! str ) {
    scheme_glib_log_message (((void * ) 0 ) , (1 << 4 ) , "test" , ((void * ) 0 ) ) ; 
  }

# 4050 "./../src/error.c"
  else {
    int i ; 
    for (i = 0 ; str [i ] ; i ++ ) {
      if (str [i ] == ';' ) {
        str [i ] = 0 ; 
        scheme_glib_log_message ("test" , (1 << 4 ) , str , ((void * ) 0 ) ) ; 
        str [i ] = ';' ; 
        str = str + i + 1 ; 
        i = 0 ; 
      }
    }
    scheme_glib_log_message ("test" , (1 << 4 ) , str , ((void * ) 0 ) ) ; 
  }
  return ((void * ) 0 ) ; 
}


void scheme_init_glib_log_queue (void ) 
{
  /* No conversion */

# 4069 "./../src/error.c"
  mzrt_mutex_create (& glib_log_queue_lock ) ; 
  glib_log_signal_handle = scheme_get_signal_handle () ; 
}

void scheme_check_glib_log_messages (void ) 
{
  PREPARE_VAR_STACK(3);
# define XfOrM655_COUNT (0)
# define SETUP_XfOrM655(x) SETUP(XfOrM655_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4075 "./../src/error.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) == 0 ) {
    glib_log_queue_entry * e , * prev = ((void * ) 0 ) , * next ; 
    BLOCK_SETUP((PUSH(next, 0+XfOrM655_COUNT), PUSH(prev, 1+XfOrM655_COUNT), PUSH(e, 2+XfOrM655_COUNT)));
#   define XfOrM656_COUNT (3+XfOrM655_COUNT)
#   define SETUP_XfOrM656(x) SETUP(XfOrM656_COUNT)
    e = NULLED_OUT ; 
    next = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM656(_), mzrt_mutex_lock (glib_log_queue_lock ) )
# 4078 "./../src/error.c"
    ; 
    e = glib_log_queue ; 
    glib_log_queue = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM656(_), mzrt_mutex_unlock (glib_log_queue_lock ) ); 

    if (e ) {
#     define XfOrM657_COUNT (0+XfOrM656_COUNT)
#     define SETUP_XfOrM657(x) SETUP_XfOrM656(x)

# 4085 "./../src/error.c"
      while (e -> next ) {
        next = e -> next ; 
        e -> next = prev ; 
        prev = e ; 
        e = next ; 
      }
      e -> next = prev ; 


      for (; e ; e = e -> next ) {
#       define XfOrM659_COUNT (0+XfOrM657_COUNT)
#       define SETUP_XfOrM659(x) SETUP_XfOrM657(x)
        FUNCCALL(SETUP_XfOrM659(_), glib_log_message (e -> log_domain , e -> log_level , e -> message , ((void * ) 0 ) ) )
# 4095 "./../src/error.c"
        ; 
      }
      FUNCCALL_EMPTY(scheme_signal_received_at (glib_log_signal_handle ) )

      ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4105 "./../src/error.c"
static int extract_level (const char * who , int none_ok , int which , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4107 "./../src/error.c"
  Scheme_Object * v ; 
  int level ; 

  v = argv [which ] ; 
  if ((v ) == (none_symbol ) ) 
    level = 0 ; 
  else if ((v ) == (fatal_symbol ) ) 
    level = 1 ; 
  else if ((v ) == (error_symbol ) ) 
    level = 2 ; 
  else if ((v ) == (warning_symbol ) ) 
    level = 3 ; 
  else if ((v ) == (info_symbol ) ) 
    level = 4 ; 
  else if ((v ) == (debug_symbol ) ) 
    level = 5 ; 
  else {
    scheme_wrong_contract (who , 
    (none_ok 
    ? "(or/c 'none 'fatal 'error 'warning 'info 'debug)" 
    : "(or/c 'fatal 'error 'warning 'info 'debug)" ) , 
    which , argc , argv ) ; 
    return 0 ; 
  }

  return level ; 
}

static Scheme_Object * 
log_message (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * logger ; 
  Scheme_Object * bytes ; 
  Scheme_Object * name ; 
  Scheme_Object * data ; 
  int level , pos , pfx ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(data, 1), PUSH(logger, 2), PUSH(bytes, 3), PUSH(argv, 4)));
# define XfOrM664_COUNT (5)
# define SETUP_XfOrM664(x) SETUP(XfOrM664_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  logger = NULLED_OUT ; 
  bytes = NULLED_OUT ; 
  name = NULLED_OUT ; 
  data = NULLED_OUT ; 

# 4144 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("log-message" , "logger?" , 0 , argc , argv ) ); 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  level = FUNCCALL(SETUP_XfOrM664(_), extract_level ("log-message" , 0 , 1 , argc , argv ) ); 

  pos = 2 ; 
  if (((Scheme_Type ) (((((intptr_t ) (argv [pos ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [pos ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || (((argv [pos ] ) ) == (scheme_false ) ) )
    name = argv [pos ++ ] ; 
  else 
  name = ((void * ) 0 ) ; 

  bytes = argv [pos ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (bytes ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bytes ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("log-message" , "string?" , pos , argc , argv ) ); 
  bytes = FUNCCALL(SETUP_XfOrM664(_), scheme_char_string_to_byte_string (bytes ) ); 
  pos ++ ; 

  if (argc > (pos + 1 ) )
    pfx = (! (((argv [pos + 1 ] ) ) == (scheme_false ) ) ) ; 
  else 
  pfx = 1 ; 

  if (pos >= argc )
    data = scheme_false ; 
  else 
  data = argv [pos ] ; 
  FUNCCALL_EMPTY(scheme_log_name_pfx_message (logger , level , name , (((Scheme_Simple_Object * ) (bytes ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (bytes ) ) -> u . byte_str_val . tag_val ) , data , pfx ) )


  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4179 "./../src/error.c"
static Scheme_Object * 
log_level_p (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * logger ; 
  Scheme_Object * name = scheme_false ; 
  int level , want_level ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(logger, 1), PUSH(argv, 2)));
# define XfOrM665_COUNT (3)
# define SETUP_XfOrM665(x) SETUP(XfOrM665_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  logger = NULLED_OUT ; 

# 4186 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("log-level?" , "logger?" , 0 , argc , argv ) ); 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  level = FUNCCALL(SETUP_XfOrM665(_), extract_level ("log-level?" , 0 , 1 , argc , argv ) ); 

  if (argc > 2 ) {
#   define XfOrM666_COUNT (0+XfOrM665_COUNT)
#   define SETUP_XfOrM666(x) SETUP_XfOrM665(x)

# 4193 "./../src/error.c"
    if (! (((argv [2 ] ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("log-level?" , "(or/c f? #symbol)" , 2 , argc , argv ) ); 
    name = argv [2 ] ; 
  }

  want_level = FUNCCALL_EMPTY(get_want_level (logger , name ) ); 

  RET_VALUE_START (((want_level >= level ) ? scheme_true : scheme_false ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4203 "./../src/error.c"
static Scheme_Object * 
log_max_level (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * logger ; 
  Scheme_Object * name = scheme_false ; 

# 3684 "./../src/error.c"
  int __funcarg142 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(0);
# define XfOrM667_COUNT (0)
# define SETUP_XfOrM667(x) SETUP(XfOrM667_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  logger = NULLED_OUT ; 

# 4209 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("log-max-level" , "logger?" , 0 , argc , argv ) ); 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  if (argc > 1 ) {
#   define XfOrM668_COUNT (0+XfOrM667_COUNT)
#   define SETUP_XfOrM668(x) SETUP_XfOrM667(x)

# 4214 "./../src/error.c"
    if (! (((argv [1 ] ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("log-max-level" , "(or/c f? #symbol)" , 1 , argc , argv ) ); 
    name = argv [1 ] ; 
  }

  RET_VALUE_START ((__funcarg142 = FUNCCALL_EMPTY(get_want_level (logger , name ) ), FUNCCALL_EMPTY(level_number_to_symbol (__funcarg142 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4222 "./../src/error.c"
static Scheme_Object * 
log_all_levels (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4225 "./../src/error.c"
  Scheme_Logger * logger ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    scheme_wrong_contract ("log-all-levels" , "logger?" , 0 , argc , argv ) ; 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  return extract_all_levels (logger ) ; 
}

static Scheme_Object * 
log_level_evt (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * logger ; 
  Scheme_Object * sema ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(logger, 0), PUSH(sema, 1)));
# define XfOrM670_COUNT (2)
# define SETUP_XfOrM670(x) SETUP(XfOrM670_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  logger = NULLED_OUT ; 
  sema = NULLED_OUT ; 

# 4240 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("log-level-evt" , "logger?" , 0 , argc , argv ) ); 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  sema = logger -> root_timestamp [1 ] ; 
  if (! sema ) {
#   define XfOrM671_COUNT (0+XfOrM670_COUNT)
#   define SETUP_XfOrM671(x) SETUP_XfOrM670(x)

# 4246 "./../src/error.c"
    sema = FUNCCALL(SETUP_XfOrM671(_), scheme_make_sema (0 ) ); 
    logger -> root_timestamp [1 ] = sema ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_sema_repost (sema ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4253 "./../src/error.c"
static Scheme_Object * get_levels_and_names (const char * who , int i , int argc , Scheme_Object * * argv , 
int default_lvl ) 
{
  int lvl ; 
  Scheme_Object * level = scheme_null , * last = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(last, 0), PUSH(who, 1), PUSH(level, 2), PUSH(argv, 3)));
# define XfOrM672_COUNT (4)
# define SETUP_XfOrM672(x) SETUP(XfOrM672_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4259 "./../src/error.c"
  for (; i < argc ; i += 2 ) {
#   define XfOrM677_COUNT (0+XfOrM672_COUNT)
#   define SETUP_XfOrM677(x) SETUP_XfOrM672(x)

# 4260 "./../src/error.c"
    lvl = FUNCCALL(SETUP_XfOrM677(_), extract_level (who , 1 , i , argc , argv ) ); 
    if ((i + 1 ) < argc ) {
#     define XfOrM679_COUNT (0+XfOrM677_COUNT)
#     define SETUP_XfOrM679(x) SETUP_XfOrM677(x)

# 4262 "./../src/error.c"
      if (((argv [i + 1 ] ) ) == (scheme_false ) ) 
        default_lvl = lvl ; 
      else {
#       define XfOrM680_COUNT (0+XfOrM679_COUNT)
#       define SETUP_XfOrM680(x) SETUP_XfOrM679(x)

# 4265 "./../src/error.c"
        if (! ((Scheme_Type ) (((((intptr_t ) (argv [i + 1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i + 1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
          FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c symbol? #f)" , i + 1 , argc , argv ) ); 
        level = FUNCCALL(SETUP_XfOrM680(_), scheme_make_pair (argv [i + 1 ] , level ) ); 
        if (! last )

# 4268 "./../src/error.c"
        last = level ; 
        level = FUNCCALL(SETUP_XfOrM680(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (lvl ) ) ) << 1 ) | 0x1 ) ) , level ) ); 
      }
    }

# 4271 "./../src/error.c"
    else {
      default_lvl = lvl ; 
    }
  }

  if (last )
    (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (default_lvl ) ) ) << 1 ) | 0x1 ) ) ; 
  else 
  level = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (default_lvl ) ) ) << 1 ) | 0x1 ) ) ; 

  RET_VALUE_START (level ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4284 "./../src/error.c"
static Scheme_Object * 
make_logger (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * parent , * logger ; 
  Scheme_Object * propagate_level ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(parent, 0), PUSH(logger, 1), PUSH(propagate_level, 2), PUSH(argv, 3)));
# define XfOrM681_COUNT (4)
# define SETUP_XfOrM681(x) SETUP(XfOrM681_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  parent = NULLED_OUT ; 
  logger = NULLED_OUT ; 
  propagate_level = NULLED_OUT ; 

# 4290 "./../src/error.c"
  if (argc ) {
#   define XfOrM682_COUNT (0+XfOrM681_COUNT)
#   define SETUP_XfOrM682(x) SETUP_XfOrM681(x)

# 4291 "./../src/error.c"
    if (! (((argv [0 ] ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-logger" , "(or/c symbol? #f)" , 0 , argc , argv ) ); 

    if (argc > 1 ) {
#     define XfOrM683_COUNT (0+XfOrM682_COUNT)
#     define SETUP_XfOrM683(x) SETUP_XfOrM682(x)

# 4295 "./../src/error.c"
      if (((argv [1 ] ) ) == (scheme_false ) ) 
        parent = ((void * ) 0 ) ; 
      else {
#       define XfOrM684_COUNT (0+XfOrM683_COUNT)
#       define SETUP_XfOrM684(x) SETUP_XfOrM683(x)

# 4298 "./../src/error.c"
        if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
          FUNCCALL_EMPTY(scheme_wrong_contract ("make-logger" , "(or/c logger? #f)" , 1 , argc , argv ) ); 
        parent = (Scheme_Logger * ) argv [1 ] ; 
      }
    }

# 4302 "./../src/error.c"
    else 
    parent = ((void * ) 0 ) ; 
  }

# 4304 "./../src/error.c"
  else 
  parent = ((void * ) 0 ) ; 

  propagate_level = FUNCCALL(SETUP_XfOrM681(_), get_levels_and_names ("make-logger" , 2 , argc , argv , 5 ) )
  ; 

  logger = FUNCCALL_AGAIN(scheme_make_logger (parent , (argc ? ((((argv [0 ] ) ) == (scheme_false ) ) ? ((void * ) 0 ) : argv [0 ] ) : ((void * ) 0 ) ) ) )


  ; 

  if (parent )
    logger -> propagate_level = propagate_level ; 

  RET_VALUE_START ((Scheme_Object * ) logger ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4321 "./../src/error.c"
Scheme_Logger * scheme_make_logger (Scheme_Logger * parent , Scheme_Object * name ) 
{
  Scheme_Logger * logger ; 
  DECL_RET_SAVE (Scheme_Logger * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(parent, 0), PUSH(name, 1), PUSH(logger, 2)));
# define XfOrM685_COUNT (3)
# define SETUP_XfOrM685(x) SETUP(XfOrM685_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  logger = NULLED_OUT ; 

# 4325 "./../src/error.c"
  logger = ((Scheme_Logger * ) FUNCCALL(SETUP_XfOrM685(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Logger ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  logger -> so . type = scheme_logger_type ; 
  logger -> parent = parent ; 
  if (parent ) {
    logger -> root_timestamp = parent -> root_timestamp ; 
  }

# 4330 "./../src/error.c"
  else {
    Scheme_Object * * root_timestamp ; 
    BLOCK_SETUP((PUSH(root_timestamp, 0+XfOrM685_COUNT)));
#   define XfOrM686_COUNT (1+XfOrM685_COUNT)
#   define SETUP_XfOrM686(x) SETUP(XfOrM686_COUNT)
    root_timestamp = NULLED_OUT ; 

# 4332 "./../src/error.c"
    root_timestamp = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM686(_), GC_malloc (sizeof (Scheme_Object * ) * (2 ) ) )) ; 
    root_timestamp [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
    logger -> root_timestamp = root_timestamp ; 
  }
  logger -> name = name ; 

  RET_VALUE_START (logger ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4341 "./../src/error.c"
static Scheme_Object * 
logger_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4344 "./../src/error.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * 
current_logger (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4352 "./../src/error.c"
  return scheme_param_config2 ("current-logger" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_LOGGER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , logger_p , "logger?" , 0 ) ; 
}

static Scheme_Object * 
logger_name (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4361 "./../src/error.c"
  Scheme_Object * name ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    scheme_wrong_contract ("logger-name" , "logger?" , 0 , argc , argv ) ; 

  name = ((Scheme_Logger * ) argv [0 ] ) -> name ; 
  return (name ? name : scheme_false ) ; 
}

static Scheme_Object * 
make_log_reader (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Logger * logger ; 
  Scheme_Log_Reader * lr ; 
  Scheme_Object * sema , * q ; 
  Scheme_Object * level ; 
  Scheme_Object * __funcarg144 = NULLED_OUT ; 
  Scheme_Object * __funcarg143 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(q, 0), PUSH(logger, 1), PUSH(sema, 2), PUSH(level, 3), PUSH(lr, 4)));
# define XfOrM691_COUNT (5)
# define SETUP_XfOrM691(x) SETUP(XfOrM691_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  logger = NULLED_OUT ; 
  lr = NULLED_OUT ; 
  sema = NULLED_OUT ; 
  q = NULLED_OUT ; 
  level = NULLED_OUT ; 

# 4378 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-log-receiver" , "logger?" , 0 , argc , argv ) ); 
  logger = (Scheme_Logger * ) argv [0 ] ; 

  level = FUNCCALL(SETUP_XfOrM691(_), get_levels_and_names ("make-log-receiver" , 1 , argc , argv , 0 ) ); 

  lr = ((Scheme_Log_Reader * ) FUNCCALL(SETUP_XfOrM691(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Log_Reader ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  lr -> so . type = scheme_log_reader_type ; 
  lr -> level = level ; 

  sema = FUNCCALL(SETUP_XfOrM691(_), scheme_make_sema (0 ) ); 
  lr -> sema = sema ; 






  q = (__funcarg143 = (__funcarg144 = FUNCCALL(SETUP_XfOrM691(_), scheme_make_weak_box ((Scheme_Object * ) lr ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg144 , sema ) )) 
  , FUNCCALL_AGAIN(scheme_make_raw_pair (__funcarg143 , logger -> readers ) )) 
  ; 
  logger -> readers = q ; 
  logger -> root_timestamp [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((((intptr_t ) (logger -> root_timestamp [0 ] ) ) >> 1 ) + 1 ) ) ) << 1 ) | 0x1 ) ) ; 
  if (logger -> root_timestamp [1 ] ) {
#   define XfOrM692_COUNT (0+XfOrM691_COUNT)
#   define SETUP_XfOrM692(x) SETUP_XfOrM691(x)
    FUNCCALL(SETUP_XfOrM692(_), scheme_post_sema_all (logger -> root_timestamp [1 ] ) )
# 4402 "./../src/error.c"
    ; 
    logger -> root_timestamp [1 ] = ((void * ) 0 ) ; 
  }

  RET_VALUE_START ((Scheme_Object * ) lr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4409 "./../src/error.c"
static Scheme_Object * 
log_reader_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4412 "./../src/error.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_log_reader_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * dequeue_log (Scheme_Object * _lr ) 
{
  /* No conversion */

# 4419 "./../src/error.c"
  Scheme_Log_Reader * lr = (Scheme_Log_Reader * ) _lr ; 

  if (lr -> head ) {
    Scheme_Object * v ; 
    v = (((Scheme_Simple_Object * ) (lr -> head ) ) -> u . pair_val . car ) ; 
    lr -> head = (((Scheme_Simple_Object * ) (lr -> head ) ) -> u . pair_val . cdr ) ; 
    if (! lr -> head )
      lr -> tail = ((void * ) 0 ) ; 
    return v ; 
  }

# 4428 "./../src/error.c"
  else {
    scheme_signal_error ("empty log-reader queue!?" ) ; 
    return ((void * ) 0 ) ; 
  }
}

static int log_reader_get (Scheme_Object * _lr , Scheme_Schedule_Info * sinfo ) 
{
  /* No conversion */

# 4436 "./../src/error.c"
  Scheme_Log_Reader * lr = (Scheme_Log_Reader * ) _lr ; 
  scheme_set_sync_target (sinfo , lr -> sema , (Scheme_Object * ) lr , ((void * ) 0 ) , 0 , 1 , dequeue_log ) ; 
  return 0 ; 
}



void 
scheme_raise_exn (int id , ... ) 
{
  GC_CAN_IGNORE va_list args ; 
  intptr_t alen ; 
  char * msg ; 
  int i , c , unsupported = 0 ; 
  Scheme_Object * eargs [3 ] , * errno_val = ((void * ) 0 ) ; 
  char * buffer ; 
  Scheme_Object * __funcarg145 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(errno_val, 0), PUSHARRAY(eargs, 3, 1), PUSH(buffer, 4)));
# define XfOrM698_COUNT (5)
# define SETUP_XfOrM698(x) SETUP(XfOrM698_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  msg = NULLED_OUT ; 
  eargs[0] = NULLED_OUT ; 
  eargs[1] = NULLED_OUT ; 
  eargs[2] = NULLED_OUT ; 
  buffer = NULLED_OUT ; 
  (
# 4453 "./../src/error.c"
  rktio_remap_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 


  HIDE_FROM_XFORM (__builtin_va_start (args , id ) ) ; 

  if (id == MZEXN_OTHER )
    c = 3 ; 
  else 
  c = exn_table [id ] . args ; 

  for (i = 2 ; i < c ; i ++ ) {
    eargs [i ] = HIDE_FROM_XFORM (__builtin_va_arg (args , Scheme_Object * ) ) ; 
  }

  msg = HIDE_FROM_XFORM (__builtin_va_arg (args , char * ) ) ; 

  alen = FUNCCALL(SETUP_XfOrM698(_), sch_vsprintf (((void * ) 0 ) , 0 , msg , args , & buffer , & errno_val , & unsupported ) ); 
  HIDE_FROM_XFORM (__builtin_va_end (args ) ) ; 

  eargs [0 ] = FUNCCALL(SETUP_XfOrM698(_), scheme_make_immutable_sized_utf8_string (buffer , alen ) ); 
  eargs [1 ] = scheme_parameterization_key ; 
  if (errno_val ) {
    if (id == MZEXN_FAIL_FILESYSTEM ) {
      id = MZEXN_FAIL_FILESYSTEM_ERRNO ; 
      eargs [2 ] = errno_val ; 
      c ++ ; 
    }

# 4479 "./../src/error.c"
    else if (id == MZEXN_FAIL_NETWORK ) {
      id = MZEXN_FAIL_NETWORK_ERRNO ; 
      eargs [2 ] = errno_val ; 
      c ++ ; 
    }
  }

# 4484 "./../src/error.c"
  else if (unsupported ) {
    if (id == MZEXN_FAIL )
      id = MZEXN_FAIL_UNSUPPORTED ; 
  }
  (__funcarg145 = FUNCCALL(SETUP_XfOrM698(_), scheme_make_struct_instance (exn_table [id ] . type , c , eargs ) )

  , FUNCCALL_AGAIN(do_raise (__funcarg145 , 1 , 1 ) )) 

  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4495 "./../src/error.c"
static void 
def_exn_handler (int argc , Scheme_Object * argv [] ) 
{
  char * s ; 
  intptr_t len = - 1 ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(argv, 1)));
# define XfOrM705_COUNT (2)
# define SETUP_XfOrM705(x) SETUP(XfOrM705_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 

# 4501 "./../src/error.c"
  if (((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && (scheme_is_struct_instance (exn_table [MZEXN ] . type , argv [0 ] ) ) ) {
    Scheme_Object * str ; 
    BLOCK_SETUP((PUSH(str, 0+XfOrM705_COUNT)));
#   define XfOrM707_COUNT (1+XfOrM705_COUNT)
#   define SETUP_XfOrM707(x) SETUP(XfOrM707_COUNT)
    str = NULLED_OUT ; 

# 4504 "./../src/error.c"
    str = FUNCCALL(SETUP_XfOrM707(_), scheme_struct_ref (argv [0 ] , 0 ) ); 
    if ((Scheme_Type ) (((((intptr_t ) (str ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (str ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#     define XfOrM708_COUNT (0+XfOrM707_COUNT)
#     define SETUP_XfOrM708(x) SETUP_XfOrM707(x)

# 4506 "./../src/error.c"
      str = FUNCCALL(SETUP_XfOrM708(_), scheme_char_string_to_byte_string (str ) ); 
      s = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) ; 
      len = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . tag_val ) ; 
    }

# 4509 "./../src/error.c"
    else 
    s = "exception raised [message field is not a string]" ; 
  }

# 4511 "./../src/error.c"
  else {
    char * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM705_COUNT)));
#   define XfOrM706_COUNT (1+XfOrM705_COUNT)
#   define SETUP_XfOrM706(x) SETUP(XfOrM706_COUNT)
    v = NULLED_OUT ; 

# 4514 "./../src/error.c"
    v = FUNCCALL(SETUP_XfOrM706(_), scheme_make_provided_string (argv [0 ] , 1 , & len ) ); 
    s = FUNCCALL_AGAIN(GC_malloc_atomic (len + 21 ) ); 
    (memcpy (s , "uncaught exception: " , 20 ) ) ; 
    (memcpy (s + 20 , v , len + 1 ) ) ; 
    len += 20 ; 
  }
  FUNCCALL_EMPTY(call_error (s , len , argv [0 ] ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4524 "./../src/error.c"
static Scheme_Object * 
init_exn_handler (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4527 "./../src/error.c"
  return scheme_param_config ("uncaught-exception-handler" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_INIT_EXN_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  1 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static void 
nested_exn_handler (void * old_exn , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * arg = argv [0 ] , * orig_arg = (((Scheme_Simple_Object * ) ((Scheme_Object * ) old_exn ) ) -> u . pair_val . cdr ) ; 
  intptr_t len , mlen = - 1 , orig_mlen = - 1 , blen ; 
  char * buffer , * msg , * orig_msg , * raisetype , * orig_raisetype , * who , * sep ; 
  PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(orig_msg, 0), PUSH(who, 1), PUSH(buffer, 2), PUSH(orig_arg, 3), PUSH(arg, 4), PUSH(orig_raisetype, 5), PUSH(sep, 6), PUSH(msg, 7), PUSH(raisetype, 8), PUSH(old_exn, 9)));
# define XfOrM710_COUNT (10)
# define SETUP_XfOrM710(x) SETUP(XfOrM710_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  buffer = NULLED_OUT ; 
  msg = NULLED_OUT ; 
  orig_msg = NULLED_OUT ; 
  raisetype = NULLED_OUT ; 
  orig_raisetype = NULLED_OUT ; 
  who = NULLED_OUT ; 
  sep = NULLED_OUT ; 

# 4540 "./../src/error.c"
  buffer = FUNCCALL(SETUP_XfOrM710(_), init_buf (& len , & blen ) ); 

  if ((((((Scheme_Simple_Object * ) ((Scheme_Object * ) old_exn ) ) -> u . pair_val . car ) ) ) == (scheme_false ) )  {
    raisetype = "" ; 
    sep = "" ; 
    who = "handler for uncaught exceptions" ; 
    msg = "did not escape" ; 
  }

# 4547 "./../src/error.c"
  else {
#   define XfOrM713_COUNT (0+XfOrM710_COUNT)
#   define SETUP_XfOrM713(x) SETUP_XfOrM710(x)

# 4548 "./../src/error.c"
    who = (((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) ((Scheme_Object * ) old_exn ) ) -> u . pair_val . car ) ) ) -> u . byte_str_val . string_val ) ; 
    sep = " by " ; 

    if (((((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && (scheme_is_struct_instance (exn_table [MZEXN ] . type , arg ) ) ) {
      Scheme_Object * str ; 
      BLOCK_SETUP((PUSH(str, 0+XfOrM713_COUNT)));
#     define XfOrM715_COUNT (1+XfOrM713_COUNT)
#     define SETUP_XfOrM715(x) SETUP(XfOrM715_COUNT)
      str = NULLED_OUT ; 

# 4554 "./../src/error.c"
      str = FUNCCALL(SETUP_XfOrM715(_), scheme_struct_ref (arg , 0 ) ); 
      raisetype = "exception raised" ; 
      str = FUNCCALL(SETUP_XfOrM715(_), scheme_char_string_to_byte_string (str ) ); 
      msg = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) ; 
      mlen = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . tag_val ) ; 
    }

# 4559 "./../src/error.c"
    else {
#     define XfOrM714_COUNT (0+XfOrM713_COUNT)
#     define SETUP_XfOrM714(x) SETUP_XfOrM713(x)

# 4560 "./../src/error.c"
      msg = FUNCCALL(SETUP_XfOrM714(_), error_write_to_string_w_max (arg , len , ((void * ) 0 ) ) ); 
      raisetype = "raise called (with non-exception value)" ; 
    }
  }

  if (((((Scheme_Type ) (((((intptr_t ) (orig_arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_arg ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (orig_arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (orig_arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_arg ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (orig_arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) orig_arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) orig_arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) orig_arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) orig_arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && (scheme_is_struct_instance (exn_table [MZEXN ] . type , orig_arg ) ) ) {
    Scheme_Object * str ; 
    BLOCK_SETUP((PUSH(str, 0+XfOrM710_COUNT)));
#   define XfOrM712_COUNT (1+XfOrM710_COUNT)
#   define SETUP_XfOrM712(x) SETUP(XfOrM712_COUNT)
    str = NULLED_OUT ; 

# 4568 "./../src/error.c"
    str = FUNCCALL(SETUP_XfOrM712(_), scheme_struct_ref (orig_arg , 0 ) ); 
    orig_raisetype = "exception raised" ; 
    str = FUNCCALL(SETUP_XfOrM712(_), scheme_char_string_to_byte_string (str ) ); 
    orig_msg = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . string_val ) ; 
    orig_mlen = (((Scheme_Simple_Object * ) (str ) ) -> u . byte_str_val . tag_val ) ; 
  }

# 4573 "./../src/error.c"
  else {
#   define XfOrM711_COUNT (0+XfOrM710_COUNT)
#   define SETUP_XfOrM711(x) SETUP_XfOrM710(x)

# 4574 "./../src/error.c"
    orig_msg = FUNCCALL(SETUP_XfOrM711(_), error_write_to_string_w_max (orig_arg , len , ((void * ) 0 ) ) ); 
    orig_raisetype = "raise called (with non-exception value)" ; 
  }


  blen = FUNCCALL(SETUP_XfOrM710(_), scheme_sprintf (buffer , blen , "%s%s%s: %t; original %s: %t" , raisetype , sep , who , msg , mlen , orig_raisetype , orig_msg , orig_mlen ) )



  ; 
  FUNCCALL_EMPTY(call_error (buffer , blen , scheme_false ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4588 "./../src/error.c"
static void * do_raise_inside_barrier (void ) 
{
  Scheme_Object * arg ; 
  Scheme_Object * v , * p [1 ] , * h , * marks ; 
  Scheme_Cont_Mark_Chain * chain ; 
  Scheme_Cont_Frame_Data cframe , cframe2 ; 
  int got_chain ; 
  Scheme_Config * __funcarg151 = NULLED_OUT ; 
  Scheme_Object * __funcarg150 = NULLED_OUT ; 
  Scheme_Object * __funcarg149 = NULLED_OUT ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(10);
  BLOCK_SETUP_TOP((PUSH(arg, 0), PUSH(h, 1), PUSHARRAY(p, 1, 2), PUSH(cframe.cache, 5), PUSH(marks, 6), PUSH(v, 7), PUSH(chain, 8), PUSH(cframe2.cache, 9)));
# define XfOrM717_COUNT (10)
# define SETUP_XfOrM717(x) SETUP(XfOrM717_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  arg = NULLED_OUT ; 
  v = NULLED_OUT ; 
  p[0] = NULLED_OUT ; 
  h = NULLED_OUT ; 
  marks = NULLED_OUT ; 
  chain = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 
  cframe2.cache = NULLED_OUT ; 

# 4596 "./../src/error.c"
  arg = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p1 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p1 = ((void * ) 0 ) ; 

  h = FUNCCALL(SETUP_XfOrM717(_), scheme_extract_one_cc_mark (((void * ) 0 ) , scheme_exn_handler_key ) ); 

  chain = ((void * ) 0 ) ; 
  got_chain = 0 ; 

  while (1 ) {
#   define XfOrM727_COUNT (0+XfOrM717_COUNT)
#   define SETUP_XfOrM727(x) SETUP_XfOrM717(x)

# 4605 "./../src/error.c"
    if (! h ) {
#     define XfOrM735_COUNT (0+XfOrM727_COUNT)
#     define SETUP_XfOrM735(x) SETUP_XfOrM727(x)

# 4606 "./../src/error.c"
      h = (__funcarg151 = FUNCCALL(SETUP_XfOrM735(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg151 , MZCONFIG_INIT_EXN_HANDLER ) )) ; 
      chain = ((void * ) 0 ) ; 
      got_chain = 1 ; 
    }

    v = FUNCCALL(SETUP_XfOrM727(_), scheme_make_byte_string_without_copying ("exception handler" ) ); 
    v = (__funcarg150 = FUNCCALL(SETUP_XfOrM727(_), scheme_make_pair (v , arg ) )
    , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity ((Scheme_Closed_Prim * ) nested_exn_handler , __funcarg150 , "nested-exception-handler" , 1 , 1 ) )) 

    ; 
    FUNCCALL_AGAIN(scheme_push_continuation_frame (& cframe ) )
    ; 
    FUNCCALL_AGAIN(scheme_set_cont_mark (scheme_exn_handler_key , v ) ); 
    FUNCCALL_AGAIN(scheme_push_break_enable (& cframe2 , 0 , 0 ) ); 

    p [0 ] = arg ; 
    v = FUNCCALL(SETUP_XfOrM727(_), scheme_do_eval (h , 1 , p , 1 ) ); 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& cframe2 , 0 ) )
    ; 
    FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) ); 




    if (! got_chain ) {
#     define XfOrM732_COUNT (0+XfOrM727_COUNT)
#     define SETUP_XfOrM732(x) SETUP_XfOrM727(x)

# 4631 "./../src/error.c"
      marks = FUNCCALL(SETUP_XfOrM732(_), scheme_all_current_continuation_marks () ); 
      chain = ((Scheme_Cont_Mark_Set * ) marks ) -> chain ; 
      marks = ((void * ) 0 ) ; 


      while (chain -> key != scheme_exn_handler_key ) {
        chain = chain -> next ; 
      }
      got_chain = 1 ; 
    }

    if (chain ) {
      chain = chain -> next ; 
      while (chain && (chain -> key != scheme_exn_handler_key ) ) {
        chain = chain -> next ; 
      }

      if (! chain )
        h = ((void * ) 0 ) ; 
      else 
      h = chain -> val ; 
      arg = v ; 
    }

# 4653 "./../src/error.c"
    else {
#     define XfOrM728_COUNT (0+XfOrM727_COUNT)
#     define SETUP_XfOrM728(x) SETUP_XfOrM727(x)

# 4655 "./../src/error.c"
      p [0 ] = scheme_false ; 
      (__funcarg149 = FUNCCALL(SETUP_XfOrM728(_), scheme_make_pair (scheme_false , arg ) ), FUNCCALL_AGAIN(nested_exn_handler (__funcarg149 , 1 , p ) )) ; 

      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4664 "./../src/error.c"
static void 
do_raise (Scheme_Object * arg , int need_debug , int eb ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  char * __funcarg153 = NULLED_OUT ; 
  Scheme_Logger * __funcarg152 = NULLED_OUT ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(__funcarg152, 0), PUSH(p, 1), PUSH(arg, 2)));
# define XfOrM736_COUNT (3)
# define SETUP_XfOrM736(x) SETUP(XfOrM736_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4669 "./../src/error.c"
  if (p -> constant_folding ) {
#   define XfOrM739_COUNT (0+XfOrM736_COUNT)
#   define SETUP_XfOrM739(x) SETUP_XfOrM736(x)

# 4670 "./../src/error.c"
    if (p -> constant_folding != (Optimize_Info * ) scheme_false ) {
      const char * msg ; 
      BLOCK_SETUP((PUSH(msg, 0+XfOrM739_COUNT)));
#     define XfOrM741_COUNT (1+XfOrM739_COUNT)
#     define SETUP_XfOrM741(x) SETUP(XfOrM741_COUNT)
      msg = NULLED_OUT ; 

# 4672 "./../src/error.c"
      if (need_debug ) {
#       define XfOrM742_COUNT (0+XfOrM741_COUNT)
#       define SETUP_XfOrM742(x) SETUP_XfOrM741(x)

# 4673 "./../src/error.c"
        msg = FUNCCALL(SETUP_XfOrM742(_), scheme_display_to_string (((Scheme_Structure * ) arg ) -> slots [0 ] , ((void * ) 0 ) ) ); 
      }

# 4674 "./../src/error.c"
      else 
      msg = FUNCCALL(SETUP_XfOrM741(_), scheme_print_to_string (arg , ((void * ) 0 ) ) ); 
      (__funcarg152 = FUNCCALL(SETUP_XfOrM741(_), scheme_optimize_info_logger (p -> constant_folding ) ), __funcarg153 = FUNCCALL(SETUP_XfOrM741(_), scheme_optimize_info_context (p -> constant_folding ) )



      , FUNCCALL_AGAIN(scheme_log (__funcarg152 , 3 , 0 , "warning%s: constant-fold attempt failed: %s" , __funcarg153 , msg ) )) 
      ; 
    }
    if (((((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) arg ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && (scheme_is_struct_instance (exn_table [MZEXN_BREAK ] . type , arg ) ) ) {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> reading_delayed = arg ; 
    }
    (((intptr_t * ) (void * ) ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs ) ) [1 ] = (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . gcvs , longjmp ((* (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) ) . jb , 1 ) ) ; 
  }

  if (need_debug ) {
    Scheme_Object * marks ; 
    BLOCK_SETUP((PUSH(marks, 0+XfOrM736_COUNT)));
#   define XfOrM738_COUNT (1+XfOrM736_COUNT)
#   define SETUP_XfOrM738(x) SETUP(XfOrM738_COUNT)
    marks = NULLED_OUT ; 

# 4693 "./../src/error.c"
    marks = FUNCCALL(SETUP_XfOrM738(_), scheme_current_continuation_marks (((void * ) 0 ) ) ); 
    ((Scheme_Structure * ) arg ) -> slots [1 ] = marks ; 
  }

  p -> ku . k . p1 = arg ; 

  if (eb ) {
#   define XfOrM737_COUNT (0+XfOrM736_COUNT)
#   define SETUP_XfOrM737(x) SETUP_XfOrM736(x)
    FUNCCALL_EMPTY(scheme_top_level_do (do_raise_inside_barrier , 1 ) )
# 4700 "./../src/error.c"
    ; 
    FUNCCALL_EMPTY(__builtin_unreachable () ); 
  }
  else FUNCCALL_EMPTY(do_raise_inside_barrier () )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4707 "./../src/error.c"
static void 
sch_raise (int argc , Scheme_Object * argv [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM743_COUNT (1)
# define SETUP_XfOrM743(x) SETUP(XfOrM743_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4710 "./../src/error.c"
  if ((argc > 1 ) && (((argv [1 ] ) ) == (scheme_false ) ) )
    FUNCCALL(SETUP_XfOrM743(_), do_raise (argv [0 ] , 0 , 0 ) ); 
  else FUNCCALL_EMPTY(do_raise (argv [0 ] , 0 , 1 ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4716 "./../src/error.c"
void scheme_raise (Scheme_Object * exn ) 
{
  /* No conversion */

# 4718 "./../src/error.c"
  do_raise (exn , 0 , 1 ) ; 
}

typedef Scheme_Object (* Scheme_Struct_Field_Guard_Proc ) (int argc , Scheme_Object * v ) ; 

static Scheme_Object * exn_field_check (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * a [2 ] , * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSHARRAY(a, 2, 1), PUSH(argv, 4)));
# define XfOrM745_COUNT (5)
# define SETUP_XfOrM745(x) SETUP(XfOrM745_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 4727 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL(SETUP_XfOrM745(_), scheme_wrong_field_contract (argv [2 ] , "string?" , argv [0 ] ) ); 
  if (! ((argv [1 ] ) == (scheme_parameterization_key ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) )
    FUNCCALL(SETUP_XfOrM745(_), scheme_wrong_field_contract (argv [2 ] , "continuation-mark-set?" , argv [1 ] ) ); 

  a [0 ] = argv [0 ] ; 
  a [1 ] = argv [1 ] ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (a [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) && (((Scheme_Inclhash_Object * ) (a [0 ] ) ) -> so . keyex & 0x1 ) ) ) {
#   define XfOrM746_COUNT (0+XfOrM745_COUNT)
#   define SETUP_XfOrM746(x) SETUP_XfOrM745(x)

# 4736 "./../src/error.c"
    v = FUNCCALL(SETUP_XfOrM746(_), scheme_make_immutable_sized_char_string ((((Scheme_Simple_Object * ) (a [0 ] ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (a [0 ] ) ) -> u . char_str_val . tag_val ) , 1 ) )

    ; 
    a [0 ] = v ; 
  }

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM745(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4745 "./../src/error.c"
static Scheme_Object * variable_field_check (int argc , Scheme_Object * * argv ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM747_COUNT (1)
# define SETUP_XfOrM747(x) SETUP(XfOrM747_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4747 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL(SETUP_XfOrM747(_), scheme_wrong_field_contract (argv [3 ] , "symbol?" , argv [2 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (3 , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4753 "./../src/error.c"
static Scheme_Object * read_field_check (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * l ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(argv, 1)));
# define XfOrM748_COUNT (2)
# define SETUP_XfOrM748(x) SETUP(XfOrM748_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 

# 4757 "./../src/error.c"
  l = argv [2 ] ; 
  while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM750_COUNT (0+XfOrM748_COUNT)
#   define SETUP_XfOrM750(x) SETUP_XfOrM748(x)

# 4759 "./../src/error.c"
    if (! FUNCCALL(SETUP_XfOrM750(_), scheme_is_location ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ))
      break ; 
    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  }

  if (! ((l ) == (scheme_null ) ) )
    FUNCCALL(SETUP_XfOrM748(_), scheme_wrong_field_contract (argv [3 ] , "(listof srcloc?)" , argv [2 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (3 , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4770 "./../src/error.c"
static Scheme_Object * break_field_check (int argc , Scheme_Object * * argv ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM751_COUNT (1)
# define SETUP_XfOrM751(x) SETUP(XfOrM751_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4772 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) ) )
    FUNCCALL(SETUP_XfOrM751(_), scheme_wrong_field_contract (argv [3 ] , "escape-continuation?" , argv [2 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (3 , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4778 "./../src/error.c"
static Scheme_Object * errno_field_check (int argc , Scheme_Object * * argv ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM752_COUNT (1)
# define SETUP_XfOrM752(x) SETUP(XfOrM752_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4780 "./../src/error.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
  || ! FUNCCALL(SETUP_XfOrM752(_), scheme_exact_p ((((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . pair_val . car ) ) )
  || ! ((((((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . pair_val . cdr ) ) == (posix_symbol ) ) 
  || (((((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . pair_val . cdr ) ) == (windows_symbol ) ) 
  || (((((Scheme_Simple_Object * ) (argv [2 ] ) ) -> u . pair_val . cdr ) ) == (gai_symbol ) ) ) )
    FUNCCALL(SETUP_XfOrM752(_), scheme_wrong_field_contract (argv [3 ] , "(cons/c exact-integer? (or/c 'posix 'windows 'gai))" , argv [2 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (3 , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4790 "./../src/error.c"
static Scheme_Object * extract_read_locations (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4792 "./../src/error.c"
  if (scheme_is_struct_instance (exn_table [MZEXN_FAIL_READ ] . type , argv [0 ] ) )
    return scheme_struct_ref (argv [0 ] , 2 ) ; 
  scheme_wrong_contract ("exn:fail:read-locations-accessor" , "exn:fail:read?" , 0 , argc , argv ) ; 
  return ((void * ) 0 ) ; 
}

void scheme_init_exn (Scheme_Startup_Env * env ) 
{
  int i , j ; 
  Scheme_Object * tmpo , * * tmpop ; 

# 100 "./../src/schexn.h"
  static const char * MZEXN_FIELDS [2 ] = {

# 100 "./../src/schexn.h"
    "message" , "continuation-marks" }

# 100 "./../src/schexn.h"
  ; 
  static const char * MZEXN_FAIL_CONTRACT_VARIABLE_FIELDS [1 ] = {

# 101 "./../src/schexn.h"
    "id" }

# 101 "./../src/schexn.h"
  ; 
  static const char * MZEXN_FAIL_READ_FIELDS [1 ] = {

# 102 "./../src/schexn.h"
    "srclocs" }

# 102 "./../src/schexn.h"
  ; 
  static const char * MZEXN_FAIL_FILESYSTEM_ERRNO_FIELDS [1 ] = {

# 103 "./../src/schexn.h"
    "errno" }

# 103 "./../src/schexn.h"
  ; 
  static const char * MZEXN_FAIL_NETWORK_ERRNO_FIELDS [1 ] = {

# 104 "./../src/schexn.h"
    "errno" }

# 104 "./../src/schexn.h"
  ; 
  static const char * MZEXN_BREAK_FIELDS [1 ] = {

# 105 "./../src/schexn.h"
    "continuation" }

# 105 "./../src/schexn.h"
  ; 
  Scheme_Object * __funcarg164 = NULLED_OUT ; 
  Scheme_Object * __funcarg163 = NULLED_OUT ; 
  Scheme_Object * __funcarg162 = NULLED_OUT ; 
  Scheme_Object * __funcarg161 = NULLED_OUT ; 
  Scheme_Object * __funcarg160 = NULLED_OUT ; 
  Scheme_Object * __funcarg159 = NULLED_OUT ; 
  Scheme_Object * __funcarg158 = NULLED_OUT ; 
  Scheme_Object * __funcarg157 = NULLED_OUT ; 
  Scheme_Object * __funcarg156 = NULLED_OUT ; 
  Scheme_Object * __funcarg155 = NULLED_OUT ; 
  Scheme_Object * __funcarg154 = NULLED_OUT ; 
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(tmpop, 0), PUSH(__funcarg159, 1), PUSH(env, 2), PUSH(tmpo, 3)));
# define XfOrM754_COUNT (4)
# define SETUP_XfOrM754(x) SETUP(XfOrM754_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  tmpo = NULLED_OUT ; 
  tmpop = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM754(_), scheme_register_static ((void * ) & exn_table , sizeof (exn_table ) ) )
# 4810 "./../src/error.c"
  ; 

# 71 "./../src/schexn.h"
  exn_table = (exn_rec * ) FUNCCALL(SETUP_XfOrM754(_), GC_malloc (sizeof (exn_rec ) * MZEXN_OTHER ) ); 
  exn_table [MZEXN ] . args = 2 ; 
  exn_table [MZEXN_FAIL ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT_ARITY ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT_NON_FIXNUM_RESULT ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT_CONTINUATION ] . args = 2 ; 
  exn_table [MZEXN_FAIL_CONTRACT_VARIABLE ] . args = 3 ; 
  exn_table [MZEXN_FAIL_READ ] . args = 3 ; 
  exn_table [MZEXN_FAIL_READ_EOF ] . args = 3 ; 
  exn_table [MZEXN_FAIL_READ_NON_CHAR ] . args = 3 ; 
  exn_table [MZEXN_FAIL_FILESYSTEM ] . args = 2 ; 
  exn_table [MZEXN_FAIL_FILESYSTEM_EXISTS ] . args = 2 ; 
  exn_table [MZEXN_FAIL_FILESYSTEM_VERSION ] . args = 2 ; 
  exn_table [MZEXN_FAIL_FILESYSTEM_ERRNO ] . args = 3 ; 
  exn_table [MZEXN_FAIL_NETWORK ] . args = 2 ; 
  exn_table [MZEXN_FAIL_NETWORK_ERRNO ] . args = 3 ; 
  exn_table [MZEXN_FAIL_OUT_OF_MEMORY ] . args = 2 ; 
  exn_table [MZEXN_FAIL_UNSUPPORTED ] . args = 2 ; 
  exn_table [MZEXN_FAIL_USER ] . args = 2 ; 
  exn_table [MZEXN_BREAK ] . args = 3 ; 
  exn_table [MZEXN_BREAK_HANG_UP ] . args = 3 ; 
  exn_table [MZEXN_BREAK_TERMINATE ] . args = 3 ; 

# 113 "./../src/schexn.h"
  {
#   define XfOrM785_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM785(x) SETUP_XfOrM754(x)

# 113 "./../src/schexn.h"
    tmpo = (__funcarg164 = FUNCCALL(SETUP_XfOrM785(_), scheme_make_prim_w_arity (exn_field_check , "exn_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn" , ((void * ) 0 ) , 2 , scheme_null , __funcarg164 , 1 ) )) ; 

# 113 "./../src/schexn.h"
    exn_table [MZEXN ] . type = tmpo ; 

# 113 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM785(_), scheme_make_struct_names_from_array ("exn" , 2 , MZEXN_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN ] . count ) ); 

# 113 "./../src/schexn.h"
    exn_table [MZEXN ] . names = tmpop ; 
  }

# 114 "./../src/schexn.h"
  {
#   define XfOrM784_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM784(x) SETUP_XfOrM754(x)

# 114 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM784(_), scheme_make_struct_type_from_string ("exn:fail" , exn_table [MZEXN ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 114 "./../src/schexn.h"
    exn_table [MZEXN_FAIL ] . type = tmpo ; 

# 114 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM784(_), scheme_make_struct_names_from_array ("exn:fail" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL ] . count ) ); 

# 114 "./../src/schexn.h"
    exn_table [MZEXN_FAIL ] . names = tmpop ; 
  }

# 115 "./../src/schexn.h"
  {
#   define XfOrM783_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM783(x) SETUP_XfOrM754(x)

# 115 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM783(_), scheme_make_struct_type_from_string ("exn:fail:contract" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 115 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT ] . type = tmpo ; 

# 115 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM783(_), scheme_make_struct_names_from_array ("exn:fail:contract" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT ] . count ) ); 

# 115 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT ] . names = tmpop ; 
  }

# 116 "./../src/schexn.h"
  {
#   define XfOrM782_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM782(x) SETUP_XfOrM754(x)

# 116 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM782(_), scheme_make_struct_type_from_string ("exn:fail:contract:arity" , exn_table [MZEXN_FAIL_CONTRACT ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 116 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_ARITY ] . type = tmpo ; 

# 116 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM782(_), scheme_make_struct_names_from_array ("exn:fail:contract:arity" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT_ARITY ] . count ) ); 

# 116 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_ARITY ] . names = tmpop ; 
  }

# 117 "./../src/schexn.h"
  {
#   define XfOrM781_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM781(x) SETUP_XfOrM754(x)

# 117 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM781(_), scheme_make_struct_type_from_string ("exn:fail:contract:divide-by-zero" , exn_table [MZEXN_FAIL_CONTRACT ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 117 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO ] . type = tmpo ; 

# 117 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM781(_), scheme_make_struct_names_from_array ("exn:fail:contract:divide-by-zero" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO ] . count ) ); 

# 117 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_DIVIDE_BY_ZERO ] . names = tmpop ; 
  }

# 118 "./../src/schexn.h"
  {
#   define XfOrM780_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM780(x) SETUP_XfOrM754(x)

# 118 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM780(_), scheme_make_struct_type_from_string ("exn:fail:contract:non-fixnum-result" , exn_table [MZEXN_FAIL_CONTRACT ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 118 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_NON_FIXNUM_RESULT ] . type = tmpo ; 

# 118 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM780(_), scheme_make_struct_names_from_array ("exn:fail:contract:non-fixnum-result" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT_NON_FIXNUM_RESULT ] . count ) ); 

# 118 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_NON_FIXNUM_RESULT ] . names = tmpop ; 
  }

# 119 "./../src/schexn.h"
  {
#   define XfOrM779_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM779(x) SETUP_XfOrM754(x)

# 119 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM779(_), scheme_make_struct_type_from_string ("exn:fail:contract:continuation" , exn_table [MZEXN_FAIL_CONTRACT ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 119 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_CONTINUATION ] . type = tmpo ; 

# 119 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM779(_), scheme_make_struct_names_from_array ("exn:fail:contract:continuation" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT_CONTINUATION ] . count ) ); 

# 119 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_CONTINUATION ] . names = tmpop ; 
  }

# 120 "./../src/schexn.h"
  {
#   define XfOrM778_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM778(x) SETUP_XfOrM754(x)

# 120 "./../src/schexn.h"
    tmpo = (__funcarg163 = FUNCCALL(SETUP_XfOrM778(_), scheme_make_prim_w_arity (variable_field_check , "variable_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn:fail:contract:variable" , exn_table [MZEXN_FAIL_CONTRACT ] . type , 1 , scheme_null , __funcarg163 , 1 ) )) ; 

# 120 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_VARIABLE ] . type = tmpo ; 

# 120 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM778(_), scheme_make_struct_names_from_array ("exn:fail:contract:variable" , 1 , MZEXN_FAIL_CONTRACT_VARIABLE_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_CONTRACT_VARIABLE ] . count ) ); 

# 120 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_CONTRACT_VARIABLE ] . names = tmpop ; 
  }

# 121 "./../src/schexn.h"
  {
#   define XfOrM777_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM777(x) SETUP_XfOrM754(x)

# 121 "./../src/schexn.h"
    tmpo = (__funcarg159 = (__funcarg161 = (__funcarg162 = FUNCCALL(SETUP_XfOrM777(_), scheme_make_prim_w_arity (extract_read_locations , "extract_read_locations" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_pair (scheme_source_property , __funcarg162 ) )) , FUNCCALL_AGAIN(scheme_make_pair (__funcarg161 , scheme_null ) )) , __funcarg160 = FUNCCALL(SETUP_XfOrM777(_), scheme_make_prim_w_arity (read_field_check , "read_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn:fail:read" , exn_table [MZEXN_FAIL ] . type , 1 , __funcarg159 , __funcarg160 , 1 ) )) ; 

# 121 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_READ ] . type = tmpo ; 

# 121 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM777(_), scheme_make_struct_names_from_array ("exn:fail:read" , 1 , MZEXN_FAIL_READ_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_READ ] . count ) ); 

# 121 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_READ ] . names = tmpop ; 
  }

# 122 "./../src/schexn.h"
  {
#   define XfOrM776_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM776(x) SETUP_XfOrM754(x)

# 122 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM776(_), scheme_make_struct_type_from_string ("exn:fail:read:eof" , exn_table [MZEXN_FAIL_READ ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 122 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_READ_EOF ] . type = tmpo ; 

# 122 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM776(_), scheme_make_struct_names_from_array ("exn:fail:read:eof" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_READ_EOF ] . count ) ); 

# 122 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_READ_EOF ] . names = tmpop ; 
  }

# 123 "./../src/schexn.h"
  {
#   define XfOrM775_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM775(x) SETUP_XfOrM754(x)

# 123 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM775(_), scheme_make_struct_type_from_string ("exn:fail:read:non-char" , exn_table [MZEXN_FAIL_READ ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 123 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_READ_NON_CHAR ] . type = tmpo ; 

# 123 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM775(_), scheme_make_struct_names_from_array ("exn:fail:read:non-char" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_READ_NON_CHAR ] . count ) ); 

# 123 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_READ_NON_CHAR ] . names = tmpop ; 
  }

# 124 "./../src/schexn.h"
  {
#   define XfOrM774_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM774(x) SETUP_XfOrM754(x)

# 124 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM774(_), scheme_make_struct_type_from_string ("exn:fail:filesystem" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 124 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM ] . type = tmpo ; 

# 124 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM774(_), scheme_make_struct_names_from_array ("exn:fail:filesystem" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_FILESYSTEM ] . count ) ); 

# 124 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM ] . names = tmpop ; 
  }

# 125 "./../src/schexn.h"
  {
#   define XfOrM773_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM773(x) SETUP_XfOrM754(x)

# 125 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM773(_), scheme_make_struct_type_from_string ("exn:fail:filesystem:exists" , exn_table [MZEXN_FAIL_FILESYSTEM ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 125 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_EXISTS ] . type = tmpo ; 

# 125 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM773(_), scheme_make_struct_names_from_array ("exn:fail:filesystem:exists" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_FILESYSTEM_EXISTS ] . count ) ); 

# 125 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_EXISTS ] . names = tmpop ; 
  }

# 126 "./../src/schexn.h"
  {
#   define XfOrM772_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM772(x) SETUP_XfOrM754(x)

# 126 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM772(_), scheme_make_struct_type_from_string ("exn:fail:filesystem:version" , exn_table [MZEXN_FAIL_FILESYSTEM ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 126 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_VERSION ] . type = tmpo ; 

# 126 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM772(_), scheme_make_struct_names_from_array ("exn:fail:filesystem:version" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_FILESYSTEM_VERSION ] . count ) ); 

# 126 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_VERSION ] . names = tmpop ; 
  }

# 127 "./../src/schexn.h"
  {
#   define XfOrM771_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM771(x) SETUP_XfOrM754(x)

# 127 "./../src/schexn.h"
    tmpo = (__funcarg158 = FUNCCALL(SETUP_XfOrM771(_), scheme_make_prim_w_arity (errno_field_check , "errno_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn:fail:filesystem:errno" , exn_table [MZEXN_FAIL_FILESYSTEM ] . type , 1 , scheme_null , __funcarg158 , 1 ) )) ; 

# 127 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_ERRNO ] . type = tmpo ; 

# 127 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM771(_), scheme_make_struct_names_from_array ("exn:fail:filesystem:errno" , 1 , MZEXN_FAIL_FILESYSTEM_ERRNO_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_FILESYSTEM_ERRNO ] . count ) ); 

# 127 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_FILESYSTEM_ERRNO ] . names = tmpop ; 
  }

# 128 "./../src/schexn.h"
  {
#   define XfOrM770_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM770(x) SETUP_XfOrM754(x)

# 128 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM770(_), scheme_make_struct_type_from_string ("exn:fail:network" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 128 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_NETWORK ] . type = tmpo ; 

# 128 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM770(_), scheme_make_struct_names_from_array ("exn:fail:network" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_NETWORK ] . count ) ); 

# 128 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_NETWORK ] . names = tmpop ; 
  }

# 129 "./../src/schexn.h"
  {
#   define XfOrM769_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM769(x) SETUP_XfOrM754(x)

# 129 "./../src/schexn.h"
    tmpo = (__funcarg157 = FUNCCALL(SETUP_XfOrM769(_), scheme_make_prim_w_arity (errno_field_check , "errno_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn:fail:network:errno" , exn_table [MZEXN_FAIL_NETWORK ] . type , 1 , scheme_null , __funcarg157 , 1 ) )) ; 

# 129 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_NETWORK_ERRNO ] . type = tmpo ; 

# 129 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM769(_), scheme_make_struct_names_from_array ("exn:fail:network:errno" , 1 , MZEXN_FAIL_NETWORK_ERRNO_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_NETWORK_ERRNO ] . count ) ); 

# 129 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_NETWORK_ERRNO ] . names = tmpop ; 
  }

# 130 "./../src/schexn.h"
  {
#   define XfOrM768_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM768(x) SETUP_XfOrM754(x)

# 130 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM768(_), scheme_make_struct_type_from_string ("exn:fail:out-of-memory" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 130 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_OUT_OF_MEMORY ] . type = tmpo ; 

# 130 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM768(_), scheme_make_struct_names_from_array ("exn:fail:out-of-memory" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_OUT_OF_MEMORY ] . count ) ); 

# 130 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_OUT_OF_MEMORY ] . names = tmpop ; 
  }

# 131 "./../src/schexn.h"
  {
#   define XfOrM767_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM767(x) SETUP_XfOrM754(x)

# 131 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM767(_), scheme_make_struct_type_from_string ("exn:fail:unsupported" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 131 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_UNSUPPORTED ] . type = tmpo ; 

# 131 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM767(_), scheme_make_struct_names_from_array ("exn:fail:unsupported" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_UNSUPPORTED ] . count ) ); 

# 131 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_UNSUPPORTED ] . names = tmpop ; 
  }

# 132 "./../src/schexn.h"
  {
#   define XfOrM766_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM766(x) SETUP_XfOrM754(x)

# 132 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM766(_), scheme_make_struct_type_from_string ("exn:fail:user" , exn_table [MZEXN_FAIL ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 132 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_USER ] . type = tmpo ; 

# 132 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM766(_), scheme_make_struct_names_from_array ("exn:fail:user" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_FAIL_USER ] . count ) ); 

# 132 "./../src/schexn.h"
    exn_table [MZEXN_FAIL_USER ] . names = tmpop ; 
  }

# 133 "./../src/schexn.h"
  {
#   define XfOrM765_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM765(x) SETUP_XfOrM754(x)

# 133 "./../src/schexn.h"
    tmpo = (__funcarg156 = FUNCCALL(SETUP_XfOrM765(_), scheme_make_prim_w_arity (break_field_check , "break_field_check" , 0 , - 1 ) ), FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("exn:break" , exn_table [MZEXN ] . type , 1 , scheme_null , __funcarg156 , 1 ) )) ; 

# 133 "./../src/schexn.h"
    exn_table [MZEXN_BREAK ] . type = tmpo ; 

# 133 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM765(_), scheme_make_struct_names_from_array ("exn:break" , 1 , MZEXN_BREAK_FIELDS , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_BREAK ] . count ) ); 

# 133 "./../src/schexn.h"
    exn_table [MZEXN_BREAK ] . names = tmpop ; 
  }

# 134 "./../src/schexn.h"
  {
#   define XfOrM764_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM764(x) SETUP_XfOrM754(x)

# 134 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM764(_), scheme_make_struct_type_from_string ("exn:break:hang-up" , exn_table [MZEXN_BREAK ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 134 "./../src/schexn.h"
    exn_table [MZEXN_BREAK_HANG_UP ] . type = tmpo ; 

# 134 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM764(_), scheme_make_struct_names_from_array ("exn:break:hang-up" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_BREAK_HANG_UP ] . count ) ); 

# 134 "./../src/schexn.h"
    exn_table [MZEXN_BREAK_HANG_UP ] . names = tmpop ; 
  }

# 135 "./../src/schexn.h"
  {
#   define XfOrM763_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM763(x) SETUP_XfOrM754(x)

# 135 "./../src/schexn.h"
    tmpo = FUNCCALL(SETUP_XfOrM763(_), scheme_make_struct_type_from_string ("exn:break:terminate" , exn_table [MZEXN_BREAK ] . type , 0 , scheme_null , ((void * ) 0 ) , 1 ) ); 

# 135 "./../src/schexn.h"
    exn_table [MZEXN_BREAK_TERMINATE ] . type = tmpo ; 

# 135 "./../src/schexn.h"
    tmpop = FUNCCALL(SETUP_XfOrM763(_), scheme_make_struct_names_from_array ("exn:break:terminate" , 0 , ((void * ) 0 ) , (0x80 | 0x10 | 0x100 | 0x400 ) , & exn_table [MZEXN_BREAK_TERMINATE ] . count ) ); 

# 135 "./../src/schexn.h"
    exn_table [MZEXN_BREAK_TERMINATE ] . names = tmpop ; 
  }

# 4836 "./../src/error.c"
  for (i = 0 ; i < MZEXN_OTHER ; i ++ ) {
#   define XfOrM759_COUNT (0+XfOrM754_COUNT)
#   define SETUP_XfOrM759(x) SETUP_XfOrM754(x)

# 4837 "./../src/error.c"
    if (exn_table [i ] . count ) {
      Scheme_Object * * values ; 
      BLOCK_SETUP((PUSH(values, 0+XfOrM759_COUNT)));
#     define XfOrM760_COUNT (1+XfOrM759_COUNT)
#     define SETUP_XfOrM760(x) SETUP(XfOrM760_COUNT)
      values = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM760(_), scheme_force_struct_type_info ((Scheme_Struct_Type * ) exn_table [i ] . type ) )
# 4840 "./../src/error.c"
      ; 
      values = FUNCCALL_AGAIN(scheme_make_struct_values (exn_table [i ] . type , exn_table [i ] . names , exn_table [i ] . count , (0x80 | 0x10 | 0x100 | 0x400 ) ) )


      ; 
      for (j = exn_table [i ] . count - 1 ; j -- ; ) {
#       define XfOrM762_COUNT (0+XfOrM760_COUNT)
#       define SETUP_XfOrM762(x) SETUP_XfOrM760(x)
        FUNCCALL(SETUP_XfOrM762(_), scheme_addto_primitive_instance_by_symbol (exn_table [i ] . names [j ] , values [j ] , env ) ); 
      }
    }
  }
  (__funcarg155 = FUNCCALL(SETUP_XfOrM754(_), scheme_register_parameter (init_exn_handler , "uncaught-exception-handler" , MZCONFIG_INIT_EXN_HANDLER ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("uncaught-exception-handler" , __funcarg155 , env ) )) 
  ; 
  (__funcarg154 = FUNCCALL(SETUP_XfOrM754(_), scheme_make_noncm_prim ((Scheme_Prim * ) sch_raise , "raise" , 1 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("raise" , __funcarg154 , env ) )) 
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4866 "./../src/error.c"
void scheme_init_exn_config (void ) 
{
  Scheme_Object * h ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(h, 0)));
# define XfOrM786_COUNT (1)
# define SETUP_XfOrM786(x) SETUP(XfOrM786_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  h = NULLED_OUT ; 

# 4870 "./../src/error.c"
  h = FUNCCALL(SETUP_XfOrM786(_), scheme_make_prim_w_arity ((Scheme_Prim * ) def_exn_handler , "default-exception-handler" , 1 , 1 ) ); 
  FUNCCALL_EMPTY(scheme_set_root_param (MZCONFIG_INIT_EXN_HANDLER , h ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
