#include "precomp.h"

# 34 "../rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "./../../rktio/rktio.h"
typedef struct rktio_t rktio_t ; 

# 117 "./../../rktio/rktio.h"
__xform_nongcing__ extern void rktio_free (void * p ) ; 



typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "./../../rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 351 "./../../rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "./../../rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 

# 403 "./../../rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "./../../rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "./../../rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "./../../rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "./../../rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "./../../rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "./../../rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "./../../rktio/rktio.h"
rktio_process_result_t ; 

# 646 "./../../rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "./../../rktio/rktio.h"
rktio_status_t ; 

# 669 "./../../rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "./../../rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

# 742 "./../../rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

# 762 "./../../rktio/rktio.h"
enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

# 793 "./../../rktio/rktio.h"
enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 874 "./../../rktio/rktio.h"
typedef intptr_t rktio_timestamp_t ; 






typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "./../../rktio/rktio.h"
rktio_stat_t ; 



typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "./../../rktio/rktio.h"
rktio_identity_t ; 

# 925 "./../../rktio/rktio.h"
typedef struct rktio_directory_list_t rktio_directory_list_t ; 

# 947 "./../../rktio/rktio.h"
typedef struct rktio_file_copy_t rktio_file_copy_t ; 

# 975 "./../../rktio/rktio.h"
enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 






enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

# 1018 "./../../rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "./../../rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

# 1075 "./../../rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "./../../rktio/rktio.h"
rktio_date_t ; 

__xform_nongcing__ extern uintptr_t rktio_get_milliseconds (void ) ; 



__xform_nongcing__ extern double rktio_get_inexact_milliseconds (void ) ; 



__xform_nongcing__ extern double rktio_get_inexact_monotonic_milliseconds (rktio_t * rktio ) ; 



__xform_nongcing__ extern uintptr_t rktio_get_process_milliseconds (rktio_t * rktio ) ; 
__xform_nongcing__ extern uintptr_t rktio_get_process_children_milliseconds (rktio_t * rktio ) ; 



__xform_nongcing__ extern rktio_timestamp_t rktio_get_seconds (rktio_t * rktio ) ; 
__xform_nongcing__ extern rktio_date_t * rktio_seconds_to_date (rktio_t * rktio , rktio_timestamp_t seconds , int nanoseconds , int get_gmt ) ; 





enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1160 "./../../rktio/rktio.h"
enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "./../../rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "./../../rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "./../../rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "./../../rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "./../../rktio/rktio.h"
rktio_sha1_ctx_t ; 

# 1304 "./../../rktio/rktio.h"
typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "./../../rktio/rktio.h"
rktio_sha2_ctx_t ; 

# 1322 "./../../rktio/rktio.h"
typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "./../../rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 









__xform_nongcing__ extern int rktio_get_last_error_kind (rktio_t * rktio ) ; 


enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 

__xform_nongcing__ extern int rktio_get_last_error (rktio_t * rktio ) ; 


enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 

# 1436 "./../../rktio/rktio.h"
__xform_nongcing__ extern const char * rktio_get_last_error_string (rktio_t * rktio ) ; 

# 11 "./../src/fun.c"
static void ASSERT_SUSPEND_BREAK_ZERO () {
  /* No conversion */
}





int scheme_defining_primitives ; 

int scheme_prim_opt_flags [(1 << 7 ) ] ; 

Scheme_Object scheme_void [1 ] ; 
Scheme_Object * scheme_values_proc ; 
Scheme_Object * scheme_procedure_p_proc ; 
Scheme_Object * scheme_procedure_arity_includes_proc ; 
Scheme_Object * scheme_procedure_specialize_proc ; 
Scheme_Object * scheme_void_proc ; 
Scheme_Object * scheme_void_p_proc ; 
Scheme_Object * scheme_check_not_undefined_proc ; 
Scheme_Object * scheme_check_assign_not_undefined_proc ; 
Scheme_Object * scheme_apply_proc ; 
Scheme_Object * scheme_call_with_values_proc ; 
Scheme_Object * scheme_call_with_immed_mark_proc ; 
Scheme_Object * scheme_reduced_procedure_struct ; 
Scheme_Object * scheme_tail_call_waiting ; 
Scheme_Object * scheme_default_prompt_tag ; 
Scheme_Object * scheme_root_prompt_tag ; 
Scheme_Object * scheme_chaperone_undefined_property ; 



static Scheme_Object * certify_mode_symbol ; 
static Scheme_Object * taint_mode_symbol ; 
static Scheme_Object * transparent_symbol ; 
static Scheme_Object * transparent_binding_symbol ; 
static Scheme_Object * opaque_symbol ; 
static Scheme_Object * none_symbol ; 
static Scheme_Object * subprocesses_symbol ; 
static Scheme_Object * is_method_symbol ; 
static Scheme_Object * cont_key ; 
static Scheme_Object * barrier_prompt_key ; 
static Scheme_Object * prompt_cc_guard_key ; 
static Scheme_Object * mark_symbol ; 
static Scheme_Prompt * original_default_prompt ; 
static Scheme_Object * call_with_prompt_proc ; 
static Scheme_Object * abort_continuation_proc ; 
static Scheme_Object * internal_call_cc_prim ; 
static Scheme_Object * finish_call_cc_prim ; 
static Scheme_Object * propagate_abort_prim ; 


; 
; 
; 
; 
; 
; 
; 

; 
; 




static Scheme_Object * procedure_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * apply (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * map (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * for_each (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * andmap (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * ormap (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_cc (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * internal_call_cc (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * finish_call_cc (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_in_continuation (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * propagate_abort (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * continuation_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_continuation_barrier (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_prompt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_control (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_prompt_tag (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * abort_continuation (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * continuation_prompt_available (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * get_default_prompt_tag (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * prompt_tag_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonate_prompt_tag (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_prompt_tag (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_sema (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_sema_enable_break (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_continuation_mark_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * continuation_mark_key_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonate_continuation_mark_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_continuation_mark_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cc_marks (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cont_marks (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * cc_marks_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extract_cc_marks (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extract_cc_markses (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extract_cc_iterator (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extract_cc_proc_marks (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * extract_one_cc_mark (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_immediate_cc_mark (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * void_func (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * void_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * dynamic_wind (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * time_apply (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_milliseconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_inexact_milliseconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_inexact_monotonic_milliseconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_process_milliseconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_gc_milliseconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_seconds (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * seconds_to_date (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * object_name (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_arity (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_arity_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_arity_mask (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_reduce_arity (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_reduce_arity_mask (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_rename (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_to_method (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_equal_closure_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_specialize (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_procedure (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_chaperone_procedure (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonate_procedure (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_impersonate_procedure (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_procedure_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * impersonate_procedure_star (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * primitive_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * primitive_closure_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * primitive_result_arity (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * procedure_result_arity (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * call_with_values (int argc , Scheme_Object * argv [] ) ; 
Scheme_Object * scheme_values (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_print (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * current_prompt_read (int , Scheme_Object * * ) ; 
static Scheme_Object * current_read (int , Scheme_Object * * ) ; 
static Scheme_Object * current_get_read_input_port (int , Scheme_Object * * ) ; 
static Scheme_Object * current_get_interaction_evt (int , Scheme_Object * * ) ; 

static Scheme_Object * chaperone_wrap_cc_guard (Scheme_Object * obj , Scheme_Object * proc ) ; 
static Scheme_Object * do_cc_guard (Scheme_Object * v , Scheme_Object * cc_guard , Scheme_Object * chaperone ) ; 

static Scheme_Object * chaperone_unsafe_undefined (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * unsafe_abort_continuation_no_dws (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_call_with_control_no_dws (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * unsafe_root_continuation_prompt_tag (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * 
scheme_extract_one_cc_mark_with_meta (Scheme_Object * mark_set , Scheme_Object * key , 
Scheme_Object * prompt_tag , Scheme_Meta_Continuation * * _meta , 
intptr_t * _vpos ) ; 
static Scheme_Object * get_set_cont_mark_by_pos (Scheme_Object * key , 
Scheme_Thread * p , 
Scheme_Meta_Continuation * mc , 
intptr_t mpos , 
Scheme_Object * val ) ; 
static Scheme_Cont_Mark_Chain * current_mark_chain (const char * who , Scheme_Object * prompt_tag ) ; 

static Scheme_Object * jump_to_alt_continuation () ; 
static void reset_cjs (Scheme_Continuation_Jump_State * a ) ; 

typedef void (* DW_PrePost_Proc ) (void * ) ; 



static Scheme_Object * mask_to_arity (Scheme_Object * mask , int mode ) ; 


static void register_traversers (void ) ; 



typedef struct Scheme_Dynamic_Wind_List {
  Scheme_Type type ; 
  Scheme_Dynamic_Wind * dw ; 
  int meta_depth ; 
  struct Scheme_Dynamic_Wind_List * next ; 
}

# 192 "./../src/fun.c"
Scheme_Dynamic_Wind_List ; 





void 
scheme_init_fun (Scheme_Startup_Env * env ) 
{
  Scheme_Object * o ; 
  Scheme_Object * __funcarg110 = NULLED_OUT ; 
  Scheme_Object * __funcarg109 = NULLED_OUT ; 
  Scheme_Object * __funcarg108 = NULLED_OUT ; 
  Scheme_Object * __funcarg107 = NULLED_OUT ; 
  Scheme_Object * __funcarg106 = NULLED_OUT ; 
  Scheme_Object * __funcarg105 = NULLED_OUT ; 
  Scheme_Object * __funcarg104 = NULLED_OUT ; 
  Scheme_Object * __funcarg103 = NULLED_OUT ; 
  Scheme_Object * __funcarg102 = NULLED_OUT ; 
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  Scheme_Object * __funcarg100 = NULLED_OUT ; 
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  Scheme_Object * __funcarg98 = NULLED_OUT ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  Scheme_Object * __funcarg96 = NULLED_OUT ; 
  Scheme_Object * __funcarg95 = NULLED_OUT ; 
  Scheme_Object * __funcarg94 = NULLED_OUT ; 
  Scheme_Object * __funcarg93 = NULLED_OUT ; 
  Scheme_Object * __funcarg92 = NULLED_OUT ; 
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  Scheme_Object * __funcarg90 = NULLED_OUT ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(env, 1)));
# define XfOrM2_COUNT (2)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM2(_), register_traversers () )
# 204 "./../src/fun.c"
  ; 



  scheme_tail_call_waiting = ((Scheme_Object * ) 0x4 ) ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_procedure_p_proc , sizeof (scheme_procedure_p_proc ) ) )





  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_procedure_arity_includes_proc , sizeof (scheme_procedure_arity_includes_proc ) ) ); 

  o = FUNCCALL_AGAIN(scheme_make_folding_prim (procedure_p , "procedure?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 0 ) | (1 << 4 ) | (1 << 25 ) ) )

  ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("procedure?" , o , env ) ); 

  scheme_procedure_p_proc = o ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_apply_proc , sizeof (scheme_apply_proc ) ) )
  ; 
  scheme_apply_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (apply , 1 , "apply" , 2 , - 1 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("apply" , scheme_apply_proc , env ) ); 

  o = FUNCCALL_AGAIN(scheme_make_noncm_prim (map , "map" , 2 , - 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 24 ) ) ); 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("map" , o , env ) ); 

  o = FUNCCALL_AGAIN(scheme_make_noncm_prim (for_each , "for-each" , 2 , - 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 24 ) ) ); 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("for-each" , o , env ) ); 

  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (andmap , "andmap" , 2 , - 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 24 ) ) ); 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("andmap" , o , env ) ); 

  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (ormap , "ormap" , 2 , - 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 24 ) ) ); 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("ormap" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_call_with_values_proc , sizeof (scheme_call_with_values_proc ) ) )
  ; 
  scheme_call_with_values_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (call_with_values , 1 , "call-with-values" , 2 , 2 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-values" , scheme_call_with_values_proc , env ) )

  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_values_proc , sizeof (scheme_values_proc ) ) )
  ; 
  scheme_values_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (scheme_values , 1 , "values" , 0 , - 1 , 0 , 0 , - 1 ) )


  ; 
  (((Scheme_Prim_Proc_Header * ) scheme_values_proc ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 0 ) | (1 << 1 ) | (1 << 2 ) | (1 << 4 ) ) )


  ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("values" , scheme_values_proc , env ) )

  ; 

  o = FUNCCALL_AGAIN(scheme_make_prim_w_everything (scheme_call_ec , 1 , "call-with-escape-continuation" , 1 , 1 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-escape-continuation" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & internal_call_cc_prim , sizeof (internal_call_cc_prim ) ) )
  ; 
  internal_call_cc_prim = FUNCCALL_AGAIN(scheme_make_prim_w_everything (internal_call_cc , 1 , "call-with-current-continuation" , 1 , 3 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & finish_call_cc_prim , sizeof (finish_call_cc_prim ) ) ); 
  finish_call_cc_prim = FUNCCALL_AGAIN(scheme_make_prim_w_everything (finish_call_cc , 1 , "finish-call-with-current-continuation" , 2 , 2 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & propagate_abort_prim , sizeof (propagate_abort_prim ) ) ); 
  propagate_abort_prim = FUNCCALL_AGAIN(scheme_make_prim_w_arity (propagate_abort , "propagate-abort" , 0 , - 1 ) ); 


  o = FUNCCALL_AGAIN(scheme_make_prim_w_everything (call_cc , 1 , "call-with-current-continuation" , 1 , 2 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-current-continuation" , o , env ) )
  ; 
  (__funcarg110 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (call_with_control , 1 , "call-with-composable-continuation" , 1 , 2 , 0 , 0 , - 1 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-composable-continuation" , __funcarg110 , env ) )) 
  ; 
  (__funcarg109 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (continuation_p , "continuation?" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation?" , __funcarg109 , env ) )) 
  ; 
  (__funcarg108 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (call_with_continuation_barrier , 1 , "call-with-continuation-barrier" , 1 , 1 , 0 , 0 , - 1 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-continuation-barrier" , __funcarg108 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & call_with_prompt_proc , sizeof (call_with_prompt_proc ) ) )
  ; 
  call_with_prompt_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (call_with_prompt , 1 , "call-with-continuation-prompt" , 1 , - 1 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-continuation-prompt" , call_with_prompt_proc , env ) )

  ; 
  (__funcarg107 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (call_in_continuation , 1 , "call-in-continuation" , 2 , 2 , 0 , 0 , - 1 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-in-continuation" , __funcarg107 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & abort_continuation_proc , sizeof (abort_continuation_proc ) ) )
  ; 
  abort_continuation_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (abort_continuation , "abort-current-continuation" , 1 , - 1 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("abort-current-continuation" , abort_continuation_proc , env ) )

  ; 
  (__funcarg106 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (continuation_prompt_available , "continuation-prompt-available?" , 1 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-prompt-available?" , __funcarg106 , env ) )) 
  ; 
  (__funcarg105 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (make_prompt_tag , "make-continuation-prompt-tag" , 0 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-continuation-prompt-tag" , __funcarg105 , env ) )) 
  ; 
  (__funcarg104 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (get_default_prompt_tag , "default-continuation-prompt-tag" , 0 , 0 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("default-continuation-prompt-tag" , __funcarg104 , env ) )) 
  ; 
  (__funcarg103 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (prompt_tag_p , "continuation-prompt-tag?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-prompt-tag?" , __funcarg103 , env ) )) 
  ; 
  (__funcarg102 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (impersonate_prompt_tag , "impersonate-prompt-tag" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-prompt-tag" , __funcarg102 , env ) )) 
  ; 
  (__funcarg101 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_prompt_tag , "chaperone-prompt-tag" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-prompt-tag" , __funcarg101 , env ) )) 
  ; 
  (__funcarg100 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (call_with_sema , 1 , "call-with-semaphore" , 2 , - 1 , 0 , 0 , - 1 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-semaphore" , __funcarg100 , env ) )) 
  ; 
  (__funcarg99 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (call_with_sema_enable_break , 1 , "call-with-semaphore/enable-break" , 2 , - 1 , 0 , 0 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-semaphore/enable-break" , __funcarg99 , env ) )) 
  ; 
  (__funcarg98 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (make_continuation_mark_key , "make-continuation-mark-key" , 0 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-continuation-mark-key" , __funcarg98 , env ) )) 
  ; 
  (__funcarg97 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (continuation_mark_key_p , "continuation-mark-key?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-key?" , __funcarg97 , env ) )) 
  ; 
  (__funcarg96 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (impersonate_continuation_mark_key , "impersonate-continuation-mark-key" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-continuation-mark-key" , __funcarg96 , env ) )) 
  ; 
  (__funcarg95 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_continuation_mark_key , "chaperone-continuation-mark-key" , 3 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-continuation-mark-key" , __funcarg95 , env ) )) 
  ; 
  (__funcarg94 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (cc_marks , "current-continuation-marks" , 0 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-continuation-marks" , __funcarg94 , env ) )) 
  ; 
  (__funcarg93 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (cont_marks , "continuation-marks" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-marks" , __funcarg93 , env ) )) 
  ; 
  (__funcarg92 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (extract_cc_marks , "continuation-mark-set->list" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-set->list" , __funcarg92 , env ) )) 
  ; 
  (__funcarg91 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (extract_cc_markses , "continuation-mark-set->list*" , 2 , 4 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-set->list*" , __funcarg91 , env ) )) 
  ; 
  (__funcarg90 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (extract_cc_iterator , "continuation-mark-set->iterator" , 2 , 4 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-set->iterator" , __funcarg90 , env ) )) 
  ; 

  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (extract_one_cc_mark , "continuation-mark-set-first" , 2 , 4 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 1 ) ) ); 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("continuation-mark-set-first" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_call_with_immed_mark_proc , sizeof (scheme_call_with_immed_mark_proc ) ) )
  ; 
  scheme_call_with_immed_mark_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (call_with_immediate_cc_mark , 1 , "call-with-immediate-continuation-mark" , 2 , 3 , 0 , 0 , - 1 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("call-with-immediate-continuation-mark" , scheme_call_with_immed_mark_proc , env ) )

  ; 
  (__funcarg89 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (cc_marks_p , "continuation-mark-set?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-set?" , __funcarg89 , env ) )) 
  ; 
  (__funcarg88 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (extract_cc_proc_marks , "continuation-mark-set->context" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("continuation-mark-set->context" , __funcarg88 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_void_proc , sizeof (scheme_void_proc ) ) )
  ; 
  scheme_void_proc = FUNCCALL_AGAIN(scheme_make_folding_prim (void_func , "void" , 0 , - 1 , 1 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) scheme_void_proc ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 4 ) ) ); 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("void" , scheme_void_proc , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_void_p_proc , sizeof (scheme_void_p_proc ) ) )

  ; 
  scheme_void_p_proc = FUNCCALL_AGAIN(scheme_make_folding_prim (void_p , "void?" , 1 , 1 , 1 ) ); 
  (((Scheme_Prim_Proc_Header * ) scheme_void_p_proc ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 0 ) | (1 << 4 ) | (1 << 25 ) ) )

  ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("void?" , scheme_void_p_proc , env ) ); 
  (__funcarg87 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (time_apply , 1 , "time-apply" , 2 , 2 , 0 , 4 , 4 ) )




  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("time-apply" , __funcarg87 , env ) )) 
  ; 
  (__funcarg86 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_milliseconds , "current-milliseconds" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-milliseconds" , __funcarg86 , env ) )) 
  ; 
  (__funcarg85 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_inexact_milliseconds , "current-inexact-milliseconds" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-inexact-milliseconds" , __funcarg85 , env ) )) 
  ; 
  (__funcarg84 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_inexact_monotonic_milliseconds , "current-inexact-monotonic-milliseconds" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-inexact-monotonic-milliseconds" , __funcarg84 , env ) )) 
  ; 
  (__funcarg83 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_process_milliseconds , "current-process-milliseconds" , 0 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-process-milliseconds" , __funcarg83 , env ) )) 
  ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_gc_milliseconds , "current-gc-milliseconds" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-gc-milliseconds" , __funcarg82 , env ) )) 
  ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (current_seconds , "current-seconds" , 0 , 0 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-seconds" , __funcarg81 , env ) )) 
  ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (seconds_to_date , "seconds->date" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("seconds->date" , __funcarg80 , env ) )) 
  ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (dynamic_wind , "dynamic-wind" , 3 , 3 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("dynamic-wind" , __funcarg79 , env ) )) 
  ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (object_name , "object-name" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("object-name" , __funcarg78 , env ) )) 
  ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (procedure_arity , "procedure-arity" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-arity" , __funcarg77 , env ) )) 
  ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (procedure_arity_p , "procedure-arity?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-arity?" , __funcarg76 , env ) )) 
  ; 

  o = FUNCCALL_AGAIN(scheme_make_folding_prim (scheme_procedure_arity_includes , "procedure-arity-includes?" , 2 , 3 , 1 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 1 ) | (1 << 24 ) | (1 << 25 ) ) )

  ; 
  scheme_procedure_arity_includes_proc = o ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("procedure-arity-includes?" , o , env ) ); 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (procedure_arity_mask , "procedure-arity-mask" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-arity-mask" , __funcarg75 , env ) )) 
  ; 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (procedure_reduce_arity , "procedure-reduce-arity" , 2 , 3 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-reduce-arity" , __funcarg74 , env ) )) 
  ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (procedure_rename , "procedure-rename" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-rename" , __funcarg73 , env ) )) 
  ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (procedure_reduce_arity_mask , "procedure-reduce-arity-mask" , 2 , 3 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-reduce-arity-mask" , __funcarg72 , env ) )) 
  ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (procedure_to_method , "procedure->method" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure->method" , __funcarg71 , env ) )) 
  ; 

  o = FUNCCALL_AGAIN(scheme_make_folding_prim (procedure_equal_closure_p , "procedure-closure-contents-eq?" , 2 , 2 , 1 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 24 ) | (1 << 25 ) ) )
  ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("procedure-closure-contents-eq?" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_procedure_specialize_proc , sizeof (scheme_procedure_specialize_proc ) ) )
  ; 
  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (procedure_specialize , "procedure-specialize" , 1 , 1 ) )

  ; 
  scheme_procedure_specialize_proc = o ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("procedure-specialize" , o , env ) ); 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_procedure , "chaperone-procedure" , 2 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-procedure" , __funcarg70 , env ) )) 
  ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (impersonate_procedure , "impersonate-procedure" , 2 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-procedure" , __funcarg69 , env ) )) 
  ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_procedure_star , "chaperone-procedure*" , 2 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-procedure*" , __funcarg68 , env ) )) 
  ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (impersonate_procedure_star , "impersonate-procedure*" , 2 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-procedure*" , __funcarg67 , env ) )) 
  ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (primitive_p , "primitive?" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("primitive?" , __funcarg66 , env ) )) 
  ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (primitive_closure_p , "primitive-closure?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("primitive-closure?" , __funcarg65 , env ) )) 
  ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (primitive_result_arity , "primitive-result-arity" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("primitive-result-arity" , __funcarg64 , env ) )) 
  ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (procedure_result_arity , "procedure-result-arity" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-result-arity" , __funcarg63 , env ) )) 
  ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_print , "current-print" , MZCONFIG_PRINT_HANDLER ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-print" , __funcarg62 , env ) )) 
  ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_prompt_read , "current-prompt-read" , MZCONFIG_PROMPT_READ_HANDLER ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-prompt-read" , __funcarg61 , env ) )) 
  ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_read , "current-read-interaction" , MZCONFIG_READ_HANDLER ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-read-interaction" , __funcarg60 , env ) )) 
  ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_get_read_input_port , "current-get-interaction-input-port" , MZCONFIG_READ_INPUT_PORT_HANDLER ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-get-interaction-input-port" , __funcarg59 , env ) )) 
  ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_get_interaction_evt , "current-get-interaction-evt" , MZCONFIG_READ_GET_EVT ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-get-interaction-evt" , __funcarg58 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & certify_mode_symbol , sizeof (certify_mode_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & taint_mode_symbol , sizeof (taint_mode_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & transparent_symbol , sizeof (transparent_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & transparent_binding_symbol , sizeof (transparent_binding_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & opaque_symbol , sizeof (opaque_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & none_symbol , sizeof (none_symbol ) ) ); 
  certify_mode_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("certify-mode" ) ); 
  taint_mode_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("taint-mode" ) ); 
  transparent_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("transparent" ) ); 
  transparent_binding_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("transparent-binding" ) ); 
  opaque_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("opaque" ) ); 
  none_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("none" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & subprocesses_symbol , sizeof (subprocesses_symbol ) ) )
  ; 
  subprocesses_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("subprocesses" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & is_method_symbol , sizeof (is_method_symbol ) ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & cont_key , sizeof (cont_key ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & barrier_prompt_key , sizeof (barrier_prompt_key ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & prompt_cc_guard_key , sizeof (prompt_cc_guard_key ) ) ); 
  is_method_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("method-arity-error" ) ); 
  cont_key = FUNCCALL_AGAIN(scheme_make_symbol ("k" ) ); 
  barrier_prompt_key = FUNCCALL_AGAIN(scheme_make_symbol ("bar" ) ); 
  prompt_cc_guard_key = FUNCCALL_AGAIN(scheme_make_symbol ("cc" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & mark_symbol , sizeof (mark_symbol ) ) )
  ; 
  mark_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("mark" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_default_prompt_tag , sizeof (scheme_default_prompt_tag ) ) )
  ; 
  {
    Scheme_Object * a [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM2_COUNT)));
#   define XfOrM4_COUNT (3+XfOrM2_COUNT)
#   define SETUP_XfOrM4(x) SETUP(XfOrM4_COUNT)
    a[0] = NULLED_OUT ; 

# 693 "./../src/fun.c"
    a [0 ] = FUNCCALL(SETUP_XfOrM4(_), scheme_intern_symbol ("default" ) ); 
    scheme_default_prompt_tag = FUNCCALL(SETUP_XfOrM4(_), make_prompt_tag (1 , a ) ); 
    (void ) (scheme_hash_key ((((Scheme_Small_Object * ) (scheme_default_prompt_tag ) ) -> u . ptr_val ) ) ) ; 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_root_prompt_tag , sizeof (scheme_root_prompt_tag ) ) )
  ; 
  {
    Scheme_Object * a [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(a, 1, 0+XfOrM2_COUNT)));
#   define XfOrM3_COUNT (3+XfOrM2_COUNT)
#   define SETUP_XfOrM3(x) SETUP(XfOrM3_COUNT)
    a[0] = NULLED_OUT ; 

# 701 "./../src/fun.c"
    a [0 ] = FUNCCALL(SETUP_XfOrM3(_), scheme_intern_symbol ("root" ) ); 
    scheme_root_prompt_tag = FUNCCALL(SETUP_XfOrM3(_), make_prompt_tag (1 , a ) ); 
    (void ) (scheme_hash_key ((((Scheme_Small_Object * ) (scheme_root_prompt_tag ) ) -> u . ptr_val ) ) ) ; 
  }
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & original_default_prompt , sizeof (original_default_prompt ) ) )
  ; 
  original_default_prompt = ((Scheme_Prompt * ) FUNCCALL_EMPTY(GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  original_default_prompt -> so . type = scheme_prompt_type ; 
  original_default_prompt -> tag = scheme_default_prompt_tag ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 712 "./../src/fun.c"
void 
scheme_init_unsafe_fun (Scheme_Startup_Env * env ) 
{
  Scheme_Object * o ; 
  Scheme_Object * __funcarg116 = NULLED_OUT ; 
  Scheme_Object * __funcarg115 = NULLED_OUT ; 
  Scheme_Object * __funcarg114 = NULLED_OUT ; 
  Scheme_Object * __funcarg113 = NULLED_OUT ; 
  Scheme_Object * __funcarg112 = NULLED_OUT ; 
  Scheme_Object * __funcarg111 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(env, 1)));
# define XfOrM5_COUNT (2)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_register_static ((void * ) & scheme_check_not_undefined_proc , sizeof (scheme_check_not_undefined_proc ) ) )
# 717 "./../src/fun.c"
  ; 
  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_check_not_undefined , "check-not-unsafe-undefined" , 2 , 2 ) ); 
  scheme_check_not_undefined_proc = o ; 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= (2 
  | FUNCCALL(SETUP_XfOrM5(_), scheme_intern_prim_opt_flags ((1 << 1 ) ) )) ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("check-not-unsafe-undefined" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_check_assign_not_undefined_proc , sizeof (scheme_check_assign_not_undefined_proc ) ) )
  ; 
  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_check_assign_not_undefined , "check-not-unsafe-undefined/assign" , 2 , 2 ) ); 
  scheme_check_assign_not_undefined_proc = o ; 
  (((Scheme_Prim_Proc_Header * ) o ) -> flags ) |= FUNCCALL(SETUP_XfOrM5(_), scheme_intern_prim_opt_flags ((1 << 1 ) ) ); 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("check-not-unsafe-undefined/assign" , o , env ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-undefined" , scheme_undefined , env ) )
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_chaperone_undefined_property , sizeof (scheme_chaperone_undefined_property ) ) )
  ; 
  o = (__funcarg116 = FUNCCALL(SETUP_XfOrM5(_), scheme_intern_symbol ("chaperone-unsafe-undefined" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg116 ) )) ; 
  scheme_chaperone_undefined_property = o ; 
  FUNCCALL(SETUP_XfOrM5(_), scheme_addto_prim_instance ("prop:chaperone-unsafe-undefined" , o , env ) ); 

  o = FUNCCALL_AGAIN(scheme_make_prim_w_arity (chaperone_unsafe_undefined , "chaperone-struct-unsafe-undefined" , 1 , 1 ) ); 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-struct-unsafe-undefined" , o , env ) ); 
  (__funcarg115 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (unsafe_chaperone_procedure , "unsafe-chaperone-procedure" , 2 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-chaperone-procedure" , __funcarg115 , env ) )) 
  ; 
  (__funcarg114 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (unsafe_impersonate_procedure , "unsafe-impersonate-procedure" , 2 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-impersonate-procedure" , __funcarg114 , env ) )) 
  ; 
  (__funcarg113 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (unsafe_abort_continuation_no_dws , "unsafe-abort-current-continuation/no-wind" , 2 , 2 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-abort-current-continuation/no-wind" , __funcarg113 , env ) )) ; 
  (__funcarg112 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (unsafe_call_with_control_no_dws , "unsafe-call-with-composable-continuation/no-wind" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-call-with-composable-continuation/no-wind" , __funcarg112 , env ) )) ; 
  (__funcarg111 = FUNCCALL(SETUP_XfOrM5(_), scheme_make_prim_w_arity (unsafe_root_continuation_prompt_tag , "unsafe-root-continuation-prompt-tag" , 0 , 0 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("unsafe-root-continuation-prompt-tag" , __funcarg111 , env ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 757 "./../src/fun.c"
void 
scheme_init_fun_places () 
{
  /* No conversion */

# 760 "./../src/fun.c"
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_cont_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_cont_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) ) ) ; 
}


Scheme_Object * 
scheme_make_void (void ) 
{
  /* No conversion */

# 768 "./../src/fun.c"
  return scheme_void ; 
}





static Scheme_Object * 
make_prim_closure (Scheme_Prim * fun , int eternal , 
const char * name , 
mzshort mina , mzshort maxa , 
int flags , 
mzshort minr , mzshort maxr , 
int closed , int count , Scheme_Object * * vals ) 
{
  Scheme_Primitive_Proc * prim ; 
  int hasr , size ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(prim, 0), PUSH(fun, 1), PUSH(vals, 2), PUSH(name, 3)));
# define XfOrM8_COUNT (4)
# define SETUP_XfOrM8(x) SETUP(XfOrM8_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prim = NULLED_OUT ; 

# 786 "./../src/fun.c"
  hasr = ((minr != 1 ) || (maxr != 1 ) ) ; 
  size = (hasr 
  ? sizeof (Scheme_Prim_W_Result_Arity ) 
  : (closed 
  ? (sizeof (Scheme_Primitive_Closure ) 
  + ((count - 0 ) * sizeof (Scheme_Object * ) ) ) 
  : sizeof (Scheme_Primitive_Proc ) ) ) ; 

  if (eternal && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) && ! closed )
    prim = (Scheme_Primitive_Proc * ) FUNCCALL(SETUP_XfOrM8(_), GC_malloc_atomic_uncollectable (size ) ); 
  else 
  prim = (Scheme_Primitive_Proc * ) FUNCCALL(SETUP_XfOrM8(_), GC_malloc_one_tagged (size ) ); 
  prim -> pp . so . type = scheme_prim_type ; 
  prim -> prim_val = (Scheme_Primitive_Closure_Proc * ) fun ; 
  prim -> name = name ; 
  prim -> mina = mina ; 
  if (maxa < 0 )
    maxa = 0x3FFFFFFE + 1 ; 
  prim -> mu . maxa = maxa ; 
  prim -> pp . flags = (flags 
  | (scheme_defining_primitives ? 4 : 0 ) 
  | (hasr ? 8 : 0 ) 
  | (closed ? 16 : 0 ) ) ; 

  if (hasr ) {
    ((Scheme_Prim_W_Result_Arity * ) prim ) -> minr = minr ; 
    ((Scheme_Prim_W_Result_Arity * ) prim ) -> maxr = maxr ; 
  }
  if (closed ) {
#   define XfOrM9_COUNT (0+XfOrM8_COUNT)
#   define SETUP_XfOrM9(x) SETUP_XfOrM8(x)

# 816 "./../src/fun.c"
    ((Scheme_Primitive_Closure * ) prim ) -> count = count ; 
    (
    memcpy (((Scheme_Primitive_Closure * ) prim ) -> val , 
    vals , 
    count * sizeof (Scheme_Object * ) ) ) ; 
  }

  RET_VALUE_START ((Scheme_Object * ) prim ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 826 "./../src/fun.c"
Scheme_Object * 
scheme_make_prim_w_everything (Scheme_Prim * fun , int eternal , 
const char * name , 
mzshort mina , mzshort maxa , 
int flags , 
mzshort minr , mzshort maxr ) 
{
  /* No conversion */

# 833 "./../src/fun.c"
  return make_prim_closure (fun , eternal , 
  name , 
  mina , maxa , 
  flags , 
  minr , maxr , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * scheme_make_prim (Scheme_Prim * fun ) 
{
  /* No conversion */

# 843 "./../src/fun.c"
  return make_prim_closure (fun , 1 , ((void * ) 0 ) , 0 , - 1 , 0 , 1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_noneternal_prim (Scheme_Prim * fun ) 
{
  /* No conversion */

# 850 "./../src/fun.c"
  return make_prim_closure (fun , 0 , ((void * ) 0 ) , 0 , - 1 , 0 , 1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_prim_w_arity (Scheme_Prim * fun , const char * name , 
mzshort mina , mzshort maxa ) 
{
  /* No conversion */

# 858 "./../src/fun.c"
  return make_prim_closure (fun , 1 , name , mina , maxa , 0 , 1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_noncm_prim (Scheme_Prim * fun , const char * name , 
mzshort mina , mzshort maxa ) 
{
  /* No conversion */



  return make_prim_closure (fun , 1 , name , mina , maxa , 
  1 , 
  1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_immed_prim (Scheme_Prim * fun , const char * name , 
mzshort mina , mzshort maxa ) 
{
  /* No conversion */



  return make_prim_closure (fun , 1 , name , mina , maxa , 
  2 , 
  1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_folding_prim (Scheme_Prim * fun , const char * name , 
mzshort mina , mzshort maxa , 
short folding ) 
{
  /* No conversion */

  return make_prim_closure (fun , 1 , name , mina , maxa , 
  (folding 
  ? 3 
  : 0 ) , 
  1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_make_noneternal_prim_w_arity (Scheme_Prim * fun , const char * name , 
mzshort mina , mzshort maxa ) 
{
  /* No conversion */

# 909 "./../src/fun.c"
  return make_prim_closure (fun , 0 , name , mina , maxa , 0 , 1 , 1 , 
  0 , 0 , ((void * ) 0 ) ) ; 
}

Scheme_Object * scheme_make_prim_closure_w_arity (Scheme_Primitive_Closure_Proc * prim , 
int size , Scheme_Object * * vals , 
const char * name , 
mzshort mina , mzshort maxa ) 
{
  /* No conversion */

# 918 "./../src/fun.c"
  return make_prim_closure ((Scheme_Prim * ) prim , 1 , name , mina , maxa , 0 , 1 , 1 , 
  1 , size , vals ) ; 
}


Scheme_Object * scheme_make_folding_prim_closure (Scheme_Primitive_Closure_Proc * prim , 
int size , Scheme_Object * * vals , 
const char * name , 
mzshort mina , mzshort maxa , 
short functional ) 
{
  /* No conversion */

# 929 "./../src/fun.c"
  return make_prim_closure ((Scheme_Prim * ) prim , 1 , name , mina , maxa , 
  (functional 
  ? 3 
  : 0 ) , 
  1 , 1 , 
  1 , size , vals ) ; 
}

Scheme_Object * 
scheme_make_closed_prim_w_everything (Scheme_Closed_Prim * fun , 
void * data , 
const char * name , 
mzshort mina , mzshort maxa , 
short folding , 
mzshort minr , mzshort maxr ) 
{
  Scheme_Closed_Primitive_Proc * prim ; 
  int hasr , size ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(data, 0), PUSH(prim, 1), PUSH(fun, 2), PUSH(name, 3)));
# define XfOrM21_COUNT (4)
# define SETUP_XfOrM21(x) SETUP(XfOrM21_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prim = NULLED_OUT ; 

# 948 "./../src/fun.c"
  hasr = ((minr != 1 ) || (maxr != 1 ) ) ; 
  size = hasr ? sizeof (Scheme_Closed_Prim_W_Result_Arity ) : sizeof (Scheme_Closed_Primitive_Proc ) ; 

  prim = (Scheme_Closed_Primitive_Proc * ) FUNCCALL(SETUP_XfOrM21(_), GC_malloc_one_tagged (size ) ); 

  prim -> pp . so . type = scheme_closed_prim_type ; 
  (((Scheme_Closed_Primitive_Proc * ) (prim ) ) -> prim_val ) = fun ; 
  (((Scheme_Closed_Primitive_Proc * ) (prim ) ) -> data ) = data ; 
  prim -> name = name ; 
  prim -> mina = mina ; 
  prim -> maxa = maxa ; 
  prim -> pp . flags = ((folding ? 3 : 0 ) 
  | (scheme_defining_primitives ? 4 : 0 ) 
  | (hasr ? 8 : 0 ) ) ; 

  if (hasr ) {
    ((Scheme_Closed_Prim_W_Result_Arity * ) prim ) -> minr = minr ; 
    ((Scheme_Closed_Prim_W_Result_Arity * ) prim ) -> maxr = maxr ; 
  }

  RET_VALUE_START ((Scheme_Object * ) prim ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 971 "./../src/fun.c"
Scheme_Object * 
scheme_make_folding_closed_prim (Scheme_Closed_Prim * fun , 
void * data , 
const char * name , 
mzshort mina , mzshort maxa , 
short folding ) 
{
  /* No conversion */

# 978 "./../src/fun.c"
  return scheme_make_closed_prim_w_everything (fun , data , name , mina , maxa , folding , 1 , 1 ) ; 
}

Scheme_Object * 
scheme_make_closed_prim_w_arity (Scheme_Closed_Prim * fun , void * data , 
const char * name , mzshort mina , mzshort maxa ) 
{
  /* No conversion */

# 985 "./../src/fun.c"
  return scheme_make_closed_prim_w_everything (fun , data , name , mina , maxa , 0 , 1 , 1 ) ; 
}

Scheme_Object * 
scheme_make_closed_prim (Scheme_Closed_Prim * fun , void * data ) 
{
  /* No conversion */

# 991 "./../src/fun.c"
  return scheme_make_closed_prim_w_everything (fun , data , ((void * ) 0 ) , 0 , - 1 , 0 , 1 , 1 ) ; 
}

void scheme_prim_is_method (Scheme_Object * o ) 
{
  /* No conversion */

# 996 "./../src/fun.c"
  scheme_signal_error ("no longer supported" ) ; 
}

int scheme_has_method_property (Scheme_Object * code ) 
{
  /* No conversion */

# 1001 "./../src/fun.c"
  return (! (((scheme_stx_property (code , is_method_symbol , ((void * ) 0 ) ) ) ) == (scheme_false ) ) ) ; 
}

int scheme_intern_prim_opt_flags (int flags ) 
{
  /* No conversion */

# 1006 "./../src/fun.c"
  int i ; 

  if (! flags )

# 1008 "./../src/fun.c"
  return 0 ; 

  for (i = 1 ; i < (1 << 7 ) ; i ++ ) {
    if (scheme_prim_opt_flags [i ] == flags )
      return (i << 9 ) ; 
    else if (! scheme_prim_opt_flags [i ] ) {
      scheme_prim_opt_flags [i ] = flags ; 
      return (i << 9 ) ; 
    }
  }

  scheme_log_abort ("too many flag combinations" ) ; 
  abort () ; 

  return 0 ; 
}





static void initialize_prompt (Scheme_Thread * p , Scheme_Prompt * prompt , void * stack_boundary , int is_barrier ) 
{
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(prompt, 0)));
# define XfOrM33_COUNT (1)
# define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1031 "./../src/fun.c"
  prompt -> is_barrier = is_barrier ; 
  prompt -> stack_boundary = stack_boundary ; 
  if (is_barrier ) {

    Scheme_Object * ref ; 
    BLOCK_SETUP((PUSH(ref, 0+XfOrM33_COUNT)));
#   define XfOrM34_COUNT (1+XfOrM33_COUNT)
#   define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
    ref = NULLED_OUT ; 

# 1036 "./../src/fun.c"
    ref = FUNCCALL(SETUP_XfOrM34(_), scheme_make_weak_box ((Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) ); 
    prompt -> u . runstack_boundary_start_ref = ref ; 
    prompt -> weak_boundary = 1 ; 
  }

# 1039 "./../src/fun.c"
  else 
  prompt -> u . runstack_boundary_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ; 
  prompt -> runstack_boundary_offset = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) ; 
  prompt -> mark_boundary = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
  prompt -> boundary_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1046 "./../src/fun.c"
Scheme_Object * * scheme_prompt_runstack_boundary_start (Scheme_Prompt * p ) 
{
  /* No conversion */

# 1048 "./../src/fun.c"
  if (p -> weak_boundary )
    return (Scheme_Object * * ) ((((Scheme_Small_Object * ) (p -> u . runstack_boundary_start_ref ) ) -> u . ptr_val ) ) ; 
  else 
  return p -> u . runstack_boundary_start ; 
}

static void init_prompt_id (Scheme_Prompt * prompt ) 
{
  Scheme_Object * id ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(prompt, 0), PUSH(id, 1)));
# define XfOrM36_COUNT (2)
# define SETUP_XfOrM36(x) SETUP(XfOrM36_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  id = NULLED_OUT ; 

# 1058 "./../src/fun.c"
  if (! prompt -> id ) {
#   define XfOrM37_COUNT (0+XfOrM36_COUNT)
#   define SETUP_XfOrM37(x) SETUP_XfOrM36(x)

# 1059 "./../src/fun.c"
    id = FUNCCALL(SETUP_XfOrM37(_), scheme_make_pair (scheme_false , scheme_false ) ); 
    prompt -> id = id ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1064 "./../src/fun.c"
Scheme_Prompt * make_weak_prompt (Scheme_Prompt * p ) 
{
  Scheme_Prompt * p2 ; 
  Scheme_Object * ref ; 
  DECL_RET_SAVE (Scheme_Prompt * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(p2, 1), PUSH(ref, 2)));
# define XfOrM38_COUNT (3)
# define SETUP_XfOrM38(x) SETUP(XfOrM38_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p2 = NULLED_OUT ; 
  ref = NULLED_OUT ; 

# 1069 "./../src/fun.c"
  if (p -> weak_boundary )
    RET_VALUE_START (p ) RET_VALUE_END ; 
  FUNCCALL(SETUP_XfOrM38(_), init_prompt_id (p ) )
  ; 

  p2 = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM38(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  (memcpy (p2 , p , sizeof (Scheme_Prompt ) ) ) ; 

  ref = FUNCCALL(SETUP_XfOrM38(_), scheme_make_weak_box ((Scheme_Object * ) p2 -> u . runstack_boundary_start ) ); 
  p2 -> u . runstack_boundary_start_ref = ref ; 
  p2 -> weak_boundary = 1 ; 

  RET_VALUE_START (p2 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

typedef Scheme_Object * (* Overflow_K_Proc ) (void ) ; 

; 
; 

void scheme_really_create_overflow (void * stack_base ) __attribute__ ((noinline ) ) ; 

void scheme_really_create_overflow (void * stack_base ) 
{
  Scheme_Overflow_Jmp * jmp ; 
  PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(stack_base, 0), PUSH(jmp, 1)));
# define XfOrM39_COUNT (2)
# define SETUP_XfOrM39(x) SETUP(XfOrM39_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  jmp = NULLED_OUT ; 

# 1099 "./../src/fun.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) )
    RET_NOTHING ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_stack_start_ ) = stack_base ; 

  jmp = ((Scheme_Overflow_Jmp * ) FUNCCALL(SETUP_XfOrM39(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow_Jmp ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  jmp -> type = scheme_rt_overflow_jmp ; 
  FUNCCALL(SETUP_XfOrM39(_), scheme_init_jmpup_buf (& jmp -> cont ) )

  ; 
  if (FUNCCALL(SETUP_XfOrM39(_), scheme_setjmpup_relative (& jmp -> cont , jmp , stack_base , ((void * ) 0 ) ) )) {





    Scheme_Thread * volatile p ; 
    Scheme_Overflow * volatile overflow ; 
    mz_jmp_buf nestedbuf ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM39_COUNT), PUSH(overflow, 1+XfOrM39_COUNT)));
#   define XfOrM41_COUNT (2+XfOrM39_COUNT)
#   define SETUP_XfOrM41(x) SETUP(XfOrM41_COUNT)
    p = NULLED_OUT ; 
    overflow = NULLED_OUT ; 

# 1120 "./../src/fun.c"
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    overflow = p -> overflow ; 

    overflow -> jmp -> savebuf = p -> error_buf ; 
    p -> error_buf = & nestedbuf ; 
    if (((nestedbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (nestedbuf ) . gcvs_cnt = XfOrM41_COUNT , (_setjmp ((nestedbuf ) . jb ) ) ) ) {

      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      p -> overflow_reply = ((void * ) 0 ) ; 
    }

# 1129 "./../src/fun.c"
    else {
      void * p1 , * p2 , * p3 , * p4 , * p5 ; 
      intptr_t i1 , i2 , i3 , i4 ; 
      Overflow_K_Proc f = p -> overflow_k ; 
      Scheme_Object * reply ; 
      BLOCK_SETUP((PUSH(reply, 0+XfOrM41_COUNT), PUSH(p1, 1+XfOrM41_COUNT), PUSH(p2, 2+XfOrM41_COUNT), PUSH(p5, 3+XfOrM41_COUNT), PUSH(p3, 4+XfOrM41_COUNT), PUSH(p4, 5+XfOrM41_COUNT)));
#     define XfOrM42_COUNT (6+XfOrM41_COUNT)
#     define SETUP_XfOrM42(x) SETUP(XfOrM42_COUNT)
      p1 = NULLED_OUT ; 
      p2 = NULLED_OUT ; 
      p3 = NULLED_OUT ; 
      p4 = NULLED_OUT ; 
      p5 = NULLED_OUT ; 
      reply = NULLED_OUT ; 

# 1135 "./../src/fun.c"
      p1 = p -> ku . k . p1 ; 
      p2 = p -> ku . k . p2 ; 
      p3 = p -> ku . k . p3 ; 
      p4 = p -> ku . k . p4 ; 
      p5 = p -> ku . k . p5 ; 
      i1 = p -> ku . k . i1 ; 
      i2 = p -> ku . k . i2 ; 
      i3 = p -> ku . k . i3 ; 
      i4 = p -> ku . k . i4 ; 
      FUNCCALL(SETUP_XfOrM42(_), scheme_thread_block (0 ) )

      ; 
      p -> ran_some = 1 ; 

      p -> ku . k . p1 = p1 ; 
      p -> ku . k . p2 = p2 ; 
      p -> ku . k . p3 = p3 ; 
      p -> ku . k . p4 = p4 ; 
      p -> ku . k . p5 = p5 ; 
      p -> ku . k . i1 = i1 ; 
      p -> ku . k . i2 = i2 ; 
      p -> ku . k . i3 = i3 ; 
      p -> ku . k . i4 = i4 ; 

      reply = FUNCCALL(SETUP_XfOrM42(_), f () ); 
      (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> overflow_reply ) = reply ; 





      if (reply == ((Scheme_Object * ) 0x6 ) ) {
        p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
        if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
          p -> values_buffer = ((void * ) 0 ) ; 
      }

# 1170 "./../src/fun.c"
      else if (reply == ((Scheme_Object * ) 0x4 ) ) {
#       define XfOrM43_COUNT (0+XfOrM42_COUNT)
#       define SETUP_XfOrM43(x) SETUP_XfOrM42(x)

# 1171 "./../src/fun.c"
        p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
        if (p -> ku . apply . tail_rands == p -> tail_buffer )
          FUNCCALL(SETUP_XfOrM43(_), scheme_realloc_tail_buffer (p ) ); 
      }
    }

    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    overflow = p -> overflow ; 
    p -> stack_start = overflow -> stack_start ; 
    FUNCCALL(SETUP_XfOrM41(_), scheme_longjmpup (& overflow -> jmp -> cont ) )

    ; 
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) ) {
#   define XfOrM40_COUNT (0+XfOrM39_COUNT)
#   define SETUP_XfOrM40(x) SETUP_XfOrM39(x)
    FUNCCALL(SETUP_XfOrM40(_), scheme_signal_error ("shouldn't get here!" ) )
# 1186 "./../src/fun.c"
    ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) = jmp ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1192 "./../src/fun.c"
void scheme_create_overflow (void ) 
{
  void * stack_marker ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(stack_marker, 0)));
# define XfOrM46_COUNT (1)
# define SETUP_XfOrM46(x) SETUP(XfOrM46_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stack_marker = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM46(_), scheme_really_create_overflow (& __gc_var_stack__ ) )
# 1195 "./../src/fun.c"
  ; 
  stack_marker = ((void * ) 0 ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1199 "./../src/fun.c"
void scheme_init_overflow (void ) 
{
  /* No conversion */

# 1201 "./../src/fun.c"
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) ) ) ; 
}

void scheme_reset_overflow (void ) 
{
  /* No conversion */

# 1206 "./../src/fun.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_overflow_jmp_ ) = ((void * ) 0 ) ; 
}





static Scheme_Prompt * allocate_prompt (Scheme_Prompt * * cached_prompt ) {
  Scheme_Prompt * prompt ; 
  DECL_RET_SAVE (Scheme_Prompt * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(prompt, 0)));
# define XfOrM49_COUNT (1)
# define SETUP_XfOrM49(x) SETUP(XfOrM49_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prompt = NULLED_OUT ; 

# 1215 "./../src/fun.c"
  if (* cached_prompt ) {
    prompt = * cached_prompt ; 
    * cached_prompt = ((void * ) 0 ) ; 
  }

# 1218 "./../src/fun.c"
  else {
#   define XfOrM50_COUNT (0+XfOrM49_COUNT)
#   define SETUP_XfOrM50(x) SETUP_XfOrM49(x)

# 1219 "./../src/fun.c"
    prompt = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM50(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    prompt -> so . type = scheme_prompt_type ; 
  }
  RET_VALUE_START (prompt ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1225 "./../src/fun.c"
static void * apply_again_k (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * val = p -> ku . k . p1 ; 
  int num_vals = p -> ku . k . i1 ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(val, 0)));
# define XfOrM52_COUNT (1)
# define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1231 "./../src/fun.c"
  p -> ku . k . p1 = ((void * ) 0 ) ; 

  if (num_vals != 1 ) {
#   define XfOrM54_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM54(x) SETUP_XfOrM52(x)
    FUNCCALL(SETUP_XfOrM54(_), scheme_wrong_return_arity ("call-with-continuation-prompt" , 1 , num_vals , (Scheme_Object * * ) val , "\n  in: application of default prompt handler" ) )
# 1235 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 1237 "./../src/fun.c"
  else {
#   define XfOrM53_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM53(x) SETUP_XfOrM52(x)
    FUNCCALL(SETUP_XfOrM53(_), scheme_check_proc_arity ("default-continuation-prompt-handler" , 0 , 0 , 1 , & val ) )
# 1238 "./../src/fun.c"
    ; 
    RET_VALUE_START ((void * ) FUNCCALL(SETUP_XfOrM53(_), scheme_do_eval (val , 0 , ((void * ) 0 ) , 1 ) )) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1243 "./../src/fun.c"
void * scheme_top_level_do (void * (* k ) (void ) , int eb ) {
  /* No conversion */

# 1244 "./../src/fun.c"
  return scheme_top_level_do_worker (k , eb , 0 ) ; 
}

void * scheme_top_level_do_worker (void * (* k ) (void ) , int eb , int new_thread ) 
{


  void * v ; 
  Scheme_Prompt * volatile prompt = ((void * ) 0 ) ; 
  mz_jmp_buf * save ; 
  mz_jmp_buf newbuf ; 
  Scheme_Stack_State envss ; 
  Scheme_Thread * volatile p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  volatile int old_pcc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ; 
  Scheme_Cont_Frame_Data cframe ; 
  volatile int need_final_abort = 0 ; 

  void * external_stack ; 

  int num_vals = p -> ku . k . i1 ; 
  void * val = p -> ku . k . p1 ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(p, 1), PUSH(external_stack, 2), PUSH(v, 3), PUSH(prompt, 4), PUSH(cframe.cache, 5), PUSH(save, 6)));
# define XfOrM56_COUNT (7)
# define SETUP_XfOrM56(x) SETUP(XfOrM56_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  save = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 
  external_stack = NULLED_OUT ; 

# 1266 "./../src/fun.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_active_but_sleeping_ ) )
    FUNCCALL(SETUP_XfOrM56(_), scheme_wake_up () ); 

  if (eb ) {
#   define XfOrM83_COUNT (0+XfOrM56_COUNT)
#   define SETUP_XfOrM83(x) SETUP_XfOrM56(x)

# 1270 "./../src/fun.c"
    prompt = FUNCCALL(SETUP_XfOrM83(_), allocate_prompt (& XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_ ) ) ); 
    FUNCCALL(SETUP_XfOrM83(_), initialize_prompt (p , prompt , & __gc_var_stack__ , ! new_thread ) ); 
  }


  if (scheme_get_external_stack_val )
    external_stack = FUNCCALL(SETUP_XfOrM56(_), scheme_get_external_stack_val () ); 
  else 
  external_stack = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM56(_), scheme_create_overflow () )

  ; 

  save = p -> error_buf ; 

  while (1 ) {
#   define XfOrM72_COUNT (0+XfOrM56_COUNT)
#   define SETUP_XfOrM72(x) SETUP_XfOrM56(x)

# 1287 "./../src/fun.c"
    (envss . runstack_offset = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) , envss . cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) , envss . cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ; 

    if (prompt ) {
#     define XfOrM82_COUNT (0+XfOrM72_COUNT)
#     define SETUP_XfOrM82(x) SETUP_XfOrM72(x)
      FUNCCALL(SETUP_XfOrM82(_), scheme_push_continuation_frame (& cframe ) )
# 1290 "./../src/fun.c"
      ; 
      FUNCCALL(SETUP_XfOrM82(_), scheme_set_cont_mark (barrier_prompt_key , (Scheme_Object * ) prompt ) ); 
    }

    p -> error_buf = & newbuf ; 

    if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM72_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
      int again ; 
#     define XfOrM75_COUNT (0+XfOrM72_COUNT)
#     define SETUP_XfOrM75(x) SETUP_XfOrM72(x)

# 1299 "./../src/fun.c"
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

      if ((p -> cjs . jumping_to_continuation ) == ((Scheme_Object * ) original_default_prompt ) )  {
#       define XfOrM81_COUNT (0+XfOrM75_COUNT)
#       define SETUP_XfOrM81(x) SETUP_XfOrM75(x)
        num_vals = p -> cjs . num_vals ; 
        val = p -> cjs . val ; 
        FUNCCALL(SETUP_XfOrM81(_), reset_cjs (& p -> cjs ) ); 
        k = apply_again_k ; 
        need_final_abort = 1 ; 
        again = 1 ; 
      }

# 1310 "./../src/fun.c"
      else {
        num_vals = 0 ; 
        val = ((void * ) 0 ) ; 
        again = 0 ; 
      }

      if (! new_thread || again ) {
#       define XfOrM76_COUNT (0+XfOrM75_COUNT)
#       define SETUP_XfOrM76(x) SETUP_XfOrM75(x)

# 1317 "./../src/fun.c"
        (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + envss . runstack_offset , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = envss . cont_mark_stack , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = envss . cont_mark_pos ) ; 

        if (scheme_set_external_stack_val )
          FUNCCALL(SETUP_XfOrM76(_), scheme_set_external_stack_val (external_stack ) ); 

        if (prompt ) {
#         define XfOrM77_COUNT (0+XfOrM76_COUNT)
#         define SETUP_XfOrM77(x) SETUP_XfOrM76(x)
          FUNCCALL(SETUP_XfOrM77(_), scheme_pop_continuation_frame (& cframe ) )
# 1323 "./../src/fun.c"
          ; 
          if (! again ) {
            if (old_pcc == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ) {

              XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_ ) = prompt ; 
            }
          }
        }
      }

      if (! again )
        (((intptr_t * ) (void * ) ((* save ) . gcvs ) ) [1 ] = (* save ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* save ) . gcvs , longjmp ((* save ) . jb , 1 ) ) ; 
    }

# 1335 "./../src/fun.c"
    else {
#     define XfOrM73_COUNT (0+XfOrM72_COUNT)
#     define SETUP_XfOrM73(x) SETUP_XfOrM72(x)

# 1336 "./../src/fun.c"
      if (new_thread ) {
#       define XfOrM74_COUNT (0+XfOrM73_COUNT)
#       define SETUP_XfOrM74(x) SETUP_XfOrM73(x)
        FUNCCALL(SETUP_XfOrM74(_), scheme_check_break_now () )
# 1338 "./../src/fun.c"
        ; 
      }

      p -> ku . k . i1 = num_vals ; 
      p -> ku . k . p1 = val ; 

      v = FUNCCALL(SETUP_XfOrM73(_), k () ); 

      break ; 
    }
  }





  if (! new_thread ) {
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

    p -> error_buf = save ; 
  }

  if (prompt ) {
#   define XfOrM58_COUNT (0+XfOrM56_COUNT)
#   define SETUP_XfOrM58(x) SETUP_XfOrM56(x)
    FUNCCALL(SETUP_XfOrM58(_), scheme_pop_continuation_frame (& cframe ) )
# 1361 "./../src/fun.c"
    ; 
    if (old_pcc == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ) {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_ ) = prompt ; 
    }
  }

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_active_but_sleeping_ ) )
    FUNCCALL(SETUP_XfOrM56(_), scheme_wake_up () ); 

  if (need_final_abort ) {
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    (((intptr_t * ) (void * ) ((* p -> error_buf ) . gcvs ) ) [1 ] = (* p -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* p -> error_buf ) . gcvs , longjmp ((* p -> error_buf ) . jb , 1 ) ) ; 
  }

  RET_VALUE_START ((Scheme_Object * ) v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1380 "./../src/fun.c"
void scheme_clear_prompt_cache () 
{
  /* No conversion */

# 1382 "./../src/fun.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_cws_prompt_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_mc_ ) = ((void * ) 0 ) ; 
}

static void ensure_overflow_id (Scheme_Overflow * overflow ) 
{
  void * id ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(id, 0), PUSH(overflow, 1)));
# define XfOrM85_COUNT (2)
# define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  id = NULLED_OUT ; 

# 1392 "./../src/fun.c"
  if (! overflow -> id ) {
#   define XfOrM86_COUNT (0+XfOrM85_COUNT)
#   define SETUP_XfOrM86(x) SETUP_XfOrM85(x)

# 1393 "./../src/fun.c"
    if (overflow -> jmp ) {
      overflow -> id = overflow -> jmp ; 
    }

# 1395 "./../src/fun.c"
    else {
#     define XfOrM87_COUNT (0+XfOrM86_COUNT)
#     define SETUP_XfOrM87(x) SETUP_XfOrM86(x)

# 1396 "./../src/fun.c"
      id = FUNCCALL(SETUP_XfOrM87(_), GC_malloc_atomic (4 ) ); 
      overflow -> id = id ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1402 "./../src/fun.c"
void scheme_ensure_dw_id (Scheme_Dynamic_Wind * dw ) 
{
  void * id ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(id, 0), PUSH(dw, 1)));
# define XfOrM89_COUNT (2)
# define SETUP_XfOrM89(x) SETUP(XfOrM89_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  id = NULLED_OUT ; 

# 1405 "./../src/fun.c"
  if (! dw -> id ) {
#   define XfOrM90_COUNT (0+XfOrM89_COUNT)
#   define SETUP_XfOrM90(x) SETUP_XfOrM89(x)

# 1406 "./../src/fun.c"
    id = FUNCCALL(SETUP_XfOrM90(_), GC_malloc_atomic (4 ) ); 
    dw -> id = id ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * 
force_values (Scheme_Object * obj , int multi_ok ) 


{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(obj, 0)));
# define XfOrM91_COUNT (1)
# define SETUP_XfOrM91(x) SETUP(XfOrM91_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1420 "./../src/fun.c"
  if ((obj ) == (((Scheme_Object * ) 0x4 ) ) )  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    GC_CAN_IGNORE Scheme_Object * rator , * result ; 
    GC_CAN_IGNORE Scheme_Object * * rands ; 
    int argc = p -> ku . apply . tail_num_rands , popc = 0 ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM91_COUNT)));
#   define XfOrM93_COUNT (1+XfOrM91_COUNT)
#   define SETUP_XfOrM93(x) SETUP(XfOrM93_COUNT)

# 1426 "./../src/fun.c"
    rands = p -> ku . apply . tail_rands ; 


    if (rands == p -> tail_buffer ) {
      GC_CAN_IGNORE Scheme_Object * * runstack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
#     define XfOrM94_COUNT (0+XfOrM93_COUNT)
#     define SETUP_XfOrM94(x) SETUP_XfOrM93(x)

# 1431 "./../src/fun.c"
      if (((runstack - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) - argc ) > 5 ) {
#       define XfOrM96_COUNT (0+XfOrM94_COUNT)
#       define SETUP_XfOrM96(x) SETUP_XfOrM94(x)

# 1433 "./../src/fun.c"
        runstack -= argc ; 
        (memcpy (runstack , rands , argc * sizeof (Scheme_Object * ) ) ) ; 
        rands = runstack ; 
        popc = argc ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = rands ; 
      }

# 1438 "./../src/fun.c"
      else {
#       define XfOrM95_COUNT (0+XfOrM94_COUNT)
#       define SETUP_XfOrM95(x) SETUP_XfOrM94(x)
        FUNCCALL(SETUP_XfOrM95(_), scheme_realloc_tail_buffer (p ) )
# 1439 "./../src/fun.c"
        ; 
        rands = p -> ku . apply . tail_rands ; 
      }
    }

    rator = p -> ku . apply . tail_rator ; 
    p -> ku . apply . tail_rator = ((void * ) 0 ) ; 
    p -> ku . apply . tail_rands = ((void * ) 0 ) ; 

    if (multi_ok )
      result = FUNCCALL(SETUP_XfOrM93(_), scheme_do_eval (rator , argc , rands , - 1 ) ); 
    else 
    result = FUNCCALL(SETUP_XfOrM93(_), scheme_do_eval (rator , argc , rands , 1 ) ); 

    if (popc )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += popc ; 

    RET_VALUE_START (result ) RET_VALUE_END ; 
  }

# 1457 "./../src/fun.c"
  else if ((obj ) == (((Scheme_Object * ) 0x2 ) ) )  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM92_COUNT (0+XfOrM91_COUNT)
#   define SETUP_XfOrM92(x) SETUP_XfOrM91(x)

# 1459 "./../src/fun.c"
    if (multi_ok )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_do_eval (p -> ku . eval . wait_expr , - 1 , ((void * ) 0 ) , - 1 ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_do_eval (p -> ku . eval . wait_expr , - 1 , ((void * ) 0 ) , 1 ) )) RET_VALUE_EMPTY_END ; 
  }

# 1463 "./../src/fun.c"
  else if (obj )
    RET_VALUE_START (obj ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1469 "./../src/fun.c"
Scheme_Object * 
scheme_force_value (Scheme_Object * obj ) 
{
  /* No conversion */

# 1472 "./../src/fun.c"
  return force_values (obj , 1 ) ; 
}

Scheme_Object * 
scheme_force_one_value (Scheme_Object * obj ) 
{
  /* No conversion */

# 1478 "./../src/fun.c"
  return force_values (obj , 0 ) ; 
}

Scheme_Object * 
scheme_force_value_same_mark (Scheme_Object * obj ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM99_COUNT (1)
# define SETUP_XfOrM99(x) SETUP(XfOrM99_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 1486 "./../src/fun.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 








  v = FUNCCALL(SETUP_XfOrM99(_), force_values (obj , 1 ) ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1502 "./../src/fun.c"
Scheme_Object * 
scheme_force_one_value_same_mark (Scheme_Object * obj ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM100_COUNT (1)
# define SETUP_XfOrM100(x) SETUP(XfOrM100_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 1507 "./../src/fun.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 


  v = FUNCCALL(SETUP_XfOrM100(_), force_values (obj , 0 ) ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1517 "./../src/fun.c"
static void * apply_k (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * rator ; 
  int num_rands ; 
  Scheme_Object * * rands ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(rator, 0), PUSH(rands, 1)));
# define XfOrM101_COUNT (2)
# define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  rator = NULLED_OUT ; 
  rands = NULLED_OUT ; 

# 1524 "./../src/fun.c"
  rator = (Scheme_Object * ) p -> ku . k . p1 ; 
  rands = (Scheme_Object * * ) p -> ku . k . p2 ; 
  num_rands = p -> ku . k . i1 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 

  if (p -> ku . k . i2 )
    RET_VALUE_START ((void * ) FUNCCALL(SETUP_XfOrM101(_), scheme_do_eval (rator , num_rands , rands , - 1 ) )) RET_VALUE_END ; 
  else 
  RET_VALUE_START ((void * ) FUNCCALL_EMPTY(scheme_do_eval (rator , num_rands , rands , 1 ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1537 "./../src/fun.c"
static Scheme_Object * 
_apply (Scheme_Object * rator , int num_rands , Scheme_Object * * rands , int multi , int eb ) 
{
  /* No conversion */

# 1540 "./../src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = rator ; 
  p -> ku . k . p2 = rands ; 
  p -> ku . k . i1 = num_rands ; 
  p -> ku . k . i2 = multi ; 

  return (Scheme_Object * ) scheme_top_level_do (apply_k , eb ) ; 
}

Scheme_Object * 
scheme_apply (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1553 "./../src/fun.c"
  return _apply (rator , num_rands , rands , 0 , 1 ) ; 
}

Scheme_Object * 
scheme_apply_multi (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1559 "./../src/fun.c"
  return _apply (rator , num_rands , rands , 1 , 1 ) ; 
}

Scheme_Object * 
scheme_apply_thread_thunk (Scheme_Object * rator ) 
{
  /* No conversion */

# 1565 "./../src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = rator ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . i1 = 0 ; 
  p -> ku . k . i2 = 1 ; 

  return (Scheme_Object * ) scheme_top_level_do_worker (apply_k , 1 , 1 ) ; 
}

Scheme_Object * 
scheme_apply_no_eb (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1578 "./../src/fun.c"
  return _apply (rator , num_rands , rands , 0 , 0 ) ; 
}

Scheme_Object * 
scheme_apply_multi_no_eb (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1584 "./../src/fun.c"
  return _apply (rator , num_rands , rands , 1 , 0 ) ; 
}

static Scheme_Object * 
finish_apply_with_prompt (void * _data , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 1590 "./../src/fun.c"
  void * * data = (void * * ) _data ; 
  Scheme_Object * rator , * is_multi ; 

  argv = (Scheme_Object * * ) _data ; 
  for (argc = 0 ; data [argc ] ; argc ++ ) {
  }
  rator = (Scheme_Object * ) data [argc + 1 ] ; 
  is_multi = (Scheme_Object * ) data [argc + 2 ] ; 

  if (! (((is_multi ) ) == (scheme_false ) ) ) 
    return scheme_do_eval (rator , argc , argv , - 1 ) ; 
  else 
  return scheme_do_eval (rator , argc , argv , 1 ) ; 
}

static Scheme_Object * 
do_apply_with_prompt (Scheme_Object * rator , int num_rands , Scheme_Object * * rands , int multi , int top_level ) 
{
  void * * a ; 
  int i ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(rator, 1), PUSH(rands, 2)));
# define XfOrM111_COUNT (3)
# define SETUP_XfOrM111(x) SETUP(XfOrM111_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 1611 "./../src/fun.c"
  a = ((void * * ) FUNCCALL(SETUP_XfOrM111(_), GC_malloc (sizeof (void * ) * (3 + num_rands ) ) )) ; 

  for (i = 0 ; i < num_rands ; i ++ ) {
    a [i ] = rands [i ] ; 
  }
  a [num_rands ] = ((void * ) 0 ) ; 
  a [num_rands + 1 ] = rator ; 
  a [num_rands + 2 ] = (multi ? scheme_true : scheme_false ) ; 

  if (top_level ) {
#   define XfOrM113_COUNT (0+XfOrM111_COUNT)
#   define SETUP_XfOrM113(x) SETUP_XfOrM111(x)

# 1621 "./../src/fun.c"
    if (multi )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_call_with_prompt_multi (finish_apply_with_prompt , a ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_call_with_prompt (finish_apply_with_prompt , a ) )) RET_VALUE_EMPTY_END ; 
  }

# 1625 "./../src/fun.c"
  else {
#   define XfOrM112_COUNT (0+XfOrM111_COUNT)
#   define SETUP_XfOrM112(x) SETUP_XfOrM111(x)

# 1626 "./../src/fun.c"
    if (multi )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(_scheme_call_with_prompt_multi (finish_apply_with_prompt , a ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(_scheme_call_with_prompt (finish_apply_with_prompt , a ) )) RET_VALUE_EMPTY_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1633 "./../src/fun.c"
Scheme_Object * 
scheme_apply_with_prompt (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1636 "./../src/fun.c"
  return do_apply_with_prompt (rator , num_rands , rands , 0 , 1 ) ; 
}

Scheme_Object * 
scheme_apply_multi_with_prompt (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1642 "./../src/fun.c"
  return do_apply_with_prompt (rator , num_rands , rands , 1 , 1 ) ; 
}

Scheme_Object * 
_scheme_apply_with_prompt (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1648 "./../src/fun.c"
  return do_apply_with_prompt (rator , num_rands , rands , 0 , 0 ) ; 
}

Scheme_Object * _scheme_apply_multi_with_prompt (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 1653 "./../src/fun.c"
  return do_apply_with_prompt (rator , num_rands , rands , 1 , 0 ) ; 
}





Scheme_Object * 
scheme_tail_apply (Scheme_Object * rator , int num_rands , Scheme_Object * * rands ) 
{




  int i ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(rands, 1)));
# define XfOrM120_COUNT (2)
# define SETUP_XfOrM120(x) SETUP(XfOrM120_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1670 "./../src/fun.c"
  p -> ku . apply . tail_rator = rator ; 
  p -> ku . apply . tail_num_rands = num_rands ; 

  if (num_rands ) {
    Scheme_Object * * a ; 
    BLOCK_SETUP((PUSH(a, 0+XfOrM120_COUNT)));
#   define XfOrM121_COUNT (1+XfOrM120_COUNT)
#   define SETUP_XfOrM121(x) SETUP(XfOrM121_COUNT)
    a = NULLED_OUT ; 

# 1675 "./../src/fun.c"
    if (num_rands > p -> tail_buffer_size ) {
#     define XfOrM124_COUNT (0+XfOrM121_COUNT)
#     define SETUP_XfOrM124(x) SETUP_XfOrM121(x)

# 1676 "./../src/fun.c"
      a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM124(_), GC_malloc (sizeof (Scheme_Object * ) * (num_rands ) ) )) ; 
      p -> tail_buffer = a ; 
      p -> tail_buffer_size = num_rands ; 
    }

# 1679 "./../src/fun.c"
    else 
    a = p -> tail_buffer ; 
    p -> ku . apply . tail_rands = a ; 
    for (i = num_rands ; i -- ; ) {
      a [i ] = rands [i ] ; 
    }
  }

# 1685 "./../src/fun.c"
  else 
  p -> ku . apply . tail_rands = ((void * ) 0 ) ; 

  RET_VALUE_START (((Scheme_Object * ) 0x4 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1691 "./../src/fun.c"
Scheme_Object * 
scheme_tail_apply_no_copy (Scheme_Object * rator , int num_rands , 
Scheme_Object * * rands ) 
{
  /* No conversion */

# 1695 "./../src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . apply . tail_rator = rator ; 
  p -> ku . apply . tail_num_rands = num_rands ; 
  p -> ku . apply . tail_rands = rands ; 

  return ((Scheme_Object * ) 0x4 ) ; 
}

static 
Scheme_Object * 
X_scheme_apply_to_list (Scheme_Object * rator , Scheme_Object * rands , int force , 
int top_level ) 
{
  int num_rands , i ; 
  Scheme_Object * * rands_vec ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(rator, 0), PUSH(rands_vec, 1), PUSH(rands, 2)));
# define XfOrM126_COUNT (3)
# define SETUP_XfOrM126(x) SETUP(XfOrM126_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  rands_vec = NULLED_OUT ; 

# 1712 "./../src/fun.c"
  num_rands = (scheme_list_length (rands ) ) ; 
  rands_vec = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM126(_), GC_malloc (sizeof (Scheme_Object * ) * (num_rands ) ) )) ; 

  for (i = 0 ; i < num_rands ; i ++ ) {
#   define XfOrM131_COUNT (0+XfOrM126_COUNT)
#   define SETUP_XfOrM131(x) SETUP_XfOrM126(x)

# 1716 "./../src/fun.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (rands ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rands ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM132_COUNT (0+XfOrM131_COUNT)
#     define SETUP_XfOrM132(x) SETUP_XfOrM131(x)
      FUNCCALL_EMPTY(scheme_signal_error ("bad application form" ) )
# 1717 "./../src/fun.c"
      ; 
    }
    rands_vec [i ] = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . car ) ; 
    rands = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . cdr ) ; 
  }

  if (top_level ) {
#   define XfOrM128_COUNT (0+XfOrM126_COUNT)
#   define SETUP_XfOrM128(x) SETUP_XfOrM126(x)

# 1724 "./../src/fun.c"
    if (force )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_apply (rator , num_rands , rands_vec ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (rator , num_rands , rands_vec ) )) RET_VALUE_EMPTY_END ; 
  }

# 1728 "./../src/fun.c"
  else {
#   define XfOrM127_COUNT (0+XfOrM126_COUNT)
#   define SETUP_XfOrM127(x) SETUP_XfOrM126(x)

# 1729 "./../src/fun.c"
    if (force )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_do_eval (rator , num_rands , rands_vec , 1 ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (rator , num_rands , rands_vec ) )) RET_VALUE_EMPTY_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1736 "./../src/fun.c"
Scheme_Object * 
scheme_apply_to_list (Scheme_Object * rator , Scheme_Object * rands ) 
{
  /* No conversion */

# 1739 "./../src/fun.c"
  return X_scheme_apply_to_list (rator , rands , 1 , 1 ) ; 
}

Scheme_Object * 
scheme_tail_apply_to_list (Scheme_Object * rator , Scheme_Object * rands ) 
{
  /* No conversion */

# 1745 "./../src/fun.c"
  return X_scheme_apply_to_list (rator , rands , 0 , 1 ) ; 
}

Scheme_Object * 
_scheme_apply_to_list (Scheme_Object * rator , Scheme_Object * rands ) 
{
  /* No conversion */

# 1751 "./../src/fun.c"
  return X_scheme_apply_to_list (rator , rands , 1 , 0 ) ; 
}

Scheme_Object * 
_scheme_tail_apply_to_list (Scheme_Object * rator , Scheme_Object * rands ) 
{
  /* No conversion */

# 1757 "./../src/fun.c"
  return X_scheme_apply_to_list (rator , rands , 0 , 0 ) ; 
}





static Scheme_Object * make_arity (intptr_t mina , intptr_t maxa , int mode ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
# define XfOrM137_COUNT (0)
# define SETUP_XfOrM137(x) SETUP(XfOrM137_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1766 "./../src/fun.c"
  if (mina == maxa )
    RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (mina ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
  else if (maxa == - 1 ) {
#   define XfOrM141_COUNT (0+XfOrM137_COUNT)
#   define SETUP_XfOrM141(x) SETUP_XfOrM137(x)

# 1769 "./../src/fun.c"
    if (mode == - 3 ) {
      RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- (mina + 1 ) ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
    }

# 1771 "./../src/fun.c"
    else {
      Scheme_Object * p [1 ] ; 
      BLOCK_SETUP((PUSHARRAY(p, 1, 0+XfOrM141_COUNT)));
#     define XfOrM142_COUNT (3+XfOrM141_COUNT)
#     define SETUP_XfOrM142(x) SETUP(XfOrM142_COUNT)
      p[0] = NULLED_OUT ; 

# 1773 "./../src/fun.c"
      p [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (mina ) ) ) << 1 ) | 0x1 ) ) ; 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM142(_), scheme_make_struct_instance (scheme_arity_at_least , 1 , p ) )) RET_VALUE_END ; 
    }
  }

# 1776 "./../src/fun.c"
  else {
    intptr_t i ; 
    Scheme_Object * l = scheme_null ; 
    BLOCK_SETUP((PUSH(l, 0+XfOrM137_COUNT)));
#   define XfOrM138_COUNT (1+XfOrM137_COUNT)
#   define SETUP_XfOrM138(x) SETUP(XfOrM138_COUNT)

# 1780 "./../src/fun.c"
    for (i = maxa ; i >= mina ; -- i ) {
#     define XfOrM140_COUNT (0+XfOrM138_COUNT)
#     define SETUP_XfOrM140(x) SETUP_XfOrM138(x)

# 1781 "./../src/fun.c"
      l = FUNCCALL(SETUP_XfOrM140(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , l ) ); 
    }

    RET_VALUE_START (l ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1788 "./../src/fun.c"
Scheme_Object * scheme_make_arity (mzshort mina , mzshort maxa ) 
{
  /* No conversion */

# 1790 "./../src/fun.c"
  return make_arity (mina , maxa , - 1 ) ; 
}

Scheme_Object * shift_for_drop (Scheme_Object * n , int drop ) 
{
  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0)));
# define XfOrM145_COUNT (3)
# define SETUP_XfOrM145(x) SETUP(XfOrM145_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 1796 "./../src/fun.c"
  a [0 ] = n ; 
  a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- drop ) ) ) << 1 ) | 0x1 ) ) ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM145(_), scheme_bitwise_shift (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1801 "./../src/fun.c"
static Scheme_Object * make_shifted_one (intptr_t n ) 
{
  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0)));
# define XfOrM146_COUNT (3)
# define SETUP_XfOrM146(x) SETUP(XfOrM146_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 1804 "./../src/fun.c"
  a [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
  a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (n ) ) ) << 1 ) | 0x1 ) ) ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM146(_), scheme_bitwise_shift (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1809 "./../src/fun.c"
static Scheme_Object * make_arity_mask (intptr_t mina , intptr_t maxa ) 
{

# 1801 "./../src/fun.c"
  Scheme_Object * __funcarg120 = NULLED_OUT ; 
  Scheme_Object * __funcarg119 = NULLED_OUT ; 

# 1801 "./../src/fun.c"
  Scheme_Object * __funcarg118 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(1);
# define XfOrM147_COUNT (0)
# define SETUP_XfOrM147(x) SETUP(XfOrM147_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)



  if (mina == maxa ) {
#   define XfOrM154_COUNT (0+XfOrM147_COUNT)
#   define SETUP_XfOrM154(x) SETUP_XfOrM147(x)

# 1813 "./../src/fun.c"
    if (mina < 29 )
      RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 << mina ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_shifted_one (mina ) )) RET_VALUE_EMPTY_END ; 
  }

# 1817 "./../src/fun.c"
  else if (maxa == - 1 ) {
#   define XfOrM151_COUNT (0+XfOrM147_COUNT)
#   define SETUP_XfOrM151(x) SETUP_XfOrM147(x)

# 1818 "./../src/fun.c"
    if (mina < 29 ) {
      RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (((1 << mina ) - 1 ) ^ (intptr_t ) - 1 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
    }

# 1820 "./../src/fun.c"
    else {
#     define XfOrM152_COUNT (0+XfOrM151_COUNT)
#     define SETUP_XfOrM152(x) SETUP_XfOrM151(x)

# 1821 "./../src/fun.c"
      RET_VALUE_START ((__funcarg119 = (__funcarg120 = FUNCCALL(SETUP_XfOrM152(_), make_shifted_one (mina ) ), FUNCCALL_AGAIN(scheme_bin_minus (__funcarg120 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) )) , FUNCCALL_EMPTY(scheme_bin_bitwise_xor (__funcarg119 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ) )) ) RET_VALUE_END 
      ; 
    }
  }

# 1824 "./../src/fun.c"
  else {
    mzshort i ; 
    Scheme_Object * mask = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    BLOCK_SETUP((PUSH(mask, 0+XfOrM147_COUNT)));
#   define XfOrM148_COUNT (1+XfOrM147_COUNT)
#   define SETUP_XfOrM148(x) SETUP(XfOrM148_COUNT)

# 1828 "./../src/fun.c"
    for (i = mina ; i <= maxa ; i ++ ) {
#     define XfOrM150_COUNT (0+XfOrM148_COUNT)
#     define SETUP_XfOrM150(x) SETUP_XfOrM148(x)

# 1829 "./../src/fun.c"
      mask = (__funcarg118 = FUNCCALL(SETUP_XfOrM150(_), make_shifted_one (i ) ), FUNCCALL_AGAIN(scheme_bin_bitwise_or (__funcarg118 , mask ) )) ; 
    }

    RET_VALUE_START (mask ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1836 "./../src/fun.c"
Scheme_Object * scheme_make_arity_mask (intptr_t mina , intptr_t maxa ) 
{
  /* No conversion */

# 1838 "./../src/fun.c"
  return make_arity_mask (mina , maxa ) ; 
}

int scheme_fast_check_arity (Scheme_Object * p , int a ) 


{
  /* No conversion */

# 1845 "./../src/fun.c"
  Scheme_Type type ; 
  int mina , maxa ; 

  type = ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ; 
  if (type == scheme_prim_type ) {
    mina = ((Scheme_Primitive_Proc * ) p ) -> mina ; 
    maxa = ((Scheme_Primitive_Proc * ) p ) -> mu . maxa ; 
    if (mina < 0 )
      return 0 ; 
    else {
      if (maxa > 0x3FFFFFFE )
        maxa = - 1 ; 
    }
  }

# 1858 "./../src/fun.c"
  else if (type == scheme_closed_prim_type ) {
    mina = ((Scheme_Closed_Primitive_Proc * ) p ) -> mina ; 
    maxa = ((Scheme_Closed_Primitive_Proc * ) p ) -> maxa ; 
    if (mina == - 2 )
      return 0 ; 
  }

# 1863 "./../src/fun.c"
  else 
  return 0 ; 

  if (a >= mina && (maxa < 0 || a <= maxa ) )
    return 1 ; 

  return 0 ; 
}

static Scheme_Object * get_or_check_arity (Scheme_Object * p , intptr_t a , Scheme_Object * bign , int inc_ok ) 




{
  Scheme_Type type ; 
  mzshort mina , maxa ; 
  int drop = 0 , cases_count = 0 ; 
  mzshort * cases = ((void * ) 0 ) ; 

# 1872 "./../src/fun.c"
  Scheme_Object * __funcarg124 = NULLED_OUT ; 

# 1809 "./../src/fun.c"
  Scheme_Object * __funcarg122 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(cases, 1), PUSH(bign, 2)));
# define XfOrM160_COUNT (3)
# define SETUP_XfOrM160(x) SETUP(XfOrM160_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1883 "./../src/fun.c"
  top : 

  type = ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ; 
  if (type == scheme_prim_type ) {
    mina = ((Scheme_Primitive_Proc * ) p ) -> mina ; 
    maxa = ((Scheme_Primitive_Proc * ) p ) -> mu . maxa ; 
    if (mina < 0 ) {
      cases = ((Scheme_Primitive_Proc * ) p ) -> mu . cases ; 
      cases_count = - (mina + 1 ) ; 
    }

# 1892 "./../src/fun.c"
    else {
      if (maxa > 0x3FFFFFFE )
        maxa = - 1 ; 
    }
  }

# 1896 "./../src/fun.c"
  else if (type == scheme_closed_prim_type ) {
    mina = ((Scheme_Closed_Primitive_Proc * ) p ) -> mina ; 
    maxa = ((Scheme_Closed_Primitive_Proc * ) p ) -> maxa ; 
    if (mina == - 2 ) {
      cases_count = - maxa ; 
      cases = ((Scheme_Closed_Case_Primitive_Proc * ) p ) -> cases ; 
    }
  }

# 1903 "./../src/fun.c"
  else if (type == scheme_cont_type || type == scheme_escaping_cont_type ) {
    mina = 0 ; 
    maxa = - 1 ; 
  }

# 1906 "./../src/fun.c"
  else if ((type == scheme_case_closure_type ) 
  || (type == scheme_case_lambda_sequence_type ) ) {
    Scheme_Case_Lambda * seq ; 
    Scheme_Lambda * data ; 
    int i ; 
    Scheme_Object * mask = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) , * v ; 
    BLOCK_SETUP((PUSH(data, 0+XfOrM160_COUNT), PUSH(v, 1+XfOrM160_COUNT), PUSH(mask, 2+XfOrM160_COUNT), PUSH(seq, 3+XfOrM160_COUNT)));
#   define XfOrM190_COUNT (4+XfOrM160_COUNT)
#   define SETUP_XfOrM190(x) SETUP(XfOrM190_COUNT)
    seq = NULLED_OUT ; 
    data = NULLED_OUT ; 
    v = NULLED_OUT ; 

# 1913 "./../src/fun.c"
    seq = (Scheme_Case_Lambda * ) p ; 
    for (i = 0 ; i < seq -> count ; i ++ ) {
#     define XfOrM198_COUNT (0+XfOrM190_COUNT)
#     define SETUP_XfOrM198(x) SETUP_XfOrM190(x)

# 1915 "./../src/fun.c"
      v = seq -> array [i ] ; 
      if ((a == - 1 ) || (a == - 3 ) || (a == - 4 ) ) {
#       define XfOrM203_COUNT (0+XfOrM198_COUNT)
#       define SETUP_XfOrM203(x) SETUP_XfOrM198(x)

# 1917 "./../src/fun.c"
        mask = (__funcarg124 = FUNCCALL(SETUP_XfOrM203(_), get_or_check_arity (v , - 4 , ((void * ) 0 ) , inc_ok ) ), FUNCCALL_AGAIN(scheme_bin_bitwise_or (__funcarg124 , mask ) )) ; 
      }

# 1918 "./../src/fun.c"
      else {
        if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) 
          data = (Scheme_Lambda * ) v ; 
        else 
        data = ((Scheme_Closure * ) v ) -> code ; 
        mina = maxa = data -> num_params ; 
        if ((& (data ) -> iso ) -> so . keyex & 1 ) {
          if (mina )
            -- mina ; 
          maxa = - 1 ; 
        }

        if (a >= 0 ) {
          if ((a + drop ) >= mina && (maxa < 0 || (a + drop ) <= maxa ) )
            RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
        }

# 1933 "./../src/fun.c"
        else if (a == - 2 ) {
          if (maxa < 0 )
            RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
        }
      }
    }

    if ((a == - 1 ) || (a == - 3 ) || (a == - 4 ) ) {
#     define XfOrM191_COUNT (0+XfOrM190_COUNT)
#     define SETUP_XfOrM191(x) SETUP_XfOrM190(x)

# 1941 "./../src/fun.c"
      if (drop )
        mask = FUNCCALL(SETUP_XfOrM191(_), shift_for_drop (mask , drop ) ); 
      if (a != - 4 )
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(mask_to_arity (mask , a ) )) RET_VALUE_EMPTY_END ; 
      else 
      RET_VALUE_START (mask ) RET_VALUE_END ; 
    }

# 1947 "./../src/fun.c"
    else 
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  }

# 1949 "./../src/fun.c"
  else if (type == scheme_proc_struct_type ) {
    int is_method ; 
#   define XfOrM179_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM179(x) SETUP_XfOrM160(x)

# 1951 "./../src/fun.c"
    if (! inc_ok 
    && scheme_no_arity_property 
    && (scheme_struct_type_property_ref (scheme_no_arity_property , p ) ) ) {
      if (a == - 4 )
        RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
      else 
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }
    if (scheme_reduced_procedure_struct 
    && (scheme_is_struct_instance (scheme_reduced_procedure_struct , p ) ) ) {
#     define XfOrM184_COUNT (0+XfOrM179_COUNT)
#     define SETUP_XfOrM184(x) SETUP_XfOrM179(x)

# 1961 "./../src/fun.c"
      if (a == - 4 ) {
#       define XfOrM188_COUNT (0+XfOrM184_COUNT)
#       define SETUP_XfOrM188(x) SETUP_XfOrM184(x)

# 1962 "./../src/fun.c"
        p = ((Scheme_Structure * ) p ) -> slots [1 ] ; 
        if (drop )
          RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(shift_for_drop (p , drop ) )) RET_VALUE_EMPTY_END ; 
        else 
        RET_VALUE_START (p ) RET_VALUE_END ; 
      }

      if (a >= 0 ) {
#       define XfOrM187_COUNT (0+XfOrM184_COUNT)
#       define SETUP_XfOrM187(x) SETUP_XfOrM184(x)

# 1970 "./../src/fun.c"
        bign = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (a ) ) ) << 1 ) | 0x1 ) ) ; 
        if (drop )
          bign = FUNCCALL(SETUP_XfOrM187(_), scheme_bin_plus (bign , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (drop ) ) ) << 1 ) | 0x1 ) ) ) ); 
      }
      if ((a == - 1 ) || (a == - 3 ) ) {
#       define XfOrM186_COUNT (0+XfOrM184_COUNT)
#       define SETUP_XfOrM186(x) SETUP_XfOrM184(x)

# 1975 "./../src/fun.c"
        p = ((Scheme_Structure * ) p ) -> slots [1 ] ; 
        if (drop )
          p = FUNCCALL(SETUP_XfOrM186(_), shift_for_drop (p , drop ) ); 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(mask_to_arity (p , a ) )) RET_VALUE_EMPTY_END ; 
      }

# 1979 "./../src/fun.c"
      else {
#       define XfOrM185_COUNT (0+XfOrM184_COUNT)
#       define SETUP_XfOrM185(x) SETUP_XfOrM184(x)

# 1980 "./../src/fun.c"
        if (FUNCCALL(SETUP_XfOrM185(_), scheme_bin_bitwise_bit_set_p (((Scheme_Structure * ) p ) -> slots [1 ] , bign ) ))
          RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
        else 
        RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
      }
    }

# 1985 "./../src/fun.c"
    else {
#     define XfOrM182_COUNT (0+XfOrM179_COUNT)
#     define SETUP_XfOrM182(x) SETUP_XfOrM179(x)

# 1986 "./../src/fun.c"
      p = FUNCCALL(SETUP_XfOrM182(_), scheme_extract_struct_procedure (p , - 1 , ((void * ) 0 ) , & is_method ) ); 
      if (! (! (((intptr_t ) (p ) ) & 0x1 ) && ((((p ) -> type ) >= scheme_prim_type ) && (((p ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
        if (a == - 4 )
          RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
        else if ((a == - 1 ) || (a == - 3 ) )
          RET_VALUE_START (scheme_null ) RET_VALUE_END ; 
        else 
        RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
      }
      if (is_method )
        drop ++ ; 
    }
    {
#     define XfOrM180_COUNT (0+XfOrM179_COUNT)
#     define SETUP_XfOrM180(x) SETUP_XfOrM179(x)

# 1998 "./../src/fun.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM181_COUNT (0+XfOrM180_COUNT)
#       define SETUP_XfOrM181(x) SETUP_XfOrM180(x)
        FUNCCALL(SETUP_XfOrM181(_), scheme_out_of_fuel () )
# 1998 "./../src/fun.c"
        ; 
      }
    }

# 1998 "./../src/fun.c"
    ; 
    goto top ; 
  }

# 2103 "./../src/fun.c"
  else if (type == scheme_proc_chaperone_type ) {
#   define XfOrM176_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM176(x) SETUP_XfOrM160(x)

# 2104 "./../src/fun.c"
    p = (((Scheme_Chaperone * ) p ) -> val ) ; 
    {
#     define XfOrM177_COUNT (0+XfOrM176_COUNT)
#     define SETUP_XfOrM177(x) SETUP_XfOrM176(x)

# 2105 "./../src/fun.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM178_COUNT (0+XfOrM177_COUNT)
#       define SETUP_XfOrM178(x) SETUP_XfOrM177(x)
        FUNCCALL(SETUP_XfOrM178(_), scheme_out_of_fuel () )
# 2105 "./../src/fun.c"
        ; 
      }
    }

# 2105 "./../src/fun.c"
    ; 
    goto top ; 
  }

# 2107 "./../src/fun.c"
  else {
    Scheme_Lambda * data ; 
    data = NULLED_OUT ; 
    if (type == scheme_lambda_type )
      data = (Scheme_Lambda * ) p ; 
    else if (type == scheme_closure_type )
      data = ((Scheme_Closure * ) p ) -> code ; 
    else 
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

    mina = maxa = data -> num_params ; 
    if ((& (data ) -> iso ) -> so . keyex & 1 ) {
      if (mina )
        -- mina ; 
      maxa = - 1 ; 
    }
  }

  if (cases ) {
    int count = cases_count , i ; 
#   define XfOrM165_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM165(x) SETUP_XfOrM160(x)

# 2127 "./../src/fun.c"
    if ((a == - 1 ) || (a == - 3 ) || (a == - 4 ) ) {

      Scheme_Object * mask = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
      BLOCK_SETUP((PUSH(mask, 0+XfOrM165_COUNT)));
#     define XfOrM171_COUNT (1+XfOrM165_COUNT)
#     define SETUP_XfOrM171(x) SETUP(XfOrM171_COUNT)

# 2131 "./../src/fun.c"
      for (i = 0 ; i < count ; i ++ ) {
#       define XfOrM173_COUNT (0+XfOrM171_COUNT)
#       define SETUP_XfOrM173(x) SETUP_XfOrM171(x)

# 2132 "./../src/fun.c"
        mask = (__funcarg122 = FUNCCALL(SETUP_XfOrM173(_), make_arity_mask (cases [2 * i ] , cases [(2 * i ) + 1 ] ) ), FUNCCALL_AGAIN(scheme_bin_bitwise_or (__funcarg122 , mask ) )) ; 
      }
      if (drop )
        mask = FUNCCALL(SETUP_XfOrM171(_), shift_for_drop (mask , drop ) ); 


      if (a == - 4 )
        RET_VALUE_START (mask ) RET_VALUE_END ; 
      else 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(mask_to_arity (mask , a ) )) RET_VALUE_EMPTY_END ; 
    }

    if (a == - 2 ) {
      for (i = 0 ; i < count ; i ++ ) {
        if (cases [(2 * i ) + 1 ] < 0 )
          RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
      }

      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }

    a += drop ; 

    for (i = 0 ; i < count ; i ++ ) {
      int na , xa ; 
      na = cases [2 * i ] ; 
      xa = cases [(2 * i ) + 1 ] ; 
      if ((a >= na ) && ((xa < 0 ) || (a <= xa ) ) )
        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
    }

    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  }

  if ((a == - 1 ) || (a == - 3 ) || (a == - 4 ) ) {
#   define XfOrM161_COUNT (0+XfOrM160_COUNT)
#   define SETUP_XfOrM161(x) SETUP_XfOrM160(x)

# 2167 "./../src/fun.c"
    if (mina < drop ) {
      if ((maxa >= 0 ) && (maxa < drop ) ) {
        if (a == - 4 )
          RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
        else 
        RET_VALUE_START (scheme_null ) RET_VALUE_END ; 
      }

# 2173 "./../src/fun.c"
      else 
      mina = 0 ; 
    }

# 2175 "./../src/fun.c"
    else 
    mina -= drop ; 
    if (maxa > 0 ) {

      maxa -= drop ; 
    }

    if (a == - 4 )
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_arity_mask (mina , maxa ) )) RET_VALUE_EMPTY_END ; 

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_arity (mina , maxa , a ) )) RET_VALUE_EMPTY_END ; 
  }

  if (a == - 2 )
    RET_VALUE_START ((maxa < 0 ) ? scheme_true : scheme_false ) RET_VALUE_END ; 

  a += drop ; 

  if (a < mina || (maxa >= 0 && a > maxa ) )
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2199 "./../src/fun.c"
Scheme_Object * scheme_get_or_check_arity (Scheme_Object * p , intptr_t a ) 
{
  /* No conversion */

# 2201 "./../src/fun.c"
  return get_or_check_arity (p , a , ((void * ) 0 ) , 1 ) ; 
}

Scheme_Object * scheme_get_arity_mask (Scheme_Object * p ) 
{
  /* No conversion */

# 2206 "./../src/fun.c"
  return get_or_check_arity (p , - 4 , ((void * ) 0 ) , 1 ) ; 
}

int scheme_check_proc_arity2 (const char * where , int a , 
int which , int argc , Scheme_Object * * argv , 
int false_ok ) 
{
  Scheme_Object * p ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(where, 0), PUSH(argv, 1)));
# define XfOrM212_COUNT (2)
# define SETUP_XfOrM212(x) SETUP(XfOrM212_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 2215 "./../src/fun.c"
  if (which < 0 )
    p = argv [0 ] ; 
  else 
  p = argv [which ] ; 

  if (false_ok && (((p ) ) == (scheme_false ) ) )
    RET_VALUE_START (1 ) RET_VALUE_END ; 

  if (! (! (((intptr_t ) (p ) ) & 0x1 ) && ((((p ) -> type ) >= scheme_prim_type ) && (((p ) -> type ) <= scheme_proc_chaperone_type ) ) ) || (((FUNCCALL(SETUP_XfOrM212(_), get_or_check_arity (p , a , ((void * ) 0 ) , 1 ) )) ) == (scheme_false ) ) ) {
#   define XfOrM213_COUNT (0+XfOrM212_COUNT)
#   define SETUP_XfOrM213(x) SETUP_XfOrM212(x)

# 2224 "./../src/fun.c"
    if (where ) {
      char buffer [60 ] ; 
      const char * pre , * post ; 
#     define XfOrM214_COUNT (0+XfOrM213_COUNT)
#     define SETUP_XfOrM214(x) SETUP_XfOrM213(x)
      pre = NULLED_OUT ; 
      post = NULLED_OUT ; 

# 2228 "./../src/fun.c"
      if (false_ok ) {
        pre = "(or/c " ; 
        post = " #f)" ; 
      }

# 2231 "./../src/fun.c"
      else 
      pre = post = "" ; 

      switch (a ) {
#       define XfOrM215_COUNT (0+XfOrM214_COUNT)
#       define SETUP_XfOrM215(x) SETUP_XfOrM214(x)

# 2235 "./../src/fun.c"
        case 0 : (
        sprintf (buffer , "%s(-> any)%s" , pre , post ) ) ; 
        break ; 
        case 1 : (
        sprintf (buffer , "%s(any/c . -> . any)%s" , pre , post ) ) ; 
        break ; 
        case 2 : (
        sprintf (buffer , "%s(any/c any/c . -> . any)%s" , pre , post ) ) ; 
        break ; 
        case 3 : (
        sprintf (buffer , "%s(any/c any/c any/c . -> . any)%s" , pre , post ) ) ; 
        break ; 
        default : (
        sprintf (buffer , "%s(procedure-arity-includes/c %d)%s" , 
        pre , a , post ) ) ; 
        break ; 
      }
      FUNCCALL_EMPTY(scheme_wrong_contract (where , buffer , which , argc , argv ) )
      ; 
    }

# 2254 "./../src/fun.c"
    else 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2261 "./../src/fun.c"
int scheme_check_proc_arity (const char * where , int a , 
int which , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2264 "./../src/fun.c"
  return scheme_check_proc_arity2 (where , a , which , argc , argv , 0 ) ; 
}

int scheme_closure_preserves_marks (Scheme_Object * p ) 
{
  /* No conversion */

# 2269 "./../src/fun.c"
  Scheme_Type type = ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ; 
  Scheme_Lambda * data ; 






  if (type == scheme_closure_type ) {
    data = ((Scheme_Closure * ) p ) -> code ; 
  }

# 2279 "./../src/fun.c"
  else if (type == scheme_lambda_type ) {
    data = (Scheme_Lambda * ) p ; 
  }

# 2281 "./../src/fun.c"
  else 
  return 0 ; 

  if ((& (data ) -> iso ) -> so . keyex & 4 )
    return 1 ; 

  return 0 ; 
}

Scheme_Object * scheme_get_or_check_procedure_shape (Scheme_Object * e , Scheme_Object * expected , int imprecise ) 

{
  Scheme_Object * p ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(expected, 1), PUSH(p, 2)));
# define XfOrM221_COUNT (3)
# define SETUP_XfOrM221(x) SETUP(XfOrM221_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 

# 2295 "./../src/fun.c"
  if (expected 
  && ((Scheme_Type ) (((((intptr_t ) (expected ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expected ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#   define XfOrM231_COUNT (0+XfOrM221_COUNT)
#   define SETUP_XfOrM231(x) SETUP_XfOrM221(x)

# 2297 "./../src/fun.c"
    if ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [0 ] == 's' ) {
#     define XfOrM233_COUNT (0+XfOrM231_COUNT)
#     define SETUP_XfOrM233(x) SETUP_XfOrM231(x)

# 2298 "./../src/fun.c"
      RET_VALUE_START ((FUNCCALL(SETUP_XfOrM233(_), scheme_get_or_check_structure_shape (e , expected ) )
      ? expected 
      : ((void * ) 0 ) ) ) 
# 2298 "./../src/fun.c"
      RET_VALUE_END 

      ; 
    }

# 2301 "./../src/fun.c"
    else if ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [0 ] == 'p' ) {
#     define XfOrM232_COUNT (0+XfOrM231_COUNT)
#     define SETUP_XfOrM232(x) SETUP_XfOrM231(x)

# 2302 "./../src/fun.c"
      RET_VALUE_START ((FUNCCALL(SETUP_XfOrM232(_), scheme_get_or_check_structure_property_shape (e , expected ) )
      ? expected 
      : ((void * ) 0 ) ) ) 
# 2302 "./../src/fun.c"
      RET_VALUE_END 

      ; 
    }
  }

  if ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_inline_variant_type ) ) 
    e = (((Scheme_Vector * ) (e ) ) -> els ) [1 ] ; 

  if (! (! (((intptr_t ) (e ) ) & 0x1 ) && ((((e ) -> type ) >= scheme_prim_type ) && (((e ) -> type ) <= scheme_proc_chaperone_type ) ) ) && (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) >= _scheme_ir_values_types_ ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  p = FUNCCALL(SETUP_XfOrM221(_), scheme_get_or_check_arity (e , - 3 ) ); 
  if (((p ) ) == (scheme_false ) ) 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  if ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {

    int sz = 32 , c = 0 ; 
    char * b , * naya ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM221_COUNT), PUSH(b, 1+XfOrM221_COUNT)));
#   define XfOrM226_COUNT (2+XfOrM221_COUNT)
#   define SETUP_XfOrM226(x) SETUP(XfOrM226_COUNT)
    b = NULLED_OUT ; 
    naya = NULLED_OUT ; 

# 2322 "./../src/fun.c"
    b = (char * ) FUNCCALL(SETUP_XfOrM226(_), GC_malloc_atomic (sz ) ); 

    while (((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM229_COUNT (0+XfOrM226_COUNT)
#     define SETUP_XfOrM229(x) SETUP_XfOrM226(x)

# 2325 "./../src/fun.c"
      if (sz - c < 10 ) {
        sz *= 2 ; 
#       define XfOrM230_COUNT (0+XfOrM229_COUNT)
#       define SETUP_XfOrM230(x) SETUP_XfOrM229(x)

# 2327 "./../src/fun.c"
        naya = (char * ) FUNCCALL(SETUP_XfOrM230(_), GC_malloc_atomic (sz ) ); 
        (memcpy (naya , b , c ) ) ; 
        b = naya ; 
      }
      if (c )
        b [c ++ ] = ':' ; 
      c += (sprintf (b XFORM_OK_PLUS c , "%" "l" "d" , (((intptr_t ) ((((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . car ) ) ) >> 1 ) ) ) ; 

      p = (((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . cdr ) ; 
    }
    b [c ] = c ; 
    p = FUNCCALL(SETUP_XfOrM226(_), scheme_intern_exact_symbol (b , c ) ); 
  }

# 2339 "./../src/fun.c"
  else {


    intptr_t i = (((intptr_t ) (p ) ) >> 1 ) ; 
#   define XfOrM222_COUNT (0+XfOrM221_COUNT)
#   define SETUP_XfOrM222(x) SETUP_XfOrM221(x)

# 2343 "./../src/fun.c"
    i = ((uintptr_t ) i ) << 1 ; 
    if (expected && (((intptr_t ) (expected ) ) & 0x1 ) && ! ((((intptr_t ) (expected ) ) >> 1 ) & 0x1 ) ) {
    }

    else {
#     define XfOrM223_COUNT (0+XfOrM222_COUNT)
#     define SETUP_XfOrM223(x) SETUP_XfOrM222(x)

# 2348 "./../src/fun.c"
      if (! imprecise && FUNCCALL(SETUP_XfOrM223(_), scheme_closure_preserves_marks (e ) )) {
        i |= 0x1 ; 
      }
    }
    p = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) ; 
  }

  if (expected && ! ((expected ) == (p ) ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * 
void_func (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2368 "./../src/fun.c"
  return scheme_void ; 
}

static Scheme_Object * 
void_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2374 "./../src/fun.c"
  return ((argv [0 ] ) == (scheme_void ) ) ? scheme_true : scheme_false ; 
}

Scheme_Object * 
scheme_check_not_undefined (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2380 "./../src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("check-not-unsafe-undefined" , "symbol?" , 1 , argc , argv ) ; 

  if ((argv [0 ] ) == (scheme_undefined ) )  {
    scheme_raise_exn (MZEXN_FAIL_CONTRACT_VARIABLE , 
    argv [1 ] , 
    "%S: undefined;\n cannot use before initialization" , 
    argv [1 ] ) ; 
  }

  return argv [0 ] ; 
}

Scheme_Object * 
scheme_check_assign_not_undefined (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2396 "./../src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    scheme_wrong_contract ("check-not-unsafe-undefined/assign" , "symbol?" , 1 , argc , argv ) ; 

  if ((argv [0 ] ) == (scheme_undefined ) )  {
    scheme_raise_exn (MZEXN_FAIL_CONTRACT_VARIABLE , 
    argv [1 ] , 
    "%S: assignment disallowed;\n cannot assign before initialization" , 
    argv [1 ] ) ; 
  }

  return argv [0 ] ; 
}

static Scheme_Object * chaperone_unsafe_undefined (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2411 "./../src/fun.c"
  if ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    return scheme_chaperone_not_undefined (argv [0 ] ) ; 
  else 
  return argv [0 ] ; 
}

static Scheme_Object * 
procedure_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2420 "./../src/fun.c"
  return ((! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * primitive_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2425 "./../src/fun.c"
  int isprim ; 

  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) 
    isprim = (((Scheme_Primitive_Proc * ) argv [0 ] ) -> pp . flags & 4 ) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) 
    isprim = (((Scheme_Closed_Primitive_Proc * ) argv [0 ] ) -> pp . flags & 4 ) ; 
  else 
  isprim = 0 ; 

  return isprim ? scheme_true : scheme_false ; 
}

static Scheme_Object * primitive_closure_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2439 "./../src/fun.c"
  int isprim ; 

  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) 
    isprim = (((Scheme_Closed_Primitive_Proc * ) argv [0 ] ) -> pp . flags & 4 ) ; 
  else 
  isprim = 0 ; 

  return isprim ? scheme_true : scheme_false ; 
}

Scheme_Object * scheme_proc_struct_name_source (Scheme_Object * a ) 
{
  Scheme_Object * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(b, 1)));
# define XfOrM244_COUNT (2)
# define SETUP_XfOrM244(x) SETUP(XfOrM244_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 2453 "./../src/fun.c"
  while ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) {
#   define XfOrM252_COUNT (0+XfOrM244_COUNT)
#   define SETUP_XfOrM252(x) SETUP_XfOrM244(x)

# 2454 "./../src/fun.c"
    if (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
      a = (((Scheme_Chaperone * ) a ) -> val ) ; 
    if (scheme_object_name_property 
    && (scheme_struct_type_property_ref (scheme_object_name_property , a ) ) ) {
      RET_VALUE_START (a ) RET_VALUE_END ; 
    }

# 2459 "./../src/fun.c"
    else if (scheme_reduced_procedure_struct 
    && (scheme_is_struct_instance (scheme_reduced_procedure_struct , a ) ) 
    && (! (((((Scheme_Structure * ) a ) -> slots [2 ] ) ) == (scheme_false ) ) ) ) {
      RET_VALUE_START (a ) RET_VALUE_END ; 
    }

# 2463 "./../src/fun.c"
    else {


      int is_method ; 
#     define XfOrM253_COUNT (0+XfOrM252_COUNT)
#     define SETUP_XfOrM253(x) SETUP_XfOrM252(x)

# 2467 "./../src/fun.c"
      b = FUNCCALL(SETUP_XfOrM253(_), scheme_extract_struct_procedure (a , - 1 , ((void * ) 0 ) , & is_method ) ); 
      if (! is_method && (! (((intptr_t ) (b ) ) & 0x1 ) && ((((b ) -> type ) >= scheme_prim_type ) && (((b ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
#       define XfOrM254_COUNT (0+XfOrM253_COUNT)
#       define SETUP_XfOrM254(x) SETUP_XfOrM253(x)

# 2469 "./../src/fun.c"
        a = b ; 
        {
#         define XfOrM255_COUNT (0+XfOrM254_COUNT)
#         define SETUP_XfOrM255(x) SETUP_XfOrM254(x)

# 2470 "./../src/fun.c"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM256_COUNT (0+XfOrM255_COUNT)
#           define SETUP_XfOrM256(x) SETUP_XfOrM255(x)
            FUNCCALL(SETUP_XfOrM256(_), scheme_out_of_fuel () )
# 2470 "./../src/fun.c"
            ; 
          }
        }

# 2470 "./../src/fun.c"
        ; 
      }

# 2471 "./../src/fun.c"
      else 
      break ; 
    }
  }

  RET_VALUE_START (a ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2479 "./../src/fun.c"
const char * scheme_get_proc_name (Scheme_Object * p , int * len , int for_error ) 


{
  Scheme_Type type ; 
  int dummy ; 
  char * s ; 
  char * __funcarg125 = NULLED_OUT ; 
  DECL_RET_SAVE (const char * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(len, 1), PUSH(s, 2)));
# define XfOrM259_COUNT (3)
# define SETUP_XfOrM259(x) SETUP(XfOrM259_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  s = NULLED_OUT ; 

# 2487 "./../src/fun.c"
  if (! len )
    len = & dummy ; 

  top : 

  type = ((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ; 
  if (type == scheme_prim_type ) {
    if (((Scheme_Primitive_Proc * ) p ) -> name )
      * len = strlen (((Scheme_Primitive_Proc * ) p ) -> name ) ; 
    RET_VALUE_START (((Scheme_Primitive_Proc * ) p ) -> name ) RET_VALUE_END ; 
  }

# 2497 "./../src/fun.c"
  else if (type == scheme_closed_prim_type ) {
    if (((Scheme_Closed_Primitive_Proc * ) p ) -> name )
      * len = strlen (((Scheme_Closed_Primitive_Proc * ) p ) -> name ) ; 
    RET_VALUE_START (((Scheme_Closed_Primitive_Proc * ) p ) -> name ) RET_VALUE_END ; 
  }

# 2501 "./../src/fun.c"
  else if (type == scheme_cont_type || type == scheme_escaping_cont_type ) {
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 2503 "./../src/fun.c"
  else if (type == scheme_case_closure_type ) {
    Scheme_Object * n ; 
#   define XfOrM281_COUNT (0+XfOrM259_COUNT)
#   define SETUP_XfOrM281(x) SETUP_XfOrM259(x)
    n = NULLED_OUT ; 

# 2506 "./../src/fun.c"
    n = ((Scheme_Case_Lambda * ) p ) -> name ; 
    if (n ) {
#     define XfOrM282_COUNT (0+XfOrM281_COUNT)
#     define SETUP_XfOrM282(x) SETUP_XfOrM281(x)

# 2508 "./../src/fun.c"
      if ((Scheme_Type ) (((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) )  {

        n = (((Scheme_Small_Object * ) (n ) ) -> u . ptr_val ) ; 
        if (((n ) ) == (scheme_false ) ) 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }

      if ((Scheme_Type ) (((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
        n = (((Scheme_Vector * ) (n ) ) -> els ) [0 ] ; 

      if (for_error < 0 ) {
        s = (char * ) n ; 
        * len = - 1 ; 
      }

# 2521 "./../src/fun.c"
      else {
#       define XfOrM283_COUNT (0+XfOrM282_COUNT)
#       define SETUP_XfOrM283(x) SETUP_XfOrM282(x)

# 2522 "./../src/fun.c"
        * len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (n ) ) ) -> len ) ; 
        s = FUNCCALL(SETUP_XfOrM283(_), scheme_symbol_val (n ) ); 
      }
    }

# 2525 "./../src/fun.c"
    else 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 2527 "./../src/fun.c"
  else if (type == scheme_proc_struct_type ) {

    Scheme_Object * other ; 
    BLOCK_SETUP((PUSH(other, 0+XfOrM259_COUNT)));
#   define XfOrM273_COUNT (1+XfOrM259_COUNT)
#   define SETUP_XfOrM273(x) SETUP(XfOrM273_COUNT)
    other = NULLED_OUT ; 

# 2530 "./../src/fun.c"
    other = FUNCCALL(SETUP_XfOrM273(_), scheme_proc_struct_name_source (p ) ); 
    if ((other ) == (p ) )  {
#     define XfOrM275_COUNT (0+XfOrM273_COUNT)
#     define SETUP_XfOrM275(x) SETUP_XfOrM273(x)

# 2532 "./../src/fun.c"
      if (scheme_reduced_procedure_struct 
      && (scheme_is_struct_instance (scheme_reduced_procedure_struct , p ) ) ) {

        Scheme_Object * sym = ((Scheme_Structure * ) p ) -> slots [2 ] ; 
#       define XfOrM278_COUNT (0+XfOrM275_COUNT)
#       define SETUP_XfOrM278(x) SETUP_XfOrM275(x)

# 2536 "./../src/fun.c"
        if (for_error < 0 ) {
          s = (char * ) sym ; 
          * len = - 1 ; 
        }

# 2539 "./../src/fun.c"
        else {
#         define XfOrM279_COUNT (0+XfOrM278_COUNT)
#         define SETUP_XfOrM279(x) SETUP_XfOrM278(x)

# 2540 "./../src/fun.c"
          * len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> len ) ; 
          s = FUNCCALL(SETUP_XfOrM279(_), scheme_symbol_val (sym ) ); 
        }
      }

# 2543 "./../src/fun.c"
      else {
        Scheme_Object * sym ; 
        intptr_t offset ; 
        BLOCK_SETUP((PUSH(sym, 0+XfOrM275_COUNT)));
#       define XfOrM276_COUNT (1+XfOrM275_COUNT)
#       define SETUP_XfOrM276(x) SETUP(XfOrM276_COUNT)
        sym = NULLED_OUT ; 

# 2546 "./../src/fun.c"
        sym = ((((Scheme_Structure * ) p ) -> stype ) -> name ) ; 
        * len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> len ) ; 
        s = (char * ) FUNCCALL(SETUP_XfOrM276(_), GC_malloc_atomic ((* len ) + 8 ) ); 
        if (0 ) {
#         define XfOrM277_COUNT (0+XfOrM276_COUNT)
#         define SETUP_XfOrM277(x) SETUP_XfOrM276(x)
          (
# 2550 "./../src/fun.c"
          memcpy (s , "struct " , 7 ) ) ; 
          offset = 7 ; 
        }

# 2552 "./../src/fun.c"
        else 
        offset = 0 ; 
        (__funcarg125 = FUNCCALL(SETUP_XfOrM276(_), scheme_symbol_val (sym ) ), (memcpy (s + offset , __funcarg125 , * len ) ) ) ; 
        (* len ) += offset ; 
        s [* len ] = 0 ; 
        RET_VALUE_START (s ) RET_VALUE_END ; 
      }
    }

# 2559 "./../src/fun.c"
    else {
      p = other ; 
      goto top ; 
    }
  }

# 2563 "./../src/fun.c"
  else if (type == scheme_proc_chaperone_type ) {
#   define XfOrM270_COUNT (0+XfOrM259_COUNT)
#   define SETUP_XfOrM270(x) SETUP_XfOrM259(x)

# 2564 "./../src/fun.c"
    p = (((Scheme_Chaperone * ) p ) -> val ) ; 
    {
#     define XfOrM271_COUNT (0+XfOrM270_COUNT)
#     define SETUP_XfOrM271(x) SETUP_XfOrM270(x)

# 2565 "./../src/fun.c"
      if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#       define XfOrM272_COUNT (0+XfOrM271_COUNT)
#       define SETUP_XfOrM272(x) SETUP_XfOrM271(x)
        FUNCCALL(SETUP_XfOrM272(_), scheme_out_of_fuel () )
# 2565 "./../src/fun.c"
        ; 
      }
    }

# 2565 "./../src/fun.c"
    ; 
    goto top ; 
  }

# 2567 "./../src/fun.c"
  else {
    Scheme_Object * name ; 
#   define XfOrM261_COUNT (0+XfOrM259_COUNT)
#   define SETUP_XfOrM261(x) SETUP_XfOrM259(x)
    name = NULLED_OUT ; 

# 2570 "./../src/fun.c"
    if ((type == scheme_ir_lambda_type ) 
    || (type == scheme_lambda_type ) ) {
      name = ((Scheme_Lambda * ) p ) -> name ; 
    }

# 2573 "./../src/fun.c"
    else if (type == scheme_closure_type ) {
      name = ((Scheme_Closure * ) p ) -> code -> name ; 
    }

# 2575 "./../src/fun.c"
    else if (type == scheme_case_lambda_sequence_type ) {
      Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) p ; 
      if (! cl -> count )
        name = ((void * ) 0 ) ; 
      else 
      name = ((Scheme_Lambda * ) cl -> array [0 ] ) -> name ; 
    }

# 2581 "./../src/fun.c"
    else {

      name = ((Scheme_Native_Closure * ) p ) -> code -> u2 . name ; 
      if (name && ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) ) {


        name = ((Scheme_Lambda * ) name ) -> name ; 
      }
    }

    if (name ) {
#     define XfOrM262_COUNT (0+XfOrM261_COUNT)
#     define SETUP_XfOrM262(x) SETUP_XfOrM261(x)

# 2592 "./../src/fun.c"
      if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
        name = (((Scheme_Vector * ) (name ) ) -> els ) [0 ] ; 
      if (for_error < 0 ) {
        s = (char * ) name ; 
        * len = - 1 ; 
      }

# 2597 "./../src/fun.c"
      else {
#       define XfOrM263_COUNT (0+XfOrM262_COUNT)
#       define SETUP_XfOrM263(x) SETUP_XfOrM262(x)

# 2598 "./../src/fun.c"
        * len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ; 
        s = FUNCCALL(SETUP_XfOrM263(_), scheme_symbol_val (name ) ); 
      }
    }

# 2601 "./../src/fun.c"
    else 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (0 ) {
    char * r ; 
    BLOCK_SETUP((PUSH(r, 0+XfOrM259_COUNT)));
#   define XfOrM260_COUNT (1+XfOrM259_COUNT)
#   define SETUP_XfOrM260(x) SETUP(XfOrM260_COUNT)
    r = NULLED_OUT ; 

# 2608 "./../src/fun.c"
    r = (char * ) FUNCCALL(SETUP_XfOrM260(_), GC_malloc_atomic ((* len ) + 11 ) ); 
    (memcpy (r , "procedure " , 10 ) ) ; 
    (memcpy (r + 10 , s , * len + 1 ) ) ; 
    * len += 10 ; 

    RET_VALUE_START (r ) RET_VALUE_END ; 
  }

  RET_VALUE_START (s ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2619 "./../src/fun.c"
static Scheme_Object * primitive_result_arity (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2621 "./../src/fun.c"
  Scheme_Object * o ; 

  o = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) 
  && (((Scheme_Primitive_Proc * ) o ) -> pp . flags & 4 ) ) {
    if (((Scheme_Primitive_Proc * ) o ) -> pp . flags & 8 ) {
      Scheme_Prim_W_Result_Arity * p = (Scheme_Prim_W_Result_Arity * ) o ; 
      return scheme_make_arity (p -> minr , p -> maxr ) ; 
    }
  }

# 2631 "./../src/fun.c"
  else if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) 
  && (((Scheme_Closed_Primitive_Proc * ) o ) -> pp . flags & 4 ) ) {
    if (((Scheme_Closed_Primitive_Proc * ) o ) -> pp . flags & 8 ) {
      Scheme_Closed_Prim_W_Result_Arity * p = (Scheme_Closed_Prim_W_Result_Arity * ) o ; 
      return scheme_make_arity (p -> minr , p -> maxr ) ; 
    }
  }

# 2637 "./../src/fun.c"
  else {
    scheme_wrong_contract ("primitive-result-arity" , "primitive?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * procedure_result_arity (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2646 "./../src/fun.c"
  Scheme_Object * o , * orig_o ; 

  orig_o = argv [0 ] ; 
  o = orig_o ; 

  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 



  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) 


  && ! scheme_is_struct_instance (scheme_reduced_procedure_struct , o ) ) {
    return scheme_false ; 
  }

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) )  {
    if ((& (((Scheme_Closure * ) o ) -> code ) -> iso ) -> so . keyex & 32 )  {
      return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
    }
  }




  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) )  {
    Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) o ; 
    int i ; 

    for (i = cl -> count ; i -- ; ) {
      if (! ((& (((Scheme_Closure * ) cl -> array [i ] ) -> code ) -> iso ) -> so . keyex & 32 ) )
        break ; 
    }

    if (i < 0 )
      return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
  }

# 2683 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) )  {
    if (((Scheme_Primitive_Proc * ) o ) -> pp . flags & 8 ) {
      Scheme_Prim_W_Result_Arity * p = (Scheme_Prim_W_Result_Arity * ) o ; 
      return scheme_make_arity (p -> minr , p -> maxr ) ; 
    }
    return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
  }

# 2689 "./../src/fun.c"
  else if ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
  && scheme_is_struct_instance (scheme_reduced_procedure_struct , o ) ) {
    return procedure_result_arity (1 , & ((Scheme_Structure * ) o ) -> slots [0 ] ) ; 
  }

# 2692 "./../src/fun.c"
  else if (! (! (((intptr_t ) (o ) ) & 0x1 ) && ((((o ) -> type ) >= scheme_prim_type ) && (((o ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
    scheme_wrong_contract ("procedure-result-arity" , "procedure?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
  return scheme_false ; 
}

Scheme_Object * scheme_object_name (Scheme_Object * a ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(v, 1)));
# define XfOrM306_COUNT (2)
# define SETUP_XfOrM306(x) SETUP(XfOrM306_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 

# 2703 "./../src/fun.c"
  v = (scheme_struct_type_property_ref (scheme_object_name_property , a ) ) ; 

  if (v ) {
#   define XfOrM321_COUNT (0+XfOrM306_COUNT)
#   define SETUP_XfOrM321(x) SETUP_XfOrM306(x)

# 2706 "./../src/fun.c"
    if (((intptr_t ) (v ) ) & 0x1 ) 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM321(_), scheme_struct_ref (a , (((intptr_t ) (v ) ) >> 1 ) ) )) RET_VALUE_END ; 
    if (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) )  {
#     define XfOrM322_COUNT (0+XfOrM321_COUNT)
#     define SETUP_XfOrM322(x) SETUP_XfOrM321(x)

# 2709 "./../src/fun.c"
      if (FUNCCALL(SETUP_XfOrM322(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , 1 , & v ) )) {
        Scheme_Object * f = v , * arg [1 ] ; 
        BLOCK_SETUP((PUSHARRAY(arg, 1, 0+XfOrM322_COUNT)));
#       define XfOrM323_COUNT (3+XfOrM322_COUNT)
#       define SETUP_XfOrM323(x) SETUP(XfOrM323_COUNT)
        arg[0] = NULLED_OUT ; 

# 2712 "./../src/fun.c"
        arg [0 ] = a ; 
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM323(_), scheme_apply (f , 1 , arg ) )) RET_VALUE_END ; 
      }
    }
  }

  if (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    a = (((Scheme_Chaperone * ) a ) -> val ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) )  {
#   define XfOrM319_COUNT (0+XfOrM306_COUNT)
#   define SETUP_XfOrM319(x) SETUP_XfOrM306(x)

# 2722 "./../src/fun.c"
    a = FUNCCALL(SETUP_XfOrM319(_), scheme_proc_struct_name_source (a ) ); 
    if (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
      a = (((Scheme_Chaperone * ) a ) -> val ) ; 

    if ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
    && scheme_reduced_procedure_struct 
    && (scheme_is_struct_instance (scheme_reduced_procedure_struct , a ) ) ) {

      RET_VALUE_START (((Scheme_Structure * ) a ) -> slots [2 ] ) RET_VALUE_END ; 
    }
  }

  if (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
    if (! ((((Scheme_Structure * ) a ) -> stype ) -> more_flags & 0x2 ) )
      RET_VALUE_START (((((Scheme_Structure * ) a ) -> stype ) -> name ) ) RET_VALUE_END ; 
  }

# 2737 "./../src/fun.c"
  else if (! (((intptr_t ) (a ) ) & 0x1 ) && ((((a ) -> type ) >= scheme_prim_type ) && (((a ) -> type ) <= scheme_proc_chaperone_type ) ) )  {
    const char * s ; 
    int len ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM306_COUNT)));
#   define XfOrM316_COUNT (1+XfOrM306_COUNT)
#   define SETUP_XfOrM316(x) SETUP(XfOrM316_COUNT)
    s = NULLED_OUT ; 

# 2741 "./../src/fun.c"
    s = FUNCCALL(SETUP_XfOrM316(_), scheme_get_proc_name (a , & len , - 1 ) ); 
    if (s ) {
#     define XfOrM317_COUNT (0+XfOrM316_COUNT)
#     define SETUP_XfOrM317(x) SETUP_XfOrM316(x)

# 2743 "./../src/fun.c"
      if (len < 0 )
        RET_VALUE_START ((Scheme_Object * ) s ) RET_VALUE_END ; 
      else 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM317(_), scheme_intern_exact_symbol (s , len ) )) RET_VALUE_END ; 
    }
  }

# 2748 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) )  {
    RET_VALUE_START (((Scheme_Struct_Type * ) a ) -> name ) RET_VALUE_END ; 
  }

# 2750 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) )  {
    RET_VALUE_START (((Scheme_Struct_Property * ) a ) -> name ) RET_VALUE_END ; 
  }

# 2752 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_regexp_type ) )  {
    Scheme_Object * s ; 
#   define XfOrM313_COUNT (0+XfOrM306_COUNT)
#   define SETUP_XfOrM313(x) SETUP_XfOrM306(x)
    s = NULLED_OUT ; 

# 2754 "./../src/fun.c"
    s = (scheme_regexp_source (a ) ) ; 
    if (s )
      RET_VALUE_START (s ) RET_VALUE_END ; 
  }

# 2757 "./../src/fun.c"
  else if (scheme_is_input_port (a ) )  {
    Scheme_Input_Port * ip ; 
    BLOCK_SETUP((PUSH(ip, 0+XfOrM306_COUNT)));
#   define XfOrM312_COUNT (1+XfOrM306_COUNT)
#   define SETUP_XfOrM312(x) SETUP(XfOrM312_COUNT)
    ip = NULLED_OUT ; 

# 2759 "./../src/fun.c"
    ip = FUNCCALL(SETUP_XfOrM312(_), scheme_input_port_record (a ) ); 
    RET_VALUE_START (ip -> name ) RET_VALUE_END ; 
  }

# 2761 "./../src/fun.c"
  else if (scheme_is_output_port (a ) )  {
    Scheme_Output_Port * op ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM306_COUNT)));
#   define XfOrM311_COUNT (1+XfOrM306_COUNT)
#   define SETUP_XfOrM311(x) SETUP(XfOrM311_COUNT)
    op = NULLED_OUT ; 

# 2763 "./../src/fun.c"
    op = FUNCCALL(SETUP_XfOrM311(_), scheme_output_port_record (a ) ); 
    RET_VALUE_START (op -> name ) RET_VALUE_END ; 
  }

# 2765 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) )  {
    Scheme_Thread * t = (Scheme_Thread * ) a ; 
    if (t -> name ) {
      RET_VALUE_START (t -> name ) RET_VALUE_END ; 
    }
  }

# 2770 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_logger_type ) )  {
    Scheme_Logger * logger = (Scheme_Logger * ) a ; 
    if (logger -> name )
      RET_VALUE_START (logger -> name ) RET_VALUE_END ; 
  }

# 2774 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) )  {

    if (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) 
      RET_VALUE_START ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ) RET_VALUE_END ; 
  }

  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2783 "./../src/fun.c"
static Scheme_Object * object_name (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 2785 "./../src/fun.c"
  return scheme_object_name (argv [0 ] ) ; 
}

Scheme_Object * scheme_arity (Scheme_Object * p ) 
{
  /* No conversion */

# 2790 "./../src/fun.c"
  return get_or_check_arity (p , - 1 , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * procedure_arity (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2795 "./../src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    scheme_wrong_contract ("procedure-arity" , "procedure?" , 0 , argc , argv ) ; 

  return get_or_check_arity (argv [0 ] , - 1 , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * procedure_arity_mask (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2803 "./../src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    scheme_wrong_contract ("procedure-arity-mask" , "procedure?" , 0 , argc , argv ) ; 

  return get_or_check_arity (argv [0 ] , - 4 , ((void * ) 0 ) , 1 ) ; 
}

static Scheme_Object * procedure_arity_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2811 "./../src/fun.c"
  Scheme_Object * a = argv [0 ] , * v ; 

  if (((intptr_t ) (a ) ) & 0x1 )  {
    return (((((intptr_t ) (a ) ) >> 1 ) >= 0 ) ? scheme_true : scheme_false ) ; 
  }

# 2815 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
    return (((& ((Scheme_Bignum * ) a ) -> iso ) -> so . keyex & 0x1 ) ? scheme_true : scheme_false ) ; 
  }

# 2817 "./../src/fun.c"
  else if ((a ) == (scheme_null ) )  {
    return scheme_true ; 
  }

# 2819 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    while (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
      v = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ; 
      if (((intptr_t ) (v ) ) & 0x1 )  {
        if ((((intptr_t ) (v ) ) >> 1 ) < 0 )
          return scheme_false ; 
      }

# 2825 "./../src/fun.c"
      else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
        if (! ((& ((Scheme_Bignum * ) v ) -> iso ) -> so . keyex & 0x1 ) )
          return scheme_false ; 
      }

# 2828 "./../src/fun.c"
      else if (! ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) v ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
      || ! scheme_is_struct_instance (scheme_arity_at_least , v ) ) {
        return scheme_false ; 
      }
      a = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ; 
    }
    return ((a ) == (scheme_null ) ) ? scheme_true : scheme_false ; 
  }

# 2835 "./../src/fun.c"
  else if (((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && scheme_is_struct_instance (scheme_arity_at_least , a ) ) {
    return scheme_true ; 
  }

# 2838 "./../src/fun.c"
  else 
  return scheme_false ; 
}

Scheme_Object * scheme_procedure_arity_includes (int argc , Scheme_Object * argv [] ) 
{
  intptr_t n ; 
  int inc_ok ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM342_COUNT (1)
# define SETUP_XfOrM342(x) SETUP(XfOrM342_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2847 "./../src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure-arity-includes?" , "procedure?" , 0 , argc , argv ) ); 

  n = FUNCCALL(SETUP_XfOrM342(_), scheme_extract_index ("procedure-arity-includes?" , 1 , argc , argv , - 2 , 0 ) ); 


  inc_ok = ((argc > 2 ) && (! (((argv [2 ] ) ) == (scheme_false ) ) ) ) ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(get_or_check_arity (argv [0 ] , n , argv [1 ] , inc_ok ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2858 "./../src/fun.c"
static int is_arity (Scheme_Object * a , int at_least_ok , int list_ok ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(a, 0)));
# define XfOrM343_COUNT (1)
# define SETUP_XfOrM343(x) SETUP(XfOrM343_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2860 "./../src/fun.c"
  if (((intptr_t ) (a ) ) & 0x1 )  {
    RET_VALUE_START (((((intptr_t ) (a ) ) >> 1 ) >= 0 ) ) RET_VALUE_END ; 
  }

# 2862 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
    RET_VALUE_START (((& ((Scheme_Bignum * ) a ) -> iso ) -> so . keyex & 0x1 ) ) RET_VALUE_END ; 
  }

# 2864 "./../src/fun.c"
  else if (at_least_ok 
  && ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) a ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && (scheme_is_struct_instance (scheme_arity_at_least , a ) ) ) {
#   define XfOrM346_COUNT (0+XfOrM343_COUNT)
#   define SETUP_XfOrM346(x) SETUP_XfOrM343(x)

# 2867 "./../src/fun.c"
    a = FUNCCALL(SETUP_XfOrM346(_), scheme_struct_ref (a , 0 ) ); 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(is_arity (a , 0 , 0 ) )) RET_VALUE_EMPTY_END ; 
  }

  if (! list_ok )
    RET_VALUE_START (0 ) RET_VALUE_END ; 

  while (((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM345_COUNT (0+XfOrM343_COUNT)
#   define SETUP_XfOrM345(x) SETUP_XfOrM343(x)

# 2875 "./../src/fun.c"
    if (! FUNCCALL(SETUP_XfOrM345(_), is_arity ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) , 1 , 0 ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    a = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ; 
  }

  if ((a ) == (scheme_null ) ) 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2885 "./../src/fun.c"
void scheme_init_reduced_proc_struct (Scheme_Startup_Env * env ) 
{
  Scheme_Object * __funcarg126 = NULLED_OUT ; 
  PREPARE_VAR_STACK(1);
# define XfOrM349_COUNT (0)
# define SETUP_XfOrM349(x) SETUP(XfOrM349_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2887 "./../src/fun.c"
  if (! scheme_reduced_procedure_struct ) {
    Scheme_Inspector * insp ; 
    BLOCK_SETUP((PUSH(insp, 0+XfOrM349_COUNT)));
#   define XfOrM350_COUNT (1+XfOrM349_COUNT)
#   define SETUP_XfOrM350(x) SETUP(XfOrM350_COUNT)
    insp = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM350(_), scheme_register_static ((void * ) & scheme_reduced_procedure_struct , sizeof (scheme_reduced_procedure_struct ) ) )
# 2890 "./../src/fun.c"
    ; 
    insp = (Scheme_Inspector * ) FUNCCALL(SETUP_XfOrM350(_), scheme_get_current_inspector () ); 
    while (insp -> superior -> superior ) {
      insp = insp -> superior ; 
    }
    scheme_reduced_procedure_struct = (__funcarg126 = FUNCCALL(SETUP_XfOrM350(_), scheme_intern_symbol ("procedure" ) ), FUNCCALL_AGAIN(scheme_make_struct_type2 (__funcarg126 , ((void * ) 0 ) , (Scheme_Object * ) insp , 4 , 0 , scheme_false , scheme_null , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) , ((void * ) 0 ) ) )) 






    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2906 "./../src/fun.c"
static Scheme_Object * arity_to_mask (Scheme_Object * aty ) 
{
  Scheme_Object * __funcarg129 = NULLED_OUT ; 

# 2906 "./../src/fun.c"
  Scheme_Object * __funcarg128 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(aty, 0)));
# define XfOrM353_COUNT (1)
# define SETUP_XfOrM353(x) SETUP(XfOrM353_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2908 "./../src/fun.c"
  if (((intptr_t ) (aty ) ) & 0x1 )  {
    intptr_t n = (((intptr_t ) (aty ) ) >> 1 ) ; 
#   define XfOrM360_COUNT (0+XfOrM353_COUNT)
#   define SETUP_XfOrM360(x) SETUP_XfOrM353(x)

# 2910 "./../src/fun.c"
    if (n <= 29 )
      RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 << n ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_shifted_one (n ) )) RET_VALUE_EMPTY_END ; 
  }

# 2914 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (aty ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (aty ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
#   define XfOrM359_COUNT (0+XfOrM353_COUNT)
#   define SETUP_XfOrM359(x) SETUP_XfOrM353(x)
    FUNCCALL_EMPTY(scheme_raise_out_of_memory (((void * ) 0 ) , ((void * ) 0 ) ) )
# 2915 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 2917 "./../src/fun.c"
  else if (((Scheme_Type ) (((((intptr_t ) (aty ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (aty ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (aty ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (aty ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
    Scheme_Object * mask ; 
    BLOCK_SETUP((PUSH(mask, 0+XfOrM353_COUNT)));
#   define XfOrM357_COUNT (1+XfOrM353_COUNT)
#   define SETUP_XfOrM357(x) SETUP(XfOrM357_COUNT)
    mask = NULLED_OUT ; 

# 2920 "./../src/fun.c"
    aty = FUNCCALL(SETUP_XfOrM357(_), scheme_struct_ref (aty , 0 ) ); 
    if (((intptr_t ) (aty ) ) & 0x1 ) 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_arity_mask ((((intptr_t ) (aty ) ) >> 1 ) , - 1 ) )) RET_VALUE_EMPTY_END ; 
    else {
#     define XfOrM358_COUNT (0+XfOrM357_COUNT)
#     define SETUP_XfOrM358(x) SETUP_XfOrM357(x)

# 2924 "./../src/fun.c"
      mask = FUNCCALL(SETUP_XfOrM358(_), arity_to_mask (aty ) ); 
      RET_VALUE_START ((__funcarg129 = FUNCCALL(SETUP_XfOrM358(_), scheme_bin_minus (mask , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ), FUNCCALL_EMPTY(scheme_bin_bitwise_xor (__funcarg129 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ) )) ) RET_VALUE_END 
      ; 
    }
  }

# 2928 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (aty ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (aty ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    Scheme_Object * mask = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    BLOCK_SETUP((PUSH(mask, 0+XfOrM353_COUNT)));
#   define XfOrM354_COUNT (1+XfOrM353_COUNT)
#   define SETUP_XfOrM354(x) SETUP(XfOrM354_COUNT)

# 2930 "./../src/fun.c"
    while (((Scheme_Type ) (((((intptr_t ) (aty ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (aty ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM356_COUNT (0+XfOrM354_COUNT)
#     define SETUP_XfOrM356(x) SETUP_XfOrM354(x)

# 2931 "./../src/fun.c"
      mask = (__funcarg128 = FUNCCALL(SETUP_XfOrM356(_), arity_to_mask ((((Scheme_Simple_Object * ) (aty ) ) -> u . pair_val . car ) ) ), FUNCCALL_AGAIN(scheme_bin_bitwise_or (__funcarg128 , mask ) )) ; 
      aty = (((Scheme_Simple_Object * ) (aty ) ) -> u . pair_val . cdr ) ; 
    }
    RET_VALUE_START (mask ) RET_VALUE_END ; 
  }

# 2935 "./../src/fun.c"
  else 
  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2939 "./../src/fun.c"
static Scheme_Object * mask_to_arity (Scheme_Object * mask , int mode ) 
{
  intptr_t n , pos = 0 ; 
  Scheme_Object * l = scheme_null ; 

# 1764 "./../src/fun.c"
  Scheme_Object * __funcarg135 = NULLED_OUT ; 
  Scheme_Object * __funcarg134 = NULLED_OUT ; 
  Scheme_Object * __funcarg133 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSH(mask, 1)));
# define XfOrM361_COUNT (2)
# define SETUP_XfOrM361(x) SETUP(XfOrM361_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2944 "./../src/fun.c"
  while (! (((intptr_t ) (mask ) ) & 0x1 ) ) {
    Scheme_Object * a [2 ] , * b ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM361_COUNT), PUSH(b, 3+XfOrM361_COUNT)));
#   define XfOrM374_COUNT (4+XfOrM361_COUNT)
#   define SETUP_XfOrM374(x) SETUP(XfOrM374_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    b = NULLED_OUT ; 

# 2946 "./../src/fun.c"
    b = FUNCCALL(SETUP_XfOrM374(_), scheme_bin_bitwise_and (mask , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0xFFFF ) ) ) << 1 ) | 0x1 ) ) ) ); 
    if (((intptr_t ) (b ) ) & 0x1 )  {
#     define XfOrM376_COUNT (0+XfOrM374_COUNT)
#     define SETUP_XfOrM376(x) SETUP_XfOrM374(x)

# 2948 "./../src/fun.c"
      b = FUNCCALL(SETUP_XfOrM376(_), scheme_bin_bitwise_and (mask , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
      if (((intptr_t ) (b ) ) & 0x1 ) 
        l = FUNCCALL(SETUP_XfOrM376(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , l ) ); 
      pos ++ ; 
      a [0 ] = mask ; 
      a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ; 
      mask = FUNCCALL(SETUP_XfOrM376(_), scheme_bitwise_shift (2 , a ) ); 
    }

# 2955 "./../src/fun.c"
    else {
#     define XfOrM375_COUNT (0+XfOrM374_COUNT)
#     define SETUP_XfOrM375(x) SETUP_XfOrM374(x)

# 2956 "./../src/fun.c"
      pos += 16 ; 
      a [0 ] = mask ; 
      a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 16 ) ) ) << 1 ) | 0x1 ) ) ; 
      mask = FUNCCALL(SETUP_XfOrM375(_), scheme_bitwise_shift (2 , a ) ); 
    }
  }

  n = (((intptr_t ) (mask ) ) >> 1 ) ; 
  if (! n ) {
#   define XfOrM370_COUNT (0+XfOrM361_COUNT)
#   define SETUP_XfOrM370(x) SETUP_XfOrM361(x)

# 2965 "./../src/fun.c"
    if (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && (((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) == (scheme_null ) ) )
      RET_VALUE_START ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) RET_VALUE_END ; 
    else 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_reverse (l ) )) RET_VALUE_EMPTY_END ; 
  }

  while (1 ) {
#   define XfOrM366_COUNT (0+XfOrM361_COUNT)
#   define SETUP_XfOrM366(x) SETUP_XfOrM361(x)

# 2972 "./../src/fun.c"
    if (n == - 1 ) {
#     define XfOrM369_COUNT (0+XfOrM366_COUNT)
#     define SETUP_XfOrM369(x) SETUP_XfOrM366(x)

# 2973 "./../src/fun.c"
      if ((l ) == (scheme_null ) ) 
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_arity (pos , - 1 , mode ) )) RET_VALUE_EMPTY_END ; 
      else 
      RET_VALUE_START ((__funcarg134 = (__funcarg135 = FUNCCALL(SETUP_XfOrM369(_), make_arity (pos , - 1 , mode ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg135 , l ) )) , FUNCCALL_EMPTY(scheme_reverse (__funcarg134 ) )) ) RET_VALUE_END ; 
    }

# 2977 "./../src/fun.c"
    else if (n == 1 ) {
#     define XfOrM368_COUNT (0+XfOrM366_COUNT)
#     define SETUP_XfOrM368(x) SETUP_XfOrM366(x)

# 2978 "./../src/fun.c"
      if ((l ) == (scheme_null ) ) 
        RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
      else 
      RET_VALUE_START ((__funcarg133 = FUNCCALL(SETUP_XfOrM368(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , l ) ), FUNCCALL_EMPTY(scheme_reverse (__funcarg133 ) )) ) RET_VALUE_END ; 
    }

# 2982 "./../src/fun.c"
    else if (n & 0x1 ) {
#     define XfOrM367_COUNT (0+XfOrM366_COUNT)
#     define SETUP_XfOrM367(x) SETUP_XfOrM366(x)

# 2983 "./../src/fun.c"
      l = FUNCCALL(SETUP_XfOrM367(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , l ) ); 
    }
    pos ++ ; 
    n >>= 1 ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2990 "./../src/fun.c"
Scheme_Object * scheme_arity_mask_to_arity (Scheme_Object * mask , int mode ) 
{
  /* No conversion */

# 2992 "./../src/fun.c"
  return mask_to_arity (mask , mode ) ; 
}

static Scheme_Object * make_reduced_proc (Scheme_Object * proc , 
Scheme_Object * mask , 
Scheme_Object * name , Scheme_Object * is_meth ) 
{
  Scheme_Structure * inst ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(is_meth, 1), PUSH(name, 2), PUSH(mask, 3), PUSH(inst, 4)));
# define XfOrM378_COUNT (5)
# define SETUP_XfOrM378(x) SETUP(XfOrM378_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 3001 "./../src/fun.c"
  if ((((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
  && (scheme_is_struct_instance (scheme_reduced_procedure_struct , proc ) ) ) {

    if (! name )
      name = ((Scheme_Structure * ) proc ) -> slots [2 ] ; 
    if (! is_meth )
      is_meth = ((Scheme_Structure * ) proc ) -> slots [3 ] ; 
    proc = ((Scheme_Structure * ) proc ) -> slots [0 ] ; 
  }

  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM378(_), GC_malloc_one_tagged (sizeof (Scheme_Structure ) + ((4 - 0 ) * sizeof (Scheme_Object * ) ) ) )
  ; 
  inst -> so . type = scheme_proc_struct_type ; 
  inst -> stype = (Scheme_Struct_Type * ) scheme_reduced_procedure_struct ; 

  inst -> slots [0 ] = proc ; 
  inst -> slots [1 ] = mask ; 
  inst -> slots [2 ] = (name ? name : scheme_false ) ; 
  inst -> slots [3 ] = (is_meth ? is_meth : scheme_false ) ; 

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3024 "./../src/fun.c"
static int is_subarity (Scheme_Object * req , Scheme_Object * orig , int req_delta ) 
{
  Scheme_Object * oa , * ra , * ol , * lra , * ara , * prev , * pr , * tmp , * rd ; 
  Scheme_Object * __funcarg195 = NULLED_OUT ; 
  Scheme_Object * __funcarg194 = NULLED_OUT ; 
  Scheme_Object * __funcarg193 = NULLED_OUT ; 
  Scheme_Object * __funcarg192 = NULLED_OUT ; 
  Scheme_Object * __funcarg191 = NULLED_OUT ; 
  Scheme_Object * __funcarg190 = NULLED_OUT ; 
  Scheme_Object * __funcarg189 = NULLED_OUT ; 
  Scheme_Object * __funcarg188 = NULLED_OUT ; 
  Scheme_Object * __funcarg187 = NULLED_OUT ; 
  Scheme_Object * __funcarg186 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(11);
  BLOCK_SETUP_TOP((PUSH(oa, 0), PUSH(ara, 1), PUSH(orig, 2), PUSH(prev, 3), PUSH(ol, 4), PUSH(lra, 5), PUSH(tmp, 6), PUSH(ra, 7), PUSH(rd, 8), PUSH(pr, 9), PUSH(req, 10)));
# define XfOrM380_COUNT (11)
# define SETUP_XfOrM380(x) SETUP(XfOrM380_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  oa = NULLED_OUT ; 
  ra = NULLED_OUT ; 
  ol = NULLED_OUT ; 
  lra = NULLED_OUT ; 
  ara = NULLED_OUT ; 
  prev = NULLED_OUT ; 
  pr = NULLED_OUT ; 
  tmp = NULLED_OUT ; 
  rd = NULLED_OUT ; 

# 3028 "./../src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (orig ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ! ((orig ) == (scheme_null ) ) )
    orig = FUNCCALL(SETUP_XfOrM380(_), scheme_make_pair (orig , scheme_null ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (req ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (req ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ! ((req ) == (scheme_null ) ) )
    req = FUNCCALL(SETUP_XfOrM380(_), scheme_make_pair (req , scheme_null ) ); 

  rd = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (req_delta ) ) ) << 1 ) | 0x1 ) ) ; 

  while (! ((req ) == (scheme_null ) ) ) {
#   define XfOrM450_COUNT (0+XfOrM380_COUNT)
#   define SETUP_XfOrM450(x) SETUP_XfOrM380(x)

# 3036 "./../src/fun.c"
    ra = (((Scheme_Simple_Object * ) (req ) ) -> u . pair_val . car ) ; 
    if (((((Scheme_Type ) (((((intptr_t ) (ra ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ra ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (ra ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ra ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (ra ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ra ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (ra ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ra ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) ra ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) ra ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) ra ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) ra ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
    && (scheme_is_struct_instance (scheme_arity_at_least , ra ) ) ) {
#     define XfOrM518_COUNT (0+XfOrM450_COUNT)
#     define SETUP_XfOrM518(x) SETUP_XfOrM450(x)


      ra = (__funcarg194 = (__funcarg195 = FUNCCALL(SETUP_XfOrM518(_), scheme_struct_ref (ra , 0 ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg195 , scheme_false ) )) 
      , FUNCCALL_AGAIN(scheme_make_pair (__funcarg194 , scheme_null ) )) 
      ; 
    }

    for (ol = orig ; ! ((ol ) == (scheme_null ) ) ; ol = (((Scheme_Simple_Object * ) (ol ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM485_COUNT (0+XfOrM450_COUNT)
#     define SETUP_XfOrM485(x) SETUP_XfOrM450(x)

# 3049 "./../src/fun.c"
      oa = (((Scheme_Simple_Object * ) (ol ) ) -> u . pair_val . car ) ; 
      if ((((intptr_t ) (ra ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (ra ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ra ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
#       define XfOrM515_COUNT (0+XfOrM485_COUNT)
#       define SETUP_XfOrM515(x) SETUP_XfOrM485(x)

# 3051 "./../src/fun.c"
        if ((((intptr_t ) (oa ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (oa ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (oa ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
#         define XfOrM517_COUNT (0+XfOrM515_COUNT)
#         define SETUP_XfOrM517(x) SETUP_XfOrM515(x)

# 3052 "./../src/fun.c"
          if ((__funcarg193 = FUNCCALL(SETUP_XfOrM517(_), scheme_bin_plus (ra , rd ) ), FUNCCALL_AGAIN(scheme_equal (__funcarg193 , oa ) )) )
            break ; 
        }

# 3054 "./../src/fun.c"
        else {
#         define XfOrM516_COUNT (0+XfOrM515_COUNT)
#         define SETUP_XfOrM516(x) SETUP_XfOrM515(x)

# 3056 "./../src/fun.c"
          oa = ((Scheme_Structure * ) oa ) -> slots [0 ] ; 
          if ((__funcarg192 = FUNCCALL(SETUP_XfOrM516(_), scheme_bin_plus (ra , rd ) ), FUNCCALL_AGAIN(scheme_bin_lt_eq (oa , __funcarg192 ) )) )
            break ; 
        }
      }

# 3060 "./../src/fun.c"
      else {

        int at_least ; 
#       define XfOrM486_COUNT (0+XfOrM485_COUNT)
#       define SETUP_XfOrM486(x) SETUP_XfOrM485(x)

# 3063 "./../src/fun.c"
        if ((((intptr_t ) (oa ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (oa ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (oa ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
          at_least = 0 ; 
        }

# 3065 "./../src/fun.c"
        else {

          at_least = 1 ; 
          oa = ((Scheme_Structure * ) oa ) -> slots [0 ] ; 
        }

        lra = ra ; 
        prev = ((void * ) 0 ) ; 
        while (! ((lra ) == (scheme_null ) ) ) {
#         define XfOrM500_COUNT (0+XfOrM486_COUNT)
#         define SETUP_XfOrM500(x) SETUP_XfOrM486(x)

# 3075 "./../src/fun.c"
          ara = (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . car ) ; 
          if (((((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) ) ) == (scheme_false ) ) 
          || (__funcarg191 = FUNCCALL(SETUP_XfOrM500(_), scheme_bin_plus ((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) , rd ) ), FUNCCALL_AGAIN(scheme_bin_lt_eq (oa , __funcarg191 ) )) ) {
#           define XfOrM501_COUNT (0+XfOrM500_COUNT)
#           define SETUP_XfOrM501(x) SETUP_XfOrM500(x)

# 3078 "./../src/fun.c"
            if ((__funcarg190 = FUNCCALL(SETUP_XfOrM501(_), scheme_bin_plus ((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . car ) , rd ) ), FUNCCALL_AGAIN(scheme_bin_gt_eq (oa , __funcarg190 ) )) ) {
#             define XfOrM503_COUNT (0+XfOrM501_COUNT)
#             define SETUP_XfOrM503(x) SETUP_XfOrM501(x)

# 3080 "./../src/fun.c"
              if ((__funcarg189 = FUNCCALL(SETUP_XfOrM503(_), scheme_bin_plus ((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . car ) , rd ) ), FUNCCALL_AGAIN(scheme_equal (oa , __funcarg189 ) )) ) {
#               define XfOrM508_COUNT (0+XfOrM503_COUNT)
#               define SETUP_XfOrM508(x) SETUP_XfOrM503(x)

# 3082 "./../src/fun.c"
                if (at_least ) {

                  if (prev )
                    (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = scheme_null ; 
                  else 
                  ra = scheme_null ; 
                }

# 3088 "./../src/fun.c"
                else {
#                 define XfOrM509_COUNT (0+XfOrM508_COUNT)
#                 define SETUP_XfOrM509(x) SETUP_XfOrM508(x)

# 3089 "./../src/fun.c"
                  if ((__funcarg188 = FUNCCALL(SETUP_XfOrM509(_), scheme_bin_plus ((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) , rd ) ), FUNCCALL_AGAIN(scheme_equal (oa , __funcarg188 ) )) ) {

                    if (prev )
                      (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) ; 
                    else 
                    ra = (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) ; 
                  }

# 3095 "./../src/fun.c"
                  else {
#                   define XfOrM510_COUNT (0+XfOrM509_COUNT)
#                   define SETUP_XfOrM510(x) SETUP_XfOrM509(x)

# 3097 "./../src/fun.c"
                    tmp = FUNCCALL(SETUP_XfOrM510(_), scheme_bin_plus (oa , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
                    tmp = FUNCCALL(SETUP_XfOrM510(_), scheme_bin_minus (tmp , rd ) ); 
                    (((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . car ) = tmp ; 
                  }
                }
              }

# 3102 "./../src/fun.c"
              else if ((__funcarg187 = FUNCCALL(SETUP_XfOrM503(_), scheme_bin_plus ((((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . car ) , rd ) ), FUNCCALL_AGAIN(scheme_equal (oa , __funcarg187 ) )) ) {
#               define XfOrM507_COUNT (0+XfOrM503_COUNT)
#               define SETUP_XfOrM507(x) SETUP_XfOrM503(x)

# 3104 "./../src/fun.c"
                tmp = FUNCCALL(SETUP_XfOrM507(_), scheme_bin_minus (oa , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
                tmp = FUNCCALL(SETUP_XfOrM507(_), scheme_bin_minus (tmp , rd ) ); 
                (((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) = tmp ; 
                if (at_least )
                  (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) = scheme_null ; 
              }

# 3109 "./../src/fun.c"
              else {
#               define XfOrM504_COUNT (0+XfOrM503_COUNT)
#               define SETUP_XfOrM504(x) SETUP_XfOrM503(x)

# 3111 "./../src/fun.c"
                if (at_least ) {
#                 define XfOrM506_COUNT (0+XfOrM504_COUNT)
#                 define SETUP_XfOrM506(x) SETUP_XfOrM504(x)

# 3112 "./../src/fun.c"
                  tmp = FUNCCALL(SETUP_XfOrM506(_), scheme_bin_minus (oa , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
                  tmp = FUNCCALL(SETUP_XfOrM506(_), scheme_bin_minus (tmp , rd ) ); 
                  (((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) = tmp ; 
                  (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) = scheme_null ; 
                }

# 3116 "./../src/fun.c"
                else {
#                 define XfOrM505_COUNT (0+XfOrM504_COUNT)
#                 define SETUP_XfOrM505(x) SETUP_XfOrM504(x)

# 3117 "./../src/fun.c"
                  tmp = FUNCCALL(SETUP_XfOrM505(_), scheme_bin_plus (oa , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
                  tmp = FUNCCALL(SETUP_XfOrM505(_), scheme_bin_minus (tmp , rd ) ); 
                  pr = (__funcarg186 = FUNCCALL(SETUP_XfOrM505(_), scheme_make_pair (tmp , (((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg186 , (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) ) )) 
                  ; 
                  tmp = FUNCCALL_AGAIN(scheme_bin_minus (oa , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) ); 
                  tmp = FUNCCALL_AGAIN(scheme_bin_minus (tmp , rd ) ); 
                  (((Scheme_Simple_Object * ) (ara ) ) -> u . pair_val . cdr ) = tmp ; 
                  (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) = pr ; 
                }
              }
              break ; 
            }

# 3128 "./../src/fun.c"
            else if (at_least ) {

              if (prev )
                (((Scheme_Simple_Object * ) (prev ) ) -> u . pair_val . cdr ) = scheme_null ; 
              else 
              ra = scheme_null ; 
              break ; 
            }
          }
          prev = lra ; 
          lra = (((Scheme_Simple_Object * ) (lra ) ) -> u . pair_val . cdr ) ; 
        }
        if ((ra ) == (scheme_null ) ) 
          break ; 
      }
    }

    if ((ol ) == (scheme_null ) )  {
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

    req = (((Scheme_Simple_Object * ) (req ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3155 "./../src/fun.c"
static int proc_is_method (Scheme_Object * proc ) 
{
  /* No conversion */

# 3157 "./../src/fun.c"
  if (((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    proc = (((Scheme_Chaperone * ) proc ) -> val ) ; 

  if ((((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
  && scheme_is_struct_instance (scheme_reduced_procedure_struct , proc ) )
    return (! (((((Scheme_Structure * ) proc ) -> slots [3 ] ) ) == (scheme_false ) ) ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) )  {
    Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) proc ; 
    if (cl -> count )
      proc = cl -> array [0 ] ; 
    else 
    return 0 ; 
  }

  if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) )  {
    return (((& (((Scheme_Closure * ) proc ) -> code ) -> iso ) -> so . keyex & 16 ) 
    ? 1 
    : 0 ) ; 
  }









  return 0 ; 
}

static Scheme_Object * do_procedure_reduce_arity (const char * who , int argc , Scheme_Object * argv [] , int as_arity ) 
{
  Scheme_Object * orig , * mask , * is_meth = ((void * ) 0 ) , * name = ((void * ) 0 ) ; 
  Scheme_Object * __funcarg196 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(name, 1), PUSH(is_meth, 2), PUSH(orig, 3), PUSH(mask, 4), PUSH(argv, 5)));
# define XfOrM522_COUNT (6)
# define SETUP_XfOrM522(x) SETUP(XfOrM522_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  orig = NULLED_OUT ; 
  mask = NULLED_OUT ; 

# 3193 "./../src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure-reduce-arity" , "procedure?" , 0 , argc , argv ) ); 

  if (as_arity ) {
#   define XfOrM528_COUNT (0+XfOrM522_COUNT)
#   define SETUP_XfOrM528(x) SETUP_XfOrM522(x)

# 3197 "./../src/fun.c"
    if (! FUNCCALL(SETUP_XfOrM528(_), is_arity (argv [1 ] , 1 , 1 ) )) {
#     define XfOrM529_COUNT (0+XfOrM528_COUNT)
#     define SETUP_XfOrM529(x) SETUP_XfOrM528(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c exact-nonnegative-integer? arity-at-least? (listof (or/c exact-nonnegative-integer? arity-at-least?)))" , 1 , argc , argv ) ); 
    }
    mask = FUNCCALL(SETUP_XfOrM528(_), arity_to_mask (argv [1 ] ) ); 
  }

# 3203 "./../src/fun.c"
  else {
#   define XfOrM526_COUNT (0+XfOrM522_COUNT)
#   define SETUP_XfOrM526(x) SETUP_XfOrM522(x)

# 3204 "./../src/fun.c"
    mask = argv [1 ] ; 
    if (! FUNCCALL(SETUP_XfOrM526(_), scheme_exact_p (mask ) )) {
#     define XfOrM527_COUNT (0+XfOrM526_COUNT)
#     define SETUP_XfOrM527(x) SETUP_XfOrM526(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-integer?" , 1 , argc , argv ) )
# 3206 "./../src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (argc > 2 ) {
#   define XfOrM524_COUNT (0+XfOrM522_COUNT)
#   define SETUP_XfOrM524(x) SETUP_XfOrM522(x)

# 3212 "./../src/fun.c"
    name = argv [2 ] ; 
    if (((name ) ) == (scheme_false ) ) 
      name = ((void * ) 0 ) ; 
    else if (! ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#     define XfOrM525_COUNT (0+XfOrM524_COUNT)
#     define SETUP_XfOrM525(x) SETUP_XfOrM524(x)
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c symbol? #f)" , 2 , argc , argv ) )
# 3216 "./../src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 3219 "./../src/fun.c"
  else 
  name = ((void * ) 0 ) ; 



  orig = FUNCCALL(SETUP_XfOrM522(_), get_or_check_arity (argv [0 ] , - 4 , ((void * ) 0 ) , 1 ) ); 

  if (! (__funcarg196 = FUNCCALL(SETUP_XfOrM522(_), scheme_bin_bitwise_and (mask , orig ) ), FUNCCALL_AGAIN(scheme_bin_eq (__funcarg196 , mask ) )) ) {
#   define XfOrM523_COUNT (0+XfOrM522_COUNT)
#   define SETUP_XfOrM523(x) SETUP_XfOrM522(x)
    FUNCCALL_EMPTY(scheme_contract_error (who , (as_arity ? "arity of procedure does not include requested arity" : "arity mask of procedure does not include requested arity mask" ) , "procedure" , 1 , argv [0 ] , (as_arity ? "requested arity" : "requested arity mask" ) , 1 , argv [1 ] , ((void * ) 0 ) ) )



    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (FUNCCALL(SETUP_XfOrM522(_), proc_is_method (argv [0 ] ) ))
    is_meth = scheme_true ; 


  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_reduced_proc (argv [0 ] , mask , name , is_meth ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3244 "./../src/fun.c"
static Scheme_Object * procedure_reduce_arity (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3246 "./../src/fun.c"
  return do_procedure_reduce_arity ("procedure-reduce-arity" , argc , argv , 1 ) ; 
}

static Scheme_Object * procedure_reduce_arity_mask (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3251 "./../src/fun.c"
  return do_procedure_reduce_arity ("procedure-reduce-arity-mask" , argc , argv , 0 ) ; 
}

static Scheme_Object * procedure_rename (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * p , * mask ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(mask, 1), PUSH(argv, 2)));
# define XfOrM532_COUNT (3)
# define SETUP_XfOrM532(x) SETUP(XfOrM532_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  mask = NULLED_OUT ; 

# 3258 "./../src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure-rename" , "procedure?" , 0 , argc , argv ) ); 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure-rename" , "symbol?" , 1 , argc , argv ) ); 

  p = FUNCCALL(SETUP_XfOrM532(_), scheme_rename_struct_proc (argv [0 ] , argv [1 ] ) ); 
  if (p )

# 3264 "./../src/fun.c"
  RET_VALUE_START (p ) RET_VALUE_END ; 

  mask = FUNCCALL(SETUP_XfOrM532(_), get_or_check_arity (argv [0 ] , - 4 , ((void * ) 0 ) , 1 ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_reduced_proc (argv [0 ] , mask , argv [1 ] , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3271 "./../src/fun.c"
static Scheme_Object * procedure_to_method (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * mask ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(mask, 0), PUSH(argv, 1)));
# define XfOrM533_COUNT (2)
# define SETUP_XfOrM533(x) SETUP(XfOrM533_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  mask = NULLED_OUT ; 

# 3275 "./../src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure->method" , "procedure?" , 0 , argc , argv ) ); 

  mask = FUNCCALL(SETUP_XfOrM533(_), get_or_check_arity (argv [0 ] , - 4 , ((void * ) 0 ) , 1 ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_reduced_proc (argv [0 ] , mask , ((void * ) 0 ) , scheme_true ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3283 "./../src/fun.c"
static Scheme_Object * procedure_equal_closure_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3285 "./../src/fun.c"
  Scheme_Object * v1 = argv [0 ] , * v2 = argv [1 ] ; 

  if (! (! (((intptr_t ) (v1 ) ) & 0x1 ) && ((((v1 ) -> type ) >= scheme_prim_type ) && (((v1 ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    scheme_wrong_contract ("procedure-closure-contents-eq?" , "procedure?" , 0 , argc , argv ) ; 
  if (! (! (((intptr_t ) (v2 ) ) & 0x1 ) && ((((v2 ) -> type ) >= scheme_prim_type ) && (((v2 ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    scheme_wrong_contract ("procedure-closure-contents-eq?" , "procedure?" , 1 , argc , argv ) ; 

  if ((v1 ) == (v2 ) ) 
    return scheme_true ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (v1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v1 ) ) -> type ) ) == (Scheme_Type ) (((((intptr_t ) (v2 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v2 ) ) -> type ) ) ) )
    return scheme_false ; 

  switch (((((intptr_t ) (v1 ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v1 ) ) -> type ) ) {
    case scheme_prim_type : 
    {
      Scheme_Primitive_Proc * p1 = (Scheme_Primitive_Proc * ) v1 ; 
      Scheme_Primitive_Proc * p2 = (Scheme_Primitive_Proc * ) v2 ; 

      if (p1 -> prim_val == p2 -> prim_val ) {
        if (p1 -> pp . flags & 16 ) {
          if (! (p2 -> pp . flags & 16 ) )
            return scheme_false ; 




          return scheme_false ; 
        }

# 3313 "./../src/fun.c"
        else if (! (p2 -> pp . flags & 16 ) )
          return scheme_true ; 
      }
    }
    break ; 
    case scheme_closure_type : 
    {
      Scheme_Closure * c1 = (Scheme_Closure * ) v1 ; 
      Scheme_Closure * c2 = (Scheme_Closure * ) v2 ; 

      if ((c1 -> code ) == (c2 -> code ) )  {
        int i ; 
        for (i = c1 -> code -> closure_size ; i -- ; ) {
          if (! ((c1 -> vals [i ] ) == (c2 -> vals [i ] ) ) )
            return scheme_false ; 
        }
        return scheme_true ; 
      }
    }
    break ; 
    case scheme_native_closure_type : 
    {
      Scheme_Native_Closure * c1 = (Scheme_Native_Closure * ) v1 ; 
      Scheme_Native_Closure * c2 = (Scheme_Native_Closure * ) v2 ; 

      if (((c1 -> code ) == (c2 -> code ) ) 
      || (c1 -> code -> eq_key && ((c1 -> code -> eq_key ) == (c2 -> code -> eq_key ) ) ) ) {
        int i ; 
        i = c1 -> code -> closure_size ; 
        if (i < 0 ) {

          Scheme_Native_Closure * sc1 , * sc2 ; 
          int j ; 
          i = - (i + 1 ) ; 
          while (i -- ) {
            sc1 = (Scheme_Native_Closure * ) c1 -> vals [i ] ; 
            sc2 = (Scheme_Native_Closure * ) c2 -> vals [i ] ; 
            j = sc1 -> code -> closure_size ; 
            while (j -- ) {
              if (! ((sc1 -> vals [j ] ) == (sc2 -> vals [j ] ) ) )
                return scheme_false ; 
            }
          }
        }

# 3356 "./../src/fun.c"
        else {

          while (i -- ) {
            if (! ((c1 -> vals [i ] ) == (c2 -> vals [i ] ) ) )
              return scheme_false ; 
          }
        }
        return scheme_true ; 
      }
    }
    break ; 
    case scheme_case_closure_type : 
    {
      Scheme_Case_Lambda * c1 = (Scheme_Case_Lambda * ) v1 ; 
      Scheme_Case_Lambda * c2 = (Scheme_Case_Lambda * ) v2 ; 
      if (c1 -> count == c2 -> count ) {
        Scheme_Closure * sc1 , * sc2 ; 
        int i , j ; 
        for (i = c1 -> count ; i -- ; ) {
          sc1 = (Scheme_Closure * ) c1 -> array [i ] ; 
          sc2 = (Scheme_Closure * ) c2 -> array [i ] ; 
          if (! ((sc1 -> code ) == (sc2 -> code ) ) )
            return scheme_false ; 
          for (j = sc1 -> code -> closure_size ; j -- ; ) {
            if (! ((sc1 -> vals [j ] ) == (sc2 -> vals [j ] ) ) )
              return scheme_false ; 
          }
        }
        return scheme_true ; 
      }
    }
    break ; 
  }

  return scheme_false ; 
}

static Scheme_Object * procedure_specialize (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3395 "./../src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    scheme_wrong_contract ("procedure-specialize" , "procedure?" , 0 , argc , argv ) ; 

# 3417 "./../src/fun.c"
  return argv [0 ] ; 
}

static Scheme_Object * do_chaperone_procedure (const char * name , const char * whating , 
int is_impersonator , int pass_self , 
int argc , Scheme_Object * argv [] , int is_unsafe ) 
{
  Scheme_Chaperone * px , * px2 ; 
  Scheme_Object * val = argv [0 ] , * orig , * r , * app_mark ; 
  Scheme_Object * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(px2, 1), PUSH(props, 2), PUSH(name, 3), PUSH(app_mark, 4), PUSH(argv, 5), PUSH(px, 6), PUSH(orig, 7), PUSH(r, 8)));
# define XfOrM564_COUNT (9)
# define SETUP_XfOrM564(x) SETUP(XfOrM564_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  px = NULLED_OUT ; 
  px2 = NULLED_OUT ; 
  orig = NULLED_OUT ; 
  r = NULLED_OUT ; 
  app_mark = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 3428 "./../src/fun.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! (! (((intptr_t ) (val ) ) & 0x1 ) && ((((val ) -> type ) >= scheme_prim_type ) && (((val ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "procedure?" , 0 , argc , argv ) ); 
  if (is_unsafe ) {
#   define XfOrM574_COUNT (0+XfOrM564_COUNT)
#   define SETUP_XfOrM574(x) SETUP_XfOrM564(x)

# 3434 "./../src/fun.c"
    if (! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "procedure?" , 1 , argc , argv ) ); 
  }

# 3436 "./../src/fun.c"
  else {
#   define XfOrM573_COUNT (0+XfOrM564_COUNT)
#   define SETUP_XfOrM573(x) SETUP_XfOrM564(x)

# 3437 "./../src/fun.c"
    if (! (((argv [1 ] ) ) == (scheme_false ) ) && ! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "(or/c procedure? #f)" , 1 , argc , argv ) ); 
  }

  orig = FUNCCALL(SETUP_XfOrM564(_), get_or_check_arity (val , - 1 , ((void * ) 0 ) , 1 ) ); 
  if (! (((argv [1 ] ) ) == (scheme_false ) ) ) {
    Scheme_Object * naya ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM564_COUNT)));
#   define XfOrM572_COUNT (1+XfOrM564_COUNT)
#   define SETUP_XfOrM572(x) SETUP(XfOrM572_COUNT)
    naya = NULLED_OUT ; 

# 3444 "./../src/fun.c"
    naya = FUNCCALL(SETUP_XfOrM572(_), get_or_check_arity (argv [1 ] , - 1 , ((void * ) 0 ) , 1 ) ); 

    if (! FUNCCALL(SETUP_XfOrM572(_), is_subarity (orig , naya , pass_self ? 1 : 0 ) ))
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: arity of wrapper procedure does not cover arity of original procedure%s\n" "  wrapper: %V\n" "  original: %V" , name , (pass_self ? " (adding an extra argument)" : "" ) , argv [1 ] , argv [0 ] ) )






    ; 
  }

  props = FUNCCALL(SETUP_XfOrM564(_), scheme_parse_chaperone_props (name , 2 , argc , argv ) ); 
  if (props ) {
#   define XfOrM570_COUNT (0+XfOrM564_COUNT)
#   define SETUP_XfOrM570(x) SETUP_XfOrM564(x)

# 3459 "./../src/fun.c"
    app_mark = FUNCCALL(SETUP_XfOrM570(_), scheme_chaperone_props_get (props , scheme_app_mark_impersonator_property ) ); 
    if (app_mark ) {
#     define XfOrM571_COUNT (0+XfOrM570_COUNT)
#     define SETUP_XfOrM571(x) SETUP_XfOrM570(x)

# 3462 "./../src/fun.c"
      props = FUNCCALL(SETUP_XfOrM571(_), scheme_chaperone_props_remove (props , scheme_app_mark_impersonator_property ) ); 
    }

# 3463 "./../src/fun.c"
    else 
    app_mark = scheme_false ; 
  }

# 3465 "./../src/fun.c"
  else 
  app_mark = scheme_false ; 

  if ((((argv [1 ] ) ) == (scheme_false ) ) && (((app_mark ) ) == (scheme_false ) ) && ! props )
    RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 


  if ((((app_mark ) ) == (scheme_false ) ) && ! ((Scheme_Type ) (((((intptr_t ) (app_mark ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (app_mark ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
    app_mark = scheme_false ; 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM564(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_proc_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 

# 3496 "./../src/fun.c"
  r = FUNCCALL(SETUP_XfOrM564(_), scheme_make_vector ((pass_self ? 5 : 3 ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (- 1 ) ) ) << 1 ) | 0x1 ) ) ) ); 

  if (((argv [1 ] ) ) == (scheme_false ) ) 
    (((Scheme_Vector * ) (r ) ) -> els ) [0 ] = argv [0 ] ; 
  else 
  (((Scheme_Vector * ) (r ) ) -> els ) [0 ] = argv [1 ] ; 
  if (((argv [1 ] ) ) == (scheme_false ) ) 
    (((Scheme_Vector * ) (r ) ) -> els ) [1 ] = scheme_false ; 
  (((Scheme_Vector * ) (r ) ) -> els ) [2 ] = app_mark ; 

  px -> redirects = r ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 
  if (is_unsafe || (((argv [1 ] ) ) == (scheme_false ) ) )
    (& (px ) -> iso ) -> so . keyex |= 0x2 ; 

  if (! is_unsafe ) {


    for (val = px -> prev ; (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ; val = ((Scheme_Chaperone * ) val ) -> prev ) {
      px2 = (Scheme_Chaperone * ) val ; 
      if (((Scheme_Type ) (((((intptr_t ) (px2 -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px2 -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && ((((Scheme_Vector * ) (px2 -> redirects ) ) -> size ) & 1 ) )  {
        if (((((Scheme_Vector * ) (px2 -> redirects ) ) -> size ) > 3 ) 
        || (((Scheme_Inclhash_Object * ) (px2 -> redirects ) ) -> so . keyex & 0x1 ) )
          ((((Scheme_Inclhash_Object * ) (px -> redirects ) ) -> so . keyex |= 0x1 ) ) ; 
        break ; 
      }
    }
  }

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3530 "./../src/fun.c"
static Scheme_Object * chaperone_procedure (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3532 "./../src/fun.c"
  return do_chaperone_procedure ("chaperone-procedure" , "chaperoning" , 0 , 0 , argc , argv , 0 ) ; 
}

static Scheme_Object * unsafe_chaperone_procedure (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3537 "./../src/fun.c"
  return do_chaperone_procedure ("unsafe-chaperone-procedure" , "chaperoning" , 0 , 0 , argc , argv , 1 ) ; 
}

static Scheme_Object * impersonate_procedure (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3542 "./../src/fun.c"
  return do_chaperone_procedure ("impersonate-procedure" , "impersonating" , 1 , 0 , argc , argv , 0 ) ; 
}

static Scheme_Object * unsafe_impersonate_procedure (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3547 "./../src/fun.c"
  return do_chaperone_procedure ("unsafe-impersonate-procedure" , "impersonating" , 1 , 0 , argc , argv , 1 ) ; 
}

static Scheme_Object * chaperone_procedure_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3552 "./../src/fun.c"
  return do_chaperone_procedure ("chaperone-procedure*" , "chaperoning" , 0 , 1 , argc , argv , 0 ) ; 
}

static Scheme_Object * impersonate_procedure_star (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3557 "./../src/fun.c"
  return do_chaperone_procedure ("impersonate-procedure*" , "impersonating" , 1 , 1 , argc , argv , 0 ) ; 
}

static Scheme_Object * apply_chaperone_k (void ) 
{
  /* No conversion */

# 3562 "./../src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * * argv = (Scheme_Object * * ) p -> ku . k . p2 ; 
  Scheme_Object * auto_val = (Scheme_Object * ) p -> ku . k . p3 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return scheme_apply_chaperone (o , p -> ku . k . i1 , argv , auto_val , p -> ku . k . i2 ) ; 
}

static Scheme_Object * do_apply_chaperone (Scheme_Object * o , int argc , Scheme_Object * * argv , Scheme_Object * auto_val , int checks ) 
{
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(auto_val, 0), PUSH(o, 1), PUSH(argv, 2)));
# define XfOrM582_COUNT (3)
# define SETUP_XfOrM582(x) SETUP(XfOrM582_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3577 "./../src/fun.c"
  {

# 24 "./../src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM583_COUNT (0+XfOrM582_COUNT)
#   define SETUP_XfOrM583(x) SETUP_XfOrM582(x)

# 26 "./../src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 3579 "./../src/fun.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      Scheme_Object * * argv2 ; 
      BLOCK_SETUP((PUSH(p, 0+XfOrM583_COUNT), PUSH(argv2, 1+XfOrM583_COUNT)));
#     define XfOrM584_COUNT (2+XfOrM583_COUNT)
#     define SETUP_XfOrM584(x) SETUP(XfOrM584_COUNT)
      argv2 = NULLED_OUT ; 

# 3582 "./../src/fun.c"
      argv2 = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM584(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
      (memcpy (argv2 , argv , sizeof (Scheme_Object * ) * argc ) ) ; 
      p -> ku . k . p1 = (void * ) o ; 
      p -> ku . k . p2 = (void * ) argv2 ; 
      p -> ku . k . p3 = (void * ) auto_val ; 
      p -> ku . k . i1 = argc ; 
      p -> ku . k . i2 = checks ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (apply_chaperone_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }


  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_apply_chaperone (o , argc , argv , auto_val , checks ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3598 "./../src/fun.c"
static Scheme_Object * _apply_native (Scheme_Object * obj , int num_rands , Scheme_Object * * rands ) 
{
  Scheme_Native_Lambda * data ; 
  GC_CAN_IGNORE intptr_t old_cont_mark_stack ; 
  GC_CAN_IGNORE Scheme_Object * * rs ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(obj, 0)));
# define XfOrM585_COUNT (1)
# define SETUP_XfOrM585(x) SETUP(XfOrM585_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  data = NULLED_OUT ; 

# 3604 "./../src/fun.c"
  data = ((Scheme_Native_Closure * ) obj ) -> code ; 

  if ((uintptr_t ) data -> max_let_depth > ((uintptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - (uintptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) ) {
#   define XfOrM586_COUNT (0+XfOrM585_COUNT)
#   define SETUP_XfOrM586(x) SETUP_XfOrM585(x)

# 3607 "./../src/fun.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_do_eval (obj , num_rands , rands , - 1 ) )) RET_VALUE_EMPTY_END ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
  old_cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
  rs = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 

  obj = FUNCCALL(SETUP_XfOrM585(_), data -> start_code (obj , num_rands , rands , & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) ) ); 

  if (obj == ((Scheme_Object * ) 0x4 ) )
    obj = FUNCCALL(SETUP_XfOrM585(_), scheme_force_value_same_mark (obj ) ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = old_cont_mark_stack ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = rs ; 

  RET_VALUE_START (obj ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3626 "./../src/fun.c"
Scheme_Object * _scheme_apply_native (Scheme_Object * obj , int num_rands , Scheme_Object * * rands ) 
{
  /* No conversion */

# 3628 "./../src/fun.c"
  return _apply_native (obj , num_rands , rands ) ; 
}

Scheme_Object * extract_impersonator_results (int c , int argc , Scheme_Object * * argv2 , 
const char * what , Scheme_Object * o , 
Scheme_Chaperone * px , 
Scheme_Cont_Frame_Data * cframe , int * _need_pop ) 
{
  int extra = c - argc ; 
  int i , fail_reason = 0 ; 
  Scheme_Object * post ; 
  char nth [32 ] ; 
  Scheme_Config * config = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(what, 0), PUSH(cframe, 1), PUSH(argv2, 2), PUSH(post, 3), PUSH(px, 4), PUSH(config, 5), PUSH(o, 6), PUSH(_need_pop, 7)));
# define XfOrM588_COUNT (8)
# define SETUP_XfOrM588(x) SETUP(XfOrM588_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  post = NULLED_OUT ; 

# 3642 "./../src/fun.c"
  if (! extra )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  post = ((void * ) 0 ) ; 
  for (i = 0 ; i < extra ; ) {
#   define XfOrM601_COUNT (0+XfOrM588_COUNT)
#   define SETUP_XfOrM601(x) SETUP_XfOrM588(x)

# 3647 "./../src/fun.c"
    if (! i && (! (((intptr_t ) (argv2 [0 ] ) ) & 0x1 ) && ((((argv2 [0 ] ) -> type ) >= scheme_prim_type ) && (((argv2 [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
      post = argv2 [i ] ; 
      i ++ ; 
    }

# 3650 "./../src/fun.c"
    else if ((argv2 [i ] ) == (mark_symbol ) )  {
#     define XfOrM603_COUNT (0+XfOrM601_COUNT)
#     define SETUP_XfOrM603(x) SETUP_XfOrM601(x)

# 3651 "./../src/fun.c"
      if (i + 3 > extra ) {
        fail_reason = 2 ; 
        break ; 
      }
      if (post && ! * _need_pop ) {
#       define XfOrM604_COUNT (0+XfOrM603_COUNT)
#       define SETUP_XfOrM604(x) SETUP_XfOrM603(x)
        FUNCCALL(SETUP_XfOrM604(_), scheme_push_continuation_frame (cframe ) )
# 3656 "./../src/fun.c"
        ; 
        * _need_pop = 1 ; 
      }
      FUNCCALL(SETUP_XfOrM603(_), scheme_set_cont_mark (argv2 [i + 1 ] , argv2 [i + 2 ] ) ); 
      i += 3 ; 
    }

# 3661 "./../src/fun.c"
    else {
      fail_reason = 1 ; 
      break ; 
    }
  }

  if (! fail_reason ) {
#   define XfOrM592_COUNT (0+XfOrM588_COUNT)
#   define SETUP_XfOrM592(x) SETUP_XfOrM588(x)

# 3668 "./../src/fun.c"
    if (config ) {
#     define XfOrM593_COUNT (0+XfOrM592_COUNT)
#     define SETUP_XfOrM593(x) SETUP_XfOrM592(x)

# 3669 "./../src/fun.c"
      if (post && ! * _need_pop ) {
#       define XfOrM594_COUNT (0+XfOrM593_COUNT)
#       define SETUP_XfOrM594(x) SETUP_XfOrM593(x)
        FUNCCALL(SETUP_XfOrM594(_), scheme_push_continuation_frame (cframe ) )
# 3670 "./../src/fun.c"
        ; 
        * _need_pop = 1 ; 
      }
      FUNCCALL(SETUP_XfOrM593(_), scheme_set_cont_mark (scheme_parameterization_key , (Scheme_Object * ) config ) ); 
    }
    RET_VALUE_START (post ) RET_VALUE_END ; 
  }



  switch (i % 10 ) {
#   define XfOrM591_COUNT (0+XfOrM588_COUNT)
#   define SETUP_XfOrM591(x) SETUP_XfOrM588(x)

# 3681 "./../src/fun.c"
    case 1 : (
    sprintf (nth , "%dst" , i ) ) ; 
    break ; 
    case 2 : (
    sprintf (nth , "%dnd" , i ) ) ; 
    break ; 
    case 3 : (
    sprintf (nth , "%drd" , i ) ) ; 
    break ; 
    default : (
    sprintf (nth , "%dth" , i ) ) ; 
  }

  if (fail_reason == 1 ) {
#   define XfOrM590_COUNT (0+XfOrM588_COUNT)
#   define SETUP_XfOrM590(x) SETUP_XfOrM588(x)
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "procedure %s: wrapper's %s result is not valid;\n" " %s extra result (before original argument count) should be\n" " 'mark%s\n" "  original: %V\n" "  wrapper: %V\n" "  received: %V" , what , nth , nth , (i ? "" : " or a wrapper for the original procedure's result" ) , o , (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] , argv2 [i ] ) )
# 3708 "./../src/fun.c"
    ; 
  }

# 3709 "./../src/fun.c"
  else if (fail_reason == 2 ) {
#   define XfOrM589_COUNT (0+XfOrM588_COUNT)
#   define SETUP_XfOrM589(x) SETUP_XfOrM588(x)
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "procedure %s: wrapper's %s result needs addition extra results;\n" " %s extra result (before original argument count) needs an\n" " additional %s after %V\n" "  original: %V\n" "  wrapper: %V" , what , nth , nth , ((i + 1 < extra ) ? "result" : "two results" ) , argv2 [i ] , o , (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ) )
# 3722 "./../src/fun.c"
    ; 
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}


Scheme_Object * scheme_apply_chaperone (Scheme_Object * o , int argc , Scheme_Object * * argv , Scheme_Object * auto_val , int checks ) 


{
  Scheme_Chaperone * px ; 
  Scheme_Object * v , * a [1 ] , * a2 [5 ] , * * argv2 , * post , * result_v , * orig_obj , * app_mark , * self_proc , * simple_call ; 
  int c , i , need_restore = 0 ; 
  int need_pop_mark ; 
  Scheme_Cont_Frame_Data cframe ; 
  const char * __funcarg200 = NULLED_OUT ; 
  const char * __funcarg198 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(19);
  BLOCK_SETUP_TOP((PUSH(self_proc, 0), PUSH(auto_val, 1), PUSH(v, 2), PUSH(post, 3), PUSH(argv2, 4), PUSH(argv, 5), PUSH(simple_call, 6), PUSH(app_mark, 7), PUSH(cframe.cache, 8), PUSH(o, 9), PUSH(result_v, 10), PUSHARRAY(a2, 5, 11), PUSH(orig_obj, 14), PUSH(px, 15), PUSHARRAY(a, 1, 16)));
# define XfOrM607_COUNT (19)
# define SETUP_XfOrM607(x) SETUP(XfOrM607_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  v = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  NULL_OUT_ARRAY (a2 ) ; 
  argv2 = NULLED_OUT ; 
  post = NULLED_OUT ; 
  result_v = NULLED_OUT ; 
  orig_obj = NULLED_OUT ; 
  app_mark = NULLED_OUT ; 
  self_proc = NULLED_OUT ; 
  simple_call = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 3743 "./../src/fun.c"
  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) )  {




    orig_obj = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ; 
    o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ; 
  }

# 3750 "./../src/fun.c"
  else {
    orig_obj = ((void * ) 0 ) ; 
  }
  px = (Scheme_Chaperone * ) o ; 

  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    self_proc = p -> self_for_proc_chaperone ; 
    if (self_proc )
      p -> self_for_proc_chaperone = ((void * ) 0 ) ; 
    else 
    self_proc = o ; 
  }


  if (! ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) ) == (scheme_false ) ) 
  && (argc != (((intptr_t ) ((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) ) >> 1 ) ) ) {
#   define XfOrM671_COUNT (0+XfOrM607_COUNT)
#   define SETUP_XfOrM671(x) SETUP_XfOrM607(x)

# 3767 "./../src/fun.c"
    a [0 ] = px -> prev ; 
    if (! FUNCCALL(SETUP_XfOrM671(_), scheme_check_proc_arity (((void * ) 0 ) , argc , 0 , 0 , a ) )) {
#     define XfOrM672_COUNT (0+XfOrM671_COUNT)
#     define SETUP_XfOrM672(x) SETUP_XfOrM671(x)


      (void ) FUNCCALL(SETUP_XfOrM672(_), scheme_do_eval (px -> prev , argc , argv , - 1 ) ); 
      FUNCCALL(SETUP_XfOrM672(_), scheme_signal_error ("internal error: unexpected success applying chaperoned/proxied procedure" ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }


    (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (argc ) ) ) << 1 ) | 0x1 ) ) ; 
  }

  if ((& (px ) -> iso ) -> so . keyex & 0x2 ) {
#   define XfOrM665_COUNT (0+XfOrM607_COUNT)
#   define SETUP_XfOrM665(x) SETUP_XfOrM607(x)

# 3783 "./../src/fun.c"
    if (auto_val )
      RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
    simple_call = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ; 

    if (((Scheme_Inclhash_Object * ) (px -> redirects ) ) -> so . keyex & 0x1 )  {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> self_for_proc_chaperone = self_proc ; 
    }
    if (checks ) {
#     define XfOrM666_COUNT (0+XfOrM665_COUNT)
#     define SETUP_XfOrM666(x) SETUP_XfOrM665(x)

# 3793 "./../src/fun.c"
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 
      if (checks & 0x1 ) {
#       define XfOrM669_COUNT (0+XfOrM666_COUNT)
#       define SETUP_XfOrM669(x) SETUP_XfOrM666(x)

# 3795 "./../src/fun.c"
        v = FUNCCALL(SETUP_XfOrM669(_), scheme_do_eval (simple_call , argc , argv , 1 ) ); 
      }

# 3796 "./../src/fun.c"
      else if ((Scheme_Type ) (((((intptr_t ) (simple_call ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (simple_call ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) )  {
#       define XfOrM668_COUNT (0+XfOrM666_COUNT)
#       define SETUP_XfOrM668(x) SETUP_XfOrM666(x)

# 3797 "./../src/fun.c"
        v = FUNCCALL(SETUP_XfOrM668(_), _apply_native (simple_call , argc , argv ) ); 
      }

# 3798 "./../src/fun.c"
      else {
#       define XfOrM667_COUNT (0+XfOrM666_COUNT)
#       define SETUP_XfOrM667(x) SETUP_XfOrM666(x)

# 3799 "./../src/fun.c"
        v = FUNCCALL(SETUP_XfOrM667(_), scheme_do_eval (simple_call , argc , argv , - 1 ) ); 
      }
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }

# 3803 "./../src/fun.c"
    else 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM665(_), scheme_tail_apply (simple_call , argc , argv ) )) RET_VALUE_END ; 
  }

  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {
#   define XfOrM662_COUNT (0+XfOrM607_COUNT)
#   define SETUP_XfOrM662(x) SETUP_XfOrM607(x)
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) > XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) {
      -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
      * XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = ((void * ) 0 ) ; 
      need_restore = 1 ; 
    }

# 3814 "./../src/fun.c"
    else {
#     define XfOrM663_COUNT (0+XfOrM662_COUNT)
#     define SETUP_XfOrM663(x) SETUP_XfOrM662(x)

# 3816 "./../src/fun.c"
      argv2 = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM663(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
      (memcpy (argv2 , argv , sizeof (Scheme_Object * ) * argc ) ) ; 
      argv = argv2 ; 
    }
  }

  app_mark = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [2 ] ; 
  if (((app_mark ) ) == (scheme_false ) ) 
    app_mark = ((void * ) 0 ) ; 

  if (app_mark ) {
#   define XfOrM660_COUNT (0+XfOrM607_COUNT)
#   define SETUP_XfOrM660(x) SETUP_XfOrM607(x)

# 3827 "./../src/fun.c"
    v = FUNCCALL(SETUP_XfOrM660(_), scheme_chaperone_get_immediate_cc_mark ((((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . car ) , ((void * ) 0 ) ) ); 
    if (v ) {
#     define XfOrM661_COUNT (0+XfOrM660_COUNT)
#     define SETUP_XfOrM661(x) SETUP_XfOrM660(x)
      FUNCCALL(SETUP_XfOrM661(_), scheme_push_continuation_frame (& cframe ) )
# 3829 "./../src/fun.c"
      ; 
      FUNCCALL(SETUP_XfOrM661(_), scheme_set_cont_mark ((((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . car ) , v ) ); 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 
      need_pop_mark = 1 ; 
    }

# 3833 "./../src/fun.c"
    else 
    need_pop_mark = 0 ; 
  }

# 3835 "./../src/fun.c"
  else 
  need_pop_mark = 0 ; 

  if ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) > 3 ) {
#   define XfOrM657_COUNT (0+XfOrM607_COUNT)
#   define SETUP_XfOrM657(x) SETUP_XfOrM607(x)

# 3840 "./../src/fun.c"
    c = argc + 1 ; 
    if (c <= 5 )
      argv2 = a2 ; 
    else 
    argv2 = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM657(_), GC_malloc (sizeof (Scheme_Object * ) * (5 ) ) )) ; 
    for (i = 0 ; i < argc ; i ++ ) {
      argv2 [i + 1 ] = argv [i ] ; 
    }
    argv2 [0 ] = self_proc ; 
  }

# 3849 "./../src/fun.c"
  else {

    c = argc ; 
    argv2 = argv ; 
  }

  v = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ; 
  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) ) 
    v = FUNCCALL(SETUP_XfOrM607(_), _apply_native (v , c , argv2 ) ); 
  else 
  v = FUNCCALL(SETUP_XfOrM607(_), scheme_do_eval (v , c , argv2 , - 1 ) ); 

  if (v == ((Scheme_Object * ) 0x6 ) ) {
    GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    c = p -> ku . multiple . count ; 
    argv2 = p -> ku . multiple . array ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
    if ((argv2 ) == (p -> values_buffer ) )  {
      if (c <= 5 ) {
        for (i = 0 ; i < c ; i ++ ) {
          a2 [i ] = argv2 [i ] ; 
        }
        argv2 = a2 ; 
      }

# 3872 "./../src/fun.c"
      else {
        p -> values_buffer = ((void * ) 0 ) ; 
      }
    }
  }

# 3876 "./../src/fun.c"
  else {
    c = 1 ; 
    a2 [0 ] = v ; 
    argv2 = a2 ; 
  }

  if (need_pop_mark ) {
#   define XfOrM648_COUNT (0+XfOrM607_COUNT)
#   define SETUP_XfOrM648(x) SETUP_XfOrM607(x)

# 3883 "./../src/fun.c"
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
    FUNCCALL(SETUP_XfOrM648(_), scheme_pop_continuation_frame (& cframe ) ); 
  }

  if (c >= argc ) {
    int need_pop = 0 ; 
#   define XfOrM640_COUNT (0+XfOrM607_COUNT)
#   define SETUP_XfOrM640(x) SETUP_XfOrM607(x)

# 3889 "./../src/fun.c"
    post = FUNCCALL(SETUP_XfOrM640(_), extract_impersonator_results (c , argc , argv2 , (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ? "chaperone" : "impersonator" ) , o , px , & cframe , & need_pop ) )

    ; 
    need_pop_mark = need_pop ; 

    if (c > argc )
      (memmove (argv2 , argv2 + (c - argc ) , sizeof (Scheme_Object * ) * argc ) ) ; 
    if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ) {
#     define XfOrM641_COUNT (0+XfOrM640_COUNT)
#     define SETUP_XfOrM641(x) SETUP_XfOrM640(x)

# 3897 "./../src/fun.c"
      for (i = 0 ; i < argc ; i ++ ) {
#       define XfOrM645_COUNT (0+XfOrM641_COUNT)
#       define SETUP_XfOrM645(x) SETUP_XfOrM641(x)

# 3898 "./../src/fun.c"
        if (! ((argv2 [i ] ) == (argv [i ] ) ) 
        && ! FUNCCALL(SETUP_XfOrM645(_), scheme_chaperone_of (argv2 [i ] , argv [i ] ) )) {
#         define XfOrM646_COUNT (0+XfOrM645_COUNT)
#         define SETUP_XfOrM646(x) SETUP_XfOrM645(x)

# 3900 "./../src/fun.c"
          if (argc == 1 )
            FUNCCALL(SETUP_XfOrM646(_), scheme_wrong_chaperoned ("procedure chaperone" , "argument" , argv [i ] , argv2 [i ] ) ); 
          else {
            char nbuf [32 ] ; 
#           define XfOrM647_COUNT (0+XfOrM646_COUNT)
#           define SETUP_XfOrM647(x) SETUP_XfOrM646(x)
            (__funcarg200 = FUNCCALL(SETUP_XfOrM647(_), scheme_number_suffix (i ) ), (
# 3904 "./../src/fun.c"
            sprintf (nbuf , "%d%s argument" , i , __funcarg200 ) ) ) ; 
            FUNCCALL(SETUP_XfOrM647(_), scheme_wrong_chaperoned ("procedure chaperone" , nbuf , argv [i ] , argv2 [i ] ) ); 
          }
        }
      }
    }
  }

# 3910 "./../src/fun.c"
  else {
#   define XfOrM639_COUNT (0+XfOrM607_COUNT)
#   define SETUP_XfOrM639(x) SETUP_XfOrM607(x)
    FUNCCALL(SETUP_XfOrM639(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "procedure %s: arity mismatch;\n" " expected number of results not received from wrapper on the original\n" " procedure's arguments\n" "  original: %V\n" "  wrapper: %V\n" "  expected: %d or more\n" "  received: %d" , (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ? "chaperone" : "impersonator" ) , o , (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] , argc , c ) )
# 3923 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (need_restore ) {


    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ++ ; 
    for (i = 0 ; i < argc ; i ++ ) {
      argv [i ] = ((void * ) 0 ) ; 
    }
  }

# 3934 "./../src/fun.c"
  else 
  argv = ((void * ) 0 ) ; 

  if (! post ) {
#   define XfOrM628_COUNT (0+XfOrM607_COUNT)
#   define SETUP_XfOrM628(x) SETUP_XfOrM607(x)

# 3939 "./../src/fun.c"
    if (app_mark )
      FUNCCALL(SETUP_XfOrM628(_), scheme_set_cont_mark ((((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . car ) , (((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . cdr ) ) ); 
    if (((Scheme_Inclhash_Object * ) (px -> redirects ) ) -> so . keyex & 0x1 )  {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> self_for_proc_chaperone = self_proc ; 
    }
    if (auto_val ) {
#     define XfOrM634_COUNT (0+XfOrM628_COUNT)
#     define SETUP_XfOrM634(x) SETUP_XfOrM628(x)

# 3946 "./../src/fun.c"
      if (((Scheme_Type ) (((((intptr_t ) (px -> prev ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> prev ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (px -> prev ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> prev ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM634(_), do_apply_chaperone (px -> prev , argc , argv2 , auto_val , 0 ) )) RET_VALUE_END ; 
      else 
      RET_VALUE_START (argv2 [0 ] ) RET_VALUE_END ; 
    }

# 3950 "./../src/fun.c"
    else {
#     define XfOrM629_COUNT (0+XfOrM628_COUNT)
#     define SETUP_XfOrM629(x) SETUP_XfOrM628(x)

# 3951 "./../src/fun.c"
      if (orig_obj )

      orig_obj = FUNCCALL(SETUP_XfOrM629(_), scheme_make_raw_pair (px -> prev , orig_obj ) ); 
      else 
      orig_obj = px -> prev ; 
      if (checks ) {
#       define XfOrM630_COUNT (0+XfOrM629_COUNT)
#       define SETUP_XfOrM630(x) SETUP_XfOrM629(x)

# 3958 "./../src/fun.c"
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 
        if (checks & 0x1 ) {
#         define XfOrM633_COUNT (0+XfOrM630_COUNT)
#         define SETUP_XfOrM633(x) SETUP_XfOrM630(x)

# 3960 "./../src/fun.c"
          v = FUNCCALL(SETUP_XfOrM633(_), scheme_do_eval (orig_obj , argc , argv2 , 1 ) ); 
        }

# 3961 "./../src/fun.c"
        else if ((Scheme_Type ) (((((intptr_t ) (orig_obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_obj ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) )  {
#         define XfOrM632_COUNT (0+XfOrM630_COUNT)
#         define SETUP_XfOrM632(x) SETUP_XfOrM630(x)

# 3962 "./../src/fun.c"
          v = FUNCCALL(SETUP_XfOrM632(_), _apply_native (orig_obj , argc , argv2 ) ); 
        }

# 3963 "./../src/fun.c"
        else {
#         define XfOrM631_COUNT (0+XfOrM630_COUNT)
#         define SETUP_XfOrM631(x) SETUP_XfOrM630(x)

# 3964 "./../src/fun.c"
          v = FUNCCALL(SETUP_XfOrM631(_), scheme_do_eval (orig_obj , argc , argv2 , - 1 ) ); 
        }
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
        RET_VALUE_START (v ) RET_VALUE_END ; 
      }

# 3968 "./../src/fun.c"
      else 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM629(_), scheme_tail_apply (orig_obj , argc , argv2 ) )) RET_VALUE_END ; 
    }
  }

# 3971 "./../src/fun.c"
  else {
#   define XfOrM608_COUNT (0+XfOrM607_COUNT)
#   define SETUP_XfOrM608(x) SETUP_XfOrM607(x)

# 3972 "./../src/fun.c"
    if (app_mark ) {
#     define XfOrM627_COUNT (0+XfOrM608_COUNT)
#     define SETUP_XfOrM627(x) SETUP_XfOrM608(x)

# 3973 "./../src/fun.c"
      if (! need_pop_mark )
        FUNCCALL(SETUP_XfOrM627(_), scheme_push_continuation_frame (& cframe ) ); 
      FUNCCALL(SETUP_XfOrM627(_), scheme_set_cont_mark ((((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . car ) , (((Scheme_Simple_Object * ) (app_mark ) ) -> u . pair_val . cdr ) ) ); 
      need_pop_mark = 1 ; 
    }

# 3977 "./../src/fun.c"
    else 
    need_pop_mark = 0 ; 

    if (need_pop_mark )
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 

    if (((Scheme_Inclhash_Object * ) (px -> redirects ) ) -> so . keyex & 0x1 )  {

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> self_for_proc_chaperone = self_proc ; 
    }

    if (auto_val ) {
#     define XfOrM625_COUNT (0+XfOrM608_COUNT)
#     define SETUP_XfOrM625(x) SETUP_XfOrM608(x)

# 3989 "./../src/fun.c"
      if (((Scheme_Type ) (((((intptr_t ) (px -> prev ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> prev ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (px -> prev ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> prev ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
        result_v = FUNCCALL(SETUP_XfOrM625(_), do_apply_chaperone (px -> prev , argc , argv2 , auto_val , 0 ) ); 
      else 
      result_v = argv2 [0 ] ; 
      v = auto_val ; 
    }

# 3994 "./../src/fun.c"
    else {
#     define XfOrM624_COUNT (0+XfOrM608_COUNT)
#     define SETUP_XfOrM624(x) SETUP_XfOrM608(x)

# 3995 "./../src/fun.c"
      if (orig_obj )

      orig_obj = FUNCCALL(SETUP_XfOrM624(_), scheme_make_raw_pair (px -> prev , orig_obj ) ); 
      else 
      orig_obj = px -> prev ; 
      if ((Scheme_Type ) (((((intptr_t ) (orig_obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (orig_obj ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) ) 
        v = FUNCCALL(SETUP_XfOrM624(_), _apply_native (orig_obj , argc , argv2 ) ); 
      else 
      v = FUNCCALL(SETUP_XfOrM624(_), scheme_do_eval (orig_obj , argc , argv2 , - 1 ) ); 
      result_v = ((void * ) 0 ) ; 
    }

    if (v == ((Scheme_Object * ) 0x6 ) ) {
      GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
        p -> values_buffer = ((void * ) 0 ) ; 
      c = p -> ku . multiple . count ; 
      argv = p -> ku . multiple . array ; 
      p -> ku . multiple . array = ((void * ) 0 ) ; 
    }

# 4014 "./../src/fun.c"
    else {
      c = 1 ; 
      a [0 ] = v ; 
      argv = a ; 
    }

    if (need_pop_mark ) {
#     define XfOrM621_COUNT (0+XfOrM608_COUNT)
#     define SETUP_XfOrM621(x) SETUP_XfOrM608(x)

# 4021 "./../src/fun.c"
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
      FUNCCALL(SETUP_XfOrM621(_), scheme_pop_continuation_frame (& cframe ) ); 
    }

    if (! FUNCCALL(SETUP_XfOrM608(_), scheme_check_proc_arity (((void * ) 0 ) , c , 0 , - 1 , & post ) ))
      FUNCCALL(SETUP_XfOrM608(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT , "procedure-result %s: arity mismatch;\n" " wrapper does not accept the number of values produced by\n" " the original procedure\n" "  original: %V\n" "  wrapper: %V\n" "  number of values: %d" , (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ? "chaperone" : "impersonator" ) , o , post , c ) )
# 4036 "./../src/fun.c"
    ; 

    if ((Scheme_Type ) (((((intptr_t ) (post ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (post ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) ) 
      v = FUNCCALL(SETUP_XfOrM608(_), _apply_native (post , c , argv ) ); 
    else 
    v = FUNCCALL(SETUP_XfOrM608(_), scheme_do_eval (post , c , argv , - 1 ) ); 
    if (v == ((Scheme_Object * ) 0x6 ) ) {
      GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
        p -> values_buffer = ((void * ) 0 ) ; 
      argc = p -> ku . multiple . count ; 
      argv2 = p -> ku . multiple . array ; 
      p -> ku . multiple . array = ((void * ) 0 ) ; 
    }

# 4049 "./../src/fun.c"
    else {
      argc = 1 ; 
      a2 [0 ] = v ; 
      argv2 = a2 ; 
    }

    if (c == argc ) {
#     define XfOrM611_COUNT (0+XfOrM608_COUNT)
#     define SETUP_XfOrM611(x) SETUP_XfOrM608(x)

# 4056 "./../src/fun.c"
      if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ) {
#       define XfOrM612_COUNT (0+XfOrM611_COUNT)
#       define SETUP_XfOrM612(x) SETUP_XfOrM611(x)

# 4057 "./../src/fun.c"
        for (i = 0 ; i < argc ; i ++ ) {
#         define XfOrM616_COUNT (0+XfOrM612_COUNT)
#         define SETUP_XfOrM616(x) SETUP_XfOrM612(x)

# 4058 "./../src/fun.c"
          if (! ((argv2 [i ] ) == (argv [i ] ) ) 
          && ! FUNCCALL(SETUP_XfOrM616(_), scheme_chaperone_of (argv2 [i ] , argv [i ] ) )) {
#           define XfOrM617_COUNT (0+XfOrM616_COUNT)
#           define SETUP_XfOrM617(x) SETUP_XfOrM616(x)

# 4060 "./../src/fun.c"
            if (argc == 1 )
              FUNCCALL(SETUP_XfOrM617(_), scheme_wrong_chaperoned ("procedure-result chaperone" , "result" , argv [i ] , argv2 [i ] ) ); 
            else {
              char nbuf [32 ] ; 
#             define XfOrM618_COUNT (0+XfOrM617_COUNT)
#             define SETUP_XfOrM618(x) SETUP_XfOrM617(x)
              (__funcarg198 = FUNCCALL(SETUP_XfOrM618(_), scheme_number_suffix (i ) ), (
# 4064 "./../src/fun.c"
              sprintf (nbuf , "%d%s result" , i , __funcarg198 ) ) ) ; 
              FUNCCALL(SETUP_XfOrM618(_), scheme_wrong_chaperoned ("procedure-result chaperone" , nbuf , argv [i ] , argv2 [i ] ) ); 
            }
          }
        }
      }
    }

# 4070 "./../src/fun.c"
    else {
#     define XfOrM610_COUNT (0+XfOrM608_COUNT)
#     define SETUP_XfOrM610(x) SETUP_XfOrM608(x)
      FUNCCALL(SETUP_XfOrM610(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "procedure-result %s: result arity mismatch;\n" " expected number of values not received from wrapper on the original\n" " procedure's result\n" "  original: %V\n" "  wrapper: %V\n" "  expected: %d\n" "  received: %d" , (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ? "chaperone" : "impersonator" ) , o , post , c , argc ) )








      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    if (result_v )
      RET_VALUE_START (result_v ) RET_VALUE_END ; 
    else if (c == 1 )
      RET_VALUE_START (argv2 [0 ] ) RET_VALUE_END ; 
    else {
#     define XfOrM609_COUNT (0+XfOrM608_COUNT)
#     define SETUP_XfOrM609(x) SETUP_XfOrM608(x)

# 4091 "./../src/fun.c"
      if (checks & 0x1 )
        FUNCCALL(SETUP_XfOrM609(_), scheme_wrong_return_arity (((void * ) 0 ) , 1 , c , argv2 , ((void * ) 0 ) ) ); 
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM609(_), scheme_values (c , argv2 ) )) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4098 "./../src/fun.c"
static Scheme_Object * 
apply (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * rands ; 
  Scheme_Object * * rand_vec ; 
  int i , num_rands ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(argv, 1), PUSH(rand_vec, 2), PUSH(rands, 3)));
# define XfOrM676_COUNT (4)
# define SETUP_XfOrM676(x) SETUP(XfOrM676_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  rands = NULLED_OUT ; 
  rand_vec = NULLED_OUT ; 

# 4106 "./../src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
#   define XfOrM683_COUNT (0+XfOrM676_COUNT)
#   define SETUP_XfOrM683(x) SETUP_XfOrM676(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("apply" , "procedure?" , 0 , argc , argv ) )
# 4107 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  rands = argv [argc - 1 ] ; 

  num_rands = (scheme_proper_list_length (rands ) ) ; 
  if (num_rands < 0 ) {
#   define XfOrM682_COUNT (0+XfOrM676_COUNT)
#   define SETUP_XfOrM682(x) SETUP_XfOrM676(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("apply" , "list?" , argc - 1 , argc , argv ) )
# 4115 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  num_rands += (argc - 2 ) ; 

  if (num_rands > p -> tail_buffer_size ) {
#   define XfOrM681_COUNT (0+XfOrM676_COUNT)
#   define SETUP_XfOrM681(x) SETUP_XfOrM676(x)

# 4121 "./../src/fun.c"
    rand_vec = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM681(_), GC_malloc (sizeof (Scheme_Object * ) * (num_rands ) ) )) ; 
  }
  else 
  rand_vec = p -> tail_buffer ; 

  for (i = argc - 2 ; i -- ; ) {
    rand_vec [i ] = argv [i + 1 ] ; 
  }

  for (i = argc - 2 ; ((Scheme_Type ) (((((intptr_t ) (rands ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rands ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; i ++ , rands = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . cdr ) ) {
    rand_vec [i ] = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . car ) ; 
  }

  p -> ku . apply . tail_rator = argv [0 ] ; 
  p -> ku . apply . tail_rands = rand_vec ; 
  p -> ku . apply . tail_num_rands = num_rands ; 

  RET_VALUE_START (((Scheme_Object * ) 0x4 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 13 "./../src/schmap.inc"
static Scheme_Object * 
map (int argc , Scheme_Object * argv [] ) 
{


  int i , size = 0 , l , pos , pop_runstack = 0 ; 
  Scheme_Object * quick1 [3 ] , * quick2 [3 ] ; 
  Scheme_Object * * working , * * args ; 

  Scheme_Object * quick3 [5 ] , * * resarray ; 


  Scheme_Object * v ; 

  Scheme_Object * proc ; 
  int cc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(v, 1), PUSH(resarray, 2), PUSH(argv, 3), PUSH(args, 4), PUSH(working, 5), PUSHARRAY(quick1, 3, 6), PUSHARRAY(quick3, 5, 9), PUSHARRAY(quick2, 3, 12)));
# define XfOrM684_COUNT (15)
# define SETUP_XfOrM684(x) SETUP(XfOrM684_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  quick1[0] = NULLED_OUT ; 
  quick1[1] = NULLED_OUT ; 
  quick1[2] = NULLED_OUT ; 
  quick2[0] = NULLED_OUT ; 
  quick2[1] = NULLED_OUT ; 
  quick2[2] = NULLED_OUT ; 
  working = NULLED_OUT ; 
  args = NULLED_OUT ; 
  NULL_OUT_ARRAY (quick3 ) ; 
  resarray = NULLED_OUT ; 
  v = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 30 "./../src/schmap.inc"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL(SETUP_XfOrM684(_), scheme_wrong_contract ("map" , "procedure?" , 0 , argc , argv ) ); 

  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM710_COUNT (0+XfOrM684_COUNT)
#   define SETUP_XfOrM710(x) SETUP_XfOrM684(x)

# 34 "./../src/schmap.inc"
    l = (scheme_proper_list_length (argv [i ] ) ) ; 

    if (l < 0 )
      FUNCCALL(SETUP_XfOrM710(_), scheme_wrong_contract ("map" , "list?" , i , argc , argv ) ); 

    if (i == 1 )
      size = l ; 
    else if (size != l ) {
      char * argstr ; 
      intptr_t alen ; 
      BLOCK_SETUP((PUSH(argstr, 0+XfOrM710_COUNT)));
#     define XfOrM711_COUNT (1+XfOrM710_COUNT)
#     define SETUP_XfOrM711(x) SETUP(XfOrM711_COUNT)
      argstr = NULLED_OUT ; 

# 45 "./../src/schmap.inc"
      argstr = FUNCCALL(SETUP_XfOrM711(_), scheme_make_args_string ("" , - 1 , argc , argv , & alen ) ); 
      FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: all lists must have same size%t" , "map" , argstr , alen ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((FUNCCALL(SETUP_XfOrM684(_), scheme_get_or_check_arity (argv [0 ] , argc - 1 ) )) ) == (scheme_false ) )  {
    char * s ; 
    intptr_t aelen ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM684_COUNT)));
#   define XfOrM707_COUNT (1+XfOrM684_COUNT)
#   define SETUP_XfOrM707(x) SETUP(XfOrM707_COUNT)
    s = NULLED_OUT ; 

# 58 "./../src/schmap.inc"
    s = FUNCCALL(SETUP_XfOrM707(_), scheme_make_arity_expect_string ("map" , argv [0 ] , argc - 1 , ((void * ) 0 ) , & aelen ) ); 
    FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%t" , s , aelen ) )


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {




    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 72 "./../src/schmap.inc"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - (argc - 1 ) >= (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + 5 ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) -= (argc - 1 ) ; 
    pop_runstack = 1 ; 
    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 76 "./../src/schmap.inc"
  else if (argc <= (3 + 1 ) ) {
    args = quick1 ; 
  }

# 78 "./../src/schmap.inc"
  else {
#   define XfOrM703_COUNT (0+XfOrM684_COUNT)
#   define SETUP_XfOrM703(x) SETUP_XfOrM684(x)

# 79 "./../src/schmap.inc"
    args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM703(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }

  if (argc <= (3 + 1 ) ) {
    working = quick2 ; 
  }

# 84 "./../src/schmap.inc"
  else {
#   define XfOrM701_COUNT (0+XfOrM684_COUNT)
#   define SETUP_XfOrM701(x) SETUP_XfOrM684(x)

# 85 "./../src/schmap.inc"
    working = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM701(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }


  if (size <= 5 )
    resarray = quick3 ; 
  else 
  resarray = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM684(_), GC_malloc (sizeof (Scheme_Object * ) * (size ) ) )) ; 



  for (i = 1 ; i < argc ; i ++ ) {
    working [i - 1 ] = argv [i ] ; 
    if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {

      argv [i ] = ((void * ) 0 ) ; 
    }
  }

  -- argc ; 
  proc = argv [0 ] ; 
  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) )
    argv [0 ] = ((void * ) 0 ) ; 
  argv = ((void * ) 0 ) ; 

  pos = 0 ; 
  while (pos < size ) {
#   define XfOrM691_COUNT (0+XfOrM684_COUNT)
#   define SETUP_XfOrM691(x) SETUP_XfOrM684(x)

# 113 "./../src/schmap.inc"
    for (i = 0 ; i < argc ; i ++ ) {

# 124 "./../src/schmap.inc"
      args [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . car ) ; 


      working [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . cdr ) ; 
    }

    cc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 


    v = FUNCCALL(SETUP_XfOrM691(_), scheme_do_eval (proc , argc , args , 1 ) ); 

# 149 "./../src/schmap.inc"
    if (cc != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM692_COUNT (0+XfOrM691_COUNT)
#     define SETUP_XfOrM692(x) SETUP_XfOrM691(x)
      if (size > 5 ) {
        Scheme_Object * * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM692_COUNT)));
#       define XfOrM694_COUNT (1+XfOrM692_COUNT)
#       define SETUP_XfOrM694(x) SETUP(XfOrM694_COUNT)
        naya = NULLED_OUT ; 

# 154 "./../src/schmap.inc"
        naya = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM694(_), GC_malloc (sizeof (Scheme_Object * ) * (size ) ) )) ; 
        (memcpy (naya , resarray , pos * sizeof (Scheme_Object * ) ) ) ; 
        resarray = naya ; 
      }

      if ((argc > 3 ) && (pos + 1 < size ) ) {
        Scheme_Object * * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM692_COUNT)));
#       define XfOrM693_COUNT (1+XfOrM692_COUNT)
#       define SETUP_XfOrM693(x) SETUP(XfOrM693_COUNT)
        naya = NULLED_OUT ; 

# 161 "./../src/schmap.inc"
        args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM693(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        naya = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM693(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        (memcpy (naya , working , argc * sizeof (Scheme_Object * ) ) ) ; 
        working = naya ; 
      }
    }


    resarray [pos ] = v ; 

# 185 "./../src/schmap.inc"
    pos ++ ; 
  }

  if (pop_runstack )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 


  RET_VALUE_START (FUNCCALL(SETUP_XfOrM684(_), scheme_build_list (size , resarray ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 13 "./../src/schmap.inc"
static Scheme_Object * 
for_each (int argc , Scheme_Object * argv [] ) 
{


  int i , size = 0 , l , pos , pop_runstack = 0 ; 
  Scheme_Object * quick1 [3 ] , * quick2 [3 ] ; 
  Scheme_Object * * working , * * args ; 






  Scheme_Object * proc ; 
  int cc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(working, 1), PUSHARRAY(quick1, 3, 2), PUSH(args, 5), PUSHARRAY(quick2, 3, 6), PUSH(argv, 9)));
# define XfOrM712_COUNT (10)
# define SETUP_XfOrM712(x) SETUP(XfOrM712_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  quick1[0] = NULLED_OUT ; 
  quick1[1] = NULLED_OUT ; 
  quick1[2] = NULLED_OUT ; 
  quick2[0] = NULLED_OUT ; 
  quick2[1] = NULLED_OUT ; 
  quick2[2] = NULLED_OUT ; 
  working = NULLED_OUT ; 
  args = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 30 "./../src/schmap.inc"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL(SETUP_XfOrM712(_), scheme_wrong_contract ("for-each" , "procedure?" , 0 , argc , argv ) ); 

  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM736_COUNT (0+XfOrM712_COUNT)
#   define SETUP_XfOrM736(x) SETUP_XfOrM712(x)

# 34 "./../src/schmap.inc"
    l = (scheme_proper_list_length (argv [i ] ) ) ; 

    if (l < 0 )
      FUNCCALL(SETUP_XfOrM736(_), scheme_wrong_contract ("for-each" , "list?" , i , argc , argv ) ); 

    if (i == 1 )
      size = l ; 
    else if (size != l ) {
      char * argstr ; 
      intptr_t alen ; 
      BLOCK_SETUP((PUSH(argstr, 0+XfOrM736_COUNT)));
#     define XfOrM737_COUNT (1+XfOrM736_COUNT)
#     define SETUP_XfOrM737(x) SETUP(XfOrM737_COUNT)
      argstr = NULLED_OUT ; 

# 45 "./../src/schmap.inc"
      argstr = FUNCCALL(SETUP_XfOrM737(_), scheme_make_args_string ("" , - 1 , argc , argv , & alen ) ); 
      FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: all lists must have same size%t" , "for-each" , argstr , alen ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((FUNCCALL(SETUP_XfOrM712(_), scheme_get_or_check_arity (argv [0 ] , argc - 1 ) )) ) == (scheme_false ) )  {
    char * s ; 
    intptr_t aelen ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM712_COUNT)));
#   define XfOrM733_COUNT (1+XfOrM712_COUNT)
#   define SETUP_XfOrM733(x) SETUP(XfOrM733_COUNT)
    s = NULLED_OUT ; 

# 58 "./../src/schmap.inc"
    s = FUNCCALL(SETUP_XfOrM733(_), scheme_make_arity_expect_string ("for-each" , argv [0 ] , argc - 1 , ((void * ) 0 ) , & aelen ) ); 
    FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%t" , s , aelen ) )


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {




    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 72 "./../src/schmap.inc"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - (argc - 1 ) >= (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + 5 ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) -= (argc - 1 ) ; 
    pop_runstack = 1 ; 
    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 76 "./../src/schmap.inc"
  else if (argc <= (3 + 1 ) ) {
    args = quick1 ; 
  }

# 78 "./../src/schmap.inc"
  else {
#   define XfOrM729_COUNT (0+XfOrM712_COUNT)
#   define SETUP_XfOrM729(x) SETUP_XfOrM712(x)

# 79 "./../src/schmap.inc"
    args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM729(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }

  if (argc <= (3 + 1 ) ) {
    working = quick2 ; 
  }

# 84 "./../src/schmap.inc"
  else {
#   define XfOrM727_COUNT (0+XfOrM712_COUNT)
#   define SETUP_XfOrM727(x) SETUP_XfOrM712(x)

# 85 "./../src/schmap.inc"
    working = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM727(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }









  for (i = 1 ; i < argc ; i ++ ) {
    working [i - 1 ] = argv [i ] ; 
    if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {

      argv [i ] = ((void * ) 0 ) ; 
    }
  }

  -- argc ; 
  proc = argv [0 ] ; 
  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) )
    argv [0 ] = ((void * ) 0 ) ; 
  argv = ((void * ) 0 ) ; 

  pos = 0 ; 
  while (pos < size ) {
#   define XfOrM718_COUNT (0+XfOrM712_COUNT)
#   define SETUP_XfOrM718(x) SETUP_XfOrM712(x)

# 113 "./../src/schmap.inc"
    for (i = 0 ; i < argc ; i ++ ) {

# 124 "./../src/schmap.inc"
      args [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . car ) ; 


      working [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . cdr ) ; 
    }

    cc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 
    FUNCCALL(SETUP_XfOrM718(_), scheme_do_eval (proc , argc , args , - 1 ) )




    ; 

# 149 "./../src/schmap.inc"
    if (cc != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM719_COUNT (0+XfOrM718_COUNT)
#     define SETUP_XfOrM719(x) SETUP_XfOrM718(x)







      if ((argc > 3 ) && (pos + 1 < size ) ) {
        Scheme_Object * * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM719_COUNT)));
#       define XfOrM720_COUNT (1+XfOrM719_COUNT)
#       define SETUP_XfOrM720(x) SETUP(XfOrM720_COUNT)
        naya = NULLED_OUT ; 

# 161 "./../src/schmap.inc"
        args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM720(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        naya = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM720(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        (memcpy (naya , working , argc * sizeof (Scheme_Object * ) ) ) ; 
        working = naya ; 
      }
    }

# 185 "./../src/schmap.inc"
    pos ++ ; 
  }

  if (pop_runstack )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 





  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 13 "./../src/schmap.inc"
static Scheme_Object * 
andmap (int argc , Scheme_Object * argv [] ) 
{


  int i , size = 0 , l , pos , pop_runstack = 0 ; 
  Scheme_Object * quick1 [3 ] , * quick2 [3 ] ; 
  Scheme_Object * * working , * * args ; 




  Scheme_Object * v ; 

  Scheme_Object * proc ; 
  int cc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(v, 1), PUSHARRAY(quick1, 3, 2), PUSH(argv, 5), PUSH(args, 6), PUSH(working, 7), PUSHARRAY(quick2, 3, 8)));
# define XfOrM738_COUNT (11)
# define SETUP_XfOrM738(x) SETUP(XfOrM738_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  quick1[0] = NULLED_OUT ; 
  quick1[1] = NULLED_OUT ; 
  quick1[2] = NULLED_OUT ; 
  quick2[0] = NULLED_OUT ; 
  quick2[1] = NULLED_OUT ; 
  quick2[2] = NULLED_OUT ; 
  working = NULLED_OUT ; 
  args = NULLED_OUT ; 
  v = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 30 "./../src/schmap.inc"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL(SETUP_XfOrM738(_), scheme_wrong_contract ("andmap" , "procedure?" , 0 , argc , argv ) ); 

  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM768_COUNT (0+XfOrM738_COUNT)
#   define SETUP_XfOrM768(x) SETUP_XfOrM738(x)

# 34 "./../src/schmap.inc"
    l = (scheme_proper_list_length (argv [i ] ) ) ; 

    if (l < 0 )
      FUNCCALL(SETUP_XfOrM768(_), scheme_wrong_contract ("andmap" , "list?" , i , argc , argv ) ); 

    if (i == 1 )
      size = l ; 
    else if (size != l ) {
      char * argstr ; 
      intptr_t alen ; 
      BLOCK_SETUP((PUSH(argstr, 0+XfOrM768_COUNT)));
#     define XfOrM769_COUNT (1+XfOrM768_COUNT)
#     define SETUP_XfOrM769(x) SETUP(XfOrM769_COUNT)
      argstr = NULLED_OUT ; 

# 45 "./../src/schmap.inc"
      argstr = FUNCCALL(SETUP_XfOrM769(_), scheme_make_args_string ("" , - 1 , argc , argv , & alen ) ); 
      FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: all lists must have same size%t" , "andmap" , argstr , alen ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((FUNCCALL(SETUP_XfOrM738(_), scheme_get_or_check_arity (argv [0 ] , argc - 1 ) )) ) == (scheme_false ) )  {
    char * s ; 
    intptr_t aelen ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM738_COUNT)));
#   define XfOrM765_COUNT (1+XfOrM738_COUNT)
#   define SETUP_XfOrM765(x) SETUP(XfOrM765_COUNT)
    s = NULLED_OUT ; 

# 58 "./../src/schmap.inc"
    s = FUNCCALL(SETUP_XfOrM765(_), scheme_make_arity_expect_string ("andmap" , argv [0 ] , argc - 1 , ((void * ) 0 ) , & aelen ) ); 
    FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%t" , s , aelen ) )


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {




    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 72 "./../src/schmap.inc"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - (argc - 1 ) >= (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + 5 ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) -= (argc - 1 ) ; 
    pop_runstack = 1 ; 
    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 76 "./../src/schmap.inc"
  else if (argc <= (3 + 1 ) ) {
    args = quick1 ; 
  }

# 78 "./../src/schmap.inc"
  else {
#   define XfOrM761_COUNT (0+XfOrM738_COUNT)
#   define SETUP_XfOrM761(x) SETUP_XfOrM738(x)

# 79 "./../src/schmap.inc"
    args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM761(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }

  if (argc <= (3 + 1 ) ) {
    working = quick2 ; 
  }

# 84 "./../src/schmap.inc"
  else {
#   define XfOrM759_COUNT (0+XfOrM738_COUNT)
#   define SETUP_XfOrM759(x) SETUP_XfOrM738(x)

# 85 "./../src/schmap.inc"
    working = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM759(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }









  for (i = 1 ; i < argc ; i ++ ) {
    working [i - 1 ] = argv [i ] ; 
    if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {

      argv [i ] = ((void * ) 0 ) ; 
    }
  }

  -- argc ; 
  proc = argv [0 ] ; 
  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) )
    argv [0 ] = ((void * ) 0 ) ; 
  argv = ((void * ) 0 ) ; 

  pos = 0 ; 
  while (pos < size ) {
#   define XfOrM747_COUNT (0+XfOrM738_COUNT)
#   define SETUP_XfOrM747(x) SETUP_XfOrM738(x)

# 113 "./../src/schmap.inc"
    for (i = 0 ; i < argc ; i ++ ) {

# 124 "./../src/schmap.inc"
      args [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . car ) ; 


      working [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . cdr ) ; 
    }

    cc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 







    if (pos + 1 == size ) {
#     define XfOrM752_COUNT (0+XfOrM747_COUNT)
#     define SETUP_XfOrM752(x) SETUP_XfOrM747(x)

# 139 "./../src/schmap.inc"
      v = FUNCCALL(SETUP_XfOrM752(_), scheme_tail_apply (proc , argc , args ) ); 
      if (pop_runstack )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }

# 143 "./../src/schmap.inc"
    else {
#     define XfOrM751_COUNT (0+XfOrM747_COUNT)
#     define SETUP_XfOrM751(x) SETUP_XfOrM747(x)

# 144 "./../src/schmap.inc"
      v = FUNCCALL(SETUP_XfOrM751(_), scheme_do_eval (proc , argc , args , 1 ) ); 
    }



    if (cc != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM749_COUNT (0+XfOrM747_COUNT)
#     define SETUP_XfOrM749(x) SETUP_XfOrM747(x)







      if ((argc > 3 ) && (pos + 1 < size ) ) {
        Scheme_Object * * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM749_COUNT)));
#       define XfOrM750_COUNT (1+XfOrM749_COUNT)
#       define SETUP_XfOrM750(x) SETUP(XfOrM750_COUNT)
        naya = NULLED_OUT ; 

# 161 "./../src/schmap.inc"
        args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM750(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        naya = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM750(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        (memcpy (naya , working , argc * sizeof (Scheme_Object * ) ) ) ; 
        working = naya ; 
      }
    }





    if (((v ) ) == (scheme_false ) )  {
      if (pop_runstack )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }








    pos ++ ; 
  }

  if (pop_runstack )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 








  RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 13 "./../src/schmap.inc"
static Scheme_Object * 
ormap (int argc , Scheme_Object * argv [] ) 
{


  int i , size = 0 , l , pos , pop_runstack = 0 ; 
  Scheme_Object * quick1 [3 ] , * quick2 [3 ] ; 
  Scheme_Object * * working , * * args ; 




  Scheme_Object * v ; 

  Scheme_Object * proc ; 
  int cc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(v, 1), PUSHARRAY(quick1, 3, 2), PUSH(argv, 5), PUSH(args, 6), PUSH(working, 7), PUSHARRAY(quick2, 3, 8)));
# define XfOrM770_COUNT (11)
# define SETUP_XfOrM770(x) SETUP(XfOrM770_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  quick1[0] = NULLED_OUT ; 
  quick1[1] = NULLED_OUT ; 
  quick1[2] = NULLED_OUT ; 
  quick2[0] = NULLED_OUT ; 
  quick2[1] = NULLED_OUT ; 
  quick2[2] = NULLED_OUT ; 
  working = NULLED_OUT ; 
  args = NULLED_OUT ; 
  v = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 30 "./../src/schmap.inc"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL(SETUP_XfOrM770(_), scheme_wrong_contract ("ormap" , "procedure?" , 0 , argc , argv ) ); 

  for (i = 1 ; i < argc ; i ++ ) {
#   define XfOrM800_COUNT (0+XfOrM770_COUNT)
#   define SETUP_XfOrM800(x) SETUP_XfOrM770(x)

# 34 "./../src/schmap.inc"
    l = (scheme_proper_list_length (argv [i ] ) ) ; 

    if (l < 0 )
      FUNCCALL(SETUP_XfOrM800(_), scheme_wrong_contract ("ormap" , "list?" , i , argc , argv ) ); 

    if (i == 1 )
      size = l ; 
    else if (size != l ) {
      char * argstr ; 
      intptr_t alen ; 
      BLOCK_SETUP((PUSH(argstr, 0+XfOrM800_COUNT)));
#     define XfOrM801_COUNT (1+XfOrM800_COUNT)
#     define SETUP_XfOrM801(x) SETUP(XfOrM801_COUNT)
      argstr = NULLED_OUT ; 

# 45 "./../src/schmap.inc"
      argstr = FUNCCALL(SETUP_XfOrM801(_), scheme_make_args_string ("" , - 1 , argc , argv , & alen ) ); 
      FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: all lists must have same size%t" , "ormap" , argstr , alen ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((FUNCCALL(SETUP_XfOrM770(_), scheme_get_or_check_arity (argv [0 ] , argc - 1 ) )) ) == (scheme_false ) )  {
    char * s ; 
    intptr_t aelen ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM770_COUNT)));
#   define XfOrM797_COUNT (1+XfOrM770_COUNT)
#   define SETUP_XfOrM797(x) SETUP(XfOrM797_COUNT)
    s = NULLED_OUT ; 

# 58 "./../src/schmap.inc"
    s = FUNCCALL(SETUP_XfOrM797(_), scheme_make_arity_expect_string ("ormap" , argv [0 ] , argc - 1 , ((void * ) 0 ) , & aelen ) ); 
    FUNCCALL_AGAIN(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%t" , s , aelen ) )


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {




    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 72 "./../src/schmap.inc"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - (argc - 1 ) >= (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + 5 ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) -= (argc - 1 ) ; 
    pop_runstack = 1 ; 
    args = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ; 
  }

# 76 "./../src/schmap.inc"
  else if (argc <= (3 + 1 ) ) {
    args = quick1 ; 
  }

# 78 "./../src/schmap.inc"
  else {
#   define XfOrM793_COUNT (0+XfOrM770_COUNT)
#   define SETUP_XfOrM793(x) SETUP_XfOrM770(x)

# 79 "./../src/schmap.inc"
    args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM793(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }

  if (argc <= (3 + 1 ) ) {
    working = quick2 ; 
  }

# 84 "./../src/schmap.inc"
  else {
#   define XfOrM791_COUNT (0+XfOrM770_COUNT)
#   define SETUP_XfOrM791(x) SETUP_XfOrM770(x)

# 85 "./../src/schmap.inc"
    working = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM791(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
  }









  for (i = 1 ; i < argc ; i ++ ) {
    working [i - 1 ] = argv [i ] ; 
    if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {

      argv [i ] = ((void * ) 0 ) ; 
    }
  }

  -- argc ; 
  proc = argv [0 ] ; 
  if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) )
    argv [0 ] = ((void * ) 0 ) ; 
  argv = ((void * ) 0 ) ; 

  pos = 0 ; 
  while (pos < size ) {
#   define XfOrM779_COUNT (0+XfOrM770_COUNT)
#   define SETUP_XfOrM779(x) SETUP_XfOrM770(x)

# 113 "./../src/schmap.inc"
    for (i = 0 ; i < argc ; i ++ ) {

# 124 "./../src/schmap.inc"
      args [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . car ) ; 


      working [i ] = (((Scheme_Simple_Object * ) (working [i ] ) ) -> u . pair_val . cdr ) ; 
    }

    cc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 







    if (pos + 1 == size ) {
#     define XfOrM784_COUNT (0+XfOrM779_COUNT)
#     define SETUP_XfOrM784(x) SETUP_XfOrM779(x)

# 139 "./../src/schmap.inc"
      v = FUNCCALL(SETUP_XfOrM784(_), scheme_tail_apply (proc , argc , args ) ); 
      if (pop_runstack )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }

# 143 "./../src/schmap.inc"
    else {
#     define XfOrM783_COUNT (0+XfOrM779_COUNT)
#     define SETUP_XfOrM783(x) SETUP_XfOrM779(x)

# 144 "./../src/schmap.inc"
      v = FUNCCALL(SETUP_XfOrM783(_), scheme_do_eval (proc , argc , args , 1 ) ); 
    }



    if (cc != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM781_COUNT (0+XfOrM779_COUNT)
#     define SETUP_XfOrM781(x) SETUP_XfOrM779(x)







      if ((argc > 3 ) && (pos + 1 < size ) ) {
        Scheme_Object * * naya ; 
        BLOCK_SETUP((PUSH(naya, 0+XfOrM781_COUNT)));
#       define XfOrM782_COUNT (1+XfOrM781_COUNT)
#       define SETUP_XfOrM782(x) SETUP(XfOrM782_COUNT)
        naya = NULLED_OUT ; 

# 161 "./../src/schmap.inc"
        args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM782(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        naya = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM782(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
        (memcpy (naya , working , argc * sizeof (Scheme_Object * ) ) ) ; 
        working = naya ; 
      }
    }

# 179 "./../src/schmap.inc"
    if (! (((v ) ) == (scheme_false ) ) )  {
      if (pop_runstack )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }

    pos ++ ; 
  }

  if (pop_runstack )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) += argc ; 

# 201 "./../src/schmap.inc"
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4173 "./../src/fun.c"
static Scheme_Object * call_with_values (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread * p ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(v, 1), PUSH(argv, 2)));
# define XfOrM802_COUNT (3)
# define SETUP_XfOrM802(x) SETUP(XfOrM802_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  v = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM802(_), scheme_check_proc_arity ("call-with-values" , 0 , 0 , argc , argv ) )
# 4178 "./../src/fun.c"
  ; 
  if (! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("call-with-values" , "procedure?" , 1 , argc , argv ) ); 

  v = FUNCCALL(SETUP_XfOrM802(_), scheme_do_eval (argv [0 ] , 0 , ((void * ) 0 ) , - 1 ) ); 
  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
    int n ; 
    Scheme_Object * * a ; 
    a = NULLED_OUT ; 

# 4187 "./../src/fun.c"
    if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
    n = p -> ku . multiple . count ; 
    a = p -> ku . multiple . array ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
    p -> ku . apply . tail_num_rands = n ; 
    p -> ku . apply . tail_rands = a ; 
  }

# 4194 "./../src/fun.c"
  else {
    p -> ku . apply . tail_num_rands = 1 ; 
    p -> ku . apply . tail_rands = p -> tail_buffer ; 
    p -> ku . apply . tail_rands [0 ] = v ; 
  }

  p -> ku . apply . tail_rator = argv [1 ] ; 

  RET_VALUE_START (((Scheme_Object * ) 0x4 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4205 "./../src/fun.c"
static inline Scheme_Object * values_slow (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * * a ; 
  int i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(a, 1), PUSH(argv, 2)));
# define XfOrM805_COUNT (3)
# define SETUP_XfOrM805(x) SETUP(XfOrM805_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 4211 "./../src/fun.c"
  a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM805(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
  p -> values_buffer = a ; 
  p -> values_buffer_size = argc ; 

  p -> ku . multiple . array = a ; 

  for (i = 0 ; i < argc ; i ++ ) {
    a [i ] = argv [i ] ; 
  }

  RET_VALUE_START (((Scheme_Object * ) 0x6 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4224 "./../src/fun.c"
Scheme_Object * scheme_values (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4226 "./../src/fun.c"
  Scheme_Thread * p ; 
  int i ; 
  Scheme_Object * * a ; 

  if (argc == 1 )
    return argv [0 ] ; 

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  p -> ku . multiple . count = argc ; 
  if (p -> values_buffer && (p -> values_buffer_size >= argc ) ) {
    a = p -> values_buffer ; 
  }

# 4237 "./../src/fun.c"
  else {
    return values_slow (argc , argv ) ; 
  }

  p -> ku . multiple . array = a ; 

  for (i = 0 ; i < argc ; i ++ ) {
    a [i ] = argv [i ] ; 
  }

  return ((Scheme_Object * ) 0x6 ) ; 
}

void scheme_detach_multple_array (Scheme_Object * * values ) 
{
  /* No conversion */

# 4252 "./../src/fun.c"
  Scheme_Thread * t = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  if ((values ) == (t -> values_buffer ) ) 
    t -> values_buffer = ((void * ) 0 ) ; 
}





static void reset_cjs (Scheme_Continuation_Jump_State * a ) 
{
  /* No conversion */

# 4264 "./../src/fun.c"
  a -> jumping_to_continuation = ((void * ) 0 ) ; 
  a -> alt_full_continuation = ((void * ) 0 ) ; 
  a -> val = ((void * ) 0 ) ; 
  a -> num_vals = 0 ; 
  a -> is_kill = 0 ; 
  a -> is_escape = 0 ; 
  a -> skip_dws = 0 ; 
}

void scheme_clear_escape (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM815_COUNT (1)
# define SETUP_XfOrM815(x) SETUP(XfOrM815_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM815(_), reset_cjs (& p -> cjs ) )
# 4277 "./../src/fun.c"
  ; 
  p -> suspend_break = 0 ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4281 "./../src/fun.c"
static void copy_cjs (Scheme_Continuation_Jump_State * a , Scheme_Continuation_Jump_State * b ) 
{
  /* No conversion */

# 4283 "./../src/fun.c"
  a -> jumping_to_continuation = b -> jumping_to_continuation ; 
  a -> alt_full_continuation = b -> alt_full_continuation ; 
  a -> val = b -> val ; 
  a -> num_vals = b -> num_vals ; 
  a -> is_kill = b -> is_kill ; 
  a -> is_escape = b -> is_escape ; 
  a -> skip_dws = b -> skip_dws ; 
}

Scheme_Object * 
do_call_ec (int argc , Scheme_Object * argv [] , Scheme_Object * _for_cc ) 
{
  mz_jmp_buf newbuf ; 
  Scheme_Escaping_Cont * volatile cont ; 
  Scheme_Thread * p1 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * volatile v ; 
  Scheme_Object * a [1 ] ; 
  Scheme_Cont_Frame_Data cframe ; 
  Scheme_Prompt * barrier_prompt ; 
  Scheme_Object * volatile for_cc = _for_cc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(for_cc, 0), PUSH(p1, 1), PUSH(cont, 2), PUSH(argv, 3), PUSH(v, 4), PUSH(barrier_prompt, 5), PUSHARRAY(a, 1, 6), PUSH(cframe.cache, 9)));
# define XfOrM817_COUNT (10)
# define SETUP_XfOrM817(x) SETUP(XfOrM817_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cont = NULLED_OUT ; 
  v = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 
  barrier_prompt = NULLED_OUT ; 

# 4304 "./../src/fun.c"
  cont = ((Scheme_Escaping_Cont * ) FUNCCALL(SETUP_XfOrM817(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Escaping_Cont ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  cont -> so . type = scheme_escaping_cont_type ; 
  FUNCCALL(SETUP_XfOrM817(_), ASSERT_SUSPEND_BREAK_ZERO () ); 

  cont -> saveerr = p1 -> error_buf ; 
  p1 -> error_buf = & newbuf ; 
  cont -> myerr = & newbuf ; 

  (cont -> envss . runstack_offset = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) , cont -> envss . cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) , cont -> envss . cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ; 

  barrier_prompt = FUNCCALL(SETUP_XfOrM817(_), scheme_get_barrier_prompt (((void * ) 0 ) , ((void * ) 0 ) ) ); 
  cont -> barrier_prompt = barrier_prompt ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ++ ; 

  if (! for_cc )
    FUNCCALL(SETUP_XfOrM817(_), scheme_push_continuation_frame (& cframe ) ); 
  FUNCCALL(SETUP_XfOrM817(_), scheme_set_cont_mark ((Scheme_Object * ) cont , scheme_true ) ); 

  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM817_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
    Scheme_Thread * p2 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    BLOCK_SETUP((PUSH(p2, 0+XfOrM817_COUNT)));
#   define XfOrM820_COUNT (1+XfOrM817_COUNT)
#   define SETUP_XfOrM820(x) SETUP(XfOrM820_COUNT)

# 4325 "./../src/fun.c"
    if (p2 -> cjs . jumping_to_continuation 
    && ((p2 -> cjs . jumping_to_continuation ) == ((Scheme_Object * ) cont ) ) ) {
      Scheme_Object * alt_cont ; 
      int n ; 
#     define XfOrM822_COUNT (0+XfOrM820_COUNT)
#     define SETUP_XfOrM822(x) SETUP_XfOrM820(x)
      alt_cont = NULLED_OUT ; 

# 4330 "./../src/fun.c"
      alt_cont = p2 -> cjs . alt_full_continuation ; 
      if (alt_cont && ! ((Scheme_Cont * ) alt_cont ) -> orig_escape_cont ) {
#       define XfOrM823_COUNT (0+XfOrM822_COUNT)
#       define SETUP_XfOrM823(x) SETUP_XfOrM822(x)


        RET_VALUE_START (FUNCCALL(SETUP_XfOrM823(_), jump_to_alt_continuation () )) RET_VALUE_END ; 
      }

      n = p2 -> cjs . num_vals ; 
      v = p2 -> cjs . val ; 
      FUNCCALL(SETUP_XfOrM822(_), reset_cjs (& p2 -> cjs ) ); 
      (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + cont -> envss . runstack_offset , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = cont -> envss . cont_mark_stack , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = cont -> envss . cont_mark_pos ) ; 
      p2 -> suspend_break = 0 ; 
      FUNCCALL(SETUP_XfOrM822(_), scheme_check_break_now () ); 
      if (n != 1 )
        v = FUNCCALL(SETUP_XfOrM822(_), scheme_values (n , (Scheme_Object * * ) v ) ); 
      else if (v && ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_thunk_for_continue_type ) ) )
        v = FUNCCALL(SETUP_XfOrM822(_), scheme_do_eval ((((Scheme_Small_Object * ) (v ) ) -> u . ptr_val ) , 0 , ((void * ) 0 ) , - 1 ) ); 
    }

# 4349 "./../src/fun.c"
    else {
      (((intptr_t * ) (void * ) ((* cont -> saveerr ) . gcvs ) ) [1 ] = (* cont -> saveerr ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* cont -> saveerr ) . gcvs , longjmp ((* cont -> saveerr ) . jb , 1 ) ) ; 
    }
  }

# 4352 "./../src/fun.c"
  else if (for_cc ) {
#   define XfOrM819_COUNT (0+XfOrM817_COUNT)
#   define SETUP_XfOrM819(x) SETUP_XfOrM817(x)

# 4353 "./../src/fun.c"
    ((Scheme_Cont * ) for_cc ) -> escape_cont = (Scheme_Object * ) cont ; 
    ((Scheme_Cont * ) for_cc ) -> orig_escape_cont = 1 ; 
    a [0 ] = (Scheme_Object * ) for_cc ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) -= 2 ; 
    v = FUNCCALL(SETUP_XfOrM819(_), scheme_do_eval (argv [0 ] , 1 , a , - 1 ) ); 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) += 2 ; 
  }

# 4359 "./../src/fun.c"
  else {
#   define XfOrM818_COUNT (0+XfOrM817_COUNT)
#   define SETUP_XfOrM818(x) SETUP_XfOrM817(x)

# 4360 "./../src/fun.c"
    a [0 ] = (Scheme_Object * ) cont ; 
    v = FUNCCALL(SETUP_XfOrM818(_), scheme_do_eval (argv [0 ] , 1 , a , - 1 ) ); 
  }

  p1 = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p1 -> error_buf = cont -> saveerr ; 
  if (! for_cc )
    FUNCCALL(SETUP_XfOrM817(_), scheme_pop_continuation_frame (& cframe ) ); 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4373 "./../src/fun.c"
Scheme_Object * 
scheme_call_ec (int argc , Scheme_Object * argv [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM824_COUNT (1)
# define SETUP_XfOrM824(x) SETUP(XfOrM824_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM824(_), scheme_check_proc_arity ("call-with-escape-continuation" , 1 , 0 , argc , argv ) )
# 4377 "./../src/fun.c"
  ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(do_call_ec (argc , argv , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4382 "./../src/fun.c"
int scheme_escape_continuation_ok (Scheme_Object * ec ) 
{
  /* No conversion */

# 4384 "./../src/fun.c"
  Scheme_Escaping_Cont * cont = (Scheme_Escaping_Cont * ) ec ; 

  if (scheme_extract_one_cc_mark (((void * ) 0 ) , (Scheme_Object * ) cont ) )
    return 1 ; 
  else 
  return 0 ; 
}

static Scheme_Object * make_continuation_mark_key (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(argv, 1)));
# define XfOrM826_COUNT (2)
# define SETUP_XfOrM826(x) SETUP(XfOrM826_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 4396 "./../src/fun.c"
  if (argc && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-continuation-mark-key" , "symbol?" , 0 , argc , argv ) ); 

  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM826(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = scheme_continuation_mark_key_type ; 
  (((Scheme_Small_Object * ) (o ) ) -> u . ptr_val ) = (argc ? argv [0 ] : ((void * ) 0 ) ) ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4406 "./../src/fun.c"
static Scheme_Object * continuation_mark_key_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4408 "./../src/fun.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

Scheme_Object * scheme_chaperone_do_continuation_mark (const char * name , int is_get , Scheme_Object * key , Scheme_Object * val ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * proc ; 
  Scheme_Object * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(px, 1), PUSH(val, 2), PUSH(name, 3), PUSH(key, 4), PUSHARRAY(a, 1, 5)));
# define XfOrM828_COUNT (8)
# define SETUP_XfOrM828(x) SETUP(XfOrM828_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  proc = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 4419 "./../src/fun.c"
  while (1 ) {
#   define XfOrM833_COUNT (0+XfOrM828_COUNT)
#   define SETUP_XfOrM833(x) SETUP_XfOrM828(x)

# 4420 "./../src/fun.c"
    if ((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) )  {
      RET_VALUE_START (val ) RET_VALUE_END ; 
    }

# 4422 "./../src/fun.c"
    else {
#     define XfOrM834_COUNT (0+XfOrM833_COUNT)
#     define SETUP_XfOrM834(x) SETUP_XfOrM833(x)

# 4423 "./../src/fun.c"
      px = (Scheme_Chaperone * ) key ; 
      key = px -> prev ; 

      if (is_get )
        proc = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . car ) ; 
      else 
      proc = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . cdr ) ; 

      a [0 ] = val ; 
      val = FUNCCALL(SETUP_XfOrM834(_), scheme_do_eval (proc , 1 , a , 1 ) ); 

      if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ) {
#       define XfOrM835_COUNT (0+XfOrM834_COUNT)
#       define SETUP_XfOrM835(x) SETUP_XfOrM834(x)

# 4435 "./../src/fun.c"
        if (! FUNCCALL(SETUP_XfOrM835(_), scheme_chaperone_of (val , a [0 ] ) ))
          FUNCCALL(SETUP_XfOrM835(_), scheme_wrong_chaperoned (name , "value" , a [0 ] , val ) ); 
      }
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4442 "./../src/fun.c"
Scheme_Object * do_chaperone_continuation_mark_key (const char * name , int is_impersonator , int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val = argv [0 ] ; 
  Scheme_Object * redirects ; 
  Scheme_Object * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(px, 1), PUSH(props, 2), PUSH(name, 3), PUSH(redirects, 4), PUSH(argv, 5)));
# define XfOrM837_COUNT (6)
# define SETUP_XfOrM837(x) SETUP(XfOrM837_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 4449 "./../src/fun.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "continuation-mark-key?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM837(_), scheme_check_proc_arity (name , 1 , 1 , argc , argv ) )
  ; 
  FUNCCALL_AGAIN(scheme_check_proc_arity (name , 1 , 2 , argc , argv ) ); 

  redirects = FUNCCALL_AGAIN(scheme_make_pair (argv [1 ] , argv [2 ] ) ); 

  props = FUNCCALL_AGAIN(scheme_parse_chaperone_props (name , 3 , argc , argv ) ); 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM837(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 
  px -> redirects = redirects ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4475 "./../src/fun.c"
static Scheme_Object * chaperone_continuation_mark_key (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4477 "./../src/fun.c"
  return do_chaperone_continuation_mark_key ("chaperone-continuation-mark-key" , 0 , argc , argv ) ; 
}

static Scheme_Object * impersonate_continuation_mark_key (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4482 "./../src/fun.c"
  return do_chaperone_continuation_mark_key ("impersonate-continuation-mark-key" , 1 , argc , argv ) ; 
}

Scheme_Object * scheme_get_immediate_cc_mark (Scheme_Object * key , Scheme_Object * def_val ) 
{
  /* No conversion */

# 4487 "./../src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  intptr_t findpos , bottom ; 

  if (p -> cont_mark_stack_segments ) {
    findpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
    bottom = (intptr_t ) p -> cont_mark_stack_bottom ; 
    while (findpos -- > bottom ) {
      Scheme_Cont_Mark * seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
      intptr_t pos = findpos & ((1 << 6 ) - 1 ) ; 
      Scheme_Cont_Mark * find = seg + pos ; 

      if ((intptr_t ) find -> pos < (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) {
        break ; 
      }

# 4500 "./../src/fun.c"
      else {
        if (find -> key == key )
          return find -> val ; 
      }
    }
  }

  return def_val ; 
}

Scheme_Object * scheme_chaperone_get_immediate_cc_mark (Scheme_Object * key , Scheme_Object * def_val ) 
{
  /* No conversion */

# 4512 "./../src/fun.c"
  Scheme_Object * val ; 

  if ((((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) ) {
    val = scheme_get_immediate_cc_mark ((((Scheme_Chaperone * ) key ) -> val ) , ((void * ) 0 ) ) ; 
    if (val )
      return scheme_chaperone_do_continuation_mark ("call-with-immediate-continuation-mark" , 
    1 , key , val ) ; 
    else 
    return def_val ; 
  }

# 4522 "./../src/fun.c"
  else 
  return scheme_get_immediate_cc_mark (key , def_val ) ; 
}

static Scheme_Object * call_with_immediate_cc_mark (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * a [1 ] , * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSHARRAY(a, 1, 1), PUSH(argv, 4)));
# define XfOrM850_COUNT (5)
# define SETUP_XfOrM850(x) SETUP(XfOrM850_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  val = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM850(_), scheme_check_proc_arity ("call-with-immediate-continuation-mark" , 1 , 1 , argc , argv ) )
# 4530 "./../src/fun.c"
  ; 

  val = FUNCCALL_AGAIN(scheme_chaperone_get_immediate_cc_mark (argv [0 ] , ((argc > 2 ) ? argv [2 ] : scheme_false ) ) ); 
  a [0 ] = val ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM850(_), scheme_tail_apply (argv [1 ] , 1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4538 "./../src/fun.c"
static Scheme_Object * 
do_call_with_sema (const char * who , int enable_break , int argc , Scheme_Object * argv [] ) 
{
  mz_jmp_buf newbuf , * volatile savebuf ; 
  Scheme_Prompt * volatile prompt ; 
  int i , just_try ; 
  int volatile extra ; 
  Scheme_Object * volatile sema ; 
  Scheme_Object * v , * quick_args [4 ] , * * extra_args ; 
  Scheme_Cont_Frame_Data cframe ; 
  int old_pcc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(who, 0), PUSH(extra_args, 1), PUSH(v, 2), PUSH(sema, 3), PUSH(argv, 4), PUSH(prompt, 5), PUSH(cframe.cache, 6), PUSH(savebuf, 7), PUSHARRAY(quick_args, 4, 8)));
# define XfOrM851_COUNT (11)
# define SETUP_XfOrM851(x) SETUP(XfOrM851_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  savebuf = NULLED_OUT ; 
  prompt = NULLED_OUT ; 
  sema = NULLED_OUT ; 
  v = NULLED_OUT ; 
  NULL_OUT_ARRAY (quick_args ) ; 
  extra_args = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 4550 "./../src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) ) ) {
#   define XfOrM863_COUNT (0+XfOrM851_COUNT)
#   define SETUP_XfOrM863(x) SETUP_XfOrM851(x)
    FUNCCALL(SETUP_XfOrM863(_), scheme_wrong_contract (who , "semaphore?" , 0 , argc , argv ) )
# 4551 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (argc > 2 )
    extra = argc - 3 ; 
  else 
  extra = 0 ; 
  if (! FUNCCALL(SETUP_XfOrM851(_), scheme_check_proc_arity (((void * ) 0 ) , extra , 1 , argc , argv ) )) {
#   define XfOrM862_COUNT (0+XfOrM851_COUNT)
#   define SETUP_XfOrM862(x) SETUP_XfOrM851(x)

# 4559 "./../src/fun.c"
    if (! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      FUNCCALL(SETUP_XfOrM862(_), scheme_wrong_contract (who , "procedure?" , 1 , argc , argv ) ); 
    else FUNCCALL(SETUP_XfOrM862(_), scheme_contract_error (who , "procedure arity does not match extra-argument count" , "procedure" , 1 , argv [1 ] , "extra-argument count" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (extra ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )



    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if ((argc > 2 ) && (! (((argv [2 ] ) ) == (scheme_false ) ) ) ) {
#   define XfOrM860_COUNT (0+XfOrM851_COUNT)
#   define SETUP_XfOrM860(x) SETUP_XfOrM851(x)

# 4569 "./../src/fun.c"
    if (! FUNCCALL(SETUP_XfOrM860(_), scheme_check_proc_arity (((void * ) 0 ) , 0 , 2 , argc , argv ) )) {
#     define XfOrM861_COUNT (0+XfOrM860_COUNT)
#     define SETUP_XfOrM861(x) SETUP_XfOrM860(x)
      FUNCCALL(SETUP_XfOrM861(_), scheme_wrong_contract (who , "(or/c (-> any) #f)" , 1 , argc , argv ) )
# 4570 "./../src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    just_try = 1 ; 
  }

# 4574 "./../src/fun.c"
  else 
  just_try = 0 ; 

  sema = argv [0 ] ; 

  if (just_try && enable_break && XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> external_break ) {

    Scheme_Cont_Frame_Data bcframe ; 
    BLOCK_SETUP((PUSH(bcframe.cache, 0+XfOrM851_COUNT)));
#   define XfOrM859_COUNT (1+XfOrM851_COUNT)
#   define SETUP_XfOrM859(x) SETUP(XfOrM859_COUNT)
    bcframe.cache = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM859(_), scheme_push_break_enable (& bcframe , 1 , 1 ) )
# 4582 "./../src/fun.c"
    ; 
    FUNCCALL_AGAIN(scheme_check_break_now () ); 
    FUNCCALL_AGAIN(scheme_pop_break_enable (& bcframe , 0 ) ); 
  }

  if (! FUNCCALL(SETUP_XfOrM851(_), scheme_wait_sema (sema , just_try ? 1 : (enable_break ? - 1 : 0 ) ) )) {
#   define XfOrM858_COUNT (0+XfOrM851_COUNT)
#   define SETUP_XfOrM858(x) SETUP_XfOrM851(x)

# 4588 "./../src/fun.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM858(_), scheme_tail_apply (argv [2 ] , 0 , ((void * ) 0 ) ) )) RET_VALUE_END ; 
  }

  savebuf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_cws_prompt_ ) ) {
    prompt = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_cws_prompt_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_cws_prompt_ ) = ((void * ) 0 ) ; 
  }

# 4597 "./../src/fun.c"
  else {
#   define XfOrM856_COUNT (0+XfOrM851_COUNT)
#   define SETUP_XfOrM856(x) SETUP_XfOrM851(x)

# 4598 "./../src/fun.c"
    prompt = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM856(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    prompt -> so . type = scheme_prompt_type ; 
  }
  FUNCCALL(SETUP_XfOrM851(_), scheme_push_continuation_frame (& cframe ) )
  ; 
  FUNCCALL(SETUP_XfOrM851(_), scheme_set_cont_mark (barrier_prompt_key , (Scheme_Object * ) prompt ) ); 

  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM851_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
    v = ((void * ) 0 ) ; 
  }

# 4607 "./../src/fun.c"
  else {
#   define XfOrM852_COUNT (0+XfOrM851_COUNT)
#   define SETUP_XfOrM852(x) SETUP_XfOrM851(x)

# 4608 "./../src/fun.c"
    if (extra > 4 )
      extra_args = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM852(_), GC_malloc (sizeof (Scheme_Object * ) * (extra ) ) )) ; 
    else 
    extra_args = quick_args ; 
    for (i = 3 ; i < argc ; i ++ ) {
      extra_args [i - 3 ] = argv [i ] ; 
    }

    v = FUNCCALL(SETUP_XfOrM852(_), scheme_do_eval (argv [1 ] , extra , extra_args , - 1 ) ); 
  }
  FUNCCALL(SETUP_XfOrM851(_), scheme_pop_continuation_frame (& cframe ) )
  ; 
  FUNCCALL(SETUP_XfOrM851(_), scheme_post_sema (sema ) )
  ; 

  if (old_pcc != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_cws_prompt_ ) = prompt ; 

  if (! v )
    (((intptr_t * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* savebuf ) . gcvs , longjmp ((* savebuf ) . jb , 1 ) ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = savebuf ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4634 "./../src/fun.c"
static Scheme_Object * 
call_with_sema (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4637 "./../src/fun.c"
  return do_call_with_sema ("call-with-semaphore" , 0 , argc , argv ) ; 
}

static Scheme_Object * 
call_with_sema_enable_break (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 4643 "./../src/fun.c"
  return do_call_with_sema ("call-with-semaphore/enable-break" , 1 , argc , argv ) ; 
}

static Scheme_Saved_Stack * copy_out_runstack (Scheme_Thread * p , 
Scheme_Object * * runstack , 
Scheme_Object * * runstack_start , 
Scheme_Cont * share_from , 
Scheme_Prompt * effective_prompt ) 
{
  Scheme_Saved_Stack * saved , * isaved , * csaved , * share_saved , * share_csaved , * ss ; 
  Scheme_Object * * start ; 
  intptr_t size ; 
  int done ; 
  DECL_RET_SAVE (Scheme_Saved_Stack * ) PREPARE_VAR_STACK_ONCE(12);
  BLOCK_SETUP_TOP((PUSH(start, 0), PUSH(p, 1), PUSH(ss, 2), PUSH(share_csaved, 3), PUSH(share_from, 4), PUSH(runstack, 5), PUSH(csaved, 6), PUSH(saved, 7), PUSH(effective_prompt, 8), PUSH(share_saved, 9), PUSH(isaved, 10), PUSH(runstack_start, 11)));
# define XfOrM866_COUNT (12)
# define SETUP_XfOrM866(x) SETUP(XfOrM866_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  saved = NULLED_OUT ; 
  isaved = NULLED_OUT ; 
  csaved = NULLED_OUT ; 
  share_saved = NULLED_OUT ; 
  share_csaved = NULLED_OUT ; 
  ss = NULLED_OUT ; 
  start = NULLED_OUT ; 

# 4658 "./../src/fun.c"
  saved = ((Scheme_Saved_Stack * ) FUNCCALL(SETUP_XfOrM866(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Saved_Stack ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  saved -> type = scheme_rt_saved_stack ; 

  if (share_from && (share_from -> runstack_start == runstack_start ) ) {
    intptr_t shared_amt ; 

    size = (share_from -> ss . runstack_offset - (runstack XFORM_OK_MINUS runstack_start ) ) ; 

    shared_amt = (p -> runstack_size - share_from -> ss . runstack_offset ) ; 
    if (shared_amt > 2 )
      size += 2 ; 
    else 
    size += shared_amt ; 
  }

# 4672 "./../src/fun.c"
  else if (effective_prompt && ((scheme_prompt_runstack_boundary_start (effective_prompt ) ) == runstack_start ) ) {

    size = effective_prompt -> runstack_boundary_offset - (runstack XFORM_OK_MINUS runstack_start ) ; 
  }

# 4675 "./../src/fun.c"
  else {
    size = p -> runstack_size - (runstack XFORM_OK_MINUS runstack_start ) ; 
  }

  ((void ) sizeof ((size <= p -> runstack_size ) ? 1 : 0 ) , __extension__ ({
#   define XfOrM878_COUNT (0+XfOrM866_COUNT)
#   define SETUP_XfOrM878(x) SETUP_XfOrM866(x)

# 4679 "./../src/fun.c" 3
    if (size <= p -> runstack_size )

# 4679 "./../src/fun.c" 3
    ; 

# 4679 "./../src/fun.c" 3
    else FUNCCALL(SETUP_XfOrM878(_), __assert_fail ("size <= p->runstack_size" , "./../src/fun.c" , 4679 , __extension__ __PRETTY_FUNCTION__ ) ); 
  }
  ) ) 
# 4679 "./../src/fun.c"
  ; 

  saved -> runstack_size = size ; 
  start = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM866(_), GC_malloc (sizeof (Scheme_Object * ) * (size ) ) )) ; 
  saved -> runstack_start = start ; 
  (memcpy (saved -> runstack_start , runstack , size * sizeof (Scheme_Object * ) ) ) ; 
  saved -> runstack_offset = (runstack XFORM_OK_MINUS runstack_start ) ; 

  if (! effective_prompt || ((scheme_prompt_runstack_boundary_start (effective_prompt ) ) != runstack_start ) ) {
#   define XfOrM867_COUNT (0+XfOrM866_COUNT)
#   define SETUP_XfOrM867(x) SETUP_XfOrM866(x)
    if (share_from ) {

      share_csaved = share_from -> runstack_saved ; 
      share_saved = share_from -> runstack_copied -> prev ; 
    }

# 4694 "./../src/fun.c"
    else {
      share_saved = ((void * ) 0 ) ; 
      share_csaved = ((void * ) 0 ) ; 
    }
    isaved = saved ; 
    for (csaved = p -> runstack_saved ; csaved ; csaved = csaved -> prev ) {
#     define XfOrM872_COUNT (0+XfOrM867_COUNT)
#     define SETUP_XfOrM872(x) SETUP_XfOrM867(x)

# 4700 "./../src/fun.c"
      if (share_csaved && (csaved -> runstack_start == share_csaved -> runstack_start ) ) {

        isaved -> prev = share_saved ; 
        break ; 
      }

      ss = ((Scheme_Saved_Stack * ) FUNCCALL(SETUP_XfOrM872(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Saved_Stack ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

      ss -> type = scheme_rt_saved_stack ; 

      isaved -> prev = ss ; 
      isaved = ss ; 

      if (effective_prompt && ((scheme_prompt_runstack_boundary_start (effective_prompt ) ) == csaved -> runstack_start ) ) {
        size = effective_prompt -> runstack_boundary_offset - csaved -> runstack_offset ; 
        done = 1 ; 
      }

# 4716 "./../src/fun.c"
      else {
        size = csaved -> runstack_size - csaved -> runstack_offset ; 
        done = 0 ; 
      }

      isaved -> runstack_size = size ; 

      start = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM872(_), GC_malloc (sizeof (Scheme_Object * ) * (size ) ) )) ; 
      isaved -> runstack_start = start ; 
      (memcpy (isaved -> runstack_start , 
      csaved -> runstack_start XFORM_OK_PLUS csaved -> runstack_offset , 
      size * sizeof (Scheme_Object * ) ) ) ; 
      isaved -> runstack_offset = csaved -> runstack_offset ; 

      if (done )

# 4730 "./../src/fun.c"
      break ; 
    }
  }

  RET_VALUE_START (saved ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4737 "./../src/fun.c"
static Scheme_Cont_Mark * copy_out_mark_stack (Scheme_Thread * p , 
intptr_t pos , 
Scheme_Cont * sub_cont , 
intptr_t * _offset , 
Scheme_Prompt * effective_prompt , 
int clear_caches ) 
{
  intptr_t cmcount , offset = 0 , sub_count = 0 ; 
  Scheme_Cont_Mark * cont_mark_stack_copied ; 
  DECL_RET_SAVE (Scheme_Cont_Mark * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(cont_mark_stack_copied, 1)));
# define XfOrM882_COUNT (2)
# define SETUP_XfOrM882(x) SETUP(XfOrM882_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cont_mark_stack_copied = NULLED_OUT ; 

# 4748 "./../src/fun.c"
  cmcount = (intptr_t ) pos ; 
  offset = 0 ; 

  if (sub_cont ) {

    sub_count = sub_cont -> cont_mark_total - sub_cont -> cont_mark_nonshare ; 
    if (sub_count < 0 )
      sub_count = 0 ; 
  }

# 4756 "./../src/fun.c"
  else if (effective_prompt ) {

    sub_count = effective_prompt -> mark_boundary ; 
  }
  cmcount -= sub_count ; 
  offset += sub_count ; 

  if (_offset )

# 4763 "./../src/fun.c"
  * _offset = offset ; 

  if (cmcount ) {
#   define XfOrM883_COUNT (0+XfOrM882_COUNT)
#   define SETUP_XfOrM883(x) SETUP_XfOrM882(x)

# 4766 "./../src/fun.c"
    cont_mark_stack_copied = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM883(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (cmcount ) ) )) ; 
    while (cmcount -- ) {
      int cms = cmcount + offset ; 
      Scheme_Cont_Mark * seg = p -> cont_mark_stack_segments [cms >> 6 ] ; 
      intptr_t pos = cms & ((1 << 6 ) - 1 ) ; 
      Scheme_Cont_Mark * cm = seg + pos ; 
#     define XfOrM885_COUNT (0+XfOrM883_COUNT)
#     define SETUP_XfOrM885(x) SETUP_XfOrM883(x)
      (
# 4773 "./../src/fun.c"
      memcpy (cont_mark_stack_copied + cmcount , cm , sizeof (Scheme_Cont_Mark ) ) ) ; 
      if (clear_caches )
        cont_mark_stack_copied [cmcount ] . cache = ((void * ) 0 ) ; 
    }

    RET_VALUE_START (cont_mark_stack_copied ) RET_VALUE_END ; 
  }

# 4779 "./../src/fun.c"
  else 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4783 "./../src/fun.c"
static void copy_in_runstack (Scheme_Thread * p , Scheme_Saved_Stack * isaved , int set_runstack ) 
{
  /* No conversion */

# 4785 "./../src/fun.c"
  Scheme_Saved_Stack * csaved ; 
  intptr_t size ; 

  size = isaved -> runstack_size ; 
  if (set_runstack ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + (p -> runstack_size - size ) ; 
  }
  memcpy (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) , isaved -> runstack_start , size * sizeof (Scheme_Object * ) ) ; 
  for (csaved = p -> runstack_saved ; csaved ; csaved = csaved -> prev ) {
    isaved = isaved -> prev ; 
    if (! isaved ) {


      break ; 
    }
    size = isaved -> runstack_size ; 
    csaved -> runstack_offset = isaved -> runstack_offset ; 
    memcpy (csaved -> runstack_start XFORM_OK_PLUS csaved -> runstack_offset , 
    isaved -> runstack_start , 
    size * sizeof (Scheme_Object * ) ) ; 
  }
}

static void copy_in_mark_stack (Scheme_Thread * p , Scheme_Cont_Mark * cont_mark_stack_copied , 
intptr_t cms , intptr_t base_cms , 
intptr_t copied_offset , Scheme_Object * * _sub_conts , 
int clear_caches , 
intptr_t new_mark_pos ) 




{
  intptr_t cmcount , base_cmcount , cmoffset ; 
  Scheme_Cont_Mark * cm_src ; 
  Scheme_Cont * sub_cont = ((void * ) 0 ) ; 
  PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(cont_mark_stack_copied, 1), PUSH(_sub_conts, 2), PUSH(sub_cont, 3), PUSH(cm_src, 4)));
# define XfOrM894_COUNT (5)
# define SETUP_XfOrM894(x) SETUP(XfOrM894_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cm_src = NULLED_OUT ; 

# 4822 "./../src/fun.c"
  cmcount = (intptr_t ) cms ; 
  base_cmcount = (intptr_t ) base_cms ; 

  if (cmcount ) {

    intptr_t needed = ((cmcount - 1 ) >> 6 ) + 1 ; 
#   define XfOrM917_COUNT (0+XfOrM894_COUNT)
#   define SETUP_XfOrM917(x) SETUP_XfOrM894(x)

# 4829 "./../src/fun.c"
    if (needed > p -> cont_mark_seg_count ) {
      Scheme_Cont_Mark * * segs , * * old_segs = p -> cont_mark_stack_segments ; 
      int newcount = needed , oldcount = p -> cont_mark_seg_count , npos ; 
      BLOCK_SETUP((PUSH(segs, 0+XfOrM917_COUNT), PUSH(old_segs, 1+XfOrM917_COUNT)));
#     define XfOrM918_COUNT (2+XfOrM917_COUNT)
#     define SETUP_XfOrM918(x) SETUP(XfOrM918_COUNT)
      segs = NULLED_OUT ; 

# 4835 "./../src/fun.c"
      segs = ((Scheme_Cont_Mark * * ) FUNCCALL(SETUP_XfOrM918(_), GC_malloc (sizeof (Scheme_Cont_Mark * ) * (needed ) ) )) ; 

      for (npos = needed ; npos -- ; ) {
#       define XfOrM921_COUNT (0+XfOrM918_COUNT)
#       define SETUP_XfOrM921(x) SETUP_XfOrM918(x)

# 4838 "./../src/fun.c"
        if (npos < oldcount )
          segs [npos ] = old_segs [npos ] ; 
        else 
        segs [npos ] = ((void * ) 0 ) ; 

        if (! segs [npos ] ) {
          Scheme_Cont_Mark * cm ; 
          BLOCK_SETUP((PUSH(cm, 0+XfOrM921_COUNT)));
#         define XfOrM922_COUNT (1+XfOrM921_COUNT)
#         define SETUP_XfOrM922(x) SETUP(XfOrM922_COUNT)
          cm = NULLED_OUT ; 

# 4845 "./../src/fun.c"
          cm = FUNCCALL(SETUP_XfOrM922(_), GC_malloc_allow_interior (sizeof (Scheme_Cont_Mark ) * (1 << 6 ) ) ); 
          segs [npos ] = cm ; 
        }
      }

      p -> cont_mark_seg_count = newcount ; 
      p -> cont_mark_stack_segments = segs ; 
    }
  }


  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = new_mark_pos ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = cms ; 

  if (_sub_conts ) {
    if (* _sub_conts ) {
      sub_cont = (Scheme_Cont * ) (((Scheme_Simple_Object * ) (* _sub_conts ) ) -> u . pair_val . car ) ; 
    }
  }

  while (base_cmcount < cmcount ) {
    Scheme_Cont_Mark * seg = p -> cont_mark_stack_segments [base_cmcount >> 6 ] ; 
    intptr_t pos = base_cmcount & ((1 << 6 ) - 1 ) ; 
    GC_CAN_IGNORE Scheme_Cont_Mark * cm = seg + pos ; 
#   define XfOrM905_COUNT (0+XfOrM894_COUNT)
#   define SETUP_XfOrM905(x) SETUP_XfOrM894(x)

# 4870 "./../src/fun.c"
    cm_src = cont_mark_stack_copied ; 
    cmoffset = base_cmcount - copied_offset ; 

    if (sub_cont ) {
      while (base_cmcount >= (sub_cont -> cont_mark_total - sub_cont -> cont_mark_nonshare ) ) {
        * _sub_conts = (((Scheme_Simple_Object * ) (* _sub_conts ) ) -> u . pair_val . cdr ) ; 
        if (* _sub_conts ) {
          sub_cont = (Scheme_Cont * ) (((Scheme_Simple_Object * ) (* _sub_conts ) ) -> u . pair_val . car ) ; 
        }

# 4878 "./../src/fun.c"
        else {
          sub_cont = ((void * ) 0 ) ; 
          break ; 
        }
      }
      if (sub_cont ) {
        cm_src = sub_cont -> cont_mark_stack_copied ; 
        cmoffset = base_cmcount - sub_cont -> cont_mark_offset ; 
      }
    }
    (
    memcpy (cm , cm_src + cmoffset , sizeof (Scheme_Cont_Mark ) ) ) ; 
    if (clear_caches ) {
      cm -> cache = ((void * ) 0 ) ; 
    }

    base_cmcount ++ ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4898 "./../src/fun.c"
static intptr_t find_shareable_marks () 
{
  /* No conversion */

# 4900 "./../src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  intptr_t cmcount , delta = 0 ; 

  cmcount = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 

  while (cmcount -- ) {
    Scheme_Cont_Mark * seg = p -> cont_mark_stack_segments [cmcount >> 6 ] ; 
    intptr_t pos = cmcount & ((1 << 6 ) - 1 ) ; 

    if (seg [pos ] . pos < XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) )
      break ; 




    if ((seg [pos ] . key ) == (cont_key ) ) 
      delta ++ ; 
    else if ((seg [pos ] . key ) == (scheme_stack_dump_key ) ) 
      delta ++ ; 
    else 
    delta = 0 ; 
  }

  return cmcount + 1 + delta ; 
}

static Scheme_Overflow * clone_overflows (Scheme_Overflow * overflow , void * limit , Scheme_Overflow * tail ) 
{
  Scheme_Overflow * naya , * first = ((void * ) 0 ) , * prev = ((void * ) 0 ) ; 
  int stop = 0 ; 
  DECL_RET_SAVE (Scheme_Overflow * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(tail, 1), PUSH(prev, 2), PUSH(overflow, 3), PUSH(limit, 4), PUSH(first, 5)));
# define XfOrM926_COUNT (6)
# define SETUP_XfOrM926(x) SETUP(XfOrM926_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 4931 "./../src/fun.c"
  for (; overflow && ! stop ; overflow = overflow -> prev ) {
#   define XfOrM929_COUNT (0+XfOrM926_COUNT)
#   define SETUP_XfOrM929(x) SETUP_XfOrM926(x)

# 4932 "./../src/fun.c"
    naya = ((Scheme_Overflow * ) FUNCCALL(SETUP_XfOrM929(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    (memcpy (naya , overflow , sizeof (Scheme_Overflow ) ) ) ; 
    if (prev )
      prev -> prev = naya ; 
    else 
    first = naya ; 
    prev = naya ; 
    if (limit && overflow -> id == limit )
      stop = 1 ; 
  }

  if (first ) {
    prev -> prev = tail ; 
    RET_VALUE_START (first ) RET_VALUE_END ; 
  }

# 4946 "./../src/fun.c"
  else 
  RET_VALUE_START (tail ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4950 "./../src/fun.c"
static Scheme_Dynamic_Wind * clone_dyn_wind (Scheme_Dynamic_Wind * dw , 
Scheme_Object * limit_prompt_tag , int limit_depth , int limit_count , 
Scheme_Dynamic_Wind * tail , 
int keep_tail , int composable ) 
{
  Scheme_Dynamic_Wind * naya , * first = ((void * ) 0 ) , * prev = ((void * ) 0 ) ; 
  int cnt = 0 ; 
  DECL_RET_SAVE (Scheme_Dynamic_Wind * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(tail, 1), PUSH(limit_prompt_tag, 2), PUSH(dw, 3), PUSH(prev, 4), PUSH(first, 5)));
# define XfOrM930_COUNT (6)
# define SETUP_XfOrM930(x) SETUP(XfOrM930_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 4958 "./../src/fun.c"
  for (; dw ; dw = dw -> prev ) {
#   define XfOrM936_COUNT (0+XfOrM930_COUNT)
#   define SETUP_XfOrM936(x) SETUP_XfOrM930(x)

# 4959 "./../src/fun.c"
    if (dw -> depth == limit_depth )
      break ; 
    if (composable && limit_prompt_tag && (dw -> prompt_tag == limit_prompt_tag ) )
      break ; 
    if (cnt == limit_count )
      break ; 
    FUNCCALL(SETUP_XfOrM936(_), scheme_ensure_dw_id (dw ) ); 
    naya = ((Scheme_Dynamic_Wind * ) FUNCCALL(SETUP_XfOrM936(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Dynamic_Wind ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    (memcpy (naya , dw , sizeof (Scheme_Dynamic_Wind ) ) ) ; 
    if (prev )
      prev -> prev = naya ; 
    else 
    first = naya ; 
    prev = naya ; 
    cnt ++ ; 
    if (limit_prompt_tag && (dw -> prompt_tag == limit_prompt_tag ) ) {
      dw = dw -> prev ; 
      break ; 
    }
  }
  if (keep_tail )
    tail = dw ; 
  if (first ) {
    prev -> prev = tail ; 
    if (tail )
      cnt += tail -> depth + 1 ; 
    for (dw = first ; dw != tail ; dw = dw -> prev ) {
      dw -> depth = -- cnt ; 
    }
    RET_VALUE_START (first ) RET_VALUE_END ; 
  }

# 4989 "./../src/fun.c"
  else 
  RET_VALUE_START (tail ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4993 "./../src/fun.c"
static void clear_cm_copy_caches (Scheme_Cont_Mark * cp , int cnt ) 
{
  /* No conversion */

# 4995 "./../src/fun.c"
  int i ; 
  for (i = 0 ; i < cnt ; i ++ ) {
    cp [i ] . cache = ((void * ) 0 ) ; 
  }
}

static Scheme_Saved_Stack * clone_runstack_saved (Scheme_Saved_Stack * saved , Scheme_Object * * boundary_start , 
Scheme_Saved_Stack * last ) 
{
  Scheme_Saved_Stack * naya , * first = last , * prev = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Saved_Stack * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(boundary_start, 0), PUSH(naya, 1), PUSH(saved, 2), PUSH(first, 3), PUSH(last, 4), PUSH(prev, 5)));
# define XfOrM941_COUNT (6)
# define SETUP_XfOrM941(x) SETUP(XfOrM941_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 5006 "./../src/fun.c"
  while (saved ) {
#   define XfOrM943_COUNT (0+XfOrM941_COUNT)
#   define SETUP_XfOrM943(x) SETUP_XfOrM941(x)

# 5007 "./../src/fun.c"
    naya = ((Scheme_Saved_Stack * ) FUNCCALL(SETUP_XfOrM943(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Saved_Stack ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    (memcpy (naya , saved , sizeof (Scheme_Saved_Stack ) ) ) ; 
    if (prev )
      prev -> prev = naya ; 
    else 
    first = naya ; 
    prev = naya ; 
    if (saved -> runstack_start == boundary_start )
      break ; 
    saved = saved -> prev ; 
  }
  if (prev )
    prev -> prev = last ; 

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5024 "./../src/fun.c"
static Scheme_Saved_Stack * clone_runstack_copied (Scheme_Saved_Stack * copied , 
Scheme_Object * * copied_start , 
Scheme_Saved_Stack * saved , 
Scheme_Object * * boundary_start , 
intptr_t boundary_offset ) 
{
  Scheme_Saved_Stack * naya , * first = ((void * ) 0 ) , * prev = ((void * ) 0 ) , * s ; 
  DECL_RET_SAVE (Scheme_Saved_Stack * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(boundary_start, 0), PUSH(naya, 1), PUSH(copied_start, 2), PUSH(first, 3), PUSH(s, 4), PUSH(saved, 5), PUSH(prev, 6), PUSH(copied, 7)));
# define XfOrM944_COUNT (8)
# define SETUP_XfOrM944(x) SETUP(XfOrM944_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  naya = NULLED_OUT ; 
  s = NULLED_OUT ; 

# 5032 "./../src/fun.c"
  if (copied_start == boundary_start ) {
    naya = copied ; 
  }

# 5034 "./../src/fun.c"
  else {
    for (naya = copied -> prev , s = saved ; 
    s -> runstack_start != boundary_start ; 
    naya = naya -> prev , s = s -> prev ) {
    }
  }
  if ((naya -> runstack_offset + naya -> runstack_size == boundary_offset ) 
  && ! naya -> prev ) {

    RET_VALUE_START (copied ) RET_VALUE_END ; 
  }

  s = ((void * ) 0 ) ; 
  while (copied ) {
#   define XfOrM947_COUNT (0+XfOrM944_COUNT)
#   define SETUP_XfOrM947(x) SETUP_XfOrM944(x)

# 5048 "./../src/fun.c"
    naya = ((Scheme_Saved_Stack * ) FUNCCALL(SETUP_XfOrM947(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Saved_Stack ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    (memcpy (naya , copied , sizeof (Scheme_Saved_Stack ) ) ) ; 
    naya -> prev = ((void * ) 0 ) ; 
    if (prev )
      prev -> prev = naya ; 
    else 
    first = naya ; 
    prev = naya ; 
    if ((! s && copied_start == boundary_start ) 
    || (s && (s -> runstack_start == boundary_start ) ) ) {
      intptr_t size ; 
      Scheme_Object * * a ; 
      BLOCK_SETUP((PUSH(a, 0+XfOrM947_COUNT)));
#     define XfOrM948_COUNT (1+XfOrM947_COUNT)
#     define SETUP_XfOrM948(x) SETUP(XfOrM948_COUNT)
      a = NULLED_OUT ; 

# 5060 "./../src/fun.c"
      size = boundary_offset - naya -> runstack_offset ; 
      if (size < 0 )
        FUNCCALL_EMPTY(scheme_signal_error ("negative stack-copy size while pruning" ) ); 
      if (size > naya -> runstack_size )
        FUNCCALL_EMPTY(scheme_signal_error ("bigger stack-copy size while pruning: %d vs. %d" , size , naya -> runstack_size ) ); 
      a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM948(_), GC_malloc (sizeof (Scheme_Object * ) * (size ) ) )) ; 
      (memcpy (a , naya -> runstack_start , size * sizeof (Scheme_Object * ) ) ) ; 
      naya -> runstack_start = a ; 
      naya -> runstack_size = size ; 
      break ; 
    }

    copied = copied -> prev ; 
    if (! s )
      s = saved ; 
    else 
    s = s -> prev ; 
  }

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5082 "./../src/fun.c"
static Scheme_Meta_Continuation * clone_meta_cont (Scheme_Meta_Continuation * mc , 
Scheme_Object * limit_tag , int limit_depth , 
Scheme_Meta_Continuation * prompt_cont , 
Scheme_Prompt * prompt , 
Scheme_Meta_Continuation * tail , 
int for_composable ) 
{
  Scheme_Meta_Continuation * naya , * first = ((void * ) 0 ) , * prev = ((void * ) 0 ) ; 
  int cnt = 0 , depth ; 

# 1046 "./../src/fun.c"
  Scheme_Object * * __funcarg204 = NULLED_OUT ; 

# 1046 "./../src/fun.c"
  Scheme_Object * * __funcarg203 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Meta_Continuation * ) PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(prompt_cont, 1), PUSH(tail, 2), PUSH(limit_tag, 3), PUSH(prompt, 4), PUSH(first, 5), PUSH(prev, 6), PUSH(mc, 7)));
# define XfOrM954_COUNT (8)
# define SETUP_XfOrM954(x) SETUP(XfOrM954_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  naya = NULLED_OUT ; 

# 5092 "./../src/fun.c"
  for (; mc ; mc = mc -> next ) {
#   define XfOrM972_COUNT (0+XfOrM954_COUNT)
#   define SETUP_XfOrM972(x) SETUP_XfOrM954(x)

# 5093 "./../src/fun.c"
    if (! limit_depth -- )
      break ; 
    if (! mc -> pseudo && ((mc -> prompt_tag ) == (limit_tag ) ) )
      break ; 
    if (for_composable && mc -> pseudo && mc -> empty_to_next && mc -> next 
    && ((mc -> next -> prompt_tag ) == (limit_tag ) ) ) {



      break ; 
    }

    naya = ((Scheme_Meta_Continuation * ) FUNCCALL(SETUP_XfOrM972(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Meta_Continuation ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    cnt ++ ; 
    (memcpy (naya , mc , sizeof (Scheme_Meta_Continuation ) ) ) ; 
    if ((mc ) == (prompt_cont ) )  {

      intptr_t delta ; 
      void * stack_boundary ; 
      BLOCK_SETUP((PUSH(stack_boundary, 0+XfOrM972_COUNT)));
#     define XfOrM976_COUNT (1+XfOrM972_COUNT)
#     define SETUP_XfOrM976(x) SETUP(XfOrM976_COUNT)
      stack_boundary = NULLED_OUT ; 

# 5113 "./../src/fun.c"
      delta = prompt -> mark_boundary - naya -> cont_mark_offset ; 
      if (delta ) {
#       define XfOrM982_COUNT (0+XfOrM976_COUNT)
#       define SETUP_XfOrM982(x) SETUP_XfOrM976(x)

# 5115 "./../src/fun.c"
        naya -> cont_mark_total -= delta ; 
        naya -> cont_mark_offset += delta ; 
        if (naya -> cont_mark_total ) {
          Scheme_Cont_Mark * cp ; 
          BLOCK_SETUP((PUSH(cp, 0+XfOrM982_COUNT)));
#         define XfOrM983_COUNT (1+XfOrM982_COUNT)
#         define SETUP_XfOrM983(x) SETUP(XfOrM983_COUNT)
          cp = NULLED_OUT ; 

# 5119 "./../src/fun.c"
          cp = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM983(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (naya -> cont_mark_total ) ) )) ; 
          (memcpy (cp , mc -> cont_mark_stack_copied + delta , naya -> cont_mark_total * sizeof (Scheme_Cont_Mark ) ) ) ; 
          if (mc -> cm_caches ) {
#           define XfOrM984_COUNT (0+XfOrM983_COUNT)
#           define SETUP_XfOrM984(x) SETUP_XfOrM983(x)
            FUNCCALL(SETUP_XfOrM984(_), clear_cm_copy_caches (cp , naya -> cont_mark_total ) )
# 5122 "./../src/fun.c"
            ; 
          }
          naya -> cont_mark_stack_copied = cp ; 
          naya -> cm_caches = 0 ; 
          naya -> cm_shared = 0 ; 
        }

# 5127 "./../src/fun.c"
        else 
        naya -> cont_mark_stack_copied = ((void * ) 0 ) ; 
      }
      naya -> cont_mark_pos_bottom = prompt -> boundary_mark_pos ; 

      if ((prompt -> boundary_overflow_id && (prompt -> boundary_overflow_id == naya -> overflow -> id ) ) 
      || (! prompt -> boundary_overflow_id && ! naya -> overflow -> prev ) ) {
        stack_boundary = prompt -> stack_boundary ; 
      }

# 5135 "./../src/fun.c"
      else {
        stack_boundary = naya -> overflow -> stack_start ; 
      }

      if (naya -> cont ) {
        Scheme_Cont * cnaya ; 
        Scheme_Saved_Stack * saved ; 
        BLOCK_SETUP((PUSH(cnaya, 0+XfOrM976_COUNT), PUSH(saved, 1+XfOrM976_COUNT)));
#       define XfOrM979_COUNT (2+XfOrM976_COUNT)
#       define SETUP_XfOrM979(x) SETUP(XfOrM979_COUNT)
        cnaya = NULLED_OUT ; 
        saved = NULLED_OUT ; 

# 5143 "./../src/fun.c"
        cnaya = ((Scheme_Cont * ) FUNCCALL(SETUP_XfOrM979(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        (memcpy (cnaya , naya -> cont , sizeof (Scheme_Cont ) ) ) ; 

        naya -> cont = cnaya ; 

        cnaya -> cont_mark_total = naya -> cont_mark_total ; 
        cnaya -> cont_mark_offset = naya -> cont_mark_offset ; 
        cnaya -> cont_mark_pos_bottom = naya -> cont_mark_pos_bottom ; 
        cnaya -> cont_mark_stack_copied = naya -> cont_mark_stack_copied ; 

        cnaya -> prompt_stack_start = stack_boundary ; 


        saved = (__funcarg204 = (


        scheme_prompt_runstack_boundary_start (prompt ) ) , FUNCCALL(SETUP_XfOrM979(_), clone_runstack_copied (cnaya -> runstack_copied , cnaya -> runstack_start , cnaya -> runstack_saved , __funcarg204 , prompt -> runstack_boundary_offset ) )) 
        ; 
        cnaya -> runstack_copied = saved ; 


        if ((scheme_prompt_runstack_boundary_start (prompt ) ) == cnaya -> runstack_start )
          saved = ((void * ) 0 ) ; 
        else 
        saved = (__funcarg203 = (
        scheme_prompt_runstack_boundary_start (prompt ) ) , FUNCCALL(SETUP_XfOrM979(_), clone_runstack_saved (cnaya -> runstack_saved , __funcarg203 , ((void * ) 0 ) ) )) 
        ; 
        cnaya -> runstack_saved = saved ; 

        cnaya -> need_meta_prompt = 1 ; 
      }
      if (naya -> overflow && ! naya -> overflow -> eot ) {

        Scheme_Overflow * onaya ; 
        Scheme_Overflow_Jmp * jmp ; 
        BLOCK_SETUP((PUSH(onaya, 0+XfOrM976_COUNT), PUSH(jmp, 1+XfOrM976_COUNT)));
#       define XfOrM977_COUNT (2+XfOrM976_COUNT)
#       define SETUP_XfOrM977(x) SETUP(XfOrM977_COUNT)
        onaya = NULLED_OUT ; 
        jmp = NULLED_OUT ; 

# 5178 "./../src/fun.c"
        jmp = FUNCCALL(SETUP_XfOrM977(_), scheme_prune_jmpup (naya -> overflow -> jmp , stack_boundary ) ); 
        if (jmp ) {
#         define XfOrM978_COUNT (0+XfOrM977_COUNT)
#         define SETUP_XfOrM978(x) SETUP_XfOrM977(x)

# 5180 "./../src/fun.c"
          onaya = ((Scheme_Overflow * ) FUNCCALL(SETUP_XfOrM978(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
          (memcpy (onaya , naya -> overflow , sizeof (Scheme_Overflow ) ) ) ; 
          naya -> overflow = onaya ; 
          onaya -> jmp = jmp ; 
          onaya -> stack_start = stack_boundary ; 
        }
      }
    }

# 5187 "./../src/fun.c"
    else {
#     define XfOrM973_COUNT (0+XfOrM972_COUNT)
#     define SETUP_XfOrM973(x) SETUP_XfOrM972(x)

# 5188 "./../src/fun.c"
      if (! mc -> cm_caches ) {
        mc -> cm_shared = 1 ; 
        naya -> cm_shared = 1 ; 
      }

# 5191 "./../src/fun.c"
      else {
        Scheme_Cont_Mark * cp ; 
        BLOCK_SETUP((PUSH(cp, 0+XfOrM973_COUNT)));
#       define XfOrM974_COUNT (1+XfOrM973_COUNT)
#       define SETUP_XfOrM974(x) SETUP(XfOrM974_COUNT)
        cp = NULLED_OUT ; 

# 5193 "./../src/fun.c"
        cp = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM974(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (naya -> cont_mark_total ) ) )) ; 
        if (naya -> cont_mark_total )
          (memcpy (cp , mc -> cont_mark_stack_copied , naya -> cont_mark_total * sizeof (Scheme_Cont_Mark ) ) ) ; 
        FUNCCALL(SETUP_XfOrM974(_), clear_cm_copy_caches (cp , naya -> cont_mark_total ) ); 
        naya -> cont_mark_stack_copied = cp ; 
        naya -> cm_caches = 0 ; 
        naya -> cm_shared = 0 ; 
      }
    }
    if (prev )
      prev -> next = naya ; 
    else 
    first = naya ; 
    prev = naya ; 
  }

  if (first ) {
    prev -> next = tail ; 
  }

# 5211 "./../src/fun.c"
  else 
  first = tail ; 


  if (tail )
    depth = tail -> depth + 1 ; 
  else 
  depth = 0 ; 
  for (naya = first ; cnt -- ; naya = naya -> next ) {
    naya -> depth = depth + cnt ; 
  }

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5226 "./../src/fun.c"
static void sync_meta_cont (Scheme_Meta_Continuation * resume_mc ) 
{
  Scheme_Cont * cnaya ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(cnaya, 0), PUSH(resume_mc, 1)));
# define XfOrM986_COUNT (2)
# define SETUP_XfOrM986(x) SETUP(XfOrM986_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cnaya = NULLED_OUT ; 

# 5230 "./../src/fun.c"
  if (! resume_mc -> cont )
    RET_NOTHING ; 

  cnaya = ((Scheme_Cont * ) FUNCCALL(SETUP_XfOrM986(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  (memcpy (cnaya , resume_mc -> cont , sizeof (Scheme_Cont ) ) ) ; 

  resume_mc -> cont = cnaya ; 

  cnaya -> ss . cont_mark_stack += (resume_mc -> cont_mark_total - cnaya -> cont_mark_total ) ; 

  cnaya -> cont_mark_total = resume_mc -> cont_mark_total ; 
  cnaya -> cont_mark_offset = resume_mc -> cont_mark_offset ; 
  cnaya -> cont_mark_pos_bottom = resume_mc -> cont_mark_pos_bottom ; 
  cnaya -> cont_mark_stack_copied = resume_mc -> cont_mark_stack_copied ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5246 "./../src/fun.c"
void prune_cont_marks (Scheme_Meta_Continuation * resume_mc , Scheme_Cont * cont , Scheme_Object * extra_marks ) 
{
  Scheme_Object * val ; 
  Scheme_Hash_Table * ht ; 
  intptr_t pos , num_overlap , num_coverlap , new_overlap , base , i ; 
  Scheme_Cont_Mark * cp ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(val, 1), PUSH(extra_marks, 2), PUSH(cp, 3), PUSH(cont, 4), PUSH(resume_mc, 5)));
# define XfOrM987_COUNT (6)
# define SETUP_XfOrM987(x) SETUP(XfOrM987_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  val = NULLED_OUT ; 
  ht = NULLED_OUT ; 
  cp = NULLED_OUT ; 

# 5253 "./../src/fun.c"
  for (pos = resume_mc -> cont_mark_total , num_overlap = 0 ; 
  pos -- ; 
  num_overlap ++ ) {
    if (resume_mc -> cont_mark_stack_copied [pos ] . pos != resume_mc -> cont_mark_pos )
      break ; 
  }

  if (! num_overlap && (! extra_marks || ! (((Scheme_Vector * ) (extra_marks ) ) -> size ) ) ) {

    RET_NOTHING ; 
  }

  for (pos = 0 , num_coverlap = 0 ; 
  pos < cont -> cont_mark_total ; 
  num_coverlap ++ , pos ++ ) {
    if (cont -> cont_mark_stack_copied [pos ] . pos != (cont -> cont_mark_pos_bottom + 2 ) )
      break ; 
  }

  if (! num_coverlap && (! extra_marks || ! (((Scheme_Vector * ) (extra_marks ) ) -> size ) ) ) {

    RET_NOTHING ; 
  }


  ht = FUNCCALL(SETUP_XfOrM987(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

  for (pos = resume_mc -> cont_mark_total - 1 , i = 0 ; i < num_overlap ; i ++ , pos -- ) {
#   define XfOrM998_COUNT (0+XfOrM987_COUNT)
#   define SETUP_XfOrM998(x) SETUP_XfOrM987(x)

# 5281 "./../src/fun.c"
    val = resume_mc -> cont_mark_stack_copied [pos ] . val ; 
    if (! val )
      val = cont_key ; 
    FUNCCALL(SETUP_XfOrM998(_), scheme_hash_set (ht , resume_mc -> cont_mark_stack_copied [pos ] . key , val ) )

    ; 
  }
  if (extra_marks ) {
#   define XfOrM994_COUNT (0+XfOrM987_COUNT)
#   define SETUP_XfOrM994(x) SETUP_XfOrM987(x)

# 5289 "./../src/fun.c"
    for (i = 0 ; i < (((Scheme_Vector * ) (extra_marks ) ) -> size ) ; i += 2 ) {
#     define XfOrM996_COUNT (0+XfOrM994_COUNT)
#     define SETUP_XfOrM996(x) SETUP_XfOrM994(x)

# 5290 "./../src/fun.c"
      val = (((Scheme_Vector * ) (extra_marks ) ) -> els ) [i + 1 ] ; 
      if (! val )
        val = cont_key ; 
      FUNCCALL(SETUP_XfOrM996(_), scheme_hash_set (ht , (((Scheme_Vector * ) (extra_marks ) ) -> els ) [i ] , val ) ); 
    }
  }
  for (pos = 0 , i = 0 ; i < num_coverlap ; i ++ , pos ++ ) {
#   define XfOrM993_COUNT (0+XfOrM987_COUNT)
#   define SETUP_XfOrM993(x) SETUP_XfOrM987(x)
    FUNCCALL(SETUP_XfOrM993(_), scheme_hash_set (ht , cont -> cont_mark_stack_copied [pos ] . key , ((void * ) 0 ) ) ); 
  }

  new_overlap = ht -> count ; 


  base = resume_mc -> cont_mark_total - num_overlap ; 
  cp = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM987(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (base + new_overlap ) ) )) ; 
  (memcpy (cp , resume_mc -> cont_mark_stack_copied , base * sizeof (Scheme_Cont_Mark ) ) ) ; 
  resume_mc -> cont_mark_stack_copied = cp ; 
  resume_mc -> cont_mark_total = base + new_overlap ; 
  resume_mc -> cm_shared = 0 ; 
  resume_mc -> cont_mark_stack += (new_overlap - num_overlap ) ; 
  for (i = 0 ; i < ht -> size ; i ++ ) {
    if (ht -> vals [i ] ) {
      cp [base ] . key = ht -> keys [i ] ; 
      val = ht -> vals [i ] ; 
      if ((val ) == (cont_key ) ) 
        val = ((void * ) 0 ) ; 
      cp [base ] . val = val ; 
      cp [base ] . pos = resume_mc -> cont_mark_pos ; 
      cp [base ] . cache = ((void * ) 0 ) ; 
      base ++ ; 
    }
  }
  FUNCCALL_EMPTY(sync_meta_cont (resume_mc ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5328 "./../src/fun.c"
static intptr_t exec_dyn_wind_pres (Scheme_Dynamic_Wind_List * dwl , 
int dwl_len , 
Scheme_Cont * cont , 
intptr_t copied_cms , 
int clear_cm_caches , 
Scheme_Object * * _sub_conts , 
int skip_dws ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  int old_cac = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) ; 
  int need_clone = 0 ; 
  Scheme_Dynamic_Wind * dw ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(dw, 1), PUSH(_sub_conts, 2), PUSH(cont, 3), PUSH(dwl, 4)));
# define XfOrM1005_COUNT (5)
# define SETUP_XfOrM1005(x) SETUP(XfOrM1005_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  dw = NULLED_OUT ; 

# 5341 "./../src/fun.c"
  for (; dwl ; dwl = dwl -> next ) {
#   define XfOrM1014_COUNT (0+XfOrM1005_COUNT)
#   define SETUP_XfOrM1014(x) SETUP_XfOrM1005(x)

# 5342 "./../src/fun.c"
    if (dwl -> dw -> pre ) {
#     define XfOrM1017_COUNT (0+XfOrM1014_COUNT)
#     define SETUP_XfOrM1017(x) SETUP_XfOrM1014(x)

# 5343 "./../src/fun.c"
      p -> next_meta = dwl -> meta_depth + dwl -> dw -> next_meta ; 
      if (dwl -> meta_depth > 0 ) {
#       define XfOrM1021_COUNT (0+XfOrM1017_COUNT)
#       define SETUP_XfOrM1021(x) SETUP_XfOrM1017(x)

# 5345 "./../src/fun.c"
        if (! skip_dws )
          FUNCCALL(SETUP_XfOrM1021(_), scheme_apply_dw_in_meta (dwl -> dw , 0 , dwl -> meta_depth , cont ) ); 
      }

# 5347 "./../src/fun.c"
      else {



        DW_PrePost_Proc pre = dwl -> dw -> pre ; 
#       define XfOrM1018_COUNT (0+XfOrM1017_COUNT)
#       define SETUP_XfOrM1018(x) SETUP_XfOrM1017(x)
        FUNCCALL(SETUP_XfOrM1018(_), copy_in_mark_stack (p , cont -> cont_mark_stack_copied , dwl -> dw -> envss . cont_mark_stack , copied_cms , cont -> cont_mark_offset , _sub_conts , clear_cm_caches , dwl -> dw -> envss . cont_mark_pos ) )

        ; 
        copied_cms = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 

        if (! skip_dws )
          FUNCCALL(SETUP_XfOrM1018(_), pre (dwl -> dw -> data ) ); 

        if (! cont -> composable ) {
#         define XfOrM1019_COUNT (0+XfOrM1018_COUNT)
#         define SETUP_XfOrM1019(x) SETUP_XfOrM1018(x)

# 5363 "./../src/fun.c"
          if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) != old_cac ) {
#           define XfOrM1020_COUNT (0+XfOrM1019_COUNT)
#           define SETUP_XfOrM1020(x) SETUP_XfOrM1019(x)

# 5364 "./../src/fun.c"
            old_cac = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) ; 
            FUNCCALL(SETUP_XfOrM1020(_), scheme_recheck_prompt_and_barrier (cont ) ); 
          }
        }
      }
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    }

    if (p -> dw != dwl -> dw -> prev ) {


      need_clone = 1 ; 
    }

    if (need_clone ) {
#     define XfOrM1015_COUNT (0+XfOrM1014_COUNT)
#     define SETUP_XfOrM1015(x) SETUP_XfOrM1014(x)

# 5379 "./../src/fun.c"
      dw = FUNCCALL(SETUP_XfOrM1015(_), clone_dyn_wind (dwl -> dw , ((void * ) 0 ) , - 1 , 1 , p -> dw , 0 , 0 ) ); 
      dw -> next_meta = p -> next_meta ; 
    }

# 5381 "./../src/fun.c"
    else 
    dw = dwl -> dw ; 
    p -> dw = dw ; 
  }
  RET_VALUE_START (copied_cms ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5388 "./../src/fun.c"
static void root_prompt_tag_misuse (const char * who ) 
{
  /* No conversion */

# 5390 "./../src/fun.c"
  scheme_signal_error ("%s: misuse of root prompt tag" , who ) ; 
}

static Scheme_Object * 
call_cc (int argc , Scheme_Object * argv [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM1023_COUNT (1)
# define SETUP_XfOrM1023(x) SETUP(XfOrM1023_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM1023(_), scheme_check_proc_arity ("call-with-current-continuation" , 1 , 0 , argc , argv ) )
# 5397 "./../src/fun.c"
  ; 
  if (argc > 1 ) {
#   define XfOrM1024_COUNT (0+XfOrM1023_COUNT)
#   define SETUP_XfOrM1024(x) SETUP_XfOrM1023(x)

# 5399 "./../src/fun.c"
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) ) 
    && ! (((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("call-with-current-continuation" , "continuation-prompt-tag?" , 1 , argc , argv ) )
    ; 
  }



  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (internal_call_cc_prim , argc , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5411 "./../src/fun.c"
static Scheme_Cont * grab_continuation (Scheme_Thread * p , int for_prompt , int composable , 
Scheme_Object * prompt_tag , Scheme_Object * pt , 
Scheme_Cont * sub_cont , Scheme_Prompt * prompt , 
Scheme_Meta_Continuation * prompt_cont , 
Scheme_Prompt * effective_barrier_prompt , 
int cm_only , 
int argc , Scheme_Object * * argv ) 
{
  Scheme_Cont * cont ; 
  Scheme_Cont_Jmp * buf_ptr ; 

# 1046 "./../src/fun.c"
  Scheme_Object * * __funcarg205 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Cont * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(pt, 0), PUSH(p, 1), PUSH(buf_ptr, 2), PUSH(sub_cont, 3), PUSH(prompt_cont, 4), PUSH(prompt, 5), PUSH(effective_barrier_prompt, 6), PUSH(argv, 7), PUSH(cont, 8), PUSH(prompt_tag, 9)));
# define XfOrM1025_COUNT (10)
# define SETUP_XfOrM1025(x) SETUP(XfOrM1025_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cont = NULLED_OUT ; 
  buf_ptr = NULLED_OUT ; 

# 5422 "./../src/fun.c"
  cont = ((Scheme_Cont * ) FUNCCALL(SETUP_XfOrM1025(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  cont -> so . type = scheme_cont_type ; 

  if (! for_prompt && ! composable && ! cm_only ) {
#   define XfOrM1049_COUNT (0+XfOrM1025_COUNT)
#   define SETUP_XfOrM1049(x) SETUP_XfOrM1025(x)
    FUNCCALL(SETUP_XfOrM1049(_), scheme_set_cont_mark (cont_key , (Scheme_Object * ) cont ) )
# 5427 "./../src/fun.c"
    ; 
  }

  if (composable )
    cont -> composable = 1 ; 

  buf_ptr = ((Scheme_Cont_Jmp * ) FUNCCALL(SETUP_XfOrM1025(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont_Jmp ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  buf_ptr -> type = scheme_rt_cont_jmp ; 
  cont -> buf_ptr = buf_ptr ; 

  if (! cm_only ) {
#   define XfOrM1045_COUNT (0+XfOrM1025_COUNT)
#   define SETUP_XfOrM1045(x) SETUP_XfOrM1025(x)
    FUNCCALL(SETUP_XfOrM1045(_), scheme_init_jmpup_buf (& cont -> buf_ptr -> buf ) )
# 5438 "./../src/fun.c"
    ; 
    cont -> prompt_tag = prompt_tag ; 
    if (for_prompt )
      cont -> dw = ((void * ) 0 ) ; 
    else if (prompt ) {
      Scheme_Dynamic_Wind * dw ; 
      BLOCK_SETUP((PUSH(dw, 0+XfOrM1045_COUNT)));
#     define XfOrM1047_COUNT (1+XfOrM1045_COUNT)
#     define SETUP_XfOrM1047(x) SETUP(XfOrM1047_COUNT)
      dw = NULLED_OUT ; 

# 5444 "./../src/fun.c"
      if (p -> dw ) {
#       define XfOrM1048_COUNT (0+XfOrM1047_COUNT)
#       define SETUP_XfOrM1048(x) SETUP_XfOrM1047(x)

# 5445 "./../src/fun.c"
        dw = FUNCCALL(SETUP_XfOrM1048(_), clone_dyn_wind (p -> dw , pt , - 1 , - 1 , ((void * ) 0 ) , 0 , composable ) ); 
        cont -> dw = dw ; 
        cont -> next_meta = p -> next_meta ; 
      }

# 5448 "./../src/fun.c"
      else 
      cont -> dw = ((void * ) 0 ) ; 
    }

# 5450 "./../src/fun.c"
    else {
      cont -> dw = p -> dw ; 
      cont -> next_meta = p -> next_meta ; 
    }
  }
  if (! for_prompt )
    FUNCCALL(SETUP_XfOrM1025(_), ASSERT_SUSPEND_BREAK_ZERO () ); 
  FUNCCALL(SETUP_XfOrM1025(_), copy_cjs (& cont -> cjs , & p -> cjs ) ); 
  cont -> save_overflow = p -> overflow ; 
  (cont -> ss . runstack_offset = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) , cont -> ss . cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) , cont -> ss . cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ; 
  cont -> runstack_size = p -> runstack_size ; 
  cont -> runstack_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ; 
  cont -> runstack_saved = p -> runstack_saved ; 
  cont -> meta_tail_pos = (prompt ? prompt -> boundary_mark_pos + 2 : 0 ) ; 
  cont -> init_config = p -> init_config ; 
  cont -> init_break_cell = p -> init_break_cell ; 
  if (for_prompt || cm_only ) {
    cont -> meta_continuation = ((void * ) 0 ) ; 
  }

# 5468 "./../src/fun.c"
  else if (prompt ) {
    Scheme_Meta_Continuation * mc ; 
    BLOCK_SETUP((PUSH(mc, 0+XfOrM1025_COUNT)));
#   define XfOrM1042_COUNT (1+XfOrM1025_COUNT)
#   define SETUP_XfOrM1042(x) SETUP(XfOrM1042_COUNT)
    mc = NULLED_OUT ; 

# 5470 "./../src/fun.c"
    mc = FUNCCALL(SETUP_XfOrM1042(_), clone_meta_cont (p -> meta_continuation , pt , - 1 , prompt_cont , prompt , ((void * ) 0 ) , composable ) ); 
    cont -> meta_continuation = mc ; 
    if (! prompt_cont ) {
#     define XfOrM1043_COUNT (0+XfOrM1042_COUNT)
#     define SETUP_XfOrM1043(x) SETUP_XfOrM1042(x)
      FUNCCALL(SETUP_XfOrM1043(_), init_prompt_id (prompt ) ); 
      cont -> prompt_id = prompt -> id ; 
    }
    cont -> has_prompt_dw = 1 ; 
  }

# 5479 "./../src/fun.c"
  else 
  cont -> meta_continuation = p -> meta_continuation ; 

  if (! cm_only ) {



    Scheme_Object * meta_continuation_src ; 
    BLOCK_SETUP((PUSH(meta_continuation_src, 0+XfOrM1025_COUNT)));
#   define XfOrM1041_COUNT (1+XfOrM1025_COUNT)
#   define SETUP_XfOrM1041(x) SETUP(XfOrM1041_COUNT)
    meta_continuation_src = NULLED_OUT ; 

# 5487 "./../src/fun.c"
    meta_continuation_src = FUNCCALL(SETUP_XfOrM1041(_), scheme_make_weak_box ((Scheme_Object * ) p -> meta_continuation ) ); 
    cont -> meta_continuation_src = meta_continuation_src ; 
  }

  if (effective_barrier_prompt ) {
    cont -> barrier_prompt = effective_barrier_prompt ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_prompt_capture_count_ ) ++ ; 
  }

  if (p -> meta_prompt && prompt_cont )
    prompt = p -> meta_prompt ; 

  if (! cm_only ) {
    Scheme_Overflow * overflow ; 
    BLOCK_SETUP((PUSH(overflow, 0+XfOrM1025_COUNT)));
#   define XfOrM1036_COUNT (1+XfOrM1025_COUNT)
#   define SETUP_XfOrM1036(x) SETUP(XfOrM1036_COUNT)
    overflow = NULLED_OUT ; 

# 5502 "./../src/fun.c"
    for (overflow = p -> overflow ; overflow ; overflow = overflow -> prev ) {
      overflow -> jmp -> captured = 1 ; 
    }

    if (prompt ) {
#     define XfOrM1037_COUNT (0+XfOrM1036_COUNT)
#     define SETUP_XfOrM1037(x) SETUP_XfOrM1036(x)

# 5507 "./../src/fun.c"
      overflow = FUNCCALL(SETUP_XfOrM1037(_), clone_overflows (p -> overflow , prompt -> boundary_overflow_id , ((void * ) 0 ) ) ); 
      cont -> save_overflow = overflow ; 
    }
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ++ ; 
  }

  if ((! effective_barrier_prompt || ! effective_barrier_prompt -> is_barrier ) && ! cm_only ) {
#   define XfOrM1033_COUNT (0+XfOrM1025_COUNT)
#   define SETUP_XfOrM1033(x) SETUP_XfOrM1025(x)
    if (! p -> runstack_owner ) {
      Scheme_Thread * * owner ; 
      BLOCK_SETUP((PUSH(owner, 0+XfOrM1033_COUNT)));
#     define XfOrM1035_COUNT (1+XfOrM1033_COUNT)
#     define SETUP_XfOrM1035(x) SETUP(XfOrM1035_COUNT)
      owner = NULLED_OUT ; 

# 5518 "./../src/fun.c"
      owner = ((Scheme_Thread * * ) FUNCCALL(SETUP_XfOrM1035(_), GC_malloc (sizeof (Scheme_Thread * ) * (1 ) ) )) ; 
      p -> runstack_owner = owner ; 
      * owner = p ; 
    }
    if (cont -> ss . cont_mark_stack && ! p -> cont_mark_stack_owner ) {
      Scheme_Thread * * owner ; 
      BLOCK_SETUP((PUSH(owner, 0+XfOrM1033_COUNT)));
#     define XfOrM1034_COUNT (1+XfOrM1033_COUNT)
#     define SETUP_XfOrM1034(x) SETUP(XfOrM1034_COUNT)
      owner = NULLED_OUT ; 

# 5524 "./../src/fun.c"
      owner = ((Scheme_Thread * * ) FUNCCALL(SETUP_XfOrM1034(_), GC_malloc (sizeof (Scheme_Thread * ) * (1 ) ) )) ; 
      p -> cont_mark_stack_owner = owner ; 
      * owner = p ; 
    }
  }

# 5540 "./../src/fun.c"
  if (! cm_only ) {
    Scheme_Saved_Stack * saved ; 
    BLOCK_SETUP((PUSH(saved, 0+XfOrM1025_COUNT)));
#   define XfOrM1028_COUNT (1+XfOrM1025_COUNT)
#   define SETUP_XfOrM1028(x) SETUP(XfOrM1028_COUNT)
    saved = NULLED_OUT ; 

# 5542 "./../src/fun.c"
    saved = FUNCCALL(SETUP_XfOrM1028(_), copy_out_runstack (p , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) , sub_cont , (for_prompt ? p -> meta_prompt : prompt ) ) )
    ; 
    if (argv == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) ) {


      intptr_t i ; 
      for (i = 0 ; i < argc ; i ++ ) {
        saved -> runstack_start [i ] = scheme_false ; 
      }
    }
    cont -> runstack_copied = saved ; 
    if (! for_prompt && prompt ) {
#     define XfOrM1029_COUNT (0+XfOrM1028_COUNT)
#     define SETUP_XfOrM1029(x) SETUP_XfOrM1028(x)


      if ((scheme_prompt_runstack_boundary_start (prompt ) ) == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) )
        saved = ((void * ) 0 ) ; 
      else 
      saved = (__funcarg205 = (
      scheme_prompt_runstack_boundary_start (prompt ) ) , FUNCCALL(SETUP_XfOrM1029(_), clone_runstack_saved (cont -> runstack_saved , __funcarg205 , ((void * ) 0 ) ) )) 
      ; 
      cont -> runstack_saved = saved ; 
    }
  }

  {
    Scheme_Prompt * effective_prompt ; 
    Scheme_Cont_Mark * msaved ; 
    intptr_t offset ; 
    BLOCK_SETUP((PUSH(effective_prompt, 0+XfOrM1025_COUNT), PUSH(msaved, 1+XfOrM1025_COUNT)));
#   define XfOrM1027_COUNT (2+XfOrM1025_COUNT)
#   define SETUP_XfOrM1027(x) SETUP(XfOrM1027_COUNT)
    effective_prompt = NULLED_OUT ; 
    msaved = NULLED_OUT ; 

# 5572 "./../src/fun.c"
    effective_prompt = (for_prompt ? p -> meta_prompt : prompt ) ; 
    msaved = FUNCCALL(SETUP_XfOrM1027(_), copy_out_mark_stack (p , cont -> ss . cont_mark_stack , sub_cont , & offset , effective_prompt , ! ! prompt ) )







    ; 
    cont -> cont_mark_stack_copied = msaved ; 
    cont -> cont_mark_offset = offset ; 
    if (effective_prompt )
      cont -> cont_mark_total = cont -> ss . cont_mark_stack - effective_prompt -> mark_boundary ; 
    else 
    cont -> cont_mark_total = cont -> ss . cont_mark_stack ; 
    offset = FUNCCALL(SETUP_XfOrM1027(_), find_shareable_marks () ); 
    cont -> cont_mark_nonshare = cont -> ss . cont_mark_stack - offset ; 




    cont -> cont_mark_pos_bottom = (effective_prompt 
    ? effective_prompt -> boundary_mark_pos 
    : 1 ) ; 
  }

  if (! cm_only ) {
    cont -> runstack_owner = p -> runstack_owner ; 
    cont -> cont_mark_stack_owner = p -> cont_mark_stack_owner ; 

    cont -> stack_start = p -> stack_start ; 

    cont -> savebuf = p -> error_buf ; 

    if (prompt )
      cont -> prompt_buf = prompt -> prompt_buf ; 
  }

  RET_VALUE_START (cont ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5614 "./../src/fun.c"
static void restore_continuation (Scheme_Cont * cont , Scheme_Thread * p , int for_prompt , 
Scheme_Object * result , 
Scheme_Overflow * resume , int empty_to_next_mc , 
Scheme_Object * prompt_tag , 
Scheme_Dynamic_Wind * common_dw , int common_next_meta , 
Scheme_Prompt * shortcut_prompt , 
int clear_cm_caches , int do_reset_cjs , 
Scheme_Cont * cm_cont , Scheme_Object * extra_marks ) 
{
  intptr_t copied_cms = 0 ; 
  Scheme_Object * * mv , * sub_conts = ((void * ) 0 ) ; 
  Scheme_Cont * sub_cont ; 
  int mc ; 
  PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(result, 0), PUSH(p, 1), PUSH(cont, 2), PUSH(cm_cont, 3), PUSH(common_dw, 4), PUSH(sub_cont, 5), PUSH(extra_marks, 6), PUSH(sub_conts, 7), PUSH(mv, 8), PUSH(resume, 9), PUSH(prompt_tag, 10), PUSH(shortcut_prompt, 11)));
# define XfOrM1050_COUNT (12)
# define SETUP_XfOrM1050(x) SETUP(XfOrM1050_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  mv = NULLED_OUT ; 
  sub_cont = NULLED_OUT ; 

# 5628 "./../src/fun.c"
  if ((result ) == (((Scheme_Object * ) 0x6 ) ) )  {

    mv = p -> ku . multiple . array ; 
    mc = p -> ku . multiple . count ; 
    if ((mv ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
  }

# 5635 "./../src/fun.c"
  else {
    mv = ((void * ) 0 ) ; 
    mc = 0 ; 
  }

  p -> error_buf = cont -> savebuf ; 

  p -> init_config = cont -> init_config ; 
  p -> init_break_cell = cont -> init_break_cell ; 

  if (do_reset_cjs )
    FUNCCALL(SETUP_XfOrM1050(_), copy_cjs (& p -> cjs , & cont -> cjs ) ); 
  if (shortcut_prompt ) {
    Scheme_Overflow * overflow ; 
    BLOCK_SETUP((PUSH(overflow, 0+XfOrM1050_COUNT)));
#   define XfOrM1111_COUNT (1+XfOrM1050_COUNT)
#   define SETUP_XfOrM1111(x) SETUP(XfOrM1111_COUNT)
    overflow = NULLED_OUT ; 

# 5649 "./../src/fun.c"
    overflow = FUNCCALL(SETUP_XfOrM1111(_), clone_overflows (cont -> save_overflow , ((void * ) 0 ) , p -> overflow ) ); 
    p -> overflow = overflow ; 
  }

# 5651 "./../src/fun.c"
  else {
    p -> overflow = cont -> save_overflow ; 
  }
  if (for_prompt ) {
    if (p -> meta_prompt )
      cont -> need_meta_prompt = 1 ; 
  }

# 5657 "./../src/fun.c"
  else {
    Scheme_Meta_Continuation * mc , * resume_mc ; 
    BLOCK_SETUP((PUSH(resume_mc, 0+XfOrM1050_COUNT), PUSH(mc, 1+XfOrM1050_COUNT)));
#   define XfOrM1102_COUNT (2+XfOrM1050_COUNT)
#   define SETUP_XfOrM1102(x) SETUP(XfOrM1102_COUNT)
    mc = NULLED_OUT ; 
    resume_mc = NULLED_OUT ; 

# 5659 "./../src/fun.c"
    if (resume ) {
#     define XfOrM1106_COUNT (0+XfOrM1102_COUNT)
#     define SETUP_XfOrM1106(x) SETUP_XfOrM1102(x)

# 5660 "./../src/fun.c"
      resume_mc = ((Scheme_Meta_Continuation * ) FUNCCALL(SETUP_XfOrM1106(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Meta_Continuation ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

      resume_mc -> type = scheme_rt_meta_cont ; 

      resume_mc -> overflow = resume ; 

      resume_mc -> prompt_tag = prompt_tag ; 
      resume_mc -> pseudo = cont -> composable ; 
      resume_mc -> empty_to_next = empty_to_next_mc ; 
      resume_mc -> meta_tail_pos = cont -> meta_tail_pos ; 

      if (! cm_cont ) {
      }

      else {
        resume_mc -> cont_mark_stack = cm_cont -> ss . cont_mark_stack ; 
        resume_mc -> cont_mark_pos = cm_cont -> ss . cont_mark_pos ; 
        resume_mc -> cont_mark_total = cm_cont -> cont_mark_total ; 
        resume_mc -> cont_mark_offset = cm_cont -> cont_mark_offset ; 
        resume_mc -> cont_mark_pos_bottom = cm_cont -> cont_mark_pos_bottom ; 
        resume_mc -> cont_mark_stack_copied = cm_cont -> cont_mark_stack_copied ; 

        resume_mc -> cont = cm_cont ; 

        resume_mc -> cm_caches = 1 ; 

        resume_mc -> next = p -> meta_continuation ; 
        if (p -> meta_continuation )
          resume_mc -> depth = p -> meta_continuation -> depth + 1 ; 
      }
    }

# 5690 "./../src/fun.c"
    else 
    resume_mc = ((void * ) 0 ) ; 
    if (resume_mc ) {
#     define XfOrM1104_COUNT (0+XfOrM1102_COUNT)
#     define SETUP_XfOrM1104(x) SETUP_XfOrM1102(x)

# 5693 "./../src/fun.c"
      if (cont -> composable ) {
#       define XfOrM1105_COUNT (0+XfOrM1104_COUNT)
#       define SETUP_XfOrM1105(x) SETUP_XfOrM1104(x)
        FUNCCALL(SETUP_XfOrM1105(_), prune_cont_marks (resume_mc , cont , extra_marks ) ); 
        p -> cont_mark_pos_bottom = cont -> cont_mark_pos_bottom ; 
      }

      mc = FUNCCALL(SETUP_XfOrM1104(_), clone_meta_cont (cont -> meta_continuation , ((void * ) 0 ) , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , resume_mc , 0 ) ); 
    }

# 5701 "./../src/fun.c"
    else if (shortcut_prompt ) {
#     define XfOrM1103_COUNT (0+XfOrM1102_COUNT)
#     define SETUP_XfOrM1103(x) SETUP_XfOrM1102(x)

# 5702 "./../src/fun.c"
      mc = FUNCCALL(SETUP_XfOrM1103(_), clone_meta_cont (cont -> meta_continuation , ((void * ) 0 ) , - 1 , ((void * ) 0 ) , ((void * ) 0 ) , p -> meta_continuation , 0 ) ); 
    }

# 5703 "./../src/fun.c"
    else 
    mc = cont -> meta_continuation ; 
    p -> meta_continuation = mc ; 
  }

  if (shortcut_prompt ) {


    Scheme_Saved_Stack * rs ; 
    BLOCK_SETUP((PUSH(rs, 0+XfOrM1050_COUNT)));
#   define XfOrM1098_COUNT (1+XfOrM1050_COUNT)
#   define SETUP_XfOrM1098(x) SETUP(XfOrM1098_COUNT)
    rs = NULLED_OUT ; 

# 5712 "./../src/fun.c"
    if ((scheme_prompt_runstack_boundary_start (shortcut_prompt ) ) == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) )
      rs = p -> runstack_saved ; 
    else {
#     define XfOrM1099_COUNT (0+XfOrM1098_COUNT)
#     define SETUP_XfOrM1099(x) SETUP_XfOrM1098(x)

# 5715 "./../src/fun.c"
      rs = p -> runstack_saved ; 
      while (rs && (rs -> runstack_start != (scheme_prompt_runstack_boundary_start (shortcut_prompt ) ) ) ) {
        rs = rs -> prev ; 
      }
      if (rs )
        rs = rs -> prev ; 
    }
    if (rs )
      rs = FUNCCALL(SETUP_XfOrM1098(_), clone_runstack_saved (cont -> runstack_saved , ((void * ) 0 ) , rs ) ); 
    else 
    rs = cont -> runstack_saved ; 
    p -> runstack_saved = rs ; 
  }

# 5727 "./../src/fun.c"
  else 
  p -> runstack_saved = cont -> runstack_saved ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = cont -> runstack_start ; 
  p -> runstack_size = cont -> runstack_size ; 

  (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + cont -> ss . runstack_offset , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = cont -> ss . cont_mark_stack , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = cont -> ss . cont_mark_pos ) ; 

  if (p -> runstack_owner 
  && (* p -> runstack_owner == p ) ) {
    * p -> runstack_owner = ((void * ) 0 ) ; 
  }

  if (resume )
    p -> meta_prompt = ((void * ) 0 ) ; 

  p -> runstack_owner = cont -> runstack_owner ; 
  if (p -> runstack_owner && (* p -> runstack_owner != p ) ) {
    Scheme_Thread * op ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM1050_COUNT)));
#   define XfOrM1095_COUNT (1+XfOrM1050_COUNT)
#   define SETUP_XfOrM1095(x) SETUP(XfOrM1095_COUNT)
    op = NULLED_OUT ; 

# 5746 "./../src/fun.c"
    op = * p -> runstack_owner ; 
    if (op ) {
      Scheme_Saved_Stack * saved ; 
      BLOCK_SETUP((PUSH(saved, 0+XfOrM1095_COUNT)));
#     define XfOrM1096_COUNT (1+XfOrM1095_COUNT)
#     define SETUP_XfOrM1096(x) SETUP(XfOrM1096_COUNT)
      saved = NULLED_OUT ; 

# 5749 "./../src/fun.c"
      saved = FUNCCALL(SETUP_XfOrM1096(_), copy_out_runstack (op , op -> runstack , op -> runstack_start , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
      op -> runstack_swapped = saved ; 
    }
    * p -> runstack_owner = p ; 
  }
  FUNCCALL(SETUP_XfOrM1050(_), copy_in_runstack (p , cont -> runstack_copied , 0 ) )




  ; 
  {
    intptr_t done = cont -> runstack_copied -> runstack_size , size ; 
#   define XfOrM1088_COUNT (0+XfOrM1050_COUNT)
#   define SETUP_XfOrM1088(x) SETUP_XfOrM1050(x)

# 5762 "./../src/fun.c"
    sub_cont = cont ; 
    while (sub_cont ) {
#     define XfOrM1092_COUNT (0+XfOrM1088_COUNT)
#     define SETUP_XfOrM1092(x) SETUP_XfOrM1088(x)

# 5764 "./../src/fun.c"
      if (sub_cont -> buf_ptr -> buf . cont 
      && (sub_cont -> runstack_start == sub_cont -> buf_ptr -> buf . cont -> runstack_start ) ) {
        intptr_t delta ; 
#       define XfOrM1093_COUNT (0+XfOrM1092_COUNT)
#       define SETUP_XfOrM1093(x) SETUP_XfOrM1092(x)

# 5768 "./../src/fun.c"
        sub_cont = sub_cont -> buf_ptr -> buf . cont ; 
        size = sub_cont -> runstack_copied -> runstack_size ; 


        if (size > 2 )
          delta = 2 ; 
        else 
        delta = size ; 
        if (size > delta ) {
#         define XfOrM1094_COUNT (0+XfOrM1093_COUNT)
#         define SETUP_XfOrM1094(x) SETUP_XfOrM1093(x)
          (
# 5777 "./../src/fun.c"
          memcpy (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) XFORM_OK_PLUS done , 
          sub_cont -> runstack_copied -> runstack_start + delta , 
          (size - delta ) * sizeof (Scheme_Object * ) ) ) ; 
          done += (size - delta ) ; 
        }
      }

# 5782 "./../src/fun.c"
      else 
      break ; 
    }
  }

  if (p -> cont_mark_stack_owner 
  && (* p -> cont_mark_stack_owner == p ) )
    * p -> cont_mark_stack_owner = ((void * ) 0 ) ; 

  p -> cont_mark_stack_owner = cont -> cont_mark_stack_owner ; 
  if (p -> cont_mark_stack_owner 
  && (* p -> cont_mark_stack_owner != p ) ) {
    Scheme_Thread * op ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM1050_COUNT)));
#   define XfOrM1086_COUNT (1+XfOrM1050_COUNT)
#   define SETUP_XfOrM1086(x) SETUP(XfOrM1086_COUNT)
    op = NULLED_OUT ; 

# 5795 "./../src/fun.c"
    op = * p -> cont_mark_stack_owner ; 
    if (op ) {
      Scheme_Cont_Mark * msaved ; 
      BLOCK_SETUP((PUSH(msaved, 0+XfOrM1086_COUNT)));
#     define XfOrM1087_COUNT (1+XfOrM1086_COUNT)
#     define SETUP_XfOrM1087(x) SETUP(XfOrM1087_COUNT)
      msaved = NULLED_OUT ; 

# 5798 "./../src/fun.c"
      msaved = FUNCCALL(SETUP_XfOrM1087(_), copy_out_mark_stack (op , op -> cont_mark_stack , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
      op -> cont_mark_stack_swapped = msaved ; 
    }
    * p -> cont_mark_stack_owner = p ; 

    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = 0 ; 
  }





  if (resume || (for_prompt && cont -> need_meta_prompt ) ) {
    Scheme_Prompt * meta_prompt ; 
    BLOCK_SETUP((PUSH(meta_prompt, 0+XfOrM1050_COUNT)));
#   define XfOrM1072_COUNT (1+XfOrM1050_COUNT)
#   define SETUP_XfOrM1072(x) SETUP(XfOrM1072_COUNT)
    meta_prompt = NULLED_OUT ; 

# 5813 "./../src/fun.c"
    meta_prompt = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1072(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    meta_prompt -> so . type = scheme_prompt_type ; 
    meta_prompt -> stack_boundary = cont -> prompt_stack_start ; 
    meta_prompt -> boundary_overflow_id = ((void * ) 0 ) ; 
    {
      Scheme_Cont * tc ; 
      tc = NULLED_OUT ; 

# 5819 "./../src/fun.c"
      for (tc = cont ; tc -> buf_ptr -> buf . cont ; tc = tc -> buf_ptr -> buf . cont ) {
      }
      meta_prompt -> mark_boundary = tc -> cont_mark_offset ; 
    }
    meta_prompt -> prompt_buf = cont -> prompt_buf ; 
    {

      Scheme_Cont * rs_cont = cont ; 
      Scheme_Saved_Stack * saved , * actual ; 
      int delta = 0 ; 
#     define XfOrM1073_COUNT (0+XfOrM1072_COUNT)
#     define SETUP_XfOrM1073(x) SETUP_XfOrM1072(x)
      saved = NULLED_OUT ; 
      actual = NULLED_OUT ; 

# 5829 "./../src/fun.c"
      while (rs_cont -> buf_ptr -> buf . cont 
      && (rs_cont -> buf_ptr -> buf . cont -> runstack_start == cont -> runstack_start ) ) {
        delta += rs_cont -> runstack_copied -> runstack_size ; 
        rs_cont = rs_cont -> buf_ptr -> buf . cont ; 
        if (rs_cont -> runstack_copied -> runstack_size > 2 ) {
          delta -= 2 ; 
        }
      }
      actual = ((void * ) 0 ) ; 
      for (saved = rs_cont -> runstack_copied ; saved -> prev ; saved = saved -> prev ) {
        if (! actual )
          actual = p -> runstack_saved ; 
        else 
        actual = actual -> prev ; 
      }
      if (actual ) {
        meta_prompt -> u . runstack_boundary_start = actual -> runstack_start ; 
        meta_prompt -> runstack_boundary_offset = actual -> runstack_offset + saved -> runstack_size ; 
      }

# 5847 "./../src/fun.c"
      else {
#       define XfOrM1074_COUNT (0+XfOrM1073_COUNT)
#       define SETUP_XfOrM1074(x) SETUP_XfOrM1073(x)

# 5848 "./../src/fun.c"
        meta_prompt -> u . runstack_boundary_start = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ; 
        meta_prompt -> runstack_boundary_offset = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) ) + saved -> runstack_size + delta ; 
        ((void ) sizeof ((meta_prompt -> runstack_boundary_offset <= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_size ) ? 1 : 0 ) , __extension__ ({
#         define XfOrM1075_COUNT (0+XfOrM1074_COUNT)
#         define SETUP_XfOrM1075(x) SETUP_XfOrM1074(x)

# 5850 "./../src/fun.c" 3
          if (meta_prompt -> runstack_boundary_offset <= XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> runstack_size )

# 5850 "./../src/fun.c" 3
          ; 

# 5850 "./../src/fun.c" 3
          else FUNCCALL(SETUP_XfOrM1075(_), __assert_fail ("meta_prompt->runstack_boundary_offset <= XFORM_OK_ASSIGN ((&scheme_thread_locals)->scheme_current_thread_)->runstack_size" , "./../src/fun.c" , 5850 , __extension__ __PRETTY_FUNCTION__ ) ); 
        }
        ) ) 
# 5850 "./../src/fun.c"
        ; 
      }
    }

    meta_prompt -> boundary_mark_pos = cont -> cont_mark_pos_bottom ; 

    p -> meta_prompt = meta_prompt ; 
  }



  copied_cms = cont -> cont_mark_offset ; 
  for (sub_cont = cont -> buf_ptr -> buf . cont ; sub_cont ; sub_cont = sub_cont -> buf_ptr -> buf . cont ) {
#   define XfOrM1071_COUNT (0+XfOrM1050_COUNT)
#   define SETUP_XfOrM1071(x) SETUP_XfOrM1050(x)

# 5863 "./../src/fun.c"
    copied_cms = sub_cont -> cont_mark_offset ; 
    sub_conts = FUNCCALL(SETUP_XfOrM1071(_), scheme_make_raw_pair ((Scheme_Object * ) sub_cont , sub_conts ) ); 
  }

  if (! shortcut_prompt ) {
    Scheme_Cont * tc ; 
    tc = NULLED_OUT ; 

# 5869 "./../src/fun.c"
    for (tc = cont ; tc -> buf_ptr -> buf . cont ; tc = tc -> buf_ptr -> buf . cont ) {
    }
    p -> cont_mark_stack_bottom = tc -> cont_mark_offset ; 
    p -> cont_mark_pos_bottom = tc -> cont_mark_pos_bottom ; 
  }

  if (for_prompt ) {
  }
  else {




    Scheme_Dynamic_Wind * dw , * all_dw ; 
    Scheme_Dynamic_Wind_List * dwl = ((void * ) 0 ) ; 
    int common_depth , dwl_len = 0 ; 
    BLOCK_SETUP((PUSH(dw, 0+XfOrM1050_COUNT), PUSH(dwl, 1+XfOrM1050_COUNT), PUSH(all_dw, 2+XfOrM1050_COUNT)));
#   define XfOrM1052_COUNT (3+XfOrM1050_COUNT)
#   define SETUP_XfOrM1052(x) SETUP(XfOrM1052_COUNT)
    dw = NULLED_OUT ; 
    all_dw = NULLED_OUT ; 

# 5888 "./../src/fun.c"
    if (resume ) {
#     define XfOrM1060_COUNT (0+XfOrM1052_COUNT)
#     define SETUP_XfOrM1060(x) SETUP_XfOrM1052(x)
      if (cont -> composable ) {

        p -> next_meta ++ ; 
      }

# 5894 "./../src/fun.c"
      else {
#       define XfOrM1061_COUNT (0+XfOrM1060_COUNT)
#       define SETUP_XfOrM1061(x) SETUP_XfOrM1060(x)
        p -> dw = common_dw ; 
        p -> next_meta = common_next_meta ; 
        if (p -> dw ) {
#         define XfOrM1062_COUNT (0+XfOrM1061_COUNT)
#         define SETUP_XfOrM1062(x) SETUP_XfOrM1061(x)

# 5901 "./../src/fun.c"
          all_dw = FUNCCALL(SETUP_XfOrM1062(_), clone_dyn_wind (p -> dw , cont -> prompt_tag , - 1 , - 1 , ((void * ) 0 ) , 1 , 0 ) ); 
          for (dw = all_dw ; dw && ! ((dw -> prompt_tag ) == (cont -> prompt_tag ) ) ; dw = dw -> prev ) {
            p -> dw = p -> dw -> prev ; 
          }
          if (dw )
            dw -> next_meta += 1 ; 
          p -> dw = all_dw ; 
        }
      }
    }

# 5910 "./../src/fun.c"
    else {
      p -> dw = common_dw ; 
      p -> next_meta = common_next_meta ; 
    }

    if (cont -> dw ) {
      int meta_depth ; 
#     define XfOrM1053_COUNT (0+XfOrM1052_COUNT)
#     define SETUP_XfOrM1053(x) SETUP_XfOrM1052(x)



      common_depth = (p -> dw ? p -> dw -> depth : - 1 ) ; 
      all_dw = FUNCCALL(SETUP_XfOrM1053(_), clone_dyn_wind (cont -> dw , ((void * ) 0 ) , cont -> common_dw_depth , - 1 , p -> dw , 0 , 0 ) ); 

      if ((common_depth != - 1 ) && (common_depth != all_dw -> depth ) ) {

        for (dw = all_dw ; dw -> prev -> depth != common_depth ; dw = dw -> prev ) {
        }
        dw -> next_meta = p -> next_meta ; 
      }

      meta_depth = cont -> next_meta ; 
      for (dw = all_dw ; dw && (dw -> depth != common_depth ) ; dw = dw -> prev ) {
        Scheme_Dynamic_Wind_List * cell ; 
        BLOCK_SETUP((PUSH(cell, 0+XfOrM1053_COUNT)));
#       define XfOrM1055_COUNT (1+XfOrM1053_COUNT)
#       define SETUP_XfOrM1055(x) SETUP(XfOrM1055_COUNT)
        cell = NULLED_OUT ; 

# 5936 "./../src/fun.c"
        cell = ((Scheme_Dynamic_Wind_List * ) FUNCCALL(SETUP_XfOrM1055(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Dynamic_Wind_List ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

        cell -> type = scheme_rt_dyn_wind_cell ; 

        cell -> dw = dw ; 
        cell -> meta_depth = meta_depth ; 
        cell -> next = dwl ; 
        dwl = cell ; 
        dwl_len ++ ; 

        meta_depth += dw -> next_meta ; 
      }
      copied_cms = FUNCCALL(SETUP_XfOrM1053(_), exec_dyn_wind_pres (dwl , dwl_len , cont , copied_cms , clear_cm_caches , & sub_conts , cont -> skip_dws ) )
      ; 
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      p -> next_meta = cont -> next_meta ; 
    }
  }

  if (! for_prompt )
    p -> suspend_break = 0 ; 
  FUNCCALL(SETUP_XfOrM1050(_), copy_in_mark_stack (p , cont -> cont_mark_stack_copied , cont -> ss . cont_mark_stack , copied_cms , cont -> cont_mark_offset , & sub_conts , clear_cm_caches , cont -> ss . cont_mark_pos ) )






  ; 

  if ((result ) == (((Scheme_Object * ) 0x6 ) ) )  {
    p -> ku . multiple . array = mv ; 
    p -> ku . multiple . count = mc ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5972 "./../src/fun.c"
static Scheme_Object * 
internal_call_cc (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * ret , * volatile pt , * prompt_tag ; 
  Scheme_Cont * volatile cont ; 
  Scheme_Cont * sub_cont ; 
  Scheme_Meta_Continuation * prompt_cont , * barrier_cont ; 
  intptr_t prompt_pos , barrier_pos ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Prompt * prompt , * barrier_prompt , * effective_barrier_prompt ; 
  Scheme_Object * ec ; 
  GC_CAN_IGNORE void * stack_start ; 
  int composable ; 
  Scheme_Config * __funcarg206 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(barrier_cont, 1), PUSH(argv, 2), PUSH(ret, 3), PUSH(cont, 4), PUSH(pt, 5), PUSH(effective_barrier_prompt, 6), PUSH(sub_cont, 7), PUSH(prompt_cont, 8), PUSH(prompt, 9), PUSH(ec, 10), PUSH(barrier_prompt, 11), PUSH(prompt_tag, 12)));
# define XfOrM1114_COUNT (13)
# define SETUP_XfOrM1114(x) SETUP(XfOrM1114_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  ret = NULLED_OUT ; 
  pt = NULLED_OUT ; 
  prompt_tag = NULLED_OUT ; 
  cont = NULLED_OUT ; 
  sub_cont = NULLED_OUT ; 
  prompt_cont = NULLED_OUT ; 
  barrier_cont = NULLED_OUT ; 
  prompt = NULLED_OUT ; 
  barrier_prompt = NULLED_OUT ; 
  effective_barrier_prompt = NULLED_OUT ; 
  ec = NULLED_OUT ; 

# 5986 "./../src/fun.c"
  if (argc > 1 )
    prompt_tag = argv [1 ] ; 
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  if (((Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    pt = (((Scheme_Chaperone * ) prompt_tag ) -> val ) ; 
  else 
  pt = prompt_tag ; 

  composable = (argc > 2 ) ; 

  if ((pt ) == (scheme_root_prompt_tag ) )  {
#   define XfOrM1137_COUNT (0+XfOrM1114_COUNT)
#   define SETUP_XfOrM1137(x) SETUP_XfOrM1114(x)
    FUNCCALL(SETUP_XfOrM1137(_), root_prompt_tag_misuse (composable ? "call-with-composable-continuation" : "call-with-current-continuation" ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  prompt = FUNCCALL(SETUP_XfOrM1114(_), scheme_get_prompt ((((Scheme_Small_Object * ) (pt ) ) -> u . ptr_val ) , & prompt_cont , & prompt_pos ) ); 
  if (! prompt && ! ((scheme_default_prompt_tag ) == (pt ) ) ) {
#   define XfOrM1136_COUNT (0+XfOrM1114_COUNT)
#   define SETUP_XfOrM1136(x) SETUP_XfOrM1114(x)
    FUNCCALL(SETUP_XfOrM1136(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "%s: continuation includes no prompt with the given tag\n" "  tag: %V" , (composable ? "call-with-composable-continuation" : "call-with-current-continuation" ) , prompt_tag ) )



    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }





  if (prompt )
    prompt = FUNCCALL(SETUP_XfOrM1114(_), make_weak_prompt (prompt ) ); 

  barrier_prompt = FUNCCALL(SETUP_XfOrM1114(_), scheme_get_barrier_prompt (& barrier_cont , & barrier_pos ) ); 

  if (composable && (((argv [2 ] ) ) == (scheme_false ) ) ) {
#   define XfOrM1132_COUNT (0+XfOrM1114_COUNT)
#   define SETUP_XfOrM1132(x) SETUP_XfOrM1114(x)

# 6027 "./../src/fun.c"
    if (! prompt && ! barrier_prompt -> is_barrier ) {
    }
    else {
#     define XfOrM1133_COUNT (0+XfOrM1132_COUNT)
#     define SETUP_XfOrM1133(x) SETUP_XfOrM1132(x)

# 6030 "./../src/fun.c"
      if (! prompt 
      || FUNCCALL(SETUP_XfOrM1133(_), scheme_is_cm_deeper (prompt_cont , prompt_pos , barrier_cont , barrier_pos ) )) {
#       define XfOrM1134_COUNT (0+XfOrM1133_COUNT)
#       define SETUP_XfOrM1134(x) SETUP_XfOrM1133(x)
        FUNCCALL(SETUP_XfOrM1134(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "call-with-composable-continuation: cannot capture past continuation barrier" ) )
# 6033 "./../src/fun.c"
        ; 
      }
    }
  }

  effective_barrier_prompt = barrier_prompt ; 
  if (effective_barrier_prompt && prompt ) {
#   define XfOrM1131_COUNT (0+XfOrM1114_COUNT)
#   define SETUP_XfOrM1131(x) SETUP_XfOrM1114(x)

# 6040 "./../src/fun.c"
    if (FUNCCALL(SETUP_XfOrM1131(_), scheme_is_cm_deeper (barrier_cont , barrier_pos , prompt_cont , prompt_pos ) ))

    effective_barrier_prompt = ((void * ) 0 ) ; 
  }

  if (composable )
    sub_cont = ((void * ) 0 ) ; 
  else 
  sub_cont = (Scheme_Cont * ) FUNCCALL(SETUP_XfOrM1114(_), scheme_extract_one_cc_mark (((void * ) 0 ) , cont_key ) ); 
  if (sub_cont 
  && (sub_cont -> save_overflow == p -> overflow ) 
  && (sub_cont -> prompt_tag == prompt_tag ) 
  && (sub_cont -> barrier_prompt == effective_barrier_prompt ) 
  && (((Scheme_Escaping_Cont * ) sub_cont -> escape_cont ) -> myerr == p -> error_buf ) ) {




    ec = sub_cont -> escape_cont ; 
  }

# 6059 "./../src/fun.c"
  else 
  ec = ((void * ) 0 ) ; 
  if (sub_cont && ((sub_cont -> save_overflow != p -> overflow ) 
  || (sub_cont -> prompt_tag != prompt_tag ) 
  || (sub_cont -> barrier_prompt != effective_barrier_prompt ) 
  || ((Scheme_Meta_Continuation * ) (((Scheme_Small_Object * ) (sub_cont -> meta_continuation_src ) ) -> u . ptr_val ) 
  != p -> meta_continuation ) ) ) {
    sub_cont = ((void * ) 0 ) ; 
  }
  if (sub_cont && (sub_cont -> ss . cont_mark_pos == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ) {
    Scheme_Object * argv2 [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(argv2, 1, 0+XfOrM1114_COUNT)));
#   define XfOrM1126_COUNT (3+XfOrM1114_COUNT)
#   define SETUP_XfOrM1126(x) SETUP(XfOrM1126_COUNT)
    argv2[0] = NULLED_OUT ; 






    if (! sub_cont -> cont_mark_nonshare 
    && (FUNCCALL(SETUP_XfOrM1126(_), find_shareable_marks () )== XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ) ) 
# 6093 "./../src/fun.c"
    {

      cont = sub_cont ; 
    }

# 6096 "./../src/fun.c"
    else {
#     define XfOrM1127_COUNT (0+XfOrM1126_COUNT)
#     define SETUP_XfOrM1127(x) SETUP_XfOrM1126(x)


      cont = FUNCCALL(SETUP_XfOrM1127(_), grab_continuation (p , 0 , 0 , prompt_tag , pt , sub_cont , prompt , prompt_cont , effective_barrier_prompt , 1 , argc , argv ) )

      ; 




      cont -> buf_ptr -> buf . cont = sub_cont ; 
      cont -> escape_cont = sub_cont -> escape_cont ; 
    }

    argv2 [0 ] = (Scheme_Object * ) cont ; 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1126(_), scheme_tail_apply (argv [0 ] , 1 , argv2 ) )) RET_VALUE_END ; 
  }

  cont = FUNCCALL(SETUP_XfOrM1114(_), grab_continuation (p , 0 , composable , prompt_tag , pt , sub_cont , prompt , prompt_cont , effective_barrier_prompt , 0 , argc , argv ) )

  ; 
  FUNCCALL(SETUP_XfOrM1114(_), scheme_zero_unneeded_rands (p ) )
  ; 
  (__funcarg206 = FUNCCALL(SETUP_XfOrM1114(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_flatten_config (__funcarg206 ) )) 
  ; 

  {
    void * overflow_id ; 
    overflow_id = NULLED_OUT ; 
    overflow_id = (p -> overflow 
    ? (p -> overflow -> id 
    ? p -> overflow -> id 
    : p -> overflow ) 
    : ((void * ) 0 ) ) ; 

    if (prompt 
    && ! prompt_cont 
    && (prompt -> boundary_overflow_id == overflow_id ) ) {



      stack_start = prompt -> stack_boundary ; 
    }

# 6140 "./../src/fun.c"
    else {
      Scheme_Prompt * meta_prompt , * stack_barrier_prompt ; 
      meta_prompt = NULLED_OUT ; 
      stack_barrier_prompt = NULLED_OUT ; 

# 6143 "./../src/fun.c"
      stack_barrier_prompt = barrier_prompt ; 

      if (! stack_barrier_prompt -> is_barrier )
        stack_barrier_prompt = ((void * ) 0 ) ; 
      else if (stack_barrier_prompt -> boundary_overflow_id != overflow_id )
        stack_barrier_prompt = ((void * ) 0 ) ; 
      meta_prompt = p -> meta_prompt ; 
      if (meta_prompt )
        if (meta_prompt -> boundary_overflow_id != overflow_id )
        meta_prompt = ((void * ) 0 ) ; 

      if (stack_barrier_prompt && meta_prompt ) {
        stack_barrier_prompt = ((void * ) 0 ) ; 
      }

      if (stack_barrier_prompt )
        stack_start = stack_barrier_prompt -> stack_boundary ; 
      else if (meta_prompt )
        stack_start = meta_prompt -> stack_boundary ; 
      else 
      stack_start = p -> stack_start ; 
    }
  }




  cont -> prompt_stack_start = stack_start ; 

  cont -> escape_cont = ec ; 





  prompt_cont = ((void * ) 0 ) ; 
  barrier_cont = ((void * ) 0 ) ; 

  if (FUNCCALL(SETUP_XfOrM1114(_), scheme_setjmpup_relative (& cont -> buf_ptr -> buf , cont -> buf_ptr , stack_start , sub_cont ) )) {

    Scheme_Object * result , * extra_marks ; 
    Scheme_Overflow * resume ; 
    Scheme_Cont * use_next_cont ; 
    Scheme_Dynamic_Wind * common_dw ; 
    Scheme_Prompt * shortcut_prompt ; 
    int common_next_meta , empty_to_next_mc ; 
    BLOCK_SETUP((PUSH(result, 0+XfOrM1114_COUNT)));
#   define XfOrM1117_COUNT (1+XfOrM1114_COUNT)
#   define SETUP_XfOrM1117(x) SETUP(XfOrM1117_COUNT)
    result = NULLED_OUT ; 
    extra_marks = NULLED_OUT ; 
    resume = NULLED_OUT ; 
    use_next_cont = NULLED_OUT ; 
    common_dw = NULLED_OUT ; 
    shortcut_prompt = NULLED_OUT ; 

# 6190 "./../src/fun.c"
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

    result = cont -> value ; 
    cont -> value = ((void * ) 0 ) ; 

    resume = cont -> resume_to ; 
    cont -> resume_to = ((void * ) 0 ) ; 

    use_next_cont = cont -> use_next_cont ; 
    cont -> use_next_cont = ((void * ) 0 ) ; 

    extra_marks = cont -> extra_marks ; 
    cont -> extra_marks = ((void * ) 0 ) ; 

    common_dw = cont -> common_dw ; 
    cont -> common_dw = ((void * ) 0 ) ; 

    common_next_meta = cont -> common_next_meta ; 
    cont -> common_next_meta = 0 ; 

    shortcut_prompt = cont -> shortcut_prompt ; 
    cont -> shortcut_prompt = ((void * ) 0 ) ; 

    empty_to_next_mc = cont -> empty_to_next_mc ; 
    cont -> empty_to_next_mc = 0 ; 
    FUNCCALL(SETUP_XfOrM1117(_), restore_continuation (cont , p , 0 , result , resume , empty_to_next_mc , pt , common_dw , common_next_meta , shortcut_prompt , ! ! resume , 1 , use_next_cont , extra_marks ) )




    ; 
    FUNCCALL_AGAIN(scheme_check_break_now () )

    ; 

    if (! FUNCCALL(SETUP_XfOrM1117(_), scheme_get_barrier_prompt (((void * ) 0 ) , ((void * ) 0 ) ) )) {





      Scheme_Prompt * acting_barrier_prompt ; 
      BLOCK_SETUP((PUSH(acting_barrier_prompt, 0+XfOrM1117_COUNT)));
#     define XfOrM1120_COUNT (1+XfOrM1117_COUNT)
#     define SETUP_XfOrM1120(x) SETUP(XfOrM1120_COUNT)
      acting_barrier_prompt = NULLED_OUT ; 

# 6232 "./../src/fun.c"
      if (! barrier_prompt -> is_barrier )
        acting_barrier_prompt = barrier_prompt ; 
      else {
#       define XfOrM1121_COUNT (0+XfOrM1120_COUNT)
#       define SETUP_XfOrM1121(x) SETUP_XfOrM1120(x)

# 6235 "./../src/fun.c"
        acting_barrier_prompt = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1121(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        (memcpy (acting_barrier_prompt , barrier_prompt , sizeof (Scheme_Prompt ) ) ) ; 
        acting_barrier_prompt -> is_barrier = 0 ; 
      }
      p -> acting_barrier_prompt = acting_barrier_prompt ; 
    }

    {
      Scheme_Meta_Continuation * mc ; 
      intptr_t pos ; 
      Scheme_Object * cc_guard ; 
      BLOCK_SETUP((PUSH(cc_guard, 0+XfOrM1117_COUNT), PUSH(mc, 1+XfOrM1117_COUNT)));
#     define XfOrM1118_COUNT (2+XfOrM1117_COUNT)
#     define SETUP_XfOrM1118(x) SETUP(XfOrM1118_COUNT)
      mc = NULLED_OUT ; 
      cc_guard = NULLED_OUT ; 

# 6247 "./../src/fun.c"
      prompt = FUNCCALL(SETUP_XfOrM1118(_), scheme_get_prompt ((((Scheme_Small_Object * ) (pt ) ) -> u . ptr_val ) , & mc , & pos ) ); 
      if (prompt && (prompt -> has_chaperone || (((Scheme_Type ) (((((intptr_t ) (cont -> prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cont -> prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) ) {
#       define XfOrM1119_COUNT (0+XfOrM1118_COUNT)
#       define SETUP_XfOrM1119(x) SETUP_XfOrM1118(x)

# 6249 "./../src/fun.c"
        cc_guard = FUNCCALL(SETUP_XfOrM1119(_), get_set_cont_mark_by_pos (prompt_cc_guard_key , p , mc , pos , ((void * ) 0 ) ) ); 

        if (((cc_guard ) ) == (scheme_false ) ) 
          cc_guard = scheme_values_proc ; 
        if (((Scheme_Type ) (((((intptr_t ) (cont -> prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cont -> prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
          cc_guard = FUNCCALL(SETUP_XfOrM1119(_), chaperone_wrap_cc_guard (cont -> prompt_tag , cc_guard ) ); 
        FUNCCALL(SETUP_XfOrM1119(_), get_set_cont_mark_by_pos (prompt_cc_guard_key , p , mc , pos , cc_guard ) )
        ; 
      }
    }

    if ((result != ((Scheme_Object * ) 0x6 ) ) 
    && ((Scheme_Type ) (((((intptr_t ) (result ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (result ) ) -> type ) ) == (Scheme_Type ) (scheme_thunk_for_continue_type ) ) )
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1117(_), scheme_tail_apply ((((Scheme_Small_Object * ) (result ) ) -> u . ptr_val ) , 0 , ((void * ) 0 ) ) )) RET_VALUE_END ; 
    else 
    RET_VALUE_START (result ) RET_VALUE_END ; 
  }

# 6265 "./../src/fun.c"
  else if (composable || cont -> escape_cont ) {
    Scheme_Object * argv2 [1 ] ; 
    BLOCK_SETUP((PUSHARRAY(argv2, 1, 0+XfOrM1114_COUNT)));
#   define XfOrM1116_COUNT (3+XfOrM1114_COUNT)
#   define SETUP_XfOrM1116(x) SETUP(XfOrM1116_COUNT)
    argv2[0] = NULLED_OUT ; 

# 6268 "./../src/fun.c"
    if (! (((argv [2 ] ) ) == (scheme_false ) ) ) 
      cont -> skip_dws = 1 ; 

    argv2 [0 ] = (Scheme_Object * ) cont ; 
    ret = FUNCCALL(SETUP_XfOrM1116(_), scheme_tail_apply (argv [0 ] , 1 , argv2 ) ); 
    RET_VALUE_START (ret ) RET_VALUE_END ; 
  }

# 6274 "./../src/fun.c"
  else {
    Scheme_Object * argv2 [2 ] ; 
    BLOCK_SETUP((PUSHARRAY(argv2, 2, 0+XfOrM1114_COUNT)));
#   define XfOrM1115_COUNT (3+XfOrM1114_COUNT)
#   define SETUP_XfOrM1115(x) SETUP(XfOrM1115_COUNT)
    argv2[0] = NULLED_OUT ; 
    argv2[1] = NULLED_OUT ; 

# 6277 "./../src/fun.c"
    argv2 [0 ] = argv [0 ] ; 
    argv2 [1 ] = (Scheme_Object * ) cont ; 

    ret = FUNCCALL(SETUP_XfOrM1115(_), scheme_tail_apply (finish_call_cc_prim , 2 , argv2 ) ); 
    RET_VALUE_START (ret ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6285 "./../src/fun.c"
static Scheme_Object * 
finish_call_cc (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6288 "./../src/fun.c"
  return do_call_ec (1 , argv , argv [1 ] ) ; 
}

static Scheme_Object * call_in_continuation (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * k = argv [0 ] , * p , * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSHARRAY(a, 1, 1), PUSH(k, 4), PUSH(argv, 5)));
# define XfOrM1139_COUNT (6)
# define SETUP_XfOrM1139(x) SETUP(XfOrM1139_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 6295 "./../src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (k ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (k ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_type ) ) && ! ((Scheme_Type ) (((((intptr_t ) (k ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (k ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) ) )
    FUNCCALL(SETUP_XfOrM1139(_), scheme_wrong_contract ("call-in-continuation" , "continuation?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM1139(_), scheme_check_proc_arity ("call-in-continuation" , 0 , 1 , argc , argv ) )
  ; 





  p = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM1139(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  p -> type = scheme_thunk_for_continue_type ; 
  (((Scheme_Small_Object * ) (p ) ) -> u . ptr_val ) = argv [1 ] ; 

  a [0 ] = p ; 

  if ((Scheme_Type ) (((((intptr_t ) (k ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (k ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_type ) )  {

    int can_escape = 0 ; 
#   define XfOrM1141_COUNT (0+XfOrM1139_COUNT)
#   define SETUP_XfOrM1141(x) SETUP_XfOrM1139(x)

# 6313 "./../src/fun.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1141(_), scheme_jump_to_continuation (k , 1 , a , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) , can_escape ) )) RET_VALUE_END ; 
  }

# 6314 "./../src/fun.c"
  else {
#   define XfOrM1140_COUNT (0+XfOrM1139_COUNT)
#   define SETUP_XfOrM1140(x) SETUP_XfOrM1139(x)
    FUNCCALL(SETUP_XfOrM1140(_), scheme_escape_to_continuation (k , 1 , a , ((void * ) 0 ) ) )
# 6315 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6320 "./../src/fun.c"
static Scheme_Object * continuation_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6322 "./../src/fun.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

void scheme_takeover_stacks (Scheme_Thread * p ) 





{
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM1143_COUNT (1)
# define SETUP_XfOrM1143(x) SETUP(XfOrM1143_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 6334 "./../src/fun.c"
  if (p -> runstack_owner && ((* p -> runstack_owner ) != p ) ) {
    Scheme_Thread * op ; 
    Scheme_Saved_Stack * swapped ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM1143_COUNT), PUSH(swapped, 1+XfOrM1143_COUNT)));
#   define XfOrM1146_COUNT (2+XfOrM1143_COUNT)
#   define SETUP_XfOrM1146(x) SETUP(XfOrM1146_COUNT)
    op = NULLED_OUT ; 
    swapped = NULLED_OUT ; 

# 6337 "./../src/fun.c"
    op = * p -> runstack_owner ; 
    if (op ) {
#     define XfOrM1147_COUNT (0+XfOrM1146_COUNT)
#     define SETUP_XfOrM1147(x) SETUP_XfOrM1146(x)

# 6339 "./../src/fun.c"
      swapped = FUNCCALL(SETUP_XfOrM1147(_), copy_out_runstack (op , op -> runstack , op -> runstack_start , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
      op -> runstack_swapped = swapped ; 
    }
    * (p -> runstack_owner ) = p ; 
    FUNCCALL(SETUP_XfOrM1146(_), copy_in_runstack (p , p -> runstack_swapped , 1 ) ); 
    p -> runstack_swapped = ((void * ) 0 ) ; 
  }

  if (p -> cont_mark_stack_owner && ((* p -> cont_mark_stack_owner ) != p ) ) {
    Scheme_Thread * op ; 
    Scheme_Cont_Mark * swapped ; 
    BLOCK_SETUP((PUSH(op, 0+XfOrM1143_COUNT), PUSH(swapped, 1+XfOrM1143_COUNT)));
#   define XfOrM1144_COUNT (2+XfOrM1143_COUNT)
#   define SETUP_XfOrM1144(x) SETUP(XfOrM1144_COUNT)
    op = NULLED_OUT ; 
    swapped = NULLED_OUT ; 

# 6350 "./../src/fun.c"
    op = * p -> cont_mark_stack_owner ; 
    if (op ) {
#     define XfOrM1145_COUNT (0+XfOrM1144_COUNT)
#     define SETUP_XfOrM1145(x) SETUP_XfOrM1144(x)

# 6352 "./../src/fun.c"
      swapped = FUNCCALL(SETUP_XfOrM1145(_), copy_out_mark_stack (op , op -> cont_mark_stack , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ); 
      op -> cont_mark_stack_swapped = swapped ; 
    }
    * (p -> cont_mark_stack_owner ) = p ; 
    FUNCCALL(SETUP_XfOrM1144(_), copy_in_mark_stack (p , p -> cont_mark_stack_swapped , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) , 0 , 0 , ((void * ) 0 ) , 0 , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ); 
    p -> cont_mark_stack_swapped = ((void * ) 0 ) ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6361 "./../src/fun.c"
static Scheme_Object * 
call_with_continuation_barrier (int argc , Scheme_Object * argv [] ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM1148_COUNT (1)
# define SETUP_XfOrM1148(x) SETUP(XfOrM1148_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM1148(_), scheme_check_proc_arity ("call-with-continuation-barrier" , 0 , 0 , argc , argv ) )
# 6364 "./../src/fun.c"
  ; 



  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_apply_multi (argv [0 ] , 0 , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6371 "./../src/fun.c"
Scheme_Prompt * scheme_get_barrier_prompt (Scheme_Meta_Continuation * * _meta_cont , 
intptr_t * _pos ) 
{
  Scheme_Prompt * p ; 
  DECL_RET_SAVE (Scheme_Prompt * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(_meta_cont, 1), PUSH(_pos, 2)));
# define XfOrM1149_COUNT (3)
# define SETUP_XfOrM1149(x) SETUP(XfOrM1149_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 

# 6376 "./../src/fun.c"
  p = (Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1149(_), scheme_extract_one_cc_mark_with_meta (((void * ) 0 ) , barrier_prompt_key , ((void * ) 0 ) , _meta_cont , _pos ) ); 
  if (! p ) {
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> acting_barrier_prompt ; 
    if (_meta_cont ) {

      Scheme_Meta_Continuation * mc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> meta_continuation ; 
      while (mc && mc -> next ) {
        mc = mc -> next ; 
      }
      * _meta_cont = mc ; 
      * _pos = - 1 ; 
    }
  }

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6393 "./../src/fun.c"
Scheme_Prompt * scheme_get_prompt (Scheme_Object * prompt_tag , 
Scheme_Meta_Continuation * * _meta_cont , 
intptr_t * _pos ) 
{
  /* No conversion */

# 6397 "./../src/fun.c"
  return (Scheme_Prompt * ) scheme_extract_one_cc_mark_with_meta (((void * ) 0 ) , prompt_tag , ((void * ) 0 ) , _meta_cont , _pos ) ; 
}

static Scheme_Meta_Continuation * scheme_get_meta_continuation (Scheme_Object * key ) 
{
  Scheme_Meta_Continuation * mc ; 
  DECL_RET_SAVE (Scheme_Meta_Continuation * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(mc, 0)));
# define XfOrM1155_COUNT (1)
# define SETUP_XfOrM1155(x) SETUP(XfOrM1155_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  mc = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM1155(_), scheme_extract_one_cc_mark_with_meta (((void * ) 0 ) , key , ((void * ) 0 ) , & mc , ((void * ) 0 ) ) )
# 6403 "./../src/fun.c"
  ; 
  RET_VALUE_START (mc ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6408 "./../src/fun.c"
static Scheme_Object * make_prompt_tag (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * o , * key ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(key, 1), PUSH(argv, 2)));
# define XfOrM1156_COUNT (3)
# define SETUP_XfOrM1156(x) SETUP(XfOrM1156_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  key = NULLED_OUT ; 

# 6412 "./../src/fun.c"
  if (argc && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-continuation-prompt-tag" , "symbol?" , 0 , argc , argv ) ); 

  key = FUNCCALL(SETUP_XfOrM1156(_), scheme_make_pair (scheme_false , scheme_false ) ); 

  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM1156(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  o -> type = scheme_prompt_tag_type ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) = key ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) = (argc ? argv [0 ] : ((void * ) 0 ) ) ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6425 "./../src/fun.c"
static Scheme_Object * get_default_prompt_tag (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6427 "./../src/fun.c"
  return scheme_default_prompt_tag ; 
}

static Scheme_Object * prompt_tag_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 6432 "./../src/fun.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

Scheme_Object * do_chaperone_prompt_tag (const char * name , int is_impersonator , int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val = argv [0 ] ; 
  Scheme_Object * redirects ; 
  Scheme_Object * props ; 
  int ppos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(px, 1), PUSH(props, 2), PUSH(name, 3), PUSH(redirects, 4), PUSH(argv, 5)));
# define XfOrM1159_COUNT (6)
# define SETUP_XfOrM1159(x) SETUP(XfOrM1159_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 6445 "./../src/fun.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "prompt-tag?" , 0 , argc , argv ) ); 

  if (! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "procedure?" , 1 , argc , argv ) ); 
  if (! (! (((intptr_t ) (argv [2 ] ) ) & 0x1 ) && ((((argv [2 ] ) -> type ) >= scheme_prim_type ) && (((argv [2 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "procedure?" , 2 , argc , argv ) ); 

  if ((argc > 3 ) && ! (((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
#   define XfOrM1161_COUNT (0+XfOrM1159_COUNT)
#   define SETUP_XfOrM1161(x) SETUP_XfOrM1159(x)

# 6457 "./../src/fun.c"
    if (! (! (((intptr_t ) (argv [3 ] ) ) & 0x1 ) && ((((argv [3 ] ) -> type ) >= scheme_prim_type ) && (((argv [3 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract (name , "(or/c procedure? impersonator-property?)" , 3 , argc , argv ) ); 
    redirects = argv [3 ] ; 
    if ((argc > 4 ) && ! (((Scheme_Type ) (((((intptr_t ) (argv [4 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [4 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [4 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [4 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
#     define XfOrM1162_COUNT (0+XfOrM1161_COUNT)
#     define SETUP_XfOrM1162(x) SETUP_XfOrM1161(x)

# 6461 "./../src/fun.c"
      if (! FUNCCALL(SETUP_XfOrM1162(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 4 , argc , argv ) ))
        FUNCCALL_EMPTY(scheme_wrong_contract (name , "(or/c (procedure-arity-includes/c 1) impersonator-property?)" , 4 , argc , argv ) ); 
      redirects = FUNCCALL(SETUP_XfOrM1162(_), scheme_make_pair (redirects , argv [4 ] ) ); 
      ppos = 5 ; 
    }

# 6465 "./../src/fun.c"
    else 
    ppos = 4 ; 
    redirects = FUNCCALL(SETUP_XfOrM1161(_), scheme_make_pair (argv [2 ] , redirects ) ); 
  }

# 6468 "./../src/fun.c"
  else {
    ppos = 3 ; 
    redirects = argv [2 ] ; 
  }

  redirects = FUNCCALL(SETUP_XfOrM1159(_), scheme_make_pair (argv [1 ] , redirects ) ); 

  props = FUNCCALL(SETUP_XfOrM1159(_), scheme_parse_chaperone_props (name , ppos , argc , argv ) ); 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM1159(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 
  px -> redirects = redirects ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6490 "./../src/fun.c"
static Scheme_Object * chaperone_prompt_tag (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6492 "./../src/fun.c"
  return do_chaperone_prompt_tag ("chaperone-prompt-tag" , 0 , argc , argv ) ; 
}

static Scheme_Object * impersonate_prompt_tag (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6497 "./../src/fun.c"
  return do_chaperone_prompt_tag ("impersonate-prompt-tag" , 1 , argc , argv ) ; 
}

Scheme_Overflow * scheme_get_thread_end_overflow (void ) 
{
  Scheme_Overflow * overflow ; 
  DECL_RET_SAVE (Scheme_Overflow * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(overflow, 0)));
# define XfOrM1165_COUNT (1)
# define SETUP_XfOrM1165(x) SETUP(XfOrM1165_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  overflow = NULLED_OUT ; 

# 6503 "./../src/fun.c"
  overflow = ((Scheme_Overflow * ) FUNCCALL(SETUP_XfOrM1165(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  overflow -> type = scheme_rt_overflow ; 

  overflow -> eot = 1 ; 
  RET_VALUE_START (overflow ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6512 "./../src/fun.c"
void scheme_drop_prompt_meta_continuations (Scheme_Object * prompt_tag ) 
{
  /* No conversion */

# 6514 "./../src/fun.c"
  Scheme_Meta_Continuation * mc ; 

  mc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> meta_continuation ; 
  while (! ((mc -> prompt_tag ) == (prompt_tag ) ) ) {
    if (mc -> overflow ) {
      scheme_signal_error ("meta-continuation to drop is not just a placeholder?!" ) ; 
    }
    mc = mc -> next ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> meta_continuation = mc ; 
}

Scheme_Object * scheme_finish_apply_for_prompt (Scheme_Prompt * prompt , Scheme_Object * _prompt_tag , Scheme_Object * proc , int argc , Scheme_Object * * argv ) __attribute__ ((noinline ) ) 
; 

Scheme_Object * scheme_finish_apply_for_prompt (Scheme_Prompt * prompt , Scheme_Object * _prompt_tag , 
Scheme_Object * proc , int argc , Scheme_Object * * argv ) 
{





  Scheme_Thread * p ; 
  Scheme_Object * volatile prompt_tag = _prompt_tag ; 
  mz_jmp_buf newbuf , * volatile savebuf ; 
  Scheme_Object * val ; 
  int cc_count = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(proc, 0), PUSH(val, 1), PUSH(p, 2), PUSH(savebuf, 3), PUSH(prompt_tag, 4), PUSH(argv, 5)));
# define XfOrM1171_COUNT (6)
# define SETUP_XfOrM1171(x) SETUP(XfOrM1171_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 
  savebuf = NULLED_OUT ; 
  val = NULLED_OUT ; 

# 6544 "./../src/fun.c"
  prompt -> prompt_buf = & newbuf ; 
  prompt = ((void * ) 0 ) ; 

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  savebuf = p -> error_buf ; 
  p -> error_buf = & newbuf ; 




  {
    Scheme_Meta_Continuation * resume_mc ; 
    BLOCK_SETUP((PUSH(resume_mc, 0+XfOrM1171_COUNT)));
#   define XfOrM1181_COUNT (1+XfOrM1171_COUNT)
#   define SETUP_XfOrM1181(x) SETUP(XfOrM1181_COUNT)
    resume_mc = NULLED_OUT ; 

# 6557 "./../src/fun.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_mc_ ) ) {
      resume_mc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_mc_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_mc_ ) = ((void * ) 0 ) ; 
    }

# 6560 "./../src/fun.c"
    else 
    resume_mc = ((Scheme_Meta_Continuation * ) FUNCCALL(SETUP_XfOrM1181(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Meta_Continuation ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

    resume_mc -> type = scheme_rt_meta_cont ; 

    resume_mc -> prompt_tag = prompt_tag ; 
    if (p -> meta_continuation ) {
      resume_mc -> next = p -> meta_continuation ; 
      resume_mc -> depth = p -> meta_continuation -> depth + 1 ; 
    }
    resume_mc -> meta_tail_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) + 2 ; 
    p -> meta_continuation = resume_mc ; 
  }

  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM1171_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {

# 6596 "./../src/fun.c"
    val = ((void * ) 0 ) ; 
  }

# 6597 "./../src/fun.c"
  else {
#   define XfOrM1179_COUNT (0+XfOrM1171_COUNT)
#   define SETUP_XfOrM1179(x) SETUP_XfOrM1171(x)

# 6598 "./../src/fun.c"
    val = FUNCCALL(SETUP_XfOrM1179(_), scheme_do_eval (proc , argc , argv , - 1 ) ); 
  }

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  p -> error_buf = savebuf ; 

  {
    Scheme_Meta_Continuation * resume_mc ; 
    Scheme_Overflow * resume ; 
    BLOCK_SETUP((PUSH(resume_mc, 0+XfOrM1171_COUNT), PUSH(resume, 1+XfOrM1171_COUNT)));
#   define XfOrM1172_COUNT (2+XfOrM1171_COUNT)
#   define SETUP_XfOrM1172(x) SETUP(XfOrM1172_COUNT)
    resume_mc = NULLED_OUT ; 
    resume = NULLED_OUT ; 

# 6608 "./../src/fun.c"
    resume = p -> meta_continuation -> overflow ; 
    resume_mc = p -> meta_continuation ; 
    p -> meta_continuation = p -> meta_continuation -> next ; 

# 6621 "./../src/fun.c"
    if (cc_count == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM1178_COUNT (0+XfOrM1172_COUNT)
#     define SETUP_XfOrM1178(x) SETUP_XfOrM1172(x)
      (
# 6622 "./../src/fun.c"
      memset (resume_mc , 0 , sizeof (Scheme_Meta_Continuation ) ) ) ; 

      resume_mc -> type = scheme_rt_meta_cont ; 

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_mc_ ) = resume_mc ; 
    }

    if (! resume ) {


      RET_VALUE_START (val ) RET_VALUE_END ; 
    }

# 6633 "./../src/fun.c"
    else if (resume -> eot ) {
#     define XfOrM1176_COUNT (0+XfOrM1172_COUNT)
#     define SETUP_XfOrM1176(x) SETUP_XfOrM1172(x)


      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = ((void * ) 0 ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = ((void * ) 0 ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = 0 ; 
      p -> runstack_start = ((void * ) 0 ) ; 
      p -> runstack = ((void * ) 0 ) ; 
      p -> runstack_size = 0 ; 
      p -> runstack_saved = ((void * ) 0 ) ; 
      p -> cont_mark_stack_segments = ((void * ) 0 ) ; 
      FUNCCALL(SETUP_XfOrM1176(_), scheme_end_current_thread () ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 6648 "./../src/fun.c"
    else {
#     define XfOrM1173_COUNT (0+XfOrM1172_COUNT)
#     define SETUP_XfOrM1173(x) SETUP_XfOrM1172(x)


      if (val ) {
        if (val == ((Scheme_Object * ) 0x6 ) ) {
          if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
            p -> values_buffer = ((void * ) 0 ) ; 
        }
        p -> cjs . val = val ; 
      }
      p -> stack_start = resume -> stack_start ; 
      p -> decompose_mc = resume_mc ; 
      FUNCCALL(SETUP_XfOrM1173(_), scheme_longjmpup (& resume -> jmp -> cont ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6668 "./../src/fun.c"
Scheme_Object * scheme_apply_for_prompt (Scheme_Prompt * prompt , Scheme_Object * prompt_tag , Scheme_Object * proc , int argc , Scheme_Object * * argv ) __attribute__ ((noinline ) ) 
; 

Scheme_Object * scheme_apply_for_prompt (Scheme_Prompt * prompt , Scheme_Object * prompt_tag , 
Scheme_Object * proc , int argc , Scheme_Object * * argv ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(proc, 0)));
# define XfOrM1184_COUNT (1)
# define SETUP_XfOrM1184(x) SETUP(XfOrM1184_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 6675 "./../src/fun.c"
  prompt -> stack_boundary = & __gc_var_stack__ ; 

  proc = FUNCCALL(SETUP_XfOrM1184(_), scheme_finish_apply_for_prompt (prompt , prompt_tag , proc , argc , argv ) ); 

  RET_VALUE_START (proc ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6682 "./../src/fun.c"
static Scheme_Object * compose_continuation (Scheme_Cont * cont , int exec_chain , 
Scheme_Object * loop_prompt , int empty_to_next_mc ) 

{



  Scheme_Overflow * overflow ; 
  Scheme_Overflow_Jmp * jmp ; 
  Scheme_Cont * saved ; 
  Scheme_Prompt * saved_meta_prompt ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(overflow, 1), PUSH(saved_meta_prompt, 2), PUSH(saved, 3), PUSH(loop_prompt, 4), PUSH(cont, 5), PUSH(jmp, 6)));
# define XfOrM1185_COUNT (7)
# define SETUP_XfOrM1185(x) SETUP(XfOrM1185_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  overflow = NULLED_OUT ; 
  jmp = NULLED_OUT ; 
  saved = NULLED_OUT ; 
  saved_meta_prompt = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM1185(_), scheme_about_to_move_C_stack () )
# 6695 "./../src/fun.c"
  ; 
  FUNCCALL_AGAIN(reset_cjs (& p -> cjs ) )
  ; 

  saved_meta_prompt = p -> meta_prompt ; 



  saved = FUNCCALL(SETUP_XfOrM1185(_), grab_continuation (p , 1 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) ); 

  if (p -> meta_prompt )
    saved -> prompt_stack_start = p -> meta_prompt -> stack_boundary ; 

  overflow = ((Scheme_Overflow * ) FUNCCALL(SETUP_XfOrM1185(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  overflow -> type = scheme_rt_overflow ; 

  overflow -> prev = p -> overflow ; 
  overflow -> stack_start = p -> stack_start ; 

  jmp = ((Scheme_Overflow_Jmp * ) FUNCCALL(SETUP_XfOrM1185(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Overflow_Jmp ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  jmp -> type = scheme_rt_overflow_jmp ; 

  overflow -> jmp = jmp ; 

  saved -> resume_to = overflow ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_cont_ ) = saved ; 
  saved = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM1185(_), scheme_init_jmpup_buf (& overflow -> jmp -> cont ) )
  ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) = overflow ; 
  overflow = ((void * ) 0 ) ; 

  if (FUNCCALL(SETUP_XfOrM1185(_), scheme_setjmpup_relative (& XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) -> jmp -> cont , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) -> jmp , p -> stack_start , ((void * ) 0 ) ) )) 

  {

# 6747 "./../src/fun.c"
    Scheme_Object * v ; 
    Scheme_Meta_Continuation * mc , * dmc ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM1185_COUNT), PUSH(mc, 1+XfOrM1185_COUNT)));
#   define XfOrM1187_COUNT (2+XfOrM1185_COUNT)
#   define SETUP_XfOrM1187(x) SETUP(XfOrM1187_COUNT)
    v = NULLED_OUT ; 
    mc = NULLED_OUT ; 
    dmc = NULLED_OUT ; 

# 6750 "./../src/fun.c"
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

    dmc = p -> decompose_mc ; 
    p -> decompose_mc = ((void * ) 0 ) ; 
    saved = dmc -> cont ; 
    overflow = dmc -> overflow ; 

    if (! p -> cjs . jumping_to_continuation ) {

      v = p -> cjs . val ; 
      p -> cjs . val = ((void * ) 0 ) ; 
      if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
        if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
          p -> values_buffer = ((void * ) 0 ) ; 
      }
    }

# 6765 "./../src/fun.c"
    else {


      v = ((void * ) 0 ) ; 
    }
    mc = p -> meta_continuation ; 
    p -> meta_prompt = saved_meta_prompt ; 
    FUNCCALL(SETUP_XfOrM1187(_), restore_continuation (saved , p , 1 , v , ((void * ) 0 ) , 0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 , ((void * ) 0 ) , 1 , ! p -> cjs . jumping_to_continuation , ((void * ) 0 ) , ((void * ) 0 ) ) )





    ; 

    p -> meta_continuation = mc ; 







    if (! v && ((loop_prompt 
    && (((Scheme_Object * ) p -> cjs . jumping_to_continuation ) == (loop_prompt ) ) 

    && p -> cjs . is_escape ) 
    || (! loop_prompt 
    && p -> cjs . jumping_to_continuation 
    && ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) p -> cjs . jumping_to_continuation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) p -> cjs . jumping_to_continuation ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) ) {
#     define XfOrM1189_COUNT (0+XfOrM1187_COUNT)
#     define SETUP_XfOrM1189(x) SETUP_XfOrM1187(x)
      cont = (Scheme_Cont * ) p -> cjs . val ; 
      if ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) p -> cjs . jumping_to_continuation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) p -> cjs . jumping_to_continuation ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {


        cont -> extra_marks = (Scheme_Object * ) p -> cjs . jumping_to_continuation ; 
      }
      FUNCCALL(SETUP_XfOrM1189(_), reset_cjs (& p -> cjs ) ); 

      saved -> meta_continuation = p -> meta_continuation ; 
    }
    else {
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }
  }

# 6810 "./../src/fun.c"
  else {
    saved = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_cont_ ) ; 
    overflow = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_cont_ ) = ((void * ) 0 ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> offstack_overflow_ ) = ((void * ) 0 ) ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_break ++ ; 


  cont -> use_next_cont = saved ; 
  cont -> resume_to = overflow ; 
  cont -> empty_to_next_mc = (char ) empty_to_next_mc ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> stack_start = cont -> prompt_stack_start ; 
  FUNCCALL(SETUP_XfOrM1185(_), scheme_longjmpup (& cont -> buf_ptr -> buf ) ); 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6829 "./../src/fun.c"
static void continue_prompt_escape () 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Prompt * targetc = (Scheme_Prompt * ) p -> cjs . jumping_to_continuation ; 
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(targetc, 1)));
# define XfOrM1194_COUNT (2)
# define SETUP_XfOrM1194(x) SETUP(XfOrM1194_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  FUNCCALL(SETUP_XfOrM1194(_), scheme_drop_prompt_meta_continuations (targetc -> tag ) )
# 6834 "./../src/fun.c"
  ; 

  if ((! targetc -> boundary_overflow_id && ! p -> overflow ) 
  || (targetc -> boundary_overflow_id == p -> overflow -> id ) ) {

    (((intptr_t * ) (void * ) ((* targetc -> prompt_buf ) . gcvs ) ) [1 ] = (* targetc -> prompt_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* targetc -> prompt_buf ) . gcvs , longjmp ((* targetc -> prompt_buf ) . jb , 1 ) ) ; 
  }

# 6840 "./../src/fun.c"
  else {

    Scheme_Overflow * overflow = p -> overflow ; 
    BLOCK_SETUP((PUSH(overflow, 0+XfOrM1194_COUNT)));
#   define XfOrM1195_COUNT (1+XfOrM1194_COUNT)
#   define SETUP_XfOrM1195(x) SETUP(XfOrM1195_COUNT)

# 6843 "./../src/fun.c"
    while (overflow -> prev 
    && (! overflow -> prev -> id 
    || (overflow -> prev -> id != targetc -> boundary_overflow_id ) ) ) {
      overflow = overflow -> prev ; 
    }
    p -> overflow = overflow ; 
    p -> stack_start = overflow -> stack_start ; 
    FUNCCALL(SETUP_XfOrM1195(_), scheme_longjmpup (& overflow -> jmp -> cont ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6854 "./../src/fun.c"
static void restore_from_prompt (Scheme_Prompt * prompt ) 
{
  /* No conversion */

# 6856 "./../src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  while (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) != scheme_prompt_runstack_boundary_start (prompt ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = p -> runstack_saved -> runstack_start ; 
    p -> runstack_saved = p -> runstack_saved -> prev ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + prompt -> runstack_boundary_offset ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = prompt -> mark_boundary ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = prompt -> boundary_mark_pos ; 

  p -> runstack_size = prompt -> runstack_size ; 

  if (prompt -> boundary_overflow_id ) {
    while (p -> overflow -> id != prompt -> boundary_overflow_id ) {
      p -> overflow = p -> overflow -> prev ; 
    }
  }

# 6873 "./../src/fun.c"
  else 
  p -> overflow = ((void * ) 0 ) ; 
}

static void prompt_unwind_dw (Scheme_Object * prompt_tag ) 
{
  /* No conversion */

# 6879 "./../src/fun.c"
  int delta = 0 ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  while (p -> dw && ! ((p -> dw -> prompt_tag ) == (prompt_tag ) ) ) {
    delta += p -> dw -> next_meta ; 
    p -> dw = p -> dw -> prev ; 
  }
  if (! p -> dw ) {
    scheme_signal_error ("Lost prompt dynamic-wind record!\n" ) ; 
  }

# 6888 "./../src/fun.c"
  else {
    delta += p -> dw -> next_meta ; 
    p -> dw = p -> dw -> prev ; 
    p -> next_meta += delta ; 
  }
}

static void prompt_unwind_one_dw (Scheme_Object * prompt_tag ) 
{
  /* No conversion */

# 6897 "./../src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  if (! p -> dw || ! ((p -> dw -> prompt_tag ) == (prompt_tag ) ) ) {
    scheme_signal_error ("Dynamic-wind record doesn't match prompt!\n" ) ; 
  }

# 6900 "./../src/fun.c"
  else 
  prompt_unwind_dw (prompt_tag ) ; 
}

static Scheme_Object * * chaperone_do_control (const char * name , int mode , 
Scheme_Object * init_guard , Scheme_Object * obj , 
int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * * vals = argv ; 
  Scheme_Object * v ; 
  Scheme_Object * proc ; 
  int i , num_args ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(px, 0), PUSH(init_guard, 1), PUSH(name, 2), PUSH(vals, 3), PUSH(argv, 4), PUSH(obj, 5), PUSH(proc, 6), PUSH(v, 7)));
# define XfOrM1212_COUNT (8)
# define SETUP_XfOrM1212(x) SETUP(XfOrM1212_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  v = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 6914 "./../src/fun.c"
  while (1 ) {
#   define XfOrM1233_COUNT (0+XfOrM1212_COUNT)
#   define SETUP_XfOrM1233(x) SETUP_XfOrM1212(x)

# 6915 "./../src/fun.c"
    if (init_guard || ! ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) {
#     define XfOrM1235_COUNT (0+XfOrM1233_COUNT)
#     define SETUP_XfOrM1235(x) SETUP_XfOrM1233(x)

# 6916 "./../src/fun.c"
      if (init_guard ) {
        proc = init_guard ; 
        if ((((void * ) 0 ) ) == (scheme_values_proc ) ) 
          proc = ((void * ) 0 ) ; 
        px = ((void * ) 0 ) ; 
      }

# 6921 "./../src/fun.c"
      else {
        px = (Scheme_Chaperone * ) obj ; 
        obj = px -> prev ; 

        if (! mode )
          proc = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . car ) ; 
        else {
          proc = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . cdr ) ; 
          if (mode == 1 ) {
            if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
              proc = (((Scheme_Simple_Object * ) (proc ) ) -> u . pair_val . car ) ; 
          }

# 6932 "./../src/fun.c"
          else {
            if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
              proc = (((Scheme_Simple_Object * ) (proc ) ) -> u . pair_val . cdr ) ; 
              if (mode == 2 ) {
                if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
                  proc = (((Scheme_Simple_Object * ) (proc ) ) -> u . pair_val . car ) ; 
              }

# 6938 "./../src/fun.c"
              else {
                if ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
                  proc = (((Scheme_Simple_Object * ) (proc ) ) -> u . pair_val . cdr ) ; 
                else 
                proc = ((void * ) 0 ) ; 
              }
            }

# 6944 "./../src/fun.c"
            else 
            proc = ((void * ) 0 ) ; 
          }
        }
      }

      if (proc ) {
#       define XfOrM1236_COUNT (0+XfOrM1235_COUNT)
#       define SETUP_XfOrM1236(x) SETUP_XfOrM1235(x)

# 6951 "./../src/fun.c"
        if (mode == 3 )
          v = FUNCCALL(SETUP_XfOrM1236(_), scheme_apply (proc , argc , argv ) ); 
        else 
        v = FUNCCALL(SETUP_XfOrM1236(_), scheme_do_eval (proc , argc , argv , - 1 ) ); 

        if (v == ((Scheme_Object * ) 0x6 ) ) {
          GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
          if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
            p -> values_buffer = ((void * ) 0 ) ; 
          num_args = p -> ku . multiple . count ; 
          vals = p -> ku . multiple . array ; 
          p -> ku . multiple . array = ((void * ) 0 ) ; 
        }

# 6963 "./../src/fun.c"
        else {
#         define XfOrM1243_COUNT (0+XfOrM1236_COUNT)
#         define SETUP_XfOrM1243(x) SETUP_XfOrM1236(x)

# 6964 "./../src/fun.c"
          num_args = 1 ; 
          vals = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1243(_), GC_malloc (sizeof (Scheme_Object * ) * (1 ) ) )) ; 
          vals [0 ] = v ; 
        }





        if (num_args == 1 && num_args != argc )
          FUNCCALL(SETUP_XfOrM1236(_), scheme_wrong_return_arity (name , argc , 1 , (Scheme_Object * * ) (vals [0 ] ) , "\n  in: use of redirecting procedure" ) ); 
        else if (num_args != argc )
          FUNCCALL(SETUP_XfOrM1236(_), scheme_wrong_return_arity (name , argc , num_args , vals , "\n   in: use of redirecting procedure" ) ); 

        if (mode == 3 ) {
#         define XfOrM1241_COUNT (0+XfOrM1236_COUNT)
#         define SETUP_XfOrM1241(x) SETUP_XfOrM1236(x)

# 6979 "./../src/fun.c"
          if (! FUNCCALL(SETUP_XfOrM1241(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , argc , vals ) )) {
#           define XfOrM1242_COUNT (0+XfOrM1241_COUNT)
#           define SETUP_XfOrM1242(x) SETUP_XfOrM1241(x)
            FUNCCALL_EMPTY(scheme_wrong_type ("call/cc guard-wrapping function" , "(procedure-arity-includes/c 2)" , 0 , - 1 , vals ) )
# 6980 "./../src/fun.c"
            ; 
          }
        }

        if (! init_guard ) {
#         define XfOrM1237_COUNT (0+XfOrM1236_COUNT)
#         define SETUP_XfOrM1237(x) SETUP_XfOrM1236(x)

# 6985 "./../src/fun.c"
          if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) ) {
#           define XfOrM1238_COUNT (0+XfOrM1237_COUNT)
#           define SETUP_XfOrM1238(x) SETUP_XfOrM1237(x)

# 6986 "./../src/fun.c"
            for (i = 0 ; i < argc ; i ++ ) {
#             define XfOrM1240_COUNT (0+XfOrM1238_COUNT)
#             define SETUP_XfOrM1240(x) SETUP_XfOrM1238(x)

# 6987 "./../src/fun.c"
              if (! FUNCCALL(SETUP_XfOrM1240(_), scheme_chaperone_of (vals [i ] , argv [i ] ) ))
                FUNCCALL(SETUP_XfOrM1240(_), scheme_wrong_chaperoned (name , "value" , argv [i ] , vals [i ] ) ); 
            }
          }
        }

        argv = vals ; 
      }

      init_guard = ((void * ) 0 ) ; 
    }

# 6997 "./../src/fun.c"
    else {
      RET_VALUE_START (vals ) RET_VALUE_END ; 
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7003 "./../src/fun.c"
static Scheme_Object * * chaperone_do_prompt_handler (Scheme_Object * obj , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7005 "./../src/fun.c"
  return chaperone_do_control ("call-with-continuation-prompt" , 0 , ((void * ) 0 ) , obj , argc , argv ) ; 
}

static Scheme_Object * * chaperone_do_abort (Scheme_Object * obj , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7010 "./../src/fun.c"
  return chaperone_do_control ("abort-current-continuation" , 1 , ((void * ) 0 ) , obj , argc , argv ) ; 
}

static Scheme_Object * * chaperone_do_cc_guard (Scheme_Object * cc_guard , Scheme_Object * obj , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 7015 "./../src/fun.c"
  return chaperone_do_control ("call-with-continuation-prompt" , 2 , cc_guard , obj , argc , argv ) ; 
}

static Scheme_Object * chaperone_wrap_cc_guard (Scheme_Object * obj , Scheme_Object * proc ) 
{
  Scheme_Object * a [1 ] , * * a2 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(a2, 0), PUSHARRAY(a, 1, 1)));
# define XfOrM1256_COUNT (4)
# define SETUP_XfOrM1256(x) SETUP(XfOrM1256_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a2 = NULLED_OUT ; 

# 7022 "./../src/fun.c"
  a [0 ] = proc ; 
  a2 = FUNCCALL(SETUP_XfOrM1256(_), chaperone_do_control ("call-with-current-continuation" , 3 , ((void * ) 0 ) , obj , 1 , a ) ); 

  RET_VALUE_START (a2 [0 ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7028 "./../src/fun.c"
static Scheme_Object * do_cc_guard (Scheme_Object * v , Scheme_Object * cc_guard , Scheme_Object * chaperone ) 
{
  int argc ; 
  Scheme_Object * * argv , * a [1 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0), PUSH(argv, 3)));
# define XfOrM1257_COUNT (4)
# define SETUP_XfOrM1257(x) SETUP(XfOrM1257_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  argv = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 7033 "./../src/fun.c"
  if (v == ((Scheme_Object * ) 0x6 ) ) {
    GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
    argc = p -> ku . multiple . count ; 
    argv = p -> ku . multiple . array ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
  }

# 7040 "./../src/fun.c"
  else {
    a [0 ] = v ; 
    argv = a ; 
    argc = 1 ; 
  }

  if (! chaperone )

# 7046 "./../src/fun.c"
  chaperone = scheme_default_prompt_tag ; 

  argv = FUNCCALL(SETUP_XfOrM1257(_), chaperone_do_cc_guard (cc_guard , chaperone , argc , argv ) ); 

  if (argc == 1 )
    RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1257(_), scheme_values (argc , argv ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7056 "./../src/fun.c"
static Scheme_Object * call_with_prompt (int in_argc , Scheme_Object * in_argv [] ) 
{
  Scheme_Object * v ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * proc = in_argv [0 ] , * prompt_tag ; 
  Scheme_Prompt * prompt ; 
  int argc , handler_argument_error = 0 ; 

  Scheme_Object * * argv , * a [3 ] , * handler ; 
  Scheme_Cont_Frame_Data cframe ; 
  Scheme_Dynamic_Wind * prompt_dw ; 
  int cc_count = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ; 
  Scheme_Object * chaperone = ((void * ) 0 ) , * cc_guard = scheme_false ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(v, 1), PUSH(argv, 2), PUSH(in_argv, 3), PUSH(cframe.cache, 4), PUSH(proc, 5), PUSH(cc_guard, 6), PUSH(chaperone, 7), PUSH(prompt_dw, 8), PUSH(prompt, 9), PUSH(handler, 10), PUSHARRAY(a, 3, 11), PUSH(prompt_tag, 14)));
# define XfOrM1260_COUNT (15)
# define SETUP_XfOrM1260(x) SETUP(XfOrM1260_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  prompt_tag = NULLED_OUT ; 
  prompt = NULLED_OUT ; 
  argv = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  handler = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 
  prompt_dw = NULLED_OUT ; 

# 7070 "./../src/fun.c"
  argc = in_argc - 3 ; 
  if (argc <= 0 ) {
    argc = 0 ; 
    argv = ((void * ) 0 ) ; 
  }

# 7074 "./../src/fun.c"
  else {
    int i ; 
#   define XfOrM1342_COUNT (0+XfOrM1260_COUNT)
#   define SETUP_XfOrM1342(x) SETUP_XfOrM1260(x)

# 7076 "./../src/fun.c"
    if (argc <= 3 )
      argv = a ; 
    else 
    argv = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1342(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
    for (i = 0 ; i < argc ; i ++ ) {
      argv [i ] = in_argv [i + 3 ] ; 
    }
  }
  FUNCCALL(SETUP_XfOrM1260(_), scheme_check_proc_arity ("call-with-continuation-prompt" , argc , 0 , in_argc , in_argv ) )
  ; 
  if (in_argc > 1 ) {
#   define XfOrM1337_COUNT (0+XfOrM1260_COUNT)
#   define SETUP_XfOrM1337(x) SETUP_XfOrM1260(x)

# 7088 "./../src/fun.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (in_argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (in_argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) {
#     define XfOrM1339_COUNT (0+XfOrM1337_COUNT)
#     define SETUP_XfOrM1339(x) SETUP_XfOrM1337(x)

# 7089 "./../src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (in_argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (in_argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) in_argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) in_argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) {
        chaperone = in_argv [1 ] ; 
        prompt_tag = (((Scheme_Chaperone * ) in_argv [1 ] ) -> val ) ; 
      }

# 7093 "./../src/fun.c"
      else {
#       define XfOrM1340_COUNT (0+XfOrM1339_COUNT)
#       define SETUP_XfOrM1340(x) SETUP_XfOrM1339(x)
        FUNCCALL(SETUP_XfOrM1340(_), scheme_wrong_contract ("call-with-continuation-prompt" , "continuation-prompt-tag?" , 1 , in_argc , in_argv ) )
# 7095 "./../src/fun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 7098 "./../src/fun.c"
    else 
    prompt_tag = in_argv [1 ] ; 
    if ((prompt_tag ) == (scheme_root_prompt_tag ) )  {
#     define XfOrM1338_COUNT (0+XfOrM1337_COUNT)
#     define SETUP_XfOrM1338(x) SETUP_XfOrM1337(x)
      FUNCCALL(SETUP_XfOrM1338(_), root_prompt_tag_misuse ("call-with-continuation-prompt" ) )
# 7101 "./../src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 7104 "./../src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  if (in_argc > 2 ) {
#   define XfOrM1336_COUNT (0+XfOrM1260_COUNT)
#   define SETUP_XfOrM1336(x) SETUP_XfOrM1260(x)

# 7108 "./../src/fun.c"
    if ((! (((in_argv [2 ] ) ) == (scheme_false ) ) ) && ! (! (((intptr_t ) (in_argv [2 ] ) ) & 0x1 ) && ((((in_argv [2 ] ) -> type ) >= scheme_prim_type ) && (((in_argv [2 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      FUNCCALL(SETUP_XfOrM1336(_), scheme_wrong_contract ("call-with-continuation-prompt" , "(or/c procedure? #f)" , 2 , in_argc , in_argv ) ); 
    handler = in_argv [2 ] ; 
  }

# 7111 "./../src/fun.c"
  else 
  handler = scheme_false ; 

  do {
#   define XfOrM1301_COUNT (0+XfOrM1260_COUNT)
#   define SETUP_XfOrM1301(x) SETUP_XfOrM1260(x)
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) ) {



      prompt = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) = ((void * ) 0 ) ; 
    }

# 7123 "./../src/fun.c"
    else 
    prompt = ((Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1301(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Prompt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

    prompt -> so . type = scheme_prompt_type ; 

    prompt -> tag = prompt_tag ; 
    FUNCCALL(SETUP_XfOrM1301(_), scheme_push_continuation_frame (& cframe ) )
# 7140 "./../src/fun.c"
    ; 
    FUNCCALL_AGAIN(scheme_set_cont_mark (prompt_cc_guard_key , cc_guard ) ); 
    FUNCCALL_AGAIN(scheme_set_cont_mark ((((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) , (Scheme_Object * ) prompt ) ); 
    FUNCCALL_AGAIN(ASSERT_SUSPEND_BREAK_ZERO () )





    ; 
    FUNCCALL_AGAIN(initialize_prompt (p , prompt , ((void * ) 0 ) , 0 ) )
    ; 

    if (p -> overflow ) {
#     define XfOrM1334_COUNT (0+XfOrM1301_COUNT)
#     define SETUP_XfOrM1334(x) SETUP_XfOrM1301(x)
      FUNCCALL(SETUP_XfOrM1334(_), ensure_overflow_id (p -> overflow ) )
# 7154 "./../src/fun.c"
      ; 
      prompt -> boundary_overflow_id = p -> overflow -> id ; 
    }

    prompt -> runstack_size = p -> runstack_size ; 

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) ) {
      prompt_dw = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) = ((void * ) 0 ) ; 
    }

# 7163 "./../src/fun.c"
    else 
    prompt_dw = ((Scheme_Dynamic_Wind * ) FUNCCALL(SETUP_XfOrM1301(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Dynamic_Wind ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

    prompt_dw -> type = scheme_rt_dyn_wind ; 

    prompt_dw -> prompt_tag = prompt_tag ; 
    if (p -> dw ) {
      prompt_dw -> next_meta = p -> next_meta ; 
      prompt_dw -> prev = p -> dw ; 
      prompt_dw -> depth = p -> dw -> depth + 1 ; 
    }

    p -> next_meta = 0 ; 
    p -> dw = prompt_dw ; 
    if (chaperone )
      prompt -> has_chaperone = 1 ; 

    v = FUNCCALL(SETUP_XfOrM1301(_), scheme_apply_for_prompt (prompt , prompt_tag , proc , argc , argv ) ); 






    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

    if (v == ((Scheme_Object * ) 0x6 ) ) {
      if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
        p -> values_buffer = ((void * ) 0 ) ; 
    }
    FUNCCALL(SETUP_XfOrM1301(_), restore_from_prompt (prompt ) )
    ; 

    p -> suspend_break = 0 ; 

    if (! v ) {
#     define XfOrM1306_COUNT (0+XfOrM1301_COUNT)
#     define SETUP_XfOrM1306(x) SETUP_XfOrM1301(x)

# 7200 "./../src/fun.c"
      if (((Scheme_Object * ) p -> cjs . jumping_to_continuation ) == ((Scheme_Object * ) prompt ) )  
      {
#       define XfOrM1309_COUNT (0+XfOrM1306_COUNT)
#       define SETUP_XfOrM1309(x) SETUP_XfOrM1306(x)
        if (p -> cjs . is_escape ) {




          Scheme_Cont * target ; 
          BLOCK_SETUP((PUSH(target, 0+XfOrM1309_COUNT)));
#         define XfOrM1322_COUNT (1+XfOrM1309_COUNT)
#         define SETUP_XfOrM1322(x) SETUP(XfOrM1322_COUNT)
          target = NULLED_OUT ; 

# 7211 "./../src/fun.c"
          target = (Scheme_Cont * ) p -> cjs . val ; 
          FUNCCALL(SETUP_XfOrM1322(_), reset_cjs (& p -> cjs ) ); 

          v = FUNCCALL_AGAIN(compose_continuation (target , 1 , (Scheme_Object * ) prompt , 0 ) ); 

          if (v ) {
#           define XfOrM1329_COUNT (0+XfOrM1322_COUNT)
#           define SETUP_XfOrM1329(x) SETUP_XfOrM1322(x)

# 7218 "./../src/fun.c"
            if (v == ((Scheme_Object * ) 0x6 ) ) {
              if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
                p -> values_buffer = ((void * ) 0 ) ; 
            }
            FUNCCALL(SETUP_XfOrM1329(_), prompt_unwind_one_dw (prompt_tag ) ); 
            handler = ((void * ) 0 ) ; 
          }

# 7224 "./../src/fun.c"
          else {
#           define XfOrM1323_COUNT (0+XfOrM1322_COUNT)
#           define SETUP_XfOrM1323(x) SETUP_XfOrM1322(x)

# 7226 "./../src/fun.c"
            p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
            if (((Scheme_Object * ) p -> cjs . jumping_to_continuation ) == ((Scheme_Object * ) prompt ) )  
            {
#             define XfOrM1326_COUNT (0+XfOrM1323_COUNT)
#             define SETUP_XfOrM1326(x) SETUP_XfOrM1323(x)
              if (p -> cjs . is_escape ) {
#               define XfOrM1328_COUNT (0+XfOrM1326_COUNT)
#               define SETUP_XfOrM1328(x) SETUP_XfOrM1326(x)
                FUNCCALL(SETUP_XfOrM1328(_), scheme_signal_error ("escape-to-prompt escaped!" ) )
# 7233 "./../src/fun.c"
                ; 
                RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
              }

# 7235 "./../src/fun.c"
              else {
#               define XfOrM1327_COUNT (0+XfOrM1326_COUNT)
#               define SETUP_XfOrM1327(x) SETUP_XfOrM1326(x)
                FUNCCALL(SETUP_XfOrM1327(_), prompt_unwind_one_dw (prompt_tag ) ); 
                v = ((void * ) 0 ) ; 
              }
            }

# 7241 "./../src/fun.c"
            else if (p -> cjs . is_escape ) {
#             define XfOrM1325_COUNT (0+XfOrM1323_COUNT)
#             define SETUP_XfOrM1325(x) SETUP_XfOrM1323(x)
              FUNCCALL(SETUP_XfOrM1325(_), continue_prompt_escape () ); 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }

# 7246 "./../src/fun.c"
            else {
#             define XfOrM1324_COUNT (0+XfOrM1323_COUNT)
#             define SETUP_XfOrM1324(x) SETUP_XfOrM1323(x)
              FUNCCALL(SETUP_XfOrM1324(_), restore_from_prompt (prompt ) )
# 7248 "./../src/fun.c"
              ; 
              FUNCCALL(SETUP_XfOrM1324(_), prompt_unwind_one_dw (prompt_tag ) ); 
              (((intptr_t * ) (void * ) ((* p -> error_buf ) . gcvs ) ) [1 ] = (* p -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* p -> error_buf ) . gcvs , longjmp ((* p -> error_buf ) . jb , 1 ) ) ; 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
          }
        }

# 7254 "./../src/fun.c"
        else {
#         define XfOrM1321_COUNT (0+XfOrM1309_COUNT)
#         define SETUP_XfOrM1321(x) SETUP_XfOrM1309(x)
          FUNCCALL(SETUP_XfOrM1321(_), prompt_unwind_one_dw (prompt_tag ) )
          ; 
          v = ((void * ) 0 ) ; 
        }




        if (! v ) {
#         define XfOrM1311_COUNT (0+XfOrM1309_COUNT)
#         define SETUP_XfOrM1311(x) SETUP_XfOrM1309(x)
          FUNCCALL(SETUP_XfOrM1311(_), get_set_cont_mark_by_pos (prompt_cc_guard_key , p , ((void * ) 0 ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) , scheme_false ) )
# 7267 "./../src/fun.c"
          ; 

          argc = p -> cjs . num_vals ; 

          if (argc == 1 ) {
            a [0 ] = p -> cjs . val ; 
            argv = a ; 
          }

# 7274 "./../src/fun.c"
          else 
          argv = (Scheme_Object * * ) p -> cjs . val ; 
          FUNCCALL(SETUP_XfOrM1311(_), reset_cjs (& p -> cjs ) )
          ; 





          if (chaperone ) {
#           define XfOrM1319_COUNT (0+XfOrM1311_COUNT)
#           define SETUP_XfOrM1319(x) SETUP_XfOrM1311(x)

# 7284 "./../src/fun.c"
            argv = FUNCCALL(SETUP_XfOrM1319(_), chaperone_do_prompt_handler (chaperone , argc , argv ) ); 
          }

          if ((handler ) == (scheme_values_proc ) )  {
#           define XfOrM1317_COUNT (0+XfOrM1311_COUNT)
#           define SETUP_XfOrM1317(x) SETUP_XfOrM1311(x)

# 7288 "./../src/fun.c"
            v = FUNCCALL(SETUP_XfOrM1317(_), scheme_values (argc , argv ) ); 
            if (v == ((Scheme_Object * ) 0x6 ) ) {
              if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
                p -> values_buffer = ((void * ) 0 ) ; 
            }
            handler = ((void * ) 0 ) ; 
          }

# 7294 "./../src/fun.c"
          else if (((handler ) ) == (scheme_false ) )  {
#           define XfOrM1312_COUNT (0+XfOrM1311_COUNT)
#           define SETUP_XfOrM1312(x) SETUP_XfOrM1311(x)

# 7295 "./../src/fun.c"
            if (argc == 1 ) {
#             define XfOrM1314_COUNT (0+XfOrM1312_COUNT)
#             define SETUP_XfOrM1314(x) SETUP_XfOrM1312(x)

# 7296 "./../src/fun.c"
              if (! FUNCCALL(SETUP_XfOrM1314(_), scheme_check_proc_arity (((void * ) 0 ) , 0 , 0 , argc , argv ) )) {

                handler_argument_error = 1 ; 
                handler = ((void * ) 0 ) ; 
              }

# 7300 "./../src/fun.c"
              else {
                proc = a [0 ] ; 
                argc = 0 ; 
                argv = ((void * ) 0 ) ; 
              }
            }

# 7305 "./../src/fun.c"
            else {

              handler_argument_error = 1 ; 
              handler = ((void * ) 0 ) ; 
            }
          }
        }

# 7311 "./../src/fun.c"
        else {
          argc = 0 ; 
          argv = ((void * ) 0 ) ; 
        }
      }

# 7315 "./../src/fun.c"
      else {
#       define XfOrM1307_COUNT (0+XfOrM1306_COUNT)
#       define SETUP_XfOrM1307(x) SETUP_XfOrM1306(x)

# 7317 "./../src/fun.c"
        if ((p -> dw != prompt_dw ) 
        && (! p -> dw || ! prompt_dw -> id || (p -> dw -> id != prompt_dw -> id ) ) ) {
        }

        else FUNCCALL(SETUP_XfOrM1307(_), prompt_unwind_one_dw (prompt_tag ) )
        ; 
        (((intptr_t * ) (void * ) ((* p -> error_buf ) . gcvs ) ) [1 ] = (* p -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* p -> error_buf ) . gcvs , longjmp ((* p -> error_buf ) . jb , 1 ) ) ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 7326 "./../src/fun.c"
    else {
#     define XfOrM1305_COUNT (0+XfOrM1301_COUNT)
#     define SETUP_XfOrM1305(x) SETUP_XfOrM1301(x)
      FUNCCALL(SETUP_XfOrM1305(_), prompt_unwind_one_dw (prompt_tag ) )
# 7327 "./../src/fun.c"
      ; 
      handler = ((void * ) 0 ) ; 
      argc = 0 ; 
      argv = ((void * ) 0 ) ; 
    }

    cc_guard = FUNCCALL(SETUP_XfOrM1301(_), get_set_cont_mark_by_pos (prompt_cc_guard_key , p , ((void * ) 0 ) , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) , ((void * ) 0 ) ) ); 
    if (((cc_guard ) ) == (scheme_false ) ) 

# 7334 "./../src/fun.c"
    cc_guard = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM1301(_), scheme_pop_continuation_frame (& cframe ) )
    ; 

    if (cc_count == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_cont_capture_count_ ) ) {
#     define XfOrM1302_COUNT (0+XfOrM1301_COUNT)
#     define SETUP_XfOrM1302(x) SETUP_XfOrM1301(x)

# 7339 "./../src/fun.c"
      if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) ) {
#       define XfOrM1304_COUNT (0+XfOrM1302_COUNT)
#       define SETUP_XfOrM1304(x) SETUP_XfOrM1302(x)
        (
# 7340 "./../src/fun.c"
        memset (prompt , 0 , sizeof (Scheme_Prompt ) ) ) ; 
        prompt -> so . type = scheme_prompt_type ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_regular_prompt_ ) = prompt ; 
      }
      if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) ) {
#       define XfOrM1303_COUNT (0+XfOrM1302_COUNT)
#       define SETUP_XfOrM1303(x) SETUP_XfOrM1302(x)
        (
# 7345 "./../src/fun.c"
        memset (prompt_dw , 0 , sizeof (Scheme_Dynamic_Wind ) ) ) ; 

        prompt_dw -> type = scheme_rt_dyn_wind ; 

        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> available_prompt_dw_ ) = prompt_dw ; 
      }
    }
  }

# 7352 "./../src/fun.c"
  while (handler && (((handler ) ) == (scheme_false ) ) ) ; 

  if (handler_argument_error ) {
#   define XfOrM1263_COUNT (0+XfOrM1260_COUNT)
#   define SETUP_XfOrM1263(x) SETUP_XfOrM1260(x)

# 7355 "./../src/fun.c"
    if (argc == 1 ) {
#     define XfOrM1265_COUNT (0+XfOrM1263_COUNT)
#     define SETUP_XfOrM1265(x) SETUP_XfOrM1263(x)
      FUNCCALL(SETUP_XfOrM1265(_), scheme_check_proc_arity ("default-continuation-prompt-handler" , 0 , 0 , argc , argv ) )
# 7356 "./../src/fun.c"
      ; 
    }

# 7357 "./../src/fun.c"
    else {
#     define XfOrM1264_COUNT (0+XfOrM1263_COUNT)
#     define SETUP_XfOrM1264(x) SETUP_XfOrM1263(x)
      FUNCCALL(SETUP_XfOrM1264(_), scheme_wrong_return_arity ("call-with-continuation-prompt" , 1 , argc , argv , "\n  in: application of default prompt handler" ) )
# 7359 "./../src/fun.c"
      ; 
    }
  }

  if (handler ) {
#   define XfOrM1262_COUNT (0+XfOrM1260_COUNT)
#   define SETUP_XfOrM1262(x) SETUP_XfOrM1260(x)

# 7364 "./../src/fun.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1262(_), scheme_tail_apply (handler , argc , argv ) )) RET_VALUE_END ; 
  }

# 7365 "./../src/fun.c"
  else if (cc_guard ) {
#   define XfOrM1261_COUNT (0+XfOrM1260_COUNT)
#   define SETUP_XfOrM1261(x) SETUP_XfOrM1260(x)

# 7366 "./../src/fun.c"
    if ((cc_guard ) == (scheme_values_proc ) ) 
      cc_guard = ((void * ) 0 ) ; 
    if (cc_guard || chaperone )
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1261(_), do_cc_guard (v , cc_guard , chaperone ) )) RET_VALUE_END ; 
    else 
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

# 7372 "./../src/fun.c"
  else 
  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7376 "./../src/fun.c"
static Scheme_Object * propagate_abort (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * * argv2 ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv2, 0), PUSH(argv, 1)));
# define XfOrM1346_COUNT (2)
# define SETUP_XfOrM1346(x) SETUP(XfOrM1346_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  argv2 = NULLED_OUT ; 

# 7380 "./../src/fun.c"
  argv2 = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1346(_), GC_malloc (sizeof (Scheme_Object * ) * (argc + 1 ) ) )) ; 
  (memcpy (argv2 XFORM_OK_PLUS 1 , argv , sizeof (Scheme_Object * ) * argc ) ) ; 
  argv2 [0 ] = scheme_default_prompt_tag ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_do_eval (abort_continuation_proc , argc + 1 , argv2 , 1 ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7387 "./../src/fun.c"
static Scheme_Object * do_call_with_prompt (Scheme_Closed_Prim f , void * data , 
int multi , int top_level ) 
{
  Scheme_Object * prim , * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0), PUSH(prim, 3)));
# define XfOrM1347_COUNT (4)
# define SETUP_XfOrM1347(x) SETUP(XfOrM1347_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prim = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 7392 "./../src/fun.c"
  prim = FUNCCALL(SETUP_XfOrM1347(_), scheme_make_closed_prim (f , data ) ); 
  a [0 ] = prim ; 
  a [1 ] = scheme_default_prompt_tag ; 
  a [2 ] = propagate_abort_prim ; 

  if (multi ) {
#   define XfOrM1349_COUNT (0+XfOrM1347_COUNT)
#   define SETUP_XfOrM1349(x) SETUP_XfOrM1347(x)

# 7398 "./../src/fun.c"
    if (top_level )
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1349(_), scheme_apply_multi (call_with_prompt_proc , 3 , a ) )) RET_VALUE_END ; 
    else 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1349(_), scheme_do_eval (call_with_prompt_proc , 3 , a , - 1 ) )) RET_VALUE_END ; 
  }

# 7402 "./../src/fun.c"
  else {
#   define XfOrM1348_COUNT (0+XfOrM1347_COUNT)
#   define SETUP_XfOrM1348(x) SETUP_XfOrM1347(x)

# 7403 "./../src/fun.c"
    if (top_level )
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1348(_), scheme_apply (call_with_prompt_proc , 3 , a ) )) RET_VALUE_END ; 
    else 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1348(_), scheme_do_eval (call_with_prompt_proc , 3 , a , 1 ) )) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7410 "./../src/fun.c"
Scheme_Object * scheme_call_with_prompt (Scheme_Closed_Prim f , void * data ) 
{
  /* No conversion */

# 7412 "./../src/fun.c"
  return do_call_with_prompt (f , data , 0 , 1 ) ; 
}

Scheme_Object * scheme_call_with_prompt_multi (Scheme_Closed_Prim f , void * data ) 
{
  /* No conversion */

# 7417 "./../src/fun.c"
  return do_call_with_prompt (f , data , 1 , 1 ) ; 
}

Scheme_Object * _scheme_call_with_prompt (Scheme_Closed_Prim f , void * data ) 
{
  /* No conversion */

# 7422 "./../src/fun.c"
  return do_call_with_prompt (f , data , 0 , 0 ) ; 
}

Scheme_Object * _scheme_call_with_prompt_multi (Scheme_Closed_Prim f , void * data ) 
{
  /* No conversion */

# 7427 "./../src/fun.c"
  return do_call_with_prompt (f , data , 1 , 0 ) ; 
}

Scheme_Object * scheme_compose_continuation (Scheme_Cont * cont , int num_rands , Scheme_Object * value ) 
{
  Scheme_Meta_Continuation * mc ; 
  int empty_to_next_mc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(value, 0), PUSH(cont, 1), PUSH(mc, 2)));
# define XfOrM1354_COUNT (3)
# define SETUP_XfOrM1354(x) SETUP(XfOrM1354_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  mc = NULLED_OUT ; 

# 7435 "./../src/fun.c"
  if (num_rands != 1 ) {
#   define XfOrM1369_COUNT (0+XfOrM1354_COUNT)
#   define SETUP_XfOrM1369(x) SETUP_XfOrM1354(x)

# 7436 "./../src/fun.c"
    value = FUNCCALL(SETUP_XfOrM1369(_), scheme_values (num_rands , (Scheme_Object * * ) value ) ); 
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      if ((p -> ku . multiple . array ) == (p -> values_buffer ) ) 
        p -> values_buffer = ((void * ) 0 ) ; 
    }
  }
  cont -> value = value ; 
  cont -> common_dw_depth = - 1 ; 

  mc = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> meta_continuation ; 
  if (mc && mc -> pseudo && mc -> meta_tail_pos == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) {






    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    Scheme_Object * cm_info ; 
    intptr_t findpos , bottom , pos ; 
    int count , mcount , i ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM1354_COUNT), PUSH(cm_info, 1+XfOrM1354_COUNT)));
#   define XfOrM1360_COUNT (2+XfOrM1354_COUNT)
#   define SETUP_XfOrM1360(x) SETUP(XfOrM1360_COUNT)
    cm_info = NULLED_OUT ; 

# 7459 "./../src/fun.c"
    p -> meta_continuation = mc -> next ; 

    bottom = (intptr_t ) p -> cont_mark_stack_bottom ; 
    count = 0 ; 
    for (findpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) - 1 ; findpos >= bottom ; findpos -- ) {
      GC_CAN_IGNORE Scheme_Cont_Mark * seg ; 

      seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
      pos = findpos & ((1 << 6 ) - 1 ) ; 
      if (seg [pos ] . pos != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) )
        break ; 
      count ++ ; 
    }
    mcount = 0 ; 
    for (findpos = (intptr_t ) mc -> cont_mark_total ; findpos -- ; ) {
      if (mc -> cont_mark_stack_copied [findpos ] . pos != mc -> cont_mark_pos )
        break ; 
      mcount ++ ; 
    }

    cm_info = FUNCCALL(SETUP_XfOrM1360(_), scheme_make_vector ((count + mcount ) * 2 , ((void * ) 0 ) ) ); 
    for (findpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) - 1 , i = 0 ; i < count ; findpos -- , i ++ ) {
      GC_CAN_IGNORE Scheme_Cont_Mark * seg ; 

      seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
      pos = findpos & ((1 << 6 ) - 1 ) ; 
      (((Scheme_Vector * ) (cm_info ) ) -> els ) [2 * i ] = seg [pos ] . key ; 
      (((Scheme_Vector * ) (cm_info ) ) -> els ) [(2 * i ) + 1 ] = seg [pos ] . val ; 
    }
    for (findpos = (intptr_t ) mc -> cont_mark_total - 1 , i = 0 ; i < mcount ; findpos -- , i ++ ) {
      (((Scheme_Vector * ) (cm_info ) ) -> els ) [2 * (count + i ) ] = mc -> cont_mark_stack_copied [findpos ] . key ; 
      (((Scheme_Vector * ) (cm_info ) ) -> els ) [(2 * (count + i ) ) + 1 ] = mc -> cont_mark_stack_copied [findpos ] . val ; 
    }

    p -> cjs . jumping_to_continuation = cm_info ; 
    p -> cjs . alt_full_continuation = ((void * ) 0 ) ; 
    p -> cjs . val = (Scheme_Object * ) cont ; 
    p -> cjs . num_vals = 1 ; 
    p -> cjs . is_escape = 1 ; 
    p -> cjs . skip_dws = 0 ; 

    p -> stack_start = mc -> overflow -> stack_start ; 
    p -> decompose_mc = mc ; 
    FUNCCALL(SETUP_XfOrM1360(_), scheme_longjmpup (& mc -> overflow -> jmp -> cont ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 7505 "./../src/fun.c"
  else if (mc && mc -> meta_tail_pos == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) {
    empty_to_next_mc = 1 ; 
  }

# 7507 "./../src/fun.c"
  else {
    empty_to_next_mc = 0 ; 
  }


  mc = ((void * ) 0 ) ; 

  value = FUNCCALL(SETUP_XfOrM1354(_), compose_continuation (cont , 0 , ((void * ) 0 ) , empty_to_next_mc ) ); 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> next_meta -= 1 ; 

  if (! value ) {


    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM1355_COUNT (0+XfOrM1354_COUNT)
#   define SETUP_XfOrM1355(x) SETUP_XfOrM1354(x)

# 7522 "./../src/fun.c"
    if (p -> cjs . is_escape ) {
#     define XfOrM1357_COUNT (0+XfOrM1355_COUNT)
#     define SETUP_XfOrM1357(x) SETUP_XfOrM1355(x)
      FUNCCALL(SETUP_XfOrM1357(_), continue_prompt_escape () ); 
    }

# 7526 "./../src/fun.c"
    else {
      (((intptr_t * ) (void * ) ((* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs ) ) [1 ] = (* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . gcvs , longjmp ((* XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ) . jb , 1 ) ) ; 
    }
  }

  RET_VALUE_START (value ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7534 "./../src/fun.c"
static Scheme_Object * do_abort_continuation (int argc , Scheme_Object * argv [] , int skip_dws ) 
{
  Scheme_Object * prompt_tag ; 
  Scheme_Prompt * prompt ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * a [1 ] ; 
  Scheme_Object * * vals ; 
  int is_chaperoned = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(prompt, 0), PUSH(vals, 1), PUSH(p, 2), PUSHARRAY(a, 1, 3), PUSH(prompt_tag, 6), PUSH(argv, 7)));
# define XfOrM1371_COUNT (8)
# define SETUP_XfOrM1371(x) SETUP(XfOrM1371_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prompt_tag = NULLED_OUT ; 
  prompt = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  vals = NULLED_OUT ; 

# 7543 "./../src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) {
#   define XfOrM1380_COUNT (0+XfOrM1371_COUNT)
#   define SETUP_XfOrM1380(x) SETUP_XfOrM1371(x)

# 7545 "./../src/fun.c"
    if ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) ) {
      is_chaperoned = 1 ; 
      prompt_tag = (((Scheme_Chaperone * ) argv [0 ] ) -> val ) ; 
    }

# 7549 "./../src/fun.c"
    else {
#     define XfOrM1381_COUNT (0+XfOrM1380_COUNT)
#     define SETUP_XfOrM1381(x) SETUP_XfOrM1380(x)
      FUNCCALL(SETUP_XfOrM1381(_), scheme_wrong_contract ("abort-current-continuation" , "continuation-prompt-tag?" , 0 , argc , argv ) )
# 7551 "./../src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 7554 "./../src/fun.c"
  else 
  prompt_tag = argv [0 ] ; 

  if ((prompt_tag ) == (scheme_root_prompt_tag ) )  {
#   define XfOrM1379_COUNT (0+XfOrM1371_COUNT)
#   define SETUP_XfOrM1379(x) SETUP_XfOrM1371(x)
    FUNCCALL(SETUP_XfOrM1379(_), root_prompt_tag_misuse ("abort-current-continuation" ) )
# 7558 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  prompt = (Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1371(_), scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ) ); 
  if (! prompt && ((scheme_default_prompt_tag ) == (prompt_tag ) ) )
    prompt = original_default_prompt ; 

  if (! prompt ) {
#   define XfOrM1378_COUNT (0+XfOrM1371_COUNT)
#   define SETUP_XfOrM1378(x) SETUP_XfOrM1371(x)
    FUNCCALL(SETUP_XfOrM1378(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "abort-current-continuation: continuation includes no prompt with the given tag\n" "  tag: %V" , prompt_tag ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argc == 2 ) {
#   define XfOrM1376_COUNT (0+XfOrM1371_COUNT)
#   define SETUP_XfOrM1376(x) SETUP_XfOrM1371(x)

# 7575 "./../src/fun.c"
    p -> cjs . num_vals = 1 ; 





    if (! is_chaperoned )
      p -> cjs . val = argv [1 ] ; 
    else {
#     define XfOrM1377_COUNT (0+XfOrM1376_COUNT)
#     define SETUP_XfOrM1377(x) SETUP_XfOrM1376(x)

# 7584 "./../src/fun.c"
      a [0 ] = argv [1 ] ; 
      vals = FUNCCALL(SETUP_XfOrM1377(_), chaperone_do_abort (argv [0 ] , 1 , a ) ); 
      p -> cjs . val = (Scheme_Object * ) vals [0 ] ; 
    }
  }

# 7588 "./../src/fun.c"
  else {
    int i ; 
#   define XfOrM1372_COUNT (0+XfOrM1371_COUNT)
#   define SETUP_XfOrM1372(x) SETUP_XfOrM1371(x)

# 7590 "./../src/fun.c"
    vals = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1372(_), GC_malloc (sizeof (Scheme_Object * ) * (argc - 1 ) ) )) ; 
    for (i = argc ; i -- > 1 ; ) {
      vals [i - 1 ] = argv [i ] ; 
    }
    p -> cjs . num_vals = argc - 1 ; 
    if (! is_chaperoned )
      p -> cjs . val = (Scheme_Object * ) vals ; 
    else {
#     define XfOrM1373_COUNT (0+XfOrM1372_COUNT)
#     define SETUP_XfOrM1373(x) SETUP_XfOrM1372(x)

# 7598 "./../src/fun.c"
      vals = FUNCCALL(SETUP_XfOrM1373(_), chaperone_do_abort (argv [0 ] , argc - 1 , vals ) ); 
      p -> cjs . val = (Scheme_Object * ) vals ; 
    }
  }
  p -> cjs . jumping_to_continuation = (Scheme_Object * ) prompt ; 
  p -> cjs . alt_full_continuation = ((void * ) 0 ) ; 
  p -> cjs . skip_dws = skip_dws ; 

  (((intptr_t * ) (void * ) ((* p -> error_buf ) . gcvs ) ) [1 ] = (* p -> error_buf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* p -> error_buf ) . gcvs , longjmp ((* p -> error_buf ) . jb , 1 ) ) ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7611 "./../src/fun.c"
static Scheme_Object * abort_continuation (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7613 "./../src/fun.c"
  return do_abort_continuation (argc , argv , 0 ) ; 
}

Scheme_Object * scheme_abort_continuation_no_dws (Scheme_Object * pt , Scheme_Object * v ) 
{


  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0)));
# define XfOrM1384_COUNT (3)
# define SETUP_XfOrM1384(x) SETUP(XfOrM1384_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 7622 "./../src/fun.c"
  a [0 ] = pt ; 
  a [1 ] = v ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1384(_), do_abort_continuation (2 , a , 1 ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7628 "./../src/fun.c"
static Scheme_Object * unsafe_abort_continuation_no_dws (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */
  return do_abort_continuation (argc , argv , 1 ) ; 
}

static Scheme_Object * do_call_with_control (int argc , Scheme_Object * argv [] , int no_dws ) 
{
  Scheme_Object * prompt_tag ; 
  Scheme_Object * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0), PUSH(prompt_tag, 3), PUSH(argv, 4)));
# define XfOrM1386_COUNT (5)
# define SETUP_XfOrM1386(x) SETUP(XfOrM1386_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prompt_tag = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM1386(_), scheme_check_proc_arity ("call-with-composable-continuation" , 1 , 0 , argc , argv ) )
# 7639 "./../src/fun.c"
  ; 
  if (argc > 1 ) {
#   define XfOrM1387_COUNT (0+XfOrM1386_COUNT)
#   define SETUP_XfOrM1387(x) SETUP_XfOrM1386(x)

# 7641 "./../src/fun.c"
    prompt_tag = argv [1 ] ; 
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) ) ) {
#     define XfOrM1389_COUNT (0+XfOrM1387_COUNT)
#     define SETUP_XfOrM1389(x) SETUP_XfOrM1387(x)

# 7643 "./../src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) prompt_tag ) -> val ) ; 
      else {
#       define XfOrM1390_COUNT (0+XfOrM1389_COUNT)
#       define SETUP_XfOrM1390(x) SETUP_XfOrM1389(x)
        FUNCCALL(SETUP_XfOrM1390(_), scheme_wrong_contract ("call-with-composable-continuation" , "continuation-prompt-tag?" , 1 , argc , argv ) )
# 7648 "./../src/fun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }
    if ((prompt_tag ) == (scheme_root_prompt_tag ) )  {
#     define XfOrM1388_COUNT (0+XfOrM1387_COUNT)
#     define SETUP_XfOrM1388(x) SETUP_XfOrM1387(x)
      FUNCCALL(SETUP_XfOrM1388(_), root_prompt_tag_misuse ("abort-current-continuation" ) )
# 7653 "./../src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 7656 "./../src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  a [0 ] = argv [0 ] ; 
  a [1 ] = prompt_tag ; 
  a [2 ] = (no_dws ? scheme_true : scheme_false ) ; 



  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1386(_), scheme_tail_apply (internal_call_cc_prim , 3 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7668 "./../src/fun.c"
static Scheme_Object * call_with_control (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7670 "./../src/fun.c"
  return do_call_with_control (argc , argv , 0 ) ; 
}

Scheme_Object * scheme_call_with_composable_no_dws (Scheme_Object * proc , Scheme_Object * pt ) 
{

  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0)));
# define XfOrM1392_COUNT (3)
# define SETUP_XfOrM1392(x) SETUP(XfOrM1392_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 7678 "./../src/fun.c"
  a [0 ] = proc ; 
  a [1 ] = pt ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1392(_), do_call_with_control (2 , a , 1 ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7684 "./../src/fun.c"
static Scheme_Object * unsafe_call_with_control_no_dws (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */
  return do_call_with_control (argc , argv , 1 ) ; 
}

static Scheme_Object * unsafe_root_continuation_prompt_tag (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 7692 "./../src/fun.c"
  return scheme_root_prompt_tag ; 
}

static Scheme_Cont_Mark * copy_cm_shared_on_write (Scheme_Meta_Continuation * mc ) 
{
  Scheme_Cont_Mark * cp ; 
  DECL_RET_SAVE (Scheme_Cont_Mark * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(cp, 0), PUSH(mc, 1)));
# define XfOrM1395_COUNT (2)
# define SETUP_XfOrM1395(x) SETUP(XfOrM1395_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cp = NULLED_OUT ; 

# 7699 "./../src/fun.c"
  cp = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM1395(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (mc -> cont_mark_total ) ) )) ; 
  (memcpy (cp , mc -> cont_mark_stack_copied , mc -> cont_mark_total * sizeof (Scheme_Cont_Mark ) ) ) ; 
  mc -> cont_mark_stack_copied = cp ; 
  mc -> cm_shared = 0 ; 

  RET_VALUE_START (cp ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 7707 "./../src/fun.c"
static Scheme_Object * continuation_marks (Scheme_Thread * p , 
Scheme_Object * _cont , 
Scheme_Object * econt , 
Scheme_Meta_Continuation * mc , 
Scheme_Object * prompt_tag , 
const char * who , 
int just_chain , 
int use_boundary_prompt ) 

{
  Scheme_Cont * cont = (Scheme_Cont * ) _cont , * top_cont ; 
  Scheme_Cont_Mark_Chain * first = ((void * ) 0 ) , * last = ((void * ) 0 ) ; 
  Scheme_Cont_Mark_Set * set ; 
  Scheme_Object * cache , * nt ; 
  intptr_t findpos , bottom ; 
  intptr_t cmpos , first_cmpos = 0 , cdelta = 0 ; 
  int found_tag = 0 , at_mc_boundary = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(nt, 1), PUSH(cont, 2), PUSH(first, 3), PUSH(econt, 4), PUSH(top_cont, 5), PUSH(who, 6), PUSH(set, 7), PUSH(prompt_tag, 8), PUSH(last, 9), PUSH(mc, 10), PUSH(cache, 11)));
# define XfOrM1396_COUNT (12)
# define SETUP_XfOrM1396(x) SETUP(XfOrM1396_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  top_cont = NULLED_OUT ; 
  set = NULLED_OUT ; 
  cache = NULLED_OUT ; 
  nt = NULLED_OUT ; 

# 7725 "./../src/fun.c"
  if ((prompt_tag ) == (scheme_root_prompt_tag ) ) 
    prompt_tag = ((void * ) 0 ) ; 

  if (cont 
  && (use_boundary_prompt || ! cont -> composable ) 
  && ((cont -> prompt_tag ) == (prompt_tag ) ) )
    found_tag = 1 ; 
  if (! prompt_tag )
    found_tag = 1 ; 

  do {
#   define XfOrM1477_COUNT (0+XfOrM1396_COUNT)
#   define SETUP_XfOrM1477(x) SETUP_XfOrM1396(x)

# 7736 "./../src/fun.c"
    if (econt ) {
      findpos = (intptr_t ) ((Scheme_Escaping_Cont * ) econt ) -> envss . cont_mark_stack ; 
      cmpos = (intptr_t ) ((Scheme_Escaping_Cont * ) econt ) -> envss . cont_mark_pos ; 
      if (mc ) {
        cdelta = mc -> cont_mark_offset ; 
        bottom = 0 ; 
      }

# 7742 "./../src/fun.c"
      else 
      bottom = p -> cont_mark_stack_bottom ; 
    }

# 7744 "./../src/fun.c"
    else if (cont ) {
      findpos = (intptr_t ) cont -> ss . cont_mark_stack ; 
      cmpos = (intptr_t ) cont -> ss . cont_mark_pos ; 
      cdelta = cont -> cont_mark_offset ; 
      bottom = 0 ; 
    }

# 7749 "./../src/fun.c"
    else if (mc ) {
      findpos = (intptr_t ) mc -> cont_mark_stack ; 
      cmpos = (intptr_t ) mc -> cont_mark_pos ; 
      cdelta = mc -> cont_mark_offset ; 
      bottom = 0 ; 
      at_mc_boundary = 1 ; 
    }

# 7755 "./../src/fun.c"
    else {
      findpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
      cmpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ; 
      if (! p -> cont_mark_stack_segments )
        findpos = 0 ; 
      bottom = p -> cont_mark_stack_bottom ; 
    }

    top_cont = cont ; 

    while (findpos -- > bottom ) {
      Scheme_Cont_Mark * find ; 
      intptr_t pos ; 
      BLOCK_SETUP((PUSH(find, 0+XfOrM1477_COUNT)));
#     define XfOrM1514_COUNT (1+XfOrM1477_COUNT)
#     define SETUP_XfOrM1514(x) SETUP(XfOrM1514_COUNT)
      find = NULLED_OUT ; 

# 7769 "./../src/fun.c"
      if (cont ) {
        while (findpos < cdelta ) {
          if (! cont -> runstack_copied ) {


            cont = cont -> buf_ptr -> buf . cont ; 
          }
          cont = cont -> buf_ptr -> buf . cont ; 
          if (cont )
            cdelta = cont -> cont_mark_offset ; 
          else 
          break ; 
        }
        if (! cont )
          break ; 
        find = cont -> cont_mark_stack_copied ; 
        pos = findpos - cdelta ; 
      }

# 7786 "./../src/fun.c"
      else if (mc ) {
        if (findpos < cdelta )
          break ; 
        find = mc -> cont_mark_stack_copied ; 
        pos = findpos - cdelta ; 
      }

# 7791 "./../src/fun.c"
      else {
        GC_CAN_IGNORE Scheme_Cont_Mark * seg ; 

        seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
        pos = findpos & ((1 << 6 ) - 1 ) ; 
        find = seg ; 
      }

# 7813 "./../src/fun.c"
      if (prompt_tag && (find [pos ] . key == (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ) ) {
        found_tag = 1 ; 

        mc = ((void * ) 0 ) ; 
        p = ((void * ) 0 ) ; 
        econt = ((void * ) 0 ) ; 
        cont = ((void * ) 0 ) ; 
        top_cont = ((void * ) 0 ) ; 
        break ; 
      }

      cache = find [pos ] . cache ; 
      if (cache ) {
#       define XfOrM1535_COUNT (0+XfOrM1514_COUNT)
#       define SETUP_XfOrM1535(x) SETUP_XfOrM1514(x)

# 7826 "./../src/fun.c"
        if (((cache ) ) == (scheme_false ) ) 
          cache = ((void * ) 0 ) ; 
        if (cache ) {
#         define XfOrM1537_COUNT (0+XfOrM1535_COUNT)
#         define SETUP_XfOrM1537(x) SETUP_XfOrM1535(x)

# 7829 "./../src/fun.c"
          if ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) 
            cache = (scheme_eq_hash_get ((Scheme_Hash_Table * ) cache , prompt_tag ? prompt_tag : scheme_false ) ) ; 
          else if (prompt_tag != scheme_default_prompt_tag )
            cache = ((void * ) 0 ) ; 
        }
        if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
          cache = (((Scheme_Vector * ) (cache ) ) -> els ) [0 ] ; 
        }
      }

      if (cache ) {
        if (((Scheme_Cont_Mark_Chain * ) cache ) -> key ) {
          if (last ) {
            last -> next = (Scheme_Cont_Mark_Chain * ) cache ; 
            if (at_mc_boundary ) {
              (& (last ) -> iso ) -> so . keyex |= 0x1 ; 
              at_mc_boundary = 0 ; 
            }
          }

# 7847 "./../src/fun.c"
          else {
            first = (Scheme_Cont_Mark_Chain * ) cache ; 
            first_cmpos = cmpos ; 
          }

          found_tag = 1 ; 
        }

# 7853 "./../src/fun.c"
        else {
        }



        mc = ((void * ) 0 ) ; 
        p = ((void * ) 0 ) ; 
        econt = ((void * ) 0 ) ; 
        cont = ((void * ) 0 ) ; 
        top_cont = ((void * ) 0 ) ; 

        break ; 
      }

# 7865 "./../src/fun.c"
      else {
        Scheme_Cont_Mark_Chain * pr ; 
        BLOCK_SETUP((PUSH(pr, 0+XfOrM1514_COUNT)));
#       define XfOrM1515_COUNT (1+XfOrM1514_COUNT)
#       define SETUP_XfOrM1515(x) SETUP(XfOrM1515_COUNT)
        pr = NULLED_OUT ; 

# 7867 "./../src/fun.c"
        pr = ((Scheme_Cont_Mark_Chain * ) FUNCCALL(SETUP_XfOrM1515(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont_Mark_Chain ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
        pr -> iso . so . type = scheme_cont_mark_chain_type ; 
        pr -> key = find [pos ] . key ; 
        pr -> val = find [pos ] . val ; 
        pr -> pos = find [pos ] . pos ; 
        pr -> next = ((void * ) 0 ) ; 
        if (mc ) {
#         define XfOrM1528_COUNT (0+XfOrM1515_COUNT)
#         define SETUP_XfOrM1528(x) SETUP_XfOrM1515(x)

# 7874 "./../src/fun.c"
          if (mc -> cm_shared )
            find = FUNCCALL(SETUP_XfOrM1528(_), copy_cm_shared_on_write (mc ) ); 
          mc -> cm_caches = 1 ; 
        }
        cache = find [pos ] . cache ; 
        if (cache && ! (((cache ) ) == (scheme_false ) ) ) {
#         define XfOrM1521_COUNT (0+XfOrM1515_COUNT)
#         define SETUP_XfOrM1521(x) SETUP_XfOrM1515(x)

# 7880 "./../src/fun.c"
          if ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
            Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) cache ; 
#           define XfOrM1525_COUNT (0+XfOrM1521_COUNT)
#           define SETUP_XfOrM1525(x) SETUP_XfOrM1521(x)

# 7882 "./../src/fun.c"
            cache = (scheme_eq_hash_get (ht , prompt_tag ? prompt_tag : scheme_false ) ) ; 
            if (! cache ) {
#             define XfOrM1527_COUNT (0+XfOrM1525_COUNT)
#             define SETUP_XfOrM1527(x) SETUP_XfOrM1525(x)
              FUNCCALL(SETUP_XfOrM1527(_), scheme_hash_set (ht , prompt_tag ? prompt_tag : scheme_false , (Scheme_Object * ) pr ) )
# 7884 "./../src/fun.c"
              ; 
            }

# 7885 "./../src/fun.c"
            else {

              (((Scheme_Vector * ) (cache ) ) -> els ) [0 ] = (Scheme_Object * ) pr ; 
            }
          }

# 7889 "./../src/fun.c"
          else if (! ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {

            Scheme_Hash_Table * ht ; 
            BLOCK_SETUP((PUSH(ht, 0+XfOrM1521_COUNT)));
#           define XfOrM1524_COUNT (1+XfOrM1521_COUNT)
#           define SETUP_XfOrM1524(x) SETUP(XfOrM1524_COUNT)
            ht = NULLED_OUT ; 

# 7892 "./../src/fun.c"
            ht = FUNCCALL(SETUP_XfOrM1524(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
            FUNCCALL_AGAIN(scheme_hash_set (ht , scheme_default_prompt_tag , cache ) ); 
            FUNCCALL_AGAIN(scheme_hash_set (ht , prompt_tag ? prompt_tag : scheme_false , (Scheme_Object * ) pr ) ); 
            find [pos ] . cache = (Scheme_Object * ) ht ; 
          }

# 7896 "./../src/fun.c"
          else {
#           define XfOrM1522_COUNT (0+XfOrM1521_COUNT)
#           define SETUP_XfOrM1522(x) SETUP_XfOrM1521(x)

# 7898 "./../src/fun.c"
            if (prompt_tag == scheme_default_prompt_tag )
              (((Scheme_Vector * ) (cache ) ) -> els ) [0 ] = (Scheme_Object * ) pr ; 
            else {



              Scheme_Hash_Table * ht ; 
              Scheme_Object * vec ; 
              BLOCK_SETUP((PUSH(ht, 0+XfOrM1522_COUNT), PUSH(vec, 1+XfOrM1522_COUNT)));
#             define XfOrM1523_COUNT (2+XfOrM1522_COUNT)
#             define SETUP_XfOrM1523(x) SETUP(XfOrM1523_COUNT)
              ht = NULLED_OUT ; 
              vec = NULLED_OUT ; 

# 7906 "./../src/fun.c"
              ht = FUNCCALL(SETUP_XfOrM1523(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
              vec = FUNCCALL_AGAIN(scheme_make_vector (4 , ((void * ) 0 ) ) ); 
              (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ; 
              (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
              (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [3 ] ; 
              FUNCCALL(SETUP_XfOrM1523(_), scheme_hash_set (ht , scheme_false , vec ) ); 
              if (! prompt_tag )
                (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = (Scheme_Object * ) pr ; 
              else FUNCCALL(SETUP_XfOrM1523(_), scheme_hash_set (ht , prompt_tag , (Scheme_Object * ) pr ) )
              ; 
              find [pos ] . cache = (Scheme_Object * ) ht ; 
            }
          }
        }

# 7919 "./../src/fun.c"
        else if (prompt_tag == scheme_default_prompt_tag ) {
          find [pos ] . cache = (Scheme_Object * ) pr ; 
        }

# 7921 "./../src/fun.c"
        else {
#         define XfOrM1519_COUNT (0+XfOrM1515_COUNT)
#         define SETUP_XfOrM1519(x) SETUP_XfOrM1515(x)

# 7922 "./../src/fun.c"
          cache = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM1519(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
          FUNCCALL(SETUP_XfOrM1519(_), scheme_hash_set ((Scheme_Hash_Table * ) cache , prompt_tag ? prompt_tag : scheme_false , (Scheme_Object * ) pr ) )

          ; 
          find [pos ] . cache = cache ; 
        }
        if (last ) {
          last -> next = pr ; 
          if (at_mc_boundary ) {
            (& (last ) -> iso ) -> so . keyex |= 1 ; 
            at_mc_boundary = 0 ; 
          }
        }

# 7934 "./../src/fun.c"
        else {
          first = pr ; 
          first_cmpos = cmpos ; 
        }

        last = pr ; 
      }
    }

    if (mc ) {
      mc = mc -> next ; 
    }

# 7945 "./../src/fun.c"
    else if (top_cont ) {
      mc = top_cont -> meta_continuation ; 
    }

# 7947 "./../src/fun.c"
    else if (econt ) {
      mc = p -> meta_continuation ; 
    }

# 7949 "./../src/fun.c"
    else if (p ) {
      mc = p -> meta_continuation ; 
    }
    cont = ((void * ) 0 ) ; 
    econt = ((void * ) 0 ) ; 
    p = ((void * ) 0 ) ; 
  }

# 7955 "./../src/fun.c"
  while (mc ) ; 

  if (! found_tag ) {
#   define XfOrM1398_COUNT (0+XfOrM1396_COUNT)
#   define SETUP_XfOrM1398(x) SETUP_XfOrM1396(x)

# 7958 "./../src/fun.c"
    if (! ((prompt_tag ) == (scheme_default_prompt_tag ) ) ) {
#     define XfOrM1400_COUNT (0+XfOrM1398_COUNT)
#     define SETUP_XfOrM1400(x) SETUP_XfOrM1398(x)

      while (first ) {
        first -> key = ((void * ) 0 ) ; 
        first = first -> next ; 
      }
      if (! who )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "%s: no corresponding prompt in the continuation\n" "  tag: %V" , who , prompt_tag ) )


      ; 
    }

# 7972 "./../src/fun.c"
    else if (! use_boundary_prompt ) {

      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (just_chain )
    RET_VALUE_START ((Scheme_Object * ) first ) RET_VALUE_END ; 









  nt = ((void * ) 0 ) ; 


  if (first && (first_cmpos < first -> pos ) ) {
#   define XfOrM1397_COUNT (0+XfOrM1396_COUNT)
#   define SETUP_XfOrM1397(x) SETUP_XfOrM1396(x)
    FUNCCALL(SETUP_XfOrM1397(_), scheme_log_abort ("internal error: bad mark-stack position" ) ); 
    FUNCCALL(SETUP_XfOrM1397(_), abort () ); 
  }

  set = ((Scheme_Cont_Mark_Set * ) FUNCCALL(SETUP_XfOrM1396(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont_Mark_Set ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  set -> so . type = scheme_cont_mark_set_type ; 
  set -> chain = first ; 
  set -> cmpos = first_cmpos ; 
  set -> native_stack_trace = nt ; 

  RET_VALUE_START ((Scheme_Object * ) set ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8008 "./../src/fun.c"
static Scheme_Object * make_empty_marks () 
{

  Scheme_Cont_Mark_Set * set ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(set, 0)));
# define XfOrM1551_COUNT (1)
# define SETUP_XfOrM1551(x) SETUP(XfOrM1551_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  set = NULLED_OUT ; 

# 8013 "./../src/fun.c"
  set = ((Scheme_Cont_Mark_Set * ) FUNCCALL(SETUP_XfOrM1551(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cont_Mark_Set ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  set -> so . type = scheme_cont_mark_set_type ; 
  set -> chain = ((void * ) 0 ) ; 
  set -> cmpos = 1 ; 
  set -> native_stack_trace = ((void * ) 0 ) ; 

  RET_VALUE_START ((Scheme_Object * ) set ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8022 "./../src/fun.c"
Scheme_Object * scheme_current_continuation_marks_as (const char * who , Scheme_Object * prompt_tag ) 

{
  /* No conversion */

# 8025 "./../src/fun.c"
  return continuation_marks (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 
  prompt_tag ? prompt_tag : scheme_default_prompt_tag , 
  who , 
  0 , 1 ) ; 
}

Scheme_Object * scheme_current_continuation_marks (Scheme_Object * prompt_tag ) 
{
  /* No conversion */

# 8033 "./../src/fun.c"
  return scheme_current_continuation_marks_as ("continuation-marks" , prompt_tag ) ; 
}

Scheme_Object * scheme_all_current_continuation_marks () 
{
  /* No conversion */

# 8038 "./../src/fun.c"
  return continuation_marks (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 
  ((void * ) 0 ) , 
  "continuation-marks" , 
  0 , 1 ) ; 
}

Scheme_Cont_Mark_Chain * current_mark_chain (const char * who , Scheme_Object * prompt_tag ) {
  /* No conversion */

# 8045 "./../src/fun.c"
  return (Scheme_Cont_Mark_Chain * ) continuation_marks (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , 
  prompt_tag , 
  who , 
  1 , 1 ) ; 
}

static Scheme_Object * 
cc_marks (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * prompt_tag ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0)));
# define XfOrM1556_COUNT (1)
# define SETUP_XfOrM1556(x) SETUP(XfOrM1556_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prompt_tag = NULLED_OUT ; 

# 8056 "./../src/fun.c"
  if (argc ) {
#   define XfOrM1557_COUNT (0+XfOrM1556_COUNT)
#   define SETUP_XfOrM1557(x) SETUP_XfOrM1556(x)

# 8057 "./../src/fun.c"
    prompt_tag = argv [0 ] ; 
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) ) ) {
#     define XfOrM1559_COUNT (0+XfOrM1557_COUNT)
#     define SETUP_XfOrM1559(x) SETUP_XfOrM1557(x)

# 8059 "./../src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) prompt_tag ) -> val ) ; 
      else FUNCCALL_EMPTY(scheme_wrong_contract ("current-continuation-marks" , "continuation-prompt-tag?" , 0 , argc , argv ) )

      ; 
    }

    if (! ((scheme_default_prompt_tag ) == (prompt_tag ) ) 
    && ! ((scheme_root_prompt_tag ) == (prompt_tag ) ) )
      if (! FUNCCALL(SETUP_XfOrM1557(_), scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ) )) {
#     define XfOrM1558_COUNT (0+XfOrM1557_COUNT)
#     define SETUP_XfOrM1558(x) SETUP_XfOrM1557(x)
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "current-continuation-marks: no corresponding prompt in the continuation\n" "  prompt tag: %V" , prompt_tag ) )
      ; 
    }
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_current_continuation_marks (argc ? prompt_tag : ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8080 "./../src/fun.c"
static Scheme_Object * 
cont_marks (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * prompt_tag ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0), PUSH(argv, 1)));
# define XfOrM1560_COUNT (2)
# define SETUP_XfOrM1560(x) SETUP(XfOrM1560_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  prompt_tag = NULLED_OUT ; 

# 8085 "./../src/fun.c"
  if ((! (((argv [0 ] ) ) == (scheme_false ) ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_type ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-marks" , "(or/c continuation? thread? #f)" , 0 , argc , argv ) ); 

  if (argc > 1 ) {
#   define XfOrM1573_COUNT (0+XfOrM1560_COUNT)
#   define SETUP_XfOrM1573(x) SETUP_XfOrM1560(x)

# 8090 "./../src/fun.c"
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) ) ) {
#     define XfOrM1574_COUNT (0+XfOrM1573_COUNT)
#     define SETUP_XfOrM1574(x) SETUP_XfOrM1573(x)

# 8091 "./../src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) argv [1 ] ) -> val ) ; 
      else {
#       define XfOrM1575_COUNT (0+XfOrM1574_COUNT)
#       define SETUP_XfOrM1575(x) SETUP_XfOrM1574(x)
        FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-marks" , "continuation-prompt-tag?" , 1 , argc , argv ) )
# 8096 "./../src/fun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 8099 "./../src/fun.c"
    else 
    prompt_tag = argv [1 ] ; 
  }

# 8101 "./../src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  if (((argv [0 ] ) ) == (scheme_false ) )  {
#   define XfOrM1572_COUNT (0+XfOrM1560_COUNT)
#   define SETUP_XfOrM1572(x) SETUP_XfOrM1560(x)

# 8105 "./../src/fun.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_empty_marks () )) RET_VALUE_EMPTY_END ; 
  }

# 8106 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) )  {
#   define XfOrM1569_COUNT (0+XfOrM1560_COUNT)
#   define SETUP_XfOrM1569(x) SETUP_XfOrM1560(x)

# 8107 "./../src/fun.c"
    if (! FUNCCALL(SETUP_XfOrM1569(_), scheme_escape_continuation_ok (argv [0 ] ) )) {
#     define XfOrM1571_COUNT (0+XfOrM1569_COUNT)
#     define SETUP_XfOrM1571(x) SETUP_XfOrM1569(x)
      FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "continuation-marks: escape continuation not in the current thread's continuation\n" "  escape continuation: %V" , argv [0 ] ) ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 8112 "./../src/fun.c"
    else {
      Scheme_Meta_Continuation * mc ; 
      BLOCK_SETUP((PUSH(mc, 0+XfOrM1569_COUNT)));
#     define XfOrM1570_COUNT (1+XfOrM1569_COUNT)
#     define SETUP_XfOrM1570(x) SETUP(XfOrM1570_COUNT)
      mc = NULLED_OUT ; 

# 8114 "./../src/fun.c"
      mc = FUNCCALL(SETUP_XfOrM1570(_), scheme_get_meta_continuation (argv [0 ] ) ); 

      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(continuation_marks (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , ((void * ) 0 ) , argv [0 ] , mc , prompt_tag , "continuation-marks" , 0 , 1 ) )) RET_VALUE_EMPTY_END 
      ; 
    }
  }

# 8119 "./../src/fun.c"
  else if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) )  {
    Scheme_Thread * t = (Scheme_Thread * ) argv [0 ] ; 
    Scheme_Object * m ; 
    BLOCK_SETUP((PUSH(m, 0+XfOrM1560_COUNT), PUSH(t, 1+XfOrM1560_COUNT)));
#   define XfOrM1562_COUNT (2+XfOrM1560_COUNT)
#   define SETUP_XfOrM1562(x) SETUP(XfOrM1562_COUNT)
    m = NULLED_OUT ; 

# 8123 "./../src/fun.c"
    while (t -> nestee ) {
      t = t -> nestee ; 
    }

    if ((t ) == (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ) 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_current_continuation_marks (prompt_tag ) )) RET_VALUE_EMPTY_END ; 

    while (t -> return_marks_to ) {
#     define XfOrM1566_COUNT (0+XfOrM1562_COUNT)
#     define SETUP_XfOrM1566(x) SETUP_XfOrM1562(x)
      FUNCCALL(SETUP_XfOrM1566(_), scheme_thread_block (0.0 ) )
# 8131 "./../src/fun.c"
      ; 
    }

    if (! (t -> running & 0x1 ) ) {
#     define XfOrM1564_COUNT (0+XfOrM1562_COUNT)
#     define SETUP_XfOrM1564(x) SETUP_XfOrM1562(x)

# 8135 "./../src/fun.c"
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_empty_marks () )) RET_VALUE_EMPTY_END ; 
    }

# 8136 "./../src/fun.c"
    else {
#     define XfOrM1563_COUNT (0+XfOrM1562_COUNT)
#     define SETUP_XfOrM1563(x) SETUP_XfOrM1562(x)
      FUNCCALL(SETUP_XfOrM1563(_), scheme_start_atomic () )
# 8137 "./../src/fun.c"
      ; 

      t -> return_marks_to = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      t -> returned_marks = prompt_tag ; 
      FUNCCALL(SETUP_XfOrM1563(_), scheme_swap_thread (t ) ); 

      m = t -> returned_marks ; 
      t -> returned_marks = ((void * ) 0 ) ; 
      FUNCCALL(SETUP_XfOrM1563(_), scheme_end_atomic_no_swap () )
      ; 

      if (! m )
        FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "%s: no corresponding prompt in the continuation\n" "  tag: %V" , "continuation-marks" , prompt_tag ) )


      ; 

      RET_VALUE_START (m ) RET_VALUE_END ; 
    }
  }

# 8156 "./../src/fun.c"
  else {
#   define XfOrM1561_COUNT (0+XfOrM1560_COUNT)
#   define SETUP_XfOrM1561(x) SETUP_XfOrM1560(x)

# 8157 "./../src/fun.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(continuation_marks (((void * ) 0 ) , argv [0 ] , ((void * ) 0 ) , ((void * ) 0 ) , prompt_tag , "continuation-marks" , 0 , 1 ) )) RET_VALUE_EMPTY_END 
    ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8162 "./../src/fun.c"
static Scheme_Object * 
cc_marks_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8165 "./../src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) )
    return scheme_false ; 
  else 
  return scheme_true ; 
}

static Scheme_Object * 
extract_cc_marks (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Cont_Mark_Chain * chain ; 
  Scheme_Object * first = scheme_null , * last = ((void * ) 0 ) , * key , * prompt_tag ; 
  Scheme_Object * v ; 
  Scheme_Object * pr ; 
  int is_chaperoned = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(chain, 0), PUSH(v, 1), PUSH(argv, 2), PUSH(prompt_tag, 3), PUSH(key, 4), PUSH(last, 5), PUSH(pr, 6), PUSH(first, 7)));
# define XfOrM1577_COUNT (8)
# define SETUP_XfOrM1577(x) SETUP(XfOrM1577_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  chain = NULLED_OUT ; 
  key = NULLED_OUT ; 
  prompt_tag = NULLED_OUT ; 
  v = NULLED_OUT ; 
  pr = NULLED_OUT ; 

# 8180 "./../src/fun.c"
  if ((! (((argv [0 ] ) ) == (scheme_false ) ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) ) {
#   define XfOrM1587_COUNT (0+XfOrM1577_COUNT)
#   define SETUP_XfOrM1587(x) SETUP_XfOrM1577(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-mark-set->list" , "(or/c continuation-mark-set? #f)" , 0 , argc , argv ) )
# 8182 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (argc > 2 ) {
#   define XfOrM1584_COUNT (0+XfOrM1577_COUNT)
#   define SETUP_XfOrM1584(x) SETUP_XfOrM1577(x)

# 8186 "./../src/fun.c"
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) ) ) {
#     define XfOrM1585_COUNT (0+XfOrM1584_COUNT)
#     define SETUP_XfOrM1585(x) SETUP_XfOrM1584(x)

# 8187 "./../src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [2 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [2 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) argv [2 ] ) -> val ) ; 
      else {
#       define XfOrM1586_COUNT (0+XfOrM1585_COUNT)
#       define SETUP_XfOrM1586(x) SETUP_XfOrM1585(x)
        FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-mark-set->list" , "continuation-prompt-tag?" , 2 , argc , argv ) )
# 8192 "./../src/fun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 8195 "./../src/fun.c"
    else 
    prompt_tag = argv [2 ] ; 
  }

# 8197 "./../src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  if (((argv [0 ] ) ) == (scheme_false ) ) 
    chain = FUNCCALL(SETUP_XfOrM1577(_), current_mark_chain ("continuation-mark-set->list" , prompt_tag ) ); 
  else 
  chain = ((Scheme_Cont_Mark_Set * ) argv [0 ] ) -> chain ; 
  key = argv [1 ] ; 

  if ((key == scheme_parameterization_key ) 
  || (key == scheme_break_enabled_key ) 
  || (key == scheme_exn_handler_key ) ) {
#   define XfOrM1583_COUNT (0+XfOrM1577_COUNT)
#   define SETUP_XfOrM1583(x) SETUP_XfOrM1577(x)
    FUNCCALL_EMPTY(scheme_signal_error ("continuation-mark-set->list: secret key leaked!" ) )
# 8209 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if ((((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) ) {
    is_chaperoned = 1 ; 
    key = (((Scheme_Chaperone * ) key ) -> val ) ; 
  }

  prompt_tag = (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ; 

  while (chain ) {
#   define XfOrM1580_COUNT (0+XfOrM1577_COUNT)
#   define SETUP_XfOrM1580(x) SETUP_XfOrM1577(x)

# 8222 "./../src/fun.c"
    if (chain -> key == key ) {
#     define XfOrM1581_COUNT (0+XfOrM1580_COUNT)
#     define SETUP_XfOrM1581(x) SETUP_XfOrM1580(x)

# 8223 "./../src/fun.c"
      if (is_chaperoned )
        v = FUNCCALL(SETUP_XfOrM1581(_), scheme_chaperone_do_continuation_mark ("continuation-mark-set->list" , 1 , argv [1 ] , chain -> val ) )
      ; 
      else 
      v = chain -> val ; 
      pr = FUNCCALL(SETUP_XfOrM1581(_), scheme_make_pair (v , scheme_null ) ); 
      if (last )
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pr ; 
      else 
      first = pr ; 
      last = pr ; 
    }

# 8234 "./../src/fun.c"
    else if (chain -> key == prompt_tag )
      break ; 

    chain = chain -> next ; 
  }

  RET_VALUE_START (first ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8243 "./../src/fun.c"
static Scheme_Object * 
iterate_cc_markses (const char * who , 
Scheme_Object * prompt_tag , Scheme_Object * none , 
intptr_t len , Scheme_Object * * keys , 
Scheme_Cont_Mark_Chain * * _chain ) 
{
  Scheme_Cont_Mark_Chain * chain = * _chain ; 
  intptr_t last_pos = - 1 , i ; 
  Scheme_Object * vals = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(none, 0), PUSH(who, 1), PUSH(vals, 2), PUSH(_chain, 3), PUSH(chain, 4), PUSH(prompt_tag, 5), PUSH(keys, 6)));
# define XfOrM1588_COUNT (7)
# define SETUP_XfOrM1588(x) SETUP(XfOrM1588_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 8253 "./../src/fun.c"
  prompt_tag = (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ; 

  while (chain ) {
#   define XfOrM1601_COUNT (0+XfOrM1588_COUNT)
#   define SETUP_XfOrM1601(x) SETUP_XfOrM1588(x)

# 8256 "./../src/fun.c"
    if (vals && (last_pos != chain -> pos ) ) {
      * _chain = chain ; 
      RET_VALUE_START (vals ) RET_VALUE_END ; 
    }

    for (i = 0 ; i < len ; i ++ ) {
      int is_chaperoned = 0 ; 
      Scheme_Object * orig_key , * val ; 
      BLOCK_SETUP((PUSH(val, 0+XfOrM1601_COUNT), PUSH(orig_key, 1+XfOrM1601_COUNT)));
#     define XfOrM1607_COUNT (2+XfOrM1601_COUNT)
#     define SETUP_XfOrM1607(x) SETUP(XfOrM1607_COUNT)
      orig_key = NULLED_OUT ; 
      val = NULLED_OUT ; 

# 8265 "./../src/fun.c"
      if ((& (chain ) -> iso ) -> so . keyex & 0x1 )
        last_pos = - 1 ; 
      if ((((Scheme_Type ) (((((intptr_t ) (keys [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (keys [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) keys [i ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) keys [i ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) ) {
        is_chaperoned = 1 ; 
        orig_key = keys [i ] ; 
        keys [i ] = (((Scheme_Chaperone * ) orig_key ) -> val ) ; 
      }

# 8272 "./../src/fun.c"
      else 
      orig_key = ((void * ) 0 ) ; 
      if ((chain -> key ) == (keys [i ] ) )  {
        intptr_t pos ; 
#       define XfOrM1608_COUNT (0+XfOrM1607_COUNT)
#       define SETUP_XfOrM1608(x) SETUP_XfOrM1607(x)

# 8276 "./../src/fun.c"
        pos = (intptr_t ) chain -> pos ; 
        if (! vals ) {
#         define XfOrM1610_COUNT (0+XfOrM1608_COUNT)
#         define SETUP_XfOrM1610(x) SETUP_XfOrM1608(x)

# 8278 "./../src/fun.c"
          vals = FUNCCALL(SETUP_XfOrM1610(_), scheme_make_vector (len , none ) ); 
          last_pos = pos ; 
        }
        if (is_chaperoned ) {
#         define XfOrM1609_COUNT (0+XfOrM1608_COUNT)
#         define SETUP_XfOrM1609(x) SETUP_XfOrM1608(x)

# 8282 "./../src/fun.c"
          val = FUNCCALL(SETUP_XfOrM1609(_), scheme_chaperone_do_continuation_mark (who , 1 , orig_key , chain -> val ) )
          ; 
          (((Scheme_Vector * ) (vals ) ) -> els ) [i ] = val ; 
        }

# 8285 "./../src/fun.c"
        else 
        (((Scheme_Vector * ) (vals ) ) -> els ) [i ] = chain -> val ; 
      }
    }

    if ((chain -> key ) == (prompt_tag ) ) 
      break ; 

    chain = chain -> next ; 
  }

  * _chain = ((void * ) 0 ) ; 

  RET_VALUE_START (vals ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8301 "./../src/fun.c"
static Scheme_Object * iterate_step (void * data , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Cont_Mark_Chain * chain = ((void * * ) data ) [0 ] ; 
  void * * clos = ((void * * ) data ) [1 ] , * * new_state ; 
  Scheme_Object * vals , * a [2 ] ; 
  Scheme_Object * prompt_tag = ((Scheme_Object * * ) clos ) [0 ] ; 
  Scheme_Object * * keys = ((Scheme_Object * * * ) clos ) [1 ] ; 
  intptr_t len = (((intptr_t ) (((Scheme_Object * * ) clos ) [2 ] ) ) >> 1 ) ; 
  Scheme_Object * none = ((Scheme_Object * * ) clos ) [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(chain, 3), PUSH(clos, 4), PUSH(new_state, 5), PUSH(vals, 6)));
# define XfOrM1613_COUNT (7)
# define SETUP_XfOrM1613(x) SETUP(XfOrM1613_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  new_state = NULLED_OUT ; 
  vals = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 8311 "./../src/fun.c"
  if (! chain ) {
    a [0 ] = scheme_false ; 
    new_state = data ; 
  }

# 8314 "./../src/fun.c"
  else {
#   define XfOrM1614_COUNT (0+XfOrM1613_COUNT)
#   define SETUP_XfOrM1614(x) SETUP_XfOrM1613(x)

# 8315 "./../src/fun.c"
    vals = FUNCCALL(SETUP_XfOrM1614(_), iterate_cc_markses ("mark-list*-iterator" , prompt_tag , none , len , keys , & chain ) ); 
    if (! vals )
      a [0 ] = scheme_false ; 
    else 
    a [0 ] = vals ; 
    new_state = ((void * * ) FUNCCALL(SETUP_XfOrM1614(_), GC_malloc (sizeof (void * ) * (2 ) ) )) ; 
    new_state [0 ] = chain ; 
    new_state [1 ] = clos ; 
  }

  a [1 ] = FUNCCALL(SETUP_XfOrM1613(_), scheme_make_closed_prim_w_arity (iterate_step , new_state , "mark-list*-iterator" , 0 , 0 ) ); 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1613(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8329 "./../src/fun.c"
static Scheme_Object * 
do_extract_cc_markses (const char * who , int argc , Scheme_Object * argv [] , int iterator ) 
{
  Scheme_Cont_Mark_Chain * chain ; 
  Scheme_Object * first = scheme_null , * last = ((void * ) 0 ) ; 
  Scheme_Object * pr , * * keys , * vals , * none , * prompt_tag ; 
  intptr_t len , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(none, 0), PUSH(who, 1), PUSH(first, 2), PUSH(vals, 3), PUSH(argv, 4), PUSH(pr, 5), PUSH(last, 6), PUSH(chain, 7), PUSH(prompt_tag, 8), PUSH(keys, 9)));
# define XfOrM1616_COUNT (10)
# define SETUP_XfOrM1616(x) SETUP(XfOrM1616_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  chain = NULLED_OUT ; 
  pr = NULLED_OUT ; 
  keys = NULLED_OUT ; 
  vals = NULLED_OUT ; 
  none = NULLED_OUT ; 
  prompt_tag = NULLED_OUT ; 

# 8337 "./../src/fun.c"
  if ((! (((argv [0 ] ) ) == (scheme_false ) ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) ) {
#   define XfOrM1631_COUNT (0+XfOrM1616_COUNT)
#   define SETUP_XfOrM1631(x) SETUP_XfOrM1616(x)
    FUNCCALL(SETUP_XfOrM1631(_), scheme_wrong_contract (who , "(or/c continuation-mark-set? #f)" , 0 , argc , argv ) )
# 8339 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  len = (scheme_proper_list_length (argv [1 ] ) ) ; 
  if (len < 0 ) {
#   define XfOrM1630_COUNT (0+XfOrM1616_COUNT)
#   define SETUP_XfOrM1630(x) SETUP_XfOrM1616(x)
    FUNCCALL(SETUP_XfOrM1630(_), scheme_wrong_contract (who , "list?" , 1 , argc , argv ) )
# 8344 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
  if (argc > 2 )
    none = argv [2 ] ; 
  else 
  none = scheme_false ; 
  if (argc > 3 ) {
#   define XfOrM1627_COUNT (0+XfOrM1616_COUNT)
#   define SETUP_XfOrM1627(x) SETUP_XfOrM1616(x)

# 8352 "./../src/fun.c"
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) ) ) {
#     define XfOrM1628_COUNT (0+XfOrM1627_COUNT)
#     define SETUP_XfOrM1628(x) SETUP_XfOrM1627(x)

# 8353 "./../src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [3 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [3 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) argv [3 ] ) -> val ) ; 
      else {
#       define XfOrM1629_COUNT (0+XfOrM1628_COUNT)
#       define SETUP_XfOrM1629(x) SETUP_XfOrM1628(x)
        FUNCCALL(SETUP_XfOrM1629(_), scheme_wrong_contract (who , "continuation-prompt-tag?" , 3 , argc , argv ) )
# 8358 "./../src/fun.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }

# 8361 "./../src/fun.c"
    else 
    prompt_tag = argv [3 ] ; 
  }

# 8363 "./../src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  keys = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1616(_), GC_malloc (sizeof (Scheme_Object * ) * (len ) ) )) ; 
  for (pr = argv [1 ] , i = 0 ; ((Scheme_Type ) (((((intptr_t ) (pr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pr ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) , i ++ ) {
#   define XfOrM1625_COUNT (0+XfOrM1616_COUNT)
#   define SETUP_XfOrM1625(x) SETUP_XfOrM1616(x)

# 8368 "./../src/fun.c"
    keys [i ] = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . car ) ; 
    if ((keys [i ] == scheme_parameterization_key ) 
    || (keys [i ] == scheme_break_enabled_key ) ) {
#     define XfOrM1626_COUNT (0+XfOrM1625_COUNT)
#     define SETUP_XfOrM1626(x) SETUP_XfOrM1625(x)
      FUNCCALL(SETUP_XfOrM1626(_), scheme_signal_error ("%s: misuse of primitive key" , who ) )
# 8371 "./../src/fun.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((argv [0 ] ) ) == (scheme_false ) ) 
    chain = FUNCCALL(SETUP_XfOrM1616(_), current_mark_chain (who , prompt_tag ) ); 
  else 
  chain = ((Scheme_Cont_Mark_Set * ) argv [0 ] ) -> chain ; 

  if (iterator ) {
    void * * clos , * * state ; 
    BLOCK_SETUP((PUSH(clos, 0+XfOrM1616_COUNT), PUSH(state, 1+XfOrM1616_COUNT)));
#   define XfOrM1622_COUNT (2+XfOrM1616_COUNT)
#   define SETUP_XfOrM1622(x) SETUP(XfOrM1622_COUNT)
    clos = NULLED_OUT ; 
    state = NULLED_OUT ; 

# 8383 "./../src/fun.c"
    clos = ((void * * ) FUNCCALL(SETUP_XfOrM1622(_), GC_malloc (sizeof (void * ) * (4 ) ) )) ; 
    clos [0 ] = prompt_tag ; 
    clos [1 ] = keys ; 
    clos [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (len ) ) ) << 1 ) | 0x1 ) ) ; 
    clos [3 ] = none ; 
    state = ((void * * ) FUNCCALL(SETUP_XfOrM1622(_), GC_malloc (sizeof (void * ) * (2 ) ) )) ; 
    state [0 ] = chain ; 
    state [1 ] = clos ; 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM1622(_), scheme_make_closed_prim_w_arity (iterate_step , state , "mark-list*-iterator" , 0 , 0 ) )) RET_VALUE_END ; 
  }

# 8392 "./../src/fun.c"
  else {
#   define XfOrM1617_COUNT (0+XfOrM1616_COUNT)
#   define SETUP_XfOrM1617(x) SETUP_XfOrM1616(x)

# 8393 "./../src/fun.c"
    while (chain ) {
#     define XfOrM1620_COUNT (0+XfOrM1617_COUNT)
#     define SETUP_XfOrM1620(x) SETUP_XfOrM1617(x)

# 8394 "./../src/fun.c"
      vals = FUNCCALL(SETUP_XfOrM1620(_), iterate_cc_markses (who , prompt_tag , none , len , keys , & chain ) ); 
      if (vals ) {
#       define XfOrM1621_COUNT (0+XfOrM1620_COUNT)
#       define SETUP_XfOrM1621(x) SETUP_XfOrM1620(x)

# 8396 "./../src/fun.c"
        pr = FUNCCALL(SETUP_XfOrM1621(_), scheme_make_pair (vals , scheme_null ) ); 
        if (last )
          (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pr ; 
        else 
        first = pr ; 
        last = pr ; 
      }
    }

    RET_VALUE_START (first ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8409 "./../src/fun.c"
static Scheme_Object * 
extract_cc_markses (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8412 "./../src/fun.c"
  return do_extract_cc_markses ("continuation-mark-set->list*" , argc , argv , 0 ) ; 
}

static Scheme_Object * 
extract_cc_iterator (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8418 "./../src/fun.c"
  return do_extract_cc_markses ("continuation-mark-set->iterator" , argc , argv , 1 ) ; 
}

Scheme_Object * 
scheme_get_stack_trace (Scheme_Object * mark_set ) 
{
  Scheme_Object * l , * n , * m , * name , * loc ; 
  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(l, 0), PUSHARRAY(a, 2, 1), PUSH(name, 4), PUSH(loc, 5), PUSH(m, 6), PUSH(n, 7)));
# define XfOrM1634_COUNT (8)
# define SETUP_XfOrM1634(x) SETUP(XfOrM1634_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  l = NULLED_OUT ; 
  n = NULLED_OUT ; 
  m = NULLED_OUT ; 
  name = NULLED_OUT ; 
  loc = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 8427 "./../src/fun.c"
  l = ((Scheme_Cont_Mark_Set * ) mark_set ) -> native_stack_trace ; 

  if (! l ) {
#   define XfOrM1654_COUNT (0+XfOrM1634_COUNT)
#   define SETUP_XfOrM1654(x) SETUP_XfOrM1634(x)

# 8430 "./../src/fun.c"
    a [0 ] = mark_set ; 
    a [1 ] = scheme_stack_dump_key ; 

    l = FUNCCALL(SETUP_XfOrM1654(_), extract_cc_marks (2 , a ) ); 
  }

# 8434 "./../src/fun.c"
  else {

    Scheme_Object * first = scheme_null , * last = ((void * ) 0 ) ; 
    BLOCK_SETUP((PUSH(first, 0+XfOrM1634_COUNT), PUSH(last, 1+XfOrM1634_COUNT)));
#   define XfOrM1651_COUNT (2+XfOrM1634_COUNT)
#   define SETUP_XfOrM1651(x) SETUP(XfOrM1651_COUNT)

# 8437 "./../src/fun.c"
    while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#     define XfOrM1653_COUNT (0+XfOrM1651_COUNT)
#     define SETUP_XfOrM1653(x) SETUP_XfOrM1651(x)

# 8438 "./../src/fun.c"
      n = FUNCCALL(SETUP_XfOrM1653(_), scheme_make_pair ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , scheme_null ) ); 
      if (last )
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = n ; 
      else 
      first = n ; 
      last = n ; 
      l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
    }
    l = first ; 
  }


  while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && ! (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) {
    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  }
  for (n = l ; ((Scheme_Type ) (((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; ) {
    m = (((Scheme_Simple_Object * ) (n ) ) -> u . pair_val . cdr ) ; 
    if ((m ) == (scheme_null ) ) 
      break ; 
    if (((Scheme_Simple_Object * ) (m ) ) -> u . pair_val . car )  {
      n = m ; 
    }

# 8459 "./../src/fun.c"
    else {
      (((Scheme_Simple_Object * ) (n ) ) -> u . pair_val . cdr ) = (((Scheme_Simple_Object * ) (m ) ) -> u . pair_val . cdr ) ; 
    }
  }


  for (n = l ; ((Scheme_Type ) (((((intptr_t ) (n ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (n ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; n = (((Scheme_Simple_Object * ) (n ) ) -> u . pair_val . cdr ) ) {
#   define XfOrM1639_COUNT (0+XfOrM1634_COUNT)
#   define SETUP_XfOrM1639(x) SETUP_XfOrM1634(x)

# 8466 "./../src/fun.c"
    name = (((Scheme_Simple_Object * ) (n ) ) -> u . pair_val . car ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
#     define XfOrM1642_COUNT (0+XfOrM1639_COUNT)
#     define SETUP_XfOrM1642(x) SETUP_XfOrM1639(x)

# 8468 "./../src/fun.c"
      loc = FUNCCALL(SETUP_XfOrM1642(_), scheme_make_location ((((Scheme_Vector * ) (name ) ) -> els ) [1 ] , (((Scheme_Vector * ) (name ) ) -> els ) [2 ] , (((Scheme_Vector * ) (name ) ) -> els ) [3 ] , (((Scheme_Vector * ) (name ) ) -> els ) [4 ] , (((Scheme_Vector * ) (name ) ) -> els ) [5 ] ) )



      ; 
      if (! ((((((Scheme_Vector * ) (name ) ) -> els ) [6 ] ) ) == (scheme_false ) ) ) 
        name = FUNCCALL(SETUP_XfOrM1642(_), scheme_make_pair (scheme_false , loc ) ); 
      else 
      name = FUNCCALL(SETUP_XfOrM1642(_), scheme_make_pair ((((Scheme_Vector * ) (name ) ) -> els ) [0 ] , loc ) ); 
    }

# 8477 "./../src/fun.c"
    else if (((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && (((((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . cdr ) ) == (scheme_true ) ) ) {

      const char * what ; 
      BLOCK_SETUP((PUSH(what, 0+XfOrM1639_COUNT)));
#     define XfOrM1641_COUNT (1+XfOrM1639_COUNT)
#     define SETUP_XfOrM1641(x) SETUP(XfOrM1641_COUNT)
      what = NULLED_OUT ; 

# 8481 "./../src/fun.c"
      what = "[running body]" ; 

      name = (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . car ) ; 
      loc = FUNCCALL(SETUP_XfOrM1641(_), scheme_make_location (name , scheme_false , scheme_false , scheme_false , scheme_false ) ); 

      name = FUNCCALL_AGAIN(scheme_intern_symbol (what ) ); 
      name = FUNCCALL_AGAIN(scheme_make_pair (name , loc ) ); 
    }

# 8488 "./../src/fun.c"
    else {
#     define XfOrM1640_COUNT (0+XfOrM1639_COUNT)
#     define SETUP_XfOrM1640(x) SETUP_XfOrM1639(x)

# 8489 "./../src/fun.c"
      name = FUNCCALL(SETUP_XfOrM1640(_), scheme_make_pair (name , scheme_false ) ); 
    }
    (((Scheme_Simple_Object * ) (n ) ) -> u . pair_val . car ) = name ; 
  }

  RET_VALUE_START (l ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8497 "./../src/fun.c"
static Scheme_Object * 
extract_cc_proc_marks (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 8500 "./../src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) ) {
    scheme_wrong_contract ("continuation-mark-set->context" , "continuation-mark-set?" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }

  return scheme_get_stack_trace (argv [0 ] ) ; 
}

__xform_nongcing__ static Scheme_Object * default_mark_value (Scheme_Object * key ) 
{
  /* No conversion */

# 8510 "./../src/fun.c"
  if (key == scheme_parameterization_key )
    return (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> init_config ; 
  else if (key == scheme_break_enabled_key )
    return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> init_break_cell ; 

  return ((void * ) 0 ) ; 
}

static Scheme_Object * 
scheme_extract_one_cc_mark_with_meta (Scheme_Object * mark_set , Scheme_Object * key_arg , 
Scheme_Object * prompt_tag , Scheme_Meta_Continuation * * _meta , 
intptr_t * _vpos ) 
{
  Scheme_Object * key = key_arg ; 
  Scheme_Object * __funcarg212 = NULLED_OUT ; 
  Scheme_Object * __funcarg211 = NULLED_OUT ; 
  Scheme_Object * __funcarg210 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(_vpos, 0), PUSH(key_arg, 1), PUSH(key, 2), PUSH(prompt_tag, 3), PUSH(_meta, 4)));
# define XfOrM1658_COUNT (5)
# define SETUP_XfOrM1658(x) SETUP(XfOrM1658_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 8525 "./../src/fun.c"
  if (prompt_tag && ((prompt_tag ) == ((((Scheme_Small_Object * ) (scheme_root_prompt_tag ) ) -> u . ptr_val ) ) ) )
    prompt_tag = ((void * ) 0 ) ; 

  if ((((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) key ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_continuation_mark_key_type ) ) ) {
    key = (((Scheme_Chaperone * ) key ) -> val ) ; 
  }

  if (mark_set ) {
    Scheme_Cont_Mark_Chain * chain ; 
#   define XfOrM1746_COUNT (0+XfOrM1658_COUNT)
#   define SETUP_XfOrM1746(x) SETUP_XfOrM1658(x)
    chain = NULLED_OUT ; 

# 8535 "./../src/fun.c"
    chain = ((Scheme_Cont_Mark_Set * ) mark_set ) -> chain ; 
    while (chain ) {
#     define XfOrM1748_COUNT (0+XfOrM1746_COUNT)
#     define SETUP_XfOrM1748(x) SETUP_XfOrM1746(x)

# 8537 "./../src/fun.c"
      if (chain -> key == key )
        if (key_arg != key )
        RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_chaperone_do_continuation_mark ("continuation-mark-set-first" , 1 , key_arg , chain -> val ) )) RET_VALUE_EMPTY_END 
      ; 
      else 
      RET_VALUE_START (chain -> val ) RET_VALUE_END ; 
      else if ((chain -> key ) == (prompt_tag ) ) 
        break ; 
      else 
      chain = chain -> next ; 
    }
  }

# 8548 "./../src/fun.c"
  else {
    intptr_t findpos , bottom , startpos ; 
    intptr_t pos ; 
    Scheme_Object * val = ((void * ) 0 ) ; 
    intptr_t vpos = 0 ; 
    Scheme_Object * cache ; 
    Scheme_Meta_Continuation * mc = ((void * ) 0 ) ; 
    Scheme_Cont_Mark * seg ; 
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    BLOCK_SETUP((PUSH(val, 0+XfOrM1658_COUNT), PUSH(p, 1+XfOrM1658_COUNT), PUSH(mc, 2+XfOrM1658_COUNT), PUSH(cache, 3+XfOrM1658_COUNT), PUSH(seg, 4+XfOrM1658_COUNT)));
#   define XfOrM1659_COUNT (5+XfOrM1658_COUNT)
#   define SETUP_XfOrM1659(x) SETUP(XfOrM1659_COUNT)
    cache = NULLED_OUT ; 
    seg = NULLED_OUT ; 

# 8558 "./../src/fun.c"
    do {
#     define XfOrM1703_COUNT (0+XfOrM1659_COUNT)
#     define SETUP_XfOrM1703(x) SETUP_XfOrM1659(x)

# 8559 "./../src/fun.c"
      if (mc ) {
        startpos = mc -> cont_mark_total ; 
        bottom = 0 ; 
      }

# 8562 "./../src/fun.c"
      else {
        startpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
        bottom = p -> cont_mark_stack_bottom ; 
      }

      findpos = startpos ; 


      while (findpos -- > bottom ) {
#       define XfOrM1733_COUNT (0+XfOrM1703_COUNT)
#       define SETUP_XfOrM1733(x) SETUP_XfOrM1703(x)

# 8571 "./../src/fun.c"
        if (mc ) {
          seg = mc -> cont_mark_stack_copied ; 
          pos = findpos ; 
        }

# 8574 "./../src/fun.c"
        else {
          seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
          pos = findpos & ((1 << 6 ) - 1 ) ; 
        }

        if ((seg [pos ] . key ) == (key ) )  {
          val = seg [pos ] . val ; 
          vpos = seg [pos ] . pos ; 
          break ; 
        }

# 8583 "./../src/fun.c"
        else if ((seg [pos ] . key ) == (prompt_tag ) )  {
          break ; 
        }

# 8585 "./../src/fun.c"
        else {
#         define XfOrM1734_COUNT (0+XfOrM1733_COUNT)
#         define SETUP_XfOrM1734(x) SETUP_XfOrM1733(x)

# 8586 "./../src/fun.c"
          cache = seg [pos ] . cache ; 
          if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) )
            cache = (scheme_eq_hash_get ((Scheme_Hash_Table * ) cache , 
          prompt_tag ? prompt_tag : scheme_false ) ) ; 
          else if (prompt_tag )
            cache = ((void * ) 0 ) ; 
          if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
#           define XfOrM1735_COUNT (0+XfOrM1734_COUNT)
#           define SETUP_XfOrM1735(x) SETUP_XfOrM1734(x)
            if ((((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ) {
              if (((((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ) == (key ) )  {
                val = (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
                vpos = (intptr_t ) (((Scheme_Vector * ) (cache ) ) -> els ) [3 ] ; 
                break ; 
              }
            }

# 8601 "./../src/fun.c"
            else {
              Scheme_Hash_Table * ht ; 
#             define XfOrM1736_COUNT (0+XfOrM1735_COUNT)
#             define SETUP_XfOrM1736(x) SETUP_XfOrM1735(x)
              ht = NULLED_OUT ; 

# 8603 "./../src/fun.c"
              ht = (Scheme_Hash_Table * ) (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
              val = (scheme_eq_hash_get (ht , key ) ) ; 
              if (val ) {
                vpos = (intptr_t ) (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . cdr ) ; 
                val = (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . car ) ; 
                break ; 
              }
            }
          }
        }
      }

      if (key_arg != key && val != ((void * ) 0 ) )
        val = FUNCCALL(SETUP_XfOrM1703(_), scheme_chaperone_do_continuation_mark ("continuation-mark-set-first" , 1 , key_arg , val ) ); 

      pos = startpos - findpos ; 
      if (pos > 16 ) {
        pos >>= 1 ; 
#       define XfOrM1707_COUNT (0+XfOrM1703_COUNT)
#       define SETUP_XfOrM1707(x) SETUP_XfOrM1703(x)

# 8621 "./../src/fun.c"
        findpos = findpos + pos ; 
        if (mc ) {
          seg = mc -> cont_mark_stack_copied ; 
          pos = findpos ; 
        }

# 8625 "./../src/fun.c"
        else {
          seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
          pos = findpos & ((1 << 6 ) - 1 ) ; 
        }



        cache = seg [pos ] . cache ; 
        {
          Scheme_Hash_Table * cht ; 
          BLOCK_SETUP((PUSH(cht, 0+XfOrM1707_COUNT)));
#         define XfOrM1708_COUNT (1+XfOrM1707_COUNT)
#         define SETUP_XfOrM1708(x) SETUP(XfOrM1708_COUNT)
          cht = NULLED_OUT ; 

# 8635 "./../src/fun.c"
          if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) {
#           define XfOrM1719_COUNT (0+XfOrM1708_COUNT)
#           define SETUP_XfOrM1719(x) SETUP_XfOrM1708(x)

# 8636 "./../src/fun.c"
            cht = (Scheme_Hash_Table * ) cache ; 
            cache = (scheme_eq_hash_get (cht , prompt_tag ? prompt_tag : scheme_false ) ) ; 
          }

# 8638 "./../src/fun.c"
          else if (prompt_tag ) {
#           define XfOrM1715_COUNT (0+XfOrM1708_COUNT)
#           define SETUP_XfOrM1715(x) SETUP_XfOrM1708(x)

# 8639 "./../src/fun.c"
            cht = FUNCCALL(SETUP_XfOrM1715(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
            if (cache ) {
#             define XfOrM1716_COUNT (0+XfOrM1715_COUNT)
#             define SETUP_XfOrM1716(x) SETUP_XfOrM1715(x)

# 8641 "./../src/fun.c"
              if ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
                Scheme_Object * vec ; 
                BLOCK_SETUP((PUSH(vec, 0+XfOrM1716_COUNT)));
#               define XfOrM1718_COUNT (1+XfOrM1716_COUNT)
#               define SETUP_XfOrM1718(x) SETUP(XfOrM1718_COUNT)
                vec = NULLED_OUT ; 

# 8643 "./../src/fun.c"
                if ((((Scheme_Vector * ) (cache ) ) -> els ) [0 ] )
                  FUNCCALL(SETUP_XfOrM1718(_), scheme_hash_set (cht , scheme_default_prompt_tag , (((Scheme_Vector * ) (cache ) ) -> els ) [0 ] ) ); 

                vec = FUNCCALL(SETUP_XfOrM1718(_), scheme_make_vector (4 , ((void * ) 0 ) ) ); 
                (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ; 
                (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
                (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = (((Scheme_Vector * ) (cache ) ) -> els ) [3 ] ; 
                FUNCCALL(SETUP_XfOrM1718(_), scheme_hash_set (cht , scheme_false , vec ) ); 
              }

# 8651 "./../src/fun.c"
              else {
#               define XfOrM1717_COUNT (0+XfOrM1716_COUNT)
#               define SETUP_XfOrM1717(x) SETUP_XfOrM1716(x)
                FUNCCALL(SETUP_XfOrM1717(_), scheme_hash_set (cht , scheme_default_prompt_tag , cache ) )
# 8652 "./../src/fun.c"
                ; 
              }
              cache = ((void * ) 0 ) ; 
            }
            seg [pos ] . cache = (Scheme_Object * ) cht ; 
          }

# 8657 "./../src/fun.c"
          else 
          cht = ((void * ) 0 ) ; 

          if (! cache || ! ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {
#           define XfOrM1712_COUNT (0+XfOrM1708_COUNT)
#           define SETUP_XfOrM1712(x) SETUP_XfOrM1708(x)

# 8662 "./../src/fun.c"
            cache = FUNCCALL(SETUP_XfOrM1712(_), scheme_make_vector (4 , ((void * ) 0 ) ) ); 
            (((Scheme_Vector * ) (cache ) ) -> els ) [1 ] = key ; 
            (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] = val ; 
            (((Scheme_Vector * ) (cache ) ) -> els ) [3 ] = (Scheme_Object * ) vpos ; 
            if (cht ) {
#             define XfOrM1714_COUNT (0+XfOrM1712_COUNT)
#             define SETUP_XfOrM1714(x) SETUP_XfOrM1712(x)
              FUNCCALL(SETUP_XfOrM1714(_), scheme_hash_set (cht , prompt_tag ? prompt_tag : scheme_false , cache ) )
# 8667 "./../src/fun.c"
              ; 
            }

# 8668 "./../src/fun.c"
            else {
              if (seg [pos ] . cache && ! (((seg [pos ] . cache ) ) == (scheme_false ) ) )
                (((Scheme_Vector * ) (cache ) ) -> els ) [0 ] = seg [pos ] . cache ; 
              seg [pos ] . cache = cache ; 
            }
          }

# 8673 "./../src/fun.c"
          else {
#           define XfOrM1709_COUNT (0+XfOrM1708_COUNT)
#           define SETUP_XfOrM1709(x) SETUP_XfOrM1708(x)

# 8674 "./../src/fun.c"
            if ((((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ) {

              Scheme_Hash_Table * ht ; 
              BLOCK_SETUP((PUSH(ht, 0+XfOrM1709_COUNT)));
#             define XfOrM1711_COUNT (1+XfOrM1709_COUNT)
#             define SETUP_XfOrM1711(x) SETUP(XfOrM1711_COUNT)
              ht = NULLED_OUT ; 

# 8677 "./../src/fun.c"
              ht = FUNCCALL(SETUP_XfOrM1711(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
              (__funcarg212 = FUNCCALL(SETUP_XfOrM1711(_), scheme_make_raw_pair (val , (Scheme_Object * ) vpos ) ), FUNCCALL_AGAIN(scheme_hash_set (ht , key , __funcarg212 ) )) ; 
              (__funcarg211 = FUNCCALL(SETUP_XfOrM1711(_), scheme_make_raw_pair ((((Scheme_Vector * ) (cache ) ) -> els ) [2 ] , (((Scheme_Vector * ) (cache ) ) -> els ) [3 ] ) ), FUNCCALL_AGAIN(scheme_hash_set (ht , (((Scheme_Vector * ) (cache ) ) -> els ) [1 ] , __funcarg211 ) )) 
              ; 
              (((Scheme_Vector * ) (cache ) ) -> els ) [1 ] = ((void * ) 0 ) ; 
              (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] = (Scheme_Object * ) ht ; 
            }

# 8683 "./../src/fun.c"
            else {

              Scheme_Hash_Table * ht ; 
              BLOCK_SETUP((PUSH(ht, 0+XfOrM1709_COUNT)));
#             define XfOrM1710_COUNT (1+XfOrM1709_COUNT)
#             define SETUP_XfOrM1710(x) SETUP(XfOrM1710_COUNT)
              ht = NULLED_OUT ; 

# 8686 "./../src/fun.c"
              ht = (Scheme_Hash_Table * ) (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
              (__funcarg210 = FUNCCALL(SETUP_XfOrM1710(_), scheme_make_raw_pair (val , (Scheme_Object * ) vpos ) ), FUNCCALL_AGAIN(scheme_hash_set (ht , key , __funcarg210 ) )) ; 
            }
          }
        }
      }

      if (val ) {
        if (_meta )
          * _meta = mc ; 
        if (_vpos )
          * _vpos = vpos ; 
        RET_VALUE_START (val ) RET_VALUE_END ; 
      }

      if (mc ) {
        mc = mc -> next ; 
      }

# 8703 "./../src/fun.c"
      else {
        mc = p -> meta_continuation ; 
      }
    }

# 8706 "./../src/fun.c"
    while (mc ) ; 
  }

  RET_VALUE_START ((default_mark_value (key ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8712 "./../src/fun.c"
__xform_nongcing__ static Scheme_Object * 
extract_one_cc_mark_fast (Scheme_Object * key , int * _conclusive ) 


{
  /* No conversion */

# 8717 "./../src/fun.c"
  intptr_t findpos , bottom , startpos ; 
  intptr_t pos ; 
  Scheme_Object * val = ((void * ) 0 ) ; 
  Scheme_Object * cache ; 
  Scheme_Cont_Mark * seg ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Meta_Continuation * mc = ((void * ) 0 ) ; 

  do {
    if (mc ) {
      startpos = mc -> cont_mark_total ; 
      bottom = 0 ; 
    }

# 8729 "./../src/fun.c"
    else {
      startpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
      bottom = p -> cont_mark_stack_bottom ; 
    }

    findpos = startpos ; 


    while (findpos -- > bottom ) {
      if ((startpos - findpos ) > 16 ) {

        return ((void * ) 0 ) ; 
      }

      if (mc ) {
        seg = mc -> cont_mark_stack_copied ; 
        pos = findpos ; 
      }

# 8746 "./../src/fun.c"
      else {
        seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
        pos = findpos & ((1 << 6 ) - 1 ) ; 
      }

      if ((seg [pos ] . key ) == (key ) )  {
        * _conclusive = 1 ; 
        return seg [pos ] . val ; 
      }

# 8754 "./../src/fun.c"
      else {
        cache = seg [pos ] . cache ; 
        if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) )
          cache = scheme_eq_hash_get ((Scheme_Hash_Table * ) cache , scheme_false ) ; 
        if (cache && ((Scheme_Type ) (((((intptr_t ) (cache ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cache ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {


          if ((((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ) {
            if (((((Scheme_Vector * ) (cache ) ) -> els ) [1 ] ) == (key ) )  {
              val = (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
              if (val ) {
                * _conclusive = 1 ; 
                return val ; 
              }

# 8767 "./../src/fun.c"
              else 
              break ; 
            }
          }

# 8770 "./../src/fun.c"
          else {
            Scheme_Hash_Table * ht ; 
            ht = (Scheme_Hash_Table * ) (((Scheme_Vector * ) (cache ) ) -> els ) [2 ] ; 
            val = scheme_eq_hash_get (ht , key ) ; 
            if (val ) {
              val = (((Scheme_Simple_Object * ) (val ) ) -> u . pair_val . car ) ; 
              if (val ) {
                * _conclusive = 1 ; 
                return val ; 
              }

# 8779 "./../src/fun.c"
              else 
              break ; 
            }
          }
        }
      }
    }

    if (mc )
      mc = mc -> next ; 
    else 
    mc = p -> meta_continuation ; 
  }

# 8791 "./../src/fun.c"
  while (mc ) ; 



  * _conclusive = 1 ; 
  return default_mark_value (key ) ; 
}

static Scheme_Object * get_set_cont_mark_by_pos (Scheme_Object * key , 
Scheme_Thread * p , 
Scheme_Meta_Continuation * mc , 
intptr_t mpos , 
Scheme_Object * val ) 
{
  intptr_t findpos , bottom , startpos ; 
  intptr_t pos ; 
  int down_delta = 0 ; 
  Scheme_Cont_Mark * seg ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(p, 1), PUSH(key, 2), PUSH(seg, 3), PUSH(mc, 4)));
# define XfOrM1809_COUNT (5)
# define SETUP_XfOrM1809(x) SETUP(XfOrM1809_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  seg = NULLED_OUT ; 

# 8810 "./../src/fun.c"
  if (mc ) {
    startpos = mc -> cont_mark_total ; 
    bottom = 0 ; 
  }

# 8813 "./../src/fun.c"
  else {
    startpos = (intptr_t ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) ; 
    bottom = p -> cont_mark_stack_bottom ; 
  }


  while (bottom < startpos ) {
#   define XfOrM1819_COUNT (0+XfOrM1809_COUNT)
#   define SETUP_XfOrM1819(x) SETUP_XfOrM1809(x)

# 8820 "./../src/fun.c"
    findpos = ((bottom + startpos ) / 2 ) - down_delta ; 

    if (mc ) {
      seg = mc -> cont_mark_stack_copied ; 
      pos = findpos ; 
    }

# 8825 "./../src/fun.c"
    else {
      seg = p -> cont_mark_stack_segments [findpos >> 6 ] ; 
      pos = findpos & ((1 << 6 ) - 1 ) ; 
    }

    if (seg [pos ] . pos == mpos ) {
#     define XfOrM1822_COUNT (0+XfOrM1819_COUNT)
#     define SETUP_XfOrM1822(x) SETUP_XfOrM1819(x)

# 8831 "./../src/fun.c"
      if ((seg [pos ] . key ) == (key ) )  {
#       define XfOrM1825_COUNT (0+XfOrM1822_COUNT)
#       define SETUP_XfOrM1825(x) SETUP_XfOrM1822(x)

# 8832 "./../src/fun.c"
        if (! val )
          RET_VALUE_START (seg [pos ] . val ) RET_VALUE_END ; 

        if (mc && mc -> cm_shared )
          seg = FUNCCALL(SETUP_XfOrM1825(_), copy_cm_shared_on_write (mc ) ); 

        seg [pos ] . val = val ; 

        RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
      }

# 8841 "./../src/fun.c"
      else if (findpos > bottom ) {
        down_delta ++ ; 
      }

# 8843 "./../src/fun.c"
      else {
        bottom = (findpos + down_delta ) + 1 ; 
        down_delta = 0 ; 
      }
    }

# 8847 "./../src/fun.c"
    else if (seg [pos ] . pos < mpos ) {
      bottom = findpos + 1 ; 
    }

# 8849 "./../src/fun.c"
    else {
      startpos = findpos ; 
    }
  }
  FUNCCALL_EMPTY(scheme_signal_error ("get_set_cont_mark_by_pos: key not found" ) )
  ; 
  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8858 "./../src/fun.c"
Scheme_Object * 
scheme_extract_one_cc_mark (Scheme_Object * mark_set , Scheme_Object * key ) 
{
  /* No conversion */

# 8861 "./../src/fun.c"
  Scheme_Object * v ; 

  if (! mark_set ) {
    int conclusive = 0 ; 
    v = extract_one_cc_mark_fast (key , & conclusive ) ; 
    if (conclusive )

# 8866 "./../src/fun.c"
    return v ; 
  }

  return scheme_extract_one_cc_mark_with_meta (mark_set , key , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ; 
}

Scheme_Object * 
scheme_extract_one_cc_mark_to_tag (Scheme_Object * mark_set , Scheme_Object * key , 
Scheme_Object * prompt_tag ) 
{
  /* No conversion */

# 8876 "./../src/fun.c"
  return scheme_extract_one_cc_mark_with_meta (mark_set , key , prompt_tag , ((void * ) 0 ) , ((void * ) 0 ) ) ; 
}

static Scheme_Object * 
extract_one_cc_mark (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * r ; 
  Scheme_Object * prompt_tag ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(r, 0), PUSH(prompt_tag, 1), PUSH(argv, 2)));
# define XfOrM1833_COUNT (3)
# define SETUP_XfOrM1833(x) SETUP(XfOrM1833_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  r = NULLED_OUT ; 
  prompt_tag = NULLED_OUT ; 

# 8885 "./../src/fun.c"
  if ((! (((argv [0 ] ) ) == (scheme_false ) ) ) 
  && ! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_mark_set_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-mark-set-first" , "(or/c continuation-mark-set? #f)" , 0 , argc , argv ) ); 

  if ((argv [1 ] == scheme_parameterization_key ) 
  || (argv [1 ] == scheme_break_enabled_key ) ) {





    prompt_tag = ((void * ) 0 ) ; 
  }

# 8897 "./../src/fun.c"
  else 
  prompt_tag = scheme_default_prompt_tag ; 

  if (argc > 3 ) {
#   define XfOrM1835_COUNT (0+XfOrM1833_COUNT)
#   define SETUP_XfOrM1835(x) SETUP_XfOrM1833(x)

# 8901 "./../src/fun.c"
    if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) ) ) {
#     define XfOrM1839_COUNT (0+XfOrM1835_COUNT)
#     define SETUP_XfOrM1839(x) SETUP_XfOrM1835(x)

# 8902 "./../src/fun.c"
      if ((((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [3 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [3 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
        prompt_tag = (((Scheme_Chaperone * ) argv [3 ] ) -> val ) ; 
      else FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-mark-set-first" , "continuation-prompt-tag?" , 3 , argc , argv ) )

      ; 
    }

# 8908 "./../src/fun.c"
    else 
    prompt_tag = argv [3 ] ; 

    if (! ((scheme_default_prompt_tag ) == (prompt_tag ) ) 
    && ! ((scheme_root_prompt_tag ) == (prompt_tag ) ) ) {
#     define XfOrM1836_COUNT (0+XfOrM1835_COUNT)
#     define SETUP_XfOrM1836(x) SETUP_XfOrM1835(x)

# 8913 "./../src/fun.c"
      if (((argv [0 ] ) ) == (scheme_false ) )  {
#       define XfOrM1837_COUNT (0+XfOrM1836_COUNT)
#       define SETUP_XfOrM1837(x) SETUP_XfOrM1836(x)

# 8914 "./../src/fun.c"
        if (! FUNCCALL(SETUP_XfOrM1837(_), scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ) )) {
#         define XfOrM1838_COUNT (0+XfOrM1837_COUNT)
#         define SETUP_XfOrM1838(x) SETUP_XfOrM1837(x)
          FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "continuation-mark-set-first: no corresponding prompt in the current continuation\n" "  tag: %V" , prompt_tag ) )
          ; 
        }
      }
    }
  }

  r = FUNCCALL(SETUP_XfOrM1833(_), scheme_extract_one_cc_mark_to_tag ((! (((argv [0 ] ) ) == (scheme_false ) ) ) ? argv [0 ] : ((void * ) 0 ) , argv [1 ] , prompt_tag ? (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) : ((void * ) 0 ) ) )
  ; 
  if (! r ) {
    if (argc > 2 )
      r = argv [2 ] ; 
    else 
    r = scheme_false ; 
  }

  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 8936 "./../src/fun.c"
int scheme_is_cm_deeper (Scheme_Meta_Continuation * m1 , intptr_t p1 , 
Scheme_Meta_Continuation * m2 , intptr_t p2 ) 
{
  /* No conversion */

# 8939 "./../src/fun.c"
  if (m1 != m2 ) {
    if (! m1 )
      return 0 ; 
    if (! m2 )
      return 1 ; 
    return (m1 -> depth < m2 -> depth ) ; 
  }
  return p1 < p2 ; 
}

static Scheme_Object * continuation_prompt_available (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * prompt_tag ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(prompt_tag, 0), PUSH(argv, 1)));
# define XfOrM1843_COUNT (2)
# define SETUP_XfOrM1843(x) SETUP(XfOrM1843_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  prompt_tag = NULLED_OUT ; 

# 8953 "./../src/fun.c"
  prompt_tag = argv [0 ] ; 
  if (! ((Scheme_Type ) (scheme_prompt_tag_type ) == (Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) ) ) {
#   define XfOrM1851_COUNT (0+XfOrM1843_COUNT)
#   define SETUP_XfOrM1851(x) SETUP_XfOrM1843(x)

# 8955 "./../src/fun.c"
    if ((((Scheme_Type ) (((((intptr_t ) (prompt_tag ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prompt_tag ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) prompt_tag ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) )
      prompt_tag = (((Scheme_Chaperone * ) prompt_tag ) -> val ) ; 
    else FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-prompt-available?" , "continuation-prompt-tag?" , 0 , argc , argv ) )

    ; 
  }

  if (argc > 1 ) {
#   define XfOrM1845_COUNT (0+XfOrM1843_COUNT)
#   define SETUP_XfOrM1845(x) SETUP_XfOrM1843(x)

# 8964 "./../src/fun.c"
    if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) )  {
#     define XfOrM1848_COUNT (0+XfOrM1845_COUNT)
#     define SETUP_XfOrM1848(x) SETUP_XfOrM1845(x)

# 8965 "./../src/fun.c"
      if (! FUNCCALL(SETUP_XfOrM1848(_), scheme_escape_continuation_ok (argv [1 ] ) )) {
#       define XfOrM1850_COUNT (0+XfOrM1848_COUNT)
#       define SETUP_XfOrM1850(x) SETUP_XfOrM1848(x)
        FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "continuation-prompt-available?: escape continuation not in the current thread's continuation\n" "  escape continuation: %V" , argv [1 ] ) )
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }

# 8971 "./../src/fun.c"
      else {
        Scheme_Meta_Continuation * mc ; 
        BLOCK_SETUP((PUSH(mc, 0+XfOrM1848_COUNT)));
#       define XfOrM1849_COUNT (1+XfOrM1848_COUNT)
#       define SETUP_XfOrM1849(x) SETUP(XfOrM1849_COUNT)
        mc = NULLED_OUT ; 

# 8974 "./../src/fun.c"
        if (((scheme_default_prompt_tag ) == (prompt_tag ) ) 
        || ((scheme_root_prompt_tag ) == (prompt_tag ) ) )
          RET_VALUE_START (scheme_true ) RET_VALUE_END ; 

        mc = FUNCCALL(SETUP_XfOrM1849(_), scheme_get_meta_continuation (argv [1 ] ) ); 

        if (FUNCCALL(SETUP_XfOrM1849(_), continuation_marks (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) , ((void * ) 0 ) , argv [1 ] , mc , prompt_tag , ((void * ) 0 ) , 0 , 0 ) ))

        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
      }
    }

# 8984 "./../src/fun.c"
    else if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_cont_type ) )  {
#     define XfOrM1847_COUNT (0+XfOrM1845_COUNT)
#     define SETUP_XfOrM1847(x) SETUP_XfOrM1845(x)

# 8985 "./../src/fun.c"
      if (FUNCCALL(SETUP_XfOrM1847(_), continuation_marks (((void * ) 0 ) , argv [1 ] , ((void * ) 0 ) , ((void * ) 0 ) , prompt_tag , ((void * ) 0 ) , 0 , 0 ) ))
        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
    }

# 8987 "./../src/fun.c"
    else {
#     define XfOrM1846_COUNT (0+XfOrM1845_COUNT)
#     define SETUP_XfOrM1846(x) SETUP_XfOrM1845(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("continuation-prompt-available?" , "continuation?" , 1 , argc , argv ) )
# 8989 "./../src/fun.c"
      ; 
    }
  }

# 8991 "./../src/fun.c"
  else {
#   define XfOrM1844_COUNT (0+XfOrM1843_COUNT)
#   define SETUP_XfOrM1844(x) SETUP_XfOrM1843(x)

# 8992 "./../src/fun.c"
    if (((scheme_default_prompt_tag ) == (prompt_tag ) ) 
    || ((scheme_root_prompt_tag ) == (prompt_tag ) ) )
      RET_VALUE_START (scheme_true ) RET_VALUE_END ; 

    if (FUNCCALL_EMPTY(scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (prompt_tag ) ) -> u . ptr_val ) ) ))
      RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  }

  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9364 "./../src/fun.c"
void scheme_init_thread_lwc (void ) XFORM_SKIP_PROC {
}






typedef struct {
  Scheme_Type type ; 
  Scheme_Object * pre , * act , * post ; 
}

# 9375 "./../src/fun.c"
Dyn_Wind ; 

static void pre_post_dyn_wind (Scheme_Object * prepost ) 
{
  Scheme_Cont_Frame_Data cframe ; 
  Scheme_Object * __funcarg214 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(cframe.cache, 0), PUSH(prepost, 1)));
# define XfOrM1852_COUNT (2)
# define SETUP_XfOrM1852(x) SETUP(XfOrM1852_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  cframe.cache = NULLED_OUT ; 

# 9383 "./../src/fun.c"
  -- XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_break ; 
  FUNCCALL(SETUP_XfOrM1852(_), ASSERT_SUSPEND_BREAK_ZERO () ); 
  FUNCCALL_AGAIN(scheme_push_break_enable (& cframe , 0 , 0 ) )
  ; 
  (__funcarg214 = FUNCCALL(SETUP_XfOrM1852(_), scheme_do_eval (prepost , 0 , ((void * ) 0 ) , - 1 ) ), (

  scheme_ignore_result (__funcarg214 ) ) ) ; 
  FUNCCALL(SETUP_XfOrM1852(_), scheme_pop_break_enable (& cframe , 0 ) )
  ; 


  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> suspend_break ++ ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9397 "./../src/fun.c"
static Scheme_Object * do_dyn_wind (void * d ) 
{
  /* No conversion */

# 9399 "./../src/fun.c"
  Dyn_Wind * dw ; 
  dw = (Dyn_Wind * ) d ; 

  return scheme_do_eval (dw -> act , 0 , ((void * ) 0 ) , - 1 ) ; 
}

static void pre_dyn_wind (void * d ) 
{
  /* No conversion */

# 9407 "./../src/fun.c"
  pre_post_dyn_wind (((Dyn_Wind * ) d ) -> pre ) ; 
}

static void post_dyn_wind (void * d ) 
{
  /* No conversion */

# 9412 "./../src/fun.c"
  pre_post_dyn_wind (((Dyn_Wind * ) d ) -> post ) ; 
}

static Scheme_Object * dynamic_wind (int c , Scheme_Object * argv [] ) 
{
  Dyn_Wind * dw ; 
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(dw, 0), PUSH(v, 1), PUSH(argv, 2)));
# define XfOrM1856_COUNT (3)
# define SETUP_XfOrM1856(x) SETUP(XfOrM1856_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  dw = NULLED_OUT ; 
  v = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM1856(_), scheme_check_proc_arity ("dynamic-wind" , 0 , 0 , c , argv ) )
# 9420 "./../src/fun.c"
  ; 
  FUNCCALL_AGAIN(scheme_check_proc_arity ("dynamic-wind" , 0 , 1 , c , argv ) ); 
  FUNCCALL_AGAIN(scheme_check_proc_arity ("dynamic-wind" , 0 , 2 , c , argv ) ); 

  dw = ((Dyn_Wind * ) FUNCCALL(SETUP_XfOrM1856(_), GC_malloc_one_small_tagged ((((sizeof (Dyn_Wind ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  dw -> type = scheme_rt_dyn_wind_info ; 


  dw -> pre = argv [0 ] ; 
  dw -> act = argv [1 ] ; 
  dw -> post = argv [2 ] ; 

  v = FUNCCALL(SETUP_XfOrM1856(_), scheme_dynamic_wind (pre_dyn_wind , do_dyn_wind , post_dyn_wind , ((void * ) 0 ) , (void * ) dw ) )
  ; 


  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    BLOCK_SETUP((PUSH(p, 0+XfOrM1856_COUNT)));
#   define XfOrM1857_COUNT (1+XfOrM1856_COUNT)
#   define SETUP_XfOrM1857(x) SETUP(XfOrM1857_COUNT)

# 9439 "./../src/fun.c"
    if (p -> external_break && FUNCCALL(SETUP_XfOrM1857(_), scheme_can_break (p ) )) {
      Scheme_Object * * save_values ; 
      int save_count ; 
      BLOCK_SETUP((PUSH(save_values, 0+XfOrM1857_COUNT)));
#     define XfOrM1858_COUNT (1+XfOrM1857_COUNT)
#     define SETUP_XfOrM1858(x) SETUP(XfOrM1858_COUNT)
      save_values = NULLED_OUT ; 

# 9443 "./../src/fun.c"
      if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
        save_count = p -> ku . multiple . count ; 
        save_values = p -> ku . multiple . array ; 
        p -> ku . multiple . array = ((void * ) 0 ) ; 
        if ((save_values ) == (p -> values_buffer ) ) 
          p -> values_buffer = ((void * ) 0 ) ; 
      }

# 9449 "./../src/fun.c"
      else {
        save_count = 0 ; 
        save_values = ((void * ) 0 ) ; 
      }
      FUNCCALL(SETUP_XfOrM1858(_), scheme_thread_block (0.0 ) )
      ; 
      p -> ran_some = 1 ; 

      if (save_values ) {
        p -> ku . multiple . count = save_count ; 
        p -> ku . multiple . array = save_values ; 
      }
    }
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9467 "./../src/fun.c"
Scheme_Object * scheme_dynamic_wind (void (* pre ) (void * ) , 
Scheme_Object * (* volatile act ) (void * ) , 
void (* volatile post ) (void * ) , 
Scheme_Object * (* jmp_handler ) (void * ) , 
void * volatile data ) 
{
  mz_jmp_buf newbuf ; 
  Scheme_Object * volatile v , * * volatile save_values ; 
  volatile int err ; 
  Scheme_Dynamic_Wind * volatile dw ; 
  volatile int save_count , old_cac ; 
  Scheme_Thread * p ; 
  int delta ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(data, 0), PUSH(p, 1), PUSH(dw, 2), PUSH(save_values, 3), PUSH(v, 4)));
# define XfOrM1862_COUNT (5)
# define SETUP_XfOrM1862(x) SETUP(XfOrM1862_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  save_values = NULLED_OUT ; 
  dw = NULLED_OUT ; 
  p = NULLED_OUT ; 

# 9481 "./../src/fun.c"
  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  if (pre ) {
#   define XfOrM1884_COUNT (0+XfOrM1862_COUNT)
#   define SETUP_XfOrM1884(x) SETUP_XfOrM1862(x)
    FUNCCALL(SETUP_XfOrM1884(_), ASSERT_SUSPEND_BREAK_ZERO () )
# 9484 "./../src/fun.c"
    ; 
    p -> suspend_break ++ ; 
    FUNCCALL(SETUP_XfOrM1884(_), pre (data ) ); 
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    -- p -> suspend_break ; 
  }




  dw = ((Scheme_Dynamic_Wind * ) FUNCCALL(SETUP_XfOrM1862(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Dynamic_Wind ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  dw -> type = scheme_rt_dyn_wind ; 


  dw -> data = data ; 
  dw -> pre = pre ; 
  dw -> post = post ; 
  dw -> prev = p -> dw ; 
  if (dw -> prev )
    dw -> depth = dw -> prev -> depth + 1 ; 
  else 
  dw -> depth = 0 ; 
  dw -> next_meta = p -> next_meta ; 

  p -> next_meta = 0 ; 
  p -> dw = dw ; 

  dw -> saveerr = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> error_buf = & newbuf ; 

  (dw -> envss . runstack_offset = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) - XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) , dw -> envss . cont_mark_stack = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) , dw -> envss . cont_mark_pos = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) ) ; 

  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM1862_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#   define XfOrM1881_COUNT (0+XfOrM1862_COUNT)
#   define SETUP_XfOrM1881(x) SETUP_XfOrM1862(x)

# 9518 "./../src/fun.c"
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + dw -> envss . runstack_offset , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = dw -> envss . cont_mark_stack , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = dw -> envss . cont_mark_pos ) ; 
    if ((p -> dw != dw ) 
    && (! p -> dw || ! dw -> id || (p -> dw -> id != dw -> id ) ) ) {







      (((intptr_t * ) (void * ) ((* dw -> saveerr ) . gcvs ) ) [1 ] = (* dw -> saveerr ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* dw -> saveerr ) . gcvs , longjmp ((* dw -> saveerr ) . jb , 1 ) ) ; 
    }

# 9530 "./../src/fun.c"
    else {
#     define XfOrM1882_COUNT (0+XfOrM1881_COUNT)
#     define SETUP_XfOrM1882(x) SETUP_XfOrM1881(x)

# 9531 "./../src/fun.c"
      if (jmp_handler )
        v = FUNCCALL(SETUP_XfOrM1882(_), jmp_handler (data ) ); 
      else 
      v = ((void * ) 0 ) ; 
      err = ! v ; 
    }
  }

# 9537 "./../src/fun.c"
  else {
#   define XfOrM1879_COUNT (0+XfOrM1862_COUNT)
#   define SETUP_XfOrM1879(x) SETUP_XfOrM1862(x)

# 9538 "./../src/fun.c"
    if (pre ) {
#     define XfOrM1880_COUNT (0+XfOrM1879_COUNT)
#     define SETUP_XfOrM1880(x) SETUP_XfOrM1879(x)
      FUNCCALL(SETUP_XfOrM1880(_), scheme_check_break_now () ); 
    }

    v = FUNCCALL(SETUP_XfOrM1879(_), act (data ) ); 

    err = 0 ; 
  }

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
    save_count = p -> ku . multiple . count ; 
    save_values = p -> ku . multiple . array ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
    if ((save_values ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
  }

# 9556 "./../src/fun.c"
  else {
    save_count = 0 ; 
    save_values = ((void * ) 0 ) ; 
  }

  delta = p -> dw -> next_meta ; 
  p -> dw = p -> dw -> prev ; 

  p -> next_meta += delta ; 


  if (err && p -> cjs . is_kill && (post == post_dyn_wind ) )
    post = ((void * ) 0 ) ; 

  old_cac = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) ; 

  if (post ) {
#   define XfOrM1873_COUNT (0+XfOrM1862_COUNT)
#   define SETUP_XfOrM1873(x) SETUP_XfOrM1862(x)

# 9573 "./../src/fun.c"
    p -> error_buf = & newbuf ; 
    if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM1873_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) + dw -> envss . runstack_offset , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = dw -> envss . cont_mark_stack , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = dw -> envss . cont_mark_pos ) ; 
      err = 1 ; 
    }

# 9578 "./../src/fun.c"
    else {
      Scheme_Continuation_Jump_State cjs ; 
      BLOCK_SETUP((PUSH(cjs.jumping_to_continuation, 0+XfOrM1873_COUNT), PUSH(cjs.alt_full_continuation, 1+XfOrM1873_COUNT), PUSH(cjs.val, 2+XfOrM1873_COUNT)));
#     define XfOrM1874_COUNT (3+XfOrM1873_COUNT)
#     define SETUP_XfOrM1874(x) SETUP(XfOrM1874_COUNT)
      cjs.jumping_to_continuation = NULLED_OUT ; 
      cjs.alt_full_continuation = NULLED_OUT ; 
      cjs.val = NULLED_OUT ; 

# 9580 "./../src/fun.c"
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      if (! p -> cjs . skip_dws ) {
#       define XfOrM1875_COUNT (0+XfOrM1874_COUNT)
#       define SETUP_XfOrM1875(x) SETUP_XfOrM1874(x)
        FUNCCALL(SETUP_XfOrM1875(_), ASSERT_SUSPEND_BREAK_ZERO () )
# 9582 "./../src/fun.c"
        ; 
        p -> suspend_break ++ ; 
        FUNCCALL(SETUP_XfOrM1875(_), copy_cjs (& cjs , & p -> cjs ) ); 
        FUNCCALL_AGAIN(reset_cjs (& p -> cjs ) ); 
        FUNCCALL_AGAIN(post (data ) ); 
        FUNCCALL_AGAIN(copy_cjs (& p -> cjs , & cjs ) ); 
        p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
        -- p -> suspend_break ; 
      }
    }
  }

  if (err ) {
#   define XfOrM1865_COUNT (0+XfOrM1862_COUNT)
#   define SETUP_XfOrM1865(x) SETUP_XfOrM1862(x)
    if ((old_cac != XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) ) 
    && p -> cjs . jumping_to_continuation ) {
#     define XfOrM1866_COUNT (0+XfOrM1865_COUNT)
#     define SETUP_XfOrM1866(x) SETUP_XfOrM1865(x)

# 9599 "./../src/fun.c"
      p -> error_buf = dw -> saveerr ; 
      if ((Scheme_Type ) (((((intptr_t ) (p -> cjs . jumping_to_continuation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p -> cjs . jumping_to_continuation ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_type ) )  {
        Scheme_Object * tag ; 
        Scheme_Prompt * prompt ; 
        BLOCK_SETUP((PUSH(prompt, 0+XfOrM1866_COUNT), PUSH(tag, 1+XfOrM1866_COUNT)));
#       define XfOrM1870_COUNT (2+XfOrM1866_COUNT)
#       define SETUP_XfOrM1870(x) SETUP(XfOrM1870_COUNT)
        tag = NULLED_OUT ; 
        prompt = NULLED_OUT ; 

# 9603 "./../src/fun.c"
        tag = ((Scheme_Prompt * ) p -> cjs . jumping_to_continuation ) -> tag ; 
        prompt = (Scheme_Prompt * ) FUNCCALL(SETUP_XfOrM1870(_), scheme_extract_one_cc_mark (((void * ) 0 ) , (((Scheme_Small_Object * ) (tag ) ) -> u . ptr_val ) ) ); 
        if (! prompt && ((scheme_default_prompt_tag ) == (tag ) ) ) {
          prompt = original_default_prompt ; 
        }
        if (! prompt ) {
#         define XfOrM1871_COUNT (0+XfOrM1870_COUNT)
#         define SETUP_XfOrM1871(x) SETUP_XfOrM1870(x)
          FUNCCALL(SETUP_XfOrM1871(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "abort-current-continuation:" " abort in progress, but current continuation includes" " no prompt with the given tag" " after a `dynamic-wind' post-thunk return\n" "  tag: %V" , tag ) )



          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        p -> cjs . jumping_to_continuation = (Scheme_Object * ) prompt ; 
      }

# 9619 "./../src/fun.c"
      else if ((Scheme_Type ) (((((intptr_t ) (p -> cjs . jumping_to_continuation ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p -> cjs . jumping_to_continuation ) ) -> type ) ) == (Scheme_Type ) (scheme_escaping_cont_type ) )  {
#       define XfOrM1867_COUNT (0+XfOrM1866_COUNT)
#       define SETUP_XfOrM1867(x) SETUP_XfOrM1866(x)

# 9620 "./../src/fun.c"
        if (! FUNCCALL(SETUP_XfOrM1867(_), scheme_escape_continuation_ok (p -> cjs . jumping_to_continuation ) )) {
#         define XfOrM1868_COUNT (0+XfOrM1867_COUNT)
#         define SETUP_XfOrM1868(x) SETUP_XfOrM1867(x)

# 9621 "./../src/fun.c"
          if (p -> cjs . alt_full_continuation ) {
#           define XfOrM1869_COUNT (0+XfOrM1868_COUNT)
#           define SETUP_XfOrM1869(x) SETUP_XfOrM1868(x)
            RET_VALUE_START (FUNCCALL(SETUP_XfOrM1869(_), jump_to_alt_continuation () )) RET_VALUE_END ; 
          }
          FUNCCALL(SETUP_XfOrM1868(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_CONTINUATION , "continuation application: lost target;\n" " jump to escape continuation in progress, and the target is not in the\n" " current continuation after a `dynamic-wind' post-thunk return" ) )


          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
    }

    (((intptr_t * ) (void * ) ((* dw -> saveerr ) . gcvs ) ) [1 ] = (* dw -> saveerr ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* dw -> saveerr ) . gcvs , longjmp ((* dw -> saveerr ) . jb , 1 ) ) ; 
  }

  p -> error_buf = dw -> saveerr ; 

  if (post ) {
#   define XfOrM1864_COUNT (0+XfOrM1862_COUNT)
#   define SETUP_XfOrM1864(x) SETUP_XfOrM1862(x)
    FUNCCALL(SETUP_XfOrM1864(_), scheme_check_break_now () )
# 9642 "./../src/fun.c"
    ; 
  }

  if (v == ((Scheme_Object * ) 0x6 ) ) {
    p -> ku . multiple . count = save_count ; 
    p -> ku . multiple . array = save_values ; 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9653 "./../src/fun.c"
void scheme_apply_dw_in_meta (Scheme_Dynamic_Wind * dw , int post_part , int meta_depth , Scheme_Cont * recheck ) 
{

# 9683 "./../src/fun.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Meta_Continuation * mc , * old_mc , * rest ; 
  intptr_t delta ; 
  int i , actual_depth ; 
  int old_cac ; 
  PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(p, 0), PUSH(rest, 1), PUSH(dw, 2), PUSH(recheck, 3), PUSH(old_mc, 4), PUSH(mc, 5)));
# define XfOrM1885_COUNT (6)
# define SETUP_XfOrM1885(x) SETUP(XfOrM1885_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  mc = NULLED_OUT ; 
  old_mc = NULLED_OUT ; 
  rest = NULLED_OUT ; 

# 9689 "./../src/fun.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = p -> cont_mark_stack_bottom ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = p -> meta_continuation -> meta_tail_pos + 2 ; 

  old_mc = p -> meta_continuation ; 


  for (i = 0 , actual_depth = 0 , rest = old_mc ; i < meta_depth ; actual_depth ++ ) {
    if (rest -> overflow )
      i ++ ; 
    rest = rest -> next ; 
  }
  mc = FUNCCALL(SETUP_XfOrM1885(_), clone_meta_cont (p -> meta_continuation , ((void * ) 0 ) , actual_depth , ((void * ) 0 ) , ((void * ) 0 ) , rest , 0 ) ); 
  p -> meta_continuation = mc ; 


  rest = mc ; 
  for (i = 0 ; i < actual_depth - 1 ; i ++ ) {
#   define XfOrM1895_COUNT (0+XfOrM1885_COUNT)
#   define SETUP_XfOrM1895(x) SETUP_XfOrM1885(x)

# 9706 "./../src/fun.c"
    rest -> cont_mark_total = 0 ; 
    rest -> cont_mark_offset = rest -> cont_mark_stack ; 
    rest -> cont_mark_stack_copied = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM1895(_), sync_meta_cont (rest ) ); 
    rest = rest -> next ; 
  }


  delta = rest -> cont_mark_stack - dw -> envss . cont_mark_stack ; 
  if (delta ) {
#   define XfOrM1892_COUNT (0+XfOrM1885_COUNT)
#   define SETUP_XfOrM1892(x) SETUP_XfOrM1885(x)

# 9716 "./../src/fun.c"
    rest -> cont_mark_total -= delta ; 
    rest -> cont_mark_stack -= delta ; 
    if (rest -> cont_mark_total ) {
      Scheme_Cont_Mark * cp ; 
      BLOCK_SETUP((PUSH(cp, 0+XfOrM1892_COUNT)));
#     define XfOrM1893_COUNT (1+XfOrM1892_COUNT)
#     define SETUP_XfOrM1893(x) SETUP(XfOrM1893_COUNT)
      cp = NULLED_OUT ; 

# 9720 "./../src/fun.c"
      cp = ((Scheme_Cont_Mark * ) FUNCCALL(SETUP_XfOrM1893(_), GC_malloc (sizeof (Scheme_Cont_Mark ) * (rest -> cont_mark_total ) ) )) ; 
      (memcpy (cp , rest -> cont_mark_stack_copied , rest -> cont_mark_total * sizeof (Scheme_Cont_Mark ) ) ) ; 
      rest -> cont_mark_stack_copied = cp ; 
    }

# 9723 "./../src/fun.c"
    else 
    rest -> cont_mark_stack_copied = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM1892(_), sync_meta_cont (rest ) ); 
  }

  old_cac = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) ; 


  if (post_part ) {
    DW_PrePost_Proc post = dw -> post ; 
#   define XfOrM1891_COUNT (0+XfOrM1885_COUNT)
#   define SETUP_XfOrM1891(x) SETUP_XfOrM1885(x)
    FUNCCALL(SETUP_XfOrM1891(_), post (dw -> data ) )
# 9733 "./../src/fun.c"
    ; 
  }

# 9734 "./../src/fun.c"
  else {
    DW_PrePost_Proc pre = dw -> pre ; 
#   define XfOrM1890_COUNT (0+XfOrM1885_COUNT)
#   define SETUP_XfOrM1890(x) SETUP_XfOrM1885(x)
    FUNCCALL(SETUP_XfOrM1890(_), pre (dw -> data ) )
# 9736 "./../src/fun.c"
    ; 
  }

  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  if (recheck && ! recheck -> composable ) {
#   define XfOrM1888_COUNT (0+XfOrM1885_COUNT)
#   define SETUP_XfOrM1888(x) SETUP_XfOrM1885(x)

# 9742 "./../src/fun.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_continuation_application_count_ ) != old_cac ) {
#     define XfOrM1889_COUNT (0+XfOrM1888_COUNT)
#     define SETUP_XfOrM1889(x) SETUP_XfOrM1888(x)
      FUNCCALL(SETUP_XfOrM1889(_), scheme_recheck_prompt_and_barrier (recheck ) )
# 9743 "./../src/fun.c"
      ; 
    }
  }




  for (i = 0 , rest = p -> meta_continuation ; i < actual_depth ; i ++ ) {
    rest = rest -> next ; 
  }
  old_mc = FUNCCALL(SETUP_XfOrM1885(_), clone_meta_cont (old_mc , ((void * ) 0 ) , actual_depth , ((void * ) 0 ) , ((void * ) 0 ) , rest , 0 ) ); 
  p -> meta_continuation = old_mc ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9757 "./../src/fun.c"
static Scheme_Object * jump_to_alt_continuation () 
{
  Scheme_Thread * p ; 
  Scheme_Object * a [1 ] , * * args , * fc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 1, 0)));
# define XfOrM1898_COUNT (3)
# define SETUP_XfOrM1898(x) SETUP(XfOrM1898_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  args = NULLED_OUT ; 
  fc = NULLED_OUT ; 

# 9762 "./../src/fun.c"
  p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  a [0 ] = p -> cjs . val ; 
  fc = p -> cjs . alt_full_continuation ; 
  args = ((p -> cjs . num_vals == 1 ) ? a : (Scheme_Object * * ) p -> cjs . val ) ; 
  p -> cjs . jumping_to_continuation = ((void * ) 0 ) ; 
  p -> cjs . alt_full_continuation = ((void * ) 0 ) ; 
  p -> cjs . val = ((void * ) 0 ) ; 
  p -> cjs . skip_dws = 0 ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1898(_), scheme_jump_to_continuation (fc , p -> cjs . num_vals , args , ((void * ) 0 ) , 0 ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

uintptr_t scheme_get_milliseconds (void ) 

{
  /* No conversion */

# 9782 "./../src/fun.c"
  return rktio_get_milliseconds () ; 
}

double scheme_get_inexact_milliseconds (void ) 

{
  /* No conversion */

# 9788 "./../src/fun.c"
  return rktio_get_inexact_milliseconds () ; 
}

static double get_inexact_monotonic_milliseconds (void ) 

{
  /* No conversion */

# 9794 "./../src/fun.c"
  return rktio_get_inexact_monotonic_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 
}

intptr_t scheme_get_process_milliseconds (void ) 
{
  /* No conversion */

# 9799 "./../src/fun.c"
  return rktio_get_process_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 
}

intptr_t scheme_get_process_children_milliseconds (void ) 
{
  /* No conversion */

# 9804 "./../src/fun.c"
  return rktio_get_process_children_milliseconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 
}

intptr_t scheme_get_thread_milliseconds (Scheme_Object * thrd ) 
XFORM_SKIP_PROC 
{
  Scheme_Thread * t = thrd ? (Scheme_Thread * ) thrd : XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  if (t == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) {
    intptr_t cpm ; 
    cpm = scheme_get_process_milliseconds () ; 
    return t -> accum_process_msec + (cpm - t -> current_start_process_msec ) ; 
  }

# 9816 "./../src/fun.c"
  else {
    return t -> accum_process_msec ; 
  }
}

intptr_t scheme_get_seconds (void ) 
{
  /* No conversion */

# 9823 "./../src/fun.c"
  return rktio_get_seconds (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ; 
}

static Scheme_Object * seconds_to_date (int argc , Scheme_Object * * argv ) 
{
  intptr_t lnow ; 
  int get_gmt ; 
  rktio_date_t * dt ; 
  Scheme_Object * p [12 ] , * secs , * nsecs , * zname ; 
  char * tzn ; 

# 1436 "./../../rktio/rktio.h"
  const char * __funcarg216 = NULLED_OUT ; 

# 1385 "./../../rktio/rktio.h"
  int __funcarg215 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(dt, 0), PUSHARRAY(p, 12, 1), PUSH(nsecs, 4), PUSH(argv, 5), PUSH(zname, 6), PUSH(tzn, 7), PUSH(secs, 8)));
# define XfOrM1905_COUNT (9)
# define SETUP_XfOrM1905(x) SETUP(XfOrM1905_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  dt = NULLED_OUT ; 
  NULL_OUT_ARRAY (p ) ; 
  secs = NULLED_OUT ; 
  nsecs = NULLED_OUT ; 
  zname = NULLED_OUT ; 
  tzn = NULLED_OUT ; 

# 9834 "./../src/fun.c"
  secs = argv [0 ] ; 

  if (! ((((intptr_t ) (secs ) ) & 0x1 ) || ((((secs ) -> type ) >= scheme_bignum_type ) && (((secs ) -> type ) < scheme_complex_type ) ) ) ) {
#   define XfOrM1911_COUNT (0+XfOrM1905_COUNT)
#   define SETUP_XfOrM1911(x) SETUP_XfOrM1905(x)
    FUNCCALL(SETUP_XfOrM1911(_), scheme_wrong_contract ("seconds->date" , "real?" , 0 , argc , argv ) )
# 9837 "./../src/fun.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argc > 1 )
    get_gmt = (((argv [1 ] ) ) == (scheme_false ) ) ; 
  else 
  get_gmt = 0 ; 

  if ((((intptr_t ) (secs ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (secs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (secs ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
    nsecs = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
  }

# 9848 "./../src/fun.c"
  else {
#   define XfOrM1909_COUNT (0+XfOrM1905_COUNT)
#   define SETUP_XfOrM1909(x) SETUP_XfOrM1905(x)

# 9849 "./../src/fun.c"
    p [0 ] = secs ; 
    secs = FUNCCALL(SETUP_XfOrM1909(_), scheme_inexact_to_exact (1 , p ) ); 
    nsecs = secs ; 
    p [0 ] = secs ; 
    secs = FUNCCALL(SETUP_XfOrM1909(_), scheme_floor (1 , p ) ); 
    nsecs = FUNCCALL_AGAIN(scheme_bin_minus (nsecs , secs ) ); 
    nsecs = FUNCCALL_AGAIN(scheme_bin_mult (nsecs , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1000000000 ) ) ) << 1 ) | 0x1 ) ) ) ); 
    p [0 ] = nsecs ; 
    nsecs = FUNCCALL(SETUP_XfOrM1909(_), scheme_floor (1 , p ) ); 
    p [0 ] = nsecs ; 
    nsecs = FUNCCALL(SETUP_XfOrM1909(_), scheme_inexact_to_exact (1 , p ) ); 
    p [0 ] = secs ; 
    secs = FUNCCALL(SETUP_XfOrM1909(_), scheme_inexact_to_exact (1 , p ) ); 
  }

  if (scheme_get_int_val (secs , & lnow ) )  {
#   define XfOrM1906_COUNT (0+XfOrM1905_COUNT)
#   define SETUP_XfOrM1906(x) SETUP_XfOrM1905(x)

# 9865 "./../src/fun.c"
    dt = (rktio_seconds_to_date (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , lnow , (((intptr_t ) (nsecs ) ) >> 1 ) , get_gmt ) ) ; 
    if (dt ) {
#     define XfOrM1908_COUNT (0+XfOrM1906_COUNT)
#     define SETUP_XfOrM1908(x) SETUP_XfOrM1906(x)

# 9867 "./../src/fun.c"
      tzn = dt -> zone_name ; 
      if (! tzn )
        tzn = "?" ; 
      zname = FUNCCALL(SETUP_XfOrM1908(_), scheme_make_utf8_string (tzn ) ); 
      ((((Scheme_Inclhash_Object * ) (zname ) ) -> so . keyex |= 0x1 ) ) ; 

      p [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> second ) ) ) << 1 ) | 0x1 ) ) ; 
      p [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> minute ) ) ) << 1 ) | 0x1 ) ) ; 
      p [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> hour ) ) ) << 1 ) | 0x1 ) ) ; 
      p [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> day ) ) ) << 1 ) | 0x1 ) ) ; 
      p [4 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> month ) ) ) << 1 ) | 0x1 ) ) ; 
      p [5 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> year ) ) ) << 1 ) | 0x1 ) ) ; 
      p [6 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> day_of_week ) ) ) << 1 ) | 0x1 ) ) ; 
      p [7 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> day_of_year ) ) ) << 1 ) | 0x1 ) ) ; 
      p [8 ] = (dt -> is_dst ? scheme_true : scheme_false ) ; 
      p [9 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> zone_offset ) ) ) << 1 ) | 0x1 ) ) ; 
      p [10 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dt -> nanosecond ) ) ) << 1 ) | 0x1 ) ) ; 
      p [11 ] = zname ; 

      if (dt -> zone_name )
        (rktio_free (dt -> zone_name ) ) ; 
      FUNCCALL(SETUP_XfOrM1908(_), free (dt ) ); 

      RET_VALUE_START (FUNCCALL(SETUP_XfOrM1908(_), scheme_make_struct_instance (scheme_date , 12 , p ) )) RET_VALUE_END ; 
    }

# 9891 "./../src/fun.c"
    else if (((rktio_get_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) != RKTIO_ERROR_TIME_OUT_OF_RANGE ) 
    || ((rktio_get_last_error_kind (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) != RKTIO_ERROR_KIND_RACKET ) ) {
#     define XfOrM1907_COUNT (0+XfOrM1906_COUNT)
#     define SETUP_XfOrM1907(x) SETUP_XfOrM1906(x)
      (__funcarg215 = (
      rktio_get_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) , __funcarg216 = (
      rktio_get_last_error_string (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) , FUNCCALL(SETUP_XfOrM1907(_), scheme_raise_exn (MZEXN_FAIL , "seconds->date: conversion error\n" "  error: %d; %s" , __funcarg215 , __funcarg216 ) )) ; 
    }
  }
  FUNCCALL(SETUP_XfOrM1905(_), scheme_raise_exn (MZEXN_FAIL , "seconds->date: integer is out-of-range\n" "  integer: %V" , secs ) )



  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9909 "./../src/fun.c"
static Scheme_Object * time_apply (int argc , Scheme_Object * argv [] ) 
{
  double start , end ; 
  uintptr_t cpustart , cpuend ; 
  uintptr_t gcstart , gcend ; 
  uintptr_t dur , cpudur , gcdur ; 
  int i , num_rands ; 
  Scheme_Object * v , * p [4 ] , * * rand_vec , * rands , * r ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSHARRAY(p, 4, 0), PUSH(rands, 3), PUSH(rand_vec, 4), PUSH(v, 5), PUSH(argv, 6), PUSH(r, 7)));
# define XfOrM1912_COUNT (8)
# define SETUP_XfOrM1912(x) SETUP(XfOrM1912_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  NULL_OUT_ARRAY (p ) ; 
  rand_vec = NULLED_OUT ; 
  rands = NULLED_OUT ; 
  r = NULLED_OUT ; 

# 9918 "./../src/fun.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL(SETUP_XfOrM1912(_), scheme_wrong_contract ("time-apply" , "procedure?" , 0 , argc , argv ) ); 

  rands = argv [1 ] ; 

  num_rands = 0 ; 
  r = rands ; 
  while (! ((r ) == (scheme_null ) ) ) {
#   define XfOrM1918_COUNT (0+XfOrM1912_COUNT)
#   define SETUP_XfOrM1918(x) SETUP_XfOrM1912(x)

# 9926 "./../src/fun.c"
    if (! ((Scheme_Type ) (((((intptr_t ) (r ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (r ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      FUNCCALL(SETUP_XfOrM1918(_), scheme_wrong_contract ("time-apply" , "list?" , 1 , argc , argv ) ); 
    r = (((Scheme_Simple_Object * ) (r ) ) -> u . pair_val . cdr ) ; 
    num_rands ++ ; 
  }

  if (((FUNCCALL(SETUP_XfOrM1912(_), get_or_check_arity (argv [0 ] , num_rands , ((void * ) 0 ) , 1 ) )) ) == (scheme_false ) )  {
#   define XfOrM1916_COUNT (0+XfOrM1912_COUNT)
#   define SETUP_XfOrM1916(x) SETUP_XfOrM1912(x)
    FUNCCALL(SETUP_XfOrM1916(_), scheme_contract_error ("time-apply" , "arity mismatch between procedure and argument-list length\n" , "procedure" , 1 , argv [0 ] , "argument-list length" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (num_rands ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )

    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  rand_vec = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM1912(_), GC_malloc (sizeof (Scheme_Object * ) * (num_rands ) ) )) ; 
  for (i = 0 ; ((Scheme_Type ) (((((intptr_t ) (rands ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rands ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; i ++ , rands = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . cdr ) ) {
    rand_vec [i ] = (((Scheme_Simple_Object * ) (rands ) ) -> u . pair_val . car ) ; 
  }

  gcstart = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_total_gc_time_ ) ; 
  start = FUNCCALL(SETUP_XfOrM1912(_), get_inexact_monotonic_milliseconds () ); 
  cpustart = (scheme_get_process_milliseconds () ) ; 
  v = FUNCCALL(SETUP_XfOrM1912(_), scheme_do_eval (argv [0 ] , num_rands , rand_vec , - 1 ) ); 
  cpuend = (scheme_get_process_milliseconds () ) ; 
  end = FUNCCALL(SETUP_XfOrM1912(_), get_inexact_monotonic_milliseconds () ); 
  gcend = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_total_gc_time_ ) ; 

  dur = (uintptr_t ) (end - start ) ; 
  cpudur = cpuend - cpustart ; 
  gcdur = gcend - gcstart ; 

  if (v == ((Scheme_Object * ) 0x6 ) ) {
    Scheme_Thread * cp = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    Scheme_Object * * args ; 
#   define XfOrM1913_COUNT (0+XfOrM1912_COUNT)
#   define SETUP_XfOrM1913(x) SETUP_XfOrM1912(x)
    args = NULLED_OUT ; 

# 9961 "./../src/fun.c"
    if ((cp -> ku . multiple . array ) == (cp -> values_buffer ) ) 
      cp -> values_buffer = ((void * ) 0 ) ; 
    args = cp -> ku . multiple . array ; 
    cp -> ku . multiple . array = ((void * ) 0 ) ; 
    v = FUNCCALL(SETUP_XfOrM1913(_), scheme_build_list (cp -> ku . multiple . count , args ) ); 
  }

# 9966 "./../src/fun.c"
  else 
  v = FUNCCALL(SETUP_XfOrM1912(_), scheme_make_pair (v , scheme_null ) ); 

  p [0 ] = v ; 
  p [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (cpudur ) ) ) << 1 ) | 0x1 ) ) ; 
  p [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (dur ) ) ) << 1 ) | 0x1 ) ) ; 
  p [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (gcdur ) ) ) << 1 ) | 0x1 ) ) ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM1912(_), scheme_values (4 , p ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9977 "./../src/fun.c"
static Scheme_Object * current_milliseconds (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 9979 "./../src/fun.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (scheme_get_milliseconds () ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * current_inexact_milliseconds (int argc , Scheme_Object * * argv ) 
{

# 9785 "./../src/fun.c"
  double __funcarg217 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(0);
# define XfOrM1920_COUNT (0)
# define SETUP_XfOrM1920(x) SETUP(XfOrM1920_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 9984 "./../src/fun.c"
  RET_VALUE_START ((__funcarg217 = (scheme_get_inexact_milliseconds () ) , FUNCCALL_EMPTY(scheme_make_double (__funcarg217 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9987 "./../src/fun.c"
static Scheme_Object * current_inexact_monotonic_milliseconds (int argc , Scheme_Object * * argv ) 
{

# 9791 "./../src/fun.c"
  double __funcarg218 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(0);
# define XfOrM1921_COUNT (0)
# define SETUP_XfOrM1921(x) SETUP(XfOrM1921_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 9989 "./../src/fun.c"
  RET_VALUE_START ((__funcarg218 = FUNCCALL_EMPTY(get_inexact_monotonic_milliseconds () ), FUNCCALL_EMPTY(scheme_make_double (__funcarg218 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 9992 "./../src/fun.c"
static Scheme_Object * current_process_milliseconds (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 9994 "./../src/fun.c"
  if (! argc || (((argv [0 ] ) ) == (scheme_false ) ) )
    return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (scheme_get_process_milliseconds () ) ) ) << 1 ) | 0x1 ) ) ; 
  else if ((argv [0 ] ) == (subprocesses_symbol ) ) 
    return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (scheme_get_process_children_milliseconds () ) ) ) << 1 ) | 0x1 ) ) ; 
  else {
    if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) 
      return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (scheme_get_thread_milliseconds (argv [0 ] ) ) ) ) << 1 ) | 0x1 ) ) ; 
    scheme_wrong_contract ("current-process-milliseconds" , "(or/c #f thread? 'subprocesses)" , 0 , argc , argv ) ; 
    return ((void * ) 0 ) ; 
  }
}

static Scheme_Object * current_gc_milliseconds (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10008 "./../src/fun.c"
  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_total_gc_time_ ) ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * current_seconds (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10013 "./../src/fun.c"
  intptr_t secs ; 
  secs = scheme_get_seconds () ; 
  return scheme_make_integer_value ((intptr_t ) secs ) ; 
}






static Scheme_Object * 
current_print (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10026 "./../src/fun.c"
  return scheme_param_config ("current-print" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PRINT_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  1 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
current_prompt_read (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10035 "./../src/fun.c"
  return scheme_param_config ("current-prompt-read" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_PROMPT_READ_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
current_read (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10044 "./../src/fun.c"
  return scheme_param_config ("current-read-interaction" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_READ_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  2 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
current_get_read_input_port (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10053 "./../src/fun.c"
  return scheme_param_config ("current-get-interaction-input-port" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_READ_INPUT_PORT_HANDLER ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

static Scheme_Object * 
current_get_interaction_evt (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 10062 "./../src/fun.c"
  return scheme_param_config ("current-get-interaction-evt" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_READ_GET_EVT ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  0 , ((void * ) 0 ) , ((void * ) 0 ) , 0 ) ; 
}

Scheme_Object * 
scheme_default_print_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * obj = argv [0 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSHARRAY(argv, 2, 1)));
# define XfOrM1931_COUNT (4)
# define SETUP_XfOrM1931(x) SETUP(XfOrM1931_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 10073 "./../src/fun.c"
  if (! ((obj ) == (scheme_void ) ) ) {
    Scheme_Config * config ; 
    Scheme_Object * port ; 
    Scheme_Object * argv [2 ] ; 
    BLOCK_SETUP((PUSH(port, 0+XfOrM1931_COUNT), PUSH(config, 1+XfOrM1931_COUNT), PUSHARRAY(argv, 2, 2+XfOrM1931_COUNT)));
#   define XfOrM1932_COUNT (5+XfOrM1931_COUNT)
#   define SETUP_XfOrM1932(x) SETUP(XfOrM1932_COUNT)
    config = NULLED_OUT ; 
    port = NULLED_OUT ; 
    argv[0] = NULLED_OUT ; 
    argv[1] = NULLED_OUT ; 

# 10078 "./../src/fun.c"
    config = FUNCCALL(SETUP_XfOrM1932(_), scheme_current_config () ); 
    port = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_OUTPUT_PORT ) ); 

    argv [0 ] = obj ; 
    argv [1 ] = port ; 
    FUNCCALL(SETUP_XfOrM1932(_), scheme_do_eval (scheme_print_proc , 2 , argv , 1 ) ); 
    FUNCCALL_AGAIN(scheme_write_byte_string ("\n" , 1 , port ) ); 
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 10090 "./../src/fun.c"
Scheme_Object * 
scheme_default_read_input_port_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * inport ; 
  Scheme_Config * __funcarg219 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(inport, 0)));
# define XfOrM1933_COUNT (1)
# define SETUP_XfOrM1933(x) SETUP(XfOrM1933_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inport = NULLED_OUT ; 

# 10095 "./../src/fun.c"
  inport = (__funcarg219 = FUNCCALL(SETUP_XfOrM1933(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg219 , MZCONFIG_INPUT_PORT ) )) ; 

  if (inport == XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdin_port_ ) )
    FUNCCALL(SETUP_XfOrM1933(_), scheme_flush_orig_outputs () ); 

  RET_VALUE_START (inport ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 10103 "./../src/fun.c"
Scheme_Object * 
scheme_default_read_get_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 10106 "./../src/fun.c"
  return scheme_never_ready_evt ; 
}

Scheme_Object * 
scheme_default_prompt_read_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Config * config ; 
  Scheme_Object * port , * reader , * getter ; 
  Scheme_Object * inport , * name , * a [4 ] , * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(10);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSHARRAY(a, 4, 1), PUSH(getter, 4), PUSH(inport, 5), PUSH(name, 6), PUSH(v, 7), PUSH(reader, 8), PUSH(config, 9)));
# define XfOrM1935_COUNT (10)
# define SETUP_XfOrM1935(x) SETUP(XfOrM1935_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  config = NULLED_OUT ; 
  port = NULLED_OUT ; 
  reader = NULLED_OUT ; 
  getter = NULLED_OUT ; 
  inport = NULLED_OUT ; 
  name = NULLED_OUT ; 
  NULL_OUT_ARRAY (a ) ; 
  v = NULLED_OUT ; 

# 10116 "./../src/fun.c"
  config = FUNCCALL(SETUP_XfOrM1935(_), scheme_current_config () ); 
  port = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_OUTPUT_PORT ) ); 
  FUNCCALL_AGAIN(scheme_write_byte_string ("> " , 2 , port ) )
  ; 
  FUNCCALL_AGAIN(scheme_flush_output (port ) ); 

  getter = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_READ_INPUT_PORT_HANDLER ) ); 
  inport = FUNCCALL_AGAIN(scheme_do_eval (getter , 0 , ((void * ) 0 ) , 1 ) ); 

  if (! ((Scheme_Type ) (((((intptr_t ) (inport ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inport ) ) -> type ) ) == (Scheme_Type ) (scheme_input_port_type ) ) )
    FUNCCALL(SETUP_XfOrM1935(_), scheme_wrong_contract ("default-prompt-read-hander" , "input-port?" , - 1 , - 1 , & inport ) ); 

  name = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM1935(_), scheme_port_record (inport ) ); 
  name = ((Scheme_Input_Port * ) name ) -> name ; 

  reader = FUNCCALL(SETUP_XfOrM1935(_), scheme_get_param (config , MZCONFIG_READ_HANDLER ) ); 

  a [0 ] = name ; 
  a [1 ] = inport ; 
  v = FUNCCALL(SETUP_XfOrM1935(_), scheme_do_eval (reader , 2 , a , 1 ) ); 

  a [0 ] = inport ; 
  if (! (((FUNCCALL(SETUP_XfOrM1935(_), scheme_terminal_port_p (1 , a ) )) ) == (scheme_false ) ) )  {
#   define XfOrM1936_COUNT (0+XfOrM1935_COUNT)
#   define SETUP_XfOrM1936(x) SETUP_XfOrM1935(x)

# 10139 "./../src/fun.c"
    a [0 ] = port ; 
    if (! (((FUNCCALL(SETUP_XfOrM1936(_), scheme_terminal_port_p (1 , a ) )) ) == (scheme_false ) ) )  {
      intptr_t line , col , pos ; 
#     define XfOrM1937_COUNT (0+XfOrM1936_COUNT)
#     define SETUP_XfOrM1937(x) SETUP_XfOrM1936(x)
      FUNCCALL(SETUP_XfOrM1937(_), scheme_tell_all (port , & line , & col , & pos ) )
# 10142 "./../src/fun.c"
      ; 
      if ((col > 0 ) && (line > 0 ) ) {
#       define XfOrM1938_COUNT (0+XfOrM1937_COUNT)
#       define SETUP_XfOrM1938(x) SETUP_XfOrM1937(x)

        a [0 ] = port ; 
        a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (line + 1 ) ) ) << 1 ) | 0x1 ) ) ; 
        a [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
        if (pos > 0 )
          a [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos + 2 ) ) ) << 1 ) | 0x1 ) ) ; 
        else 
        a [3 ] = scheme_false ; 
        FUNCCALL(SETUP_XfOrM1938(_), scheme_set_port_location (4 , a ) ); 
      }
    }
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 10162 "./../src/fun.c"
Scheme_Object * 
scheme_default_read_handler (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Config * config ; 
  Scheme_Object * name = argv [0 ] ; 
  Scheme_Object * inport = argv [1 ] ; 
  Scheme_Object * stx ; 
  Scheme_Cont_Frame_Data cframe ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(stx, 0), PUSH(config, 1), PUSH(inport, 2), PUSH(name, 3), PUSH(cframe.cache, 4)));
# define XfOrM1939_COUNT (5)
# define SETUP_XfOrM1939(x) SETUP(XfOrM1939_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  config = NULLED_OUT ; 
  stx = NULLED_OUT ; 
  cframe.cache = NULLED_OUT ; 

# 10171 "./../src/fun.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (inport ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inport ) ) -> type ) ) == (Scheme_Type ) (scheme_input_port_type ) ) )
    FUNCCALL(SETUP_XfOrM1939(_), scheme_wrong_contract ("default-read-interaction-handler" , "input-port?" , 1 , argc , argv ) )



  ; 

  config = FUNCCALL(SETUP_XfOrM1939(_), scheme_current_config () ); 
  FUNCCALL_AGAIN(scheme_push_continuation_frame (& cframe ) )







  ; 
  FUNCCALL_AGAIN(scheme_install_config (config ) ); 

  stx = FUNCCALL_AGAIN(scheme_read_syntax (inport , name ) ); 
  FUNCCALL_AGAIN(scheme_pop_continuation_frame (& cframe ) )
  ; 

  RET_VALUE_START (stx ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3 "./../src/mzmark_fun.inc"
static int mark_dyn_wind_cell_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_dyn_wind_cell_MARK (void * p , struct NewGC * gc ) {

  Scheme_Dynamic_Wind_List * l = (Scheme_Dynamic_Wind_List * ) p ; 

  GC_mark2 (& (l -> dw ) , gc ) ; 
  GC_mark2 (& (l -> next ) , gc ) ; 


  return 0 ; 
}






static int mark_dyn_wind_cell_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Dynamic_Wind_List * l = (Scheme_Dynamic_Wind_List * ) p ; 

  GC_fixup2 (& (l -> dw ) , gc ) ; 
  GC_fixup2 (& (l -> next ) , gc ) ; 


  return 0 ; 
}

# 47 "./../src/mzmark_fun.inc"
static int mark_dyn_wind_info_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_dyn_wind_info_MARK (void * p , struct NewGC * gc ) {

  Dyn_Wind * d = (Dyn_Wind * ) p ; 

  GC_mark2 (& (d -> pre ) , gc ) ; 
  GC_mark2 (& (d -> act ) , gc ) ; 
  GC_mark2 (& (d -> post ) , gc ) ; 


  return 0 ; 
}






static int mark_dyn_wind_info_FIXUP (void * p , struct NewGC * gc ) {

  Dyn_Wind * d = (Dyn_Wind * ) p ; 

  GC_fixup2 (& (d -> pre ) , gc ) ; 
  GC_fixup2 (& (d -> act ) , gc ) ; 
  GC_fixup2 (& (d -> post ) , gc ) ; 


  return 0 ; 
}

# 93 "./../src/mzmark_fun.inc"
static int mark_cont_mark_chain_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_cont_mark_chain_MARK (void * p , struct NewGC * gc ) {

  Scheme_Cont_Mark_Chain * c = (Scheme_Cont_Mark_Chain * ) p ; 

  GC_mark2 (& (c -> key ) , gc ) ; 
  GC_mark2 (& (c -> val ) , gc ) ; 
  GC_mark2 (& (c -> next ) , gc ) ; 


  return 0 ; 
}






static int mark_cont_mark_chain_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Cont_Mark_Chain * c = (Scheme_Cont_Mark_Chain * ) p ; 

  GC_fixup2 (& (c -> key ) , gc ) ; 
  GC_fixup2 (& (c -> val ) , gc ) ; 
  GC_fixup2 (& (c -> next ) , gc ) ; 


  return 0 ; 
}

# 10207 "./../src/fun.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_rt_dyn_wind_cell , mark_dyn_wind_cell_SIZE , mark_dyn_wind_cell_MARK , mark_dyn_wind_cell_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_dyn_wind_info , mark_dyn_wind_info_SIZE , mark_dyn_wind_info_MARK , mark_dyn_wind_info_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_cont_mark_chain_type , mark_cont_mark_chain_SIZE , mark_cont_mark_chain_MARK , mark_cont_mark_chain_FIXUP , 1 , 0 ) ; 
}
