#include "precomp.h"

# 34 "../rktio/rktio_config.h"
typedef long long rktio_int64_t ; 

# 101 "./../../rktio/rktio.h"
typedef struct rktio_t rktio_t ; 

# 121 "./../../rktio/rktio.h"
typedef int rktio_ok_t ; 



typedef int rktio_tri_t ; 



typedef int rktio_bool_t ; 


typedef unsigned short rktio_char16_t ; 



typedef const char * rktio_const_string_t ; 

# 158 "./../../rktio/rktio.h"
typedef struct rktio_fd_t rktio_fd_t ; 

# 246 "./../../rktio/rktio.h"
__xform_nongcing__ extern void rktio_close_noerr (rktio_t * rktio , rktio_fd_t * fd ) ; 





__xform_nongcing__ extern rktio_fd_t * rktio_dup (rktio_t * rktio , rktio_fd_t * rfd ) ; 

# 351 "./../../rktio/rktio.h"
typedef rktio_int64_t rktio_filesize_t ; 




enum {
  RKTIO_POSITION_FROM_START , 
  RKTIO_POSITION_FROM_END }
; 

# 370 "./../../rktio/rktio.h"
typedef struct rktio_fd_transfer_t rktio_fd_transfer_t ; 


__xform_nongcing__ extern rktio_fd_transfer_t * rktio_fd_detach (rktio_t * rktio , rktio_fd_t * rfd ) ; 






__xform_nongcing__ extern rktio_fd_t * rktio_fd_attach (rktio_t * rktio , rktio_fd_transfer_t * rfdt ) ; 



__xform_nongcing__ extern void rktio_fd_close_transfer (rktio_fd_transfer_t * rfdt ) ; 






__xform_nongcing__ extern rktio_fd_t * * rktio_make_pipe (rktio_t * rktio , int flags ) ; 

# 403 "./../../rktio/rktio.h"
typedef struct rktio_addrinfo_lookup_t rktio_addrinfo_lookup_t ; 
typedef struct rktio_addrinfo_t rktio_addrinfo_t ; 

# 426 "./../../rktio/rktio.h"
typedef struct rktio_listener_t rktio_listener_t ; 
typedef struct rktio_connect_t rktio_connect_t ; 

# 499 "./../../rktio/rktio.h"
typedef struct rktio_length_and_addrinfo_t {
  intptr_t len ; 
  char * * address ; 
}

# 502 "./../../rktio/rktio.h"
rktio_length_and_addrinfo_t ; 

# 538 "./../../rktio/rktio.h"
enum {
  RKTIO_ADD_MEMBERSHIP , 
  RKTIO_DROP_MEMBERSHIP }
; 

# 569 "./../../rktio/rktio.h"
typedef struct rktio_envvars_t rktio_envvars_t ; 

# 595 "./../../rktio/rktio.h"
typedef struct rktio_process_t rktio_process_t ; 

typedef struct rktio_process_result_t {
  rktio_process_t * process ; 
  rktio_fd_t * stdin_fd ; 
  rktio_fd_t * stdout_fd ; 
  rktio_fd_t * stderr_fd ; 
}

# 602 "./../../rktio/rktio.h"
rktio_process_result_t ; 

# 646 "./../../rktio/rktio.h"
typedef struct rktio_status_t {
  rktio_bool_t running ; 
  int result ; 
}

# 649 "./../../rktio/rktio.h"
rktio_status_t ; 

# 669 "./../../rktio/rktio.h"
typedef struct rktio_fs_change_t rktio_fs_change_t ; 
struct rktio_ltps_t ; 

# 695 "./../../rktio/rktio.h"
typedef struct rktio_poll_set_t rktio_poll_set_t ; 

# 742 "./../../rktio/rktio.h"
typedef struct rktio_ltps_t rktio_ltps_t ; 
typedef struct rktio_ltps_handle_t rktio_ltps_handle_t ; 

# 762 "./../../rktio/rktio.h"
enum {
  RKTIO_LTPS_CREATE_READ = 1 , 
  RKTIO_LTPS_CREATE_WRITE , 
  RKTIO_LTPS_CHECK_READ , 
  RKTIO_LTPS_CHECK_WRITE , 
  RKTIO_LTPS_REMOVE , 

  RKTIO_LTPS_CREATE_VNODE , 
  RKTIO_LTPS_CHECK_VNODE , 
  RKTIO_LTPS_REMOVE_VNODE }
; 

# 793 "./../../rktio/rktio.h"
enum {
  RKTIO_LTPS_HANDLE_NONE , 
  RKTIO_LTPS_HANDLE_ZERO , 
  RKTIO_LTPS_HANDLE_FREE }
; 

# 874 "./../../rktio/rktio.h"
typedef intptr_t rktio_timestamp_t ; 






typedef struct rktio_stat_t {

  uintptr_t device_id , inode , mode , hardlink_count , user_id , group_id , 
  device_id_for_special_file , size , block_size , block_count , 
  access_time_seconds , access_time_nanoseconds , 
  modify_time_seconds , modify_time_nanoseconds , 
  ctime_seconds , ctime_nanoseconds ; 


  rktio_bool_t ctime_is_change_time ; 
}

# 891 "./../../rktio/rktio.h"
rktio_stat_t ; 



typedef struct rktio_identity_t {
  uintptr_t a , b , c ; 
  int a_bits , b_bits , c_bits ; 
}

# 898 "./../../rktio/rktio.h"
rktio_identity_t ; 

# 925 "./../../rktio/rktio.h"
typedef struct rktio_directory_list_t rktio_directory_list_t ; 

# 947 "./../../rktio/rktio.h"
typedef struct rktio_file_copy_t rktio_file_copy_t ; 

# 975 "./../../rktio/rktio.h"
enum {
  RKTIO_COPY_STEP_UNKNOWN , 
  RKTIO_COPY_STEP_OPEN_SRC , 
  RKTIO_COPY_STEP_OPEN_DEST , 
  RKTIO_COPY_STEP_READ_SRC_DATA , 
  RKTIO_COPY_STEP_WRITE_DEST_DATA , 
  RKTIO_COPY_STEP_READ_SRC_METADATA , 
  RKTIO_COPY_STEP_WRITE_DEST_METADATA }
; 






enum {
  RKTIO_PATH_SYS_DIR , 
  RKTIO_PATH_TEMP_DIR , 
  RKTIO_PATH_PREF_DIR , 
  RKTIO_PATH_PREF_FILE , 
  RKTIO_PATH_ADDON_DIR , 
  RKTIO_PATH_HOME_DIR , 
  RKTIO_PATH_DESK_DIR , 
  RKTIO_PATH_DOC_DIR , 
  RKTIO_PATH_INIT_DIR , 
  RKTIO_PATH_INIT_FILE , 
  RKTIO_PATH_CACHE_DIR }
; 

# 1018 "./../../rktio/rktio.h"
typedef struct rktio_signal_handle_t rktio_signal_handle_t ; 

# 1054 "./../../rktio/rktio.h"
enum {
  RKTIO_OS_SIGNAL_INT , 
  RKTIO_OS_SIGNAL_TERM , 
  RKTIO_OS_SIGNAL_HUP , 
  RKTIO_NUM_OS_SIGNALS }
; 

# 1075 "./../../rktio/rktio.h"
typedef struct rktio_date_t {
  int nanosecond , second , minute , hour , day , month ; 
  intptr_t year ; 
  int day_of_week ; 
  int day_of_year ; 
  int is_dst ; 
  int zone_offset ; 
  char * zone_name ; 
}

# 1083 "./../../rktio/rktio.h"
rktio_date_t ; 

# 1109 "./../../rktio/rktio.h"
enum {
  RKTIO_SW_HIDE , 
  RKTIO_SW_MAXIMIZE , 
  RKTIO_SW_MINIMIZE , 
  RKTIO_SW_RESTORE , 
  RKTIO_SW_SHOW , 
  RKTIO_SW_SHOWDEFAULT , 
  RKTIO_SW_SHOWMAXIMIZED , 
  RKTIO_SW_SHOWMINIMIZED , 
  RKTIO_SW_SHOWMINNOACTIVE , 
  RKTIO_SW_SHOWNA , 
  RKTIO_SW_SHOWNOACTIVATE , 
  RKTIO_SW_SHOWNORMAL }
; 

# 1160 "./../../rktio/rktio.h"
enum {
  RKTIO_LOG_FATAL = 1 , 
  RKTIO_LOG_ERROR , 
  RKTIO_LOG_WARNING , 
  RKTIO_LOG_INFO , 
  RKTIO_LOG_DEBUG }
; 

# 1178 "./../../rktio/rktio.h"
typedef struct rktio_converter_t rktio_converter_t ; 

# 1203 "./../../rktio/rktio.h"
typedef struct rktio_convert_result_t {
  intptr_t in_consumed ; 
  intptr_t out_produced ; 
  intptr_t converted ; 
}

# 1207 "./../../rktio/rktio.h"
rktio_convert_result_t ; 

# 1285 "./../../rktio/rktio.h"
typedef struct rktio_sha1_ctx_t {
  unsigned int state [5 ] ; 
  unsigned int count [2 ] ; 
  unsigned char buffer [64 ] ; 
}

# 1289 "./../../rktio/rktio.h"
rktio_sha1_ctx_t ; 

# 1304 "./../../rktio/rktio.h"
typedef struct rktio_sha2_ctx_t {
  unsigned total [2 ] ; 
  unsigned state [8 ] ; 
  unsigned char buffer [64 ] ; 
  int is224 ; 
}

# 1309 "./../../rktio/rktio.h"
rktio_sha2_ctx_t ; 

# 1322 "./../../rktio/rktio.h"
typedef struct rktio_dll_t rktio_dll_t ; 

# 1363 "./../../rktio/rktio.h"
typedef void * (* dll_open_proc ) (rktio_const_string_t name , rktio_bool_t as_global ) ; 
typedef void * (* dll_find_object_proc ) (void * h , rktio_const_string_t name ) ; 
typedef void (* dll_close_proc ) (void * h ) ; 









__xform_nongcing__ extern int rktio_get_last_error_kind (rktio_t * rktio ) ; 


enum {
  RKTIO_ERROR_KIND_POSIX , 
  RKTIO_ERROR_KIND_WINDOWS , 
  RKTIO_ERROR_KIND_GAI , 
  RKTIO_ERROR_KIND_RACKET }
; 

__xform_nongcing__ extern int rktio_get_last_error (rktio_t * rktio ) ; 


enum {
  RKTIO_ERROR_UNSUPPORTED = 1 , 
  RKTIO_ERROR_INVALID_PATH , 
  RKTIO_ERROR_DOES_NOT_EXIST , 
  RKTIO_ERROR_EXISTS , 
  RKTIO_ERROR_ACCESS_DENIED , 
  RKTIO_ERROR_LINK_FAILED , 
  RKTIO_ERROR_NOT_A_LINK , 
  RKTIO_ERROR_BAD_PERMISSION , 
  RKTIO_ERROR_IS_A_DIRECTORY , 
  RKTIO_ERROR_NOT_A_DIRECTORY , 
  RKTIO_ERROR_UNSUPPORTED_TEXT_MODE , 
  RKTIO_ERROR_CANNOT_FILE_POSITION , 
  RKTIO_ERROR_NO_TILDE , 
  RKTIO_ERROR_ILL_FORMED_USER , 
  RKTIO_ERROR_UNKNOWN_USER , 
  RKTIO_ERROR_INIT_FAILED , 
  RKTIO_ERROR_LTPS_NOT_FOUND , 
  RKTIO_ERROR_LTPS_REMOVED , 
  RKTIO_ERROR_CONNECT_TRYING_NEXT , 
  RKTIO_ERROR_ACCEPT_NOT_READY , 
  RKTIO_ERROR_HOST_AND_PORT_BOTH_UNSPECIFIED , 
  RKTIO_ERROR_INFO_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN , 
  RKTIO_ERROR_TRY_AGAIN_WITH_IPV4 , 
  RKTIO_ERROR_TIME_OUT_OF_RANGE , 
  RKTIO_ERROR_NO_SUCH_ENVVAR , 
  RKTIO_ERROR_SHELL_EXECUTE_FAILED , 
  RKTIO_ERROR_CONVERT_NOT_ENOUGH_SPACE , 
  RKTIO_ERROR_CONVERT_BAD_SEQUENCE , 
  RKTIO_ERROR_CONVERT_PREMATURE_END , 
  RKTIO_ERROR_CONVERT_OTHER , 
  RKTIO_ERROR_DLL , }
; 





__xform_nongcing__ extern void rktio_set_last_error (rktio_t * rktio , int kind , int errid ) ; 

# 3 "./../src/place.c"
static Scheme_Object * scheme_place_enabled (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * scheme_place_shared (int argc , Scheme_Object * args [] ) ; 

; 

static intptr_t embedded_load_len ; 
static const char * embedded_load ; 





static Scheme_Object * scheme_def_place_exit_proc ; 
static int scheme_places_enabled = 1 ; 

static Scheme_Object * quote_symbol ; 

static int id_counter ; 
static mzrt_mutex * id_counter_mutex ; 

mz_proc_thread * scheme_master_proc_thread ; 
; 
; 
; 
; 
static Scheme_Object * scheme_place (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * place_pumper_threads (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * place_wait (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * place_kill (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * place_break (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * place_p (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * place_send (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * place_receive (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * place_channel_p (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * def_place_exit_handler_proc (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * place_channel (int argc , Scheme_Object * args [] ) ; 
static Scheme_Object * place_allowed_p (int argc , Scheme_Object * args [] ) ; 
static void cust_kill_place (Scheme_Object * pl , void * notused ) ; 
static void resume_one_place_with_lock (Scheme_Place_Object * place_obj ) ; 

static Scheme_Place_Async_Channel * place_async_channel_create () ; 
static Scheme_Place_Bi_Channel * place_bi_channel_malloc () ; 
static Scheme_Place_Bi_Channel * place_bi_channel_create () ; 
static Scheme_Place_Bi_Channel * place_bi_peer_channel_create (Scheme_Place_Bi_Channel * orig ) ; 
static int place_channel_ready (Scheme_Object * so , Scheme_Schedule_Info * sinfo ) ; 
static void place_async_send (Scheme_Place_Async_Channel * ch , Scheme_Object * o ) ; 
static Scheme_Object * place_async_receive (Scheme_Place_Async_Channel * ch ) ; 

static Scheme_Object * make_place_dead (int argc , Scheme_Object * argv [] ) ; 
static int place_dead_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static void * GC_master_malloc_tagged (size_t size ) ; 
static void destroy_place_object_locks (Scheme_Place_Object * place_obj ) ; 

static void bi_channel_refcount (Scheme_Place_Bi_Channel * ch , int delta ) ; 
static void bi_channel_set_finalizer (Scheme_Place_Bi_Channel * ch ) ; 


static Scheme_Object * places_deep_copy_worker (Scheme_Object * so , Scheme_Hash_Table * * ht , 
int mode , int gcable , int can_raise_exn , 
Scheme_Object * * master_chain , 
Scheme_Object * * invalid_object , 
char * * delayed_err , intptr_t * delayed_errno , intptr_t * delayed_errkind ) ; 







static Scheme_Object * strip_chaperones (Scheme_Object * so ) ; 


static Scheme_Object * places_prepare_direct (Scheme_Object * so ) ; 
static void log_place_event (const char * what , const char * tag , int has_amount , intptr_t amount ) ; 


static void register_traversers (void ) ; 


static void * place_start_proc (void * arg ) ; 
static void * place_start_proc_after_stack (void * data_arg , void * stack_base ) __attribute__ ((noinline ) ) ; 

# 109 "./../src/place.c"
void scheme_init_place (Scheme_Startup_Env * env ) 
{
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  Scheme_Object * __funcarg58 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(env, 0)));
# define XfOrM1_COUNT (1)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM1(_), register_traversers () )
# 112 "./../src/place.c"
  ; 
  FUNCCALL(SETUP_XfOrM1(_), scheme_switch_prim_instance (env , "#%place" ) )

  ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (scheme_place_enabled , "place-enabled?" , 0 , 0 ) )
  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-enabled?" , __funcarg71 , env ) )) ; 
  (__funcarg70 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (scheme_place_shared , "place-shared?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-shared?" , __funcarg70 , env ) )) ; 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (scheme_place , "dynamic-place" , 5 , 5 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("dynamic-place" , __funcarg69 , env ) )) ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (place_pumper_threads , "place-pumper-threads" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-pumper-threads" , __funcarg68 , env ) )) ; 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (place_wait , "place-wait" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-wait" , __funcarg67 , env ) )) ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (place_kill , "place-kill" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-kill" , __funcarg66 , env ) )) ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (place_break , "place-break" , 1 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-break" , __funcarg65 , env ) )) ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (place_p , "place?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place?" , __funcarg64 , env ) )) ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (place_channel , "place-channel" , 0 , 0 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-channel" , __funcarg63 , env ) )) ; 
  (__funcarg62 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (place_send , "place-channel-put" , 2 , 2 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-channel-put" , __funcarg62 , env ) )) ; 
  (__funcarg61 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (place_receive , "place-channel-get" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-channel-get" , __funcarg61 , env ) )) ; 
  (__funcarg60 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (place_channel_p , "place-channel?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-channel?" , __funcarg60 , env ) )) ; 
  (__funcarg59 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (place_allowed_p , "place-message-allowed?" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-message-allowed?" , __funcarg59 , env ) )) ; 
  (__funcarg58 = FUNCCALL(SETUP_XfOrM1(_), scheme_make_prim_w_arity (make_place_dead , "place-dead-evt" , 1 , 1 ) ), FUNCCALL_AGAIN(scheme_addto_prim_instance ("place-dead-evt" , __funcarg58 , env ) )) ; 
  FUNCCALL_EMPTY(scheme_restore_prim_instance (env ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 135 "./../src/place.c"
void scheme_init_place_per_place () 
{
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(0);
# define XfOrM2_COUNT (0)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> all_child_places_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> all_child_places_ ) ) ) )
# 138 "./../src/place.c"
  ; 
  FUNCCALL_EMPTY(scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_event_prefab_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_event_prefab_ ) ) ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_event_prefab_ ) = (__funcarg72 = FUNCCALL_EMPTY(scheme_intern_symbol ("place-event" ) ), FUNCCALL_EMPTY(scheme_lookup_prefab_type (__funcarg72 , 4 ) )) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 145 "./../src/place.c"
static Scheme_Object * scheme_place_enabled (int argc , Scheme_Object * args [] ) {
  /* No conversion */

# 146 "./../src/place.c"
  return (scheme_places_enabled == 0 ) ? scheme_false : scheme_true ; 
}

static Scheme_Object * scheme_place_shared (int argc , Scheme_Object * args [] ) {
  /* No conversion */

# 150 "./../src/place.c"
  return (((Scheme_Inclhash_Object * ) (args [0 ] ) ) -> so . keyex & 0x2 ) ? scheme_true : scheme_false ; 
}

void scheme_init_places_once () {
  /* No conversion */
  scheme_add_evt (scheme_place_type , (Scheme_Ready_Fun ) place_channel_ready , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_place_bi_channel_type , (Scheme_Ready_Fun ) place_channel_ready , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_place_dead_type , (Scheme_Ready_Fun ) place_dead_ready , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  mzrt_mutex_create (& id_counter_mutex ) ; 
  scheme_register_static ((void * ) & scheme_def_place_exit_proc , sizeof (scheme_def_place_exit_proc ) ) ; 
  scheme_def_place_exit_proc = scheme_make_prim_w_arity (def_place_exit_handler_proc , "default-place-exit-handler" , 1 , 1 ) ; 

  scheme_register_static ((void * ) & quote_symbol , sizeof (quote_symbol ) ) ; 
  quote_symbol = scheme_intern_symbol ("quote" ) ; 
}


int scheme_get_place_id (void ) 
{
  /* No conversion */
  return XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) ; 
}




void scheme_register_embedded_load (intptr_t len , const char * s ) 
{
  /* No conversion */

# 178 "./../src/place.c"
  embedded_load_len = len ; 
  embedded_load = s ; 
}







typedef struct Place_Start_Data {


  Scheme_Object * module ; 
  Scheme_Object * function ; 
  Scheme_Object * channel ; 
  Scheme_Object * current_library_collection_paths ; 
  Scheme_Object * current_library_collection_links ; 
  Scheme_Object * compiled_roots ; 
  Scheme_Object * current_directory ; 
  mzrt_sema * ready ; 
  struct Scheme_Place_Object * place_obj ; 
  struct NewGC * parent_gc ; 
  Scheme_Object * cust_limit ; 
  rktio_fd_t * in ; 
  rktio_fd_t * out ; 
  rktio_fd_t * err ; 
  Scheme_Object * new_id ; 
}

# 206 "./../src/place.c"
Place_Start_Data ; 

static void null_out_runtime_globals () {
  /* No conversion */

# 209 "./../src/place.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_first_thread_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) = ((void * ) 0 ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_start_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_runstack_ ) = ((void * ) 0 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_stack_ ) = 0 ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_cont_mark_pos_ ) = 0 ; 
}

Scheme_Object * scheme_make_place_object () {
  Scheme_Place_Object * place_obj ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(place_obj, 0)));
# define XfOrM9_COUNT (1)
# define SETUP_XfOrM9(x) SETUP(XfOrM9_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  place_obj = NULLED_OUT ; 

# 221 "./../src/place.c"
  place_obj = FUNCCALL(SETUP_XfOrM9(_), GC_master_malloc_tagged (sizeof (Scheme_Place_Object ) ) ); 
  place_obj -> so . type = scheme_place_object_type ; 
  FUNCCALL(SETUP_XfOrM9(_), mzrt_mutex_create (& place_obj -> 
  lock ) )
# 223 "./../src/place.c"
  ; 
  place_obj -> die = 0 ; 
  place_obj -> dead = 0 ; 
  place_obj -> refcount = 1 ; 
  place_obj -> pbreak = 0 ; 
  place_obj -> result = 1 ; 
  RET_VALUE_START ((Scheme_Object * ) place_obj ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 232 "./../src/place.c"
static void close_six_fds (rktio_fd_t * * rw ) {
  /* No conversion */

# 233 "./../src/place.c"
  int i ; 
  for (i = 0 ; i < 6 ; i ++ ) {
    if (rw [i ] )
      rktio_close_noerr (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , rw [i ] ) ; 
  }
}

Scheme_Object * place_pumper_threads (int argc , Scheme_Object * args [] ) {
  /* No conversion */

# 241 "./../src/place.c"
  Scheme_Place * place ; 
  Scheme_Object * tmp ; 

  place = (Scheme_Place * ) args [0 ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_type ) ) )
    scheme_wrong_contract ("place-pumper-threads" , "place?" , 0 , argc , args ) ; 

  if (argc == 2 ) {
    tmp = args [1 ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (tmp ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (tmp ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || (((Scheme_Vector * ) (tmp ) ) -> size ) != 3 )
      scheme_wrong_type ("place-pumper-threads" , "vector of size 3" , 1 , argc , args ) ; 
    place -> pumper_threads = tmp ; 
  }
  return place -> pumper_threads ; 
}

Scheme_Object * scheme_place (int argc , Scheme_Object * args [] ) {
  Scheme_Place * place ; 
  Place_Start_Data * place_data ; 
  mz_proc_thread * proc_thread ; 
  Scheme_Object * collection_paths ; 
  Scheme_Object * collection_links ; 
  Scheme_Object * directory ; 
  Scheme_Place_Object * place_obj ; 
  mzrt_sema * ready ; 
  struct NewGC * parent_gc ; 
  Scheme_Custodian * cust ; 
  intptr_t mem_limit ; 
  Scheme_Object * in_arg ; 
  Scheme_Object * out_arg ; 
  Scheme_Object * err_arg ; 
  rktio_fd_t * rw [6 ] , * * rwp ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(22);
  BLOCK_SETUP_TOP((PUSH(collection_paths, 0), PUSH(place_obj, 1), PUSH(args, 2), PUSH(place_data, 3), PUSHARRAY(rw, 6, 4), PUSH(out_arg, 7), PUSH(ready, 8), PUSH(directory, 9), PUSH(parent_gc, 10), PUSH(err_arg, 11), PUSH(place, 12), PUSH(rwp, 13), PUSH(in_arg, 14), PUSH(collection_links, 15), PUSH(cust, 16), PUSH(proc_thread, 17)));
# define XfOrM15_COUNT (18)
# define SETUP_XfOrM15(x) SETUP(XfOrM15_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  place = NULLED_OUT ; 
  place_data = NULLED_OUT ; 
  proc_thread = NULLED_OUT ; 
  collection_paths = NULLED_OUT ; 
  collection_links = NULLED_OUT ; 
  directory = NULLED_OUT ; 
  place_obj = NULLED_OUT ; 
  ready = NULLED_OUT ; 
  parent_gc = NULLED_OUT ; 
  cust = NULLED_OUT ; 
  in_arg = NULLED_OUT ; 
  out_arg = NULLED_OUT ; 
  err_arg = NULLED_OUT ; 
  NULL_OUT_ARRAY (rw ) ; 
  rwp = NULLED_OUT ; 

# 274 "./../src/place.c"
  rw [0 ] = ((void * ) 0 ) ; 
  rw [1 ] = ((void * ) 0 ) ; 
  rw [2 ] = ((void * ) 0 ) ; 
  rw [3 ] = ((void * ) 0 ) ; 
  rw [4 ] = ((void * ) 0 ) ; 
  rw [5 ] = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM15(_), scheme_thread_block (0.0 ) )

  ; 

  parent_gc = FUNCCALL_AGAIN(GC_get_current_instance () ); 


  place = ((Scheme_Place * ) FUNCCALL(SETUP_XfOrM15(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Place ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  place -> so . type = scheme_place_type ; 
  place_obj = (Scheme_Place_Object * ) FUNCCALL(SETUP_XfOrM15(_), scheme_make_place_object () ); 
  place -> place_obj = place_obj ; 
  {
    GC_CAN_IGNORE void * handle ; 
#   define XfOrM51_COUNT (0+XfOrM15_COUNT)
#   define SETUP_XfOrM51(x) SETUP_XfOrM15(x)

# 293 "./../src/place.c"
    handle = FUNCCALL(SETUP_XfOrM51(_), scheme_get_signal_handle () ); 
    place_obj -> parent_signal_handle = handle ; 
  }









  place_obj -> use_factor = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) ? (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) -> use_factor / 2 ) : 1.0 ) ; 
  FUNCCALL(SETUP_XfOrM15(_), mzrt_sema_create (& ready , 0 ) )
  ; 


  place_data = ((Place_Start_Data * ) FUNCCALL(SETUP_XfOrM15(_), GC_malloc (sizeof (Place_Start_Data ) * (1 ) ) )) ; 
  place_data -> ready = ready ; 
  place_data -> place_obj = place_obj ; 
  place_data -> parent_gc = parent_gc ; 

  {
#   define XfOrM43_COUNT (0+XfOrM15_COUNT)
#   define SETUP_XfOrM43(x) SETUP_XfOrM15(x)

# 316 "./../src/place.c"
    in_arg = args [2 ] ; 
    out_arg = args [3 ] ; 
    err_arg = args [4 ] ; 

    if (! FUNCCALL(SETUP_XfOrM43(_), scheme_is_module_path (args [0 ] ) )&& ! ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#     define XfOrM50_COUNT (0+XfOrM43_COUNT)
#     define SETUP_XfOrM50(x) SETUP_XfOrM43(x)
      FUNCCALL(SETUP_XfOrM50(_), scheme_wrong_contract ("dynamic-place" , "(or/c module-path? path?)" , 0 , argc , args ) )
# 321 "./../src/place.c"
      ; 
    }
    if (! ((Scheme_Type ) (((((intptr_t ) (args [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#     define XfOrM49_COUNT (0+XfOrM43_COUNT)
#     define SETUP_XfOrM49(x) SETUP_XfOrM43(x)
      FUNCCALL(SETUP_XfOrM49(_), scheme_wrong_contract ("dynamic-place" , "symbol?" , 1 , argc , args ) )
# 324 "./../src/place.c"
      ; 
    }
    if ((! (((in_arg ) ) == (scheme_false ) ) ) && ! (! (((FUNCCALL(SETUP_XfOrM43(_), scheme_file_stream_port_p (1 , & in_arg ) )) ) == (scheme_false ) ) ) ) {
#     define XfOrM48_COUNT (0+XfOrM43_COUNT)
#     define SETUP_XfOrM48(x) SETUP_XfOrM43(x)
      FUNCCALL(SETUP_XfOrM48(_), scheme_wrong_contract ("dynamic-place" , "(or/c (and/c file-stream-port? input-port?) #f)" , 2 , argc , args ) )
# 327 "./../src/place.c"
      ; 
    }
    if ((! (((out_arg ) ) == (scheme_false ) ) ) && ! (! (((FUNCCALL(SETUP_XfOrM43(_), scheme_file_stream_port_p (1 , & out_arg ) )) ) == (scheme_false ) ) ) ) {
#     define XfOrM47_COUNT (0+XfOrM43_COUNT)
#     define SETUP_XfOrM47(x) SETUP_XfOrM43(x)
      FUNCCALL(SETUP_XfOrM47(_), scheme_wrong_contract ("dynamic-place" , "(or/c (and/c file-stream-port? output-port?) #f)" , 3 , argc , args ) )
# 330 "./../src/place.c"
      ; 
    }
    if ((! (((err_arg ) ) == (scheme_false ) ) ) && ! (! (((FUNCCALL(SETUP_XfOrM43(_), scheme_file_stream_port_p (1 , & err_arg ) )) ) == (scheme_false ) ) ) ) {
#     define XfOrM46_COUNT (0+XfOrM43_COUNT)
#     define SETUP_XfOrM46(x) SETUP_XfOrM43(x)
      FUNCCALL(SETUP_XfOrM46(_), scheme_wrong_contract ("dynamic-place" , "(or/c (and/c file-stream-port? output-port?) #f)" , 4 , argc , args ) )
# 333 "./../src/place.c"
      ; 
    }

    if (((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
    && (((((Scheme_Simple_Object * ) (args [0 ] ) ) -> u . pair_val . car ) ) == (quote_symbol ) ) 
    && ! FUNCCALL(SETUP_XfOrM43(_), scheme_is_predefined_module_path (args [0 ] ) )) {
#     define XfOrM45_COUNT (0+XfOrM43_COUNT)
#     define SETUP_XfOrM45(x) SETUP_XfOrM43(x)
      FUNCCALL(SETUP_XfOrM45(_), scheme_contract_error ("dynamic-place" , "not a filesystem or predefined module-path" , "module path" , 1 , args [0 ] , ((void * ) 0 ) ) ); 
    }

    place_data -> module = args [0 ] ; 
    place_data -> function = args [1 ] ; 
    place_data -> ready = ready ; 


    {
      Scheme_Place_Bi_Channel * channel ; 
      BLOCK_SETUP((PUSH(channel, 0+XfOrM43_COUNT)));
#     define XfOrM44_COUNT (1+XfOrM43_COUNT)
#     define SETUP_XfOrM44(x) SETUP(XfOrM44_COUNT)
      channel = NULLED_OUT ; 

# 351 "./../src/place.c"
      channel = FUNCCALL(SETUP_XfOrM44(_), place_bi_channel_create () ); 
      place -> channel = (Scheme_Object * ) channel ; 
      channel = FUNCCALL(SETUP_XfOrM44(_), place_bi_peer_channel_create (channel ) ); 
      place_data -> channel = (Scheme_Object * ) channel ; 
    }
  }

  collection_paths = FUNCCALL(SETUP_XfOrM15(_), scheme_current_library_collection_paths (0 , ((void * ) 0 ) ) ); 
  place_data -> current_library_collection_paths = collection_paths ; 

  collection_links = FUNCCALL(SETUP_XfOrM15(_), scheme_current_library_collection_links (0 , ((void * ) 0 ) ) ); 
  place_data -> current_library_collection_links = collection_links ; 

  collection_paths = FUNCCALL(SETUP_XfOrM15(_), scheme_compiled_file_roots (0 , ((void * ) 0 ) ) ); 
  place_data -> compiled_roots = collection_paths ; 

  directory = FUNCCALL(SETUP_XfOrM15(_), scheme_current_directory (0 , ((void * ) 0 ) ) ); 
  place_data -> current_directory = directory ; 

  cust = FUNCCALL(SETUP_XfOrM15(_), scheme_get_current_custodian () ); 
  mem_limit = FUNCCALL_AGAIN(GC_get_account_memory_limit (cust ) ); 
  place_data -> cust_limit = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (mem_limit ) ) ) << 1 ) | 0x1 ) ) ; 
  place_obj -> memory_limit = mem_limit ; 
  place_obj -> parent_need_gc = & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> force_gc_for_place_accounting_ ) ; 

  {
    rktio_fd_t * tmpfd ; 
    BLOCK_SETUP((PUSH(tmpfd, 0+XfOrM15_COUNT)));
#   define XfOrM23_COUNT (1+XfOrM15_COUNT)
#   define SETUP_XfOrM23(x) SETUP(XfOrM23_COUNT)
    tmpfd = NULLED_OUT ; 

# 379 "./../src/place.c"
    if (! (((in_arg ) ) == (scheme_false ) ) )  {
#     define XfOrM40_COUNT (0+XfOrM23_COUNT)
#     define SETUP_XfOrM40(x) SETUP_XfOrM23(x)

# 380 "./../src/place.c"
      if (FUNCCALL(SETUP_XfOrM40(_), scheme_port_closed_p (in_arg ) )) {
#       define XfOrM42_COUNT (0+XfOrM40_COUNT)
#       define SETUP_XfOrM42(x) SETUP_XfOrM40(x)
        FUNCCALL(SETUP_XfOrM42(_), close_six_fds (rw ) )
# 381 "./../src/place.c"
        ; 
        FUNCCALL(SETUP_XfOrM42(_), scheme_contract_error ("dynamic-place" , "port is closed" , "port" , 1 , in_arg , ((void * ) 0 ) ) )

        ; 
      }
      FUNCCALL(SETUP_XfOrM40(_), scheme_get_port_rktio_file_descriptor (in_arg , & tmpfd ) ); 
      tmpfd = (rktio_dup (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , tmpfd ) ) ; 
      if (! tmpfd ) {
#       define XfOrM41_COUNT (0+XfOrM40_COUNT)
#       define SETUP_XfOrM41(x) SETUP_XfOrM40(x)
        FUNCCALL(SETUP_XfOrM41(_), close_six_fds (rw ) )
# 389 "./../src/place.c"
        ; 
        FUNCCALL(SETUP_XfOrM41(_), scheme_rktio_error ("dynamic-place" , "stdin dup" ) ); 
      }
      rw [0 ] = tmpfd ; 
    }

# 393 "./../src/place.c"
    else {
#     define XfOrM37_COUNT (0+XfOrM23_COUNT)
#     define SETUP_XfOrM37(x) SETUP_XfOrM23(x)

# 394 "./../src/place.c"
      rwp = (rktio_make_pipe (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , 0 ) ) ; 
      if (! rwp ) {
#       define XfOrM39_COUNT (0+XfOrM37_COUNT)
#       define SETUP_XfOrM39(x) SETUP_XfOrM37(x)
        FUNCCALL(SETUP_XfOrM39(_), close_six_fds (rw ) )
# 396 "./../src/place.c"
        ; 
        FUNCCALL(SETUP_XfOrM39(_), scheme_rktio_error ("dynamic-place" , "stdin pipe" ) ); 
      }

# 398 "./../src/place.c"
      else {
#       define XfOrM38_COUNT (0+XfOrM37_COUNT)
#       define SETUP_XfOrM38(x) SETUP_XfOrM37(x)

# 399 "./../src/place.c"
        rw [0 ] = rwp [0 ] ; 
        rw [1 ] = rwp [1 ] ; 
        FUNCCALL(SETUP_XfOrM38(_), free (rwp ) ); 
      }
    }

    if (! (((out_arg ) ) == (scheme_false ) ) )  {
#     define XfOrM34_COUNT (0+XfOrM23_COUNT)
#     define SETUP_XfOrM34(x) SETUP_XfOrM23(x)

# 406 "./../src/place.c"
      if (FUNCCALL(SETUP_XfOrM34(_), scheme_port_closed_p (out_arg ) )) {
#       define XfOrM36_COUNT (0+XfOrM34_COUNT)
#       define SETUP_XfOrM36(x) SETUP_XfOrM34(x)
        FUNCCALL(SETUP_XfOrM36(_), close_six_fds (rw ) )
# 407 "./../src/place.c"
        ; 
        FUNCCALL(SETUP_XfOrM36(_), scheme_contract_error ("dynamic-place" , "port is closed" , "port" , 1 , out_arg , ((void * ) 0 ) ) )

        ; 
      }
      FUNCCALL(SETUP_XfOrM34(_), scheme_get_port_rktio_file_descriptor (out_arg , & tmpfd ) ); 
      tmpfd = (rktio_dup (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , tmpfd ) ) ; 
      if (! tmpfd ) {
#       define XfOrM35_COUNT (0+XfOrM34_COUNT)
#       define SETUP_XfOrM35(x) SETUP_XfOrM34(x)
        FUNCCALL(SETUP_XfOrM35(_), close_six_fds (rw ) )
# 415 "./../src/place.c"
        ; 
        FUNCCALL(SETUP_XfOrM35(_), scheme_rktio_error ("dynamic-place" , "stdout dup" ) ); 
      }
      rw [3 ] = tmpfd ; 
    }

# 419 "./../src/place.c"
    else {
#     define XfOrM31_COUNT (0+XfOrM23_COUNT)
#     define SETUP_XfOrM31(x) SETUP_XfOrM23(x)

# 420 "./../src/place.c"
      rwp = (rktio_make_pipe (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , 0 ) ) ; 
      if (! rwp ) {
#       define XfOrM33_COUNT (0+XfOrM31_COUNT)
#       define SETUP_XfOrM33(x) SETUP_XfOrM31(x)
        FUNCCALL(SETUP_XfOrM33(_), close_six_fds (rw ) )
# 422 "./../src/place.c"
        ; 
        FUNCCALL(SETUP_XfOrM33(_), scheme_rktio_error ("dynamic-place" , "stdout pipe" ) ); 
      }

# 424 "./../src/place.c"
      else {
#       define XfOrM32_COUNT (0+XfOrM31_COUNT)
#       define SETUP_XfOrM32(x) SETUP_XfOrM31(x)

# 425 "./../src/place.c"
        rw [2 ] = rwp [0 ] ; 
        rw [3 ] = rwp [1 ] ; 
        FUNCCALL(SETUP_XfOrM32(_), free (rwp ) ); 
      }
    }

    if (! (((err_arg ) ) == (scheme_false ) ) )  {
#     define XfOrM28_COUNT (0+XfOrM23_COUNT)
#     define SETUP_XfOrM28(x) SETUP_XfOrM23(x)

# 432 "./../src/place.c"
      if (FUNCCALL(SETUP_XfOrM28(_), scheme_port_closed_p (err_arg ) )) {
#       define XfOrM30_COUNT (0+XfOrM28_COUNT)
#       define SETUP_XfOrM30(x) SETUP_XfOrM28(x)
        FUNCCALL(SETUP_XfOrM30(_), close_six_fds (rw ) )
# 433 "./../src/place.c"
        ; 
        FUNCCALL(SETUP_XfOrM30(_), scheme_contract_error ("dynamic-place" , "port is closed" , "port" , 1 , err_arg , ((void * ) 0 ) ) )

        ; 
      }
      FUNCCALL(SETUP_XfOrM28(_), scheme_get_port_rktio_file_descriptor (err_arg , & tmpfd ) ); 
      tmpfd = (rktio_dup (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , tmpfd ) ) ; 
      if (! tmpfd ) {
#       define XfOrM29_COUNT (0+XfOrM28_COUNT)
#       define SETUP_XfOrM29(x) SETUP_XfOrM28(x)
        FUNCCALL(SETUP_XfOrM29(_), close_six_fds (rw ) )
# 441 "./../src/place.c"
        ; 
        FUNCCALL(SETUP_XfOrM29(_), scheme_rktio_error ("dynamic-place" , "stderr dup" ) ); 
      }
      rw [5 ] = tmpfd ; 
    }

# 445 "./../src/place.c"
    else {
#     define XfOrM25_COUNT (0+XfOrM23_COUNT)
#     define SETUP_XfOrM25(x) SETUP_XfOrM23(x)

# 446 "./../src/place.c"
      rwp = (rktio_make_pipe (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , 0 ) ) ; 
      if (! rwp ) {
#       define XfOrM27_COUNT (0+XfOrM25_COUNT)
#       define SETUP_XfOrM27(x) SETUP_XfOrM25(x)
        FUNCCALL(SETUP_XfOrM27(_), close_six_fds (rw ) )
# 448 "./../src/place.c"
        ; 
        FUNCCALL(SETUP_XfOrM27(_), scheme_rktio_error ("dynamic-place" , "stderr pipe" ) ); 
      }

# 450 "./../src/place.c"
      else {
#       define XfOrM26_COUNT (0+XfOrM25_COUNT)
#       define SETUP_XfOrM26(x) SETUP_XfOrM25(x)

# 451 "./../src/place.c"
        rw [4 ] = rwp [0 ] ; 
        rw [5 ] = rwp [1 ] ; 
        FUNCCALL(SETUP_XfOrM26(_), free (rwp ) ); 
      }
    }

    {
      place_data -> in = rw [0 ] ; 
      place_data -> out = rw [3 ] ; 
      place_data -> err = rw [5 ] ; 
    }
  }

  {
    Scheme_Object * tmp ; 
    BLOCK_SETUP((PUSH(tmp, 0+XfOrM15_COUNT)));
#   define XfOrM22_COUNT (1+XfOrM15_COUNT)
#   define SETUP_XfOrM22(x) SETUP(XfOrM22_COUNT)
    tmp = NULLED_OUT ; 

# 466 "./../src/place.c"
    tmp = FUNCCALL(SETUP_XfOrM22(_), places_prepare_direct (place_data -> current_library_collection_paths ) ); 
    place_data -> current_library_collection_paths = tmp ; 
    tmp = FUNCCALL(SETUP_XfOrM22(_), places_prepare_direct (place_data -> current_library_collection_links ) ); 
    place_data -> current_library_collection_links = tmp ; 
    tmp = FUNCCALL(SETUP_XfOrM22(_), places_prepare_direct (place_data -> compiled_roots ) ); 
    place_data -> compiled_roots = tmp ; 
    tmp = FUNCCALL(SETUP_XfOrM22(_), places_prepare_direct (place_data -> current_directory ) ); 
    place_data -> current_directory = tmp ; 
    tmp = FUNCCALL(SETUP_XfOrM22(_), places_prepare_direct (place_data -> channel ) ); 
    place_data -> channel = tmp ; 
    tmp = FUNCCALL(SETUP_XfOrM22(_), places_prepare_direct (place_data -> module ) ); 
    place_data -> module = tmp ; 
    tmp = FUNCCALL(SETUP_XfOrM22(_), places_prepare_direct (place_data -> function ) ); 
    place_data -> function = tmp ; 
  }


  proc_thread = FUNCCALL(SETUP_XfOrM15(_), mz_proc_thread_create (place_start_proc , place_data ) ); 

  if (! proc_thread ) {
#   define XfOrM21_COUNT (0+XfOrM15_COUNT)
#   define SETUP_XfOrM21(x) SETUP_XfOrM15(x)
    FUNCCALL(SETUP_XfOrM21(_), mzrt_sema_destroy (ready ) )
# 486 "./../src/place.c"
    ; 
    ready = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM21(_), scheme_signal_error ("place: place creation failed" ) ); 
  }
  FUNCCALL(SETUP_XfOrM15(_), mz_proc_thread_detach (proc_thread ) )
  ; 
  proc_thread = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM15(_), mzrt_sema_wait (ready ) )



  ; 
  FUNCCALL_AGAIN(mzrt_sema_destroy (ready ) ); 
  ready = ((void * ) 0 ) ; 

  if (! place_data -> place_obj )
    FUNCCALL(SETUP_XfOrM15(_), scheme_signal_error ("place: place creation failed" ) ); 
  FUNCCALL(SETUP_XfOrM15(_), log_place_event ("id %d: create %" "l" "d" , "create" , 1 , place_data -> place_obj -> id ) )
  ; 

  place_data -> ready = ((void * ) 0 ) ; 
  place_data -> place_obj = ((void * ) 0 ) ; 

  place -> next = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> all_child_places_ ) ; 
  if (place -> next )
    place -> next -> prev = place ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> all_child_places_ ) = place ; 

  {
    Scheme_Custodian_Reference * mref ; 
    BLOCK_SETUP((PUSH(mref, 0+XfOrM15_COUNT)));
#   define XfOrM20_COUNT (1+XfOrM15_COUNT)
#   define SETUP_XfOrM20(x) SETUP(XfOrM20_COUNT)
    mref = NULLED_OUT ; 

# 516 "./../src/place.c"
    mref = FUNCCALL(SETUP_XfOrM20(_), scheme_add_managed (((void * ) 0 ) , (Scheme_Object * ) place , cust_kill_place , ((void * ) 0 ) , 1 ) )



    ; 
    place -> mref = mref ; 
  }
  FUNCCALL(SETUP_XfOrM15(_), GC_register_new_thread (place , cust ) )

  ; 


  {
    Scheme_Object * a [4 ] ; 
    Scheme_Object * tmpport ; 
    BLOCK_SETUP((PUSHARRAY(a, 4, 0+XfOrM15_COUNT), PUSH(tmpport, 3+XfOrM15_COUNT)));
#   define XfOrM16_COUNT (4+XfOrM15_COUNT)
#   define SETUP_XfOrM16(x) SETUP(XfOrM16_COUNT)
    NULL_OUT_ARRAY (a ) ; 
    tmpport = NULLED_OUT ; 

# 531 "./../src/place.c"
    a [0 ] = (Scheme_Object * ) place ; 
    if (rw [1 ] ) {
#     define XfOrM19_COUNT (0+XfOrM16_COUNT)
#     define SETUP_XfOrM19(x) SETUP_XfOrM16(x)

# 533 "./../src/place.c"
      tmpport = (__funcarg75 = FUNCCALL(SETUP_XfOrM19(_), scheme_intern_symbol ("place-in" ) ), FUNCCALL_AGAIN(scheme_make_rktio_fd_output_port (rw [1 ] , __funcarg75 , 0 ) )) ; 
      a [1 ] = tmpport ; 
    }
    else 
    a [1 ] = scheme_false ; 

    if (rw [2 ] ) {
#     define XfOrM18_COUNT (0+XfOrM16_COUNT)
#     define SETUP_XfOrM18(x) SETUP_XfOrM16(x)

# 540 "./../src/place.c"
      tmpport = (__funcarg74 = FUNCCALL(SETUP_XfOrM18(_), scheme_intern_symbol ("place-out" ) ), FUNCCALL_AGAIN(scheme_make_rktio_fd_input_port (rw [2 ] , __funcarg74 ) )) ; 
      a [2 ] = tmpport ; 
    }
    else 
    a [2 ] = scheme_false ; 

    if (rw [4 ] ) {
#     define XfOrM17_COUNT (0+XfOrM16_COUNT)
#     define SETUP_XfOrM17(x) SETUP_XfOrM16(x)

# 547 "./../src/place.c"
      tmpport = (__funcarg73 = FUNCCALL(SETUP_XfOrM17(_), scheme_intern_symbol ("place-err" ) ), FUNCCALL_AGAIN(scheme_make_rktio_fd_input_port (rw [4 ] , __funcarg73 ) )) ; 
      a [3 ] = tmpport ; 
    }
    else 
    a [3 ] = scheme_false ; 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM16(_), scheme_values (4 , a ) )) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 556 "./../src/place.c"
static void do_place_kill (Scheme_Place * place ) 
{
  Scheme_Place_Object * place_obj ; 
  intptr_t refcount ; 
  int old_id ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(place, 0), PUSH(place_obj, 1)));
# define XfOrM52_COUNT (2)
# define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  place_obj = NULLED_OUT ; 

# 562 "./../src/place.c"
  place_obj = place -> place_obj ; 

  if (! place_obj )

# 564 "./../src/place.c"
  RET_NOTHING ; 

  {
#   define XfOrM54_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM54(x) SETUP_XfOrM52(x)
    FUNCCALL(SETUP_XfOrM54(_), mzrt_mutex_lock (place_obj -> 
    lock ) )
# 567 "./../src/place.c"
    ; 

    if (! place_obj -> dead ) {
#     define XfOrM55_COUNT (0+XfOrM54_COUNT)
#     define SETUP_XfOrM55(x) SETUP_XfOrM54(x)

# 570 "./../src/place.c"
      if (! place_obj -> die )
        place_obj -> die = 1 ; 
      if (place_obj -> signal_handle )
        FUNCCALL(SETUP_XfOrM55(_), scheme_signal_received_at (place_obj -> signal_handle ) ); 
      FUNCCALL(SETUP_XfOrM55(_), resume_one_place_with_lock (place_obj ) ); 

      do {
#       define XfOrM57_COUNT (0+XfOrM55_COUNT)
#       define SETUP_XfOrM57(x) SETUP_XfOrM55(x)
        FUNCCALL(SETUP_XfOrM57(_), mzrt_mutex_unlock (place_obj -> 
        lock ) ); 
        FUNCCALL(SETUP_XfOrM57(_), GC_check_master_gc_request () ); 
        FUNCCALL_AGAIN(scheme_start_atomic () ); 
        FUNCCALL_AGAIN(scheme_thread_block (0.0 ) ); 
        FUNCCALL_AGAIN(scheme_end_atomic_no_swap () ); 
        FUNCCALL_AGAIN(mzrt_mutex_lock (place_obj -> 
        lock ) )
# 585 "./../src/place.c"
        ; 
      }

# 586 "./../src/place.c"
      while (! place_obj -> dead ) ; 
    }

    place_obj -> refcount -- ; 
    refcount = place_obj -> refcount ; 

    if (place_obj -> signal_handle )
      FUNCCALL(SETUP_XfOrM54(_), scheme_signal_received_at (place_obj -> signal_handle ) ); 

    place -> result = place_obj -> result ; 

    place_obj -> parent_signal_handle = ((void * ) 0 ) ; 

    if (refcount )
      FUNCCALL(SETUP_XfOrM54(_), resume_one_place_with_lock (place_obj ) ); 
    FUNCCALL(SETUP_XfOrM54(_), mzrt_mutex_unlock (place_obj -> 
    lock ) ); 
  }
  FUNCCALL(SETUP_XfOrM52(_), scheme_remove_managed (place -> mref , (Scheme_Object * ) place ) )
  ; 

  if (place -> next )
    place -> next -> prev = place -> prev ; 
  if (place -> prev )
    place -> prev -> next = place -> next ; 
  else 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> all_child_places_ ) = place -> next ; 

  old_id = place_obj -> id ; 

  if (! refcount ) {
#   define XfOrM53_COUNT (0+XfOrM52_COUNT)
#   define SETUP_XfOrM53(x) SETUP_XfOrM52(x)
    FUNCCALL(SETUP_XfOrM53(_), destroy_place_object_locks (place_obj ) )
# 617 "./../src/place.c"
    ; 
  }
  place -> place_obj = ((void * ) 0 ) ; 
  FUNCCALL_EMPTY(log_place_event ("id %d: reap %" "l" "d" , "reap" , 1 , old_id ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 624 "./../src/place.c"
static int do_place_break (Scheme_Place * place , int kind ) 
{
  Scheme_Place_Object * place_obj ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(place_obj, 0)));
# define XfOrM58_COUNT (1)
# define SETUP_XfOrM58(x) SETUP(XfOrM58_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  place_obj = NULLED_OUT ; 

# 627 "./../src/place.c"
  place_obj = place -> place_obj ; 

  if (place_obj ) {
#   define XfOrM59_COUNT (0+XfOrM58_COUNT)
#   define SETUP_XfOrM59(x) SETUP_XfOrM58(x)
    FUNCCALL(SETUP_XfOrM59(_), mzrt_mutex_lock (place_obj -> 
    lock ) )
# 630 "./../src/place.c"
    ; 

    place_obj -> pbreak = kind ; 

    if (place_obj -> signal_handle )
      FUNCCALL(SETUP_XfOrM59(_), scheme_signal_received_at (place_obj -> signal_handle ) ); 
    FUNCCALL_EMPTY(mzrt_mutex_unlock (place_obj -> 
    lock ) ); 
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 643 "./../src/place.c"
static void cust_kill_place (Scheme_Object * pl , void * notused ) 
{
  /* No conversion */

# 645 "./../src/place.c"
  do_place_kill ((Scheme_Place * ) pl ) ; 
}

static Scheme_Object * place_kill (int argc , Scheme_Object * args [] ) {
  /* No conversion */

# 649 "./../src/place.c"
  Scheme_Place * place ; 
  place = (Scheme_Place * ) args [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_type ) ) )
    scheme_wrong_contract ("place-kill" , "place?" , 0 , argc , args ) ; 

  do_place_kill (place ) ; 
  return scheme_void ; 
}

static Scheme_Object * place_break (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 661 "./../src/place.c"
  Scheme_Place * place = (Scheme_Place * ) args [0 ] ; 
  int kind = MZEXN_BREAK ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_type ) ) )
    scheme_wrong_contract ("place-break" , "place?" , 0 , argc , args ) ; 

  if ((argc > 1 ) && (! (((args [1 ] ) ) == (scheme_false ) ) ) ) {
    if (((Scheme_Type ) (((((intptr_t ) (args [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    && ! ((& ((Scheme_Symbol * ) (args [1 ] ) ) -> iso ) -> so . keyex & 0x3 ) 
    && ! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (args [1 ] ) ) ) -> s ) , "hang-up" ) )
      kind = MZEXN_BREAK_HANG_UP ; 
    else if (((Scheme_Type ) (((((intptr_t ) (args [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    && ! ((& ((Scheme_Symbol * ) (args [1 ] ) ) -> iso ) -> so . keyex & 0x3 ) 
    && ! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (args [1 ] ) ) ) -> s ) , "terminate" ) )
      kind = MZEXN_BREAK_TERMINATE ; 
    else 
    scheme_wrong_contract ("place-break" , "(or/c #f 'hang-up 'terminate)" , 1 , argc , args ) ; 
  }

  do_place_break (place , kind ) ; 

  return scheme_void ; 
}

static int place_deadp (Scheme_Object * place ) {
  Scheme_Place_Object * place_obj ; 
  int dead = 0 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(place_obj, 0)));
# define XfOrM64_COUNT (1)
# define SETUP_XfOrM64(x) SETUP(XfOrM64_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  place_obj = NULLED_OUT ; 

# 688 "./../src/place.c"
  place_obj = (Scheme_Place_Object * ) ((Scheme_Place * ) place ) -> place_obj ; 

  if (place_obj == ((void * ) 0 ) ) {
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
  else 
  {
#   define XfOrM66_COUNT (0+XfOrM64_COUNT)
#   define SETUP_XfOrM66(x) SETUP_XfOrM64(x)
    FUNCCALL(SETUP_XfOrM66(_), mzrt_mutex_lock (place_obj -> 
    lock ) )
# 695 "./../src/place.c"
    ; 

    dead = place_obj -> die | place_obj -> dead ; 
    FUNCCALL_EMPTY(mzrt_mutex_unlock (place_obj -> 
    lock ) ); 
  }
  if (dead ) {

# 701 "./../src/place.c"
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

# 702 "./../src/place.c"
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 705 "./../src/place.c"
static Scheme_Object * make_place_dead (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * b ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(b, 0), PUSH(argv, 1)));
# define XfOrM68_COUNT (2)
# define SETUP_XfOrM68(x) SETUP(XfOrM68_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  b = NULLED_OUT ; 

# 709 "./../src/place.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("place-dead-evt" , "place?" , 0 , argc , argv ) ); 

  b = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM68(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  b -> type = scheme_place_dead_type ; 
  (((Scheme_Small_Object * ) (b ) ) -> u . ptr_val ) = argv [0 ] ; 
  RET_VALUE_START (b ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 718 "./../src/place.c"
static int place_dead_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) {
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(sinfo, 1)));
# define XfOrM69_COUNT (2)
# define SETUP_XfOrM69(x) SETUP(XfOrM69_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 719 "./../src/place.c"
  if (FUNCCALL(SETUP_XfOrM69(_), place_deadp ((((Scheme_Small_Object * ) (o ) ) -> u . ptr_val ) ) )) {
#   define XfOrM70_COUNT (0+XfOrM69_COUNT)
#   define SETUP_XfOrM70(x) SETUP_XfOrM69(x)
    FUNCCALL_EMPTY(scheme_set_sync_target (sinfo , o , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) )
# 720 "./../src/place.c"
    ; 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 728 "./../src/place.c"
static int place_wait_ready (Scheme_Object * _p ) {
  Scheme_Place * p = (Scheme_Place * ) _p ; 
  int done ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM71_COUNT (1)
# define SETUP_XfOrM71(x) SETUP(XfOrM71_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 732 "./../src/place.c"
  if (! p -> place_obj )

# 732 "./../src/place.c"
  RET_VALUE_START (1 ) RET_VALUE_END ; 
  FUNCCALL(SETUP_XfOrM71(_), mzrt_mutex_lock (p -> place_obj -> 
  lock ) ); 
  done = p -> place_obj -> dead ; 
  FUNCCALL(SETUP_XfOrM71(_), mzrt_mutex_unlock (p -> place_obj -> 
  lock ) )
# 736 "./../src/place.c"
  ; 

  if (done ) {
#   define XfOrM72_COUNT (0+XfOrM71_COUNT)
#   define SETUP_XfOrM72(x) SETUP_XfOrM71(x)
    FUNCCALL_EMPTY(do_place_kill (p ) )
# 739 "./../src/place.c"
    ; 

    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 747 "./../src/place.c"
static Scheme_Object * place_wait (int argc , Scheme_Object * args [] ) {
  Scheme_Place * place ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(place, 0)));
# define XfOrM73_COUNT (1)
# define SETUP_XfOrM73(x) SETUP(XfOrM73_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  place = NULLED_OUT ; 

# 749 "./../src/place.c"
  place = (Scheme_Place * ) args [0 ] ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("place-wait" , "place?" , 0 , argc , args ) ); 
  FUNCCALL(SETUP_XfOrM73(_), scheme_block_until (place_wait_ready , ((void * ) 0 ) , (Scheme_Object * ) place , 0 ) )
  ; 

  if ((Scheme_Type ) (((((intptr_t ) (place -> pumper_threads ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (place -> pumper_threads ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
    int i ; 
#   define XfOrM74_COUNT (0+XfOrM73_COUNT)
#   define SETUP_XfOrM74(x) SETUP_XfOrM73(x)

# 758 "./../src/place.c"
    for (i = 0 ; i < 3 ; i ++ ) {
      Scheme_Object * tmp ; 
      BLOCK_SETUP((PUSH(tmp, 0+XfOrM74_COUNT)));
#     define XfOrM76_COUNT (1+XfOrM74_COUNT)
#     define SETUP_XfOrM76(x) SETUP(XfOrM76_COUNT)
      tmp = NULLED_OUT ; 

# 760 "./../src/place.c"
      tmp = (((Scheme_Vector * ) (place -> pumper_threads ) ) -> els ) [i ] ; 
      if ((Scheme_Type ) (((((intptr_t ) (tmp ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (tmp ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) 
        FUNCCALL(SETUP_XfOrM76(_), scheme_thread_wait (tmp ) ); 
    }
  }

  RET_VALUE_START (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (place -> result ) ) ) << 1 ) | 0x1 ) ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 769 "./../src/place.c"
static Scheme_Object * place_p (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 771 "./../src/place.c"
  return ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_type ) ) ? scheme_true : scheme_false ; 
}

static Scheme_Object * do_places_deep_copy (Scheme_Object * so , int mode , int gcable , 
Scheme_Object * * master_chain , 
Scheme_Object * * invalid_object , 
char * * delayed_err , intptr_t * delayed_errno , intptr_t * delayed_errkind ) 
{

  Scheme_Hash_Table * ht = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ht, 0)));
# define XfOrM78_COUNT (1)
# define SETUP_XfOrM78(x) SETUP(XfOrM78_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 781 "./../src/place.c"
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM78(_), places_deep_copy_worker (so , & ht , mode , gcable , gcable , master_chain , invalid_object , delayed_err , delayed_errno , delayed_errkind ) )) RET_VALUE_END 
  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * places_prepare_direct (Scheme_Object * so ) {
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(so, 0)));
# define XfOrM79_COUNT (1)
# define SETUP_XfOrM79(x) SETUP(XfOrM79_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 789 "./../src/place.c"
  so = FUNCCALL(SETUP_XfOrM79(_), strip_chaperones (so ) ); 
  (void ) FUNCCALL(SETUP_XfOrM79(_), do_places_deep_copy (so , 0 , 1 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  RET_VALUE_START (so ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 794 "./../src/place.c"
static Scheme_Object * places_deep_direct_uncopy (Scheme_Object * so ) {
  /* No conversion */

# 795 "./../src/place.c"
  return do_places_deep_copy (so , 3 , 1 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ; 
}

static void bad_place_message (Scheme_Object * so , 
char * delayed_err , intptr_t delayed_errno , intptr_t delayed_errkind ) {
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(so, 0)));
# define XfOrM81_COUNT (1)
# define SETUP_XfOrM81(x) SETUP(XfOrM81_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 800 "./../src/place.c"
  if (delayed_err ) {
#   define XfOrM82_COUNT (0+XfOrM81_COUNT)
#   define SETUP_XfOrM82(x) SETUP_XfOrM81(x)
    (
# 801 "./../src/place.c"
    rktio_set_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , delayed_errkind , delayed_errno ) ) ; 
    FUNCCALL(SETUP_XfOrM82(_), scheme_rktio_error ("place-channel-put" , delayed_err ) ); 
  }

# 803 "./../src/place.c"
  else FUNCCALL_EMPTY(scheme_contract_error ("place-channel-put" , "value not allowed in a message" , "value" , 1 , so , ((void * ) 0 ) ) )



  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 810 "./../src/place.c"
static void * box_fd (rktio_fd_transfer_t * fd ) 
{
  rktio_fd_transfer_t * * fdp ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(fdp, 0), PUSH(fd, 1)));
# define XfOrM83_COUNT (2)
# define SETUP_XfOrM83(x) SETUP(XfOrM83_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  fdp = NULLED_OUT ; 

# 813 "./../src/place.c"
  fdp = FUNCCALL(SETUP_XfOrM83(_), GC_malloc_atomic (sizeof (rktio_fd_transfer_t * ) ) ); 
  * fdp = fd ; 
  RET_VALUE_START (fdp ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 818 "./../src/place.c"
static rktio_fd_transfer_t * unbox_fd (void * p ) 
{
  /* No conversion */

# 820 "./../src/place.c"
  return * (rktio_fd_transfer_t * * ) p ; 
}

static void bad_place_message2 (Scheme_Object * so , Scheme_Object * o , int can_raise_exn , 
char * delayed_err , intptr_t delayed_errno , intptr_t delayed_errkind ) {
  Scheme_Object * l ; 
  Scheme_Vector * v = (Scheme_Vector * ) o ; 

# 818 "./../src/place.c"
  rktio_fd_transfer_t * __funcarg79 = NULLED_OUT ; 

# 818 "./../src/place.c"
  rktio_fd_transfer_t * __funcarg77 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(so, 0), PUSH(delayed_err, 1), PUSH(l, 2), PUSH(v, 3)));
# define XfOrM85_COUNT (4)
# define SETUP_XfOrM85(x) SETUP(XfOrM85_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  l = NULLED_OUT ; 

# 827 "./../src/place.c"
  if (v ) {
#   define XfOrM86_COUNT (0+XfOrM85_COUNT)
#   define SETUP_XfOrM86(x) SETUP_XfOrM85(x)

# 828 "./../src/place.c"
    if ((((Scheme_Vector * ) (v ) ) -> els ) [0 ] ) {
#     define XfOrM94_COUNT (0+XfOrM86_COUNT)
#     define SETUP_XfOrM94(x) SETUP_XfOrM86(x)

# 829 "./../src/place.c"
      l = (((Scheme_Vector * ) (v ) ) -> els ) [0 ] ; 
      while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) ) {
#       define XfOrM98_COUNT (0+XfOrM94_COUNT)
#       define SETUP_XfOrM98(x) SETUP_XfOrM94(x)
        (__funcarg79 = FUNCCALL(SETUP_XfOrM98(_), unbox_fd ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ), (
# 831 "./../src/place.c"
        rktio_fd_close_transfer (__funcarg79 ) ) ) ; 
        l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        {
#         define XfOrM99_COUNT (0+XfOrM98_COUNT)
#         define SETUP_XfOrM99(x) SETUP_XfOrM98(x)

# 833 "./../src/place.c"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM100_COUNT (0+XfOrM99_COUNT)
#           define SETUP_XfOrM100(x) SETUP_XfOrM99(x)
            FUNCCALL(SETUP_XfOrM100(_), scheme_out_of_fuel () )
# 833 "./../src/place.c"
            ; 
          }
        }

# 833 "./../src/place.c"
        ; 
      }
    }
    if ((((Scheme_Vector * ) (v ) ) -> els ) [1 ] ) {
#     define XfOrM87_COUNT (0+XfOrM86_COUNT)
#     define SETUP_XfOrM87(x) SETUP_XfOrM86(x)

# 837 "./../src/place.c"
      l = (((Scheme_Vector * ) (v ) ) -> els ) [1 ] ; 
      while (((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_raw_pair_type ) ) ) {
#       define XfOrM91_COUNT (0+XfOrM87_COUNT)
#       define SETUP_XfOrM91(x) SETUP_XfOrM87(x)
        (__funcarg77 = FUNCCALL(SETUP_XfOrM91(_), unbox_fd ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ), (
# 839 "./../src/place.c"
        rktio_fd_close_transfer (__funcarg77 ) ) ) ; 
        l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        {
#         define XfOrM92_COUNT (0+XfOrM91_COUNT)
#         define SETUP_XfOrM92(x) SETUP_XfOrM91(x)

# 841 "./../src/place.c"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM93_COUNT (0+XfOrM92_COUNT)
#           define SETUP_XfOrM93(x) SETUP_XfOrM92(x)
            FUNCCALL(SETUP_XfOrM93(_), scheme_out_of_fuel () )
# 841 "./../src/place.c"
            ; 
          }
        }

# 841 "./../src/place.c"
        ; 
      }
    }
  }
  if (can_raise_exn )
    FUNCCALL_EMPTY(bad_place_message (so , delayed_err , delayed_errno , delayed_errkind ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 849 "./../src/place.c"
static void push_duped_fd (Scheme_Object * * fd_accumulators , intptr_t slot , rktio_fd_transfer_t * dupfdt ) {
  Scheme_Object * tmp ; 
  Scheme_Vector * v ; 

# 810 "./../src/place.c"
  void * __funcarg80 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(dupfdt, 0), PUSH(v, 1), PUSH(tmp, 2), PUSH(fd_accumulators, 3)));
# define XfOrM101_COUNT (4)
# define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  tmp = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 852 "./../src/place.c"
  if (fd_accumulators ) {
#   define XfOrM102_COUNT (0+XfOrM101_COUNT)
#   define SETUP_XfOrM102(x) SETUP_XfOrM101(x)

# 853 "./../src/place.c"
    if (! * fd_accumulators ) {
#     define XfOrM103_COUNT (0+XfOrM102_COUNT)
#     define SETUP_XfOrM103(x) SETUP_XfOrM102(x)

# 854 "./../src/place.c"
      tmp = FUNCCALL(SETUP_XfOrM103(_), scheme_make_vector (2 , scheme_null ) ); 
      * fd_accumulators = tmp ; 
    }
    v = (Scheme_Vector * ) * fd_accumulators ; 

    tmp = (__funcarg80 = FUNCCALL(SETUP_XfOrM102(_), box_fd (dupfdt ) ), FUNCCALL_AGAIN(scheme_make_raw_pair (__funcarg80 , (((Scheme_Vector * ) (v ) ) -> els ) [slot ] ) )) ; 
    (((Scheme_Vector * ) (v ) ) -> els ) [slot ] = tmp ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 864 "./../src/place.c"
static Scheme_Object * trivial_copy (Scheme_Object * so , Scheme_Object * * master_chain ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(master_chain, 0), PUSH(so, 1)));
# define XfOrM104_COUNT (2)
# define SETUP_XfOrM104(x) SETUP(XfOrM104_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 866 "./../src/place.c"
  switch (((((intptr_t ) (so ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (so ) ) -> type ) ) {
#   define XfOrM105_COUNT (0+XfOrM104_COUNT)
#   define SETUP_XfOrM105(x) SETUP_XfOrM104(x)

# 867 "./../src/place.c"
    case scheme_integer_type : 
    case scheme_true_type : 
    case scheme_false_type : 
    case scheme_null_type : 
    case scheme_void_type : 
    RET_VALUE_START (so ) RET_VALUE_END ; 
    case scheme_byte_string_type : 
    case scheme_flvector_type : 



    case scheme_fxvector_type : 
    if (((Scheme_Inclhash_Object * ) (so ) ) -> so . keyex & 0x2 )  {
#     define XfOrM106_COUNT (0+XfOrM105_COUNT)
#     define SETUP_XfOrM106(x) SETUP_XfOrM105(x)
      (
# 880 "./../src/place.c"
      scheme_hash_key (so ) ) ; 
      if (master_chain ) {




        Scheme_Object * mc ; 
        BLOCK_SETUP((PUSH(mc, 0+XfOrM106_COUNT)));
#       define XfOrM107_COUNT (1+XfOrM106_COUNT)
#       define SETUP_XfOrM107(x) SETUP(XfOrM107_COUNT)
        mc = NULLED_OUT ; 

# 887 "./../src/place.c"
        mc = FUNCCALL(SETUP_XfOrM107(_), scheme_make_raw_pair (so , * master_chain ) ); 
        * master_chain = mc ; 
      }
      RET_VALUE_START (so ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 897 "./../src/place.c"
static Scheme_Object * shallow_types_copy (Scheme_Object * so , Scheme_Hash_Table * ht , 
Scheme_Object * * fd_accumulators , 
char * * delayed_err , intptr_t * delayed_errno , intptr_t * delayed_errkind , 
int mode , int can_raise_exn , 
Scheme_Object * * master_chain , 
Scheme_Object * * invalid_object ) {
  Scheme_Object * new_so ; 
  int copy_mode = ((mode == 1 ) || (mode == 2 ) || (mode == 3 ) ) ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(15);
  BLOCK_SETUP_TOP((PUSH(master_chain, 0), PUSH(delayed_errkind, 1), PUSH(so, 2), PUSH(new_so, 3), PUSH(delayed_errno, 4), PUSH(fd_accumulators, 5), PUSH(invalid_object, 6), PUSH(delayed_err, 7), PUSH(ht, 8)));
# define XfOrM108_COUNT (9)
# define SETUP_XfOrM108(x) SETUP(XfOrM108_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  new_so = NULLED_OUT ; 

# 906 "./../src/place.c"
  new_so = FUNCCALL(SETUP_XfOrM108(_), trivial_copy (so , master_chain ) ); 
  if (new_so )

# 907 "./../src/place.c"
  RET_VALUE_START (new_so ) RET_VALUE_END ; 

  new_so = so ; 

  switch (((((intptr_t ) (so ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (so ) ) -> type ) ) {
#   define XfOrM110_COUNT (0+XfOrM108_COUNT)
#   define SETUP_XfOrM110(x) SETUP_XfOrM108(x)

# 912 "./../src/place.c"
    case scheme_place_type : 
    so = ((Scheme_Place * ) so ) -> channel ; 
    new_so = so ; 
    case scheme_place_bi_channel_type : 
    if (copy_mode ) {
      Scheme_Place_Bi_Channel * ch ; 
      BLOCK_SETUP((PUSH(ch, 0+XfOrM110_COUNT)));
#     define XfOrM168_COUNT (1+XfOrM110_COUNT)
#     define SETUP_XfOrM168(x) SETUP(XfOrM168_COUNT)
      ch = NULLED_OUT ; 

# 918 "./../src/place.c"
      ch = FUNCCALL(SETUP_XfOrM168(_), place_bi_channel_malloc () ); 
      ch -> link -> sendch = ((Scheme_Place_Bi_Channel * ) so ) -> link -> sendch ; 
      ch -> link -> recvch = ((Scheme_Place_Bi_Channel * ) so ) -> link -> recvch ; 

      if ((mode == 1 ) || (mode == 3 ) )
        FUNCCALL(SETUP_XfOrM168(_), bi_channel_refcount (ch , 1 ) ); 
      if ((mode == 2 ) || (mode == 3 ) )
        FUNCCALL(SETUP_XfOrM168(_), bi_channel_set_finalizer (ch ) ); 

      if (master_chain ) {
#       define XfOrM169_COUNT (0+XfOrM168_COUNT)
#       define SETUP_XfOrM169(x) SETUP_XfOrM168(x)

# 929 "./../src/place.c"
        new_so = FUNCCALL(SETUP_XfOrM169(_), scheme_make_raw_pair ((Scheme_Object * ) ch -> link -> sendch , * master_chain ) ); 
        new_so = FUNCCALL(SETUP_XfOrM169(_), scheme_make_raw_pair ((Scheme_Object * ) ch -> link -> recvch , new_so ) ); 
        * master_chain = new_so ; 
      }
      new_so = (Scheme_Object * ) ch ; 
    }

# 934 "./../src/place.c"
    else if (mode == 5 ) {
#     define XfOrM167_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM167(x) SETUP_XfOrM110(x)
      FUNCCALL(SETUP_XfOrM167(_), bi_channel_refcount ((Scheme_Place_Bi_Channel * ) so , - 1 ) )
# 935 "./../src/place.c"
      ; 
    }

# 936 "./../src/place.c"
    else if (mode == 4 ) {
#     define XfOrM166_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM166(x) SETUP_XfOrM110(x)
      FUNCCALL(SETUP_XfOrM166(_), bi_channel_set_finalizer ((Scheme_Place_Bi_Channel * ) so ) )
# 937 "./../src/place.c"
      ; 
    }
    break ; 
    case scheme_char_type : 
    if (copy_mode )
      new_so = FUNCCALL(SETUP_XfOrM110(_), scheme_make_char ((((Scheme_Small_Object * ) (so ) ) -> u . char_val ) ) ); 
    break ; 
    case scheme_bignum_type : 
    if (copy_mode )
      new_so = FUNCCALL(SETUP_XfOrM110(_), scheme_bignum_copy (so ) ); 
    break ; 
    case scheme_rational_type : 
    if (copy_mode ) {
      Scheme_Object * n ; 
      Scheme_Object * d ; 
      BLOCK_SETUP((PUSH(n, 0+XfOrM110_COUNT), PUSH(d, 1+XfOrM110_COUNT)));
#     define XfOrM165_COUNT (2+XfOrM110_COUNT)
#     define SETUP_XfOrM165(x) SETUP(XfOrM165_COUNT)
      n = NULLED_OUT ; 
      d = NULLED_OUT ; 

# 952 "./../src/place.c"
      n = (scheme_rational_numerator (so ) ) ; 
      d = (scheme_rational_denominator (so ) ) ; 
      n = FUNCCALL(SETUP_XfOrM165(_), shallow_types_copy (n , ((void * ) 0 ) , fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )
      ; 
      d = FUNCCALL_AGAIN(shallow_types_copy (d , ((void * ) 0 ) , fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )
      ; 
      new_so = FUNCCALL_AGAIN(scheme_make_rational_pre_normalized (n , d ) ); 
    }
    break ; 
    case scheme_float_type : 
    if (copy_mode )
      new_so = FUNCCALL(SETUP_XfOrM110(_), scheme_make_float ((((Scheme_Float * ) (so ) ) -> float_val ) ) ); 
    break ; 
    case scheme_double_type : 
    if (copy_mode )
      new_so = FUNCCALL(SETUP_XfOrM110(_), scheme_make_double ((((Scheme_Double * ) (so ) ) -> double_val ) ) ); 
    break ; 






    case scheme_complex_type : 
    if (copy_mode ) {
      Scheme_Object * r ; 
      Scheme_Object * i ; 
      BLOCK_SETUP((PUSH(i, 0+XfOrM110_COUNT), PUSH(r, 1+XfOrM110_COUNT)));
#     define XfOrM164_COUNT (2+XfOrM110_COUNT)
#     define SETUP_XfOrM164(x) SETUP(XfOrM164_COUNT)
      r = NULLED_OUT ; 
      i = NULLED_OUT ; 

# 979 "./../src/place.c"
      r = (scheme_complex_real_part (so ) ) ; 
      i = (scheme_complex_imaginary_part (so ) ) ; 
      r = FUNCCALL(SETUP_XfOrM164(_), shallow_types_copy (r , ((void * ) 0 ) , fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )
      ; 
      i = FUNCCALL_AGAIN(shallow_types_copy (i , ((void * ) 0 ) , fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )
      ; 
      new_so = FUNCCALL_AGAIN(scheme_make_complex (r , i ) ); 
    }
    break ; 
    case scheme_char_string_type : 
    if (copy_mode ) {
#     define XfOrM163_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM163(x) SETUP_XfOrM110(x)

# 990 "./../src/place.c"
      new_so = FUNCCALL(SETUP_XfOrM163(_), scheme_make_sized_offset_char_string ((((Scheme_Simple_Object * ) (so ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (so ) ) -> u . char_str_val . tag_val ) , 1 ) ); 
      ((((Scheme_Inclhash_Object * ) (new_so ) ) -> so . keyex |= 0x1 ) ) ; 
    }
    break ; 
    case scheme_byte_string_type : 

    if (copy_mode ) {
#     define XfOrM162_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM162(x) SETUP_XfOrM110(x)

# 997 "./../src/place.c"
      new_so = FUNCCALL(SETUP_XfOrM162(_), scheme_make_sized_offset_byte_string ((((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . tag_val ) , 1 ) ); 
      ((((Scheme_Inclhash_Object * ) (new_so ) ) -> so . keyex |= 0x1 ) ) ; 
    }
    break ; 
    case scheme_unix_path_type : 
    case scheme_windows_path_type : 
    if (copy_mode )
      new_so = FUNCCALL(SETUP_XfOrM110(_), scheme_make_sized_offset_kind_path ((((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . tag_val ) , 1 , ((((intptr_t ) (so ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (so ) ) -> type ) ) )
    ; 
    break ; 
    case scheme_symbol_type : 
    if (mode == 1 ) {
#     define XfOrM159_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM159(x) SETUP_XfOrM110(x)

# 1009 "./../src/place.c"
      new_so = FUNCCALL(SETUP_XfOrM159(_), scheme_make_sized_offset_byte_string ((char * ) so , ((uintptr_t ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (so ) ) ) -> s ) - (uintptr_t ) (so ) ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (so ) ) ) -> len ) , 1 ) ); 
      if ((& ((Scheme_Symbol * ) (so ) ) -> iso ) -> so . keyex & 0x1 )  {
        (& ((Scheme_Symbol * ) new_so ) -> iso ) -> so . keyex = 0x1 ; 
      }

# 1012 "./../src/place.c"
      else if ((& ((Scheme_Symbol * ) (so ) ) -> iso ) -> so . keyex & 0x2 )  {
        (& ((Scheme_Symbol * ) new_so ) -> iso ) -> so . keyex = 0x2 ; 
      }
      new_so -> type = scheme_serialized_symbol_type ; 
    }

# 1016 "./../src/place.c"
    else if (mode == 3 ) {
      char * str , buf [64 ] ; 
      intptr_t len ; 
      BLOCK_SETUP((PUSH(str, 0+XfOrM110_COUNT)));
#     define XfOrM158_COUNT (1+XfOrM110_COUNT)
#     define SETUP_XfOrM158(x) SETUP(XfOrM158_COUNT)
      str = NULLED_OUT ; 

# 1019 "./../src/place.c"
      len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (so ) ) ) -> len ) ; 
      if (len < 64 )
        str = buf ; 
      else 
      str = (char * ) FUNCCALL(SETUP_XfOrM158(_), GC_malloc_atomic (len ) ); 
      (memcpy (str , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (so ) ) ) -> s ) , len ) ) ; 
      if ((& ((Scheme_Symbol * ) (so ) ) -> iso ) -> so . keyex & 0x1 ) 
        new_so = FUNCCALL(SETUP_XfOrM158(_), scheme_make_exact_symbol (str , len ) ); 
      else if ((& ((Scheme_Symbol * ) (so ) ) -> iso ) -> so . keyex & 0x2 ) 
        new_so = FUNCCALL(SETUP_XfOrM158(_), scheme_intern_exact_parallel_symbol (str , len ) ); 
      else 
      new_so = FUNCCALL(SETUP_XfOrM158(_), scheme_intern_exact_symbol (str , len ) ); 
    }

# 1031 "./../src/place.c"
    else if (mode != 0 ) {
#     define XfOrM157_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM157(x) SETUP_XfOrM110(x)
      FUNCCALL(SETUP_XfOrM157(_), scheme_log_abort ("encountered symbol in bad mode" ) )
# 1032 "./../src/place.c"
      ; 
      FUNCCALL(SETUP_XfOrM157(_), abort () ); 
    }
    break ; 
    case scheme_serialized_symbol_type : 
    if ((mode == 2 ) || (mode == 4 ) ) {
#     define XfOrM153_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM153(x) SETUP_XfOrM110(x)

# 1038 "./../src/place.c"
      if ((& ((Scheme_Symbol * ) (so ) ) -> iso ) -> so . keyex & 0x1 )  {
#       define XfOrM156_COUNT (0+XfOrM153_COUNT)
#       define SETUP_XfOrM156(x) SETUP_XfOrM153(x)

# 1039 "./../src/place.c"
        new_so = FUNCCALL(SETUP_XfOrM156(_), scheme_make_exact_symbol ((((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . tag_val ) ) ); 
      }
      else if ((& ((Scheme_Symbol * ) (so ) ) -> iso ) -> so . keyex & 0x2 )  {
#       define XfOrM155_COUNT (0+XfOrM153_COUNT)
#       define SETUP_XfOrM155(x) SETUP_XfOrM153(x)

# 1042 "./../src/place.c"
        new_so = FUNCCALL(SETUP_XfOrM155(_), scheme_intern_exact_parallel_symbol ((((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . tag_val ) ) ); 
      }
      else {
#       define XfOrM154_COUNT (0+XfOrM153_COUNT)
#       define SETUP_XfOrM154(x) SETUP_XfOrM153(x)

# 1045 "./../src/place.c"
        new_so = FUNCCALL(SETUP_XfOrM154(_), scheme_intern_exact_symbol ((((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . tag_val ) ) ); 
      }
    }

# 1047 "./../src/place.c"
    else if (mode != 5 ) {
#     define XfOrM152_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM152(x) SETUP_XfOrM110(x)
      FUNCCALL(SETUP_XfOrM152(_), scheme_log_abort ("encountered serialized symbol in bad mode" ) )
# 1048 "./../src/place.c"
      ; 
      FUNCCALL(SETUP_XfOrM152(_), abort () ); 
    }
    break ; 
    case scheme_keyword_type : 
    if (mode == 1 ) {
#     define XfOrM151_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM151(x) SETUP_XfOrM110(x)

# 1054 "./../src/place.c"
      new_so = FUNCCALL(SETUP_XfOrM151(_), scheme_make_sized_offset_byte_string ((char * ) so , ((uintptr_t ) (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (so ) ) ) -> s ) - (uintptr_t ) (so ) ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (so ) ) ) -> len ) , 1 ) ); 
      new_so -> type = scheme_serialized_keyword_type ; 
    }

# 1056 "./../src/place.c"
    else if (mode == 3 ) {
      char * str , buf [64 ] ; 
      intptr_t len ; 
      BLOCK_SETUP((PUSH(str, 0+XfOrM110_COUNT)));
#     define XfOrM150_COUNT (1+XfOrM110_COUNT)
#     define SETUP_XfOrM150(x) SETUP(XfOrM150_COUNT)
      str = NULLED_OUT ; 

# 1059 "./../src/place.c"
      len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (so ) ) ) -> len ) ; 
      if (len < 64 )
        str = buf ; 
      else 
      str = (char * ) FUNCCALL(SETUP_XfOrM150(_), GC_malloc_atomic (len ) ); 
      (memcpy (str , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (so ) ) ) -> s ) , len ) ) ; 
      new_so = FUNCCALL(SETUP_XfOrM150(_), scheme_intern_exact_keyword (str , len ) ); 
    }

# 1066 "./../src/place.c"
    else if (mode != 0 ) {
#     define XfOrM149_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM149(x) SETUP_XfOrM110(x)
      FUNCCALL(SETUP_XfOrM149(_), scheme_log_abort ("encountered keyword in bad mode" ) )
# 1067 "./../src/place.c"
      ; 
      FUNCCALL(SETUP_XfOrM149(_), abort () ); 
    }
    break ; 
    case scheme_serialized_keyword_type : 
    if ((mode == 2 ) || (mode == 4 ) ) {
#     define XfOrM148_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM148(x) SETUP_XfOrM110(x)

# 1073 "./../src/place.c"
      new_so = FUNCCALL(SETUP_XfOrM148(_), scheme_intern_exact_keyword ((((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (so ) ) -> u . byte_str_val . tag_val ) ) ); 
    }

# 1074 "./../src/place.c"
    else if (mode != 5 ) {
#     define XfOrM147_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM147(x) SETUP_XfOrM110(x)
      FUNCCALL(SETUP_XfOrM147(_), scheme_log_abort ("encountered serialized keyword in bad mode" ) )
# 1075 "./../src/place.c"
      ; 
      FUNCCALL(SETUP_XfOrM147(_), abort () ); 
    }
    break ; 
    case scheme_fxvector_type : 

    if (copy_mode ) {
      Scheme_Vector * vec ; 
      intptr_t i ; 
      intptr_t size = (((Scheme_Vector * ) (so ) ) -> size ) ; 
      BLOCK_SETUP((PUSH(vec, 0+XfOrM110_COUNT)));
#     define XfOrM144_COUNT (1+XfOrM110_COUNT)
#     define SETUP_XfOrM144(x) SETUP(XfOrM144_COUNT)
      vec = NULLED_OUT ; 

# 1085 "./../src/place.c"
      vec = FUNCCALL(SETUP_XfOrM144(_), scheme_alloc_fxvector (size ) ); 

      for (i = 0 ; i < size ; i ++ ) {
        (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = (((Scheme_Vector * ) (so ) ) -> els ) [i ] ; 
      }
      new_so = (Scheme_Object * ) vec ; 
    }
    break ; 
    case scheme_flvector_type : 

    if (copy_mode ) {
      Scheme_Double_Vector * vec ; 
      intptr_t i ; 
      intptr_t size = (((Scheme_Double_Vector * ) (so ) ) -> size ) ; 
      BLOCK_SETUP((PUSH(vec, 0+XfOrM110_COUNT)));
#     define XfOrM141_COUNT (1+XfOrM110_COUNT)
#     define SETUP_XfOrM141(x) SETUP(XfOrM141_COUNT)
      vec = NULLED_OUT ; 

# 1099 "./../src/place.c"
      vec = FUNCCALL(SETUP_XfOrM141(_), scheme_alloc_flvector (size ) ); 

      for (i = 0 ; i < size ; i ++ ) {
        (((Scheme_Double_Vector * ) (vec ) ) -> els ) [i ] = (((Scheme_Double_Vector * ) (so ) ) -> els ) [i ] ; 
      }
      new_so = (Scheme_Object * ) vec ; 
    }
    break ; 

# 1123 "./../src/place.c"
    case scheme_cpointer_type : 
    if ((& ((Scheme_Cptr * ) (so ) ) -> so ) -> so . keyex & 0x1 ) {
#     define XfOrM136_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM136(x) SETUP_XfOrM110(x)

# 1125 "./../src/place.c"
      if (copy_mode ) {
        Scheme_Object * o ; 
        Scheme_Object * o2 ; 
        BLOCK_SETUP((PUSH(o2, 0+XfOrM136_COUNT), PUSH(o, 1+XfOrM136_COUNT)));
#       define XfOrM139_COUNT (2+XfOrM136_COUNT)
#       define SETUP_XfOrM139(x) SETUP(XfOrM139_COUNT)
        o = NULLED_OUT ; 
        o2 = NULLED_OUT ; 

# 1128 "./../src/place.c"
        if ((& ((Scheme_Cptr * ) (so ) ) -> so ) -> so . keyex & 0x2 ) {
#         define XfOrM140_COUNT (0+XfOrM139_COUNT)
#         define SETUP_XfOrM140(x) SETUP_XfOrM139(x)

# 1129 "./../src/place.c"
          o = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM140(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Offset_Cptr ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) ); 
          (& ((Scheme_Cptr * ) (o ) ) -> so ) -> so . keyex |= 0x2 ; 
          ((Scheme_Offset_Cptr * ) o ) -> offset = ((Scheme_Offset_Cptr * ) so ) -> offset ; 
        }
        else 
        o = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM139(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Cptr ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) ); 

        o -> type = scheme_cpointer_type ; 
        (& ((Scheme_Cptr * ) (o ) ) -> so ) -> so . keyex |= 0x1 ; 
        (((Scheme_Cptr * ) (o ) ) -> val ) = (((Scheme_Cptr * ) (so ) ) -> val ) ; 
        o2 = (((Scheme_Cptr * ) (so ) ) -> type ) ; 
        if (o2 )
          o2 = FUNCCALL(SETUP_XfOrM139(_), shallow_types_copy (o2 , ((void * ) 0 ) , fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )
        ; 
        (((Scheme_Cptr * ) (o ) ) -> type ) = o2 ; 

        new_so = o ; 
      }

# 1146 "./../src/place.c"
      else {
#       define XfOrM137_COUNT (0+XfOrM136_COUNT)
#       define SETUP_XfOrM137(x) SETUP_XfOrM136(x)

# 1147 "./../src/place.c"
        if (((Scheme_Cptr * ) (so ) ) -> type )  {
#         define XfOrM138_COUNT (0+XfOrM137_COUNT)
#         define SETUP_XfOrM138(x) SETUP_XfOrM137(x)

# 1148 "./../src/place.c"
          (void ) FUNCCALL(SETUP_XfOrM138(_), shallow_types_copy ((((Scheme_Cptr * ) (so ) ) -> type ) , ((void * ) 0 ) , fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )
          ; 
        }
      }
    }
    else {
#     define XfOrM135_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM135(x) SETUP_XfOrM110(x)
      FUNCCALL(SETUP_XfOrM135(_), bad_place_message2 (so , * fd_accumulators , can_raise_exn , 0 , 0 , 0 ) )
# 1154 "./../src/place.c"
      ; 
      if (invalid_object )

# 1155 "./../src/place.c"
      * invalid_object = so ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    break ; 
    case scheme_input_port_type : 
    case scheme_output_port_type : 
    {
      rktio_fd_t * fd ; 
      BLOCK_SETUP((PUSH(fd, 0+XfOrM110_COUNT)));
#     define XfOrM123_COUNT (1+XfOrM110_COUNT)
#     define SETUP_XfOrM123(x) SETUP(XfOrM123_COUNT)
      fd = NULLED_OUT ; 

# 1163 "./../src/place.c"
      if ((fd = FUNCCALL(SETUP_XfOrM123(_), scheme_get_port_rktio_socket (so ) )) ) {
#       define XfOrM131_COUNT (0+XfOrM123_COUNT)
#       define SETUP_XfOrM131(x) SETUP_XfOrM123(x)

# 1164 "./../src/place.c"
        if (mode == 1 ) {
          Scheme_Object * tmp ; 
          Scheme_Object * portname ; 
          Scheme_Serialized_Socket_FD * ssfd ; 
          rktio_fd_t * dupfd ; 
          rktio_fd_transfer_t * dupfdt ; 
          BLOCK_SETUP((PUSH(dupfdt, 0+XfOrM131_COUNT), PUSH(ssfd, 1+XfOrM131_COUNT), PUSH(portname, 2+XfOrM131_COUNT), PUSH(dupfd, 3+XfOrM131_COUNT), PUSH(tmp, 4+XfOrM131_COUNT)));
#         define XfOrM132_COUNT (5+XfOrM131_COUNT)
#         define SETUP_XfOrM132(x) SETUP(XfOrM132_COUNT)
          tmp = NULLED_OUT ; 
          portname = NULLED_OUT ; 
          ssfd = NULLED_OUT ; 
          dupfd = NULLED_OUT ; 
          dupfdt = NULLED_OUT ; 

# 1170 "./../src/place.c"
          dupfd = (rktio_dup (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fd ) ) ; 
          if (! dupfd ) {
#           define XfOrM133_COUNT (0+XfOrM132_COUNT)
#           define SETUP_XfOrM133(x) SETUP_XfOrM132(x)

# 1172 "./../src/place.c"
            if (can_raise_exn )
              FUNCCALL(SETUP_XfOrM133(_), scheme_rktio_error ("dynamic-place" , "socket dup" ) ); 
            if (delayed_err ) {
              intptr_t tmp ; 
#             define XfOrM134_COUNT (0+XfOrM133_COUNT)
#             define SETUP_XfOrM134(x) SETUP_XfOrM133(x)

# 1176 "./../src/place.c"
              * delayed_err = "socket dup" ; 
              tmp = (rktio_get_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
              * delayed_errno = tmp ; 
              tmp = (rktio_get_last_error_kind (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
              * delayed_errkind = tmp ; 
            }
            if (invalid_object )

# 1182 "./../src/place.c"
            * invalid_object = so ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          dupfdt = (rktio_fd_detach (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , dupfd ) ) ; 
          FUNCCALL(SETUP_XfOrM132(_), push_duped_fd (fd_accumulators , 1 , dupfdt ) ); 
          ssfd = FUNCCALL_AGAIN(GC_malloc_one_tagged (sizeof (Scheme_Serialized_Socket_FD ) ) ); 
          ssfd -> so . type = scheme_serialized_tcp_fd_type ; 
          ssfd -> type = so -> type ; 
          ssfd -> fdt = dupfdt ; 
          portname = FUNCCALL(SETUP_XfOrM132(_), scheme_port_name (so ) ); 
          tmp = FUNCCALL_AGAIN(shallow_types_copy (portname , ht , fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )
          ; 
          ssfd -> name = tmp ; 
          RET_VALUE_START ((Scheme_Object * ) ssfd ) RET_VALUE_END ; 
        }
      }
      else if (! (((FUNCCALL(SETUP_XfOrM123(_), scheme_file_stream_port_p (1 , & so ) )) ) == (scheme_false ) ) )  {
#       define XfOrM125_COUNT (0+XfOrM123_COUNT)
#       define SETUP_XfOrM125(x) SETUP_XfOrM123(x)

# 1199 "./../src/place.c"
        if (FUNCCALL(SETUP_XfOrM125(_), scheme_get_port_rktio_file_descriptor (so , & fd ) )) {
#         define XfOrM127_COUNT (0+XfOrM125_COUNT)
#         define SETUP_XfOrM127(x) SETUP_XfOrM125(x)

# 1200 "./../src/place.c"
          if (mode == 1 ) {
            Scheme_Object * tmp ; 
            Scheme_Serialized_File_FD * sffd ; 
            rktio_fd_t * dupfd ; 
            rktio_fd_transfer_t * dupfdt ; 
            BLOCK_SETUP((PUSH(dupfdt, 0+XfOrM127_COUNT), PUSH(sffd, 1+XfOrM127_COUNT), PUSH(dupfd, 2+XfOrM127_COUNT), PUSH(tmp, 3+XfOrM127_COUNT)));
#           define XfOrM128_COUNT (4+XfOrM127_COUNT)
#           define SETUP_XfOrM128(x) SETUP(XfOrM128_COUNT)
            tmp = NULLED_OUT ; 
            sffd = NULLED_OUT ; 
            dupfd = NULLED_OUT ; 
            dupfdt = NULLED_OUT ; 

# 1205 "./../src/place.c"
            sffd = FUNCCALL(SETUP_XfOrM128(_), GC_malloc_one_tagged (sizeof (Scheme_Serialized_File_FD ) ) ); 
            sffd -> so . type = scheme_serialized_file_fd_type ; 
            FUNCCALL(SETUP_XfOrM128(_), scheme_get_serialized_fd_flags (so , sffd ) ); 
            tmp = (__funcarg81 = FUNCCALL(SETUP_XfOrM128(_), scheme_port_name (so ) ), FUNCCALL_AGAIN(shallow_types_copy (__funcarg81 , ht , fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )) 
            ; 
            sffd -> name = tmp ; 
            dupfd = (rktio_dup (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fd ) ) ; 
            if (! dupfd ) {
#             define XfOrM129_COUNT (0+XfOrM128_COUNT)
#             define SETUP_XfOrM129(x) SETUP_XfOrM128(x)

# 1213 "./../src/place.c"
              if (can_raise_exn )
                FUNCCALL(SETUP_XfOrM129(_), scheme_rktio_error ("dynamic-place" , "port dup" ) ); 
              if (delayed_err ) {
                intptr_t tmp ; 
#               define XfOrM130_COUNT (0+XfOrM129_COUNT)
#               define SETUP_XfOrM130(x) SETUP_XfOrM129(x)

# 1217 "./../src/place.c"
                * delayed_err = "port dup" ; 
                tmp = (rktio_get_last_error (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
                * delayed_errno = tmp ; 
                tmp = (rktio_get_last_error_kind (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) ) ) ; 
                * delayed_errkind = tmp ; 
              }
              if (invalid_object )

# 1223 "./../src/place.c"
              * invalid_object = so ; 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
            dupfdt = (rktio_fd_detach (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , dupfd ) ) ; 
            FUNCCALL(SETUP_XfOrM128(_), push_duped_fd (fd_accumulators , 0 , dupfdt ) ); 
            sffd -> fdt = dupfdt ; 
            sffd -> type = so -> type ; 
            new_so = (Scheme_Object * ) sffd ; 
          }
        }
        else {
#         define XfOrM126_COUNT (0+XfOrM125_COUNT)
#         define SETUP_XfOrM126(x) SETUP_XfOrM125(x)
          FUNCCALL(SETUP_XfOrM126(_), bad_place_message2 (so , * fd_accumulators , can_raise_exn , 0 , 0 , 0 ) )
# 1234 "./../src/place.c"
          ; 
          if (invalid_object )

# 1235 "./../src/place.c"
          * invalid_object = so ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }
      else {
#       define XfOrM124_COUNT (0+XfOrM123_COUNT)
#       define SETUP_XfOrM124(x) SETUP_XfOrM123(x)
        FUNCCALL(SETUP_XfOrM124(_), bad_place_message2 (so , * fd_accumulators , can_raise_exn , 0 , 0 , 0 ) )
# 1240 "./../src/place.c"
        ; 
        if (invalid_object )

# 1241 "./../src/place.c"
        * invalid_object = so ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
    }
    break ; 
    case scheme_serialized_tcp_fd_type : 
    {
#     define XfOrM117_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM117(x) SETUP_XfOrM110(x)

# 1248 "./../src/place.c"
      if ((mode == 2 ) || (mode == 3 ) || (mode == 4 ) ) {
        Scheme_Object * in ; 
        Scheme_Object * out ; 
        Scheme_Object * name ; 
        int type = ((Scheme_Serialized_Socket_FD * ) so ) -> type ; 
        rktio_fd_transfer_t * fdt = ((Scheme_Serialized_Socket_FD * ) so ) -> fdt ; 
        rktio_fd_t * fd ; 
        BLOCK_SETUP((PUSH(in, 0+XfOrM117_COUNT), PUSH(name, 1+XfOrM117_COUNT), PUSH(fdt, 2+XfOrM117_COUNT), PUSH(fd, 3+XfOrM117_COUNT), PUSH(out, 4+XfOrM117_COUNT)));
#       define XfOrM120_COUNT (5+XfOrM117_COUNT)
#       define SETUP_XfOrM120(x) SETUP(XfOrM120_COUNT)
        in = NULLED_OUT ; 
        out = NULLED_OUT ; 
        name = NULLED_OUT ; 
        fd = NULLED_OUT ; 

# 1256 "./../src/place.c"
        name = ((Scheme_Serialized_Socket_FD * ) so ) -> name ; 
        name = FUNCCALL(SETUP_XfOrM120(_), shallow_types_copy (name , ((void * ) 0 ) , fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )
        ; 
        fd = (rktio_fd_attach (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , fdt ) ) ; 


        if (type == scheme_input_port_type ) {
#         define XfOrM122_COUNT (0+XfOrM120_COUNT)
#         define SETUP_XfOrM122(x) SETUP_XfOrM120(x)
          FUNCCALL(SETUP_XfOrM122(_), scheme_rktio_socket_to_input_port (fd , name , 1 , & in ) )
# 1263 "./../src/place.c"
          ; 

          new_so = in ; 
        }
        else {
#         define XfOrM121_COUNT (0+XfOrM120_COUNT)
#         define SETUP_XfOrM121(x) SETUP_XfOrM120(x)
          FUNCCALL(SETUP_XfOrM121(_), scheme_rktio_socket_to_output_port (fd , name , 1 , & out ) )
# 1268 "./../src/place.c"
          ; 

          new_so = out ; 
        }
      }

# 1272 "./../src/place.c"
      else if (mode == 5 ) {
        rktio_fd_transfer_t * fdt = ((Scheme_Serialized_Socket_FD * ) so ) -> fdt ; 
#       define XfOrM119_COUNT (0+XfOrM117_COUNT)
#       define SETUP_XfOrM119(x) SETUP_XfOrM117(x)
        (
# 1274 "./../src/place.c"
        rktio_fd_close_transfer (fdt ) ) ; 
      }

# 1275 "./../src/place.c"
      else {
#       define XfOrM118_COUNT (0+XfOrM117_COUNT)
#       define SETUP_XfOrM118(x) SETUP_XfOrM117(x)
        FUNCCALL(SETUP_XfOrM118(_), scheme_log_abort ("encountered serialized TCP socket in bad mode" ) )
# 1276 "./../src/place.c"
        ; 
        FUNCCALL(SETUP_XfOrM118(_), abort () ); 
      }
    }
    break ; 
    case scheme_serialized_file_fd_type : 
    {
#     define XfOrM111_COUNT (0+XfOrM110_COUNT)
#     define SETUP_XfOrM111(x) SETUP_XfOrM110(x)

# 1283 "./../src/place.c"
      if ((mode == 2 ) || (mode == 3 ) || (mode == 4 ) ) {
        Scheme_Serialized_File_FD * ffd ; 
        Scheme_Object * name ; 
        rktio_fd_t * fd ; 
        int type ; 
        BLOCK_SETUP((PUSH(name, 0+XfOrM111_COUNT), PUSH(fd, 1+XfOrM111_COUNT)));
#       define XfOrM114_COUNT (2+XfOrM111_COUNT)
#       define SETUP_XfOrM114(x) SETUP(XfOrM114_COUNT)
        ffd = NULLED_OUT ; 
        name = NULLED_OUT ; 
        fd = NULLED_OUT ; 

# 1289 "./../src/place.c"
        ffd = (Scheme_Serialized_File_FD * ) so ; 
        fd = (rktio_fd_attach (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) , ffd -> fdt ) ) ; 
        name = ffd -> name ; 
        type = ffd -> type ; 

        name = FUNCCALL(SETUP_XfOrM114(_), shallow_types_copy (name , ((void * ) 0 ) , fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )
        ; 

        if (type == scheme_input_port_type ) {
#         define XfOrM116_COUNT (0+XfOrM114_COUNT)
#         define SETUP_XfOrM116(x) SETUP_XfOrM114(x)

# 1298 "./../src/place.c"
          new_so = FUNCCALL(SETUP_XfOrM116(_), scheme_make_rktio_fd_input_port (fd , name ) ); 
        }
        else {
#         define XfOrM115_COUNT (0+XfOrM114_COUNT)
#         define SETUP_XfOrM115(x) SETUP_XfOrM114(x)

# 1301 "./../src/place.c"
          new_so = FUNCCALL(SETUP_XfOrM115(_), scheme_make_rktio_fd_output_port (fd , name , 0 ) ); 
        }
      }

# 1303 "./../src/place.c"
      else if (mode == 5 ) {
        Scheme_Serialized_File_FD * sffd ; 
#       define XfOrM113_COUNT (0+XfOrM111_COUNT)
#       define SETUP_XfOrM113(x) SETUP_XfOrM111(x)
        sffd = NULLED_OUT ; 

# 1305 "./../src/place.c"
        sffd = (Scheme_Serialized_File_FD * ) so ; 
        (rktio_fd_close_transfer (sffd -> fdt ) ) ; 
      }

# 1307 "./../src/place.c"
      else {
#       define XfOrM112_COUNT (0+XfOrM111_COUNT)
#       define SETUP_XfOrM112(x) SETUP_XfOrM111(x)
        FUNCCALL(SETUP_XfOrM112(_), scheme_log_abort ("encountered serialized fd in bad mode" ) )
# 1308 "./../src/place.c"
        ; 
        FUNCCALL(SETUP_XfOrM112(_), abort () ); 
      }
    }
    break ; 
    default : 
    new_so = ((void * ) 0 ) ; 
    break ; 
  }
  if (ht && new_so ) {
#   define XfOrM109_COUNT (0+XfOrM108_COUNT)
#   define SETUP_XfOrM109(x) SETUP_XfOrM108(x)
    FUNCCALL(SETUP_XfOrM109(_), scheme_hash_set (ht , so , new_so ) )
# 1318 "./../src/place.c"
    ; 
  }
  RET_VALUE_START (new_so ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}


static Scheme_Object * create_infinite_stack (int gcable ) {
  Scheme_Object * * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM170_COUNT (1)
# define SETUP_XfOrM170(x) SETUP(XfOrM170_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 1331 "./../src/place.c"
  if (gcable ) {
#   define XfOrM172_COUNT (0+XfOrM170_COUNT)
#   define SETUP_XfOrM172(x) SETUP_XfOrM170(x)

    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> reusable_ifs_stack_ ) ) {
      v = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> reusable_ifs_stack_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> reusable_ifs_stack_ ) = ((void * ) 0 ) ; 
    }

# 1338 "./../src/place.c"
    else {
#     define XfOrM173_COUNT (0+XfOrM172_COUNT)
#     define SETUP_XfOrM173(x) SETUP_XfOrM172(x)

# 1339 "./../src/place.c"
      v = FUNCCALL(SETUP_XfOrM173(_), GC_malloc (512 * sizeof (Scheme_Object * ) ) ); 
    }
  }

# 1341 "./../src/place.c"
  else {
    v = malloc (512 * sizeof (Scheme_Object * ) ) ; 
    v [0 ] = ((void * ) 0 ) ; 
    v [(512 - 1 ) ] = ((void * ) 0 ) ; 
  }

  RET_VALUE_START ((Scheme_Object * ) v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1349 "./../src/place.c"
static void free_infinite_stack (Scheme_Object * * st , intptr_t max_depth , int gcable ) {
  Scheme_Object * * prev ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(st, 0), PUSH(prev, 1)));
# define XfOrM175_COUNT (2)
# define SETUP_XfOrM175(x) SETUP(XfOrM175_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  prev = NULLED_OUT ; 

# 1351 "./../src/place.c"
  if (st [(512 - 1 ) ] ) {
#   define XfOrM178_COUNT (0+XfOrM175_COUNT)
#   define SETUP_XfOrM178(x) SETUP_XfOrM175(x)

# 1352 "./../src/place.c"
    if (! gcable )
      FUNCCALL(SETUP_XfOrM178(_), free (st [(512 - 1 ) ] ) )
# 1352 "./../src/place.c"
    ; 
    st [(512 - 1 ) ] = ((void * ) 0 ) ; 
  }
  prev = (Scheme_Object * * ) st [0 ] ; 
  if (prev ) {
    prev [(512 - 1 ) ] = ((void * ) 0 ) ; 
  }
  if (! gcable )
    FUNCCALL(SETUP_XfOrM175(_), free (st ) )
# 1359 "./../src/place.c"
  ; 
  else if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> reusable_ifs_stack_ ) && (max_depth >= 0 ) ) {
#   define XfOrM176_COUNT (0+XfOrM175_COUNT)
#   define SETUP_XfOrM176(x) SETUP_XfOrM175(x)

# 1361 "./../src/place.c"
    if (max_depth > 512 )
      max_depth = 512 ; 
    (memset (st , 0 , max_depth * sizeof (Scheme_Object * ) ) ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> reusable_ifs_stack_ ) = st ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1368 "./../src/place.c"
void scheme_clear_place_ifs_stack () 
{
  /* No conversion */

# 1370 "./../src/place.c"
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> reusable_ifs_stack_ ) = ((void * ) 0 ) ; 
}

static inline void inf_push (Scheme_Object * * instack , Scheme_Object * item , uintptr_t * indepth , 
uintptr_t * maxdepth , int gcable ) {
  Scheme_Object * * stack = (Scheme_Object * * ) * instack ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(stack, 0), PUSH(maxdepth, 1), PUSH(item, 2), PUSH(indepth, 3), PUSH(instack, 4)));
# define XfOrM180_COUNT (5)
# define SETUP_XfOrM180(x) SETUP(XfOrM180_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1376 "./../src/place.c"
  if (* indepth == (512 - 1 ) ) {
#   define XfOrM181_COUNT (0+XfOrM180_COUNT)
#   define SETUP_XfOrM181(x) SETUP_XfOrM180(x)

# 1377 "./../src/place.c"
    if (stack [(512 - 1 ) ] ) {
      stack = (Scheme_Object * * ) stack [(512 - 1 ) ] ; 
    }
    else {
      Scheme_Object * tmp ; 
      BLOCK_SETUP((PUSH(tmp, 0+XfOrM181_COUNT)));
#     define XfOrM182_COUNT (1+XfOrM181_COUNT)
#     define SETUP_XfOrM182(x) SETUP(XfOrM182_COUNT)
      tmp = NULLED_OUT ; 

# 1382 "./../src/place.c"
      tmp = FUNCCALL(SETUP_XfOrM182(_), create_infinite_stack (gcable ) ); 
      stack [(512 - 1 ) ] = tmp ; 
      stack = (Scheme_Object * * ) stack [(512 - 1 ) ] ; 
      stack [0 ] = (Scheme_Object * ) (* instack ) ; 
    }
    * instack = (Scheme_Object * ) stack ; 
    * indepth = 1 ; 
  }


  stack [((* indepth ) ++ ) ] = item ; 
  if (* indepth > * maxdepth )
    * maxdepth = * indepth ; 
  RET_NOTHING ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1398 "./../src/place.c"
static inline Scheme_Object * inf_pop (Scheme_Object * * instack , uintptr_t * indepth , int gcable ) {
  Scheme_Object * * stack = (Scheme_Object * * ) * instack ; 
  Scheme_Object * val ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(stack, 0), PUSH(indepth, 1), PUSH(val, 2), PUSH(instack, 3)));
# define XfOrM184_COUNT (4)
# define SETUP_XfOrM184(x) SETUP(XfOrM184_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  val = NULLED_OUT ; 

# 1401 "./../src/place.c"
  if (* indepth == 1 ) {
#   define XfOrM185_COUNT (0+XfOrM184_COUNT)
#   define SETUP_XfOrM185(x) SETUP_XfOrM184(x)

# 1402 "./../src/place.c"
    if (stack [(512 - 1 ) ] ) {
#     define XfOrM188_COUNT (0+XfOrM185_COUNT)
#     define SETUP_XfOrM188(x) SETUP_XfOrM185(x)
      FUNCCALL(SETUP_XfOrM188(_), free_infinite_stack ((Scheme_Object * * ) stack [(512 - 1 ) ] , - 1 , gcable ) )
# 1403 "./../src/place.c"
      ; 
      stack [(512 - 1 ) ] = ((void * ) 0 ) ; 
    }
    if (stack [0 ] ) {
      stack = (Scheme_Object * * ) stack [0 ] ; 
      stack [(512 - 1 ) ] = (Scheme_Object * ) (* instack ) ; 
      * instack = (Scheme_Object * ) stack ; 
      * indepth = (512 - 1 ) ; 
    }
    else {
#     define XfOrM186_COUNT (0+XfOrM185_COUNT)
#     define SETUP_XfOrM186(x) SETUP_XfOrM185(x)
      (
# 1413 "./../src/place.c"
      printf ("pop beyond start of inf stack\n" ) ) ; 
      FUNCCALL(SETUP_XfOrM186(_), abort () ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  val = stack [-- (* indepth ) ] ; 

  stack [* indepth ] = ((void * ) 0 ) ; 
  RET_VALUE_START (val ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1425 "./../src/place.c"
static inline Scheme_Object * inf_set (Scheme_Object * * instack , int pos , Scheme_Object * item , uintptr_t * indepth ) {
  Scheme_Object * * stack = (Scheme_Object * * ) * instack ; 
  Scheme_Object * old ; 
  int realpos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(stack, 0), PUSH(item, 1), PUSH(indepth, 2), PUSH(old, 3)));
# define XfOrM189_COUNT (4)
# define SETUP_XfOrM189(x) SETUP(XfOrM189_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  old = NULLED_OUT ; 

# 1429 "./../src/place.c"
  if (* indepth <= pos + 1 ) {
#   define XfOrM191_COUNT (0+XfOrM189_COUNT)
#   define SETUP_XfOrM191(x) SETUP_XfOrM189(x)

# 1430 "./../src/place.c"
    if (stack [0 ] ) {
      stack = (Scheme_Object * * ) stack [0 ] ; 
      realpos = ((512 - 1 ) - (pos + 2 ) ) + * indepth ; 
    }
    else {
#     define XfOrM192_COUNT (0+XfOrM191_COUNT)
#     define SETUP_XfOrM192(x) SETUP_XfOrM191(x)
      (
# 1435 "./../src/place.c"
      printf ("set beyond start of inf stack\n" ) ) ; 
      FUNCCALL(SETUP_XfOrM192(_), abort () ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }
  else {

# 1440 "./../src/place.c"
    realpos = * indepth - 1 - pos ; 
  }

  old = stack [realpos ] ; 
  stack [realpos ] = item ; 
  RET_VALUE_START (old ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1448 "./../src/place.c"
static inline Scheme_Object * inf_get (Scheme_Object * * instack , int pos , uintptr_t * indepth ) {
  Scheme_Object * * stack = (Scheme_Object * * ) * instack ; 
  Scheme_Object * item ; 
  int realpos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(stack, 0), PUSH(item, 1), PUSH(indepth, 2)));
# define XfOrM194_COUNT (3)
# define SETUP_XfOrM194(x) SETUP(XfOrM194_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  item = NULLED_OUT ; 

# 1452 "./../src/place.c"
  if (* indepth <= pos + 1 ) {
#   define XfOrM196_COUNT (0+XfOrM194_COUNT)
#   define SETUP_XfOrM196(x) SETUP_XfOrM194(x)

# 1453 "./../src/place.c"
    if (stack [0 ] ) {
      stack = (Scheme_Object * * ) stack [0 ] ; 
      realpos = ((512 - 1 ) - (pos + 2 ) ) + * indepth ; 
    }
    else {
#     define XfOrM197_COUNT (0+XfOrM196_COUNT)
#     define SETUP_XfOrM197(x) SETUP_XfOrM196(x)
      (
# 1458 "./../src/place.c"
      printf ("get beyond start of inf stack\n" ) ) ; 
      FUNCCALL(SETUP_XfOrM197(_), abort () ); 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }
  else {

# 1463 "./../src/place.c"
    realpos = * indepth - 1 - pos ; 
  }
  item = stack [realpos ] ; 


  RET_VALUE_START (item ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * places_deep_copy_worker (Scheme_Object * so , Scheme_Hash_Table * * ht , 
int mode , int gcable , int can_raise_exn , 
Scheme_Object * * master_chain , 
Scheme_Object * * invalid_object , 
char * * delayed_err , intptr_t * delayed_errno , intptr_t * delayed_errkind ) {
  Scheme_Object * inf_stack = ((void * ) 0 ) ; 
  Scheme_Object * reg0 = ((void * ) 0 ) ; 
  uintptr_t inf_stack_depth = 0 , inf_max_depth = 0 ; 

  Scheme_Object * fd_accumulators = ((void * ) 0 ) ; 

  int set_mode = ((mode == 1 ) 
  || (mode == 2 ) || (mode == 3 ) 
  || (mode == 4 ) ) ; 


  Scheme_Object * pair ; 
  Scheme_Object * vec ; 
  Scheme_Object * nht ; 
  Scheme_Object * hti ; 
  Scheme_Object * htk ; 
  intptr_t i ; 
  intptr_t size ; 
  Scheme_Structure * st ; 
  Scheme_Serialized_Structure * sst ; 
  Scheme_Struct_Type * stype ; 

# 1524 "./../src/place.c"
  Scheme_Object * new_so = so ; 
  int ctr = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(22);
  BLOCK_SETUP_TOP((PUSH(pair, 0), PUSH(master_chain, 1), PUSH(stype, 2), PUSH(sst, 3), PUSH(reg0, 4), PUSH(invalid_object, 5), PUSH(st, 6), PUSH(nht, 7), PUSH(delayed_err, 8), PUSH(delayed_errkind, 9), PUSH(so, 10), PUSH(new_so, 11), PUSH(hti, 12), PUSH(fd_accumulators, 13), PUSH(inf_stack, 14), PUSH(delayed_errno, 15), PUSH(vec, 16), PUSH(htk, 17), PUSH(ht, 18)));
# define XfOrM199_COUNT (19)
# define SETUP_XfOrM199(x) SETUP(XfOrM199_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  pair = NULLED_OUT ; 
  vec = NULLED_OUT ; 
  nht = NULLED_OUT ; 
  hti = NULLED_OUT ; 
  htk = NULLED_OUT ; 
  st = NULLED_OUT ; 
  sst = NULLED_OUT ; 
  stype = NULLED_OUT ; 

# 1528 "./../src/place.c"
  new_so = FUNCCALL(SETUP_XfOrM199(_), shallow_types_copy (so , * ht , & fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )
  ; 
  if (new_so )

# 1530 "./../src/place.c"
  RET_VALUE_START (new_so ) RET_VALUE_END ; 
  if (delayed_err && * delayed_err ) {
#   define XfOrM315_COUNT (0+XfOrM199_COUNT)
#   define SETUP_XfOrM315(x) SETUP_XfOrM199(x)
    FUNCCALL(SETUP_XfOrM315(_), bad_place_message2 (so , fd_accumulators , can_raise_exn , * delayed_err , * delayed_errkind , * delayed_errno ) )
# 1532 "./../src/place.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (* ht ) {
    Scheme_Object * r ; 
    BLOCK_SETUP((PUSH(r, 0+XfOrM199_COUNT)));
#   define XfOrM313_COUNT (1+XfOrM199_COUNT)
#   define SETUP_XfOrM313(x) SETUP(XfOrM313_COUNT)
    r = NULLED_OUT ; 

# 1538 "./../src/place.c"
    if ((r = FUNCCALL(SETUP_XfOrM313(_), scheme_hash_get (* ht , so ) )) ) {
      RET_VALUE_START (r ) RET_VALUE_END ; 
    }
  }

  if (! * ht ) {
    Scheme_Hash_Table * _ht ; 
    BLOCK_SETUP((PUSH(_ht, 0+XfOrM199_COUNT)));
#   define XfOrM312_COUNT (1+XfOrM199_COUNT)
#   define SETUP_XfOrM312(x) SETUP(XfOrM312_COUNT)
    _ht = NULLED_OUT ; 

# 1545 "./../src/place.c"
    _ht = FUNCCALL(SETUP_XfOrM312(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
    * ht = _ht ; 
  }

  inf_stack = FUNCCALL(SETUP_XfOrM199(_), create_infinite_stack (gcable ) ); 
  inf_stack_depth = 1 ; 
  inf_max_depth = 1 ; 
  FUNCCALL(SETUP_XfOrM199(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (11 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
  ; 
  reg0 = so ; 

  DEEP_DO : 
  ctr ++ ; 

  so = (reg0 ) ; 
  new_so = FUNCCALL(SETUP_XfOrM199(_), trivial_copy (so , master_chain ) ); 
  if (new_so )

# 1561 "./../src/place.c"
  do {

# 1561 "./../src/place.c"
    goto DEEP_RETURN_L ; 
  }

# 1561 "./../src/place.c"
  while (0 ) ; 

# 1561 "./../src/place.c"
  ; 

  if (* ht ) {
#   define XfOrM306_COUNT (0+XfOrM199_COUNT)
#   define SETUP_XfOrM306(x) SETUP_XfOrM199(x)

# 1564 "./../src/place.c"
    if ((new_so = FUNCCALL(SETUP_XfOrM306(_), scheme_hash_get (* ht , so ) )) ) {
      reg0 = new_so ; 
      do {

# 1566 "./../src/place.c"
        goto DEEP_RETURN_L ; 
      }

# 1566 "./../src/place.c"
      while (0 ) ; 

# 1566 "./../src/place.c"
      ; 
    }
  }

  new_so = FUNCCALL(SETUP_XfOrM199(_), shallow_types_copy (so , * ht , & fd_accumulators , delayed_err , delayed_errno , delayed_errkind , mode , can_raise_exn , master_chain , invalid_object ) )
  ; 
  if (new_so )

# 1572 "./../src/place.c"
  do {

# 1572 "./../src/place.c"
    goto DEEP_RETURN_L ; 
  }

# 1572 "./../src/place.c"
  while (0 ) ; 

# 1572 "./../src/place.c"
  ; 
  if (delayed_err && * delayed_err ) {
#   define XfOrM301_COUNT (0+XfOrM199_COUNT)
#   define SETUP_XfOrM301(x) SETUP_XfOrM199(x)
    FUNCCALL(SETUP_XfOrM301(_), bad_place_message2 (so , fd_accumulators , can_raise_exn , * delayed_err , * delayed_errkind , * delayed_errno ) )
# 1574 "./../src/place.c"
    ; 
    do {

# 1575 "./../src/place.c"
      goto DEEP_DONE_L ; 
    }

# 1575 "./../src/place.c"
    while (0 ) ; 

# 1575 "./../src/place.c"
    ; 
  }

  if (gcable && (mode == 2 ) ) 
  {
#   define XfOrM299_COUNT (0+XfOrM199_COUNT)
#   define SETUP_XfOrM299(x) SETUP_XfOrM199(x)

# 1579 "./../src/place.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM300_COUNT (0+XfOrM299_COUNT)
#     define SETUP_XfOrM300(x) SETUP_XfOrM299(x)
      FUNCCALL(SETUP_XfOrM300(_), scheme_out_of_fuel () )
# 1579 "./../src/place.c"
      ; 
    }
  }

# 1579 "./../src/place.c"
  ; 

  switch (((((intptr_t ) (so ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (so ) ) -> type ) ) {
#   define XfOrM202_COUNT (0+XfOrM199_COUNT)
#   define SETUP_XfOrM202(x) SETUP_XfOrM199(x)

# 1583 "./../src/place.c"
    case scheme_pair_type : 

    if ((mode == 1 ) || (mode == 2 ) || (mode == 3 ) ) {
#     define XfOrM298_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM298(x) SETUP_XfOrM202(x)

# 1586 "./../src/place.c"
      pair = FUNCCALL(SETUP_XfOrM298(_), scheme_make_pair (scheme_false , scheme_false ) ); 
      ((& ((Scheme_Simple_Object * ) (pair ) ) -> iso ) -> so . keyex |= ((& ((Scheme_Simple_Object * ) (so ) ) -> iso ) -> so . keyex & 0x3 ) ) ; 
    }

# 1588 "./../src/place.c"
    else 
    pair = so ; 
    FUNCCALL(SETUP_XfOrM202(_), scheme_hash_set (* ht , so , pair ) ); 
    FUNCCALL_AGAIN(inf_push (& inf_stack , so , & inf_stack_depth , & inf_max_depth , gcable ) )
    ; 
    FUNCCALL_AGAIN(inf_push (& inf_stack , pair , & inf_stack_depth , & inf_max_depth , gcable ) ); 
    reg0 = (((Scheme_Simple_Object * ) (so ) ) -> u . pair_val . car ) ; 
    do {
#     define XfOrM297_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM297(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM297(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1595 "./../src/place.c"
      ; 

# 1595 "./../src/place.c"
      goto DEEP_DO ; 
    }

# 1595 "./../src/place.c"
    while (0 ) ; 

# 1595 "./../src/place.c"
    ; 

    DEEP_DO_CDR_L : 
    pair = FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (0 ) , & inf_stack_depth ) ); 
    so = FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (1 ) , & inf_stack_depth ) ); 
    if (set_mode ) {
      (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) = (reg0 ) ; 
    }
    reg0 = (((Scheme_Simple_Object * ) (so ) ) -> u . pair_val . cdr ) ; 
    do {
#     define XfOrM294_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM294(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM294(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (2 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1604 "./../src/place.c"
      ; 

# 1604 "./../src/place.c"
      goto DEEP_DO ; 
    }

# 1604 "./../src/place.c"
    while (0 ) ; 

# 1604 "./../src/place.c"
    ; 

    DEEP_DO_FIN_PAIR_L : 
    pair = FUNCCALL(SETUP_XfOrM202(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) ); 
    so = FUNCCALL(SETUP_XfOrM202(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) ); 
    if (set_mode ) {
      (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) = (reg0 ) ; 
      new_so = pair ; 
    }
    do {

# 1613 "./../src/place.c"
      goto DEEP_RETURN_L ; 
    }

# 1613 "./../src/place.c"
    while (0 ) ; 

# 1613 "./../src/place.c"
    ; 
    break ; 


    case scheme_vector_type : 
    size = (((Scheme_Vector * ) (so ) ) -> size ) ; 

    if ((mode == 1 ) || (mode == 2 ) || (mode == 3 ) )
      vec = FUNCCALL(SETUP_XfOrM202(_), scheme_make_vector (size , 0 ) ); 
    else 
    vec = so ; 
    FUNCCALL(SETUP_XfOrM202(_), scheme_hash_set (* ht , so , vec ) )

    ; 
    i = 0 ; 
    FUNCCALL(SETUP_XfOrM202(_), inf_push (& inf_stack , vec , & inf_stack_depth , & inf_max_depth , gcable ) )
    ; 
    FUNCCALL_AGAIN(inf_push (& inf_stack , so , & inf_stack_depth , & inf_max_depth , gcable ) ); 
    FUNCCALL_AGAIN(inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (size ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) ); 
    FUNCCALL_AGAIN(inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) ); 

    if (i < size ) {
#     define XfOrM287_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM287(x) SETUP_XfOrM202(x)

# 1635 "./../src/place.c"
      reg0 = (((Scheme_Vector * ) (so ) ) -> els ) [i ] ; 
      do {
#       define XfOrM289_COUNT (0+XfOrM287_COUNT)
#       define SETUP_XfOrM289(x) SETUP_XfOrM287(x)
        FUNCCALL(SETUP_XfOrM289(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (3 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1636 "./../src/place.c"
        ; 

# 1636 "./../src/place.c"
        goto DEEP_DO ; 
      }

# 1636 "./../src/place.c"
      while (0 ) ; 

# 1636 "./../src/place.c"
      ; 
    }
    else {
      goto DEEP_VEC2 ; 
    }

    DEEP_VEC1_L : 

    i = (((intptr_t ) (FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (0 ) , & inf_stack_depth ) )) ) >> 1 ) ; 
    size = (((intptr_t ) (FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (1 ) , & inf_stack_depth ) )) ) >> 1 ) ; 
    so = FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (2 ) , & inf_stack_depth ) ); 
    vec = FUNCCALL_AGAIN(inf_get (& inf_stack , (3 ) , & inf_stack_depth ) ); 
    if (set_mode ) {
      (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = (reg0 ) ; 
    }
    i ++ ; 
    if (i < size ) {
#     define XfOrM282_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM282(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM282(_), inf_set (& inf_stack , (0 ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth ) )
# 1653 "./../src/place.c"
      ; 
      reg0 = (((Scheme_Vector * ) (so ) ) -> els ) [i ] ; 
      do {
#       define XfOrM284_COUNT (0+XfOrM282_COUNT)
#       define SETUP_XfOrM284(x) SETUP_XfOrM282(x)
        FUNCCALL(SETUP_XfOrM284(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (3 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1655 "./../src/place.c"
        ; 

# 1655 "./../src/place.c"
        goto DEEP_DO ; 
      }

# 1655 "./../src/place.c"
      while (0 ) ; 

# 1655 "./../src/place.c"
      ; 
    }
    else {
      goto DEEP_VEC2 ; 
    }

    DEEP_VEC2 : 
    i = (((intptr_t ) (FUNCCALL(SETUP_XfOrM202(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) )) ) >> 1 ) ; 
    size = (((intptr_t ) (FUNCCALL(SETUP_XfOrM202(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) )) ) >> 1 ) ; 
    so = FUNCCALL(SETUP_XfOrM202(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) ); 
    vec = FUNCCALL_AGAIN(inf_pop (& inf_stack , & inf_stack_depth , gcable ) ); 

    if (set_mode ) {
      ((((Scheme_Inclhash_Object * ) (vec ) ) -> so . keyex |= 0x1 ) ) ; 
      new_so = vec ; 
    }

# 1670 "./../src/place.c"
    else 
    new_so = vec ; 
    do {

# 1672 "./../src/place.c"
      goto DEEP_RETURN_L ; 
    }

# 1672 "./../src/place.c"
    while (0 ) ; 

# 1672 "./../src/place.c"
    ; 
    break ; 


    case scheme_structure_type : 
    st = (Scheme_Structure * ) so ; 
    stype = st -> stype ; 
    size = stype -> num_slots ; 

    if (! stype -> prefab_key ) {
#     define XfOrM275_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM275(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM275(_), bad_place_message2 (so , fd_accumulators , can_raise_exn , 0 , 0 , 0 ) )
# 1682 "./../src/place.c"
      ; 
      if (invalid_object )

# 1683 "./../src/place.c"
      * invalid_object = so ; 
      new_so = ((void * ) 0 ) ; 
      do {

# 1685 "./../src/place.c"
        goto DEEP_DONE_L ; 
      }

# 1685 "./../src/place.c"
      while (0 ) ; 

# 1685 "./../src/place.c"
      ; 
    }
    if (! ((& stype -> iso ) -> so . keyex & 0x1 ) ) {
#     define XfOrM272_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM272(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM272(_), bad_place_message2 (so , fd_accumulators , can_raise_exn , 0 , 0 , 0 ) )
# 1688 "./../src/place.c"
      ; 
      if (invalid_object )

# 1689 "./../src/place.c"
      * invalid_object = so ; 
      new_so = ((void * ) 0 ) ; 
      do {

# 1691 "./../src/place.c"
        goto DEEP_DONE_L ; 
      }

# 1691 "./../src/place.c"
      while (0 ) ; 

# 1691 "./../src/place.c"
      ; 
    }
    FUNCCALL(SETUP_XfOrM202(_), inf_push (& inf_stack , (Scheme_Object * ) st , & inf_stack_depth , & inf_max_depth , gcable ) )
    ; 
    reg0 = (((Scheme_Simple_Object * ) (stype -> prefab_key ) ) -> u . pair_val . cdr ) ; 
    do {
#     define XfOrM271_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM271(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM271(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (4 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1696 "./../src/place.c"
      ; 

# 1696 "./../src/place.c"
      goto DEEP_DO ; 
    }

# 1696 "./../src/place.c"
    while (0 ) ; 

# 1696 "./../src/place.c"
    ; 

    DEEP_ST1_L : 
    st = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (0 ) , & inf_stack_depth ) ); 
    so = (Scheme_Object * ) st ; 
    size = st -> stype -> num_slots ; 
    if (mode == 1 ) {
#     define XfOrM269_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM269(x) SETUP_XfOrM202(x)

# 1703 "./../src/place.c"
      new_so = FUNCCALL(SETUP_XfOrM269(_), scheme_make_serialized_struct_instance ((reg0 ) , size ) ); 
      sst = (Scheme_Serialized_Structure * ) new_so ; 
    }

# 1705 "./../src/place.c"
    else if (mode == 0 ) {
      sst = ((void * ) 0 ) ; 
    }

# 1707 "./../src/place.c"
    else {
#     define XfOrM267_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM267(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM267(_), scheme_log_abort ("encountered structure in bad mode" ) )
# 1708 "./../src/place.c"
      ; 
      FUNCCALL(SETUP_XfOrM267(_), abort () ); 
    }
    FUNCCALL(SETUP_XfOrM202(_), scheme_hash_set (* ht , so , new_so ) )

    ; 

    i = 0 ; 
    if (i < size ) {
#     define XfOrM264_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM264(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM264(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (size ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1717 "./../src/place.c"
      ; 
      FUNCCALL(SETUP_XfOrM264(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) ); 
      FUNCCALL_AGAIN(inf_push (& inf_stack , (Scheme_Object * ) sst , & inf_stack_depth , & inf_max_depth , gcable ) ); 
      reg0 = st -> slots [i ] ; 
      do {
#       define XfOrM266_COUNT (0+XfOrM264_COUNT)
#       define SETUP_XfOrM266(x) SETUP_XfOrM264(x)
        FUNCCALL(SETUP_XfOrM266(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (5 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1721 "./../src/place.c"
        ; 

# 1721 "./../src/place.c"
        goto DEEP_DO ; 
      }

# 1721 "./../src/place.c"
      while (0 ) ; 

# 1721 "./../src/place.c"
      ; 
    }
    else {
#     define XfOrM261_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM261(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM261(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) )
# 1724 "./../src/place.c"
      ; 
      do {

# 1725 "./../src/place.c"
        goto DEEP_RETURN_L ; 
      }

# 1725 "./../src/place.c"
      while (0 ) ; 

# 1725 "./../src/place.c"
      ; 
    }

    DEEP_ST2_L : 
    i = (((intptr_t ) (FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (1 ) , & inf_stack_depth ) )) ) >> 1 ) ; 
    size = (((intptr_t ) (FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (2 ) , & inf_stack_depth ) )) ) >> 1 ) ; 
    st = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (3 ) , & inf_stack_depth ) ); 
    so = (Scheme_Object * ) st ; 
    if (mode == 1 ) {
#     define XfOrM260_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM260(x) SETUP_XfOrM202(x)

# 1734 "./../src/place.c"
      sst = (Scheme_Serialized_Structure * ) FUNCCALL(SETUP_XfOrM260(_), inf_get (& inf_stack , (0 ) , & inf_stack_depth ) ); 
      sst -> slots [i ] = (reg0 ) ; 
    }
    i ++ ; 
    if (i < size ) {
#     define XfOrM257_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM257(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM257(_), inf_set (& inf_stack , (1 ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth ) )
# 1739 "./../src/place.c"
      ; 
      reg0 = st -> slots [i ] ; 
      do {
#       define XfOrM259_COUNT (0+XfOrM257_COUNT)
#       define SETUP_XfOrM259(x) SETUP_XfOrM257(x)
        FUNCCALL(SETUP_XfOrM259(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (5 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1741 "./../src/place.c"
        ; 

# 1741 "./../src/place.c"
        goto DEEP_DO ; 
      }

# 1741 "./../src/place.c"
      while (0 ) ; 

# 1741 "./../src/place.c"
      ; 
    }
    else {
#     define XfOrM248_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM248(x) SETUP_XfOrM202(x)

# 1744 "./../src/place.c"
      if (mode == 1 )
        new_so = (Scheme_Object * ) sst ; 
      do {

# 1746 "./../src/place.c"
        int N = (4 ) ; 
#       define XfOrM254_COUNT (0+XfOrM248_COUNT)
#       define SETUP_XfOrM254(x) SETUP_XfOrM248(x)

# 1746 "./../src/place.c"
        while (N > 0 ) {
#         define XfOrM256_COUNT (0+XfOrM254_COUNT)
#         define SETUP_XfOrM256(x) SETUP_XfOrM254(x)
          FUNCCALL(SETUP_XfOrM256(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) )
# 1746 "./../src/place.c"
          ; 

# 1746 "./../src/place.c"
          N -- ; 
        }
      }

# 1746 "./../src/place.c"
      while (0 ) ; 

# 1746 "./../src/place.c"
      ; 
      do {

# 1747 "./../src/place.c"
        goto DEEP_RETURN_L ; 
      }

# 1747 "./../src/place.c"
      while (0 ) ; 

# 1747 "./../src/place.c"
      ; 
    }
    break ; 


    case scheme_serialized_structure_type : 
    sst = (Scheme_Serialized_Structure * ) so ; 
    FUNCCALL(SETUP_XfOrM202(_), inf_push (& inf_stack , (Scheme_Object * ) sst , & inf_stack_depth , & inf_max_depth , gcable ) )
    ; 
    reg0 = sst -> prefab_key ; 
    do {
#     define XfOrM247_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM247(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM247(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (6 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1757 "./../src/place.c"
      ; 

# 1757 "./../src/place.c"
      goto DEEP_DO ; 
    }

# 1757 "./../src/place.c"
    while (0 ) ; 

# 1757 "./../src/place.c"
    ; 

    DEEP_SST1_L : 
    sst = (Scheme_Serialized_Structure * ) FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (0 ) , & inf_stack_depth ) ); 
    so = (Scheme_Object * ) sst ; 
    size = sst -> num_slots ; 
    if ((mode == 2 ) || (mode == 4 ) ) {
#     define XfOrM245_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM245(x) SETUP_XfOrM202(x)

# 1764 "./../src/place.c"
      stype = FUNCCALL(SETUP_XfOrM245(_), scheme_lookup_prefab_type ((reg0 ) , size ) ); 
      new_so = FUNCCALL(SETUP_XfOrM245(_), scheme_make_blank_prefab_struct_instance (stype ) ); 

      st = (Scheme_Structure * ) new_so ; 
    }

# 1768 "./../src/place.c"
    else if (mode == 5 ) {
      st = ((void * ) 0 ) ; 
    }

# 1770 "./../src/place.c"
    else {
#     define XfOrM243_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM243(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM243(_), scheme_log_abort ("encountered serialized structure in bad mode" ) )
# 1771 "./../src/place.c"
      ; 
      FUNCCALL(SETUP_XfOrM243(_), abort () ); 
    }
    FUNCCALL(SETUP_XfOrM202(_), scheme_hash_set (* ht , so , new_so ) )

    ; 

    i = 0 ; 
    if (i < size ) {
#     define XfOrM240_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM240(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM240(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (size ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1780 "./../src/place.c"
      ; 
      FUNCCALL(SETUP_XfOrM240(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) ); 
      FUNCCALL_AGAIN(inf_push (& inf_stack , (Scheme_Object * ) st , & inf_stack_depth , & inf_max_depth , gcable ) ); 
      reg0 = sst -> slots [i ] ; 
      do {
#       define XfOrM242_COUNT (0+XfOrM240_COUNT)
#       define SETUP_XfOrM242(x) SETUP_XfOrM240(x)
        FUNCCALL(SETUP_XfOrM242(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (7 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1784 "./../src/place.c"
        ; 

# 1784 "./../src/place.c"
        goto DEEP_DO ; 
      }

# 1784 "./../src/place.c"
      while (0 ) ; 

# 1784 "./../src/place.c"
      ; 
    }
    else {
#     define XfOrM237_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM237(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM237(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) )
# 1787 "./../src/place.c"
      ; 
      do {

# 1788 "./../src/place.c"
        goto DEEP_RETURN_L ; 
      }

# 1788 "./../src/place.c"
      while (0 ) ; 

# 1788 "./../src/place.c"
      ; 
    }

    DEEP_SST2_L : 
    i = (((intptr_t ) (FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (1 ) , & inf_stack_depth ) )) ) >> 1 ) ; 
    size = (((intptr_t ) (FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (2 ) , & inf_stack_depth ) )) ) >> 1 ) ; 
    sst = (Scheme_Serialized_Structure * ) FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (3 ) , & inf_stack_depth ) ); 
    so = (Scheme_Object * ) sst ; 
    if ((mode == 2 ) || (mode == 4 ) ) {
#     define XfOrM236_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM236(x) SETUP_XfOrM202(x)

# 1797 "./../src/place.c"
      st = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM236(_), inf_get (& inf_stack , (0 ) , & inf_stack_depth ) ); 
      st -> slots [i ] = (reg0 ) ; 
    }
    i ++ ; 
    if (i < size ) {
#     define XfOrM233_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM233(x) SETUP_XfOrM202(x)
      FUNCCALL(SETUP_XfOrM233(_), inf_set (& inf_stack , (1 ) , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth ) )
# 1802 "./../src/place.c"
      ; 
      reg0 = sst -> slots [i ] ; 
      do {
#       define XfOrM235_COUNT (0+XfOrM233_COUNT)
#       define SETUP_XfOrM235(x) SETUP_XfOrM233(x)
        FUNCCALL(SETUP_XfOrM235(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (7 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1804 "./../src/place.c"
        ; 

# 1804 "./../src/place.c"
        goto DEEP_DO ; 
      }

# 1804 "./../src/place.c"
      while (0 ) ; 

# 1804 "./../src/place.c"
      ; 
    }
    else {
#     define XfOrM224_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM224(x) SETUP_XfOrM202(x)

# 1807 "./../src/place.c"
      new_so = (Scheme_Object * ) st ; 
      do {

# 1808 "./../src/place.c"
        int N = (4 ) ; 
#       define XfOrM230_COUNT (0+XfOrM224_COUNT)
#       define SETUP_XfOrM230(x) SETUP_XfOrM224(x)

# 1808 "./../src/place.c"
        while (N > 0 ) {
#         define XfOrM232_COUNT (0+XfOrM230_COUNT)
#         define SETUP_XfOrM232(x) SETUP_XfOrM230(x)
          FUNCCALL(SETUP_XfOrM232(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) )
# 1808 "./../src/place.c"
          ; 

# 1808 "./../src/place.c"
          N -- ; 
        }
      }

# 1808 "./../src/place.c"
      while (0 ) ; 

# 1808 "./../src/place.c"
      ; 
      do {

# 1809 "./../src/place.c"
        goto DEEP_RETURN_L ; 
      }

# 1809 "./../src/place.c"
      while (0 ) ; 

# 1809 "./../src/place.c"
      ; 
    }
    break ; 
    case scheme_hash_table_type : 
    case scheme_hash_tree_type : 
    case scheme_eq_hash_tree_type : 
    case scheme_eqv_hash_tree_type : 
    if (set_mode ) {
#     define XfOrM220_COUNT (0+XfOrM202_COUNT)
#     define SETUP_XfOrM220(x) SETUP_XfOrM202(x)

# 1817 "./../src/place.c"
      if (scheme_true == FUNCCALL(SETUP_XfOrM220(_), scheme_hash_eq_p (1 , & so ) )) {
#       define XfOrM223_COUNT (0+XfOrM220_COUNT)
#       define SETUP_XfOrM223(x) SETUP_XfOrM220(x)

# 1818 "./../src/place.c"
        nht = FUNCCALL(SETUP_XfOrM223(_), scheme_make_immutable_hasheq (0 , ((void * ) 0 ) ) ); 
      }
      else if (scheme_true == FUNCCALL(SETUP_XfOrM220(_), scheme_hash_eqv_p (1 , & so ) )) {
#       define XfOrM222_COUNT (0+XfOrM220_COUNT)
#       define SETUP_XfOrM222(x) SETUP_XfOrM220(x)

# 1821 "./../src/place.c"
        nht = FUNCCALL(SETUP_XfOrM222(_), scheme_make_immutable_hasheqv (0 , ((void * ) 0 ) ) ); 
      }
      else if (scheme_true == FUNCCALL(SETUP_XfOrM220(_), scheme_hash_equal_p (1 , & so ) )) {
#       define XfOrM221_COUNT (0+XfOrM220_COUNT)
#       define SETUP_XfOrM221(x) SETUP_XfOrM220(x)

# 1824 "./../src/place.c"
        nht = FUNCCALL(SETUP_XfOrM221(_), scheme_make_immutable_hash (0 , ((void * ) 0 ) ) ); 
      }
    }
    else 
    nht = so ; 
    FUNCCALL(SETUP_XfOrM202(_), scheme_hash_set (* ht , so , nht ) )

    ; 
    hti = FUNCCALL_AGAIN(scheme_hash_table_iterate_start (1 , & so ) ); 
    i = 0 ; 
    FUNCCALL(SETUP_XfOrM202(_), inf_push (& inf_stack , nht , & inf_stack_depth , & inf_max_depth , gcable ) )
    ; 
    FUNCCALL_AGAIN(inf_push (& inf_stack , so , & inf_stack_depth , & inf_max_depth , gcable ) ); 
    FUNCCALL_AGAIN(inf_push (& inf_stack , hti , & inf_stack_depth , & inf_max_depth , gcable ) ); 

    if (((intptr_t ) (hti ) ) & 0x1 )  {
      Scheme_Object * a [2 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM202_COUNT)));
#     define XfOrM217_COUNT (3+XfOrM202_COUNT)
#     define SETUP_XfOrM217(x) SETUP(XfOrM217_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 

# 1841 "./../src/place.c"
      a [0 ] = so ; 
      a [1 ] = hti ; 
      reg0 = FUNCCALL(SETUP_XfOrM217(_), scheme_hash_table_iterate_key (2 , a ) ); 
      do {
#       define XfOrM219_COUNT (0+XfOrM217_COUNT)
#       define SETUP_XfOrM219(x) SETUP_XfOrM217(x)
        FUNCCALL(SETUP_XfOrM219(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (8 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1844 "./../src/place.c"
        ; 

# 1844 "./../src/place.c"
        goto DEEP_DO ; 
      }

# 1844 "./../src/place.c"
      while (0 ) ; 

# 1844 "./../src/place.c"
      ; 
    }
    else {
      goto DEEP_HT3 ; 
    }

    DEEP_HT1_L : 

    hti = FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (0 ) , & inf_stack_depth ) ); 
    so = FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (1 ) , & inf_stack_depth ) ); 
    nht = FUNCCALL_AGAIN(inf_get (& inf_stack , (2 ) , & inf_stack_depth ) ); 
    FUNCCALL_AGAIN(inf_push (& inf_stack , (reg0 ) , & inf_stack_depth , & inf_max_depth , gcable ) ); 

    {
      Scheme_Object * a [2 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM202_COUNT)));
#     define XfOrM213_COUNT (3+XfOrM202_COUNT)
#     define SETUP_XfOrM213(x) SETUP(XfOrM213_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 

# 1859 "./../src/place.c"
      a [0 ] = so ; 
      a [1 ] = hti ; 
      reg0 = FUNCCALL(SETUP_XfOrM213(_), scheme_hash_table_iterate_value (2 , a ) ); 
      do {
#       define XfOrM215_COUNT (0+XfOrM213_COUNT)
#       define SETUP_XfOrM215(x) SETUP_XfOrM213(x)
        FUNCCALL(SETUP_XfOrM215(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (9 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1862 "./../src/place.c"
        ; 

# 1862 "./../src/place.c"
        goto DEEP_DO ; 
      }

# 1862 "./../src/place.c"
      while (0 ) ; 

# 1862 "./../src/place.c"
      ; 
    }

    DEEP_HT2_L : 
    htk = FUNCCALL(SETUP_XfOrM202(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) ); 
    hti = FUNCCALL(SETUP_XfOrM202(_), inf_get (& inf_stack , (0 ) , & inf_stack_depth ) ); 
    so = FUNCCALL_AGAIN(inf_get (& inf_stack , (1 ) , & inf_stack_depth ) ); 
    nht = FUNCCALL_AGAIN(inf_get (& inf_stack , (2 ) , & inf_stack_depth ) ); 

    if (set_mode ) {
      Scheme_Object * a [3 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 3, 0+XfOrM202_COUNT)));
#     define XfOrM212_COUNT (3+XfOrM202_COUNT)
#     define SETUP_XfOrM212(x) SETUP(XfOrM212_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      a[2] = NULLED_OUT ; 

# 1873 "./../src/place.c"
      a [0 ] = nht ; 
      a [1 ] = htk ; 
      a [2 ] = (reg0 ) ; 
      nht = FUNCCALL(SETUP_XfOrM212(_), scheme_hash_table_put (3 , a ) ); 
      FUNCCALL_AGAIN(inf_set (& inf_stack , (2 ) , nht , & inf_stack_depth ) ); 
    }
    {
      Scheme_Object * a [3 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 3, 0+XfOrM202_COUNT)));
#     define XfOrM211_COUNT (3+XfOrM202_COUNT)
#     define SETUP_XfOrM211(x) SETUP(XfOrM211_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      a[2] = NULLED_OUT ; 

# 1881 "./../src/place.c"
      a [0 ] = so ; 
      a [1 ] = hti ; 
      hti = FUNCCALL(SETUP_XfOrM211(_), scheme_hash_table_iterate_next (2 , a ) ); 
    }

    if (((intptr_t ) (hti ) ) & 0x1 )  {
      Scheme_Object * a [2 ] ; 
      BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM202_COUNT)));
#     define XfOrM208_COUNT (3+XfOrM202_COUNT)
#     define SETUP_XfOrM208(x) SETUP(XfOrM208_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM208(_), inf_set (& inf_stack , (0 ) , hti , & inf_stack_depth ) )
# 1888 "./../src/place.c"
      ; 
      a [0 ] = so ; 
      a [1 ] = hti ; 
      reg0 = FUNCCALL(SETUP_XfOrM208(_), scheme_hash_table_iterate_key (2 , a ) ); 
      do {
#       define XfOrM210_COUNT (0+XfOrM208_COUNT)
#       define SETUP_XfOrM210(x) SETUP_XfOrM208(x)
        FUNCCALL(SETUP_XfOrM210(_), inf_push (& inf_stack , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (8 ) ) ) << 1 ) | 0x1 ) ) , & inf_stack_depth , & inf_max_depth , gcable ) )
# 1892 "./../src/place.c"
        ; 

# 1892 "./../src/place.c"
        goto DEEP_DO ; 
      }

# 1892 "./../src/place.c"
      while (0 ) ; 

# 1892 "./../src/place.c"
      ; 
    }
    else {
      goto DEEP_HT3 ; 
    }

    DEEP_HT3 : 
    hti = FUNCCALL(SETUP_XfOrM202(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) ); 
    so = FUNCCALL(SETUP_XfOrM202(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) ); 
    nht = FUNCCALL_AGAIN(inf_pop (& inf_stack , & inf_stack_depth , gcable ) ); 

    if (set_mode )
      new_so = nht ; 
    else 
    new_so = so ; 
    do {

# 1907 "./../src/place.c"
      goto DEEP_RETURN_L ; 
    }

# 1907 "./../src/place.c"
    while (0 ) ; 

# 1907 "./../src/place.c"
    ; 
    break ; 

    default : FUNCCALL(SETUP_XfOrM202(_), bad_place_message2 (so , fd_accumulators , can_raise_exn , 0 , 0 , 0 ) )
    ; 
    if (invalid_object )

# 1912 "./../src/place.c"
    * invalid_object = so ; 
    new_so = ((void * ) 0 ) ; 
    do {

# 1914 "./../src/place.c"
      goto DEEP_DONE_L ; 
    }

# 1914 "./../src/place.c"
    while (0 ) ; 

# 1914 "./../src/place.c"
    ; 
    break ; 
  }

  DEEP_RETURN_L : 
  {
    ctr -- ; 
#   define XfOrM200_COUNT (0+XfOrM199_COUNT)
#   define SETUP_XfOrM200(x) SETUP_XfOrM199(x)

# 1921 "./../src/place.c"
    reg0 = new_so ; 
    switch ((((intptr_t ) (FUNCCALL(SETUP_XfOrM200(_), inf_pop (& inf_stack , & inf_stack_depth , gcable ) )) ) >> 1 ) ) {
#     define XfOrM201_COUNT (0+XfOrM200_COUNT)
#     define SETUP_XfOrM201(x) SETUP_XfOrM200(x)

# 1923 "./../src/place.c"
      case 1 : goto DEEP_DO_CDR_L ; 
      case 2 : goto DEEP_DO_FIN_PAIR_L ; 
      case 3 : goto DEEP_VEC1_L ; 
      case 4 : goto DEEP_ST1_L ; 
      case 5 : goto DEEP_ST2_L ; 
      case 6 : goto DEEP_SST1_L ; 
      case 7 : goto DEEP_SST2_L ; 
      case 8 : goto DEEP_HT1_L ; 
      case 9 : goto DEEP_HT2_L ; 
      case 10 : goto DEEP_RETURN_L ; 
      case 11 : goto DEEP_DONE_L ; 
      default : (
      printf ("Invalid places_deep_copy_worker state\n" ) ) ; 
      FUNCCALL(SETUP_XfOrM201(_), abort () ); 
    }
  }

  DEEP_DONE_L : FUNCCALL(SETUP_XfOrM199(_), free_infinite_stack ((Scheme_Object * * ) inf_stack , inf_max_depth , gcable ) )
  ; 
  RET_VALUE_START (new_so ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1966 "./../src/place.c"
static Scheme_Object * strip_chaperones_k (void ) ; 




static Scheme_Object * strip_chaperones (Scheme_Object * so ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(so, 0), PUSH(o, 1)));
# define XfOrM316_COUNT (2)
# define SETUP_XfOrM316(x) SETUP(XfOrM316_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 

# 1976 "./../src/place.c"
  {

# 24 "./../src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM325_COUNT (0+XfOrM316_COUNT)
#   define SETUP_XfOrM325(x) SETUP_XfOrM316(x)

# 26 "./../src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 1978 "./../src/place.c"
    {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#     define XfOrM326_COUNT (0+XfOrM325_COUNT)
#     define SETUP_XfOrM326(x) SETUP_XfOrM325(x)

# 1980 "./../src/place.c"
      p -> ku . k . p1 = (void * ) so ; 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_handle_stack_overflow (strip_chaperones_k ) )) RET_VALUE_EMPTY_END ; 
    }
  }


  if (((Scheme_Type ) (((((intptr_t ) (so ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (so ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (so ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (so ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) so ) -> val ) ; 
  else 
  o = so ; 

  if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    Scheme_Object * a , * d ; 
    BLOCK_SETUP((PUSH(a, 0+XfOrM316_COUNT), PUSH(d, 1+XfOrM316_COUNT)));
#   define XfOrM324_COUNT (2+XfOrM316_COUNT)
#   define SETUP_XfOrM324(x) SETUP(XfOrM324_COUNT)
    a = NULLED_OUT ; 
    d = NULLED_OUT ; 

# 1993 "./../src/place.c"
    a = FUNCCALL(SETUP_XfOrM324(_), strip_chaperones ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ) ); 
    if (! a )

# 1994 "./../src/place.c"
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    d = FUNCCALL(SETUP_XfOrM324(_), strip_chaperones ((((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ) ); 
    if (! d )

# 1996 "./../src/place.c"
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_pair (a , d ) )) RET_VALUE_EMPTY_END ; 
  }

# 1998 "./../src/place.c"
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
    Scheme_Object * v , * e ; 
    intptr_t len = (((Scheme_Vector * ) (o ) ) -> size ) , i ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM316_COUNT), PUSH(e, 1+XfOrM316_COUNT)));
#   define XfOrM321_COUNT (2+XfOrM316_COUNT)
#   define SETUP_XfOrM321(x) SETUP(XfOrM321_COUNT)
    v = NULLED_OUT ; 
    e = NULLED_OUT ; 

# 2001 "./../src/place.c"
    v = FUNCCALL(SETUP_XfOrM321(_), scheme_make_vector (len , ((void * ) 0 ) ) ); 
    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM323_COUNT (0+XfOrM321_COUNT)
#     define SETUP_XfOrM323(x) SETUP_XfOrM321(x)

# 2003 "./../src/place.c"
      if ((o ) == (so ) ) 
        e = (((Scheme_Vector * ) (so ) ) -> els ) [i ] ; 
      else 
      e = FUNCCALL(SETUP_XfOrM323(_), scheme_chaperone_vector_ref (so , i ) ); 
      e = FUNCCALL(SETUP_XfOrM323(_), strip_chaperones (e ) ); 
      if (! e )

# 2008 "./../src/place.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      (((Scheme_Vector * ) (v ) ) -> els ) [i ] = e ; 
    }
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

# 2012 "./../src/place.c"
  else if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) || ((((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) {
#   define XfOrM320_COUNT (0+XfOrM316_COUNT)
#   define SETUP_XfOrM320(x) SETUP_XfOrM316(x)

# 2013 "./../src/place.c"
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_chaperone_hash_table_filtered_copy (so , strip_chaperones ) )) RET_VALUE_EMPTY_END ; 
  }

# 2014 "./../src/place.c"
  else if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
    Scheme_Structure * s = (Scheme_Structure * ) (o ) , * s2 ; 
    Scheme_Object * e ; 
    intptr_t i , len = s -> stype -> num_slots ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM316_COUNT), PUSH(e, 1+XfOrM316_COUNT), PUSH(s2, 2+XfOrM316_COUNT)));
#   define XfOrM317_COUNT (3+XfOrM316_COUNT)
#   define SETUP_XfOrM317(x) SETUP(XfOrM317_COUNT)
    s2 = NULLED_OUT ; 
    e = NULLED_OUT ; 

# 2018 "./../src/place.c"
    if (! s -> stype -> prefab_key )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    s2 = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM317(_), scheme_make_blank_prefab_struct_instance (s -> stype ) ); 
    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM319_COUNT (0+XfOrM317_COUNT)
#     define SETUP_XfOrM319(x) SETUP_XfOrM317(x)

# 2022 "./../src/place.c"
      if ((o ) == (so ) ) 
        e = s -> slots [i ] ; 
      else 
      e = FUNCCALL(SETUP_XfOrM319(_), scheme_struct_ref (so , i ) ); 
      e = FUNCCALL(SETUP_XfOrM319(_), strip_chaperones (e ) ); 
      if (! e )

# 2027 "./../src/place.c"
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      s2 -> slots [i ] = e ; 
    }
    RET_VALUE_START ((Scheme_Object * ) s2 ) RET_VALUE_END ; 
  }

# 2031 "./../src/place.c"
  else 
  RET_VALUE_START (so ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2035 "./../src/place.c"
static Scheme_Object * strip_chaperones_k (void ) 
{
  /* No conversion */

# 2037 "./../src/place.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * so = (Scheme_Object * ) p -> ku . k . p1 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 

  return strip_chaperones (so ) ; 
}

# 2085 "./../src/place.c"
static void log_place_event (const char * what , const char * tag , int has_amount , intptr_t amount ) 
{
  int id ; 
  Scheme_Logger * pl ; 
  Scheme_Object * data , * tag_sym , * t ; 
  double __funcarg82 ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(t, 0), PUSH(tag_sym, 1), PUSH(pl, 2), PUSH(data, 3), PUSH(what, 4), PUSH(tag, 5)));
# define XfOrM328_COUNT (6)
# define SETUP_XfOrM328(x) SETUP(XfOrM328_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pl = NULLED_OUT ; 
  data = NULLED_OUT ; 
  tag_sym = NULLED_OUT ; 
  t = NULLED_OUT ; 

# 2091 "./../src/place.c"
  pl = FUNCCALL(SETUP_XfOrM328(_), scheme_get_place_logger () ); 
  if (! FUNCCALL(SETUP_XfOrM328(_), scheme_log_level_p (pl , 5 ) ))
    RET_NOTHING ; 

  id = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) ; 
  tag_sym = FUNCCALL(SETUP_XfOrM328(_), scheme_intern_symbol (tag ) ); 

  data = FUNCCALL_AGAIN(scheme_make_blank_prefab_struct_instance (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_event_prefab_ ) ) ); 
  ((Scheme_Structure * ) data ) -> slots [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (id ) ) ) << 1 ) | 0x1 ) ) ; 
  ((Scheme_Structure * ) data ) -> slots [1 ] = tag_sym ; 
  ((Scheme_Structure * ) data ) -> slots [2 ] = (has_amount 
  ? ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (amount ) ) ) << 1 ) | 0x1 ) ) 
  : scheme_false ) ; 
  t = (__funcarg82 = (scheme_get_inexact_milliseconds () ) , FUNCCALL(SETUP_XfOrM328(_), scheme_make_double (__funcarg82 ) )) ; 
  ((Scheme_Structure * ) data ) -> slots [3 ] = t ; 

  if (has_amount )
    FUNCCALL(SETUP_XfOrM328(_), scheme_log_w_data (pl , 5 , 0 , data , what , id , amount ) )
  ; 
  else FUNCCALL_EMPTY(scheme_log_w_data (pl , 5 , 0 , data , what , id ) )

  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2115 "./../src/place.c"
static void * place_start_proc (void * data_arg ) {
  void * stack_base ; 
  void * rc ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(stack_base, 0), PUSH(rc, 1)));
# define XfOrM329_COUNT (2)
# define SETUP_XfOrM329(x) SETUP(XfOrM329_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stack_base = NULLED_OUT ; 
  rc = NULLED_OUT ; 

# 2118 "./../src/place.c"
  stack_base = & __gc_var_stack__ ; 
  rc = FUNCCALL(SETUP_XfOrM329(_), place_start_proc_after_stack (data_arg , stack_base ) ); 
  stack_base = ((void * ) 0 ) ; 
  RET_VALUE_START (rc ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2124 "./../src/place.c"
static void pause_one_place (Scheme_Place * p ) 
{
  Scheme_Place_Object * place_obj = p -> place_obj ; 
  PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(place_obj, 0)));
# define XfOrM330_COUNT (1)
# define SETUP_XfOrM330(x) SETUP(XfOrM330_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2128 "./../src/place.c"
  if (place_obj ) {
#   define XfOrM331_COUNT (0+XfOrM330_COUNT)
#   define SETUP_XfOrM331(x) SETUP_XfOrM330(x)
    FUNCCALL(SETUP_XfOrM331(_), mzrt_mutex_lock (place_obj -> 
    lock ) )
# 2129 "./../src/place.c"
    ; 
    if (! place_obj -> pause ) {
      mzrt_sema * s ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM331_COUNT)));
#     define XfOrM332_COUNT (1+XfOrM331_COUNT)
#     define SETUP_XfOrM332(x) SETUP(XfOrM332_COUNT)
      s = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM332(_), mzrt_sema_create (& s , 0 ) )
# 2132 "./../src/place.c"
      ; 
      place_obj -> pause = s ; 
    }
    FUNCCALL_EMPTY(mzrt_mutex_unlock (place_obj -> 
    lock ) )
# 2135 "./../src/place.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2139 "./../src/place.c"
static void resume_one_place_with_lock (Scheme_Place_Object * place_obj ) 
{
  PREPARE_VAR_STACK(1);
# define XfOrM333_COUNT (0)
# define SETUP_XfOrM333(x) SETUP(XfOrM333_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2141 "./../src/place.c"
  if (place_obj -> pause ) {
    mzrt_sema * s = place_obj -> pause ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM333_COUNT)));
#   define XfOrM334_COUNT (1+XfOrM333_COUNT)
#   define SETUP_XfOrM334(x) SETUP(XfOrM334_COUNT)

# 2143 "./../src/place.c"
    place_obj -> pause = ((void * ) 0 ) ; 
    if (! place_obj -> pausing ) {
#     define XfOrM336_COUNT (0+XfOrM334_COUNT)
#     define SETUP_XfOrM336(x) SETUP_XfOrM334(x)
      FUNCCALL(SETUP_XfOrM336(_), mzrt_sema_destroy (s ) )
# 2145 "./../src/place.c"
      ; 
    }

# 2146 "./../src/place.c"
    else {
#     define XfOrM335_COUNT (0+XfOrM334_COUNT)
#     define SETUP_XfOrM335(x) SETUP_XfOrM334(x)
      FUNCCALL_EMPTY(mzrt_sema_post (s ) )
# 2147 "./../src/place.c"
      ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2152 "./../src/place.c"
static void resume_one_place (Scheme_Place * p ) 
{
  Scheme_Place_Object * place_obj = p -> place_obj ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(place_obj, 0)));
# define XfOrM337_COUNT (1)
# define SETUP_XfOrM337(x) SETUP(XfOrM337_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2156 "./../src/place.c"
  if (place_obj ) {
#   define XfOrM338_COUNT (0+XfOrM337_COUNT)
#   define SETUP_XfOrM338(x) SETUP_XfOrM337(x)
    FUNCCALL(SETUP_XfOrM338(_), mzrt_mutex_lock (place_obj -> 
    lock ) )
# 2157 "./../src/place.c"
    ; 
    FUNCCALL(SETUP_XfOrM338(_), resume_one_place_with_lock (place_obj ) ); 
    FUNCCALL_EMPTY(mzrt_mutex_unlock (place_obj -> 
    lock ) )
# 2159 "./../src/place.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2163 "./../src/place.c"
static void pause_all_child_places () 
{
  Scheme_Place * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> all_child_places_ ) ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM339_COUNT (1)
# define SETUP_XfOrM339(x) SETUP(XfOrM339_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2166 "./../src/place.c"
  while (p ) {
#   define XfOrM341_COUNT (0+XfOrM339_COUNT)
#   define SETUP_XfOrM341(x) SETUP_XfOrM339(x)
    FUNCCALL(SETUP_XfOrM341(_), pause_one_place (p ) )
# 2167 "./../src/place.c"
    ; 
    p = p -> next ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2172 "./../src/place.c"
static void resume_all_child_places () 
{
  Scheme_Place * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> all_child_places_ ) ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM342_COUNT (1)
# define SETUP_XfOrM342(x) SETUP(XfOrM342_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2175 "./../src/place.c"
  while (p ) {
#   define XfOrM344_COUNT (0+XfOrM342_COUNT)
#   define SETUP_XfOrM344(x) SETUP_XfOrM342(x)
    FUNCCALL(SETUP_XfOrM344(_), resume_one_place (p ) )
# 2176 "./../src/place.c"
    ; 
    p = p -> next ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2181 "./../src/place.c"
void destroy_place_object_locks (Scheme_Place_Object * place_obj ) {
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(place_obj, 0)));
# define XfOrM345_COUNT (1)
# define SETUP_XfOrM345(x) SETUP(XfOrM345_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM345(_), mzrt_mutex_destroy (place_obj -> 
  lock ) )
# 2182 "./../src/place.c"
  ; 
  if (place_obj -> pause )
    FUNCCALL(SETUP_XfOrM345(_), mzrt_sema_destroy (place_obj -> pause ) ); 
  place_obj -> 
  lock 
# 2185 "./../src/place.c"
  = ((void * ) 0 ) ; 
  place_obj -> pause = ((void * ) 0 ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2189 "./../src/place.c"
void scheme_place_check_for_interruption () 
{
  Scheme_Place_Object * place_obj ; 
  char local_die ; 
  char local_break ; 
  mzrt_sema * local_pause ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(local_pause, 0), PUSH(place_obj, 1)));
# define XfOrM346_COUNT (2)
# define SETUP_XfOrM346(x) SETUP(XfOrM346_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  place_obj = NULLED_OUT ; 
  local_pause = NULLED_OUT ; 

# 2196 "./../src/place.c"
  place_obj = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) ; 
  if (! place_obj )
    RET_NOTHING ; 

  while (1 ) {
#   define XfOrM349_COUNT (0+XfOrM346_COUNT)
#   define SETUP_XfOrM349(x) SETUP_XfOrM346(x)
    FUNCCALL(SETUP_XfOrM349(_), mzrt_mutex_lock (place_obj -> 
    lock ) )
# 2201 "./../src/place.c"
    ; 

    local_die = place_obj -> die ; 
    local_break = place_obj -> pbreak ; 
    local_pause = place_obj -> pause ; 
    if (local_die )
      place_obj -> die = - 1 ; 
    place_obj -> pbreak = 0 ; 
    if (local_pause )
      place_obj -> pausing = 1 ; 
    FUNCCALL(SETUP_XfOrM349(_), mzrt_mutex_unlock (place_obj -> 
    lock ) ); 

    if (local_pause ) {
#     define XfOrM350_COUNT (0+XfOrM349_COUNT)
#     define SETUP_XfOrM350(x) SETUP_XfOrM349(x)
      FUNCCALL(SETUP_XfOrM350(_), pause_all_child_places () )
# 2215 "./../src/place.c"
      ; 
      FUNCCALL(SETUP_XfOrM350(_), mzrt_sema_wait (local_pause ) ); 
      FUNCCALL_AGAIN(mzrt_sema_destroy (local_pause ) ); 
      local_pause = ((void * ) 0 ) ; 
      FUNCCALL(SETUP_XfOrM350(_), resume_all_child_places () ); 
    }

# 2220 "./../src/place.c"
    else 
    break ; 
  }

  if (local_die > 0 )
    FUNCCALL_EMPTY(scheme_kill_thread (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_main_thread_ ) ) ); 
  if (local_break )
    FUNCCALL_EMPTY(scheme_break_kind_thread (((void * ) 0 ) , local_break ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2230 "./../src/place.c"
void scheme_place_set_memory_use (intptr_t mem_use ) 
{
  Scheme_Place_Object * place_obj ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(place_obj, 0)));
# define XfOrM351_COUNT (1)
# define SETUP_XfOrM351(x) SETUP(XfOrM351_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  place_obj = NULLED_OUT ; 

# 2234 "./../src/place.c"
  place_obj = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) ; 
  if (! place_obj )
    RET_NOTHING ; 
  FUNCCALL(SETUP_XfOrM351(_), mzrt_mutex_lock (place_obj -> 
  lock ) ); 
  place_obj -> memory_use = mem_use ; 
  FUNCCALL(SETUP_XfOrM351(_), mzrt_mutex_unlock (place_obj -> 
  lock ) )
# 2240 "./../src/place.c"
  ; 

  if (place_obj -> parent_signal_handle && place_obj -> memory_limit ) {
#   define XfOrM352_COUNT (0+XfOrM351_COUNT)
#   define SETUP_XfOrM352(x) SETUP_XfOrM351(x)

# 2243 "./../src/place.c"
    if (mem_use > place_obj -> memory_limit ) {
#     define XfOrM355_COUNT (0+XfOrM352_COUNT)
#     define SETUP_XfOrM355(x) SETUP_XfOrM352(x)
      FUNCCALL(SETUP_XfOrM355(_), pause_all_child_places () )

      ; 
      FUNCCALL(SETUP_XfOrM355(_), mzrt_ensure_max_cas (place_obj -> parent_need_gc , 1 ) ); 
      FUNCCALL_AGAIN(scheme_signal_received_at (place_obj -> parent_signal_handle ) ); 
    }

# 2251 "./../src/place.c"
    else if (mem_use > (1 + place_obj -> use_factor ) * place_obj -> prev_notify_memory_use ) {
#     define XfOrM354_COUNT (0+XfOrM352_COUNT)
#     define SETUP_XfOrM354(x) SETUP_XfOrM352(x)

# 2253 "./../src/place.c"
      if (place_obj -> parent_signal_handle )
        FUNCCALL(SETUP_XfOrM354(_), scheme_signal_received_at (place_obj -> parent_signal_handle ) ); 
      place_obj -> prev_notify_memory_use = mem_use ; 
    }

# 2256 "./../src/place.c"
    else if (mem_use < place_obj -> prev_notify_memory_use ) {
      place_obj -> prev_notify_memory_use = mem_use ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2262 "./../src/place.c"
void scheme_place_check_memory_use () 
{
  /* No conversion */

# 2264 "./../src/place.c"
  intptr_t m ; 

  m = GC_propagate_hierarchy_memory_use () ; 
  scheme_place_set_memory_use (m ) ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> force_gc_for_place_accounting_ ) ) {
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> force_gc_for_place_accounting_ ) = 0 ; 
    scheme_collect_garbage () ; 
    resume_all_child_places () ; 
  }
}

static void place_set_result (struct Scheme_Place_Object * place_obj , Scheme_Object * result ) 

{
  intptr_t status ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(place_obj, 0), PUSH(result, 1)));
# define XfOrM358_COUNT (2)
# define SETUP_XfOrM358(x) SETUP(XfOrM358_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2281 "./../src/place.c"
  if (((intptr_t ) (result ) ) & 0x1 )  {
    status = (((intptr_t ) (result ) ) >> 1 ) ; 
    if (status < 1 || status > 255 )
      status = 0 ; 
  }

# 2285 "./../src/place.c"
  else 
  status = 0 ; 
  FUNCCALL(SETUP_XfOrM358(_), mzrt_mutex_lock (place_obj -> 
  lock ) ); 
  place_obj -> result = status ; 
  if (place_obj -> parent_signal_handle ) {
#   define XfOrM359_COUNT (0+XfOrM358_COUNT)
#   define SETUP_XfOrM359(x) SETUP_XfOrM358(x)
    FUNCCALL(SETUP_XfOrM359(_), scheme_signal_received_at (place_obj -> parent_signal_handle ) )
# 2291 "./../src/place.c"
    ; 
    place_obj -> parent_signal_handle = ((void * ) 0 ) ; 
  }
  place_obj -> signal_handle = ((void * ) 0 ) ; 
  place_obj -> dead = 1 ; 
  FUNCCALL_EMPTY(mzrt_mutex_unlock (place_obj -> 
  lock ) )
# 2296 "./../src/place.c"
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2299 "./../src/place.c"
static void terminate_current_place (Scheme_Object * result ) 
{
  intptr_t place_obj_die ; 
  intptr_t refcount ; 
  Scheme_Place_Object * place_obj ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(place_obj, 0), PUSH(result, 1)));
# define XfOrM361_COUNT (2)
# define SETUP_XfOrM361(x) SETUP(XfOrM361_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  place_obj = NULLED_OUT ; 

# 2305 "./../src/place.c"
  place_obj = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) ; 
  FUNCCALL(SETUP_XfOrM361(_), mzrt_mutex_lock (place_obj -> 
  lock ) ); 
  place_obj_die = place_obj -> die ; 
  FUNCCALL(SETUP_XfOrM361(_), mzrt_mutex_unlock (place_obj -> 
  lock ) )
# 2309 "./../src/place.c"
  ; 

  if (! place_obj_die ) {
#   define XfOrM362_COUNT (0+XfOrM361_COUNT)
#   define SETUP_XfOrM362(x) SETUP_XfOrM361(x)

# 2312 "./../src/place.c"
    if (FUNCCALL(SETUP_XfOrM362(_), scheme_flush_managed (((void * ) 0 ) , 1 ) ))
      result = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
  }

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM361(_), scheme_place_instance_destroy (place_obj_die ) )




  ; 
  FUNCCALL_AGAIN(place_set_result (place_obj , result ) )
  ; 
  FUNCCALL_AGAIN(mzrt_mutex_lock (place_obj -> 
  lock ) ); 

  place_obj -> refcount -- ; 
  refcount = place_obj -> refcount ; 
  FUNCCALL(SETUP_XfOrM361(_), mzrt_mutex_unlock (place_obj -> 
  lock ) ); 

  if (! refcount )
    FUNCCALL_EMPTY(destroy_place_object_locks (place_obj ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2337 "./../src/place.c"
static Scheme_Object * def_place_exit_handler_proc (int argc , Scheme_Object * argv [] ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM363_COUNT (1)
# define SETUP_XfOrM363(x) SETUP(XfOrM363_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM363(_), log_place_event ("id %d: exit (via `exit')" , "exit" , 0 , 0 ) )
# 2339 "./../src/place.c"
  ; 
  FUNCCALL_EMPTY(terminate_current_place (argv [0 ] ) )
  ; 
  FUNCCALL_EMPTY(mz_proc_thread_exit (((void * ) 0 ) ) )
  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2348 "./../src/place.c"
static int do_embedded_load () 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(2);
# define XfOrM364_COUNT (0)
# define SETUP_XfOrM364(x) SETUP(XfOrM364_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2350 "./../src/place.c"
  if (embedded_load ) {
    Scheme_Thread * volatile p ; 
    mz_jmp_buf * volatile save , newbuf ; 
    volatile int rc ; 
    BLOCK_SETUP((PUSH(save, 0+XfOrM364_COUNT), PUSH(p, 1+XfOrM364_COUNT)));
#   define XfOrM365_COUNT (2+XfOrM364_COUNT)
#   define SETUP_XfOrM365(x) SETUP(XfOrM365_COUNT)
    p = NULLED_OUT ; 
    save = NULLED_OUT ; 

# 2355 "./../src/place.c"
    p = (scheme_get_current_thread () ) ; 
    save = p -> error_buf ; 
    p -> error_buf = & newbuf ; 

    if (! ((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM365_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#     define XfOrM367_COUNT (0+XfOrM365_COUNT)
#     define SETUP_XfOrM367(x) SETUP_XfOrM365(x)
      FUNCCALL(SETUP_XfOrM367(_), scheme_embedded_load (embedded_load_len , embedded_load , 1 ) )
# 2360 "./../src/place.c"
      ; 
      rc = 1 ; 
    }

# 2362 "./../src/place.c"
    else {
      rc = 0 ; 
    }

    p -> error_buf = save ; 

    RET_VALUE_START (rc ) RET_VALUE_END ; 
  }

  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2374 "./../src/place.c"
static void * place_start_proc_after_stack (void * data_arg , void * stack_base ) {
  Place_Start_Data * place_data ; 
  Scheme_Place_Object * place_obj ; 
  Scheme_Object * place_main ; 
  Scheme_Object * a [2 ] , * channel , * result ; 
  intptr_t mem_limit ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(stack_base, 0), PUSH(place_obj, 1), PUSH(place_data, 2), PUSHARRAY(a, 2, 3), PUSH(channel, 6), PUSH(place_main, 7), PUSH(result, 8)));
# define XfOrM368_COUNT (9)
# define SETUP_XfOrM368(x) SETUP(XfOrM368_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  place_data = NULLED_OUT ; 
  place_obj = NULLED_OUT ; 
  place_main = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  channel = NULLED_OUT ; 
  result = NULLED_OUT ; 

# 2381 "./../src/place.c"
  place_data = (Place_Start_Data * ) data_arg ; 
  data_arg = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM368(_), null_out_runtime_globals () )



  ; 
  FUNCCALL_AGAIN(mzrt_mutex_lock (id_counter_mutex ) )
  ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) = ++ id_counter ; 
  FUNCCALL(SETUP_XfOrM368(_), mzrt_mutex_unlock (id_counter_mutex ) ); 

  mem_limit = (((intptr_t ) (place_data -> cust_limit ) ) >> 1 ) ; 


  if (! FUNCCALL(SETUP_XfOrM368(_), scheme_place_instance_init (stack_base , place_data -> parent_gc , mem_limit ) )) {
#   define XfOrM381_COUNT (0+XfOrM368_COUNT)
#   define SETUP_XfOrM381(x) SETUP_XfOrM368(x)

# 2398 "./../src/place.c"
    place_data -> place_obj = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM381(_), mzrt_sema_post (place_data -> ready ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  a [0 ] = FUNCCALL(SETUP_XfOrM368(_), places_deep_direct_uncopy (place_data -> current_library_collection_paths ) ); 
  FUNCCALL(SETUP_XfOrM368(_), scheme_current_library_collection_paths (1 , a ) ); 
  a [0 ] = FUNCCALL(SETUP_XfOrM368(_), places_deep_direct_uncopy (place_data -> current_library_collection_links ) ); 
  FUNCCALL(SETUP_XfOrM368(_), scheme_current_library_collection_links (1 , a ) ); 
  a [0 ] = FUNCCALL(SETUP_XfOrM368(_), places_deep_direct_uncopy (place_data -> compiled_roots ) ); 
  FUNCCALL(SETUP_XfOrM368(_), scheme_compiled_file_roots (1 , a ) ); 
  a [0 ] = FUNCCALL(SETUP_XfOrM368(_), places_deep_direct_uncopy (place_data -> current_directory ) ); 
  FUNCCALL(SETUP_XfOrM368(_), scheme_current_directory (1 , a ) ); 
  FUNCCALL_AGAIN(scheme_seal_parameters () ); 

  a [0 ] = FUNCCALL(SETUP_XfOrM368(_), places_deep_direct_uncopy (place_data -> module ) ); 
  a [1 ] = FUNCCALL(SETUP_XfOrM368(_), places_deep_direct_uncopy (place_data -> function ) ); 
  a [1 ] = FUNCCALL(SETUP_XfOrM368(_), scheme_intern_exact_symbol ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (a [1 ] ) ) ) -> s ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (a [1 ] ) ) ) -> len ) ) ); 
  channel = FUNCCALL(SETUP_XfOrM368(_), places_deep_direct_uncopy (place_data -> channel ) ); 
  place_obj = place_data -> place_obj ; 
  FUNCCALL(SETUP_XfOrM368(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) ) ) ); 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) = place_obj ; 
  place_obj -> refcount ++ ; 

  place_obj -> id = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_place_id_ ) ; 

  {
    void * signal_handle ; 
    BLOCK_SETUP((PUSH(signal_handle, 0+XfOrM368_COUNT)));
#   define XfOrM380_COUNT (1+XfOrM368_COUNT)
#   define SETUP_XfOrM380(x) SETUP(XfOrM380_COUNT)
    signal_handle = NULLED_OUT ; 

# 2426 "./../src/place.c"
    signal_handle = FUNCCALL(SETUP_XfOrM380(_), scheme_get_signal_handle () ); 
    place_obj -> signal_handle = signal_handle ; 
  }

  {
    Scheme_Object * tmp ; 
    BLOCK_SETUP((PUSH(tmp, 0+XfOrM368_COUNT)));
#   define XfOrM373_COUNT (1+XfOrM368_COUNT)
#   define SETUP_XfOrM373(x) SETUP(XfOrM373_COUNT)
    tmp = NULLED_OUT ; 

# 2432 "./../src/place.c"
    if (place_data -> in ) {
#     define XfOrM378_COUNT (0+XfOrM373_COUNT)
#     define SETUP_XfOrM378(x) SETUP_XfOrM373(x)

# 2433 "./../src/place.c"
      tmp = (__funcarg85 = FUNCCALL(SETUP_XfOrM378(_), scheme_intern_symbol ("place-in" ) ), FUNCCALL_AGAIN(scheme_make_rktio_fd_input_port (place_data -> in , __funcarg85 ) )) ; 
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdin_port_ ) ) {
#       define XfOrM379_COUNT (0+XfOrM378_COUNT)
#       define SETUP_XfOrM379(x) SETUP_XfOrM378(x)
        FUNCCALL(SETUP_XfOrM379(_), scheme_close_input_port (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdin_port_ ) ) )
# 2435 "./../src/place.c"
        ; 
      }
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdin_port_ ) = tmp ; 
    }
    if (place_data -> out >= 0 ) {
#     define XfOrM376_COUNT (0+XfOrM373_COUNT)
#     define SETUP_XfOrM376(x) SETUP_XfOrM373(x)

# 2440 "./../src/place.c"
      tmp = (__funcarg84 = FUNCCALL(SETUP_XfOrM376(_), scheme_intern_symbol ("place-out" ) ), FUNCCALL_AGAIN(scheme_make_rktio_fd_output_port (place_data -> out , __funcarg84 , 0 ) )) ; 
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdout_port_ ) ) {
#       define XfOrM377_COUNT (0+XfOrM376_COUNT)
#       define SETUP_XfOrM377(x) SETUP_XfOrM376(x)
        FUNCCALL(SETUP_XfOrM377(_), scheme_close_output_port (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdout_port_ ) ) )
# 2442 "./../src/place.c"
        ; 
      }
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdout_port_ ) = tmp ; 
    }
    if (place_data -> err >= 0 ) {
#     define XfOrM374_COUNT (0+XfOrM373_COUNT)
#     define SETUP_XfOrM374(x) SETUP_XfOrM373(x)

# 2447 "./../src/place.c"
      tmp = (__funcarg83 = FUNCCALL(SETUP_XfOrM374(_), scheme_intern_symbol ("place-err" ) ), FUNCCALL_AGAIN(scheme_make_rktio_fd_output_port (place_data -> err , __funcarg83 , 0 ) )) ; 
      if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stderr_port_ ) ) {
#       define XfOrM375_COUNT (0+XfOrM374_COUNT)
#       define SETUP_XfOrM375(x) SETUP_XfOrM374(x)
        FUNCCALL(SETUP_XfOrM375(_), scheme_close_output_port (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stderr_port_ ) ) )
# 2449 "./../src/place.c"
        ; 
      }
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stderr_port_ ) = tmp ; 
    }
    FUNCCALL(SETUP_XfOrM373(_), scheme_init_port_config () ); 
  }
  FUNCCALL(SETUP_XfOrM368(_), mzrt_sema_post (place_data -> ready ) )
  ; 
  place_data = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM368(_), GC_allow_master_gc_check () )


  ; 
  FUNCCALL_AGAIN(scheme_set_root_param (MZCONFIG_EXIT_HANDLER , scheme_def_place_exit_proc ) )




  ; 
  FUNCCALL_AGAIN(log_place_event ("id %d: enter" , "enter" , 0 , 0 ) )
  ; 

  if (FUNCCALL(SETUP_XfOrM368(_), do_embedded_load () )) {
    Scheme_Thread * volatile p ; 
    mz_jmp_buf * volatile saved_error_buf ; 
    mz_jmp_buf new_error_buf ; 
    Scheme_Object * volatile rc = scheme_false ; 
    BLOCK_SETUP((PUSH(rc, 0+XfOrM368_COUNT), PUSH(p, 1+XfOrM368_COUNT), PUSH(saved_error_buf, 2+XfOrM368_COUNT)));
#   define XfOrM370_COUNT (3+XfOrM368_COUNT)
#   define SETUP_XfOrM370(x) SETUP(XfOrM370_COUNT)
    p = NULLED_OUT ; 
    saved_error_buf = NULLED_OUT ; 

# 2477 "./../src/place.c"
    p = (scheme_get_current_thread () ) ; 
    saved_error_buf = p -> error_buf ; 
    p -> error_buf = & new_error_buf ; 
    if (! ((new_error_buf ) . gcvs = (intptr_t ) __gc_var_stack__ , (new_error_buf ) . gcvs_cnt = XfOrM370_COUNT , (_setjmp ((new_error_buf ) . jb ) ) ) ) {
#     define XfOrM372_COUNT (0+XfOrM370_COUNT)
#     define SETUP_XfOrM372(x) SETUP_XfOrM370(x)

# 2481 "./../src/place.c"
      if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_rktio_ ) )
        FUNCCALL(SETUP_XfOrM372(_), scheme_signal_error ("place: I/O manager initialization failed" ) ); 

      place_main = FUNCCALL(SETUP_XfOrM372(_), scheme_dynamic_require (2 , a ) ); 
      a [0 ] = channel ; 
      (void ) FUNCCALL(SETUP_XfOrM372(_), scheme_apply (place_main , 1 , a ) ); 
      rc = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    }

# 2488 "./../src/place.c"
    else {
      rc = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
    }
    p -> error_buf = saved_error_buf ; 

    result = rc ; 
  }

# 2494 "./../src/place.c"
  else {
    result = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ; 
  }
  FUNCCALL(SETUP_XfOrM368(_), log_place_event ("id %d: exit" , "exit" , 0 , 0 ) )
  ; 
  FUNCCALL(SETUP_XfOrM368(_), terminate_current_place (result ) )
  ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2505 "./../src/place.c"
static Scheme_Object * places_serialize (Scheme_Object * so , void * * msg_memory , Scheme_Object * * master_chain , 
Scheme_Object * * invalid_object , 
char * * delayed_err , intptr_t * delayed_errno , intptr_t * delayed_errkind ) {

  Scheme_Object * new_so ; 
  Scheme_Object * tmp ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(delayed_err, 0), PUSH(delayed_errkind, 1), PUSH(master_chain, 2), PUSH(new_so, 3), PUSH(so, 4), PUSH(delayed_errno, 5), PUSH(msg_memory, 6), PUSH(invalid_object, 7), PUSH(tmp, 8)));
# define XfOrM382_COUNT (9)
# define SETUP_XfOrM382(x) SETUP(XfOrM382_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  new_so = NULLED_OUT ; 
  tmp = NULLED_OUT ; 

# 2512 "./../src/place.c"
  new_so = FUNCCALL(SETUP_XfOrM382(_), trivial_copy (so , ((void * ) 0 ) ) ); 
  if (new_so )

# 2513 "./../src/place.c"
  RET_VALUE_START (new_so ) RET_VALUE_END ; 

  while (1 ) {
#   define XfOrM385_COUNT (0+XfOrM382_COUNT)
#   define SETUP_XfOrM385(x) SETUP_XfOrM382(x)
    FUNCCALL(SETUP_XfOrM385(_), GC_create_message_allocator () )
# 2516 "./../src/place.c"
    ; 
    new_so = FUNCCALL(SETUP_XfOrM385(_), do_places_deep_copy (so , 1 , 0 , master_chain , invalid_object , delayed_err , delayed_errno , delayed_errkind ) )
    ; 
    tmp = FUNCCALL_AGAIN(GC_finish_message_allocator () ); 
    if (! new_so )
      FUNCCALL(SETUP_XfOrM385(_), GC_destroy_orphan_msg_memory (tmp ) ); 
    else 
    (* msg_memory ) = tmp ; 

    if (! new_so && ! * delayed_err && (((Scheme_Type ) (((((intptr_t ) (* invalid_object ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (* invalid_object ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (* invalid_object ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (* invalid_object ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
#     define XfOrM386_COUNT (0+XfOrM385_COUNT)
#     define SETUP_XfOrM386(x) SETUP_XfOrM385(x)

# 2527 "./../src/place.c"
      so = FUNCCALL(SETUP_XfOrM386(_), strip_chaperones (so ) ); 
      if (! so )
        break ; 
    }

# 2530 "./../src/place.c"
    else 
    break ; 
  }

  RET_VALUE_START (new_so ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * places_deserialize (Scheme_Object * so , void * msg_memory , Scheme_Thread * from_p ) 






{

  Scheme_Object * new_so = so ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(msg_memory, 0), PUSH(from_p, 1), PUSH(new_so, 2), PUSH(so, 3)));
# define XfOrM387_COUNT (4)
# define SETUP_XfOrM387(x) SETUP(XfOrM387_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2551 "./../src/place.c"
  new_so = FUNCCALL(SETUP_XfOrM387(_), trivial_copy (so , ((void * ) 0 ) ) ); 
  if (new_so )

# 2552 "./../src/place.c"
  RET_VALUE_START (new_so ) RET_VALUE_END ; 


  if (FUNCCALL(SETUP_XfOrM387(_), GC_message_small_objects_size (msg_memory , 1024 ) )) {
#   define XfOrM389_COUNT (0+XfOrM387_COUNT)
#   define SETUP_XfOrM389(x) SETUP_XfOrM387(x)

# 2556 "./../src/place.c"
    new_so = FUNCCALL(SETUP_XfOrM389(_), do_places_deep_copy (so , 2 , 1 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
    from_p -> place_channel_msg_in_flight = ((void * ) 0 ) ; 
    from_p -> place_channel_msg_chain_in_flight = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM389(_), GC_dispose_short_message_allocator (msg_memory ) ); 


    msg_memory = ((void * ) 0 ) ; 
  }
  else {
#   define XfOrM388_COUNT (0+XfOrM387_COUNT)
#   define SETUP_XfOrM388(x) SETUP_XfOrM387(x)

# 2565 "./../src/place.c"
    from_p -> place_channel_msg_in_flight = ((void * ) 0 ) ; 
    from_p -> place_channel_msg_chain_in_flight = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM388(_), GC_adopt_message_allocator (msg_memory ) ); 
    msg_memory = ((void * ) 0 ) ; 

    new_so = FUNCCALL(SETUP_XfOrM388(_), do_places_deep_copy (so , 4 , 1 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  }

  RET_VALUE_START (new_so ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
Scheme_Object * place_send (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 2581 "./../src/place.c"
  Scheme_Place_Bi_Channel * ch ; 
  if ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_type ) )  {
    ch = (Scheme_Place_Bi_Channel * ) ((Scheme_Place * ) args [0 ] ) -> channel ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_bi_channel_type ) )  {
    ch = (Scheme_Place_Bi_Channel * ) args [0 ] ; 
  }
  else {
    ch = ((void * ) 0 ) ; 
    scheme_wrong_contract ("place-channel-put" , "place-channel?" , 0 , argc , args ) ; 
  }
  place_async_send ((Scheme_Place_Async_Channel * ) ch -> link -> sendch , args [1 ] ) ; 
  return scheme_void ; 
}

Scheme_Object * place_receive (int argc , Scheme_Object * args [] ) {
  /* No conversion */

# 2597 "./../src/place.c"
  Scheme_Place_Bi_Channel * ch ; 
  if ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_type ) )  {
    ch = (Scheme_Place_Bi_Channel * ) ((Scheme_Place * ) args [0 ] ) -> channel ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_bi_channel_type ) )  {
    ch = (Scheme_Place_Bi_Channel * ) args [0 ] ; 
  }
  else {
    ch = ((void * ) 0 ) ; 
    scheme_wrong_contract ("place-channel-get" , "place-channel?" , 0 , argc , args ) ; 
  }
  return place_async_receive ((Scheme_Place_Async_Channel * ) ch -> link -> recvch ) ; 
}

static Scheme_Object * place_allowed_p (int argc , Scheme_Object * args [] ) 
{
  Scheme_Hash_Table * ht = ((void * ) 0 ) ; 
  Scheme_Object * v , * invalid_object = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(invalid_object, 0), PUSH(v, 1), PUSH(ht, 2)));
# define XfOrM398_COUNT (3)
# define SETUP_XfOrM398(x) SETUP(XfOrM398_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 2616 "./../src/place.c"
  v = args [0 ] ; 

  if (FUNCCALL(SETUP_XfOrM398(_), places_deep_copy_worker (v , & ht , 0 , 1 , 0 , ((void * ) 0 ) , & invalid_object , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ))
    RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  else {
#   define XfOrM399_COUNT (0+XfOrM398_COUNT)
#   define SETUP_XfOrM399(x) SETUP_XfOrM398(x)

# 2621 "./../src/place.c"
    if (invalid_object && (((Scheme_Type ) (((((intptr_t ) (invalid_object ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (invalid_object ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (invalid_object ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (invalid_object ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
#     define XfOrM400_COUNT (0+XfOrM399_COUNT)
#     define SETUP_XfOrM400(x) SETUP_XfOrM399(x)

# 2622 "./../src/place.c"
      v = FUNCCALL(SETUP_XfOrM400(_), strip_chaperones (v ) ); 
      if (v && FUNCCALL(SETUP_XfOrM400(_), places_deep_copy_worker (v , & ht , 0 , 1 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ))
        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
    }
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2631 "./../src/place.c"
void scheme_spawn_master_place () {
  /* No conversion */

# 2632 "./../src/place.c"
  mzrt_proc_first_thread_init () ; 



  scheme_master_proc_thread = (void * ) ~ 0 ; 
}







static void * GC_master_malloc (size_t size ) {
  void * ptr ; 

  void * original_gc ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ptr, 0), PUSH(original_gc, 1)));
# define XfOrM402_COUNT (2)
# define SETUP_XfOrM402(x) SETUP(XfOrM402_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ptr = NULLED_OUT ; 
  original_gc = NULLED_OUT ; 

# 2649 "./../src/place.c"
  original_gc = FUNCCALL(SETUP_XfOrM402(_), GC_switch_to_master_gc () ); 

  ptr = FUNCCALL_AGAIN(GC_malloc (size ) ); 
  FUNCCALL_AGAIN(GC_switch_back_from_master (original_gc ) )
  ; 

  RET_VALUE_START (ptr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2658 "./../src/place.c"
static void * GC_master_malloc_tagged (size_t size ) {
  void * ptr ; 

  void * original_gc ; 
  DECL_RET_SAVE (void * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ptr, 0), PUSH(original_gc, 1)));
# define XfOrM403_COUNT (2)
# define SETUP_XfOrM403(x) SETUP(XfOrM403_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ptr = NULLED_OUT ; 
  original_gc = NULLED_OUT ; 

# 2662 "./../src/place.c"
  original_gc = FUNCCALL(SETUP_XfOrM403(_), GC_switch_to_master_gc () ); 

  ptr = FUNCCALL_AGAIN(GC_malloc_one_small_tagged ((((size + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) ); 
  FUNCCALL_AGAIN(GC_switch_back_from_master (original_gc ) )
  ; 

  RET_VALUE_START (ptr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2671 "./../src/place.c"
static void maybe_report_message_size (Scheme_Place_Async_Channel * ch ) 
{
  /* No conversion */
  if ((ch -> reported_size > (2 * ch -> mem_size ) ) 
  || (((ch -> reported_size * 2 ) < ch -> mem_size ) 
  && ((ch -> mem_size - ch -> reported_size ) > (1 << (16 + 1 ) ) ) ) ) {
    intptr_t delta = ch -> mem_size - ch -> reported_size ; 
    ch -> reported_size = ch -> mem_size ; 
    GC_report_unsent_message_delta (delta ) ; 
  }
}


static void async_channel_finalize (void * p , void * data ) {
  Scheme_Place_Async_Channel * ch ; 
  int i ; 
  Scheme_Hash_Table * ht = ((void * ) 0 ) ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(ht, 1)));
# define XfOrM406_COUNT (2)
# define SETUP_XfOrM406(x) SETUP(XfOrM406_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  ch = NULLED_OUT ; 

# 2688 "./../src/place.c"
  ch = (Scheme_Place_Async_Channel * ) p ; 

  ch -> mem_size = 0 ; 
  FUNCCALL(SETUP_XfOrM406(_), maybe_report_message_size (ch ) ); 
  FUNCCALL_AGAIN(mzrt_mutex_destroy (ch -> 
  lock ) ); 
  ch -> 
  lock 
# 2694 "./../src/place.c"
  = ((void * ) 0 ) ; 
  for (i = 0 ; i < ch -> size ; i ++ ) {
#   define XfOrM420_COUNT (0+XfOrM406_COUNT)
#   define SETUP_XfOrM420(x) SETUP_XfOrM406(x)

# 2696 "./../src/place.c"
    ht = ((void * ) 0 ) ; 
    if (ch -> msgs [i ] ) {
#     define XfOrM422_COUNT (0+XfOrM420_COUNT)
#     define SETUP_XfOrM422(x) SETUP_XfOrM420(x)

# 2698 "./../src/place.c"
      (void ) FUNCCALL(SETUP_XfOrM422(_), places_deep_copy_worker (ch -> msgs [i ] , & ht , 5 , 0 , 0 , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
      ch -> msgs [i ] = ((void * ) 0 ) ; 
    }

    if (ch -> msg_memory [i ] ) {
#     define XfOrM421_COUNT (0+XfOrM420_COUNT)
#     define SETUP_XfOrM421(x) SETUP_XfOrM420(x)
      FUNCCALL(SETUP_XfOrM421(_), GC_destroy_orphan_msg_memory (ch -> msg_memory [i ] ) )
# 2703 "./../src/place.c"
      ; 
    }

    ch -> msg_memory [i ] = ((void * ) 0 ) ; 
    ch -> msg_chains [i ] = ((void * ) 0 ) ; 
  }
  ch -> in = 0 ; 
  ch -> out = 0 ; 
  ch -> count = 0 ; 

  if (ch -> wakeup_signal ) {
#   define XfOrM407_COUNT (0+XfOrM406_COUNT)
#   define SETUP_XfOrM407(x) SETUP_XfOrM406(x)

# 2715 "./../src/place.c"
    if (((((intptr_t ) (ch -> wakeup_signal ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ch -> wakeup_signal ) ) -> type ) == scheme_place_object_type )  {
      int refcount = 0 ; 
      Scheme_Place_Object * place_obj ; 
      BLOCK_SETUP((PUSH(place_obj, 0+XfOrM407_COUNT)));
#     define XfOrM415_COUNT (1+XfOrM407_COUNT)
#     define SETUP_XfOrM415(x) SETUP(XfOrM415_COUNT)
      place_obj = NULLED_OUT ; 

# 2718 "./../src/place.c"
      place_obj = ((Scheme_Place_Object * ) ch -> wakeup_signal ) ; 
      FUNCCALL(SETUP_XfOrM415(_), mzrt_mutex_lock (place_obj -> 
      lock ) ); 
      place_obj -> refcount -- ; 
      refcount = place_obj -> refcount ; 
      FUNCCALL(SETUP_XfOrM415(_), mzrt_mutex_unlock (place_obj -> 
      lock ) )
# 2723 "./../src/place.c"
      ; 
      if (! refcount ) {
#       define XfOrM416_COUNT (0+XfOrM415_COUNT)
#       define SETUP_XfOrM416(x) SETUP_XfOrM415(x)
        FUNCCALL(SETUP_XfOrM416(_), destroy_place_object_locks (place_obj ) )
# 2725 "./../src/place.c"
        ; 
      }
    }

    else if ((Scheme_Type ) (((((intptr_t ) (ch -> wakeup_signal ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ch -> wakeup_signal ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
      Scheme_Object * v = ch -> wakeup_signal ; 
      int i ; 
      int size = (((Scheme_Vector * ) (v ) ) -> size ) ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM407_COUNT)));
#     define XfOrM408_COUNT (1+XfOrM407_COUNT)
#     define SETUP_XfOrM408(x) SETUP(XfOrM408_COUNT)

# 2733 "./../src/place.c"
      for (i = 0 ; i < size ; i ++ ) {
        Scheme_Place_Object * o3 ; 
        BLOCK_SETUP((PUSH(o3, 0+XfOrM408_COUNT)));
#       define XfOrM412_COUNT (1+XfOrM408_COUNT)
#       define SETUP_XfOrM412(x) SETUP(XfOrM412_COUNT)
        o3 = NULLED_OUT ; 

# 2735 "./../src/place.c"
        o3 = (Scheme_Place_Object * ) (((Scheme_Vector * ) (v ) ) -> els ) [i ] ; 
        if (o3 ) {
          int refcount = 0 ; 
#         define XfOrM413_COUNT (0+XfOrM412_COUNT)
#         define SETUP_XfOrM413(x) SETUP_XfOrM412(x)
          FUNCCALL(SETUP_XfOrM413(_), mzrt_mutex_lock (o3 -> 
          lock ) )
# 2738 "./../src/place.c"
          ; 
          (((Scheme_Vector * ) (v ) ) -> els ) [i ] = ((void * ) 0 ) ; 
          o3 -> refcount -- ; 
          refcount = o3 -> refcount ; 
          FUNCCALL(SETUP_XfOrM413(_), mzrt_mutex_unlock (o3 -> 
          lock ) )
# 2742 "./../src/place.c"
          ; 

          if (! refcount ) {
#           define XfOrM414_COUNT (0+XfOrM413_COUNT)
#           define SETUP_XfOrM414(x) SETUP_XfOrM413(x)
            FUNCCALL(SETUP_XfOrM414(_), destroy_place_object_locks (o3 ) )
# 2745 "./../src/place.c"
            ; 
          }
        }
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2753 "./../src/place.c"
Scheme_Place_Async_Channel * place_async_channel_create () {
  Scheme_Object * * msgs , * * msg_chains ; 
  Scheme_Place_Async_Channel * ch ; 
  void * * msg_memory ; 

  void * original_gc ; 
  DECL_RET_SAVE (Scheme_Place_Async_Channel * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(msgs, 0), PUSH(msg_memory, 1), PUSH(ch, 2), PUSH(original_gc, 3), PUSH(msg_chains, 4)));
# define XfOrM423_COUNT (5)
# define SETUP_XfOrM423(x) SETUP(XfOrM423_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  msgs = NULLED_OUT ; 
  msg_chains = NULLED_OUT ; 
  ch = NULLED_OUT ; 
  msg_memory = NULLED_OUT ; 
  original_gc = NULLED_OUT ; 

# 2761 "./../src/place.c"
  ch = FUNCCALL(SETUP_XfOrM423(_), GC_master_malloc_tagged (sizeof (Scheme_Place_Async_Channel ) ) ); 
  ch -> so . type = scheme_place_async_channel_type ; 

  msgs = FUNCCALL(SETUP_XfOrM423(_), GC_master_malloc (sizeof (Scheme_Object * ) * 8 ) ); 
  msg_memory = FUNCCALL_AGAIN(GC_master_malloc (sizeof (void * ) * 8 ) ); 
  msg_chains = FUNCCALL_AGAIN(GC_master_malloc (sizeof (Scheme_Object * ) * 8 ) ); 

  ch -> in = 0 ; 
  ch -> out = 0 ; 
  ch -> count = 0 ; 
  ch -> size = 8 ; 
  FUNCCALL(SETUP_XfOrM423(_), mzrt_mutex_create (& ch -> 
  lock ) )
# 2772 "./../src/place.c"
  ; 
  ch -> msgs = msgs ; 
  ch -> msg_memory = msg_memory ; 
  ch -> msg_chains = msg_chains ; 
  ch -> wakeup_signal = ((void * ) 0 ) ; 


  original_gc = FUNCCALL(SETUP_XfOrM423(_), GC_switch_to_master_gc () ); 
  FUNCCALL_AGAIN(GC_set_finalizer (ch , 1 , 1 , async_channel_finalize , ((void * ) 0 ) , ((void * ) 0 ) , ((void * ) 0 ) ) ); 
  FUNCCALL_AGAIN(GC_switch_back_from_master (original_gc ) ); 




  RET_VALUE_START (ch ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2789 "./../src/place.c"
static void async_channel_refcount (Scheme_Place_Async_Channel * ch , int for_send , int delta ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ch, 0)));
# define XfOrM424_COUNT (1)
# define SETUP_XfOrM424(x) SETUP(XfOrM424_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2791 "./../src/place.c"
  if (! ch -> 
  lock ) 
# 2791 "./../src/place.c"
  {


    RET_NOTHING ; 
  }
  FUNCCALL(SETUP_XfOrM424(_), mzrt_mutex_lock (ch -> 
  lock ) )
# 2796 "./../src/place.c"
  ; 
  if (for_send )
    ch -> wr_ref += delta ; 
  else 
  ch -> rd_ref += delta ; 
  if ((ch -> wr_ref < 0 ) || (ch -> rd_ref < 0 ) ) {
#   define XfOrM425_COUNT (0+XfOrM424_COUNT)
#   define SETUP_XfOrM425(x) SETUP_XfOrM424(x)
    FUNCCALL(SETUP_XfOrM425(_), scheme_log_abort ("internal error: bad reference count on async channel" ) )
# 2802 "./../src/place.c"
    ; 
    FUNCCALL(SETUP_XfOrM425(_), abort () ); 
  }
  FUNCCALL_EMPTY(mzrt_mutex_unlock (ch -> 
  lock ) )
# 2805 "./../src/place.c"
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2808 "./../src/place.c"
Scheme_Object * scheme_place_make_async_channel () 
{
  Scheme_Place_Async_Channel * ch ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ch, 0)));
# define XfOrM427_COUNT (1)
# define SETUP_XfOrM427(x) SETUP(XfOrM427_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ch = NULLED_OUT ; 

# 2811 "./../src/place.c"
  ch = FUNCCALL(SETUP_XfOrM427(_), place_async_channel_create () ); 
  FUNCCALL_AGAIN(async_channel_refcount (ch , 0 , 1 ) )

  ; 
  FUNCCALL_AGAIN(async_channel_refcount (ch , 1 , 1 ) ); 

  RET_VALUE_START ((Scheme_Object * ) ch ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2820 "./../src/place.c"
static void bi_channel_refcount (Scheme_Place_Bi_Channel * ch , int delta ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ch, 0)));
# define XfOrM428_COUNT (1)
# define SETUP_XfOrM428(x) SETUP(XfOrM428_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM428(_), async_channel_refcount (ch -> link -> sendch , 1 , delta ) )
# 2822 "./../src/place.c"
  ; 
  FUNCCALL_EMPTY(async_channel_refcount (ch -> link -> recvch , 0 , delta ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2826 "./../src/place.c"
static void bi_channel_refcount_down (void * _ch , void * data ) 
{
  /* No conversion */

# 2828 "./../src/place.c"
  Scheme_Place_Bi_Channel * ch = (Scheme_Place_Bi_Channel * ) _ch ; 

  if (! ch -> link -> sendch ) {

    return ; 
  }

  if (ch -> link -> prev )
    ch -> link -> prev -> next = ch -> link -> next ; 
  else 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_channel_links_ ) = ch -> link -> next ; 
  if (ch -> link -> next )
    ch -> link -> next -> prev = ch -> link -> prev ; 

  bi_channel_refcount (ch , - 1 ) ; 
}

void scheme_free_place_bi_channels () 
{
  Scheme_Place_Bi_Channel_Link * link ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(link, 0)));
# define XfOrM431_COUNT (1)
# define SETUP_XfOrM431(x) SETUP(XfOrM431_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  link = NULLED_OUT ; 

# 2849 "./../src/place.c"
  for (link = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_channel_links_ ) ; link ; link = link -> next ) {
#   define XfOrM433_COUNT (0+XfOrM431_COUNT)
#   define SETUP_XfOrM433(x) SETUP_XfOrM431(x)
    FUNCCALL(SETUP_XfOrM433(_), async_channel_refcount (link -> sendch , 1 , - 1 ) )
# 2850 "./../src/place.c"
    ; 
    FUNCCALL(SETUP_XfOrM433(_), async_channel_refcount (link -> recvch , 0 , - 1 ) ); 

    link -> sendch = ((void * ) 0 ) ; 
    link -> recvch = ((void * ) 0 ) ; 
  }
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_channel_links_ ) = ((void * ) 0 ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2859 "./../src/place.c"
static void bi_channel_set_finalizer (Scheme_Place_Bi_Channel * ch ) 
{
  /* No conversion */

# 2861 "./../src/place.c"
  ch -> link -> next = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_channel_links_ ) ; 
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_channel_links_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_channel_links_ ) -> prev = ch -> link ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_channel_links_ ) = ch -> link ; 

  scheme_add_finalizer (ch , bi_channel_refcount_down , ((void * ) 0 ) ) ; 
}


Scheme_Place_Bi_Channel * place_bi_channel_malloc () {
  Scheme_Place_Bi_Channel * ch ; 
  Scheme_Place_Bi_Channel_Link * link ; 
  DECL_RET_SAVE (Scheme_Place_Bi_Channel * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(link, 1)));
# define XfOrM435_COUNT (2)
# define SETUP_XfOrM435(x) SETUP(XfOrM435_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ch = NULLED_OUT ; 
  link = NULLED_OUT ; 

# 2874 "./../src/place.c"
  ch = ((Scheme_Place_Bi_Channel * ) FUNCCALL(SETUP_XfOrM435(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Place_Bi_Channel ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  ch -> so . type = scheme_place_bi_channel_type ; 

  link = (Scheme_Place_Bi_Channel_Link * ) FUNCCALL(SETUP_XfOrM435(_), GC_malloc (sizeof (Scheme_Place_Bi_Channel_Link ) ) ); 
  ch -> link = link ; 

  RET_VALUE_START (ch ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2883 "./../src/place.c"
Scheme_Place_Bi_Channel * place_bi_channel_create () {
  Scheme_Place_Async_Channel * tmp ; 
  Scheme_Place_Bi_Channel * ch ; 
  DECL_RET_SAVE (Scheme_Place_Bi_Channel * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(tmp, 1)));
# define XfOrM436_COUNT (2)
# define SETUP_XfOrM436(x) SETUP(XfOrM436_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  tmp = NULLED_OUT ; 
  ch = NULLED_OUT ; 

# 2887 "./../src/place.c"
  ch = FUNCCALL(SETUP_XfOrM436(_), place_bi_channel_malloc () ); 

  tmp = FUNCCALL_AGAIN(place_async_channel_create () ); 
  ch -> link -> sendch = tmp ; 
  tmp = FUNCCALL(SETUP_XfOrM436(_), place_async_channel_create () ); 
  ch -> link -> recvch = tmp ; 
  FUNCCALL(SETUP_XfOrM436(_), bi_channel_refcount (ch , 1 ) )
  ; 
  FUNCCALL_AGAIN(bi_channel_set_finalizer (ch ) ); 

  RET_VALUE_START (ch ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2900 "./../src/place.c"
Scheme_Place_Bi_Channel * place_bi_peer_channel_create (Scheme_Place_Bi_Channel * orig ) {
  Scheme_Place_Bi_Channel * ch ; 
  DECL_RET_SAVE (Scheme_Place_Bi_Channel * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(orig, 1)));
# define XfOrM437_COUNT (2)
# define SETUP_XfOrM437(x) SETUP(XfOrM437_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ch = NULLED_OUT ; 

# 2903 "./../src/place.c"
  ch = FUNCCALL(SETUP_XfOrM437(_), place_bi_channel_malloc () ); 

  ch -> link -> sendch = orig -> link -> recvch ; 
  ch -> link -> recvch = orig -> link -> sendch ; 
  FUNCCALL(SETUP_XfOrM437(_), bi_channel_refcount (ch , 1 ) )
  ; 
  FUNCCALL_AGAIN(bi_channel_set_finalizer (ch ) ); 

  RET_VALUE_START (ch ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2914 "./../src/place.c"
static Scheme_Object * place_channel (int argc , Scheme_Object * args [] ) {
  Scheme_Place_Bi_Channel * ch ; 
  Scheme_Object * a [2 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSHARRAY(a, 2, 1)));
# define XfOrM438_COUNT (4)
# define SETUP_XfOrM438(x) SETUP(XfOrM438_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ch = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 2917 "./../src/place.c"
  ch = FUNCCALL(SETUP_XfOrM438(_), place_bi_channel_create () ); 
  a [0 ] = (Scheme_Object * ) ch ; 
  a [1 ] = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM438(_), place_bi_peer_channel_create (ch ) ); 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM438(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2923 "./../src/place.c"
static Scheme_Object * place_channel_p (int argc , Scheme_Object * args [] ) 
{
  /* No conversion */

# 2925 "./../src/place.c"
  return (((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_bi_channel_type ) ) || 
  ((Scheme_Type ) (((((intptr_t ) (args [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_place_type ) ) ) ? scheme_true : scheme_false ; 
}

static Scheme_Object * GC_master_make_vector (int size ) {
  Scheme_Object * v ; 

  void * original_gc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(original_gc, 0), PUSH(v, 1)));
# define XfOrM440_COUNT (2)
# define SETUP_XfOrM440(x) SETUP(XfOrM440_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  original_gc = NULLED_OUT ; 

# 2933 "./../src/place.c"
  original_gc = FUNCCALL(SETUP_XfOrM440(_), GC_switch_to_master_gc () ); 

  v = FUNCCALL_AGAIN(scheme_make_vector (size , ((void * ) 0 ) ) ); 
  FUNCCALL_AGAIN(GC_switch_back_from_master (original_gc ) )
  ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2942 "./../src/place.c"
static void place_async_send (Scheme_Place_Async_Channel * ch , Scheme_Object * uo ) {
  void * msg_memory = ((void * ) 0 ) ; 
  Scheme_Object * o , * master_chain = ((void * ) 0 ) , * invalid_object = ((void * ) 0 ) ; 
  intptr_t sz , cnt ; 
  char * delayed_err = ((void * ) 0 ) ; 
  intptr_t delayed_errno = 0 ; 
  intptr_t delayed_errkind = 0 ; 
  PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(master_chain, 0), PUSH(ch, 1), PUSH(delayed_err, 2), PUSH(uo, 3), PUSH(invalid_object, 4), PUSH(msg_memory, 5), PUSH(o, 6)));
# define XfOrM441_COUNT (7)
# define SETUP_XfOrM441(x) SETUP(XfOrM441_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  o = NULLED_OUT ; 

# 2951 "./../src/place.c"
  o = FUNCCALL(SETUP_XfOrM441(_), places_serialize (uo , & msg_memory , & master_chain , & invalid_object , & delayed_err , & delayed_errno , & delayed_errkind ) )
  ; 


  if (! o ) {
#   define XfOrM481_COUNT (0+XfOrM441_COUNT)
#   define SETUP_XfOrM481(x) SETUP_XfOrM441(x)

# 2956 "./../src/place.c"
    if (invalid_object && ! delayed_err ) {
#     define XfOrM482_COUNT (0+XfOrM481_COUNT)
#     define SETUP_XfOrM482(x) SETUP_XfOrM481(x)
      FUNCCALL(SETUP_XfOrM482(_), scheme_contract_error ("place-channel-put" , "value not allowed in a message" , "value" , 1 , invalid_object , "message" , 1 , uo , ((void * ) 0 ) ) )

      ; 
    }

# 2962 "./../src/place.c"
    else FUNCCALL(SETUP_XfOrM481(_), bad_place_message (uo , delayed_err , delayed_errno , delayed_errkind ) )
    ; 
  }

  {
    intptr_t msg_size ; 
#   define XfOrM480_COUNT (0+XfOrM441_COUNT)
#   define SETUP_XfOrM480(x) SETUP_XfOrM441(x)

# 2968 "./../src/place.c"
    msg_size = FUNCCALL(SETUP_XfOrM480(_), GC_message_allocator_size (msg_memory ) ); 
    FUNCCALL(SETUP_XfOrM480(_), log_place_event ("id %d: put message of %" "l" "d" " bytes" , "put" , 1 , msg_size ) ); 
  }
  FUNCCALL(SETUP_XfOrM441(_), mzrt_mutex_lock (ch -> 
  lock ) ); 
  {
#   define XfOrM468_COUNT (0+XfOrM441_COUNT)
#   define SETUP_XfOrM468(x) SETUP_XfOrM441(x)

# 2974 "./../src/place.c"
    cnt = ch -> count ; 
    if (ch -> count == ch -> size ) {
      Scheme_Object * * new_msgs = ((void * ) 0 ) , * * new_chains = ((void * ) 0 ) ; 
      void * * new_msg_memory = ((void * ) 0 ) ; 
      intptr_t sz = 0 ; 
      BLOCK_SETUP((PUSH(new_chains, 0+XfOrM468_COUNT), PUSH(new_msgs, 1+XfOrM468_COUNT), PUSH(new_msg_memory, 2+XfOrM468_COUNT)));
#     define XfOrM469_COUNT (3+XfOrM468_COUNT)
#     define SETUP_XfOrM469(x) SETUP(XfOrM469_COUNT)

# 2981 "./../src/place.c"
      while (ch -> count == ch -> size ) {
#       define XfOrM475_COUNT (0+XfOrM469_COUNT)
#       define SETUP_XfOrM475(x) SETUP_XfOrM469(x)

# 2982 "./../src/place.c"
        if ((sz == ch -> size ) && new_msgs ) {
#         define XfOrM477_COUNT (0+XfOrM475_COUNT)
#         define SETUP_XfOrM477(x) SETUP_XfOrM475(x)

# 2983 "./../src/place.c"
          if (ch -> out < ch -> in ) {
#           define XfOrM479_COUNT (0+XfOrM477_COUNT)
#           define SETUP_XfOrM479(x) SETUP_XfOrM477(x)
            (
# 2984 "./../src/place.c"
            memcpy (new_msgs , ch -> msgs + ch -> out , sizeof (Scheme_Object * ) * (ch -> in - ch -> out ) ) ) ; 
            (memcpy (new_msg_memory , ch -> msg_memory + ch -> out , sizeof (void * ) * (ch -> in - ch -> out ) ) ) ; 
            (memcpy (new_chains , ch -> msg_chains + ch -> out , sizeof (void * ) * (ch -> in - ch -> out ) ) ) ; 
          }
          else {
            int s1 = (ch -> size - ch -> out ) ; 
#           define XfOrM478_COUNT (0+XfOrM477_COUNT)
#           define SETUP_XfOrM478(x) SETUP_XfOrM477(x)
            (
# 2990 "./../src/place.c"
            memcpy (new_msgs , ch -> msgs + ch -> out , sizeof (Scheme_Object * ) * s1 ) ) ; 
            (memcpy (new_msgs + s1 , ch -> msgs , sizeof (Scheme_Object * ) * ch -> in ) ) ; 
            (
            memcpy (new_msg_memory , ch -> msg_memory + ch -> out , sizeof (void * ) * s1 ) ) ; 
            (memcpy (new_msg_memory + s1 , ch -> msg_memory , sizeof (void * ) * ch -> in ) ) ; 
            (
            memcpy (new_chains , ch -> msg_chains + ch -> out , sizeof (Scheme_Object * ) * s1 ) ) ; 
            (memcpy (new_chains + s1 , ch -> msg_chains , sizeof (Scheme_Object * ) * ch -> in ) ) ; 
          }

          ch -> msgs = new_msgs ; 
          ch -> msg_memory = new_msg_memory ; 
          ch -> msg_chains = new_chains ; 
          ch -> in = ch -> size ; 
          ch -> out = 0 ; 
          ch -> size *= 2 ; 

          break ; 
        }

# 3008 "./../src/place.c"
        else {
#         define XfOrM476_COUNT (0+XfOrM475_COUNT)
#         define SETUP_XfOrM476(x) SETUP_XfOrM475(x)

# 3009 "./../src/place.c"
          sz = ch -> size ; 
          FUNCCALL(SETUP_XfOrM476(_), mzrt_mutex_unlock (ch -> 
          lock ) )
# 3010 "./../src/place.c"
          ; 

          new_msgs = FUNCCALL_AGAIN(GC_master_malloc (sizeof (Scheme_Object * ) * sz * 2 ) ); 
          new_msg_memory = FUNCCALL_AGAIN(GC_master_malloc (sizeof (void * ) * sz * 2 ) ); 
          new_chains = FUNCCALL_AGAIN(GC_master_malloc (sizeof (Scheme_Object * ) * sz * 2 ) ); 
          FUNCCALL_AGAIN(mzrt_mutex_lock (ch -> 
          lock ) ); 
        }
      }
    }

    ch -> msgs [ch -> in ] = o ; 
    ch -> msg_memory [ch -> in ] = msg_memory ; 
    ch -> msg_chains [ch -> in ] = master_chain ; 
    ++ ch -> count ; 
    ch -> in = ((ch -> in + 1 ) % ch -> size ) ; 

    sz = FUNCCALL(SETUP_XfOrM468(_), GC_message_allocator_size (msg_memory ) ); 
    ch -> mem_size += sz ; 
    FUNCCALL(SETUP_XfOrM468(_), maybe_report_message_size (ch ) )
    ; 
  }


  if (! uo )
    FUNCCALL(SETUP_XfOrM441(_), scheme_signal_error ("?" ) )
# 3034 "./../src/place.c"
  ; 

  if (! cnt && ch -> wakeup_signal ) {
#   define XfOrM442_COUNT (0+XfOrM441_COUNT)
#   define SETUP_XfOrM442(x) SETUP_XfOrM441(x)

# 3038 "./../src/place.c"
    if (((((intptr_t ) (ch -> wakeup_signal ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ch -> wakeup_signal ) ) -> type ) == scheme_place_object_type )  {
      Scheme_Place_Object * place_obj ; 
      BLOCK_SETUP((PUSH(place_obj, 0+XfOrM442_COUNT)));
#     define XfOrM466_COUNT (1+XfOrM442_COUNT)
#     define SETUP_XfOrM466(x) SETUP(XfOrM466_COUNT)
      place_obj = NULLED_OUT ; 

# 3040 "./../src/place.c"
      place_obj = ((Scheme_Place_Object * ) ch -> wakeup_signal ) ; 
      FUNCCALL(SETUP_XfOrM466(_), mzrt_mutex_lock (place_obj -> 
      lock ) ); 
      if (place_obj -> signal_handle ) {
#       define XfOrM467_COUNT (0+XfOrM466_COUNT)
#       define SETUP_XfOrM467(x) SETUP_XfOrM466(x)
        FUNCCALL(SETUP_XfOrM467(_), scheme_signal_received_at (place_obj -> signal_handle ) )
# 3044 "./../src/place.c"
        ; 
      }
      FUNCCALL(SETUP_XfOrM466(_), mzrt_mutex_unlock (place_obj -> 
      lock ) )
# 3046 "./../src/place.c"
      ; 
    }

    else if ((Scheme_Type ) (((((intptr_t ) (ch -> wakeup_signal ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ch -> wakeup_signal ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
      Scheme_Object * v = ch -> wakeup_signal ; 
      int i , j , delta ; 
      int size = (((Scheme_Vector * ) (v ) ) -> size ) ; 
      int alive = 0 ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM442_COUNT)));
#     define XfOrM444_COUNT (1+XfOrM442_COUNT)
#     define SETUP_XfOrM444(x) SETUP(XfOrM444_COUNT)

# 3056 "./../src/place.c"
      delta = ch -> delta ++ ; 
      if (delta < 0 )

# 3057 "./../src/place.c"
      delta = - delta ; 
      for (j = 0 ; j < size ; j ++ ) {
        Scheme_Place_Object * o3 ; 
        BLOCK_SETUP((PUSH(o3, 0+XfOrM444_COUNT)));
#       define XfOrM461_COUNT (1+XfOrM444_COUNT)
#       define SETUP_XfOrM461(x) SETUP(XfOrM461_COUNT)
        o3 = NULLED_OUT ; 

# 3060 "./../src/place.c"
        i = (j + delta ) % size ; 
        o3 = (Scheme_Place_Object * ) (((Scheme_Vector * ) (v ) ) -> els ) [i ] ; 
        if (o3 ) {
          int refcount = 0 ; 
#         define XfOrM462_COUNT (0+XfOrM461_COUNT)
#         define SETUP_XfOrM462(x) SETUP_XfOrM461(x)
          FUNCCALL(SETUP_XfOrM462(_), mzrt_mutex_lock (o3 -> 
          lock ) )
# 3064 "./../src/place.c"
          ; 
          if (o3 -> signal_handle != ((void * ) 0 ) ) {
#           define XfOrM465_COUNT (0+XfOrM462_COUNT)
#           define SETUP_XfOrM465(x) SETUP_XfOrM462(x)
            FUNCCALL(SETUP_XfOrM465(_), scheme_signal_received_at (o3 -> signal_handle ) )
# 3066 "./../src/place.c"
            ; 
            alive ++ ; 
          }
          else {
            (((Scheme_Vector * ) (v ) ) -> els ) [i ] = ((void * ) 0 ) ; 
            o3 -> refcount -- ; 
          }
          refcount = o3 -> refcount ; 
          FUNCCALL(SETUP_XfOrM462(_), mzrt_mutex_unlock (o3 -> 
          lock ) )
# 3074 "./../src/place.c"
          ; 

          if (! refcount ) {
#           define XfOrM463_COUNT (0+XfOrM462_COUNT)
#           define SETUP_XfOrM463(x) SETUP_XfOrM462(x)
            FUNCCALL(SETUP_XfOrM463(_), destroy_place_object_locks (o3 ) )
# 3077 "./../src/place.c"
            ; 
          }
        }
      }

      if (alive < (size / 2 ) ) {
#       define XfOrM445_COUNT (0+XfOrM444_COUNT)
#       define SETUP_XfOrM445(x) SETUP_XfOrM444(x)

# 3083 "./../src/place.c"
        if (alive == 1 ) {
          ch -> wakeup_signal = ((void * ) 0 ) ; 
          for (i = 0 ; i < size ; i ++ ) {
            Scheme_Place_Object * o2 = (Scheme_Place_Object * ) (((Scheme_Vector * ) (v ) ) -> els ) [i ] ; 
            if (o2 ) {
              ch -> wakeup_signal = (Scheme_Object * ) o2 ; 
              break ; 
            }
          }
        }
        else {
          Scheme_Object * nv ; 
          int ncnt = 0 ; 
          BLOCK_SETUP((PUSH(nv, 0+XfOrM445_COUNT)));
#         define XfOrM446_COUNT (1+XfOrM445_COUNT)
#         define SETUP_XfOrM446(x) SETUP(XfOrM446_COUNT)
          nv = NULLED_OUT ; 

# 3096 "./../src/place.c"
          nv = FUNCCALL(SETUP_XfOrM446(_), GC_master_make_vector (size / 2 ) ); 
          for (i = 0 ; i < size ; i ++ ) {
            Scheme_Place_Object * o2 = (Scheme_Place_Object * ) (((Scheme_Vector * ) (v ) ) -> els ) [i ] ; 
            if (o2 ) {
              (((Scheme_Vector * ) (nv ) ) -> els ) [ncnt ] = (Scheme_Object * ) o2 ; 
              ncnt ++ ; 
            }
          }
          ch -> wakeup_signal = nv ; 
        }
      }
    }
    else {
#     define XfOrM443_COUNT (0+XfOrM442_COUNT)
#     define SETUP_XfOrM443(x) SETUP_XfOrM442(x)
      (
# 3109 "./../src/place.c"
      printf ("Oops not a valid ch->wakeup_signal\n" ) ) ; 
      FUNCCALL(SETUP_XfOrM443(_), exit (1 ) ); 
    }
  }
  FUNCCALL(SETUP_XfOrM441(_), mzrt_mutex_unlock (ch -> 
  lock ) )
# 3113 "./../src/place.c"
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3116 "./../src/place.c"
void scheme_place_async_channel_send (Scheme_Object * ch , Scheme_Object * uo ) {
  /* No conversion */

# 3117 "./../src/place.c"
  place_async_send ((Scheme_Place_Async_Channel * ) ch , uo ) ; 
}

static void place_object_inc_refcount (Scheme_Object * o ) {
  Scheme_Place_Object * place_obj ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(place_obj, 0)));
# define XfOrM484_COUNT (1)
# define SETUP_XfOrM484(x) SETUP(XfOrM484_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  place_obj = NULLED_OUT ; 

# 3122 "./../src/place.c"
  place_obj = (Scheme_Place_Object * ) o ; 
  FUNCCALL(SETUP_XfOrM484(_), mzrt_mutex_lock (place_obj -> 
  lock ) ); 
  place_obj -> refcount ++ ; 
  FUNCCALL_EMPTY(mzrt_mutex_unlock (place_obj -> 
  lock ) )
# 3126 "./../src/place.c"
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3129 "./../src/place.c"
static void place_object_dec_refcount (Scheme_Object * o ) {
  int refcount ; 
  Scheme_Place_Object * place_obj ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(place_obj, 0)));
# define XfOrM485_COUNT (1)
# define SETUP_XfOrM485(x) SETUP(XfOrM485_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  place_obj = NULLED_OUT ; 

# 3132 "./../src/place.c"
  place_obj = (Scheme_Place_Object * ) o ; 
  FUNCCALL(SETUP_XfOrM485(_), mzrt_mutex_lock (place_obj -> 
  lock ) ); 
  place_obj -> refcount -- ; 
  refcount = place_obj -> refcount ; 
  FUNCCALL(SETUP_XfOrM485(_), mzrt_mutex_unlock (place_obj -> 
  lock ) )
# 3137 "./../src/place.c"
  ; 

  if (! refcount ) {
#   define XfOrM486_COUNT (0+XfOrM485_COUNT)
#   define SETUP_XfOrM486(x) SETUP_XfOrM485(x)
    FUNCCALL_EMPTY(destroy_place_object_locks (place_obj ) )
# 3140 "./../src/place.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3144 "./../src/place.c"
static void lock_and_register_place_object_with_channel (Scheme_Place_Async_Channel * ch , Scheme_Object * o ) 
{
  Scheme_Object * avail_vector ; 
  PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(avail_vector, 1), PUSH(o, 2)));
# define XfOrM487_COUNT (3)
# define SETUP_XfOrM487(x) SETUP(XfOrM487_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  avail_vector = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM487(_), mzrt_mutex_lock (ch -> 
  lock ) )
# 3148 "./../src/place.c"
  ; 

  if (ch -> count )
    RET_NOTHING ; 


  while (1 ) {
#   define XfOrM510_COUNT (0+XfOrM487_COUNT)
#   define SETUP_XfOrM510(x) SETUP_XfOrM487(x)

# 3155 "./../src/place.c"
    if (ch -> wakeup_signal == o ) {
      RET_NOTHING ; 
    }
    else if (! ch -> wakeup_signal ) {
#     define XfOrM530_COUNT (0+XfOrM510_COUNT)
#     define SETUP_XfOrM530(x) SETUP_XfOrM510(x)
      FUNCCALL(SETUP_XfOrM530(_), place_object_inc_refcount (o ) )
# 3159 "./../src/place.c"
      ; 
      ch -> wakeup_signal = o ; 
      RET_NOTHING ; 
    }
    else if ((((((intptr_t ) (ch -> wakeup_signal ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ch -> wakeup_signal ) ) -> type ) == scheme_place_object_type ) 
    && ((Scheme_Place_Object * ) ch -> wakeup_signal ) -> signal_handle == ((void * ) 0 ) ) {
#     define XfOrM529_COUNT (0+XfOrM510_COUNT)
#     define SETUP_XfOrM529(x) SETUP_XfOrM510(x)
      FUNCCALL(SETUP_XfOrM529(_), place_object_dec_refcount (ch -> wakeup_signal ) )
# 3165 "./../src/place.c"
      ; 
      FUNCCALL(SETUP_XfOrM529(_), place_object_inc_refcount (o ) ); 
      ch -> wakeup_signal = o ; 
      RET_NOTHING ; 
    }
    else if ((Scheme_Type ) (((((intptr_t ) (ch -> wakeup_signal ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ch -> wakeup_signal ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
      int i = 0 ; 
      Scheme_Object * v = ch -> wakeup_signal ; 
      int size = (((Scheme_Vector * ) (v ) ) -> size ) ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM510_COUNT)));
#     define XfOrM515_COUNT (1+XfOrM510_COUNT)
#     define SETUP_XfOrM515(x) SETUP(XfOrM515_COUNT)

# 3175 "./../src/place.c"
      for (i = 0 ; i < size ; i ++ ) {
        Scheme_Object * vo = (((Scheme_Vector * ) (v ) ) -> els ) [i ] ; 
        if (vo == o )
          RET_NOTHING ; 
      }

      for (i = 0 ; i < size ; i ++ ) {
        Scheme_Object * vo = (((Scheme_Vector * ) (v ) ) -> els ) [i ] ; 
        BLOCK_SETUP((PUSH(vo, 0+XfOrM515_COUNT)));
#       define XfOrM524_COUNT (1+XfOrM515_COUNT)
#       define SETUP_XfOrM524(x) SETUP(XfOrM524_COUNT)

# 3183 "./../src/place.c"
        if (! vo ) {
#         define XfOrM526_COUNT (0+XfOrM524_COUNT)
#         define SETUP_XfOrM526(x) SETUP_XfOrM524(x)
          FUNCCALL(SETUP_XfOrM526(_), place_object_inc_refcount (o ) )
# 3184 "./../src/place.c"
          ; 
          (((Scheme_Vector * ) (v ) ) -> els ) [i ] = o ; 
          RET_NOTHING ; 
        }
        else if ((((((intptr_t ) (vo ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vo ) ) -> type ) == scheme_place_object_type ) && 
        ((Scheme_Place_Object * ) vo ) -> signal_handle == ((void * ) 0 ) ) {
#         define XfOrM525_COUNT (0+XfOrM524_COUNT)
#         define SETUP_XfOrM525(x) SETUP_XfOrM524(x)
          FUNCCALL(SETUP_XfOrM525(_), place_object_dec_refcount (vo ) )
# 3190 "./../src/place.c"
          ; 
          FUNCCALL(SETUP_XfOrM525(_), place_object_inc_refcount (o ) ); 
          (((Scheme_Vector * ) (v ) ) -> els ) [i ] = o ; 
          RET_NOTHING ; 
        }
      }


      {
#       define XfOrM516_COUNT (0+XfOrM515_COUNT)
#       define SETUP_XfOrM516(x) SETUP_XfOrM515(x)

# 3199 "./../src/place.c"
        if (avail_vector && ((((Scheme_Vector * ) (avail_vector ) ) -> size ) == size * 2 ) ) {
          Scheme_Object * nv ; 
          BLOCK_SETUP((PUSH(nv, 0+XfOrM516_COUNT)));
#         define XfOrM518_COUNT (1+XfOrM516_COUNT)
#         define SETUP_XfOrM518(x) SETUP(XfOrM518_COUNT)
          nv = NULLED_OUT ; 

# 3201 "./../src/place.c"
          nv = avail_vector ; 
          for (i = 0 ; i < size ; i ++ ) {
            (((Scheme_Vector * ) (nv ) ) -> els ) [i ] = (((Scheme_Vector * ) (v ) ) -> els ) [i ] ; 
          }
          FUNCCALL(SETUP_XfOrM518(_), place_object_inc_refcount (o ) ); 
          (((Scheme_Vector * ) (nv ) ) -> els ) [size + 1 ] = o ; 
          ch -> wakeup_signal = nv ; 
        }

# 3208 "./../src/place.c"
        else {
#         define XfOrM517_COUNT (0+XfOrM516_COUNT)
#         define SETUP_XfOrM517(x) SETUP_XfOrM516(x)
          FUNCCALL(SETUP_XfOrM517(_), mzrt_mutex_unlock (ch -> 
          lock ) )
# 3209 "./../src/place.c"
          ; 
          avail_vector = FUNCCALL(SETUP_XfOrM517(_), GC_master_make_vector (size * 2 ) ); 
          FUNCCALL_AGAIN(mzrt_mutex_lock (ch -> 
          lock ) )
# 3211 "./../src/place.c"
          ; 
        }
      }
    }

    else if (((((intptr_t ) (ch -> wakeup_signal ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ch -> wakeup_signal ) ) -> type ) == scheme_place_object_type )  {
#     define XfOrM512_COUNT (0+XfOrM510_COUNT)
#     define SETUP_XfOrM512(x) SETUP_XfOrM510(x)

# 3217 "./../src/place.c"
      if (avail_vector && ((((Scheme_Vector * ) (avail_vector ) ) -> size ) == 2 ) ) {
        Scheme_Object * v ; 
        BLOCK_SETUP((PUSH(v, 0+XfOrM512_COUNT)));
#       define XfOrM514_COUNT (1+XfOrM512_COUNT)
#       define SETUP_XfOrM514(x) SETUP(XfOrM514_COUNT)
        v = NULLED_OUT ; 

# 3219 "./../src/place.c"
        v = avail_vector ; 
        (((Scheme_Vector * ) (v ) ) -> els ) [0 ] = ch -> wakeup_signal ; 
        FUNCCALL(SETUP_XfOrM514(_), place_object_inc_refcount (o ) ); 
        (((Scheme_Vector * ) (v ) ) -> els ) [1 ] = o ; 
        ch -> wakeup_signal = v ; 
      }

# 3224 "./../src/place.c"
      else {
#       define XfOrM513_COUNT (0+XfOrM512_COUNT)
#       define SETUP_XfOrM513(x) SETUP_XfOrM512(x)
        FUNCCALL(SETUP_XfOrM513(_), mzrt_mutex_unlock (ch -> 
        lock ) )
# 3225 "./../src/place.c"
        ; 
        avail_vector = FUNCCALL(SETUP_XfOrM513(_), GC_master_make_vector (2 ) ); 
        FUNCCALL_AGAIN(mzrt_mutex_lock (ch -> 
        lock ) )
# 3227 "./../src/place.c"
        ; 
      }
    }
    else {
#     define XfOrM511_COUNT (0+XfOrM510_COUNT)
#     define SETUP_XfOrM511(x) SETUP_XfOrM510(x)
      (
# 3231 "./../src/place.c"
      printf ("Oops not a valid ch->wakeup_signal\n" ) ) ; 
      FUNCCALL_EMPTY(exit (1 ) ); 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3237 "./../src/place.c"
static Scheme_Object * place_async_try_receive_raw (Scheme_Place_Async_Channel * ch , 
void * * msg_memory_ptr , 
void * * msg_chain_ptr , 
int * _no_writers ) 

{
  Scheme_Object * msg = ((void * ) 0 ) ; 
  void * msg_memory = ((void * ) 0 ) , * msg_chain = ((void * ) 0 ) ; 
  intptr_t sz ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(msg_chain_ptr, 0), PUSH(ch, 1), PUSH(_no_writers, 2), PUSH(msg_memory_ptr, 3), PUSH(msg_memory, 4), PUSH(msg_chain, 5), PUSH(msg, 6)));
# define XfOrM532_COUNT (7)
# define SETUP_XfOrM532(x) SETUP(XfOrM532_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM532(_), lock_and_register_place_object_with_channel (ch , (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) ) )
# 3247 "./../src/place.c"
  ; 
  {
#   define XfOrM533_COUNT (0+XfOrM532_COUNT)
#   define SETUP_XfOrM533(x) SETUP_XfOrM532(x)

# 3249 "./../src/place.c"
    if (ch -> count > 0 ) {
#     define XfOrM534_COUNT (0+XfOrM533_COUNT)
#     define SETUP_XfOrM534(x) SETUP_XfOrM533(x)

# 3250 "./../src/place.c"
      msg = ch -> msgs [ch -> out ] ; 
      msg_memory = ch -> msg_memory [ch -> out ] ; 
      msg_chain = ch -> msg_chains [ch -> out ] ; 

      ch -> msgs [ch -> out ] = ((void * ) 0 ) ; 
      ch -> msg_memory [ch -> out ] = ((void * ) 0 ) ; 
      ch -> msg_chains [ch -> out ] = ((void * ) 0 ) ; 



      -- ch -> count ; 
      ch -> out = ((ch -> out + 1 ) % ch -> size ) ; 

      sz = FUNCCALL(SETUP_XfOrM534(_), GC_message_allocator_size (msg_memory ) ); 
      ch -> mem_size -= sz ; 
      FUNCCALL(SETUP_XfOrM534(_), maybe_report_message_size (ch ) )
      ; 
    }
  }
  if (! msg && ! ch -> wr_ref && _no_writers )
    * _no_writers = 1 ; 
  FUNCCALL(SETUP_XfOrM532(_), mzrt_mutex_unlock (ch -> 
  lock ) )
# 3271 "./../src/place.c"
  ; 

  * msg_memory_ptr = msg_memory ; 
  * msg_chain_ptr = msg_chain ; 

  RET_VALUE_START (msg ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3279 "./../src/place.c"
static void cleanup_msg_memmory (void * thread ) {
  Scheme_Thread * p = thread ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM535_COUNT (1)
# define SETUP_XfOrM535(x) SETUP(XfOrM535_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3281 "./../src/place.c"
  if (p -> place_channel_msg_in_flight ) {
#   define XfOrM536_COUNT (0+XfOrM535_COUNT)
#   define SETUP_XfOrM536(x) SETUP_XfOrM535(x)

# 3282 "./../src/place.c"
    p -> place_channel_msg_chain_in_flight = ((void * ) 0 ) ; 
    FUNCCALL(SETUP_XfOrM536(_), GC_destroy_orphan_msg_memory (p -> place_channel_msg_in_flight ) ); 
    p -> place_channel_msg_in_flight = ((void * ) 0 ) ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3288 "./../src/place.c"
static void log_received_msg (Scheme_Object * msg , void * msg_memory ) 
{
  /* No conversion */

# 3290 "./../src/place.c"
  if (msg ) {
    intptr_t msg_size ; 
    msg_size = GC_message_allocator_size (msg_memory ) ; 
    log_place_event ("id %d: get message of %" "l" "d" " bytes" , "get" , 1 , msg_size ) ; 
  }
}

static Scheme_Object * place_async_try_receive (Scheme_Place_Async_Channel * ch , int * _no_writers ) {
  Scheme_Object * msg = ((void * ) 0 ) ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  GC_CAN_IGNORE void * msg_memory , * msg_chain ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(_no_writers, 1), PUSH(msg, 2), PUSH(p, 3)));
# define XfOrM539_COUNT (4)
# define SETUP_XfOrM539(x) SETUP(XfOrM539_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3301 "./../src/place.c"
  {

# 3301 "./../src/place.c"
    mz_jmp_buf * volatile savebuf , newbuf ; 

# 3301 "./../src/place.c"
    Scheme_Thread * thread ; 
    BLOCK_SETUP((PUSH(thread, 0+XfOrM539_COUNT), PUSH(savebuf, 1+XfOrM539_COUNT)));
#   define XfOrM540_COUNT (2+XfOrM539_COUNT)
#   define SETUP_XfOrM540(x) SETUP(XfOrM540_COUNT)
    savebuf = NULLED_OUT ; 
    thread = NULLED_OUT ; 

# 3301 "./../src/place.c"
    thread = (scheme_get_current_thread () ) ; 
    FUNCCALL(SETUP_XfOrM540(_), scheme_push_kill_action ((Scheme_Kill_Action_Func ) cleanup_msg_memmory , (void * ) p ) )
# 3301 "./../src/place.c"
    ; 

# 3301 "./../src/place.c"
    savebuf = thread -> error_buf ; 

# 3301 "./../src/place.c"
    thread -> error_buf = & newbuf ; 

# 3301 "./../src/place.c"
    thread = ((void * ) 0 ) ; 

# 3301 "./../src/place.c"
    if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM540_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#     define XfOrM543_COUNT (0+XfOrM540_COUNT)
#     define SETUP_XfOrM543(x) SETUP_XfOrM540(x)
      FUNCCALL(SETUP_XfOrM543(_), scheme_pop_kill_action () )
# 3301 "./../src/place.c"
      ; 

# 3301 "./../src/place.c"
      thread = (scheme_get_current_thread () ) ; 

# 3301 "./../src/place.c"
      if (! thread -> cjs . skip_dws ) {
#       define XfOrM544_COUNT (0+XfOrM543_COUNT)
#       define SETUP_XfOrM544(x) SETUP_XfOrM543(x)
        FUNCCALL(SETUP_XfOrM544(_), cleanup_msg_memmory (p ) )
# 3301 "./../src/place.c"
        ; 
      }

# 3301 "./../src/place.c"
      (((intptr_t * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* savebuf ) . gcvs , longjmp ((* savebuf ) . jb , 1 ) ) ; 
    }

# 3301 "./../src/place.c"
    else {
#     define XfOrM541_COUNT (0+XfOrM540_COUNT)
#     define SETUP_XfOrM541(x) SETUP_XfOrM540(x)

# 3301 "./../src/place.c"
      ; 
      msg = FUNCCALL(SETUP_XfOrM541(_), place_async_try_receive_raw (ch , & msg_memory , & msg_chain , _no_writers ) ); 

      if (msg ) {
#       define XfOrM542_COUNT (0+XfOrM541_COUNT)
#       define SETUP_XfOrM542(x) SETUP_XfOrM541(x)

# 3305 "./../src/place.c"
        p -> place_channel_msg_in_flight = msg_memory ; 
        p -> place_channel_msg_chain_in_flight = msg_chain ; 
        FUNCCALL(SETUP_XfOrM542(_), log_received_msg (msg , msg_memory ) ); 
        msg = FUNCCALL_AGAIN(places_deserialize (msg , msg_memory , p ) ); 
      }
      thread = (scheme_get_current_thread () ) ; 
      FUNCCALL(SETUP_XfOrM541(_), scheme_pop_kill_action () )
# 3310 "./../src/place.c"
      ; 

# 3310 "./../src/place.c"
      thread -> error_buf = savebuf ; 

# 3310 "./../src/place.c"
      thread = ((void * ) 0 ) ; 
    }
  }

# 3310 "./../src/place.c"
  ; 
  RET_VALUE_START (msg ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3314 "./../src/place.c"
static int scheme_place_async_ch_ready (Scheme_Place_Async_Channel * ch ) {
  int ready = 0 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(ch, 0)));
# define XfOrM545_COUNT (1)
# define SETUP_XfOrM545(x) SETUP(XfOrM545_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM545(_), lock_and_register_place_object_with_channel (ch , (Scheme_Object * ) XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) ) )
# 3316 "./../src/place.c"
  ; 
  {
    if (ch -> count > 0 )

# 3318 "./../src/place.c"
    ready = 1 ; 
    if (! ch -> wr_ref )

# 3319 "./../src/place.c"
    ready = 1 ; 
  }
  FUNCCALL_EMPTY(mzrt_mutex_unlock (ch -> 
  lock ) )
# 3321 "./../src/place.c"
  ; 
  RET_VALUE_START (ready ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3325 "./../src/place.c"
static Scheme_Object * place_channel_finish_ready (void * d , int argc , struct Scheme_Object * argv [] ) 
{
  Scheme_Object * msg ; 
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(msg, 0), PUSH(p, 1)));
# define XfOrM547_COUNT (2)
# define SETUP_XfOrM547(x) SETUP(XfOrM547_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  msg = NULLED_OUT ; 

# 3330 "./../src/place.c"
  msg = * (Scheme_Object * * ) d ; 

  {

# 3332 "./../src/place.c"
    mz_jmp_buf * volatile savebuf , newbuf ; 

# 3332 "./../src/place.c"
    Scheme_Thread * thread ; 
    BLOCK_SETUP((PUSH(thread, 0+XfOrM547_COUNT), PUSH(savebuf, 1+XfOrM547_COUNT)));
#   define XfOrM548_COUNT (2+XfOrM547_COUNT)
#   define SETUP_XfOrM548(x) SETUP(XfOrM548_COUNT)
    savebuf = NULLED_OUT ; 
    thread = NULLED_OUT ; 

# 3332 "./../src/place.c"
    thread = (scheme_get_current_thread () ) ; 
    FUNCCALL(SETUP_XfOrM548(_), scheme_push_kill_action ((Scheme_Kill_Action_Func ) cleanup_msg_memmory , (void * ) p ) )
# 3332 "./../src/place.c"
    ; 

# 3332 "./../src/place.c"
    savebuf = thread -> error_buf ; 

# 3332 "./../src/place.c"
    thread -> error_buf = & newbuf ; 

# 3332 "./../src/place.c"
    thread = ((void * ) 0 ) ; 

# 3332 "./../src/place.c"
    if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM548_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#     define XfOrM550_COUNT (0+XfOrM548_COUNT)
#     define SETUP_XfOrM550(x) SETUP_XfOrM548(x)
      FUNCCALL(SETUP_XfOrM550(_), scheme_pop_kill_action () )
# 3332 "./../src/place.c"
      ; 

# 3332 "./../src/place.c"
      thread = (scheme_get_current_thread () ) ; 

# 3332 "./../src/place.c"
      if (! thread -> cjs . skip_dws ) {
#       define XfOrM551_COUNT (0+XfOrM550_COUNT)
#       define SETUP_XfOrM551(x) SETUP_XfOrM550(x)
        FUNCCALL(SETUP_XfOrM551(_), cleanup_msg_memmory (p ) )
# 3332 "./../src/place.c"
        ; 
      }

# 3332 "./../src/place.c"
      (((intptr_t * ) (void * ) ((* savebuf ) . gcvs ) ) [1 ] = (* savebuf ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* savebuf ) . gcvs , longjmp ((* savebuf ) . jb , 1 ) ) ; 
    }

# 3332 "./../src/place.c"
    else {
#     define XfOrM549_COUNT (0+XfOrM548_COUNT)
#     define SETUP_XfOrM549(x) SETUP_XfOrM548(x)

# 3332 "./../src/place.c"
      ; 
      msg = FUNCCALL(SETUP_XfOrM549(_), places_deserialize (msg , p -> place_channel_msg_in_flight , p ) ); 
      thread = (scheme_get_current_thread () ) ; 
      FUNCCALL(SETUP_XfOrM549(_), scheme_pop_kill_action () )
# 3334 "./../src/place.c"
      ; 

# 3334 "./../src/place.c"
      thread -> error_buf = savebuf ; 

# 3334 "./../src/place.c"
      thread = ((void * ) 0 ) ; 
    }
  }

# 3334 "./../src/place.c"
  ; 

  RET_VALUE_START (msg ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3339 "./../src/place.c"
static int place_channel_ready (Scheme_Object * so , Scheme_Schedule_Info * sinfo ) {
  Scheme_Place_Bi_Channel * ch ; 
  Scheme_Object * msg = ((void * ) 0 ) ; 
  Scheme_Object * wrapper ; 
  GC_CAN_IGNORE void * msg_memory = ((void * ) 0 ) , * msg_chain = ((void * ) 0 ) ; 
  int no_writers = 0 ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(msg, 0), PUSH(sinfo, 1), PUSH(wrapper, 2)));
# define XfOrM552_COUNT (3)
# define SETUP_XfOrM552(x) SETUP(XfOrM552_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  ch = NULLED_OUT ; 
  wrapper = NULLED_OUT ; 

# 3346 "./../src/place.c"
  if ((Scheme_Type ) (((((intptr_t ) (so ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (so ) ) -> type ) ) == (Scheme_Type ) (scheme_place_type ) )  {
    ch = (Scheme_Place_Bi_Channel * ) ((Scheme_Place * ) so ) -> channel ; 
  }
  else {
    ch = (Scheme_Place_Bi_Channel * ) so ; 
  }

  msg = FUNCCALL(SETUP_XfOrM552(_), place_async_try_receive_raw ((Scheme_Place_Async_Channel * ) ch -> link -> recvch , & msg_memory , & msg_chain , & no_writers ) )
  ; 

  if (msg != ((void * ) 0 ) ) {
    Scheme_Object * * msg_holder ; 
    Scheme_Thread * p = ((Syncing * ) (sinfo -> current_syncing ) ) -> thread ; 
    BLOCK_SETUP((PUSH(msg_holder, 0+XfOrM552_COUNT)));
#   define XfOrM554_COUNT (1+XfOrM552_COUNT)
#   define SETUP_XfOrM554(x) SETUP(XfOrM554_COUNT)
    msg_holder = NULLED_OUT ; 

# 3360 "./../src/place.c"
    p -> place_channel_msg_in_flight = msg_memory ; 
    p -> place_channel_msg_chain_in_flight = msg_chain ; 
    FUNCCALL(SETUP_XfOrM554(_), log_received_msg (msg , msg_memory ) )
    ; 




    msg_holder = (Scheme_Object * * ) FUNCCALL(SETUP_XfOrM554(_), GC_malloc_atomic (sizeof (Scheme_Object * ) ) ); 
    * msg_holder = msg ; 

    wrapper = FUNCCALL(SETUP_XfOrM554(_), scheme_make_closed_prim (place_channel_finish_ready , msg_holder ) ); 
    FUNCCALL_AGAIN(scheme_set_sync_target (sinfo , scheme_void , wrapper , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) ); 

    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

  if (no_writers ) {
#   define XfOrM553_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM553(x) SETUP_XfOrM552(x)
    (__funcarg86 = FUNCCALL(SETUP_XfOrM553(_), scheme_make_sema (0 ) ), FUNCCALL_AGAIN(scheme_set_sync_target (sinfo , __funcarg86 , scheme_void , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) )) ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3387 "./../src/place.c"
static Scheme_Object * place_async_receive (Scheme_Place_Async_Channel * ch ) {
  Scheme_Object * msg = ((void * ) 0 ) ; 
  int no_writers = 0 ; 
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(ch, 0), PUSH(msg, 1)));
# define XfOrM557_COUNT (2)
# define SETUP_XfOrM557(x) SETUP(XfOrM557_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3391 "./../src/place.c"
  while (1 ) {
#   define XfOrM561_COUNT (0+XfOrM557_COUNT)
#   define SETUP_XfOrM561(x) SETUP_XfOrM557(x)

# 3392 "./../src/place.c"
    msg = FUNCCALL(SETUP_XfOrM561(_), place_async_try_receive (ch , & no_writers ) ); 
    if (msg )
      break ; 
    else {
#     define XfOrM562_COUNT (0+XfOrM561_COUNT)
#     define SETUP_XfOrM562(x) SETUP_XfOrM561(x)

# 3396 "./../src/place.c"
      if (no_writers ) {
#       define XfOrM563_COUNT (0+XfOrM562_COUNT)
#       define SETUP_XfOrM563(x) SETUP_XfOrM562(x)
        (__funcarg88 = FUNCCALL(SETUP_XfOrM563(_), scheme_make_sema (0 ) )
# 3398 "./../src/place.c"
        , FUNCCALL_AGAIN(scheme_wait_sema (__funcarg88 , 0 ) )) ; 
      }
      FUNCCALL(SETUP_XfOrM562(_), scheme_thread_block (0 ) ); 
      FUNCCALL(SETUP_XfOrM562(_), scheme_block_until ((Scheme_Ready_Fun ) scheme_place_async_ch_ready , ((void * ) 0 ) , (Scheme_Object * ) ch , 0 ) ); 
    }
  }

  RET_VALUE_START (msg ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3408 "./../src/place.c"
Scheme_Object * scheme_place_async_channel_receive (Scheme_Object * ch ) {
  /* No conversion */

# 3409 "./../src/place.c"
  return place_async_receive ((Scheme_Place_Async_Channel * ) ch ) ; 
}

int scheme_place_can_receive () 
{
  /* No conversion */

# 3414 "./../src/place.c"
  return ! ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> place_object_ ) ; 
}

# 3 "./../src/mzmark_place.inc"
static int place_bi_channel_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int place_bi_channel_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Place_Bi_Channel * pbc = (Scheme_Place_Bi_Channel * ) p ; 
  GC_mark2 (& (pbc -> link ) , gc ) ; 


  return 0 ; 
}






static int place_bi_channel_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Place_Bi_Channel * pbc = (Scheme_Place_Bi_Channel * ) p ; 
  GC_fixup2 (& (pbc -> link ) , gc ) ; 


  return 0 ; 
}

# 43 "./../src/mzmark_place.inc"
static int place_object_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int place_object_val_MARK (void * p , struct NewGC * gc ) {


  return 0 ; 
}






static int place_object_val_FIXUP (void * p , struct NewGC * gc ) {


  return 0 ; 
}

# 77 "./../src/mzmark_place.inc"
static int place_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int place_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Place * pr = (Scheme_Place * ) p ; 
  GC_mark2 (& (pr -> channel ) , gc ) ; 
  GC_mark2 (& (pr -> mref ) , gc ) ; 
  GC_mark2 (& (pr -> pumper_threads ) , gc ) ; 
  GC_mark2 (& (pr -> place_obj ) , gc ) ; 
  GC_mark2 (& (pr -> prev ) , gc ) ; 
  GC_mark2 (& (pr -> next ) , gc ) ; 


  return 0 ; 
}






static int place_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Place * pr = (Scheme_Place * ) p ; 
  GC_fixup2 (& (pr -> channel ) , gc ) ; 
  GC_fixup2 (& (pr -> mref ) , gc ) ; 
  GC_fixup2 (& (pr -> pumper_threads ) , gc ) ; 
  GC_fixup2 (& (pr -> place_obj ) , gc ) ; 
  GC_fixup2 (& (pr -> prev ) , gc ) ; 
  GC_fixup2 (& (pr -> next ) , gc ) ; 


  return 0 ; 
}

# 127 "./../src/mzmark_place.inc"
static int place_async_channel_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int place_async_channel_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Place_Async_Channel * pac = (Scheme_Place_Async_Channel * ) p ; 
  Scheme_Object * pr ; 
  int i , j , sz ; 
  GC_mark2 (& (pac -> msgs ) , gc ) ; 
  GC_mark2 (& (pac -> msg_memory ) , gc ) ; 
  GC_mark2 (& (pac -> msg_chains ) , gc ) ; 
  GC_mark2 (& (pac -> wakeup_signal ) , gc ) ; 



  j = pac -> out ; 
  sz = pac -> size ; 
  for (i = pac -> count ; i -- ; ) {
    pr = pac -> msg_chains [j ] ; 
    while (pr ) {
      GC_mark2 (& ((((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . car ) ) , gc ) ; 
      pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ; 
    }
    j = ((j + 1 ) % sz ) ; 
  }


  return 0 ; 
}






static int place_async_channel_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Place_Async_Channel * pac = (Scheme_Place_Async_Channel * ) p ; 
  Scheme_Object * pr ; 
  int i , j , sz ; 
  GC_fixup2 (& (pac -> msgs ) , gc ) ; 
  GC_fixup2 (& (pac -> msg_memory ) , gc ) ; 
  GC_fixup2 (& (pac -> msg_chains ) , gc ) ; 
  GC_fixup2 (& (pac -> wakeup_signal ) , gc ) ; 



  j = pac -> out ; 
  sz = pac -> size ; 
  for (i = pac -> count ; i -- ; ) {
    pr = pac -> msg_chains [j ] ; 
    while (pr ) {
      GC_fixup2 (& ((((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . car ) ) , gc ) ; 
      pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ; 
    }
    j = ((j + 1 ) % sz ) ; 
  }


  return 0 ; 
}

# 203 "./../src/mzmark_place.inc"
static int serialized_file_fd_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int serialized_file_fd_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Serialized_File_FD * ffd = (Scheme_Serialized_File_FD * ) p ; 
  GC_mark2 (& (ffd -> name ) , gc ) ; 


  return 0 ; 
}






static int serialized_file_fd_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Serialized_File_FD * ffd = (Scheme_Serialized_File_FD * ) p ; 
  GC_fixup2 (& (ffd -> name ) , gc ) ; 


  return 0 ; 
}

# 243 "./../src/mzmark_place.inc"
static int serialized_socket_fd_val_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int serialized_socket_fd_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Serialized_Socket_FD * sfd = (Scheme_Serialized_Socket_FD * ) p ; 
  GC_mark2 (& (sfd -> name ) , gc ) ; 


  return 0 ; 
}






static int serialized_socket_fd_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Serialized_Socket_FD * sfd = (Scheme_Serialized_Socket_FD * ) p ; 
  GC_fixup2 (& (sfd -> name ) , gc ) ; 


  return 0 ; 
}

# 3427 "./../src/place.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_place_type , place_val_SIZE , place_val_MARK , place_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_place_object_type , place_object_val_SIZE , place_object_val_MARK , place_object_val_FIXUP , 1 , 1 ) ; 
  GC_register_traversers2 (scheme_place_async_channel_type , place_async_channel_val_SIZE , place_async_channel_val_MARK , place_async_channel_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_place_bi_channel_type , place_bi_channel_val_SIZE , place_bi_channel_val_MARK , place_bi_channel_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_serialized_file_fd_type , serialized_file_fd_val_SIZE , serialized_file_fd_val_MARK , serialized_file_fd_val_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_serialized_tcp_fd_type , serialized_socket_fd_val_SIZE , serialized_socket_fd_val_MARK , serialized_socket_fd_val_FIXUP , 1 , 0 ) ; 
}
