#include "precomp.h"

# 2 "./../src/schcpt.h"
enum {
  CPT_ESCAPE , 
  CPT_SYMBOL , 
  CPT_SYMREF , 
  CPT_WEIRD_SYMBOL , 
  CPT_KEYWORD , 
  CPT_BYTE_STRING , 
  CPT_CHAR_STRING , 
  CPT_CHAR , 
  CPT_INT , 
  CPT_NULL , 
  CPT_TRUE , 
  CPT_FALSE , 
  CPT_VOID , 
  CPT_BOX , 
  CPT_PAIR , 
  CPT_LIST , 
  CPT_VECTOR , 
  CPT_HASH_TABLE , 
  CPT_LET_ONE_TYPED , 
  CPT_LINKLET , 
  CPT_QUOTE , 
  CPT_REFERENCE , 
  CPT_LOCAL , 
  CPT_LOCAL_UNBOX , 
  CPT_SVECTOR , 
  CPT_APPLICATION , 
  CPT_LET_ONE , 
  CPT_BRANCH , 
  CPT_PATH , 
  CPT_CLOSURE , 
  CPT_DELAY_REF , 
  CPT_PREFAB , 
  CPT_LET_ONE_UNUSED , 
  CPT_SHARED , 
  CPT_TOPLEVEL , 
  CPT_BEGIN , 
  CPT_BEGIN0 , 
  CPT_LET_VALUE , 
  CPT_LET_VOID , 
  CPT_LETREC , 
  CPT_WCM , 
  CPT_DEFINE_VALUES , 
  CPT_SET_BANG , 
  CPT_VARREF , 
  CPT_APPLY_VALUES , 
  CPT_OTHER_FORM , 
  CPT_SRCLOC , 
  _CPT_COUNT_ }
; 

# 46 "/usr/include/ctype.h" 3
enum 
{
  _ISupper = ((0 ) < 8 ? ((1 << (0 ) ) << 8 ) : ((1 << (0 ) ) >> 8 ) ) , 
  _ISlower = ((1 ) < 8 ? ((1 << (1 ) ) << 8 ) : ((1 << (1 ) ) >> 8 ) ) , 
  _ISalpha = ((2 ) < 8 ? ((1 << (2 ) ) << 8 ) : ((1 << (2 ) ) >> 8 ) ) , 
  _ISdigit = ((3 ) < 8 ? ((1 << (3 ) ) << 8 ) : ((1 << (3 ) ) >> 8 ) ) , 
  _ISxdigit = ((4 ) < 8 ? ((1 << (4 ) ) << 8 ) : ((1 << (4 ) ) >> 8 ) ) , 
  _ISspace = ((5 ) < 8 ? ((1 << (5 ) ) << 8 ) : ((1 << (5 ) ) >> 8 ) ) , 
  _ISprint = ((6 ) < 8 ? ((1 << (6 ) ) << 8 ) : ((1 << (6 ) ) >> 8 ) ) , 
  _ISgraph = ((7 ) < 8 ? ((1 << (7 ) ) << 8 ) : ((1 << (7 ) ) >> 8 ) ) , 
  _ISblank = ((8 ) < 8 ? ((1 << (8 ) ) << 8 ) : ((1 << (8 ) ) >> 8 ) ) , 
  _IScntrl = ((9 ) < 8 ? ((1 << (9 ) ) << 8 ) : ((1 << (9 ) ) >> 8 ) ) , 
  _ISpunct = ((10 ) < 8 ? ((1 << (10 ) ) << 8 ) : ((1 << (10 ) ) >> 8 ) ) , 
  _ISalnum = ((11 ) < 8 ? ((1 << (11 ) ) << 8 ) : ((1 << (11 ) ) >> 8 ) ) }
; 

# 10 "./../src/print.c"
int (* scheme_check_print_is_obj ) (Scheme_Object * o ) ; 


; 
; 

; 


static Scheme_Type_Printer * printers ; 
static int printers_count ; 

; 


static char compacts [_CPT_COUNT_ ] ; 

Scheme_Object * quote_symbol ; 
Scheme_Object * quasiquote_symbol ; 
Scheme_Object * unquote_symbol ; 
Scheme_Object * unquote_splicing_symbol ; 
Scheme_Object * syntax_symbol ; 
Scheme_Object * quasisyntax_symbol ; 
Scheme_Object * unsyntax_symbol ; 
Scheme_Object * unsyntax_splicing_symbol ; 
Scheme_Object * qq_ellipses ; 

# 58 "./../src/print.c"
typedef struct Scheme_Print_Params {
  Scheme_Type type ; 

  char print_struct ; 
  char print_graph ; 
  char print_box ; 
  char print_vec_shorthand ; 
  char print_hash_table ; 
  char print_unreadable ; 
  char print_pair_curly , print_mpair_curly ; 
  char print_reader ; 
  char print_long_bools ; 
  char can_read_pipe_quote ; 
  char case_sens ; 
  Scheme_Object * inspector ; 

  char printing_quoted ; 


  char * print_buffer ; 
  intptr_t print_position ; 
  intptr_t print_allocated ; 
  intptr_t print_maxlen ; 
  intptr_t print_offset ; 
  intptr_t print_syntax ; 
  Scheme_Object * print_port ; 
  mz_jmp_buf * print_escape ; 
  Scheme_Object * depth_delta ; 
  Scheme_Hash_Table * uq_ht ; 
}

# 87 "./../src/print.c"
PrintParams ; 


static void register_traversers (void ) ; 


static void print_to_port (char * name , Scheme_Object * obj , Scheme_Object * port , 
int notdisplay , intptr_t maxl , Scheme_Object * qq_depth ) ; 
static int print (Scheme_Object * obj , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * p ) ; 
static void print_char_string (const char * s , int l , const mzchar * us , int delta , int ul , 
int notdisplay , PrintParams * pp ) ; 
static void print_byte_string (const char * s , int delta , int l , int notdisplay , PrintParams * pp ) ; 
static void print_pair (Scheme_Object * pair , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
Scheme_Type type , int round_parens , int first_unquoted ) ; 
static void print_vector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) ; 
static void print_flvector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) ; 
static void print_fxvector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) ; 
static void print_char (Scheme_Object * chobj , int notdisplay , PrintParams * pp ) ; 
static char * print_to_string (Scheme_Object * obj , intptr_t * volatile len , int write , 
Scheme_Object * port , intptr_t maxl , 
Scheme_Object * qq_depth , int * _release_to_quick ) ; 

static void custom_write_struct (Scheme_Object * s , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , int notdisplay ) ; 

static int writable_struct_subs (Scheme_Object * s , int for_write , PrintParams * pp , 
int mode , Scheme_Hash_Table * ht , int * counter ) ; 




static Scheme_Object * srcloc_path_to_string (Scheme_Object * p ) ; 

# 175 "./../src/print.c"
void scheme_init_print (Scheme_Startup_Env * env ) 
{
  /* No conversion */

# 177 "./../src/print.c"
  int i ; 

  for (i = 0 ; i < _CPT_COUNT_ ; i ++ ) {
    compacts [i ] = i ; 
  }

  scheme_register_static ((void * ) & quote_symbol , sizeof (quote_symbol ) ) ; 
  scheme_register_static ((void * ) & quasiquote_symbol , sizeof (quasiquote_symbol ) ) ; 
  scheme_register_static ((void * ) & unquote_symbol , sizeof (unquote_symbol ) ) ; 
  scheme_register_static ((void * ) & unquote_splicing_symbol , sizeof (unquote_splicing_symbol ) ) ; 
  scheme_register_static ((void * ) & syntax_symbol , sizeof (syntax_symbol ) ) ; 
  scheme_register_static ((void * ) & quasisyntax_symbol , sizeof (quasisyntax_symbol ) ) ; 
  scheme_register_static ((void * ) & unsyntax_symbol , sizeof (unsyntax_symbol ) ) ; 
  scheme_register_static ((void * ) & unsyntax_splicing_symbol , sizeof (unsyntax_splicing_symbol ) ) ; 
  scheme_register_static ((void * ) & qq_ellipses , sizeof (qq_ellipses ) ) ; 
  quote_symbol = scheme_intern_symbol ("quote" ) ; 
  quasiquote_symbol = scheme_intern_symbol ("quasiquote" ) ; 
  unquote_symbol = scheme_intern_symbol ("unquote" ) ; 
  unquote_splicing_symbol = scheme_intern_symbol ("unquote-splicing" ) ; 
  syntax_symbol = scheme_intern_symbol ("syntax" ) ; 
  quasisyntax_symbol = scheme_intern_symbol ("quasisyntax" ) ; 
  unsyntax_symbol = scheme_intern_symbol ("unsyntax" ) ; 
  unsyntax_splicing_symbol = scheme_intern_symbol ("unsyntax-splicing" ) ; 
  qq_ellipses = scheme_make_symbol ("..." ) ; 


  register_traversers () ; 
}


void scheme_init_print_buffers_places () 
{
  /* No conversion */

# 209 "./../src/print.c"
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) ) ) ; 
  scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) ) ) ; 

  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) = (char * ) GC_malloc_atomic (100 ) ; 
  XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) = (char * ) GC_malloc_atomic (256 ) ; 
}

Scheme_Object * scheme_make_svector (mzshort c , mzshort * a ) 
{
  Scheme_Object * o ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(o, 0), PUSH(a, 1)));
# define XfOrM5_COUNT (2)
# define SETUP_XfOrM5(x) SETUP(XfOrM5_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 221 "./../src/print.c"
  o = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM5(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 

  o -> type = scheme_svector_type ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . len ) = c ; 
  (((Scheme_Simple_Object * ) (o ) ) -> u . svector_val . vec ) = a ; 

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 230 "./../src/print.c"
PrintParams * copy_print_params (PrintParams * pp ) 
{
  PrintParams * pp2 ; 
  DECL_RET_SAVE (PrintParams * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pp2, 0), PUSH(pp, 1)));
# define XfOrM6_COUNT (2)
# define SETUP_XfOrM6(x) SETUP(XfOrM6_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  pp2 = NULLED_OUT ; 

# 234 "./../src/print.c"
  pp2 = ((PrintParams * ) FUNCCALL(SETUP_XfOrM6(_), GC_malloc_one_small_tagged ((((sizeof (PrintParams ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  (memcpy (pp2 , pp , sizeof (PrintParams ) ) ) ; 

  pp2 -> type = scheme_rt_print_params ; 

  RET_VALUE_START (pp2 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 242 "./../src/print.c"
void 
scheme_debug_print (Scheme_Object * obj ) 
{
  /* No conversion */

# 245 "./../src/print.c"
  scheme_write (obj , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdout_port_ ) ) ; 
  scheme_flush_output (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_orig_stdout_port_ ) ) ; 
}

static void * print_to_port_k (void ) 
{
  /* No conversion */

# 251 "./../src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * obj , * port , * depth ; 

  port = (Scheme_Object * ) p -> ku . k . p1 ; 
  obj = (Scheme_Object * ) p -> ku . k . p2 ; 
  depth = (Scheme_Object * ) p -> ku . k . p3 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  print_to_port ((p -> ku . k . i2 
  ? ((p -> ku . k . i2 == 2 ) 
  ? "print" 
  : "write" ) 
  : "display" ) , 
  obj , port , 
  p -> ku . k . i2 , p -> ku . k . i1 , 
  depth ) ; 

  return ((void * ) 0 ) ; 
}

static void do_handled_print (Scheme_Object * obj , Scheme_Object * port , 
Scheme_Object * proc , intptr_t maxl ) 
{
  Scheme_Object * a [2 ] ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(proc, 1), PUSHARRAY(a, 2, 2)));
# define XfOrM9_COUNT (5)
# define SETUP_XfOrM9(x) SETUP(XfOrM9_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 279 "./../src/print.c"
  a [0 ] = obj ; 

  if (maxl > 0 ) {
#   define XfOrM11_COUNT (0+XfOrM9_COUNT)
#   define SETUP_XfOrM11(x) SETUP_XfOrM9(x)

# 282 "./../src/print.c"
    a [1 ] = FUNCCALL(SETUP_XfOrM11(_), scheme_make_byte_string_output_port () ); 
  }

# 283 "./../src/print.c"
  else 
  a [1 ] = port ; 
  FUNCCALL(SETUP_XfOrM9(_), scheme_apply_multi (proc , 2 , a ) )
  ; 

  if (maxl > 0 ) {
    char * s ; 
    intptr_t len ; 
    BLOCK_SETUP((PUSH(s, 0+XfOrM9_COUNT)));
#   define XfOrM10_COUNT (1+XfOrM9_COUNT)
#   define SETUP_XfOrM10(x) SETUP(XfOrM10_COUNT)
    s = NULLED_OUT ; 

# 292 "./../src/print.c"
    s = FUNCCALL(SETUP_XfOrM10(_), scheme_get_sized_byte_string_output (a [1 ] , & len ) ); 
    if (len > maxl )
      len = maxl ; 
    FUNCCALL(SETUP_XfOrM10(_), scheme_write_byte_string (s , len , port ) )
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 300 "./../src/print.c"
static int can_print_fast (Scheme_Object * obj ) 
{
  /* No conversion */
  return (((((intptr_t ) (obj ) ) & 0x1 ) || ((((obj ) -> type ) >= scheme_bignum_type ) && (((obj ) -> type ) <= scheme_complex_type ) ) ) 
  || (((obj ) == (scheme_true ) ) || ((obj ) == (scheme_false ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ; 
}

void scheme_write_w_max (Scheme_Object * obj , Scheme_Object * port , intptr_t maxl ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(obj, 1)));
# define XfOrM13_COUNT (2)
# define SETUP_XfOrM13(x) SETUP(XfOrM13_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 310 "./../src/print.c"
  if (((Scheme_Output_Port * ) port ) -> write_handler )
    FUNCCALL(SETUP_XfOrM13(_), do_handled_print (obj , port , scheme_write_proc , maxl ) ); 
  else if (FUNCCALL(SETUP_XfOrM13(_), can_print_fast (obj ) ))
    FUNCCALL(SETUP_XfOrM13(_), print_to_port ("write" , obj , port , 1 , maxl , ((void * ) 0 ) ) ); 
  else {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM14_COUNT (0+XfOrM13_COUNT)
#   define SETUP_XfOrM14(x) SETUP_XfOrM13(x)

# 317 "./../src/print.c"
    p -> ku . k . p1 = port ; 
    p -> ku . k . p2 = obj ; 
    p -> ku . k . i1 = maxl ; 
    p -> ku . k . i2 = 1 ; 
    p -> ku . k . p3 = ((void * ) 0 ) ; 

    (void ) FUNCCALL_EMPTY(scheme_top_level_do (print_to_port_k , 0 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 327 "./../src/print.c"
void scheme_write (Scheme_Object * obj , Scheme_Object * port ) 
{
  /* No conversion */

# 329 "./../src/print.c"
  scheme_write_w_max (obj , port , - 1 ) ; 
}

void scheme_display_w_max (Scheme_Object * obj , Scheme_Object * port , intptr_t maxl ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(obj, 1)));
# define XfOrM16_COUNT (2)
# define SETUP_XfOrM16(x) SETUP(XfOrM16_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 334 "./../src/print.c"
  if (((Scheme_Output_Port * ) port ) -> display_handler )
    FUNCCALL(SETUP_XfOrM16(_), do_handled_print (obj , port , scheme_display_proc , maxl ) ); 
  else if (FUNCCALL(SETUP_XfOrM16(_), can_print_fast (obj ) ))
    FUNCCALL(SETUP_XfOrM16(_), print_to_port ("display" , obj , port , 0 , maxl , ((void * ) 0 ) ) ); 
  else {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM17_COUNT (0+XfOrM16_COUNT)
#   define SETUP_XfOrM17(x) SETUP_XfOrM16(x)

# 341 "./../src/print.c"
    p -> ku . k . p1 = port ; 
    p -> ku . k . p2 = obj ; 
    p -> ku . k . i1 = maxl ; 
    p -> ku . k . i2 = 0 ; 
    p -> ku . k . p3 = ((void * ) 0 ) ; 

    (void ) FUNCCALL_EMPTY(scheme_top_level_do (print_to_port_k , 0 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 351 "./../src/print.c"
void scheme_display (Scheme_Object * obj , Scheme_Object * port ) 
{
  /* No conversion */

# 353 "./../src/print.c"
  scheme_display_w_max (obj , port , - 1 ) ; 
}

void scheme_print_w_max (Scheme_Object * obj , Scheme_Object * port , intptr_t maxl ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(port, 0), PUSH(obj, 1)));
# define XfOrM19_COUNT (2)
# define SETUP_XfOrM19(x) SETUP(XfOrM19_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 358 "./../src/print.c"
  if (((Scheme_Output_Port * ) port ) -> print_handler )
    FUNCCALL(SETUP_XfOrM19(_), do_handled_print (obj , port , scheme_print_proc , maxl ) ); 
  else if (FUNCCALL(SETUP_XfOrM19(_), can_print_fast (obj ) ))
    FUNCCALL(SETUP_XfOrM19(_), print_to_port ("print" , obj , port , 2 , maxl , ((void * ) 0 ) ) ); 
  else {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#   define XfOrM20_COUNT (0+XfOrM19_COUNT)
#   define SETUP_XfOrM20(x) SETUP_XfOrM19(x)

# 365 "./../src/print.c"
    p -> ku . k . p1 = port ; 
    p -> ku . k . p2 = obj ; 
    p -> ku . k . i1 = maxl ; 
    p -> ku . k . i2 = 2 ; 
    p -> ku . k . p3 = ((void * ) 0 ) ; 

    (void ) FUNCCALL_EMPTY(scheme_top_level_do (print_to_port_k , 0 ) ); 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 375 "./../src/print.c"
void scheme_print (Scheme_Object * obj , Scheme_Object * port ) 
{
  /* No conversion */

# 377 "./../src/print.c"
  scheme_print_w_max (obj , port , - 1 ) ; 
}

static void * print_to_string_k (void ) 
{
  /* No conversion */

# 382 "./../src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * obj , * qq_depth ; 
  intptr_t * len , maxl ; 
  int iswrite ; 

  obj = (Scheme_Object * ) p -> ku . k . p1 ; 
  len = (intptr_t * ) (void * ) p -> ku . k . p2 ; 
  maxl = p -> ku . k . i1 ; 
  iswrite = p -> ku . k . i2 ; 
  qq_depth = (Scheme_Object * ) p -> ku . k . p3 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return (void * ) print_to_string (obj , len , iswrite , ((void * ) 0 ) , maxl , qq_depth , ((void * ) 0 ) ) ; 
}

char * scheme_write_to_string_w_max (Scheme_Object * obj , intptr_t * len , intptr_t maxl ) 
{
  /* No conversion */

# 402 "./../src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = obj ; 
  p -> ku . k . p2 = len ; 
  p -> ku . k . i1 = maxl ; 
  p -> ku . k . i2 = 1 ; 
  p -> ku . k . i3 = 0 ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return (char * ) scheme_top_level_do (print_to_string_k , 0 ) ; 
}

char * scheme_write_to_string (Scheme_Object * obj , intptr_t * len ) 
{
  /* No conversion */

# 416 "./../src/print.c"
  return scheme_write_to_string_w_max (obj , len , - 1 ) ; 
}

char * scheme_display_to_string_w_max (Scheme_Object * obj , intptr_t * len , intptr_t maxl ) 
{
  /* No conversion */

# 421 "./../src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = obj ; 
  p -> ku . k . p2 = len ; 
  p -> ku . k . i1 = maxl ; 
  p -> ku . k . i2 = 0 ; 
  p -> ku . k . i3 = 0 ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return (char * ) scheme_top_level_do (print_to_string_k , 0 ) ; 
}

char * scheme_display_to_string (Scheme_Object * obj , intptr_t * len ) 
{
  /* No conversion */

# 435 "./../src/print.c"
  return scheme_display_to_string_w_max (obj , len , - 1 ) ; 
}

char * scheme_print_to_string_w_max (Scheme_Object * obj , intptr_t * len , intptr_t maxl ) 
{
  /* No conversion */

# 440 "./../src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = obj ; 
  p -> ku . k . p2 = len ; 
  p -> ku . k . i1 = maxl ; 
  p -> ku . k . i2 = 2 ; 
  p -> ku . k . i3 = 1 ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return (char * ) scheme_top_level_do (print_to_string_k , 0 ) ; 
}

char * scheme_print_to_string (Scheme_Object * obj , intptr_t * len ) 
{
  /* No conversion */

# 454 "./../src/print.c"
  return scheme_print_to_string_w_max (obj , len , - 1 ) ; 
}

void 
scheme_internal_write (Scheme_Object * obj , Scheme_Object * port ) 
{
  /* No conversion */

# 460 "./../src/print.c"
  print_to_port ("write" , obj , port , 1 , - 1 , ((void * ) 0 ) ) ; 
}

void 
scheme_internal_display (Scheme_Object * obj , Scheme_Object * port ) 
{
  /* No conversion */

# 466 "./../src/print.c"
  print_to_port ("display" , obj , port , 0 , - 1 , ((void * ) 0 ) ) ; 
}

void 
scheme_internal_print (Scheme_Object * obj , Scheme_Object * port , Scheme_Object * depth ) 
{
  /* No conversion */

# 472 "./../src/print.c"
  print_to_port ("print" , obj , port , 2 , - 1 , depth ) ; 
}


static int check_cycles (Scheme_Object * , int , Scheme_Hash_Table * ht , PrintParams * ) ; 

static Scheme_Object * check_cycle_k (void ) 
{
  /* No conversion */

# 480 "./../src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p -> ku . k . p2 ; 
  PrintParams * pp = (PrintParams * ) p -> ku . k . p3 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (check_cycles (o , p -> ku . k . i1 , ht , pp ) ) ) ) << 1 ) | 0x1 ) ) ; 
}





static int check_cycles (Scheme_Object * obj , int for_write , Scheme_Hash_Table * ht , PrintParams * pp ) 


{
  Scheme_Type t ; 
  Scheme_Object * val ; 
  int res , res2 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(pp, 1), PUSH(ht, 2), PUSH(obj, 3)));
# define XfOrM33_COUNT (4)
# define SETUP_XfOrM33(x) SETUP(XfOrM33_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  val = NULLED_OUT ; 

# 505 "./../src/print.c"
  {

# 24 "./../src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM64_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM64(x) SETUP_XfOrM33(x)

# 26 "./../src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 507 "./../src/print.c"
    {
#     define XfOrM65_COUNT (0+XfOrM64_COUNT)
#     define SETUP_XfOrM65(x) SETUP_XfOrM64(x)

# 508 "./../src/print.c"
      pp = FUNCCALL(SETUP_XfOrM65(_), copy_print_params (pp ) ); 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p1 = (void * ) obj ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p2 = (void * ) ht ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p3 = (void * ) pp ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . i1 = for_write ; 
      RET_VALUE_START ((((intptr_t ) (FUNCCALL(SETUP_XfOrM65(_), scheme_handle_stack_overflow (check_cycle_k ) )) ) >> 1 ) ) RET_VALUE_END ; 
    }
  }

  {
#   define XfOrM62_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM62(x) SETUP_XfOrM33(x)

# 517 "./../src/print.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM63_COUNT (0+XfOrM62_COUNT)
#     define SETUP_XfOrM63(x) SETUP_XfOrM62(x)
      FUNCCALL(SETUP_XfOrM63(_), scheme_out_of_fuel () )
# 517 "./../src/print.c"
      ; 
    }
  }

# 517 "./../src/print.c"
  ; 

  t = ((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) 
  || (pp -> print_box && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) ) 
  || (((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) 
  && ((pp -> print_struct 
  && (FUNCCALL(SETUP_XfOrM33(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) ) 
  || FUNCCALL(SETUP_XfOrM33(_), scheme_is_writable_struct (obj ) )) ) 
  || (pp -> print_hash_table 
  && (((Scheme_Type ) (t ) == (Scheme_Type ) (scheme_hash_table_type ) ) 
  || ((t >= scheme_hash_tree_type ) 
  && (t <= scheme_hash_tree_indirection_type ) ) ) ) ) {
#   define XfOrM61_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM61(x) SETUP_XfOrM33(x)

# 535 "./../src/print.c"
    val = FUNCCALL(SETUP_XfOrM61(_), scheme_hash_get (ht , obj ) ); 
    if (val )
      RET_VALUE_START ((((intptr_t ) (val ) ) >> 1 ) ) RET_VALUE_END ; 
    FUNCCALL(SETUP_XfOrM61(_), scheme_hash_set (ht , obj , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0x2 ) ) ) << 1 ) | 0x1 ) ) ) ); 
  }

# 539 "./../src/print.c"
  else 
  RET_VALUE_START (0 ) RET_VALUE_END ; 

  if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#   define XfOrM60_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM60(x) SETUP_XfOrM33(x)

# 543 "./../src/print.c"
    res = FUNCCALL(SETUP_XfOrM60(_), check_cycles ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) , for_write , ht , pp ) ); 
    if ((for_write < 3 ) && (res & 0x2 ) )
      RET_VALUE_START (res ) RET_VALUE_END ; 
    res2 = FUNCCALL(SETUP_XfOrM60(_), check_cycles ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) , for_write , ht , pp ) ); 
    res |= res2 ; 
  }

# 548 "./../src/print.c"
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) )  {
#   define XfOrM59_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM59(x) SETUP_XfOrM33(x)

# 549 "./../src/print.c"
    res = FUNCCALL(SETUP_XfOrM59(_), check_cycles ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) , for_write , ht , pp ) ); 
    if ((for_write < 3 ) && (res & 0x2 ) )
      RET_VALUE_START (res ) RET_VALUE_END ; 
    res2 = FUNCCALL(SETUP_XfOrM59(_), check_cycles ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) , for_write , ht , pp ) ); 
    res |= res2 ; 
    if (for_write >= 3 )
      res |= 0x1 ; 
  }

# 556 "./../src/print.c"
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) )  {

    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM33_COUNT)));
#   define XfOrM58_COUNT (1+XfOrM33_COUNT)
#   define SETUP_XfOrM58(x) SETUP(XfOrM58_COUNT)
    v = NULLED_OUT ; 

# 559 "./../src/print.c"
    if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) 
      v = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
    else 
    v = FUNCCALL(SETUP_XfOrM58(_), scheme_unbox (obj ) ); 
    res = FUNCCALL(SETUP_XfOrM58(_), check_cycles (v , for_write , ht , pp ) ); 
  }

# 564 "./../src/print.c"
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) )  {
    int i , len ; 
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM33_COUNT)));
#   define XfOrM55_COUNT (1+XfOrM33_COUNT)
#   define SETUP_XfOrM55(x) SETUP(XfOrM55_COUNT)
    v = NULLED_OUT ; 

# 568 "./../src/print.c"
    if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
      len = (((Scheme_Vector * ) (obj ) ) -> size ) ; 
    else 
    len = (((Scheme_Vector * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> size ) ; 
    res = 0 ; 
    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM57_COUNT (0+XfOrM55_COUNT)
#     define SETUP_XfOrM57(x) SETUP_XfOrM55(x)

# 574 "./../src/print.c"
      if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
        v = (((Scheme_Vector * ) (obj ) ) -> els ) [i ] ; 
      else 
      v = FUNCCALL(SETUP_XfOrM57(_), scheme_chaperone_vector_ref (obj , i ) ); 
      res2 = FUNCCALL(SETUP_XfOrM57(_), check_cycles (v , for_write , ht , pp ) ); 
      res |= res2 ; 
      if ((for_write < 3 ) && (res & 0x2 ) )
        RET_VALUE_START (res ) RET_VALUE_END ; 
    }
  }

# 583 "./../src/print.c"
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) ) ) {
    res = 0x1 ; 
  }

# 586 "./../src/print.c"
  else if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) )  {
#   define XfOrM44_COUNT (0+XfOrM33_COUNT)
#   define SETUP_XfOrM44(x) SETUP_XfOrM33(x)

# 587 "./../src/print.c"
    if (FUNCCALL(SETUP_XfOrM44(_), scheme_is_writable_struct (obj ) )) {
#     define XfOrM50_COUNT (0+XfOrM44_COUNT)
#     define SETUP_XfOrM50(x) SETUP_XfOrM44(x)

# 588 "./../src/print.c"
      if (pp -> print_unreadable ) {
#       define XfOrM51_COUNT (0+XfOrM50_COUNT)
#       define SETUP_XfOrM51(x) SETUP_XfOrM50(x)

# 589 "./../src/print.c"
        res = FUNCCALL(SETUP_XfOrM51(_), writable_struct_subs (obj , for_write , pp , 1 , ht , ((void * ) 0 ) ) ); 

        if (for_write >= 3 ) {
          Scheme_Object * kind ; 
          BLOCK_SETUP((PUSH(kind, 0+XfOrM51_COUNT)));
#         define XfOrM52_COUNT (1+XfOrM51_COUNT)
#         define SETUP_XfOrM52(x) SETUP(XfOrM52_COUNT)
          kind = NULLED_OUT ; 

# 593 "./../src/print.c"
          kind = FUNCCALL(SETUP_XfOrM52(_), scheme_print_attribute_ref (obj ) ); 

          if (kind ) {
#           define XfOrM53_COUNT (0+XfOrM52_COUNT)
#           define SETUP_XfOrM53(x) SETUP_XfOrM52(x)

# 596 "./../src/print.c"
            if (! (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "never" ) ) )
              res |= 0x1 ; 
            if (! (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "always" ) ) 
            || ! (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "self" ) ) )
              res -= (res & 0x1 ) ; 
          }

# 601 "./../src/print.c"
          else 
          res -= (res & 0x1 ) ; 
        }
      }

# 604 "./../src/print.c"
      else 
      res = 0 ; 
    }

# 606 "./../src/print.c"
    else {

      int i ; 
#     define XfOrM45_COUNT (0+XfOrM44_COUNT)
#     define SETUP_XfOrM45(x) SETUP_XfOrM44(x)

# 610 "./../src/print.c"
      if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
        i = ((((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype ) -> num_slots ) ; 
      else 
      i = ((((Scheme_Structure * ) obj ) -> stype ) -> num_slots ) ; 

      if ((for_write >= 3 ) && ! ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (obj ) ) -> stype -> prefab_key ) )
        res = 0x1 ; 
      else 
      res = 0 ; 
      while (i -- ) {
#       define XfOrM48_COUNT (0+XfOrM45_COUNT)
#       define SETUP_XfOrM48(x) SETUP_XfOrM45(x)

# 620 "./../src/print.c"
        if (FUNCCALL(SETUP_XfOrM48(_), scheme_inspector_sees_part (obj , pp -> inspector , i ) )) {
#         define XfOrM49_COUNT (0+XfOrM48_COUNT)
#         define SETUP_XfOrM49(x) SETUP_XfOrM48(x)

# 621 "./../src/print.c"
          if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
            val = FUNCCALL(SETUP_XfOrM49(_), scheme_struct_ref (obj , i ) ); 
          else 
          val = ((Scheme_Structure * ) obj ) -> slots [i ] ; 
          res2 = FUNCCALL(SETUP_XfOrM49(_), check_cycles (val , for_write , ht , pp ) ); 
          res |= res2 ; 
          if ((for_write < 3 ) && (res & 0x2 ) )
            RET_VALUE_START (res ) RET_VALUE_END ; 
        }
      }
    }
  }

# 632 "./../src/print.c"
  else if (((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) obj ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) )  {

    Scheme_Hash_Table * t ; 
    Scheme_Object * * keys , * * vals , * val , * key ; 
    int i , size ; 
    BLOCK_SETUP((PUSH(val, 0+XfOrM33_COUNT), PUSH(key, 1+XfOrM33_COUNT), PUSH(vals, 2+XfOrM33_COUNT), PUSH(keys, 3+XfOrM33_COUNT), PUSH(t, 4+XfOrM33_COUNT)));
#   define XfOrM37_COUNT (5+XfOrM33_COUNT)
#   define SETUP_XfOrM37(x) SETUP(XfOrM37_COUNT)
    t = NULLED_OUT ; 
    keys = NULLED_OUT ; 
    vals = NULLED_OUT ; 
    val = NULLED_OUT ; 
    key = NULLED_OUT ; 

# 638 "./../src/print.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      t = (Scheme_Hash_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    else 
    t = (Scheme_Hash_Table * ) obj ; 

    keys = t -> keys ; 
    vals = t -> vals ; 
    size = t -> size ; 
    res = 0 ; 
    for (i = 0 ; i < size ; i ++ ) {
#     define XfOrM41_COUNT (0+XfOrM37_COUNT)
#     define SETUP_XfOrM41(x) SETUP_XfOrM37(x)

# 648 "./../src/print.c"
      if (vals [i ] ) {
#       define XfOrM42_COUNT (0+XfOrM41_COUNT)
#       define SETUP_XfOrM42(x) SETUP_XfOrM41(x)

# 649 "./../src/print.c"
        key = keys [i ] ; 
        if (! (((Scheme_Object * ) t ) == (obj ) ) )
          val = FUNCCALL(SETUP_XfOrM42(_), scheme_chaperone_hash_traversal_get (obj , key , & key ) ); 
        else 
        val = vals [i ] ; 
        if (val ) {
#         define XfOrM43_COUNT (0+XfOrM42_COUNT)
#         define SETUP_XfOrM43(x) SETUP_XfOrM42(x)

# 655 "./../src/print.c"
          res2 = FUNCCALL(SETUP_XfOrM43(_), check_cycles (key , for_write , ht , pp ) ); 
          res |= res2 ; 
          if ((for_write < 3 ) && (res & 0x2 ) )
            RET_VALUE_START (res ) RET_VALUE_END ; 
          res2 = FUNCCALL(SETUP_XfOrM43(_), check_cycles (val , for_write , ht , pp ) ); 
          res |= res2 ; 
          if ((for_write < 3 ) && (res & 0x2 ) )
            RET_VALUE_START (res ) RET_VALUE_END ; 
        }
      }
    }
  }

# 666 "./../src/print.c"
  else if (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) )  {

    Scheme_Hash_Tree * t ; 
    Scheme_Object * key , * val ; 
    mzlonglong i ; 
    BLOCK_SETUP((PUSH(val, 0+XfOrM33_COUNT), PUSH(key, 1+XfOrM33_COUNT), PUSH(t, 2+XfOrM33_COUNT)));
#   define XfOrM34_COUNT (3+XfOrM33_COUNT)
#   define SETUP_XfOrM34(x) SETUP(XfOrM34_COUNT)
    t = NULLED_OUT ; 
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 

# 672 "./../src/print.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      t = (Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    else 
    t = (Scheme_Hash_Tree * ) obj ; 

    res = 0 ; 
    i = (scheme_hash_tree_next (t , - 1 ) ) ; 
    while (i != - 1 ) {
#     define XfOrM36_COUNT (0+XfOrM34_COUNT)
#     define SETUP_XfOrM36(x) SETUP_XfOrM34(x)
      (
# 680 "./../src/print.c"
      scheme_hash_tree_index (t , i , & key , & val ) ) ; 
      if (! (((Scheme_Object * ) t ) == (obj ) ) )
        val = FUNCCALL(SETUP_XfOrM36(_), scheme_chaperone_hash_traversal_get (obj , key , & key ) ); 
      res2 = FUNCCALL(SETUP_XfOrM36(_), check_cycles (key , for_write , ht , pp ) ); 
      res |= res2 ; 
      if ((for_write < 3 ) && (res & 0x2 ) )
        RET_VALUE_START (res ) RET_VALUE_END ; 
      res2 = FUNCCALL(SETUP_XfOrM36(_), check_cycles (val , for_write , ht , pp ) ); 
      res |= res2 ; 
      if ((for_write < 3 ) && (res & 0x2 ) )
        RET_VALUE_START (res ) RET_VALUE_END ; 
      i = (scheme_hash_tree_next (t , i ) ) ; 
    }
  }

# 693 "./../src/print.c"
  else 
  res = 0 ; 
  FUNCCALL_EMPTY(scheme_hash_set (ht , obj , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (res ) ) ) << 1 ) | 0x1 ) ) ) )
  ; 

  RET_VALUE_START (res ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 806 "./../src/print.c"
static void setup_graph_table (Scheme_Object * obj , int for_write , Scheme_Hash_Table * ht , int * counter , PrintParams * pp ) ; 

static Scheme_Object * setup_graph_k (void ) 
{
  /* No conversion */

# 810 "./../src/print.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p -> ku . k . p2 ; 
  int * counter = (int * ) p -> ku . k . p3 ; 
  PrintParams * pp = (PrintParams * ) p -> ku . k . p4 ; 
  int for_write = p -> ku . k . i1 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 

  setup_graph_table (o , for_write , ht , counter , pp ) ; 

  return scheme_false ; 
}


static void setup_graph_table (Scheme_Object * obj , int for_write , Scheme_Hash_Table * ht , 
int * counter , PrintParams * pp ) 
{
  Scheme_Object * __funcarg59 = NULLED_OUT ; 
  PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(pp, 1), PUSH(obj, 2), PUSH(counter, 3)));
# define XfOrM67_COUNT (4)
# define SETUP_XfOrM67(x) SETUP(XfOrM67_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 831 "./../src/print.c"
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) ) || ((pp ? pp -> print_box : 1 ) && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) || ((pp ? pp -> print_struct && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && (FUNCCALL(SETUP_XfOrM67(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) : 0 ) ) || ((pp ? ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && FUNCCALL(SETUP_XfOrM67(_), scheme_is_writable_struct (obj ) ): 0 ) ) || ((pp ? pp -> print_struct : 1 ) && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (obj ) ) -> stype -> prefab_key ) ) || ((pp ? pp -> print_hash_table : 1 ) && ((((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) obj ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? (((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> count ) : (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (obj ) ) -> count ) ) ) ) )  {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM67_COUNT)));
#   define XfOrM90_COUNT (1+XfOrM67_COUNT)
#   define SETUP_XfOrM90(x) SETUP(XfOrM90_COUNT)
    v = NULLED_OUT ; 

# 835 "./../src/print.c"
    {

# 24 "./../src/mzstkchk.h"
      uintptr_t _stk_pos ; 
#     define XfOrM93_COUNT (0+XfOrM90_COUNT)
#     define SETUP_XfOrM93(x) SETUP_XfOrM90(x)

# 26 "./../src/mzstkchk.h"
      _stk_pos = (uintptr_t ) & _stk_pos ; 

      if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
      && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 837 "./../src/print.c"
      {
#       define XfOrM94_COUNT (0+XfOrM93_COUNT)
#       define SETUP_XfOrM94(x) SETUP_XfOrM93(x)

# 838 "./../src/print.c"
        if (pp )
          pp = FUNCCALL(SETUP_XfOrM94(_), copy_print_params (pp ) ); 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p1 = (void * ) obj ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p2 = (void * ) ht ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p3 = (void * ) counter ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p4 = (void * ) pp ; 
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . i1 = for_write ; 
        FUNCCALL(SETUP_XfOrM94(_), scheme_handle_stack_overflow (setup_graph_k ) ); 
        RET_NOTHING ; 
      }
    }


    v = FUNCCALL(SETUP_XfOrM90(_), scheme_hash_get (ht , obj ) ); 

    if (! v )
      FUNCCALL(SETUP_XfOrM90(_), scheme_hash_set (ht , obj , (Scheme_Object * ) 0x1 ) ); 
    else {
#     define XfOrM91_COUNT (0+XfOrM90_COUNT)
#     define SETUP_XfOrM91(x) SETUP_XfOrM90(x)

# 856 "./../src/print.c"
      if ((intptr_t ) v == 1 ) {
#       define XfOrM92_COUNT (0+XfOrM91_COUNT)
#       define SETUP_XfOrM92(x) SETUP_XfOrM91(x)

# 857 "./../src/print.c"
        (* counter ) += 2 ; 
        FUNCCALL(SETUP_XfOrM92(_), scheme_hash_set (ht , obj , (Scheme_Object * ) (intptr_t ) * counter ) ); 
      }
      RET_NOTHING ; 
    }
  }

# 862 "./../src/print.c"
  else 
  RET_NOTHING ; 

  {
#   define XfOrM88_COUNT (0+XfOrM67_COUNT)
#   define SETUP_XfOrM88(x) SETUP_XfOrM67(x)

# 865 "./../src/print.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM89_COUNT (0+XfOrM88_COUNT)
#     define SETUP_XfOrM89(x) SETUP_XfOrM88(x)
      FUNCCALL(SETUP_XfOrM89(_), scheme_out_of_fuel () )
# 865 "./../src/print.c"
      ; 
    }
  }

# 865 "./../src/print.c"
  ; 

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) ) {
#   define XfOrM87_COUNT (0+XfOrM67_COUNT)
#   define SETUP_XfOrM87(x) SETUP_XfOrM67(x)
    FUNCCALL(SETUP_XfOrM87(_), setup_graph_table ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . car ) , for_write , ht , counter , pp ) )
# 868 "./../src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM87(_), setup_graph_table ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) , for_write , ht , counter , pp ) ); 
  }

# 870 "./../src/print.c"
  else if ((! pp || pp -> print_box ) && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) {
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM67_COUNT)));
#   define XfOrM86_COUNT (1+XfOrM67_COUNT)
#   define SETUP_XfOrM86(x) SETUP(XfOrM86_COUNT)
    v = NULLED_OUT ; 

# 872 "./../src/print.c"
    if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) 
      v = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
    else 
    v = FUNCCALL(SETUP_XfOrM86(_), scheme_unbox (obj ) ); 
    FUNCCALL(SETUP_XfOrM86(_), setup_graph_table (v , for_write , ht , counter , pp ) ); 
  }

# 877 "./../src/print.c"
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) )  {
    int i , len ; 
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM67_COUNT)));
#   define XfOrM83_COUNT (1+XfOrM67_COUNT)
#   define SETUP_XfOrM83(x) SETUP(XfOrM83_COUNT)
    v = NULLED_OUT ; 

# 881 "./../src/print.c"
    if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
      len = (((Scheme_Vector * ) (obj ) ) -> size ) ; 
    else 
    len = (((Scheme_Vector * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> size ) ; 
    for (i = 0 ; i < len ; i ++ ) {
#     define XfOrM85_COUNT (0+XfOrM83_COUNT)
#     define SETUP_XfOrM85(x) SETUP_XfOrM83(x)

# 886 "./../src/print.c"
      if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
        v = (((Scheme_Vector * ) (obj ) ) -> els ) [i ] ; 
      else 
      v = FUNCCALL(SETUP_XfOrM85(_), scheme_chaperone_vector_ref (obj , i ) ); 
      FUNCCALL(SETUP_XfOrM85(_), setup_graph_table (v , for_write , ht , counter , pp ) ); 
    }
  }

# 892 "./../src/print.c"
  else if (pp && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) ) {
#   define XfOrM78_COUNT (0+XfOrM67_COUNT)
#   define SETUP_XfOrM78(x) SETUP_XfOrM67(x)

# 893 "./../src/print.c"
    if (FUNCCALL(SETUP_XfOrM78(_), scheme_is_writable_struct (obj ) )) {
#     define XfOrM82_COUNT (0+XfOrM78_COUNT)
#     define SETUP_XfOrM82(x) SETUP_XfOrM78(x)

# 894 "./../src/print.c"
      if (pp -> print_unreadable )
        (void ) FUNCCALL(SETUP_XfOrM82(_), writable_struct_subs (obj , for_write , pp , 2 , ht , counter ) ); 
    }

# 896 "./../src/print.c"
    else {
      int i ; 
#     define XfOrM79_COUNT (0+XfOrM78_COUNT)
#     define SETUP_XfOrM79(x) SETUP_XfOrM78(x)

# 899 "./../src/print.c"
      if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
        i = ((((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype ) -> num_slots ) ; 
      else 
      i = ((((Scheme_Structure * ) obj ) -> stype ) -> num_slots ) ; 

      while (i -- ) {
#       define XfOrM81_COUNT (0+XfOrM79_COUNT)
#       define SETUP_XfOrM81(x) SETUP_XfOrM79(x)

# 905 "./../src/print.c"
        if (FUNCCALL(SETUP_XfOrM81(_), scheme_inspector_sees_part (obj , pp -> inspector , i ) ))
          (__funcarg59 = FUNCCALL(SETUP_XfOrM81(_), scheme_struct_ref (obj , i ) ), FUNCCALL_AGAIN(setup_graph_table (__funcarg59 , for_write , ht , counter , pp ) )) ; 
      }
    }
  }

# 909 "./../src/print.c"
  else if (pp && (((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) obj ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) ) ) {
    Scheme_Hash_Table * t ; 
    Scheme_Object * * keys , * * vals , * val , * key ; 
    int i , size ; 
    BLOCK_SETUP((PUSH(val, 0+XfOrM67_COUNT), PUSH(key, 1+XfOrM67_COUNT), PUSH(vals, 2+XfOrM67_COUNT), PUSH(keys, 3+XfOrM67_COUNT), PUSH(t, 4+XfOrM67_COUNT)));
#   define XfOrM71_COUNT (5+XfOrM67_COUNT)
#   define SETUP_XfOrM71(x) SETUP(XfOrM71_COUNT)
    t = NULLED_OUT ; 
    keys = NULLED_OUT ; 
    vals = NULLED_OUT ; 
    val = NULLED_OUT ; 
    key = NULLED_OUT ; 

# 914 "./../src/print.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      t = (Scheme_Hash_Table * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    else 
    t = (Scheme_Hash_Table * ) obj ; 

    keys = t -> keys ; 
    vals = t -> vals ; 
    size = t -> size ; 
    for (i = 0 ; i < size ; i ++ ) {
#     define XfOrM75_COUNT (0+XfOrM71_COUNT)
#     define SETUP_XfOrM75(x) SETUP_XfOrM71(x)

# 923 "./../src/print.c"
      if (vals [i ] ) {
#       define XfOrM76_COUNT (0+XfOrM75_COUNT)
#       define SETUP_XfOrM76(x) SETUP_XfOrM75(x)

# 924 "./../src/print.c"
        key = keys [i ] ; 
        if (! (((Scheme_Object * ) t ) == (obj ) ) )
          val = FUNCCALL(SETUP_XfOrM76(_), scheme_chaperone_hash_traversal_get (obj , key , & key ) ); 
        else 
        val = vals [i ] ; 
        if (val ) {
#         define XfOrM77_COUNT (0+XfOrM76_COUNT)
#         define SETUP_XfOrM77(x) SETUP_XfOrM76(x)
          FUNCCALL(SETUP_XfOrM77(_), setup_graph_table (key , for_write , ht , counter , pp ) )
# 930 "./../src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM77(_), setup_graph_table (val , for_write , ht , counter , pp ) ); 
        }
      }
    }
  }

# 935 "./../src/print.c"
  else if (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) )  {

    Scheme_Hash_Tree * t ; 
    Scheme_Object * key , * val ; 
    mzlonglong i ; 
    BLOCK_SETUP((PUSH(val, 0+XfOrM67_COUNT), PUSH(key, 1+XfOrM67_COUNT), PUSH(t, 2+XfOrM67_COUNT)));
#   define XfOrM68_COUNT (3+XfOrM67_COUNT)
#   define SETUP_XfOrM68(x) SETUP(XfOrM68_COUNT)
    t = NULLED_OUT ; 
    key = NULLED_OUT ; 
    val = NULLED_OUT ; 

# 941 "./../src/print.c"
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      t = (Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) obj ) -> val ) ; 
    else 
    t = (Scheme_Hash_Tree * ) obj ; 

    i = (scheme_hash_tree_next (t , - 1 ) ) ; 
    while (i != - 1 ) {
#     define XfOrM70_COUNT (0+XfOrM68_COUNT)
#     define SETUP_XfOrM70(x) SETUP_XfOrM68(x)
      (
# 948 "./../src/print.c"
      scheme_hash_tree_index (t , i , & key , & val ) ) ; 
      if (! (((Scheme_Object * ) t ) == (obj ) ) )
        val = FUNCCALL(SETUP_XfOrM70(_), scheme_chaperone_hash_traversal_get (obj , key , & key ) ); 
      FUNCCALL(SETUP_XfOrM70(_), setup_graph_table (key , for_write , ht , counter , pp ) ); 
      FUNCCALL_AGAIN(setup_graph_table (val , for_write , ht , counter , pp ) ); 
      i = (scheme_hash_tree_next (t , i ) ) ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 960 "./../src/print.c"
static Scheme_Hash_Table * setup_datum_graph (Scheme_Object * o , int for_write , void * for_print ) 
{
  Scheme_Hash_Table * ht ; 
  int counter = 1 ; 
  DECL_RET_SAVE (Scheme_Hash_Table * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(for_print, 0), PUSH(ht, 1), PUSH(o, 2)));
# define XfOrM95_COUNT (3)
# define SETUP_XfOrM95(x) SETUP(XfOrM95_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ht = NULLED_OUT ; 

# 965 "./../src/print.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) ) {
    ht = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) = ((void * ) 0 ) ; 
  }

# 968 "./../src/print.c"
  else 
  ht = FUNCCALL(SETUP_XfOrM95(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  FUNCCALL(SETUP_XfOrM95(_), setup_graph_table (o , for_write , ht , & counter , (PrintParams * ) for_print ) )
  ; 

  if (counter > 1 )
    RET_VALUE_START (ht ) RET_VALUE_END ; 
  else {
    if (ht -> size < 32 ) {
      int i ; 
      for (i = 0 ; i < ht -> size ; i ++ ) {
        ht -> keys [i ] = ((void * ) 0 ) ; 
        ht -> vals [i ] = ((void * ) 0 ) ; 
      }
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> cache_ht_ ) = ht ; 
    }
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 988 "./../src/print.c"
static char * 
print_to_string (Scheme_Object * obj , 
intptr_t * volatile len , int write , 
Scheme_Object * port , intptr_t maxl , 
Scheme_Object * qq_depth , int * _release_to_quick ) 
{
  Scheme_Hash_Table * ht ; 
  Scheme_Hash_Table * uq_ht ; 
  Scheme_Object * v ; 
  char * ca ; 
  int cycles ; 
  mz_jmp_buf escape ; 
  volatile PrintParams params ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(ca, 0), PUSH(ht, 1), PUSH(v, 2), PUSH(port, 3), PUSH(obj, 4), PUSH(_release_to_quick, 5), PUSH(len, 6), PUSH(uq_ht, 7), PUSH(qq_depth, 8), PUSH(params.inspector, 9), PUSH(params.print_buffer, 10), PUSH(params.print_port, 11), PUSH(params.print_escape, 12), PUSH(params.depth_delta, 13), PUSH(params.uq_ht, 14)));
# define XfOrM101_COUNT (15)
# define SETUP_XfOrM101(x) SETUP(XfOrM101_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  ht = NULLED_OUT ; 
  uq_ht = NULLED_OUT ; 
  v = NULLED_OUT ; 
  ca = NULLED_OUT ; 
  params.inspector = NULLED_OUT ; 
  params.print_buffer = NULLED_OUT ; 
  params.print_port = NULLED_OUT ; 
  params.print_escape = NULLED_OUT ; 
  params.depth_delta = NULLED_OUT ; 
  params.uq_ht = NULLED_OUT ; 

# 1002 "./../src/print.c"
  params . print_allocated = 50 ; 
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) ) {
    ca = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) = ((void * ) 0 ) ; 
  }

# 1006 "./../src/print.c"
  else 
  ca = (char * ) FUNCCALL(SETUP_XfOrM101(_), GC_malloc_atomic (params . print_allocated ) ); 
  params . print_buffer = ca ; 
  params . print_position = 0 ; 
  params . print_offset = 0 ; 
  params . print_maxlen = maxl ; 
  params . print_port = port ; 
  params . print_syntax = 0 ; 
  params . depth_delta = ((void * ) 0 ) ; 
  params . printing_quoted = 0 ; 



  if (((((intptr_t ) (obj ) ) & 0x1 ) || ((((obj ) -> type ) >= scheme_bignum_type ) && (((obj ) -> type ) <= scheme_complex_type ) ) ) 
  || (! write 
  && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) ) ) {
    params . print_graph = 0 ; 
    params . print_box = 0 ; 
    params . print_struct = 0 ; 
    params . print_vec_shorthand = 0 ; 
    params . print_hash_table = 0 ; 
    params . print_unreadable = 1 ; 
    params . print_reader = 1 ; 
    params . print_long_bools = 0 ; 
    params . print_pair_curly = 0 ; 
    params . print_mpair_curly = 1 ; 
    params . can_read_pipe_quote = 1 ; 
    params . case_sens = 1 ; 
    params . inspector = scheme_false ; 
    params . print_syntax = - 1 ; 
  }

# 1038 "./../src/print.c"
  else {
    Scheme_Config * config ; 
    BLOCK_SETUP((PUSH(config, 0+XfOrM101_COUNT)));
#   define XfOrM106_COUNT (1+XfOrM101_COUNT)
#   define SETUP_XfOrM106(x) SETUP(XfOrM106_COUNT)
    config = NULLED_OUT ; 

# 1041 "./../src/print.c"
    config = FUNCCALL(SETUP_XfOrM106(_), scheme_current_config () ); 

    v = FUNCCALL_AGAIN(scheme_get_param (config , MZCONFIG_PRINT_GRAPH ) ); 
    params . print_graph = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM106(_), scheme_get_param (config , MZCONFIG_PRINT_BOX ) ); 
    params . print_box = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM106(_), scheme_get_param (config , MZCONFIG_PRINT_STRUCT ) ); 
    params . print_struct = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM106(_), scheme_get_param (config , MZCONFIG_PRINT_VEC_SHORTHAND ) ); 
    params . print_vec_shorthand = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM106(_), scheme_get_param (config , MZCONFIG_PRINT_SYNTAX_WIDTH ) ); 
    if (((intptr_t ) (v ) ) & 0x1 ) 
      params . print_syntax = (((intptr_t ) (v ) ) >> 1 ) ; 
    else 
    params . print_syntax = - 1 ; 
    v = FUNCCALL(SETUP_XfOrM106(_), scheme_get_param (config , MZCONFIG_PRINT_HASH_TABLE ) ); 
    params . print_hash_table = (! (((v ) ) == (scheme_false ) ) ) ; 
    if (write ) {
#     define XfOrM113_COUNT (0+XfOrM106_COUNT)
#     define SETUP_XfOrM113(x) SETUP_XfOrM106(x)

# 1059 "./../src/print.c"
      if (maxl > 0 )
        params . print_unreadable = 1 ; 
      else {
#       define XfOrM114_COUNT (0+XfOrM113_COUNT)
#       define SETUP_XfOrM114(x) SETUP_XfOrM113(x)

# 1062 "./../src/print.c"
        v = FUNCCALL(SETUP_XfOrM114(_), scheme_get_param (config , MZCONFIG_PRINT_UNREADABLE ) ); 
        params . print_unreadable = (! (((v ) ) == (scheme_false ) ) ) ; 
      }
    }

# 1065 "./../src/print.c"
    else 
    params . print_unreadable = 1 ; 
    v = FUNCCALL(SETUP_XfOrM106(_), scheme_get_param (config , MZCONFIG_PRINT_PAIR_CURLY ) ); 
    params . print_pair_curly = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM106(_), scheme_get_param (config , MZCONFIG_PRINT_MPAIR_CURLY ) ); 
    params . print_mpair_curly = (! (((v ) ) == (scheme_false ) ) ) ; 
    if (write > 1 ) {
#     define XfOrM109_COUNT (0+XfOrM106_COUNT)
#     define SETUP_XfOrM109(x) SETUP_XfOrM106(x)

# 1072 "./../src/print.c"
      v = FUNCCALL(SETUP_XfOrM109(_), scheme_get_param (config , MZCONFIG_PRINT_AS_QQ ) ); 
      if (! (((v ) ) == (scheme_false ) ) )  {
#       define XfOrM110_COUNT (0+XfOrM109_COUNT)
#       define SETUP_XfOrM110(x) SETUP_XfOrM109(x)

# 1074 "./../src/print.c"
        params . depth_delta = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
        if (qq_depth ) {
#         define XfOrM111_COUNT (0+XfOrM110_COUNT)
#         define SETUP_XfOrM111(x) SETUP_XfOrM110(x)

# 1076 "./../src/print.c"
          if (FUNCCALL(SETUP_XfOrM111(_), scheme_bin_gt (qq_depth , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((1 << 29 ) ) ) ) << 1 ) | 0x1 ) ) ) )) {
#           define XfOrM112_COUNT (0+XfOrM111_COUNT)
#           define SETUP_XfOrM112(x) SETUP_XfOrM111(x)

# 1077 "./../src/print.c"
            write = 3 + (1 << 29 ) ; 
            qq_depth = FUNCCALL(SETUP_XfOrM112(_), scheme_bin_minus (qq_depth , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((1 << 29 ) ) ) ) << 1 ) | 0x1 ) ) ) ); 
            params . depth_delta = qq_depth ; 
          }

# 1080 "./../src/print.c"
          else 
          write = 3 + (((intptr_t ) (qq_depth ) ) >> 1 ) ; 
        }

# 1082 "./../src/print.c"
        else 
        write = 3 ; 
      }
    }

    if (write > 2 ) {
      params . print_reader = 1 ; 
    }

# 1089 "./../src/print.c"
    else {
#     define XfOrM107_COUNT (0+XfOrM106_COUNT)
#     define SETUP_XfOrM107(x) SETUP_XfOrM106(x)

# 1090 "./../src/print.c"
      v = FUNCCALL(SETUP_XfOrM107(_), scheme_get_param (config , MZCONFIG_PRINT_READER ) ); 
      params . print_reader = (! (((v ) ) == (scheme_false ) ) ) ; 
    }
    v = FUNCCALL(SETUP_XfOrM106(_), scheme_get_param (config , MZCONFIG_CAN_READ_PIPE_QUOTE ) ); 
    params . can_read_pipe_quote = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM106(_), scheme_get_param (config , MZCONFIG_CASE_SENS ) ); 
    params . case_sens = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM106(_), scheme_get_param (config , MZCONFIG_PRINT_LONG_BOOLEAN ) ); 
    params . print_long_bools = (! (((v ) ) == (scheme_false ) ) ) ; 
    v = FUNCCALL(SETUP_XfOrM106(_), scheme_get_param (config , MZCONFIG_INSPECTOR ) ); 
    params . inspector = v ; 
  }

  uq_ht = ((void * ) 0 ) ; 

  if (params . print_graph && (write < 3 ) )
    cycles = 1 ; 
  else {
#   define XfOrM104_COUNT (0+XfOrM101_COUNT)
#   define SETUP_XfOrM104(x) SETUP_XfOrM101(x)

# 1109 "./../src/print.c"
    if (FUNCCALL(SETUP_XfOrM104(_), can_print_fast (obj ) ))
      cycles = 0 ; 
    else 
    cycles = - 1 ; 




    if ((cycles == - 1 ) || (cycles && (write >= 3 ) ) ) {
#     define XfOrM105_COUNT (0+XfOrM104_COUNT)
#     define SETUP_XfOrM105(x) SETUP_XfOrM104(x)

# 1118 "./../src/print.c"
      uq_ht = FUNCCALL(SETUP_XfOrM105(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      cycles = FUNCCALL(SETUP_XfOrM105(_), check_cycles (obj , write , uq_ht , (PrintParams * ) & params ) )& 0x2 ; 
    }
    if (! cycles && params . print_graph )
      cycles = 1 ; 
  }

  if (cycles )
    ht = FUNCCALL(SETUP_XfOrM101(_), setup_datum_graph (obj , write , (PrintParams * ) & params ) ); 
  else 
  ht = ((void * ) 0 ) ; 

  if (maxl > 0 )
    params . print_escape = & escape ; 
  else 
  params . print_escape = ((void * ) 0 ) ; 

  params . uq_ht = uq_ht ; 

  if ((maxl < 3 ) 
  || ! ((escape ) . gcvs = (intptr_t ) __gc_var_stack__ , (escape ) . gcvs_cnt = XfOrM101_COUNT , (_setjmp ((escape ) . jb ) ) ) )
    FUNCCALL(SETUP_XfOrM101(_), print (obj , write , 0 , ht , ((void * ) 0 ) , (PrintParams * ) & params ) ); 

  params . print_buffer [params . print_position ] = '\0' ; 

  if (len )
    * len = params . print_position ; 

  params . inspector = ((void * ) 0 ) ; 

  if (_release_to_quick ) {
    * _release_to_quick = 0 ; 
    if (params . print_buffer != ca ) {
      if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) )
        XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) = ca ; 
    }

# 1153 "./../src/print.c"
    else 
    * _release_to_quick = 1 ; 
  }

  RET_VALUE_START (params . print_buffer ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1160 "./../src/print.c"
static void 
print_to_port (char * name , Scheme_Object * obj , Scheme_Object * port , int notdisplay , 
intptr_t maxl , Scheme_Object * qq_depth ) 
{
  Scheme_Output_Port * op ; 
  char * str ; 
  intptr_t len ; 
  int rel ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(op, 1), PUSH(qq_depth, 2), PUSH(obj, 3), PUSH(name, 4), PUSH(port, 5)));
# define XfOrM117_COUNT (6)
# define SETUP_XfOrM117(x) SETUP(XfOrM117_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  op = NULLED_OUT ; 
  str = NULLED_OUT ; 

# 1169 "./../src/print.c"
  op = FUNCCALL(SETUP_XfOrM117(_), scheme_output_port_record (port ) ); 
  if (op -> closed )
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL , "%s: output port is closed\n" "  port: %V" , name , port ) )

  ; 

  str = FUNCCALL(SETUP_XfOrM117(_), print_to_string (obj , & len , notdisplay , port , maxl , qq_depth , & rel ) ); 
  FUNCCALL_AGAIN(scheme_write_byte_string (str , len , port ) )
  ; 

  if (rel && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) = str ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1183 "./../src/print.c"
static void print_this_string (PrintParams * pp , const char * str , int offset , int autolen ) 

{
  intptr_t len ; 
  char * oldstr ; 
  PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(pp, 1), PUSH(oldstr, 2)));
# define XfOrM118_COUNT (3)
# define SETUP_XfOrM118(x) SETUP(XfOrM118_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  oldstr = NULLED_OUT ; 

# 1189 "./../src/print.c"
  if (! autolen ) {
    if (! str )
      len = 0 ; 
    else 
    RET_NOTHING ; 
  }

# 1194 "./../src/print.c"
  else if (autolen > 0 )
    len = autolen ; 
  else 
  len = strlen (str XFORM_OK_PLUS offset ) ; 

  if (! pp -> print_buffer ) {

    pp -> print_position += len ; 
    pp -> print_offset += len ; 
    RET_NOTHING ; 
  }

  if (len + pp -> print_position + 1 > pp -> print_allocated ) {
#   define XfOrM125_COUNT (0+XfOrM118_COUNT)
#   define SETUP_XfOrM125(x) SETUP_XfOrM118(x)

# 1207 "./../src/print.c"
    if (len + 1 >= pp -> print_allocated )
      pp -> print_allocated = 2 * pp -> print_allocated + len + 1 ; 
    else 
    pp -> print_allocated = 2 * pp -> print_allocated ; 

    oldstr = pp -> print_buffer ; 
    {
      char * ca ; 
      BLOCK_SETUP((PUSH(ca, 0+XfOrM125_COUNT)));
#     define XfOrM126_COUNT (1+XfOrM125_COUNT)
#     define SETUP_XfOrM126(x) SETUP(XfOrM126_COUNT)
      ca = NULLED_OUT ; 

# 1215 "./../src/print.c"
      ca = (char * ) FUNCCALL(SETUP_XfOrM126(_), GC_malloc_atomic (pp -> print_allocated ) ); 
      pp -> print_buffer = ca ; 
    }
    (memcpy (pp -> print_buffer , oldstr , pp -> print_position ) ) ; 
  }

  if (len )
    (memcpy (pp -> print_buffer + pp -> print_position , str + offset , len ) ) ; 
  pp -> print_position += len ; 
  pp -> print_offset += len ; 





  {
#   define XfOrM123_COUNT (0+XfOrM118_COUNT)
#   define SETUP_XfOrM123(x) SETUP_XfOrM118(x)

# 1230 "./../src/print.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM124_COUNT (0+XfOrM123_COUNT)
#     define SETUP_XfOrM124(x) SETUP_XfOrM123(x)
      FUNCCALL(SETUP_XfOrM124(_), scheme_out_of_fuel () )
# 1230 "./../src/print.c"
      ; 
    }
  }

# 1230 "./../src/print.c"
  ; 

  if (pp -> print_maxlen >= 3 ) {
    if (pp -> print_position > pp -> print_maxlen ) {
      intptr_t l = pp -> print_maxlen ; 

      pp -> print_buffer [l ] = 0 ; 
      pp -> print_buffer [l - 1 ] = '.' ; 
      pp -> print_buffer [l - 2 ] = '.' ; 
      pp -> print_buffer [l - 3 ] = '.' ; 

      pp -> print_position = l ; 

      (((intptr_t * ) (void * ) ((* pp -> print_escape ) . gcvs ) ) [1 ] = (* pp -> print_escape ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* pp -> print_escape ) . gcvs , longjmp ((* pp -> print_escape ) . jb , 1 ) ) ; 
    }
  }

# 1245 "./../src/print.c"
  else if ((pp -> print_position > 500 ) || ! str ) {
#   define XfOrM119_COUNT (0+XfOrM118_COUNT)
#   define SETUP_XfOrM119(x) SETUP_XfOrM118(x)

# 1246 "./../src/print.c"
    if (pp -> print_port ) {
#     define XfOrM120_COUNT (0+XfOrM119_COUNT)
#     define SETUP_XfOrM120(x) SETUP_XfOrM119(x)

# 1247 "./../src/print.c"
      pp -> print_buffer [pp -> print_position ] = 0 ; 
      FUNCCALL(SETUP_XfOrM120(_), scheme_write_byte_string (pp -> print_buffer , pp -> print_position , pp -> print_port ) ); 

      pp -> print_position = 0 ; 
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1255 "./../src/print.c"
static void print_utf8_string (PrintParams * pp , const char * str , int offset , int autolen ) 
{
  /* No conversion */

# 1257 "./../src/print.c"
  print_this_string (pp , str , offset , autolen ) ; 
}

void scheme_print_bytes (Scheme_Print_Params * pp , const char * str , int offset , int len ) 
{
  /* No conversion */

# 1262 "./../src/print.c"
  print_this_string (pp , str , offset , len ) ; 
}

void scheme_print_utf8 (Scheme_Print_Params * pp , const char * str , int offset , int len ) 
{
  /* No conversion */

# 1267 "./../src/print.c"
  print_utf8_string (pp , str , offset , len ) ; 
}

static void print_number (PrintParams * pp , intptr_t n ) 
{
  /* No conversion */

# 1272 "./../src/print.c"
  unsigned char s [4 ] ; 

  s [0 ] = (unsigned char ) (n & 0xFF ) ; 
  s [1 ] = (unsigned char ) ((n >> 8 ) & 0xFF ) ; 
  s [2 ] = (unsigned char ) ((n >> 16 ) & 0xFF ) ; 
  s [3 ] = (unsigned char ) ((n >> 24 ) & 0xFF ) ; 

  print_this_string (pp , (char * ) s , 0 , 4 ) ; 
}

static void print_short_number (PrintParams * pp , intptr_t n ) 
{
  /* No conversion */

# 1284 "./../src/print.c"
  unsigned char s [2 ] ; 

  s [0 ] = (unsigned char ) (n & 0xFF ) ; 
  s [1 ] = (unsigned char ) ((n >> 8 ) & 0xFF ) ; 

  print_this_string (pp , (char * ) s , 0 , 2 ) ; 
}

static void print_one_byte (PrintParams * pp , int n ) 
{
  /* No conversion */

# 1294 "./../src/print.c"
  unsigned char s [1 ] ; 

  s [0 ] = n ; 

  print_this_string (pp , (char * ) s , 0 , 1 ) ; 
}

static void print_compact_number (PrintParams * pp , intptr_t n ) 
{
  unsigned char s [2 ] ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pp, 0)));
# define XfOrM135_COUNT (1)
# define SETUP_XfOrM135(x) SETUP(XfOrM135_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1305 "./../src/print.c"
  if (n < 0 ) {
#   define XfOrM139_COUNT (0+XfOrM135_COUNT)
#   define SETUP_XfOrM139(x) SETUP_XfOrM135(x)

# 1306 "./../src/print.c"
    if (n > - 32 ) {
#     define XfOrM141_COUNT (0+XfOrM139_COUNT)
#     define SETUP_XfOrM141(x) SETUP_XfOrM139(x)

# 1307 "./../src/print.c"
      s [0 ] = (unsigned char ) (0xC0 | (- n ) ) ; 
      FUNCCALL(SETUP_XfOrM141(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      RET_NOTHING ; 
    }

# 1310 "./../src/print.c"
    else {
      n = - n ; 
      s [0 ] = 0xE0 ; 
    }
  }

# 1314 "./../src/print.c"
  else if (n < 128 ) {
#   define XfOrM138_COUNT (0+XfOrM135_COUNT)
#   define SETUP_XfOrM138(x) SETUP_XfOrM135(x)

# 1315 "./../src/print.c"
    s [0 ] = (unsigned char ) n ; 
    FUNCCALL(SETUP_XfOrM138(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    RET_NOTHING ; 
  }

# 1318 "./../src/print.c"
  else if (n < 0x4000 ) {
#   define XfOrM137_COUNT (0+XfOrM135_COUNT)
#   define SETUP_XfOrM137(x) SETUP_XfOrM135(x)

# 1319 "./../src/print.c"
    s [0 ] = (unsigned char ) (0x80 | (n & 0x3F ) ) ; 
    s [1 ] = (unsigned char ) ((n >> 6 ) & 0xFF ) ; 
    FUNCCALL(SETUP_XfOrM137(_), print_this_string (pp , (char * ) s , 0 , 2 ) ); 
    RET_NOTHING ; 
  }

# 1323 "./../src/print.c"
  else {
    s [0 ] = 0xF0 ; 
  }
  FUNCCALL(SETUP_XfOrM135(_), print_this_string (pp , (char * ) s , 0 , 1 ) )
  ; 
  FUNCCALL_EMPTY(print_number (pp , n ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1331 "./../src/print.c"
static void do_print_string (int compact , int notdisplay , 
Scheme_Print_Params * pp , const mzchar * s , int offset , int l ) 
{
  int el , reset ; 
  char * buf ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(pp, 1), PUSH(buf, 2)));
# define XfOrM142_COUNT (3)
# define SETUP_XfOrM142(x) SETUP(XfOrM142_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  buf = NULLED_OUT ; 

# 1337 "./../src/print.c"
  el = l * 6 ; 
  if (el <= 256 ) {
#   define XfOrM146_COUNT (0+XfOrM142_COUNT)
#   define SETUP_XfOrM146(x) SETUP_XfOrM142(x)

# 1339 "./../src/print.c"
    if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) ) {
      buf = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) = ((void * ) 0 ) ; 
    }

# 1342 "./../src/print.c"
    else 
    buf = (char * ) FUNCCALL(SETUP_XfOrM146(_), GC_malloc_atomic (256 ) ); 
    reset = 1 ; 
  }

# 1345 "./../src/print.c"
  else {
#   define XfOrM145_COUNT (0+XfOrM142_COUNT)
#   define SETUP_XfOrM145(x) SETUP_XfOrM142(x)

# 1346 "./../src/print.c"
    buf = (char * ) FUNCCALL(SETUP_XfOrM145(_), GC_malloc_atomic (el ) ); 
    reset = 0 ; 
  }

  el = FUNCCALL(SETUP_XfOrM142(_), scheme_utf8_encode (s , offset , offset + l , (unsigned char * ) buf , 0 , 0 ) ); 

  if (compact ) {
#   define XfOrM144_COUNT (0+XfOrM142_COUNT)
#   define SETUP_XfOrM144(x) SETUP_XfOrM142(x)
    FUNCCALL(SETUP_XfOrM144(_), print_this_string (pp , & compacts [CPT_CHAR_STRING ] , 0 , 1 ) )
# 1353 "./../src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM144(_), print_compact_number (pp , el ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , l ) ); 
    FUNCCALL_AGAIN(print_this_string (pp , buf , 0 , el ) ); 
  }

# 1357 "./../src/print.c"
  else {
#   define XfOrM143_COUNT (0+XfOrM142_COUNT)
#   define SETUP_XfOrM143(x) SETUP_XfOrM142(x)
    FUNCCALL(SETUP_XfOrM143(_), print_char_string (buf , el , s , offset , l , notdisplay , pp ) )
# 1358 "./../src/print.c"
    ; 
  }

  if (reset )
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_encode_buffer_ ) = buf ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1365 "./../src/print.c"
void scheme_print_string (Scheme_Print_Params * pp , const mzchar * s , int offset , int l ) 
{
  /* No conversion */

# 1367 "./../src/print.c"
  do_print_string (0 , 0 , pp , s , offset , l ) ; 
}

static void print_string_in_angle (PrintParams * pp , const char * start , const char * prefix , int slen ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(start, 0), PUSH(pp, 1)));
# define XfOrM149_COUNT (2)
# define SETUP_XfOrM149(x) SETUP(XfOrM149_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM149(_), print_utf8_string (pp , prefix , 0 , - 1 ) )
# 1373 "./../src/print.c"
  ; 
  FUNCCALL_EMPTY(print_utf8_string (pp , start , 0 , slen ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1379 "./../src/print.c"
static Scheme_Object * print_k (void ) 
{
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) p -> ku . k . p2 ; 
  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) p -> ku . k . p3 ; 
  PrintParams * pp = (PrintParams * ) p -> ku . k . p5 ; 
  mz_jmp_buf * volatile save ; 
  mz_jmp_buf newbuf ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(pp, 1), PUSH(save, 2), PUSH(mt, 3), PUSH(o, 4), PUSH(p, 5)));
# define XfOrM150_COUNT (6)
# define SETUP_XfOrM150(x) SETUP(XfOrM150_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  save = NULLED_OUT ; 

# 1389 "./../src/print.c"
  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p5 = ((void * ) 0 ) ; 

  save = pp -> print_escape ; 
  pp -> print_escape = & newbuf ; 
  if (((newbuf ) . gcvs = (intptr_t ) __gc_var_stack__ , (newbuf ) . gcvs_cnt = XfOrM150_COUNT , (_setjmp ((newbuf ) . jb ) ) ) ) {
#   define XfOrM152_COUNT (0+XfOrM150_COUNT)
#   define SETUP_XfOrM152(x) SETUP_XfOrM150(x)
    FUNCCALL(SETUP_XfOrM152(_), scheme_make_pair (scheme_void , scheme_void ) )
# 1398 "./../src/print.c"
    ; 

    pp -> print_escape = save ; 
    RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
  }

# 1402 "./../src/print.c"
  else {
    int r ; 
#   define XfOrM151_COUNT (0+XfOrM150_COUNT)
#   define SETUP_XfOrM151(x) SETUP_XfOrM150(x)

# 1404 "./../src/print.c"
    r = FUNCCALL(SETUP_XfOrM151(_), print (o , p -> ku . k . i1 , p -> ku . k . i2 , ht , mt , pp ) )




    ; 
    pp -> print_escape = save ; 
    RET_VALUE_START (r ? scheme_true : scheme_false ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}






static int compare_keys (const void * a , const void * b ) 
{
  /* No conversion */

# 1426 "./../src/print.c"
  Scheme_Object * av , * bv ; 

# 1438 "./../src/print.c"
  av = ((Scheme_Object * * ) a ) [0 ] ; 
  bv = ((Scheme_Object * * ) b ) [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) || ((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) || ((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (av ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (av ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) || ((((intptr_t ) (av ) ) & 0x1 ) || ((((av ) -> type ) >= scheme_bignum_type ) && (((av ) -> type ) <= scheme_complex_type ) ) ) )  {
    if (! (((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) || ((((intptr_t ) (bv ) ) & 0x1 ) || ((((bv ) -> type ) >= scheme_bignum_type ) && (((bv ) -> type ) <= scheme_complex_type ) ) ) ) )
      return - 1 ; 
  }

# 1443 "./../src/print.c"
  else if (((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) || ((Scheme_Type ) (((((intptr_t ) (bv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (bv ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) ) || ((((intptr_t ) (bv ) ) & 0x1 ) || ((((bv ) -> type ) >= scheme_bignum_type ) && (((bv ) -> type ) <= scheme_complex_type ) ) ) ) 
    return 1 ; 

  return ((intptr_t * ) a ) [1 ] - ((intptr_t * ) b ) [1 ] ; 
}

static void sort_referenced_keys (Scheme_Marshal_Tables * mt ) 
{
  intptr_t j , size , pos = 0 ; 
  Scheme_Object * * keys ; 
  Scheme_Hash_Table * key_map ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(mt, 0), PUSH(keys, 1), PUSH(key_map, 2)));
# define XfOrM155_COUNT (3)
# define SETUP_XfOrM155(x) SETUP(XfOrM155_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  keys = NULLED_OUT ; 
  key_map = NULLED_OUT ; 

# 1455 "./../src/print.c"
  size = mt -> st_refs -> count ; 
  keys = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM155(_), GC_malloc (sizeof (Scheme_Object * ) * ((2 * size ) ) ) )) ; 

  for (j = 0 ; j < mt -> st_refs -> size ; j ++ ) {
    if (mt -> st_refs -> vals [j ] ) {
      keys [pos ] = mt -> st_refs -> keys [j ] ; 
      keys [pos + 1 ] = mt -> st_refs -> vals [j ] ; 
      pos += 2 ; 
    }
  }
  FUNCCALL(SETUP_XfOrM155(_), qsort (keys , size , 2 * sizeof (Scheme_Object * ) , compare_keys ) )
  ; 

  key_map = FUNCCALL(SETUP_XfOrM155(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
  for (j = 0 ; j < size ; j ++ ) {
#   define XfOrM157_COUNT (0+XfOrM155_COUNT)
#   define SETUP_XfOrM157(x) SETUP_XfOrM155(x)
    FUNCCALL(SETUP_XfOrM157(_), scheme_hash_set (key_map , keys [(j << 1 ) + 1 ] , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (j + 1 ) ) ) << 1 ) | 0x1 ) ) ) )
# 1470 "./../src/print.c"
    ; 
  }
  mt -> key_map = key_map ; 

  mt -> sorted_keys = keys ; 
  mt -> sorted_keys_count = size ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1478 "./../src/print.c"
static void print_table_keys (int notdisplay , int compact , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp ) 
{
  intptr_t j , size , offset ; 
  Scheme_Object * * keys , * key ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(pp, 1), PUSH(key, 2), PUSH(keys, 3), PUSH(mt, 4)));
# define XfOrM162_COUNT (5)
# define SETUP_XfOrM162(x) SETUP(XfOrM162_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  keys = NULLED_OUT ; 
  key = NULLED_OUT ; 

# 1485 "./../src/print.c"
  size = mt -> sorted_keys_count ; 
  keys = mt -> sorted_keys ; 

  for (j = 0 ; j < size ; j ++ ) {
#   define XfOrM164_COUNT (0+XfOrM162_COUNT)
#   define SETUP_XfOrM164(x) SETUP_XfOrM162(x)

# 1489 "./../src/print.c"
    offset = pp -> print_offset ; 
    mt -> shared_offsets [j ] = offset ; 
    key = keys [j << 1 ] ; 
    mt -> print_now = j + 1 ; 
    FUNCCALL(SETUP_XfOrM164(_), print (key , notdisplay , compact , ht , mt , pp ) ); 
    mt -> print_now = 0 ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1498 "./../src/print.c"
static int 
print_substring (Scheme_Object * obj , int notdisplay , int compact , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , char * * result , intptr_t * rlen , 
int print_keys , intptr_t * klen ) 
{
  int closed ; 
  intptr_t save_alloc , save_pos , save_off , save_maxl ; 
  char * save_buf ; 
  Scheme_Object * save_port ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(result, 1), PUSH(rlen, 2), PUSH(mt, 3), PUSH(klen, 4), PUSH(obj, 5), PUSH(save_buf, 6), PUSH(pp, 7), PUSH(save_port, 8)));
# define XfOrM165_COUNT (9)
# define SETUP_XfOrM165(x) SETUP(XfOrM165_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  save_buf = NULLED_OUT ; 
  save_port = NULLED_OUT ; 

# 1509 "./../src/print.c"
  save_alloc = pp -> print_allocated ; 
  save_buf = pp -> print_buffer ; 
  save_pos = pp -> print_position ; 
  save_off = pp -> print_offset ; 
  save_maxl = pp -> print_maxlen ; 
  save_port = pp -> print_port ; 


  if (result ) {
    char * ca ; 
    BLOCK_SETUP((PUSH(ca, 0+XfOrM165_COUNT)));
#   define XfOrM169_COUNT (1+XfOrM165_COUNT)
#   define SETUP_XfOrM169(x) SETUP(XfOrM169_COUNT)
    ca = NULLED_OUT ; 

# 1519 "./../src/print.c"
    pp -> print_allocated = 50 ; 
    ca = (char * ) FUNCCALL(SETUP_XfOrM169(_), GC_malloc_atomic (pp -> print_allocated ) ); 
    pp -> print_buffer = ca ; 
  }

# 1522 "./../src/print.c"
  else {
    pp -> print_allocated = 0 ; 
    pp -> print_buffer = ((void * ) 0 ) ; 
  }
  pp -> print_position = 0 ; 
  pp -> print_offset = 0 ; 
  pp -> print_port = ((void * ) 0 ) ; 

  if (print_keys < 0 ) {
#   define XfOrM167_COUNT (0+XfOrM165_COUNT)
#   define SETUP_XfOrM167(x) SETUP_XfOrM165(x)
    FUNCCALL(SETUP_XfOrM167(_), print_table_keys (notdisplay , compact , ht , mt , pp ) )
# 1531 "./../src/print.c"
    ; 
    * klen = pp -> print_offset ; 
  }

  closed = FUNCCALL(SETUP_XfOrM165(_), print (obj , notdisplay , compact , ht , mt , pp ) ); 

  if (print_keys > 0 ) {
#   define XfOrM166_COUNT (0+XfOrM165_COUNT)
#   define SETUP_XfOrM166(x) SETUP_XfOrM165(x)
    FUNCCALL(SETUP_XfOrM166(_), print_table_keys (notdisplay , compact , ht , mt , pp ) )
# 1538 "./../src/print.c"
    ; 
    * klen = pp -> print_offset ; 
  }

  if (result )
    * result = pp -> print_buffer ; 
  * rlen = pp -> print_position ; 

  pp -> print_allocated = save_alloc ; 
  pp -> print_buffer = save_buf ; 
  pp -> print_position = save_pos ; 
  pp -> print_offset = save_off ; 
  pp -> print_maxlen = save_maxl ; 
  pp -> print_port = save_port ; 

  RET_VALUE_START (closed ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1556 "./../src/print.c"
static Scheme_Object * get_symtab_idx (Scheme_Marshal_Tables * mt , Scheme_Object * obj ) 
{
  Scheme_Object * idx ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(obj, 0), PUSH(idx, 1), PUSH(mt, 2)));
# define XfOrM170_COUNT (3)
# define SETUP_XfOrM170(x) SETUP(XfOrM170_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  idx = NULLED_OUT ; 

# 1560 "./../src/print.c"
  idx = FUNCCALL(SETUP_XfOrM170(_), scheme_hash_get (mt -> symtab , obj ) ); 

  if (idx ) {
#   define XfOrM174_COUNT (0+XfOrM170_COUNT)
#   define SETUP_XfOrM174(x) SETUP_XfOrM170(x)

# 1563 "./../src/print.c"
    if (! mt -> pass ) {
#     define XfOrM175_COUNT (0+XfOrM174_COUNT)
#     define SETUP_XfOrM175(x) SETUP_XfOrM174(x)
      FUNCCALL(SETUP_XfOrM175(_), scheme_hash_set (mt -> st_refs , obj , idx ) )
# 1565 "./../src/print.c"
      ; 
    }
  }

# 1567 "./../src/print.c"
  else {
#   define XfOrM171_COUNT (0+XfOrM170_COUNT)
#   define SETUP_XfOrM171(x) SETUP_XfOrM170(x)

# 1568 "./../src/print.c"
    if (mt -> pass && mt -> print_now ) {
#     define XfOrM172_COUNT (0+XfOrM171_COUNT)
#     define SETUP_XfOrM172(x) SETUP_XfOrM171(x)

# 1569 "./../src/print.c"
      idx = FUNCCALL(SETUP_XfOrM172(_), scheme_hash_get (mt -> st_refs , obj ) ); 
      if (idx ) {
#       define XfOrM173_COUNT (0+XfOrM172_COUNT)
#       define SETUP_XfOrM173(x) SETUP_XfOrM172(x)

# 1571 "./../src/print.c"
        idx = FUNCCALL(SETUP_XfOrM173(_), scheme_hash_get (mt -> key_map , idx ) ); 
        if ((((intptr_t ) (idx ) ) >> 1 ) != mt -> print_now )
          RET_VALUE_START (idx ) RET_VALUE_END ; 

        idx = ((void * ) 0 ) ; 
      }
    }
  }

  RET_VALUE_START (idx ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1583 "./../src/print.c"
static void set_symtab_shared (Scheme_Marshal_Tables * mt , Scheme_Object * obj ) 
{
  /* No conversion */

# 1585 "./../src/print.c"
  (void ) get_symtab_idx (mt , obj ) ; 
}

static void print_general_symtab_ref (PrintParams * pp , Scheme_Object * idx , int cpt_id ) 
{
  int l ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(idx, 1)));
# define XfOrM177_COUNT (2)
# define SETUP_XfOrM177(x) SETUP(XfOrM177_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM177(_), print_this_string (pp , & compacts [cpt_id ] , 0 , 1 ) )
# 1591 "./../src/print.c"
  ; 
  l = (((intptr_t ) (idx ) ) >> 1 ) ; 
  FUNCCALL_EMPTY(print_compact_number (pp , l ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1596 "./../src/print.c"
static void print_symtab_ref (PrintParams * pp , Scheme_Object * idx ) 
{
  /* No conversion */

# 1598 "./../src/print.c"
  print_general_symtab_ref (pp , idx , CPT_SYMREF ) ; 
}

static int add_symtab (Scheme_Marshal_Tables * mt , Scheme_Object * obj ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(mt, 0), PUSH(obj, 1)));
# define XfOrM179_COUNT (2)
# define SETUP_XfOrM179(x) SETUP(XfOrM179_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1603 "./../src/print.c"
  if (mt -> pass < 1 ) {
    int l ; 
#   define XfOrM184_COUNT (0+XfOrM179_COUNT)
#   define SETUP_XfOrM184(x) SETUP_XfOrM179(x)

# 1605 "./../src/print.c"
    l = mt -> symtab -> count + 1 ; 
    FUNCCALL(SETUP_XfOrM184(_), scheme_hash_set (mt -> symtab , obj , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (l ) ) ) << 1 ) | 0x1 ) ) ) ); 
    RET_VALUE_START (l ) RET_VALUE_END ; 
  }

# 1608 "./../src/print.c"
  else {
    Scheme_Object * key , * l ; 
    BLOCK_SETUP((PUSH(key, 0+XfOrM179_COUNT), PUSH(l, 1+XfOrM179_COUNT)));
#   define XfOrM180_COUNT (2+XfOrM179_COUNT)
#   define SETUP_XfOrM180(x) SETUP(XfOrM180_COUNT)
    key = NULLED_OUT ; 
    l = NULLED_OUT ; 

# 1611 "./../src/print.c"
    key = FUNCCALL(SETUP_XfOrM180(_), scheme_hash_get (mt -> st_refs , obj ) ); 
    for (l = mt -> st_ref_stack ; ! key && ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM183_COUNT (0+XfOrM180_COUNT)
#     define SETUP_XfOrM183(x) SETUP_XfOrM180(x)

# 1613 "./../src/print.c"
      key = FUNCCALL(SETUP_XfOrM183(_), scheme_hash_get ((Scheme_Hash_Table * ) (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) , obj ) ); 
    }

    if (! key ) {

      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }

    key = FUNCCALL(SETUP_XfOrM180(_), scheme_hash_get (mt -> key_map , key ) ); 
    FUNCCALL(SETUP_XfOrM180(_), scheme_hash_set (mt -> symtab , obj , key ) )
    ; 

    RET_VALUE_START ((((intptr_t ) (key ) ) >> 1 ) ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1629 "./../src/print.c"
static void symtab_set (PrintParams * pp , Scheme_Marshal_Tables * mt , Scheme_Object * obj ) 
{
  /* No conversion */

# 1631 "./../src/print.c"
  (void ) add_symtab (mt , obj ) ; 
}

static void print_symtab_set (PrintParams * pp , Scheme_Marshal_Tables * mt , Scheme_Object * obj ) 
{
  int l ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(pp, 0)));
# define XfOrM186_COUNT (1)
# define SETUP_XfOrM186(x) SETUP(XfOrM186_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1637 "./../src/print.c"
  l = FUNCCALL(SETUP_XfOrM186(_), add_symtab (mt , obj ) ); 
  FUNCCALL_EMPTY(print_compact_number (pp , l ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1641 "./../src/print.c"
static void print_escaped (PrintParams * pp , int notdisplay , 
Scheme_Object * obj , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , int shared ) 
{
  char * r ; 
  intptr_t len ; 
  Scheme_Object * idx ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(pp, 1), PUSH(r, 2), PUSH(mt, 3), PUSH(idx, 4), PUSH(obj, 5)));
# define XfOrM187_COUNT (6)
# define SETUP_XfOrM187(x) SETUP(XfOrM187_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  r = NULLED_OUT ; 
  idx = NULLED_OUT ; 

# 1649 "./../src/print.c"
  if (shared ) {
#   define XfOrM189_COUNT (0+XfOrM187_COUNT)
#   define SETUP_XfOrM189(x) SETUP_XfOrM187(x)

# 1650 "./../src/print.c"
    idx = FUNCCALL(SETUP_XfOrM189(_), get_symtab_idx (mt , obj ) ); 
    if (idx ) {
#     define XfOrM190_COUNT (0+XfOrM189_COUNT)
#     define SETUP_XfOrM190(x) SETUP_XfOrM189(x)
      FUNCCALL(SETUP_XfOrM190(_), print_symtab_ref (pp , idx ) )
# 1652 "./../src/print.c"
      ; 
      RET_NOTHING ; 
    }
  }
  FUNCCALL(SETUP_XfOrM187(_), print_substring (obj , notdisplay , 0 , ht , ((void * ) 0 ) , pp , & r , & len , 0 , ((void * ) 0 ) ) )
  ; 
  FUNCCALL(SETUP_XfOrM187(_), print_this_string (pp , & compacts [CPT_ESCAPE ] , 0 , 1 ) )
  ; 
  FUNCCALL_AGAIN(print_compact_number (pp , len ) ); 
  FUNCCALL_AGAIN(print_this_string (pp , r , 0 , len ) ); 

  if (mt ) {
#   define XfOrM188_COUNT (0+XfOrM187_COUNT)
#   define SETUP_XfOrM188(x) SETUP_XfOrM187(x)
    FUNCCALL(SETUP_XfOrM188(_), symtab_set (pp , mt , obj ) )
# 1664 "./../src/print.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1668 "./../src/print.c"
static void cannot_print (PrintParams * pp , int notdisplay , 
Scheme_Object * obj , Scheme_Hash_Table * ht , 
int compact ) 
{
  /* No conversion */

# 1672 "./../src/print.c"
  scheme_raise_exn (MZEXN_FAIL , 
  ((compact || pp -> printing_quoted ) 
  ? "%s: cannot marshal value that is embedded in compiled code\n  value: %V" 
  : "%s: printing disabled for unreadable value\n  value: %V" ) , 
  notdisplay ? "write" : "display" , 
  obj ) ; 
}

# 1692 "./../src/print.c"
static void print_named (Scheme_Object * obj , const char * kind , 
const char * s , int len , PrintParams * pp ) 
{
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(s, 0), PUSH(kind, 1), PUSH(pp, 2)));
# define XfOrM192_COUNT (3)
# define SETUP_XfOrM192(x) SETUP(XfOrM192_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM192(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 1695 "./../src/print.c"
  ; 
  FUNCCALL(SETUP_XfOrM192(_), print_utf8_string (pp , kind , 0 , - 1 ) ); 

  if (s ) {
#   define XfOrM193_COUNT (0+XfOrM192_COUNT)
#   define SETUP_XfOrM193(x) SETUP_XfOrM192(x)
    FUNCCALL(SETUP_XfOrM193(_), print_utf8_string (pp , ":" , 0 , 1 ) )
# 1699 "./../src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM193(_), print_utf8_string (pp , s , 0 , len ) )
    ; 
  }

  ; 
  FUNCCALL_EMPTY(print_utf8_string (pp , ">" , 0 , 1 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1708 "./../src/print.c"
static int to_quoted (Scheme_Object * obj , PrintParams * pp , int notdisplay ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(pp, 0), PUSH(obj, 1)));
# define XfOrM194_COUNT (2)
# define SETUP_XfOrM194(x) SETUP(XfOrM194_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1710 "./../src/print.c"
  if (notdisplay == 3 ) {
#   define XfOrM195_COUNT (0+XfOrM194_COUNT)
#   define SETUP_XfOrM195(x) SETUP_XfOrM194(x)

# 1711 "./../src/print.c"
    if (! obj || ! pp -> uq_ht )
      obj = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    else {
#     define XfOrM197_COUNT (0+XfOrM195_COUNT)
#     define SETUP_XfOrM197(x) SETUP_XfOrM195(x)

# 1714 "./../src/print.c"
      obj = FUNCCALL(SETUP_XfOrM197(_), scheme_hash_get (pp -> uq_ht , obj ) ); 
      if (! obj )

# 1715 "./../src/print.c"
      obj = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
    }

    if (! ((((intptr_t ) (obj ) ) >> 1 ) & 0x1 ) ) {
#     define XfOrM196_COUNT (0+XfOrM195_COUNT)
#     define SETUP_XfOrM196(x) SETUP_XfOrM195(x)
      FUNCCALL_EMPTY(print_utf8_string (pp , "'" , 0 , 1 ) )
# 1719 "./../src/print.c"
      ; 
      RET_VALUE_START (notdisplay + 1 ) RET_VALUE_END ; 
    }

# 1721 "./../src/print.c"
    else 
    RET_VALUE_START (notdisplay ) RET_VALUE_END ; 
  }

# 1723 "./../src/print.c"
  else 
  RET_VALUE_START (notdisplay ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1727 "./../src/print.c"
static int is_graph_point (Scheme_Hash_Table * ht , Scheme_Object * obj ) 
{
  /* No conversion */

# 1729 "./../src/print.c"
  if (ht ) {
    intptr_t v ; 
    v = (intptr_t ) scheme_hash_get (ht , obj ) ; 
    if ((v == 0 ) || (v == 1 ) )
      return 0 ; 
    return 1 ; 
  }

# 1735 "./../src/print.c"
  else 
  return 0 ; 
}

static int 
print (Scheme_Object * obj , int notdisplay , int compact , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , PrintParams * pp ) 

{
  int closed = 0 ; 

# 24 "./../src/mzstkchk.h"
  uintptr_t _stk_pos ; 
  char * __funcarg103 = NULLED_OUT ; 
  char * __funcarg102 = NULLED_OUT ; 
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  Scheme_Config * __funcarg100 = NULLED_OUT ; 
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  Scheme_Object * __funcarg98 = NULLED_OUT ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  Scheme_Config * __funcarg95 = NULLED_OUT ; 
  Scheme_Config * __funcarg94 = NULLED_OUT ; 
  char * __funcarg93 = NULLED_OUT ; 
  char * __funcarg92 = NULLED_OUT ; 
  char * __funcarg91 = NULLED_OUT ; 
  char * __funcarg90 = NULLED_OUT ; 
  char * __funcarg89 = NULLED_OUT ; 
  char * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  Scheme_Object * __funcarg61 = NULLED_OUT ; 
  Scheme_Object * __funcarg60 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(pp, 1), PUSH(mt, 2), PUSH(obj, 3)));
# define XfOrM200_COUNT (4)
# define SETUP_XfOrM200(x) SETUP(XfOrM200_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 26 "./../src/mzstkchk.h"
  _stk_pos = (uintptr_t ) & _stk_pos ; 

  if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
  && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 1748 "./../src/print.c"
  {
    Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    PrintParams * pp2 ; 
    BLOCK_SETUP((PUSH(pp2, 0+XfOrM200_COUNT), PUSH(p, 1+XfOrM200_COUNT)));
#   define XfOrM468_COUNT (2+XfOrM200_COUNT)
#   define SETUP_XfOrM468(x) SETUP(XfOrM468_COUNT)
    pp2 = NULLED_OUT ; 

# 1752 "./../src/print.c"
    pp2 = FUNCCALL(SETUP_XfOrM468(_), copy_print_params (pp ) ); 

    p -> ku . k . p1 = (void * ) obj ; 
    p -> ku . k . i1 = notdisplay ; 
    p -> ku . k . i2 = compact ; 
    p -> ku . k . p2 = (void * ) ht ; 
    p -> ku . k . p3 = mt ; 
    p -> ku . k . p5 = pp2 ; 

    obj = FUNCCALL(SETUP_XfOrM468(_), scheme_handle_stack_overflow (print_k ) ); 
    (
    memcpy (pp , pp2 , sizeof (PrintParams ) ) ) ; 

    if (((obj ) ) == (scheme_void ) )  {
      (((intptr_t * ) (void * ) ((* pp -> print_escape ) . gcvs ) ) [1 ] = (* pp -> print_escape ) . gcvs_cnt , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> GC_variable_stack_ ) = (void * * ) (void * ) (* pp -> print_escape ) . gcvs , longjmp ((* pp -> print_escape ) . jb , 1 ) ) ; 
    }

    RET_VALUE_START (closed ) RET_VALUE_END ; 
  }


  if (scheme_check_print_is_obj && ! FUNCCALL(SETUP_XfOrM200(_), scheme_check_print_is_obj (obj ) )) {
#   define XfOrM467_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM467(x) SETUP_XfOrM200(x)
    FUNCCALL(SETUP_XfOrM467(_), print_utf8_string (pp , "#<" "???" ">" , 0 , 6 ) )
# 1774 "./../src/print.c"
    ; 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }


  if (compact && ((! (((intptr_t ) (obj ) ) & 0x1 ) && ((((obj ) -> type ) >= scheme_prim_type ) && (((obj ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) 
  || (((obj ) ) == (scheme_eof ) ) 
  || ((scheme_undefined ) == (obj ) ) 
  || ((scheme_parameterization_key ) == (obj ) ) 
  || ((scheme_break_enabled_key ) == (obj ) ) 
  || ((scheme_exn_handler_key ) == (obj ) ) 
  || ((Scheme_Type ) (scheme_always_evt_type ) == (Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) 
  || ((Scheme_Type ) (scheme_never_evt_type ) == (Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) 
  || ((Scheme_Type ) (scheme_struct_property_type ) == (Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) 
  || ((Scheme_Type ) (scheme_ctype_type ) == (Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) 
  || ((scheme_app_mark_impersonator_property ) == (obj ) ) ) ) {

    Scheme_Object * val ; 
    BLOCK_SETUP((PUSH(val, 0+XfOrM200_COUNT)));
#   define XfOrM465_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM465(x) SETUP(XfOrM465_COUNT)
    val = NULLED_OUT ; 

# 1793 "./../src/print.c"
    val = FUNCCALL(SETUP_XfOrM465(_), scheme_hash_get (scheme_startup_env -> primitive_ids_table , obj ) ); 
    if (val ) {
#     define XfOrM466_COUNT (0+XfOrM465_COUNT)
#     define SETUP_XfOrM466(x) SETUP_XfOrM465(x)
      FUNCCALL(SETUP_XfOrM466(_), print_this_string (pp , & compacts [CPT_REFERENCE ] , 0 , 1 ) )
# 1795 "./../src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM466(_), print_compact_number (pp , (((intptr_t ) (val ) ) >> 1 ) ) ); 
      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }

  if (ht && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) ) || (pp -> print_box && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) || (pp -> print_struct && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && (FUNCCALL(SETUP_XfOrM200(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) ) || (((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && FUNCCALL(SETUP_XfOrM200(_), scheme_is_writable_struct (obj ) )) || (pp -> print_struct && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (obj ) ) -> stype -> prefab_key ) ) || (pp -> print_hash_table && ((((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) obj ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? (((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> count ) : (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (obj ) ) -> count ) ) ) ) ) ) {
    intptr_t val ; 
#   define XfOrM458_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM458(x) SETUP_XfOrM200(x)

# 1804 "./../src/print.c"
    val = (intptr_t ) FUNCCALL(SETUP_XfOrM458(_), scheme_hash_get (ht , obj ) ); 

    if (val ) {
#     define XfOrM459_COUNT (0+XfOrM458_COUNT)
#     define SETUP_XfOrM459(x) SETUP_XfOrM458(x)

# 1807 "./../src/print.c"
      if (val != 1 ) {
#       define XfOrM460_COUNT (0+XfOrM459_COUNT)
#       define SETUP_XfOrM460(x) SETUP_XfOrM459(x)

# 1808 "./../src/print.c"
        if (compact ) {
#         define XfOrM464_COUNT (0+XfOrM460_COUNT)
#         define SETUP_XfOrM464(x) SETUP_XfOrM460(x)
          FUNCCALL(SETUP_XfOrM464(_), print_escaped (pp , notdisplay , obj , ht , mt , 0 ) )
# 1809 "./../src/print.c"
          ; 
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        }

# 1811 "./../src/print.c"
        else {
#         define XfOrM461_COUNT (0+XfOrM460_COUNT)
#         define SETUP_XfOrM461(x) SETUP_XfOrM460(x)

# 1812 "./../src/print.c"
          if (val > 0 ) {
#           define XfOrM463_COUNT (0+XfOrM461_COUNT)
#           define SETUP_XfOrM463(x) SETUP_XfOrM461(x)
            (
# 1813 "./../src/print.c"
            sprintf (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , "#%" "l" "d" "=" , (val - 3 ) >> 1 ) ) ; 
            FUNCCALL(SETUP_XfOrM463(_), print_utf8_string (pp , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , 0 , - 1 ) ); 
            FUNCCALL_AGAIN(scheme_hash_set (ht , obj , (Scheme_Object * ) (- val ) ) ); 
          }

# 1816 "./../src/print.c"
          else {
#           define XfOrM462_COUNT (0+XfOrM461_COUNT)
#           define SETUP_XfOrM462(x) SETUP_XfOrM461(x)
            (
# 1817 "./../src/print.c"
            sprintf (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , "#%" "l" "d" "#" , ((- val ) - 3 ) >> 1 ) ) ; 
            FUNCCALL(SETUP_XfOrM462(_), print_utf8_string (pp , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , 0 , - 1 ) ); 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }
        }
      }
    }
  }

  if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) )  {
    if (! (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) )

    obj = (((Scheme_Chaperone * ) obj ) -> val ) ; 
  }

  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) ) 
  {
    intptr_t l ; 
    Scheme_Object * idx ; 
    int is_kw ; 
    BLOCK_SETUP((PUSH(idx, 0+XfOrM200_COUNT)));
#   define XfOrM447_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM447(x) SETUP(XfOrM447_COUNT)
    idx = NULLED_OUT ; 

# 1839 "./../src/print.c"
    is_kw = ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_keyword_type ) ) ; 

    if (compact )
      idx = FUNCCALL(SETUP_XfOrM447(_), get_symtab_idx (mt , obj ) ); 
    else 
    idx = ((void * ) 0 ) ; 

    if (idx ) {
#     define XfOrM456_COUNT (0+XfOrM447_COUNT)
#     define SETUP_XfOrM456(x) SETUP_XfOrM447(x)
      FUNCCALL(SETUP_XfOrM456(_), print_symtab_ref (pp , idx ) )
# 1847 "./../src/print.c"
      ; 
    }

# 1848 "./../src/print.c"
    else if (compact ) {
      int weird ; 
#     define XfOrM452_COUNT (0+XfOrM447_COUNT)
#     define SETUP_XfOrM452(x) SETUP_XfOrM447(x)

# 1851 "./../src/print.c"
      weird = ((& ((Scheme_Symbol * ) (obj ) ) -> iso ) -> so . keyex & 0x3 ) ; 
      l = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> len ) ; 
      if (! weird && ! is_kw && (l < (92 - 74 ) ) ) {
        unsigned char s [1 ] ; 
#       define XfOrM455_COUNT (0+XfOrM452_COUNT)
#       define SETUP_XfOrM455(x) SETUP_XfOrM452(x)

# 1855 "./../src/print.c"
        s [0 ] = l + 74 ; 
        FUNCCALL(SETUP_XfOrM455(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      }

# 1857 "./../src/print.c"
      else {
#       define XfOrM453_COUNT (0+XfOrM452_COUNT)
#       define SETUP_XfOrM453(x) SETUP_XfOrM452(x)
        FUNCCALL(SETUP_XfOrM453(_), print_this_string (pp , & compacts [(is_kw ? CPT_KEYWORD : (weird ? CPT_WEIRD_SYMBOL : CPT_SYMBOL ) ) ] , 0 , 1 ) ); 
        if (weird ) {
#         define XfOrM454_COUNT (0+XfOrM453_COUNT)
#         define SETUP_XfOrM454(x) SETUP_XfOrM453(x)
          FUNCCALL(SETUP_XfOrM454(_), print_compact_number (pp , ((& ((Scheme_Symbol * ) (obj ) ) -> iso ) -> so . keyex & 0x1 ) ? 1 : 0 ) )
# 1862 "./../src/print.c"
          ; 
        }
        FUNCCALL(SETUP_XfOrM453(_), print_compact_number (pp , l ) ); 
      }
      (__funcarg103 = FUNCCALL(SETUP_XfOrM452(_), scheme_symbol_val (obj ) )


      , FUNCCALL_AGAIN(print_this_string (pp , __funcarg103 , 0 , l ) )) ; 
      FUNCCALL(SETUP_XfOrM452(_), symtab_set (pp , mt , obj ) )
      ; 
    }

# 1872 "./../src/print.c"
    else if (notdisplay ) {
      const char * s ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM447_COUNT)));
#     define XfOrM449_COUNT (1+XfOrM447_COUNT)
#     define SETUP_XfOrM449(x) SETUP(XfOrM449_COUNT)
      s = NULLED_OUT ; 

# 1875 "./../src/print.c"
      if (notdisplay >= 3 ) {
#       define XfOrM450_COUNT (0+XfOrM449_COUNT)
#       define SETUP_XfOrM450(x) SETUP_XfOrM449(x)

# 1876 "./../src/print.c"
        if ((qq_ellipses ) == (obj ) )  {
        }
        else 
        notdisplay = FUNCCALL(SETUP_XfOrM450(_), to_quoted (((void * ) 0 ) , pp , notdisplay ) ); 
      }

      if (is_kw )
        FUNCCALL(SETUP_XfOrM449(_), print_utf8_string (pp , "#:" , 0 , 2 ) ); 
      s = FUNCCALL(SETUP_XfOrM449(_), scheme_symbol_name_and_size (obj , (uintptr_t * ) & l , ((pp -> can_read_pipe_quote ? 0x2 : 0x4 ) | (pp -> case_sens ? 0 : 0x8 ) | (is_kw ? 0x10 : 0 ) ) ) )








      ; 
      FUNCCALL_AGAIN(print_utf8_string (pp , s , 0 , l ) ); 
    }

# 1895 "./../src/print.c"
    else {
#     define XfOrM448_COUNT (0+XfOrM447_COUNT)
#     define SETUP_XfOrM448(x) SETUP_XfOrM447(x)

# 1896 "./../src/print.c"
      if (is_kw )
        FUNCCALL(SETUP_XfOrM448(_), print_utf8_string (pp , "#:" , 0 , 2 ) ); 
      FUNCCALL(SETUP_XfOrM448(_), print_utf8_string (pp , (char * ) obj , ((char * ) ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> s ) ) ) - ((char * ) obj ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (obj ) ) ) -> len ) ) )
      ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  
  {
#   define XfOrM441_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM441(x) SETUP_XfOrM200(x)

# 1904 "./../src/print.c"
    if (compact ) {
      int l ; 
      Scheme_Object * idx ; 
      BLOCK_SETUP((PUSH(idx, 0+XfOrM441_COUNT)));
#     define XfOrM444_COUNT (1+XfOrM441_COUNT)
#     define SETUP_XfOrM444(x) SETUP(XfOrM444_COUNT)
      idx = NULLED_OUT ; 

# 1908 "./../src/print.c"
      idx = FUNCCALL(SETUP_XfOrM444(_), get_symtab_idx (mt , obj ) ); 
      if (idx ) {
#       define XfOrM446_COUNT (0+XfOrM444_COUNT)
#       define SETUP_XfOrM446(x) SETUP_XfOrM444(x)
        FUNCCALL(SETUP_XfOrM446(_), print_symtab_ref (pp , idx ) )
# 1910 "./../src/print.c"
        ; 
      }

# 1911 "./../src/print.c"
      else {
#       define XfOrM445_COUNT (0+XfOrM444_COUNT)
#       define SETUP_XfOrM445(x) SETUP_XfOrM444(x)
        FUNCCALL(SETUP_XfOrM445(_), print_this_string (pp , & compacts [CPT_BYTE_STRING ] , 0 , 1 ) )
# 1912 "./../src/print.c"
        ; 
        l = (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . tag_val ) ; 
        FUNCCALL(SETUP_XfOrM445(_), print_compact_number (pp , l ) ); 
        FUNCCALL_AGAIN(print_this_string (pp , (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . string_val ) , 0 , l ) ); 
        FUNCCALL_AGAIN(symtab_set (pp , mt , obj ) )
        ; 
      }
    }

# 1919 "./../src/print.c"
    else {
#     define XfOrM442_COUNT (0+XfOrM441_COUNT)
#     define SETUP_XfOrM442(x) SETUP_XfOrM441(x)

# 1920 "./../src/print.c"
      if (notdisplay ) {
#       define XfOrM443_COUNT (0+XfOrM442_COUNT)
#       define SETUP_XfOrM443(x) SETUP_XfOrM442(x)
        FUNCCALL(SETUP_XfOrM443(_), print_utf8_string (pp , "#" , 0 , 1 ) )
# 1921 "./../src/print.c"
        ; 
      }
      FUNCCALL(SETUP_XfOrM442(_), print_byte_string ((((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . tag_val ) , notdisplay , pp ) )


      ; 
      closed = 1 ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  
  {
    Scheme_Object * idx ; 
    BLOCK_SETUP((PUSH(idx, 0+XfOrM200_COUNT)));
#   define XfOrM438_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM438(x) SETUP(XfOrM438_COUNT)
    idx = NULLED_OUT ; 

# 1934 "./../src/print.c"
    if (compact )
      idx = FUNCCALL(SETUP_XfOrM438(_), get_symtab_idx (mt , obj ) ); 
    else 
    idx = ((void * ) 0 ) ; 

    if (idx ) {
#     define XfOrM440_COUNT (0+XfOrM438_COUNT)
#     define SETUP_XfOrM440(x) SETUP_XfOrM438(x)
      FUNCCALL(SETUP_XfOrM440(_), print_symtab_ref (pp , idx ) )
# 1940 "./../src/print.c"
      ; 
    }

# 1941 "./../src/print.c"
    else {
#     define XfOrM439_COUNT (0+XfOrM438_COUNT)
#     define SETUP_XfOrM439(x) SETUP_XfOrM438(x)
      FUNCCALL(SETUP_XfOrM439(_), do_print_string (compact , notdisplay , pp , (((Scheme_Simple_Object * ) (obj ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (obj ) ) -> u . char_str_val . tag_val ) ) )
# 1943 "./../src/print.c"
      ; 
      if (compact )
        FUNCCALL(SETUP_XfOrM439(_), symtab_set (pp , mt , obj ) ); 
    }
    closed = 1 ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_unquoted_printing_string_type ) )  
  {
#   define XfOrM435_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM435(x) SETUP_XfOrM200(x)

# 1951 "./../src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM437_COUNT (0+XfOrM435_COUNT)
#     define SETUP_XfOrM437(x) SETUP_XfOrM435(x)
      FUNCCALL(SETUP_XfOrM437(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 1952 "./../src/print.c"
      ; 
    }

# 1953 "./../src/print.c"
    else {
#     define XfOrM436_COUNT (0+XfOrM435_COUNT)
#     define SETUP_XfOrM436(x) SETUP_XfOrM435(x)

# 1954 "./../src/print.c"
      obj = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
      FUNCCALL(SETUP_XfOrM436(_), do_print_string (compact , 0 , pp , (((Scheme_Simple_Object * ) (obj ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (obj ) ) -> u . char_str_val . tag_val ) ) )
      ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_char_type ) )  
  {
#   define XfOrM433_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM433(x) SETUP_XfOrM200(x)

# 1961 "./../src/print.c"
    if (compact ) {
      int cv ; 
#     define XfOrM434_COUNT (0+XfOrM433_COUNT)
#     define SETUP_XfOrM434(x) SETUP_XfOrM433(x)
      FUNCCALL(SETUP_XfOrM434(_), print_this_string (pp , & compacts [CPT_CHAR ] , 0 , 1 ) )
# 1963 "./../src/print.c"
      ; 
      cv = (((Scheme_Small_Object * ) (obj ) ) -> u . char_val ) ; 
      FUNCCALL(SETUP_XfOrM434(_), print_compact_number (pp , cv ) ); 
    }

# 1966 "./../src/print.c"
    else FUNCCALL(SETUP_XfOrM433(_), print_char (obj , notdisplay , pp ) )
    ; 
  }
  else if (((intptr_t ) (obj ) ) & 0x1 )  
  {
#   define XfOrM426_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM426(x) SETUP_XfOrM200(x)

# 1971 "./../src/print.c"
    if (compact ) {
      intptr_t v = (((intptr_t ) (obj ) ) >> 1 ) ; 
#     define XfOrM428_COUNT (0+XfOrM426_COUNT)
#     define SETUP_XfOrM428(x) SETUP_XfOrM426(x)

# 1973 "./../src/print.c"
      if (v >= 0 && v < (74 - 47 ) ) {
        unsigned char s [1 ] ; 
#       define XfOrM432_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM432(x) SETUP_XfOrM428(x)

# 1975 "./../src/print.c"
        s [0 ] = (unsigned char ) (v + 47 ) ; 
        FUNCCALL(SETUP_XfOrM432(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      }

# 1977 "./../src/print.c"
      else {
#       define XfOrM429_COUNT (0+XfOrM428_COUNT)
#       define SETUP_XfOrM429(x) SETUP_XfOrM428(x)

# 1979 "./../src/print.c"
        if (((v ) >= - 1073741824 ) && ((v ) <= 1073741823 ) )  {
#         define XfOrM431_COUNT (0+XfOrM429_COUNT)
#         define SETUP_XfOrM431(x) SETUP_XfOrM429(x)
          FUNCCALL(SETUP_XfOrM431(_), print_this_string (pp , & compacts [CPT_INT ] , 0 , 1 ) )
# 1980 "./../src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM431(_), print_compact_number (pp , v ) ); 
        }

# 1982 "./../src/print.c"
        else {
#         define XfOrM430_COUNT (0+XfOrM429_COUNT)
#         define SETUP_XfOrM430(x) SETUP_XfOrM429(x)
          FUNCCALL(SETUP_XfOrM430(_), print_escaped (pp , notdisplay , obj , ht , mt , 1 ) )
# 1983 "./../src/print.c"
          ; 
        }
      }
    }

# 1986 "./../src/print.c"
    else {
#     define XfOrM427_COUNT (0+XfOrM426_COUNT)
#     define SETUP_XfOrM427(x) SETUP_XfOrM426(x)
      (
# 1987 "./../src/print.c"
      sprintf (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , "%" "l" "d" "" , (((intptr_t ) (obj ) ) >> 1 ) ) ) ; 
      FUNCCALL(SETUP_XfOrM427(_), print_utf8_string (pp , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , 0 , - 1 ) ); 
    }
  }
  else if (((((intptr_t ) (obj ) ) & 0x1 ) || ((((obj ) -> type ) >= scheme_bignum_type ) && (((obj ) -> type ) <= scheme_complex_type ) ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_long_double_type ) ) ) 
  {
#   define XfOrM423_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM423(x) SETUP_XfOrM200(x)

# 1993 "./../src/print.c"
    if (compact ) {
#     define XfOrM425_COUNT (0+XfOrM423_COUNT)
#     define SETUP_XfOrM425(x) SETUP_XfOrM423(x)
      FUNCCALL(SETUP_XfOrM425(_), print_escaped (pp , notdisplay , obj , ht , mt , 1 ) )
# 1994 "./../src/print.c"
      ; 
      closed = 1 ; 
    }

# 1996 "./../src/print.c"
    else {
#     define XfOrM424_COUNT (0+XfOrM423_COUNT)
#     define SETUP_XfOrM424(x) SETUP_XfOrM423(x)
      (__funcarg102 = FUNCCALL(SETUP_XfOrM424(_), scheme_number_to_string (10 , obj ) )
# 1997 "./../src/print.c"
      , FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg102 , 0 , - 1 ) )) ; 
    }
  }
  else if ((obj ) == (scheme_null ) )  
  {
#   define XfOrM420_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM420(x) SETUP_XfOrM200(x)

# 2002 "./../src/print.c"
    if (compact ) {
#     define XfOrM422_COUNT (0+XfOrM420_COUNT)
#     define SETUP_XfOrM422(x) SETUP_XfOrM420(x)
      FUNCCALL(SETUP_XfOrM422(_), print_this_string (pp , & compacts [CPT_NULL ] , 0 , 1 ) )
# 2003 "./../src/print.c"
      ; 
    }

# 2004 "./../src/print.c"
    else {
#     define XfOrM421_COUNT (0+XfOrM420_COUNT)
#     define SETUP_XfOrM421(x) SETUP_XfOrM420(x)
      FUNCCALL(SETUP_XfOrM421(_), to_quoted (((void * ) 0 ) , pp , notdisplay ) )
# 2005 "./../src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM421(_), print_utf8_string (pp , "()" , 0 , 2 ) ); 
      closed = 1 ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  
  {
#   define XfOrM419_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM419(x) SETUP_XfOrM200(x)

# 2012 "./../src/print.c"
    notdisplay = FUNCCALL(SETUP_XfOrM419(_), to_quoted (obj , pp , notdisplay ) ); 
    FUNCCALL(SETUP_XfOrM419(_), print_pair (obj , notdisplay , compact , ht , mt , pp , scheme_pair_type , ! pp -> print_pair_curly , 0 ) ); 
    closed = 1 ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) )  
  {
#   define XfOrM418_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM418(x) SETUP_XfOrM200(x)

# 2018 "./../src/print.c"
    if (compact || ! pp -> print_unreadable )
      FUNCCALL(SETUP_XfOrM418(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    FUNCCALL(SETUP_XfOrM418(_), print_pair (obj , notdisplay , compact , ht , mt , pp , scheme_mutable_pair_type , ! pp -> print_mpair_curly , 0 ) ); 
    closed = 1 ; 
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) )  
  {
#   define XfOrM417_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM417(x) SETUP_XfOrM200(x)

# 2025 "./../src/print.c"
    notdisplay = FUNCCALL(SETUP_XfOrM417(_), to_quoted (obj , pp , notdisplay ) ); 
    FUNCCALL(SETUP_XfOrM417(_), print_vector (obj , notdisplay , compact , ht , mt , pp , 0 ) ); 
    closed = 1 ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) )  
  {
#   define XfOrM416_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM416(x) SETUP_XfOrM200(x)

# 2031 "./../src/print.c"
    notdisplay = FUNCCALL(SETUP_XfOrM416(_), to_quoted (obj , pp , notdisplay ) ); 
    FUNCCALL(SETUP_XfOrM416(_), print_flvector (obj , notdisplay , compact , ht , mt , pp , 0 ) ); 
    closed = 1 ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) )  
  {
#   define XfOrM415_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM415(x) SETUP_XfOrM200(x)

# 2037 "./../src/print.c"
    notdisplay = FUNCCALL(SETUP_XfOrM415(_), to_quoted (obj , pp , notdisplay ) ); 
    FUNCCALL(SETUP_XfOrM415(_), print_fxvector (obj , notdisplay , compact , ht , mt , pp , 0 ) ); 
    closed = 1 ; 
  }
  else if ((compact || pp -> print_box ) && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) 
  {
#   define XfOrM411_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM411(x) SETUP_XfOrM200(x)

# 2043 "./../src/print.c"
    if (compact && ! pp -> print_box ) {
#     define XfOrM414_COUNT (0+XfOrM411_COUNT)
#     define SETUP_XfOrM414(x) SETUP_XfOrM411(x)

# 2044 "./../src/print.c"
      closed = (__funcarg101 = FUNCCALL(SETUP_XfOrM414(_), scheme_protect_quote (obj ) ), FUNCCALL_AGAIN(print (__funcarg101 , notdisplay , compact , ht , mt , pp ) )) ; 
    }

# 2045 "./../src/print.c"
    else {
      Scheme_Object * content ; 
      BLOCK_SETUP((PUSH(content, 0+XfOrM411_COUNT)));
#     define XfOrM412_COUNT (1+XfOrM411_COUNT)
#     define SETUP_XfOrM412(x) SETUP(XfOrM412_COUNT)
      content = NULLED_OUT ; 

# 2047 "./../src/print.c"
      if (compact )
        FUNCCALL(SETUP_XfOrM412(_), print_this_string (pp , & compacts [CPT_BOX ] , 0 , 1 ) ); 
      else {
#       define XfOrM413_COUNT (0+XfOrM412_COUNT)
#       define SETUP_XfOrM413(x) SETUP_XfOrM412(x)

# 2050 "./../src/print.c"
        notdisplay = FUNCCALL(SETUP_XfOrM413(_), to_quoted (obj , pp , notdisplay ) ); 
        if (notdisplay == 3 )
          FUNCCALL(SETUP_XfOrM413(_), print_utf8_string (pp , "(box " , 0 , 5 ) ); 
        else FUNCCALL(SETUP_XfOrM413(_), print_utf8_string (pp , "#&" , 0 , 2 ) )
        ; 
      }
      if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) 
        content = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 
      else 
      content = FUNCCALL(SETUP_XfOrM412(_), scheme_unbox (obj ) ); 
      closed = FUNCCALL(SETUP_XfOrM412(_), print (content , notdisplay , compact , ht , mt , pp ) ); 
      if (notdisplay == 3 )
        FUNCCALL(SETUP_XfOrM412(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
    }
  }
  else if ((compact || pp -> print_hash_table ) 
  && ((((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) obj ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) ) || (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) ) ) ) ) 
  {
    Scheme_Hash_Table * t ; 
    Scheme_Hash_Tree * tr ; 
    Scheme_Object * * keys , * * vals , * val , * key , * orig , * * sorted_keys ; 
    intptr_t i , size , count , vals_size ; 
    int did_one = 0 ; 
    mzlonglong pos ; 
    BLOCK_SETUP((PUSH(tr, 0+XfOrM200_COUNT), PUSH(keys, 1+XfOrM200_COUNT), PUSH(val, 2+XfOrM200_COUNT), PUSH(key, 3+XfOrM200_COUNT), PUSH(orig, 4+XfOrM200_COUNT), PUSH(sorted_keys, 5+XfOrM200_COUNT), PUSH(vals, 6+XfOrM200_COUNT), PUSH(t, 7+XfOrM200_COUNT)));
#   define XfOrM381_COUNT (8+XfOrM200_COUNT)
#   define SETUP_XfOrM381(x) SETUP(XfOrM381_COUNT)
    t = NULLED_OUT ; 
    tr = NULLED_OUT ; 
    keys = NULLED_OUT ; 
    vals = NULLED_OUT ; 
    val = NULLED_OUT ; 
    key = NULLED_OUT ; 
    orig = NULLED_OUT ; 
    sorted_keys = NULLED_OUT ; 

# 2075 "./../src/print.c"
    orig = obj ; 
    if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
      obj = (((Scheme_Chaperone * ) obj ) -> val ) ; 

    if (compact ) {
#     define XfOrM410_COUNT (0+XfOrM381_COUNT)
#     define SETUP_XfOrM410(x) SETUP_XfOrM381(x)
      FUNCCALL(SETUP_XfOrM410(_), print_this_string (pp , & compacts [CPT_HASH_TABLE ] , 0 , 1 ) )
# 2080 "./../src/print.c"
      ; 
      if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && FUNCCALL(SETUP_XfOrM410(_), scheme_is_hash_table_equal (obj ) )) 
      || (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && FUNCCALL(SETUP_XfOrM410(_), scheme_is_hash_tree_equal (obj ) )) )
        FUNCCALL(SETUP_XfOrM410(_), print_compact_number (pp , 1 ) ); 
      else if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && FUNCCALL(SETUP_XfOrM410(_), scheme_is_hash_table_eqv (obj ) )) 
      || (((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && FUNCCALL(SETUP_XfOrM410(_), scheme_is_hash_tree_eqv (obj ) )) )
        FUNCCALL(SETUP_XfOrM410(_), print_compact_number (pp , 2 ) ); 
      else FUNCCALL(SETUP_XfOrM410(_), print_compact_number (pp , 0 ) )
      ; 
    }

# 2089 "./../src/print.c"
    else {
#     define XfOrM405_COUNT (0+XfOrM381_COUNT)
#     define SETUP_XfOrM405(x) SETUP_XfOrM381(x)

# 2090 "./../src/print.c"
      notdisplay = FUNCCALL(SETUP_XfOrM405(_), to_quoted (obj , pp , notdisplay ) ); 
      if (notdisplay == 3 )
        FUNCCALL(SETUP_XfOrM405(_), print_utf8_string (pp , "(hash" , 0 , 5 ) ); 
      else FUNCCALL(SETUP_XfOrM405(_), print_utf8_string (pp , "#hash" , 0 , 5 ) )
      ; 
      if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
#       define XfOrM408_COUNT (0+XfOrM405_COUNT)
#       define SETUP_XfOrM408(x) SETUP_XfOrM405(x)

# 2096 "./../src/print.c"
        if (! FUNCCALL(SETUP_XfOrM408(_), scheme_is_hash_table_equal (obj ) )) {
#         define XfOrM409_COUNT (0+XfOrM408_COUNT)
#         define SETUP_XfOrM409(x) SETUP_XfOrM408(x)

# 2097 "./../src/print.c"
          if (FUNCCALL(SETUP_XfOrM409(_), scheme_is_hash_table_eqv (obj ) ))
            FUNCCALL(SETUP_XfOrM409(_), print_utf8_string (pp , "eqv" , 0 , 3 ) ); 
          else FUNCCALL(SETUP_XfOrM409(_), print_utf8_string (pp , "eq" , 0 , 2 ) )
          ; 
        }
      }

# 2102 "./../src/print.c"
      else {
#       define XfOrM406_COUNT (0+XfOrM405_COUNT)
#       define SETUP_XfOrM406(x) SETUP_XfOrM405(x)

# 2103 "./../src/print.c"
        if (! FUNCCALL(SETUP_XfOrM406(_), scheme_is_hash_tree_equal (obj ) )) {
#         define XfOrM407_COUNT (0+XfOrM406_COUNT)
#         define SETUP_XfOrM407(x) SETUP_XfOrM406(x)

# 2104 "./../src/print.c"
          if (FUNCCALL(SETUP_XfOrM407(_), scheme_is_hash_tree_eqv (obj ) ))
            FUNCCALL(SETUP_XfOrM407(_), print_utf8_string (pp , "eqv" , 0 , 3 ) ); 
          else FUNCCALL(SETUP_XfOrM407(_), print_utf8_string (pp , "eq" , 0 , 2 ) )
          ; 
        }
      }
      if (notdisplay == 3 )
        FUNCCALL(SETUP_XfOrM405(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
      if (notdisplay != 3 )
        FUNCCALL(SETUP_XfOrM405(_), print_utf8_string (pp , "(" , 0 , 1 ) ); 
    }

    if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) )  {
      t = (Scheme_Hash_Table * ) obj ; 
      tr = ((void * ) 0 ) ; 
    }

# 2119 "./../src/print.c"
    else {
      t = ((void * ) 0 ) ; 
      tr = (Scheme_Hash_Tree * ) obj ; 
    }

    if (t ) {
      keys = t -> keys ; 
      vals = t -> vals ; 
      size = t -> size ; 
      vals_size = size ; 
      count = t -> count ; 
    }

# 2130 "./../src/print.c"
    else {
      keys = ((void * ) 0 ) ; 
      vals = ((void * ) 0 ) ; 
      vals_size = 0 ; 
      size = tr -> count ; 
      count = size ; 
    }

    if (compact )
      FUNCCALL(SETUP_XfOrM381(_), print_compact_number (pp , count ) ); 


    if ((obj ) == (orig ) )  {
#     define XfOrM400_COUNT (0+XfOrM381_COUNT)
#     define SETUP_XfOrM400(x) SETUP_XfOrM381(x)

# 2143 "./../src/print.c"
      sorted_keys = FUNCCALL(SETUP_XfOrM400(_), scheme_extract_sorted_keys (obj ) ); 
      if (sorted_keys )
        size = count ; 
    }

# 2146 "./../src/print.c"
    else 
    sorted_keys = ((void * ) 0 ) ; 

    pos = - 1 ; 
    for (i = 0 ; i < size ; i ++ ) {
#     define XfOrM391_COUNT (0+XfOrM381_COUNT)
#     define SETUP_XfOrM391(x) SETUP_XfOrM381(x)

# 2151 "./../src/print.c"
      if (! vals || vals [i ] || sorted_keys ) {
#       define XfOrM392_COUNT (0+XfOrM391_COUNT)
#       define SETUP_XfOrM392(x) SETUP_XfOrM391(x)

# 2152 "./../src/print.c"
        if (sorted_keys ) {
#         define XfOrM399_COUNT (0+XfOrM392_COUNT)
#         define SETUP_XfOrM399(x) SETUP_XfOrM392(x)

# 2153 "./../src/print.c"
          key = sorted_keys [i ] ; 
          if (t )
            val = FUNCCALL(SETUP_XfOrM399(_), scheme_hash_get (t , key ) ); 
          else 
          val = FUNCCALL(SETUP_XfOrM399(_), scheme_hash_tree_get (tr , key ) ); 
        }

# 2158 "./../src/print.c"
        else if (! vals ) {
#         define XfOrM398_COUNT (0+XfOrM392_COUNT)
#         define SETUP_XfOrM398(x) SETUP_XfOrM392(x)

# 2159 "./../src/print.c"
          pos = (scheme_hash_tree_next (tr , pos ) ) ; 
          (scheme_hash_tree_index (tr , pos , & key , & val ) ) ; 
          if (! ((obj ) == (orig ) ) )
            val = FUNCCALL(SETUP_XfOrM398(_), scheme_chaperone_hash_traversal_get (orig , key , & key ) ); 
        }

# 2163 "./../src/print.c"
        else {
#         define XfOrM396_COUNT (0+XfOrM392_COUNT)
#         define SETUP_XfOrM396(x) SETUP_XfOrM392(x)

# 2164 "./../src/print.c"
          if (i < vals_size ) {
#           define XfOrM397_COUNT (0+XfOrM396_COUNT)
#           define SETUP_XfOrM397(x) SETUP_XfOrM396(x)

# 2165 "./../src/print.c"
            val = vals [i ] ; 
            key = keys [i ] ; 
            if (! ((obj ) == (orig ) ) )
              val = FUNCCALL(SETUP_XfOrM397(_), scheme_chaperone_hash_traversal_get (orig , key , & key ) ); 
          }

# 2169 "./../src/print.c"
          else 
          val = ((void * ) 0 ) ; 
        }

        if (val ) {
#         define XfOrM393_COUNT (0+XfOrM392_COUNT)
#         define SETUP_XfOrM393(x) SETUP_XfOrM392(x)

# 2174 "./../src/print.c"
          if (! compact ) {
#           define XfOrM395_COUNT (0+XfOrM393_COUNT)
#           define SETUP_XfOrM395(x) SETUP_XfOrM393(x)

# 2175 "./../src/print.c"
            if (did_one )
              FUNCCALL(SETUP_XfOrM395(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
            if (notdisplay != 3 )
              FUNCCALL(SETUP_XfOrM395(_), print_utf8_string (pp , "(" , 0 , 1 ) ); 
          }
          FUNCCALL(SETUP_XfOrM393(_), print (key , notdisplay , compact , ht , mt , pp ) ); 
          if (! compact ) {
#           define XfOrM394_COUNT (0+XfOrM393_COUNT)
#           define SETUP_XfOrM394(x) SETUP_XfOrM393(x)

# 2182 "./../src/print.c"
            if (notdisplay == 3 )
              FUNCCALL(SETUP_XfOrM394(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
            else FUNCCALL(SETUP_XfOrM394(_), print_utf8_string (pp , " . " , 0 , 3 ) )
            ; 
          }
          FUNCCALL(SETUP_XfOrM393(_), print (val , notdisplay , compact , ht , mt , pp ) ); 
          if (! compact && (notdisplay != 3 ) )
            FUNCCALL(SETUP_XfOrM393(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
          did_one ++ ; 
        }
      }
    }

    if (! compact && (notdisplay != 3 ) )
      FUNCCALL(SETUP_XfOrM381(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
    if (notdisplay == 3 )
      FUNCCALL(SETUP_XfOrM381(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 

    closed = 1 ; 
  }
  else if ((obj ) == (scheme_true ) )  
  {
#   define XfOrM380_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM380(x) SETUP_XfOrM200(x)

# 2204 "./../src/print.c"
    if (compact )
      FUNCCALL(SETUP_XfOrM380(_), print_this_string (pp , & compacts [CPT_TRUE ] , 0 , 1 ) ); 
    else if (pp -> print_long_bools )
      FUNCCALL(SETUP_XfOrM380(_), print_utf8_string (pp , "#true" , 0 , 5 ) ); 
    else FUNCCALL(SETUP_XfOrM380(_), print_utf8_string (pp , "#t" , 0 , 2 ) )
    ; 
  }
  else if ((obj ) == (scheme_false ) )  
  {
#   define XfOrM379_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM379(x) SETUP_XfOrM200(x)

# 2213 "./../src/print.c"
    if (compact )
      FUNCCALL(SETUP_XfOrM379(_), print_this_string (pp , & compacts [CPT_FALSE ] , 0 , 1 ) ); 
    else if (pp -> print_long_bools )
      FUNCCALL(SETUP_XfOrM379(_), print_utf8_string (pp , "#false" , 0 , 6 ) ); 
    else FUNCCALL(SETUP_XfOrM379(_), print_utf8_string (pp , "#f" , 0 , 2 ) )
    ; 
  }
  else if (compact && ((obj ) == (scheme_void ) ) ) 
  {
#   define XfOrM378_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM378(x) SETUP_XfOrM200(x)
    FUNCCALL(SETUP_XfOrM378(_), print_this_string (pp , & compacts [CPT_VOID ] , 0 , 1 ) )
# 2222 "./../src/print.c"
    ; 
  }
  else if (compact && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && FUNCCALL(SETUP_XfOrM200(_), scheme_is_location (obj ) )) 
  {


    int i ; 
    Scheme_Object * src , * rel_src , * dir ; 
    BLOCK_SETUP((PUSH(rel_src, 0+XfOrM200_COUNT), PUSH(dir, 1+XfOrM200_COUNT), PUSH(src, 2+XfOrM200_COUNT)));
#   define XfOrM369_COUNT (3+XfOrM200_COUNT)
#   define SETUP_XfOrM369(x) SETUP(XfOrM369_COUNT)
    src = NULLED_OUT ; 
    rel_src = NULLED_OUT ; 
    dir = NULLED_OUT ; 

# 2231 "./../src/print.c"
    src = FUNCCALL(SETUP_XfOrM369(_), scheme_struct_ref (obj , 0 ) ); 
    if ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#     define XfOrM374_COUNT (0+XfOrM369_COUNT)
#     define SETUP_XfOrM374(x) SETUP_XfOrM369(x)


      dir = (__funcarg100 = FUNCCALL(SETUP_XfOrM374(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg100 , MZCONFIG_WRITE_DIRECTORY ) )) 
      ; 
      if (! (((dir ) ) == (scheme_false ) ) ) 
        rel_src = FUNCCALL(SETUP_XfOrM374(_), scheme_extract_relative_to (src , dir , mt -> path_cache ) ); 
      else 
      rel_src = src ; 
      if ((Scheme_Type ) (((((intptr_t ) (rel_src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (rel_src ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#       define XfOrM376_COUNT (0+XfOrM374_COUNT)
#       define SETUP_XfOrM376(x) SETUP_XfOrM374(x)

# 2244 "./../src/print.c"
        src = (__funcarg99 = FUNCCALL(SETUP_XfOrM376(_), scheme_box (rel_src ) ), FUNCCALL_AGAIN(scheme_hash_get (mt -> path_cache , __funcarg99 ) )) ; 
        if (! src ) {
#         define XfOrM377_COUNT (0+XfOrM376_COUNT)
#         define SETUP_XfOrM377(x) SETUP_XfOrM376(x)

# 2246 "./../src/print.c"
          src = FUNCCALL(SETUP_XfOrM377(_), srcloc_path_to_string (rel_src ) ); 
          (__funcarg98 = FUNCCALL(SETUP_XfOrM377(_), scheme_box (rel_src ) ), FUNCCALL_AGAIN(scheme_hash_set (mt -> path_cache , __funcarg98 , src ) )) ; 
        }
      }

# 2249 "./../src/print.c"
      else {
      }
    }
    else if ((((src ) ) == (scheme_false ) ) 
    || ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) 
    || ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) ) 
    || ((Scheme_Type ) (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    || ((((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (src ) ) -> type ) <= scheme_windows_path_type ) ) ) {
    }
    else {
#     define XfOrM372_COUNT (0+XfOrM369_COUNT)
#     define SETUP_XfOrM372(x) SETUP_XfOrM369(x)
      FUNCCALL(SETUP_XfOrM372(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2259 "./../src/print.c"
      ; 
    }
    FUNCCALL(SETUP_XfOrM369(_), print_this_string (pp , & compacts [CPT_SRCLOC ] , 0 , 1 ) )
    ; 
    FUNCCALL(SETUP_XfOrM369(_), print (src , notdisplay , compact , ht , mt , pp ) ); 
    for (i = 1 ; i < 5 ; i ++ ) {
#     define XfOrM371_COUNT (0+XfOrM369_COUNT)
#     define SETUP_XfOrM371(x) SETUP_XfOrM369(x)
      (__funcarg97 = FUNCCALL(SETUP_XfOrM371(_), scheme_struct_ref (obj , i ) )
# 2265 "./../src/print.c"
      , FUNCCALL_AGAIN(print (__funcarg97 , notdisplay , compact , ht , mt , pp ) )) ; 
    }

    closed = 1 ; 
  }
  else if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) obj ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) )  
  {
#   define XfOrM350_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM350(x) SETUP_XfOrM200(x)

# 2272 "./../src/print.c"
    if (compact && ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (obj ) ) -> stype -> prefab_key ) ) {
      Scheme_Object * vec , * prefab ; 
      BLOCK_SETUP((PUSH(vec, 0+XfOrM350_COUNT), PUSH(prefab, 1+XfOrM350_COUNT)));
#     define XfOrM368_COUNT (2+XfOrM350_COUNT)
#     define SETUP_XfOrM368(x) SETUP(XfOrM368_COUNT)
      vec = NULLED_OUT ; 
      prefab = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM368(_), print_this_string (pp , & compacts [CPT_PREFAB ] , 0 , 1 ) )
# 2274 "./../src/print.c"
      ; 
      prefab = (scheme_prefab_struct_key (obj ) ) ; 
      vec = FUNCCALL(SETUP_XfOrM368(_), scheme_struct_to_vector (obj , (notdisplay >= 3 ) ? qq_ellipses : ((void * ) 0 ) , pp -> inspector ) ); 
      (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = prefab ; 
      FUNCCALL(SETUP_XfOrM368(_), print_vector (vec , notdisplay , compact , ht , mt , pp , 1 ) ); 
    }

# 2279 "./../src/print.c"
    else if (compact || (! pp -> print_unreadable && ! ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) obj ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (obj ) ) -> stype -> prefab_key ) ) ) {
#     define XfOrM367_COUNT (0+XfOrM350_COUNT)
#     define SETUP_XfOrM367(x) SETUP_XfOrM350(x)
      FUNCCALL(SETUP_XfOrM367(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2280 "./../src/print.c"
      ; 
    }

# 2281 "./../src/print.c"
    else if (FUNCCALL(SETUP_XfOrM350(_), scheme_is_writable_struct (obj ) )) {
#     define XfOrM365_COUNT (0+XfOrM350_COUNT)
#     define SETUP_XfOrM365(x) SETUP_XfOrM350(x)

# 2282 "./../src/print.c"
      if (notdisplay == 3 ) {
        Scheme_Object * kind ; 
        BLOCK_SETUP((PUSH(kind, 0+XfOrM365_COUNT)));
#       define XfOrM366_COUNT (1+XfOrM365_COUNT)
#       define SETUP_XfOrM366(x) SETUP(XfOrM366_COUNT)
        kind = NULLED_OUT ; 

# 2284 "./../src/print.c"
        kind = FUNCCALL(SETUP_XfOrM366(_), scheme_print_attribute_ref (obj ) ); 
        if (kind 
        && (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "never" ) ) 
        && (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "self" ) ) )
          notdisplay = FUNCCALL(SETUP_XfOrM366(_), to_quoted (obj , pp , notdisplay ) ); 
      }
      FUNCCALL(SETUP_XfOrM365(_), custom_write_struct (obj , ht , mt , pp , notdisplay ) ); 
    }

# 2291 "./../src/print.c"
    else {
      int pb ; 
#     define XfOrM351_COUNT (0+XfOrM350_COUNT)
#     define SETUP_XfOrM351(x) SETUP_XfOrM350(x)

# 2294 "./../src/print.c"
      pb = pp -> print_struct && (FUNCCALL(SETUP_XfOrM351(_), scheme_inspector_sees_part (obj , pp -> inspector , - 1 ) )) ; 

      if (pb ) {
        Scheme_Object * vec , * prefab ; 
        BLOCK_SETUP((PUSH(vec, 0+XfOrM351_COUNT), PUSH(prefab, 1+XfOrM351_COUNT)));
#       define XfOrM362_COUNT (2+XfOrM351_COUNT)
#       define SETUP_XfOrM362(x) SETUP(XfOrM362_COUNT)
        vec = NULLED_OUT ; 
        prefab = NULLED_OUT ; 

# 2298 "./../src/print.c"
        prefab = (scheme_prefab_struct_key (obj ) ) ; 
        vec = FUNCCALL(SETUP_XfOrM362(_), scheme_struct_to_vector (obj , (notdisplay >= 3 ) ? qq_ellipses : ((void * ) 0 ) , pp -> inspector ) ); 
        if (! (((prefab ) ) == (scheme_false ) ) ) 
          notdisplay = FUNCCALL(SETUP_XfOrM362(_), to_quoted (obj , pp , notdisplay ) ); 
        if (notdisplay == 3 ) {
#         define XfOrM364_COUNT (0+XfOrM362_COUNT)
#         define SETUP_XfOrM364(x) SETUP_XfOrM362(x)

# 2303 "./../src/print.c"
          if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
            obj = (((Scheme_Chaperone * ) obj ) -> val ) ; 
          vec = FUNCCALL(SETUP_XfOrM364(_), scheme_vector_to_list (vec ) ); 
          vec = FUNCCALL_AGAIN(scheme_make_pair (((((Scheme_Structure * ) obj ) -> stype ) -> name ) , (((Scheme_Simple_Object * ) (vec ) ) -> u . pair_val . cdr ) ) ); 
          FUNCCALL_AGAIN(print_pair (vec , notdisplay , compact , ht , mt , pp , scheme_pair_type , 1 , 1 ) ); 
        }

# 2308 "./../src/print.c"
        else {
#         define XfOrM363_COUNT (0+XfOrM362_COUNT)
#         define SETUP_XfOrM363(x) SETUP_XfOrM362(x)

# 2309 "./../src/print.c"
          if (! (((prefab ) ) == (scheme_false ) ) ) 
            (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = prefab ; 
          FUNCCALL(SETUP_XfOrM363(_), print_vector (vec , notdisplay , compact , ht , mt , pp , (! (((prefab ) ) == (scheme_false ) ) ) ) ); 
        }
        closed = 1 ; 
      }

# 2314 "./../src/print.c"
      else {
        Scheme_Object * src ; 
        int check_object_name ; 
        BLOCK_SETUP((PUSH(src, 0+XfOrM351_COUNT)));
#       define XfOrM352_COUNT (1+XfOrM351_COUNT)
#       define SETUP_XfOrM352(x) SETUP(XfOrM352_COUNT)
        src = NULLED_OUT ; 

# 2318 "./../src/print.c"
        if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
          obj = (((Scheme_Chaperone * ) obj ) -> val ) ; 

        if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) )  {
#         define XfOrM361_COUNT (0+XfOrM352_COUNT)
#         define SETUP_XfOrM361(x) SETUP_XfOrM352(x)

# 2323 "./../src/print.c"
          src = FUNCCALL(SETUP_XfOrM361(_), scheme_proc_struct_name_source (obj ) ); 
          check_object_name = 1 ; 
        }

# 2325 "./../src/print.c"
        else {
          src = obj ; 
          check_object_name = 0 ; 
        }

        if ((src ) == (obj ) )  {
          intptr_t l ; 
          const char * s ; 
          Scheme_Object * name ; 
          BLOCK_SETUP((PUSH(s, 0+XfOrM352_COUNT), PUSH(name, 1+XfOrM352_COUNT)));
#         define XfOrM354_COUNT (2+XfOrM352_COUNT)
#         define SETUP_XfOrM354(x) SETUP(XfOrM354_COUNT)
          s = NULLED_OUT ; 
          name = NULLED_OUT ; 
          FUNCCALL(SETUP_XfOrM354(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2335 "./../src/print.c"
          ; 
          if (check_object_name 
          && scheme_object_name_property 
          && (scheme_struct_type_property_ref (scheme_object_name_property , obj ) ) ) {
#           define XfOrM359_COUNT (0+XfOrM354_COUNT)
#           define SETUP_XfOrM359(x) SETUP_XfOrM354(x)

# 2339 "./../src/print.c"
            name = FUNCCALL(SETUP_XfOrM359(_), scheme_object_name (obj ) ); 
            if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) 
              name = FUNCCALL(SETUP_XfOrM359(_), scheme_path_to_char_string (name ) ); 
            FUNCCALL(SETUP_XfOrM359(_), print_utf8_string (pp , "procedure:" , 0 , ((((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) || ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) ) ? 10 : 9 ) ) )

            ; 
          }

# 2345 "./../src/print.c"
          else if (scheme_reduced_procedure_struct 
          && (scheme_is_struct_instance (scheme_reduced_procedure_struct , obj ) ) ) {
#           define XfOrM358_COUNT (0+XfOrM354_COUNT)
#           define SETUP_XfOrM358(x) SETUP_XfOrM354(x)
            FUNCCALL(SETUP_XfOrM358(_), print_utf8_string (pp , "procedure:" , 0 , 10 ) ); 
            name = ((Scheme_Structure * ) obj ) -> slots [2 ] ; 
          }

# 2351 "./../src/print.c"
          else {
#           define XfOrM357_COUNT (0+XfOrM354_COUNT)
#           define SETUP_XfOrM357(x) SETUP_XfOrM354(x)

# 2352 "./../src/print.c"
            if (! (((intptr_t ) (obj ) ) & 0x1 ) && ((((obj ) -> type ) >= scheme_prim_type ) && (((obj ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
              FUNCCALL(SETUP_XfOrM357(_), print_utf8_string (pp , "procedure:" , 0 , 10 ) ); 
            name = ((((Scheme_Structure * ) obj ) -> stype ) -> name ) ; 
          }

          if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#           define XfOrM356_COUNT (0+XfOrM354_COUNT)
#           define SETUP_XfOrM356(x) SETUP_XfOrM354(x)

# 2358 "./../src/print.c"
            s = FUNCCALL(SETUP_XfOrM356(_), scheme_symbol_val (name ) ); 
            l = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ; 
            FUNCCALL(SETUP_XfOrM356(_), print_utf8_string (pp , s , 0 , l ) )
            ; 
          }

# 2362 "./../src/print.c"
          else if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#           define XfOrM355_COUNT (0+XfOrM354_COUNT)
#           define SETUP_XfOrM355(x) SETUP_XfOrM354(x)

# 2363 "./../src/print.c"
            name = FUNCCALL(SETUP_XfOrM355(_), scheme_char_string_to_byte_string (name ) ); 
            FUNCCALL(SETUP_XfOrM355(_), print_utf8_string (pp , (((Scheme_Simple_Object * ) (name ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (name ) ) -> u . byte_str_val . tag_val ) ) ); 
          }
          ; 
          FUNCCALL(SETUP_XfOrM354(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
        }

# 2368 "./../src/print.c"
        else {
#         define XfOrM353_COUNT (0+XfOrM352_COUNT)
#         define SETUP_XfOrM353(x) SETUP_XfOrM352(x)

# 2369 "./../src/print.c"
          closed = FUNCCALL(SETUP_XfOrM353(_), print (src , notdisplay , compact , ht , mt , pp ) ); 
        }
      }
    }

    closed = 1 ; 
  }
  else if ((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) >= scheme_unix_path_type ) && (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) <= scheme_windows_path_type ) )  
  {
#   define XfOrM335_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM335(x) SETUP_XfOrM200(x)

# 2378 "./../src/print.c"
    if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {

      Scheme_Object * idx ; 
      int l ; 
      BLOCK_SETUP((PUSH(idx, 0+XfOrM335_COUNT)));
#     define XfOrM345_COUNT (1+XfOrM335_COUNT)
#     define SETUP_XfOrM345(x) SETUP(XfOrM345_COUNT)
      idx = NULLED_OUT ; 

# 2383 "./../src/print.c"
      idx = FUNCCALL(SETUP_XfOrM345(_), scheme_hash_get (mt -> intern_map , obj ) ); 
      if (! idx )
        FUNCCALL(SETUP_XfOrM345(_), scheme_hash_set (mt -> intern_map , obj , obj ) ); 
      else 
      obj = idx ; 

      idx = FUNCCALL(SETUP_XfOrM345(_), get_symtab_idx (mt , obj ) ); 
      if (idx ) {
#       define XfOrM349_COUNT (0+XfOrM345_COUNT)
#       define SETUP_XfOrM349(x) SETUP_XfOrM345(x)
        FUNCCALL(SETUP_XfOrM349(_), print_symtab_ref (pp , idx ) )
# 2391 "./../src/print.c"
        ; 
      }

# 2392 "./../src/print.c"
      else {
        Scheme_Object * orig_obj = obj , * dir ; 
        BLOCK_SETUP((PUSH(orig_obj, 0+XfOrM345_COUNT), PUSH(dir, 1+XfOrM345_COUNT)));
#       define XfOrM346_COUNT (2+XfOrM345_COUNT)
#       define SETUP_XfOrM346(x) SETUP(XfOrM346_COUNT)
        dir = NULLED_OUT ; 

# 2395 "./../src/print.c"
        dir = (__funcarg95 = FUNCCALL(SETUP_XfOrM346(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg95 , MZCONFIG_WRITE_DIRECTORY ) )) 
        ; 
        if (! (((dir ) ) == (scheme_false ) ) ) 
          obj = FUNCCALL(SETUP_XfOrM346(_), scheme_extract_relative_to (obj , dir , mt -> path_cache ) ); 
        FUNCCALL(SETUP_XfOrM346(_), print_this_string (pp , & compacts [CPT_PATH ] , 0 , 1 ) )
        ; 
        if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#         define XfOrM348_COUNT (0+XfOrM346_COUNT)
#         define SETUP_XfOrM348(x) SETUP_XfOrM346(x)

# 2402 "./../src/print.c"
          l = (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . tag_val ) ; 
          FUNCCALL(SETUP_XfOrM348(_), print_compact_number (pp , l ) ); 
          FUNCCALL_AGAIN(print_this_string (pp , (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . string_val ) , 0 , l ) ); 
        }

# 2405 "./../src/print.c"
        else {
#         define XfOrM347_COUNT (0+XfOrM346_COUNT)
#         define SETUP_XfOrM347(x) SETUP_XfOrM346(x)
          FUNCCALL(SETUP_XfOrM347(_), print_compact_number (pp , 0 ) )
# 2406 "./../src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM347(_), print (obj , notdisplay , compact , ht , mt , pp ) ); 
        }
        FUNCCALL(SETUP_XfOrM346(_), symtab_set (pp , mt , orig_obj ) )
        ; 
      }
    }

# 2412 "./../src/print.c"
    else if (! compact && pp -> printing_quoted ) {



      Scheme_Object * dir ; 
      BLOCK_SETUP((PUSH(dir, 0+XfOrM335_COUNT)));
#     define XfOrM344_COUNT (1+XfOrM335_COUNT)
#     define SETUP_XfOrM344(x) SETUP(XfOrM344_COUNT)
      dir = NULLED_OUT ; 

# 2418 "./../src/print.c"
      dir = (__funcarg94 = FUNCCALL(SETUP_XfOrM344(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg94 , MZCONFIG_WRITE_DIRECTORY ) )) 
      ; 
      if (! (((dir ) ) == (scheme_false ) ) ) 
        obj = FUNCCALL(SETUP_XfOrM344(_), scheme_extract_relative_to (obj , dir , mt -> path_cache ) ); 
      FUNCCALL(SETUP_XfOrM344(_), print_utf8_string (pp , "#^" , 0 , 2 ) )
      ; 
      obj = FUNCCALL_AGAIN(scheme_make_sized_byte_string ((((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (obj ) ) -> u . byte_str_val . tag_val ) , 1 ) )

      ; 
      FUNCCALL_AGAIN(print (obj , notdisplay , compact , ht , mt , pp ) ); 

      closed = 1 ; 
    }

# 2430 "./../src/print.c"
    else if (! pp -> print_unreadable ) {
#     define XfOrM343_COUNT (0+XfOrM335_COUNT)
#     define SETUP_XfOrM343(x) SETUP_XfOrM335(x)
      FUNCCALL(SETUP_XfOrM343(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2431 "./../src/print.c"
      ; 
    }

# 2432 "./../src/print.c"
    else {
#     define XfOrM336_COUNT (0+XfOrM335_COUNT)
#     define SETUP_XfOrM336(x) SETUP_XfOrM335(x)

# 2433 "./../src/print.c"
      if (notdisplay ) {
#       define XfOrM339_COUNT (0+XfOrM336_COUNT)
#       define SETUP_XfOrM339(x) SETUP_XfOrM336(x)

# 2434 "./../src/print.c"
        if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#         define XfOrM342_COUNT (0+XfOrM339_COUNT)
#         define SETUP_XfOrM342(x) SETUP_XfOrM339(x)
          FUNCCALL(SETUP_XfOrM342(_), print_utf8_string (pp , "#<path:" , 0 , 7 ) )
# 2435 "./../src/print.c"
          ; 
        }

# 2436 "./../src/print.c"
        else {
#         define XfOrM340_COUNT (0+XfOrM339_COUNT)
#         define SETUP_XfOrM340(x) SETUP_XfOrM339(x)

# 2437 "./../src/print.c"
          switch (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) {
#           define XfOrM341_COUNT (0+XfOrM340_COUNT)
#           define SETUP_XfOrM341(x) SETUP_XfOrM340(x)

# 2438 "./../src/print.c"
            case scheme_windows_path_type : FUNCCALL(SETUP_XfOrM341(_), print_utf8_string (pp , "#<windows-path:" , 0 , 15 ) )
            ; 
            break ; 
            default : 
            case scheme_unix_path_type : FUNCCALL(SETUP_XfOrM341(_), print_utf8_string (pp , "#<unix-path:" , 0 , 12 ) )
            ; 
            break ; 
          }
        }
      }
      {
        Scheme_Object * str ; 
        BLOCK_SETUP((PUSH(str, 0+XfOrM336_COUNT)));
#       define XfOrM338_COUNT (1+XfOrM336_COUNT)
#       define SETUP_XfOrM338(x) SETUP(XfOrM338_COUNT)
        str = NULLED_OUT ; 

# 2450 "./../src/print.c"
        str = FUNCCALL(SETUP_XfOrM338(_), scheme_path_to_char_string (obj ) ); 
        FUNCCALL_AGAIN(print (str , 0 , 0 , ht , mt , pp ) ); 
      }
      if (notdisplay ) {
#       define XfOrM337_COUNT (0+XfOrM336_COUNT)
#       define SETUP_XfOrM337(x) SETUP_XfOrM336(x)

# 2454 "./../src/print.c"
        ; 
        FUNCCALL(SETUP_XfOrM337(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
      }
    }
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((Scheme_Primitive_Proc * ) obj ) -> name ) 
  {
#   define XfOrM332_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM332(x) SETUP_XfOrM200(x)

# 2461 "./../src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM334_COUNT (0+XfOrM332_COUNT)
#     define SETUP_XfOrM334(x) SETUP_XfOrM332(x)
      FUNCCALL(SETUP_XfOrM334(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2462 "./../src/print.c"
      ; 
    }

# 2463 "./../src/print.c"
    else {
#     define XfOrM333_COUNT (0+XfOrM332_COUNT)
#     define SETUP_XfOrM333(x) SETUP_XfOrM332(x)
      FUNCCALL(SETUP_XfOrM333(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2464 "./../src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM333(_), print_string_in_angle (pp , ((Scheme_Primitive_Proc * ) obj ) -> name , "procedure:" , - 1 ) ); 
      ; 
      FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
    closed = 1 ; 
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_closed_prim_type ) ) && ((Scheme_Closed_Primitive_Proc * ) obj ) -> name ) 
  {
#   define XfOrM328_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM328(x) SETUP_XfOrM200(x)

# 2473 "./../src/print.c"
    if (compact || ! pp -> print_unreadable )
      FUNCCALL(SETUP_XfOrM328(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    else {
      int kind ; 
#     define XfOrM329_COUNT (0+XfOrM328_COUNT)
#     define SETUP_XfOrM329(x) SETUP_XfOrM328(x)

# 2477 "./../src/print.c"
      kind = (((Scheme_Primitive_Proc * ) (obj ) ) -> pp . flags & (32 | 64 | 128 | 256 ) ) ; 
      if ((kind == (32 | 256 ) ) 
      || (kind == 128 ) 
      || (kind == 256 ) 
      || (kind == (128 | 256 ) ) 
      || (kind == (32 | 128 ) ) 
      || (kind == 32 ) 
      || (kind == (32 | 64 ) ) ) {
#       define XfOrM331_COUNT (0+XfOrM329_COUNT)
#       define SETUP_XfOrM331(x) SETUP_XfOrM329(x)
        FUNCCALL(SETUP_XfOrM331(_), print_named (obj , "struct-procedure" , ((Scheme_Closed_Primitive_Proc * ) obj ) -> name , - 1 , pp ) ); 
      }

# 2488 "./../src/print.c"
      else {
#       define XfOrM330_COUNT (0+XfOrM329_COUNT)
#       define SETUP_XfOrM330(x) SETUP_XfOrM329(x)
        FUNCCALL(SETUP_XfOrM330(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2489 "./../src/print.c"
        ; 
        FUNCCALL(SETUP_XfOrM330(_), print_string_in_angle (pp , ((Scheme_Closed_Primitive_Proc * ) obj ) -> name , "procedure:" , - 1 ) ); 
        ; 
        FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
      }
    }

    closed = 1 ; 
  }
  else if ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_closure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_case_closure_type ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) ) ) 
  {
#   define XfOrM318_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM318(x) SETUP_XfOrM200(x)

# 2501 "./../src/print.c"
    if (compact || ! pp -> print_unreadable ) {
      int done = 0 ; 
#     define XfOrM320_COUNT (0+XfOrM318_COUNT)
#     define SETUP_XfOrM320(x) SETUP_XfOrM318(x)

# 2503 "./../src/print.c"
      if (compact ) {
#       define XfOrM321_COUNT (0+XfOrM320_COUNT)
#       define SETUP_XfOrM321(x) SETUP_XfOrM320(x)

# 2504 "./../src/print.c"
        if (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) == scheme_closure_type ) {
          Scheme_Closure * closure = (Scheme_Closure * ) obj ; 
          BLOCK_SETUP((PUSH(closure, 0+XfOrM321_COUNT)));
#         define XfOrM324_COUNT (1+XfOrM321_COUNT)
#         define SETUP_XfOrM324(x) SETUP(XfOrM324_COUNT)

# 2506 "./../src/print.c"
          if (! (closure -> code -> closure_size ) ) {


            Scheme_Object * idx ; 
            BLOCK_SETUP((PUSH(idx, 0+XfOrM324_COUNT)));
#           define XfOrM325_COUNT (1+XfOrM324_COUNT)
#           define SETUP_XfOrM325(x) SETUP(XfOrM325_COUNT)
            idx = NULLED_OUT ; 

# 2510 "./../src/print.c"
            idx = FUNCCALL(SETUP_XfOrM325(_), get_symtab_idx (mt , obj ) ); 
            if (idx ) {
#             define XfOrM327_COUNT (0+XfOrM325_COUNT)
#             define SETUP_XfOrM327(x) SETUP_XfOrM325(x)
              FUNCCALL(SETUP_XfOrM327(_), print_symtab_ref (pp , idx ) )
# 2512 "./../src/print.c"
              ; 
            }

# 2513 "./../src/print.c"
            else {
#             define XfOrM326_COUNT (0+XfOrM325_COUNT)
#             define SETUP_XfOrM326(x) SETUP_XfOrM325(x)
              FUNCCALL(SETUP_XfOrM326(_), print_this_string (pp , & compacts [CPT_CLOSURE ] , 0 , 1 ) )
# 2514 "./../src/print.c"
              ; 
              FUNCCALL(SETUP_XfOrM326(_), print_symtab_set (pp , mt , obj ) ); 
              FUNCCALL_AGAIN(print ((Scheme_Object * ) ((Scheme_Closure * ) closure ) -> code , notdisplay , compact , ht , mt , pp ) ); 
            }
            compact = 1 ; 
            done = 1 ; 
          }
        }

# 2521 "./../src/print.c"
        else if (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) == scheme_case_closure_type ) {
#         define XfOrM322_COUNT (0+XfOrM321_COUNT)
#         define SETUP_XfOrM322(x) SETUP_XfOrM321(x)

# 2522 "./../src/print.c"
          obj = FUNCCALL(SETUP_XfOrM322(_), scheme_unclose_case_lambda (obj , 0 ) ); 
          if (! (! (((intptr_t ) (obj ) ) & 0x1 ) && ((((obj ) -> type ) >= scheme_prim_type ) && (((obj ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
#           define XfOrM323_COUNT (0+XfOrM322_COUNT)
#           define SETUP_XfOrM323(x) SETUP_XfOrM322(x)

# 2525 "./../src/print.c"
            compact = FUNCCALL(SETUP_XfOrM323(_), print (obj , notdisplay , compact , ht , mt , pp ) ); 
            done = 1 ; 
          }
        }
      }
      if (! done )
        FUNCCALL(SETUP_XfOrM320(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    }

# 2532 "./../src/print.c"
    else {
      int len ; 
      const char * s ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM318_COUNT)));
#     define XfOrM319_COUNT (1+XfOrM318_COUNT)
#     define SETUP_XfOrM319(x) SETUP(XfOrM319_COUNT)
      s = NULLED_OUT ; 

# 2535 "./../src/print.c"
      s = FUNCCALL(SETUP_XfOrM319(_), scheme_get_proc_name (obj , & len , 0 ) ); 
      FUNCCALL_AGAIN(print_named (obj , "procedure" , s , len , pp ) )
      ; 
    }
    closed = 1 ; 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) )  
  {
#   define XfOrM313_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM313(x) SETUP_XfOrM200(x)

# 2543 "./../src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM317_COUNT (0+XfOrM313_COUNT)
#     define SETUP_XfOrM317(x) SETUP_XfOrM313(x)
      FUNCCALL(SETUP_XfOrM317(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2544 "./../src/print.c"
      ; 
    }

# 2545 "./../src/print.c"
    else {
#     define XfOrM314_COUNT (0+XfOrM313_COUNT)
#     define SETUP_XfOrM314(x) SETUP_XfOrM313(x)
      FUNCCALL(SETUP_XfOrM314(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2546 "./../src/print.c"
      ; 
      if (((Scheme_Struct_Type * ) obj ) -> name ) {
#       define XfOrM316_COUNT (0+XfOrM314_COUNT)
#       define SETUP_XfOrM316(x) SETUP_XfOrM314(x)
        (__funcarg93 = FUNCCALL(SETUP_XfOrM316(_), scheme_symbol_val (((Scheme_Struct_Type * ) obj ) -> name ) )
# 2548 "./../src/print.c"
        , FUNCCALL_AGAIN(print_string_in_angle (pp , __funcarg93 , "struct-type:" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (((Scheme_Struct_Type * ) obj ) -> name ) ) ) -> len ) ) )) 

        ; 
      }

# 2551 "./../src/print.c"
      else {
#       define XfOrM315_COUNT (0+XfOrM314_COUNT)
#       define SETUP_XfOrM315(x) SETUP_XfOrM314(x)
        FUNCCALL(SETUP_XfOrM315(_), print_utf8_string (pp , "struct-type" , 0 , 11 ) )
# 2552 "./../src/print.c"
        ; 
      }
      ; 
      FUNCCALL(SETUP_XfOrM314(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) )  
  {
#   define XfOrM308_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM308(x) SETUP_XfOrM200(x)

# 2560 "./../src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM312_COUNT (0+XfOrM308_COUNT)
#     define SETUP_XfOrM312(x) SETUP_XfOrM308(x)
      FUNCCALL(SETUP_XfOrM312(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2561 "./../src/print.c"
      ; 
    }

# 2562 "./../src/print.c"
    else {
#     define XfOrM309_COUNT (0+XfOrM308_COUNT)
#     define SETUP_XfOrM309(x) SETUP_XfOrM308(x)
      FUNCCALL(SETUP_XfOrM309(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2563 "./../src/print.c"
      ; 
      if (((Scheme_Struct_Property * ) obj ) -> name ) {
#       define XfOrM311_COUNT (0+XfOrM309_COUNT)
#       define SETUP_XfOrM311(x) SETUP_XfOrM309(x)
        (__funcarg92 = FUNCCALL(SETUP_XfOrM311(_), scheme_symbol_val (((Scheme_Struct_Property * ) obj ) -> name ) )
# 2565 "./../src/print.c"
        , FUNCCALL_AGAIN(print_string_in_angle (pp , __funcarg92 , "struct-type-property:" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (((Scheme_Struct_Property * ) obj ) -> name ) ) ) -> len ) ) )) 

        ; 
      }

# 2568 "./../src/print.c"
      else {
#       define XfOrM310_COUNT (0+XfOrM309_COUNT)
#       define SETUP_XfOrM310(x) SETUP_XfOrM309(x)
        FUNCCALL(SETUP_XfOrM310(_), print_utf8_string (pp , "struct-type-property" , 0 , 21 ) )
# 2569 "./../src/print.c"
        ; 
      }
      ; 
      FUNCCALL(SETUP_XfOrM309(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_thread_type ) ) && (((Scheme_Thread * ) obj ) -> name ) ) 
  {
#   define XfOrM305_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM305(x) SETUP_XfOrM200(x)

# 2577 "./../src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM307_COUNT (0+XfOrM305_COUNT)
#     define SETUP_XfOrM307(x) SETUP_XfOrM305(x)
      FUNCCALL(SETUP_XfOrM307(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2578 "./../src/print.c"
      ; 
    }

# 2579 "./../src/print.c"
    else {
      Scheme_Thread * t = (Scheme_Thread * ) obj ; 
      BLOCK_SETUP((PUSH(t, 0+XfOrM305_COUNT)));
#     define XfOrM306_COUNT (1+XfOrM305_COUNT)
#     define SETUP_XfOrM306(x) SETUP(XfOrM306_COUNT)
      FUNCCALL(SETUP_XfOrM306(_), print_utf8_string (pp , "#<thread:" , 0 , 9 ) )
# 2581 "./../src/print.c"
      ; 
      (__funcarg91 = FUNCCALL(SETUP_XfOrM306(_), scheme_symbol_val (t -> name ) ), FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg91 , 0 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (t -> name ) ) ) -> len ) ) )) ; 
      FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_input_port_type ) )  
  {
#   define XfOrM299_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM299(x) SETUP_XfOrM200(x)

# 2588 "./../src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM304_COUNT (0+XfOrM299_COUNT)
#     define SETUP_XfOrM304(x) SETUP_XfOrM299(x)
      FUNCCALL(SETUP_XfOrM304(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2589 "./../src/print.c"
      ; 
    }

# 2590 "./../src/print.c"
    else {
      Scheme_Input_Port * ip ; 
      BLOCK_SETUP((PUSH(ip, 0+XfOrM299_COUNT)));
#     define XfOrM300_COUNT (1+XfOrM299_COUNT)
#     define SETUP_XfOrM300(x) SETUP(XfOrM300_COUNT)
      ip = NULLED_OUT ; 

# 2592 "./../src/print.c"
      ip = (Scheme_Input_Port * ) obj ; 
      FUNCCALL(SETUP_XfOrM300(_), print_utf8_string (pp , "#<input-port" , 0 , 12 ) ); 
      if (ip -> name ) {
#       define XfOrM301_COUNT (0+XfOrM300_COUNT)
#       define SETUP_XfOrM301(x) SETUP_XfOrM300(x)

# 2595 "./../src/print.c"
        if ((Scheme_Type ) (((((intptr_t ) (ip -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ip -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#         define XfOrM303_COUNT (0+XfOrM301_COUNT)
#         define SETUP_XfOrM303(x) SETUP_XfOrM301(x)
          FUNCCALL(SETUP_XfOrM303(_), print_utf8_string (pp , ":" , 0 , 1 ) )
# 2596 "./../src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM303(_), print_utf8_string (pp , (((Scheme_Simple_Object * ) (ip -> name ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (ip -> name ) ) -> u . byte_str_val . tag_val ) ) ); 
        }

# 2598 "./../src/print.c"
        else if ((Scheme_Type ) (((((intptr_t ) (ip -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ip -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#         define XfOrM302_COUNT (0+XfOrM301_COUNT)
#         define SETUP_XfOrM302(x) SETUP_XfOrM301(x)
          FUNCCALL(SETUP_XfOrM302(_), print_utf8_string (pp , ":" , 0 , 1 ) )
# 2599 "./../src/print.c"
          ; 
          (__funcarg90 = FUNCCALL(SETUP_XfOrM302(_), scheme_symbol_val (ip -> name ) ), FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg90 , 0 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (ip -> name ) ) ) -> len ) ) )) ; 
        }
      }
      FUNCCALL(SETUP_XfOrM300(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) )  
  {
#   define XfOrM298_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM298(x) SETUP_XfOrM200(x)

# 2609 "./../src/print.c"
    closed = FUNCCALL(SETUP_XfOrM298(_), print ((((Scheme_Chaperone * ) obj ) -> val ) , notdisplay , compact , ht , mt , pp ) ); 
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_regexp_type ) )  
  {
#   define XfOrM294_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM294(x) SETUP_XfOrM200(x)

# 2613 "./../src/print.c"
    if (compact ) {
#     define XfOrM297_COUNT (0+XfOrM294_COUNT)
#     define SETUP_XfOrM297(x) SETUP_XfOrM294(x)
      FUNCCALL(SETUP_XfOrM297(_), print_escaped (pp , notdisplay , obj , ht , mt , 1 ) )
# 2614 "./../src/print.c"
      ; 
    }

# 2615 "./../src/print.c"
    else {
      Scheme_Object * src ; 
      BLOCK_SETUP((PUSH(src, 0+XfOrM294_COUNT)));
#     define XfOrM295_COUNT (1+XfOrM294_COUNT)
#     define SETUP_XfOrM295(x) SETUP(XfOrM295_COUNT)
      src = NULLED_OUT ; 

# 2617 "./../src/print.c"
      src = (scheme_regexp_source (obj ) ) ; 
      if (src ) {
#       define XfOrM296_COUNT (0+XfOrM295_COUNT)
#       define SETUP_XfOrM296(x) SETUP_XfOrM295(x)

# 2619 "./../src/print.c"
        if (FUNCCALL(SETUP_XfOrM296(_), scheme_is_pregexp (obj ) ))
          FUNCCALL(SETUP_XfOrM296(_), print_utf8_string (pp , "#px" , 0 , 3 ) ); 
        else FUNCCALL(SETUP_XfOrM296(_), print_utf8_string (pp , "#rx" , 0 , 3 ) )
        ; 
        FUNCCALL(SETUP_XfOrM296(_), print (src , 1 , 0 , ht , mt , pp ) ); 
      }

# 2624 "./../src/print.c"
      else if (compact || ! pp -> print_unreadable )
        FUNCCALL(SETUP_XfOrM295(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
      else FUNCCALL(SETUP_XfOrM295(_), print_utf8_string (pp , "#<regexp>" , 0 , 9 ) )
      ; 
      closed = 1 ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_output_port_type ) )  
  {
#   define XfOrM288_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM288(x) SETUP_XfOrM200(x)

# 2633 "./../src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM293_COUNT (0+XfOrM288_COUNT)
#     define SETUP_XfOrM293(x) SETUP_XfOrM288(x)
      FUNCCALL(SETUP_XfOrM293(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2634 "./../src/print.c"
      ; 
    }

# 2635 "./../src/print.c"
    else {
      Scheme_Output_Port * op ; 
      BLOCK_SETUP((PUSH(op, 0+XfOrM288_COUNT)));
#     define XfOrM289_COUNT (1+XfOrM288_COUNT)
#     define SETUP_XfOrM289(x) SETUP(XfOrM289_COUNT)
      op = NULLED_OUT ; 

# 2637 "./../src/print.c"
      op = (Scheme_Output_Port * ) obj ; 
      FUNCCALL(SETUP_XfOrM289(_), print_utf8_string (pp , "#<output-port" , 0 , 13 ) ); 
      if (op -> name ) {
#       define XfOrM290_COUNT (0+XfOrM289_COUNT)
#       define SETUP_XfOrM290(x) SETUP_XfOrM289(x)

# 2640 "./../src/print.c"
        if ((Scheme_Type ) (((((intptr_t ) (op -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (op -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#         define XfOrM292_COUNT (0+XfOrM290_COUNT)
#         define SETUP_XfOrM292(x) SETUP_XfOrM290(x)
          FUNCCALL(SETUP_XfOrM292(_), print_utf8_string (pp , ":" , 0 , 1 ) )
# 2641 "./../src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM292(_), print_utf8_string (pp , (((Scheme_Simple_Object * ) (op -> name ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (op -> name ) ) -> u . byte_str_val . tag_val ) ) ); 
        }

# 2643 "./../src/print.c"
        else if ((Scheme_Type ) (((((intptr_t ) (op -> name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (op -> name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#         define XfOrM291_COUNT (0+XfOrM290_COUNT)
#         define SETUP_XfOrM291(x) SETUP_XfOrM290(x)
          FUNCCALL(SETUP_XfOrM291(_), print_utf8_string (pp , ":" , 0 , 1 ) )
# 2644 "./../src/print.c"
          ; 
          (__funcarg89 = FUNCCALL(SETUP_XfOrM291(_), scheme_symbol_val (op -> name ) ), FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg89 , 0 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (op -> name ) ) ) -> len ) ) )) ; 
        }
      }
      FUNCCALL(SETUP_XfOrM289(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_prompt_tag_type ) ) 
  && (((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) && ! (compact || ! pp -> print_unreadable ) ) 
  {
#   define XfOrM287_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM287(x) SETUP_XfOrM200(x)
    FUNCCALL(SETUP_XfOrM287(_), print_utf8_string (pp , "#<" , 0 , 2 ) )
# 2654 "./../src/print.c"
    ; 
    (__funcarg88 = FUNCCALL(SETUP_XfOrM287(_), scheme_symbol_val ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) ) ), FUNCCALL_AGAIN(print_string_in_angle (pp , __funcarg88 , "continuation-prompt-tag:" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (obj ) ) -> u . pair_val . cdr ) ) ) ) -> len ) ) )) 

    ; 
    ; 
    FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
  }
  else if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_cpointer_type ) ) )  
  {
    Scheme_Object * tag = (((Scheme_Cptr * ) (obj ) ) -> type ) ; 
    BLOCK_SETUP((PUSH(tag, 0+XfOrM200_COUNT)));
#   define XfOrM279_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM279(x) SETUP(XfOrM279_COUNT)

# 2664 "./../src/print.c"
    if (compact || ! pp -> print_unreadable ) {
#     define XfOrM286_COUNT (0+XfOrM279_COUNT)
#     define SETUP_XfOrM286(x) SETUP_XfOrM279(x)
      FUNCCALL(SETUP_XfOrM286(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2665 "./../src/print.c"
      ; 
    }

# 2666 "./../src/print.c"
    else if (tag == ((void * ) 0 ) ) {
#     define XfOrM285_COUNT (0+XfOrM279_COUNT)
#     define SETUP_XfOrM285(x) SETUP_XfOrM279(x)
      FUNCCALL(SETUP_XfOrM285(_), print_utf8_string (pp , "#<cpointer>" , 0 , 11 ) )
# 2667 "./../src/print.c"
      ; 
    }

# 2668 "./../src/print.c"
    else {
      Scheme_Object * name = tag ; 
      BLOCK_SETUP((PUSH(name, 0+XfOrM279_COUNT)));
#     define XfOrM280_COUNT (1+XfOrM279_COUNT)
#     define SETUP_XfOrM280(x) SETUP(XfOrM280_COUNT)

# 2670 "./../src/print.c"
      if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 

# 2670 "./../src/print.c"
      name = (((Scheme_Simple_Object * ) (name ) ) -> u . pair_val . car ) ; 
      FUNCCALL(SETUP_XfOrM280(_), print_utf8_string (pp , "#<cpointer:" , 0 , 11 ) ); 
      if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
#       define XfOrM284_COUNT (0+XfOrM280_COUNT)
#       define SETUP_XfOrM284(x) SETUP_XfOrM280(x)
        FUNCCALL(SETUP_XfOrM284(_), print_this_string (pp , (char * ) name , ((char * ) ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) ) ) - ((char * ) name ) , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> len ) ) )
        ; 
      }

# 2677 "./../src/print.c"
      else if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_byte_string_type ) )  {
#       define XfOrM283_COUNT (0+XfOrM280_COUNT)
#       define SETUP_XfOrM283(x) SETUP_XfOrM280(x)
        FUNCCALL(SETUP_XfOrM283(_), print_byte_string ((((Scheme_Simple_Object * ) (name ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (name ) ) -> u . byte_str_val . tag_val ) , 0 , pp ) )
        ; 
      }

# 2682 "./../src/print.c"
      else if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) )  {
#       define XfOrM282_COUNT (0+XfOrM280_COUNT)
#       define SETUP_XfOrM282(x) SETUP_XfOrM280(x)
        FUNCCALL(SETUP_XfOrM282(_), scheme_print_string (pp , (((Scheme_Simple_Object * ) (name ) ) -> u . char_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (name ) ) -> u . char_str_val . tag_val ) ) )
# 2684 "./../src/print.c"
        ; 
      }

# 2685 "./../src/print.c"
      else {
#       define XfOrM281_COUNT (0+XfOrM280_COUNT)
#       define SETUP_XfOrM281(x) SETUP_XfOrM280(x)
        FUNCCALL(SETUP_XfOrM281(_), print_utf8_string (pp , "#" , 0 , 1 ) )
# 2686 "./../src/print.c"
        ; 
      }
      FUNCCALL(SETUP_XfOrM280(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
      closed = 1 ; 
    }
  }
  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_stx_type ) )  
  {
#   define XfOrM273_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM273(x) SETUP_XfOrM200(x)

# 2694 "./../src/print.c"
    if (pp -> print_unreadable ) {
      Scheme_Stx * stx = (Scheme_Stx * ) obj ; 
      BLOCK_SETUP((PUSH(stx, 0+XfOrM273_COUNT)));
#     define XfOrM275_COUNT (1+XfOrM273_COUNT)
#     define SETUP_XfOrM275(x) SETUP(XfOrM275_COUNT)

# 2696 "./../src/print.c"
      if (stx -> srcloc && ((stx -> srcloc -> line >= 0 ) || (stx -> srcloc -> pos >= 0 ) ) ) {
#       define XfOrM277_COUNT (0+XfOrM275_COUNT)
#       define SETUP_XfOrM277(x) SETUP_XfOrM275(x)
        FUNCCALL(SETUP_XfOrM277(_), print_utf8_string (pp , "#<correlated:" , 0 , 13 ) )
# 2697 "./../src/print.c"
        ; 
        if (stx -> srcloc -> src && ((Scheme_Type ) (((((intptr_t ) (stx -> srcloc -> src ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (stx -> srcloc -> src ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#         define XfOrM278_COUNT (0+XfOrM277_COUNT)
#         define SETUP_XfOrM278(x) SETUP_XfOrM277(x)
          FUNCCALL(SETUP_XfOrM278(_), print_utf8_string (pp , (((Scheme_Simple_Object * ) (stx -> srcloc -> src ) ) -> u . byte_str_val . string_val ) , 0 , (((Scheme_Simple_Object * ) (stx -> srcloc -> src ) ) -> u . byte_str_val . tag_val ) ) )
# 2699 "./../src/print.c"
          ; 
          FUNCCALL(SETUP_XfOrM278(_), print_utf8_string (pp , ":" , 0 , 1 ) ); 
        }
        if ((stx -> srcloc -> line >= 0 ) 
        && (stx -> srcloc -> col >= 0 ) )
          (sprintf (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , 
        "%" "l" "d" ":%" "l" "d" "" , 
        stx -> srcloc -> line , stx -> srcloc -> col - 1 ) ) ; 
        else if (stx -> srcloc -> pos >= 0 )
          (sprintf (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , ":%" "l" "d" "" , 
        stx -> srcloc -> pos ) ) ; 
        FUNCCALL(SETUP_XfOrM277(_), print_utf8_string (pp , XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_buffer_ ) , 0 , - 1 ) ); 
      }

# 2711 "./../src/print.c"
      else FUNCCALL(SETUP_XfOrM275(_), print_utf8_string (pp , "#<correlated" , 0 , 12 ) )
      ; 
      if (pp -> print_syntax ) {
        intptr_t slen ; 
        char * str ; 
        int rel ; 
        BLOCK_SETUP((PUSH(str, 0+XfOrM275_COUNT)));
#       define XfOrM276_COUNT (1+XfOrM275_COUNT)
#       define SETUP_XfOrM276(x) SETUP(XfOrM276_COUNT)
        str = NULLED_OUT ; 
        FUNCCALL(SETUP_XfOrM276(_), print_utf8_string (pp , " " , 0 , 1 ) )
# 2717 "./../src/print.c"
        ; 
        str = (__funcarg87 = FUNCCALL(SETUP_XfOrM276(_), scheme_syntax_to_datum ((Scheme_Object * ) stx ) ), FUNCCALL_AGAIN(print_to_string (__funcarg87 , & slen , 1 , ((void * ) 0 ) , pp -> print_syntax , ((void * ) 0 ) , & rel ) )) 
        ; 
        FUNCCALL_AGAIN(print_utf8_string (pp , str , 0 , slen ) ); 
        if (rel && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) )
          XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> quick_print_buffer_ ) = str ; 
      }
      FUNCCALL(SETUP_XfOrM275(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
    }

# 2725 "./../src/print.c"
    else {
#     define XfOrM274_COUNT (0+XfOrM273_COUNT)
#     define SETUP_XfOrM274(x) SETUP_XfOrM273(x)
      FUNCCALL(SETUP_XfOrM274(_), cannot_print (pp , notdisplay , obj , ht , compact ) )
# 2726 "./../src/print.c"
      ; 
    }
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_toplevel_type ) ) ) ) 
  {
    int flags , pos , depth ; 
#   define XfOrM272_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM272(x) SETUP_XfOrM200(x)
    FUNCCALL(SETUP_XfOrM272(_), print_this_string (pp , & compacts [CPT_TOPLEVEL ] , 0 , 1 ) )
# 2733 "./../src/print.c"
    ; 

    flags = ((& ((Scheme_Toplevel * ) (obj ) ) -> iso ) -> so . keyex & 0x3 ) ; 
    pos = (((Scheme_Toplevel * ) (obj ) ) -> position ) ; 
    depth = (((Scheme_Toplevel * ) (obj ) ) -> u . depth ) ; 
    FUNCCALL(SETUP_XfOrM272(_), print_compact_number (pp , flags ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , pos ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , depth ) ); 
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_static_toplevel_type ) ) ) ) 
  {
    int flags , pos ; 
#   define XfOrM271_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM271(x) SETUP_XfOrM200(x)
    FUNCCALL(SETUP_XfOrM271(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 2747 "./../src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM271(_), print_compact_number (pp , scheme_static_toplevel_type ) ); 

    flags = ((& ((Scheme_Toplevel * ) (obj ) ) -> iso ) -> so . keyex & 0x3 ) ; 
    pos = (((Scheme_Toplevel * ) (obj ) ) -> position ) ; 
    FUNCCALL(SETUP_XfOrM271(_), print_compact_number (pp , flags ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , pos ) ); 

    closed = FUNCCALL_AGAIN(print ((Scheme_Object * ) (((Scheme_Toplevel * ) (obj ) ) -> u . prefix ) , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_prefix_type ) ) ) ) 
  {

    Scheme_Object * idx ; 
    BLOCK_SETUP((PUSH(idx, 0+XfOrM200_COUNT)));
#   define XfOrM268_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM268(x) SETUP(XfOrM268_COUNT)
    idx = NULLED_OUT ; 

# 2762 "./../src/print.c"
    if (compact )
      idx = FUNCCALL(SETUP_XfOrM268(_), get_symtab_idx (mt , obj ) ); 
    else 
    idx = ((void * ) 0 ) ; 

    if (idx ) {
#     define XfOrM270_COUNT (0+XfOrM268_COUNT)
#     define SETUP_XfOrM270(x) SETUP_XfOrM268(x)
      FUNCCALL(SETUP_XfOrM270(_), print_symtab_ref (pp , idx ) )
# 2768 "./../src/print.c"
      ; 
    }

# 2769 "./../src/print.c"
    else if (compact ) {
#     define XfOrM269_COUNT (0+XfOrM268_COUNT)
#     define SETUP_XfOrM269(x) SETUP_XfOrM268(x)
      FUNCCALL(SETUP_XfOrM269(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 2770 "./../src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM269(_), print_compact_number (pp , scheme_prefix_type ) ); 
      FUNCCALL_AGAIN(print_compact_number (pp , ((Scheme_Prefix * ) obj ) -> num_slots ) ); 
      FUNCCALL_AGAIN(symtab_set (pp , mt , obj ) )
      ; 
    }
  }
  else if (compact 
  && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_local_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_local_unbox_type ) ) ) ) 
  {
    int unbox = ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_local_unbox_type ) ) ; 
    Scheme_Local * loc = (Scheme_Local * ) obj ; 
    BLOCK_SETUP((PUSH(loc, 0+XfOrM200_COUNT)));
#   define XfOrM264_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM264(x) SETUP(XfOrM264_COUNT)

# 2783 "./../src/print.c"
    if ((loc -> position < (207 - 192 ) ) 
    && ! ((& ((Scheme_Local * ) (loc ) ) -> iso ) -> so . keyex & ~ 0x2000 ) ) {
      unsigned char s [1 ] ; 
#     define XfOrM267_COUNT (0+XfOrM264_COUNT)
#     define SETUP_XfOrM267(x) SETUP_XfOrM264(x)

# 2786 "./../src/print.c"
      s [0 ] = loc -> position + (unbox 
      ? 207 
      : 192 ) ; 
      FUNCCALL(SETUP_XfOrM267(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    }

# 2790 "./../src/print.c"
    else {
      int flags ; 
#     define XfOrM265_COUNT (0+XfOrM264_COUNT)
#     define SETUP_XfOrM265(x) SETUP_XfOrM264(x)
      FUNCCALL(SETUP_XfOrM265(_), print_this_string (pp , & compacts [unbox ? CPT_LOCAL_UNBOX : CPT_LOCAL ] , 0 , 1 ) )
# 2792 "./../src/print.c"
      ; 
      flags = ((& ((Scheme_Local * ) (loc ) ) -> iso ) -> so . keyex & ~ 0x2000 ) ; 
      if (flags ) {
#       define XfOrM266_COUNT (0+XfOrM265_COUNT)
#       define SETUP_XfOrM266(x) SETUP_XfOrM265(x)
        FUNCCALL(SETUP_XfOrM266(_), print_compact_number (pp , - (loc -> position + 1 ) ) )
# 2795 "./../src/print.c"
        ; 
        FUNCCALL(SETUP_XfOrM266(_), print_compact_number (pp , flags ) ); 
      }

# 2797 "./../src/print.c"
      else FUNCCALL(SETUP_XfOrM265(_), print_compact_number (pp , loc -> position ) )
      ; 
    }
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_application_type ) ) ) 
  {
    Scheme_App_Rec * app ; 
    int i ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM200_COUNT)));
#   define XfOrM259_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM259(x) SETUP(XfOrM259_COUNT)
    app = NULLED_OUT ; 

# 2806 "./../src/print.c"
    app = (Scheme_App_Rec * ) obj ; 

    if (app -> num_args < (255 - 247 ) ) {
      unsigned char s [1 ] ; 
#     define XfOrM263_COUNT (0+XfOrM259_COUNT)
#     define SETUP_XfOrM263(x) SETUP_XfOrM259(x)

# 2810 "./../src/print.c"
      s [0 ] = 247 + app -> num_args ; 
      FUNCCALL(SETUP_XfOrM263(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    }

# 2812 "./../src/print.c"
    else {
#     define XfOrM262_COUNT (0+XfOrM259_COUNT)
#     define SETUP_XfOrM262(x) SETUP_XfOrM259(x)
      FUNCCALL(SETUP_XfOrM262(_), print_this_string (pp , & compacts [CPT_APPLICATION ] , 0 , 1 ) )
# 2813 "./../src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM262(_), print_compact_number (pp , app -> num_args ) ); 
    }

    for (i = 0 ; i < app -> num_args + 1 ; i ++ ) {
#     define XfOrM261_COUNT (0+XfOrM259_COUNT)
#     define SETUP_XfOrM261(x) SETUP_XfOrM259(x)

# 2818 "./../src/print.c"
      closed = (__funcarg86 = FUNCCALL(SETUP_XfOrM261(_), scheme_protect_quote (app -> args [i ] ) ), FUNCCALL_AGAIN(print (__funcarg86 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    }
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_application2_type ) ) ) 
  {
    Scheme_App2_Rec * app ; 
    unsigned char s [1 ] ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM200_COUNT)));
#   define XfOrM258_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM258(x) SETUP(XfOrM258_COUNT)
    app = NULLED_OUT ; 

# 2826 "./../src/print.c"
    app = (Scheme_App2_Rec * ) obj ; 

    s [0 ] = 247 + 1 ; 
    FUNCCALL(SETUP_XfOrM258(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    (__funcarg84 = FUNCCALL(SETUP_XfOrM258(_), scheme_protect_quote (app -> rator ) )
    , FUNCCALL_AGAIN(print (__funcarg84 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg83 = FUNCCALL(SETUP_XfOrM258(_), scheme_protect_quote (app -> rand ) ), FUNCCALL_AGAIN(print (__funcarg83 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_application3_type ) ) ) 
  {
    Scheme_App3_Rec * app ; 
    unsigned char s [1 ] ; 
    BLOCK_SETUP((PUSH(app, 0+XfOrM200_COUNT)));
#   define XfOrM257_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM257(x) SETUP(XfOrM257_COUNT)
    app = NULLED_OUT ; 

# 2839 "./../src/print.c"
    app = (Scheme_App3_Rec * ) obj ; 

    s [0 ] = 247 + 2 ; 
    FUNCCALL(SETUP_XfOrM257(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    (__funcarg82 = FUNCCALL(SETUP_XfOrM257(_), scheme_protect_quote (app -> rator ) )
    , FUNCCALL_AGAIN(print (__funcarg82 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    (__funcarg81 = FUNCCALL(SETUP_XfOrM257(_), scheme_protect_quote (app -> rand1 ) ), FUNCCALL_AGAIN(print (__funcarg81 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg80 = FUNCCALL(SETUP_XfOrM257(_), scheme_protect_quote (app -> rand2 ) ), FUNCCALL_AGAIN(print (__funcarg80 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_sequence_type ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_begin0_sequence_type ) ) ) ) 
  {
    int i , count ; 
#   define XfOrM254_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM254(x) SETUP_XfOrM200(x)
    FUNCCALL(SETUP_XfOrM254(_), print_this_string (pp , & compacts [(((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_sequence_type ) ) ? CPT_BEGIN : CPT_BEGIN0 ) ] , 0 , 1 ) )
    ; 
    count = ((Scheme_Sequence * ) obj ) -> count ; 
    FUNCCALL(SETUP_XfOrM254(_), print_compact_number (pp , count ) ); 

    for (i = 0 ; i < count ; i ++ ) {
#     define XfOrM256_COUNT (0+XfOrM254_COUNT)
#     define SETUP_XfOrM256(x) SETUP_XfOrM254(x)

# 2860 "./../src/print.c"
      closed = (__funcarg79 = FUNCCALL(SETUP_XfOrM256(_), scheme_protect_quote (((Scheme_Sequence * ) obj ) -> array [i ] ) ), FUNCCALL_AGAIN(print (__funcarg79 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    }
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_let_value_type ) ) ) ) 
  {
    Scheme_Let_Value * lv ; 
    BLOCK_SETUP((PUSH(lv, 0+XfOrM200_COUNT)));
#   define XfOrM253_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM253(x) SETUP(XfOrM253_COUNT)
    lv = NULLED_OUT ; 

# 2867 "./../src/print.c"
    lv = (Scheme_Let_Value * ) obj ; 
    FUNCCALL(SETUP_XfOrM253(_), print_this_string (pp , & compacts [CPT_LET_VALUE ] , 0 , 1 ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , lv -> count ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , lv -> position ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , ((& lv -> iso ) -> so . keyex ? 1 : 0 ) ) ); 
    (__funcarg77 = FUNCCALL(SETUP_XfOrM253(_), scheme_protect_quote (lv -> value ) ), FUNCCALL_AGAIN(print (__funcarg77 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg76 = FUNCCALL(SETUP_XfOrM253(_), scheme_protect_quote (lv -> body ) ), FUNCCALL_AGAIN(print (__funcarg76 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_let_void_type ) ) ) ) 
  {
    Scheme_Let_Void * lv ; 
    BLOCK_SETUP((PUSH(lv, 0+XfOrM200_COUNT)));
#   define XfOrM252_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM252(x) SETUP(XfOrM252_COUNT)
    lv = NULLED_OUT ; 

# 2880 "./../src/print.c"
    lv = (Scheme_Let_Void * ) obj ; 
    FUNCCALL(SETUP_XfOrM252(_), print_this_string (pp , & compacts [CPT_LET_VOID ] , 0 , 1 ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , lv -> count ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , ((& lv -> iso ) -> so . keyex ? 1 : 0 ) ) ); 
    closed = (__funcarg75 = FUNCCALL(SETUP_XfOrM252(_), scheme_protect_quote (lv -> body ) ), FUNCCALL_AGAIN(print (__funcarg75 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_letrec_type ) ) ) ) 
  {
    Scheme_Letrec * lr = (Scheme_Letrec * ) obj ; 
    int i , count ; 
    BLOCK_SETUP((PUSH(lr, 0+XfOrM200_COUNT)));
#   define XfOrM249_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM249(x) SETUP(XfOrM249_COUNT)

# 2892 "./../src/print.c"
    count = lr -> count ; 
    FUNCCALL(SETUP_XfOrM249(_), print_this_string (pp , & compacts [CPT_LETREC ] , 0 , 1 ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , count ) ); 

    for (i = 0 ; i < count ; i ++ ) {
#     define XfOrM251_COUNT (0+XfOrM249_COUNT)
#     define SETUP_XfOrM251(x) SETUP_XfOrM249(x)
      (__funcarg74 = FUNCCALL(SETUP_XfOrM251(_), scheme_protect_quote (lr -> procs [i ] ) )
# 2898 "./../src/print.c"
      , FUNCCALL_AGAIN(print (__funcarg74 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    }

    closed = (__funcarg72 = FUNCCALL(SETUP_XfOrM249(_), scheme_protect_quote (lr -> body ) ), FUNCCALL_AGAIN(print (__funcarg72 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_let_one_type ) ) ) 
  {
    Scheme_Let_One * lo ; 
    BLOCK_SETUP((PUSH(lo, 0+XfOrM200_COUNT)));
#   define XfOrM248_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM248(x) SETUP(XfOrM248_COUNT)
    lo = NULLED_OUT ; 

# 2907 "./../src/print.c"
    lo = (Scheme_Let_One * ) obj ; 

    if ((& lo -> iso ) -> so . keyex & 0x8 )
      FUNCCALL(SETUP_XfOrM248(_), print_this_string (pp , & compacts [CPT_LET_ONE_UNUSED ] , 0 , 1 ) ); 
    else if ((& lo -> iso ) -> so . keyex >> 4 ) 
      FUNCCALL(SETUP_XfOrM248(_), print_this_string (pp , & compacts [CPT_LET_ONE_TYPED ] , 0 , 1 ) ); 
    else FUNCCALL(SETUP_XfOrM248(_), print_this_string (pp , & compacts [CPT_LET_ONE ] , 0 , 1 ) )
    ; 
    (__funcarg71 = FUNCCALL(SETUP_XfOrM248(_), scheme_protect_quote (lo -> value ) ), FUNCCALL_AGAIN(print (__funcarg71 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg70 = FUNCCALL(SETUP_XfOrM248(_), scheme_protect_quote (lo -> body ) ), FUNCCALL_AGAIN(print (__funcarg70 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    if ((& lo -> iso ) -> so . keyex >> 4 ) 
      FUNCCALL(SETUP_XfOrM248(_), print_compact_number (pp , ((& lo -> iso ) -> so . keyex >> 4 ) ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_branch_type ) ) ) 
  {
    Scheme_Branch_Rec * b ; 
    BLOCK_SETUP((PUSH(b, 0+XfOrM200_COUNT)));
#   define XfOrM247_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM247(x) SETUP(XfOrM247_COUNT)
    b = NULLED_OUT ; 

# 2924 "./../src/print.c"
    b = (Scheme_Branch_Rec * ) obj ; 
    FUNCCALL(SETUP_XfOrM247(_), print_this_string (pp , & compacts [CPT_BRANCH ] , 0 , 1 ) )
    ; 
    (__funcarg69 = FUNCCALL(SETUP_XfOrM247(_), scheme_protect_quote (b -> test ) ), FUNCCALL_AGAIN(print (__funcarg69 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    (__funcarg68 = FUNCCALL(SETUP_XfOrM247(_), scheme_protect_quote (b -> tbranch ) ), FUNCCALL_AGAIN(print (__funcarg68 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg67 = FUNCCALL(SETUP_XfOrM247(_), scheme_protect_quote (b -> fbranch ) ), FUNCCALL_AGAIN(print (__funcarg67 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_with_cont_mark_type ) ) ) 
  {
    Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) obj ; 
    BLOCK_SETUP((PUSH(wcm, 0+XfOrM200_COUNT)));
#   define XfOrM246_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM246(x) SETUP(XfOrM246_COUNT)
    FUNCCALL(SETUP_XfOrM246(_), print_this_string (pp , & compacts [CPT_WCM ] , 0 , 1 ) )
# 2935 "./../src/print.c"
    ; 
    (__funcarg66 = FUNCCALL(SETUP_XfOrM246(_), scheme_protect_quote (wcm -> key ) ), FUNCCALL_AGAIN(print (__funcarg66 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    (__funcarg65 = FUNCCALL(SETUP_XfOrM246(_), scheme_protect_quote (wcm -> val ) ), FUNCCALL_AGAIN(print (__funcarg65 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg64 = FUNCCALL(SETUP_XfOrM246(_), scheme_protect_quote (wcm -> body ) ), FUNCCALL_AGAIN(print (__funcarg64 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_define_values_type ) ) ) 
  {
    Scheme_Object * e ; 
    BLOCK_SETUP((PUSH(e, 0+XfOrM200_COUNT)));
#   define XfOrM245_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM245(x) SETUP(XfOrM245_COUNT)
    e = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM245(_), print_this_string (pp , & compacts [CPT_DEFINE_VALUES ] , 0 , 1 ) )
# 2944 "./../src/print.c"
    ; 

    obj = FUNCCALL_AGAIN(scheme_clone_vector (obj , 0 , 0 ) ); 
    e = FUNCCALL_AGAIN(scheme_protect_quote ((((Scheme_Vector * ) (obj ) ) -> els ) [0 ] ) ); 
    (((Scheme_Vector * ) (obj ) ) -> els ) [0 ] = e ; 

    closed = FUNCCALL(SETUP_XfOrM245(_), print (obj , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_set_bang_type ) ) ) 
  {
    Scheme_Set_Bang * sb = (Scheme_Set_Bang * ) obj ; 
    BLOCK_SETUP((PUSH(sb, 0+XfOrM200_COUNT)));
#   define XfOrM244_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM244(x) SETUP(XfOrM244_COUNT)
    FUNCCALL(SETUP_XfOrM244(_), print_this_string (pp , & compacts [CPT_SET_BANG ] , 0 , 1 ) )
# 2956 "./../src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM244(_), print_compact_number (pp , sb -> set_undef ? 1 : 0 ) ); 
    FUNCCALL_AGAIN(print (sb -> var , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    closed = (__funcarg63 = FUNCCALL(SETUP_XfOrM244(_), scheme_protect_quote (sb -> val ) ), FUNCCALL_AGAIN(print (__funcarg63 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_boxenv_type ) ) ) 
  {
#   define XfOrM243_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM243(x) SETUP_XfOrM200(x)
    FUNCCALL(SETUP_XfOrM243(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 2963 "./../src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM243(_), print_compact_number (pp , scheme_boxenv_type ) ); 
    FUNCCALL_AGAIN(print ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr1 ) , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )
    ; 
    closed = FUNCCALL_AGAIN(print ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr2 ) , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_varref_form_type ) ) ) 
  {
#   define XfOrM242_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM242(x) SETUP_XfOrM200(x)
    FUNCCALL(SETUP_XfOrM242(_), print_this_string (pp , & compacts [CPT_VARREF ] , 0 , 1 ) )
# 2971 "./../src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM242(_), print_compact_number (pp , (& ((Scheme_Simple_Object * ) obj ) -> iso ) -> so . keyex & (0x1 | 0x2 ) ) )
    ; 
    FUNCCALL_AGAIN(print ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr1 ) , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    closed = FUNCCALL_AGAIN(print ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr2 ) , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_apply_values_type ) ) ) 
  {
#   define XfOrM241_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM241(x) SETUP_XfOrM200(x)
    FUNCCALL(SETUP_XfOrM241(_), print_this_string (pp , & compacts [CPT_APPLY_VALUES ] , 0 , 1 ) )
# 2979 "./../src/print.c"
    ; 
    (__funcarg62 = FUNCCALL(SETUP_XfOrM241(_), scheme_protect_quote ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr1 ) ) )
    , FUNCCALL_AGAIN(print (__funcarg62 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
    closed = (__funcarg61 = FUNCCALL(SETUP_XfOrM241(_), scheme_protect_quote ((((Scheme_Simple_Object * ) (obj ) ) -> u . two_ptr_val . ptr2 ) ) ), FUNCCALL_AGAIN(print (__funcarg61 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_with_immed_mark_type ) ) ) 
  {
    Scheme_With_Continuation_Mark * wcm = (Scheme_With_Continuation_Mark * ) obj ; 
    BLOCK_SETUP((PUSH(wcm, 0+XfOrM200_COUNT)));
#   define XfOrM240_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM240(x) SETUP(XfOrM240_COUNT)
    FUNCCALL(SETUP_XfOrM240(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 2988 "./../src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM240(_), print_compact_number (pp , scheme_with_immed_mark_type ) ); 
    FUNCCALL_AGAIN(print (wcm -> key , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )
    ; 
    FUNCCALL_AGAIN(print (wcm -> val , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    closed = FUNCCALL_AGAIN(print (wcm -> body , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_inline_variant_type ) ) ) 
  {
#   define XfOrM239_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM239(x) SETUP_XfOrM200(x)
    FUNCCALL(SETUP_XfOrM239(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 2997 "./../src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM239(_), print_compact_number (pp , scheme_inline_variant_type ) ); 
    FUNCCALL_AGAIN(print ((((Scheme_Vector * ) (obj ) ) -> els ) [0 ] , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )
    ; 
    closed = FUNCCALL_AGAIN(print ((((Scheme_Vector * ) (obj ) ) -> els ) [1 ] , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_case_lambda_sequence_type ) ) ) 
  {
    Scheme_Case_Lambda * cl = (Scheme_Case_Lambda * ) obj ; 
    int i , count ; 
    BLOCK_SETUP((PUSH(cl, 0+XfOrM200_COUNT)));
#   define XfOrM236_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM236(x) SETUP(XfOrM236_COUNT)
    FUNCCALL(SETUP_XfOrM236(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 3008 "./../src/print.c"
    ; 
    FUNCCALL(SETUP_XfOrM236(_), print_compact_number (pp , scheme_case_lambda_sequence_type ) ); 

    count = cl -> count ; 
    FUNCCALL(SETUP_XfOrM236(_), print_compact_number (pp , count ) ); 
    (__funcarg60 = FUNCCALL(SETUP_XfOrM236(_), scheme_closure_marshal_name (cl -> name ) )
    , FUNCCALL_AGAIN(print (__funcarg60 , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )) ; 

    for (i = 0 ; i < count ; i ++ ) {
#     define XfOrM238_COUNT (0+XfOrM236_COUNT)
#     define SETUP_XfOrM238(x) SETUP_XfOrM236(x)

# 3017 "./../src/print.c"
      closed = FUNCCALL(SETUP_XfOrM238(_), print (cl -> array [i ] , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    }
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_lambda_type ) ) ) 
  {
    Scheme_Lambda * data = (Scheme_Lambda * ) obj ; 
    Scheme_Object * name , * ds , * closure_map , * tl_map ; 
    BLOCK_SETUP((PUSH(closure_map, 0+XfOrM200_COUNT), PUSH(data, 1+XfOrM200_COUNT), PUSH(name, 2+XfOrM200_COUNT), PUSH(tl_map, 3+XfOrM200_COUNT), PUSH(ds, 4+XfOrM200_COUNT)));
#   define XfOrM235_COUNT (5+XfOrM200_COUNT)
#   define SETUP_XfOrM235(x) SETUP(XfOrM235_COUNT)
    name = NULLED_OUT ; 
    ds = NULLED_OUT ; 
    closure_map = NULLED_OUT ; 
    tl_map = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM235(_), print_this_string (pp , & compacts [CPT_OTHER_FORM ] , 0 , 1 ) )
# 3025 "./../src/print.c"
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , scheme_lambda_type ) ); 
    FUNCCALL_AGAIN(scheme_write_lambda (obj , & name , & ds , & closure_map , & tl_map ) )
    ; 
    FUNCCALL_AGAIN(print_compact_number (pp , (& (data ) -> iso ) -> so . keyex & 0x7F ) )
    ; 
    if ((& (data ) -> iso ) -> so . keyex & 2 )
      FUNCCALL(SETUP_XfOrM235(_), print_compact_number (pp , data -> closure_size ) ); 
    FUNCCALL(SETUP_XfOrM235(_), print_compact_number (pp , data -> num_params ) ); 
    FUNCCALL_AGAIN(print_compact_number (pp , data -> max_let_depth ) ); 
    FUNCCALL_AGAIN(print (name , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )
    ; 
    FUNCCALL_AGAIN(print (ds , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    FUNCCALL_AGAIN(print (closure_map , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    closed = FUNCCALL_AGAIN(print (tl_map , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
  }

  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_rt_delay_load_info ) )  
  {
    Scheme_Load_Delay * ld ; 
    int l ; 
    BLOCK_SETUP((PUSH(ld, 0+XfOrM200_COUNT)));
#   define XfOrM232_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM232(x) SETUP(XfOrM232_COUNT)
    ld = NULLED_OUT ; 

# 3046 "./../src/print.c"
    ld = (Scheme_Load_Delay * ) obj ; 
    FUNCCALL(SETUP_XfOrM232(_), print_utf8_string (pp , "#<delay-load-info:" , 0 , 18 ) ); 
    if ((Scheme_Type ) (((((intptr_t ) (ld -> path ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (ld -> path ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) )  {
#     define XfOrM234_COUNT (0+XfOrM232_COUNT)
#     define SETUP_XfOrM234(x) SETUP_XfOrM232(x)

# 3049 "./../src/print.c"
      l = (((Scheme_Simple_Object * ) (ld -> path ) ) -> u . byte_str_val . tag_val ) ; 
      FUNCCALL(SETUP_XfOrM234(_), print_this_string (pp , (((Scheme_Simple_Object * ) (ld -> path ) ) -> u . byte_str_val . string_val ) , 0 , l ) ); 
    }
    else {
#     define XfOrM233_COUNT (0+XfOrM232_COUNT)
#     define SETUP_XfOrM233(x) SETUP_XfOrM232(x)
      FUNCCALL(SETUP_XfOrM233(_), print_utf8_string (pp , "???" , 0 , 3 ) )
# 3053 "./../src/print.c"
      ; 
    }
    FUNCCALL(SETUP_XfOrM232(_), print_utf8_string (pp , ">" , 0 , 1 ) ); 
  }


  else if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_quote_compilation_type ) )  
  {
    Scheme_Hash_Table * q_ht ; 
    Scheme_Object * v ; 
    int counter = 1 , qpht , qpb , qpu ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM200_COUNT), PUSH(q_ht, 1+XfOrM200_COUNT)));
#   define XfOrM230_COUNT (2+XfOrM200_COUNT)
#   define SETUP_XfOrM230(x) SETUP(XfOrM230_COUNT)
    q_ht = NULLED_OUT ; 
    v = NULLED_OUT ; 

# 3065 "./../src/print.c"
    v = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 




    qpht = pp -> print_hash_table ; 
    qpb = pp -> print_box ; 


    pp -> print_hash_table = 1 ; 
    pp -> print_box = 1 ; 

    q_ht = FUNCCALL(SETUP_XfOrM230(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
    FUNCCALL_AGAIN(setup_graph_table (v , notdisplay , q_ht , & counter , pp ) ); 

    if (compact )
      FUNCCALL(SETUP_XfOrM230(_), print_this_string (pp , & compacts [CPT_QUOTE ] , 0 , 1 ) ); 
    else {
#     define XfOrM231_COUNT (0+XfOrM230_COUNT)
#     define SETUP_XfOrM231(x) SETUP_XfOrM230(x)
      FUNCCALL_EMPTY(scheme_signal_error ("internal error: non-compact quote compilation" ) )
# 3084 "./../src/print.c"
      ; 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }


    qpu = pp -> print_unreadable ; 
    pp -> print_unreadable = 0 ; 
    pp -> printing_quoted = 1 ; 

    compact = FUNCCALL(SETUP_XfOrM230(_), print (v , notdisplay , 1 , q_ht , mt , pp ) ); 

    pp -> printing_quoted = 0 ; 
    pp -> print_unreadable = qpu ; 

    pp -> print_hash_table = qpht ; 
    pp -> print_box = qpb ; 
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_svector_type ) ) ) 
  {
    mzshort l , * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM200_COUNT)));
#   define XfOrM225_COUNT (1+XfOrM200_COUNT)
#   define SETUP_XfOrM225(x) SETUP(XfOrM225_COUNT)
    v = NULLED_OUT ; 

# 3104 "./../src/print.c"
    l = (((Scheme_Simple_Object * ) (obj ) ) -> u . svector_val . len ) ; 
    v = (mzshort * ) (((Scheme_Simple_Object * ) (obj ) ) -> u . svector_val . vec ) ; 

    if (l < (247 - 222 ) ) {
      unsigned char s [1 ] ; 
#     define XfOrM229_COUNT (0+XfOrM225_COUNT)
#     define SETUP_XfOrM229(x) SETUP_XfOrM225(x)

# 3109 "./../src/print.c"
      s [0 ] = l + 222 ; 
      FUNCCALL(SETUP_XfOrM229(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
    }

# 3111 "./../src/print.c"
    else {
#     define XfOrM228_COUNT (0+XfOrM225_COUNT)
#     define SETUP_XfOrM228(x) SETUP_XfOrM225(x)
      FUNCCALL(SETUP_XfOrM228(_), print_this_string (pp , & compacts [CPT_SVECTOR ] , 0 , 1 ) )
# 3112 "./../src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM228(_), print_compact_number (pp , l ) ); 
    }
    while (l -- ) {
      int n = v [l ] ; 
#     define XfOrM227_COUNT (0+XfOrM225_COUNT)
#     define SETUP_XfOrM227(x) SETUP_XfOrM225(x)
      FUNCCALL(SETUP_XfOrM227(_), print_compact_number (pp , n ) )
# 3117 "./../src/print.c"
      ; 
    }
  }
  else if (compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_delay_syntax_type ) ) ) 
  {


    Scheme_Object * idx , * key ; 
    BLOCK_SETUP((PUSH(key, 0+XfOrM200_COUNT), PUSH(idx, 1+XfOrM200_COUNT)));
#   define XfOrM217_COUNT (2+XfOrM200_COUNT)
#   define SETUP_XfOrM217(x) SETUP(XfOrM217_COUNT)
    idx = NULLED_OUT ; 
    key = NULLED_OUT ; 

# 3126 "./../src/print.c"
    if ((& ((Scheme_Small_Object * ) obj ) -> iso ) -> so . keyex & 0x1 ) {
    }
    else {
#     define XfOrM220_COUNT (0+XfOrM217_COUNT)
#     define SETUP_XfOrM220(x) SETUP_XfOrM217(x)

# 3129 "./../src/print.c"
      key = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 

      if (mt -> pass < 0 ) {
      }
      else if (! mt -> pass ) {
#       define XfOrM221_COUNT (0+XfOrM220_COUNT)
#       define SETUP_XfOrM221(x) SETUP_XfOrM220(x)

# 3134 "./../src/print.c"
        if (! mt -> delay_map ) {
          Scheme_Hash_Table * delay_map ; 
          BLOCK_SETUP((PUSH(delay_map, 0+XfOrM221_COUNT)));
#         define XfOrM222_COUNT (1+XfOrM221_COUNT)
#         define SETUP_XfOrM222(x) SETUP(XfOrM222_COUNT)
          delay_map = NULLED_OUT ; 

# 3136 "./../src/print.c"
          delay_map = FUNCCALL(SETUP_XfOrM222(_), scheme_make_hash_table_eqv () ); 
          mt -> delay_map = delay_map ; 
        }
        FUNCCALL(SETUP_XfOrM221(_), scheme_hash_set (mt -> delay_map , key , obj ) ); 
      }

# 3140 "./../src/print.c"
      else 
      obj = FUNCCALL(SETUP_XfOrM220(_), scheme_hash_get (mt -> delay_map , key ) ); 
    }

    idx = FUNCCALL(SETUP_XfOrM217(_), get_symtab_idx (mt , obj ) ); 

    if (idx ) {
#     define XfOrM219_COUNT (0+XfOrM217_COUNT)
#     define SETUP_XfOrM219(x) SETUP_XfOrM217(x)
      FUNCCALL(SETUP_XfOrM219(_), print_general_symtab_ref (pp , idx , CPT_DELAY_REF ) )
# 3147 "./../src/print.c"
      ; 
    }

# 3148 "./../src/print.c"
    else {
#     define XfOrM218_COUNT (0+XfOrM217_COUNT)
#     define SETUP_XfOrM218(x) SETUP_XfOrM217(x)
      FUNCCALL(SETUP_XfOrM218(_), print ((((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) , notdisplay , 1 , ht , mt , pp ) )
# 3149 "./../src/print.c"
      ; 
      FUNCCALL(SETUP_XfOrM218(_), symtab_set (pp , mt , obj ) ); 
      FUNCCALL_AGAIN(set_symtab_shared (mt , obj ) ); 
    }
  }
  else if ((compact && ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_type ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_bundle_type ) ) ) 
  {
#   define XfOrM206_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM206(x) SETUP_XfOrM200(x)

# 3157 "./../src/print.c"
    if (compact ) {
      Scheme_Object * v ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM206_COUNT)));
#     define XfOrM215_COUNT (1+XfOrM206_COUNT)
#     define SETUP_XfOrM215(x) SETUP(XfOrM215_COUNT)
      v = NULLED_OUT ; 
      FUNCCALL(SETUP_XfOrM215(_), print_this_string (pp , & compacts [CPT_LINKLET ] , 0 , 1 ) )
# 3160 "./../src/print.c"
      ; 

      if (((Scheme_Linklet * ) obj ) -> static_prefix ) {
#       define XfOrM216_COUNT (0+XfOrM215_COUNT)
#       define SETUP_XfOrM216(x) SETUP_XfOrM215(x)
        FUNCCALL(SETUP_XfOrM216(_), print_compact_number (pp , 1 ) )
# 3163 "./../src/print.c"
        ; 
        FUNCCALL(SETUP_XfOrM216(_), print ((Scheme_Object * ) ((Scheme_Linklet * ) obj ) -> static_prefix , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
      }

# 3165 "./../src/print.c"
      else FUNCCALL(SETUP_XfOrM215(_), print_compact_number (pp , 0 ) )
      ; 

      v = FUNCCALL(SETUP_XfOrM215(_), scheme_write_linklet (obj ) ); 

      closed = FUNCCALL_AGAIN(print (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 
    }

# 3171 "./../src/print.c"
    else {
      Scheme_Hash_Table * st_refs , * symtab , * intern_map , * path_cache ; 
      Scheme_Object * v ; 
      intptr_t * shared_offsets ; 
      intptr_t st_len , j , shared_offset , start_offset ; 
      intptr_t slen ; 
      BLOCK_SETUP((PUSH(intern_map, 0+XfOrM206_COUNT), PUSH(path_cache, 1+XfOrM206_COUNT), PUSH(shared_offsets, 2+XfOrM206_COUNT), PUSH(st_refs, 3+XfOrM206_COUNT), PUSH(v, 4+XfOrM206_COUNT), PUSH(symtab, 5+XfOrM206_COUNT)));
#     define XfOrM207_COUNT (6+XfOrM206_COUNT)
#     define SETUP_XfOrM207(x) SETUP(XfOrM207_COUNT)
      st_refs = NULLED_OUT ; 
      symtab = NULLED_OUT ; 
      intern_map = NULLED_OUT ; 
      path_cache = NULLED_OUT ; 
      v = NULLED_OUT ; 
      shared_offsets = NULLED_OUT ; 

# 3178 "./../src/print.c"
      ((void ) sizeof ((((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_bundle_type ) ) ) ? 1 : 0 ) , __extension__ ({
#       define XfOrM214_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM214(x) SETUP_XfOrM207(x)

# 3178 "./../src/print.c" 3
        if ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_linklet_bundle_type ) ) 

# 3178 "./../src/print.c" 3
        ; 

# 3178 "./../src/print.c" 3
        else FUNCCALL(SETUP_XfOrM214(_), __assert_fail ("((Scheme_Type)(((((intptr_t)(obj)) & 0x1)?(Scheme_Type)scheme_integer_type:((Scheme_Object *)(obj))->type)) == (Scheme_Type)(scheme_linklet_bundle_type))" , "./../src/print.c" , 3178 , __extension__ __PRETTY_FUNCTION__ ) ); 
      }
      ) ) 
# 3178 "./../src/print.c"
      ; 
      v = (((Scheme_Small_Object * ) (obj ) ) -> u . ptr_val ) ; 

      mt = ((Scheme_Marshal_Tables * ) FUNCCALL(SETUP_XfOrM207(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Marshal_Tables ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
      mt -> type = scheme_rt_marshal_info ; 
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> current_mt = mt ; 

      intern_map = FUNCCALL(SETUP_XfOrM207(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 
      mt -> intern_map = intern_map ; 

      symtab = FUNCCALL(SETUP_XfOrM207(_), scheme_make_hash_table_eqv () ); 
      mt -> symtab = symtab ; 
      path_cache = FUNCCALL(SETUP_XfOrM207(_), scheme_make_hash_table_equal () ); 
      mt -> path_cache = path_cache ; 

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> current_mt = mt ; 


      st_refs = FUNCCALL(SETUP_XfOrM207(_), scheme_make_hash_table_eqv () ); 
      mt -> st_refs = st_refs ; 
      mt -> st_ref_stack = scheme_null ; 






      symtab = FUNCCALL(SETUP_XfOrM207(_), scheme_make_hash_table_eqv () ); 
      mt -> symtab = symtab ; 
      mt -> pass = 0 ; 
      FUNCCALL(SETUP_XfOrM207(_), scheme_hash_set (symtab , scheme_void , scheme_true ) ); 
      FUNCCALL_AGAIN(print_substring (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp , ((void * ) 0 ) , & slen , 0 , ((void * ) 0 ) ) ); 
      FUNCCALL_AGAIN(sort_referenced_keys (mt ) )
      ; 




      shared_offsets = ((intptr_t * ) FUNCCALL(SETUP_XfOrM207(_), GC_malloc_atomic (sizeof (intptr_t ) * (mt -> st_refs -> count ) ) )) ; 
      mt -> shared_offsets = shared_offsets ; 
      symtab = FUNCCALL(SETUP_XfOrM207(_), scheme_make_hash_table_eqv () ); 
      mt -> symtab = symtab ; 
      mt -> pass = 1 ; 
      FUNCCALL(SETUP_XfOrM207(_), print_substring (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp , ((void * ) 0 ) , & slen , 1 , & st_len ) )
      ; 


      symtab = FUNCCALL_AGAIN(scheme_make_hash_table_eqv () ); 
      mt -> symtab = symtab ; 
      mt -> pass = 2 ; 
      FUNCCALL(SETUP_XfOrM207(_), print_substring (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp , ((void * ) 0 ) , & slen , - 1 , & st_len ) )
      ; 

      if (mt -> st_refs -> count != mt -> sorted_keys_count )
        FUNCCALL_EMPTY(scheme_signal_error ("shared key count somehow changed" ) ); 
      FUNCCALL(SETUP_XfOrM207(_), print_number (pp , mt -> st_refs -> count + 1 ) )
      ; 


      if (mt -> st_refs -> count ) {
        int all_short = shared_offsets [mt -> st_refs -> count - 1 ] < 0xFFFF ; 
#       define XfOrM211_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM211(x) SETUP_XfOrM207(x)
        FUNCCALL(SETUP_XfOrM211(_), print_one_byte (pp , all_short ) )
# 3239 "./../src/print.c"
        ; 
        for (j = 0 ; j < mt -> st_refs -> count ; j ++ ) {
#         define XfOrM213_COUNT (0+XfOrM211_COUNT)
#         define SETUP_XfOrM213(x) SETUP_XfOrM211(x)

# 3241 "./../src/print.c"
          if (all_short )
            FUNCCALL(SETUP_XfOrM213(_), print_short_number (pp , shared_offsets [j ] ) ); 
          else FUNCCALL(SETUP_XfOrM213(_), print_number (pp , shared_offsets [j ] ) )
          ; 
        }
      }

# 3246 "./../src/print.c"
      else {
#       define XfOrM210_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM210(x) SETUP_XfOrM207(x)
        FUNCCALL(SETUP_XfOrM210(_), print_one_byte (pp , 1 ) )
# 3247 "./../src/print.c"
        ; 
      }
      FUNCCALL(SETUP_XfOrM207(_), print_number (pp , st_len ) )
      ; 
      FUNCCALL(SETUP_XfOrM207(_), print_number (pp , slen ) ); 



      symtab = FUNCCALL_AGAIN(scheme_make_hash_table_eqv () ); 
      mt -> symtab = symtab ; 
      mt -> pass = 3 ; 

      start_offset = pp -> print_offset ; 
      FUNCCALL(SETUP_XfOrM207(_), print_table_keys (notdisplay , 1 , ((void * ) 0 ) , mt , pp ) )


      ; 
      shared_offset = pp -> print_offset ; 
      closed = FUNCCALL(SETUP_XfOrM207(_), print (v , notdisplay , 1 , ((void * ) 0 ) , mt , pp ) ); 

      if (shared_offset - start_offset != st_len ) {
#       define XfOrM209_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM209(x) SETUP_XfOrM207(x)
        FUNCCALL_EMPTY(scheme_signal_error ("compiled code shared printed size changed on third pass:" " %ld versus %ld (total %ld)" , st_len , shared_offset - start_offset , slen ) ); 
      }
      if (pp -> print_offset - start_offset != slen ) {
#       define XfOrM208_COUNT (0+XfOrM207_COUNT)
#       define SETUP_XfOrM208(x) SETUP_XfOrM207(x)
        FUNCCALL_EMPTY(scheme_signal_error ("compiled code printed size changed on third pass:" " %ld versus %ld" , slen , pp -> print_offset - start_offset ) ); 
      }

      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> current_mt = ((void * ) 0 ) ; 
      mt = ((void * ) 0 ) ; 
    }
  }
  else 
  {
#   define XfOrM201_COUNT (0+XfOrM200_COUNT)
#   define SETUP_XfOrM201(x) SETUP_XfOrM200(x)

# 3284 "./../src/print.c"
    if (compact || ! pp -> print_unreadable )
      FUNCCALL(SETUP_XfOrM201(_), cannot_print (pp , notdisplay , obj , ht , compact ) ); 
    else if ((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) < printers_count ) 
    && printers [((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ] ) {
      Scheme_Type_Printer printer ; 
#     define XfOrM205_COUNT (0+XfOrM201_COUNT)
#     define SETUP_XfOrM205(x) SETUP_XfOrM201(x)

# 3289 "./../src/print.c"
      printer = printers [((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ] ; 
      FUNCCALL(SETUP_XfOrM205(_), printer (obj , ! notdisplay , pp ) ); 
    }

# 3291 "./../src/print.c"
    else {
      char * s ; 
      intptr_t len = - 1 ; 
      BLOCK_SETUP((PUSH(s, 0+XfOrM201_COUNT)));
#     define XfOrM202_COUNT (1+XfOrM201_COUNT)
#     define SETUP_XfOrM202(x) SETUP(XfOrM202_COUNT)
      s = NULLED_OUT ; 

# 3294 "./../src/print.c"
      s = FUNCCALL(SETUP_XfOrM202(_), scheme_get_type_name ((((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) ); 
      FUNCCALL_AGAIN(print_utf8_string (pp , "#" , 0 , 1 ) ); 



      if (! s ) {
        char s [8 ] ; 
#       define XfOrM204_COUNT (0+XfOrM202_COUNT)
#       define SETUP_XfOrM204(x) SETUP_XfOrM202(x)
        FUNCCALL(SETUP_XfOrM204(_), print_utf8_string (pp , "<???:" , 0 , 5 ) )
# 3301 "./../src/print.c"
        ; 
        (sprintf (s , "%d" , ((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) ) ; 
        FUNCCALL(SETUP_XfOrM204(_), print_utf8_string (pp , s , 0 , - 1 ) ); 
        FUNCCALL_AGAIN(print_utf8_string (pp , ">" , 0 , 1 ) ); 
      }

# 3305 "./../src/print.c"
      else {
#       define XfOrM203_COUNT (0+XfOrM202_COUNT)
#       define SETUP_XfOrM203(x) SETUP_XfOrM202(x)
        FUNCCALL_EMPTY(print_utf8_string (pp , s , 0 , len ) )
# 3306 "./../src/print.c"
        ; 
      }
    }





    closed = 1 ; 
  }

  RET_VALUE_START ((closed || compact ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3320 "./../src/print.c"
static void 
print_char_string (const char * str , int len , 
const mzchar * ustr , int delta , int ulen , 
int notdisplay , PrintParams * pp ) 
{
  char minibuf [12 ] , * esc ; 
  int a , i , v , ui , cont_utf8 = 0 , isize ; 
  PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(pp, 1), PUSH(esc, 2), PUSH(ustr, 3)));
# define XfOrM470_COUNT (4)
# define SETUP_XfOrM470(x) SETUP(XfOrM470_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  esc = NULLED_OUT ; 

# 3328 "./../src/print.c"
  if (notdisplay ) {
#   define XfOrM472_COUNT (0+XfOrM470_COUNT)
#   define SETUP_XfOrM472(x) SETUP_XfOrM470(x)
    FUNCCALL(SETUP_XfOrM472(_), print_utf8_string (pp , "\"" , 0 , 1 ) )
# 3329 "./../src/print.c"
    ; 

    for (a = i = ui = 0 ; i < len ; i += isize , ui ++ ) {
#     define XfOrM485_COUNT (0+XfOrM472_COUNT)
#     define SETUP_XfOrM485(x) SETUP_XfOrM472(x)

# 3332 "./../src/print.c"
      v = ((unsigned char * ) str ) [i ] ; 
      isize = 1 ; 

      switch (v ) {
#       define XfOrM489_COUNT (0+XfOrM485_COUNT)
#       define SETUP_XfOrM489(x) SETUP_XfOrM485(x)

# 3336 "./../src/print.c"
        case '\"' : 
        esc = "\\\"" ; 
        break ; 
        case '\\' : esc = "\\\\" ; 

# 3339 "./../src/print.c"
        break ; 
        case '\a' : esc = "\\a" ; 

# 3340 "./../src/print.c"
        break ; 
        case '\b' : esc = "\\b" ; 

# 3341 "./../src/print.c"
        break ; 
        case 27 : esc = "\\e" ; 

# 3342 "./../src/print.c"
        break ; 
        case '\f' : esc = "\\f" ; 

# 3343 "./../src/print.c"
        break ; 
        case '\n' : esc = "\\n" ; 

# 3344 "./../src/print.c"
        break ; 
        case '\r' : esc = "\\r" ; 

# 3345 "./../src/print.c"
        break ; 
        case '\t' : esc = "\\t" ; 

# 3346 "./../src/print.c"
        break ; 
        case '\v' : esc = "\\v" ; 

# 3347 "./../src/print.c"
        break ; 
        default : 
        if (v > 127 ) {
#         define XfOrM492_COUNT (0+XfOrM489_COUNT)
#         define SETUP_XfOrM492(x) SETUP_XfOrM489(x)

# 3350 "./../src/print.c"
          if (cont_utf8 ) {
            cont_utf8 -- ; 
            ui -- ; 
            esc = ((void * ) 0 ) ; 
          }

# 3354 "./../src/print.c"
          else {
            int clen ; 
#           define XfOrM493_COUNT (0+XfOrM492_COUNT)
#           define SETUP_XfOrM493(x) SETUP_XfOrM492(x)

# 3356 "./../src/print.c"
            clen = FUNCCALL(SETUP_XfOrM493(_), scheme_utf8_encode (ustr , ui + delta , ui + delta + 1 , ((void * ) 0 ) , 0 , 0 ) ); 
            if ((((scheme_uchar_table [(ustr [ui + delta ] >> 8 ) & 0x1FFF ] [ustr [ui + delta ] & 0xFF ] ) ) & 0x800 ) 
            || (((scheme_uchar_table [(ustr [ui + delta ] >> 8 ) & 0x1FFF ] [ustr [ui + delta ] & 0xFF ] ) ) & 0x1 ) ) {
              cont_utf8 = clen - 1 ; 
              esc = ((void * ) 0 ) ; 
            }

# 3361 "./../src/print.c"
            else {
              esc = minibuf ; 
              isize = clen ; 
            }
          }
        }

# 3366 "./../src/print.c"
        else if ((((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x800 ) 
        || (((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x1 ) ) {
          esc = ((void * ) 0 ) ; 
        }

# 3369 "./../src/print.c"
        else {
          esc = minibuf ; 
        }
        break ; 
      }

      if (esc ) {
#       define XfOrM486_COUNT (0+XfOrM485_COUNT)
#       define SETUP_XfOrM486(x) SETUP_XfOrM485(x)

# 3376 "./../src/print.c"
        if (esc == minibuf ) {
#         define XfOrM487_COUNT (0+XfOrM486_COUNT)
#         define SETUP_XfOrM487(x) SETUP_XfOrM486(x)

# 3377 "./../src/print.c"
          if (ustr [ui + delta ] > 0xFFFF ) {
#           define XfOrM488_COUNT (0+XfOrM487_COUNT)
#           define SETUP_XfOrM488(x) SETUP_XfOrM487(x)
            (
# 3378 "./../src/print.c"
            sprintf (minibuf , "\\U%.8X" , ustr [ui + delta ] ) ) ; 
          }

# 3379 "./../src/print.c"
          else (
          sprintf (minibuf , "\\u%.4X" , ustr [ui + delta ] ) ) ; 
        }

        if (a < i )
          FUNCCALL(SETUP_XfOrM486(_), print_utf8_string (pp , str , a , i - a ) ); 
        FUNCCALL(SETUP_XfOrM486(_), print_utf8_string (pp , esc , 0 , - 1 ) ); 
        a = i + isize ; 
      }
    }
    if (a < i )
      FUNCCALL(SETUP_XfOrM472(_), print_utf8_string (pp , str , a , i - a ) ); 
    FUNCCALL(SETUP_XfOrM472(_), print_utf8_string (pp , "\"" , 0 , 1 ) )
    ; 
  }

# 3393 "./../src/print.c"
  else if (len ) {
#   define XfOrM471_COUNT (0+XfOrM470_COUNT)
#   define SETUP_XfOrM471(x) SETUP_XfOrM470(x)
    FUNCCALL_EMPTY(print_utf8_string (pp , str , 0 , len ) )
# 3394 "./../src/print.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3398 "./../src/print.c"
static void 
print_byte_string (const char * str , int delta , int len , int notdisplay , PrintParams * pp ) 
{
  char minibuf [8 ] , * esc ; 
  int a , i , v ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(pp, 1), PUSH(esc, 2)));
# define XfOrM497_COUNT (3)
# define SETUP_XfOrM497(x) SETUP(XfOrM497_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  esc = NULLED_OUT ; 

# 3404 "./../src/print.c"
  if (notdisplay ) {
#   define XfOrM499_COUNT (0+XfOrM497_COUNT)
#   define SETUP_XfOrM499(x) SETUP_XfOrM497(x)
    FUNCCALL(SETUP_XfOrM499(_), print_utf8_string (pp , "\"" , 0 , 1 ) )
# 3405 "./../src/print.c"
    ; 

    for (a = i = delta ; i < delta + len ; i ++ ) {
#     define XfOrM507_COUNT (0+XfOrM499_COUNT)
#     define SETUP_XfOrM507(x) SETUP_XfOrM499(x)

# 3409 "./../src/print.c"
      switch (((unsigned char * ) str ) [i ] ) {
        case '\"' : esc = "\\\"" ; 

# 3410 "./../src/print.c"
        break ; 
        case '\\' : esc = "\\\\" ; 

# 3411 "./../src/print.c"
        break ; 
        case '\a' : esc = "\\a" ; 

# 3412 "./../src/print.c"
        break ; 
        case '\b' : esc = "\\b" ; 

# 3413 "./../src/print.c"
        break ; 
        case 27 : esc = "\\e" ; 

# 3414 "./../src/print.c"
        break ; 
        case '\f' : esc = "\\f" ; 

# 3415 "./../src/print.c"
        break ; 
        case '\n' : esc = "\\n" ; 

# 3416 "./../src/print.c"
        break ; 
        case '\r' : esc = "\\r" ; 

# 3417 "./../src/print.c"
        break ; 
        case '\t' : esc = "\\t" ; 

# 3418 "./../src/print.c"
        break ; 
        case '\v' : esc = "\\v" ; 

# 3419 "./../src/print.c"
        break ; 
        default : 
        v = ((unsigned char * ) str ) [i ] ; 
        if (v > 127 ) {
          esc = minibuf ; 
        }

# 3424 "./../src/print.c"
        else if ((((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x800 ) || (((scheme_uchar_table [(v >> 8 ) & 0x1FFF ] [v & 0xFF ] ) ) & 0x1 ) ) {
          esc = ((void * ) 0 ) ; 
        }

# 3426 "./../src/print.c"
        else {
          esc = minibuf ; 
        }
        break ; 
      }

      if (esc ) {
#       define XfOrM508_COUNT (0+XfOrM507_COUNT)
#       define SETUP_XfOrM508(x) SETUP_XfOrM507(x)

# 3433 "./../src/print.c"
        if (esc == minibuf ) {
#         define XfOrM509_COUNT (0+XfOrM508_COUNT)
#         define SETUP_XfOrM509(x) SETUP_XfOrM508(x)
          (
# 3434 "./../src/print.c"
          sprintf (minibuf , 
          ((i + 1 >= len ) || (str [i + 1 ] < '0' ) || (str [i + 1 ] > '7' ) ) ? "\\%o" : "\\%03o" , 
          ((unsigned char * ) str ) [i ] ) ) ; 
        }

        if (a < i )
          FUNCCALL(SETUP_XfOrM508(_), print_utf8_string (pp , str , a , i - a ) ); 
        FUNCCALL(SETUP_XfOrM508(_), print_utf8_string (pp , esc , 0 , - 1 ) ); 
        a = i + 1 ; 
      }
    }
    if (a < i )
      FUNCCALL(SETUP_XfOrM499(_), print_utf8_string (pp , str , a , i - a ) ); 
    FUNCCALL(SETUP_XfOrM499(_), print_utf8_string (pp , "\"" , 0 , 1 ) )
    ; 
  }

# 3449 "./../src/print.c"
  else if (len ) {
#   define XfOrM498_COUNT (0+XfOrM497_COUNT)
#   define SETUP_XfOrM498(x) SETUP_XfOrM497(x)
    FUNCCALL_EMPTY(print_this_string (pp , str , delta , len ) )
# 3450 "./../src/print.c"
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3454 "./../src/print.c"
static int is_special_reader_form (PrintParams * pp , int notdisplay , Scheme_Object * p ) 
{
  /* No conversion */

# 3456 "./../src/print.c"
  Scheme_Object * v ; 

  if (notdisplay && (notdisplay != 3 ) && pp -> print_reader ) {
    v = (((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . car ) ; 
    p = (((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . cdr ) ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )

# 3461 "./../src/print.c"
    return 0 ; 
    p = (((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . cdr ) ; 
    if (! ((p ) == (scheme_null ) ) )

# 3463 "./../src/print.c"
    return 0 ; 
    if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) )  {
      if (((v ) == (quote_symbol ) ) 
      || ((v ) == (quasiquote_symbol ) ) 
      || ((v ) == (unquote_symbol ) ) 
      || ((v ) == (unquote_splicing_symbol ) ) 
      || ((v ) == (syntax_symbol ) ) 
      || ((v ) == (quasisyntax_symbol ) ) 
      || ((v ) == (unsyntax_symbol ) ) 
      || ((v ) == (unsyntax_splicing_symbol ) ) )
        return 1 ; 
    }
  }

  return 0 ; 
}

static void print_special_reader_form (Scheme_Object * v , PrintParams * pp , int notdisplay ) 
{
  /* No conversion */

# 3482 "./../src/print.c"
  const char * str ; 
  int len ; 

  if ((v ) == (quote_symbol ) )  {
    str = "'" ; 
    len = 1 ; 
  }

# 3488 "./../src/print.c"
  else if ((v ) == (quasiquote_symbol ) )  {
    str = "`" ; 
    len = 1 ; 
  }

# 3491 "./../src/print.c"
  else if ((v ) == (unquote_symbol ) )  {
    str = "," ; 
    len = 1 ; 
  }

# 3494 "./../src/print.c"
  else if ((v ) == (unquote_splicing_symbol ) )  {
    str = ",@" ; 
    len = 2 ; 
  }

# 3497 "./../src/print.c"
  else if ((v ) == (syntax_symbol ) )  {
    str = "#'" ; 
    len = 2 ; 
  }

# 3500 "./../src/print.c"
  else if ((v ) == (quasisyntax_symbol ) )  {
    str = "#`" ; 
    len = 2 ; 
  }

# 3503 "./../src/print.c"
  else if ((v ) == (unsyntax_symbol ) )  {
    str = "#," ; 
    len = 2 ; 
  }

# 3506 "./../src/print.c"
  else if ((v ) == (unsyntax_splicing_symbol ) )  {
    str = "#,@" ; 
    len = 3 ; 
  }

# 3509 "./../src/print.c"
  else {
    str = "???" ; 
    len = 3 ; 
  }

  print_utf8_string (pp , str , 0 , len ) ; 
}

static void 
print_pair (Scheme_Object * pair , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
Scheme_Type pair_type , int round_parens , int first_unquoted ) 
{
  Scheme_Object * cdr ; 
  int super_compact = 0 ; 
  PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(cdr, 1), PUSH(pp, 2), PUSH(pair, 3), PUSH(mt, 4)));
# define XfOrM527_COUNT (5)
# define SETUP_XfOrM527(x) SETUP(XfOrM527_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  cdr = NULLED_OUT ; 

# 3527 "./../src/print.c"
  if (compact ) {
    int c = 0 ; 
    Scheme_Object * pr ; 
    BLOCK_SETUP((PUSH(pr, 0+XfOrM527_COUNT)));
#   define XfOrM550_COUNT (1+XfOrM527_COUNT)
#   define SETUP_XfOrM550(x) SETUP(XfOrM550_COUNT)
    pr = NULLED_OUT ; 

# 3531 "./../src/print.c"
    pr = pair ; 
    while (((Scheme_Type ) (((((intptr_t ) (pr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pr ) ) -> type ) ) == (Scheme_Type ) (pair_type ) ) ) {
#     define XfOrM556_COUNT (0+XfOrM550_COUNT)
#     define SETUP_XfOrM556(x) SETUP_XfOrM550(x)

# 3533 "./../src/print.c"
      if (ht )
        if (FUNCCALL(SETUP_XfOrM556(_), is_graph_point (ht , pr ) )) {
        c = - 1 ; 
        break ; 
      }
      c ++ ; 
      pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ; 
    }

    if (c > - 1 ) {
#     define XfOrM551_COUNT (0+XfOrM550_COUNT)
#     define SETUP_XfOrM551(x) SETUP_XfOrM550(x)

# 3543 "./../src/print.c"
      super_compact = 1 ; 
      if (c < (((92 + 50 ) + 50 ) - (92 + 50 ) ) ) {
        unsigned char s [1 ] ; 
#       define XfOrM553_COUNT (0+XfOrM551_COUNT)
#       define SETUP_XfOrM553(x) SETUP_XfOrM551(x)

# 3546 "./../src/print.c"
        s [0 ] = c + (((pr ) == (scheme_null ) ) 
        ? 92 
        : (92 + 50 ) ) ; 
        FUNCCALL(SETUP_XfOrM553(_), print_this_string (pp , (char * ) s , 0 , 1 ) ); 
      }

# 3550 "./../src/print.c"
      else {
#       define XfOrM552_COUNT (0+XfOrM551_COUNT)
#       define SETUP_XfOrM552(x) SETUP_XfOrM551(x)
        FUNCCALL(SETUP_XfOrM552(_), print_this_string (pp , & compacts [CPT_LIST ] , 0 , 1 ) )
# 3551 "./../src/print.c"
        ; 
        FUNCCALL(SETUP_XfOrM552(_), print_compact_number (pp , c ) ); 
        super_compact = - 1 ; 
      }
    }
  }

  if (compact ) {
#   define XfOrM549_COUNT (0+XfOrM527_COUNT)
#   define SETUP_XfOrM549(x) SETUP_XfOrM527(x)

# 3559 "./../src/print.c"
    if (! super_compact )
      FUNCCALL(SETUP_XfOrM549(_), print_this_string (pp , & compacts [CPT_PAIR ] , 0 , 1 ) ); 
  }

# 3561 "./../src/print.c"
  else {
#   define XfOrM541_COUNT (0+XfOrM527_COUNT)
#   define SETUP_XfOrM541(x) SETUP_XfOrM527(x)

# 3562 "./../src/print.c"
    if (round_parens 
    && ! first_unquoted 
    && FUNCCALL(SETUP_XfOrM541(_), is_special_reader_form (pp , notdisplay , pair ) )) {
#     define XfOrM546_COUNT (0+XfOrM541_COUNT)
#     define SETUP_XfOrM546(x) SETUP_XfOrM541(x)
      FUNCCALL(SETUP_XfOrM546(_), print_special_reader_form ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) , pp , notdisplay ) )
# 3565 "./../src/print.c"
      ; 




      if (((((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) ) == (unquote_symbol ) ) 
      || (((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) ) == (unsyntax_symbol ) ) ) 
      && (((Scheme_Type ) (((((intptr_t ) (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
      && ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ) ) ) -> s ) [0 ] == '@' ) ) ) {

        const char * sv ; 
        BLOCK_SETUP((PUSH(sv, 0+XfOrM546_COUNT)));
#       define XfOrM547_COUNT (1+XfOrM546_COUNT)
#       define SETUP_XfOrM547(x) SETUP(XfOrM547_COUNT)
        sv = NULLED_OUT ; 

# 3576 "./../src/print.c"
        sv = FUNCCALL(SETUP_XfOrM547(_), scheme_symbol_name_and_size (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) , ((void * ) 0 ) , ((pp -> can_read_pipe_quote ? 0x2 : 0x4 ) ) ) )


        ; 
        if (sv [0 ] == '@' ) {
#         define XfOrM548_COUNT (0+XfOrM547_COUNT)
#         define SETUP_XfOrM548(x) SETUP_XfOrM547(x)
          FUNCCALL(SETUP_XfOrM548(_), print_utf8_string (pp , " " , 0 , 1 ) )
# 3582 "./../src/print.c"
          ; 
        }
      }
      (void ) FUNCCALL(SETUP_XfOrM546(_), print (((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) , notdisplay , compact , ht , mt , pp ) ); 
      RET_NOTHING ; 
    }

# 3587 "./../src/print.c"
    else if ((notdisplay == 3 ) && ! first_unquoted ) {
#     define XfOrM543_COUNT (0+XfOrM541_COUNT)
#     define SETUP_XfOrM543(x) SETUP_XfOrM541(x)

# 3588 "./../src/print.c"
      if ((Scheme_Type ) (pair_type ) == (Scheme_Type ) (scheme_pair_type ) )  {
#       define XfOrM545_COUNT (0+XfOrM543_COUNT)
#       define SETUP_XfOrM545(x) SETUP_XfOrM543(x)

# 3589 "./../src/print.c"
        if (scheme_is_list (pair ) ) 
          FUNCCALL(SETUP_XfOrM545(_), print_utf8_string (pp , "(list " , 0 , 6 ) ); 
        else if (! ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
        || FUNCCALL(SETUP_XfOrM545(_), is_graph_point (ht , (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ) ))
          FUNCCALL(SETUP_XfOrM545(_), print_utf8_string (pp , "(cons " , 0 , 6 ) ); 
        else FUNCCALL(SETUP_XfOrM545(_), print_utf8_string (pp , "(list* " , 0 , 7 ) )
        ; 
      }

# 3596 "./../src/print.c"
      else {
#       define XfOrM544_COUNT (0+XfOrM543_COUNT)
#       define SETUP_XfOrM544(x) SETUP_XfOrM543(x)

# 3597 "./../src/print.c"
        pair_type = - 1 ; 
        FUNCCALL(SETUP_XfOrM544(_), print_utf8_string (pp , "(mcons " , 0 , 7 ) ); 
      }
      round_parens = 1 ; 
    }

# 3601 "./../src/print.c"
    else if (round_parens ) {
#     define XfOrM542_COUNT (0+XfOrM541_COUNT)
#     define SETUP_XfOrM542(x) SETUP_XfOrM541(x)
      FUNCCALL(SETUP_XfOrM542(_), print_utf8_string (pp , "(" , 0 , 1 ) )
# 3602 "./../src/print.c"
      ; 
    }

# 3603 "./../src/print.c"
    else FUNCCALL(SETUP_XfOrM541(_), print_utf8_string (pp , "{" , 0 , 1 ) )
    ; 
  }
  FUNCCALL(SETUP_XfOrM527(_), print ((((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . car ) , (first_unquoted ? 1 : notdisplay ) , compact , ht , mt , pp ) )
  ; 

  cdr = (((Scheme_Simple_Object * ) (pair ) ) -> u . pair_val . cdr ) ; 
  while (((Scheme_Type ) (((((intptr_t ) (cdr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (cdr ) ) -> type ) ) == (Scheme_Type ) (pair_type ) ) 
  && ! FUNCCALL(SETUP_XfOrM527(_), is_special_reader_form (pp , notdisplay , pair ) )) {
#   define XfOrM536_COUNT (0+XfOrM527_COUNT)
#   define SETUP_XfOrM536(x) SETUP_XfOrM527(x)

# 3612 "./../src/print.c"
    if (ht && ! super_compact ) {
#     define XfOrM537_COUNT (0+XfOrM536_COUNT)
#     define SETUP_XfOrM537(x) SETUP_XfOrM536(x)

# 3613 "./../src/print.c"
      if (FUNCCALL(SETUP_XfOrM537(_), is_graph_point (ht , cdr ) )) {
#       define XfOrM538_COUNT (0+XfOrM537_COUNT)
#       define SETUP_XfOrM538(x) SETUP_XfOrM537(x)

# 3615 "./../src/print.c"
        if (! compact ) {
#         define XfOrM540_COUNT (0+XfOrM538_COUNT)
#         define SETUP_XfOrM540(x) SETUP_XfOrM538(x)

# 3616 "./../src/print.c"
          if (notdisplay == 3 )
            FUNCCALL(SETUP_XfOrM540(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
          else FUNCCALL(SETUP_XfOrM540(_), print_utf8_string (pp , " . " , 0 , 3 ) )
          ; 
        }
        (void ) FUNCCALL(SETUP_XfOrM538(_), print (cdr , notdisplay , compact , ht , mt , pp ) ); 
        if (! compact ) {
#         define XfOrM539_COUNT (0+XfOrM538_COUNT)
#         define SETUP_XfOrM539(x) SETUP_XfOrM538(x)

# 3623 "./../src/print.c"
          if (round_parens )
            FUNCCALL(SETUP_XfOrM539(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
          else FUNCCALL(SETUP_XfOrM539(_), print_utf8_string (pp , "}" , 0 , 1 ) )
          ; 
        }
        RET_NOTHING ; 
      }
    }
    if (compact && ! super_compact )
      FUNCCALL(SETUP_XfOrM536(_), print_this_string (pp , & compacts [CPT_PAIR ] , 0 , 1 ) ); 
    if (! compact )
      FUNCCALL(SETUP_XfOrM536(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    FUNCCALL(SETUP_XfOrM536(_), print ((((Scheme_Simple_Object * ) (cdr ) ) -> u . pair_val . car ) , notdisplay , compact , ht , mt , pp ) ); 
    cdr = (((Scheme_Simple_Object * ) (cdr ) ) -> u . pair_val . cdr ) ; 
  }

  if (! ((cdr ) == (scheme_null ) ) || (pair_type == - 1 ) ) {
#   define XfOrM529_COUNT (0+XfOrM527_COUNT)
#   define SETUP_XfOrM529(x) SETUP_XfOrM527(x)

# 3640 "./../src/print.c"
    if (! compact ) {
#     define XfOrM530_COUNT (0+XfOrM529_COUNT)
#     define SETUP_XfOrM530(x) SETUP_XfOrM529(x)

# 3641 "./../src/print.c"
      if (notdisplay == 3 )
        FUNCCALL(SETUP_XfOrM530(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
      else FUNCCALL(SETUP_XfOrM530(_), print_utf8_string (pp , " . " , 0 , 3 ) )
      ; 
    }
    FUNCCALL(SETUP_XfOrM529(_), print (cdr , notdisplay , compact , ht , mt , pp ) ); 
  }

# 3647 "./../src/print.c"
  else if (compact && (super_compact < 1 ) )
    FUNCCALL(SETUP_XfOrM527(_), print_this_string (pp , & compacts [CPT_NULL ] , 0 , 1 ) ); 

  if (! compact ) {
#   define XfOrM528_COUNT (0+XfOrM527_COUNT)
#   define SETUP_XfOrM528(x) SETUP_XfOrM527(x)

# 3651 "./../src/print.c"
    if (round_parens )
      FUNCCALL(SETUP_XfOrM528(_), print_utf8_string (pp , ")" , 0 , 1 ) ); 
    else FUNCCALL_EMPTY(print_utf8_string (pp , "}" , 0 , 1 ) )
    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1 "./../src/print_vector.inc"
static void 
print_vector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) 
{
  int i , size , common = 0 ; 
  Scheme_Object * * elems ; 
  Scheme_Object * elem ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(vec, 1), PUSH(elem, 2), PUSH(mt, 3), PUSH(pp, 4), PUSH(elems, 5)));
# define XfOrM558_COUNT (6)
# define SETUP_XfOrM558(x) SETUP(XfOrM558_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  elems = NULLED_OUT ; 
  elem = NULLED_OUT ; 

# 13 "./../src/print_vector.inc"
  do {

# 13 "./../src/print_vector.inc"
    if ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 

# 13 "./../src/print_vector.inc"
    size = (((Scheme_Vector * ) (vec ) ) -> size ) ; 

# 13 "./../src/print_vector.inc"
    else size = (((Scheme_Vector * ) ((((Scheme_Chaperone * ) vec ) -> val ) ) ) -> size ) ; 
  }

# 13 "./../src/print_vector.inc"
  while (0 ) ; 
  if (compact ) {
#   define XfOrM581_COUNT (0+XfOrM558_COUNT)
#   define SETUP_XfOrM581(x) SETUP_XfOrM558(x)

# 15 "./../src/print_vector.inc"
    do {
#     define XfOrM583_COUNT (0+XfOrM581_COUNT)
#     define SETUP_XfOrM583(x) SETUP_XfOrM581(x)
      FUNCCALL(SETUP_XfOrM583(_), print_this_string (pp , & compacts [CPT_VECTOR ] , 0 , 1 ) )
# 15 "./../src/print_vector.inc"
      ; 
      FUNCCALL(SETUP_XfOrM583(_), print_compact_number (pp , size ) )
# 15 "./../src/print_vector.inc"
      ; 
    }

# 15 "./../src/print_vector.inc"
    while (0 ) ; 
  }

# 16 "./../src/print_vector.inc"
  else {
#   define XfOrM571_COUNT (0+XfOrM558_COUNT)
#   define SETUP_XfOrM571(x) SETUP_XfOrM558(x)

# 17 "./../src/print_vector.inc"
    do {

# 17 "./../src/print_vector.inc"
      if ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 

# 17 "./../src/print_vector.inc"
      elems = (((Scheme_Vector * ) (vec ) ) -> els ) ; 

# 17 "./../src/print_vector.inc"
      else elems = (((Scheme_Vector * ) ((((Scheme_Chaperone * ) vec ) -> val ) ) ) -> els ) ; 
    }

# 17 "./../src/print_vector.inc"
    while (0 ) ; 
    for (i = size ; i -- ; common ++ ) {
      if (! i || (elems [i ] != elems [i - 1 ] ) )
        break ; 
    }
    elems = ((void * ) 0 ) ; 

    if (as_prefab ) {
#     define XfOrM576_COUNT (0+XfOrM571_COUNT)
#     define SETUP_XfOrM576(x) SETUP_XfOrM571(x)
      FUNCCALL(SETUP_XfOrM576(_), print_utf8_string (pp , "#s(" , 0 , 3 ) )
# 25 "./../src/print_vector.inc"
      ; 
    }

# 26 "./../src/print_vector.inc"
    else if (notdisplay && pp -> print_vec_shorthand && (notdisplay != 3 ) ) {
#     define XfOrM573_COUNT (0+XfOrM571_COUNT)
#     define SETUP_XfOrM573(x) SETUP_XfOrM571(x)

# 27 "./../src/print_vector.inc"
      if (size == 0 ) {
#       define XfOrM575_COUNT (0+XfOrM573_COUNT)
#       define SETUP_XfOrM575(x) SETUP_XfOrM573(x)
        FUNCCALL(SETUP_XfOrM575(_), print_utf8_string (pp , "#0(" , 0 , 3 ) )
# 28 "./../src/print_vector.inc"
        ; 
      }

# 29 "./../src/print_vector.inc"
      else {
        char buffer [100 ] ; 
#       define XfOrM574_COUNT (0+XfOrM573_COUNT)
#       define SETUP_XfOrM574(x) SETUP_XfOrM573(x)
        (
# 31 "./../src/print_vector.inc"
        sprintf (buffer , "#%d(" , size ) ) ; 
        FUNCCALL(SETUP_XfOrM574(_), print_utf8_string (pp , buffer , 0 , - 1 ) ); 
        size -= common ; 
      }
    }

# 35 "./../src/print_vector.inc"
    else if (notdisplay == 3 ) {
#     define XfOrM572_COUNT (0+XfOrM571_COUNT)
#     define SETUP_XfOrM572(x) SETUP_XfOrM571(x)
      FUNCCALL(SETUP_XfOrM572(_), print_utf8_string (pp , "(vector" , 0 , 7 ) )
# 36 "./../src/print_vector.inc"
      ; 
      if (size )
        FUNCCALL(SETUP_XfOrM572(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }

# 39 "./../src/print_vector.inc"
    else FUNCCALL(SETUP_XfOrM571(_), print_utf8_string (pp , "#(" , 0 , 2 ) )
    ; 
  }

  for (i = 0 ; i < size ; i ++ ) {
#   define XfOrM565_COUNT (0+XfOrM558_COUNT)
#   define SETUP_XfOrM565(x) SETUP_XfOrM558(x)

# 44 "./../src/print_vector.inc"
    do {
#     define XfOrM570_COUNT (0+XfOrM565_COUNT)
#     define SETUP_XfOrM570(x) SETUP_XfOrM565(x)

# 44 "./../src/print_vector.inc"
      if ((Scheme_Type ) (((((intptr_t ) (vec ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (vec ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 

# 44 "./../src/print_vector.inc"
      elem = (((Scheme_Vector * ) (vec ) ) -> els ) [i ] ; 

# 44 "./../src/print_vector.inc"
      else elem = FUNCCALL(SETUP_XfOrM570(_), scheme_chaperone_vector_ref (vec , i ) ); 
    }

# 44 "./../src/print_vector.inc"
    while (0 ) ; 
    do {
#     define XfOrM568_COUNT (0+XfOrM565_COUNT)
#     define SETUP_XfOrM568(x) SETUP_XfOrM565(x)
      FUNCCALL(SETUP_XfOrM568(_), print (elem , notdisplay , compact , ht , mt , pp ) )
# 45 "./../src/print_vector.inc"
      ; 
    }

# 45 "./../src/print_vector.inc"
    while (0 ) ; 
    if (i < (size - 1 ) ) {
#     define XfOrM566_COUNT (0+XfOrM565_COUNT)
#     define SETUP_XfOrM566(x) SETUP_XfOrM565(x)

# 47 "./../src/print_vector.inc"
      if (! compact )
        FUNCCALL(SETUP_XfOrM566(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }
  }

  if (! compact )
    FUNCCALL_EMPTY(print_utf8_string (pp , ")" , 0 , 1 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1 "./../src/print_vector.inc"
static void 
print_flvector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) 
{
  int i , size , common = 0 ; 
  double * elems ; 
  double elem ; 
  int used_buffer = 0 ; 

# 11 "./../src/print_vector.inc"
  char buffer [100 ] ; 
  char * __funcarg107 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(vec, 1), PUSH(pp, 2), PUSH(mt, 3), PUSH(elems, 4)));
# define XfOrM586_COUNT (5)
# define SETUP_XfOrM586(x) SETUP(XfOrM586_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  elems = NULLED_OUT ; 

# 13 "./../src/print_vector.inc"
  size = (((Scheme_Double_Vector * ) (vec ) ) -> size ) ; 
  if (compact ) {
#   define XfOrM603_COUNT (0+XfOrM586_COUNT)
#   define SETUP_XfOrM603(x) SETUP_XfOrM586(x)

# 15 "./../src/print_vector.inc"
    do {
#     define XfOrM605_COUNT (0+XfOrM603_COUNT)
#     define SETUP_XfOrM605(x) SETUP_XfOrM603(x)
      FUNCCALL(SETUP_XfOrM605(_), print_escaped (pp , notdisplay , vec , ht , mt , 1 ) )
# 15 "./../src/print_vector.inc"
      ; 

# 15 "./../src/print_vector.inc"
      RET_NOTHING ; 
    }

# 15 "./../src/print_vector.inc"
    while (0 ) ; 
  }

# 16 "./../src/print_vector.inc"
  else {
#   define XfOrM595_COUNT (0+XfOrM586_COUNT)
#   define SETUP_XfOrM595(x) SETUP_XfOrM586(x)

# 17 "./../src/print_vector.inc"
    elems = (((Scheme_Double_Vector * ) (vec ) ) -> els ) ; 
    for (i = size ; i -- ; common ++ ) {
      if (! i || (elems [i ] != elems [i - 1 ] ) )
        break ; 
    }
    elems = ((void * ) 0 ) ; 

    if (as_prefab ) {
#     define XfOrM600_COUNT (0+XfOrM595_COUNT)
#     define SETUP_XfOrM600(x) SETUP_XfOrM595(x)
      FUNCCALL(SETUP_XfOrM600(_), print_utf8_string (pp , "#s(" , 0 , 3 ) )
# 25 "./../src/print_vector.inc"
      ; 
    }

# 26 "./../src/print_vector.inc"
    else if (notdisplay && pp -> print_vec_shorthand && (notdisplay != 3 ) ) {
#     define XfOrM597_COUNT (0+XfOrM595_COUNT)
#     define SETUP_XfOrM597(x) SETUP_XfOrM595(x)

# 27 "./../src/print_vector.inc"
      if (size == 0 ) {
#       define XfOrM599_COUNT (0+XfOrM597_COUNT)
#       define SETUP_XfOrM599(x) SETUP_XfOrM597(x)
        FUNCCALL(SETUP_XfOrM599(_), print_utf8_string (pp , "#fl0(" , 0 , 5 ) )
# 28 "./../src/print_vector.inc"
        ; 
      }

# 29 "./../src/print_vector.inc"
      else {
        char buffer [100 ] ; 
#       define XfOrM598_COUNT (0+XfOrM597_COUNT)
#       define SETUP_XfOrM598(x) SETUP_XfOrM597(x)
        (
# 31 "./../src/print_vector.inc"
        sprintf (buffer , "#fl%d(" , size ) ) ; 
        FUNCCALL(SETUP_XfOrM598(_), print_utf8_string (pp , buffer , 0 , - 1 ) ); 
        size -= common ; 
      }
    }

# 35 "./../src/print_vector.inc"
    else if (notdisplay == 3 ) {
#     define XfOrM596_COUNT (0+XfOrM595_COUNT)
#     define SETUP_XfOrM596(x) SETUP_XfOrM595(x)
      FUNCCALL(SETUP_XfOrM596(_), print_utf8_string (pp , "(flvector" , 0 , 9 ) )
# 36 "./../src/print_vector.inc"
      ; 
      if (size )
        FUNCCALL(SETUP_XfOrM596(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }

# 39 "./../src/print_vector.inc"
    else FUNCCALL(SETUP_XfOrM595(_), print_utf8_string (pp , "#fl(" , 0 , 4 ) )
    ; 
  }

  for (i = 0 ; i < size ; i ++ ) {
#   define XfOrM591_COUNT (0+XfOrM586_COUNT)
#   define SETUP_XfOrM591(x) SETUP_XfOrM586(x)

# 44 "./../src/print_vector.inc"
    elem = (((Scheme_Double_Vector * ) (vec ) ) -> els ) [i ] ; 
    do {
#     define XfOrM594_COUNT (0+XfOrM591_COUNT)
#     define SETUP_XfOrM594(x) SETUP_XfOrM591(x)
      (__funcarg107 = FUNCCALL(SETUP_XfOrM594(_), scheme_double_to_string (elem , buffer , 100 , 0 , & used_buffer ) )
# 45 "./../src/print_vector.inc"
      , FUNCCALL_AGAIN(print_utf8_string (pp , __funcarg107 , 0 , - 1 ) )) ; 
    }

# 45 "./../src/print_vector.inc"
    while (0 ) ; 
    if (i < (size - 1 ) ) {
#     define XfOrM592_COUNT (0+XfOrM591_COUNT)
#     define SETUP_XfOrM592(x) SETUP_XfOrM591(x)

# 47 "./../src/print_vector.inc"
      if (! compact )
        FUNCCALL(SETUP_XfOrM592(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }
  }

  if (! compact )
    FUNCCALL_EMPTY(print_utf8_string (pp , ")" , 0 , 1 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1 "./../src/print_vector.inc"
static void 
print_fxvector (Scheme_Object * vec , int notdisplay , int compact , 
Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * pp , 
int as_prefab ) 
{
  int i , size , common = 0 ; 
  Scheme_Object * * elems ; 
  Scheme_Object * elem ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(vec, 1), PUSH(elem, 2), PUSH(mt, 3), PUSH(pp, 4), PUSH(elems, 5)));
# define XfOrM606_COUNT (6)
# define SETUP_XfOrM606(x) SETUP(XfOrM606_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  elems = NULLED_OUT ; 
  elem = NULLED_OUT ; 

# 13 "./../src/print_vector.inc"
  size = (((Scheme_Vector * ) (vec ) ) -> size ) ; 
  if (compact ) {
#   define XfOrM623_COUNT (0+XfOrM606_COUNT)
#   define SETUP_XfOrM623(x) SETUP_XfOrM606(x)

# 15 "./../src/print_vector.inc"
    do {
#     define XfOrM625_COUNT (0+XfOrM623_COUNT)
#     define SETUP_XfOrM625(x) SETUP_XfOrM623(x)
      FUNCCALL(SETUP_XfOrM625(_), print_escaped (pp , notdisplay , vec , ht , mt , 1 ) )
# 15 "./../src/print_vector.inc"
      ; 

# 15 "./../src/print_vector.inc"
      RET_NOTHING ; 
    }

# 15 "./../src/print_vector.inc"
    while (0 ) ; 
  }

# 16 "./../src/print_vector.inc"
  else {
#   define XfOrM615_COUNT (0+XfOrM606_COUNT)
#   define SETUP_XfOrM615(x) SETUP_XfOrM606(x)

# 17 "./../src/print_vector.inc"
    elems = (((Scheme_Vector * ) (vec ) ) -> els ) ; 
    for (i = size ; i -- ; common ++ ) {
      if (! i || (elems [i ] != elems [i - 1 ] ) )
        break ; 
    }
    elems = ((void * ) 0 ) ; 

    if (as_prefab ) {
#     define XfOrM620_COUNT (0+XfOrM615_COUNT)
#     define SETUP_XfOrM620(x) SETUP_XfOrM615(x)
      FUNCCALL(SETUP_XfOrM620(_), print_utf8_string (pp , "#s(" , 0 , 3 ) )
# 25 "./../src/print_vector.inc"
      ; 
    }

# 26 "./../src/print_vector.inc"
    else if (notdisplay && pp -> print_vec_shorthand && (notdisplay != 3 ) ) {
#     define XfOrM617_COUNT (0+XfOrM615_COUNT)
#     define SETUP_XfOrM617(x) SETUP_XfOrM615(x)

# 27 "./../src/print_vector.inc"
      if (size == 0 ) {
#       define XfOrM619_COUNT (0+XfOrM617_COUNT)
#       define SETUP_XfOrM619(x) SETUP_XfOrM617(x)
        FUNCCALL(SETUP_XfOrM619(_), print_utf8_string (pp , "#fx0(" , 0 , 5 ) )
# 28 "./../src/print_vector.inc"
        ; 
      }

# 29 "./../src/print_vector.inc"
      else {
        char buffer [100 ] ; 
#       define XfOrM618_COUNT (0+XfOrM617_COUNT)
#       define SETUP_XfOrM618(x) SETUP_XfOrM617(x)
        (
# 31 "./../src/print_vector.inc"
        sprintf (buffer , "#fx%d(" , size ) ) ; 
        FUNCCALL(SETUP_XfOrM618(_), print_utf8_string (pp , buffer , 0 , - 1 ) ); 
        size -= common ; 
      }
    }

# 35 "./../src/print_vector.inc"
    else if (notdisplay == 3 ) {
#     define XfOrM616_COUNT (0+XfOrM615_COUNT)
#     define SETUP_XfOrM616(x) SETUP_XfOrM615(x)
      FUNCCALL(SETUP_XfOrM616(_), print_utf8_string (pp , "(fxvector" , 0 , 9 ) )
# 36 "./../src/print_vector.inc"
      ; 
      if (size )
        FUNCCALL(SETUP_XfOrM616(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }

# 39 "./../src/print_vector.inc"
    else FUNCCALL(SETUP_XfOrM615(_), print_utf8_string (pp , "#fx(" , 0 , 4 ) )
    ; 
  }

  for (i = 0 ; i < size ; i ++ ) {
#   define XfOrM611_COUNT (0+XfOrM606_COUNT)
#   define SETUP_XfOrM611(x) SETUP_XfOrM606(x)

# 44 "./../src/print_vector.inc"
    elem = (((Scheme_Vector * ) (vec ) ) -> els ) [i ] ; 
    do {
#     define XfOrM614_COUNT (0+XfOrM611_COUNT)
#     define SETUP_XfOrM614(x) SETUP_XfOrM611(x)
      FUNCCALL(SETUP_XfOrM614(_), print (elem , notdisplay , compact , ht , mt , pp ) )
# 45 "./../src/print_vector.inc"
      ; 
    }

# 45 "./../src/print_vector.inc"
    while (0 ) ; 
    if (i < (size - 1 ) ) {
#     define XfOrM612_COUNT (0+XfOrM611_COUNT)
#     define SETUP_XfOrM612(x) SETUP_XfOrM611(x)

# 47 "./../src/print_vector.inc"
      if (! compact )
        FUNCCALL(SETUP_XfOrM612(_), print_utf8_string (pp , " " , 0 , 1 ) ); 
    }
  }

  if (! compact )
    FUNCCALL_EMPTY(print_utf8_string (pp , ")" , 0 , 1 ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3733 "./../src/print.c"
static void 
print_char (Scheme_Object * charobj , int notdisplay , PrintParams * pp ) 
{
  int ch ; 
  char minibuf [10 + 6 ] , * str ; 
  int len = - 1 ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(str, 0), PUSH(pp, 1)));
# define XfOrM626_COUNT (2)
# define SETUP_XfOrM626(x) SETUP(XfOrM626_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  str = NULLED_OUT ; 

# 3740 "./../src/print.c"
  ch = (((Scheme_Small_Object * ) (charobj ) ) -> u . char_val ) ; 
  if (notdisplay ) {
#   define XfOrM628_COUNT (0+XfOrM626_COUNT)
#   define SETUP_XfOrM628(x) SETUP_XfOrM626(x)

# 3742 "./../src/print.c"
    switch (ch ) 
    {
#     define XfOrM629_COUNT (0+XfOrM628_COUNT)
#     define SETUP_XfOrM629(x) SETUP_XfOrM628(x)

# 3744 "./../src/print.c"
      case '\0' : 
      str = "#\\nul" ; 
      break ; 
      case '\n' : 
      str = "#\\newline" ; 
      break ; 
      case '\t' : 
      str = "#\\tab" ; 
      break ; 
      case 0xb : 
      str = "#\\vtab" ; 
      break ; 
      case ' ' : 
      str = "#\\space" ; 
      break ; 
      case '\r' : 
      str = "#\\return" ; 
      break ; 
      case '\f' : 
      str = "#\\page" ; 
      break ; 
      case '\b' : 
      str = "#\\backspace" ; 
      break ; 
      case 0x7f : 
      str = "#\\rubout" ; 
      break ; 
      default : 
      if (((scheme_uchar_table [(ch >> 8 ) & 0x1FFF ] [ch & 0xFF ] ) ) & 0x800 )  {
#       define XfOrM631_COUNT (0+XfOrM629_COUNT)
#       define SETUP_XfOrM631(x) SETUP_XfOrM629(x)

# 3773 "./../src/print.c"
        minibuf [0 ] = '#' ; 
        minibuf [1 ] = '\\' ; 
        ch = FUNCCALL(SETUP_XfOrM631(_), scheme_utf8_encode ((unsigned int * ) & ch , 0 , 1 , (unsigned char * ) minibuf , 2 , 0 ) )

        ; 
        minibuf [2 + ch ] = 0 ; 
      }

# 3779 "./../src/print.c"
      else {
#       define XfOrM630_COUNT (0+XfOrM629_COUNT)
#       define SETUP_XfOrM630(x) SETUP_XfOrM629(x)

# 3780 "./../src/print.c"
        if (ch > 0xFFFF )
          (sprintf (minibuf , "#\\U%.8X" , ch ) ) ; 
        else (
        sprintf (minibuf , "#\\u%.4X" , ch ) ) ; 
      }
      str = minibuf ; 
      break ; 
    }
  }

# 3788 "./../src/print.c"
  else {
#   define XfOrM627_COUNT (0+XfOrM626_COUNT)
#   define SETUP_XfOrM627(x) SETUP_XfOrM626(x)

# 3789 "./../src/print.c"
    len = FUNCCALL(SETUP_XfOrM627(_), scheme_utf8_encode ((unsigned int * ) & ch , 0 , 1 , (unsigned char * ) minibuf , 0 , 0 ) )

    ; 
    minibuf [len ] = 0 ; 
    str = minibuf ; 
  }
  FUNCCALL_EMPTY(print_utf8_string (pp , str , 0 , len ) )
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3801 "./../src/print.c"
Scheme_Object * scheme_protect_quote (Scheme_Object * expr ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(expr, 0)));
# define XfOrM632_COUNT (1)
# define SETUP_XfOrM632(x) SETUP(XfOrM632_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3803 "./../src/print.c"
  if (((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_mutable_pair_type ) ) || (((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_flvector_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_fxvector_type ) ) || (1 && (((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) ) ) ) ) || (0 ) || (0 ) || (1 && ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) && ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? ((Scheme_Structure * ) (((Scheme_Chaperone * ) expr ) -> val ) ) -> stype -> prefab_key : ((Scheme_Structure * ) (expr ) ) -> stype -> prefab_key ) ) || (1 && ((((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) && ! ((& (((Scheme_Hash_Table * ) expr ) -> iso ) ) -> so . keyex & 0x1 ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_hash_table_type ) ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ? (((((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) expr ) -> val ) ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (((Scheme_Chaperone * ) expr ) -> val ) ) -> count ) : (((((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) >= scheme_hash_tree_type ) && (((((intptr_t ) (expr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expr ) ) -> type ) <= scheme_hash_tree_indirection_type ) ) && ((Scheme_Hash_Tree * ) (expr ) ) -> count ) ) ) ) )  {
    Scheme_Object * q ; 
    BLOCK_SETUP((PUSH(q, 0+XfOrM632_COUNT)));
#   define XfOrM633_COUNT (1+XfOrM632_COUNT)
#   define SETUP_XfOrM633(x) SETUP(XfOrM633_COUNT)
    q = NULLED_OUT ; 

# 3805 "./../src/print.c"
    q = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM633(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Small_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
    q -> type = scheme_quote_compilation_type ; 
    (((Scheme_Small_Object * ) (q ) ) -> u . ptr_val ) = expr ; 
    RET_VALUE_START (q ) RET_VALUE_END ; 
  }

# 3809 "./../src/print.c"
  else 
  RET_VALUE_START (expr ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

void scheme_set_type_printer (Scheme_Type stype , Scheme_Type_Printer printer ) 
{
  PREPARE_VAR_STACK(1);
# define XfOrM634_COUNT (0)
# define SETUP_XfOrM634(x) SETUP(XfOrM634_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3819 "./../src/print.c"
  if (! printers ) {
#   define XfOrM636_COUNT (0+XfOrM634_COUNT)
#   define SETUP_XfOrM636(x) SETUP_XfOrM634(x)
    FUNCCALL(SETUP_XfOrM636(_), scheme_register_static ((void * ) & printers , sizeof (printers ) ) )
# 3820 "./../src/print.c"
    ; 
  }

  if (stype >= printers_count ) {
    Scheme_Type_Printer * naya ; 
    BLOCK_SETUP((PUSH(naya, 0+XfOrM634_COUNT)));
#   define XfOrM635_COUNT (1+XfOrM634_COUNT)
#   define SETUP_XfOrM635(x) SETUP(XfOrM635_COUNT)
    naya = NULLED_OUT ; 

# 3825 "./../src/print.c"
    naya = ((Scheme_Type_Printer * ) FUNCCALL(SETUP_XfOrM635(_), GC_malloc (sizeof (Scheme_Type_Printer ) * (stype + 10 ) ) )) ; 
    (memset (naya , 0 , sizeof (Scheme_Type_Printer ) * (stype + 10 ) ) ) ; 
    if (printers_count )
      (memcpy (naya , printers , sizeof (Scheme_Type_Printer ) * printers_count ) ) ; 
    printers_count = stype + 10 ; 
    printers = naya ; 
  }

  printers [stype ] = printer ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
static Scheme_Object * callback_write (void * _p , int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * p = (Scheme_Object * ) _p ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM637_COUNT (1)
# define SETUP_XfOrM637(x) SETUP(XfOrM637_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3844 "./../src/print.c"
  if ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
    Scheme_Object * v = (((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . car ) ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM637_COUNT)));
#   define XfOrM638_COUNT (1+XfOrM637_COUNT)
#   define SETUP_XfOrM638(x) SETUP(XfOrM638_COUNT)

# 3846 "./../src/print.c"
    if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
      int cb_mode = (((intptr_t ) ((((Scheme_Vector * ) (v ) ) -> els ) [0 ] ) ) >> 1 ) ; 
      Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) ((((Scheme_Vector * ) (v ) ) -> els ) [1 ] ) ; 
      int * counter = (int * ) (((Scheme_Simple_Object * ) ((((Scheme_Vector * ) (v ) ) -> els ) [2 ] ) ) -> u . pair_val . car ) ; 
      PrintParams * pp = (PrintParams * ) (((Scheme_Simple_Object * ) ((((Scheme_Vector * ) (v ) ) -> els ) [2 ] ) ) -> u . pair_val . cdr ) ; 
      int mode = (((intptr_t ) ((((Scheme_Simple_Object * ) (p ) ) -> u . pair_val . cdr ) ) ) >> 1 ) ; 
      BLOCK_SETUP((PUSH(ht, 0+XfOrM638_COUNT), PUSH(pp, 1+XfOrM638_COUNT), PUSH(counter, 2+XfOrM638_COUNT)));
#     define XfOrM639_COUNT (3+XfOrM638_COUNT)
#     define SETUP_XfOrM639(x) SETUP(XfOrM639_COUNT)

# 3853 "./../src/print.c"
      if (argc > 2 )
        mode += (((intptr_t ) (argv [2 ] ) ) >> 1 ) ; 

      if (cb_mode == 1 ) {
        int res ; 
#       define XfOrM641_COUNT (0+XfOrM639_COUNT)
#       define SETUP_XfOrM641(x) SETUP_XfOrM639(x)

# 3858 "./../src/print.c"
        res = FUNCCALL(SETUP_XfOrM641(_), check_cycles (argv [0 ] , mode , ht , pp ) ); 
        (((Scheme_Vector * ) (v ) ) -> els ) [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (res | (((intptr_t ) ((((Scheme_Vector * ) (v ) ) -> els ) [3 ] ) ) >> 1 ) ) ) ) << 1 ) | 0x1 ) ) ; 
      }

# 3860 "./../src/print.c"
      else {
#       define XfOrM640_COUNT (0+XfOrM639_COUNT)
#       define SETUP_XfOrM640(x) SETUP_XfOrM639(x)
        FUNCCALL_EMPTY(setup_graph_table (argv [0 ] , mode , ht , counter , pp ) )
# 3861 "./../src/print.c"
        ; 
      }
    }
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3870 "./../src/print.c"
static int writable_struct_subs (Scheme_Object * s , int for_write , PrintParams * pp , 
int mode , Scheme_Hash_Table * ht , int * counter ) 
{
  Scheme_Object * v , * o , * a [3 ] , * cb , * pr ; 
  Scheme_Object * d_callback_proc , * w_callback_proc , * p_callback_proc ; 
  Scheme_Output_Port * op ; 
  Scheme_Object * __funcarg110 = NULLED_OUT ; 
  Scheme_Object * __funcarg109 = NULLED_OUT ; 
  Scheme_Object * __funcarg108 = NULLED_OUT ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(16);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(d_callback_proc, 1), PUSHARRAY(a, 3, 2), PUSH(op, 5), PUSH(pr, 6), PUSH(s, 7), PUSH(v, 8), PUSH(w_callback_proc, 9), PUSH(o, 10), PUSH(counter, 11), PUSH(p_callback_proc, 12), PUSH(pp, 13), PUSH(cb, 14)));
# define XfOrM642_COUNT (15)
# define SETUP_XfOrM642(x) SETUP(XfOrM642_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  o = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  cb = NULLED_OUT ; 
  pr = NULLED_OUT ; 
  d_callback_proc = NULLED_OUT ; 
  w_callback_proc = NULLED_OUT ; 
  p_callback_proc = NULLED_OUT ; 
  op = NULLED_OUT ; 

# 3877 "./../src/print.c"
  if (for_write >= 3 ) {
    Scheme_Object * kind ; 
    BLOCK_SETUP((PUSH(kind, 0+XfOrM642_COUNT)));
#   define XfOrM643_COUNT (1+XfOrM642_COUNT)
#   define SETUP_XfOrM643(x) SETUP(XfOrM643_COUNT)
    kind = NULLED_OUT ; 

# 3879 "./../src/print.c"
    kind = FUNCCALL(SETUP_XfOrM643(_), scheme_print_attribute_ref (s ) ); 
    if (kind && ! (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (kind ) ) ) -> s ) , "always" ) ) )
      for_write = 4 ; 
  }

  v = FUNCCALL(SETUP_XfOrM642(_), scheme_is_writable_struct (s ) ); 

  o = FUNCCALL(SETUP_XfOrM642(_), scheme_make_null_output_port (pp -> print_port && ((Scheme_Output_Port * ) pp -> print_port ) -> write_special_fun ) )
  ; 

  op = (Scheme_Output_Port * ) o ; 

  cb = FUNCCALL(SETUP_XfOrM642(_), scheme_make_vector (4 , ((void * ) 0 ) ) ); 
  (((Scheme_Vector * ) (cb ) ) -> els ) [0 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (mode ) ) ) << 1 ) | 0x1 ) ) ; 
  (((Scheme_Vector * ) (cb ) ) -> els ) [1 ] = (Scheme_Object * ) ht ; 
  pr = FUNCCALL(SETUP_XfOrM642(_), scheme_make_raw_pair ((Scheme_Object * ) counter , (Scheme_Object * ) pp ) ); 
  (((Scheme_Vector * ) (cb ) ) -> els ) [2 ] = pr ; 
  (((Scheme_Vector * ) (cb ) ) -> els ) [3 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 

  d_callback_proc = (__funcarg110 = FUNCCALL(SETUP_XfOrM642(_), scheme_make_pair (cb , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) )
  , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (callback_write , __funcarg110 , "custom-display-recur-handler" , 2 , 2 ) )) 

  ; 
  w_callback_proc = (__funcarg109 = FUNCCALL(SETUP_XfOrM642(_), scheme_make_pair (cb , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (1 ) ) ) << 1 ) | 0x1 ) ) ) )
  , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (callback_write , __funcarg109 , "custom-write-recur-handler" , 2 , 2 ) )) 

  ; 
  p_callback_proc = (__funcarg108 = FUNCCALL(SETUP_XfOrM642(_), scheme_make_pair (cb , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (3 ) ) ) << 1 ) | 0x1 ) ) ) )
  , FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (callback_write , __funcarg108 , "custom-print-recur-handler" , 2 , 3 ) )) 

  ; 

  op -> display_handler = d_callback_proc ; 
  op -> write_handler = w_callback_proc ; 
  op -> print_handler = p_callback_proc ; 

  a [0 ] = s ; 
  a [1 ] = o ; 
  a [2 ] = (for_write 
  ? ((for_write >= 3 ) 
  ? ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (for_write - 3 ) ) ) << 1 ) | 0x1 ) ) 
  : scheme_true ) 
  : scheme_false ) ; 
  FUNCCALL(SETUP_XfOrM642(_), scheme_apply_multi (v , 3 , a ) )
  ; 
  FUNCCALL_AGAIN(scheme_close_output_port (o ) )
  ; 

  RET_VALUE_START ((((intptr_t ) ((((Scheme_Vector * ) (cb ) ) -> els ) [3 ] ) ) >> 1 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3930 "./../src/print.c"
static void flush_from_byte_port (Scheme_Object * orig_port , PrintParams * pp ) 
{
  char * bytes ; 
  intptr_t len ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(bytes, 0), PUSH(pp, 1)));
# define XfOrM644_COUNT (2)
# define SETUP_XfOrM644(x) SETUP(XfOrM644_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  bytes = NULLED_OUT ; 

# 3934 "./../src/print.c"
  bytes = FUNCCALL(SETUP_XfOrM644(_), scheme_get_sized_byte_string_output (orig_port , & len ) ); 
  FUNCCALL_EMPTY(print_this_string (pp , bytes , 0 , len ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3938 "./../src/print.c"
static Scheme_Object * custom_recur (int notdisplay , void * _vec , int argc , Scheme_Object * * argv ) 
{
  Scheme_Hash_Table * ht = (Scheme_Hash_Table * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [0 ] ; 
  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [1 ] ; 
  PrintParams * volatile pp = (PrintParams * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [2 ] , * sub_pp ; 
  Scheme_Object * volatile save_port ; 
  mz_jmp_buf escape , * volatile save ; 
  volatile intptr_t save_max ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(pp, 1), PUSH(sub_pp, 2), PUSH(_vec, 3), PUSH(argv, 4), PUSH(save, 5), PUSH(save_port, 6), PUSH(mt, 7)));
# define XfOrM645_COUNT (8)
# define SETUP_XfOrM645(x) SETUP(XfOrM645_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  sub_pp = NULLED_OUT ; 
  save_port = NULLED_OUT ; 
  save = NULLED_OUT ; 

# 3947 "./../src/print.c"
  if (! (scheme_is_output_port (argv [1 ] ) ) ) {
#   define XfOrM659_COUNT (0+XfOrM645_COUNT)
#   define SETUP_XfOrM659(x) SETUP_XfOrM645(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ((notdisplay > 1 ) ? "print/recursive" : (notdisplay ? "write/recursive" : "display/recursive" ) , "output-port?" , 1 , argc , argv ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if ((((Scheme_Vector * ) (_vec ) ) -> els ) [3 ] ) {
#   define XfOrM646_COUNT (0+XfOrM645_COUNT)
#   define SETUP_XfOrM646(x) SETUP_XfOrM645(x)

# 3957 "./../src/print.c"
    {
#     define XfOrM647_COUNT (0+XfOrM646_COUNT)
#     define SETUP_XfOrM647(x) SETUP_XfOrM646(x)

# 3958 "./../src/print.c"
      if (pp -> print_escape ) {
        save = pp -> print_escape ; 
        pp -> print_escape = & escape ; 
      }

# 3961 "./../src/print.c"
      else 
      save = ((void * ) 0 ) ; 

      save_port = pp -> print_port ; 
      save_max = pp -> print_maxlen ; 

      if (! pp -> print_escape 
      || ! ((escape ) . gcvs = (intptr_t ) __gc_var_stack__ , (escape ) . gcvs_cnt = XfOrM647_COUNT , (_setjmp ((escape ) . jb ) ) ) ) {

        Scheme_Object * sp ; 
        BLOCK_SETUP((PUSH(sp, 0+XfOrM647_COUNT)));
#       define XfOrM648_COUNT (1+XfOrM647_COUNT)
#       define SETUP_XfOrM648(x) SETUP(XfOrM648_COUNT)
        sp = NULLED_OUT ; 

# 3971 "./../src/print.c"
        sp = (((Scheme_Vector * ) (_vec ) ) -> els ) [4 ] ; 
        if (sp ) {
#         define XfOrM657_COUNT (0+XfOrM648_COUNT)
#         define SETUP_XfOrM657(x) SETUP_XfOrM648(x)
          FUNCCALL(SETUP_XfOrM657(_), flush_from_byte_port (sp , pp ) )
# 3973 "./../src/print.c"
          ; 
          sp = FUNCCALL(SETUP_XfOrM657(_), scheme_make_byte_string_output_port () ); 
          ((Scheme_Output_Port * ) (((Scheme_Vector * ) (_vec ) ) -> els ) [5 ] ) -> port_data = sp ; 
          (((Scheme_Vector * ) (_vec ) ) -> els ) [4 ] = sp ; 
        }



        if (! ((save_port ) == (argv [1 ] ) ) ) {
#         define XfOrM656_COUNT (0+XfOrM648_COUNT)
#         define SETUP_XfOrM656(x) SETUP_XfOrM648(x)
          FUNCCALL(SETUP_XfOrM656(_), print_this_string (pp , ((void * ) 0 ) , 0 , 0 ) )
# 3982 "./../src/print.c"
          ; 



          pp -> print_maxlen = 0 ; 
        }

        pp -> print_port = argv [1 ] ; 

        if (notdisplay > 1 ) {
#         define XfOrM655_COUNT (0+XfOrM648_COUNT)
#         define SETUP_XfOrM655(x) SETUP_XfOrM648(x)
          FUNCCALL(SETUP_XfOrM655(_), print_this_string (pp , ((void * ) 0 ) , 0 , 0 ) ); 
        }

        if (notdisplay > 1 ) {
#         define XfOrM649_COUNT (0+XfOrM648_COUNT)
#         define SETUP_XfOrM649(x) SETUP_XfOrM648(x)

# 3998 "./../src/print.c"
          if (argc > 2 ) {
            Scheme_Object * qq_depth = argv [2 ] ; 
            BLOCK_SETUP((PUSH(qq_depth, 0+XfOrM649_COUNT)));
#           define XfOrM652_COUNT (1+XfOrM649_COUNT)
#           define SETUP_XfOrM652(x) SETUP(XfOrM652_COUNT)

# 4000 "./../src/print.c"
            if (! FUNCCALL(SETUP_XfOrM652(_), scheme_nonneg_exact_p (qq_depth ) ))
              FUNCCALL_EMPTY(scheme_wrong_contract ("print/recursive" , "exact-nonnegative-integer?" , 2 , argc , argv ) ); 
            sub_pp = FUNCCALL(SETUP_XfOrM652(_), copy_print_params (pp ) ); 
            if (FUNCCALL(SETUP_XfOrM652(_), scheme_bin_gt (qq_depth , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((1 << 29 ) ) ) ) << 1 ) | 0x1 ) ) ) )) {
#             define XfOrM654_COUNT (0+XfOrM652_COUNT)
#             define SETUP_XfOrM654(x) SETUP_XfOrM652(x)

# 4004 "./../src/print.c"
              notdisplay = 3 + (1 << 29 ) ; 
              qq_depth = FUNCCALL(SETUP_XfOrM654(_), scheme_bin_minus (qq_depth , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) ((1 << 29 ) ) ) ) << 1 ) | 0x1 ) ) ) ); 
              sub_pp -> depth_delta = qq_depth ; 
            }

# 4007 "./../src/print.c"
            else {
              sub_pp -> depth_delta = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
              notdisplay = 3 + (((intptr_t ) (qq_depth ) ) >> 1 ) ; 
            }
          }

# 4011 "./../src/print.c"
          else if (pp -> depth_delta ) {
#           define XfOrM650_COUNT (0+XfOrM649_COUNT)
#           define SETUP_XfOrM650(x) SETUP_XfOrM649(x)

# 4012 "./../src/print.c"
            notdisplay = 3 ; 
            if (! ((pp -> depth_delta ) == (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ) ) ) {
#             define XfOrM651_COUNT (0+XfOrM650_COUNT)
#             define SETUP_XfOrM651(x) SETUP_XfOrM650(x)

# 4014 "./../src/print.c"
              sub_pp = FUNCCALL(SETUP_XfOrM651(_), copy_print_params (pp ) ); 
              sub_pp -> depth_delta = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (0 ) ) ) << 1 ) | 0x1 ) ) ; 
            }

# 4016 "./../src/print.c"
            else 
            sub_pp = pp ; 
          }

# 4018 "./../src/print.c"
          else 
          sub_pp = pp ; 
        }

# 4020 "./../src/print.c"
        else 
        sub_pp = pp ; 
        FUNCCALL(SETUP_XfOrM648(_), print (argv [0 ] , notdisplay , 0 , ht , mt , sub_pp ) )

        ; 
        FUNCCALL_AGAIN(print_this_string (sub_pp , ((void * ) 0 ) , 0 , 0 ) )


        ; 
      }

      pp -> print_port = save_port ; 
      pp -> print_escape = save ; 
      pp -> print_maxlen = save_max ; 
    }
  }

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4040 "./../src/print.c"
static Scheme_Object * custom_write_recur (void * _vec , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4042 "./../src/print.c"
  return custom_recur (1 , _vec , argc , argv ) ; 
}

static Scheme_Object * custom_display_recur (void * _vec , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4047 "./../src/print.c"
  return custom_recur (0 , _vec , argc , argv ) ; 
}

static Scheme_Object * custom_print_recur (void * _vec , int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 4052 "./../src/print.c"
  return custom_recur (2 , _vec , argc , argv ) ; 
}

static void custom_write_struct (Scheme_Object * s , Scheme_Hash_Table * ht , 
Scheme_Marshal_Tables * mt , 
PrintParams * orig_pp , int notdisplay ) 
{
  Scheme_Object * v , * a [3 ] , * o , * vec , * orig_port ; 
  Scheme_Output_Port * op ; 
  Scheme_Object * recur_write , * recur_display , * recur_print ; 
  PrintParams * pp ; 
  PREPARE_VAR_STACK_ONCE(16);
  BLOCK_SETUP_TOP((PUSH(ht, 0), PUSH(recur_print, 1), PUSH(orig_pp, 2), PUSHARRAY(a, 3, 3), PUSH(v, 6), PUSH(recur_display, 7), PUSH(s, 8), PUSH(pp, 9), PUSH(mt, 10), PUSH(o, 11), PUSH(orig_port, 12), PUSH(vec, 13), PUSH(op, 14), PUSH(recur_write, 15)));
# define XfOrM663_COUNT (16)
# define SETUP_XfOrM663(x) SETUP(XfOrM663_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 
  o = NULLED_OUT ; 
  vec = NULLED_OUT ; 
  orig_port = NULLED_OUT ; 
  op = NULLED_OUT ; 
  recur_write = NULLED_OUT ; 
  recur_display = NULLED_OUT ; 
  recur_print = NULLED_OUT ; 
  pp = NULLED_OUT ; 

# 4064 "./../src/print.c"
  v = FUNCCALL(SETUP_XfOrM663(_), scheme_is_writable_struct (s ) ); 


  pp = FUNCCALL_AGAIN(copy_print_params (orig_pp ) ); 

  if (pp -> print_port )
    orig_port = pp -> print_port ; 
  else 
  orig_port = FUNCCALL(SETUP_XfOrM663(_), scheme_make_byte_string_output_port () ); 

  o = FUNCCALL(SETUP_XfOrM663(_), scheme_make_redirect_output_port (orig_port ) ); 

  op = (Scheme_Output_Port * ) o ; 

  vec = FUNCCALL(SETUP_XfOrM663(_), scheme_make_vector (6 , ((void * ) 0 ) ) ); 
  (((Scheme_Vector * ) (vec ) ) -> els ) [0 ] = (Scheme_Object * ) ht ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [1 ] = (Scheme_Object * ) mt ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [2 ] = (Scheme_Object * ) pp ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = scheme_true ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [4 ] = (pp -> print_port ? ((void * ) 0 ) : orig_port ) ; 
  (((Scheme_Vector * ) (vec ) ) -> els ) [5 ] = o ; 

  recur_write = FUNCCALL(SETUP_XfOrM663(_), scheme_make_closed_prim_w_arity (custom_write_recur , vec , "custom-write-recur-handler" , 2 , 2 ) )


  ; 
  recur_display = FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (custom_display_recur , vec , "custom-display-recur-handler" , 2 , 2 ) )


  ; 
  recur_print = FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity (custom_print_recur , vec , "custom-print-recur-handler" , 2 , 3 ) )


  ; 

  op -> write_handler = recur_write ; 
  op -> display_handler = recur_display ; 
  op -> print_handler = recur_print ; 



  if (pp -> print_port )
    FUNCCALL(SETUP_XfOrM663(_), print_this_string (pp , ((void * ) 0 ) , 0 , 0 ) ); 

  a [0 ] = s ; 
  a [1 ] = o ; 
  if (notdisplay >= 3 ) {
#   define XfOrM664_COUNT (0+XfOrM663_COUNT)
#   define SETUP_XfOrM664(x) SETUP_XfOrM663(x)

# 4111 "./../src/print.c"
    a [2 ] = FUNCCALL(SETUP_XfOrM664(_), scheme_bin_plus (pp -> depth_delta , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (notdisplay - 3 ) ) ) << 1 ) | 0x1 ) ) ) ); 
  }

# 4112 "./../src/print.c"
  else 
  a [2 ] = (notdisplay ? scheme_true : scheme_false ) ; 
  FUNCCALL(SETUP_XfOrM663(_), scheme_apply_multi (v , 3 , a ) )
  ; 
  FUNCCALL_AGAIN(scheme_close_output_port (o ) )
  ; 
  (
  memcpy (orig_pp , pp , sizeof (PrintParams ) ) ) ; 

  (((Scheme_Vector * ) (vec ) ) -> els ) [3 ] = ((void * ) 0 ) ; 


  if (! orig_pp -> print_port )
    FUNCCALL(SETUP_XfOrM663(_), flush_from_byte_port ((((Scheme_Vector * ) (vec ) ) -> els ) [4 ] , orig_pp ) ); 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4128 "./../src/print.c"
static Scheme_Object * srcloc_path_to_string (Scheme_Object * p ) 
{
  Scheme_Object * base , * name , * dir_name ; 
  int isdir ; 
  Scheme_Object * __funcarg114 = NULLED_OUT ; 
  Scheme_Object * __funcarg113 = NULLED_OUT ; 
  Scheme_Object * __funcarg112 = NULLED_OUT ; 
  Scheme_Object * __funcarg111 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(name, 0), PUSH(base, 1), PUSH(dir_name, 2), PUSH(__funcarg112, 3), PUSH(p, 4)));
# define XfOrM665_COUNT (5)
# define SETUP_XfOrM665(x) SETUP(XfOrM665_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  base = NULLED_OUT ; 
  name = NULLED_OUT ; 
  dir_name = NULLED_OUT ; 

# 4133 "./../src/print.c"
  name = FUNCCALL(SETUP_XfOrM665(_), scheme_split_path ((((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (p ) ) -> u . byte_str_val . tag_val ) , & base , & isdir , scheme_unix_path_type ) ); 
  if ((((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) || ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) (base ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (base ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) ) {
#   define XfOrM667_COUNT (0+XfOrM665_COUNT)
#   define SETUP_XfOrM667(x) SETUP_XfOrM665(x)

# 4135 "./../src/print.c"
    dir_name = FUNCCALL(SETUP_XfOrM667(_), scheme_split_path ((((Scheme_Simple_Object * ) (base ) ) -> u . byte_str_val . string_val ) , (((Scheme_Simple_Object * ) (base ) ) -> u . byte_str_val . tag_val ) , & base , & isdir , scheme_unix_path_type ) ); 
    if (((base ) ) == (scheme_false ) )  {
#     define XfOrM669_COUNT (0+XfOrM667_COUNT)
#     define SETUP_XfOrM669(x) SETUP_XfOrM667(x)

# 4138 "./../src/print.c"
      RET_VALUE_START (FUNCCALL(SETUP_XfOrM669(_), scheme_path_to_char_string (p ) )) RET_VALUE_END ; 
    }
    if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) 
      name = FUNCCALL(SETUP_XfOrM667(_), scheme_path_to_char_string (name ) ); 
    else {
#     define XfOrM668_COUNT (0+XfOrM667_COUNT)
#     define SETUP_XfOrM668(x) SETUP_XfOrM667(x)

# 4144 "./../src/print.c"
      if (! (strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (name ) ) ) -> s ) , "up" ) ) )
        name = FUNCCALL(SETUP_XfOrM668(_), scheme_make_utf8_string (".." ) ); 
      else 
      name = FUNCCALL(SETUP_XfOrM668(_), scheme_make_utf8_string ("." ) ); 
    }
    if ((Scheme_Type ) (((((intptr_t ) (dir_name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (dir_name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) 
      name = (__funcarg112 = FUNCCALL(SETUP_XfOrM667(_), scheme_path_to_char_string (dir_name ) ), __funcarg113 = (__funcarg114 = FUNCCALL(SETUP_XfOrM667(_), scheme_make_utf8_string ("/" ) )
    , FUNCCALL_AGAIN(scheme_append_strings (__funcarg114 , name ) )) , FUNCCALL_AGAIN(scheme_append_strings (__funcarg112 , __funcarg113 ) )) 
    ; 
    RET_VALUE_START ((__funcarg111 = FUNCCALL(SETUP_XfOrM667(_), scheme_make_utf8_string (".../" ) ), FUNCCALL_AGAIN(scheme_append_strings (__funcarg111 , name ) )) ) RET_VALUE_END ; 
  }

# 4154 "./../src/print.c"
  else if ((Scheme_Type ) (((((intptr_t ) (name ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (name ) ) -> type ) ) == (Scheme_Type ) (scheme_unix_path_type ) ) 
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM665(_), scheme_path_to_char_string (name ) )) RET_VALUE_END ; 
  else {
#   define XfOrM666_COUNT (0+XfOrM665_COUNT)
#   define SETUP_XfOrM666(x) SETUP_XfOrM665(x)

# 4158 "./../src/print.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM666(_), scheme_path_to_char_string (p ) )) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3 "./../src/mzmark_print.inc"
static int mark_print_params_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_print_params_MARK (void * p , struct NewGC * gc ) {

  PrintParams * pp = (PrintParams * ) p ; 
  GC_mark2 (& (pp -> inspector ) , gc ) ; 
  GC_mark2 (& (pp -> print_port ) , gc ) ; 
  GC_mark2 (& (pp -> print_buffer ) , gc ) ; 
  GC_mark2 (& (pp -> depth_delta ) , gc ) ; 
  GC_mark2 (& (pp -> uq_ht ) , gc ) ; 

  return 0 ; 
}






static int mark_print_params_FIXUP (void * p , struct NewGC * gc ) {

  PrintParams * pp = (PrintParams * ) p ; 
  GC_fixup2 (& (pp -> inspector ) , gc ) ; 
  GC_fixup2 (& (pp -> print_port ) , gc ) ; 
  GC_fixup2 (& (pp -> print_buffer ) , gc ) ; 
  GC_fixup2 (& (pp -> depth_delta ) , gc ) ; 
  GC_fixup2 (& (pp -> uq_ht ) , gc ) ; 

  return 0 ; 
}

# 49 "./../src/mzmark_print.inc"
static int mark_marshal_tables_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_marshal_tables_MARK (void * p , struct NewGC * gc ) {

  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) p ; 
  GC_mark2 (& (mt -> symtab ) , gc ) ; 
  GC_mark2 (& (mt -> st_refs ) , gc ) ; 
  GC_mark2 (& (mt -> st_ref_stack ) , gc ) ; 
  GC_mark2 (& (mt -> intern_map ) , gc ) ; 
  GC_mark2 (& (mt -> key_map ) , gc ) ; 
  GC_mark2 (& (mt -> delay_map ) , gc ) ; 
  GC_mark2 (& (mt -> cdata_map ) , gc ) ; 
  GC_mark2 (& (mt -> shared_offsets ) , gc ) ; 
  GC_mark2 (& (mt -> path_cache ) , gc ) ; 
  GC_mark2 (& (mt -> sorted_keys ) , gc ) ; 

  return 0 ; 
}






static int mark_marshal_tables_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Marshal_Tables * mt = (Scheme_Marshal_Tables * ) p ; 
  GC_fixup2 (& (mt -> symtab ) , gc ) ; 
  GC_fixup2 (& (mt -> st_refs ) , gc ) ; 
  GC_fixup2 (& (mt -> st_ref_stack ) , gc ) ; 
  GC_fixup2 (& (mt -> intern_map ) , gc ) ; 
  GC_fixup2 (& (mt -> key_map ) , gc ) ; 
  GC_fixup2 (& (mt -> delay_map ) , gc ) ; 
  GC_fixup2 (& (mt -> cdata_map ) , gc ) ; 
  GC_fixup2 (& (mt -> shared_offsets ) , gc ) ; 
  GC_fixup2 (& (mt -> path_cache ) , gc ) ; 
  GC_fixup2 (& (mt -> sorted_keys ) , gc ) ; 

  return 0 ; 
}

# 4172 "./../src/print.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_rt_print_params , mark_print_params_SIZE , mark_print_params_MARK , mark_print_params_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_rt_marshal_info , mark_marshal_tables_SIZE , mark_marshal_tables_MARK , mark_marshal_tables_FIXUP , 1 , 0 ) ; 
}
