#include "precomp.h"

# 7 "./../src/struct.c"
Scheme_Object * scheme_arity_at_least ; 
Scheme_Object * scheme_date ; 
Scheme_Object * scheme_make_arity_at_least ; 
Scheme_Object * scheme_source_property ; 
Scheme_Object * scheme_input_port_property ; 
Scheme_Object * scheme_output_port_property ; 
Scheme_Object * scheme_cpointer_property ; 
Scheme_Object * scheme_equal_property ; 
Scheme_Object * scheme_no_arity_property ; 
Scheme_Object * scheme_impersonator_of_property ; 
Scheme_Object * scheme_make_struct_type_proc ; 
Scheme_Object * scheme_make_struct_field_accessor_proc ; 
Scheme_Object * scheme_make_struct_field_mutator_proc ; 
Scheme_Object * scheme_make_struct_type_property_proc ; 
Scheme_Object * scheme_struct_type_p_proc ; 
Scheme_Object * scheme_current_inspector_proc ; 
Scheme_Object * scheme_make_inspector_proc ; 
Scheme_Object * scheme_recur_symbol ; 
Scheme_Object * scheme_display_symbol ; 
Scheme_Object * scheme_write_special_symbol ; 
Scheme_Object * scheme_app_mark_impersonator_property ; 
Scheme_Object * scheme_object_name_property ; 
Scheme_Object * scheme_struct_to_vector_proc ; 
Scheme_Object * scheme_authentic_property ; 
Scheme_Object * scheme_sealed_property ; 
Scheme_Object * scheme_unsafe_poller_proc ; 

static Scheme_Object * location_struct ; 
static Scheme_Object * poller_struct ; 
static Scheme_Object * write_property ; 
static Scheme_Object * print_attribute_property ; 
static Scheme_Object * evt_property ; 
static Scheme_Object * proc_property ; 
static Scheme_Object * method_property ; 
static Scheme_Object * scheme_checked_proc_property ; 
static Scheme_Object * struct_info_proc ; 
static Scheme_Object * ellipses_symbol ; 
static Scheme_Object * prefab_symbol ; 



typedef enum {
  SCHEME_CONSTR = 1 , 
  SCHEME_PRED , 
  SCHEME_GETTER , 
  SCHEME_SETTER , 
  SCHEME_GEN_GETTER , 
  SCHEME_GEN_SETTER }
Scheme_ProcT ; 

typedef struct {
  Scheme_Object so ; 
  Scheme_Object * evt ; 
  Scheme_Object * wrapper ; 
}

# 61 "./../src/struct.c"
Wrapped_Evt ; 

typedef struct {
  Scheme_Object so ; 
  Scheme_Object * maker ; 
}

# 66 "./../src/struct.c"
Nack_Guard_Evt ; 

typedef struct {
  Scheme_Object so ; 
  int done ; 
  Syncing * syncing ; 
  Scheme_Object * wrapper ; 
  Scheme_Object * orig ; 
}

# 74 "./../src/struct.c"
Active_Replace_Evt ; 

static Scheme_Object * make_inspector (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_sibling_inspector (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * inspector_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * inspector_superior_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_inspector (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * current_code_inspector (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_struct_type_property (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_struct_type_property_from_c (int argc , Scheme_Object * argv [] , 
Scheme_Object * * predout , Scheme_Object * * accessout , 
Scheme_Type type ) ; 
static Scheme_Object * struct_type_property_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_property_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_evt_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_object_name_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_equal_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_impersonator_of_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_write_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_print_attribute_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_input_port_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_output_port_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_cpointer_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * check_checked_proc_property_value_ok (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_struct_type (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_struct_field_accessor (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_struct_field_mutator (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * nack_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * handle_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * replace_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_evt (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * handle_evt_p (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * struct_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * proc_struct_type_p (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * struct_info (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_info (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_pred (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_constr (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_sealed_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_type_authentic_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_to_vector (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * prefab_struct_key (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * make_prefab_struct (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * prefab_key_struct_type (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * is_prefab_key (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * struct_setter_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_getter_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_pred_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_constr_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_prop_getter_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * struct_prop_pred_p (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * chaperone_prop_getter_p (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_struct_proc (Scheme_Struct_Type * struct_type , char * func_name , 
Scheme_ProcT proc_type , int field_num ) ; 

static Scheme_Object * make_name (const char * pre , const char * tn , int tnl , const char * post1 , 
const char * fn , int fnl , const char * post2 , int sym ) ; 
__xform_nongcing__ static void adjust_primitive (Scheme_Object * vi , Scheme_Struct_Type * stype , int flags ) ; 

static void get_struct_type_info (int argc , Scheme_Object * argv [] , Scheme_Object * * a , int always ) ; 


static int evt_struct_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static void evt_struct_needs_wakeup (Scheme_Object * o , void * fds ) ; 
static int is_evt_struct (Scheme_Object * ) ; 

static int wrapped_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int nack_guard_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int nack_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int poll_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int replace_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int active_replace_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static void active_replace_evt_needs_wakeup (Scheme_Object * s , void * fds ) ; 

static int chaperone_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) ; 
static int is_chaperone_evt (Scheme_Object * o ) ; 

static Scheme_Object * check_arity_at_least_fields (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * check_date_fields (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * check_date_star_fields (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * check_location_fields (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * check_exn_source_property_value_ok (int argc , Scheme_Object * argv [] ) ; 
static Scheme_Object * exn_source_p (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * exn_source_get (int argc , Scheme_Object * * argv ) ; 

static Scheme_Object * procedure_extract_target (int argc , Scheme_Object * * argv ) ; 
static Scheme_Struct_Type * hash_prefab (Scheme_Struct_Type * type ) ; 

static Scheme_Object * chaperone_struct (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * impersonate_struct (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * chaperone_struct_type (int argc , Scheme_Object * * argv ) ; 
static Scheme_Object * make_chaperone_property (int argc , Scheme_Object * argv [] ) ; 

static Scheme_Object * make_chaperone_property_from_c (Scheme_Object * name ) ; 






static void register_traversers (void ) ; 


; 
static Scheme_Object * make_prefab_key (Scheme_Struct_Type * type ) ; 

# 213 "./../src/struct.c"
static char * pred_name_string (Scheme_Object * sym ) 
{
  char * __funcarg61 = NULLED_OUT ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(sym, 0)));
# define XfOrM1_COUNT (1)
# define SETUP_XfOrM1(x) SETUP(XfOrM1_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 215 "./../src/struct.c"
  RET_VALUE_START ((char * ) (__funcarg61 = FUNCCALL(SETUP_XfOrM1(_), scheme_symbol_val (sym ) ), FUNCCALL_AGAIN(make_name ("" , __funcarg61 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (sym ) ) ) -> len ) , "?" , ((void * ) 0 ) , 0 , "" , 0 ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 218 "./../src/struct.c"
void 
scheme_init_struct (Scheme_Startup_Env * env ) 
{
  Scheme_Object * * as_names ; 
  Scheme_Object * * as_values ; 
  int as_count ; 
  Scheme_Object * * ts_names ; 
  Scheme_Object * * ts_values ; 
  int ts_count ; 
  Scheme_Object * * loc_names ; 
  Scheme_Object * * loc_values ; 
  int loc_count ; 
  int i ; 
  Scheme_Object * guard , * p ; 

  static const char * arity_fields [1 ] = {

# 233 "./../src/struct.c"
    "value" }

# 233 "./../src/struct.c"
  ; 
  static const char * date_fields [10 ] = {

# 234 "./../src/struct.c"
    "second" , "minute" , "hour" , 
    "day" , "month" , "year" , 
    "week-day" , "year-day" , "dst?" , "time-zone-offset" }

# 236 "./../src/struct.c"
  ; 
  static const char * date_star_fields [2 ] = {

# 237 "./../src/struct.c"
    "nanosecond" , "time-zone-name" }

# 237 "./../src/struct.c"
  ; 
  static const char * location_fields [10 ] = {

# 238 "./../src/struct.c"
    "source" , "line" , "column" , "position" , "span" }

# 238 "./../src/struct.c"
  ; 
  Scheme_Object * __funcarg125 = NULLED_OUT ; 
  char * __funcarg124 = NULLED_OUT ; 
  Scheme_Object * __funcarg122 = NULLED_OUT ; 
  char * __funcarg121 = NULLED_OUT ; 
  Scheme_Object * __funcarg119 = NULLED_OUT ; 
  char * __funcarg118 = NULLED_OUT ; 
  Scheme_Object * __funcarg116 = NULLED_OUT ; 
  char * __funcarg115 = NULLED_OUT ; 
  Scheme_Object * __funcarg113 = NULLED_OUT ; 
  Scheme_Object * __funcarg112 = NULLED_OUT ; 
  Scheme_Object * __funcarg111 = NULLED_OUT ; 
  Scheme_Object * __funcarg110 = NULLED_OUT ; 
  Scheme_Object * __funcarg109 = NULLED_OUT ; 
  Scheme_Object * __funcarg108 = NULLED_OUT ; 
  Scheme_Object * __funcarg107 = NULLED_OUT ; 
  Scheme_Object * __funcarg106 = NULLED_OUT ; 
  Scheme_Object * __funcarg105 = NULLED_OUT ; 
  Scheme_Object * __funcarg104 = NULLED_OUT ; 
  Scheme_Object * __funcarg103 = NULLED_OUT ; 
  Scheme_Object * __funcarg102 = NULLED_OUT ; 
  Scheme_Object * __funcarg101 = NULLED_OUT ; 
  Scheme_Object * __funcarg100 = NULLED_OUT ; 
  Scheme_Object * __funcarg99 = NULLED_OUT ; 
  Scheme_Object * __funcarg98 = NULLED_OUT ; 
  Scheme_Object * __funcarg97 = NULLED_OUT ; 
  Scheme_Object * __funcarg96 = NULLED_OUT ; 
  Scheme_Object * __funcarg95 = NULLED_OUT ; 
  Scheme_Object * __funcarg94 = NULLED_OUT ; 
  Scheme_Object * __funcarg93 = NULLED_OUT ; 
  Scheme_Object * __funcarg92 = NULLED_OUT ; 
  Scheme_Object * __funcarg91 = NULLED_OUT ; 
  Scheme_Object * __funcarg90 = NULLED_OUT ; 
  Scheme_Object * __funcarg89 = NULLED_OUT ; 
  Scheme_Object * __funcarg88 = NULLED_OUT ; 
  Scheme_Object * __funcarg87 = NULLED_OUT ; 
  Scheme_Object * __funcarg86 = NULLED_OUT ; 
  Scheme_Object * __funcarg85 = NULLED_OUT ; 
  Scheme_Object * __funcarg84 = NULLED_OUT ; 
  Scheme_Object * __funcarg83 = NULLED_OUT ; 
  Scheme_Object * __funcarg82 = NULLED_OUT ; 
  Scheme_Object * __funcarg81 = NULLED_OUT ; 
  Scheme_Object * __funcarg80 = NULLED_OUT ; 
  Scheme_Object * __funcarg79 = NULLED_OUT ; 
  Scheme_Object * __funcarg78 = NULLED_OUT ; 
  Scheme_Object * __funcarg77 = NULLED_OUT ; 
  Scheme_Object * __funcarg76 = NULLED_OUT ; 
  Scheme_Object * __funcarg75 = NULLED_OUT ; 
  Scheme_Object * __funcarg74 = NULLED_OUT ; 
  Scheme_Object * __funcarg73 = NULLED_OUT ; 
  Scheme_Object * __funcarg72 = NULLED_OUT ; 
  Scheme_Object * __funcarg71 = NULLED_OUT ; 
  Scheme_Object * __funcarg70 = NULLED_OUT ; 
  Scheme_Object * __funcarg69 = NULLED_OUT ; 
  Scheme_Object * __funcarg68 = NULLED_OUT ; 
  Scheme_Object * __funcarg67 = NULLED_OUT ; 
  Scheme_Object * __funcarg66 = NULLED_OUT ; 
  Scheme_Object * __funcarg65 = NULLED_OUT ; 
  Scheme_Object * __funcarg64 = NULLED_OUT ; 
  Scheme_Object * __funcarg63 = NULLED_OUT ; 
  Scheme_Object * __funcarg62 = NULLED_OUT ; 
  PREPARE_VAR_STACK(14);
  BLOCK_SETUP_TOP((PUSH(as_values, 0), PUSH(ts_names, 1), PUSH(guard, 2), PUSH(p, 3), PUSH(loc_values, 4), PUSH(loc_names, 5), PUSH(env, 6), PUSH(ts_values, 7), PUSH(as_names, 8)));
# define XfOrM2_COUNT (9)
# define SETUP_XfOrM2(x) SETUP(XfOrM2_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  as_names = NULLED_OUT ; 
  as_values = NULLED_OUT ; 
  ts_names = NULLED_OUT ; 
  ts_values = NULLED_OUT ; 
  loc_names = NULLED_OUT ; 
  loc_values = NULLED_OUT ; 
  guard = NULLED_OUT ; 
  p = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM2(_), register_traversers () )
# 241 "./../src/struct.c"
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_arity_at_least , sizeof (scheme_arity_at_least ) ) )


  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_arity_at_least , sizeof (scheme_make_arity_at_least ) ) ); 
  scheme_arity_at_least = (__funcarg125 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (check_arity_at_least_fields , "check_arity_at_least_fields" , 0 , - 1 ) )
  , FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("arity-at-least" , ((void * ) 0 ) , 1 , ((void * ) 0 ) , __funcarg125 , 1 ) )) ; 
  as_names = FUNCCALL_AGAIN(scheme_make_struct_names_from_array ("arity-at-least" , 1 , arity_fields , (0x10 | 0x80 | 0x100 | 0x400 ) , & as_count ) )


  ; 
  as_values = FUNCCALL_AGAIN(scheme_make_struct_values (scheme_arity_at_least , as_names , as_count , (0x10 | 0x80 | 0x100 | 0x400 ) ) )
  ; 
  scheme_make_arity_at_least = as_values [1 ] ; 
  for (i = 0 ; i < as_count - 1 ; i ++ ) {
#   define XfOrM26_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM26(x) SETUP_XfOrM2(x)
    (__funcarg124 = FUNCCALL(SETUP_XfOrM26(_), scheme_symbol_val (as_names [i ] ) )
# 257 "./../src/struct.c"
    , FUNCCALL_AGAIN(scheme_addto_prim_instance (__funcarg124 , as_values [i ] , env ) )) 
    ; 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_date , sizeof (scheme_date ) ) )

  ; 
  scheme_date = (__funcarg122 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (check_date_fields , "check-date-fields" , 0 , - 1 ) )
  , FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("date" , ((void * ) 0 ) , 10 , ((void * ) 0 ) , __funcarg122 , 1 ) )) ; 

  ts_names = FUNCCALL_AGAIN(scheme_make_struct_names_from_array ("date" , 10 , date_fields , (0x10 | 0x80 | 0x100 | 0x400 ) , & ts_count ) )

  ; 

  ts_values = FUNCCALL_AGAIN(scheme_make_struct_values (scheme_date , ts_names , ts_count , (0x10 | 0x80 | 0x100 | 0x400 ) ) )
  ; 
  for (i = 0 ; i < ts_count - 1 ; i ++ ) {
#   define XfOrM24_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM24(x) SETUP_XfOrM2(x)
    (__funcarg121 = FUNCCALL(SETUP_XfOrM24(_), scheme_symbol_val (ts_names [i ] ) )
# 273 "./../src/struct.c"
    , FUNCCALL_AGAIN(scheme_addto_prim_instance (__funcarg121 , ts_values [i ] , env ) )) 
    ; 
  }

  scheme_date = (__funcarg119 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (check_date_star_fields , "check_date_star_fields" , 0 , - 1 ) )
  , FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("date*" , scheme_date , 2 , ((void * ) 0 ) , __funcarg119 , 1 ) )) ; 

  ts_names = FUNCCALL(SETUP_XfOrM2(_), scheme_make_struct_names_from_array ("date*" , 2 , date_star_fields , (0x10 | 0x80 | 0x100 | 0x400 ) , & ts_count ) )

  ; 

  ts_values = FUNCCALL_AGAIN(scheme_make_struct_values (scheme_date , ts_names , ts_count , (0x10 | 0x80 | 0x100 | 0x400 ) ) )
  ; 

  for (i = 0 ; i < ts_count - 1 ; i ++ ) {
#   define XfOrM22_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM22(x) SETUP_XfOrM2(x)
    (__funcarg118 = FUNCCALL(SETUP_XfOrM22(_), scheme_symbol_val (ts_names [i ] ) )
# 288 "./../src/struct.c"
    , FUNCCALL_AGAIN(scheme_addto_prim_instance (__funcarg118 , ts_values [i ] , env ) )) 
    ; 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & location_struct , sizeof (location_struct ) ) )


  ; 
  location_struct = (__funcarg116 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (check_location_fields , "check_location_fields" , 0 , - 1 ) )
  , FUNCCALL_AGAIN(scheme_make_struct_type_from_string ("srcloc" , ((void * ) 0 ) , 5 , ((void * ) 0 ) , __funcarg116 , 1 ) )) ; 

  loc_names = FUNCCALL_AGAIN(scheme_make_struct_names_from_array ("srcloc" , 5 , location_fields , (0x10 | 0x80 | 0x100 | 0x400 ) , & loc_count ) )

  ; 

  loc_values = FUNCCALL_AGAIN(scheme_make_struct_values (location_struct , loc_names , loc_count , (0x10 | 0x80 | 0x100 | 0x400 ) ) )
  ; 
  for (i = 0 ; i < loc_count - 1 ; i ++ ) {
#   define XfOrM20_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM20(x) SETUP_XfOrM2(x)
    (__funcarg115 = FUNCCALL(SETUP_XfOrM20(_), scheme_symbol_val (loc_names [i ] ) )
# 305 "./../src/struct.c"
    , FUNCCALL_AGAIN(scheme_addto_prim_instance (__funcarg115 , loc_values [i ] , env ) )) 
    ; 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & poller_struct , sizeof (poller_struct ) ) )

  ; 
  poller_struct = FUNCCALL(SETUP_XfOrM2(_), scheme_make_struct_type_from_string ("unsafe-poller" , ((void * ) 0 ) , 1 , ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_unsafe_poller_proc , sizeof (scheme_unsafe_poller_proc ) ) ); 
  scheme_unsafe_poller_proc = FUNCCALL_AGAIN(make_struct_proc ((Scheme_Struct_Type * ) poller_struct , "unsafe-poller" , SCHEME_CONSTR , 1 ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & write_property , sizeof (write_property ) ) )
  ; 
  {
    Scheme_Object * a [2 ] , * pred , * access ; 
    BLOCK_SETUP((PUSH(pred, 0+XfOrM2_COUNT), PUSH(access, 1+XfOrM2_COUNT), PUSHARRAY(a, 2, 2+XfOrM2_COUNT)));
#   define XfOrM18_COUNT (5+XfOrM2_COUNT)
#   define SETUP_XfOrM18(x) SETUP(XfOrM18_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    pred = NULLED_OUT ; 
    access = NULLED_OUT ; 

# 318 "./../src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM18(_), scheme_make_prim_w_arity (check_write_property_value_ok , "guard-for-prop:custom-write" , 2 , 2 ) )

    ; 

    a [0 ] = FUNCCALL(SETUP_XfOrM18(_), scheme_intern_symbol ("custom-write" ) ); 
    a [1 ] = guard ; 
    write_property = FUNCCALL(SETUP_XfOrM18(_), make_struct_type_property_from_c (2 , a , & pred , & access , scheme_struct_property_type ) )
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:custom-write" , write_property , env ) ); 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("custom-write?" , pred , env ) ); 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("custom-write-accessor" , access , env ) ); 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & print_attribute_property , sizeof (print_attribute_property ) ) )
  ; 
  {
    Scheme_Object * a [2 ] , * pred , * access ; 
    BLOCK_SETUP((PUSH(pred, 0+XfOrM2_COUNT), PUSH(access, 1+XfOrM2_COUNT), PUSHARRAY(a, 2, 2+XfOrM2_COUNT)));
#   define XfOrM17_COUNT (5+XfOrM2_COUNT)
#   define SETUP_XfOrM17(x) SETUP(XfOrM17_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    pred = NULLED_OUT ; 
    access = NULLED_OUT ; 

# 334 "./../src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM17(_), scheme_make_prim_w_arity (check_print_attribute_property_value_ok , "guard-for-prop:custom-print-quotable" , 2 , 2 ) )

    ; 

    a [0 ] = FUNCCALL(SETUP_XfOrM17(_), scheme_intern_symbol ("custom-print-quotable" ) ); 
    a [1 ] = guard ; 
    print_attribute_property = FUNCCALL(SETUP_XfOrM17(_), make_struct_type_property_from_c (2 , a , & pred , & access , scheme_struct_property_type ) )
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:custom-print-quotable" , print_attribute_property , env ) ); 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("custom-print-quotable?" , pred , env ) ); 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("custom-print-quotable-accessor" , access , env ) ); 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & evt_property , sizeof (evt_property ) ) )
  ; 
  {
#   define XfOrM16_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM16(x) SETUP_XfOrM2(x)

# 349 "./../src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM16(_), scheme_make_prim_w_arity (check_evt_property_value_ok , "guard-for-prop:evt" , 2 , 2 ) )

    ; 
    evt_property = (__funcarg113 = FUNCCALL(SETUP_XfOrM16(_), scheme_intern_symbol ("evt" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg113 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:evt" , evt_property , env ) ); 
  }

  {
#   define XfOrM15_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM15(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM15(_), scheme_register_static ((void * ) & proc_property , sizeof (proc_property ) ) )
# 358 "./../src/struct.c"
    ; 
    proc_property = (__funcarg112 = FUNCCALL(SETUP_XfOrM15(_), scheme_intern_symbol ("procedure" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg112 ) )) ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:procedure" , proc_property , env ) ); 
  }

  {
#   define XfOrM14_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM14(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM14(_), scheme_register_static ((void * ) & scheme_object_name_property , sizeof (scheme_object_name_property ) ) )
# 364 "./../src/struct.c"
    ; 
    guard = FUNCCALL(SETUP_XfOrM14(_), scheme_make_prim_w_arity (check_object_name_property_value_ok , "guard-for-prop:object-name" , 2 , 2 ) )

    ; 
    scheme_object_name_property = (__funcarg111 = FUNCCALL(SETUP_XfOrM14(_), scheme_intern_symbol ("object-name" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg111 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:object-name" , scheme_object_name_property , env ) ); 
  }

  {
#   define XfOrM13_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM13(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM13(_), scheme_register_static ((void * ) & scheme_no_arity_property , sizeof (scheme_no_arity_property ) ) )
# 374 "./../src/struct.c"
    ; 
    scheme_no_arity_property = (__funcarg110 = FUNCCALL(SETUP_XfOrM13(_), scheme_intern_symbol ("incomplete-arity" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg110 ) )) ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:incomplete-arity" , scheme_no_arity_property , env ) ); 
  }

  {
#   define XfOrM12_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM12(x) SETUP_XfOrM2(x)

# 380 "./../src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM12(_), scheme_make_prim_w_arity (check_equal_property_value_ok , "guard-for-prop:equal+hash" , 2 , 2 ) )

    ; 
    FUNCCALL(SETUP_XfOrM12(_), scheme_register_static ((void * ) & scheme_equal_property , sizeof (scheme_equal_property ) ) ); 
    scheme_equal_property = (__funcarg109 = FUNCCALL(SETUP_XfOrM12(_), scheme_intern_symbol ("equal+hash" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg109 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:equal+hash" , scheme_equal_property , env ) ); 
  }

  {
#   define XfOrM11_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM11(x) SETUP_XfOrM2(x)

# 390 "./../src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM11(_), scheme_make_prim_w_arity (check_impersonator_of_property_value_ok , "guard-for-prop:impersonator-of" , 2 , 2 ) )

    ; 
    FUNCCALL(SETUP_XfOrM11(_), scheme_register_static ((void * ) & scheme_impersonator_of_property , sizeof (scheme_impersonator_of_property ) ) ); 
    scheme_impersonator_of_property = (__funcarg108 = FUNCCALL(SETUP_XfOrM11(_), scheme_intern_symbol ("impersonator-of" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg108 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:impersonator-of" , scheme_impersonator_of_property , env ) ); 
  }

  {
#   define XfOrM10_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM10(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM10(_), scheme_register_static ((void * ) & scheme_input_port_property , sizeof (scheme_input_port_property ) ) )
# 400 "./../src/struct.c"
    ; 
    FUNCCALL(SETUP_XfOrM10(_), scheme_register_static ((void * ) & scheme_output_port_property , sizeof (scheme_output_port_property ) ) ); 

    guard = FUNCCALL_AGAIN(scheme_make_prim_w_arity (check_input_port_property_value_ok , "guard-for-prop:input-port" , 2 , 2 ) )

    ; 
    scheme_input_port_property = (__funcarg107 = FUNCCALL(SETUP_XfOrM10(_), scheme_intern_symbol ("input-port" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg107 , guard ) )) 
    ; 

    guard = FUNCCALL_AGAIN(scheme_make_prim_w_arity (check_output_port_property_value_ok , "guard-for-prop:output-port" , 2 , 2 ) )

    ; 
    scheme_output_port_property = (__funcarg106 = FUNCCALL(SETUP_XfOrM10(_), scheme_intern_symbol ("output-port" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg106 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:input-port" , scheme_input_port_property , env ) )
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:output-port" , scheme_output_port_property , env ) ); 
  }

  {
#   define XfOrM9_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM9(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM9(_), scheme_register_static ((void * ) & scheme_cpointer_property , sizeof (scheme_cpointer_property ) ) )
# 420 "./../src/struct.c"
    ; 

    guard = FUNCCALL(SETUP_XfOrM9(_), scheme_make_prim_w_arity (check_cpointer_property_value_ok , "guard-for-prop:cpointer" , 2 , 2 ) )

    ; 
    scheme_cpointer_property = (__funcarg105 = FUNCCALL(SETUP_XfOrM9(_), scheme_intern_symbol ("cpointer" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg105 , guard ) )) 
    ; 
  }

  {
#   define XfOrM8_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM8(x) SETUP_XfOrM2(x)

# 430 "./../src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM8(_), scheme_make_prim_w_arity (check_checked_proc_property_value_ok , "guard-for-prop:checked-procedure" , 2 , 2 ) )

    ; 
    FUNCCALL(SETUP_XfOrM8(_), scheme_register_static ((void * ) & scheme_checked_proc_property , sizeof (scheme_checked_proc_property ) ) ); 
    scheme_checked_proc_property = (__funcarg104 = FUNCCALL(SETUP_XfOrM8(_), scheme_intern_symbol ("checked-procedure" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg104 , guard ) )) 
    ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:checked-procedure" , scheme_checked_proc_property , env ) ); 
  }

  {
#   define XfOrM7_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM7(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM7(_), scheme_register_static ((void * ) & method_property , sizeof (method_property ) ) )
# 440 "./../src/struct.c"
    ; 
    method_property = (__funcarg103 = FUNCCALL(SETUP_XfOrM7(_), scheme_intern_symbol ("method-arity-error" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg103 ) )) ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:method-arity-error" , method_property , env ) ); 
  }

  {
#   define XfOrM6_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM6(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM6(_), scheme_register_static ((void * ) & scheme_authentic_property , sizeof (scheme_authentic_property ) ) )
# 446 "./../src/struct.c"
    ; 
    scheme_authentic_property = (__funcarg102 = FUNCCALL(SETUP_XfOrM6(_), scheme_intern_symbol ("authentic" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg102 ) )) ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:authentic" , scheme_authentic_property , env ) ); 
  }

  {
#   define XfOrM5_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM5(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM5(_), scheme_register_static ((void * ) & scheme_sealed_property , sizeof (scheme_sealed_property ) ) )
# 452 "./../src/struct.c"
    ; 
    scheme_sealed_property = (__funcarg101 = FUNCCALL(SETUP_XfOrM5(_), scheme_intern_symbol ("sealed" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property (__funcarg101 ) )) ; 
    FUNCCALL_AGAIN(scheme_addto_prim_instance ("prop:sealed" , scheme_sealed_property , env ) ); 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_recur_symbol , sizeof (scheme_recur_symbol ) ) )
  ; 
  FUNCCALL(SETUP_XfOrM2(_), scheme_register_static ((void * ) & scheme_display_symbol , sizeof (scheme_display_symbol ) ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_write_special_symbol , sizeof (scheme_write_special_symbol ) ) ); 
  scheme_recur_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("recur" ) ); 
  scheme_display_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("display" ) ); 
  scheme_write_special_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("write-special" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_struct_type_proc , sizeof (scheme_make_struct_type_proc ) ) )


  ; 
  scheme_make_struct_type_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (make_struct_type , 1 , "make-struct-type" , 4 , 11 , 0 , 5 , 5 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-struct-type" , scheme_make_struct_type_proc , env ) )


  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_struct_type_property_proc , sizeof (scheme_make_struct_type_property_proc ) ) )
  ; 
  scheme_make_struct_type_property_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (make_struct_type_property , 1 , "make-struct-type-property" , 1 , 4 , 0 , 3 , 3 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-struct-type-property" , scheme_make_struct_type_property_proc , env ) )

  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_struct_field_accessor_proc , sizeof (scheme_make_struct_field_accessor_proc ) ) )
  ; 
  scheme_make_struct_field_accessor_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (make_struct_field_accessor , "make-struct-field-accessor" , 2 , 3 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-struct-field-accessor" , scheme_make_struct_field_accessor_proc , env ) )

  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_struct_field_mutator_proc , sizeof (scheme_make_struct_field_mutator_proc ) ) )
  ; 
  scheme_make_struct_field_mutator_proc = FUNCCALL_AGAIN(scheme_make_prim_w_arity (make_struct_field_mutator , "make-struct-field-mutator" , 2 , 3 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-struct-field-mutator" , scheme_make_struct_field_mutator_proc , env ) )

  ; 
  (__funcarg100 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (scheme_wrap_evt , "wrap-evt" , 2 , 2 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("wrap-evt" , __funcarg100 , env ) )) 
  ; 
  (__funcarg99 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (handle_evt , "handle-evt" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("handle-evt" , __funcarg99 , env ) )) 
  ; 
  (__funcarg98 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (replace_evt , "replace-evt" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("replace-evt" , __funcarg98 , env ) )) 
  ; 
  (__funcarg97 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_evt , "chaperone-evt" , 2 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-evt" , __funcarg97 , env ) )) 
  ; 
  (__funcarg96 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (nack_evt , "nack-guard-evt" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("nack-guard-evt" , __funcarg96 , env ) )) 
  ; 
  (__funcarg95 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (scheme_poll_evt , "poll-guard-evt" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("poll-guard-evt" , __funcarg95 , env ) )) 
  ; 
  (__funcarg94 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (handle_evt_p , "handle-evt?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("handle-evt?" , __funcarg94 , env ) )) 
  ; 
  (__funcarg93 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (struct_p , "struct?" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct?" , __funcarg93 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_struct_type_p_proc , sizeof (scheme_struct_type_p_proc ) ) )
  ; 
  scheme_struct_type_p_proc = FUNCCALL_AGAIN(scheme_make_folding_prim (struct_type_p , "struct-type?" , 1 , 1 , 1 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type?" , scheme_struct_type_p_proc , env ) ); 
  (__funcarg92 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (struct_type_property_p , "struct-type-property?" , 1 , 1 , 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-property?" , __funcarg92 , env ) )) 
  ; 
  (__funcarg91 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (proc_struct_type_p , "procedure-struct-type?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-struct-type?" , __funcarg91 , env ) )) 
  ; 
  (__funcarg90 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (procedure_extract_target , "procedure-extract-target" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("procedure-extract-target" , __funcarg90 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & struct_info_proc , sizeof (struct_info_proc ) ) )


  ; 
  struct_info_proc = FUNCCALL_AGAIN(scheme_make_prim_w_everything (struct_info , 1 , "struct-info" , 1 , 1 , 0 , 2 , 2 ) )


  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-info" , struct_info_proc , env ) ); 
  (__funcarg89 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (struct_type_info , 1 , "struct-type-info" , 1 , 1 , 0 , 8 , 8 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-info" , __funcarg89 , env ) )) 
  ; 
  (__funcarg88 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (struct_type_pred , "struct-type-make-predicate" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-make-predicate" , __funcarg88 , env ) )) 
  ; 
  (__funcarg87 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (struct_type_constr , "struct-type-make-constructor" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-make-constructor" , __funcarg87 , env ) )) 
  ; 
  (__funcarg86 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (struct_type_sealed_p , "struct-type-sealed?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-sealed?" , __funcarg86 , env ) )) 
  ; 
  (__funcarg85 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (struct_type_authentic_p , "struct-type-authentic?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-authentic?" , __funcarg85 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_struct_to_vector_proc , sizeof (scheme_struct_to_vector_proc ) ) )
  ; 
  scheme_struct_to_vector_proc = FUNCCALL_AGAIN(scheme_make_noncm_prim (struct_to_vector , "struct->vector" , 1 , 2 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct->vector" , scheme_struct_to_vector_proc , env ) ); 

  p = FUNCCALL_AGAIN(scheme_make_immed_prim (prefab_struct_key , "prefab-struct-key" , 1 , 1 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 0 ) ) ); 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("prefab-struct-key" , p , env ) ); 
  (__funcarg84 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (make_prefab_struct , "make-prefab-struct" , 1 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-prefab-struct" , __funcarg84 , env ) )) 
  ; 
  (__funcarg83 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (prefab_key_struct_type , "prefab-key->struct-type" , 2 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("prefab-key->struct-type" , __funcarg83 , env ) )) 
  ; 
  (__funcarg82 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (is_prefab_key , "prefab-key?" , 1 , 1 , 1 ) )

  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("prefab-key?" , __funcarg82 , env ) )) 
  ; 
  (__funcarg81 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_setter_p , "struct-mutator-procedure?" , 1 , 1 ) )





  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-mutator-procedure?" , __funcarg81 , env ) )) 
  ; 
  (__funcarg80 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_getter_p , "struct-accessor-procedure?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-accessor-procedure?" , __funcarg80 , env ) )) 
  ; 
  (__funcarg79 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_pred_p , "struct-predicate-procedure?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-predicate-procedure?" , __funcarg79 , env ) )) 
  ; 
  (__funcarg78 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_constr_p , "struct-constructor-procedure?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-constructor-procedure?" , __funcarg78 , env ) )) 
  ; 
  (__funcarg77 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_prop_getter_p , "struct-type-property-accessor-procedure?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-property-accessor-procedure?" , __funcarg77 , env ) )) 
  ; 
  (__funcarg76 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (struct_prop_pred_p , "struct-type-property-predicate-procedure?" , 1 , 2 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("struct-type-property-predicate-procedure?" , __funcarg76 , env ) )) 
  ; 
  (__funcarg75 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (chaperone_prop_getter_p , "impersonator-property-accessor-procedure?" , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonator-property-accessor-procedure?" , __funcarg75 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_make_inspector_proc , sizeof (scheme_make_inspector_proc ) ) )


  ; 
  scheme_make_inspector_proc = FUNCCALL_AGAIN(scheme_make_immed_prim (make_inspector , "make-inspector" , 0 , 1 ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-inspector" , scheme_make_inspector_proc , env ) ); 
  (__funcarg74 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_immed_prim (make_sibling_inspector , "make-sibling-inspector" , 0 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-sibling-inspector" , __funcarg74 , env ) )) 
  ; 
  (__funcarg73 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (inspector_p , "inspector?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("inspector?" , __funcarg73 , env ) )) 
  ; 
  (__funcarg72 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (inspector_superior_p , "inspector-superior?" , 2 , 2 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("inspector-superior?" , __funcarg72 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_current_inspector_proc , sizeof (scheme_current_inspector_proc ) ) )
  ; 
  scheme_current_inspector_proc = FUNCCALL_AGAIN(scheme_register_parameter (current_inspector , "current-inspector" , MZCONFIG_INSPECTOR ) )

  ; 
  FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-inspector" , scheme_current_inspector_proc , env ) )

  ; 
  (__funcarg71 = FUNCCALL(SETUP_XfOrM2(_), scheme_register_parameter (current_code_inspector , "current-code-inspector" , MZCONFIG_CODE_INSPECTOR ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("current-code-inspector" , __funcarg71 , env ) )) 
  ; 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & ellipses_symbol , sizeof (ellipses_symbol ) ) )
  ; 
  ellipses_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("..." ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & prefab_symbol , sizeof (prefab_symbol ) ) )
  ; 
  prefab_symbol = FUNCCALL_AGAIN(scheme_intern_symbol ("prefab" ) ); 
  FUNCCALL_AGAIN(scheme_register_static ((void * ) & scheme_source_property , sizeof (scheme_source_property ) ) )

  ; 
  {
#   define XfOrM4_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM4(x) SETUP_XfOrM2(x)

# 710 "./../src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM4(_), scheme_make_prim_w_arity (check_exn_source_property_value_ok , "guard-for-prop:exn:srclocs" , 2 , 2 ) )

    ; 
    scheme_source_property = (__funcarg70 = FUNCCALL(SETUP_XfOrM4(_), scheme_intern_symbol ("prop:exn:srclocs" ) ), FUNCCALL_AGAIN(scheme_make_struct_type_property_w_guard (__funcarg70 , guard ) )) 
    ; 
  }
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("prop:exn:srclocs" , scheme_source_property , env ) ); 
  (__funcarg69 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (exn_source_p , "exn:srclocs?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("exn:srclocs?" , __funcarg69 , env ) )) 
  ; 
  (__funcarg68 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (exn_source_get , "exn:srclocs-accessor" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("exn:srclocs-accessor" , __funcarg68 , env ) )) 
  ; 

  p = FUNCCALL_AGAIN(scheme_make_prim_w_arity (scheme_extract_checked_procedure , "checked-procedure-check-and-extract" , 5 , 5 ) )

  ; 
  (((Scheme_Prim_Proc_Header * ) p ) -> flags ) |= FUNCCALL(SETUP_XfOrM2(_), scheme_intern_prim_opt_flags ((1 << 2 ) ) ); 
  FUNCCALL(SETUP_XfOrM2(_), scheme_addto_prim_instance ("checked-procedure-check-and-extract" , p , env ) ); 
  (__funcarg67 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_struct , "chaperone-struct" , 1 , - 1 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-struct" , __funcarg67 , env ) )) 
  ; 
  (__funcarg66 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (impersonate_struct , "impersonate-struct" , 1 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonate-struct" , __funcarg66 , env ) )) 
  ; 
  (__funcarg65 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_arity (chaperone_struct_type , "chaperone-struct-type" , 4 , - 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("chaperone-struct-type" , __funcarg65 , env ) )) 
  ; 
  (__funcarg64 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_prim_w_everything (make_chaperone_property , 1 , "make-impersonator-property" , 1 , 1 , 0 , 3 , 3 ) )



  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("make-impersonator-property" , __funcarg64 , env ) )) 
  ; 
  (__funcarg63 = FUNCCALL(SETUP_XfOrM2(_), scheme_make_folding_prim (chaperone_property_p , "impersonator-property?" , 1 , 1 , 1 ) )


  , FUNCCALL_AGAIN(scheme_addto_prim_instance ("impersonator-property?" , __funcarg63 , env ) )) 
  ; 

  {
#   define XfOrM3_COUNT (0+XfOrM2_COUNT)
#   define SETUP_XfOrM3(x) SETUP_XfOrM2(x)
    FUNCCALL(SETUP_XfOrM3(_), scheme_register_static ((void * ) & scheme_app_mark_impersonator_property , sizeof (scheme_app_mark_impersonator_property ) ) )
# 762 "./../src/struct.c"
    ; 
    scheme_app_mark_impersonator_property = (__funcarg62 = FUNCCALL(SETUP_XfOrM3(_), scheme_intern_symbol ("application-mark" ) ), FUNCCALL_AGAIN(make_chaperone_property_from_c (__funcarg62 ) )) ; 
    FUNCCALL_EMPTY(scheme_addto_prim_instance ("impersonator-prop:application-mark" , scheme_app_mark_impersonator_property , env ) )

    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 770 "./../src/struct.c"
void scheme_init_struct_wait () 
{
  /* No conversion */

# 772 "./../src/struct.c"
  scheme_add_evt (scheme_structure_type , 
  (Scheme_Ready_Fun ) evt_struct_is_ready , 
  (Scheme_Needs_Wakeup_Fun ) evt_struct_needs_wakeup , 
  is_evt_struct , 1 ) ; 
  scheme_add_evt (scheme_proc_struct_type , 
  (Scheme_Ready_Fun ) evt_struct_is_ready , 
  ((void * ) 0 ) , 
  is_evt_struct , 1 ) ; 

  scheme_add_evt (scheme_wrap_evt_type , 
  (Scheme_Ready_Fun ) wrapped_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_handle_evt_type , 
  (Scheme_Ready_Fun ) wrapped_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_replace_evt_type , 
  (Scheme_Ready_Fun ) replace_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_active_replace_evt_type , 
  (Scheme_Ready_Fun ) active_replace_evt_is_ready , 
  active_replace_evt_needs_wakeup , 
  ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_chaperone_type , 
  (Scheme_Ready_Fun ) chaperone_evt_is_ready , 
  ((void * ) 0 ) , 
  is_chaperone_evt , 1 ) ; 
  scheme_add_evt (scheme_proc_chaperone_type , 
  (Scheme_Ready_Fun ) chaperone_evt_is_ready , 
  ((void * ) 0 ) , 
  is_chaperone_evt , 1 ) ; 
  scheme_add_evt (scheme_nack_guard_evt_type , 
  (Scheme_Ready_Fun ) nack_guard_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_nack_evt_type , 
  (Scheme_Ready_Fun ) nack_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
  scheme_add_evt (scheme_poll_evt_type , 
  (Scheme_Ready_Fun ) poll_evt_is_ready , 
  ((void * ) 0 ) , ((void * ) 0 ) , 1 ) ; 
}

# 824 "./../src/struct.c"
Scheme_Object * scheme_make_initial_inspectors (void ) 
{
  Scheme_Inspector * superior , * root ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(root, 0), PUSH(superior, 1)));
# define XfOrM28_COUNT (2)
# define SETUP_XfOrM28(x) SETUP(XfOrM28_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  superior = NULLED_OUT ; 
  root = NULLED_OUT ; 

# 828 "./../src/struct.c"
  superior = ((Scheme_Inspector * ) FUNCCALL(SETUP_XfOrM28(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Inspector ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  superior -> so . type = scheme_inspector_type ; 
  superior -> depth = 0 ; 

  root = ((Scheme_Inspector * ) FUNCCALL(SETUP_XfOrM28(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Inspector ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  root -> so . type = scheme_inspector_type ; 
  root -> depth = 1 ; 
  root -> superior = superior ; 

  RET_VALUE_START ((Scheme_Object * ) root ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 840 "./../src/struct.c"
Scheme_Object * scheme_make_inspector (Scheme_Object * superior ) 
{
  Scheme_Inspector * naya ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(naya, 0), PUSH(superior, 1)));
# define XfOrM29_COUNT (2)
# define SETUP_XfOrM29(x) SETUP(XfOrM29_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  naya = NULLED_OUT ; 

# 844 "./../src/struct.c"
  naya = ((Scheme_Inspector * ) FUNCCALL(SETUP_XfOrM29(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Inspector ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  naya -> so . type = scheme_inspector_type ; 
  naya -> depth = ((Scheme_Inspector * ) superior ) -> depth + 1 ; 
  naya -> superior = (Scheme_Inspector * ) superior ; 

  RET_VALUE_START ((Scheme_Object * ) naya ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 852 "./../src/struct.c"
static Scheme_Object * make_inspector (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * superior ; 
  Scheme_Config * __funcarg126 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(superior, 0)));
# define XfOrM30_COUNT (1)
# define SETUP_XfOrM30(x) SETUP(XfOrM30_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  superior = NULLED_OUT ; 

# 856 "./../src/struct.c"
  if (argc ) {
#   define XfOrM31_COUNT (0+XfOrM30_COUNT)
#   define SETUP_XfOrM31(x) SETUP_XfOrM30(x)

# 857 "./../src/struct.c"
    superior = argv [0 ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (superior ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (superior ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-inspector" , "inspector?" , 0 , argc , argv ) ); 
  }

# 860 "./../src/struct.c"
  else 
  superior = (__funcarg126 = FUNCCALL(SETUP_XfOrM30(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg126 , MZCONFIG_INSPECTOR ) )) ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_inspector (superior ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 866 "./../src/struct.c"
static Scheme_Object * make_sibling_inspector (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * superior ; 
  Scheme_Config * __funcarg127 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(superior, 0)));
# define XfOrM32_COUNT (1)
# define SETUP_XfOrM32(x) SETUP(XfOrM32_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  superior = NULLED_OUT ; 

# 870 "./../src/struct.c"
  if (argc ) {
#   define XfOrM33_COUNT (0+XfOrM32_COUNT)
#   define SETUP_XfOrM33(x) SETUP_XfOrM32(x)

# 871 "./../src/struct.c"
    superior = argv [0 ] ; 
    if (! ((Scheme_Type ) (((((intptr_t ) (superior ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (superior ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) )
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-sibling-inspector" , "inspector?" , 0 , argc , argv ) ); 
  }

# 874 "./../src/struct.c"
  else 
  superior = (__funcarg127 = FUNCCALL(SETUP_XfOrM32(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg127 , MZCONFIG_INSPECTOR ) )) ; 

  superior = (Scheme_Object * ) ((Scheme_Inspector * ) superior ) -> superior ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_inspector (superior ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 882 "./../src/struct.c"
static Scheme_Object * inspector_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 884 "./../src/struct.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * inspector_superior_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 891 "./../src/struct.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) )
    scheme_wrong_contract ("inspector-superior?" , "inspector?" , 0 , argc , argv ) ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) )
    scheme_wrong_contract ("inspector-superior?" , "inspector?" , 1 , argc , argv ) ; 

  return ((! ((argv [1 ] ) == (argv [0 ] ) ) && scheme_is_subinspector (argv [1 ] , argv [0 ] ) ) 
  ? scheme_true 
  : scheme_false ) ; 
}

int scheme_is_subinspector (Scheme_Object * i , Scheme_Object * sup ) 
{
  /* No conversion */

# 903 "./../src/struct.c"
  Scheme_Inspector * ins , * superior ; 

  if (((i ) ) == (scheme_false ) ) 
    return 1 ; 
  if (((sup ) ) == (scheme_false ) ) 
    return 0 ; 

  ins = (Scheme_Inspector * ) i ; 
  superior = (Scheme_Inspector * ) sup ; 

  while (ins -> depth > superior -> depth ) {
    if (ins -> superior == superior )
      return 1 ; 
    ins = ins -> superior ; 
  }

  return 0 ; 
}

static Scheme_Object * current_inspector (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 924 "./../src/struct.c"
  return scheme_param_config ("current-inspector" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_INSPECTOR ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , inspector_p , "inspector" , 0 ) ; 
}

static Scheme_Object * current_code_inspector (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 932 "./../src/struct.c"
  return scheme_param_config ("current-code-inspector" , 
  ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (MZCONFIG_CODE_INSPECTOR ) ) ) << 1 ) | 0x1 ) ) , 
  argc , argv , 
  - 1 , inspector_p , "inspector" , 0 ) ; 
}





Scheme_Object * scheme_chaperone_props_get (Scheme_Object * props , Scheme_Object * prop ) 
{
  /* No conversion */

# 944 "./../src/struct.c"
  if (! props )
    return ((void * ) 0 ) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
    int i ; 
    for (i = (((Scheme_Vector * ) (props ) ) -> size ) ; i > 0 ; ) {
      i -= 2 ; 
      if (((((Scheme_Vector * ) (props ) ) -> els ) [i ] ) == (prop ) ) 
        return (((Scheme_Vector * ) (props ) ) -> els ) [i + 1 ] ; 
    }
    return ((void * ) 0 ) ; 
  }

# 954 "./../src/struct.c"
  else 
  return (Scheme_Object * ) scheme_hash_tree_get ((Scheme_Hash_Tree * ) props , prop ) ; 
}

Scheme_Object * scheme_chaperone_props_remove (Scheme_Object * props , Scheme_Object * prop ) 

{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(prop, 0), PUSH(props, 1)));
# define XfOrM45_COUNT (2)
# define SETUP_XfOrM45(x) SETUP(XfOrM45_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 961 "./../src/struct.c"
  if ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
    Scheme_Object * vec ; 
    int i , j ; 
    BLOCK_SETUP((PUSH(vec, 0+XfOrM45_COUNT)));
#   define XfOrM46_COUNT (1+XfOrM45_COUNT)
#   define SETUP_XfOrM46(x) SETUP(XfOrM46_COUNT)
    vec = NULLED_OUT ; 

# 964 "./../src/struct.c"
    j = (((Scheme_Vector * ) (props ) ) -> size ) ; 
    if (j == 2 )

# 965 "./../src/struct.c"
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    vec = FUNCCALL(SETUP_XfOrM46(_), scheme_make_vector (j - 2 , ((void * ) 0 ) ) ); 
    for (i = (((Scheme_Vector * ) (props ) ) -> size ) , j = 0 ; i > 0 ; ) {
      i -= 2 ; 
      if (! (((((Scheme_Vector * ) (props ) ) -> els ) [i ] ) == (prop ) ) ) {
        (((Scheme_Vector * ) (vec ) ) -> els ) [j ++ ] = (((Scheme_Vector * ) (props ) ) -> els ) [i ] ; 
        (((Scheme_Vector * ) (vec ) ) -> els ) [j ++ ] = (((Scheme_Vector * ) (props ) ) -> els ) [i + 1 ] ; 
      }
    }
    RET_VALUE_START (vec ) RET_VALUE_END ; 
  }

# 975 "./../src/struct.c"
  else 
  RET_VALUE_START ((Scheme_Object * ) FUNCCALL_EMPTY(scheme_hash_tree_set ((Scheme_Hash_Tree * ) props , prop , ((void * ) 0 ) ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 979 "./../src/struct.c"
static Scheme_Object * prop_pred (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  Scheme_Struct_Type * stype ; 
  Scheme_Object * prop = ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] , * v ; 
  Scheme_Chaperone * px ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(prop, 1), PUSH(v, 2), PUSH(px, 3)));
# define XfOrM51_COUNT (4)
# define SETUP_XfOrM51(x) SETUP(XfOrM51_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  v = NULLED_OUT ; 
  px = NULLED_OUT ; 

# 985 "./../src/struct.c"
  v = args [0 ] ; 

  while (1 ) {
#   define XfOrM60_COUNT (0+XfOrM51_COUNT)
#   define SETUP_XfOrM60(x) SETUP_XfOrM51(x)

# 988 "./../src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
#     define XfOrM63_COUNT (0+XfOrM60_COUNT)
#     define SETUP_XfOrM63(x) SETUP_XfOrM60(x)

# 990 "./../src/struct.c"
      px = (Scheme_Chaperone * ) v ; 
      v = FUNCCALL(SETUP_XfOrM63(_), scheme_chaperone_props_get (px -> props , prop ) ); 
      if (v )
        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
      v = px -> val ; 
    }

    if ((Scheme_Type ) (((((intptr_t ) (prop ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prop ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) )  {


      Scheme_Object * procs ; 
#     define XfOrM61_COUNT (0+XfOrM60_COUNT)
#     define SETUP_XfOrM61(x) SETUP_XfOrM60(x)
      procs = NULLED_OUT ; 

# 1001 "./../src/struct.c"
      procs = (scheme_struct_type_property_ref (scheme_impersonator_of_property , v ) ) ; 
      if (procs ) {
#       define XfOrM62_COUNT (0+XfOrM61_COUNT)
#       define SETUP_XfOrM62(x) SETUP_XfOrM61(x)

# 1003 "./../src/struct.c"
        v = FUNCCALL(SETUP_XfOrM62(_), scheme_apply_impersonator_of (0 , procs , v ) ); 
        if (! v )
          RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
      }

# 1006 "./../src/struct.c"
      else 
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
    }

# 1008 "./../src/struct.c"
    else 
    break ; 
  }

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
    stype = ((Scheme_Structure * ) v ) -> stype ; 
  else if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) 
    stype = (Scheme_Struct_Type * ) v ; 
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

  if (stype -> num_props < 0 ) {
#   define XfOrM55_COUNT (0+XfOrM51_COUNT)
#   define SETUP_XfOrM55(x) SETUP_XfOrM51(x)

# 1020 "./../src/struct.c"
    if (FUNCCALL(SETUP_XfOrM55(_), scheme_hash_get ((Scheme_Hash_Table * ) stype -> props , prop ) ))
      RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
  }

# 1022 "./../src/struct.c"
  else {
    int i ; 
    for (i = stype -> num_props ; i -- ; ) {
      if (((((Scheme_Simple_Object * ) (stype -> props [i ] ) ) -> u . pair_val . car ) ) == (prop ) ) 
        RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1033 "./../src/struct.c"
__xform_nongcing__ static Scheme_Object * do_prop_accessor (Scheme_Object * prop , Scheme_Object * arg ) 
{
  /* No conversion */

# 1035 "./../src/struct.c"
  Scheme_Struct_Type * stype ; 

  if (((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
    stype = ((Scheme_Structure * ) arg ) -> stype ; 
  else if ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) 
    stype = (Scheme_Struct_Type * ) arg ; 
  else 
  stype = ((void * ) 0 ) ; 

  if (stype ) {
    if (stype -> num_props < 0 ) {
      Scheme_Object * v ; 
      v = (Scheme_Object * ) scheme_eq_hash_get ((Scheme_Hash_Table * ) stype -> props , prop ) ; 
      if (v )
        return v ; 
    }

# 1050 "./../src/struct.c"
    else {
      int i ; 
      for (i = stype -> num_props ; i -- ; ) {
        if (((((Scheme_Simple_Object * ) (stype -> props [i ] ) ) -> u . pair_val . car ) ) == (prop ) ) 
          return (((Scheme_Simple_Object * ) (stype -> props [i ] ) ) -> u . pair_val . cdr ) ; 
      }
    }
  }

  return ((void * ) 0 ) ; 
}

static Scheme_Object * do_chaperone_prop_accessor (const char * who , Scheme_Object * prop , 
Scheme_Object * orig_arg , Scheme_Object * arg ) ; 

static Scheme_Object * chaperone_prop_acc_k (void ) 
{
  /* No conversion */

# 1067 "./../src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * arg = (Scheme_Object * ) p -> ku . k . p2 ; 
  const char * who = (const char * ) p -> ku . k . p3 ; 
  Scheme_Object * orig_arg = (Scheme_Object * ) p -> ku . k . p4 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 

  return do_chaperone_prop_accessor (who , o , orig_arg , arg ) ; 
}

static Scheme_Object * chaperone_prop_acc_overflow (const char * who , Scheme_Object * o , 
Scheme_Object * orig_arg , Scheme_Object * arg ) 
{
  /* No conversion */

# 1084 "./../src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = (void * ) o ; 
  p -> ku . k . p2 = (void * ) arg ; 
  p -> ku . k . p3 = (void * ) who ; 
  p -> ku . k . p4 = (void * ) orig_arg ; 

  return scheme_handle_stack_overflow (chaperone_prop_acc_k ) ; 
}

static Scheme_Object * do_chaperone_prop_accessor (const char * who , Scheme_Object * prop , 
Scheme_Object * orig_arg , Scheme_Object * arg ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(prop, 0), PUSH(arg, 1), PUSH(orig_arg, 2), PUSH(who, 3)));
# define XfOrM72_COUNT (4)
# define SETUP_XfOrM72(x) SETUP(XfOrM72_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1097 "./../src/struct.c"
  while (1 ) {
#   define XfOrM85_COUNT (0+XfOrM72_COUNT)
#   define SETUP_XfOrM85(x) SETUP_XfOrM72(x)

# 1098 "./../src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (arg ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (arg ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
      Scheme_Chaperone * px = (Scheme_Chaperone * ) arg ; 
      Scheme_Object * a [2 ] , * red , * orig ; 
      Scheme_Object * v ; 
      Scheme_Hash_Tree * ht ; 
      BLOCK_SETUP((PUSH(red, 0+XfOrM85_COUNT), PUSH(ht, 1+XfOrM85_COUNT), PUSH(orig, 2+XfOrM85_COUNT), PUSHARRAY(a, 2, 3+XfOrM85_COUNT), PUSH(px, 6+XfOrM85_COUNT), PUSH(v, 7+XfOrM85_COUNT)));
#     define XfOrM91_COUNT (8+XfOrM85_COUNT)
#     define SETUP_XfOrM91(x) SETUP(XfOrM91_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      red = NULLED_OUT ; 
      orig = NULLED_OUT ; 
      v = NULLED_OUT ; 
      ht = NULLED_OUT ; 

# 1104 "./../src/struct.c"
      v = FUNCCALL(SETUP_XfOrM91(_), scheme_chaperone_props_get (px -> props , prop ) ); 
      if (v )
        RET_VALUE_START (v ) RET_VALUE_END ; 

      if (! (((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) ) 
      || ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ) ) == (scheme_false ) ) )
        arg = px -> prev ; 
      else {
#       define XfOrM92_COUNT (0+XfOrM91_COUNT)
#       define SETUP_XfOrM92(x) SETUP_XfOrM91(x)

# 1112 "./../src/struct.c"
        ht = (Scheme_Hash_Tree * ) (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ; 
        if (ht )
          red = FUNCCALL(SETUP_XfOrM92(_), scheme_hash_tree_get (ht , prop ) ); 
        else 
        red = ((void * ) 0 ) ; 
        if (! red )
          arg = px -> prev ; 
        else {
#         define XfOrM93_COUNT (0+XfOrM92_COUNT)
#         define SETUP_XfOrM93(x) SETUP_XfOrM92(x)

# 1121 "./../src/struct.c"
          {

# 24 "./../src/mzstkchk.h"
            uintptr_t _stk_pos ; 
#           define XfOrM96_COUNT (0+XfOrM93_COUNT)
#           define SETUP_XfOrM96(x) SETUP_XfOrM93(x)

# 26 "./../src/mzstkchk.h"
            _stk_pos = (uintptr_t ) & _stk_pos ; 

            if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
            && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 1123 "./../src/struct.c"
            RET_VALUE_START (FUNCCALL(SETUP_XfOrM96(_), chaperone_prop_acc_overflow (who , prop , orig_arg , arg ) )) RET_VALUE_END ; 
          }


          arg = px -> prev ; 
          if ((Scheme_Type ) (((((intptr_t ) (red ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (red ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#           define XfOrM95_COUNT (0+XfOrM93_COUNT)
#           define SETUP_XfOrM95(x) SETUP_XfOrM93(x)

            a [0 ] = arg ; 
            orig = FUNCCALL(SETUP_XfOrM95(_), scheme_do_eval ((((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . car ) , 1 , a , 1 ) ); 
            red = (((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . cdr ) ; 
          }

# 1135 "./../src/struct.c"
          else {
#           define XfOrM94_COUNT (0+XfOrM93_COUNT)
#           define SETUP_XfOrM94(x) SETUP_XfOrM93(x)

# 1136 "./../src/struct.c"
            orig = FUNCCALL(SETUP_XfOrM94(_), do_chaperone_prop_accessor (who , prop , orig_arg , arg ) ); 
          }

          if (! orig )

# 1139 "./../src/struct.c"
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

          a [0 ] = orig_arg ; 
          a [1 ] = orig ; 
          v = FUNCCALL(SETUP_XfOrM93(_), scheme_do_eval (red , 2 , a , 1 ) ); 

          if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
            if (! FUNCCALL(SETUP_XfOrM93(_), scheme_chaperone_of (v , orig ) ))
            FUNCCALL(SETUP_XfOrM93(_), scheme_wrong_chaperoned (who , "result" , orig , v ) ); 

          RET_VALUE_START (v ) RET_VALUE_END ; 
        }
      }
    }

# 1152 "./../src/struct.c"
    else {
#     define XfOrM86_COUNT (0+XfOrM85_COUNT)
#     define SETUP_XfOrM86(x) SETUP_XfOrM85(x)

# 1153 "./../src/struct.c"
      if ((Scheme_Type ) (((((intptr_t ) (prop ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prop ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) )  {
        Scheme_Object * procs ; 
#       define XfOrM88_COUNT (0+XfOrM86_COUNT)
#       define SETUP_XfOrM88(x) SETUP_XfOrM86(x)
        procs = NULLED_OUT ; 

# 1155 "./../src/struct.c"
        procs = (scheme_struct_type_property_ref (scheme_impersonator_of_property , arg ) ) ; 
        if (procs ) {
#         define XfOrM90_COUNT (0+XfOrM88_COUNT)
#         define SETUP_XfOrM90(x) SETUP_XfOrM88(x)

# 1157 "./../src/struct.c"
          arg = FUNCCALL(SETUP_XfOrM90(_), scheme_apply_impersonator_of (0 , procs , arg ) ); 
          if (! arg )
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
        else {

          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }
      }

# 1165 "./../src/struct.c"
      else {
#       define XfOrM87_COUNT (0+XfOrM86_COUNT)
#       define SETUP_XfOrM87(x) SETUP_XfOrM86(x)

# 1166 "./../src/struct.c"
        RET_VALUE_START ((do_prop_accessor (prop , arg ) ) ) RET_VALUE_END ; 
      }
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1172 "./../src/struct.c"
static Scheme_Object * prop_accessor (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  Scheme_Object * v ; 

# 213 "./../src/struct.c"
  char * __funcarg128 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(args, 0), PUSH(v, 1), PUSH(prim, 2)));
# define XfOrM97_COUNT (3)
# define SETUP_XfOrM97(x) SETUP(XfOrM97_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 1176 "./../src/struct.c"
  v = args [0 ] ; 
  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
  || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) ) )
    v = FUNCCALL(SETUP_XfOrM97(_), do_chaperone_prop_accessor (((Scheme_Primitive_Proc * ) prim ) -> name , ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] , v , v ) )
  ; 
  else 
  v = (do_prop_accessor (((Scheme_Primitive_Closure * ) prim ) -> val [0 ] , v ) ) ; 

  if (v )
    RET_VALUE_START (v ) RET_VALUE_END ; 
  else if (argc == 1 ) {
#   define XfOrM99_COUNT (0+XfOrM97_COUNT)
#   define SETUP_XfOrM99(x) SETUP_XfOrM97(x)
    (__funcarg128 = FUNCCALL(SETUP_XfOrM99(_), pred_name_string (((Scheme_Struct_Property * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ) -> name ) )
# 1188 "./../src/struct.c"
    , FUNCCALL_EMPTY(scheme_wrong_contract (((Scheme_Primitive_Proc * ) prim ) -> name , __funcarg128 , 0 , 1 , args ) )) 
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 1191 "./../src/struct.c"
  else {
#   define XfOrM98_COUNT (0+XfOrM97_COUNT)
#   define SETUP_XfOrM98(x) SETUP_XfOrM97(x)

# 1192 "./../src/struct.c"
    v = args [1 ] ; 
    if (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_tail_apply (v , 0 , ((void * ) 0 ) ) )) RET_VALUE_EMPTY_END ; 
    else 
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1200 "./../src/struct.c"
static Scheme_Object * make_struct_type_property_from_c (int argc , Scheme_Object * argv [] , 
Scheme_Object * * predout , Scheme_Object * * accessout , 
Scheme_Type type ) 
{

  Scheme_Struct_Property * p ; 
  Scheme_Object * a [1 ] , * v , * supers = scheme_null ; 
  char * name ; 
  int len ; 
  const char * who ; 
  char can_impersonate = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(12);
  BLOCK_SETUP_TOP((PUSH(supers, 0), PUSH(accessout, 1), PUSH(predout, 2), PUSHARRAY(a, 1, 3), PUSH(v, 6), PUSH(argv, 7), PUSH(name, 8), PUSH(p, 9), PUSH(who, 10)));
# define XfOrM100_COUNT (11)
# define SETUP_XfOrM100(x) SETUP(XfOrM100_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  p = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  v = NULLED_OUT ; 
  name = NULLED_OUT ; 
  who = NULLED_OUT ; 

# 1212 "./../src/struct.c"
  if (type == scheme_struct_property_type )
    who = "make-struct-type-property" ; 
  else 
  who = "make-impersonator-property" ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL(SETUP_XfOrM100(_), scheme_wrong_contract (who , "symbol?" , 0 , argc , argv ) ); 
  if (argc > 1 ) {
#   define XfOrM101_COUNT (0+XfOrM100_COUNT)
#   define SETUP_XfOrM101(x) SETUP_XfOrM100(x)

# 1220 "./../src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    && ! ((& ((Scheme_Symbol * ) (argv [1 ] ) ) -> iso ) -> so . keyex & 0x3 ) 
    && ! (strcmp ("can-impersonate" , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [1 ] ) ) ) -> s ) ) ) ) {
      can_impersonate = 1 ; 
    }

# 1224 "./../src/struct.c"
    else if ((! (((argv [1 ] ) ) == (scheme_false ) ) ) 
    && ! FUNCCALL(SETUP_XfOrM101(_), scheme_check_proc_arity (((void * ) 0 ) , 2 , 1 , argc , argv ) ))
      FUNCCALL(SETUP_XfOrM101(_), scheme_wrong_contract (who , "(or/c (any/c any/c . -> . any) #f 'can-impersonate)" , 1 , argc , argv ) ); 

    if (argc > 2 ) {
#     define XfOrM102_COUNT (0+XfOrM101_COUNT)
#     define SETUP_XfOrM102(x) SETUP_XfOrM101(x)

# 1229 "./../src/struct.c"
      supers = argv [2 ] ; 
      if ((scheme_proper_list_length (supers ) ) < 0 )
        supers = ((void * ) 0 ) ; 
      else {
        Scheme_Object * pr ; 
        BLOCK_SETUP((PUSH(pr, 0+XfOrM102_COUNT)));
#       define XfOrM104_COUNT (1+XfOrM102_COUNT)
#       define SETUP_XfOrM104(x) SETUP(XfOrM104_COUNT)
        pr = NULLED_OUT ; 

# 1234 "./../src/struct.c"
        for (pr = supers ; supers && ((Scheme_Type ) (((((intptr_t ) (pr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (pr ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; pr = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . cdr ) ) {
#         define XfOrM108_COUNT (0+XfOrM104_COUNT)
#         define SETUP_XfOrM108(x) SETUP_XfOrM104(x)

# 1235 "./../src/struct.c"
          v = (((Scheme_Simple_Object * ) (pr ) ) -> u . pair_val . car ) ; 
          if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
            supers = ((void * ) 0 ) ; 
          }

# 1238 "./../src/struct.c"
          else {
#           define XfOrM109_COUNT (0+XfOrM108_COUNT)
#           define SETUP_XfOrM109(x) SETUP_XfOrM108(x)

# 1239 "./../src/struct.c"
            if (! ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) )
              supers = ((void * ) 0 ) ; 
            a [0 ] = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ; 
            if (! FUNCCALL(SETUP_XfOrM109(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , 1 , a ) ))
              supers = ((void * ) 0 ) ; 
          }
        }
      }

      if (! supers ) {
#       define XfOrM103_COUNT (0+XfOrM102_COUNT)
#       define SETUP_XfOrM103(x) SETUP_XfOrM102(x)
        FUNCCALL(SETUP_XfOrM103(_), scheme_wrong_contract (who , "(listof (cons struct-type-property? (any/c . -> . any)))" , 2 , argc , argv ) ); 
      }

      if (argc > 3 )
        can_impersonate = (! (((argv [3 ] ) ) == (scheme_false ) ) ) ; 
    }
  }

  p = ((Scheme_Struct_Property * ) FUNCCALL(SETUP_XfOrM100(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Struct_Property ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  p -> so . type = type ; 
  p -> name = argv [0 ] ; 
  if ((argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) )
    p -> guard = argv [1 ] ; 
  p -> supers = supers ; 
  p -> can_impersonate = can_impersonate ; 

  a [0 ] = (Scheme_Object * ) p ; 

  len = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> len ) ; 
  name = ((char * ) FUNCCALL(SETUP_XfOrM100(_), GC_malloc_atomic (sizeof (char ) * (len + 2 ) ) )) ; 
  (memcpy (name , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> s ) , len ) ) ; 
  name [len ] = '?' ; 
  name [len + 1 ] = 0 ; 

  v = FUNCCALL(SETUP_XfOrM100(_), scheme_make_folding_prim_closure (prop_pred , 1 , a , name , 1 , 1 , 0 ) ); 
  ((Scheme_Closed_Primitive_Proc * ) v ) -> pp . flags |= (64 | 128 | 256 ) ; 
  * predout = v ; 

  name = ((char * ) FUNCCALL(SETUP_XfOrM100(_), GC_malloc_atomic (sizeof (char ) * (len + 10 ) ) )) ; 
  (memcpy (name , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [0 ] ) ) ) -> s ) , len ) ) ; 
  (memcpy (name + len , "-accessor" , 10 ) ) ; 

  v = FUNCCALL(SETUP_XfOrM100(_), scheme_make_prim_closure_w_arity (prop_accessor , 1 , a , name , 1 , 2 ) ); 
  ((Scheme_Closed_Primitive_Proc * ) v ) -> pp . flags |= (64 | 128 ) ; 

  * accessout = v ; 

  RET_VALUE_START (a [0 ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1291 "./../src/struct.c"
static Scheme_Object * make_struct_type_property (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0)));
# define XfOrM112_COUNT (3)
# define SETUP_XfOrM112(x) SETUP(XfOrM112_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 1294 "./../src/struct.c"
  a [0 ] = FUNCCALL(SETUP_XfOrM112(_), make_struct_type_property_from_c (argc , argv , & a [1 ] , & a [2 ] , scheme_struct_property_type ) ); 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM112(_), scheme_values (3 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1298 "./../src/struct.c"
static Scheme_Object * make_chaperone_property (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0)));
# define XfOrM113_COUNT (3)
# define SETUP_XfOrM113(x) SETUP(XfOrM113_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 1301 "./../src/struct.c"
  a [0 ] = FUNCCALL(SETUP_XfOrM113(_), make_struct_type_property_from_c (argc , argv , & a [1 ] , & a [2 ] , scheme_chaperone_property_type ) ); 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM113(_), scheme_values (3 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1305 "./../src/struct.c"
static Scheme_Object * make_chaperone_property_from_c (Scheme_Object * name ) 
{
  Scheme_Object * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 3, 0)));
# define XfOrM114_COUNT (3)
# define SETUP_XfOrM114(x) SETUP(XfOrM114_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 1309 "./../src/struct.c"
  a [0 ] = name ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM114(_), make_struct_type_property_from_c (1 , a , & a [1 ] , & a [2 ] , scheme_chaperone_property_type ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1313 "./../src/struct.c"
Scheme_Object * scheme_make_struct_type_property_w_guard (Scheme_Object * name , Scheme_Object * guard ) 
{
  Scheme_Object * a [2 ] ; 
  Scheme_Object * pred = ((void * ) 0 ) ; 
  Scheme_Object * access = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(pred, 0), PUSH(access, 1), PUSHARRAY(a, 2, 2)));
# define XfOrM115_COUNT (5)
# define SETUP_XfOrM115(x) SETUP(XfOrM115_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 1319 "./../src/struct.c"
  a [0 ] = name ; 
  a [1 ] = guard ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM115(_), make_struct_type_property_from_c (2 , a , & pred , & access , scheme_struct_property_type ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1324 "./../src/struct.c"
Scheme_Object * scheme_make_struct_type_property (Scheme_Object * name ) 
{
  /* No conversion */

# 1326 "./../src/struct.c"
  return scheme_make_struct_type_property_w_guard (name , scheme_false ) ; 
}

Scheme_Object * scheme_chaperone_struct_type_property_ref (Scheme_Object * prop , Scheme_Object * s ) 
{
  /* No conversion */

# 1331 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    return do_chaperone_prop_accessor ("impersonator-property-ref" , prop , s , s ) ; 
  else 
  return do_prop_accessor (prop , s ) ; 
}

Scheme_Object * scheme_struct_type_property_ref (Scheme_Object * prop , Scheme_Object * s ) 
{
  /* No conversion */

# 1339 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    s = (((Scheme_Chaperone * ) s ) -> val ) ; 
  return do_prop_accessor (prop , s ) ; 
}

static Scheme_Object * struct_type_property_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1346 "./../src/struct.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * chaperone_property_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1352 "./../src/struct.c"
  return (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * guard_property (Scheme_Object * prop , Scheme_Object * v , Scheme_Struct_Type * t ) 
{
  Scheme_Struct_Property * p = (Scheme_Struct_Property * ) prop ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(9);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(p, 1)));
# define XfOrM121_COUNT (2)
# define SETUP_XfOrM121(x) SETUP(XfOrM121_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 1360 "./../src/struct.c"
  if ((prop ) == (proc_property ) )  {

    Scheme_Object * orig_v = v ; 
#   define XfOrM125_COUNT (0+XfOrM121_COUNT)
#   define SETUP_XfOrM125(x) SETUP_XfOrM121(x)

# 1363 "./../src/struct.c"
    if ((((intptr_t ) (v ) ) & 0x1 ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) ) {
      intptr_t pos ; 
#     define XfOrM130_COUNT (0+XfOrM125_COUNT)
#     define SETUP_XfOrM130(x) SETUP_XfOrM125(x)

# 1366 "./../src/struct.c"
      if (((intptr_t ) (v ) ) & 0x1 ) 
        pos = (((intptr_t ) (v ) ) >> 1 ) ; 
      else if ((& ((Scheme_Bignum * ) v ) -> iso ) -> so . keyex & 0x1 ) 
        pos = t -> num_slots ; 
      else 
      pos = - 1 ; 

      if (pos >= 0 ) {
        Scheme_Struct_Type * parent_type ; 
        intptr_t field_count ; 
#       define XfOrM131_COUNT (0+XfOrM130_COUNT)
#       define SETUP_XfOrM131(x) SETUP_XfOrM130(x)
        parent_type = NULLED_OUT ; 

# 1377 "./../src/struct.c"
        if (t -> name_pos > 0 )
          parent_type = t -> parent_types [t -> name_pos - 1 ] ; 
        else 
        parent_type = ((void * ) 0 ) ; 

        field_count = (t -> num_islots - (parent_type ? parent_type -> num_islots : 0 ) ) ; 
        if (pos >= field_count ) {
#         define XfOrM133_COUNT (0+XfOrM131_COUNT)
#         define SETUP_XfOrM133(x) SETUP_XfOrM131(x)
          FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "index for procedure >= initialized-field count" , "index" , 1 , v , "field count" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (field_count ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )

          ; 
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        }

        if (parent_type ) {

          pos += parent_type -> num_slots ; 
          v = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) ; 
        }
      }

# 1397 "./../src/struct.c"
      else 
      v = scheme_false ; 
    }

    if ((((intptr_t ) (v ) ) & 0x1 ) || (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) {
    }
    else {
#     define XfOrM128_COUNT (0+XfOrM125_COUNT)
#     define SETUP_XfOrM128(x) SETUP_XfOrM125(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "given value did not satisfy the contract for prop:procedure" , "expected" , 0 , "(or/c procedure? exact-nonnegative-integer?)" , "given" , 1 , orig_v , ((void * ) 0 ) ) )

      ; 
    }

    t -> proc_attr = v ; 

    if (((intptr_t ) (v ) ) & 0x1 )  {
      intptr_t pos ; 
#     define XfOrM126_COUNT (0+XfOrM125_COUNT)
#     define SETUP_XfOrM126(x) SETUP_XfOrM125(x)

# 1415 "./../src/struct.c"
      pos = (((intptr_t ) (orig_v ) ) >> 1 ) ; 
      if (! t -> immutables || ! t -> immutables [pos ] ) {
#       define XfOrM127_COUNT (0+XfOrM126_COUNT)
#       define SETUP_XfOrM127(x) SETUP_XfOrM126(x)
        FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "field is not specified as immutable for a prop:procedure index" , "index" , 1 , orig_v , ((void * ) 0 ) ) )
        ; 
      }
    }

    RET_VALUE_START (orig_v ) RET_VALUE_END ; 
  }

# 1425 "./../src/struct.c"
  else {
#   define XfOrM122_COUNT (0+XfOrM121_COUNT)
#   define SETUP_XfOrM122(x) SETUP_XfOrM121(x)

# 1427 "./../src/struct.c"
    if (p -> guard && ! ((Scheme_Type ) (((((intptr_t ) (p -> guard ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p -> guard ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#     define XfOrM123_COUNT (0+XfOrM122_COUNT)
#     define SETUP_XfOrM123(x) SETUP_XfOrM122(x)

# 1428 "./../src/struct.c"
      if (! scheme_defining_primitives ) {
        Scheme_Object * a [2 ] , * info [8 ] , * l ; 
        BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM123_COUNT), PUSHARRAY(info, 8, 3+XfOrM123_COUNT), PUSH(l, 6+XfOrM123_COUNT)));
#       define XfOrM124_COUNT (7+XfOrM123_COUNT)
#       define SETUP_XfOrM124(x) SETUP(XfOrM124_COUNT)
        a[0] = NULLED_OUT ; 
        a[1] = NULLED_OUT ; 
        NULL_OUT_ARRAY (info ) ; 
        l = NULLED_OUT ; 

# 1431 "./../src/struct.c"
        a [0 ] = (Scheme_Object * ) t ; 
        FUNCCALL(SETUP_XfOrM124(_), get_struct_type_info (1 , a , info , 1 ) ); 

        l = FUNCCALL_AGAIN(scheme_build_list (8 , info ) ); 

        a [0 ] = v ; 
        a [1 ] = l ; 

        RET_VALUE_START (FUNCCALL(SETUP_XfOrM124(_), scheme_do_eval (p -> guard , 2 , a , 1 ) )) RET_VALUE_END ; 
      }
      else 
      RET_VALUE_START (v ) RET_VALUE_END ; 
    }

# 1443 "./../src/struct.c"
    else 
    RET_VALUE_START (v ) RET_VALUE_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static int extract_accessor_offset (Scheme_Object * acc ) 
{
  /* No conversion */

# 1454 "./../src/struct.c"
  Scheme_Struct_Type * st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) acc ) -> val [0 ] ; 

  if (st -> name_pos )
    return st -> parent_types [st -> name_pos - 1 ] -> num_slots ; 
  else 
  return 0 ; 
}

static char * extract_field_proc_name (Scheme_Object * prim ) 
{
  /* No conversion */

# 1464 "./../src/struct.c"
  return (char * ) ((Scheme_Primitive_Closure * ) prim ) -> val [2 ] ; 
}

typedef int (* Check_Val_Proc ) (Scheme_Object * ) ; 

static void wrong_property_contract (const char * name , const char * contract , Scheme_Object * v ) 
{
  /* No conversion */

# 1471 "./../src/struct.c"
  scheme_contract_error (name , 
  "contract violation for given property value" , 
  "expected" , 0 , contract , 
  "given" , 1 , v , 
  ((void * ) 0 ) ) ; 
}

static Scheme_Object * check_indirect_property_value_ok (const char * name , Check_Val_Proc ck , int proc_ok , 
const char * contract , 
int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v , * l , * acc ; 
  int pos , num_islots ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(acc, 1), PUSH(contract, 2), PUSH(argv, 3), PUSH(l, 4), PUSH(name, 5)));
# define XfOrM137_COUNT (6)
# define SETUP_XfOrM137(x) SETUP(XfOrM137_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  l = NULLED_OUT ; 
  acc = NULLED_OUT ; 

# 1485 "./../src/struct.c"
  v = argv [0 ] ; 

  if (FUNCCALL(SETUP_XfOrM137(_), ck (v ) ))
    RET_VALUE_START (v ) RET_VALUE_END ; 

  if (proc_ok && FUNCCALL(SETUP_XfOrM137(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , 1 , & v ) ))
    RET_VALUE_START (v ) RET_VALUE_END ; 

  if (! (((((intptr_t ) (v ) ) & 0x1 ) && ((((intptr_t ) (v ) ) >> 1 ) >= 0 ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) v ) -> iso ) -> so . keyex & 0x1 ) ) ) )
    FUNCCALL(SETUP_XfOrM137(_), wrong_property_contract (name , contract , v ) ); 

  l = argv [1 ] ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  num_islots = (((intptr_t ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  acc = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
    pos = num_islots ; 
  else 
  pos = (((intptr_t ) (v ) ) >> 1 ) ; 

  if (pos >= num_islots ) {
#   define XfOrM141_COUNT (0+XfOrM137_COUNT)
#   define SETUP_XfOrM141(x) SETUP_XfOrM137(x)
    FUNCCALL(SETUP_XfOrM141(_), scheme_contract_error (name , "field index >= initialized-field count for structure type" , "field index" , 1 , v , "initialized-field count" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (num_islots ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )

    ; 
  }

  for (; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
    if ((((intptr_t ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) >> 1 ) == pos )
      break ; 
  }

  if (! ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM138_COUNT (0+XfOrM137_COUNT)
#   define SETUP_XfOrM138(x) SETUP_XfOrM137(x)
    FUNCCALL(SETUP_XfOrM138(_), scheme_contract_error (name , "field index not declared immutable" , "field index" , 1 , v , ((void * ) 0 ) ) )
    ; 
  }

  pos += FUNCCALL(SETUP_XfOrM137(_), extract_accessor_offset (acc ) ); 
  v = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1538 "./../src/struct.c"
static int is_evt_or_poller (Scheme_Object * v ) 
{
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM142_COUNT (1)
# define SETUP_XfOrM142(x) SETUP(XfOrM142_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1540 "./../src/struct.c"
  if (FUNCCALL(SETUP_XfOrM142(_), scheme_is_evt (v ) ))
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && (scheme_is_struct_instance (poller_struct , v ) ) ) 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1547 "./../src/struct.c"
static Scheme_Object * check_evt_property_value_ok (int argc , Scheme_Object * argv [] ) 

{
  /* No conversion */

# 1550 "./../src/struct.c"
  return check_indirect_property_value_ok ("guard-for-prop:evt" , 
  is_evt_or_poller , 1 , 
  "(or/c evt? (any/c . -> . any) exact-nonnegative-integer?)" , 
  argc , argv ) ; 
}

static Scheme_Object * return_wrapped (void * data , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1558 "./../src/struct.c"
  return (Scheme_Object * ) data ; 
}

static Scheme_Object * return_wrapped_multi (void * data , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * * a , * l = (Scheme_Object * ) data ; 
  int i , n ; 
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(l, 1)));
# define XfOrM145_COUNT (2)
# define SETUP_XfOrM145(x) SETUP(XfOrM145_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 

# 1566 "./../src/struct.c"
  n = (scheme_list_length (l ) ) ; 
  a = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM145(_), GC_malloc (sizeof (Scheme_Object * ) * (n ) ) )) ; 
  for (i = 0 ; i < n ; i ++ ) {
    a [i ] = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (n , a ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1576 "./../src/struct.c"
static int evt_struct_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(sinfo, 1), PUSH(o, 2)));
# define XfOrM148_COUNT (3)
# define SETUP_XfOrM148(x) SETUP(XfOrM148_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 

# 1580 "./../src/struct.c"
  v = (scheme_struct_type_property_ref (evt_property , o ) ) ; 

  if (! v ) {
#   define XfOrM165_COUNT (0+XfOrM148_COUNT)
#   define SETUP_XfOrM165(x) SETUP_XfOrM148(x)

# 1584 "./../src/struct.c"
    if (scheme_is_input_port (o ) )  {
#     define XfOrM167_COUNT (0+XfOrM165_COUNT)
#     define SETUP_XfOrM167(x) SETUP_XfOrM165(x)

# 1585 "./../src/struct.c"
      v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM167(_), scheme_input_port_record (o ) ); 
    }

# 1586 "./../src/struct.c"
    else {
#     define XfOrM166_COUNT (0+XfOrM165_COUNT)
#     define SETUP_XfOrM166(x) SETUP_XfOrM165(x)

# 1587 "./../src/struct.c"
      v = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM166(_), scheme_output_port_record (o ) ); 
    }
    FUNCCALL(SETUP_XfOrM165(_), scheme_set_sync_target (sinfo , v , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) ); 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  if (((intptr_t ) (v ) ) & 0x1 ) 
    v = FUNCCALL(SETUP_XfOrM148(_), scheme_struct_ref (o , (((intptr_t ) (v ) ) >> 1 ) ) ); 

  if (FUNCCALL(SETUP_XfOrM148(_), scheme_is_evt (v ) )) {
#   define XfOrM164_COUNT (0+XfOrM148_COUNT)
#   define SETUP_XfOrM164(x) SETUP_XfOrM148(x)
    FUNCCALL(SETUP_XfOrM164(_), scheme_set_sync_target (sinfo , v , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
# 1597 "./../src/struct.c"
    ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  if (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) )  {
#   define XfOrM158_COUNT (0+XfOrM148_COUNT)
#   define SETUP_XfOrM158(x) SETUP_XfOrM148(x)

# 1602 "./../src/struct.c"
    if (FUNCCALL(SETUP_XfOrM158(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , 1 , & v ) )) {
      Scheme_Object * f = v , * result , * a [1 ] ; 
      BLOCK_SETUP((PUSH(result, 0+XfOrM158_COUNT), PUSHARRAY(a, 1, 1+XfOrM158_COUNT)));
#     define XfOrM159_COUNT (4+XfOrM158_COUNT)
#     define SETUP_XfOrM159(x) SETUP(XfOrM159_COUNT)
      result = NULLED_OUT ; 
      a[0] = NULLED_OUT ; 

# 1605 "./../src/struct.c"
      a [0 ] = o ; 
      result = FUNCCALL(SETUP_XfOrM159(_), scheme_apply (f , 1 , a ) ); 

      if (FUNCCALL(SETUP_XfOrM159(_), scheme_is_evt (result ) )) {
#       define XfOrM161_COUNT (0+XfOrM159_COUNT)
#       define SETUP_XfOrM161(x) SETUP_XfOrM159(x)

# 1609 "./../src/struct.c"
        {
#         define XfOrM162_COUNT (0+XfOrM161_COUNT)
#         define SETUP_XfOrM162(x) SETUP_XfOrM161(x)

# 1609 "./../src/struct.c"
          if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#           define XfOrM163_COUNT (0+XfOrM162_COUNT)
#           define SETUP_XfOrM163(x) SETUP_XfOrM162(x)
            FUNCCALL(SETUP_XfOrM163(_), scheme_out_of_fuel () )
# 1609 "./../src/struct.c"
            ; 
          }
        }

# 1609 "./../src/struct.c"
        ; 
        FUNCCALL(SETUP_XfOrM161(_), scheme_set_sync_target (sinfo , result , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
        ; 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }




      if (! (((intptr_t ) (o ) ) & 0x1 ) && ((((o ) -> type ) >= scheme_prim_type ) && (((o ) -> type ) <= scheme_proc_chaperone_type ) ) )  {
#       define XfOrM160_COUNT (0+XfOrM159_COUNT)
#       define SETUP_XfOrM160(x) SETUP_XfOrM159(x)

# 1619 "./../src/struct.c"
        o = FUNCCALL(SETUP_XfOrM160(_), scheme_make_closed_prim_w_arity (return_wrapped , (void * ) o , "wrapper" , 1 , 1 ) ); 
      }
      FUNCCALL(SETUP_XfOrM159(_), scheme_set_sync_target (sinfo , o , o , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) ); 

      RET_VALUE_START (1 ) RET_VALUE_END ; 
    }
  }

  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && (scheme_is_struct_instance (poller_struct , v ) ) )  {
    Scheme_Thread * p ; 
    Scheme_Object * a [2 ] ; 
    int done ; 
    BLOCK_SETUP((PUSHARRAY(a, 2, 0+XfOrM148_COUNT), PUSH(p, 3+XfOrM148_COUNT)));
#   define XfOrM149_COUNT (4+XfOrM148_COUNT)
#   define SETUP_XfOrM149(x) SETUP(XfOrM149_COUNT)
    p = NULLED_OUT ; 
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM149(_), scheme_start_in_scheduler () )
# 1632 "./../src/struct.c"
    ; 
    a [0 ] = o ; 
    a [1 ] = scheme_false ; 
    v = FUNCCALL(SETUP_XfOrM149(_), scheme_do_eval ((((Scheme_Structure * ) (v ) ) -> slots [0 ] ) , 2 , a , - 1 ) ); 

    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    if ((v == ((Scheme_Object * ) 0x6 ) ) 
    && (p -> ku . multiple . count == 2 ) ) {
      if (((p -> ku . multiple . array [0 ] ) ) == (scheme_false ) )  {
        v = p -> ku . multiple . array [1 ] ; 
        if (v == o )

# 1642 "./../src/struct.c"
        v = ((void * ) 0 ) ; 
        done = 0 ; 
      }

# 1644 "./../src/struct.c"
      else {
        v = p -> ku . multiple . array [0 ] ; 
        done = 1 ; 
      }
    }

# 1648 "./../src/struct.c"
    else {

      v = ((void * ) 0 ) ; 
      done = 0 ; 
    }
    FUNCCALL(SETUP_XfOrM149(_), scheme_end_in_scheduler () ); 

    if (v ) {
#     define XfOrM150_COUNT (0+XfOrM149_COUNT)
#     define SETUP_XfOrM150(x) SETUP_XfOrM149(x)

# 1656 "./../src/struct.c"
      if (done ) {
        int check_proc = 1 ; 
#       define XfOrM151_COUNT (0+XfOrM150_COUNT)
#       define SETUP_XfOrM151(x) SETUP_XfOrM150(x)

# 1658 "./../src/struct.c"
        if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) && (((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) ) == (scheme_null ) ) && ! (! (((intptr_t ) ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) ) & 0x1 ) && (((((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) -> type ) >= scheme_prim_type ) && ((((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
          v = (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 
        else if (! ((v ) == (scheme_null ) ) && ! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
        }
        else {
#         define XfOrM152_COUNT (0+XfOrM151_COUNT)
#         define SETUP_XfOrM152(x) SETUP_XfOrM151(x)

# 1663 "./../src/struct.c"
          v = FUNCCALL(SETUP_XfOrM152(_), scheme_make_closed_prim_w_arity (return_wrapped_multi , (void * ) v , "multi-wrapper" , 1 , 1 ) ); 
          check_proc = 0 ; 
        }

        if (check_proc && (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
          v = FUNCCALL(SETUP_XfOrM151(_), scheme_make_closed_prim_w_arity (return_wrapped , (void * ) v , "wrapper" , 1 , 1 ) ); 
      }
      FUNCCALL(SETUP_XfOrM150(_), scheme_set_sync_target (sinfo , v , (done ? v : ((void * ) 0 ) ) , ((void * ) 0 ) , 0 , 0 , ((void * ) 0 ) ) ); 
      RET_VALUE_START (done ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1678 "./../src/struct.c"
void evt_struct_needs_wakeup (Scheme_Object * o , void * fds ) 
{
  Scheme_Object * v ; 
  PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(fds, 1), PUSH(o, 2)));
# define XfOrM168_COUNT (3)
# define SETUP_XfOrM168(x) SETUP(XfOrM168_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 

# 1684 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    RET_NOTHING ; 

  v = (scheme_struct_type_property_ref (evt_property , o ) ) ; 
  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && (scheme_is_struct_instance (poller_struct , v ) ) )  {
    Scheme_Object * a [2 ] , * e , * r ; 
    BLOCK_SETUP((PUSH(r, 0+XfOrM168_COUNT), PUSH(e, 1+XfOrM168_COUNT), PUSHARRAY(a, 2, 2+XfOrM168_COUNT)));
#   define XfOrM169_COUNT (5+XfOrM168_COUNT)
#   define SETUP_XfOrM169(x) SETUP(XfOrM169_COUNT)
    a[0] = NULLED_OUT ; 
    a[1] = NULLED_OUT ; 
    e = NULLED_OUT ; 
    r = NULLED_OUT ; 
    FUNCCALL(SETUP_XfOrM169(_), scheme_start_in_scheduler () )
# 1691 "./../src/struct.c"
    ; 
    a [0 ] = o ; 
    e = FUNCCALL(SETUP_XfOrM169(_), scheme_make_cptr (fds , scheme_false ) ); 
    a [1 ] = e ; 
    r = FUNCCALL(SETUP_XfOrM169(_), scheme_do_eval ((((Scheme_Structure * ) (v ) ) -> slots [0 ] ) , 2 , a , - 1 ) ); 
    FUNCCALL_AGAIN(scheme_end_in_scheduler () ); 


    if (r == ((Scheme_Object * ) 0x6 ) ) {
      Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#     define XfOrM170_COUNT (0+XfOrM169_COUNT)
#     define SETUP_XfOrM170(x) SETUP_XfOrM169(x)

# 1701 "./../src/struct.c"
      if (p -> ku . multiple . count == 2 ) {
#       define XfOrM171_COUNT (0+XfOrM170_COUNT)
#       define SETUP_XfOrM171(x) SETUP_XfOrM170(x)

# 1702 "./../src/struct.c"
        if (! (((p -> ku . multiple . array [0 ] ) ) == (scheme_false ) ) ) 
          FUNCCALL(SETUP_XfOrM171(_), scheme_cancel_sleep () ); 
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1709 "./../src/struct.c"
static int is_evt_struct (Scheme_Object * o ) 
{
  /* No conversion */

# 1711 "./../src/struct.c"
  if (scheme_struct_type_property_ref (evt_property , o ) )
    return 1 ; 
  if (scheme_struct_type_property_ref (scheme_input_port_property , o ) )
    return 1 ; 
  if (scheme_struct_type_property_ref (scheme_output_port_property , o ) )
    return 1 ; 
  return 0 ; 
}







static int is_proc_1 (Scheme_Object * o ) {
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(o, 0)));
# define XfOrM173_COUNT (1)
# define SETUP_XfOrM173(x) SETUP(XfOrM173_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1726 "./../src/struct.c"
  RET_VALUE_START (((! (((intptr_t ) (o ) ) & 0x1 ) && ((((o ) -> type ) >= scheme_prim_type ) && (((o ) -> type ) <= scheme_proc_chaperone_type ) ) ) && FUNCCALL(SETUP_XfOrM173(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , - 1 , 0 , & o ) )) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1728 "./../src/struct.c"
static Scheme_Object * check_object_name_property_value_ok (int argc , Scheme_Object * argv [] ) 

{
  /* No conversion */

# 1731 "./../src/struct.c"
  return check_indirect_property_value_ok ("guard-for-prop:object-name" , 
  is_proc_1 , 1 , 
  "(or/c (any/c . -> . any) exact-nonnegative-integer?)" , 
  argc , argv ) ; 
}






static int is_input_port (Scheme_Object * v ) {
  /* No conversion */

# 1742 "./../src/struct.c"
  return scheme_is_input_port (v ) ; 
}

# 1743 "./../src/struct.c"
static int is_output_port (Scheme_Object * v ) {
  /* No conversion */

# 1743 "./../src/struct.c"
  return scheme_is_output_port (v ) ; 
}
static Scheme_Object * check_port_property_value_ok (const char * name , int input , int argc , Scheme_Object * argv [] ) 

{
  /* No conversion */

# 1748 "./../src/struct.c"
  return check_indirect_property_value_ok (name , 
  input ? is_input_port : is_output_port , 0 , 
  (input 
  ? "(or/c input-port? exact-nonnegative-integer?)" 
  : "(or/c output-port? exact-nonnegative-integer?)" ) , 
  argc , argv ) ; 
}

static Scheme_Object * check_input_port_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1758 "./../src/struct.c"
  return check_port_property_value_ok ("guard-for-prop:input-port" , 1 , argc , argv ) ; 
}

static Scheme_Object * check_output_port_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1763 "./../src/struct.c"
  return check_port_property_value_ok ("guard-for-prop:output-port" , 0 , argc , argv ) ; 
}





static Scheme_Object * check_cpointer_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1772 "./../src/struct.c"
  return check_indirect_property_value_ok ("guard-for-prop:cpointer" , 
  scheme_is_cpointer , 1 , 
  "(or/c cpointer? (any/c . -> . any) exact-nonnegative-integer?)" , 
  argc , argv ) ; 
}





static Scheme_Object * check_equal_property_value_ok (int argc , Scheme_Object * argv [] ) 

{
  Scheme_Object * v , * p ; 
  Scheme_Object * __funcarg129 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(argv, 1), PUSH(p, 2)));
# define XfOrM181_COUNT (3)
# define SETUP_XfOrM181(x) SETUP(XfOrM181_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  p = NULLED_OUT ; 

# 1787 "./../src/struct.c"
  v = argv [0 ] ; 

  if ((scheme_proper_list_length (v ) ) != 3 ) {
    v = ((void * ) 0 ) ; 
  }

# 1791 "./../src/struct.c"
  else {
#   define XfOrM183_COUNT (0+XfOrM181_COUNT)
#   define SETUP_XfOrM183(x) SETUP_XfOrM181(x)

# 1792 "./../src/struct.c"
    v = (__funcarg129 = FUNCCALL(SETUP_XfOrM183(_), scheme_make_symbol ("tag" ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg129 , v ) )) ; 
    v = FUNCCALL(SETUP_XfOrM183(_), scheme_list_to_vector (v ) ); 
    p = (((Scheme_Vector * ) (v ) ) -> els ) [1 ] ; 
    if (! FUNCCALL(SETUP_XfOrM183(_), scheme_check_proc_arity (((void * ) 0 ) , 3 , 0 , 1 , & p ) )) {
      v = ((void * ) 0 ) ; 
    }

# 1797 "./../src/struct.c"
    else {
#     define XfOrM184_COUNT (0+XfOrM183_COUNT)
#     define SETUP_XfOrM184(x) SETUP_XfOrM183(x)

# 1798 "./../src/struct.c"
      p = (((Scheme_Vector * ) (v ) ) -> els ) [2 ] ; 
      if (! FUNCCALL(SETUP_XfOrM184(_), scheme_check_proc_arity (((void * ) 0 ) , 2 , 0 , 1 , & p ) )) {
        v = ((void * ) 0 ) ; 
      }

# 1801 "./../src/struct.c"
      else {
#       define XfOrM185_COUNT (0+XfOrM184_COUNT)
#       define SETUP_XfOrM185(x) SETUP_XfOrM184(x)

# 1802 "./../src/struct.c"
        p = (((Scheme_Vector * ) (v ) ) -> els ) [3 ] ; 
        if (! FUNCCALL(SETUP_XfOrM185(_), scheme_check_proc_arity (((void * ) 0 ) , 2 , 0 , 1 , & p ) )) {
          v = ((void * ) 0 ) ; 
        }
      }
    }
  }

  if (! v ) {
#   define XfOrM182_COUNT (0+XfOrM181_COUNT)
#   define SETUP_XfOrM182(x) SETUP_XfOrM181(x)
    FUNCCALL(SETUP_XfOrM182(_), wrong_property_contract ("guard-for-prop:equal+hash" , "(list/c (any/c any/c any/c . -> . any)\n" "        (any/c any/c . -> . any)\n" "        (any/c any/c . -> . any))" , argv [0 ] ) )

    ; 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1821 "./../src/struct.c"
static Scheme_Object * check_impersonator_of_property_value_ok (int argc , Scheme_Object * argv [] ) 
{

  Scheme_Object * v ; 
  Scheme_Object * __funcarg130 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM190_COUNT (1)
# define SETUP_XfOrM190(x) SETUP(XfOrM190_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 1826 "./../src/struct.c"
  v = argv [0 ] ; 

  if (! FUNCCALL(SETUP_XfOrM190(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 0 , argc , argv ) )) {
#   define XfOrM191_COUNT (0+XfOrM190_COUNT)
#   define SETUP_XfOrM191(x) SETUP_XfOrM190(x)
    FUNCCALL(SETUP_XfOrM191(_), wrong_property_contract ("guard-for-prop:impersonator-of" , "(any/c . -> . any)" , v ) ); 
  }


  v = (__funcarg130 = FUNCCALL(SETUP_XfOrM190(_), scheme_make_symbol ("tag" ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg130 , v ) )) ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * check_write_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM192_COUNT (1)
# define SETUP_XfOrM192(x) SETUP(XfOrM192_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 1848 "./../src/struct.c"
  v = argv [0 ] ; 

  if (! FUNCCALL(SETUP_XfOrM192(_), scheme_check_proc_arity (((void * ) 0 ) , 3 , 0 , argc , argv ) )) {
#   define XfOrM193_COUNT (0+XfOrM192_COUNT)
#   define SETUP_XfOrM193(x) SETUP_XfOrM192(x)
    FUNCCALL(SETUP_XfOrM193(_), wrong_property_contract ("guard-for-prop:custom-write" , "(any/c any/c any/c . -> . any)" , v ) ); 
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 1859 "./../src/struct.c"
static Scheme_Object * check_print_attribute_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1861 "./../src/struct.c"
  Scheme_Object * s = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) && ! ((& ((Scheme_Symbol * ) (s ) ) -> iso ) -> so . keyex & 0x3 ) ) {
    if (! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s ) ) ) -> s ) , "self" ) 
    || ! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s ) ) ) -> s ) , "never" ) 
    || ! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s ) ) ) -> s ) , "always" ) 
    || ! strcmp ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (s ) ) ) -> s ) , "maybe" ) )
      return s ; 
  }

  wrong_property_contract ("guard-for-prop:custom-print-quotable" , 
  "(or/c 'self 'never 'always 'maybe)" , 
  s ) ; 

  return ((void * ) 0 ) ; 
}

Scheme_Object * scheme_is_writable_struct (Scheme_Object * s ) 
{
  /* No conversion */

# 1879 "./../src/struct.c"
  return scheme_struct_type_property_ref (write_property , s ) ; 
}

Scheme_Object * scheme_print_attribute_ref (Scheme_Object * s ) 
{
  /* No conversion */

# 1884 "./../src/struct.c"
  return scheme_struct_type_property_ref (print_attribute_property , s ) ; 
}





static Scheme_Object * check_checked_proc_property_value_ok (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 1893 "./../src/struct.c"
  Scheme_Object * parent , * l ; 
  int num_islots , num_aslots ; 

  l = argv [1 ] ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  num_islots = (((intptr_t ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  num_aslots = (((intptr_t ) ((((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
  parent = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 

  if (! (((parent ) ) == (scheme_false ) ) )  {
    scheme_contract_error ("prop:checked-procedure" , 
    "not allowed on a structure type with a supertype" , 
    ((void * ) 0 ) ) ; 
  }

  if (num_islots + num_aslots < 2 ) {
    scheme_contract_error ("prop:checked-procedure" , 
    "need at least two fields in the structure type" , 
    ((void * ) 0 ) ) ; 
  }

  return scheme_true ; 
}

Scheme_Object * scheme_extract_checked_procedure (int argc , Scheme_Object * * argv ) 
{
  Scheme_Struct_Type * stype ; 
  Scheme_Object * v , * checker , * proc , * a [3 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(stype, 1), PUSH(checker, 2), PUSH(argv, 3), PUSH(proc, 4), PUSHARRAY(a, 3, 5)));
# define XfOrM201_COUNT (8)
# define SETUP_XfOrM201(x) SETUP(XfOrM201_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  v = NULLED_OUT ; 
  checker = NULLED_OUT ; 
  proc = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 1927 "./../src/struct.c"
  v = argv [1 ] ; 

  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) 
    stype = (Scheme_Struct_Type * ) argv [0 ] ; 
  else 
  stype = ((void * ) 0 ) ; 

  if (! stype || ! ((& stype -> iso ) -> so . keyex & 0x2 ) ) {
#   define XfOrM203_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM203(x) SETUP_XfOrM201(x)
    FUNCCALL(SETUP_XfOrM203(_), scheme_wrong_type ("checked-procedure-check-and-extract" , "unchaperoned structure type with prop:checked-procedure property" , 0 , argc , argv ) )
# 1936 "./../src/struct.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }


  if ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && (scheme_is_struct_instance ((Scheme_Object * ) stype , v ) ) ) {
#   define XfOrM202_COUNT (0+XfOrM201_COUNT)
#   define SETUP_XfOrM202(x) SETUP_XfOrM201(x)

# 1942 "./../src/struct.c"
    checker = ((Scheme_Structure * ) v ) -> slots [0 ] ; 
    proc = ((Scheme_Structure * ) v ) -> slots [1 ] ; 

    a [0 ] = argv [3 ] ; 
    a [1 ] = argv [4 ] ; 
    v = FUNCCALL(SETUP_XfOrM202(_), scheme_do_eval (checker , 2 , a , 1 ) ); 

    if (! (((v ) ) == (scheme_false ) ) ) 
      RET_VALUE_START (proc ) RET_VALUE_END ; 
  }

  a [0 ] = argv [1 ] ; 
  a [1 ] = argv [3 ] ; 
  a [2 ] = argv [4 ] ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM201(_), scheme_do_eval (argv [2 ] , 3 , a , 1 ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static void wrong_struct_type (char * name , 
Scheme_Object * expected , 
Scheme_Object * received , 
int which , int argc , 
Scheme_Object * * argv ) 
{

# 213 "./../src/struct.c"
  char * __funcarg132 = NULLED_OUT ; 

# 213 "./../src/struct.c"
  char * __funcarg131 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(expected, 1), PUSH(name, 2)));
# define XfOrM204_COUNT (3)
# define SETUP_XfOrM204(x) SETUP(XfOrM204_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 1969 "./../src/struct.c"
  if ((expected ) == (received ) ) 
    (__funcarg132 = FUNCCALL(SETUP_XfOrM204(_), pred_name_string (expected ) )


  , FUNCCALL_EMPTY(scheme_contract_error (name , "contract violation;\n" " given value instantiates a different structure type with the same name" , "expected" , 0 , __funcarg132 , "given" , 1 , argv [which ] , ((void * ) 0 ) ) )) 

  ; 
  else (__funcarg131 = FUNCCALL(SETUP_XfOrM204(_), pred_name_string (expected ) )

  , FUNCCALL_EMPTY(scheme_wrong_contract (name , __funcarg131 , which , argc , argv ) )) 
  ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}
int scheme_is_struct_instance (Scheme_Object * type , Scheme_Object * v ) 
{
  /* No conversion */

# 1988 "./../src/struct.c"
  Scheme_Struct_Type * stype = (Scheme_Struct_Type * ) type ; 
  Scheme_Structure * s = (Scheme_Structure * ) v ; 

  return ((stype -> name_pos <= s -> stype -> name_pos ) && (stype == s -> stype -> parent_types [stype -> name_pos ] ) ) ; 
}

static Scheme_Object * chaperone_struct_ref (const char * who , Scheme_Object * prim , 
Scheme_Object * orig_o , Scheme_Object * o , int i ) ; 

static Scheme_Object * chaperone_struct_ref_k (void ) 
{
  /* No conversion */

# 1999 "./../src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * prim = (Scheme_Object * ) p -> ku . k . p3 ; 
  const char * who = (const char * ) p -> ku . k . p2 ; 
  Scheme_Object * orig_o = (Scheme_Object * ) p -> ku . k . p4 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 

  return chaperone_struct_ref (who , prim , orig_o , o , p -> ku . k . i1 ) ; 
}

static Scheme_Object * chaperone_struct_ref_overflow (const char * who , Scheme_Object * prim , 
Scheme_Object * orig_o , Scheme_Object * o , int i ) 
{
  /* No conversion */

# 2016 "./../src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = (void * ) o ; 
  p -> ku . k . p2 = (void * ) who ; 
  p -> ku . k . p3 = (void * ) prim ; 
  p -> ku . k . p4 = (void * ) orig_o ; 
  p -> ku . k . i1 = i ; 

  return scheme_handle_stack_overflow (chaperone_struct_ref_k ) ; 
}

static void raise_undefined_error (const char * who , Scheme_Object * prim , Scheme_Object * val , 
const char * short_error , const char * mode , int i ) 
{
  int len ; 
  Scheme_Object * o ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(mode, 0), PUSH(short_error, 1), PUSH(who, 2)));
# define XfOrM208_COUNT (3)
# define SETUP_XfOrM208(x) SETUP(XfOrM208_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 

# 2033 "./../src/struct.c"
  o = (scheme_struct_type_property_ref (scheme_chaperone_undefined_property , val ) ) ; 
  len = (o ? (scheme_proper_list_length (o ) ) : 0 ) ; 
  if (i < len ) {
#   define XfOrM210_COUNT (0+XfOrM208_COUNT)
#   define SETUP_XfOrM210(x) SETUP_XfOrM208(x)

# 2036 "./../src/struct.c"
    for (i = len - i ; -- i ; ) {
      o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . cdr ) ; 
    }
    o = (((Scheme_Simple_Object * ) (o ) ) -> u . pair_val . car ) ; 
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT_VARIABLE , o , "%S: %s;\n cannot %s field before initialization" , o , short_error , mode ) )


    ; 
  }

# 2044 "./../src/struct.c"
  else {
#   define XfOrM209_COUNT (0+XfOrM208_COUNT)
#   define SETUP_XfOrM209(x) SETUP_XfOrM208(x)

# 2045 "./../src/struct.c"
    if (prim )
      who = FUNCCALL(SETUP_XfOrM209(_), extract_field_proc_name (prim ) ); 
    FUNCCALL_EMPTY(scheme_raise_exn (MZEXN_FAIL_CONTRACT , "%s: %s;\n cannot %s field before initialization" , who , short_error , mode ) )



    ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2056 "./../src/struct.c"
static Scheme_Object * chaperone_struct_ref (const char * who , Scheme_Object * prim , 
Scheme_Object * orig_o , Scheme_Object * o , int i ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(10);
  BLOCK_SETUP_TOP((PUSH(orig_o, 0), PUSH(o, 1), PUSH(prim, 2), PUSH(who, 3)));
# define XfOrM213_COUNT (4)
# define SETUP_XfOrM213(x) SETUP(XfOrM213_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2059 "./../src/struct.c"
  while (1 ) {
#   define XfOrM225_COUNT (0+XfOrM213_COUNT)
#   define SETUP_XfOrM225(x) SETUP_XfOrM213(x)

# 2060 "./../src/struct.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
      RET_VALUE_START (((Scheme_Structure * ) o ) -> slots [i ] ) RET_VALUE_END ; 
    }

# 2062 "./../src/struct.c"
    else {
      Scheme_Chaperone * px = (Scheme_Chaperone * ) o ; 
      Scheme_Object * a [2 ] , * red , * orig ; 
      BLOCK_SETUP((PUSH(red, 0+XfOrM225_COUNT), PUSHARRAY(a, 2, 1+XfOrM225_COUNT), PUSH(orig, 4+XfOrM225_COUNT), PUSH(px, 5+XfOrM225_COUNT)));
#     define XfOrM226_COUNT (6+XfOrM225_COUNT)
#     define SETUP_XfOrM226(x) SETUP(XfOrM226_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      red = NULLED_OUT ; 
      orig = NULLED_OUT ; 

# 2066 "./../src/struct.c"
      if ((((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) ) 
      && (((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) == (scheme_undefined ) ) ) {
#       define XfOrM233_COUNT (0+XfOrM226_COUNT)
#       define SETUP_XfOrM233(x) SETUP_XfOrM226(x)

# 2069 "./../src/struct.c"
        o = px -> prev ; 

        if (! (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) )
          orig = ((Scheme_Structure * ) o ) -> slots [i ] ; 
        else 
        orig = FUNCCALL(SETUP_XfOrM233(_), chaperone_struct_ref (who , prim , orig_o , o , i ) ); 

        if ((orig ) == (scheme_undefined ) )  {
#         define XfOrM234_COUNT (0+XfOrM233_COUNT)
#         define SETUP_XfOrM234(x) SETUP_XfOrM233(x)
          FUNCCALL(SETUP_XfOrM234(_), raise_undefined_error (who , prim , px -> val , "undefined" , "use" , i ) )
# 2077 "./../src/struct.c"
          ; 
        }

        RET_VALUE_START (orig ) RET_VALUE_END ; 
      }

# 2081 "./../src/struct.c"
      else if (! (((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) ) 
      || ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [2 + i ] ) ) == (scheme_false ) ) ) {
        o = px -> prev ; 
      }

# 2084 "./../src/struct.c"
      else {
#       define XfOrM227_COUNT (0+XfOrM226_COUNT)
#       define SETUP_XfOrM227(x) SETUP_XfOrM226(x)

# 2086 "./../src/struct.c"
        {

# 24 "./../src/mzstkchk.h"
          uintptr_t _stk_pos ; 
#         define XfOrM231_COUNT (0+XfOrM227_COUNT)
#         define SETUP_XfOrM231(x) SETUP_XfOrM227(x)

# 26 "./../src/mzstkchk.h"
          _stk_pos = (uintptr_t ) & _stk_pos ; 

          if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
          && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) )

# 2088 "./../src/struct.c"
          RET_VALUE_START (FUNCCALL(SETUP_XfOrM231(_), chaperone_struct_ref_overflow (who , prim , orig_o , o , i ) )) RET_VALUE_END ; 
        }


        red = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [2 + i ] ; 
        if ((Scheme_Type ) (((((intptr_t ) (red ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (red ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#         define XfOrM230_COUNT (0+XfOrM227_COUNT)
#         define SETUP_XfOrM230(x) SETUP_XfOrM227(x)

          a [0 ] = px -> prev ; 
          orig = FUNCCALL(SETUP_XfOrM230(_), scheme_do_eval ((((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . car ) , 1 , a , 1 ) ); 
          red = (((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . cdr ) ; 
        }

# 2100 "./../src/struct.c"
        else 
        orig = FUNCCALL(SETUP_XfOrM227(_), chaperone_struct_ref (who , prim , orig_o , px -> prev , i ) ); 

        a [0 ] = orig_o ; 
        a [1 ] = orig ; 
        if ((Scheme_Type ) (((((intptr_t ) (red ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (red ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) )  {
#         define XfOrM228_COUNT (0+XfOrM227_COUNT)
#         define SETUP_XfOrM228(x) SETUP_XfOrM227(x)

# 2106 "./../src/struct.c"
          o = FUNCCALL(SETUP_XfOrM228(_), _scheme_apply_native (red , 2 , a ) ); 
          if (o == ((Scheme_Object * ) 0x6 ) ) {
            GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#           define XfOrM229_COUNT (0+XfOrM228_COUNT)
#           define SETUP_XfOrM229(x) SETUP_XfOrM228(x)
            FUNCCALL(SETUP_XfOrM229(_), scheme_wrong_return_arity (((void * ) 0 ) , 1 , p -> ku . multiple . count , p -> ku . multiple . array , ((void * ) 0 ) ) ); 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
        }

# 2114 "./../src/struct.c"
        else 
        o = FUNCCALL(SETUP_XfOrM227(_), scheme_do_eval (red , 2 , a , 1 ) ); 

        if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
          if (! ((o ) == (orig ) ) && ! FUNCCALL(SETUP_XfOrM227(_), scheme_chaperone_of (o , orig ) ))
          FUNCCALL(SETUP_XfOrM227(_), scheme_wrong_chaperoned (who , "result" , orig , o ) ); 

        RET_VALUE_START (o ) RET_VALUE_END ; 
      }
    }
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2127 "./../src/struct.c"
Scheme_Object * scheme_struct_ref (Scheme_Object * sv , int pos ) 
{
  /* No conversion */

# 2129 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (sv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sv ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (sv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sv ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    return chaperone_struct_ref ("struct-ref" , ((void * ) 0 ) , sv , sv , pos ) ; 
  }

# 2131 "./../src/struct.c"
  else {
    Scheme_Structure * s = (Scheme_Structure * ) sv ; 

    return s -> slots [pos ] ; 
  }
}

static void chaperone_struct_set (const char * who , Scheme_Object * prim , 
Scheme_Object * o , int i , Scheme_Object * v ) ; 

static Scheme_Object * chaperone_struct_set_k (void ) 
{
  /* No conversion */

# 2143 "./../src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * o = (Scheme_Object * ) p -> ku . k . p1 ; 
  Scheme_Object * prim = (Scheme_Object * ) p -> ku . k . p3 ; 
  const char * who = (const char * ) p -> ku . k . p2 ; 
  Scheme_Object * v = (Scheme_Object * ) p -> ku . k . p4 ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 
  p -> ku . k . p2 = ((void * ) 0 ) ; 
  p -> ku . k . p3 = ((void * ) 0 ) ; 
  p -> ku . k . p4 = ((void * ) 0 ) ; 

  chaperone_struct_set (who , prim , o , p -> ku . k . i1 , v ) ; 

  return scheme_false ; 
}

static void chaperone_struct_set_overflow (const char * who , Scheme_Object * prim , 
Scheme_Object * o , int i , Scheme_Object * v ) 
{
  /* No conversion */

# 2162 "./../src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 

  p -> ku . k . p1 = (void * ) o ; 
  p -> ku . k . p2 = (void * ) who ; 
  p -> ku . k . p3 = (void * ) prim ; 
  p -> ku . k . p4 = (void * ) v ; 
  p -> ku . k . i1 = i ; 

  (void ) scheme_handle_stack_overflow (chaperone_struct_set_k ) ; 
}

static void chaperone_struct_set (const char * who , Scheme_Object * prim , 
Scheme_Object * o , int i , Scheme_Object * v ) 
{
  Scheme_Object * orig_o = o ; 

# 24 "./../src/mzstkchk.h"
  uintptr_t _stk_pos ; 
  PREPARE_VAR_STACK(11);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(orig_o, 1), PUSH(prim, 2), PUSH(o, 3), PUSH(who, 4)));
# define XfOrM241_COUNT (5)
# define SETUP_XfOrM241(x) SETUP(XfOrM241_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 26 "./../src/mzstkchk.h"
  _stk_pos = (uintptr_t ) & _stk_pos ; 

  if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
  && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 2180 "./../src/struct.c"
  {
#   define XfOrM264_COUNT (0+XfOrM241_COUNT)
#   define SETUP_XfOrM264(x) SETUP_XfOrM241(x)
    FUNCCALL(SETUP_XfOrM264(_), chaperone_struct_set_overflow (who , prim , o , i , v ) )
# 2181 "./../src/struct.c"
    ; 
    RET_NOTHING ; 
  }


  while (1 ) {
#   define XfOrM253_COUNT (0+XfOrM241_COUNT)
#   define SETUP_XfOrM253(x) SETUP_XfOrM241(x)

# 2187 "./../src/struct.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
      ((Scheme_Structure * ) o ) -> slots [i ] = v ; 
      RET_NOTHING ; 
    }

# 2190 "./../src/struct.c"
    else {
      Scheme_Chaperone * px = (Scheme_Chaperone * ) o ; 
      Scheme_Object * a [2 ] , * red ; 
      int half ; 
      BLOCK_SETUP((PUSH(red, 0+XfOrM253_COUNT), PUSHARRAY(a, 2, 1+XfOrM253_COUNT), PUSH(px, 4+XfOrM253_COUNT)));
#     define XfOrM254_COUNT (5+XfOrM253_COUNT)
#     define SETUP_XfOrM254(x) SETUP(XfOrM254_COUNT)
      a[0] = NULLED_OUT ; 
      a[1] = NULLED_OUT ; 
      red = NULLED_OUT ; 

# 2195 "./../src/struct.c"
      o = px -> prev ; 
      if ((((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) ) 
      && ! (((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) == (scheme_undefined ) ) ) {
#       define XfOrM257_COUNT (0+XfOrM254_COUNT)
#       define SETUP_XfOrM257(x) SETUP_XfOrM254(x)

# 2198 "./../src/struct.c"
        half = ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) - 2 ) >> 1 ; 
        red = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [2 + half + i ] ; 
        if (! (((red ) ) == (scheme_false ) ) )  {
          Scheme_Object * finish_setter = ((void * ) 0 ) ; 
          BLOCK_SETUP((PUSH(finish_setter, 0+XfOrM257_COUNT)));
#         define XfOrM258_COUNT (1+XfOrM257_COUNT)
#         define SETUP_XfOrM258(x) SETUP(XfOrM258_COUNT)

# 2203 "./../src/struct.c"
          a [0 ] = orig_o ; 
          a [1 ] = v ; 

          if ((Scheme_Type ) (((((intptr_t ) (red ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (red ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
            finish_setter = (((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . car ) ; 
            red = (((Scheme_Simple_Object * ) (red ) ) -> u . pair_val . cdr ) ; 
          }

          if ((Scheme_Type ) (((((intptr_t ) (red ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (red ) ) -> type ) ) == (Scheme_Type ) (scheme_native_closure_type ) )  {
#           define XfOrM260_COUNT (0+XfOrM258_COUNT)
#           define SETUP_XfOrM260(x) SETUP_XfOrM258(x)

# 2212 "./../src/struct.c"
            v = FUNCCALL(SETUP_XfOrM260(_), _scheme_apply_native (red , 2 , a ) ); 
            if (v == ((Scheme_Object * ) 0x6 ) ) {
              GC_CAN_IGNORE Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
#             define XfOrM261_COUNT (0+XfOrM260_COUNT)
#             define SETUP_XfOrM261(x) SETUP_XfOrM260(x)
              FUNCCALL(SETUP_XfOrM261(_), scheme_wrong_return_arity (((void * ) 0 ) , 1 , p -> ku . multiple . count , p -> ku . multiple . array , ((void * ) 0 ) ) ); 
            }
          }

# 2219 "./../src/struct.c"
          else 
          v = FUNCCALL(SETUP_XfOrM258(_), scheme_do_eval (red , 2 , a , 1 ) ); 

          if (! ((& (px ) -> iso ) -> so . keyex & 0x1 ) )
            if (! ((v ) == (a [1 ] ) ) && ! FUNCCALL(SETUP_XfOrM258(_), scheme_chaperone_of (v , a [1 ] ) ))
            FUNCCALL(SETUP_XfOrM258(_), scheme_wrong_chaperoned (who , "value" , a [1 ] , v ) ); 

          if (finish_setter ) {
#           define XfOrM259_COUNT (0+XfOrM258_COUNT)
#           define SETUP_XfOrM259(x) SETUP_XfOrM258(x)
            a [0 ] = o ; 
            a [1 ] = v ; 
            (void ) FUNCCALL(SETUP_XfOrM259(_), scheme_do_eval (finish_setter , 2 , a , - 1 ) ); 
            RET_NOTHING ; 
          }
        }
      }

# 2235 "./../src/struct.c"
      else if ((((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) ) 
      && (((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) == (scheme_undefined ) ) ) {
#       define XfOrM255_COUNT (0+XfOrM254_COUNT)
#       define SETUP_XfOrM255(x) SETUP_XfOrM254(x)

        if ((scheme_undefined ) == (((Scheme_Structure * ) px -> val ) -> slots [i ] ) )  {
          Scheme_Object * m ; 
          BLOCK_SETUP((PUSH(m, 0+XfOrM255_COUNT)));
#         define XfOrM256_COUNT (1+XfOrM255_COUNT)
#         define SETUP_XfOrM256(x) SETUP(XfOrM256_COUNT)
          m = NULLED_OUT ; 

# 2243 "./../src/struct.c"
          m = FUNCCALL(SETUP_XfOrM256(_), scheme_extract_one_cc_mark (((void * ) 0 ) , scheme_chaperone_undefined_property ) ); 
          if (! m || ! ((m ) == (scheme_undefined ) ) )
            FUNCCALL(SETUP_XfOrM256(_), raise_undefined_error (who , prim , px -> val , "assignment disallowed" , "assign" , i ) ); 
        }
      }
    }
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2252 "./../src/struct.c"
void scheme_struct_set (Scheme_Object * sv , int pos , Scheme_Object * v ) 
{
  PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(sv, 1)));
# define XfOrM265_COUNT (2)
# define SETUP_XfOrM265(x) SETUP(XfOrM265_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2254 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (sv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sv ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (sv ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (sv ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
#   define XfOrM267_COUNT (0+XfOrM265_COUNT)
#   define SETUP_XfOrM267(x) SETUP_XfOrM265(x)
    FUNCCALL(SETUP_XfOrM267(_), chaperone_struct_set ("struct-set!" , ((void * ) 0 ) , sv , pos , v ) )
# 2255 "./../src/struct.c"
    ; 
  }

# 2256 "./../src/struct.c"
  else {
    Scheme_Structure * s = (Scheme_Structure * ) sv ; 

    s -> slots [pos ] = v ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2263 "./../src/struct.c"
int scheme_is_noninterposing_chaperone (Scheme_Object * o ) 



{
  /* No conversion */

# 2268 "./../src/struct.c"
  Scheme_Chaperone * px = (Scheme_Chaperone * ) o ; 
  int i ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) )
    return 0 ; 

  if ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) {

    if ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ) ) == (scheme_false ) ) 
      return 1 ; 
    return 0 ; 
  }

  if ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) == 0 ) {

    return 1 ; 
  }

  if (! ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [0 ] ) ) == (scheme_false ) ) ) 
    return 0 ; 

  for (i = (((Scheme_Vector * ) (px -> redirects ) ) -> size ) ; i -- > 2 ; ) {
    if (! ((((((Scheme_Vector * ) (px -> redirects ) ) -> els ) [i ] ) ) == (scheme_false ) ) )
      return 0 ; 
  }

  return 1 ; 
}

static Scheme_Object * * apply_guards (Scheme_Struct_Type * stype , int argc , Scheme_Object * * args , 
int * _chaperone_undefined ) 
{
  Scheme_Object * * guard_argv = ((void * ) 0 ) , * v , * prev_guards = ((void * ) 0 ) , * guard ; 
  int p , gcount ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(args, 0), PUSH(guard, 1), PUSH(guard_argv, 2), PUSH(stype, 3), PUSH(v, 4), PUSH(prev_guards, 5), PUSH(_chaperone_undefined, 6)));
# define XfOrM273_COUNT (7)
# define SETUP_XfOrM273(x) SETUP(XfOrM273_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  guard = NULLED_OUT ; 

# 2303 "./../src/struct.c"
  for (p = stype -> name_pos ; p >= 0 ; p -- ) {
#   define XfOrM289_COUNT (0+XfOrM273_COUNT)
#   define SETUP_XfOrM289(x) SETUP_XfOrM273(x)

# 2304 "./../src/struct.c"
    if (stype -> parent_types [p ] -> guard || prev_guards ) {
      int got ; 
#     define XfOrM290_COUNT (0+XfOrM289_COUNT)
#     define SETUP_XfOrM290(x) SETUP_XfOrM289(x)

# 2307 "./../src/struct.c"
      if (! guard_argv ) {
#       define XfOrM303_COUNT (0+XfOrM290_COUNT)
#       define SETUP_XfOrM303(x) SETUP_XfOrM290(x)

# 2308 "./../src/struct.c"
        guard_argv = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM303(_), GC_malloc (sizeof (Scheme_Object * ) * (argc + 1 ) ) )) ; 
        (memcpy (guard_argv , args , sizeof (Scheme_Object * ) * argc ) ) ; 
        args = guard_argv ; 
      }

      if (! prev_guards )
        prev_guards = scheme_null ; 
      while (prev_guards ) {
#       define XfOrM297_COUNT (0+XfOrM290_COUNT)
#       define SETUP_XfOrM297(x) SETUP_XfOrM290(x)

# 2316 "./../src/struct.c"
        if ((Scheme_Type ) (((((intptr_t ) (prev_guards ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (prev_guards ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
          guard = (((Scheme_Simple_Object * ) (prev_guards ) ) -> u . pair_val . car ) ; 
        else {
          guard = stype -> parent_types [p ] -> guard ; 

          if (guard ) {
            if ((Scheme_Type ) (((((intptr_t ) (guard ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (guard ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 

# 2322 "./../src/struct.c"
            guard = (((Scheme_Simple_Object * ) (guard ) ) -> u . pair_val . car ) ; 
          }

# 2323 "./../src/struct.c"
          else 
          guard = scheme_false ; 
        }

        if ((guard ) == (scheme_undefined ) ) 
          * _chaperone_undefined = 1 ; 
        else if (! (((guard ) ) == (scheme_false ) ) ) {
#         define XfOrM298_COUNT (0+XfOrM297_COUNT)
#         define SETUP_XfOrM298(x) SETUP_XfOrM297(x)

# 2330 "./../src/struct.c"
          gcount = stype -> parent_types [p ] -> num_islots ; 
          guard_argv [argc ] = guard_argv [gcount ] ; 
          guard_argv [gcount ] = stype -> name ; 
          v = FUNCCALL(SETUP_XfOrM298(_), scheme_do_eval (guard , gcount + 1 , guard_argv , - 1 ) ); 
          got = (((v ) == (((Scheme_Object * ) 0x6 ) ) ) ? (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . count ) : 1 ) ; 
          if (gcount != got ) {
#           define XfOrM300_COUNT (0+XfOrM298_COUNT)
#           define SETUP_XfOrM300(x) SETUP_XfOrM298(x)
            FUNCCALL(SETUP_XfOrM300(_), scheme_wrong_return_arity ("constructor" , gcount , got , (got == 1 ) ? (Scheme_Object * * ) v : (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) , "calling guard procedure" ) )
            ; 
            RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
          }
          if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
#           define XfOrM299_COUNT (0+XfOrM298_COUNT)
#           define SETUP_XfOrM299(x) SETUP_XfOrM298(x)

# 2343 "./../src/struct.c"
            if (gcount )
              (memcpy (guard_argv , (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) , gcount * sizeof (Scheme_Object * ) ) ) ; 
          }

# 2345 "./../src/struct.c"
          else 
          guard_argv [0 ] = v ; 
          guard_argv [gcount ] = guard_argv [argc ] ; 
        }

        if ((prev_guards ) == (scheme_null ) ) 
          prev_guards = ((void * ) 0 ) ; 
        else 
        prev_guards = (((Scheme_Simple_Object * ) (prev_guards ) ) -> u . pair_val . cdr ) ; 
      }
    }


    if (stype -> parent_types [p ] -> guard 
    && ((Scheme_Type ) (((((intptr_t ) (stype -> parent_types [p ] -> guard ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (stype -> parent_types [p ] -> guard ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      prev_guards = (((Scheme_Simple_Object * ) (stype -> parent_types [p ] -> guard ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START (args ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2368 "./../src/struct.c"
Scheme_Object * 
scheme_make_struct_instance (Scheme_Object * _stype , int argc , Scheme_Object * * args ) 
{
  Scheme_Structure * inst ; 
  Scheme_Struct_Type * stype ; 
  int p , i , j , nis , ns , c ; 
  int chaperone_undefined = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(args, 1), PUSH(inst, 2)));
# define XfOrM304_COUNT (3)
# define SETUP_XfOrM304(x) SETUP(XfOrM304_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 
  stype = NULLED_OUT ; 

# 2376 "./../src/struct.c"
  stype = (Scheme_Struct_Type * ) _stype ; 

  c = stype -> num_slots ; 
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM304(_), GC_malloc_one_tagged ((sizeof (Scheme_Structure ) + (((c ) - 0 ) * sizeof (Scheme_Object * ) ) ) ) )
  ; 

  inst -> so . type = (stype -> proc_attr ? scheme_proc_struct_type : scheme_structure_type ) ; 
  inst -> stype = stype ; 


  args = FUNCCALL(SETUP_XfOrM304(_), apply_guards (stype , argc , args , & chaperone_undefined ) ); 


  j = c ; 
  i = argc ; 
  for (p = stype -> name_pos ; p >= 0 ; p -- ) {

    if (p ) {
      ns = stype -> parent_types [p ] -> num_slots - stype -> parent_types [p - 1 ] -> num_slots ; 
      nis = stype -> parent_types [p ] -> num_islots - stype -> parent_types [p - 1 ] -> num_islots ; 
    }

# 2396 "./../src/struct.c"
    else {
      ns = stype -> parent_types [0 ] -> num_slots ; 
      nis = stype -> parent_types [0 ] -> num_islots ; 
    }

    ns -= nis ; 


    while (ns -- ) {
      inst -> slots [-- j ] = stype -> parent_types [p ] -> uninit_val ; 
    }


    while (nis -- ) {
      inst -> slots [-- j ] = args [-- i ] ; 
    }
  }

  if (chaperone_undefined )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_chaperone_not_undefined ((Scheme_Object * ) inst ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2420 "./../src/struct.c"
Scheme_Object * scheme_make_blank_prefab_struct_instance (Scheme_Struct_Type * stype ) 
{
  Scheme_Structure * inst ; 
  int c ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(inst, 1)));
# define XfOrM319_COUNT (2)
# define SETUP_XfOrM319(x) SETUP(XfOrM319_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 2425 "./../src/struct.c"
  c = stype -> num_slots ; 
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM319(_), GC_malloc_one_tagged ((sizeof (Scheme_Structure ) + (((c ) - 0 ) * sizeof (Scheme_Object * ) ) ) ) )
  ; 

  inst -> so . type = scheme_structure_type ; 
  inst -> stype = stype ; 

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2436 "./../src/struct.c"
Scheme_Object * scheme_make_serialized_struct_instance (Scheme_Object * prefab_key , int num_slots ) 
{
  Scheme_Serialized_Structure * inst ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(inst, 0), PUSH(prefab_key, 1)));
# define XfOrM320_COUNT (2)
# define SETUP_XfOrM320(x) SETUP(XfOrM320_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 2440 "./../src/struct.c"
  inst = (Scheme_Serialized_Structure * ) FUNCCALL(SETUP_XfOrM320(_), GC_malloc_one_tagged (sizeof (Scheme_Serialized_Structure ) + ((num_slots - 0 ) * sizeof (Scheme_Object * ) ) ) )

  ; 

  inst -> so . type = scheme_serialized_structure_type ; 
  inst -> num_slots = num_slots ; 
  inst -> prefab_key = prefab_key ; 

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2452 "./../src/struct.c"
Scheme_Object * scheme_make_prefab_struct_instance (Scheme_Struct_Type * stype , 
Scheme_Object * vec ) 
{
  Scheme_Structure * inst ; 
  int i , c ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(vec, 1), PUSH(inst, 2)));
# define XfOrM321_COUNT (3)
# define SETUP_XfOrM321(x) SETUP(XfOrM321_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 2458 "./../src/struct.c"
  c = stype -> num_slots ; 
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM321(_), GC_malloc_one_tagged ((sizeof (Scheme_Structure ) + (((c ) - 0 ) * sizeof (Scheme_Object * ) ) ) ) )
  ; 

  inst -> so . type = scheme_structure_type ; 
  inst -> stype = stype ; 

  for (i = 0 ; i < c ; i ++ ) {
    inst -> slots [i ] = (((Scheme_Vector * ) (vec ) ) -> els ) [i + 1 ] ; 
  }

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2472 "./../src/struct.c"
Scheme_Object * scheme_clone_prefab_struct_instance (Scheme_Structure * s ) 
{
  Scheme_Object * chaperone , * v ; 
  Scheme_Structure * inst ; 
  int c , sz , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(s, 1), PUSH(inst, 2), PUSH(chaperone, 3)));
# define XfOrM324_COUNT (4)
# define SETUP_XfOrM324(x) SETUP(XfOrM324_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  chaperone = NULLED_OUT ; 
  v = NULLED_OUT ; 
  inst = NULLED_OUT ; 

# 2478 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    chaperone = (Scheme_Object * ) s ; 
    s = (Scheme_Structure * ) (((Scheme_Chaperone * ) chaperone ) -> val ) ; 
  }

# 2481 "./../src/struct.c"
  else 
  chaperone = ((void * ) 0 ) ; 

  c = s -> stype -> num_slots ; 
  sz = (sizeof (Scheme_Structure ) + (((c ) - 0 ) * sizeof (Scheme_Object * ) ) ) ; 
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM324(_), GC_malloc_one_tagged (sz ) ); 
  (memcpy (inst , s , sz ) ) ; 

  if (chaperone ) {
#   define XfOrM325_COUNT (0+XfOrM324_COUNT)
#   define SETUP_XfOrM325(x) SETUP_XfOrM324(x)

# 2490 "./../src/struct.c"
    for (i = 0 ; i < c ; i ++ ) {
#     define XfOrM327_COUNT (0+XfOrM325_COUNT)
#     define SETUP_XfOrM327(x) SETUP_XfOrM325(x)

# 2491 "./../src/struct.c"
      v = FUNCCALL(SETUP_XfOrM327(_), scheme_struct_ref (chaperone , i ) ); 
      inst -> slots [i ] = v ; 
    }
  }

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2499 "./../src/struct.c"
static Scheme_Object * 
make_struct_instance (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  /* No conversion */

# 2502 "./../src/struct.c"
  return scheme_make_struct_instance (((Scheme_Primitive_Closure * ) prim ) -> val [0 ] , argc , args ) ; 
}

static Scheme_Object * 
make_simple_struct_instance (int argc , Scheme_Object * * args , Scheme_Object * prim ) 

{
  Scheme_Structure * inst ; 
  Scheme_Struct_Type * stype = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 
  int i , c ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(args, 1), PUSH(inst, 2)));
# define XfOrM330_COUNT (3)
# define SETUP_XfOrM330(x) SETUP(XfOrM330_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 2513 "./../src/struct.c"
  c = stype -> num_slots ; 
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM330(_), GC_malloc_one_tagged ((sizeof (Scheme_Structure ) + (((c ) - 0 ) * sizeof (Scheme_Object * ) ) ) ) )
  ; 

  inst -> so . type = scheme_structure_type ; 
  inst -> stype = stype ; 

  for (i = 0 ; i < argc ; i ++ ) {
    inst -> slots [i ] = args [i ] ; 
  }

  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2527 "./../src/struct.c"
int scheme_is_simple_struct_type (Scheme_Struct_Type * stype ) 
{
  /* No conversion */

# 2529 "./../src/struct.c"
  int p ; 

  if (stype -> proc_attr )
    return 0 ; 

  for (p = stype -> name_pos ; p >= 0 ; p -- ) {
    if (stype -> parent_types [p ] -> guard )
      return 0 ; 
    if (stype -> parent_types [p ] -> num_slots != stype -> parent_types [p ] -> num_islots )
      return 0 ; 
  }

  return 1 ; 
}

static Scheme_Object * struct_pred (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  /* No conversion */

# 2546 "./../src/struct.c"
  Scheme_Object * v = args [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 2548 "./../src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
    Scheme_Struct_Type * stype = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 
    if ((stype -> name_pos <= ((Scheme_Structure * ) v ) -> stype -> name_pos ) && (stype == ((Scheme_Structure * ) v ) -> stype -> parent_types [stype -> name_pos ] ) ) 
      return scheme_true ; 
  }

  return scheme_false ; 
}

static int parse_pos (const char * who , Scheme_Object * prim , Scheme_Object * * args , int argc ) 
{
  int pos ; 
  Scheme_Struct_Type * st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(args, 0), PUSH(st, 1), PUSH(prim, 2), PUSH(who, 3)));
# define XfOrM338_COUNT (4)
# define SETUP_XfOrM338(x) SETUP(XfOrM338_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 2564 "./../src/struct.c"
  if (! (((intptr_t ) (args [1 ] ) ) & 0x1 ) || ((((intptr_t ) (args [1 ] ) ) >> 1 ) < 0 ) ) {
#   define XfOrM340_COUNT (0+XfOrM338_COUNT)
#   define SETUP_XfOrM340(x) SETUP_XfOrM338(x)

# 2565 "./../src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (args [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (args [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) args [1 ] ) -> iso ) -> so . keyex & 0x1 ) ) {
      pos = (32768 + 1 ) ; 
    }

# 2567 "./../src/struct.c"
    else {
#     define XfOrM341_COUNT (0+XfOrM340_COUNT)
#     define SETUP_XfOrM341(x) SETUP_XfOrM340(x)

# 2568 "./../src/struct.c"
      if (! who )
        who = FUNCCALL(SETUP_XfOrM341(_), extract_field_proc_name (prim ) ); 
      FUNCCALL_EMPTY(scheme_wrong_contract (who , "exact-nonnegative-integer?" , 1 , argc , args ) )

      ; 
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    }
  }

# 2575 "./../src/struct.c"
  else 
  pos = (((intptr_t ) (args [1 ] ) ) >> 1 ) ; 

  if ((pos < st -> num_slots ) 
  && st -> name_pos )
    pos += st -> parent_types [st -> name_pos - 1 ] -> num_slots ; 

  if (pos >= st -> num_slots ) {
    int sc ; 
#   define XfOrM339_COUNT (0+XfOrM338_COUNT)
#   define SETUP_XfOrM339(x) SETUP_XfOrM338(x)

# 2585 "./../src/struct.c"
    if (! who )
      who = FUNCCALL(SETUP_XfOrM339(_), extract_field_proc_name (prim ) ); 

    sc = (st -> name_pos 
    ? (st -> num_slots 
    - st -> parent_types [st -> name_pos - 1 ] -> num_slots ) 
    : st -> num_slots ) ; 
    FUNCCALL_EMPTY(scheme_contract_error (who , "index too large" , "index" , 1 , args [1 ] , "maximum allowed index" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (sc - 1 ) ) ) << 1 ) | 0x1 ) ) , "structure" , 1 , args [0 ] , ((void * ) 0 ) ) )





    ; 

    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

  RET_VALUE_START (pos ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2606 "./../src/struct.c"
Scheme_Object * scheme_struct_getter (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  Scheme_Structure * inst ; 
  int pos ; 
  Scheme_Struct_Type * st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 

# 213 "./../src/struct.c"
  char * __funcarg135 = NULLED_OUT ; 

# 1462 "./../src/struct.c"
  char * __funcarg134 = NULLED_OUT ; 

# 1462 "./../src/struct.c"
  char * __funcarg133 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(st, 0), PUSH(args, 1), PUSH(__funcarg134, 2), PUSH(inst, 3), PUSH(prim, 4)));
# define XfOrM343_COUNT (5)
# define SETUP_XfOrM343(x) SETUP(XfOrM343_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 2612 "./../src/struct.c"
  inst = (Scheme_Structure * ) args [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    inst = (Scheme_Structure * ) (((Scheme_Chaperone * ) (Scheme_Object * ) inst ) -> val ) ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) {
#   define XfOrM345_COUNT (0+XfOrM343_COUNT)
#   define SETUP_XfOrM345(x) SETUP_XfOrM343(x)
    (__funcarg134 = FUNCCALL(SETUP_XfOrM345(_), extract_field_proc_name (prim ) )
# 2617 "./../src/struct.c"
    , __funcarg135 = FUNCCALL(SETUP_XfOrM345(_), pred_name_string (st -> name ) )
    , FUNCCALL_EMPTY(scheme_wrong_contract (__funcarg134 , __funcarg135 , 0 , argc , args ) )) 
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

# 2621 "./../src/struct.c"
  else if (! ((st -> name_pos <= inst -> stype -> name_pos ) && (st == inst -> stype -> parent_types [st -> name_pos ] ) ) ) {
#   define XfOrM344_COUNT (0+XfOrM343_COUNT)
#   define SETUP_XfOrM344(x) SETUP_XfOrM343(x)
    (__funcarg133 = FUNCCALL(SETUP_XfOrM344(_), extract_field_proc_name (prim ) )
# 2622 "./../src/struct.c"
    , FUNCCALL_AGAIN(wrong_struct_type (__funcarg133 , st -> name , ((((Scheme_Structure * ) inst ) -> stype ) -> name ) , 0 , argc , args ) )) 


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argc == 2 )
    pos = FUNCCALL(SETUP_XfOrM343(_), parse_pos (((void * ) 0 ) , prim , args , argc ) ); 
  else 
  pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) prim ) -> val [1 ] ) ) >> 1 ) ; 

  if (((Scheme_Object * ) inst ) == (args [0 ] ) ) 
    RET_VALUE_START (inst -> slots [pos ] ) RET_VALUE_END ; 
  else 
  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(chaperone_struct_ref ("struct-ref" , prim , args [0 ] , args [0 ] , pos ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2640 "./../src/struct.c"
Scheme_Object * scheme_struct_setter (int argc , Scheme_Object * * args , Scheme_Object * prim ) 
{
  Scheme_Structure * inst ; 
  int pos ; 
  Scheme_Object * v ; 
  Scheme_Struct_Type * st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) prim ) -> val [0 ] ; 

# 213 "./../src/struct.c"
  char * __funcarg139 = NULLED_OUT ; 

# 1462 "./../src/struct.c"
  char * __funcarg138 = NULLED_OUT ; 

# 1462 "./../src/struct.c"
  char * __funcarg137 = NULLED_OUT ; 

# 1462 "./../src/struct.c"
  char * __funcarg136 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(st, 0), PUSH(args, 1), PUSH(__funcarg138, 2), PUSH(inst, 3), PUSH(v, 4), PUSH(prim, 5)));
# define XfOrM346_COUNT (6)
# define SETUP_XfOrM346(x) SETUP(XfOrM346_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 2647 "./../src/struct.c"
  inst = (Scheme_Structure * ) args [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    inst = (Scheme_Structure * ) (((Scheme_Chaperone * ) (Scheme_Object * ) inst ) -> val ) ; 

  if (! (((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) inst ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) inst ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) {
#   define XfOrM352_COUNT (0+XfOrM346_COUNT)
#   define SETUP_XfOrM352(x) SETUP_XfOrM346(x)
    (__funcarg138 = FUNCCALL(SETUP_XfOrM352(_), extract_field_proc_name (prim ) )
# 2652 "./../src/struct.c"
    , __funcarg139 = FUNCCALL(SETUP_XfOrM352(_), pred_name_string (st -> name ) )
    , FUNCCALL_EMPTY(scheme_wrong_contract (__funcarg138 , __funcarg139 , 0 , argc , args ) )) 
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (! ((st -> name_pos <= inst -> stype -> name_pos ) && (st == inst -> stype -> parent_types [st -> name_pos ] ) ) ) {
#   define XfOrM351_COUNT (0+XfOrM346_COUNT)
#   define SETUP_XfOrM351(x) SETUP_XfOrM346(x)
    (__funcarg137 = FUNCCALL(SETUP_XfOrM351(_), extract_field_proc_name (prim ) )
# 2659 "./../src/struct.c"
    , FUNCCALL_AGAIN(wrong_struct_type (__funcarg137 , st -> name , ((((Scheme_Structure * ) inst ) -> stype ) -> name ) , 0 , argc , args ) )) 


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (argc == 3 ) {
#   define XfOrM350_COUNT (0+XfOrM346_COUNT)
#   define SETUP_XfOrM350(x) SETUP_XfOrM346(x)

# 2667 "./../src/struct.c"
    pos = FUNCCALL(SETUP_XfOrM350(_), parse_pos (((void * ) 0 ) , prim , args , argc ) ); 
    v = args [2 ] ; 
  }

# 2669 "./../src/struct.c"
  else {
    pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) prim ) -> val [1 ] ) ) >> 1 ) ; 
    v = args [1 ] ; 
  }

  if (st -> immutables ) {
    int p = pos ; 
#   define XfOrM347_COUNT (0+XfOrM346_COUNT)
#   define SETUP_XfOrM347(x) SETUP_XfOrM346(x)

# 2677 "./../src/struct.c"
    if (st -> name_pos )
      p -= st -> parent_types [st -> name_pos - 1 ] -> num_slots ; 

    if (st -> immutables [p ] ) {
#     define XfOrM348_COUNT (0+XfOrM347_COUNT)
#     define SETUP_XfOrM348(x) SETUP_XfOrM347(x)
      (__funcarg136 = FUNCCALL(SETUP_XfOrM348(_), extract_field_proc_name (prim ) )
# 2681 "./../src/struct.c"
      , FUNCCALL_EMPTY(scheme_contract_error (__funcarg136 , "cannot modify value of immutable field in structure" , "structure" , 1 , args [0 ] , "field index" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (pos ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )) 



      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  if (((Scheme_Object * ) inst ) == (args [0 ] ) ) 
    inst -> slots [pos ] = v ; 
  else FUNCCALL_EMPTY(chaperone_struct_set ("struct-set!" , prim , args [0 ] , pos , v ) )
  ; 

  RET_VALUE_START (scheme_void ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2698 "./../src/struct.c"
static Scheme_Object * 
struct_p (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * v = argv [0 ] ; 
  Scheme_Config * __funcarg140 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(2);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM353_COUNT (1)
# define SETUP_XfOrM353(x) SETUP(XfOrM353_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2703 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
    Scheme_Object * insp ; 
    BLOCK_SETUP((PUSH(insp, 0+XfOrM353_COUNT)));
#   define XfOrM354_COUNT (1+XfOrM353_COUNT)
#   define SETUP_XfOrM354(x) SETUP(XfOrM354_COUNT)
    insp = NULLED_OUT ; 

# 2708 "./../src/struct.c"
    insp = (__funcarg140 = FUNCCALL(SETUP_XfOrM354(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg140 , MZCONFIG_INSPECTOR ) )) ; 
    if (FUNCCALL_EMPTY(scheme_inspector_sees_part (v , insp , - 1 ) ))
      RET_VALUE_START (scheme_true ) RET_VALUE_END ; 
    else 
    RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
  }

# 2713 "./../src/struct.c"
  else 
  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2717 "./../src/struct.c"
static Scheme_Object * 
struct_type_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2720 "./../src/struct.c"
  return ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * proc_struct_type_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 2726 "./../src/struct.c"
  Scheme_Object * v = argv [0 ] ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) )  {
    if (((Scheme_Struct_Type * ) v ) -> proc_attr )
      return scheme_true ; 
    else 
    return scheme_false ; 
  }
  scheme_wrong_contract ("procedure-struct-type?" , "struct-type?" , 0 , argc , argv ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * apply_chaperones (const char * who , Scheme_Object * procs , int argc , Scheme_Object * * a ) 
{
  Scheme_Object * v , * * vals , * v1 [1 ] ; 
  int cnt , i , is_impersonator ; 
  Scheme_Thread * p ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(vals, 0), PUSHARRAY(v1, 1, 1), PUSH(a, 4), PUSH(v, 5), PUSH(procs, 6), PUSH(p, 7), PUSH(who, 8)));
# define XfOrM358_COUNT (9)
# define SETUP_XfOrM358(x) SETUP(XfOrM358_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 
  vals = NULLED_OUT ; 
  v1[0] = NULLED_OUT ; 
  p = NULLED_OUT ; 

# 2747 "./../src/struct.c"
  while (((Scheme_Type ) (((((intptr_t ) (procs ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (procs ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM367_COUNT (0+XfOrM358_COUNT)
#   define SETUP_XfOrM367(x) SETUP_XfOrM358(x)

# 2748 "./../src/struct.c"
    v = (((Scheme_Simple_Object * ) (procs ) ) -> u . pair_val . car ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_box_type ) )  {
      is_impersonator = 1 ; 
      v = (((Scheme_Small_Object * ) (v ) ) -> u . ptr_val ) ; 
    }

# 2752 "./../src/struct.c"
    else 
    is_impersonator = 0 ; 

    v = FUNCCALL(SETUP_XfOrM367(_), scheme_do_eval (v , argc , a , - 1 ) ); 

    if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
      p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
      cnt = p -> ku . multiple . count ; 
      vals = p -> ku . multiple . array ; 
      p -> ku . multiple . array = ((void * ) 0 ) ; 
      if ((vals ) == (p -> values_buffer ) ) 
        p -> values_buffer = ((void * ) 0 ) ; 
      p = ((void * ) 0 ) ; 
    }

# 2765 "./../src/struct.c"
    else {
      v1 [0 ] = v ; 
      vals = v1 ; 
      cnt = 1 ; 
    }

    if (cnt != argc ) {
#     define XfOrM371_COUNT (0+XfOrM367_COUNT)
#     define SETUP_XfOrM371(x) SETUP_XfOrM367(x)
      FUNCCALL(SETUP_XfOrM371(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "%s: arity mismatch;\n" " received wrong number of values from %s replacement procedure\n" "  expected: %d\n" "  received: %d\n" "  %s: %V\n" , who , is_impersonator ? "an impersonator's" : "a chaperone's" , (((Scheme_Simple_Object * ) (procs ) ) -> u . pair_val . car ) , argc , cnt , is_impersonator ? "impersonator" : "chaperone" ) )







      ; 
    }

    if (! is_impersonator ) {
#     define XfOrM368_COUNT (0+XfOrM367_COUNT)
#     define SETUP_XfOrM368(x) SETUP_XfOrM367(x)

# 2786 "./../src/struct.c"
      for (i = 0 ; i < argc ; i ++ ) {
#       define XfOrM370_COUNT (0+XfOrM368_COUNT)
#       define SETUP_XfOrM370(x) SETUP_XfOrM368(x)

# 2787 "./../src/struct.c"
        if (! FUNCCALL(SETUP_XfOrM370(_), scheme_chaperone_of (vals [i ] , a [i ] ) ))
          FUNCCALL(SETUP_XfOrM370(_), scheme_wrong_chaperoned (who , "result" , a [i ] , vals [i ] ) ); 
      }
    }

    a = vals ; 
    procs = (((Scheme_Simple_Object * ) (procs ) ) -> u . pair_val . cdr ) ; 
  }

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM358(_), scheme_values (argc , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2799 "./../src/struct.c"
static Scheme_Object * struct_info_chaperone (Scheme_Object * o , Scheme_Object * si , Scheme_Object * b ) 
{
  Scheme_Object * procs = scheme_null , * proc , * a [2 ] ; 
  Scheme_Chaperone * px ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(procs, 0), PUSH(px, 1), PUSH(si, 2), PUSHARRAY(a, 2, 3), PUSH(b, 6), PUSH(o, 7), PUSH(proc, 8)));
# define XfOrM375_COUNT (9)
# define SETUP_XfOrM375(x) SETUP(XfOrM375_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  proc = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  px = NULLED_OUT ; 

# 2804 "./../src/struct.c"
  while ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
#   define XfOrM379_COUNT (0+XfOrM375_COUNT)
#   define SETUP_XfOrM379(x) SETUP_XfOrM375(x)

# 2805 "./../src/struct.c"
    px = (Scheme_Chaperone * ) o ; 
    if (((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) && (((Scheme_Vector * ) (px -> redirects ) ) -> size ) && ! ((((Scheme_Vector * ) (px -> redirects ) ) -> size ) & 1 ) )  {
#     define XfOrM380_COUNT (0+XfOrM379_COUNT)
#     define SETUP_XfOrM380(x) SETUP_XfOrM379(x)

# 2807 "./../src/struct.c"
      proc = (((Scheme_Vector * ) (px -> redirects ) ) -> els ) [1 ] ; 
      if ((! (((proc ) ) == (scheme_false ) ) ) && ! ((proc ) == (scheme_undefined ) ) ) {
#       define XfOrM381_COUNT (0+XfOrM380_COUNT)
#       define SETUP_XfOrM381(x) SETUP_XfOrM380(x)

# 2809 "./../src/struct.c"
        if ((& (px ) -> iso ) -> so . keyex & 0x1 )
          proc = FUNCCALL(SETUP_XfOrM381(_), scheme_box (proc ) ); 
        procs = FUNCCALL(SETUP_XfOrM381(_), scheme_make_pair (proc , procs ) ); 
      }
    }
    o = px -> prev ; 
  }

  a [0 ] = si ; 
  a [1 ] = b ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM375(_), apply_chaperones ("struct-info" , procs , 2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2823 "./../src/struct.c"
static Scheme_Object * struct_info (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Structure * s ; 
  Scheme_Struct_Type * stype ; 
  int p ; 
  Scheme_Object * insp , * a [2 ] ; 
  Scheme_Object * v = argv [0 ] ; 
  Scheme_Config * __funcarg141 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(argv, 1), PUSH(s, 2), PUSHARRAY(a, 2, 3), PUSH(v, 6), PUSH(insp, 7)));
# define XfOrM382_COUNT (8)
# define SETUP_XfOrM382(x) SETUP(XfOrM382_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  stype = NULLED_OUT ; 
  insp = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 

# 2831 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
#   define XfOrM383_COUNT (0+XfOrM382_COUNT)
#   define SETUP_XfOrM383(x) SETUP_XfOrM382(x)

# 2835 "./../src/struct.c"
    s = (Scheme_Structure * ) v ; 

    insp = (__funcarg141 = FUNCCALL(SETUP_XfOrM383(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg141 , MZCONFIG_INSPECTOR ) )) ; 

    stype = s -> stype ; 
    p = stype -> name_pos + 1 ; 

    while (p -- ) {
#     define XfOrM386_COUNT (0+XfOrM383_COUNT)
#     define SETUP_XfOrM386(x) SETUP_XfOrM383(x)

# 2843 "./../src/struct.c"
      stype = stype -> parent_types [p ] ; 
      if (scheme_is_subinspector (stype -> inspector , insp ) )  {
#       define XfOrM387_COUNT (0+XfOrM386_COUNT)
#       define SETUP_XfOrM387(x) SETUP_XfOrM386(x)

# 2845 "./../src/struct.c"
        a [0 ] = (Scheme_Object * ) stype ; 
        a [1 ] = ((((stype ) == (s -> stype ) ) ) ? scheme_false : scheme_true ) ; 

        if (! ((v ) == (argv [0 ] ) ) )
          RET_VALUE_START (FUNCCALL(SETUP_XfOrM387(_), struct_info_chaperone (argv [0 ] , a [0 ] , a [1 ] ) )) RET_VALUE_END ; 
        else 
        RET_VALUE_START (FUNCCALL(SETUP_XfOrM387(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
      }
    }
  }

  a [0 ] = scheme_false ; 
  a [1 ] = scheme_true ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM382(_), scheme_values (2 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2862 "./../src/struct.c"
static Scheme_Object * check_type_and_inspector (const char * who , int always , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * insp , * val ; 
  Scheme_Struct_Type * stype ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(insp, 1), PUSH(argv, 2), PUSH(who, 3)));
# define XfOrM388_COUNT (4)
# define SETUP_XfOrM388(x) SETUP(XfOrM388_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  insp = NULLED_OUT ; 
  val = NULLED_OUT ; 
  stype = NULLED_OUT ; 

# 2867 "./../src/struct.c"
  val = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "struct-type?" , 0 , argc , argv ) ); 

  stype = (Scheme_Struct_Type * ) val ; 

  insp = FUNCCALL(SETUP_XfOrM388(_), scheme_get_current_inspector () ); 

  if (! always && ! (scheme_is_subinspector (stype -> inspector , insp ) ) ) {
#   define XfOrM389_COUNT (0+XfOrM388_COUNT)
#   define SETUP_XfOrM389(x) SETUP_XfOrM388(x)
    FUNCCALL_EMPTY(scheme_contract_error (who , "current inspector cannot extract info for structure type" , "structure type" , 1 , argv [0 ] , ((void * ) 0 ) ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  RET_VALUE_START (insp ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2889 "./../src/struct.c"
void scheme_force_struct_type_info (Scheme_Struct_Type * stype ) 
{
  PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(stype, 0)));
# define XfOrM390_COUNT (1)
# define SETUP_XfOrM390(x) SETUP(XfOrM390_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 2892 "./../src/struct.c"
  if (! stype -> accessor ) {
    Scheme_Object * p ; 
    char * fn ; 
    BLOCK_SETUP((PUSH(fn, 0+XfOrM390_COUNT), PUSH(p, 1+XfOrM390_COUNT)));
#   define XfOrM391_COUNT (2+XfOrM390_COUNT)
#   define SETUP_XfOrM391(x) SETUP(XfOrM391_COUNT)
    p = NULLED_OUT ; 
    fn = NULLED_OUT ; 

# 2896 "./../src/struct.c"
    fn = (char * ) FUNCCALL(SETUP_XfOrM391(_), make_name ("" , (char * ) stype -> name , - 1 , "-ref" , ((void * ) 0 ) , 0 , "" , 0 ) ); 
    p = FUNCCALL(SETUP_XfOrM391(_), make_struct_proc (stype , fn , SCHEME_GEN_GETTER , 0 ) ); 
    stype -> accessor = p ; 
    fn = (char * ) FUNCCALL(SETUP_XfOrM391(_), make_name ("" , (char * ) stype -> name , - 1 , "-set!" , ((void * ) 0 ) , 0 , "" , 0 ) ); 
    p = FUNCCALL(SETUP_XfOrM391(_), make_struct_proc (stype , fn , SCHEME_GEN_SETTER , 0 ) ); 
    stype -> mutator = p ; 
  }
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2905 "./../src/struct.c"
static void get_struct_type_info (int argc , Scheme_Object * argv [] , Scheme_Object * * a , int always ) 
{
  Scheme_Struct_Type * stype , * parent ; 
  Scheme_Object * insp , * ims ; 
  int p , cnt ; 
  PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(a, 1), PUSH(ims, 2), PUSH(argv, 3), PUSH(parent, 4), PUSH(insp, 5)));
# define XfOrM392_COUNT (6)
# define SETUP_XfOrM392(x) SETUP(XfOrM392_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  parent = NULLED_OUT ; 
  insp = NULLED_OUT ; 
  ims = NULLED_OUT ; 

# 2911 "./../src/struct.c"
  insp = FUNCCALL(SETUP_XfOrM392(_), check_type_and_inspector ("struct-type-info" , always , argc , argv ) ); 
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    stype = (Scheme_Struct_Type * ) (((Scheme_Chaperone * ) argv [0 ] ) -> val ) ; 
  else 
  stype = (Scheme_Struct_Type * ) argv [0 ] ; 
  FUNCCALL(SETUP_XfOrM392(_), scheme_force_struct_type_info (stype ) )
  ; 

  if (stype -> name_pos )
    parent = stype -> parent_types [stype -> name_pos - 1 ] ; 
  else 
  parent = ((void * ) 0 ) ; 

  a [0 ] = stype -> name ; 
  cnt = stype -> num_islots - (parent ? parent -> num_islots : 0 ) ; 
  a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (cnt ) ) ) << 1 ) | 0x1 ) ) ; 
  a [2 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (stype -> num_slots - (parent ? parent -> num_slots : 0 ) - cnt ) ) ) << 1 ) | 0x1 ) ) ; 
  a [3 ] = stype -> accessor ; 
  a [4 ] = stype -> mutator ; 

  p = stype -> name_pos ; 
  while (-- p >= 0 ) {
#   define XfOrM398_COUNT (0+XfOrM392_COUNT)
#   define SETUP_XfOrM398(x) SETUP_XfOrM392(x)

# 2933 "./../src/struct.c"
    if (scheme_is_subinspector (stype -> parent_types [p ] -> inspector , insp ) )  {
      break ; 
    }
  }

  ims = scheme_null ; 
  if (stype -> immutables ) {
    int i ; 
#   define XfOrM393_COUNT (0+XfOrM392_COUNT)
#   define SETUP_XfOrM393(x) SETUP_XfOrM392(x)

# 2941 "./../src/struct.c"
    for (i = stype -> num_islots - (parent ? parent -> num_islots : 0 ) ; i -- ; ) {
#     define XfOrM395_COUNT (0+XfOrM393_COUNT)
#     define SETUP_XfOrM395(x) SETUP_XfOrM393(x)

# 2942 "./../src/struct.c"
      if (stype -> immutables [i ] )
        ims = FUNCCALL(SETUP_XfOrM395(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , ims ) ); 
    }
  }
  a [5 ] = ims ; 

  a [6 ] = ((p >= 0 ) ? (Scheme_Object * ) stype -> parent_types [p ] : scheme_false ) ; 
  a [7 ] = ((p == stype -> name_pos - 1 ) ? scheme_false : scheme_true ) ; 
  RET_NOTHING_AT_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2952 "./../src/struct.c"
static Scheme_Object * struct_type_info_chaperone (Scheme_Object * o , Scheme_Object * * a ) 
{
  Scheme_Object * procs = scheme_null , * proc ; 
  Scheme_Chaperone * px ; 
  PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(procs, 1), PUSH(px, 2), PUSH(o, 3), PUSH(proc, 4)));
# define XfOrM400_COUNT (5)
# define SETUP_XfOrM400(x) SETUP(XfOrM400_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  proc = NULLED_OUT ; 
  px = NULLED_OUT ; 

# 2957 "./../src/struct.c"
  while ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
#   define XfOrM403_COUNT (0+XfOrM400_COUNT)
#   define SETUP_XfOrM403(x) SETUP_XfOrM400(x)

# 2958 "./../src/struct.c"
    px = (Scheme_Chaperone * ) o ; 
    if ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM404_COUNT (0+XfOrM403_COUNT)
#     define SETUP_XfOrM404(x) SETUP_XfOrM403(x)

# 2960 "./../src/struct.c"
      proc = (((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . car ) ; 
      if ((& (px ) -> iso ) -> so . keyex & 0x1 )
        proc = FUNCCALL(SETUP_XfOrM404(_), scheme_box (proc ) ); 
      procs = FUNCCALL(SETUP_XfOrM404(_), scheme_make_pair (proc , procs ) ); 
    }
    o = px -> prev ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(apply_chaperones ("struct-type-info" , procs , 8 , a ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2971 "./../src/struct.c"
static Scheme_Object * struct_type_info (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * a [8 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(4);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 8, 0), PUSH(argv, 3)));
# define XfOrM405_COUNT (4)
# define SETUP_XfOrM405(x) SETUP(XfOrM405_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  NULL_OUT_ARRAY (a ) ; 
  FUNCCALL(SETUP_XfOrM405(_), get_struct_type_info (argc , argv , a , 0 ) )
# 2975 "./../src/struct.c"
  ; 

  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
#   define XfOrM406_COUNT (0+XfOrM405_COUNT)
#   define SETUP_XfOrM406(x) SETUP_XfOrM405(x)

# 2978 "./../src/struct.c"
    RET_VALUE_START (FUNCCALL(SETUP_XfOrM406(_), struct_type_info_chaperone (argv [0 ] , a ) )) RET_VALUE_END ; 
  }

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM405(_), scheme_values (8 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 2984 "./../src/struct.c"
static Scheme_Object * struct_type_sealed_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 2985 "./../src/struct.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) )
    scheme_wrong_contract ("struct-type-sealed?" , "struct-type?" , 0 , argc , argv ) ; 

  return ((((Scheme_Struct_Type * ) argv [0 ] ) -> more_flags & 0x8 ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * struct_type_authentic_p (int argc , Scheme_Object * argv [] ) {
  /* No conversion */

# 2994 "./../src/struct.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) )
    scheme_wrong_contract ("struct-type-authentic?" , "struct-type?" , 0 , argc , argv ) ; 

  return ((((Scheme_Struct_Type * ) argv [0 ] ) -> more_flags & 0x4 ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * struct_type_pred (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Struct_Type * stype ; 
  char * name ; 
  char * __funcarg142 = NULLED_OUT ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(argv, 1), PUSH(name, 2)));
# define XfOrM409_COUNT (3)
# define SETUP_XfOrM409(x) SETUP(XfOrM409_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  name = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM409(_), check_type_and_inspector ("struct-type-make-predicate" , 0 , argc , argv ) )
# 3007 "./../src/struct.c"
  ; 
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    stype = (Scheme_Struct_Type * ) (((Scheme_Chaperone * ) argv [0 ] ) -> val ) ; 
  else 
  stype = (Scheme_Struct_Type * ) argv [0 ] ; 

  name = (char * ) (__funcarg142 = FUNCCALL(SETUP_XfOrM409(_), scheme_symbol_val (stype -> name ) ), FUNCCALL_AGAIN(make_name ("" , __funcarg142 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (stype -> name ) ) ) -> len ) , "?" , ((void * ) 0 ) , 0 , "" , 0 ) )) 

  ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_struct_proc (stype , name , SCHEME_PRED , stype -> num_slots ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3020 "./../src/struct.c"
static Scheme_Object * type_constr_chaperone (Scheme_Object * o , Scheme_Object * v ) 
{
  Scheme_Object * procs = scheme_null , * proc , * a [1 ] ; 
  Scheme_Chaperone * px ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(procs, 0), PUSH(v, 1), PUSH(px, 2), PUSH(o, 3), PUSH(proc, 4), PUSHARRAY(a, 1, 5)));
# define XfOrM410_COUNT (8)
# define SETUP_XfOrM410(x) SETUP(XfOrM410_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  proc = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  px = NULLED_OUT ; 

# 3025 "./../src/struct.c"
  while ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
#   define XfOrM413_COUNT (0+XfOrM410_COUNT)
#   define SETUP_XfOrM413(x) SETUP_XfOrM410(x)

# 3026 "./../src/struct.c"
    px = (Scheme_Chaperone * ) o ; 
    if ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM414_COUNT (0+XfOrM413_COUNT)
#     define SETUP_XfOrM414(x) SETUP_XfOrM413(x)

# 3028 "./../src/struct.c"
      proc = ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . car ) ) ; 
      if ((& (px ) -> iso ) -> so . keyex & 0x1 )
        proc = FUNCCALL(SETUP_XfOrM414(_), scheme_box (proc ) ); 
      procs = FUNCCALL(SETUP_XfOrM414(_), scheme_make_pair (proc , procs ) ); 
    }
    o = px -> prev ; 
  }

  a [0 ] = v ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM410(_), apply_chaperones ("struct-type-make-constructor" , procs , 1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3040 "./../src/struct.c"
static Scheme_Object * struct_type_constr (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Struct_Type * stype ; 
  Scheme_Object * v ; 
  char * __funcarg144 = NULLED_OUT ; 
  char * __funcarg143 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(argv, 1), PUSH(v, 2)));
# define XfOrM415_COUNT (3)
# define SETUP_XfOrM415(x) SETUP(XfOrM415_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  v = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM415(_), check_type_and_inspector ("struct-type-make-constructor" , 0 , argc , argv ) )
# 3045 "./../src/struct.c"
  ; 
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    stype = (Scheme_Struct_Type * ) (((Scheme_Chaperone * ) argv [0 ] ) -> val ) ; 
  else 
  stype = (Scheme_Struct_Type * ) argv [0 ] ; 

  if ((argc < 2 ) || (((argv [1 ] ) ) == (scheme_false ) ) )
    v = (__funcarg144 = FUNCCALL(SETUP_XfOrM415(_), scheme_symbol_val (stype -> name ) ), FUNCCALL_AGAIN(make_name ("make-" , __funcarg144 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (stype -> name ) ) ) -> len ) , "" , ((void * ) 0 ) , 0 , "" , 1 ) )) ; 
  else if ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    v = argv [1 ] ; 
  else {
#   define XfOrM416_COUNT (0+XfOrM415_COUNT)
#   define SETUP_XfOrM416(x) SETUP_XfOrM415(x)
    FUNCCALL_EMPTY(scheme_wrong_contract ("struct-type-make-constructor" , "symbol?" , 1 , argc , argv ) )
# 3056 "./../src/struct.c"
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  v = (__funcarg143 = FUNCCALL(SETUP_XfOrM415(_), scheme_symbol_val (v ) )
  , FUNCCALL_AGAIN(make_struct_proc (stype , __funcarg143 , SCHEME_CONSTR , stype -> num_slots ) )) 

  ; 

  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(type_constr_chaperone (argv [0 ] , v ) )) RET_VALUE_EMPTY_END ; 

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3071 "./../src/struct.c"
Scheme_Object * scheme_struct_to_vector (Scheme_Object * _s , Scheme_Object * unknown_val , Scheme_Object * insp ) 
{
  Scheme_Structure * s ; 
  Scheme_Struct_Type * stype ; 
  Scheme_Object * v , * elem , * name ; 
  GC_CAN_IGNORE Scheme_Object * * array ; 
  int i , m , p , n , last_is_unknown ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(unknown_val, 0), PUSH(elem, 1), PUSH(v, 2), PUSH(_s, 3), PUSH(insp, 4), PUSH(stype, 5), PUSH(s, 6), PUSH(name, 7)));
# define XfOrM417_COUNT (8)
# define SETUP_XfOrM417(x) SETUP(XfOrM417_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  s = NULLED_OUT ; 
  stype = NULLED_OUT ; 
  v = NULLED_OUT ; 
  elem = NULLED_OUT ; 
  name = NULLED_OUT ; 

# 3079 "./../src/struct.c"
  if (! unknown_val )
    unknown_val = ellipses_symbol ; 

  if (((Scheme_Type ) (((((intptr_t ) (_s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (_s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (_s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (_s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    s = (Scheme_Structure * ) (((Scheme_Chaperone * ) _s ) -> val ) ; 
  else 
  s = (Scheme_Structure * ) _s ; 

  stype = s -> stype ; 
  p = stype -> name_pos + 1 ; 
  m = 0 ; 
  last_is_unknown = 0 ; 
  while (p -- ) {
#   define XfOrM435_COUNT (0+XfOrM417_COUNT)
#   define SETUP_XfOrM435(x) SETUP_XfOrM417(x)

# 3092 "./../src/struct.c"
    stype = stype -> parent_types [p ] ; 
    if (! (scheme_is_subinspector (stype -> inspector , insp ) ) ) {
      if (! last_is_unknown )
        m ++ ; 
      last_is_unknown = 1 ; 
    }

# 3097 "./../src/struct.c"
    else {
      int count ; 
      if (p )
        count = stype -> num_slots - stype -> parent_types [p - 1 ] -> num_slots ; 
      else 
      count = stype -> num_slots ; 
      m += count ; 
      if (count )
        last_is_unknown = 0 ; 
    }
  }

  stype = s -> stype ; 
  p = stype -> name_pos + 1 ; 
  i = stype -> num_slots ; 
  last_is_unknown = 0 ; 

  name = FUNCCALL(SETUP_XfOrM417(_), make_name ("struct:" , (char * ) ((((Scheme_Structure * ) s ) -> stype ) -> name ) , - 1 , "" , ((void * ) 0 ) , 0 , "" , 1 ) ); 




  v = FUNCCALL_AGAIN(scheme_make_vector (m + 1 , ((void * ) 0 ) ) ); 
  array = (((Scheme_Vector * ) (v ) ) -> els ) ; 
  array [0 ] = name ; 
  while (p -- ) {
#   define XfOrM425_COUNT (0+XfOrM417_COUNT)
#   define SETUP_XfOrM425(x) SETUP_XfOrM417(x)

# 3123 "./../src/struct.c"
    stype = stype -> parent_types [p ] ; 
    if (p )
      n = stype -> num_slots - stype -> parent_types [p - 1 ] -> num_slots ; 
    else 
    n = stype -> num_slots ; 

    if (! (scheme_is_subinspector (stype -> inspector , insp ) ) ) {
      if (! last_is_unknown )
        array [1 + (-- m ) ] = unknown_val ; 
      i -= n ; 
      last_is_unknown = 1 ; 
    }

# 3134 "./../src/struct.c"
    else {
#     define XfOrM426_COUNT (0+XfOrM425_COUNT)
#     define SETUP_XfOrM426(x) SETUP_XfOrM425(x)

# 3135 "./../src/struct.c"
      if (n )
        last_is_unknown = 0 ; 
      while (n -- ) {
#       define XfOrM429_COUNT (0+XfOrM426_COUNT)
#       define SETUP_XfOrM429(x) SETUP_XfOrM426(x)

# 3138 "./../src/struct.c"
        -- i ; 
        if (((Scheme_Object * ) s ) == (_s ) ) 
          elem = s -> slots [i ] ; 
        else {
#         define XfOrM430_COUNT (0+XfOrM429_COUNT)
#         define SETUP_XfOrM430(x) SETUP_XfOrM429(x)

# 3143 "./../src/struct.c"
          array = ((void * ) 0 ) ; 
          elem = FUNCCALL(SETUP_XfOrM430(_), scheme_struct_ref (_s , i ) ); 
          array = (((Scheme_Vector * ) (v ) ) -> els ) ; 
        }
        array [1 + (-- m ) ] = elem ; 
      }
    }
  }

  RET_VALUE_START (v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3155 "./../src/struct.c"
static Scheme_Object * struct_to_vector (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Config * __funcarg146 = NULLED_OUT ; 
  Scheme_Object * __funcarg145 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM438_COUNT (1)
# define SETUP_XfOrM438(x) SETUP(XfOrM438_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 3157 "./../src/struct.c"
  if (! ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [0 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) ) ) {
    char * tn , * s ; 
    int l ; 
    Scheme_Object * v ; 
    BLOCK_SETUP((PUSH(v, 0+XfOrM438_COUNT), PUSH(tn, 1+XfOrM438_COUNT), PUSH(s, 2+XfOrM438_COUNT)));
#   define XfOrM439_COUNT (3+XfOrM438_COUNT)
#   define SETUP_XfOrM439(x) SETUP(XfOrM439_COUNT)
    tn = NULLED_OUT ; 
    s = NULLED_OUT ; 
    v = NULLED_OUT ; 

# 3162 "./../src/struct.c"
    tn = FUNCCALL(SETUP_XfOrM439(_), scheme_get_type_name (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) ); 
    l = strlen (tn ) - 2 ; 
    s = FUNCCALL(SETUP_XfOrM439(_), GC_malloc_atomic (l + 8 ) ); 
    (strcpy (s , "struct:" ) ) ; 
    (memcpy (s + 7 , tn + 1 , l ) ) ; 
    s [7 + l ] = 0 ; 

    v = FUNCCALL(SETUP_XfOrM439(_), scheme_intern_symbol (s ) ); 
    v = FUNCCALL_AGAIN(scheme_make_vector (2 , v ) ); 
    (((Scheme_Vector * ) (v ) ) -> els ) [1 ] = (argc > 1 ) ? argv [1 ] : ellipses_symbol ; 

    RET_VALUE_START (v ) RET_VALUE_END ; 
  }

  RET_VALUE_START ((__funcarg145 = (__funcarg146 = FUNCCALL(SETUP_XfOrM438(_), scheme_current_config () )

  , FUNCCALL_AGAIN(scheme_get_param (__funcarg146 , MZCONFIG_INSPECTOR ) )) , FUNCCALL_EMPTY(scheme_struct_to_vector (argv [0 ] , (argc > 1 ) ? argv [1 ] : ((void * ) 0 ) , __funcarg145 ) )) ) 
# 3176 "./../src/struct.c"
  RET_VALUE_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3181 "./../src/struct.c"
static Scheme_Object * prefab_struct_key (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3183 "./../src/struct.c"
  return scheme_prefab_struct_key (argv [0 ] ) ; 
}

Scheme_Object * scheme_prefab_struct_key (Scheme_Object * so ) 
{
  /* No conversion */

# 3188 "./../src/struct.c"
  Scheme_Structure * s = (Scheme_Structure * ) so ; 

  if (((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) ((Scheme_Object * ) s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((Scheme_Object * ) s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    s = (Scheme_Structure * ) (((Scheme_Chaperone * ) (Scheme_Object * ) s ) -> val ) ; 

  if ((((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) s ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) s ) ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (((Scheme_Object * ) s ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Object * ) s ) ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && s -> stype -> prefab_key ) {
    return (((Scheme_Simple_Object * ) (s -> stype -> prefab_key ) ) -> u . pair_val . cdr ) ; 
  }

  return scheme_false ; 
}

static Scheme_Object * make_prefab_struct (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Struct_Type * stype ; 
  Scheme_Object * vec ; 
  int i ; 
  PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(vec, 1), PUSH(argv, 2)));
# define XfOrM443_COUNT (3)
# define SETUP_XfOrM443(x) SETUP(XfOrM443_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  vec = NULLED_OUT ; 

# 3206 "./../src/struct.c"
  stype = FUNCCALL(SETUP_XfOrM443(_), scheme_lookup_prefab_type (argv [0 ] , argc - 1 ) ); 

  if (! stype )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-prefab-struct" , "prefab-key?" , 0 , argc , argv ) ); 

  if (stype -> num_slots != (argc - 1 ) ) {
#   define XfOrM446_COUNT (0+XfOrM443_COUNT)
#   define SETUP_XfOrM446(x) SETUP_XfOrM443(x)
    FUNCCALL_EMPTY(scheme_contract_error ("make-prefab-struct" , "mismatch between argument count and prefab key" , "number of field arguments" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (argc - 1 ) ) ) << 1 ) | 0x1 ) ) , "prefab key" , 1 , argv [0 ] , ((void * ) 0 ) ) )

    ; 
  }

  vec = FUNCCALL(SETUP_XfOrM443(_), scheme_make_vector (argc , 0 ) ); 
  for (i = 0 ; i < argc ; i ++ ) {
    (((Scheme_Vector * ) (vec ) ) -> els ) [i ] = argv [i ] ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_prefab_struct_instance (stype , vec ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3227 "./../src/struct.c"
static Scheme_Object * prefab_key_struct_type (int argc , Scheme_Object * argv [] ) 
{
  Scheme_Struct_Type * stype ; 
  int v ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(stype, 0), PUSH(argv, 1)));
# define XfOrM447_COUNT (2)
# define SETUP_XfOrM447(x) SETUP(XfOrM447_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 

# 3232 "./../src/struct.c"
  if (((intptr_t ) (argv [1 ] ) ) & 0x1 )  {
    v = (((intptr_t ) (argv [1 ] ) ) >> 1 ) ; 
    if (v > 32768 )
      v = - 1 ; 
  }

# 3236 "./../src/struct.c"
  else 
  v = - 1 ; 

  stype = FUNCCALL(SETUP_XfOrM447(_), scheme_lookup_prefab_type (argv [0 ] , (v >= 0 ) ? v : - 1 ) ); 

  if (! stype )
    FUNCCALL_EMPTY(scheme_wrong_contract ("prefab-key->struct-type" , "prefab-key?" , 0 , argc , argv ) ); 

  if (v < 0 )
    FUNCCALL_EMPTY(scheme_wrong_contract ("prefab-key->struct-type" , "(integer-in 0 " "32768" ")" , 1 , argc , argv ) )

  ; 

  if (stype -> num_slots != v ) {
#   define XfOrM448_COUNT (0+XfOrM447_COUNT)
#   define SETUP_XfOrM448(x) SETUP_XfOrM447(x)
    FUNCCALL_EMPTY(scheme_contract_error ("prefab-key->struct-type" , "mismatch between prefab key and field count" , "prefab key" , 1 , argv [0 ] , "field count" , 1 , argv [1 ] , ((void * ) 0 ) ) )

    ; 
  }

  RET_VALUE_START ((Scheme_Object * ) stype ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3260 "./../src/struct.c"
static Scheme_Object * is_prefab_key (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3262 "./../src/struct.c"
  return (scheme_lookup_prefab_type (argv [0 ] , - 1 ) 
  ? scheme_true 
  : scheme_false ) ; 
}

int scheme_inspector_sees_part (Scheme_Object * s , Scheme_Object * insp , int pos ) 


{
  /* No conversion */

# 3271 "./../src/struct.c"
  Scheme_Struct_Type * stype ; 
  int p ; 

  if (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    s = (((Scheme_Chaperone * ) s ) -> val ) ; 

  stype = ((Scheme_Structure * ) s ) -> stype ; 

  p = stype -> name_pos ; 

  if (pos == - 1 ) {

    Scheme_Object * prev = ((void * ) 0 ) ; 
    while (p > - 1 ) {
      if (! ((stype -> parent_types [p ] -> inspector ) == (prev ) ) ) {
        prev = stype -> parent_types [p ] -> inspector ; 
        if (scheme_is_subinspector (prev , insp ) )
          return 1 ; 
      }
      p -- ; 
    }

    return 0 ; 
  }

# 3294 "./../src/struct.c"
  else if (pos == - 2 ) {

    Scheme_Object * prev = ((void * ) 0 ) ; 
    while (p > - 1 ) {
      if (! ((stype -> parent_types [p ] -> inspector ) == (prev ) ) ) {
        prev = stype -> parent_types [p ] -> inspector ; 
        if (! scheme_is_subinspector (prev , insp ) )
          return 0 ; 
      }
      p -- ; 
    }

    return 1 ; 
  }

# 3307 "./../src/struct.c"
  else {

    while (p && (stype -> parent_types [p - 1 ] -> num_slots > pos ) ) {
      p -- ; 
    }

    return scheme_is_subinspector (stype -> parent_types [p ] -> inspector , insp ) ; 
  }
}

int scheme_struct_is_transparent (Scheme_Object * s ) 
{
  /* No conversion */

# 3319 "./../src/struct.c"
  Scheme_Struct_Type * stype ; 
  int p ; 

  if (((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (s ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (s ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    s = (((Scheme_Chaperone * ) s ) -> val ) ; 

  stype = ((Scheme_Structure * ) s ) -> stype ; 

  for (p = stype -> name_pos + 1 ; p -- ; ) {
    if (! (((stype -> parent_types [p ] -> inspector ) ) == (scheme_false ) ) ) 
      return 0 ; 
  }

  return 1 ; 
}





static Scheme_Object * 
struct_setter_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3342 "./../src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3343 "./../src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return ((((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((128 | 256 ) ) ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == (256 ) ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((32 | 128 ) ) ) ) ) 
  && ! ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & 4 ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
struct_getter_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3354 "./../src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3355 "./../src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return ((((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == (32 ) ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((32 | 256 ) ) ) ) ) 
  && ! ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & 4 ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
struct_pred_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3365 "./../src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3366 "./../src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return (((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((32 | 64 ) ) ) ) 
  && ! ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & 4 ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
struct_constr_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3375 "./../src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3376 "./../src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return ((((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == (128 ) ) ) 
  || (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((32 | 64 | 128 ) ) ) ) ) 
  && ! ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & 4 ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

static Scheme_Object * 
struct_prop_getter_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3386 "./../src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3387 "./../src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return (((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((64 | 128 ) ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) ) 
  ? scheme_true : scheme_false ) ; 
}
static Scheme_Object * 
struct_prop_pred_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3395 "./../src/struct.c"
  Scheme_Object * v = argv [0 ] , * prop , * prop_t ; 

  if (argc > 1 ) {
    if ((! (((argv [1 ] ) ) == (scheme_false ) ) ) && ! ((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) )
      scheme_wrong_contract ("struct-type-property-predicate-procedure?" , "(or/c struct-type-property? #f)" , 1 , argc , argv ) ; 
  }

  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3402 "./../src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 

  if (! ((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((64 | 128 | 256 ) ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) ) )
    return scheme_false ; 

  if ((argc > 1 ) && (! (((argv [1 ] ) ) == (scheme_false ) ) ) ) {
    prop = ((Scheme_Primitive_Closure * ) v ) -> val [0 ] ; 
    prop_t = argv [1 ] ; 
    return (((prop ) == (prop_t ) ) ? scheme_true : scheme_false ) ; 
  }

  return scheme_true ; 
}

static Scheme_Object * 
chaperone_prop_getter_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3420 "./../src/struct.c"
  Scheme_Object * v = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 3421 "./../src/struct.c"
  v = (((Scheme_Chaperone * ) v ) -> val ) ; 
  return (((((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) v ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((64 | 128 ) ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (((Scheme_Primitive_Closure * ) v ) -> val [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) ) ) 
  ? scheme_true : scheme_false ) ; 
}

int scheme_decode_struct_shape (Scheme_Object * expected , intptr_t * _v ) 
{
  /* No conversion */

# 3429 "./../src/struct.c"
  intptr_t v ; 
  int i ; 

  if (! expected || ! ((Scheme_Type ) (((((intptr_t ) (expected ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expected ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    return 0 ; 

  if (((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [0 ] != 's' ) 
  || ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> len ) < 6 ) )
    return 0 ; 

  for (i = 6 , v = 0 ; (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [i ] ; i ++ ) {
    v = (v * 10 ) + ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [i ] - '0' ) ; 
  }

  * _v = v ; 

  return 1 ; 
}

intptr_t scheme_get_or_check_structure_shape (Scheme_Object * e , Scheme_Object * expected ) 
{
  intptr_t _v , v , want_v ; 
  int i ; 
  Scheme_Struct_Type * st ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(st, 1), PUSH(expected, 2)));
# define XfOrM480_COUNT (3)
# define SETUP_XfOrM480(x) SETUP(XfOrM480_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  st = NULLED_OUT ; 

# 3454 "./../src/struct.c"
  if (expected ) {
#   define XfOrM489_COUNT (0+XfOrM480_COUNT)
#   define SETUP_XfOrM489(x) SETUP_XfOrM480(x)

# 3455 "./../src/struct.c"
    if (! FUNCCALL(SETUP_XfOrM489(_), scheme_decode_struct_shape (expected , & _v ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    v = _v ; 
  }

# 3458 "./../src/struct.c"
  else 
  v = 0 ; 

  if ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) )  {
    st = (Scheme_Struct_Type * ) e ; 
    if (st -> num_slots != st -> num_islots )
      want_v = 5 ; 
    else 
    want_v = ((st -> num_slots << 7 ) 
    | 0 
    | (((st -> more_flags & 0x4 ) 
    && (! expected || (v & 0x10 ) ) ) 
    ? 0x10 
    : 0 ) 
    | (((st -> more_flags & 0x1 ) 
    && (! expected || (v & 0x20 ) ) ) 
    ? 0x20 
    : 0 ) 
    | ((st -> prefab_key 
    && (! expected || (v & 0x40 ) ) ) 
    ? 0x40 
    : 0 ) ) ; 
  }

# 3480 "./../src/struct.c"
  else if (! ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) ) {
    want_v = - 1 ; 
  }

# 3482 "./../src/struct.c"
  else {
    i = (((Scheme_Primitive_Proc * ) e ) -> pp . flags & (32 | 64 | 128 | 256 ) ) ; 
    if ((i == 128 ) 
    || (i == (32 | 64 | 128 ) ) ) {
      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) e ) -> val [0 ] ; 
      want_v = ((st -> num_islots << 7 ) 
      | 1 
      | (((st -> more_flags & 0x1 ) 
      && (! expected || (v & 0x20 ) ) ) 
      ? 0x20 
      : 0 ) ) ; 
    }

# 3493 "./../src/struct.c"
    else if (i == (32 | 64 ) ) {
      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) e ) -> val [0 ] ; 
      want_v = (2 
      | (((st -> more_flags & 0x4 ) 
      && (! expected || (v & 0x10 ) ) ) 
      ? 0x10 
      : 0 ) ) ; 
    }

# 3500 "./../src/struct.c"
    else if (i == (128 | 256 ) ) {
      int pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) e ) -> val [1 ] ) ) >> 1 ) ; 
      int parent_slots ; 
      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) e ) -> val [0 ] ; 
      parent_slots = ((st -> name_pos > 0 ) 
      ? st -> parent_types [st -> name_pos - 1 ] -> num_slots 
      : 0 ) ; 
      if ((pos - parent_slots ) < (31 - 7 ) )
        pos ++ ; 
      else 
      pos = 0 ; 
      want_v = ((pos << 7 ) 
      | 4 
      | (((st -> more_flags & 0x4 ) 
      && (! expected || (v & 0x10 ) ) ) 
      ? 0x10 
      : 0 ) ) ; 
    }

# 3517 "./../src/struct.c"
    else if (i == 32 ) {
      int pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) e ) -> val [1 ] ) ) >> 1 ) ; 
      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) e ) -> val [0 ] ; 
      want_v = ((pos << 7 ) 
      | 3 
      | (((st -> more_flags & 0x4 ) 
      && (! expected || (v & 0x10 ) ) ) 
      ? 0x10 
      : 0 ) ) ; 
    }

# 3526 "./../src/struct.c"
    else if ((i == 256 ) 
    || (i == (32 | 128 ) ) 
    || (i == (32 | 256 ) ) ) {
      want_v = 5 ; 
    }

# 3530 "./../src/struct.c"
    else 
    want_v = - 1 ; 
  }

  if (expected )
    RET_VALUE_START ((v == want_v ) ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (want_v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3540 "./../src/struct.c"
int scheme_decode_struct_prop_shape (Scheme_Object * expected , intptr_t * _v ) 
{
  /* No conversion */

# 3542 "./../src/struct.c"
  intptr_t v ; 
  int i ; 

  if (! expected || ! ((Scheme_Type ) (((((intptr_t ) (expected ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (expected ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    return 0 ; 

  if (((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [0 ] != 'p' ) 
  || ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> len ) < 4 ) )
    return 0 ; 

  for (i = 4 , v = 0 ; (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [i ] ; i ++ ) {
    v = (v * 10 ) + ((((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (expected ) ) ) -> s ) [i ] - '0' ) ; 
  }

  * _v = v ; 

  return 1 ; 
}

intptr_t scheme_get_or_check_structure_property_shape (Scheme_Object * e , Scheme_Object * expected ) 
{
  intptr_t _v , v , want_v ; 
  int i ; 
  DECL_RET_SAVE (intptr_t ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(e, 0), PUSH(expected, 1)));
# define XfOrM493_COUNT (2)
# define SETUP_XfOrM493(x) SETUP(XfOrM493_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 3566 "./../src/struct.c"
  if (expected ) {
#   define XfOrM498_COUNT (0+XfOrM493_COUNT)
#   define SETUP_XfOrM498(x) SETUP_XfOrM493(x)

# 3567 "./../src/struct.c"
    if (! FUNCCALL(SETUP_XfOrM498(_), scheme_decode_struct_prop_shape (expected , & _v ) ))
      RET_VALUE_START (0 ) RET_VALUE_END ; 
    v = _v ; 
  }

# 3570 "./../src/struct.c"
  else 
  v = 0 ; 

  if ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) )  {
    if (((Scheme_Struct_Property * ) e ) -> guard )
      want_v = 1 ; 
    else {
      want_v = 0 ; 
      if (expected )
        RET_VALUE_START (((v == 0 ) 
      || (v == 1 ) ) ) 
# 3579 "./../src/struct.c"
      RET_VALUE_END 
      ; 
    }
  }

# 3582 "./../src/struct.c"
  else if (! ((Scheme_Type ) (((((intptr_t ) (e ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (e ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) ) {
    want_v = - 1 ; 
  }

# 3584 "./../src/struct.c"
  else {
    i = (((Scheme_Primitive_Proc * ) e ) -> pp . flags & (32 | 64 | 128 | 256 ) ) ; 
    if (i == (64 | 128 | 256 ) )
      want_v = 2 ; 
    else if (i == (64 | 128 ) )
      want_v = 3 ; 
    else 
    want_v = - 1 ; 
  }

  if (expected )
    RET_VALUE_START (v == want_v ) RET_VALUE_END ; 
  else 
  RET_VALUE_START (want_v ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3600 "./../src/struct.c"
static Scheme_Object * make_struct_field_xxor (const char * who , int getter , 
int argc , Scheme_Object * argv [] ) 
{
  int pos ; 
  char * name ; 
  const char * fieldstr ; 
  char digitbuf [20 ] ; 
  int fieldstrlen ; 
  Scheme_Struct_Type * st ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(st, 0), PUSH(argv, 1), PUSH(fieldstr, 2), PUSH(name, 3), PUSH(who, 4)));
# define XfOrM499_COUNT (5)
# define SETUP_XfOrM499(x) SETUP(XfOrM499_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name = NULLED_OUT ; 
  fieldstr = NULLED_OUT ; 
  st = NULLED_OUT ; 

# 3613 "./../src/struct.c"
  if (! (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) ) && ((((Scheme_Primitive_Proc * ) argv [0 ] ) -> pp . flags & (32 | 64 | 128 | 256 ) ) == ((getter ? (32 | 256 ) : 256 ) ) ) ) ) 

  {
#   define XfOrM508_COUNT (0+XfOrM499_COUNT)
#   define SETUP_XfOrM508(x) SETUP_XfOrM499(x)
    FUNCCALL_EMPTY(scheme_wrong_contract (who , (getter ? "(and/c struct-accessor-procedure? (lambda (p) (procedure-arity-includes? p 2)))" : "(and/c struct-mutator-procedure? (lambda (p) (procedure-arity-includes? p 2)))" ) , 0 , argc , argv ) )
    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  pos = FUNCCALL(SETUP_XfOrM499(_), parse_pos (who , argv [0 ] , argv , argc ) ); 

  if (argc > 2 ) {
#   define XfOrM504_COUNT (0+XfOrM499_COUNT)
#   define SETUP_XfOrM504(x) SETUP_XfOrM499(x)

# 3626 "./../src/struct.c"
    if (((argv [2 ] ) ) == (scheme_false ) )  {
      fieldstr = ((void * ) 0 ) ; 
      fieldstrlen = 0 ; 
    }

# 3629 "./../src/struct.c"
    else {
#     define XfOrM505_COUNT (0+XfOrM504_COUNT)
#     define SETUP_XfOrM505(x) SETUP_XfOrM504(x)

# 3630 "./../src/struct.c"
      if (! ((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) ) {
#       define XfOrM506_COUNT (0+XfOrM505_COUNT)
#       define SETUP_XfOrM506(x) SETUP_XfOrM505(x)
        FUNCCALL_EMPTY(scheme_wrong_contract (who , "(or/c symbol? #f)" , 2 , argc , argv ) )
# 3631 "./../src/struct.c"
        ; 
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      }
      fieldstr = FUNCCALL(SETUP_XfOrM505(_), scheme_symbol_val (argv [2 ] ) ); 
      fieldstrlen = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (argv [2 ] ) ) ) -> len ) ; 
    }
  }

# 3637 "./../src/struct.c"
  else {
#   define XfOrM503_COUNT (0+XfOrM499_COUNT)
#   define SETUP_XfOrM503(x) SETUP_XfOrM499(x)
    (
# 3638 "./../src/struct.c"
    sprintf (digitbuf , "field%d" , (int ) (((intptr_t ) (argv [1 ] ) ) >> 1 ) ) ) ; 
    fieldstr = digitbuf ; 
    fieldstrlen = strlen (fieldstr ) ; 
  }

  st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) argv [0 ] ) -> val [0 ] ; 

  if (! fieldstr ) {
    if (getter )
      name = "accessor" ; 
    else 
    name = "mutator" ; 
  }

# 3650 "./../src/struct.c"
  else if (getter ) {
#   define XfOrM501_COUNT (0+XfOrM499_COUNT)
#   define SETUP_XfOrM501(x) SETUP_XfOrM499(x)

# 3651 "./../src/struct.c"
    name = (char * ) FUNCCALL(SETUP_XfOrM501(_), make_name ("" , (char * ) st -> name , - 1 , "-" , fieldstr , fieldstrlen , "" , 0 ) )
    ; 
  }

# 3653 "./../src/struct.c"
  else {
#   define XfOrM500_COUNT (0+XfOrM499_COUNT)
#   define SETUP_XfOrM500(x) SETUP_XfOrM499(x)

# 3654 "./../src/struct.c"
    name = (char * ) FUNCCALL(SETUP_XfOrM500(_), make_name ("set-" , (char * ) st -> name , - 1 , "-" , fieldstr , fieldstrlen , "!" , 0 ) )
    ; 
  }

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_struct_proc (st , name , (getter ? SCHEME_GETTER : SCHEME_SETTER ) , pos ) )) RET_VALUE_EMPTY_END 

  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3663 "./../src/struct.c"
static Scheme_Object * make_struct_field_accessor (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3665 "./../src/struct.c"
  return make_struct_field_xxor ("make-struct-field-accessor" , 1 , argc , argv ) ; 
}


static Scheme_Object * make_struct_field_mutator (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3671 "./../src/struct.c"
  return make_struct_field_xxor ("make-struct-field-mutator" , 0 , argc , argv ) ; 
}





static Scheme_Object * wrap_evt (const char * who , Scheme_Type ty , int argc , Scheme_Object * argv [] ) 
{
  Wrapped_Evt * ww ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(ww, 0), PUSH(argv, 1), PUSH(who, 2)));
# define XfOrM511_COUNT (3)
# define SETUP_XfOrM511(x) SETUP(XfOrM511_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ww = NULLED_OUT ; 

# 3682 "./../src/struct.c"
  if (! FUNCCALL(SETUP_XfOrM511(_), scheme_is_evt (argv [0 ] ) ))
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "evt?" , 0 , argc , argv ) ); 

  if (! (! (((intptr_t ) (argv [1 ] ) ) & 0x1 ) && ((((argv [1 ] ) -> type ) >= scheme_prim_type ) && (((argv [1 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (who , "procedure?" , 1 , argc , argv ) ); 

  ww = ((Wrapped_Evt * ) FUNCCALL(SETUP_XfOrM511(_), GC_malloc_one_small_tagged ((((sizeof (Wrapped_Evt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  ww -> so . type = ty ; 
  ww -> evt = argv [0 ] ; 
  ww -> wrapper = argv [1 ] ; 

  RET_VALUE_START ((Scheme_Object * ) ww ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3696 "./../src/struct.c"
Scheme_Object * scheme_wrap_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3698 "./../src/struct.c"
  return wrap_evt ("wrap-evt" , scheme_wrap_evt_type , argc , argv ) ; 
}

Scheme_Object * handle_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3703 "./../src/struct.c"
  return wrap_evt ("handle-evt" , scheme_handle_evt_type , argc , argv ) ; 
}

Scheme_Object * replace_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3708 "./../src/struct.c"
  return wrap_evt ("replace-evt" , scheme_replace_evt_type , argc , argv ) ; 
}

Scheme_Object * handle_evt_p (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3713 "./../src/struct.c"
  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_handle_evt_type ) ) 
    return scheme_true ; 

  if ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_evt_set_type ) )  {
    Evt_Set * es = (Evt_Set * ) argv [0 ] ; 
    int i ; 
    for (i = es -> argc ; i -- ; ) {
      if ((Scheme_Type ) (((((intptr_t ) (es -> argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (es -> argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_handle_evt_type ) )  {
        return scheme_true ; 
      }
    }
  }

  if (argc )
    return scheme_false ; 
  else 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * do_chaperone_result_guard_proc (int is_impersonator , void * data , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * proc = (Scheme_Object * ) data , * o , * a [1 ] ; 
  Scheme_Object * * received_vals , * * guard_argv ; 
  int received_cnt , i ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(received_vals, 0), PUSH(argv, 1), PUSH(o, 2), PUSH(guard_argv, 3), PUSH(proc, 4), PUSHARRAY(a, 1, 5)));
# define XfOrM521_COUNT (8)
# define SETUP_XfOrM521(x) SETUP(XfOrM521_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  o = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  received_vals = NULLED_OUT ; 
  guard_argv = NULLED_OUT ; 

# 3739 "./../src/struct.c"
  guard_argv = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM521(_), GC_malloc (sizeof (Scheme_Object * ) * (argc ) ) )) ; 
  (memcpy (guard_argv , argv , sizeof (Scheme_Object * ) * argc ) ) ; 

  o = FUNCCALL(SETUP_XfOrM521(_), scheme_do_eval (proc , argc , guard_argv , - 1 ) ); 

  if ((o ) == (((Scheme_Object * ) 0x6 ) ) )  {
#   define XfOrM527_COUNT (0+XfOrM521_COUNT)
#   define SETUP_XfOrM527(x) SETUP_XfOrM521(x)

# 3745 "./../src/struct.c"
    received_cnt = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . count ) ; 
    received_vals = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) ; 
    FUNCCALL(SETUP_XfOrM527(_), scheme_detach_multple_array (received_vals ) ); 
  }

# 3748 "./../src/struct.c"
  else {
    a [0 ] = o ; 
    received_vals = a ; 
    received_cnt = 1 ; 
  }

  if (received_cnt != argc ) {
#   define XfOrM525_COUNT (0+XfOrM521_COUNT)
#   define SETUP_XfOrM525(x) SETUP_XfOrM521(x)
    FUNCCALL(SETUP_XfOrM525(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "evt %s: returned wrong number of values\n" "  %s : %V\n" "  expected count: %d\n" "  returned count: %d\n" , is_impersonator ? "impersonator" : "chaperone" , is_impersonator ? "impersonator" : "chaperone" , proc , argc , received_cnt ) )





    ; 
  }

  if (! is_impersonator ) {
#   define XfOrM522_COUNT (0+XfOrM521_COUNT)
#   define SETUP_XfOrM522(x) SETUP_XfOrM521(x)

# 3767 "./../src/struct.c"
    for (i = 0 ; i < argc ; i ++ ) {
#     define XfOrM524_COUNT (0+XfOrM522_COUNT)
#     define SETUP_XfOrM524(x) SETUP_XfOrM522(x)

# 3768 "./../src/struct.c"
      if (! FUNCCALL(SETUP_XfOrM524(_), scheme_chaperone_of (received_vals [i ] , argv [i ] ) ))
        FUNCCALL(SETUP_XfOrM524(_), scheme_wrong_chaperoned ("evt result" , "value" , argv [i ] , received_vals [i ] ) ); 
    }
  }

  RET_VALUE_START (o ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3776 "./../src/struct.c"
static Scheme_Object * chaperone_result_guard_proc (void * data , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3778 "./../src/struct.c"
  return do_chaperone_result_guard_proc (0 , data , argc , argv ) ; 
}

static Scheme_Object * impersonator_result_guard_proc (void * data , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3783 "./../src/struct.c"
  return do_chaperone_result_guard_proc (1 , data , argc , argv ) ; 
}

static Scheme_Object * do_chaperone_guard_proc (int is_impersonator , void * data , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Object * evt = (((Scheme_Simple_Object * ) ((Scheme_Object * ) data ) ) -> u . pair_val . car ) ; 
  Scheme_Object * proc = (((Scheme_Simple_Object * ) ((Scheme_Object * ) data ) ) -> u . pair_val . cdr ) ; 
  Scheme_Object * a [2 ] , * o , * * vals ; 
  int cnt ; 
  Scheme_Thread * p ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(8);
  BLOCK_SETUP_TOP((PUSH(vals, 0), PUSH(evt, 1), PUSHARRAY(a, 2, 2), PUSH(o, 5), PUSH(proc, 6), PUSH(p, 7)));
# define XfOrM530_COUNT (8)
# define SETUP_XfOrM530(x) SETUP(XfOrM530_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  o = NULLED_OUT ; 
  vals = NULLED_OUT ; 
  p = NULLED_OUT ; 

# 3794 "./../src/struct.c"
  a [0 ] = evt ; 

  o = FUNCCALL(SETUP_XfOrM530(_), scheme_do_eval (proc , 1 , a , - 1 ) ); 

  if ((o ) == (((Scheme_Object * ) 0x6 ) ) )  {
    p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
    cnt = p -> ku . multiple . count ; 
    vals = p -> ku . multiple . array ; 
    p -> ku . multiple . array = ((void * ) 0 ) ; 
    if ((vals ) == (p -> values_buffer ) ) 
      p -> values_buffer = ((void * ) 0 ) ; 
    p = ((void * ) 0 ) ; 
  }

# 3806 "./../src/struct.c"
  else {
    vals = ((void * ) 0 ) ; 
    cnt = 1 ; 
  }

  if (cnt != 2 )
    FUNCCALL(SETUP_XfOrM530(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT_ARITY , "evt %s: returned wrong number of values\n" "  %s: %V\n" "  expected count: 2\n" "  returned count: %d" , (is_impersonator ? "impersonator" : "chaperone" ) , (is_impersonator ? "impersonator" : "chaperone" ) , proc , cnt ) )







  ; 

  if (! is_impersonator )
    if (! FUNCCALL(SETUP_XfOrM530(_), scheme_chaperone_of (vals [0 ] , evt ) ))
    FUNCCALL(SETUP_XfOrM530(_), scheme_wrong_chaperoned ("evt chaperone" , "value" , evt , vals [0 ] ) ); 
  if (! FUNCCALL(SETUP_XfOrM530(_), scheme_check_proc_arity (((void * ) 0 ) , 1 , 1 , 1 , vals ) ))
    FUNCCALL(SETUP_XfOrM530(_), scheme_raise_exn (MZEXN_FAIL_CONTRACT , "evt %s: contract violation for second %s result\n" "  expected: (any/c any/c . -> . any)\n" "  received: %V" , (is_impersonator ? "impersonator" : "chaperone" ) , (is_impersonator ? "impersonator" : "chaperone" ) , vals [1 ] ) )





  ; 

  a [0 ] = vals [0 ] ; 
  o = FUNCCALL(SETUP_XfOrM530(_), scheme_make_closed_prim_w_arity ((is_impersonator ? impersonator_result_guard_proc : chaperone_result_guard_proc ) , (void * ) vals [1 ] , "evt-result-chaperone" , 1 , - 1 ) )




  ; 
  a [1 ] = o ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM530(_), scheme_wrap_evt (1 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3846 "./../src/struct.c"
static Scheme_Object * chaperone_guard_proc (void * data , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3848 "./../src/struct.c"
  return do_chaperone_guard_proc (0 , data , argc , argv ) ; 
}

static Scheme_Object * impersonator_guard_proc (void * data , int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3853 "./../src/struct.c"
  return do_chaperone_guard_proc (1 , data , argc , argv ) ; 
}

Scheme_Object * scheme_do_chaperone_evt (const char * name , int is_impersonator , int argc , Scheme_Object * argv [] ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * o , * val , * a [1 ] ; 
  Scheme_Object * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(val, 0), PUSH(px, 1), PUSHARRAY(a, 1, 2), PUSH(argv, 5), PUSH(o, 6), PUSH(props, 7), PUSH(name, 8)));
# define XfOrM535_COUNT (9)
# define SETUP_XfOrM535(x) SETUP(XfOrM535_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  o = NULLED_OUT ; 
  val = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 3862 "./../src/struct.c"
  val = argv [0 ] ; 
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! FUNCCALL(SETUP_XfOrM535(_), scheme_is_evt (val ) ))
    FUNCCALL(SETUP_XfOrM535(_), scheme_wrong_contract (name , "evt?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM535(_), scheme_check_proc_arity (name , 1 , 1 , argc , argv ) ); 

  props = FUNCCALL_AGAIN(scheme_parse_chaperone_props (name , 2 , argc , argv ) ); 

  o = FUNCCALL_AGAIN(scheme_make_pair (argv [0 ] , argv [1 ] ) ); 
  o = FUNCCALL_AGAIN(scheme_make_closed_prim_w_arity ((is_impersonator ? impersonator_guard_proc : chaperone_guard_proc ) , (void * ) o , (is_impersonator ? "chaperone-evt" : "impersonate-evt" ) , 1 , 1 ) )






  ; 
  a [0 ] = o ; 
  o = FUNCCALL(SETUP_XfOrM535(_), nack_evt (1 , a ) ); 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM535(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  if (! (((intptr_t ) (val ) ) & 0x1 ) && ((((val ) -> type ) >= scheme_prim_type ) && (((val ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
    px -> iso . so . type = scheme_proc_chaperone_type ; 
  else 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 
  px -> redirects = o ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3900 "./../src/struct.c"
static Scheme_Object * chaperone_evt (int argc , Scheme_Object * argv [] ) 
{
  /* No conversion */

# 3902 "./../src/struct.c"
  return scheme_do_chaperone_evt ("chaperone-evt" , 0 , argc , argv ) ; 
}

static int chaperone_evt_is_ready (Scheme_Object * obj , Scheme_Schedule_Info * sinfo ) 
{
  /* No conversion */

# 3907 "./../src/struct.c"
  Scheme_Object * o = obj ; 
  Scheme_Chaperone * px ; 
  int redirected = 0 ; 

  while ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) ) {
    px = (Scheme_Chaperone * ) o ; 
    if ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_nack_guard_evt_type ) )  {
      o = px -> redirects ; 
      redirected = 1 ; 
      break ; 
    }
    o = px -> prev ; 
  }

  if (! redirected && (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) ) {



    return evt_struct_is_ready (obj , sinfo ) ; 
  }

  scheme_set_sync_target (sinfo , o , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) ; 
  return 0 ; 
}

static int is_chaperone_evt (Scheme_Object * o ) 
{
  /* No conversion */

# 3934 "./../src/struct.c"
  return scheme_is_evt ((((Scheme_Chaperone * ) o ) -> val ) ) ; 
}

static Scheme_Object * nack_evt (int argc , Scheme_Object * argv [] ) 
{
  Nack_Guard_Evt * nw ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(nw, 1)));
# define XfOrM544_COUNT (2)
# define SETUP_XfOrM544(x) SETUP(XfOrM544_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  nw = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM544(_), scheme_check_proc_arity ("nack-guard-evt" , 1 , 0 , argc , argv ) )
# 3941 "./../src/struct.c"
  ; 

  nw = ((Nack_Guard_Evt * ) FUNCCALL(SETUP_XfOrM544(_), GC_malloc_one_small_tagged ((((sizeof (Nack_Guard_Evt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  nw -> so . type = scheme_nack_guard_evt_type ; 
  nw -> maker = argv [0 ] ; 

  RET_VALUE_START ((Scheme_Object * ) nw ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3950 "./../src/struct.c"
Scheme_Object * scheme_poll_evt (int argc , Scheme_Object * argv [] ) 
{
  Nack_Guard_Evt * nw ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(nw, 1)));
# define XfOrM545_COUNT (2)
# define SETUP_XfOrM545(x) SETUP(XfOrM545_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  nw = NULLED_OUT ; 
  FUNCCALL(SETUP_XfOrM545(_), scheme_check_proc_arity ("poll-guard-evt" , 1 , 0 , argc , argv ) )
# 3954 "./../src/struct.c"
  ; 

  nw = ((Nack_Guard_Evt * ) FUNCCALL(SETUP_XfOrM545(_), GC_malloc_one_small_tagged ((((sizeof (Nack_Guard_Evt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  nw -> so . type = scheme_poll_evt_type ; 
  nw -> maker = argv [0 ] ; 

  RET_VALUE_START ((Scheme_Object * ) nw ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3963 "./../src/struct.c"
static int wrapped_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Wrapped_Evt * ww = (Wrapped_Evt * ) o ; 
  Scheme_Object * wrapper ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(wrapper, 0), PUSH(ww, 1), PUSH(sinfo, 2)));
# define XfOrM546_COUNT (3)
# define SETUP_XfOrM546(x) SETUP(XfOrM546_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  wrapper = NULLED_OUT ; 

# 3968 "./../src/struct.c"
  if (ww -> so . type == scheme_wrap_evt_type ) {
    wrapper = ww -> wrapper ; 
  }

# 3970 "./../src/struct.c"
  else {
#   define XfOrM547_COUNT (0+XfOrM546_COUNT)
#   define SETUP_XfOrM547(x) SETUP_XfOrM546(x)

# 3972 "./../src/struct.c"
    wrapper = FUNCCALL(SETUP_XfOrM547(_), scheme_box (ww -> wrapper ) ); 
  }
  FUNCCALL_EMPTY(scheme_set_sync_target (sinfo , ww -> evt , wrapper , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
  ; 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 3979 "./../src/struct.c"
static int nack_guard_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Nack_Guard_Evt * nw = (Nack_Guard_Evt * ) o ; 
  Scheme_Object * sema , * a [1 ] , * result ; 
  Scheme_Object * nack ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(9);
  BLOCK_SETUP_TOP((PUSH(result, 0), PUSH(sema, 1), PUSH(sinfo, 2), PUSHARRAY(a, 1, 3), PUSH(nack, 6), PUSH(nw, 7), PUSH(o, 8)));
# define XfOrM549_COUNT (9)
# define SETUP_XfOrM549(x) SETUP(XfOrM549_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  sema = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  result = NULLED_OUT ; 
  nack = NULLED_OUT ; 

# 3985 "./../src/struct.c"
  if (sinfo -> false_positive_ok ) {
    sinfo -> potentially_false_positive = 1 ; 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

  sema = FUNCCALL(SETUP_XfOrM549(_), scheme_make_sema (0 ) ); 
  FUNCCALL(SETUP_XfOrM549(_), scheme_set_sync_target (sinfo , o , ((void * ) 0 ) , sema , 0 , 0 , ((void * ) 0 ) ) )



  ; 


  nack = ((Scheme_Object * ) FUNCCALL(SETUP_XfOrM549(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Simple_Object ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  nack -> type = scheme_nack_evt_type ; 
  (((Scheme_Simple_Object * ) (nack ) ) -> u . two_ptr_val . ptr1 ) = sema ; 
  result = FUNCCALL(SETUP_XfOrM549(_), scheme_get_thread_sync (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ) ); 
  (((Scheme_Simple_Object * ) (nack ) ) -> u . two_ptr_val . ptr2 ) = result ; 

  a [0 ] = nack ; 
  result = FUNCCALL(SETUP_XfOrM549(_), scheme_apply (nw -> maker , 1 , a ) ); 

  if (FUNCCALL(SETUP_XfOrM549(_), scheme_is_evt (result ) )) {
#   define XfOrM550_COUNT (0+XfOrM549_COUNT)
#   define SETUP_XfOrM550(x) SETUP_XfOrM549(x)
    FUNCCALL(SETUP_XfOrM550(_), scheme_set_sync_target (sinfo , result , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
# 4008 "./../src/struct.c"
    ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 4010 "./../src/struct.c"
  else 
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4014 "./../src/struct.c"
static int nack_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Scheme_Object * a [2 ] , * wset ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 2, 0), PUSH(sinfo, 3), PUSH(o, 4), PUSH(wset, 5)));
# define XfOrM552_COUNT (6)
# define SETUP_XfOrM552(x) SETUP(XfOrM552_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  wset = NULLED_OUT ; 

# 4018 "./../src/struct.c"
  wset = (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr1 ) ; 

  if ((Scheme_Type ) (((((intptr_t ) (wset ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (wset ) ) -> type ) ) == (Scheme_Type ) (scheme_sema_type ) )  {
#   define XfOrM553_COUNT (0+XfOrM552_COUNT)
#   define SETUP_XfOrM553(x) SETUP_XfOrM552(x)

# 4021 "./../src/struct.c"
    a [0 ] = wset ; 
    a [1 ] = (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr2 ) ; 
    wset = FUNCCALL(SETUP_XfOrM553(_), scheme_make_evt_set (2 , a ) ); 
    (((Scheme_Simple_Object * ) (o ) ) -> u . two_ptr_val . ptr1 ) = wset ; 
  }
  FUNCCALL(SETUP_XfOrM552(_), scheme_set_sync_target (sinfo , wset , scheme_void , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )

  ; 

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4033 "./../src/struct.c"
static int poll_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Nack_Guard_Evt * nw = (Nack_Guard_Evt * ) o ; 
  Scheme_Object * a [1 ] , * result ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(result, 0), PUSHARRAY(a, 1, 1), PUSH(sinfo, 4)));
# define XfOrM554_COUNT (5)
# define SETUP_XfOrM554(x) SETUP(XfOrM554_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a[0] = NULLED_OUT ; 
  result = NULLED_OUT ; 

# 4038 "./../src/struct.c"
  if (sinfo -> false_positive_ok ) {
    sinfo -> potentially_false_positive = 1 ; 
    RET_VALUE_START (1 ) RET_VALUE_END ; 
  }

  a [0 ] = (sinfo -> is_poll ? scheme_true : scheme_false ) ; 
  result = FUNCCALL(SETUP_XfOrM554(_), scheme_apply (nw -> maker , 1 , a ) ); 

  if (FUNCCALL(SETUP_XfOrM554(_), scheme_is_evt (result ) )) {
#   define XfOrM555_COUNT (0+XfOrM554_COUNT)
#   define SETUP_XfOrM555(x) SETUP_XfOrM554(x)
    FUNCCALL(SETUP_XfOrM555(_), scheme_set_sync_target (sinfo , result , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
# 4047 "./../src/struct.c"
    ; 
    RET_VALUE_START (0 ) RET_VALUE_END ; 
  }

# 4049 "./../src/struct.c"
  else 
  RET_VALUE_START (1 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4053 "./../src/struct.c"
static int replace_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Active_Replace_Evt * a ; 
  Syncing * s ; 
  Scheme_Object * argv [1 ] ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSHARRAY(argv, 1, 0), PUSH(a, 3), PUSH(s, 4), PUSH(sinfo, 5), PUSH(o, 6)));
# define XfOrM557_COUNT (7)
# define SETUP_XfOrM557(x) SETUP(XfOrM557_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 
  s = NULLED_OUT ; 
  argv[0] = NULLED_OUT ; 

# 4059 "./../src/struct.c"
  argv [0 ] = ((Wrapped_Evt * ) o ) -> evt ; 
  s = FUNCCALL(SETUP_XfOrM557(_), scheme_make_syncing (1 , argv ) ); 

  a = ((Active_Replace_Evt * ) FUNCCALL(SETUP_XfOrM557(_), GC_malloc_one_small_tagged ((((sizeof (Active_Replace_Evt ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  a -> so . type = scheme_active_replace_evt_type ; 
  a -> done = 0 ; 
  a -> wrapper = ((Wrapped_Evt * ) o ) -> wrapper ; 
  a -> syncing = s ; 
  a -> orig = o ; 
  FUNCCALL(SETUP_XfOrM557(_), scheme_set_sync_target (sinfo , (Scheme_Object * ) a , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
  ; 
  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4073 "./../src/struct.c"
static int active_replace_evt_is_ready (Scheme_Object * o , Scheme_Schedule_Info * sinfo ) 
{
  Active_Replace_Evt * a = (Active_Replace_Evt * ) o ; 
  int nested = 0 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK(7);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(sinfo, 1)));
# define XfOrM558_COUNT (2)
# define SETUP_XfOrM558(x) SETUP(XfOrM558_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4078 "./../src/struct.c"
  if (! a -> syncing )
    RET_VALUE_START (0 ) RET_VALUE_END ; 

  do {
#   define XfOrM573_COUNT (0+XfOrM558_COUNT)
#   define SETUP_XfOrM573(x) SETUP_XfOrM558(x)

# 4082 "./../src/struct.c"
    if (a -> syncing ) {
#     define XfOrM575_COUNT (0+XfOrM573_COUNT)
#     define SETUP_XfOrM575(x) SETUP_XfOrM573(x)

# 4084 "./../src/struct.c"
      if (a -> done && sinfo -> false_positive_ok ) {
        sinfo -> potentially_false_positive = 1 ; 
        if (nested )
          sinfo -> replace_chain = ((void * ) 0 ) ; 
        RET_VALUE_START (1 ) RET_VALUE_END ; 
      }

      if (! a -> done && sinfo -> replace_chain && ! nested ) {




        Scheme_Object * l ; 
        BLOCK_SETUP((PUSH(l, 0+XfOrM575_COUNT)));
#       define XfOrM585_COUNT (1+XfOrM575_COUNT)
#       define SETUP_XfOrM585(x) SETUP(XfOrM585_COUNT)
        l = NULLED_OUT ; 

# 4097 "./../src/struct.c"
        l = FUNCCALL(SETUP_XfOrM585(_), scheme_make_pair ((Scheme_Object * ) a , sinfo -> replace_chain ) ); 
        sinfo -> replace_chain = l ; 
        RET_VALUE_START (0 ) RET_VALUE_END ; 
      }

      if (! a -> done && ! sinfo -> replace_chain ) {

        sinfo -> replace_chain = scheme_null ; 
      }

      if (a -> done || FUNCCALL(SETUP_XfOrM575(_), scheme_syncing_ready (a -> syncing , sinfo , 0 ) )) {
#       define XfOrM576_COUNT (0+XfOrM575_COUNT)
#       define SETUP_XfOrM576(x) SETUP_XfOrM575(x)

# 4108 "./../src/struct.c"
        sinfo -> replace_chain = ((void * ) 0 ) ; 

        if (sinfo -> potentially_false_positive )
          RET_VALUE_START (1 ) RET_VALUE_END ; 

        a -> done = 1 ; 
        if (sinfo -> false_positive_ok ) {
          sinfo -> potentially_false_positive = 1 ; 
          RET_VALUE_START (1 ) RET_VALUE_END ; 
        }

# 4117 "./../src/struct.c"
        else if (nested ) {




          sinfo -> spin = 1 ; 
          RET_VALUE_START (0 ) RET_VALUE_END ; 
        }

# 4124 "./../src/struct.c"
        else {

          Scheme_Object * v , * argv [1 ] , * * args ; 
          Syncing * s = a -> syncing ; 
          int argc ; 
          BLOCK_SETUP((PUSHARRAY(argv, 1, 0+XfOrM576_COUNT), PUSH(args, 3+XfOrM576_COUNT), PUSH(v, 4+XfOrM576_COUNT)));
#         define XfOrM577_COUNT (5+XfOrM576_COUNT)
#         define SETUP_XfOrM577(x) SETUP(XfOrM577_COUNT)
          v = NULLED_OUT ; 
          argv[0] = NULLED_OUT ; 
          args = NULLED_OUT ; 

# 4130 "./../src/struct.c"
          a -> syncing = ((void * ) 0 ) ; 

          v = FUNCCALL(SETUP_XfOrM577(_), scheme_syncing_result (s , 0 ) ); 

          if ((v ) == (((Scheme_Object * ) 0x6 ) ) )  {
#           define XfOrM581_COUNT (0+XfOrM577_COUNT)
#           define SETUP_XfOrM581(x) SETUP_XfOrM577(x)

# 4135 "./../src/struct.c"
            argc = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . count ) ; 
            args = (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . multiple . array ) ; 
            FUNCCALL(SETUP_XfOrM581(_), scheme_detach_multple_array (args ) ); 
          }

# 4138 "./../src/struct.c"
          else {
            argv [0 ] = v ; 
            args = argv ; 
            argc = 1 ; 
          }

          v = FUNCCALL(SETUP_XfOrM577(_), scheme_apply (a -> wrapper , argc , args ) ); 

          if (FUNCCALL(SETUP_XfOrM577(_), scheme_is_evt (v ) )) {
#           define XfOrM579_COUNT (0+XfOrM577_COUNT)
#           define SETUP_XfOrM579(x) SETUP_XfOrM577(x)
            FUNCCALL(SETUP_XfOrM579(_), scheme_set_sync_target (sinfo , v , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
# 4147 "./../src/struct.c"
            ; 
            RET_VALUE_START (0 ) RET_VALUE_END ; 
          }

# 4149 "./../src/struct.c"
          else {
#           define XfOrM578_COUNT (0+XfOrM577_COUNT)
#           define SETUP_XfOrM578(x) SETUP_XfOrM577(x)
            FUNCCALL(SETUP_XfOrM578(_), scheme_set_sync_target (sinfo , a -> orig , ((void * ) 0 ) , ((void * ) 0 ) , 0 , 1 , ((void * ) 0 ) ) )
# 4151 "./../src/struct.c"
            ; 
            RET_VALUE_START (1 ) RET_VALUE_END ; 
          }
        }
      }
    }

    if (sinfo -> replace_chain && ! ((sinfo -> replace_chain ) == (scheme_null ) ) ) {

      a = (Active_Replace_Evt * ) (((Scheme_Simple_Object * ) (sinfo -> replace_chain ) ) -> u . pair_val . car ) ; 
      sinfo -> replace_chain = (((Scheme_Simple_Object * ) (sinfo -> replace_chain ) ) -> u . pair_val . cdr ) ; 
      nested = 1 ; 
    }

# 4163 "./../src/struct.c"
    else 
    a = ((void * ) 0 ) ; 
  }

# 4165 "./../src/struct.c"
  while (a ) ; 

  sinfo -> replace_chain = ((void * ) 0 ) ; 

  RET_VALUE_START (0 ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4172 "./../src/struct.c"
static void active_replace_evt_needs_wakeup (Scheme_Object * o , void * fds ) 
{
  /* No conversion */

# 4174 "./../src/struct.c"
  Active_Replace_Evt * a = (Active_Replace_Evt * ) o ; 

  if (a -> syncing && ! a -> done )
    scheme_syncing_needs_wakeup (a -> syncing , fds ) ; 
}

Syncing * scheme_replace_evt_needs_wakeup (Scheme_Object * o ) 
{
  /* No conversion */

# 4182 "./../src/struct.c"
  Active_Replace_Evt * a = (Active_Replace_Evt * ) o ; 

  if (a -> syncing && ! a -> done )
    return a -> syncing ; 

  return ((void * ) 0 ) ; 
}

Syncing * scheme_replace_evt_nack (Scheme_Object * o ) 
{
  /* No conversion */

# 4192 "./../src/struct.c"
  Active_Replace_Evt * a = (Active_Replace_Evt * ) o ; 
  Syncing * s = ((void * ) 0 ) ; 

  if (a -> syncing ) {
    s = a -> syncing ; 
    a -> syncing = ((void * ) 0 ) ; 
  }

  return s ; 
}

Syncing * scheme_replace_evt_get (Scheme_Object * o ) 
{
  /* No conversion */

# 4205 "./../src/struct.c"
  Active_Replace_Evt * a = (Active_Replace_Evt * ) o ; 

  return a -> syncing ; 
}








Scheme_Object * * scheme_make_struct_values (Scheme_Object * type , 
Scheme_Object * * names , 
int count , 
int flags ) 
{
  Scheme_Struct_Type * struct_type ; 
  Scheme_Object * * values ; 
  Scheme_Object * vi ; 
  char * nm ; 
  int slot_num , pos ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(nm, 0), PUSH(struct_type, 1), PUSH(names, 2), PUSH(values, 3), PUSH(vi, 4)));
# define XfOrM592_COUNT (5)
# define SETUP_XfOrM592(x) SETUP(XfOrM592_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  struct_type = NULLED_OUT ; 
  values = NULLED_OUT ; 
  vi = NULLED_OUT ; 
  nm = NULLED_OUT ; 

# 4228 "./../src/struct.c"
  struct_type = (Scheme_Struct_Type * ) type ; 

  if (flags & 0x80 )
    -- count ; 

  values = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM592(_), GC_malloc (sizeof (Scheme_Object * ) * (count ) ) )) ; 








  pos = 0 ; 
  if (! (flags & 0x01 ) )
    values [pos ++ ] = (Scheme_Object * ) struct_type ; 
  if (! (flags & 0x02 ) ) {
#   define XfOrM602_COUNT (0+XfOrM592_COUNT)
#   define SETUP_XfOrM602(x) SETUP_XfOrM592(x)

# 4246 "./../src/struct.c"
    nm = ((flags & 0x200 ) 
    ? (char * ) names [pos ] 
    : FUNCCALL(SETUP_XfOrM602(_), scheme_symbol_val (names [pos ] ) )) ; 
    vi = FUNCCALL(SETUP_XfOrM602(_), make_struct_proc (struct_type , nm , SCHEME_CONSTR , struct_type -> num_slots ) )


    ; 
    (adjust_primitive (vi , struct_type , flags ) ) ; 
    values [pos ] = vi ; 
    pos ++ ; 
  }
  if (! (flags & 0x04 ) ) {
#   define XfOrM601_COUNT (0+XfOrM592_COUNT)
#   define SETUP_XfOrM601(x) SETUP_XfOrM592(x)

# 4258 "./../src/struct.c"
    nm = ((flags & 0x200 ) 
    ? (char * ) names [pos ] 
    : FUNCCALL(SETUP_XfOrM601(_), scheme_symbol_val (names [pos ] ) )) ; 
    vi = FUNCCALL(SETUP_XfOrM601(_), make_struct_proc (struct_type , nm , SCHEME_PRED , 0 ) )


    ; 
    (adjust_primitive (vi , struct_type , flags ) ) ; 
    values [pos ] = vi ; 
    pos ++ ; 
  }

  if (flags & 0x20 )
    -- count ; 
  if (flags & 0x40 )
    -- count ; 

  slot_num = (struct_type -> name_pos 
  ? struct_type -> parent_types [struct_type -> name_pos - 1 ] -> num_slots 
  : 0 ) ; 
  while (pos < count ) {
#   define XfOrM598_COUNT (0+XfOrM592_COUNT)
#   define SETUP_XfOrM598(x) SETUP_XfOrM592(x)

# 4279 "./../src/struct.c"
    if (! (flags & 0x08 ) ) {
#     define XfOrM600_COUNT (0+XfOrM598_COUNT)
#     define SETUP_XfOrM600(x) SETUP_XfOrM598(x)

# 4280 "./../src/struct.c"
      nm = ((flags & 0x200 ) 
      ? (char * ) names [pos ] 
      : FUNCCALL(SETUP_XfOrM600(_), scheme_symbol_val (names [pos ] ) )) ; 
      vi = FUNCCALL(SETUP_XfOrM600(_), make_struct_proc (struct_type , nm , SCHEME_GETTER , slot_num ) )


      ; 
      (adjust_primitive (vi , struct_type , flags ) ) ; 
      values [pos ] = vi ; 
      pos ++ ; 
    }

    if (! (flags & 0x10 ) ) {
#     define XfOrM599_COUNT (0+XfOrM598_COUNT)
#     define SETUP_XfOrM599(x) SETUP_XfOrM598(x)

# 4293 "./../src/struct.c"
      nm = ((flags & 0x200 ) 
      ? (char * ) names [pos ] 
      : FUNCCALL(SETUP_XfOrM599(_), scheme_symbol_val (names [pos ] ) )) ; 
      vi = FUNCCALL(SETUP_XfOrM599(_), make_struct_proc (struct_type , nm , SCHEME_SETTER , slot_num ) )


      ; 
      (adjust_primitive (vi , struct_type , flags ) ) ; 
      values [pos ] = vi ; 
      pos ++ ; 
    }

    slot_num ++ ; 
  }

  if (flags & 0x20 ) {
#   define XfOrM594_COUNT (0+XfOrM592_COUNT)
#   define SETUP_XfOrM594(x) SETUP_XfOrM592(x)

# 4309 "./../src/struct.c"
    nm = ((flags & 0x200 ) 
    ? (char * ) names [pos ] 
    : FUNCCALL(SETUP_XfOrM594(_), scheme_symbol_val (names [pos ] ) )) ; 
    vi = FUNCCALL(SETUP_XfOrM594(_), make_struct_proc (struct_type , nm , SCHEME_GEN_GETTER , slot_num ) )


    ; 
    values [pos ] = vi ; 
    pos ++ ; 
  }
  if (flags & 0x40 ) {
#   define XfOrM593_COUNT (0+XfOrM592_COUNT)
#   define SETUP_XfOrM593(x) SETUP_XfOrM592(x)

# 4320 "./../src/struct.c"
    nm = ((flags & 0x200 ) 
    ? (char * ) names [pos ] 
    : FUNCCALL(SETUP_XfOrM593(_), scheme_symbol_val (names [pos ] ) )) ; 
    vi = FUNCCALL(SETUP_XfOrM593(_), make_struct_proc (struct_type , nm , SCHEME_GEN_SETTER , slot_num ) )


    ; 
    values [pos ] = vi ; 
    pos ++ ; 
  }

  RET_VALUE_START (values ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4334 "./../src/struct.c"
static void adjust_primitive (Scheme_Object * vi , Scheme_Struct_Type * stype , int flags ) {
  /* No conversion */

# 4335 "./../src/struct.c"
  if (flags & 0x400 ) {


    ((Scheme_Closed_Primitive_Proc * ) vi ) -> pp . flags &= ~ 4 ; 
  }

# 4339 "./../src/struct.c"
  else if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) ) {



    if (! (((stype -> inspector ) ) == (scheme_false ) ) ) 
      ((Scheme_Closed_Primitive_Proc * ) vi ) -> pp . flags |= 4 ; 
  }
}

static Scheme_Object * * _make_struct_names (const char * base , int blen , 
int fcount , 
Scheme_Object * field_symbols , 
const char * * field_strings , 
int flags , int * count_out ) 
{
  Scheme_Object * * names ; 
  const char * field_name ; 
  int count , fnlen ; 
  int slot_num , pos , as_sym ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK(6);
  BLOCK_SETUP_TOP((PUSH(base, 0), PUSH(field_symbols, 1), PUSH(field_strings, 2), PUSH(field_name, 3), PUSH(names, 4)));
# define XfOrM606_COUNT (5)
# define SETUP_XfOrM606(x) SETUP(XfOrM606_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  names = NULLED_OUT ; 
  field_name = NULLED_OUT ; 

# 4359 "./../src/struct.c"
  count = 0 ; 

  if (! (flags & 0x01 ) )
    count ++ ; 
  if (! (flags & 0x02 ) )
    count ++ ; 
  if (! (flags & 0x04 ) )
    count ++ ; 
  if (! (flags & 0x08 ) )
    count += fcount ; 
  if (! (flags & 0x10 ) )
    count += fcount ; 
  if (flags & 0x20 )
    count ++ ; 
  if (flags & 0x40 )
    count ++ ; 
  if (flags & 0x80 )
    count ++ ; 

  if (count_out ) {
    * count_out = count ; 
    count_out = ((void * ) 0 ) ; 
  }

  names = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM606(_), GC_malloc (sizeof (Scheme_Object * ) * (count ) ) )) ; 








  pos = 0 ; 

  as_sym = ((flags & 0x200 ) ? 0 : 1 ) ; 

  if (! (flags & 0x01 ) ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM606_COUNT)));
#   define XfOrM623_COUNT (1+XfOrM606_COUNT)
#   define SETUP_XfOrM623(x) SETUP(XfOrM623_COUNT)
    nm = NULLED_OUT ; 

# 4398 "./../src/struct.c"
    nm = FUNCCALL(SETUP_XfOrM623(_), make_name ("struct:" , base , blen , "" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }
  if (! (flags & 0x02 ) ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM606_COUNT)));
#   define XfOrM622_COUNT (1+XfOrM606_COUNT)
#   define SETUP_XfOrM622(x) SETUP(XfOrM622_COUNT)
    nm = NULLED_OUT ; 

# 4403 "./../src/struct.c"
    if (flags & 0x100 )
      nm = FUNCCALL(SETUP_XfOrM622(_), make_name ("" , base , blen , "" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    else 
    nm = FUNCCALL(SETUP_XfOrM622(_), make_name ("make-" , base , blen , "" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }
  if (! (flags & 0x04 ) ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM606_COUNT)));
#   define XfOrM621_COUNT (1+XfOrM606_COUNT)
#   define SETUP_XfOrM621(x) SETUP(XfOrM621_COUNT)
    nm = NULLED_OUT ; 

# 4411 "./../src/struct.c"
    nm = FUNCCALL(SETUP_XfOrM621(_), make_name ("" , base , blen , "?" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }

  if (fcount ) {
#   define XfOrM610_COUNT (0+XfOrM606_COUNT)
#   define SETUP_XfOrM610(x) SETUP_XfOrM606(x)

# 4416 "./../src/struct.c"
    for (slot_num = 0 ; slot_num < fcount ; slot_num ++ ) {
#     define XfOrM616_COUNT (0+XfOrM610_COUNT)
#     define SETUP_XfOrM616(x) SETUP_XfOrM610(x)

# 4417 "./../src/struct.c"
      if (field_symbols ) {
        Scheme_Object * fn = (((Scheme_Simple_Object * ) (field_symbols ) ) -> u . pair_val . car ) ; 
        BLOCK_SETUP((PUSH(fn, 0+XfOrM616_COUNT)));
#       define XfOrM620_COUNT (1+XfOrM616_COUNT)
#       define SETUP_XfOrM620(x) SETUP(XfOrM620_COUNT)

# 4419 "./../src/struct.c"
        field_symbols = (((Scheme_Simple_Object * ) (field_symbols ) ) -> u . pair_val . cdr ) ; 

        field_name = FUNCCALL(SETUP_XfOrM620(_), scheme_symbol_val (fn ) ); 
        fnlen = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (fn ) ) ) -> len ) ; 
      }

# 4423 "./../src/struct.c"
      else {
        field_name = field_strings [slot_num ] ; 
        fnlen = strlen (field_name ) ; 
      }

      if (! (flags & 0x08 ) ) {
        Scheme_Object * nm ; 
        BLOCK_SETUP((PUSH(nm, 0+XfOrM616_COUNT)));
#       define XfOrM618_COUNT (1+XfOrM616_COUNT)
#       define SETUP_XfOrM618(x) SETUP(XfOrM618_COUNT)
        nm = NULLED_OUT ; 

# 4430 "./../src/struct.c"
        nm = FUNCCALL(SETUP_XfOrM618(_), make_name ("" , base , blen , "-" , field_name , fnlen , "" , as_sym ) ); 
        names [pos ++ ] = nm ; 
      }
      if (! (flags & 0x10 ) ) {
        Scheme_Object * nm ; 
        BLOCK_SETUP((PUSH(nm, 0+XfOrM616_COUNT)));
#       define XfOrM617_COUNT (1+XfOrM616_COUNT)
#       define SETUP_XfOrM617(x) SETUP(XfOrM617_COUNT)
        nm = NULLED_OUT ; 

# 4435 "./../src/struct.c"
        nm = FUNCCALL(SETUP_XfOrM617(_), make_name ("set-" , base , blen , "-" , field_name , fnlen , "!" , as_sym ) ); 
        names [pos ++ ] = nm ; 
      }
    }
  }

  if (flags & 0x20 ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM606_COUNT)));
#   define XfOrM609_COUNT (1+XfOrM606_COUNT)
#   define SETUP_XfOrM609(x) SETUP(XfOrM609_COUNT)
    nm = NULLED_OUT ; 

# 4443 "./../src/struct.c"
    nm = FUNCCALL(SETUP_XfOrM609(_), make_name ("" , base , blen , "-ref" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }
  if (flags & 0x40 ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM606_COUNT)));
#   define XfOrM608_COUNT (1+XfOrM606_COUNT)
#   define SETUP_XfOrM608(x) SETUP(XfOrM608_COUNT)
    nm = NULLED_OUT ; 

# 4448 "./../src/struct.c"
    nm = FUNCCALL(SETUP_XfOrM608(_), make_name ("" , base , blen , "-set!" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }

  if (flags & 0x80 ) {
    Scheme_Object * nm ; 
    BLOCK_SETUP((PUSH(nm, 0+XfOrM606_COUNT)));
#   define XfOrM607_COUNT (1+XfOrM606_COUNT)
#   define SETUP_XfOrM607(x) SETUP(XfOrM607_COUNT)
    nm = NULLED_OUT ; 

# 4454 "./../src/struct.c"
    nm = FUNCCALL(SETUP_XfOrM607(_), make_name ("" , base , blen , "" , ((void * ) 0 ) , 0 , "" , as_sym ) ); 
    names [pos ++ ] = nm ; 
  }

  RET_VALUE_START (names ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4461 "./../src/struct.c"
Scheme_Object * * scheme_make_struct_names (Scheme_Object * base , 
Scheme_Object * field_symbols , 
int flags , int * count_out ) 
{
  int len ; 
  char * __funcarg147 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(base, 0), PUSH(field_symbols, 1), PUSH(count_out, 2)));
# define XfOrM625_COUNT (3)
# define SETUP_XfOrM625(x) SETUP(XfOrM625_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 4466 "./../src/struct.c"
  len = field_symbols ? (scheme_list_length (field_symbols ) ) : 0 ; 

  RET_VALUE_START ((__funcarg147 = FUNCCALL(SETUP_XfOrM625(_), scheme_symbol_val (base ) ), FUNCCALL_EMPTY(_make_struct_names (__funcarg147 , (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) (base ) ) ) -> len ) , len , field_symbols , ((void * ) 0 ) , flags , count_out ) )) ) RET_VALUE_END 



  ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4475 "./../src/struct.c"
Scheme_Object * * scheme_make_struct_names_from_array (const char * base , 
int fcount , 
const char * * fields , 
int flags , int * count_out ) 
{
  /* No conversion */

# 4480 "./../src/struct.c"
  return _make_struct_names (base , 
  strlen (base ) , 
  fcount , 
  ((void * ) 0 ) , fields , 
  flags , count_out ) ; 
}

static Scheme_Object * 
make_struct_proc (Scheme_Struct_Type * struct_type , 
char * func_name , 
Scheme_ProcT proc_type , int field_num ) 
{
  Scheme_Object * p , * a [3 ] ; 
  short flags = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(func_name, 0), PUSHARRAY(a, 3, 1), PUSH(p, 4), PUSH(struct_type, 5)));
# define XfOrM627_COUNT (6)
# define SETUP_XfOrM627(x) SETUP(XfOrM627_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  a[1] = NULLED_OUT ; 
  a[2] = NULLED_OUT ; 

# 4495 "./../src/struct.c"
  if (proc_type == SCHEME_CONSTR ) {
    int simple ; 
#   define XfOrM635_COUNT (0+XfOrM627_COUNT)
#   define SETUP_XfOrM635(x) SETUP_XfOrM627(x)

# 4497 "./../src/struct.c"
    simple = FUNCCALL(SETUP_XfOrM635(_), scheme_is_simple_struct_type (struct_type ) ); 
    a [0 ] = (Scheme_Object * ) struct_type ; 
    p = FUNCCALL(SETUP_XfOrM635(_), scheme_make_folding_prim_closure ((simple ? make_simple_struct_instance : make_struct_instance ) , 1 , a , func_name , struct_type -> num_islots , struct_type -> num_islots , 0 ) )






    ; 
    flags |= (simple 
    ? (32 | 64 | 128 ) 
    : 128 ) ; 
  }

# 4510 "./../src/struct.c"
  else if (proc_type == SCHEME_PRED ) {
#   define XfOrM634_COUNT (0+XfOrM627_COUNT)
#   define SETUP_XfOrM634(x) SETUP_XfOrM627(x)

# 4511 "./../src/struct.c"
    a [0 ] = (Scheme_Object * ) struct_type ; 
    p = FUNCCALL(SETUP_XfOrM634(_), scheme_make_folding_prim_closure (struct_pred , 1 , a , func_name , 1 , 1 , 1 ) )


    ; 
    flags |= (32 | 64 ) ; 
  }

# 4517 "./../src/struct.c"
  else {
    int need_pos ; 
#   define XfOrM628_COUNT (0+XfOrM627_COUNT)
#   define SETUP_XfOrM628(x) SETUP_XfOrM627(x)

# 4520 "./../src/struct.c"
    if ((proc_type == SCHEME_GEN_GETTER ) 
    || (proc_type == SCHEME_GEN_SETTER ) )
      need_pos = 1 ; 
    else 
    need_pos = 0 ; 

    a [0 ] = (Scheme_Object * ) struct_type ; 
    a [1 ] = ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (field_num ) ) ) << 1 ) | 0x1 ) ) ; 
    a [2 ] = (Scheme_Object * ) func_name ; 

    if ((proc_type == SCHEME_GETTER ) || (proc_type == SCHEME_GEN_GETTER ) ) {
#     define XfOrM633_COUNT (0+XfOrM628_COUNT)
#     define SETUP_XfOrM633(x) SETUP_XfOrM628(x)

# 4531 "./../src/struct.c"
      p = FUNCCALL(SETUP_XfOrM633(_), scheme_make_folding_prim_closure (scheme_struct_getter , 3 , a , func_name , 1 + need_pos , 1 + need_pos , 0 ) )


      ; 
      if (need_pos )
        flags |= (32 | 256 ) ; 
      else 
      flags |= 32 ; 
    }


    else {
#     define XfOrM629_COUNT (0+XfOrM628_COUNT)
#     define SETUP_XfOrM629(x) SETUP_XfOrM628(x)

# 4543 "./../src/struct.c"
      p = FUNCCALL(SETUP_XfOrM629(_), scheme_make_folding_prim_closure (scheme_struct_setter , 3 , a , func_name , 2 + need_pos , 2 + need_pos , 0 ) )


      ; 
      if (need_pos )
        flags |= 256 ; 
      else {
        flags |= (128 | 256 ) ; 

        if (struct_type -> immutables ) {
          if (struct_type -> name_pos )
            field_num -= struct_type -> parent_types [struct_type -> name_pos - 1 ] -> num_slots ; 
          if (struct_type -> immutables [field_num ] ) {
            flags -= (128 | 256 ) ; 
            flags |= (32 | 128 ) ; 
          }
        }
      }
    }
  }



  ((Scheme_Closed_Primitive_Proc * ) p ) -> pp . flags |= flags ; 

  RET_VALUE_START (p ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4571 "./../src/struct.c"
Scheme_Object * scheme_rename_struct_proc (Scheme_Object * p , Scheme_Object * sym ) 
{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(3);
  BLOCK_SETUP_TOP((PUSH(p, 0)));
# define XfOrM636_COUNT (1)
# define SETUP_XfOrM636(x) SETUP(XfOrM636_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 4573 "./../src/struct.c"
  if ((Scheme_Type ) (((((intptr_t ) (p ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (p ) ) -> type ) ) == (Scheme_Type ) (scheme_prim_type ) )  {
    unsigned short flags = ((Scheme_Primitive_Proc * ) p ) -> pp . flags ; 
    int is_getter = ((flags & (32 | 64 | 128 | 256 ) ) == 32 ) ; 
    int is_setter = (((flags & (32 | 64 | 128 | 256 ) ) == (128 | 256 ) ) 
    || ((flags & (32 | 64 | 128 | 256 ) ) == (32 | 128 ) ) ) ; 
#   define XfOrM637_COUNT (0+XfOrM636_COUNT)
#   define SETUP_XfOrM637(x) SETUP_XfOrM636(x)

# 4579 "./../src/struct.c"
    if (is_getter || is_setter ) {
      const char * func_name ; 
      Scheme_Struct_Type * st ; 
      int field_pos ; 
      BLOCK_SETUP((PUSH(func_name, 0+XfOrM637_COUNT), PUSH(st, 1+XfOrM637_COUNT)));
#     define XfOrM638_COUNT (2+XfOrM637_COUNT)
#     define SETUP_XfOrM638(x) SETUP(XfOrM638_COUNT)
      func_name = NULLED_OUT ; 
      st = NULLED_OUT ; 

# 4584 "./../src/struct.c"
      func_name = FUNCCALL(SETUP_XfOrM638(_), scheme_symbol_name (sym ) ); 

      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) p ) -> val [0 ] ; 
      field_pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) p ) -> val [1 ] ) ) >> 1 ) ; 

      RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(make_struct_proc (st , (char * ) func_name , is_getter ? SCHEME_GETTER : SCHEME_SETTER , field_pos ) )) RET_VALUE_EMPTY_END 

      ; 
    }
  }

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4598 "./../src/struct.c"
static Scheme_Object * make_name (const char * pre , const char * tn , int ltn , 
const char * post1 , const char * fn , int lfn , 
const char * post2 , int sym ) 
{
  int total , lp , lp1 , lp2 , xltn , xlfn ; 
  char * name , buffer [256 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(tn, 0), PUSH(pre, 1), PUSH(fn, 2), PUSH(post2, 3), PUSH(name, 4), PUSH(post1, 5)));
# define XfOrM639_COUNT (6)
# define SETUP_XfOrM639(x) SETUP(XfOrM639_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  name = NULLED_OUT ; 

# 4605 "./../src/struct.c"
  if (ltn < 0 )
    xltn = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) ((Scheme_Object * ) tn ) ) ) -> len ) ; 
  else 
  xltn = ltn ; 

  if (lfn < 0 )
    xlfn = (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) ((Scheme_Object * ) fn ) ) ) -> len ) ; 
  else 
  xlfn = lfn ; 

  total = lp = strlen (pre ) ; 
  total += xltn ; 
  total += (lp1 = strlen (post1 ) ) ; 
  total += xlfn ; 
  total += (lp2 = strlen (post2 ) ) ; 

  if (sym && (total < 256 ) )
    name = buffer ; 
  else 
  name = (char * ) FUNCCALL(SETUP_XfOrM639(_), GC_malloc_atomic (sizeof (char ) * (total + 1 ) ) ); 
  (
  memcpy (name , pre , lp ) ) ; 
  total = lp ; 
  if (xltn )
    (memcpy (name + total , (ltn < 0 ) ? (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) ((Scheme_Object * ) tn ) ) ) -> s ) : tn , xltn ) ) ; 
  total += xltn ; 
  (memcpy (name + total , post1 , lp1 ) ) ; 
  total += lp1 ; 
  if (xlfn )
    (memcpy (name + total , (lfn < 0 ) ? (((Scheme_Symbol * ) ((Scheme_Simple_Object * ) ((Scheme_Object * ) fn ) ) ) -> s ) : fn , xlfn ) ) ; 
  total += xlfn ; 
  (memcpy (name + total , post2 , lp2 ) ) ; 
  total += lp2 ; 

  name [total ] = 0 ; 

  if (sym )
    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_intern_exact_symbol (name , total ) )) RET_VALUE_EMPTY_END ; 
  else 
  RET_VALUE_START ((Scheme_Object * ) name ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * count_k (void ) ; 

static int count_non_proc_props (Scheme_Object * props ) 
{
  Scheme_Struct_Property * p ; 
  Scheme_Object * v ; 
  int count = 0 ; 
  DECL_RET_SAVE (int ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(v, 0), PUSH(props, 1), PUSH(p, 2)));
# define XfOrM640_COUNT (3)
# define SETUP_XfOrM640(x) SETUP(XfOrM640_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 4659 "./../src/struct.c"
  {

# 24 "./../src/mzstkchk.h"
    uintptr_t _stk_pos ; 
#   define XfOrM647_COUNT (0+XfOrM640_COUNT)
#   define SETUP_XfOrM647(x) SETUP_XfOrM640(x)

# 26 "./../src/mzstkchk.h"
    _stk_pos = (uintptr_t ) & _stk_pos ; 

    if (((_stk_pos ) < (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_stack_boundary_ ) ) ) 
    && ! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_no_stack_overflow_ ) ) 
# 4661 "./../src/struct.c"
    {
#     define XfOrM648_COUNT (0+XfOrM647_COUNT)
#     define SETUP_XfOrM648(x) SETUP_XfOrM647(x)

# 4662 "./../src/struct.c"
      XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) -> ku . k . p1 = (void * ) props ; 
      RET_VALUE_START ((((intptr_t ) (FUNCCALL(SETUP_XfOrM648(_), scheme_handle_stack_overflow (count_k ) )) ) >> 1 ) ) RET_VALUE_END ; 
    }
  }
  {
#   define XfOrM645_COUNT (0+XfOrM640_COUNT)
#   define SETUP_XfOrM645(x) SETUP_XfOrM640(x)

# 4666 "./../src/struct.c"
    if ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_fuel_counter_ ) ) <= 0 ) {
#     define XfOrM646_COUNT (0+XfOrM645_COUNT)
#     define SETUP_XfOrM646(x) SETUP_XfOrM645(x)
      FUNCCALL(SETUP_XfOrM646(_), scheme_out_of_fuel () )
# 4666 "./../src/struct.c"
      ; 
    }
  }

# 4666 "./../src/struct.c"
  ; 

  for (; ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; props = (((Scheme_Simple_Object * ) (props ) ) -> u . pair_val . cdr ) ) {
#   define XfOrM643_COUNT (0+XfOrM640_COUNT)
#   define SETUP_XfOrM643(x) SETUP_XfOrM640(x)

# 4669 "./../src/struct.c"
    v = (((Scheme_Simple_Object * ) (props ) ) -> u . pair_val . car ) ; 
    p = (Scheme_Struct_Property * ) (((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) ; 
    if (! (((Scheme_Object * ) p ) == (proc_property ) ) )
      count ++ ; 
    if (p -> supers ) {
#     define XfOrM644_COUNT (0+XfOrM643_COUNT)
#     define SETUP_XfOrM644(x) SETUP_XfOrM643(x)

# 4674 "./../src/struct.c"
      count += FUNCCALL(SETUP_XfOrM644(_), count_non_proc_props (p -> supers ) ); 
    }
  }

  RET_VALUE_START (count ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4681 "./../src/struct.c"
static Scheme_Object * count_k (void ) 
{
  /* No conversion */

# 4683 "./../src/struct.c"
  Scheme_Thread * p = XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_current_thread_ ) ; 
  Scheme_Object * props = (Scheme_Object * ) p -> ku . k . p1 ; 
  int c ; 

  p -> ku . k . p1 = ((void * ) 0 ) ; 

  c = count_non_proc_props (props ) ; 

  return ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (c ) ) ) << 1 ) | 0x1 ) ) ; 
}

static Scheme_Object * append_super_props (Scheme_Struct_Property * p , Scheme_Object * arg , Scheme_Object * orig ) 
{
  Scheme_Object * first = ((void * ) 0 ) , * last = ((void * ) 0 ) , * props , * pr , * v , * a [1 ] ; 
  Scheme_Object * __funcarg149 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(10);
  BLOCK_SETUP_TOP((PUSH(pr, 0), PUSH(first, 1), PUSH(orig, 2), PUSH(arg, 3), PUSHARRAY(a, 1, 4), PUSH(v, 7), PUSH(props, 8), PUSH(last, 9)));
# define XfOrM650_COUNT (10)
# define SETUP_XfOrM650(x) SETUP(XfOrM650_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  props = NULLED_OUT ; 
  pr = NULLED_OUT ; 
  v = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 

# 4698 "./../src/struct.c"
  if (p -> supers ) {
#   define XfOrM652_COUNT (0+XfOrM650_COUNT)
#   define SETUP_XfOrM652(x) SETUP_XfOrM650(x)

# 4699 "./../src/struct.c"
    props = p -> supers ; 
    for (; ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; props = (((Scheme_Simple_Object * ) (props ) ) -> u . pair_val . cdr ) ) {
#     define XfOrM654_COUNT (0+XfOrM652_COUNT)
#     define SETUP_XfOrM654(x) SETUP_XfOrM652(x)

# 4701 "./../src/struct.c"
      v = (((Scheme_Simple_Object * ) (props ) ) -> u . pair_val . car ) ; 

      a [0 ] = arg ; 
      v = (__funcarg149 = FUNCCALL(SETUP_XfOrM654(_), scheme_do_eval ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . cdr ) , 1 , a , 1 ) ), FUNCCALL_AGAIN(scheme_make_pair ((((Scheme_Simple_Object * ) (v ) ) -> u . pair_val . car ) , __funcarg149 ) )) ; 

      pr = FUNCCALL_AGAIN(scheme_make_pair (v , scheme_null ) ); 
      if (last )
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = pr ; 
      else 
      first = pr ; 
      last = pr ; 
    }
  }

  if (last ) {
    (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = orig ; 
    RET_VALUE_START (first ) RET_VALUE_END ; 
  }

# 4718 "./../src/struct.c"
  else 
  RET_VALUE_START (orig ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4722 "./../src/struct.c"
static Scheme_Object * add_struct_type_chaperone_guards (Scheme_Object * o , Scheme_Object * orig_guard ) 
{
  Scheme_Object * first = ((void * ) 0 ) , * last = ((void * ) 0 ) , * p ; 
  Scheme_Chaperone * px ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(first, 0), PUSH(orig_guard, 1), PUSH(px, 2), PUSH(o, 3), PUSH(p, 4), PUSH(last, 5)));
# define XfOrM655_COUNT (6)
# define SETUP_XfOrM655(x) SETUP(XfOrM655_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  p = NULLED_OUT ; 
  px = NULLED_OUT ; 

# 4730 "./../src/struct.c"
  while ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
#   define XfOrM658_COUNT (0+XfOrM655_COUNT)
#   define SETUP_XfOrM658(x) SETUP_XfOrM655(x)

# 4731 "./../src/struct.c"
    px = (Scheme_Chaperone * ) o ; 
    if ((Scheme_Type ) (((((intptr_t ) (px -> redirects ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (px -> redirects ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM659_COUNT (0+XfOrM658_COUNT)
#     define SETUP_XfOrM659(x) SETUP_XfOrM658(x)

# 4733 "./../src/struct.c"
      p = FUNCCALL(SETUP_XfOrM659(_), scheme_make_pair ((((Scheme_Simple_Object * ) ((((Scheme_Simple_Object * ) (px -> redirects ) ) -> u . pair_val . cdr ) ) ) -> u . pair_val . cdr ) , scheme_null ) ); 
      if (last )
        (((Scheme_Simple_Object * ) (last ) ) -> u . pair_val . cdr ) = p ; 
      else 
      first = p ; 
      last = p ; 
    }
    o = px -> prev ; 
  }

  if (! last )
    RET_VALUE_START (orig_guard ) RET_VALUE_END ; 

  if (! orig_guard )
    orig_guard = scheme_false ; 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_make_pair (orig_guard , first ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4752 "./../src/struct.c"
static void struct_type_set_if_immutable (Scheme_Struct_Type * struct_type ) {
  /* No conversion */

# 4753 "./../src/struct.c"
  if (! struct_type -> name_pos 
  || (& struct_type -> parent_types [struct_type -> name_pos - 1 ] -> iso ) -> so . keyex & 0x1 ) {
    int i , size ; 
    size = struct_type -> num_islots ; 
    if (struct_type -> name_pos )
      size -= struct_type -> parent_types [struct_type -> name_pos - 1 ] -> num_islots ; 
    if (! size || struct_type -> immutables ) {
      for (i = 0 ; i < size ; i ++ ) {
        if (! struct_type -> immutables [i ] )
          return ; 
      }
      (& struct_type -> iso ) -> so . keyex |= 0x1 ; 
    }
  }
}

Scheme_Struct_Type * scheme_make_prefab_struct_type_raw (Scheme_Object * base , 
Scheme_Object * parent , 
int num_fields , 
int num_uninit_fields , 
Scheme_Object * uninit_val , 
char * immutable_array ) 
{
  Scheme_Struct_Type * struct_type , * parent_type ; 
  int j , depth ; 
  DECL_RET_SAVE (Scheme_Struct_Type * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(base, 0), PUSH(struct_type, 1), PUSH(immutable_array, 2), PUSH(parent_type, 3), PUSH(uninit_val, 4)));
# define XfOrM665_COUNT (5)
# define SETUP_XfOrM665(x) SETUP(XfOrM665_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  struct_type = NULLED_OUT ; 
  parent_type = NULLED_OUT ; 

# 4779 "./../src/struct.c"
  parent_type = (Scheme_Struct_Type * ) parent ; 
  depth = parent_type ? (1 + parent_type -> name_pos ) : 0 ; 
  struct_type = (Scheme_Struct_Type * ) FUNCCALL(SETUP_XfOrM665(_), GC_malloc_one_tagged (sizeof (Scheme_Struct_Type ) + ((depth + 1 - 0 ) * sizeof (Scheme_Struct_Type * ) ) ) )

  ; 
  struct_type -> iso . so . type = scheme_struct_type_type ; 

  struct_type -> parent_types [depth ] = struct_type ; 
  for (j = depth ; j -- ; ) {
    struct_type -> parent_types [j ] = parent_type -> parent_types [j ] ; 
  }

  struct_type -> name = base ; 
  struct_type -> num_slots = num_fields + num_uninit_fields + (parent_type ? parent_type -> num_slots : 0 ) ; 
  struct_type -> num_islots = num_fields + (parent_type ? parent_type -> num_islots : 0 ) ; 
  struct_type -> name_pos = depth ; 
  struct_type -> more_flags = 0x1 ; 
  struct_type -> inspector = scheme_false ; 
  struct_type -> uninit_val = uninit_val ; 
  struct_type -> props = ((void * ) 0 ) ; 
  struct_type -> num_props = 0 ; 
  struct_type -> proc_attr = ((void * ) 0 ) ; 
  struct_type -> immutables = immutable_array ; 
  struct_type -> guard = ((void * ) 0 ) ; 
  FUNCCALL(SETUP_XfOrM665(_), struct_type_set_if_immutable (struct_type ) )
  ; 
  struct_type = FUNCCALL_AGAIN(hash_prefab (struct_type ) ); 

  RET_VALUE_START (struct_type ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4810 "./../src/struct.c"
static Scheme_Struct_Type * scheme_make_prefab_struct_type (Scheme_Object * name , 
Scheme_Object * parent , 
int num_fields , 
int num_uninit_fields , 
Scheme_Object * uninit_val , 
char * immutable_array ) 
{
  /* No conversion */

# 4817 "./../src/struct.c"
  return scheme_make_prefab_struct_type_raw (name , 
  parent , 
  num_fields , 
  num_uninit_fields , 
  uninit_val , 
  immutable_array ) ; 
}

static Scheme_Object * _make_struct_type (Scheme_Object * name , 
Scheme_Object * parent , 
Scheme_Object * inspector , 
int num_fields , 
int num_uninit_fields , 
Scheme_Object * uninit_val , 
Scheme_Object * props , 
Scheme_Object * proc_attr , 
char * immutable_array , 
Scheme_Object * guard ) 
{
  Scheme_Struct_Type * struct_type , * parent_type ; 
  int j , depth , checked_proc = 0 , chaperone_undefined = 0 ; 
  Scheme_Config * __funcarg152 = NULLED_OUT ; 
  Scheme_Object * __funcarg151 = NULLED_OUT ; 
  Scheme_Object * __funcarg150 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(19);
  BLOCK_SETUP_TOP((PUSH(immutable_array, 0), PUSH(inspector, 1), PUSH(guard, 2), PUSH(uninit_val, 3), PUSH(struct_type, 4), PUSH(parent_type, 5), PUSH(proc_attr, 6), PUSH(parent, 7), PUSH(props, 8), PUSH(name, 9)));
# define XfOrM669_COUNT (10)
# define SETUP_XfOrM669(x) SETUP(XfOrM669_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  struct_type = NULLED_OUT ; 
  parent_type = NULLED_OUT ; 

# 4839 "./../src/struct.c"
  if (parent && (((Scheme_Type ) (((((intptr_t ) (parent ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (parent ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) )
    parent_type = (Scheme_Struct_Type * ) (((Scheme_Chaperone * ) parent ) -> val ) ; 
  else 
  parent_type = (Scheme_Struct_Type * ) parent ; 

  depth = parent_type ? (1 + parent_type -> name_pos ) : 0 ; 

  struct_type = (Scheme_Struct_Type * ) FUNCCALL(SETUP_XfOrM669(_), GC_malloc_one_tagged (sizeof (Scheme_Struct_Type ) + ((depth + 1 - 0 ) * sizeof (Scheme_Struct_Type * ) ) ) )

  ; 


  depth = parent_type ? (1 + parent_type -> name_pos ) : 0 ; 

  struct_type -> iso . so . type = scheme_struct_type_type ; 

  struct_type -> name_pos = depth ; 
  struct_type -> parent_types [depth ] = struct_type ; 
  for (j = depth ; j -- ; ) {
    struct_type -> parent_types [j ] = parent_type -> parent_types [j ] ; 
  }

  struct_type -> name = name ; 
  struct_type -> more_flags = ((parent_type 
  ? (parent_type -> more_flags & 0x1 ) 
  : 0x1 ) 
  | ((XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) && inspector ) 
  ? 0x2 
  : 0 ) ) ; 

  struct_type -> num_slots = num_fields + num_uninit_fields + (parent_type ? parent_type -> num_slots : 0 ) ; 
  struct_type -> num_islots = num_fields + (parent_type ? parent_type -> num_islots : 0 ) ; 
  if (parent_type )
    struct_type -> proc_attr = parent_type -> proc_attr ; 


  if ((num_fields < 0 ) || (num_uninit_fields < 0 ) 
  || (num_fields > 32768 ) 
  || (num_uninit_fields > 32768 ) 
  || (num_uninit_fields + num_fields > 32768 ) 
  || (parent_type 
  && ((struct_type -> num_slots < parent_type -> num_slots ) 
  || (struct_type -> num_islots < parent_type -> num_islots ) ) ) ) {
#   define XfOrM725_COUNT (0+XfOrM669_COUNT)
#   define SETUP_XfOrM725(x) SETUP_XfOrM669(x)
    FUNCCALL(SETUP_XfOrM725(_), scheme_raise_exn (MZEXN_FAIL , "too many fields for struct-type\n" "  maximum total field count: " "32768" ) ); 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (! inspector ) {
#   define XfOrM722_COUNT (0+XfOrM669_COUNT)
#   define SETUP_XfOrM722(x) SETUP_XfOrM669(x)

# 4889 "./../src/struct.c"
    if (parent_type ) {
      inspector = parent_type -> inspector ; 
      if ((Scheme_Type ) (((((intptr_t ) (inspector ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (inspector ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
        inspector = scheme_false ; 
    }

# 4893 "./../src/struct.c"
    else {
#     define XfOrM723_COUNT (0+XfOrM722_COUNT)
#     define SETUP_XfOrM723(x) SETUP_XfOrM722(x)

# 4894 "./../src/struct.c"
      inspector = (__funcarg152 = FUNCCALL(SETUP_XfOrM723(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg152 , MZCONFIG_INSPECTOR ) )) ; 
    }
  }
  struct_type -> inspector = inspector ; 

  if (parent_type ) {
    struct_type -> num_props = parent_type -> num_props ; 
    struct_type -> props = parent_type -> props ; 
    if ((& parent_type -> iso ) -> so . keyex & 0x2 )
      checked_proc = 1 ; 
  }




  if (! uninit_val )
    uninit_val = scheme_false ; 
  struct_type -> uninit_val = uninit_val ; 

  if ((struct_type -> proc_attr && (((intptr_t ) (struct_type -> proc_attr ) ) & 0x1 ) ) 
  || (proc_attr && (((intptr_t ) (proc_attr ) ) & 0x1 ) ) ) {
    int n , ni , p ; 
#   define XfOrM716_COUNT (0+XfOrM669_COUNT)
#   define SETUP_XfOrM716(x) SETUP_XfOrM669(x)

# 4917 "./../src/struct.c"
    n = struct_type -> num_slots ; 
    ni = struct_type -> num_islots ; 
    if (parent_type ) {
      n -= parent_type -> num_slots ; 
      ni -= parent_type -> num_islots ; 
    }

    if (proc_attr && (((intptr_t ) (proc_attr ) ) & 0x1 ) ) {
#     define XfOrM717_COUNT (0+XfOrM716_COUNT)
#     define SETUP_XfOrM717(x) SETUP_XfOrM716(x)

# 4925 "./../src/struct.c"
      p = (((intptr_t ) (proc_attr ) ) >> 1 ) ; 
      if (p < ni ) {
#       define XfOrM718_COUNT (0+XfOrM717_COUNT)
#       define SETUP_XfOrM718(x) SETUP_XfOrM717(x)

# 4927 "./../src/struct.c"
        if (! immutable_array ) {
#         define XfOrM719_COUNT (0+XfOrM718_COUNT)
#         define SETUP_XfOrM719(x) SETUP_XfOrM718(x)

# 4928 "./../src/struct.c"
          immutable_array = (char * ) FUNCCALL(SETUP_XfOrM719(_), GC_malloc_atomic (n ) ); 
          (memset (immutable_array , 0 , n ) ) ; 
        }
        immutable_array [p ] = 1 ; 
      }
    }
  }
  struct_type -> immutables = immutable_array ; 




  if (proc_attr )
    props = (__funcarg150 = (__funcarg151 = FUNCCALL(SETUP_XfOrM669(_), scheme_make_pair (proc_property , proc_attr ) )
  , FUNCCALL_AGAIN(scheme_make_pair (__funcarg151 , scheme_null ) )) , FUNCCALL_AGAIN(scheme_append (props ? props : scheme_null , __funcarg150 ) )) 
  ; 

  if (props ) {
    int num_props , i ; 
    Scheme_Object * proc_prop_set = ((void * ) 0 ) ; 
    Scheme_Hash_Table * can_override ; 
    Scheme_Object * l , * a , * prop , * propv , * oldv ; 
    BLOCK_SETUP((PUSH(can_override, 0+XfOrM669_COUNT), PUSH(propv, 1+XfOrM669_COUNT), PUSH(l, 2+XfOrM669_COUNT), PUSH(proc_prop_set, 3+XfOrM669_COUNT), PUSH(prop, 4+XfOrM669_COUNT), PUSH(a, 5+XfOrM669_COUNT), PUSH(oldv, 6+XfOrM669_COUNT)));
#   define XfOrM675_COUNT (7+XfOrM669_COUNT)
#   define SETUP_XfOrM675(x) SETUP(XfOrM675_COUNT)
    can_override = NULLED_OUT ; 
    l = NULLED_OUT ; 
    a = NULLED_OUT ; 
    prop = NULLED_OUT ; 
    propv = NULLED_OUT ; 
    oldv = NULLED_OUT ; 

# 4951 "./../src/struct.c"
    can_override = FUNCCALL(SETUP_XfOrM675(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

    num_props = FUNCCALL_AGAIN(count_non_proc_props (props ) ); 
    if ((struct_type -> num_props < 0 ) || (struct_type -> num_props + num_props > 5 ) ) {
      Scheme_Hash_Table * ht ; 
      BLOCK_SETUP((PUSH(ht, 0+XfOrM675_COUNT)));
#     define XfOrM697_COUNT (1+XfOrM675_COUNT)
#     define SETUP_XfOrM697(x) SETUP(XfOrM697_COUNT)
      ht = NULLED_OUT ; 

# 4957 "./../src/struct.c"
      ht = FUNCCALL(SETUP_XfOrM697(_), scheme_make_hash_table (SCHEME_hash_ptr ) ); 

      if (struct_type -> num_props >= 0 ) {
#       define XfOrM713_COUNT (0+XfOrM697_COUNT)
#       define SETUP_XfOrM713(x) SETUP_XfOrM697(x)

# 4960 "./../src/struct.c"
        for (i = 0 ; i < struct_type -> num_props ; i ++ ) {
#         define XfOrM715_COUNT (0+XfOrM713_COUNT)
#         define SETUP_XfOrM715(x) SETUP_XfOrM713(x)

# 4961 "./../src/struct.c"
          prop = (((Scheme_Simple_Object * ) (struct_type -> props [i ] ) ) -> u . pair_val . car ) ; 
          FUNCCALL(SETUP_XfOrM715(_), scheme_hash_set (ht , prop , (((Scheme_Simple_Object * ) (struct_type -> props [i ] ) ) -> u . pair_val . cdr ) ) ); 
          FUNCCALL_AGAIN(scheme_hash_set (can_override , prop , scheme_true ) ); 
        }
      }

# 4965 "./../src/struct.c"
      else {

        Scheme_Hash_Table * oht = (Scheme_Hash_Table * ) struct_type -> props ; 
        BLOCK_SETUP((PUSH(oht, 0+XfOrM697_COUNT)));
#       define XfOrM708_COUNT (1+XfOrM697_COUNT)
#       define SETUP_XfOrM708(x) SETUP(XfOrM708_COUNT)

# 4968 "./../src/struct.c"
        for (i = oht -> size ; i -- ; ) {
#         define XfOrM711_COUNT (0+XfOrM708_COUNT)
#         define SETUP_XfOrM711(x) SETUP_XfOrM708(x)

# 4969 "./../src/struct.c"
          if (oht -> vals [i ] ) {
#           define XfOrM712_COUNT (0+XfOrM711_COUNT)
#           define SETUP_XfOrM712(x) SETUP_XfOrM711(x)

# 4970 "./../src/struct.c"
            prop = oht -> keys [i ] ; 
            FUNCCALL(SETUP_XfOrM712(_), scheme_hash_set (ht , prop , oht -> vals [i ] ) ); 
            FUNCCALL_AGAIN(scheme_hash_set (can_override , prop , scheme_true ) ); 
          }
        }
      }


      for (l = props ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; ) {
        int skip_supers = 0 ; 
#       define XfOrM703_COUNT (0+XfOrM697_COUNT)
#       define SETUP_XfOrM703(x) SETUP_XfOrM697(x)

# 4981 "./../src/struct.c"
        a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        prop = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ; 

        if ((prop ) == (scheme_checked_proc_property ) ) 
          checked_proc = 1 ; 
        if ((prop ) == (scheme_chaperone_undefined_property ) ) 
          chaperone_undefined = 1 ; 
        if ((prop ) == (scheme_authentic_property ) ) 
          struct_type -> more_flags |= 0x4 ; 
        if ((prop ) == (scheme_sealed_property ) ) 
          struct_type -> more_flags |= 0x8 ; 

        propv = FUNCCALL(SETUP_XfOrM703(_), guard_property (prop , (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) , struct_type ) ); 

        if ((prop ) == (proc_property ) )  {
          if (proc_prop_set && ! ((proc_prop_set ) == (propv ) ) )
            break ; 
        }

# 4998 "./../src/struct.c"
        else {
#         define XfOrM704_COUNT (0+XfOrM703_COUNT)
#         define SETUP_XfOrM704(x) SETUP_XfOrM703(x)

# 4999 "./../src/struct.c"
          oldv = FUNCCALL(SETUP_XfOrM704(_), scheme_hash_get (ht , prop ) ); 
          if (oldv ) {
#           define XfOrM705_COUNT (0+XfOrM704_COUNT)
#           define SETUP_XfOrM705(x) SETUP_XfOrM704(x)

# 5002 "./../src/struct.c"
            if (! FUNCCALL(SETUP_XfOrM705(_), scheme_hash_get (can_override , prop ) )) {
              if (! ((oldv ) == (propv ) ) )
                break ; 
              skip_supers = 1 ; 
            }
            FUNCCALL(SETUP_XfOrM705(_), scheme_hash_set (can_override , prop , ((void * ) 0 ) ) )
            ; 
          }
        }

        l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        if (! skip_supers )
          l = FUNCCALL(SETUP_XfOrM703(_), append_super_props ((Scheme_Struct_Property * ) prop , propv , l ) ); 

        if ((prop ) == (proc_property ) ) 
          proc_prop_set = propv ; 
        else FUNCCALL(SETUP_XfOrM703(_), scheme_hash_set (ht , prop , propv ) )
        ; 
      }

      struct_type -> props = (Scheme_Object * * ) ht ; 
      struct_type -> num_props = - 1 ; 
    }

# 5024 "./../src/struct.c"
    else {

      Scheme_Object * * pa ; 
      int j ; 
      BLOCK_SETUP((PUSH(pa, 0+XfOrM675_COUNT)));
#     define XfOrM677_COUNT (1+XfOrM675_COUNT)
#     define SETUP_XfOrM677(x) SETUP(XfOrM677_COUNT)
      pa = NULLED_OUT ; 

# 5030 "./../src/struct.c"
      for (i = 0 ; i < struct_type -> num_props ; i ++ ) {
#       define XfOrM696_COUNT (0+XfOrM677_COUNT)
#       define SETUP_XfOrM696(x) SETUP_XfOrM677(x)

# 5031 "./../src/struct.c"
        prop = (((Scheme_Simple_Object * ) (struct_type -> props [i ] ) ) -> u . pair_val . car ) ; 
        FUNCCALL(SETUP_XfOrM696(_), scheme_hash_set (can_override , prop , scheme_true ) ); 
      }

      pa = ((Scheme_Object * * ) FUNCCALL(SETUP_XfOrM677(_), GC_malloc (sizeof (Scheme_Object * ) * (i + num_props ) ) )) ; 
      if (i )
        (memcpy (pa , struct_type -> props , sizeof (Scheme_Object * ) * i ) ) ; 

      num_props = i ; 

      for (l = props ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; ) {
        int skip_supers = 0 ; 
#       define XfOrM687_COUNT (0+XfOrM677_COUNT)
#       define SETUP_XfOrM687(x) SETUP_XfOrM677(x)

# 5044 "./../src/struct.c"
        a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 

        prop = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ; 

        if ((prop ) == (scheme_checked_proc_property ) ) 
          checked_proc = 1 ; 
        if ((prop ) == (scheme_chaperone_undefined_property ) ) 
          chaperone_undefined = 1 ; 
        if ((prop ) == (scheme_authentic_property ) ) 
          struct_type -> more_flags |= 0x4 ; 
        if ((prop ) == (scheme_sealed_property ) ) 
          struct_type -> more_flags |= 0x8 ; 

        propv = FUNCCALL(SETUP_XfOrM687(_), guard_property (prop , (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) , struct_type ) ); 


        if ((prop ) == (proc_property ) )  {
          if (proc_prop_set && ! ((proc_prop_set ) == (propv ) ) )
            break ; 
          j = 0 ; 
        }

# 5064 "./../src/struct.c"
        else {
#         define XfOrM689_COUNT (0+XfOrM687_COUNT)
#         define SETUP_XfOrM689(x) SETUP_XfOrM687(x)

# 5065 "./../src/struct.c"
          for (j = 0 ; j < num_props ; j ++ ) {
            if (((((Scheme_Simple_Object * ) (pa [j ] ) ) -> u . pair_val . car ) ) == (prop ) ) 
              break ; 
          }
          if (j < num_props ) {
#           define XfOrM690_COUNT (0+XfOrM689_COUNT)
#           define SETUP_XfOrM690(x) SETUP_XfOrM689(x)

# 5071 "./../src/struct.c"
            if (! FUNCCALL(SETUP_XfOrM690(_), scheme_hash_get (can_override , prop ) )) {
              if (! ((propv ) == ((((Scheme_Simple_Object * ) (pa [j ] ) ) -> u . pair_val . cdr ) ) ) )
                break ; 
              skip_supers = 1 ; 
            }
            FUNCCALL(SETUP_XfOrM690(_), scheme_hash_set (can_override , prop , ((void * ) 0 ) ) )
            ; 
          }

# 5078 "./../src/struct.c"
          else 
          num_props ++ ; 
        }

        l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ; 
        if (! skip_supers )
          l = FUNCCALL(SETUP_XfOrM687(_), append_super_props ((Scheme_Struct_Property * ) prop , propv , l ) ); 

        if ((prop ) == (proc_property ) ) 
          proc_prop_set = propv ; 
        else {
#         define XfOrM688_COUNT (0+XfOrM687_COUNT)
#         define SETUP_XfOrM688(x) SETUP_XfOrM687(x)

# 5089 "./../src/struct.c"
          a = FUNCCALL(SETUP_XfOrM688(_), scheme_make_pair (prop , propv ) ); 
          pa [j ] = a ; 
        }
      }

      if (num_props ) {
        struct_type -> num_props = num_props ; 
        struct_type -> props = pa ; 
      }
    }

    if (! ((l ) == (scheme_null ) ) ) {
#     define XfOrM676_COUNT (0+XfOrM675_COUNT)
#     define SETUP_XfOrM676(x) SETUP_XfOrM675(x)

# 5102 "./../src/struct.c"
      a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
      FUNCCALL(SETUP_XfOrM676(_), scheme_contract_error ("make-struct-type" , "duplicate property binding" , "property" , 1 , a , ((void * ) 0 ) ) )

      ; 
    }
  }

  if (parent_type && ((parent_type -> more_flags & 0x4 ) 
  != (struct_type -> more_flags & 0x4 ) ) ) {
#   define XfOrM674_COUNT (0+XfOrM669_COUNT)
#   define SETUP_XfOrM674(x) SETUP_XfOrM669(x)

# 5111 "./../src/struct.c"
    if (parent_type -> more_flags & 0x4 )
      FUNCCALL(SETUP_XfOrM674(_), scheme_contract_error ("make-struct-type" , "cannot make a non-authentic subtype of an authentic type" , "type name" , 1 , struct_type -> name , "authentic type" , 1 , parent , ((void * ) 0 ) ) )



    ; 
    else FUNCCALL(SETUP_XfOrM674(_), scheme_contract_error ("make-struct-type" , "cannot make an authentic subtype of a non-authentic type" , "type name" , 1 , struct_type -> name , "non-authentic type" , 1 , parent , ((void * ) 0 ) ) )




    ; 
  }

  if (guard ) {
#   define XfOrM672_COUNT (0+XfOrM669_COUNT)
#   define SETUP_XfOrM672(x) SETUP_XfOrM669(x)

# 5126 "./../src/struct.c"
    if (! FUNCCALL(SETUP_XfOrM672(_), scheme_check_proc_arity (((void * ) 0 ) , struct_type -> num_islots + 1 , - 1 , 0 , & guard ) )) {
#     define XfOrM673_COUNT (0+XfOrM672_COUNT)
#     define SETUP_XfOrM673(x) SETUP_XfOrM672(x)
      FUNCCALL(SETUP_XfOrM673(_), scheme_contract_error ("make-struct-type" , "guard procedure does not accept correct number of arguments;\n" " should accept one more than the number of constructor arguments" , "guard procedure" , 1 , guard , "expected arity" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (struct_type -> num_islots + 1 ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )


      ; 
    }

    struct_type -> guard = guard ; 
    struct_type -> more_flags = 0 ; 
  }

# 5137 "./../src/struct.c"
  else if (chaperone_undefined ) {
    struct_type -> guard = scheme_undefined ; 
  }

  if (parent && (((Scheme_Type ) (((((intptr_t ) (parent ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (parent ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) ) {
#   define XfOrM670_COUNT (0+XfOrM669_COUNT)
#   define SETUP_XfOrM670(x) SETUP_XfOrM669(x)

# 5142 "./../src/struct.c"
    guard = FUNCCALL(SETUP_XfOrM670(_), add_struct_type_chaperone_guards (parent , struct_type -> guard ) ); 
    struct_type -> guard = guard ; 
    struct_type -> more_flags = 0 ; 
  }

  if (checked_proc )
    (& struct_type -> iso ) -> so . keyex |= 0x2 ; 
  FUNCCALL(SETUP_XfOrM669(_), struct_type_set_if_immutable (struct_type ) )

  ; 

  RET_VALUE_START ((Scheme_Object * ) struct_type ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5156 "./../src/struct.c"
Scheme_Object * scheme_make_struct_type (Scheme_Object * name , 
Scheme_Object * parent , 
Scheme_Object * inspector , 
int num_fields , int num_uninit , 
Scheme_Object * uninit_val , 
Scheme_Object * properties , 
Scheme_Object * guard ) 
{
  /* No conversion */

# 5164 "./../src/struct.c"
  return _make_struct_type (name , 
  parent , inspector , 
  num_fields , num_uninit , 
  uninit_val , properties , 
  ((void * ) 0 ) , ((void * ) 0 ) , 
  guard ) ; 
}

Scheme_Object * scheme_make_struct_type2 (Scheme_Object * name , 
Scheme_Object * parent , 
Scheme_Object * inspector , 
int num_fields , int num_uninit , 
Scheme_Object * uninit_val , 
Scheme_Object * properties , 
Scheme_Object * proc_attr , 
char * immutable_array , 
Scheme_Object * guard ) 
{
  /* No conversion */

# 5182 "./../src/struct.c"
  return _make_struct_type (name , 
  parent , inspector , 
  num_fields , num_uninit , 
  uninit_val , properties , 
  proc_attr , immutable_array , 
  guard ) ; 
}

Scheme_Object * scheme_make_struct_type_from_string (const char * name , 
Scheme_Object * parent , 
int num_fields , 
Scheme_Object * props , 
Scheme_Object * guard , 
int immutable ) 
{
  Scheme_Object * namesym , * r ; 
  char * immutable_array = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(7);
  BLOCK_SETUP_TOP((PUSH(r, 0), PUSH(immutable_array, 1), PUSH(guard, 2), PUSH(parent, 3), PUSH(props, 4), PUSH(name, 5), PUSH(namesym, 6)));
# define XfOrM730_COUNT (7)
# define SETUP_XfOrM730(x) SETUP(XfOrM730_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  namesym = NULLED_OUT ; 
  r = NULLED_OUT ; 

# 5200 "./../src/struct.c"
  if (immutable ) {
#   define XfOrM731_COUNT (0+XfOrM730_COUNT)
#   define SETUP_XfOrM731(x) SETUP_XfOrM730(x)

# 5201 "./../src/struct.c"
    immutable_array = (char * ) FUNCCALL(SETUP_XfOrM731(_), GC_malloc_atomic (num_fields ) ); 
    (memset (immutable_array , 1 , num_fields ) ) ; 
  }

  namesym = FUNCCALL(SETUP_XfOrM730(_), scheme_intern_exact_symbol (name , strlen (name ) ) ); 

  r = FUNCCALL(SETUP_XfOrM730(_), _make_struct_type (namesym , parent , scheme_false , num_fields , 0 , ((void * ) 0 ) , props , ((void * ) 0 ) , immutable_array , guard ) )




  ; 

  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> scheme_starting_up_ ) )
    FUNCCALL(SETUP_XfOrM730(_), scheme_force_struct_type_info ((Scheme_Struct_Type * ) r ) )
  ; 

  RET_VALUE_START (r ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5221 "./../src/struct.c"
static Scheme_Struct_Type * lookup_prefab (Scheme_Object * key ) {
  Scheme_Object * a = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Struct_Type * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(a, 0)));
# define XfOrM732_COUNT (1)
# define SETUP_XfOrM732(x) SETUP(XfOrM732_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5224 "./../src/struct.c"
  if (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) ) {
#   define XfOrM733_COUNT (0+XfOrM732_COUNT)
#   define SETUP_XfOrM733(x) SETUP_XfOrM732(x)

# 5225 "./../src/struct.c"
    a = FUNCCALL(SETUP_XfOrM733(_), scheme_lookup_in_table (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) , (const char * ) key ) ); 
  }

  if (a )
    RET_VALUE_START ((Scheme_Struct_Type * ) (((Scheme_Small_Object * ) (a ) ) -> u . ptr_val ) ) RET_VALUE_END ; 

  RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5234 "./../src/struct.c"
static Scheme_Struct_Type * hash_prefab (Scheme_Struct_Type * type ) 
{
  Scheme_Object * k , * v ; 
  DECL_RET_SAVE (Scheme_Struct_Type * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(type, 0), PUSH(k, 1), PUSH(v, 2)));
# define XfOrM734_COUNT (3)
# define SETUP_XfOrM734(x) SETUP(XfOrM734_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  k = NULLED_OUT ; 
  v = NULLED_OUT ; 

# 5238 "./../src/struct.c"
  if (! XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) ) {
#   define XfOrM737_COUNT (0+XfOrM734_COUNT)
#   define SETUP_XfOrM737(x) SETUP_XfOrM734(x)
    FUNCCALL(SETUP_XfOrM737(_), scheme_register_static ((void * ) & XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) , sizeof (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) ) ) )
# 5239 "./../src/struct.c"
    ; 
    XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) = FUNCCALL(SETUP_XfOrM737(_), scheme_make_weak_equal_table () ); 
  }

  k = FUNCCALL(SETUP_XfOrM734(_), make_prefab_key (type ) ); 
  type -> prefab_key = k ; 

  v = FUNCCALL(SETUP_XfOrM734(_), scheme_lookup_in_table (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) , (const char * ) k ) ); 

  if (v )
    v = (((Scheme_Small_Object * ) (v ) ) -> u . ptr_val ) ; 

  if (v ) {
    type = (Scheme_Struct_Type * ) v ; 
  }

# 5253 "./../src/struct.c"
  else {
#   define XfOrM735_COUNT (0+XfOrM734_COUNT)
#   define SETUP_XfOrM735(x) SETUP_XfOrM734(x)

# 5254 "./../src/struct.c"
    v = FUNCCALL(SETUP_XfOrM735(_), scheme_make_weak_box ((Scheme_Object * ) type ) ); 
    FUNCCALL(SETUP_XfOrM735(_), scheme_add_to_table (XFORM_OK_ASSIGN ((& scheme_thread_locals ) -> prefab_table_ ) , (const char * ) k , v , 0 ) ); 
  }

  RET_VALUE_START (type ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5261 "./../src/struct.c"
static char * immutable_pos_list_to_immutable_array (Scheme_Object * immutable_pos_list , int localfieldc ) {
  char * ia ; 
  Scheme_Object * l ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSH(immutable_pos_list, 0), PUSH(ia, 1), PUSH(l, 2)));
# define XfOrM738_COUNT (3)
# define SETUP_XfOrM738(x) SETUP(XfOrM738_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  ia = NULLED_OUT ; 
  l = NULLED_OUT ; 

# 5264 "./../src/struct.c"
  ia = (char * ) FUNCCALL(SETUP_XfOrM738(_), GC_malloc_atomic (localfieldc ) ); 
  (memset (ia , 0 , localfieldc ) ) ; 

  for (l = immutable_pos_list ; l && ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
    int a_val ; 
    Scheme_Object * a ; 
#   define XfOrM743_COUNT (0+XfOrM738_COUNT)
#   define SETUP_XfOrM743(x) SETUP_XfOrM738(x)
    a = NULLED_OUT ; 

# 5270 "./../src/struct.c"
    a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
    if (! (((intptr_t ) (a ) ) & 0x1 ) )
      a_val = - 1 ; 
    else 
    a_val = (((intptr_t ) (a ) ) >> 1 ) ; 
    if (a_val < 0 ) {
#     define XfOrM746_COUNT (0+XfOrM743_COUNT)
#     define SETUP_XfOrM746(x) SETUP_XfOrM743(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "contract violation for index of immutable field" , "expected:" , 0 , "(and/c exact-nonnegative-integer? fixnum?)" , "given" , 1 , a , "in list" , 1 , immutable_pos_list , ((void * ) 0 ) ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    if (a_val >= localfieldc ) {
#     define XfOrM745_COUNT (0+XfOrM743_COUNT)
#     define SETUP_XfOrM745(x) SETUP_XfOrM743(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "index for immutable field >= initialized-field count" , "index" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (a_val ) ) ) << 1 ) | 0x1 ) ) , "initialized-field count" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (localfieldc ) ) ) << 1 ) | 0x1 ) ) , "in list" , 1 , immutable_pos_list , ((void * ) 0 ) ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    if (ia [a_val ] ) {
#     define XfOrM744_COUNT (0+XfOrM743_COUNT)
#     define SETUP_XfOrM744(x) SETUP_XfOrM743(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "redundant immutable field index" , "index" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (a_val ) ) ) << 1 ) | 0x1 ) ) , "in list" , 1 , immutable_pos_list , ((void * ) 0 ) ) )

      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    ia [a_val ] = 1 ; 
  }

  RET_VALUE_START (ia ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5308 "./../src/struct.c"
static Scheme_Object * make_struct_type (int argc , Scheme_Object * * argv ) 
{
  int initc , uninitc , num_props = 0 , prefab = 0 ; 
  Scheme_Object * props = scheme_null , * l , * a , * * r , * cstr_name = ((void * ) 0 ) ; 
  Scheme_Object * inspector = ((void * ) 0 ) , * uninit_val ; 
  Scheme_Struct_Type * type ; 
  Scheme_Object * proc_attr = ((void * ) 0 ) , * immutable_pos_list = scheme_null , * guard = ((void * ) 0 ) ; 
  char * immutable_array ; 
  Scheme_Config * __funcarg153 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(13);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(type, 1), PUSH(immutable_array, 2), PUSH(immutable_pos_list, 3), PUSH(inspector, 4), PUSH(cstr_name, 5), PUSH(uninit_val, 6), PUSH(guard, 7), PUSH(a, 8), PUSH(proc_attr, 9), PUSH(r, 10), PUSH(props, 11)));
# define XfOrM747_COUNT (12)
# define SETUP_XfOrM747(x) SETUP(XfOrM747_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  l = NULLED_OUT ; 
  a = NULLED_OUT ; 
  r = NULLED_OUT ; 
  uninit_val = NULLED_OUT ; 
  type = NULLED_OUT ; 
  immutable_array = NULLED_OUT ; 

# 5317 "./../src/struct.c"
  if (! ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "symbol?" , 0 , argc , argv ) ); 
  if (! (((argv [1 ] ) ) == (scheme_false ) ) 
  && ! (((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) || ((((Scheme_Type ) (((((intptr_t ) (argv [1 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [1 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [1 ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(or/c struct-type? #f)" , 1 , argc , argv ) ); 

  if (! (((intptr_t ) (argv [2 ] ) ) & 0x1 ) || ((((intptr_t ) (argv [2 ] ) ) >> 1 ) < 0 ) ) {
#   define XfOrM778_COUNT (0+XfOrM747_COUNT)
#   define SETUP_XfOrM778(x) SETUP_XfOrM747(x)

# 5324 "./../src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (argv [2 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [2 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) argv [2 ] ) -> iso ) -> so . keyex & 0x1 ) )
      initc = - 1 ; 
    else {
#     define XfOrM779_COUNT (0+XfOrM778_COUNT)
#     define SETUP_XfOrM779(x) SETUP_XfOrM778(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "exact-nonnegative-integer?" , 2 , argc , argv ) )
# 5327 "./../src/struct.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 5330 "./../src/struct.c"
  else 
  initc = (((intptr_t ) (argv [2 ] ) ) >> 1 ) ; 

  if (! (((intptr_t ) (argv [3 ] ) ) & 0x1 ) || ((((intptr_t ) (argv [3 ] ) ) >> 1 ) < 0 ) ) {
#   define XfOrM776_COUNT (0+XfOrM747_COUNT)
#   define SETUP_XfOrM776(x) SETUP_XfOrM747(x)

# 5334 "./../src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (argv [3 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [3 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) argv [3 ] ) -> iso ) -> so . keyex & 0x1 ) )
      uninitc = - 1 ; 
    else {
#     define XfOrM777_COUNT (0+XfOrM776_COUNT)
#     define SETUP_XfOrM777(x) SETUP_XfOrM776(x)
      FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "exact-nonnegative-integer?" , 3 , argc , argv ) )
# 5337 "./../src/struct.c"
      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

# 5340 "./../src/struct.c"
  else 
  uninitc = (((intptr_t ) (argv [3 ] ) ) >> 1 ) ; 

  if (argc > 4 ) {
#   define XfOrM759_COUNT (0+XfOrM747_COUNT)
#   define SETUP_XfOrM759(x) SETUP_XfOrM747(x)

# 5344 "./../src/struct.c"
    uninit_val = argv [4 ] ; 

    if (argc > 5 ) {
#     define XfOrM760_COUNT (0+XfOrM759_COUNT)
#     define SETUP_XfOrM760(x) SETUP_XfOrM759(x)

# 5347 "./../src/struct.c"
      props = argv [5 ] ; 
      for (l = props ; ((Scheme_Type ) (((((intptr_t ) (l ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (l ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ; l = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . cdr ) ) {
        a = (((Scheme_Simple_Object * ) (l ) ) -> u . pair_val . car ) ; 
        if (! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
        || ! ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_property_type ) ) )
          break ; 
        num_props ++ ; 
      }
      if (! ((l ) == (scheme_null ) ) ) {
#       define XfOrM773_COUNT (0+XfOrM760_COUNT)
#       define SETUP_XfOrM773(x) SETUP_XfOrM760(x)
        FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(listof (cons/c struct-type-property? any/c))" , 5 , argc , argv ) )
# 5356 "./../src/struct.c"
        ; 
      }

      if (argc > 6 ) {
#       define XfOrM761_COUNT (0+XfOrM760_COUNT)
#       define SETUP_XfOrM761(x) SETUP_XfOrM760(x)

# 5360 "./../src/struct.c"
        inspector = argv [6 ] ; 
        if ((inspector ) == (prefab_symbol ) )  {
          prefab = 1 ; 
          inspector = scheme_false ; 
        }

# 5364 "./../src/struct.c"
        else if (! (((inspector ) ) == (scheme_false ) ) ) {
#         define XfOrM771_COUNT (0+XfOrM761_COUNT)
#         define SETUP_XfOrM771(x) SETUP_XfOrM761(x)

# 5365 "./../src/struct.c"
          if (! ((Scheme_Type ) (((((intptr_t ) (argv [6 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [6 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_inspector_type ) ) )
            FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(or/c inspector? #f 'prefab)" , 6 , argc , argv ) ); 
        }

        if (argc > 7 ) {
#         define XfOrM762_COUNT (0+XfOrM761_COUNT)
#         define SETUP_XfOrM762(x) SETUP_XfOrM761(x)

# 5370 "./../src/struct.c"
          if (! (((argv [7 ] ) ) == (scheme_false ) ) ) {
#           define XfOrM769_COUNT (0+XfOrM762_COUNT)
#           define SETUP_XfOrM769(x) SETUP_XfOrM762(x)

# 5371 "./../src/struct.c"
            proc_attr = argv [7 ] ; 

            if (! (((((intptr_t ) (proc_attr ) ) & 0x1 ) && ((((intptr_t ) (proc_attr ) ) >> 1 ) >= 0 ) ) 
            || (((Scheme_Type ) (((((intptr_t ) (proc_attr ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc_attr ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) && ((& ((Scheme_Bignum * ) proc_attr ) -> iso ) -> so . keyex & 0x1 ) ) 
            || (! (((intptr_t ) (proc_attr ) ) & 0x1 ) && ((((proc_attr ) -> type ) >= scheme_prim_type ) && (((proc_attr ) -> type ) <= scheme_proc_chaperone_type ) ) ) ) ) {
#             define XfOrM770_COUNT (0+XfOrM769_COUNT)
#             define SETUP_XfOrM770(x) SETUP_XfOrM769(x)
              FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(or/c exact-nonnegative-integer? procedure? #f)" , 7 , argc , argv ) ); 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }
          }

          if (argc > 8 ) {
#           define XfOrM763_COUNT (0+XfOrM762_COUNT)
#           define SETUP_XfOrM763(x) SETUP_XfOrM762(x)

# 5384 "./../src/struct.c"
            l = immutable_pos_list = argv [8 ] ; 

            if ((scheme_proper_list_length (l ) ) < 0 ) {
#             define XfOrM768_COUNT (0+XfOrM763_COUNT)
#             define SETUP_XfOrM768(x) SETUP_XfOrM763(x)
              FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(listof exact-nonnegative-integer?)" , 8 , argc , argv ) ); 
              RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
            }

            if (argc > 9 ) {
#             define XfOrM764_COUNT (0+XfOrM763_COUNT)
#             define SETUP_XfOrM764(x) SETUP_XfOrM763(x)

# 5394 "./../src/struct.c"
              if (! (((argv [9 ] ) ) == (scheme_false ) ) )  {
#               define XfOrM767_COUNT (0+XfOrM764_COUNT)
#               define SETUP_XfOrM767(x) SETUP_XfOrM764(x)

# 5395 "./../src/struct.c"
                guard = argv [9 ] ; 
                if (! (! (((intptr_t ) (guard ) ) & 0x1 ) && ((((guard ) -> type ) >= scheme_prim_type ) && (((guard ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
                  FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(or/c procedure? #f)" , 9 , argc , argv ) ); 
              }

              if (argc > 10 ) {
#               define XfOrM765_COUNT (0+XfOrM764_COUNT)
#               define SETUP_XfOrM765(x) SETUP_XfOrM764(x)

# 5401 "./../src/struct.c"
                if (! (((argv [10 ] ) ) == (scheme_false ) ) ) {
#                 define XfOrM766_COUNT (0+XfOrM765_COUNT)
#                 define SETUP_XfOrM766(x) SETUP_XfOrM765(x)

# 5402 "./../src/struct.c"
                  if (! ((Scheme_Type ) (((((intptr_t ) (argv [10 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [10 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
                    FUNCCALL_EMPTY(scheme_wrong_contract ("make-struct-type" , "(or/c symbol? #f)" , 10 , argc , argv ) ); 
                  cstr_name = argv [10 ] ; 
                }
              }
            }
          }
        }
      }
    }
  }

# 5412 "./../src/struct.c"
  else 
  uninit_val = scheme_false ; 

  if (! uninitc )
    uninit_val = scheme_false ; 

  if (! inspector )
    inspector = (__funcarg153 = FUNCCALL(SETUP_XfOrM747(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg153 , MZCONFIG_INSPECTOR ) )) ; 

  immutable_array = FUNCCALL(SETUP_XfOrM747(_), immutable_pos_list_to_immutable_array (immutable_pos_list , initc + uninitc ) ); 

  if (prefab ) {
    const char * bad = ((void * ) 0 ) ; 
    Scheme_Object * parent = argv [1 ] ; 
#   define XfOrM752_COUNT (0+XfOrM747_COUNT)
#   define SETUP_XfOrM752(x) SETUP_XfOrM747(x)

# 5426 "./../src/struct.c"
    if (((Scheme_Type ) (((((intptr_t ) (parent ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (parent ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) )  {
      bad = "chaperoned supertype disallowed for non-generative structure type" ; 
    }

# 5428 "./../src/struct.c"
    else if (! (((parent ) ) == (scheme_false ) ) && ! ((Scheme_Struct_Type * ) parent ) -> prefab_key ) {
      bad = "generative supertype disallowed for non-generative structure type" ; 
    }

# 5430 "./../src/struct.c"
    else if (! ((props ) == (scheme_null ) ) ) {
      bad = "properties disallowed for non-generative structure type" ; 
    }

# 5432 "./../src/struct.c"
    else if (proc_attr ) {
      bad = "procedure specification disallowed for non-generative structure type" ; 
    }

# 5434 "./../src/struct.c"
    else if (guard ) {
      bad = "guard disallowed for non-generative structure type" ; 
    }
    if (bad ) {
#     define XfOrM753_COUNT (0+XfOrM752_COUNT)
#     define SETUP_XfOrM753(x) SETUP_XfOrM752(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , bad , "structure type name" , 1 , argv [0 ] , ((void * ) 0 ) ) )
      ; 
    }

    type = FUNCCALL(SETUP_XfOrM752(_), scheme_make_prefab_struct_type (argv [0 ] , (((argv [1 ] ) ) == (scheme_false ) ) ? ((void * ) 0 ) : argv [1 ] , initc , uninitc , uninit_val , immutable_array ) )



    ; 
  }

# 5449 "./../src/struct.c"
  else {
    Scheme_Object * parent = (((argv [1 ] ) ) == (scheme_false ) ) ? ((void * ) 0 ) : argv [1 ] ; 
    Scheme_Struct_Type * parent_type ; 
#   define XfOrM750_COUNT (0+XfOrM747_COUNT)
#   define SETUP_XfOrM750(x) SETUP_XfOrM747(x)
    parent_type = NULLED_OUT ; 

# 5453 "./../src/struct.c"
    if (parent && (((Scheme_Type ) (((((intptr_t ) (parent ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (parent ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) )
      parent_type = (Scheme_Struct_Type * ) (((Scheme_Chaperone * ) parent ) -> val ) ; 
    else 
    parent_type = (Scheme_Struct_Type * ) parent ; 

    if (parent_type && (parent_type -> more_flags & 0x8 ) ) {
#     define XfOrM751_COUNT (0+XfOrM750_COUNT)
#     define SETUP_XfOrM751(x) SETUP_XfOrM750(x)
      FUNCCALL_EMPTY(scheme_contract_error ("make-struct-type" , "cannot make a subtype of a sealed type" , "type name" , 1 , argv [0 ] , "sealed type" , 1 , parent , ((void * ) 0 ) ) )

      ; 
    }

    type = (Scheme_Struct_Type * ) FUNCCALL(SETUP_XfOrM750(_), _make_struct_type (argv [0 ] , parent , inspector , initc , uninitc , uninit_val , props , proc_attr , immutable_array , guard ) )






    ; 
  }

  {
    int i ; 
    Scheme_Object * * names ; 
    BLOCK_SETUP((PUSH(names, 0+XfOrM747_COUNT)));
#   define XfOrM748_COUNT (1+XfOrM747_COUNT)
#   define SETUP_XfOrM748(x) SETUP(XfOrM748_COUNT)
    names = NULLED_OUT ; 

# 5480 "./../src/struct.c"
    names = FUNCCALL(SETUP_XfOrM748(_), scheme_make_struct_names (argv [0 ] , ((void * ) 0 ) , (0x20 | 0x40 | 0x200 ) , & i ) )



    ; 
    if (cstr_name ) {
#     define XfOrM749_COUNT (0+XfOrM748_COUNT)
#     define SETUP_XfOrM749(x) SETUP_XfOrM748(x)

# 5486 "./../src/struct.c"
      a = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM749(_), scheme_symbol_val (cstr_name ) ); 
      names [1 ] = a ; 
    }
    r = FUNCCALL(SETUP_XfOrM748(_), scheme_make_struct_values ((Scheme_Object * ) type , names , i , (0x20 | 0x40 | 0x200 ) ) )

    ; 

    RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (i , r ) )) RET_VALUE_EMPTY_END ; 
  }
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5497 "./../src/struct.c"
static Scheme_Object * make_prefab_key (Scheme_Struct_Type * type ) 
{
  Scheme_Object * key = scheme_null , * stack = scheme_null ; 
  int total_cnt ; 
  Scheme_Object * __funcarg157 = NULLED_OUT ; 
  Scheme_Object * __funcarg156 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(type, 0), PUSH(stack, 1), PUSH(key, 2)));
# define XfOrM780_COUNT (3)
# define SETUP_XfOrM780(x) SETUP(XfOrM780_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)

# 5502 "./../src/struct.c"
  total_cnt = type -> num_slots ; 

  while (type -> name_pos ) {
#   define XfOrM804_COUNT (0+XfOrM780_COUNT)
#   define SETUP_XfOrM804(x) SETUP_XfOrM780(x)

# 5505 "./../src/struct.c"
    stack = FUNCCALL(SETUP_XfOrM804(_), scheme_make_pair ((Scheme_Object * ) type , stack ) ); 
    type = type -> parent_types [type -> name_pos - 1 ] ; 
  }

  while (type ) {
    int cnt = type -> num_slots ; 
    int icnt = type -> num_islots ; 
#   define XfOrM792_COUNT (0+XfOrM780_COUNT)
#   define SETUP_XfOrM792(x) SETUP_XfOrM780(x)

# 5512 "./../src/struct.c"
    if (type -> name_pos ) {
      cnt -= type -> parent_types [type -> name_pos - 1 ] -> num_slots ; 
      icnt -= type -> parent_types [type -> name_pos - 1 ] -> num_islots ; 
    }

    if (cnt ) {
      int i ; 
      Scheme_Object * v = scheme_null ; 
      BLOCK_SETUP((PUSH(v, 0+XfOrM792_COUNT)));
#     define XfOrM795_COUNT (1+XfOrM792_COUNT)
#     define SETUP_XfOrM795(x) SETUP(XfOrM795_COUNT)

# 5520 "./../src/struct.c"
      for (i = icnt ; i -- ; ) {
#       define XfOrM800_COUNT (0+XfOrM795_COUNT)
#       define SETUP_XfOrM800(x) SETUP_XfOrM795(x)

# 5521 "./../src/struct.c"
        if (! type -> immutables || ! type -> immutables [i ] ) {
#         define XfOrM801_COUNT (0+XfOrM800_COUNT)
#         define SETUP_XfOrM801(x) SETUP_XfOrM800(x)

# 5522 "./../src/struct.c"
          v = FUNCCALL(SETUP_XfOrM801(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (i ) ) ) << 1 ) | 0x1 ) ) , v ) ); 
        }
      }
      if (! ((v ) == (scheme_null ) ) ) {
#       define XfOrM797_COUNT (0+XfOrM795_COUNT)
#       define SETUP_XfOrM797(x) SETUP_XfOrM795(x)

# 5526 "./../src/struct.c"
        v = FUNCCALL(SETUP_XfOrM797(_), scheme_list_to_vector (v ) ); 
        key = FUNCCALL(SETUP_XfOrM797(_), scheme_make_pair (v , key ) ); 
      }

      if (cnt > icnt ) {
#       define XfOrM796_COUNT (0+XfOrM795_COUNT)
#       define SETUP_XfOrM796(x) SETUP_XfOrM795(x)

# 5531 "./../src/struct.c"
        key = (__funcarg156 = (__funcarg157 = FUNCCALL(SETUP_XfOrM796(_), scheme_make_pair (type -> uninit_val , scheme_null ) ), FUNCCALL_AGAIN(scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (cnt - icnt ) ) ) << 1 ) | 0x1 ) ) , __funcarg157 ) )) 

        , FUNCCALL_AGAIN(scheme_make_pair (__funcarg156 , key ) )) 
        ; 
      }
    }
    if (! ((stack ) == (scheme_null ) ) )
      key = FUNCCALL(SETUP_XfOrM792(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (icnt ) ) ) << 1 ) | 0x1 ) ) , key ) ); 

    key = FUNCCALL(SETUP_XfOrM792(_), scheme_make_pair (type -> name , key ) ); 

    if ((Scheme_Type ) (((((intptr_t ) (stack ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (stack ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
      type = (Scheme_Struct_Type * ) (((Scheme_Simple_Object * ) (stack ) ) -> u . pair_val . car ) ; 
      stack = (((Scheme_Simple_Object * ) (stack ) ) -> u . pair_val . cdr ) ; 
    }

# 5545 "./../src/struct.c"
    else {
      type = ((void * ) 0 ) ; 
    }
  }

  if (((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) 
  && (((((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ) == (scheme_null ) ) )
    key = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . car ) ; 




  key = FUNCCALL(SETUP_XfOrM780(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (total_cnt ) ) ) << 1 ) | 0x1 ) ) , key ) )
  ; 

  RET_VALUE_START (key ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5563 "./../src/struct.c"
static char * mutability_data_to_immutability_data (int icnt , int ucnt , Scheme_Object * mutables , int * _min_cnt ) 


{
  char * immutable_array = ((void * ) 0 ) , * a2 ; 
  DECL_RET_SAVE (char * ) PREPARE_VAR_STACK(5);
  BLOCK_SETUP_TOP((PUSH(immutable_array, 0), PUSH(a2, 1), PUSH(mutables, 2), PUSH(_min_cnt, 3)));
# define XfOrM805_COUNT (4)
# define SETUP_XfOrM805(x) SETUP(XfOrM805_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  a2 = NULLED_OUT ; 

# 5569 "./../src/struct.c"
  if (_min_cnt )
    * _min_cnt = icnt + ucnt ; 

  if ((icnt > 0 ) || _min_cnt ) {
    int sz = icnt + ucnt + 1 ; 
#   define XfOrM806_COUNT (0+XfOrM805_COUNT)
#   define SETUP_XfOrM806(x) SETUP_XfOrM805(x)

# 5574 "./../src/struct.c"
    immutable_array = (char * ) FUNCCALL(SETUP_XfOrM806(_), GC_malloc_atomic (icnt + ucnt ) ); 
    (memset (immutable_array , 1 , icnt ) ) ; 
    (memset (immutable_array XFORM_OK_PLUS icnt , 0 , ucnt ) ) ; 

    if (mutables ) {
      int i ; 
      int len ; 
#     define XfOrM807_COUNT (0+XfOrM806_COUNT)
#     define SETUP_XfOrM807(x) SETUP_XfOrM806(x)

# 5581 "./../src/struct.c"
      len = (((Scheme_Vector * ) (mutables ) ) -> size ) ; 
      if ((len > icnt ) && ! _min_cnt )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

      for (i = 0 ; i < len ; i ++ ) {
        int a_val ; 
        Scheme_Object * a ; 
        BLOCK_SETUP((PUSH(a, 0+XfOrM807_COUNT)));
#       define XfOrM811_COUNT (1+XfOrM807_COUNT)
#       define SETUP_XfOrM811(x) SETUP(XfOrM811_COUNT)
        a = NULLED_OUT ; 

# 5588 "./../src/struct.c"
        a = (((Scheme_Vector * ) (mutables ) ) -> els ) [i ] ; 
        if (! (((intptr_t ) (a ) ) & 0x1 ) 
        || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) 
        || (((((intptr_t ) (a ) ) >> 1 ) >= icnt ) 
        && ! _min_cnt ) )
          RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
        a_val = (((intptr_t ) (a ) ) >> 1 ) ; 
        if (_min_cnt && ((a_val + ucnt ) >= * _min_cnt ) ) {
          * _min_cnt = a_val + ucnt + 1 ; 
        }
        if (a_val >= sz ) {
#         define XfOrM812_COUNT (0+XfOrM811_COUNT)
#         define SETUP_XfOrM812(x) SETUP_XfOrM811(x)

# 5599 "./../src/struct.c"
          a2 = (char * ) FUNCCALL(SETUP_XfOrM812(_), GC_malloc_atomic (a_val * 2 ) ); 
          (memset (a2 , 1 , a_val * 2 ) ) ; 
          (memcpy (a2 , immutable_array , sz ) ) ; 
          sz = a_val * 2 ; 
          immutable_array = a2 ; 
        }
        immutable_array [a_val ] = 0 ; 
      }
    }
  }

  RET_VALUE_START (immutable_array ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5613 "./../src/struct.c"
Scheme_Struct_Type * scheme_lookup_prefab_type (Scheme_Object * key , int min_field_count ) 
{
  Scheme_Struct_Type * parent = ((void * ) 0 ) ; 
  Scheme_Object * a , * uninit_val , * mutables , * name ; 
  intptr_t ucnt , icnt ; 
  int inferred_size = 0 ; 
  char * immutable_array = ((void * ) 0 ) ; 
  DECL_RET_SAVE (Scheme_Struct_Type * ) PREPARE_VAR_STACK(8);
  BLOCK_SETUP_TOP((PUSH(uninit_val, 0), PUSH(immutable_array, 1), PUSH(mutables, 2), PUSH(key, 3), PUSH(a, 4), PUSH(parent, 5), PUSH(name, 6)));
# define XfOrM814_COUNT (7)
# define SETUP_XfOrM814(x) SETUP(XfOrM814_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  a = NULLED_OUT ; 
  uninit_val = NULLED_OUT ; 
  mutables = NULLED_OUT ; 
  name = NULLED_OUT ; 

# 5621 "./../src/struct.c"
  if ((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) 
    key = FUNCCALL(SETUP_XfOrM814(_), scheme_make_pair (key , scheme_null ) ); 

  if ((scheme_proper_list_length (key ) ) < 0 )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  if (min_field_count > 32768 )
    min_field_count = 32768 ; 

  {
    Scheme_Struct_Type * stype = ((void * ) 0 ) ; 
    BLOCK_SETUP((PUSH(stype, 0+XfOrM814_COUNT)));
#   define XfOrM831_COUNT (1+XfOrM814_COUNT)
#   define SETUP_XfOrM831(x) SETUP(XfOrM831_COUNT)

# 5632 "./../src/struct.c"
    stype = FUNCCALL(SETUP_XfOrM831(_), lookup_prefab (key ) ); 
    if (stype ) {
      RET_VALUE_START (stype ) RET_VALUE_END ; 
    }
  }


  key = FUNCCALL(SETUP_XfOrM814(_), scheme_reverse (key ) ); 

  while (((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) ) {
#   define XfOrM823_COUNT (0+XfOrM814_COUNT)
#   define SETUP_XfOrM823(x) SETUP_XfOrM814(x)

# 5643 "./../src/struct.c"
    a = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . car ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) )  {
      mutables = a ; 
      key = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ; 
    }

# 5647 "./../src/struct.c"
    else 
    mutables = ((void * ) 0 ) ; 


    if (! ((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    a = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . car ) ; 
    if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) )  {
#     define XfOrM829_COUNT (0+XfOrM823_COUNT)
#     define SETUP_XfOrM829(x) SETUP_XfOrM823(x)

# 5655 "./../src/struct.c"
      if ((scheme_proper_list_length (a ) ) != 2 )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      if (! (((intptr_t ) ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ) ) & 0x1 ) )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      ucnt = (((intptr_t ) ((((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ) ) >> 1 ) ; 
      a = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . cdr ) ; 
      uninit_val = (((Scheme_Simple_Object * ) (a ) ) -> u . pair_val . car ) ; 
      key = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ; 
    }

# 5663 "./../src/struct.c"
    else {
      ucnt = 0 ; 
      uninit_val = scheme_false ; 
    }


    if (! ((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    a = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . car ) ; 
    if (! (((intptr_t ) (a ) ) & 0x1 ) ) {
      if (((((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ) == (scheme_null ) )  {

        icnt = min_field_count - ucnt - (parent 
        ? parent -> num_slots 
        : 0 ) ; 
        if (icnt < 0 )
          icnt = 0 ; 
        inferred_size = 1 ; 
      }

# 5681 "./../src/struct.c"
      else 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

# 5683 "./../src/struct.c"
    else {
      icnt = (((intptr_t ) (a ) ) >> 1 ) ; 
      if (icnt > 32768 )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      key = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ; 
    }


    if (! ((Scheme_Type ) (((((intptr_t ) (key ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (key ) ) -> type ) ) == (Scheme_Type ) (scheme_pair_type ) ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    a = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . car ) ; 
    key = (((Scheme_Simple_Object * ) (key ) ) -> u . pair_val . cdr ) ; 

    if (! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_symbol_type ) ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    name = a ; 

    if (icnt || (mutables && (((Scheme_Vector * ) (mutables ) ) -> size ) ) ) {
      int min_cnt ; 
#     define XfOrM824_COUNT (0+XfOrM823_COUNT)
#     define SETUP_XfOrM824(x) SETUP_XfOrM823(x)

# 5702 "./../src/struct.c"
      immutable_array = FUNCCALL(SETUP_XfOrM824(_), mutability_data_to_immutability_data (icnt , ucnt , mutables , inferred_size ? & min_cnt : ((void * ) 0 ) ) )


      ; 
      if (! immutable_array )
        RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
      if (inferred_size && (min_cnt > icnt + ucnt ) )
        icnt = min_cnt - ucnt ; 
    }

    if (parent && (icnt + parent -> num_slots > 32768 ) )
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

    parent = FUNCCALL(SETUP_XfOrM823(_), scheme_make_prefab_struct_type (name , (Scheme_Object * ) parent , icnt , ucnt , uninit_val , immutable_array ) )



    ; 
  }


  if (! ((key ) == (scheme_null ) ) )
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 

  RET_VALUE_START (parent ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

Scheme_Object * scheme_extract_struct_procedure (Scheme_Object * obj , int num_rands , Scheme_Object * * rands , int * is_method ) 
{
  Scheme_Struct_Type * stype ; 
  Scheme_Object * plain_obj , * a , * proc ; 
  int meth_wrap = 0 ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(plain_obj, 0), PUSH(a, 1), PUSH(is_method, 2), PUSH(obj, 3), PUSH(rands, 4), PUSH(proc, 5)));
# define XfOrM833_COUNT (6)
# define SETUP_XfOrM833(x) SETUP(XfOrM833_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  stype = NULLED_OUT ; 
  plain_obj = NULLED_OUT ; 
  a = NULLED_OUT ; 
  proc = NULLED_OUT ; 

# 5739 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (obj ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (obj ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    plain_obj = (((Scheme_Chaperone * ) obj ) -> val ) ; 
  else 
  plain_obj = obj ; 

  stype = ((Scheme_Structure * ) plain_obj ) -> stype ; 
  a = stype -> proc_attr ; 

  if (((intptr_t ) (a ) ) & 0x1 )  {
#   define XfOrM838_COUNT (0+XfOrM833_COUNT)
#   define SETUP_XfOrM838(x) SETUP_XfOrM833(x)

# 5748 "./../src/struct.c"
    * is_method = 0 ; 
    if (! ((plain_obj ) == (obj ) ) ) {
#     define XfOrM840_COUNT (0+XfOrM838_COUNT)
#     define SETUP_XfOrM840(x) SETUP_XfOrM838(x)

# 5750 "./../src/struct.c"
      proc = FUNCCALL(SETUP_XfOrM840(_), chaperone_struct_ref ("struct-ref" , ((void * ) 0 ) , obj , obj , (((intptr_t ) (a ) ) >> 1 ) ) ); 
    }

# 5751 "./../src/struct.c"
    else {
      proc = ((Scheme_Structure * ) obj ) -> slots [(((intptr_t ) (a ) ) >> 1 ) ] ; 
    }
  }

# 5754 "./../src/struct.c"
  else {
    * is_method = 1 ; 
    proc = a ; 
  }

  if (num_rands >= 0 ) {
#   define XfOrM834_COUNT (0+XfOrM833_COUNT)
#   define SETUP_XfOrM834(x) SETUP_XfOrM833(x)

# 5761 "./../src/struct.c"
    if (! (! (((intptr_t ) (proc ) ) & 0x1 ) && ((((proc ) -> type ) >= scheme_prim_type ) && (((proc ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
    || ! FUNCCALL(SETUP_XfOrM834(_), scheme_check_proc_arity (((void * ) 0 ) , num_rands , - 1 , 0 , & obj ) )) {
#     define XfOrM835_COUNT (0+XfOrM834_COUNT)
#     define SETUP_XfOrM835(x) SETUP_XfOrM834(x)

      if (scheme_reduced_procedure_struct 
      && (scheme_is_struct_instance (scheme_reduced_procedure_struct , plain_obj ) ) )
        meth_wrap = (! (((((Scheme_Structure * ) obj ) -> slots [3 ] ) ) == (scheme_false ) ) ) ; 
      else {
#       define XfOrM836_COUNT (0+XfOrM835_COUNT)
#       define SETUP_XfOrM836(x) SETUP_XfOrM835(x)

# 5770 "./../src/struct.c"
        a = (do_prop_accessor (method_property , plain_obj ) ) ; 
        if (a && (! (((a ) ) == (scheme_false ) ) ) )
          meth_wrap = 1 ; 
      }
      FUNCCALL(SETUP_XfOrM835(_), scheme_wrong_count_m ((char * ) obj , - 1 , 0 , num_rands , rands , meth_wrap ) )


      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
  }

  RET_VALUE_START (proc ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5785 "./../src/struct.c"
static Scheme_Object * procedure_extract_target (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * v ; 
  int is_method ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(v, 0)));
# define XfOrM841_COUNT (1)
# define SETUP_XfOrM841(x) SETUP(XfOrM841_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  v = NULLED_OUT ; 

# 5790 "./../src/struct.c"
  if (! (! (((intptr_t ) (argv [0 ] ) ) & 0x1 ) && ((((argv [0 ] ) -> type ) >= scheme_prim_type ) && (((argv [0 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract ("procedure-extract-target" , "procedure?" , 0 , argc , argv ) ); 

  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
#   define XfOrM842_COUNT (0+XfOrM841_COUNT)
#   define SETUP_XfOrM842(x) SETUP_XfOrM841(x)

# 5795 "./../src/struct.c"
    if (scheme_reduced_procedure_struct 
    && (scheme_is_struct_instance (scheme_reduced_procedure_struct , argv [0 ] ) ) )
      RET_VALUE_START (scheme_false ) RET_VALUE_END ; 

    v = FUNCCALL(SETUP_XfOrM842(_), scheme_extract_struct_procedure (argv [0 ] , - 1 , ((void * ) 0 ) , & is_method ) ); 
    if (v && ! is_method && (! (((intptr_t ) (v ) ) & 0x1 ) && ((((v ) -> type ) >= scheme_prim_type ) && (((v ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
      RET_VALUE_START (v ) RET_VALUE_END ; 
  }

  RET_VALUE_START (scheme_false ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static int exact_pos_integer (Scheme_Object * o ) 
{
  /* No conversion */

# 5813 "./../src/struct.c"
  if (((intptr_t ) (o ) ) & 0x1 ) 
    return (((intptr_t ) (o ) ) >> 1 ) > 0 ; 
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
    return ((& ((Scheme_Bignum * ) o ) -> iso ) -> so . keyex & 0x1 ) ; 
  else 
  return 0 ; 
}

static int exact_nneg_integer (Scheme_Object * o ) 
{
  /* No conversion */

# 5823 "./../src/struct.c"
  if (((intptr_t ) (o ) ) & 0x1 ) 
    return (((intptr_t ) (o ) ) >> 1 ) >= 0 ; 
  else if ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) 
    return ((& ((Scheme_Bignum * ) o ) -> iso ) -> so . keyex & 0x1 ) ; 
  else 
  return 0 ; 
}

Scheme_Object * scheme_make_location (Scheme_Object * src , 
Scheme_Object * line , 
Scheme_Object * col , 
Scheme_Object * pos , 
Scheme_Object * span ) 
{
  Scheme_Object * a [5 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(3);
  BLOCK_SETUP_TOP((PUSHARRAY(a, 5, 0)));
# define XfOrM845_COUNT (3)
# define SETUP_XfOrM845(x) SETUP(XfOrM845_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  NULL_OUT_ARRAY (a ) ; 

# 5838 "./../src/struct.c"
  a [0 ] = src ; 
  a [1 ] = line ; 
  a [2 ] = col ; 
  a [3 ] = pos ; 
  a [4 ] = span ; 
  RET_VALUE_START (FUNCCALL(SETUP_XfOrM845(_), scheme_make_struct_instance (location_struct , 5 , a ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5846 "./../src/struct.c"
Scheme_Object * scheme_unsafe_make_location (void ) 
{
  Scheme_Structure * inst ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(inst, 0)));
# define XfOrM846_COUNT (1)
# define SETUP_XfOrM846(x) SETUP(XfOrM846_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  inst = NULLED_OUT ; 

# 5850 "./../src/struct.c"
  inst = (Scheme_Structure * ) FUNCCALL(SETUP_XfOrM846(_), GC_malloc_one_tagged ((sizeof (Scheme_Structure ) + (((5 ) - 0 ) * sizeof (Scheme_Object * ) ) ) ) ); 

  inst -> so . type = scheme_structure_type ; 
  inst -> stype = (Scheme_Struct_Type * ) location_struct ; 



  RET_VALUE_START ((Scheme_Object * ) inst ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5860 "./../src/struct.c"
Scheme_Object * scheme_unsafe_make_srcloc (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * srcloc ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(2);
  BLOCK_SETUP_TOP((PUSH(srcloc, 0), PUSH(argv, 1)));
# define XfOrM847_COUNT (2)
# define SETUP_XfOrM847(x) SETUP(XfOrM847_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  srcloc = NULLED_OUT ; 

# 5864 "./../src/struct.c"
  srcloc = FUNCCALL(SETUP_XfOrM847(_), scheme_unsafe_make_location () ); 

  ((Scheme_Structure * ) srcloc ) -> slots [0 ] = argv [0 ] ; 
  ((Scheme_Structure * ) srcloc ) -> slots [1 ] = argv [1 ] ; 
  ((Scheme_Structure * ) srcloc ) -> slots [2 ] = argv [2 ] ; 
  ((Scheme_Structure * ) srcloc ) -> slots [3 ] = argv [3 ] ; 
  ((Scheme_Structure * ) srcloc ) -> slots [4 ] = argv [4 ] ; 

  RET_VALUE_START (srcloc ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5875 "./../src/struct.c"
int scheme_is_location (Scheme_Object * o ) 
{
  /* No conversion */

# 5877 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    o = (((Scheme_Chaperone * ) o ) -> val ) ; 

  return ((((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (o ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (o ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) 
  && scheme_is_struct_instance (location_struct , o ) ) ; 
}

static Scheme_Object * check_location_fields (int argc , Scheme_Object * * argv ) 
{
  PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM849_COUNT (1)
# define SETUP_XfOrM849(x) SETUP(XfOrM849_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)

# 5886 "./../src/struct.c"
  if ((! (((argv [1 ] ) ) == (scheme_false ) ) ) && ! FUNCCALL(SETUP_XfOrM849(_), exact_pos_integer (argv [1 ] ) ))
    FUNCCALL(SETUP_XfOrM849(_), scheme_wrong_field_contract (argv [5 ] , "(or/c exact-positive-integer? #f)" , argv [1 ] ) ); 
  if ((! (((argv [2 ] ) ) == (scheme_false ) ) ) && ! FUNCCALL(SETUP_XfOrM849(_), exact_nneg_integer (argv [2 ] ) ))
    FUNCCALL(SETUP_XfOrM849(_), scheme_wrong_field_contract (argv [5 ] , "(or/c exact-nonnegative-integer #f)" , argv [2 ] ) ); 
  if ((! (((argv [3 ] ) ) == (scheme_false ) ) ) && ! FUNCCALL(SETUP_XfOrM849(_), exact_pos_integer (argv [3 ] ) ))
    FUNCCALL(SETUP_XfOrM849(_), scheme_wrong_field_contract (argv [5 ] , "(or/c exact-positive-integer? #f)" , argv [3 ] ) ); 
  if ((! (((argv [4 ] ) ) == (scheme_false ) ) ) && ! FUNCCALL(SETUP_XfOrM849(_), exact_nneg_integer (argv [4 ] ) ))
    FUNCCALL(SETUP_XfOrM849(_), scheme_wrong_field_contract (argv [5 ] , "(or/c exact-nonnegative-integer? #f)" , argv [4 ] ) ); 

  RET_VALUE_EMPTY_START (FUNCCALL_EMPTY(scheme_values (5 , argv ) )) RET_VALUE_EMPTY_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

static Scheme_Object * check_arity_at_least_fields (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5904 "./../src/struct.c"
  Scheme_Object * a ; 

  a = argv [0 ] ; 
  if (((intptr_t ) (a ) ) & 0x1 )  {
    if ((((intptr_t ) (a ) ) >> 1 ) >= 0 )
      return a ; 
  }

# 5910 "./../src/struct.c"
  else if ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) )  {
    if ((& ((Scheme_Bignum * ) a ) -> iso ) -> so . keyex & 0x1 ) 
      return a ; 
  }

  scheme_wrong_field_contract (argv [1 ] , "exact-nonnegative-integer?" , a ) ; 
  return ((void * ) 0 ) ; 
}

static Scheme_Object * check_date_fields (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * a , * args [10 ] ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(argv, 1), PUSHARRAY(args, 10, 2)));
# define XfOrM853_COUNT (5)
# define SETUP_XfOrM853(x) SETUP(XfOrM853_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  a = NULLED_OUT ; 
  NULL_OUT_ARRAY (args ) ; 

# 5923 "./../src/struct.c"
  a = argv [0 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) || ((((intptr_t ) (a ) ) >> 1 ) > 60 ) )
    FUNCCALL(SETUP_XfOrM853(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 0 60)" , a ) ); 
  a = argv [1 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) || ((((intptr_t ) (a ) ) >> 1 ) > 59 ) )
    FUNCCALL(SETUP_XfOrM853(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 0 59)" , a ) ); 
  a = argv [2 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) || ((((intptr_t ) (a ) ) >> 1 ) > 23 ) )
    FUNCCALL(SETUP_XfOrM853(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 0 23)" , a ) ); 
  a = argv [3 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 1 ) || ((((intptr_t ) (a ) ) >> 1 ) > 31 ) )
    FUNCCALL(SETUP_XfOrM853(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 1 31)" , a ) ); 
  a = argv [4 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 1 ) || ((((intptr_t ) (a ) ) >> 1 ) > 12 ) )
    FUNCCALL(SETUP_XfOrM853(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 1 12)" , a ) ); 
  a = argv [5 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
    FUNCCALL(SETUP_XfOrM853(_), scheme_wrong_field_contract (argv [10 ] , "exact-integer?" , a ) ); 
  a = argv [6 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) || ((((intptr_t ) (a ) ) >> 1 ) > 6 ) )
    FUNCCALL(SETUP_XfOrM853(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 0 6)" , a ) ); 
  a = argv [7 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) || ((((intptr_t ) (a ) ) >> 1 ) > 365 ) )
    FUNCCALL(SETUP_XfOrM853(_), scheme_wrong_field_contract (argv [10 ] , "(integer-in 0 365)" , a ) ); 
  a = argv [9 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) && ! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_bignum_type ) ) )
    FUNCCALL(SETUP_XfOrM853(_), scheme_wrong_field_contract (argv [10 ] , "exact-integer?" , a ) ); 
  (

  memcpy (args , argv , sizeof (Scheme_Object * ) * 10 ) ) ; 
  args [8 ] = ((! (((argv [8 ] ) ) == (scheme_false ) ) ) ? scheme_true : scheme_false ) ; 

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM853(_), scheme_values (10 , args ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5958 "./../src/struct.c"
static Scheme_Object * check_date_star_fields (int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * args [12 ] , * a ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(a, 0), PUSH(argv, 1), PUSHARRAY(args, 12, 2)));
# define XfOrM854_COUNT (5)
# define SETUP_XfOrM854(x) SETUP(XfOrM854_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  NULL_OUT_ARRAY (args ) ; 
  a = NULLED_OUT ; 

# 5962 "./../src/struct.c"
  a = argv [10 ] ; 
  if (! (((intptr_t ) (a ) ) & 0x1 ) || ((((intptr_t ) (a ) ) >> 1 ) < 0 ) 
  || ((((intptr_t ) (a ) ) >> 1 ) > 999999999 ) )
    FUNCCALL(SETUP_XfOrM854(_), scheme_wrong_field_contract (argv [12 ] , "(integer-in 0 999999999)" , a ) ); 

  a = argv [11 ] ; 
  if (! ((Scheme_Type ) (((((intptr_t ) (a ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a ) ) -> type ) ) == (Scheme_Type ) (scheme_char_string_type ) ) )
    FUNCCALL(SETUP_XfOrM854(_), scheme_wrong_field_contract (argv [12 ] , "string?" , a ) ); 
  (
  memcpy (args , argv , sizeof (Scheme_Object * ) * 12 ) ) ; 
  if (! (((Scheme_Inclhash_Object * ) (argv [11 ] ) ) -> so . keyex & 0x1 ) ) {
#   define XfOrM855_COUNT (0+XfOrM854_COUNT)
#   define SETUP_XfOrM855(x) SETUP_XfOrM854(x)

# 5973 "./../src/struct.c"
    a = argv [11 ] ; 
    a = FUNCCALL(SETUP_XfOrM855(_), scheme_make_immutable_sized_char_string ((((Scheme_Simple_Object * ) (a ) ) -> u . char_str_val . string_val ) , (((Scheme_Simple_Object * ) (a ) ) -> u . char_str_val . tag_val ) , 1 ) )

    ; 
    args [11 ] = a ; 
  }

  RET_VALUE_START (FUNCCALL(SETUP_XfOrM854(_), scheme_values (12 , args ) )) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 5985 "./../src/struct.c"
static Scheme_Object * exn_source_p (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5987 "./../src/struct.c"
  return (scheme_struct_type_property_ref (scheme_source_property , argv [0 ] ) 
  ? scheme_true 
  : scheme_false ) ; 
}

static Scheme_Object * exn_source_get (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 5994 "./../src/struct.c"
  Scheme_Object * v ; 

  v = scheme_struct_type_property_ref (scheme_source_property , argv [0 ] ) ; 
  if (! v )
    scheme_wrong_contract ("exn:srclocs-accessor" , "exn:srclocs?" , 0 , argc , argv ) ; 

  return v ; 
}

static Scheme_Object * check_exn_source_property_value_ok (int argc , Scheme_Object * argv [] ) 

{
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(1);
  BLOCK_SETUP_TOP((PUSH(argv, 0)));
# define XfOrM858_COUNT (1)
# define SETUP_XfOrM858(x) SETUP(XfOrM858_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  FUNCCALL(SETUP_XfOrM858(_), scheme_check_proc_arity ("guard-for-prop:exn:srclocs" , 1 , 0 , argc , argv ) )
# 6006 "./../src/struct.c"
  ; 

  RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6013 "./../src/struct.c"
static Scheme_Object * do_chaperone_struct (const char * name , int is_impersonator , int argc , Scheme_Object * * argv ) 

{
  Scheme_Chaperone * px ; 
  Scheme_Struct_Type * stype , * st ; 
  Scheme_Object * val = argv [0 ] , * proc , * props = ((void * ) 0 ) ; 
  Scheme_Object * redirects , * prop , * si_chaperone = scheme_false ; 
  Scheme_Object * a [1 ] , * inspector , * getter_positions = scheme_null ; 
  int i , offset , arity , non_applicable_op , repeat_op ; 
  const char * kind ; 
  Scheme_Hash_Tree * red_props = ((void * ) 0 ) , * empty_red_props = ((void * ) 0 ) , * setter_positions = ((void * ) 0 ) ; 
  intptr_t field_pos ; 
  int empty_si_chaperone = 0 , * empty_redirects = ((void * ) 0 ) , has_redirect = 0 , witnessed = 0 ; 
  Scheme_Config * __funcarg160 = NULLED_OUT ; 
  Scheme_Object * __funcarg159 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(21);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(getter_positions, 1), PUSH(inspector, 2), PUSH(px, 3), PUSH(red_props, 4), PUSHARRAY(a, 1, 5), PUSH(kind, 8), PUSH(st, 9), PUSH(si_chaperone, 10), PUSH(name, 11), PUSH(val, 12), PUSH(empty_redirects, 13), PUSH(empty_red_props, 14), PUSH(stype, 15), PUSH(prop, 16), PUSH(setter_positions, 17), PUSH(redirects, 18), PUSH(props, 19), PUSH(proc, 20)));
# define XfOrM859_COUNT (21)
# define SETUP_XfOrM859(x) SETUP(XfOrM859_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  stype = NULLED_OUT ; 
  st = NULLED_OUT ; 
  proc = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  prop = NULLED_OUT ; 
  a[0] = NULLED_OUT ; 
  inspector = NULLED_OUT ; 
  kind = NULLED_OUT ; 

# 6027 "./../src/struct.c"
  if (argc == 1 )

# 6027 "./../src/struct.c"
  RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 

  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    props = ((Scheme_Chaperone * ) val ) -> props ; 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 
  }

  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) )  {
#   define XfOrM934_COUNT (0+XfOrM859_COUNT)
#   define SETUP_XfOrM934(x) SETUP_XfOrM859(x)

# 6035 "./../src/struct.c"
    stype = ((Scheme_Structure * ) val ) -> stype ; 

    redirects = FUNCCALL(SETUP_XfOrM934(_), scheme_make_vector (2 + 2 * stype -> num_slots , scheme_false ) ); 
  }

# 6038 "./../src/struct.c"
  else {
    stype = ((void * ) 0 ) ; 
    redirects = ((void * ) 0 ) ; 
  }

  if (is_impersonator )
    inspector = (__funcarg160 = FUNCCALL(SETUP_XfOrM859(_), scheme_current_config () ), FUNCCALL_AGAIN(scheme_get_param (__funcarg160 , MZCONFIG_INSPECTOR ) )) ; 
  else 
  inspector = ((void * ) 0 ) ; 

  i = 1 ; 

  if ((i < argc ) && (((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) 
  || ((((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
  && ((Scheme_Type ) (((((intptr_t ) ((((Scheme_Chaperone * ) argv [i ] ) -> val ) ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) ((((Scheme_Chaperone * ) argv [i ] ) -> val ) ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) ) ) ) {
#   define XfOrM931_COUNT (0+XfOrM859_COUNT)
#   define SETUP_XfOrM931(x) SETUP_XfOrM859(x)

# 6053 "./../src/struct.c"
    if (! (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ! (scheme_is_struct_instance (((((Scheme_Type ) (((((intptr_t ) (argv [i ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [i ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) ) 
    ? (((Scheme_Chaperone * ) argv [i ] ) -> val ) 
    : argv [i ] ) , 
    val ) ) ) {
#     define XfOrM932_COUNT (0+XfOrM931_COUNT)
#     define SETUP_XfOrM932(x) SETUP_XfOrM931(x)
      FUNCCALL(SETUP_XfOrM932(_), scheme_contract_error (name , "given value is not an instance of the given structure type" , "struct type" , 1 , argv [i ] , "value" , 1 , argv [0 ] , ((void * ) 0 ) ) )

      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }
    i ++ ; 
    witnessed = 1 ; 
  }

  for (; i < argc ; i ++ ) {
#   define XfOrM900_COUNT (0+XfOrM859_COUNT)
#   define SETUP_XfOrM900(x) SETUP_XfOrM859(x)

# 6069 "./../src/struct.c"
    proc = argv [i ] ; 

    if ((i > 1 ) && ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) ) ) {
#     define XfOrM930_COUNT (0+XfOrM900_COUNT)
#     define SETUP_XfOrM930(x) SETUP_XfOrM900(x)

# 6072 "./../src/struct.c"
      props = FUNCCALL(SETUP_XfOrM930(_), scheme_parse_chaperone_props (name , i , argc , argv ) ); 
      break ; 
    }

    a [0 ] = proc ; 
    if (((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (proc ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (proc ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 

# 6077 "./../src/struct.c"
    proc = (((Scheme_Chaperone * ) proc ) -> val ) ; 
    if (! (((FUNCCALL(SETUP_XfOrM900(_), struct_setter_p (1 , a ) )) ) == (scheme_false ) ) )  {
      kind = "mutator" ; 
      if (stype )
        offset = stype -> num_slots ; 
      else 
      offset = 0 ; 
      witnessed = 1 ; 
    }

# 6085 "./../src/struct.c"
    else if (! (((FUNCCALL(SETUP_XfOrM900(_), struct_getter_p (1 , a ) )) ) == (scheme_false ) ) )  {
      kind = "accessor" ; 
      offset = 0 ; 
      witnessed = 1 ; 
    }

# 6089 "./../src/struct.c"
    else if (! (((FUNCCALL(SETUP_XfOrM900(_), struct_prop_getter_p (1 , a ) )) ) == (scheme_false ) ) )  {
      kind = "struct-type property accessor" ; 
      offset = - 1 ; 
      witnessed = 1 ; 
    }

# 6093 "./../src/struct.c"
    else if (! is_impersonator && ((proc ) == (struct_info_proc ) ) ) {
      kind = "struct-info" ; 
      offset = - 2 ; 
    }

# 6096 "./../src/struct.c"
    else {
#     define XfOrM925_COUNT (0+XfOrM900_COUNT)
#     define SETUP_XfOrM925(x) SETUP_XfOrM900(x)
      FUNCCALL(SETUP_XfOrM925(_), scheme_wrong_contract (name , ((i == 1 ) ? ("(or/c " "struct-type?\n      " "struct-accessor-procedure?\n" "      struct-mutator-procedure?\n" "      struct-type-property-accessor-procedure?\n" "      (one-of/c struct-info))" ) : ("(or/c " "" "struct-accessor-procedure?\n" "      struct-mutator-procedure?\n" "      struct-type-property-accessor-procedure?\n" "      (one-of/c struct-info))" ) ) , i , argc , argv ) )







      ; 
      RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
    }

    non_applicable_op = 0 ; 
    repeat_op = 0 ; 

    if (offset == - 2 ) {
#     define XfOrM924_COUNT (0+XfOrM900_COUNT)
#     define SETUP_XfOrM924(x) SETUP_XfOrM900(x)

# 6115 "./../src/struct.c"
      if ((! (((si_chaperone ) ) == (scheme_false ) ) ) || empty_si_chaperone )
        FUNCCALL(SETUP_XfOrM924(_), scheme_contract_error (name , "struct-info procedure supplied a second time" , "procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )


      ; 
      st = ((void * ) 0 ) ; 
      field_pos = 0 ; 
      prop = ((void * ) 0 ) ; 
      arity = 2 ; 
    }

# 6124 "./../src/struct.c"
    else if (offset == - 1 ) {
#     define XfOrM921_COUNT (0+XfOrM900_COUNT)
#     define SETUP_XfOrM921(x) SETUP_XfOrM900(x)

# 6125 "./../src/struct.c"
      prop = ((Scheme_Primitive_Closure * ) proc ) -> val [0 ] ; 
      st = ((void * ) 0 ) ; 
      field_pos = 0 ; 

      if (is_impersonator 
      && ! ((Scheme_Struct_Property * ) prop ) -> can_impersonate )
        FUNCCALL(SETUP_XfOrM921(_), scheme_contract_error (name , "operation cannot be impersonated" , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )



      ; 

      if (! (scheme_struct_type_property_ref (prop , argv [0 ] ) ) ) {
        non_applicable_op = 1 ; 
        arity = 0 ; 
      }

# 6140 "./../src/struct.c"
      else {
#       define XfOrM922_COUNT (0+XfOrM921_COUNT)
#       define SETUP_XfOrM922(x) SETUP_XfOrM921(x)

# 6141 "./../src/struct.c"
        if (red_props && FUNCCALL(SETUP_XfOrM922(_), scheme_hash_tree_get (red_props , prop ) ))
          repeat_op = 1 ; 
        if (empty_red_props && FUNCCALL(SETUP_XfOrM922(_), scheme_hash_tree_get (empty_red_props , prop ) ))
          repeat_op = 1 ; 

        arity = 2 ; 
      }
    }

# 6148 "./../src/struct.c"
    else {
#     define XfOrM913_COUNT (0+XfOrM900_COUNT)
#     define SETUP_XfOrM913(x) SETUP_XfOrM900(x)

# 6149 "./../src/struct.c"
      st = (Scheme_Struct_Type * ) ((Scheme_Primitive_Closure * ) proc ) -> val [0 ] ; 
      field_pos = (((intptr_t ) (((Scheme_Primitive_Closure * ) proc ) -> val [1 ] ) ) >> 1 ) ; 
      prop = ((void * ) 0 ) ; 

      if (! (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) || ! (scheme_is_struct_instance ((Scheme_Object * ) st , val ) ) )
        non_applicable_op = 1 ; 
      else if (! ((((((Scheme_Vector * ) (redirects ) ) -> els ) [2 + offset + field_pos ] ) ) == (scheme_false ) ) ) 
        repeat_op = 1 ; 
      else if (empty_redirects && empty_redirects [offset + field_pos ] )
        repeat_op = 1 ; 
      else {
#       define XfOrM914_COUNT (0+XfOrM913_COUNT)
#       define SETUP_XfOrM914(x) SETUP_XfOrM913(x)

# 6160 "./../src/struct.c"
        if (is_impersonator ) {
          intptr_t loc_field_pos ; 
#         define XfOrM915_COUNT (0+XfOrM914_COUNT)
#         define SETUP_XfOrM915(x) SETUP_XfOrM914(x)

# 6162 "./../src/struct.c"
          loc_field_pos = field_pos - (st -> name_pos 
          ? st -> parent_types [st -> name_pos - 1 ] -> num_slots 
          : 0 ) ; 

          if (st -> immutables ) {
#           define XfOrM920_COUNT (0+XfOrM915_COUNT)
#           define SETUP_XfOrM920(x) SETUP_XfOrM915(x)

# 6167 "./../src/struct.c"
            if (st -> immutables [loc_field_pos ] )
              FUNCCALL(SETUP_XfOrM920(_), scheme_contract_error (name , "cannot replace operation for an immutable field" , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )



            ; 
          }
          if (! offset ) {
#           define XfOrM918_COUNT (0+XfOrM915_COUNT)
#           define SETUP_XfOrM918(x) SETUP_XfOrM915(x)

            if (! FUNCCALL(SETUP_XfOrM918(_), scheme_inspector_sees_part (argv [0 ] , inspector , field_pos ) )) {
#             define XfOrM919_COUNT (0+XfOrM918_COUNT)
#             define SETUP_XfOrM919(x) SETUP_XfOrM918(x)

# 6179 "./../src/struct.c"
              getter_positions = (__funcarg159 = FUNCCALL(SETUP_XfOrM919(_), scheme_make_pair (((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (field_pos ) ) ) << 1 ) | 0x1 ) ) , a [0 ] ) ), FUNCCALL_AGAIN(scheme_make_pair (__funcarg159 , getter_positions ) )) 
              ; 
            }
          }

# 6182 "./../src/struct.c"
          else {
#           define XfOrM916_COUNT (0+XfOrM915_COUNT)
#           define SETUP_XfOrM916(x) SETUP_XfOrM915(x)

# 6183 "./../src/struct.c"
            if (! FUNCCALL(SETUP_XfOrM916(_), scheme_inspector_sees_part (argv [0 ] , inspector , field_pos ) )) {
#             define XfOrM917_COUNT (0+XfOrM916_COUNT)
#             define SETUP_XfOrM917(x) SETUP_XfOrM916(x)

# 6184 "./../src/struct.c"
              if (! setter_positions )
                setter_positions = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
              setter_positions = FUNCCALL(SETUP_XfOrM917(_), scheme_hash_tree_set (setter_positions , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (field_pos ) ) ) << 1 ) | 0x1 ) ) , scheme_true ) ); 
            }
          }
        }
      }

      arity = 2 ; 
    }

    if (repeat_op )
      FUNCCALL(SETUP_XfOrM900(_), scheme_contract_error (name , "given operation accesses the same value as a previous operation argument" , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )



    ; 

    if (non_applicable_op )
      FUNCCALL(SETUP_XfOrM900(_), scheme_contract_error (name , "operation does not apply to given value" , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , "value" , 1 , argv [0 ] , ((void * ) 0 ) ) )




    ; 

    i ++ ; 
    if (i >= argc )
      FUNCCALL(SETUP_XfOrM900(_), scheme_contract_error (name , "missing redirection procedure after operation" , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )



    ; 

    proc = argv [i ] ; 
    if ((! (((proc ) ) == (scheme_false ) ) ) 
    && ! FUNCCALL(SETUP_XfOrM900(_), scheme_check_proc_arity (((void * ) 0 ) , arity , i , argc , argv ) )) {
      char buf [64 ] ; 
#     define XfOrM912_COUNT (0+XfOrM900_COUNT)
#     define SETUP_XfOrM912(x) SETUP_XfOrM900(x)
      (
# 6222 "./../src/struct.c"
      sprintf (buf , "(or/c (procedure-arity-includes/c %d) #f)" , arity ) ) ; 
      FUNCCALL(SETUP_XfOrM912(_), scheme_contract_error (name , "operation's redirection procedure does not match the expected arity" , "given" , 1 , proc , "expected" , 0 , buf , "operation kind" , 0 , kind , "operation procedure" , 1 , a [0 ] , ((void * ) 0 ) ) )





      ; 
    }



    if ((((Scheme_Type ) (((((intptr_t ) (a [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (a [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (a [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) && (! (((proc ) ) == (scheme_false ) ) ) ) {
      Scheme_Chaperone * ppx = (Scheme_Chaperone * ) a [0 ] ; 
#     define XfOrM910_COUNT (0+XfOrM900_COUNT)
#     define SETUP_XfOrM910(x) SETUP_XfOrM900(x)

# 6236 "./../src/struct.c"
      if (! is_impersonator 
      && ((& (ppx ) -> iso ) -> so . keyex & 0x1 ) ) {
#       define XfOrM911_COUNT (0+XfOrM910_COUNT)
#       define SETUP_XfOrM911(x) SETUP_XfOrM910(x)
        FUNCCALL(SETUP_XfOrM911(_), scheme_contract_error (name , "impersonated operation cannot be used to create a chaperone" , "operation" , 1 , a [0 ] , ((void * ) 0 ) ) )
        ; 
      }
      proc = FUNCCALL(SETUP_XfOrM910(_), scheme_make_pair (a [0 ] , proc ) ); 
    }

    if (prop ) {
#     define XfOrM907_COUNT (0+XfOrM900_COUNT)
#     define SETUP_XfOrM907(x) SETUP_XfOrM900(x)

# 6247 "./../src/struct.c"
      if (! (((proc ) ) == (scheme_false ) ) )  {
#       define XfOrM909_COUNT (0+XfOrM907_COUNT)
#       define SETUP_XfOrM909(x) SETUP_XfOrM907(x)

# 6248 "./../src/struct.c"
        if (! red_props )
          red_props = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
        red_props = FUNCCALL(SETUP_XfOrM909(_), scheme_hash_tree_set (red_props , prop , proc ) ); 
        has_redirect = 1 ; 
      }

# 6252 "./../src/struct.c"
      else {
#       define XfOrM908_COUNT (0+XfOrM907_COUNT)
#       define SETUP_XfOrM908(x) SETUP_XfOrM907(x)

# 6253 "./../src/struct.c"
        if (! empty_red_props )
          empty_red_props = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
        empty_red_props = FUNCCALL(SETUP_XfOrM908(_), scheme_hash_tree_set (empty_red_props , prop , proc ) ); 
      }
    }

# 6257 "./../src/struct.c"
    else if (st ) {
#     define XfOrM903_COUNT (0+XfOrM900_COUNT)
#     define SETUP_XfOrM903(x) SETUP_XfOrM900(x)

# 6258 "./../src/struct.c"
      if (! (((proc ) ) == (scheme_false ) ) )  {
        (((Scheme_Vector * ) (redirects ) ) -> els ) [2 + offset + field_pos ] = proc ; 
        has_redirect = 1 ; 
      }

# 6261 "./../src/struct.c"
      else {
#       define XfOrM904_COUNT (0+XfOrM903_COUNT)
#       define SETUP_XfOrM904(x) SETUP_XfOrM903(x)

# 6262 "./../src/struct.c"
        if (! empty_redirects ) {
#         define XfOrM905_COUNT (0+XfOrM904_COUNT)
#         define SETUP_XfOrM905(x) SETUP_XfOrM904(x)

# 6263 "./../src/struct.c"
          empty_redirects = ((int * ) FUNCCALL(SETUP_XfOrM905(_), GC_malloc_atomic (sizeof (int ) * (2 * stype -> num_slots ) ) )) ; 
          (memset (empty_redirects , 0 , sizeof (int ) * 2 * stype -> num_slots ) ) ; 
        }
        empty_redirects [offset + field_pos ] = 1 ; 
      }
    }

# 6268 "./../src/struct.c"
    else {
      if (! (((proc ) ) == (scheme_false ) ) )  {
        si_chaperone = proc ; 
        has_redirect = 1 ; 
      }

# 6272 "./../src/struct.c"
      else 
      empty_si_chaperone = 1 ; 
    }
  }

  if (is_impersonator ) {
#   define XfOrM864_COUNT (0+XfOrM859_COUNT)
#   define SETUP_XfOrM864(x) SETUP_XfOrM859(x)
    getter_positions = FUNCCALL(SETUP_XfOrM864(_), scheme_reverse (getter_positions ) ); 
    while (! ((getter_positions ) == (scheme_null ) ) ) {
#     define XfOrM867_COUNT (0+XfOrM864_COUNT)
#     define SETUP_XfOrM867(x) SETUP_XfOrM864(x)

# 6282 "./../src/struct.c"
      prop = (((Scheme_Simple_Object * ) (getter_positions ) ) -> u . pair_val . car ) ; 
      if (! setter_positions 
      || ! FUNCCALL(SETUP_XfOrM867(_), scheme_hash_tree_get (setter_positions , (((Scheme_Simple_Object * ) (prop ) ) -> u . pair_val . car ) ) )) {
#       define XfOrM868_COUNT (0+XfOrM867_COUNT)
#       define SETUP_XfOrM868(x) SETUP_XfOrM867(x)
        FUNCCALL(SETUP_XfOrM868(_), scheme_contract_error (name , "accessor redirection for a non-transparent field requires a mutator redirection" , "explanation" , 0 , "a mutator redirection acts as a witness that access is allowed" , "accessor" , 1 , (((Scheme_Simple_Object * ) (prop ) ) -> u . pair_val . cdr ) , "value to impersonate" , 1 , argv [0 ] , ((void * ) 0 ) ) )


        ; 
      }
      getter_positions = (((Scheme_Simple_Object * ) (getter_positions ) ) -> u . pair_val . cdr ) ; 
    }
  }

  if (! has_redirect && ! props )
    RET_VALUE_START (argv [0 ] ) RET_VALUE_END ; 

  if (! witnessed ) {
#   define XfOrM863_COUNT (0+XfOrM859_COUNT)
#   define SETUP_XfOrM863(x) SETUP_XfOrM859(x)
    FUNCCALL(SETUP_XfOrM863(_), scheme_contract_error (name , (is_impersonator ? "cannot impersonate value as a structure without a witness" : "cannot chaperone value as a structure without a witness" ) , "explanation" , 0 , ("a structure type, accessor, or mutator acts as a witness\n" "   that the given value's representation can be chaperoned or impersonated" ) , "given value" , 1 , argv [0 ] , ((void * ) 0 ) ) )




    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if ((((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_structure_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_struct_type ) ) ) && ((Scheme_Structure * ) val ) -> stype -> more_flags & 0x4 ) {
#   define XfOrM862_COUNT (0+XfOrM859_COUNT)
#   define SETUP_XfOrM862(x) SETUP_XfOrM859(x)
    FUNCCALL(SETUP_XfOrM862(_), scheme_contract_error (name , (is_impersonator ? "cannot impersonate instance of an authentic structure type" : "cannot chaperone instance of an authentic structure type" ) , "given value" , 1 , val , ((void * ) 0 ) ) )


    ; 
    RET_VALUE_START (((void * ) 0 ) ) RET_VALUE_END ; 
  }

  if (! redirects ) {
#   define XfOrM861_COUNT (0+XfOrM859_COUNT)
#   define SETUP_XfOrM861(x) SETUP_XfOrM859(x)

# 6323 "./../src/struct.c"
    redirects = FUNCCALL(SETUP_XfOrM861(_), scheme_make_vector (1 , ((void * ) 0 ) ) ); 
  }

# 6324 "./../src/struct.c"
  else {
    (((Scheme_Vector * ) (redirects ) ) -> els ) [1 ] = si_chaperone ; 
  }

  (((Scheme_Vector * ) (redirects ) ) -> els ) [0 ] = (red_props ? (Scheme_Object * ) red_props : scheme_false ) ; 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM859(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  if (! (((intptr_t ) (val ) ) & 0x1 ) && ((((val ) -> type ) >= scheme_prim_type ) && (((val ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
    px -> iso . so . type = scheme_proc_chaperone_type ; 
  else 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> props = props ; 
  px -> redirects = redirects ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6346 "./../src/struct.c"
static Scheme_Object * chaperone_struct (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6348 "./../src/struct.c"
  return do_chaperone_struct ("chaperone-struct" , 0 , argc , argv ) ; 
}

static Scheme_Object * impersonate_struct (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6353 "./../src/struct.c"
  return do_chaperone_struct ("impersonate-struct" , 1 , argc , argv ) ; 
}


Scheme_Object * scheme_chaperone_not_undefined (Scheme_Object * orig_val ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val , * redirects ; 
  Scheme_Object * props ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(5);
  BLOCK_SETUP_TOP((PUSH(redirects, 0), PUSH(val, 1), PUSH(orig_val, 2), PUSH(px, 3), PUSH(props, 4)));
# define XfOrM938_COUNT (5)
# define SETUP_XfOrM938(x) SETUP(XfOrM938_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  val = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 6363 "./../src/struct.c"
  val = orig_val ; 

  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) )  {
    props = ((Scheme_Chaperone * ) val ) -> props ; 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 
  }

# 6368 "./../src/struct.c"
  else 
  props = ((void * ) 0 ) ; 

  redirects = FUNCCALL(SETUP_XfOrM938(_), scheme_make_vector (2 , scheme_false ) ); 

  (((Scheme_Vector * ) (redirects ) ) -> els ) [0 ] = scheme_false ; 
  (((Scheme_Vector * ) (redirects ) ) -> els ) [1 ] = scheme_undefined ; 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM938(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  if (! (((intptr_t ) (val ) ) & 0x1 ) && ((((val ) -> type ) >= scheme_prim_type ) && (((val ) -> type ) <= scheme_proc_chaperone_type ) ) ) 
    px -> iso . so . type = scheme_proc_chaperone_type ; 
  else 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> val = val ; 
  px -> prev = orig_val ; 
  px -> props = props ; 
  px -> redirects = redirects ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6390 "./../src/struct.c"
static Scheme_Object * do_chaperone_struct_type (const char * name , int is_impersonator , int argc , Scheme_Object * * argv ) 
{
  Scheme_Chaperone * px ; 
  Scheme_Object * val = argv [0 ] ; 
  Scheme_Object * redirects ; 
  Scheme_Object * props ; 
  int arity ; 
  Scheme_Object * __funcarg161 = NULLED_OUT ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK_ONCE(6);
  BLOCK_SETUP_TOP((PUSH(redirects, 0), PUSH(val, 1), PUSH(argv, 2), PUSH(px, 3), PUSH(props, 4), PUSH(name, 5)));
# define XfOrM940_COUNT (6)
# define SETUP_XfOrM940(x) SETUP(XfOrM940_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_once(x)
# define FUNCCALL(s, x) FUNCCALL_once(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_once(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_once(x)
  px = NULLED_OUT ; 
  redirects = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 6398 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    val = (((Scheme_Chaperone * ) val ) -> val ) ; 

  if (! ((Scheme_Type ) (((((intptr_t ) (val ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (val ) ) -> type ) ) == (Scheme_Type ) (scheme_struct_type_type ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "struct-type?" , 0 , argc , argv ) ); 
  FUNCCALL(SETUP_XfOrM940(_), scheme_check_proc_arity (name , 8 , 1 , argc , argv ) ); 
  FUNCCALL_AGAIN(scheme_check_proc_arity (name , 1 , 2 , argc , argv ) ); 
  if (! (! (((intptr_t ) (argv [3 ] ) ) & 0x1 ) && ((((argv [3 ] ) -> type ) >= scheme_prim_type ) && (((argv [3 ] ) -> type ) <= scheme_proc_chaperone_type ) ) ) )
    FUNCCALL_EMPTY(scheme_wrong_contract (name , "procedure?" , 3 , argc , argv ) ); 

  arity = ((Scheme_Struct_Type * ) val ) -> num_islots + 1 ; 
  if (! FUNCCALL(SETUP_XfOrM940(_), scheme_check_proc_arity (((void * ) 0 ) , arity , 3 , argc , argv ) ))
    FUNCCALL_EMPTY(scheme_contract_error (name , "guard procedure does not accept correct number of arguments" , "explanation" , 0 , "should accept one more than the number of constructor arguments" , "guard procedure" , 1 , argv [0 ] , "expected arity" , 1 , ((Scheme_Object * ) (void * ) (intptr_t ) ((((uintptr_t ) ((intptr_t ) (arity ) ) ) << 1 ) | 0x1 ) ) , ((void * ) 0 ) ) )




  ; 

  props = FUNCCALL(SETUP_XfOrM940(_), scheme_parse_chaperone_props (name , 4 , argc , argv ) ); 

  redirects = (__funcarg161 = FUNCCALL(SETUP_XfOrM940(_), scheme_make_pair (argv [2 ] , argv [3 ] ) ), FUNCCALL_AGAIN(scheme_make_pair (argv [1 ] , __funcarg161 ) )) 

  ; 

  px = ((Scheme_Chaperone * ) FUNCCALL(SETUP_XfOrM940(_), GC_malloc_one_small_tagged ((((sizeof (Scheme_Chaperone ) * (1 ) + (1 << 3 ) - 1 ) >> 3 ) << 3 ) ) )) ; 
  px -> iso . so . type = scheme_chaperone_type ; 
  px -> props = props ; 
  px -> val = val ; 
  px -> prev = argv [0 ] ; 
  px -> redirects = redirects ; 

  if (is_impersonator )
    (& (px ) -> iso ) -> so . keyex |= 0x1 ; 

  RET_VALUE_START ((Scheme_Object * ) px ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 6436 "./../src/struct.c"
static Scheme_Object * chaperone_struct_type (int argc , Scheme_Object * * argv ) 
{
  /* No conversion */

# 6438 "./../src/struct.c"
  return do_chaperone_struct_type ("chaperone-struct-type" , 0 , argc , argv ) ; 
}



Scheme_Object * scheme_parse_chaperone_props (const char * who , int start_at , int argc , Scheme_Object * * argv ) 
{
  Scheme_Object * v , * props ; 
  int pos ; 
  DECL_RET_SAVE (Scheme_Object * ) PREPARE_VAR_STACK(4);
  BLOCK_SETUP_TOP((PUSH(argv, 0), PUSH(v, 1), PUSH(props, 2)));
# define XfOrM942_COUNT (3)
# define SETUP_XfOrM942(x) SETUP(XfOrM942_COUNT)
# define BLOCK_SETUP(x) BLOCK_SETUP_each(x)
# define FUNCCALL(s, x) FUNCCALL_each(s, x)
# define FUNCCALL_EMPTY(x) FUNCCALL_EMPTY_each(x)
# define FUNCCALL_AGAIN(x) FUNCCALL_AGAIN_each(x)
  v = NULLED_OUT ; 
  props = NULLED_OUT ; 

# 6448 "./../src/struct.c"
  if (((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_type ) ) || ((Scheme_Type ) (((((intptr_t ) (argv [0 ] ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (argv [0 ] ) ) -> type ) ) == (Scheme_Type ) (scheme_proc_chaperone_type ) ) ) 
    props = ((Scheme_Chaperone * ) argv [0 ] ) -> props ; 
  else 
  props = ((void * ) 0 ) ; 

  if (start_at < argc ) {
#   define XfOrM943_COUNT (0+XfOrM942_COUNT)
#   define SETUP_XfOrM943(x) SETUP_XfOrM942(x)

# 6455 "./../src/struct.c"
    for (pos = start_at ; pos < argc ; pos += 2 ) {
#     define XfOrM978_COUNT (0+XfOrM943_COUNT)
#     define SETUP_XfOrM978(x) SETUP_XfOrM943(x)

# 6456 "./../src/struct.c"
      v = argv [pos ] ; 
      if (! ((Scheme_Type ) (((((intptr_t ) (v ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (v ) ) -> type ) ) == (Scheme_Type ) (scheme_chaperone_property_type ) ) )
        FUNCCALL_EMPTY(scheme_wrong_contract (who , "impersonator-property?" , pos , argc , argv ) ); 

      if (pos + 1 >= argc )
        FUNCCALL_EMPTY(scheme_contract_error (who , "missing value after chaperone property" , "chaperone property" , 1 , v , ((void * ) 0 ) ) )


      ; 
    }


    if (props && ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) 
    && (((argc - start_at ) + (((Scheme_Vector * ) (props ) ) -> size ) ) > (2 * 5 ) ) ) {

      Scheme_Hash_Tree * ht ; 
      int i ; 
      BLOCK_SETUP((PUSH(ht, 0+XfOrM943_COUNT)));
#     define XfOrM974_COUNT (1+XfOrM943_COUNT)
#     define SETUP_XfOrM974(x) SETUP(XfOrM974_COUNT)
      ht = NULLED_OUT ; 

# 6473 "./../src/struct.c"
      ht = (scheme_make_hash_tree (SCHEME_hashtr_eq ) ) ; 
      for (i = (((Scheme_Vector * ) (props ) ) -> size ) ; i > 0 ; ) {
#       define XfOrM976_COUNT (0+XfOrM974_COUNT)
#       define SETUP_XfOrM976(x) SETUP_XfOrM974(x)

# 6475 "./../src/struct.c"
        i -= 2 ; 
        ht = FUNCCALL(SETUP_XfOrM976(_), scheme_hash_tree_set (ht , (((Scheme_Vector * ) (props ) ) -> els ) [i ] , (((Scheme_Vector * ) (props ) ) -> els ) [i + 1 ] ) ); 
      }
      props = (Scheme_Object * ) ht ; 
    }

    if (! props || ((Scheme_Type ) (((((intptr_t ) (props ) ) & 0x1 ) ? (Scheme_Type ) scheme_integer_type : ((Scheme_Object * ) (props ) ) -> type ) ) == (Scheme_Type ) (scheme_vector_type ) ) ) {

      int count = 0 , i , len = (props ? (((Scheme_Vector * ) (props ) ) -> size ) : 0 ) ; 
#     define XfOrM947_COUNT (0+XfOrM943_COUNT)
#     define SETUP_XfOrM947(x) SETUP_XfOrM943(x)

# 6485 "./../src/struct.c"
      for (pos = start_at ; pos < argc ; pos += 2 ) {
        v = argv [pos ] ; 
        if (props ) {
          for (i = 0 ; i < len ; i += 2 ) {
            if ((v ) == ((((Scheme_Vector * ) (props ) ) -> els ) [i ] ) ) 
              break ; 
          }
        }

# 6492 "./../src/struct.c"
        else 
        i = 0 ; 
        if (i >= len ) {
          for (i = start_at ; i < pos ; i += 2 ) {
            if ((v ) == (argv [i ] ) ) 
              break ; 
          }
          if (i >= pos )
            count ++ ; 
        }
      }

      if (props ) {

        Scheme_Object * old_props = props ; 
        BLOCK_SETUP((PUSH(old_props, 0+XfOrM947_COUNT)));
#       define XfOrM959_COUNT (1+XfOrM947_COUNT)
#       define SETUP_XfOrM959(x) SETUP(XfOrM959_COUNT)

# 6507 "./../src/struct.c"
        props = FUNCCALL(SETUP_XfOrM959(_), scheme_make_vector ((((Scheme_Vector * ) (old_props ) ) -> size ) + 2 * count , ((void * ) 0 ) ) ); 
        (memcpy ((((Scheme_Vector * ) (props ) ) -> els ) , (((Scheme_Vector * ) (old_props ) ) -> els ) , sizeof (Scheme_Object * ) * (((Scheme_Vector * ) (old_props ) ) -> size ) ) ) ; 
      }

# 6509 "./../src/struct.c"
      else {
#       define XfOrM958_COUNT (0+XfOrM947_COUNT)
#       define SETUP_XfOrM958(x) SETUP_XfOrM947(x)

# 6510 "./../src/struct.c"
        props = FUNCCALL(SETUP_XfOrM958(_), scheme_make_vector (2 * count , ((void * ) 0 ) ) ); 
      }
      len = (((Scheme_Vector * ) (props ) ) -> size ) ; 


      for (pos = start_at ; pos < argc ; pos += 2 ) {
        v = argv [pos ] ; 
        for (i = 0 ; i < len ; i += 2 ) {
          if (! (((Scheme_Vector * ) (props ) ) -> els ) [i ] || ((v ) == ((((Scheme_Vector * ) (props ) ) -> els ) [i ] ) ) ) {
            (((Scheme_Vector * ) (props ) ) -> els ) [i ] = v ; 
            (((Scheme_Vector * ) (props ) ) -> els ) [i + 1 ] = argv [pos + 1 ] ; 
            break ; 
          }
        }
      }
    }

# 6525 "./../src/struct.c"
    else {
#     define XfOrM944_COUNT (0+XfOrM943_COUNT)
#     define SETUP_XfOrM944(x) SETUP_XfOrM943(x)

# 6527 "./../src/struct.c"
      for (pos = start_at ; pos < argc ; pos += 2 ) {
#       define XfOrM946_COUNT (0+XfOrM944_COUNT)
#       define SETUP_XfOrM946(x) SETUP_XfOrM944(x)

# 6528 "./../src/struct.c"
        props = (Scheme_Object * ) FUNCCALL(SETUP_XfOrM946(_), scheme_hash_tree_set ((Scheme_Hash_Tree * ) props , argv [pos ] , argv [pos + 1 ] ) ); 
      }
    }
  }

  RET_VALUE_START (props ) RET_VALUE_END ; 
# undef BLOCK_SETUP
# undef FUNCCALL
# undef FUNCCALL_EMPTY
# undef FUNCCALL_AGAIN
}

# 4 "./../src/mzmark_struct.inc"
static int mark_serialized_struct_val_SIZE (void * p , struct NewGC * gc ) {







  return 0 ; 
}


static int mark_serialized_struct_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Serialized_Structure * s = (Scheme_Serialized_Structure * ) p ; 
  int num_slots = s -> num_slots ; 

  int i ; 

  GC_mark2 (& (s -> prefab_key ) , gc ) ; 

  for (i = num_slots ; i -- ; ) 
  GC_mark2 (& (s -> slots [i ] ) , gc ) ; 


  return 0 ; 
}







static int mark_serialized_struct_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Serialized_Structure * s = (Scheme_Serialized_Structure * ) p ; 
  int num_slots = s -> num_slots ; 

  int i ; 

  GC_fixup2 (& (s -> prefab_key ) , gc ) ; 

  for (i = num_slots ; i -- ; ) 
  GC_fixup2 (& (s -> slots [i ] ) , gc ) ; 


  return 0 ; 
}

# 65 "./../src/mzmark_struct.inc"
static int mark_struct_val_SIZE (void * p , struct NewGC * gc ) {







  return 0 ; 
}


static int mark_struct_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Structure * s = (Scheme_Structure * ) p ; 
  int num_slots = ((Scheme_Struct_Type * ) GC_resolve2 (s -> stype , gc ) ) -> num_slots ; 

  int i ; 

  GC_mark2 (& (s -> stype ) , gc ) ; 

  for (i = num_slots ; i -- ; ) 
  GC_mark2 (& (s -> slots [i ] ) , gc ) ; 


  return 0 ; 
}







static int mark_struct_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Structure * s = (Scheme_Structure * ) p ; 
  int num_slots = ((Scheme_Struct_Type * ) GC_resolve2 (s -> stype , gc ) ) -> num_slots ; 

  int i ; 

  GC_fixup2 (& (s -> stype ) , gc ) ; 

  for (i = num_slots ; i -- ; ) 
  GC_fixup2 (& (s -> slots [i ] ) , gc ) ; 


  return 0 ; 
}

# 125 "./../src/mzmark_struct.inc"
static int mark_struct_type_val_SIZE (void * p , struct NewGC * gc ) {







  return 0 ; 
}


static int mark_struct_type_val_MARK (void * p , struct NewGC * gc ) {

  Scheme_Struct_Type * t = (Scheme_Struct_Type * ) p ; 

  int i ; 
  for (i = t -> name_pos + 1 ; i -- ; ) {
    GC_mark2 (& (t -> parent_types [i ] ) , gc ) ; 
  }
  GC_mark2 (& (t -> name ) , gc ) ; 
  GC_mark2 (& (t -> inspector ) , gc ) ; 
  GC_mark2 (& (t -> accessor ) , gc ) ; 
  GC_mark2 (& (t -> mutator ) , gc ) ; 
  GC_mark2 (& (t -> prefab_key ) , gc ) ; 
  GC_mark2 (& (t -> uninit_val ) , gc ) ; 
  GC_mark2 (& (t -> props ) , gc ) ; 
  GC_mark2 (& (t -> proc_attr ) , gc ) ; 
  GC_mark2 (& (t -> guard ) , gc ) ; 
  GC_mark2 (& (t -> immutables ) , gc ) ; 


  return 0 ; 
}








static int mark_struct_type_val_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Struct_Type * t = (Scheme_Struct_Type * ) p ; 

  int i ; 
  for (i = t -> name_pos + 1 ; i -- ; ) {
    GC_fixup2 (& (t -> parent_types [i ] ) , gc ) ; 
  }
  GC_fixup2 (& (t -> name ) , gc ) ; 
  GC_fixup2 (& (t -> inspector ) , gc ) ; 
  GC_fixup2 (& (t -> accessor ) , gc ) ; 
  GC_fixup2 (& (t -> mutator ) , gc ) ; 
  GC_fixup2 (& (t -> prefab_key ) , gc ) ; 
  GC_fixup2 (& (t -> uninit_val ) , gc ) ; 
  GC_fixup2 (& (t -> props ) , gc ) ; 
  GC_fixup2 (& (t -> proc_attr ) , gc ) ; 
  GC_fixup2 (& (t -> guard ) , gc ) ; 
  GC_fixup2 (& (t -> immutables ) , gc ) ; 


  return 0 ; 
}

# 201 "./../src/mzmark_struct.inc"
static int mark_struct_property_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_struct_property_MARK (void * p , struct NewGC * gc ) {

  Scheme_Struct_Property * i = (Scheme_Struct_Property * ) p ; 
  GC_mark2 (& (i -> name ) , gc ) ; 
  GC_mark2 (& (i -> guard ) , gc ) ; 
  GC_mark2 (& (i -> supers ) , gc ) ; 

  return 0 ; 
}






static int mark_struct_property_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Struct_Property * i = (Scheme_Struct_Property * ) p ; 
  GC_fixup2 (& (i -> name ) , gc ) ; 
  GC_fixup2 (& (i -> guard ) , gc ) ; 
  GC_fixup2 (& (i -> supers ) , gc ) ; 

  return 0 ; 
}

# 243 "./../src/mzmark_struct.inc"
static int mark_wrapped_evt_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_wrapped_evt_MARK (void * p , struct NewGC * gc ) {

  Wrapped_Evt * ww = (Wrapped_Evt * ) p ; 

  GC_mark2 (& (ww -> evt ) , gc ) ; 
  GC_mark2 (& (ww -> wrapper ) , gc ) ; 


  return 0 ; 
}






static int mark_wrapped_evt_FIXUP (void * p , struct NewGC * gc ) {

  Wrapped_Evt * ww = (Wrapped_Evt * ) p ; 

  GC_fixup2 (& (ww -> evt ) , gc ) ; 
  GC_fixup2 (& (ww -> wrapper ) , gc ) ; 


  return 0 ; 
}

# 287 "./../src/mzmark_struct.inc"
static int mark_nack_guard_evt_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_nack_guard_evt_MARK (void * p , struct NewGC * gc ) {

  Nack_Guard_Evt * nw = (Nack_Guard_Evt * ) p ; 

  GC_mark2 (& (nw -> maker ) , gc ) ; 


  return 0 ; 
}






static int mark_nack_guard_evt_FIXUP (void * p , struct NewGC * gc ) {

  Nack_Guard_Evt * nw = (Nack_Guard_Evt * ) p ; 

  GC_fixup2 (& (nw -> maker ) , gc ) ; 


  return 0 ; 
}

# 329 "./../src/mzmark_struct.inc"
static int mark_active_replace_evt_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_active_replace_evt_MARK (void * p , struct NewGC * gc ) {

  Active_Replace_Evt * a = (Active_Replace_Evt * ) p ; 

  GC_mark2 (& (a -> syncing ) , gc ) ; 
  GC_mark2 (& (a -> wrapper ) , gc ) ; 
  GC_mark2 (& (a -> orig ) , gc ) ; 


  return 0 ; 
}






static int mark_active_replace_evt_FIXUP (void * p , struct NewGC * gc ) {

  Active_Replace_Evt * a = (Active_Replace_Evt * ) p ; 

  GC_fixup2 (& (a -> syncing ) , gc ) ; 
  GC_fixup2 (& (a -> wrapper ) , gc ) ; 
  GC_fixup2 (& (a -> orig ) , gc ) ; 


  return 0 ; 
}

# 375 "./../src/mzmark_struct.inc"
static int mark_chaperone_SIZE (void * p , struct NewGC * gc ) {



  return 0 ; 
}


static int mark_chaperone_MARK (void * p , struct NewGC * gc ) {

  Scheme_Chaperone * px = (Scheme_Chaperone * ) p ; 

  GC_mark2 (& (px -> val ) , gc ) ; 
  GC_mark2 (& (px -> prev ) , gc ) ; 
  GC_mark2 (& (px -> props ) , gc ) ; 
  GC_mark2 (& (px -> redirects ) , gc ) ; 


  return 0 ; 
}






static int mark_chaperone_FIXUP (void * p , struct NewGC * gc ) {

  Scheme_Chaperone * px = (Scheme_Chaperone * ) p ; 

  GC_fixup2 (& (px -> val ) , gc ) ; 
  GC_fixup2 (& (px -> prev ) , gc ) ; 
  GC_fixup2 (& (px -> props ) , gc ) ; 
  GC_fixup2 (& (px -> redirects ) , gc ) ; 


  return 0 ; 
}

# 6544 "./../src/struct.c"
static void register_traversers (void ) 
{
  GC_register_traversers2 (scheme_structure_type , mark_struct_val_SIZE , mark_struct_val_MARK , mark_struct_val_FIXUP , 0 , 0 ) ; 

  GC_register_traversers2 (scheme_serialized_structure_type , mark_serialized_struct_val_SIZE , mark_serialized_struct_val_MARK , mark_serialized_struct_val_FIXUP , 0 , 0 ) ; 

  GC_register_traversers2 (scheme_proc_struct_type , mark_struct_val_SIZE , mark_struct_val_MARK , mark_struct_val_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_struct_type_type , mark_struct_type_val_SIZE , mark_struct_type_val_MARK , mark_struct_type_val_FIXUP , 0 , 0 ) ; 
  GC_register_traversers2 (scheme_struct_property_type , mark_struct_property_SIZE , mark_struct_property_MARK , mark_struct_property_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_chaperone_property_type , mark_struct_property_SIZE , mark_struct_property_MARK , mark_struct_property_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_wrap_evt_type , mark_wrapped_evt_SIZE , mark_wrapped_evt_MARK , mark_wrapped_evt_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_handle_evt_type , mark_wrapped_evt_SIZE , mark_wrapped_evt_MARK , mark_wrapped_evt_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_nack_guard_evt_type , mark_nack_guard_evt_SIZE , mark_nack_guard_evt_MARK , mark_nack_guard_evt_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_poll_evt_type , mark_nack_guard_evt_SIZE , mark_nack_guard_evt_MARK , mark_nack_guard_evt_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_replace_evt_type , mark_wrapped_evt_SIZE , mark_wrapped_evt_MARK , mark_wrapped_evt_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_active_replace_evt_type , mark_active_replace_evt_SIZE , mark_active_replace_evt_MARK , mark_active_replace_evt_FIXUP , 1 , 0 ) ; 

  GC_register_traversers2 (scheme_chaperone_type , mark_chaperone_SIZE , mark_chaperone_MARK , mark_chaperone_FIXUP , 1 , 0 ) ; 
  GC_register_traversers2 (scheme_proc_chaperone_type , mark_chaperone_SIZE , mark_chaperone_MARK , mark_chaperone_FIXUP , 1 , 0 ) ; 
}
